/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(899), /*)*//*default:*//*Label 152*/ GIMT_Encode4(417427),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3394),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36389),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50617),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53138),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53220), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53302),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61048),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72827), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(80019), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(87543), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(97487),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97978),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(98469),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98737),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98887),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(99378), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(99411),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(108285),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(109335), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(112384), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(125910),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(127261),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(128253),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(129245),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(130737), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(132229),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(133221),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(134213),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(135205),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(136197),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(137189),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(138181), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138886),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(139591), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(140296), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(140347),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(250083), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(261599),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(261889),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(263326),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(263446), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(263687),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(265585),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(267239),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(270018),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(270843),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(271281), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(272106),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(272236), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(272778), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(280555), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(281600),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(282084),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(282568),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(282998),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(283428),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(283858), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(284288),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(286086),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(286824),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(290920), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(307193), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(307809),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(311316),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(311564),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(311752),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(312729),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(313706),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(318334),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(322340),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(322660),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(322980), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(323837),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(324119),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(324497),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(324875),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(325225),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(325575),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(326278), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(326981),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(327385),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(327789),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(328193),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(328597),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(329412),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(329578),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(329677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(329693),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(335065),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(364202), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(367120), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(369440), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(369592), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(370266),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(370426),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(370740),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(370894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(371385),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(371685),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(372176),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(372667), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(373158),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(374284),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(374900),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(378622), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(379238),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(394845), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(395145),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(395159),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(395180), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(395205), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(395515),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(395686),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(395857),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(396028),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(396199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(397328),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(397531),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(397734),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(397937), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3262 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(398140), GIMT_Encode4(0),
     /*   3270 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(398280),
     /*   3274 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(398820),
     /*   3278 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(400643),
     /*   3282 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(400898),
     /*   3286 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(401153),
     /*   3290 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(401299),
     /*   3294 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(401478),
     /*   3298 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(403128),
     /*   3302 */ /*AArch64::G_FCMGE*//*Label 129*/ GIMT_Encode4(403687),
     /*   3306 */ /*AArch64::G_FCMGT*//*Label 130*/ GIMT_Encode4(404779),
     /*   3310 */ /*AArch64::G_REV16*//*Label 131*/ GIMT_Encode4(405871),
     /*   3314 */ /*AArch64::G_REV32*//*Label 132*/ GIMT_Encode4(406025),
     /*   3318 */ /*AArch64::G_REV64*//*Label 133*/ GIMT_Encode4(406201),
     /*   3322 */ /*AArch64::G_SADDLP*//*Label 134*/ GIMT_Encode4(406475),
     /*   3326 */ /*AArch64::G_SADDLV*//*Label 135*/ GIMT_Encode4(406681),
     /*   3330 */ /*AArch64::G_SDOT*//*Label 136*/ GIMT_Encode4(407080),
     /*   3334 */ /*AArch64::G_SITOF*//*Label 137*/ GIMT_Encode4(407450),
     /*   3338 */ /*AArch64::G_SMULL*//*Label 138*/ GIMT_Encode4(407567),
     /*   3342 */ /*AArch64::G_TRN1*//*Label 139*/ GIMT_Encode4(408800),
     /*   3346 */ /*AArch64::G_TRN2*//*Label 140*/ GIMT_Encode4(409580),
     /*   3350 */ /*AArch64::G_UADDLP*//*Label 141*/ GIMT_Encode4(410360),
     /*   3354 */ /*AArch64::G_UADDLV*//*Label 142*/ GIMT_Encode4(410566),
     /*   3358 */ /*AArch64::G_UDOT*//*Label 143*/ GIMT_Encode4(411433),
     /*   3362 */ /*AArch64::G_UITOF*//*Label 144*/ GIMT_Encode4(411803),
     /*   3366 */ /*AArch64::G_UMULL*//*Label 145*/ GIMT_Encode4(411920),
     /*   3370 */ /*AArch64::G_UZP1*//*Label 146*/ GIMT_Encode4(413153),
     /*   3374 */ /*AArch64::G_UZP2*//*Label 147*/ GIMT_Encode4(413933),
     /*   3378 */ /*AArch64::G_VASHR*//*Label 148*/ GIMT_Encode4(414713),
     /*   3382 */ /*AArch64::G_VLSHR*//*Label 149*/ GIMT_Encode4(415411),
     /*   3386 */ /*AArch64::G_ZIP1*//*Label 150*/ GIMT_Encode4(415867),
     /*   3390 */ /*AArch64::G_ZIP2*//*Label 151*/ GIMT_Encode4(416647),
     /*   3394 */ // Label 0: @3394
     /*   3394 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 166*/ GIMT_Encode4(36388),
     /*   3405 */ /*GILLT_s32*//*Label 153*/ GIMT_Encode4(3493),
     /*   3409 */ /*GILLT_s64*//*Label 154*/ GIMT_Encode4(6272), GIMT_Encode4(0),
     /*   3417 */ /*GILLT_v2s32*//*Label 155*/ GIMT_Encode4(11600),
     /*   3421 */ /*GILLT_v2s64*//*Label 156*/ GIMT_Encode4(15208),
     /*   3425 */ /*GILLT_v4s16*//*Label 157*/ GIMT_Encode4(21110),
     /*   3429 */ /*GILLT_v4s32*//*Label 158*/ GIMT_Encode4(24608),
     /*   3433 */ /*GILLT_v8s8*//*Label 159*/ GIMT_Encode4(30786),
     /*   3437 */ /*GILLT_v8s16*//*Label 160*/ GIMT_Encode4(31636),
     /*   3441 */ /*GILLT_v16s8*//*Label 161*/ GIMT_Encode4(35214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3461 */ /*GILLT_nxv2s64*//*Label 162*/ GIMT_Encode4(35938), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3473 */ /*GILLT_nxv4s32*//*Label 163*/ GIMT_Encode4(36310), GIMT_Encode4(0),
     /*   3481 */ /*GILLT_nxv8s16*//*Label 164*/ GIMT_Encode4(36336), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv16s8*//*Label 165*/ GIMT_Encode4(36362),
     /*   3493 */ // Label 153: @3493
     /*   3493 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(6271),
     /*   3498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3504 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3537), // Rule ID 13185 //
     /*   3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3524 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3535 */     GIR_RootConstrainSelectedInstOperands,
     /*   3536 */     // GIR_Coverage, 13185,
     /*   3536 */     GIR_EraseRootFromParent_Done,
     /*   3537 */   // Label 168: @3537
     /*   3537 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3689), // Rule ID 13612 //
     /*   3542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3569 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3572 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3577 */     // MIs[2] pattern
     /*   3577 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3580 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3591 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3617 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3620 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3624 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3688 */     // GIR_Coverage, 13612,
     /*   3688 */     GIR_EraseRootFromParent_Done,
     /*   3689 */   // Label 169: @3689
     /*   3689 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3841), // Rule ID 15466 //
     /*   3694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3721 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3724 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3729 */     // MIs[2] pattern
     /*   3729 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3732 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3743 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3757 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3760 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3764 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3769 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3772 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3776 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3779 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3813 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3823 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3840 */     // GIR_Coverage, 15466,
     /*   3840 */     GIR_EraseRootFromParent_Done,
     /*   3841 */   // Label 170: @3841
     /*   3841 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3993), // Rule ID 15478 //
     /*   3846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3881 */     // MIs[2] pattern
     /*   3881 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3884 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3895 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3909 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3912 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3916 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3921 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3928 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3936 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3992 */     // GIR_Coverage, 15478,
     /*   3992 */     GIR_EraseRootFromParent_Done,
     /*   3993 */   // Label 171: @3993
     /*   3993 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4145), // Rule ID 15490 //
     /*   3998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4025 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4028 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4033 */     // MIs[2] pattern
     /*   4033 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4036 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4047 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4073 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4127 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4144 */     // GIR_Coverage, 15490,
     /*   4144 */     GIR_EraseRootFromParent_Done,
     /*   4145 */   // Label 172: @4145
     /*   4145 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4178), // Rule ID 91 //
     /*   4150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4165 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4176 */     GIR_RootConstrainSelectedInstOperands,
     /*   4177 */     // GIR_Coverage, 91,
     /*   4177 */     GIR_EraseRootFromParent_Done,
     /*   4178 */   // Label 173: @4178
     /*   4178 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4330), // Rule ID 2656 //
     /*   4183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4214 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4217 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4222 */     // MIs[2] pattern
     /*   4222 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4225 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4232 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4232 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4235 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4239 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4261 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4265 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4329 */     // GIR_Coverage, 2656,
     /*   4329 */     GIR_EraseRootFromParent_Done,
     /*   4330 */   // Label 174: @4330
     /*   4330 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4482), // Rule ID 9923 //
     /*   4335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4366 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4369 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4374 */     // MIs[2] pattern
     /*   4374 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4377 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4384 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4384 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4387 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4391 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4410 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4417 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4481 */     // GIR_Coverage, 9923,
     /*   4481 */     GIR_EraseRootFromParent_Done,
     /*   4482 */   // Label 175: @4482
     /*   4482 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4634), // Rule ID 9935 //
     /*   4487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4518 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4521 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4526 */     // MIs[2] pattern
     /*   4526 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4529 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4536 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4536 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4539 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4543 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4562 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4565 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4569 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4633 */     // GIR_Coverage, 9935,
     /*   4633 */     GIR_EraseRootFromParent_Done,
     /*   4634 */   // Label 176: @4634
     /*   4634 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4786), // Rule ID 9947 //
     /*   4639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4670 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4673 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4678 */     // MIs[2] pattern
     /*   4678 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4681 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4688 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4785 */     // GIR_Coverage, 9947,
     /*   4785 */     GIR_EraseRootFromParent_Done,
     /*   4786 */   // Label 177: @4786
     /*   4786 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4943), // Rule ID 15509 //
     /*   4791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4818 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4821 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4837 */     // MIs[2] pred
     /*   4837 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4848 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4848 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4851 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4855 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4874 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4881 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4942 */     // GIR_Coverage, 15509,
     /*   4942 */     GIR_EraseRootFromParent_Done,
     /*   4943 */   // Label 178: @4943
     /*   4943 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(5100), // Rule ID 15510 //
     /*   4948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4975 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4978 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4994 */     // MIs[2] pred
     /*   4994 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5005 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5031 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5038 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5082 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5099 */     // GIR_Coverage, 15510,
     /*   5099 */     GIR_EraseRootFromParent_Done,
     /*   5100 */   // Label 179: @5100
     /*   5100 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(5257), // Rule ID 15511 //
     /*   5105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5132 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5135 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5151 */     // MIs[2] pred
     /*   5151 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5162 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5256 */     // GIR_Coverage, 15511,
     /*   5256 */     GIR_EraseRootFromParent_Done,
     /*   5257 */   // Label 180: @5257
     /*   5257 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5414), // Rule ID 15512 //
     /*   5262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5289 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5292 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5301 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5308 */     // MIs[2] pred
     /*   5308 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5319 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5345 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5348 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5352 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5413 */     // GIR_Coverage, 15512,
     /*   5413 */     GIR_EraseRootFromParent_Done,
     /*   5414 */   // Label 181: @5414
     /*   5414 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5571), // Rule ID 10039 //
     /*   5419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5450 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5453 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5469 */     // MIs[2] pred
     /*   5469 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5476 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5476 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5479 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5483 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5502 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5509 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5512 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5570 */     // GIR_Coverage, 10039,
     /*   5570 */     GIR_EraseRootFromParent_Done,
     /*   5571 */   // Label 182: @5571
     /*   5571 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5728), // Rule ID 10040 //
     /*   5576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5607 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5610 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5626 */     // MIs[2] pred
     /*   5626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5633 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5633 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5636 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5640 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5659 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5666 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5710 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5727 */     // GIR_Coverage, 10040,
     /*   5727 */     GIR_EraseRootFromParent_Done,
     /*   5728 */   // Label 183: @5728
     /*   5728 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5885), // Rule ID 10041 //
     /*   5733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5764 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5767 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5783 */     // MIs[2] pred
     /*   5783 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5790 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5884 */     // GIR_Coverage, 10041,
     /*   5884 */     GIR_EraseRootFromParent_Done,
     /*   5885 */   // Label 184: @5885
     /*   5885 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(6042), // Rule ID 10042 //
     /*   5890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5921 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5924 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5933 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5940 */     // MIs[2] pred
     /*   5940 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5947 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5947 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5950 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5954 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5973 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5980 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6024 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6041 */     // GIR_Coverage, 10042,
     /*   6041 */     GIR_EraseRootFromParent_Done,
     /*   6042 */   // Label 185: @6042
     /*   6042 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(6075), // Rule ID 13189 //
     /*   6047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6062 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6073 */     GIR_RootConstrainSelectedInstOperands,
     /*   6074 */     // GIR_Coverage, 13189,
     /*   6074 */     GIR_EraseRootFromParent_Done,
     /*   6075 */   // Label 186: @6075
     /*   6075 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6111), // Rule ID 13752 //
     /*   6080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6095 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6109 */     GIR_RootConstrainSelectedInstOperands,
     /*   6110 */     // GIR_Coverage, 13752,
     /*   6110 */     GIR_EraseRootFromParent_Done,
     /*   6111 */   // Label 187: @6111
     /*   6111 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6144), // Rule ID 97 //
     /*   6116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6131 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6142 */     GIR_RootConstrainSelectedInstOperands,
     /*   6143 */     // GIR_Coverage, 97,
     /*   6143 */     GIR_EraseRootFromParent_Done,
     /*   6144 */   // Label 188: @6144
     /*   6144 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6180), // Rule ID 3921 //
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6164 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6178 */     GIR_RootConstrainSelectedInstOperands,
     /*   6179 */     // GIR_Coverage, 3921,
     /*   6179 */     GIR_EraseRootFromParent_Done,
     /*   6180 */   // Label 189: @6180
     /*   6180 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6213), // Rule ID 13187 //
     /*   6185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6200 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6211 */     GIR_RootConstrainSelectedInstOperands,
     /*   6212 */     // GIR_Coverage, 13187,
     /*   6212 */     GIR_EraseRootFromParent_Done,
     /*   6213 */   // Label 190: @6213
     /*   6213 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6246), // Rule ID 95 //
     /*   6218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6233 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6244 */     GIR_RootConstrainSelectedInstOperands,
     /*   6245 */     // GIR_Coverage, 95,
     /*   6245 */     GIR_EraseRootFromParent_Done,
     /*   6246 */   // Label 191: @6246
     /*   6246 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6270), // Rule ID 93 //
     /*   6251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6263 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6268 */     GIR_RootConstrainSelectedInstOperands,
     /*   6269 */     // GIR_Coverage, 93,
     /*   6269 */     GIR_Done,
     /*   6270 */   // Label 192: @6270
     /*   6270 */   GIM_Reject,
     /*   6271 */ // Label 167: @6271
     /*   6271 */ GIM_Reject,
     /*   6272 */ // Label 154: @6272
     /*   6272 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(11599),
     /*   6277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6283 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6419), // Rule ID 5377 //
     /*   6288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6321 */     // MIs[1] Operand 2
     /*   6321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6348 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6352 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6356 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6361 */     // MIs[3] Operand 2
     /*   6361 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6372 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6374 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6418 */     // GIR_Coverage, 5377,
     /*   6418 */     GIR_EraseRootFromParent_Done,
     /*   6419 */   // Label 194: @6419
     /*   6419 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6555), // Rule ID 5376 //
     /*   6424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6457 */     // MIs[1] Operand 2
     /*   6457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6484 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6488 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6492 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6497 */     // MIs[3] Operand 2
     /*   6497 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6510 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6537 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6554 */     // GIR_Coverage, 5376,
     /*   6554 */     GIR_EraseRootFromParent_Done,
     /*   6555 */   // Label 195: @6555
     /*   6555 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6691), // Rule ID 5386 //
     /*   6560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6593 */     // MIs[1] Operand 2
     /*   6593 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6624 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6628 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6633 */     // MIs[3] Operand 2
     /*   6633 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6646 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6690 */     // GIR_Coverage, 5386,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 196: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6827), // Rule ID 5375 //
     /*   6696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6729 */     // MIs[1] Operand 2
     /*   6729 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6760 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6764 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6769 */     // MIs[3] Operand 2
     /*   6769 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6782 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6809 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6826 */     // GIR_Coverage, 5375,
     /*   6826 */     GIR_EraseRootFromParent_Done,
     /*   6827 */   // Label 197: @6827
     /*   6827 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6963), // Rule ID 5374 //
     /*   6832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6865 */     // MIs[1] Operand 2
     /*   6865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6896 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6900 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6905 */     // MIs[3] Operand 2
     /*   6905 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6916 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6918 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6962 */     // GIR_Coverage, 5374,
     /*   6962 */     GIR_EraseRootFromParent_Done,
     /*   6963 */   // Label 198: @6963
     /*   6963 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(7031), // Rule ID 6905 //
     /*   6968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6993 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7009 */     // MIs[2] Rn
     /*   7009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7020 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7029 */     GIR_RootConstrainSelectedInstOperands,
     /*   7030 */     // GIR_Coverage, 6905,
     /*   7030 */     GIR_EraseRootFromParent_Done,
     /*   7031 */   // Label 199: @7031
     /*   7031 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(7099), // Rule ID 13910 //
     /*   7036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7077 */     // MIs[2] Rn
     /*   7077 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7082 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7088 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7097 */     GIR_RootConstrainSelectedInstOperands,
     /*   7098 */     // GIR_Coverage, 13910,
     /*   7098 */     GIR_EraseRootFromParent_Done,
     /*   7099 */   // Label 200: @7099
     /*   7099 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7132), // Rule ID 13186 //
     /*   7104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7119 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7130 */     GIR_RootConstrainSelectedInstOperands,
     /*   7131 */     // GIR_Coverage, 13186,
     /*   7131 */     GIR_EraseRootFromParent_Done,
     /*   7132 */   // Label 201: @7132
     /*   7132 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7265), // Rule ID 3973 //
     /*   7137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7174 */     // MIs[2] Operand 2
     /*   7174 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7197 */     // MIs[3] Operand 1
     /*   7197 */     // No operand predicates
     /*   7197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7203 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7215 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7263 */     GIR_RootConstrainSelectedInstOperands,
     /*   7264 */     // GIR_Coverage, 3973,
     /*   7264 */     GIR_EraseRootFromParent_Done,
     /*   7265 */   // Label 202: @7265
     /*   7265 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7360), // Rule ID 3971 //
     /*   7270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7319 */     // MIs[3] Operand 1
     /*   7319 */     // No operand predicates
     /*   7319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7325 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7337 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7358 */     GIR_RootConstrainSelectedInstOperands,
     /*   7359 */     // GIR_Coverage, 3971,
     /*   7359 */     GIR_EraseRootFromParent_Done,
     /*   7360 */   // Label 203: @7360
     /*   7360 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7455), // Rule ID 3972 //
     /*   7365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7414 */     // MIs[3] Operand 1
     /*   7414 */     // No operand predicates
     /*   7414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7420 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7432 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7453 */     GIR_RootConstrainSelectedInstOperands,
     /*   7454 */     // GIR_Coverage, 3972,
     /*   7454 */     GIR_EraseRootFromParent_Done,
     /*   7455 */   // Label 204: @7455
     /*   7455 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7488), // Rule ID 92 //
     /*   7460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7475 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7486 */     GIR_RootConstrainSelectedInstOperands,
     /*   7487 */     // GIR_Coverage, 92,
     /*   7487 */     GIR_EraseRootFromParent_Done,
     /*   7488 */   // Label 205: @7488
     /*   7488 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7621), // Rule ID 13762 //
     /*   7493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7534 */     // MIs[2] Operand 2
     /*   7534 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7553 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7557 */     // MIs[3] Operand 1
     /*   7557 */     // No operand predicates
     /*   7557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7559 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7571 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7619 */     GIR_RootConstrainSelectedInstOperands,
     /*   7620 */     // GIR_Coverage, 13762,
     /*   7620 */     GIR_EraseRootFromParent_Done,
     /*   7621 */   // Label 206: @7621
     /*   7621 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7716), // Rule ID 13760 //
     /*   7626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7679 */     // MIs[3] Operand 1
     /*   7679 */     // No operand predicates
     /*   7679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7681 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7693 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7714 */     GIR_RootConstrainSelectedInstOperands,
     /*   7715 */     // GIR_Coverage, 13760,
     /*   7715 */     GIR_EraseRootFromParent_Done,
     /*   7716 */   // Label 207: @7716
     /*   7716 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7811), // Rule ID 13761 //
     /*   7721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7770 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7774 */     // MIs[3] Operand 1
     /*   7774 */     // No operand predicates
     /*   7774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7776 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7788 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7809 */     GIR_RootConstrainSelectedInstOperands,
     /*   7810 */     // GIR_Coverage, 13761,
     /*   7810 */     GIR_EraseRootFromParent_Done,
     /*   7811 */   // Label 208: @7811
     /*   7811 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7893), // Rule ID 13197 //
     /*   7816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7876 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7891 */     GIR_RootConstrainSelectedInstOperands,
     /*   7892 */     // GIR_Coverage, 13197,
     /*   7892 */     GIR_EraseRootFromParent_Done,
     /*   7893 */   // Label 209: @7893
     /*   7893 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7975), // Rule ID 13198 //
     /*   7898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7947 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7958 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7973 */     GIR_RootConstrainSelectedInstOperands,
     /*   7974 */     // GIR_Coverage, 13198,
     /*   7974 */     GIR_EraseRootFromParent_Done,
     /*   7975 */   // Label 210: @7975
     /*   7975 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(8057), // Rule ID 123 //
     /*   7980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8033 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8040 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8055 */     GIR_RootConstrainSelectedInstOperands,
     /*   8056 */     // GIR_Coverage, 123,
     /*   8056 */     GIR_EraseRootFromParent_Done,
     /*   8057 */   // Label 211: @8057
     /*   8057 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(8139), // Rule ID 125 //
     /*   8062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8122 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8137 */     GIR_RootConstrainSelectedInstOperands,
     /*   8138 */     // GIR_Coverage, 125,
     /*   8138 */     GIR_EraseRootFromParent_Done,
     /*   8139 */   // Label 212: @8139
     /*   8139 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8197), // Rule ID 13607 //
     /*   8144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8159 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8162 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8167 */     // MIs[1] pattern
     /*   8167 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8170 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8181 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8195 */     GIR_RootConstrainSelectedInstOperands,
     /*   8196 */     // GIR_Coverage, 13607,
     /*   8196 */     GIR_EraseRootFromParent_Done,
     /*   8197 */   // Label 213: @8197
     /*   8197 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8255), // Rule ID 15461 //
     /*   8202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8217 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8220 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8225 */     // MIs[1] pattern
     /*   8225 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8228 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8239 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8253 */     GIR_RootConstrainSelectedInstOperands,
     /*   8254 */     // GIR_Coverage, 15461,
     /*   8254 */     GIR_EraseRootFromParent_Done,
     /*   8255 */   // Label 214: @8255
     /*   8255 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8313), // Rule ID 15473 //
     /*   8260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8283 */     // MIs[1] pattern
     /*   8283 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8286 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8297 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8311 */     GIR_RootConstrainSelectedInstOperands,
     /*   8312 */     // GIR_Coverage, 15473,
     /*   8312 */     GIR_EraseRootFromParent_Done,
     /*   8313 */   // Label 215: @8313
     /*   8313 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8371), // Rule ID 15485 //
     /*   8318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8333 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8336 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8341 */     // MIs[1] pattern
     /*   8341 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8344 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8355 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8369 */     GIR_RootConstrainSelectedInstOperands,
     /*   8370 */     // GIR_Coverage, 15485,
     /*   8370 */     GIR_EraseRootFromParent_Done,
     /*   8371 */   // Label 216: @8371
     /*   8371 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8429), // Rule ID 2653 //
     /*   8376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8395 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8398 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8403 */     // MIs[1] pattern
     /*   8403 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8406 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8413 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8427 */     GIR_RootConstrainSelectedInstOperands,
     /*   8428 */     // GIR_Coverage, 2653,
     /*   8428 */     GIR_EraseRootFromParent_Done,
     /*   8429 */   // Label 217: @8429
     /*   8429 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8487), // Rule ID 9920 //
     /*   8434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8453 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8456 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8461 */     // MIs[1] pattern
     /*   8461 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8464 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8471 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8485 */     GIR_RootConstrainSelectedInstOperands,
     /*   8486 */     // GIR_Coverage, 9920,
     /*   8486 */     GIR_EraseRootFromParent_Done,
     /*   8487 */   // Label 218: @8487
     /*   8487 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8545), // Rule ID 9932 //
     /*   8492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8519 */     // MIs[1] pattern
     /*   8519 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8522 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8529 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8543 */     GIR_RootConstrainSelectedInstOperands,
     /*   8544 */     // GIR_Coverage, 9932,
     /*   8544 */     GIR_EraseRootFromParent_Done,
     /*   8545 */   // Label 219: @8545
     /*   8545 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8603), // Rule ID 9944 //
     /*   8550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8569 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8572 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8577 */     // MIs[1] pattern
     /*   8577 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8580 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8587 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8601 */     GIR_RootConstrainSelectedInstOperands,
     /*   8602 */     // GIR_Coverage, 9944,
     /*   8602 */     GIR_EraseRootFromParent_Done,
     /*   8603 */   // Label 220: @8603
     /*   8603 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8766), // Rule ID 13882 //
     /*   8608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8650 */     // MIs[1] Operand 2
     /*   8650 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8667 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8670 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8674 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8693 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8700 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8765 */     // GIR_Coverage, 13882,
     /*   8765 */     GIR_EraseRootFromParent_Done,
     /*   8766 */   // Label 221: @8766
     /*   8766 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8929), // Rule ID 13879 //
     /*   8771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8813 */     // MIs[1] Operand 2
     /*   8813 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8830 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8830 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8833 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8837 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8856 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8863 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8911 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8928 */     // GIR_Coverage, 13879,
     /*   8928 */     GIR_EraseRootFromParent_Done,
     /*   8929 */   // Label 222: @8929
     /*   8929 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(9079), // Rule ID 13888 //
     /*   8934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8967 */     // MIs[1] Operand 2
     /*   8967 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8984 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9078 */     // GIR_Coverage, 13888,
     /*   9078 */     GIR_EraseRootFromParent_Done,
     /*   9079 */   // Label 223: @9079
     /*   9079 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(9229), // Rule ID 13891 //
     /*   9084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9117 */     // MIs[1] Operand 2
     /*   9117 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9134 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9134 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9137 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9141 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9160 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9167 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9180 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9211 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9228 */     // GIR_Coverage, 13891,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 224: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9379), // Rule ID 13887 //
     /*   9234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9267 */     // MIs[1] Operand 2
     /*   9267 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9284 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9310 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9378 */     // GIR_Coverage, 13887,
     /*   9378 */     GIR_EraseRootFromParent_Done,
     /*   9379 */   // Label 225: @9379
     /*   9379 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9542), // Rule ID 5359 //
     /*   9384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9430 */     // MIs[1] Operand 2
     /*   9430 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9443 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9469 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9476 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9524 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9541 */     // GIR_Coverage, 5359,
     /*   9541 */     GIR_EraseRootFromParent_Done,
     /*   9542 */   // Label 226: @9542
     /*   9542 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9705), // Rule ID 5356 //
     /*   9547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9593 */     // MIs[1] Operand 2
     /*   9593 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9606 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9632 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9704 */     // GIR_Coverage, 5356,
     /*   9704 */     GIR_EraseRootFromParent_Done,
     /*   9705 */   // Label 227: @9705
     /*   9705 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9855), // Rule ID 5383 //
     /*   9710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9747 */     // MIs[1] Operand 2
     /*   9747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9760 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9760 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9763 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9767 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9786 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9789 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9793 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9837 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9854 */     // GIR_Coverage, 5383,
     /*   9854 */     GIR_EraseRootFromParent_Done,
     /*   9855 */   // Label 228: @9855
     /*   9855 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(10005), // Rule ID 5389 //
     /*   9860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9897 */     // MIs[1] Operand 2
     /*   9897 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9910 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10004 */     // GIR_Coverage, 5389,
     /*  10004 */     GIR_EraseRootFromParent_Done,
     /*  10005 */   // Label 229: @10005
     /*  10005 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(10155), // Rule ID 5382 //
     /*  10010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10047 */     // MIs[1] Operand 2
     /*  10047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10060 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10060 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10063 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10067 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10086 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10093 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10154 */     // GIR_Coverage, 5382,
     /*  10154 */     GIR_EraseRootFromParent_Done,
     /*  10155 */   // Label 230: @10155
     /*  10155 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10188), // Rule ID 13190 //
     /*  10160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10175 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10186 */     GIR_RootConstrainSelectedInstOperands,
     /*  10187 */     // GIR_Coverage, 13190,
     /*  10187 */     GIR_EraseRootFromParent_Done,
     /*  10188 */   // Label 231: @10188
     /*  10188 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10224), // Rule ID 13753 //
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10208 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10222 */     GIR_RootConstrainSelectedInstOperands,
     /*  10223 */     // GIR_Coverage, 13753,
     /*  10223 */     GIR_EraseRootFromParent_Done,
     /*  10224 */   // Label 232: @10224
     /*  10224 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10257), // Rule ID 98 //
     /*  10229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10244 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10255 */     GIR_RootConstrainSelectedInstOperands,
     /*  10256 */     // GIR_Coverage, 98,
     /*  10256 */     GIR_EraseRootFromParent_Done,
     /*  10257 */   // Label 233: @10257
     /*  10257 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10293), // Rule ID 3922 //
     /*  10262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10277 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 3922,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 234: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10326), // Rule ID 13188 //
     /*  10298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10313 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10324 */     GIR_RootConstrainSelectedInstOperands,
     /*  10325 */     // GIR_Coverage, 13188,
     /*  10325 */     GIR_EraseRootFromParent_Done,
     /*  10326 */   // Label 235: @10326
     /*  10326 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10389), // Rule ID 15501 //
     /*  10331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10346 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10349 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10365 */     // MIs[1] pred
     /*  10365 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10376 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10387 */     GIR_RootConstrainSelectedInstOperands,
     /*  10388 */     // GIR_Coverage, 15501,
     /*  10388 */     GIR_EraseRootFromParent_Done,
     /*  10389 */   // Label 236: @10389
     /*  10389 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10452), // Rule ID 15502 //
     /*  10394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10428 */     // MIs[1] pred
     /*  10428 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10439 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10450 */     GIR_RootConstrainSelectedInstOperands,
     /*  10451 */     // GIR_Coverage, 15502,
     /*  10451 */     GIR_EraseRootFromParent_Done,
     /*  10452 */   // Label 237: @10452
     /*  10452 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10515), // Rule ID 15503 //
     /*  10457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10472 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10475 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10491 */     // MIs[1] pred
     /*  10491 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10502 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10513 */     GIR_RootConstrainSelectedInstOperands,
     /*  10514 */     // GIR_Coverage, 15503,
     /*  10514 */     GIR_EraseRootFromParent_Done,
     /*  10515 */   // Label 238: @10515
     /*  10515 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10578), // Rule ID 15504 //
     /*  10520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10535 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10538 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10554 */     // MIs[1] pred
     /*  10554 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10565 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10576 */     GIR_RootConstrainSelectedInstOperands,
     /*  10577 */     // GIR_Coverage, 15504,
     /*  10577 */     GIR_EraseRootFromParent_Done,
     /*  10578 */   // Label 239: @10578
     /*  10578 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10611), // Rule ID 96 //
     /*  10583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10598 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10609 */     GIR_RootConstrainSelectedInstOperands,
     /*  10610 */     // GIR_Coverage, 96,
     /*  10610 */     GIR_EraseRootFromParent_Done,
     /*  10611 */   // Label 240: @10611
     /*  10611 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10674), // Rule ID 10031 //
     /*  10616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10654 */     // MIs[1] pred
     /*  10654 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10661 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10672 */     GIR_RootConstrainSelectedInstOperands,
     /*  10673 */     // GIR_Coverage, 10031,
     /*  10673 */     GIR_EraseRootFromParent_Done,
     /*  10674 */   // Label 241: @10674
     /*  10674 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10737), // Rule ID 10032 //
     /*  10679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10698 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10701 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10717 */     // MIs[1] pred
     /*  10717 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10724 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10735 */     GIR_RootConstrainSelectedInstOperands,
     /*  10736 */     // GIR_Coverage, 10032,
     /*  10736 */     GIR_EraseRootFromParent_Done,
     /*  10737 */   // Label 242: @10737
     /*  10737 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10800), // Rule ID 10033 //
     /*  10742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10780 */     // MIs[1] pred
     /*  10780 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10787 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10798 */     GIR_RootConstrainSelectedInstOperands,
     /*  10799 */     // GIR_Coverage, 10033,
     /*  10799 */     GIR_EraseRootFromParent_Done,
     /*  10800 */   // Label 243: @10800
     /*  10800 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10863), // Rule ID 10034 //
     /*  10805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10824 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10827 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10843 */     // MIs[1] pred
     /*  10843 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10850 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10861 */     GIR_RootConstrainSelectedInstOperands,
     /*  10862 */     // GIR_Coverage, 10034,
     /*  10862 */     GIR_EraseRootFromParent_Done,
     /*  10863 */   // Label 244: @10863
     /*  10863 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10919), // Rule ID 13296 //
     /*  10868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10883 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10886 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10906 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10917 */     GIR_RootConstrainSelectedInstOperands,
     /*  10918 */     // GIR_Coverage, 13296,
     /*  10918 */     GIR_EraseRootFromParent_Done,
     /*  10919 */   // Label 245: @10919
     /*  10919 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10975), // Rule ID 13308 //
     /*  10924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10939 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10942 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10962 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10973 */     GIR_RootConstrainSelectedInstOperands,
     /*  10974 */     // GIR_Coverage, 13308,
     /*  10974 */     GIR_EraseRootFromParent_Done,
     /*  10975 */   // Label 246: @10975
     /*  10975 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11042), // Rule ID 13514 //
     /*  10980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11004 */     // MIs[1] imm
     /*  11004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11016 */     // MIs[2] Operand 1
     /*  11016 */     // No operand predicates
     /*  11016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11026 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11040 */     GIR_RootConstrainSelectedInstOperands,
     /*  11041 */     // GIR_Coverage, 13514,
     /*  11041 */     GIR_EraseRootFromParent_Done,
     /*  11042 */   // Label 247: @11042
     /*  11042 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11109), // Rule ID 13517 //
     /*  11047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11071 */     // MIs[1] imm
     /*  11071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11083 */     // MIs[2] Operand 1
     /*  11083 */     // No operand predicates
     /*  11083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11093 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11107 */     GIR_RootConstrainSelectedInstOperands,
     /*  11108 */     // GIR_Coverage, 13517,
     /*  11108 */     GIR_EraseRootFromParent_Done,
     /*  11109 */   // Label 248: @11109
     /*  11109 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11165), // Rule ID 997 //
     /*  11114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11133 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11136 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11152 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11163 */     GIR_RootConstrainSelectedInstOperands,
     /*  11164 */     // GIR_Coverage, 997,
     /*  11164 */     GIR_EraseRootFromParent_Done,
     /*  11165 */   // Label 249: @11165
     /*  11165 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11221), // Rule ID 1058 //
     /*  11170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11189 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11192 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11208 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11219 */     GIR_RootConstrainSelectedInstOperands,
     /*  11220 */     // GIR_Coverage, 1058,
     /*  11220 */     GIR_EraseRootFromParent_Done,
     /*  11221 */   // Label 250: @11221
     /*  11221 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11288), // Rule ID 2121 //
     /*  11226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11254 */     // MIs[1] imm
     /*  11254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11266 */     // MIs[2] Operand 1
     /*  11266 */     // No operand predicates
     /*  11266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11272 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11286 */     GIR_RootConstrainSelectedInstOperands,
     /*  11287 */     // GIR_Coverage, 2121,
     /*  11287 */     GIR_EraseRootFromParent_Done,
     /*  11288 */   // Label 251: @11288
     /*  11288 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11355), // Rule ID 2130 //
     /*  11293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11321 */     // MIs[1] imm
     /*  11321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11333 */     // MIs[2] Operand 1
     /*  11333 */     // No operand predicates
     /*  11333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11339 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 2130,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 252: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11403), // Rule ID 13295 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11390 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11401 */     GIR_RootConstrainSelectedInstOperands,
     /*  11402 */     // GIR_Coverage, 13295,
     /*  11402 */     GIR_EraseRootFromParent_Done,
     /*  11403 */   // Label 253: @11403
     /*  11403 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11451), // Rule ID 13307 //
     /*  11408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11438 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11449 */     GIR_RootConstrainSelectedInstOperands,
     /*  11450 */     // GIR_Coverage, 13307,
     /*  11450 */     GIR_EraseRootFromParent_Done,
     /*  11451 */   // Label 254: @11451
     /*  11451 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11499), // Rule ID 996 //
     /*  11456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11486 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11497 */     GIR_RootConstrainSelectedInstOperands,
     /*  11498 */     // GIR_Coverage, 996,
     /*  11498 */     GIR_EraseRootFromParent_Done,
     /*  11499 */   // Label 255: @11499
     /*  11499 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11547), // Rule ID 1057 //
     /*  11504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11534 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11545 */     GIR_RootConstrainSelectedInstOperands,
     /*  11546 */     // GIR_Coverage, 1057,
     /*  11546 */     GIR_EraseRootFromParent_Done,
     /*  11547 */   // Label 256: @11547
     /*  11547 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11571), // Rule ID 94 //
     /*  11552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11564 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11569 */     GIR_RootConstrainSelectedInstOperands,
     /*  11570 */     // GIR_Coverage, 94,
     /*  11570 */     GIR_Done,
     /*  11571 */   // Label 257: @11571
     /*  11571 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11598), // Rule ID 1607 //
     /*  11576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11591 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11596 */     GIR_RootConstrainSelectedInstOperands,
     /*  11597 */     // GIR_Coverage, 1607,
     /*  11597 */     GIR_Done,
     /*  11598 */   // Label 258: @11598
     /*  11598 */   GIM_Reject,
     /*  11599 */ // Label 193: @11599
     /*  11599 */ GIM_Reject,
     /*  11600 */ // Label 155: @11600
     /*  11600 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(15207),
     /*  11605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11611 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11799), // Rule ID 6926 //
     /*  11616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11653 */     // MIs[2] Operand 2
     /*  11653 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11672 */     // MIs[3] Rn
     /*  11672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11677 */     // MIs[3] Operand 2
     /*  11677 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11696 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11700 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11708 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11712 */     // MIs[5] Rn
     /*  11712 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11717 */     // MIs[5] Operand 2
     /*  11717 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11728 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11732 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11736 */     // MIs[6] Rn
     /*  11736 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11741 */     // MIs[6] Operand 2
     /*  11741 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11752 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11754 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11798 */     // GIR_Coverage, 6926,
     /*  11798 */     GIR_EraseRootFromParent_Done,
     /*  11799 */   // Label 260: @11799
     /*  11799 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11987), // Rule ID 13921 //
     /*  11804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11841 */     // MIs[2] Operand 2
     /*  11841 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11860 */     // MIs[3] Rn
     /*  11860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11865 */     // MIs[3] Operand 2
     /*  11865 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11884 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11900 */     // MIs[5] Rn
     /*  11900 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11905 */     // MIs[5] Operand 2
     /*  11905 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11916 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11920 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11924 */     // MIs[6] Rn
     /*  11924 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11929 */     // MIs[6] Operand 2
     /*  11929 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11940 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11942 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11969 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11986 */     // GIR_Coverage, 13921,
     /*  11986 */     GIR_EraseRootFromParent_Done,
     /*  11987 */   // Label 261: @11987
     /*  11987 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12123), // Rule ID 5373 //
     /*  11992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12025 */     // MIs[1] Operand 2
     /*  12025 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12048 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12052 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12056 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12060 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12065 */     // MIs[3] Operand 2
     /*  12065 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12076 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12078 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12122 */     // GIR_Coverage, 5373,
     /*  12122 */     GIR_EraseRootFromParent_Done,
     /*  12123 */   // Label 262: @12123
     /*  12123 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12259), // Rule ID 5372 //
     /*  12128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12161 */     // MIs[1] Operand 2
     /*  12161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12188 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12192 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12196 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12201 */     // MIs[3] Operand 2
     /*  12201 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12212 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12258 */     // GIR_Coverage, 5372,
     /*  12258 */     GIR_EraseRootFromParent_Done,
     /*  12259 */   // Label 263: @12259
     /*  12259 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12395), // Rule ID 5385 //
     /*  12264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12297 */     // MIs[1] Operand 2
     /*  12297 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12328 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12332 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12337 */     // MIs[3] Operand 2
     /*  12337 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12348 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12350 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12394 */     // GIR_Coverage, 5385,
     /*  12394 */     GIR_EraseRootFromParent_Done,
     /*  12395 */   // Label 264: @12395
     /*  12395 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12531), // Rule ID 5371 //
     /*  12400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12433 */     // MIs[1] Operand 2
     /*  12433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12468 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12473 */     // MIs[3] Operand 2
     /*  12473 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12486 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12530 */     // GIR_Coverage, 5371,
     /*  12530 */     GIR_EraseRootFromParent_Done,
     /*  12531 */   // Label 265: @12531
     /*  12531 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12667), // Rule ID 5370 //
     /*  12536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12569 */     // MIs[1] Operand 2
     /*  12569 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12600 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12604 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12609 */     // MIs[3] Operand 2
     /*  12609 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12622 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12666 */     // GIR_Coverage, 5370,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 266: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12830), // Rule ID 13881 //
     /*  12672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12714 */     // MIs[1] Operand 2
     /*  12714 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12731 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12757 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12764 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12812 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12829 */     // GIR_Coverage, 13881,
     /*  12829 */     GIR_EraseRootFromParent_Done,
     /*  12830 */   // Label 267: @12830
     /*  12830 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12993), // Rule ID 13878 //
     /*  12835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12877 */     // MIs[1] Operand 2
     /*  12877 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12894 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12894 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12897 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12901 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12920 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12927 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12992 */     // GIR_Coverage, 13878,
     /*  12992 */     GIR_EraseRootFromParent_Done,
     /*  12993 */   // Label 268: @12993
     /*  12993 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(13143), // Rule ID 13886 //
     /*  12998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13031 */     // MIs[1] Operand 2
     /*  13031 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13048 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13051 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13055 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13074 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13081 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13125 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13142 */     // GIR_Coverage, 13886,
     /*  13142 */     GIR_EraseRootFromParent_Done,
     /*  13143 */   // Label 269: @13143
     /*  13143 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13293), // Rule ID 13890 //
     /*  13148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13181 */     // MIs[1] Operand 2
     /*  13181 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13198 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13224 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13231 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13239 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13244 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13292 */     // GIR_Coverage, 13890,
     /*  13292 */     GIR_EraseRootFromParent_Done,
     /*  13293 */   // Label 270: @13293
     /*  13293 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13443), // Rule ID 13885 //
     /*  13298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13331 */     // MIs[1] Operand 2
     /*  13331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13348 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13348 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13351 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13355 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13374 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13425 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13442 */     // GIR_Coverage, 13885,
     /*  13442 */     GIR_EraseRootFromParent_Done,
     /*  13443 */   // Label 271: @13443
     /*  13443 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13606), // Rule ID 5358 //
     /*  13448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13494 */     // MIs[1] Operand 2
     /*  13494 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13507 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13533 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13588 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13605 */     // GIR_Coverage, 5358,
     /*  13605 */     GIR_EraseRootFromParent_Done,
     /*  13606 */   // Label 272: @13606
     /*  13606 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13769), // Rule ID 5355 //
     /*  13611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13657 */     // MIs[1] Operand 2
     /*  13657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13670 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13696 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13703 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13751 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13768 */     // GIR_Coverage, 5355,
     /*  13768 */     GIR_EraseRootFromParent_Done,
     /*  13769 */   // Label 273: @13769
     /*  13769 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13919), // Rule ID 5381 //
     /*  13774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13811 */     // MIs[1] Operand 2
     /*  13811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13824 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13918 */     // GIR_Coverage, 5381,
     /*  13918 */     GIR_EraseRootFromParent_Done,
     /*  13919 */   // Label 274: @13919
     /*  13919 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(14069), // Rule ID 5388 //
     /*  13924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13961 */     // MIs[1] Operand 2
     /*  13961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13974 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13974 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13977 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13981 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14000 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14007 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14051 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14068 */     // GIR_Coverage, 5388,
     /*  14068 */     GIR_EraseRootFromParent_Done,
     /*  14069 */   // Label 275: @14069
     /*  14069 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(14219), // Rule ID 5380 //
     /*  14074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14111 */     // MIs[1] Operand 2
     /*  14111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14124 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14124 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14127 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14131 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14150 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14157 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14218 */     // GIR_Coverage, 5380,
     /*  14218 */     GIR_EraseRootFromParent_Done,
     /*  14219 */   // Label 276: @14219
     /*  14219 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14288), // Rule ID 13330 //
     /*  14224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14239 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14242 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14271 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14286 */     GIR_RootConstrainSelectedInstOperands,
     /*  14287 */     // GIR_Coverage, 13330,
     /*  14287 */     GIR_EraseRootFromParent_Done,
     /*  14288 */   // Label 277: @14288
     /*  14288 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14357), // Rule ID 13342 //
     /*  14293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14340 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14355 */     GIR_RootConstrainSelectedInstOperands,
     /*  14356 */     // GIR_Coverage, 13342,
     /*  14356 */     GIR_EraseRootFromParent_Done,
     /*  14357 */   // Label 278: @14357
     /*  14357 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14413), // Rule ID 13292 //
     /*  14362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14377 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14380 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14400 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14411 */     GIR_RootConstrainSelectedInstOperands,
     /*  14412 */     // GIR_Coverage, 13292,
     /*  14412 */     GIR_EraseRootFromParent_Done,
     /*  14413 */   // Label 279: @14413
     /*  14413 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14469), // Rule ID 13304 //
     /*  14418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14433 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14436 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14456 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14467 */     GIR_RootConstrainSelectedInstOperands,
     /*  14468 */     // GIR_Coverage, 13304,
     /*  14468 */     GIR_EraseRootFromParent_Done,
     /*  14469 */   // Label 280: @14469
     /*  14469 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14536), // Rule ID 13534 //
     /*  14474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14498 */     // MIs[1] imm
     /*  14498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14510 */     // MIs[2] Operand 1
     /*  14510 */     // No operand predicates
     /*  14510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14520 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14534 */     GIR_RootConstrainSelectedInstOperands,
     /*  14535 */     // GIR_Coverage, 13534,
     /*  14535 */     GIR_EraseRootFromParent_Done,
     /*  14536 */   // Label 281: @14536
     /*  14536 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14603), // Rule ID 13555 //
     /*  14541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14565 */     // MIs[1] imm
     /*  14565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14573 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14577 */     // MIs[2] Operand 1
     /*  14577 */     // No operand predicates
     /*  14577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14587 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14601 */     GIR_RootConstrainSelectedInstOperands,
     /*  14602 */     // GIR_Coverage, 13555,
     /*  14602 */     GIR_EraseRootFromParent_Done,
     /*  14603 */   // Label 282: @14603
     /*  14603 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14672), // Rule ID 1365 //
     /*  14608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14627 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14630 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14655 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14670 */     GIR_RootConstrainSelectedInstOperands,
     /*  14671 */     // GIR_Coverage, 1365,
     /*  14671 */     GIR_EraseRootFromParent_Done,
     /*  14672 */   // Label 283: @14672
     /*  14672 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14741), // Rule ID 1488 //
     /*  14677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14724 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14739 */     GIR_RootConstrainSelectedInstOperands,
     /*  14740 */     // GIR_Coverage, 1488,
     /*  14740 */     GIR_EraseRootFromParent_Done,
     /*  14741 */   // Label 284: @14741
     /*  14741 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14797), // Rule ID 993 //
     /*  14746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14765 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14768 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14784 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14795 */     GIR_RootConstrainSelectedInstOperands,
     /*  14796 */     // GIR_Coverage, 993,
     /*  14796 */     GIR_EraseRootFromParent_Done,
     /*  14797 */   // Label 285: @14797
     /*  14797 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14853), // Rule ID 1054 //
     /*  14802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14821 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14824 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14851 */     GIR_RootConstrainSelectedInstOperands,
     /*  14852 */     // GIR_Coverage, 1054,
     /*  14852 */     GIR_EraseRootFromParent_Done,
     /*  14853 */   // Label 286: @14853
     /*  14853 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14920), // Rule ID 2238 //
     /*  14858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14886 */     // MIs[1] imm
     /*  14886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14894 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14898 */     // MIs[2] Operand 1
     /*  14898 */     // No operand predicates
     /*  14898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14904 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14918 */     GIR_RootConstrainSelectedInstOperands,
     /*  14919 */     // GIR_Coverage, 2238,
     /*  14919 */     GIR_EraseRootFromParent_Done,
     /*  14920 */   // Label 287: @14920
     /*  14920 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14987), // Rule ID 2297 //
     /*  14925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14953 */     // MIs[1] imm
     /*  14953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14965 */     // MIs[2] Operand 1
     /*  14965 */     // No operand predicates
     /*  14965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14971 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14985 */     GIR_RootConstrainSelectedInstOperands,
     /*  14986 */     // GIR_Coverage, 2297,
     /*  14986 */     GIR_EraseRootFromParent_Done,
     /*  14987 */   // Label 288: @14987
     /*  14987 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15035), // Rule ID 13291 //
     /*  14992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15022 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15033 */     GIR_RootConstrainSelectedInstOperands,
     /*  15034 */     // GIR_Coverage, 13291,
     /*  15034 */     GIR_EraseRootFromParent_Done,
     /*  15035 */   // Label 289: @15035
     /*  15035 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15083), // Rule ID 13303 //
     /*  15040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15070 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15081 */     GIR_RootConstrainSelectedInstOperands,
     /*  15082 */     // GIR_Coverage, 13303,
     /*  15082 */     GIR_EraseRootFromParent_Done,
     /*  15083 */   // Label 290: @15083
     /*  15083 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15131), // Rule ID 992 //
     /*  15088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15118 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15129 */     GIR_RootConstrainSelectedInstOperands,
     /*  15130 */     // GIR_Coverage, 992,
     /*  15130 */     GIR_EraseRootFromParent_Done,
     /*  15131 */   // Label 291: @15131
     /*  15131 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15179), // Rule ID 1053 //
     /*  15136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15166 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15177 */     GIR_RootConstrainSelectedInstOperands,
     /*  15178 */     // GIR_Coverage, 1053,
     /*  15178 */     GIR_EraseRootFromParent_Done,
     /*  15179 */   // Label 292: @15179
     /*  15179 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15206), // Rule ID 1104 //
     /*  15184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15199 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15204 */     GIR_RootConstrainSelectedInstOperands,
     /*  15205 */     // GIR_Coverage, 1104,
     /*  15205 */     GIR_Done,
     /*  15206 */   // Label 293: @15206
     /*  15206 */   GIM_Reject,
     /*  15207 */ // Label 259: @15207
     /*  15207 */ GIM_Reject,
     /*  15208 */ // Label 156: @15208
     /*  15208 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(21109),
     /*  15213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15219 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15337), // Rule ID 13469 //
     /*  15224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15292 */     // MIs[4] Operand 1
     /*  15292 */     // No operand predicates
     /*  15292 */     // MIs[2] Operand 2
     /*  15292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15307 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15316 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15335 */     GIR_RootConstrainSelectedInstOperands,
     /*  15336 */     // GIR_Coverage, 13469,
     /*  15336 */     GIR_EraseRootFromParent_Done,
     /*  15337 */   // Label 295: @15337
     /*  15337 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15455), // Rule ID 13470 //
     /*  15342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15389 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15406 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15410 */     // MIs[4] Operand 1
     /*  15410 */     // No operand predicates
     /*  15410 */     // MIs[2] Operand 2
     /*  15410 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15434 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 13470,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 296: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15573), // Rule ID 13499 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15507 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15511 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15524 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15528 */     // MIs[4] Operand 1
     /*  15528 */     // No operand predicates
     /*  15528 */     // MIs[2] Operand 2
     /*  15528 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15552 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15571 */     GIR_RootConstrainSelectedInstOperands,
     /*  15572 */     // GIR_Coverage, 13499,
     /*  15572 */     GIR_EraseRootFromParent_Done,
     /*  15573 */   // Label 297: @15573
     /*  15573 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15691), // Rule ID 13500 //
     /*  15578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15634 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15638 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15642 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15646 */     // MIs[4] Operand 1
     /*  15646 */     // No operand predicates
     /*  15646 */     // MIs[2] Operand 2
     /*  15646 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15670 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15689 */     GIR_RootConstrainSelectedInstOperands,
     /*  15690 */     // GIR_Coverage, 13500,
     /*  15690 */     GIR_EraseRootFromParent_Done,
     /*  15691 */   // Label 298: @15691
     /*  15691 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15809), // Rule ID 2042 //
     /*  15696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15747 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15760 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15764 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15768 */     // MIs[4] Operand 1
     /*  15768 */     // No operand predicates
     /*  15768 */     // MIs[2] Operand 2
     /*  15768 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15779 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15788 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15807 */     GIR_RootConstrainSelectedInstOperands,
     /*  15808 */     // GIR_Coverage, 2042,
     /*  15808 */     GIR_EraseRootFromParent_Done,
     /*  15809 */   // Label 299: @15809
     /*  15809 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15927), // Rule ID 13468 //
     /*  15814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15882 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15886 */     // MIs[4] Operand 1
     /*  15886 */     // No operand predicates
     /*  15886 */     // MIs[2] Operand 2
     /*  15886 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15897 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15906 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15925 */     GIR_RootConstrainSelectedInstOperands,
     /*  15926 */     // GIR_Coverage, 13468,
     /*  15926 */     GIR_EraseRootFromParent_Done,
     /*  15927 */   // Label 300: @15927
     /*  15927 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(16045), // Rule ID 2094 //
     /*  15932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15987 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16000 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16004 */     // MIs[4] Operand 1
     /*  16004 */     // No operand predicates
     /*  16004 */     // MIs[2] Operand 2
     /*  16004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16015 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16024 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16043 */     GIR_RootConstrainSelectedInstOperands,
     /*  16044 */     // GIR_Coverage, 2094,
     /*  16044 */     GIR_EraseRootFromParent_Done,
     /*  16045 */   // Label 301: @16045
     /*  16045 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(16163), // Rule ID 13498 //
     /*  16050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16097 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16101 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16105 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16114 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16118 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16122 */     // MIs[4] Operand 1
     /*  16122 */     // No operand predicates
     /*  16122 */     // MIs[2] Operand 2
     /*  16122 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16133 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16142 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16161 */     GIR_RootConstrainSelectedInstOperands,
     /*  16162 */     // GIR_Coverage, 13498,
     /*  16162 */     GIR_EraseRootFromParent_Done,
     /*  16163 */   // Label 302: @16163
     /*  16163 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16250), // Rule ID 13374 //
     /*  16168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16195 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16198 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16207 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16231 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16248 */     GIR_RootConstrainSelectedInstOperands,
     /*  16249 */     // GIR_Coverage, 13374,
     /*  16249 */     GIR_EraseRootFromParent_Done,
     /*  16250 */   // Label 303: @16250
     /*  16250 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16337), // Rule ID 13398 //
     /*  16255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16282 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16285 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16294 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16318 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16335 */     GIR_RootConstrainSelectedInstOperands,
     /*  16336 */     // GIR_Coverage, 13398,
     /*  16336 */     GIR_EraseRootFromParent_Done,
     /*  16337 */   // Label 304: @16337
     /*  16337 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16424), // Rule ID 1699 //
     /*  16342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16373 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16376 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16385 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16405 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16422 */     GIR_RootConstrainSelectedInstOperands,
     /*  16423 */     // GIR_Coverage, 1699,
     /*  16423 */     GIR_EraseRootFromParent_Done,
     /*  16424 */   // Label 305: @16424
     /*  16424 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16511), // Rule ID 1777 //
     /*  16429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16460 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16463 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16472 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16492 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16509 */     GIR_RootConstrainSelectedInstOperands,
     /*  16510 */     // GIR_Coverage, 1777,
     /*  16510 */     GIR_EraseRootFromParent_Done,
     /*  16511 */   // Label 306: @16511
     /*  16511 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16626), // Rule ID 13464 //
     /*  16516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16559 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16563 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16567 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16576 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16580 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16584 */     // MIs[4] Operand 1
     /*  16584 */     // No operand predicates
     /*  16584 */     // MIs[2] Operand 2
     /*  16584 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16606 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16624 */     GIR_RootConstrainSelectedInstOperands,
     /*  16625 */     // GIR_Coverage, 13464,
     /*  16625 */     GIR_EraseRootFromParent_Done,
     /*  16626 */   // Label 307: @16626
     /*  16626 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16741), // Rule ID 13463 //
     /*  16631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16687 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16700 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16704 */     // MIs[4] Operand 1
     /*  16704 */     // No operand predicates
     /*  16704 */     // MIs[2] Operand 2
     /*  16704 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16719 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16721 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16739 */     GIR_RootConstrainSelectedInstOperands,
     /*  16740 */     // GIR_Coverage, 13463,
     /*  16740 */     GIR_EraseRootFromParent_Done,
     /*  16741 */   // Label 308: @16741
     /*  16741 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16856), // Rule ID 13494 //
     /*  16746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16789 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16797 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16810 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16814 */     // MIs[4] Operand 1
     /*  16814 */     // No operand predicates
     /*  16814 */     // MIs[2] Operand 2
     /*  16814 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16836 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16854 */     GIR_RootConstrainSelectedInstOperands,
     /*  16855 */     // GIR_Coverage, 13494,
     /*  16855 */     GIR_EraseRootFromParent_Done,
     /*  16856 */   // Label 309: @16856
     /*  16856 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16971), // Rule ID 13493 //
     /*  16861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16913 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16917 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16930 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16934 */     // MIs[4] Operand 1
     /*  16934 */     // No operand predicates
     /*  16934 */     // MIs[2] Operand 2
     /*  16934 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16949 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16951 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16969 */     GIR_RootConstrainSelectedInstOperands,
     /*  16970 */     // GIR_Coverage, 13493,
     /*  16970 */     GIR_EraseRootFromParent_Done,
     /*  16971 */   // Label 310: @16971
     /*  16971 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(17040), // Rule ID 1801 //
     /*  16976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17023 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17038 */     GIR_RootConstrainSelectedInstOperands,
     /*  17039 */     // GIR_Coverage, 1801,
     /*  17039 */     GIR_EraseRootFromParent_Done,
     /*  17040 */   // Label 311: @17040
     /*  17040 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(17109), // Rule ID 1800 //
     /*  17045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17092 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17107 */     GIR_RootConstrainSelectedInstOperands,
     /*  17108 */     // GIR_Coverage, 1800,
     /*  17108 */     GIR_EraseRootFromParent_Done,
     /*  17109 */   // Label 312: @17109
     /*  17109 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17178), // Rule ID 1717 //
     /*  17114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17161 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17176 */     GIR_RootConstrainSelectedInstOperands,
     /*  17177 */     // GIR_Coverage, 1717,
     /*  17177 */     GIR_EraseRootFromParent_Done,
     /*  17178 */   // Label 313: @17178
     /*  17178 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17247), // Rule ID 1799 //
     /*  17183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17230 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17245 */     GIR_RootConstrainSelectedInstOperands,
     /*  17246 */     // GIR_Coverage, 1799,
     /*  17246 */     GIR_EraseRootFromParent_Done,
     /*  17247 */   // Label 314: @17247
     /*  17247 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17316), // Rule ID 1798 //
     /*  17252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17299 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17314 */     GIR_RootConstrainSelectedInstOperands,
     /*  17315 */     // GIR_Coverage, 1798,
     /*  17315 */     GIR_EraseRootFromParent_Done,
     /*  17316 */   // Label 315: @17316
     /*  17316 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17431), // Rule ID 13462 //
     /*  17321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17376 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17389 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17393 */     // MIs[4] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     // MIs[2] Operand 2
     /*  17393 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17409 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17411 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17429 */     GIR_RootConstrainSelectedInstOperands,
     /*  17430 */     // GIR_Coverage, 13462,
     /*  17430 */     GIR_EraseRootFromParent_Done,
     /*  17431 */   // Label 316: @17431
     /*  17431 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17546), // Rule ID 2040 //
     /*  17436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17496 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17501 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17505 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17509 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17513 */     // MIs[4] Operand 1
     /*  17513 */     // No operand predicates
     /*  17513 */     // MIs[2] Operand 2
     /*  17513 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17526 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17544 */     GIR_RootConstrainSelectedInstOperands,
     /*  17545 */     // GIR_Coverage, 2040,
     /*  17545 */     GIR_EraseRootFromParent_Done,
     /*  17546 */   // Label 317: @17546
     /*  17546 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17661), // Rule ID 13492 //
     /*  17551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17602 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17606 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17619 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17623 */     // MIs[4] Operand 1
     /*  17623 */     // No operand predicates
     /*  17623 */     // MIs[2] Operand 2
     /*  17623 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17639 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17641 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17659 */     GIR_RootConstrainSelectedInstOperands,
     /*  17660 */     // GIR_Coverage, 13492,
     /*  17660 */     GIR_EraseRootFromParent_Done,
     /*  17661 */   // Label 318: @17661
     /*  17661 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17776), // Rule ID 2092 //
     /*  17666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17726 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17739 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17743 */     // MIs[4] Operand 1
     /*  17743 */     // No operand predicates
     /*  17743 */     // MIs[2] Operand 2
     /*  17743 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17756 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17774 */     GIR_RootConstrainSelectedInstOperands,
     /*  17775 */     // GIR_Coverage, 2092,
     /*  17775 */     GIR_EraseRootFromParent_Done,
     /*  17776 */   // Label 319: @17776
     /*  17776 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17843), // Rule ID 13386 //
     /*  17781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17824 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17841 */     GIR_RootConstrainSelectedInstOperands,
     /*  17842 */     // GIR_Coverage, 13386,
     /*  17842 */     GIR_EraseRootFromParent_Done,
     /*  17843 */   // Label 320: @17843
     /*  17843 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17910), // Rule ID 13416 //
     /*  17848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17891 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17908 */     GIR_RootConstrainSelectedInstOperands,
     /*  17909 */     // GIR_Coverage, 13416,
     /*  17909 */     GIR_EraseRootFromParent_Done,
     /*  17910 */   // Label 321: @17910
     /*  17910 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17977), // Rule ID 1729 //
     /*  17915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17958 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17975 */     GIR_RootConstrainSelectedInstOperands,
     /*  17976 */     // GIR_Coverage, 1729,
     /*  17976 */     GIR_EraseRootFromParent_Done,
     /*  17977 */   // Label 322: @17977
     /*  17977 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(18044), // Rule ID 1819 //
     /*  17982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18025 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18042 */     GIR_RootConstrainSelectedInstOperands,
     /*  18043 */     // GIR_Coverage, 1819,
     /*  18043 */     GIR_EraseRootFromParent_Done,
     /*  18044 */   // Label 323: @18044
     /*  18044 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18125), // Rule ID 13372 //
     /*  18049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18076 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18079 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18088 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18108 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18123 */     GIR_RootConstrainSelectedInstOperands,
     /*  18124 */     // GIR_Coverage, 13372,
     /*  18124 */     GIR_EraseRootFromParent_Done,
     /*  18125 */   // Label 324: @18125
     /*  18125 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18206), // Rule ID 13396 //
     /*  18130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18157 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18160 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18169 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18189 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18204 */     GIR_RootConstrainSelectedInstOperands,
     /*  18205 */     // GIR_Coverage, 13396,
     /*  18205 */     GIR_EraseRootFromParent_Done,
     /*  18206 */   // Label 325: @18206
     /*  18206 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18287), // Rule ID 1697 //
     /*  18211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18242 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18245 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18254 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18270 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18285 */     GIR_RootConstrainSelectedInstOperands,
     /*  18286 */     // GIR_Coverage, 1697,
     /*  18286 */     GIR_EraseRootFromParent_Done,
     /*  18287 */   // Label 326: @18287
     /*  18287 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18368), // Rule ID 1775 //
     /*  18292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18323 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18326 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18335 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18351 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18366 */     GIR_RootConstrainSelectedInstOperands,
     /*  18367 */     // GIR_Coverage, 1775,
     /*  18367 */     GIR_EraseRootFromParent_Done,
     /*  18368 */   // Label 327: @18368
     /*  18368 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18460), // Rule ID 13467 //
     /*  18373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18429 */     // MIs[3] Operand 1
     /*  18429 */     // No operand predicates
     /*  18429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18440 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18458 */     GIR_RootConstrainSelectedInstOperands,
     /*  18459 */     // GIR_Coverage, 13467,
     /*  18459 */     GIR_EraseRootFromParent_Done,
     /*  18460 */   // Label 328: @18460
     /*  18460 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18552), // Rule ID 13466 //
     /*  18465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18526 */     // MIs[3] Operand 1
     /*  18526 */     // No operand predicates
     /*  18526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18532 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18550 */     GIR_RootConstrainSelectedInstOperands,
     /*  18551 */     // GIR_Coverage, 13466,
     /*  18551 */     GIR_EraseRootFromParent_Done,
     /*  18552 */   // Label 329: @18552
     /*  18552 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18644), // Rule ID 13497 //
     /*  18557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18613 */     // MIs[3] Operand 1
     /*  18613 */     // No operand predicates
     /*  18613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18624 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18642 */     GIR_RootConstrainSelectedInstOperands,
     /*  18643 */     // GIR_Coverage, 13497,
     /*  18643 */     GIR_EraseRootFromParent_Done,
     /*  18644 */   // Label 330: @18644
     /*  18644 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18736), // Rule ID 13496 //
     /*  18649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18710 */     // MIs[3] Operand 1
     /*  18710 */     // No operand predicates
     /*  18710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18716 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18734 */     GIR_RootConstrainSelectedInstOperands,
     /*  18735 */     // GIR_Coverage, 13496,
     /*  18735 */     GIR_EraseRootFromParent_Done,
     /*  18736 */   // Label 331: @18736
     /*  18736 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18828), // Rule ID 13465 //
     /*  18741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18797 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18801 */     // MIs[3] Operand 1
     /*  18801 */     // No operand predicates
     /*  18801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18808 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18826 */     GIR_RootConstrainSelectedInstOperands,
     /*  18827 */     // GIR_Coverage, 13465,
     /*  18827 */     GIR_EraseRootFromParent_Done,
     /*  18828 */   // Label 332: @18828
     /*  18828 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18920), // Rule ID 2041 //
     /*  18833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18898 */     // MIs[3] Operand 1
     /*  18898 */     // No operand predicates
     /*  18898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18900 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18918 */     GIR_RootConstrainSelectedInstOperands,
     /*  18919 */     // GIR_Coverage, 2041,
     /*  18919 */     GIR_EraseRootFromParent_Done,
     /*  18920 */   // Label 333: @18920
     /*  18920 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(19012), // Rule ID 13495 //
     /*  18925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18985 */     // MIs[3] Operand 1
     /*  18985 */     // No operand predicates
     /*  18985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18992 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19010 */     GIR_RootConstrainSelectedInstOperands,
     /*  19011 */     // GIR_Coverage, 13495,
     /*  19011 */     GIR_EraseRootFromParent_Done,
     /*  19012 */   // Label 334: @19012
     /*  19012 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(19104), // Rule ID 2093 //
     /*  19017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19078 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19082 */     // MIs[3] Operand 1
     /*  19082 */     // No operand predicates
     /*  19082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19102 */     GIR_RootConstrainSelectedInstOperands,
     /*  19103 */     // GIR_Coverage, 2093,
     /*  19103 */     GIR_EraseRootFromParent_Done,
     /*  19104 */   // Label 335: @19104
     /*  19104 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19155), // Rule ID 13410 //
     /*  19109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19141 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19153 */     GIR_RootConstrainSelectedInstOperands,
     /*  19154 */     // GIR_Coverage, 13410,
     /*  19154 */     GIR_EraseRootFromParent_Done,
     /*  19155 */   // Label 336: @19155
     /*  19155 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19206), // Rule ID 13380 //
     /*  19160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19192 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19204 */     GIR_RootConstrainSelectedInstOperands,
     /*  19205 */     // GIR_Coverage, 13380,
     /*  19205 */     GIR_EraseRootFromParent_Done,
     /*  19206 */   // Label 337: @19206
     /*  19206 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19257), // Rule ID 13409 //
     /*  19211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19243 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19255 */     GIR_RootConstrainSelectedInstOperands,
     /*  19256 */     // GIR_Coverage, 13409,
     /*  19256 */     GIR_EraseRootFromParent_Done,
     /*  19257 */   // Label 338: @19257
     /*  19257 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19308), // Rule ID 1813 //
     /*  19262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19294 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19306 */     GIR_RootConstrainSelectedInstOperands,
     /*  19307 */     // GIR_Coverage, 1813,
     /*  19307 */     GIR_EraseRootFromParent_Done,
     /*  19308 */   // Label 339: @19308
     /*  19308 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19359), // Rule ID 1723 //
     /*  19313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19345 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19357 */     GIR_RootConstrainSelectedInstOperands,
     /*  19358 */     // GIR_Coverage, 1723,
     /*  19358 */     GIR_EraseRootFromParent_Done,
     /*  19359 */   // Label 340: @19359
     /*  19359 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19410), // Rule ID 1812 //
     /*  19364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19396 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19408 */     GIR_RootConstrainSelectedInstOperands,
     /*  19409 */     // GIR_Coverage, 1812,
     /*  19409 */     GIR_EraseRootFromParent_Done,
     /*  19410 */   // Label 341: @19410
     /*  19410 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19466), // Rule ID 13298 //
     /*  19415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19430 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19433 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19453 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19464 */     GIR_RootConstrainSelectedInstOperands,
     /*  19465 */     // GIR_Coverage, 13298,
     /*  19465 */     GIR_EraseRootFromParent_Done,
     /*  19466 */   // Label 342: @19466
     /*  19466 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19522), // Rule ID 13310 //
     /*  19471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19486 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19489 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19509 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19520 */     GIR_RootConstrainSelectedInstOperands,
     /*  19521 */     // GIR_Coverage, 13310,
     /*  19521 */     GIR_EraseRootFromParent_Done,
     /*  19522 */   // Label 343: @19522
     /*  19522 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19589), // Rule ID 13538 //
     /*  19527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19551 */     // MIs[1] imm
     /*  19551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19563 */     // MIs[2] Operand 1
     /*  19563 */     // No operand predicates
     /*  19563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19573 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19587 */     GIR_RootConstrainSelectedInstOperands,
     /*  19588 */     // GIR_Coverage, 13538,
     /*  19588 */     GIR_EraseRootFromParent_Done,
     /*  19589 */   // Label 344: @19589
     /*  19589 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19656), // Rule ID 13559 //
     /*  19594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19618 */     // MIs[1] imm
     /*  19618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19630 */     // MIs[2] Operand 1
     /*  19630 */     // No operand predicates
     /*  19630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19640 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19654 */     GIR_RootConstrainSelectedInstOperands,
     /*  19655 */     // GIR_Coverage, 13559,
     /*  19655 */     GIR_EraseRootFromParent_Done,
     /*  19656 */   // Label 345: @19656
     /*  19656 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19712), // Rule ID 999 //
     /*  19661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19680 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19683 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19699 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19710 */     GIR_RootConstrainSelectedInstOperands,
     /*  19711 */     // GIR_Coverage, 999,
     /*  19711 */     GIR_EraseRootFromParent_Done,
     /*  19712 */   // Label 346: @19712
     /*  19712 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19768), // Rule ID 1060 //
     /*  19717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19739 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19755 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19766 */     GIR_RootConstrainSelectedInstOperands,
     /*  19767 */     // GIR_Coverage, 1060,
     /*  19767 */     GIR_EraseRootFromParent_Done,
     /*  19768 */   // Label 347: @19768
     /*  19768 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19835), // Rule ID 2242 //
     /*  19773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19801 */     // MIs[1] imm
     /*  19801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19813 */     // MIs[2] Operand 1
     /*  19813 */     // No operand predicates
     /*  19813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19819 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19833 */     GIR_RootConstrainSelectedInstOperands,
     /*  19834 */     // GIR_Coverage, 2242,
     /*  19834 */     GIR_EraseRootFromParent_Done,
     /*  19835 */   // Label 348: @19835
     /*  19835 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19902), // Rule ID 2301 //
     /*  19840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19868 */     // MIs[1] imm
     /*  19868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19876 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19880 */     // MIs[2] Operand 1
     /*  19880 */     // No operand predicates
     /*  19880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19886 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19900 */     GIR_RootConstrainSelectedInstOperands,
     /*  19901 */     // GIR_Coverage, 2301,
     /*  19901 */     GIR_EraseRootFromParent_Done,
     /*  19902 */   // Label 349: @19902
     /*  19902 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19972), // Rule ID 6922 //
     /*  19907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19945 */     // MIs[2] Rn
     /*  19945 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19950 */     // MIs[2] Rm
     /*  19950 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19957 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19970 */     GIR_RootConstrainSelectedInstOperands,
     /*  19971 */     // GIR_Coverage, 6922,
     /*  19971 */     GIR_EraseRootFromParent_Done,
     /*  19972 */   // Label 350: @19972
     /*  19972 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20042), // Rule ID 13917 //
     /*  19977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20015 */     // MIs[2] Rn
     /*  20015 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20020 */     // MIs[2] Rm
     /*  20020 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20027 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20040 */     GIR_RootConstrainSelectedInstOperands,
     /*  20041 */     // GIR_Coverage, 13917,
     /*  20041 */     GIR_EraseRootFromParent_Done,
     /*  20042 */   // Label 351: @20042
     /*  20042 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20105), // Rule ID 1797 //
     /*  20047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20090 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20103 */     GIR_RootConstrainSelectedInstOperands,
     /*  20104 */     // GIR_Coverage, 1797,
     /*  20104 */     GIR_EraseRootFromParent_Done,
     /*  20105 */   // Label 352: @20105
     /*  20105 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20168), // Rule ID 1796 //
     /*  20110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20153 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20166 */     GIR_RootConstrainSelectedInstOperands,
     /*  20167 */     // GIR_Coverage, 1796,
     /*  20167 */     GIR_EraseRootFromParent_Done,
     /*  20168 */   // Label 353: @20168
     /*  20168 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20231), // Rule ID 1716 //
     /*  20173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20216 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20229 */     GIR_RootConstrainSelectedInstOperands,
     /*  20230 */     // GIR_Coverage, 1716,
     /*  20230 */     GIR_EraseRootFromParent_Done,
     /*  20231 */   // Label 354: @20231
     /*  20231 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20294), // Rule ID 1795 //
     /*  20236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20279 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20292 */     GIR_RootConstrainSelectedInstOperands,
     /*  20293 */     // GIR_Coverage, 1795,
     /*  20293 */     GIR_EraseRootFromParent_Done,
     /*  20294 */   // Label 355: @20294
     /*  20294 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20357), // Rule ID 1794 //
     /*  20299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20342 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20355 */     GIR_RootConstrainSelectedInstOperands,
     /*  20356 */     // GIR_Coverage, 1794,
     /*  20356 */     GIR_EraseRootFromParent_Done,
     /*  20357 */   // Label 356: @20357
     /*  20357 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20418), // Rule ID 13385 //
     /*  20362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20401 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20416 */     GIR_RootConstrainSelectedInstOperands,
     /*  20417 */     // GIR_Coverage, 13385,
     /*  20417 */     GIR_EraseRootFromParent_Done,
     /*  20418 */   // Label 357: @20418
     /*  20418 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20479), // Rule ID 13415 //
     /*  20423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20462 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20477 */     GIR_RootConstrainSelectedInstOperands,
     /*  20478 */     // GIR_Coverage, 13415,
     /*  20478 */     GIR_EraseRootFromParent_Done,
     /*  20479 */   // Label 358: @20479
     /*  20479 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20527), // Rule ID 13408 //
     /*  20484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20514 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20525 */     GIR_RootConstrainSelectedInstOperands,
     /*  20526 */     // GIR_Coverage, 13408,
     /*  20526 */     GIR_EraseRootFromParent_Done,
     /*  20527 */   // Label 359: @20527
     /*  20527 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20575), // Rule ID 13297 //
     /*  20532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20562 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20573 */     GIR_RootConstrainSelectedInstOperands,
     /*  20574 */     // GIR_Coverage, 13297,
     /*  20574 */     GIR_EraseRootFromParent_Done,
     /*  20575 */   // Label 360: @20575
     /*  20575 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20623), // Rule ID 13379 //
     /*  20580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20610 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20621 */     GIR_RootConstrainSelectedInstOperands,
     /*  20622 */     // GIR_Coverage, 13379,
     /*  20622 */     GIR_EraseRootFromParent_Done,
     /*  20623 */   // Label 361: @20623
     /*  20623 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20671), // Rule ID 13309 //
     /*  20628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20658 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20669 */     GIR_RootConstrainSelectedInstOperands,
     /*  20670 */     // GIR_Coverage, 13309,
     /*  20670 */     GIR_EraseRootFromParent_Done,
     /*  20671 */   // Label 362: @20671
     /*  20671 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20719), // Rule ID 13407 //
     /*  20676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20706 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20717 */     GIR_RootConstrainSelectedInstOperands,
     /*  20718 */     // GIR_Coverage, 13407,
     /*  20718 */     GIR_EraseRootFromParent_Done,
     /*  20719 */   // Label 363: @20719
     /*  20719 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20780), // Rule ID 1728 //
     /*  20724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20763 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20778 */     GIR_RootConstrainSelectedInstOperands,
     /*  20779 */     // GIR_Coverage, 1728,
     /*  20779 */     GIR_EraseRootFromParent_Done,
     /*  20780 */   // Label 364: @20780
     /*  20780 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20841), // Rule ID 1818 //
     /*  20785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20839 */     GIR_RootConstrainSelectedInstOperands,
     /*  20840 */     // GIR_Coverage, 1818,
     /*  20840 */     GIR_EraseRootFromParent_Done,
     /*  20841 */   // Label 365: @20841
     /*  20841 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20889), // Rule ID 1811 //
     /*  20846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20876 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20887 */     GIR_RootConstrainSelectedInstOperands,
     /*  20888 */     // GIR_Coverage, 1811,
     /*  20888 */     GIR_EraseRootFromParent_Done,
     /*  20889 */   // Label 366: @20889
     /*  20889 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20937), // Rule ID 998 //
     /*  20894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20924 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20935 */     GIR_RootConstrainSelectedInstOperands,
     /*  20936 */     // GIR_Coverage, 998,
     /*  20936 */     GIR_EraseRootFromParent_Done,
     /*  20937 */   // Label 367: @20937
     /*  20937 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20985), // Rule ID 1722 //
     /*  20942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20972 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20983 */     GIR_RootConstrainSelectedInstOperands,
     /*  20984 */     // GIR_Coverage, 1722,
     /*  20984 */     GIR_EraseRootFromParent_Done,
     /*  20985 */   // Label 368: @20985
     /*  20985 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21033), // Rule ID 1059 //
     /*  20990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21020 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21031 */     GIR_RootConstrainSelectedInstOperands,
     /*  21032 */     // GIR_Coverage, 1059,
     /*  21032 */     GIR_EraseRootFromParent_Done,
     /*  21033 */   // Label 369: @21033
     /*  21033 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21081), // Rule ID 1810 //
     /*  21038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21068 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21079 */     GIR_RootConstrainSelectedInstOperands,
     /*  21080 */     // GIR_Coverage, 1810,
     /*  21080 */     GIR_EraseRootFromParent_Done,
     /*  21081 */   // Label 370: @21081
     /*  21081 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21108), // Rule ID 1106 //
     /*  21086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21101 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21106 */     GIR_RootConstrainSelectedInstOperands,
     /*  21107 */     // GIR_Coverage, 1106,
     /*  21107 */     GIR_Done,
     /*  21108 */   // Label 371: @21108
     /*  21108 */   GIM_Reject,
     /*  21109 */ // Label 294: @21109
     /*  21109 */ GIM_Reject,
     /*  21110 */ // Label 157: @21110
     /*  21110 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(24607),
     /*  21115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21121 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21257), // Rule ID 5369 //
     /*  21126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21159 */     // MIs[1] Operand 2
     /*  21159 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21186 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21190 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21194 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21199 */     // MIs[3] Operand 2
     /*  21199 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21210 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21212 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21256 */     // GIR_Coverage, 5369,
     /*  21256 */     GIR_EraseRootFromParent_Done,
     /*  21257 */   // Label 373: @21257
     /*  21257 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21393), // Rule ID 5368 //
     /*  21262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     // MIs[1] Operand 2
     /*  21295 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21326 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21330 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21335 */     // MIs[3] Operand 2
     /*  21335 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21346 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21348 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21375 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21392 */     // GIR_Coverage, 5368,
     /*  21392 */     GIR_EraseRootFromParent_Done,
     /*  21393 */   // Label 374: @21393
     /*  21393 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21529), // Rule ID 5384 //
     /*  21398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21431 */     // MIs[1] Operand 2
     /*  21431 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21458 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21462 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21466 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21471 */     // MIs[3] Operand 2
     /*  21471 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21482 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21484 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21528 */     // GIR_Coverage, 5384,
     /*  21528 */     GIR_EraseRootFromParent_Done,
     /*  21529 */   // Label 375: @21529
     /*  21529 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21665), // Rule ID 5367 //
     /*  21534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21567 */     // MIs[1] Operand 2
     /*  21567 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21590 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21594 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21598 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21602 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21607 */     // MIs[3] Operand 2
     /*  21607 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21618 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21620 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21664 */     // GIR_Coverage, 5367,
     /*  21664 */     GIR_EraseRootFromParent_Done,
     /*  21665 */   // Label 376: @21665
     /*  21665 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21801), // Rule ID 5366 //
     /*  21670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21703 */     // MIs[1] Operand 2
     /*  21703 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21730 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21734 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21738 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21743 */     // MIs[3] Operand 2
     /*  21743 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21756 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21800 */     // GIR_Coverage, 5366,
     /*  21800 */     GIR_EraseRootFromParent_Done,
     /*  21801 */   // Label 377: @21801
     /*  21801 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21934), // Rule ID 13922 //
     /*  21806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21851 */     // MIs[1] Operand 2
     /*  21851 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21870 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21874 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21878 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21882 */     // MIs[5] Rn
     /*  21882 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21887 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21889 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21916 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21933 */     // GIR_Coverage, 13922,
     /*  21933 */     GIR_EraseRootFromParent_Done,
     /*  21934 */   // Label 378: @21934
     /*  21934 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(22067), // Rule ID 6927 //
     /*  21939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  21992 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21996 */     // MIs[4] Rn
     /*  21996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22001 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22005 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22009 */     // MIs[3] Operand 2
     /*  22009 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22020 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22022 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22066 */     // GIR_Coverage, 6927,
     /*  22066 */     GIR_EraseRootFromParent_Done,
     /*  22067 */   // Label 379: @22067
     /*  22067 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(22230), // Rule ID 13880 //
     /*  22072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22114 */     // MIs[1] Operand 2
     /*  22114 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22131 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22145 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22148 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22152 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22157 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22160 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22167 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22212 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22229 */     // GIR_Coverage, 13880,
     /*  22229 */     GIR_EraseRootFromParent_Done,
     /*  22230 */   // Label 380: @22230
     /*  22230 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22393), // Rule ID 13877 //
     /*  22235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22277 */     // MIs[1] Operand 2
     /*  22277 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22294 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22320 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22327 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22375 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22392 */     // GIR_Coverage, 13877,
     /*  22392 */     GIR_EraseRootFromParent_Done,
     /*  22393 */   // Label 381: @22393
     /*  22393 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22543), // Rule ID 13884 //
     /*  22398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22431 */     // MIs[1] Operand 2
     /*  22431 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22448 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22448 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22451 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22455 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22474 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22481 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22542 */     // GIR_Coverage, 13884,
     /*  22542 */     GIR_EraseRootFromParent_Done,
     /*  22543 */   // Label 382: @22543
     /*  22543 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22693), // Rule ID 13889 //
     /*  22548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22581 */     // MIs[1] Operand 2
     /*  22581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22598 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22624 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22631 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22675 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22692 */     // GIR_Coverage, 13889,
     /*  22692 */     GIR_EraseRootFromParent_Done,
     /*  22693 */   // Label 383: @22693
     /*  22693 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22843), // Rule ID 13883 //
     /*  22698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22731 */     // MIs[1] Operand 2
     /*  22731 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22748 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22842 */     // GIR_Coverage, 13883,
     /*  22842 */     GIR_EraseRootFromParent_Done,
     /*  22843 */   // Label 384: @22843
     /*  22843 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(23006), // Rule ID 5357 //
     /*  22848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22894 */     // MIs[1] Operand 2
     /*  22894 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22907 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23005 */     // GIR_Coverage, 5357,
     /*  23005 */     GIR_EraseRootFromParent_Done,
     /*  23006 */   // Label 385: @23006
     /*  23006 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(23169), // Rule ID 5354 //
     /*  23011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23057 */     // MIs[1] Operand 2
     /*  23057 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23070 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23070 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23073 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23077 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23084 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23087 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23091 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23096 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23103 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23111 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23151 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23168 */     // GIR_Coverage, 5354,
     /*  23168 */     GIR_EraseRootFromParent_Done,
     /*  23169 */   // Label 386: @23169
     /*  23169 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23319), // Rule ID 5379 //
     /*  23174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23211 */     // MIs[1] Operand 2
     /*  23211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23224 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23224 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23227 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23231 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23253 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23318 */     // GIR_Coverage, 5379,
     /*  23318 */     GIR_EraseRootFromParent_Done,
     /*  23319 */   // Label 387: @23319
     /*  23319 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23469), // Rule ID 5387 //
     /*  23324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23361 */     // MIs[1] Operand 2
     /*  23361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23374 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23400 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23451 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23468 */     // GIR_Coverage, 5387,
     /*  23468 */     GIR_EraseRootFromParent_Done,
     /*  23469 */   // Label 388: @23469
     /*  23469 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23619), // Rule ID 5378 //
     /*  23474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23511 */     // MIs[1] Operand 2
     /*  23511 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23524 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23550 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23553 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23557 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23618 */     // GIR_Coverage, 5378,
     /*  23618 */     GIR_EraseRootFromParent_Done,
     /*  23619 */   // Label 389: @23619
     /*  23619 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23688), // Rule ID 13326 //
     /*  23624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23671 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23686 */     GIR_RootConstrainSelectedInstOperands,
     /*  23687 */     // GIR_Coverage, 13326,
     /*  23687 */     GIR_EraseRootFromParent_Done,
     /*  23688 */   // Label 390: @23688
     /*  23688 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23757), // Rule ID 13338 //
     /*  23693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23708 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23711 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23740 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23755 */     GIR_RootConstrainSelectedInstOperands,
     /*  23756 */     // GIR_Coverage, 13338,
     /*  23756 */     GIR_EraseRootFromParent_Done,
     /*  23757 */   // Label 391: @23757
     /*  23757 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23813), // Rule ID 13288 //
     /*  23762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23800 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23811 */     GIR_RootConstrainSelectedInstOperands,
     /*  23812 */     // GIR_Coverage, 13288,
     /*  23812 */     GIR_EraseRootFromParent_Done,
     /*  23813 */   // Label 392: @23813
     /*  23813 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23869), // Rule ID 13300 //
     /*  23818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23833 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23836 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23856 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23867 */     GIR_RootConstrainSelectedInstOperands,
     /*  23868 */     // GIR_Coverage, 13300,
     /*  23868 */     GIR_EraseRootFromParent_Done,
     /*  23869 */   // Label 393: @23869
     /*  23869 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23936), // Rule ID 13530 //
     /*  23874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23898 */     // MIs[1] imm
     /*  23898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23910 */     // MIs[2] Operand 1
     /*  23910 */     // No operand predicates
     /*  23910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23920 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23934 */     GIR_RootConstrainSelectedInstOperands,
     /*  23935 */     // GIR_Coverage, 13530,
     /*  23935 */     GIR_EraseRootFromParent_Done,
     /*  23936 */   // Label 394: @23936
     /*  23936 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(24003), // Rule ID 13551 //
     /*  23941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23965 */     // MIs[1] imm
     /*  23965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23973 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23977 */     // MIs[2] Operand 1
     /*  23977 */     // No operand predicates
     /*  23977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23987 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  23990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24001 */     GIR_RootConstrainSelectedInstOperands,
     /*  24002 */     // GIR_Coverage, 13551,
     /*  24002 */     GIR_EraseRootFromParent_Done,
     /*  24003 */   // Label 395: @24003
     /*  24003 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(24072), // Rule ID 1361 //
     /*  24008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24030 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24055 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24070 */     GIR_RootConstrainSelectedInstOperands,
     /*  24071 */     // GIR_Coverage, 1361,
     /*  24071 */     GIR_EraseRootFromParent_Done,
     /*  24072 */   // Label 396: @24072
     /*  24072 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24141), // Rule ID 1484 //
     /*  24077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24124 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24139 */     GIR_RootConstrainSelectedInstOperands,
     /*  24140 */     // GIR_Coverage, 1484,
     /*  24140 */     GIR_EraseRootFromParent_Done,
     /*  24141 */   // Label 397: @24141
     /*  24141 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24197), // Rule ID 989 //
     /*  24146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24184 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24195 */     GIR_RootConstrainSelectedInstOperands,
     /*  24196 */     // GIR_Coverage, 989,
     /*  24196 */     GIR_EraseRootFromParent_Done,
     /*  24197 */   // Label 398: @24197
     /*  24197 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24253), // Rule ID 1050 //
     /*  24202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24221 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24224 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24251 */     GIR_RootConstrainSelectedInstOperands,
     /*  24252 */     // GIR_Coverage, 1050,
     /*  24252 */     GIR_EraseRootFromParent_Done,
     /*  24253 */   // Label 399: @24253
     /*  24253 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24320), // Rule ID 2234 //
     /*  24258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24286 */     // MIs[1] imm
     /*  24286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24298 */     // MIs[2] Operand 1
     /*  24298 */     // No operand predicates
     /*  24298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24304 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24318 */     GIR_RootConstrainSelectedInstOperands,
     /*  24319 */     // GIR_Coverage, 2234,
     /*  24319 */     GIR_EraseRootFromParent_Done,
     /*  24320 */   // Label 400: @24320
     /*  24320 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24387), // Rule ID 2293 //
     /*  24325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24353 */     // MIs[1] imm
     /*  24353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24365 */     // MIs[2] Operand 1
     /*  24365 */     // No operand predicates
     /*  24365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24371 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24385 */     GIR_RootConstrainSelectedInstOperands,
     /*  24386 */     // GIR_Coverage, 2293,
     /*  24386 */     GIR_EraseRootFromParent_Done,
     /*  24387 */   // Label 401: @24387
     /*  24387 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24435), // Rule ID 13287 //
     /*  24392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24422 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24433 */     GIR_RootConstrainSelectedInstOperands,
     /*  24434 */     // GIR_Coverage, 13287,
     /*  24434 */     GIR_EraseRootFromParent_Done,
     /*  24435 */   // Label 402: @24435
     /*  24435 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24483), // Rule ID 13299 //
     /*  24440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24470 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 13299,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 403: @24483
     /*  24483 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24531), // Rule ID 988 //
     /*  24488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24518 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24529 */     GIR_RootConstrainSelectedInstOperands,
     /*  24530 */     // GIR_Coverage, 988,
     /*  24530 */     GIR_EraseRootFromParent_Done,
     /*  24531 */   // Label 404: @24531
     /*  24531 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24579), // Rule ID 1049 //
     /*  24536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24566 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24577 */     GIR_RootConstrainSelectedInstOperands,
     /*  24578 */     // GIR_Coverage, 1049,
     /*  24578 */     GIR_EraseRootFromParent_Done,
     /*  24579 */   // Label 405: @24579
     /*  24579 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24606), // Rule ID 1102 //
     /*  24584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24599 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24604 */     GIR_RootConstrainSelectedInstOperands,
     /*  24605 */     // GIR_Coverage, 1102,
     /*  24605 */     GIR_Done,
     /*  24606 */   // Label 406: @24606
     /*  24606 */   GIM_Reject,
     /*  24607 */ // Label 372: @24607
     /*  24607 */ GIM_Reject,
     /*  24608 */ // Label 158: @24608
     /*  24608 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(30785),
     /*  24613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24619 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24737), // Rule ID 13460 //
     /*  24624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24688 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24692 */     // MIs[4] Operand 1
     /*  24692 */     // No operand predicates
     /*  24692 */     // MIs[2] Operand 2
     /*  24692 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24716 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24735 */     GIR_RootConstrainSelectedInstOperands,
     /*  24736 */     // GIR_Coverage, 13460,
     /*  24736 */     GIR_EraseRootFromParent_Done,
     /*  24737 */   // Label 408: @24737
     /*  24737 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24855), // Rule ID 13461 //
     /*  24742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24793 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24806 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24810 */     // MIs[4] Operand 1
     /*  24810 */     // No operand predicates
     /*  24810 */     // MIs[2] Operand 2
     /*  24810 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24834 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24853 */     GIR_RootConstrainSelectedInstOperands,
     /*  24854 */     // GIR_Coverage, 13461,
     /*  24854 */     GIR_EraseRootFromParent_Done,
     /*  24855 */   // Label 409: @24855
     /*  24855 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24973), // Rule ID 13490 //
     /*  24860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24924 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24928 */     // MIs[4] Operand 1
     /*  24928 */     // No operand predicates
     /*  24928 */     // MIs[2] Operand 2
     /*  24928 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24943 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24952 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24971 */     GIR_RootConstrainSelectedInstOperands,
     /*  24972 */     // GIR_Coverage, 13490,
     /*  24972 */     GIR_EraseRootFromParent_Done,
     /*  24973 */   // Label 410: @24973
     /*  24973 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25091), // Rule ID 13491 //
     /*  24978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25038 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25042 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25046 */     // MIs[4] Operand 1
     /*  25046 */     // No operand predicates
     /*  25046 */     // MIs[2] Operand 2
     /*  25046 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25070 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25089 */     GIR_RootConstrainSelectedInstOperands,
     /*  25090 */     // GIR_Coverage, 13491,
     /*  25090 */     GIR_EraseRootFromParent_Done,
     /*  25091 */   // Label 411: @25091
     /*  25091 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25209), // Rule ID 2039 //
     /*  25096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25160 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25164 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25168 */     // MIs[4] Operand 1
     /*  25168 */     // No operand predicates
     /*  25168 */     // MIs[2] Operand 2
     /*  25168 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25179 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25188 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25207 */     GIR_RootConstrainSelectedInstOperands,
     /*  25208 */     // GIR_Coverage, 2039,
     /*  25208 */     GIR_EraseRootFromParent_Done,
     /*  25209 */   // Label 412: @25209
     /*  25209 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25327), // Rule ID 13459 //
     /*  25214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25265 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25282 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25286 */     // MIs[4] Operand 1
     /*  25286 */     // No operand predicates
     /*  25286 */     // MIs[2] Operand 2
     /*  25286 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25297 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25306 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 13459,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 413: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25445), // Rule ID 2091 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25383 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25392 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25396 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25400 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25404 */     // MIs[4] Operand 1
     /*  25404 */     // No operand predicates
     /*  25404 */     // MIs[2] Operand 2
     /*  25404 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25415 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25424 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25443 */     GIR_RootConstrainSelectedInstOperands,
     /*  25444 */     // GIR_Coverage, 2091,
     /*  25444 */     GIR_EraseRootFromParent_Done,
     /*  25445 */   // Label 414: @25445
     /*  25445 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25563), // Rule ID 13489 //
     /*  25450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25501 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25518 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25522 */     // MIs[4] Operand 1
     /*  25522 */     // No operand predicates
     /*  25522 */     // MIs[2] Operand 2
     /*  25522 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25533 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25542 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25561 */     GIR_RootConstrainSelectedInstOperands,
     /*  25562 */     // GIR_Coverage, 13489,
     /*  25562 */     GIR_EraseRootFromParent_Done,
     /*  25563 */   // Label 415: @25563
     /*  25563 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25650), // Rule ID 13370 //
     /*  25568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25595 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25598 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25607 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25631 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25648 */     GIR_RootConstrainSelectedInstOperands,
     /*  25649 */     // GIR_Coverage, 13370,
     /*  25649 */     GIR_EraseRootFromParent_Done,
     /*  25650 */   // Label 416: @25650
     /*  25650 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25737), // Rule ID 13394 //
     /*  25655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25682 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25685 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25694 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25718 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25735 */     GIR_RootConstrainSelectedInstOperands,
     /*  25736 */     // GIR_Coverage, 13394,
     /*  25736 */     GIR_EraseRootFromParent_Done,
     /*  25737 */   // Label 417: @25737
     /*  25737 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25824), // Rule ID 1695 //
     /*  25742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25773 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25776 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25785 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25805 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25822 */     GIR_RootConstrainSelectedInstOperands,
     /*  25823 */     // GIR_Coverage, 1695,
     /*  25823 */     GIR_EraseRootFromParent_Done,
     /*  25824 */   // Label 418: @25824
     /*  25824 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25911), // Rule ID 1773 //
     /*  25829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25860 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25863 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25872 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25892 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25909 */     GIR_RootConstrainSelectedInstOperands,
     /*  25910 */     // GIR_Coverage, 1773,
     /*  25910 */     GIR_EraseRootFromParent_Done,
     /*  25911 */   // Label 419: @25911
     /*  25911 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(26026), // Rule ID 13455 //
     /*  25916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25963 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25980 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25984 */     // MIs[4] Operand 1
     /*  25984 */     // No operand predicates
     /*  25984 */     // MIs[2] Operand 2
     /*  25984 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26004 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26006 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26024 */     GIR_RootConstrainSelectedInstOperands,
     /*  26025 */     // GIR_Coverage, 13455,
     /*  26025 */     GIR_EraseRootFromParent_Done,
     /*  26026 */   // Label 420: @26026
     /*  26026 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(26141), // Rule ID 13454 //
     /*  26031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26083 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26100 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26104 */     // MIs[4] Operand 1
     /*  26104 */     // No operand predicates
     /*  26104 */     // MIs[2] Operand 2
     /*  26104 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26119 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26121 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26139 */     GIR_RootConstrainSelectedInstOperands,
     /*  26140 */     // GIR_Coverage, 13454,
     /*  26140 */     GIR_EraseRootFromParent_Done,
     /*  26141 */   // Label 421: @26141
     /*  26141 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26256), // Rule ID 13485 //
     /*  26146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26193 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26210 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26214 */     // MIs[4] Operand 1
     /*  26214 */     // No operand predicates
     /*  26214 */     // MIs[2] Operand 2
     /*  26214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26234 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26236 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26254 */     GIR_RootConstrainSelectedInstOperands,
     /*  26255 */     // GIR_Coverage, 13485,
     /*  26255 */     GIR_EraseRootFromParent_Done,
     /*  26256 */   // Label 422: @26256
     /*  26256 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26371), // Rule ID 13484 //
     /*  26261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26330 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26334 */     // MIs[4] Operand 1
     /*  26334 */     // No operand predicates
     /*  26334 */     // MIs[2] Operand 2
     /*  26334 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26349 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26351 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26369 */     GIR_RootConstrainSelectedInstOperands,
     /*  26370 */     // GIR_Coverage, 13484,
     /*  26370 */     GIR_EraseRootFromParent_Done,
     /*  26371 */   // Label 423: @26371
     /*  26371 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26440), // Rule ID 1793 //
     /*  26376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26423 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26438 */     GIR_RootConstrainSelectedInstOperands,
     /*  26439 */     // GIR_Coverage, 1793,
     /*  26439 */     GIR_EraseRootFromParent_Done,
     /*  26440 */   // Label 424: @26440
     /*  26440 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26509), // Rule ID 1792 //
     /*  26445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26492 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26507 */     GIR_RootConstrainSelectedInstOperands,
     /*  26508 */     // GIR_Coverage, 1792,
     /*  26508 */     GIR_EraseRootFromParent_Done,
     /*  26509 */   // Label 425: @26509
     /*  26509 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26578), // Rule ID 1715 //
     /*  26514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26561 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26576 */     GIR_RootConstrainSelectedInstOperands,
     /*  26577 */     // GIR_Coverage, 1715,
     /*  26577 */     GIR_EraseRootFromParent_Done,
     /*  26578 */   // Label 426: @26578
     /*  26578 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26647), // Rule ID 1791 //
     /*  26583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26630 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26645 */     GIR_RootConstrainSelectedInstOperands,
     /*  26646 */     // GIR_Coverage, 1791,
     /*  26646 */     GIR_EraseRootFromParent_Done,
     /*  26647 */   // Label 427: @26647
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26716), // Rule ID 1790 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26699 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26714 */     GIR_RootConstrainSelectedInstOperands,
     /*  26715 */     // GIR_Coverage, 1790,
     /*  26715 */     GIR_EraseRootFromParent_Done,
     /*  26716 */   // Label 428: @26716
     /*  26716 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26831), // Rule ID 13453 //
     /*  26721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26781 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26785 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26789 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26793 */     // MIs[4] Operand 1
     /*  26793 */     // No operand predicates
     /*  26793 */     // MIs[2] Operand 2
     /*  26793 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26811 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26829 */     GIR_RootConstrainSelectedInstOperands,
     /*  26830 */     // GIR_Coverage, 13453,
     /*  26830 */     GIR_EraseRootFromParent_Done,
     /*  26831 */   // Label 429: @26831
     /*  26831 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26946), // Rule ID 2037 //
     /*  26836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26901 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26905 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26909 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26913 */     // MIs[4] Operand 1
     /*  26913 */     // No operand predicates
     /*  26913 */     // MIs[2] Operand 2
     /*  26913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26924 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26926 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26944 */     GIR_RootConstrainSelectedInstOperands,
     /*  26945 */     // GIR_Coverage, 2037,
     /*  26945 */     GIR_EraseRootFromParent_Done,
     /*  26946 */   // Label 430: @26946
     /*  26946 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(27061), // Rule ID 13483 //
     /*  26951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27006 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27015 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27019 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27023 */     // MIs[4] Operand 1
     /*  27023 */     // No operand predicates
     /*  27023 */     // MIs[2] Operand 2
     /*  27023 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27039 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27041 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27059 */     GIR_RootConstrainSelectedInstOperands,
     /*  27060 */     // GIR_Coverage, 13483,
     /*  27060 */     GIR_EraseRootFromParent_Done,
     /*  27061 */   // Label 431: @27061
     /*  27061 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(27176), // Rule ID 2089 //
     /*  27066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27139 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27143 */     // MIs[4] Operand 1
     /*  27143 */     // No operand predicates
     /*  27143 */     // MIs[2] Operand 2
     /*  27143 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27156 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27174 */     GIR_RootConstrainSelectedInstOperands,
     /*  27175 */     // GIR_Coverage, 2089,
     /*  27175 */     GIR_EraseRootFromParent_Done,
     /*  27176 */   // Label 432: @27176
     /*  27176 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27243), // Rule ID 13384 //
     /*  27181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27224 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27241 */     GIR_RootConstrainSelectedInstOperands,
     /*  27242 */     // GIR_Coverage, 13384,
     /*  27242 */     GIR_EraseRootFromParent_Done,
     /*  27243 */   // Label 433: @27243
     /*  27243 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27310), // Rule ID 13414 //
     /*  27248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27291 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27308 */     GIR_RootConstrainSelectedInstOperands,
     /*  27309 */     // GIR_Coverage, 13414,
     /*  27309 */     GIR_EraseRootFromParent_Done,
     /*  27310 */   // Label 434: @27310
     /*  27310 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27377), // Rule ID 1727 //
     /*  27315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27358 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27375 */     GIR_RootConstrainSelectedInstOperands,
     /*  27376 */     // GIR_Coverage, 1727,
     /*  27376 */     GIR_EraseRootFromParent_Done,
     /*  27377 */   // Label 435: @27377
     /*  27377 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27444), // Rule ID 1817 //
     /*  27382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27425 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27442 */     GIR_RootConstrainSelectedInstOperands,
     /*  27443 */     // GIR_Coverage, 1817,
     /*  27443 */     GIR_EraseRootFromParent_Done,
     /*  27444 */   // Label 436: @27444
     /*  27444 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27525), // Rule ID 13368 //
     /*  27449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27508 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27523 */     GIR_RootConstrainSelectedInstOperands,
     /*  27524 */     // GIR_Coverage, 13368,
     /*  27524 */     GIR_EraseRootFromParent_Done,
     /*  27525 */   // Label 437: @27525
     /*  27525 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27606), // Rule ID 13392 //
     /*  27530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27557 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27560 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27569 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27589 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27604 */     GIR_RootConstrainSelectedInstOperands,
     /*  27605 */     // GIR_Coverage, 13392,
     /*  27605 */     GIR_EraseRootFromParent_Done,
     /*  27606 */   // Label 438: @27606
     /*  27606 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27687), // Rule ID 1693 //
     /*  27611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27642 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27645 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27654 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27670 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27685 */     GIR_RootConstrainSelectedInstOperands,
     /*  27686 */     // GIR_Coverage, 1693,
     /*  27686 */     GIR_EraseRootFromParent_Done,
     /*  27687 */   // Label 439: @27687
     /*  27687 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27768), // Rule ID 1771 //
     /*  27692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27723 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27726 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27735 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27751 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27766 */     GIR_RootConstrainSelectedInstOperands,
     /*  27767 */     // GIR_Coverage, 1771,
     /*  27767 */     GIR_EraseRootFromParent_Done,
     /*  27768 */   // Label 440: @27768
     /*  27768 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27860), // Rule ID 13458 //
     /*  27773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27829 */     // MIs[3] Operand 1
     /*  27829 */     // No operand predicates
     /*  27829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27840 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27858 */     GIR_RootConstrainSelectedInstOperands,
     /*  27859 */     // GIR_Coverage, 13458,
     /*  27859 */     GIR_EraseRootFromParent_Done,
     /*  27860 */   // Label 441: @27860
     /*  27860 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27952), // Rule ID 13457 //
     /*  27865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27926 */     // MIs[3] Operand 1
     /*  27926 */     // No operand predicates
     /*  27926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27932 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27950 */     GIR_RootConstrainSelectedInstOperands,
     /*  27951 */     // GIR_Coverage, 13457,
     /*  27951 */     GIR_EraseRootFromParent_Done,
     /*  27952 */   // Label 442: @27952
     /*  27952 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(28044), // Rule ID 13488 //
     /*  27957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28013 */     // MIs[3] Operand 1
     /*  28013 */     // No operand predicates
     /*  28013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28024 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28042 */     GIR_RootConstrainSelectedInstOperands,
     /*  28043 */     // GIR_Coverage, 13488,
     /*  28043 */     GIR_EraseRootFromParent_Done,
     /*  28044 */   // Label 443: @28044
     /*  28044 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28136), // Rule ID 13487 //
     /*  28049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28110 */     // MIs[3] Operand 1
     /*  28110 */     // No operand predicates
     /*  28110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28116 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28134 */     GIR_RootConstrainSelectedInstOperands,
     /*  28135 */     // GIR_Coverage, 13487,
     /*  28135 */     GIR_EraseRootFromParent_Done,
     /*  28136 */   // Label 444: @28136
     /*  28136 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28228), // Rule ID 13456 //
     /*  28141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28197 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28201 */     // MIs[3] Operand 1
     /*  28201 */     // No operand predicates
     /*  28201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28208 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28226 */     GIR_RootConstrainSelectedInstOperands,
     /*  28227 */     // GIR_Coverage, 13456,
     /*  28227 */     GIR_EraseRootFromParent_Done,
     /*  28228 */   // Label 445: @28228
     /*  28228 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28320), // Rule ID 2038 //
     /*  28233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28298 */     // MIs[3] Operand 1
     /*  28298 */     // No operand predicates
     /*  28298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28300 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28318 */     GIR_RootConstrainSelectedInstOperands,
     /*  28319 */     // GIR_Coverage, 2038,
     /*  28319 */     GIR_EraseRootFromParent_Done,
     /*  28320 */   // Label 446: @28320
     /*  28320 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28412), // Rule ID 13486 //
     /*  28325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28381 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28385 */     // MIs[3] Operand 1
     /*  28385 */     // No operand predicates
     /*  28385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28392 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28410 */     GIR_RootConstrainSelectedInstOperands,
     /*  28411 */     // GIR_Coverage, 13486,
     /*  28411 */     GIR_EraseRootFromParent_Done,
     /*  28412 */   // Label 447: @28412
     /*  28412 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28504), // Rule ID 2090 //
     /*  28417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28482 */     // MIs[3] Operand 1
     /*  28482 */     // No operand predicates
     /*  28482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28484 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28502 */     GIR_RootConstrainSelectedInstOperands,
     /*  28503 */     // GIR_Coverage, 2090,
     /*  28503 */     GIR_EraseRootFromParent_Done,
     /*  28504 */   // Label 448: @28504
     /*  28504 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28555), // Rule ID 13406 //
     /*  28509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28541 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28553 */     GIR_RootConstrainSelectedInstOperands,
     /*  28554 */     // GIR_Coverage, 13406,
     /*  28554 */     GIR_EraseRootFromParent_Done,
     /*  28555 */   // Label 449: @28555
     /*  28555 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28606), // Rule ID 13378 //
     /*  28560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28592 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28604 */     GIR_RootConstrainSelectedInstOperands,
     /*  28605 */     // GIR_Coverage, 13378,
     /*  28605 */     GIR_EraseRootFromParent_Done,
     /*  28606 */   // Label 450: @28606
     /*  28606 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28657), // Rule ID 13405 //
     /*  28611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28643 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28655 */     GIR_RootConstrainSelectedInstOperands,
     /*  28656 */     // GIR_Coverage, 13405,
     /*  28656 */     GIR_EraseRootFromParent_Done,
     /*  28657 */   // Label 451: @28657
     /*  28657 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28708), // Rule ID 1809 //
     /*  28662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28694 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28706 */     GIR_RootConstrainSelectedInstOperands,
     /*  28707 */     // GIR_Coverage, 1809,
     /*  28707 */     GIR_EraseRootFromParent_Done,
     /*  28708 */   // Label 452: @28708
     /*  28708 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28759), // Rule ID 1721 //
     /*  28713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28745 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28757 */     GIR_RootConstrainSelectedInstOperands,
     /*  28758 */     // GIR_Coverage, 1721,
     /*  28758 */     GIR_EraseRootFromParent_Done,
     /*  28759 */   // Label 453: @28759
     /*  28759 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28810), // Rule ID 1808 //
     /*  28764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28796 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28808 */     GIR_RootConstrainSelectedInstOperands,
     /*  28809 */     // GIR_Coverage, 1808,
     /*  28809 */     GIR_EraseRootFromParent_Done,
     /*  28810 */   // Label 454: @28810
     /*  28810 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28879), // Rule ID 13332 //
     /*  28815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28830 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28833 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28862 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28877 */     GIR_RootConstrainSelectedInstOperands,
     /*  28878 */     // GIR_Coverage, 13332,
     /*  28878 */     GIR_EraseRootFromParent_Done,
     /*  28879 */   // Label 455: @28879
     /*  28879 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28948), // Rule ID 13344 //
     /*  28884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28931 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 13344,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 456: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29004), // Rule ID 13294 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28968 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28971 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28991 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29002 */     GIR_RootConstrainSelectedInstOperands,
     /*  29003 */     // GIR_Coverage, 13294,
     /*  29003 */     GIR_EraseRootFromParent_Done,
     /*  29004 */   // Label 457: @29004
     /*  29004 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29060), // Rule ID 13306 //
     /*  29009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29047 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 13306,
     /*  29059 */     GIR_EraseRootFromParent_Done,
     /*  29060 */   // Label 458: @29060
     /*  29060 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29127), // Rule ID 13536 //
     /*  29065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29089 */     // MIs[1] imm
     /*  29089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29101 */     // MIs[2] Operand 1
     /*  29101 */     // No operand predicates
     /*  29101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29111 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29125 */     GIR_RootConstrainSelectedInstOperands,
     /*  29126 */     // GIR_Coverage, 13536,
     /*  29126 */     GIR_EraseRootFromParent_Done,
     /*  29127 */   // Label 459: @29127
     /*  29127 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29194), // Rule ID 13557 //
     /*  29132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29156 */     // MIs[1] imm
     /*  29156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29168 */     // MIs[2] Operand 1
     /*  29168 */     // No operand predicates
     /*  29168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29178 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29192 */     GIR_RootConstrainSelectedInstOperands,
     /*  29193 */     // GIR_Coverage, 13557,
     /*  29193 */     GIR_EraseRootFromParent_Done,
     /*  29194 */   // Label 460: @29194
     /*  29194 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29263), // Rule ID 1367 //
     /*  29199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29246 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29261 */     GIR_RootConstrainSelectedInstOperands,
     /*  29262 */     // GIR_Coverage, 1367,
     /*  29262 */     GIR_EraseRootFromParent_Done,
     /*  29263 */   // Label 461: @29263
     /*  29263 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29332), // Rule ID 1490 //
     /*  29268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29287 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29290 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29315 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29330 */     GIR_RootConstrainSelectedInstOperands,
     /*  29331 */     // GIR_Coverage, 1490,
     /*  29331 */     GIR_EraseRootFromParent_Done,
     /*  29332 */   // Label 462: @29332
     /*  29332 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29388), // Rule ID 995 //
     /*  29337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29375 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29386 */     GIR_RootConstrainSelectedInstOperands,
     /*  29387 */     // GIR_Coverage, 995,
     /*  29387 */     GIR_EraseRootFromParent_Done,
     /*  29388 */   // Label 463: @29388
     /*  29388 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29444), // Rule ID 1056 //
     /*  29393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29431 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29442 */     GIR_RootConstrainSelectedInstOperands,
     /*  29443 */     // GIR_Coverage, 1056,
     /*  29443 */     GIR_EraseRootFromParent_Done,
     /*  29444 */   // Label 464: @29444
     /*  29444 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29511), // Rule ID 2240 //
     /*  29449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29477 */     // MIs[1] imm
     /*  29477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29489 */     // MIs[2] Operand 1
     /*  29489 */     // No operand predicates
     /*  29489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29495 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29509 */     GIR_RootConstrainSelectedInstOperands,
     /*  29510 */     // GIR_Coverage, 2240,
     /*  29510 */     GIR_EraseRootFromParent_Done,
     /*  29511 */   // Label 465: @29511
     /*  29511 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29578), // Rule ID 2299 //
     /*  29516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29544 */     // MIs[1] imm
     /*  29544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29556 */     // MIs[2] Operand 1
     /*  29556 */     // No operand predicates
     /*  29556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29562 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29576 */     GIR_RootConstrainSelectedInstOperands,
     /*  29577 */     // GIR_Coverage, 2299,
     /*  29577 */     GIR_EraseRootFromParent_Done,
     /*  29578 */   // Label 466: @29578
     /*  29578 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29648), // Rule ID 6923 //
     /*  29583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29621 */     // MIs[2] Rn
     /*  29621 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29626 */     // MIs[2] Rm
     /*  29626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29633 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29646 */     GIR_RootConstrainSelectedInstOperands,
     /*  29647 */     // GIR_Coverage, 6923,
     /*  29647 */     GIR_EraseRootFromParent_Done,
     /*  29648 */   // Label 467: @29648
     /*  29648 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29718), // Rule ID 13918 //
     /*  29653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29691 */     // MIs[2] Rn
     /*  29691 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29696 */     // MIs[2] Rm
     /*  29696 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29703 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29716 */     GIR_RootConstrainSelectedInstOperands,
     /*  29717 */     // GIR_Coverage, 13918,
     /*  29717 */     GIR_EraseRootFromParent_Done,
     /*  29718 */   // Label 468: @29718
     /*  29718 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29781), // Rule ID 1789 //
     /*  29723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29766 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29779 */     GIR_RootConstrainSelectedInstOperands,
     /*  29780 */     // GIR_Coverage, 1789,
     /*  29780 */     GIR_EraseRootFromParent_Done,
     /*  29781 */   // Label 469: @29781
     /*  29781 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29844), // Rule ID 1788 //
     /*  29786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29829 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29842 */     GIR_RootConstrainSelectedInstOperands,
     /*  29843 */     // GIR_Coverage, 1788,
     /*  29843 */     GIR_EraseRootFromParent_Done,
     /*  29844 */   // Label 470: @29844
     /*  29844 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29907), // Rule ID 1714 //
     /*  29849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29892 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29905 */     GIR_RootConstrainSelectedInstOperands,
     /*  29906 */     // GIR_Coverage, 1714,
     /*  29906 */     GIR_EraseRootFromParent_Done,
     /*  29907 */   // Label 471: @29907
     /*  29907 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29970), // Rule ID 1787 //
     /*  29912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29955 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29968 */     GIR_RootConstrainSelectedInstOperands,
     /*  29969 */     // GIR_Coverage, 1787,
     /*  29969 */     GIR_EraseRootFromParent_Done,
     /*  29970 */   // Label 472: @29970
     /*  29970 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30033), // Rule ID 1786 //
     /*  29975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30018 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30031 */     GIR_RootConstrainSelectedInstOperands,
     /*  30032 */     // GIR_Coverage, 1786,
     /*  30032 */     GIR_EraseRootFromParent_Done,
     /*  30033 */   // Label 473: @30033
     /*  30033 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30094), // Rule ID 13383 //
     /*  30038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30077 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30092 */     GIR_RootConstrainSelectedInstOperands,
     /*  30093 */     // GIR_Coverage, 13383,
     /*  30093 */     GIR_EraseRootFromParent_Done,
     /*  30094 */   // Label 474: @30094
     /*  30094 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30155), // Rule ID 13413 //
     /*  30099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30138 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30153 */     GIR_RootConstrainSelectedInstOperands,
     /*  30154 */     // GIR_Coverage, 13413,
     /*  30154 */     GIR_EraseRootFromParent_Done,
     /*  30155 */   // Label 475: @30155
     /*  30155 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30203), // Rule ID 13404 //
     /*  30160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30190 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30201 */     GIR_RootConstrainSelectedInstOperands,
     /*  30202 */     // GIR_Coverage, 13404,
     /*  30202 */     GIR_EraseRootFromParent_Done,
     /*  30203 */   // Label 476: @30203
     /*  30203 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30251), // Rule ID 13293 //
     /*  30208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30238 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30249 */     GIR_RootConstrainSelectedInstOperands,
     /*  30250 */     // GIR_Coverage, 13293,
     /*  30250 */     GIR_EraseRootFromParent_Done,
     /*  30251 */   // Label 477: @30251
     /*  30251 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30299), // Rule ID 13377 //
     /*  30256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30286 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30297 */     GIR_RootConstrainSelectedInstOperands,
     /*  30298 */     // GIR_Coverage, 13377,
     /*  30298 */     GIR_EraseRootFromParent_Done,
     /*  30299 */   // Label 478: @30299
     /*  30299 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30347), // Rule ID 13305 //
     /*  30304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30334 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30345 */     GIR_RootConstrainSelectedInstOperands,
     /*  30346 */     // GIR_Coverage, 13305,
     /*  30346 */     GIR_EraseRootFromParent_Done,
     /*  30347 */   // Label 479: @30347
     /*  30347 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30395), // Rule ID 13403 //
     /*  30352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30382 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30393 */     GIR_RootConstrainSelectedInstOperands,
     /*  30394 */     // GIR_Coverage, 13403,
     /*  30394 */     GIR_EraseRootFromParent_Done,
     /*  30395 */   // Label 480: @30395
     /*  30395 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30456), // Rule ID 1726 //
     /*  30400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30454 */     GIR_RootConstrainSelectedInstOperands,
     /*  30455 */     // GIR_Coverage, 1726,
     /*  30455 */     GIR_EraseRootFromParent_Done,
     /*  30456 */   // Label 481: @30456
     /*  30456 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30517), // Rule ID 1816 //
     /*  30461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30515 */     GIR_RootConstrainSelectedInstOperands,
     /*  30516 */     // GIR_Coverage, 1816,
     /*  30516 */     GIR_EraseRootFromParent_Done,
     /*  30517 */   // Label 482: @30517
     /*  30517 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30565), // Rule ID 1807 //
     /*  30522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30552 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30563 */     GIR_RootConstrainSelectedInstOperands,
     /*  30564 */     // GIR_Coverage, 1807,
     /*  30564 */     GIR_EraseRootFromParent_Done,
     /*  30565 */   // Label 483: @30565
     /*  30565 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30613), // Rule ID 994 //
     /*  30570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30600 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30611 */     GIR_RootConstrainSelectedInstOperands,
     /*  30612 */     // GIR_Coverage, 994,
     /*  30612 */     GIR_EraseRootFromParent_Done,
     /*  30613 */   // Label 484: @30613
     /*  30613 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30661), // Rule ID 1720 //
     /*  30618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30648 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30659 */     GIR_RootConstrainSelectedInstOperands,
     /*  30660 */     // GIR_Coverage, 1720,
     /*  30660 */     GIR_EraseRootFromParent_Done,
     /*  30661 */   // Label 485: @30661
     /*  30661 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30709), // Rule ID 1055 //
     /*  30666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30696 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30707 */     GIR_RootConstrainSelectedInstOperands,
     /*  30708 */     // GIR_Coverage, 1055,
     /*  30708 */     GIR_EraseRootFromParent_Done,
     /*  30709 */   // Label 486: @30709
     /*  30709 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30757), // Rule ID 1806 //
     /*  30714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30744 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30755 */     GIR_RootConstrainSelectedInstOperands,
     /*  30756 */     // GIR_Coverage, 1806,
     /*  30756 */     GIR_EraseRootFromParent_Done,
     /*  30757 */   // Label 487: @30757
     /*  30757 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30784), // Rule ID 1105 //
     /*  30762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30777 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30782 */     GIR_RootConstrainSelectedInstOperands,
     /*  30783 */     // GIR_Coverage, 1105,
     /*  30783 */     GIR_Done,
     /*  30784 */   // Label 488: @30784
     /*  30784 */   GIM_Reject,
     /*  30785 */ // Label 407: @30785
     /*  30785 */ GIM_Reject,
     /*  30786 */ // Label 159: @30786
     /*  30786 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31635),
     /*  30791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30797 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30930), // Rule ID 13923 //
     /*  30802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30847 */     // MIs[1] Operand 2
     /*  30847 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30858 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30862 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30866 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30870 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30874 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30878 */     // MIs[5] Rn
     /*  30878 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30883 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30885 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30929 */     // GIR_Coverage, 13923,
     /*  30929 */     GIR_EraseRootFromParent_Done,
     /*  30930 */   // Label 490: @30930
     /*  30930 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31063), // Rule ID 6928 //
     /*  30935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  30988 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30992 */     // MIs[4] Rn
     /*  30992 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30997 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31001 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31005 */     // MIs[3] Operand 2
     /*  31005 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31016 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31018 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31062 */     // GIR_Coverage, 6928,
     /*  31062 */     GIR_EraseRootFromParent_Done,
     /*  31063 */   // Label 491: @31063
     /*  31063 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31132), // Rule ID 13322 //
     /*  31068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31083 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31086 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31095 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31115 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31130 */     GIR_RootConstrainSelectedInstOperands,
     /*  31131 */     // GIR_Coverage, 13322,
     /*  31131 */     GIR_EraseRootFromParent_Done,
     /*  31132 */   // Label 492: @31132
     /*  31132 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31201), // Rule ID 13334 //
     /*  31137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31152 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31155 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31184 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31199 */     GIR_RootConstrainSelectedInstOperands,
     /*  31200 */     // GIR_Coverage, 13334,
     /*  31200 */     GIR_EraseRootFromParent_Done,
     /*  31201 */   // Label 493: @31201
     /*  31201 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31268), // Rule ID 13526 //
     /*  31206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31230 */     // MIs[1] imm
     /*  31230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31242 */     // MIs[2] Operand 1
     /*  31242 */     // No operand predicates
     /*  31242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31252 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31266 */     GIR_RootConstrainSelectedInstOperands,
     /*  31267 */     // GIR_Coverage, 13526,
     /*  31267 */     GIR_EraseRootFromParent_Done,
     /*  31268 */   // Label 494: @31268
     /*  31268 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31335), // Rule ID 13547 //
     /*  31273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31297 */     // MIs[1] imm
     /*  31297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31305 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31309 */     // MIs[2] Operand 1
     /*  31309 */     // No operand predicates
     /*  31309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31319 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31333 */     GIR_RootConstrainSelectedInstOperands,
     /*  31334 */     // GIR_Coverage, 13547,
     /*  31334 */     GIR_EraseRootFromParent_Done,
     /*  31335 */   // Label 495: @31335
     /*  31335 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31404), // Rule ID 1357 //
     /*  31340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31387 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31402 */     GIR_RootConstrainSelectedInstOperands,
     /*  31403 */     // GIR_Coverage, 1357,
     /*  31403 */     GIR_EraseRootFromParent_Done,
     /*  31404 */   // Label 496: @31404
     /*  31404 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31473), // Rule ID 1480 //
     /*  31409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31456 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31471 */     GIR_RootConstrainSelectedInstOperands,
     /*  31472 */     // GIR_Coverage, 1480,
     /*  31472 */     GIR_EraseRootFromParent_Done,
     /*  31473 */   // Label 497: @31473
     /*  31473 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31540), // Rule ID 2230 //
     /*  31478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31506 */     // MIs[1] imm
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31518 */     // MIs[2] Operand 1
     /*  31518 */     // No operand predicates
     /*  31518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31524 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31538 */     GIR_RootConstrainSelectedInstOperands,
     /*  31539 */     // GIR_Coverage, 2230,
     /*  31539 */     GIR_EraseRootFromParent_Done,
     /*  31540 */   // Label 498: @31540
     /*  31540 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31607), // Rule ID 2289 //
     /*  31545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31573 */     // MIs[1] imm
     /*  31573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31585 */     // MIs[2] Operand 1
     /*  31585 */     // No operand predicates
     /*  31585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31591 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31605 */     GIR_RootConstrainSelectedInstOperands,
     /*  31606 */     // GIR_Coverage, 2289,
     /*  31606 */     GIR_EraseRootFromParent_Done,
     /*  31607 */   // Label 499: @31607
     /*  31607 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31634), // Rule ID 1100 //
     /*  31612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31627 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31632 */     GIR_RootConstrainSelectedInstOperands,
     /*  31633 */     // GIR_Coverage, 1100,
     /*  31633 */     GIR_Done,
     /*  31634 */   // Label 500: @31634
     /*  31634 */   GIM_Reject,
     /*  31635 */ // Label 489: @31635
     /*  31635 */ GIM_Reject,
     /*  31636 */ // Label 160: @31636
     /*  31636 */ GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(35213),
     /*  31641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31647 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31734), // Rule ID 13366 //
     /*  31652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31679 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31682 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31691 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31715 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31732 */     GIR_RootConstrainSelectedInstOperands,
     /*  31733 */     // GIR_Coverage, 13366,
     /*  31733 */     GIR_EraseRootFromParent_Done,
     /*  31734 */   // Label 502: @31734
     /*  31734 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31821), // Rule ID 13390 //
     /*  31739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31766 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31769 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31778 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31802 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31819 */     GIR_RootConstrainSelectedInstOperands,
     /*  31820 */     // GIR_Coverage, 13390,
     /*  31820 */     GIR_EraseRootFromParent_Done,
     /*  31821 */   // Label 503: @31821
     /*  31821 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31908), // Rule ID 1691 //
     /*  31826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31857 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31860 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31869 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31889 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31906 */     GIR_RootConstrainSelectedInstOperands,
     /*  31907 */     // GIR_Coverage, 1691,
     /*  31907 */     GIR_EraseRootFromParent_Done,
     /*  31908 */   // Label 504: @31908
     /*  31908 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31995), // Rule ID 1769 //
     /*  31913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31944 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31947 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31956 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31976 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31993 */     GIR_RootConstrainSelectedInstOperands,
     /*  31994 */     // GIR_Coverage, 1769,
     /*  31994 */     GIR_EraseRootFromParent_Done,
     /*  31995 */   // Label 505: @31995
     /*  31995 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32064), // Rule ID 1785 //
     /*  32000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32047 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32062 */     GIR_RootConstrainSelectedInstOperands,
     /*  32063 */     // GIR_Coverage, 1785,
     /*  32063 */     GIR_EraseRootFromParent_Done,
     /*  32064 */   // Label 506: @32064
     /*  32064 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32133), // Rule ID 1784 //
     /*  32069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32116 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32131 */     GIR_RootConstrainSelectedInstOperands,
     /*  32132 */     // GIR_Coverage, 1784,
     /*  32132 */     GIR_EraseRootFromParent_Done,
     /*  32133 */   // Label 507: @32133
     /*  32133 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32202), // Rule ID 1713 //
     /*  32138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32185 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32200 */     GIR_RootConstrainSelectedInstOperands,
     /*  32201 */     // GIR_Coverage, 1713,
     /*  32201 */     GIR_EraseRootFromParent_Done,
     /*  32202 */   // Label 508: @32202
     /*  32202 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32271), // Rule ID 1783 //
     /*  32207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32254 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32269 */     GIR_RootConstrainSelectedInstOperands,
     /*  32270 */     // GIR_Coverage, 1783,
     /*  32270 */     GIR_EraseRootFromParent_Done,
     /*  32271 */   // Label 509: @32271
     /*  32271 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32340), // Rule ID 1782 //
     /*  32276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32323 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32338 */     GIR_RootConstrainSelectedInstOperands,
     /*  32339 */     // GIR_Coverage, 1782,
     /*  32339 */     GIR_EraseRootFromParent_Done,
     /*  32340 */   // Label 510: @32340
     /*  32340 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32407), // Rule ID 13382 //
     /*  32345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32388 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32405 */     GIR_RootConstrainSelectedInstOperands,
     /*  32406 */     // GIR_Coverage, 13382,
     /*  32406 */     GIR_EraseRootFromParent_Done,
     /*  32407 */   // Label 511: @32407
     /*  32407 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32474), // Rule ID 13412 //
     /*  32412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32455 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32472 */     GIR_RootConstrainSelectedInstOperands,
     /*  32473 */     // GIR_Coverage, 13412,
     /*  32473 */     GIR_EraseRootFromParent_Done,
     /*  32474 */   // Label 512: @32474
     /*  32474 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32541), // Rule ID 1725 //
     /*  32479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32522 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32539 */     GIR_RootConstrainSelectedInstOperands,
     /*  32540 */     // GIR_Coverage, 1725,
     /*  32540 */     GIR_EraseRootFromParent_Done,
     /*  32541 */   // Label 513: @32541
     /*  32541 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32608), // Rule ID 1815 //
     /*  32546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32589 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32606 */     GIR_RootConstrainSelectedInstOperands,
     /*  32607 */     // GIR_Coverage, 1815,
     /*  32607 */     GIR_EraseRootFromParent_Done,
     /*  32608 */   // Label 514: @32608
     /*  32608 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32689), // Rule ID 13364 //
     /*  32613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32640 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32643 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32652 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32672 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32687 */     GIR_RootConstrainSelectedInstOperands,
     /*  32688 */     // GIR_Coverage, 13364,
     /*  32688 */     GIR_EraseRootFromParent_Done,
     /*  32689 */   // Label 515: @32689
     /*  32689 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32770), // Rule ID 13388 //
     /*  32694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32721 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32724 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32733 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32753 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32768 */     GIR_RootConstrainSelectedInstOperands,
     /*  32769 */     // GIR_Coverage, 13388,
     /*  32769 */     GIR_EraseRootFromParent_Done,
     /*  32770 */   // Label 516: @32770
     /*  32770 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32851), // Rule ID 1689 //
     /*  32775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32806 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32809 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32818 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32834 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32849 */     GIR_RootConstrainSelectedInstOperands,
     /*  32850 */     // GIR_Coverage, 1689,
     /*  32850 */     GIR_EraseRootFromParent_Done,
     /*  32851 */   // Label 517: @32851
     /*  32851 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32932), // Rule ID 1767 //
     /*  32856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32887 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32890 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32899 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32915 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32930 */     GIR_RootConstrainSelectedInstOperands,
     /*  32931 */     // GIR_Coverage, 1767,
     /*  32931 */     GIR_EraseRootFromParent_Done,
     /*  32932 */   // Label 518: @32932
     /*  32932 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32983), // Rule ID 13402 //
     /*  32937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32969 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32981 */     GIR_RootConstrainSelectedInstOperands,
     /*  32982 */     // GIR_Coverage, 13402,
     /*  32982 */     GIR_EraseRootFromParent_Done,
     /*  32983 */   // Label 519: @32983
     /*  32983 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33034), // Rule ID 13376 //
     /*  32988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33020 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33032 */     GIR_RootConstrainSelectedInstOperands,
     /*  33033 */     // GIR_Coverage, 13376,
     /*  33033 */     GIR_EraseRootFromParent_Done,
     /*  33034 */   // Label 520: @33034
     /*  33034 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33085), // Rule ID 13401 //
     /*  33039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33071 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33083 */     GIR_RootConstrainSelectedInstOperands,
     /*  33084 */     // GIR_Coverage, 13401,
     /*  33084 */     GIR_EraseRootFromParent_Done,
     /*  33085 */   // Label 521: @33085
     /*  33085 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33136), // Rule ID 1805 //
     /*  33090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33122 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33134 */     GIR_RootConstrainSelectedInstOperands,
     /*  33135 */     // GIR_Coverage, 1805,
     /*  33135 */     GIR_EraseRootFromParent_Done,
     /*  33136 */   // Label 522: @33136
     /*  33136 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33187), // Rule ID 1719 //
     /*  33141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33173 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33185 */     GIR_RootConstrainSelectedInstOperands,
     /*  33186 */     // GIR_Coverage, 1719,
     /*  33186 */     GIR_EraseRootFromParent_Done,
     /*  33187 */   // Label 523: @33187
     /*  33187 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33238), // Rule ID 1804 //
     /*  33192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33224 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33236 */     GIR_RootConstrainSelectedInstOperands,
     /*  33237 */     // GIR_Coverage, 1804,
     /*  33237 */     GIR_EraseRootFromParent_Done,
     /*  33238 */   // Label 524: @33238
     /*  33238 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33307), // Rule ID 13328 //
     /*  33243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33258 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33261 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33270 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33290 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33305 */     GIR_RootConstrainSelectedInstOperands,
     /*  33306 */     // GIR_Coverage, 13328,
     /*  33306 */     GIR_EraseRootFromParent_Done,
     /*  33307 */   // Label 525: @33307
     /*  33307 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33376), // Rule ID 13340 //
     /*  33312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33327 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33330 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33359 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33374 */     GIR_RootConstrainSelectedInstOperands,
     /*  33375 */     // GIR_Coverage, 13340,
     /*  33375 */     GIR_EraseRootFromParent_Done,
     /*  33376 */   // Label 526: @33376
     /*  33376 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33432), // Rule ID 13290 //
     /*  33381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33396 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33399 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33419 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33430 */     GIR_RootConstrainSelectedInstOperands,
     /*  33431 */     // GIR_Coverage, 13290,
     /*  33431 */     GIR_EraseRootFromParent_Done,
     /*  33432 */   // Label 527: @33432
     /*  33432 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33488), // Rule ID 13302 //
     /*  33437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33475 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33486 */     GIR_RootConstrainSelectedInstOperands,
     /*  33487 */     // GIR_Coverage, 13302,
     /*  33487 */     GIR_EraseRootFromParent_Done,
     /*  33488 */   // Label 528: @33488
     /*  33488 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33555), // Rule ID 13532 //
     /*  33493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33517 */     // MIs[1] imm
     /*  33517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33529 */     // MIs[2] Operand 1
     /*  33529 */     // No operand predicates
     /*  33529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33539 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33553 */     GIR_RootConstrainSelectedInstOperands,
     /*  33554 */     // GIR_Coverage, 13532,
     /*  33554 */     GIR_EraseRootFromParent_Done,
     /*  33555 */   // Label 529: @33555
     /*  33555 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33622), // Rule ID 13553 //
     /*  33560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33584 */     // MIs[1] imm
     /*  33584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33596 */     // MIs[2] Operand 1
     /*  33596 */     // No operand predicates
     /*  33596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33606 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33620 */     GIR_RootConstrainSelectedInstOperands,
     /*  33621 */     // GIR_Coverage, 13553,
     /*  33621 */     GIR_EraseRootFromParent_Done,
     /*  33622 */   // Label 530: @33622
     /*  33622 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33691), // Rule ID 1363 //
     /*  33627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33646 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33649 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33658 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33674 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33689 */     GIR_RootConstrainSelectedInstOperands,
     /*  33690 */     // GIR_Coverage, 1363,
     /*  33690 */     GIR_EraseRootFromParent_Done,
     /*  33691 */   // Label 531: @33691
     /*  33691 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33760), // Rule ID 1486 //
     /*  33696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33715 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33718 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33727 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33743 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33758 */     GIR_RootConstrainSelectedInstOperands,
     /*  33759 */     // GIR_Coverage, 1486,
     /*  33759 */     GIR_EraseRootFromParent_Done,
     /*  33760 */   // Label 532: @33760
     /*  33760 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33816), // Rule ID 991 //
     /*  33765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33784 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33787 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33803 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33814 */     GIR_RootConstrainSelectedInstOperands,
     /*  33815 */     // GIR_Coverage, 991,
     /*  33815 */     GIR_EraseRootFromParent_Done,
     /*  33816 */   // Label 533: @33816
     /*  33816 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33872), // Rule ID 1052 //
     /*  33821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33859 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33870 */     GIR_RootConstrainSelectedInstOperands,
     /*  33871 */     // GIR_Coverage, 1052,
     /*  33871 */     GIR_EraseRootFromParent_Done,
     /*  33872 */   // Label 534: @33872
     /*  33872 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33939), // Rule ID 2236 //
     /*  33877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33905 */     // MIs[1] imm
     /*  33905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33917 */     // MIs[2] Operand 1
     /*  33917 */     // No operand predicates
     /*  33917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33923 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33937 */     GIR_RootConstrainSelectedInstOperands,
     /*  33938 */     // GIR_Coverage, 2236,
     /*  33938 */     GIR_EraseRootFromParent_Done,
     /*  33939 */   // Label 535: @33939
     /*  33939 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34006), // Rule ID 2295 //
     /*  33944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33972 */     // MIs[1] imm
     /*  33972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33980 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33984 */     // MIs[2] Operand 1
     /*  33984 */     // No operand predicates
     /*  33984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33990 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34004 */     GIR_RootConstrainSelectedInstOperands,
     /*  34005 */     // GIR_Coverage, 2295,
     /*  34005 */     GIR_EraseRootFromParent_Done,
     /*  34006 */   // Label 536: @34006
     /*  34006 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34076), // Rule ID 6924 //
     /*  34011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34049 */     // MIs[2] Rn
     /*  34049 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34054 */     // MIs[2] Rm
     /*  34054 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34061 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34074 */     GIR_RootConstrainSelectedInstOperands,
     /*  34075 */     // GIR_Coverage, 6924,
     /*  34075 */     GIR_EraseRootFromParent_Done,
     /*  34076 */   // Label 537: @34076
     /*  34076 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34146), // Rule ID 13919 //
     /*  34081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34119 */     // MIs[2] Rn
     /*  34119 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34124 */     // MIs[2] Rm
     /*  34124 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34131 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34144 */     GIR_RootConstrainSelectedInstOperands,
     /*  34145 */     // GIR_Coverage, 13919,
     /*  34145 */     GIR_EraseRootFromParent_Done,
     /*  34146 */   // Label 538: @34146
     /*  34146 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34209), // Rule ID 1781 //
     /*  34151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34194 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34207 */     GIR_RootConstrainSelectedInstOperands,
     /*  34208 */     // GIR_Coverage, 1781,
     /*  34208 */     GIR_EraseRootFromParent_Done,
     /*  34209 */   // Label 539: @34209
     /*  34209 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34272), // Rule ID 1780 //
     /*  34214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34257 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34270 */     GIR_RootConstrainSelectedInstOperands,
     /*  34271 */     // GIR_Coverage, 1780,
     /*  34271 */     GIR_EraseRootFromParent_Done,
     /*  34272 */   // Label 540: @34272
     /*  34272 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34335), // Rule ID 1712 //
     /*  34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34320 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34333 */     GIR_RootConstrainSelectedInstOperands,
     /*  34334 */     // GIR_Coverage, 1712,
     /*  34334 */     GIR_EraseRootFromParent_Done,
     /*  34335 */   // Label 541: @34335
     /*  34335 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34398), // Rule ID 1779 //
     /*  34340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34383 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34396 */     GIR_RootConstrainSelectedInstOperands,
     /*  34397 */     // GIR_Coverage, 1779,
     /*  34397 */     GIR_EraseRootFromParent_Done,
     /*  34398 */   // Label 542: @34398
     /*  34398 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34461), // Rule ID 1778 //
     /*  34403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34446 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34459 */     GIR_RootConstrainSelectedInstOperands,
     /*  34460 */     // GIR_Coverage, 1778,
     /*  34460 */     GIR_EraseRootFromParent_Done,
     /*  34461 */   // Label 543: @34461
     /*  34461 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34522), // Rule ID 13381 //
     /*  34466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34505 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34520 */     GIR_RootConstrainSelectedInstOperands,
     /*  34521 */     // GIR_Coverage, 13381,
     /*  34521 */     GIR_EraseRootFromParent_Done,
     /*  34522 */   // Label 544: @34522
     /*  34522 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34583), // Rule ID 13411 //
     /*  34527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34566 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34581 */     GIR_RootConstrainSelectedInstOperands,
     /*  34582 */     // GIR_Coverage, 13411,
     /*  34582 */     GIR_EraseRootFromParent_Done,
     /*  34583 */   // Label 545: @34583
     /*  34583 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34631), // Rule ID 13400 //
     /*  34588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34618 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34629 */     GIR_RootConstrainSelectedInstOperands,
     /*  34630 */     // GIR_Coverage, 13400,
     /*  34630 */     GIR_EraseRootFromParent_Done,
     /*  34631 */   // Label 546: @34631
     /*  34631 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34679), // Rule ID 13289 //
     /*  34636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34666 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34677 */     GIR_RootConstrainSelectedInstOperands,
     /*  34678 */     // GIR_Coverage, 13289,
     /*  34678 */     GIR_EraseRootFromParent_Done,
     /*  34679 */   // Label 547: @34679
     /*  34679 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34727), // Rule ID 13375 //
     /*  34684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34714 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34725 */     GIR_RootConstrainSelectedInstOperands,
     /*  34726 */     // GIR_Coverage, 13375,
     /*  34726 */     GIR_EraseRootFromParent_Done,
     /*  34727 */   // Label 548: @34727
     /*  34727 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34775), // Rule ID 13301 //
     /*  34732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34762 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34773 */     GIR_RootConstrainSelectedInstOperands,
     /*  34774 */     // GIR_Coverage, 13301,
     /*  34774 */     GIR_EraseRootFromParent_Done,
     /*  34775 */   // Label 549: @34775
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34823), // Rule ID 13399 //
     /*  34780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34810 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34821 */     GIR_RootConstrainSelectedInstOperands,
     /*  34822 */     // GIR_Coverage, 13399,
     /*  34822 */     GIR_EraseRootFromParent_Done,
     /*  34823 */   // Label 550: @34823
     /*  34823 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34884), // Rule ID 1724 //
     /*  34828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34867 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34882 */     GIR_RootConstrainSelectedInstOperands,
     /*  34883 */     // GIR_Coverage, 1724,
     /*  34883 */     GIR_EraseRootFromParent_Done,
     /*  34884 */   // Label 551: @34884
     /*  34884 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34945), // Rule ID 1814 //
     /*  34889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34928 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34943 */     GIR_RootConstrainSelectedInstOperands,
     /*  34944 */     // GIR_Coverage, 1814,
     /*  34944 */     GIR_EraseRootFromParent_Done,
     /*  34945 */   // Label 552: @34945
     /*  34945 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34993), // Rule ID 1803 //
     /*  34950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34980 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  34987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34991 */     GIR_RootConstrainSelectedInstOperands,
     /*  34992 */     // GIR_Coverage, 1803,
     /*  34992 */     GIR_EraseRootFromParent_Done,
     /*  34993 */   // Label 553: @34993
     /*  34993 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35041), // Rule ID 990 //
     /*  34998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35028 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35039 */     GIR_RootConstrainSelectedInstOperands,
     /*  35040 */     // GIR_Coverage, 990,
     /*  35040 */     GIR_EraseRootFromParent_Done,
     /*  35041 */   // Label 554: @35041
     /*  35041 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35089), // Rule ID 1718 //
     /*  35046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35076 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35087 */     GIR_RootConstrainSelectedInstOperands,
     /*  35088 */     // GIR_Coverage, 1718,
     /*  35088 */     GIR_EraseRootFromParent_Done,
     /*  35089 */   // Label 555: @35089
     /*  35089 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35137), // Rule ID 1051 //
     /*  35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35124 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35135 */     GIR_RootConstrainSelectedInstOperands,
     /*  35136 */     // GIR_Coverage, 1051,
     /*  35136 */     GIR_EraseRootFromParent_Done,
     /*  35137 */   // Label 556: @35137
     /*  35137 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35185), // Rule ID 1802 //
     /*  35142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35172 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35183 */     GIR_RootConstrainSelectedInstOperands,
     /*  35184 */     // GIR_Coverage, 1802,
     /*  35184 */     GIR_EraseRootFromParent_Done,
     /*  35185 */   // Label 557: @35185
     /*  35185 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35212), // Rule ID 1103 //
     /*  35190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35205 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35210 */     GIR_RootConstrainSelectedInstOperands,
     /*  35211 */     // GIR_Coverage, 1103,
     /*  35211 */     GIR_Done,
     /*  35212 */   // Label 558: @35212
     /*  35212 */   GIM_Reject,
     /*  35213 */ // Label 501: @35213
     /*  35213 */ GIM_Reject,
     /*  35214 */ // Label 161: @35214
     /*  35214 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35937),
     /*  35219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35225 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35294), // Rule ID 13324 //
     /*  35230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35245 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35248 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35277 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35292 */     GIR_RootConstrainSelectedInstOperands,
     /*  35293 */     // GIR_Coverage, 13324,
     /*  35293 */     GIR_EraseRootFromParent_Done,
     /*  35294 */   // Label 560: @35294
     /*  35294 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35363), // Rule ID 13336 //
     /*  35299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35314 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35317 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35346 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35361 */     GIR_RootConstrainSelectedInstOperands,
     /*  35362 */     // GIR_Coverage, 13336,
     /*  35362 */     GIR_EraseRootFromParent_Done,
     /*  35363 */   // Label 561: @35363
     /*  35363 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35430), // Rule ID 13528 //
     /*  35368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35392 */     // MIs[1] imm
     /*  35392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35404 */     // MIs[2] Operand 1
     /*  35404 */     // No operand predicates
     /*  35404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35414 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35428 */     GIR_RootConstrainSelectedInstOperands,
     /*  35429 */     // GIR_Coverage, 13528,
     /*  35429 */     GIR_EraseRootFromParent_Done,
     /*  35430 */   // Label 562: @35430
     /*  35430 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35497), // Rule ID 13549 //
     /*  35435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35459 */     // MIs[1] imm
     /*  35459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35471 */     // MIs[2] Operand 1
     /*  35471 */     // No operand predicates
     /*  35471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35481 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35495 */     GIR_RootConstrainSelectedInstOperands,
     /*  35496 */     // GIR_Coverage, 13549,
     /*  35496 */     GIR_EraseRootFromParent_Done,
     /*  35497 */   // Label 563: @35497
     /*  35497 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35566), // Rule ID 1359 //
     /*  35502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35549 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35564 */     GIR_RootConstrainSelectedInstOperands,
     /*  35565 */     // GIR_Coverage, 1359,
     /*  35565 */     GIR_EraseRootFromParent_Done,
     /*  35566 */   // Label 564: @35566
     /*  35566 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35635), // Rule ID 1482 //
     /*  35571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35618 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35633 */     GIR_RootConstrainSelectedInstOperands,
     /*  35634 */     // GIR_Coverage, 1482,
     /*  35634 */     GIR_EraseRootFromParent_Done,
     /*  35635 */   // Label 565: @35635
     /*  35635 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35702), // Rule ID 2232 //
     /*  35640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35668 */     // MIs[1] imm
     /*  35668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35680 */     // MIs[2] Operand 1
     /*  35680 */     // No operand predicates
     /*  35680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35686 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35700 */     GIR_RootConstrainSelectedInstOperands,
     /*  35701 */     // GIR_Coverage, 2232,
     /*  35701 */     GIR_EraseRootFromParent_Done,
     /*  35702 */   // Label 566: @35702
     /*  35702 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35769), // Rule ID 2291 //
     /*  35707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35735 */     // MIs[1] imm
     /*  35735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35747 */     // MIs[2] Operand 1
     /*  35747 */     // No operand predicates
     /*  35747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35753 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35767 */     GIR_RootConstrainSelectedInstOperands,
     /*  35768 */     // GIR_Coverage, 2291,
     /*  35768 */     GIR_EraseRootFromParent_Done,
     /*  35769 */   // Label 567: @35769
     /*  35769 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35839), // Rule ID 6925 //
     /*  35774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35812 */     // MIs[2] Rn
     /*  35812 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35817 */     // MIs[2] Rm
     /*  35817 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35824 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35837 */     GIR_RootConstrainSelectedInstOperands,
     /*  35838 */     // GIR_Coverage, 6925,
     /*  35838 */     GIR_EraseRootFromParent_Done,
     /*  35839 */   // Label 568: @35839
     /*  35839 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35909), // Rule ID 13920 //
     /*  35844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35882 */     // MIs[2] Rn
     /*  35882 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35887 */     // MIs[2] Rm
     /*  35887 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35894 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35907 */     GIR_RootConstrainSelectedInstOperands,
     /*  35908 */     // GIR_Coverage, 13920,
     /*  35908 */     GIR_EraseRootFromParent_Done,
     /*  35909 */   // Label 569: @35909
     /*  35909 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35936), // Rule ID 1101 //
     /*  35914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35929 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35934 */     GIR_RootConstrainSelectedInstOperands,
     /*  35935 */     // GIR_Coverage, 1101,
     /*  35935 */     GIR_Done,
     /*  35936 */   // Label 570: @35936
     /*  35936 */   GIM_Reject,
     /*  35937 */ // Label 559: @35937
     /*  35937 */ GIM_Reject,
     /*  35938 */ // Label 162: @35938
     /*  35938 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36309),
     /*  35943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35953 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36015), // Rule ID 15104 //
     /*  35958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  35985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  35989 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36002 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36013 */     GIR_RootConstrainSelectedInstOperands,
     /*  36014 */     // GIR_Coverage, 15104,
     /*  36014 */     GIR_EraseRootFromParent_Done,
     /*  36015 */   // Label 572: @36015
     /*  36015 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36077), // Rule ID 15103 //
     /*  36020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36051 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36064 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36075 */     GIR_RootConstrainSelectedInstOperands,
     /*  36076 */     // GIR_Coverage, 15103,
     /*  36076 */     GIR_EraseRootFromParent_Done,
     /*  36077 */   // Label 573: @36077
     /*  36077 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36139), // Rule ID 15102 //
     /*  36082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36113 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36126 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36137 */     GIR_RootConstrainSelectedInstOperands,
     /*  36138 */     // GIR_Coverage, 15102,
     /*  36138 */     GIR_EraseRootFromParent_Done,
     /*  36139 */   // Label 574: @36139
     /*  36139 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36201), // Rule ID 8870 //
     /*  36144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36175 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36188 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36199 */     GIR_RootConstrainSelectedInstOperands,
     /*  36200 */     // GIR_Coverage, 8870,
     /*  36200 */     GIR_EraseRootFromParent_Done,
     /*  36201 */   // Label 575: @36201
     /*  36201 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36247), // Rule ID 15105 //
     /*  36206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36221 */     // MIs[1] Operand 2
     /*  36221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36234 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36245 */     GIR_RootConstrainSelectedInstOperands,
     /*  36246 */     // GIR_Coverage, 15105,
     /*  36246 */     GIR_EraseRootFromParent_Done,
     /*  36247 */   // Label 576: @36247
     /*  36247 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36293), // Rule ID 8871 //
     /*  36252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36267 */     // MIs[1] Operand 2
     /*  36267 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36280 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36291 */     GIR_RootConstrainSelectedInstOperands,
     /*  36292 */     // GIR_Coverage, 8871,
     /*  36292 */     GIR_EraseRootFromParent_Done,
     /*  36293 */   // Label 577: @36293
     /*  36293 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36308), // Rule ID 2780 //
     /*  36298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36301 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36306 */     GIR_RootConstrainSelectedInstOperands,
     /*  36307 */     // GIR_Coverage, 2780,
     /*  36307 */     GIR_Done,
     /*  36308 */   // Label 578: @36308
     /*  36308 */   GIM_Reject,
     /*  36309 */ // Label 571: @36309
     /*  36309 */ GIM_Reject,
     /*  36310 */ // Label 163: @36310
     /*  36310 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36335), // Rule ID 2779 //
     /*  36315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36328 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36333 */   GIR_RootConstrainSelectedInstOperands,
     /*  36334 */   // GIR_Coverage, 2779,
     /*  36334 */   GIR_Done,
     /*  36335 */ // Label 579: @36335
     /*  36335 */ GIM_Reject,
     /*  36336 */ // Label 164: @36336
     /*  36336 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36361), // Rule ID 2778 //
     /*  36341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36354 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36359 */   GIR_RootConstrainSelectedInstOperands,
     /*  36360 */   // GIR_Coverage, 2778,
     /*  36360 */   GIR_Done,
     /*  36361 */ // Label 580: @36361
     /*  36361 */ GIM_Reject,
     /*  36362 */ // Label 165: @36362
     /*  36362 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36387), // Rule ID 2777 //
     /*  36367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36380 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36385 */   GIR_RootConstrainSelectedInstOperands,
     /*  36386 */   // GIR_Coverage, 2777,
     /*  36386 */   GIR_Done,
     /*  36387 */ // Label 581: @36387
     /*  36387 */ GIM_Reject,
     /*  36388 */ // Label 166: @36388
     /*  36388 */ GIM_Reject,
     /*  36389 */ // Label 1: @36389
     /*  36389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 595*/ GIMT_Encode4(50616),
     /*  36400 */ /*GILLT_s32*//*Label 582*/ GIMT_Encode4(36488),
     /*  36404 */ /*GILLT_s64*//*Label 583*/ GIMT_Encode4(37970), GIMT_Encode4(0),
     /*  36412 */ /*GILLT_v2s32*//*Label 584*/ GIMT_Encode4(41252),
     /*  36416 */ /*GILLT_v2s64*//*Label 585*/ GIMT_Encode4(42743),
     /*  36420 */ /*GILLT_v4s16*//*Label 586*/ GIMT_Encode4(45203),
     /*  36424 */ /*GILLT_v4s32*//*Label 587*/ GIMT_Encode4(46694),
     /*  36428 */ /*GILLT_v8s8*//*Label 588*/ GIMT_Encode4(49154),
     /*  36432 */ /*GILLT_v8s16*//*Label 589*/ GIMT_Encode4(49229),
     /*  36436 */ /*GILLT_v16s8*//*Label 590*/ GIMT_Encode4(50437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36456 */ /*GILLT_nxv2s64*//*Label 591*/ GIMT_Encode4(50512), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36468 */ /*GILLT_nxv4s32*//*Label 592*/ GIMT_Encode4(50538), GIMT_Encode4(0),
     /*  36476 */ /*GILLT_nxv8s16*//*Label 593*/ GIMT_Encode4(50564), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv16s8*//*Label 594*/ GIMT_Encode4(50590),
     /*  36488 */ // Label 582: @36488
     /*  36488 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(37969),
     /*  36493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36499 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(36651), // Rule ID 9917 //
     /*  36504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36543 */     // MIs[2] pattern
     /*  36543 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36546 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36553 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36579 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36650 */     // GIR_Coverage, 9917,
     /*  36650 */     GIR_EraseRootFromParent_Done,
     /*  36651 */   // Label 597: @36651
     /*  36651 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(36803), // Rule ID 9929 //
     /*  36656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36687 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36690 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36695 */     // MIs[2] pattern
     /*  36695 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36698 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36705 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36705 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36708 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36712 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36731 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36738 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36741 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36802 */     // GIR_Coverage, 9929,
     /*  36802 */     GIR_EraseRootFromParent_Done,
     /*  36803 */   // Label 598: @36803
     /*  36803 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36955), // Rule ID 9941 //
     /*  36808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36839 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36842 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36847 */     // MIs[2] pattern
     /*  36847 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36850 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36857 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36857 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36860 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36864 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36883 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36890 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36937 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36954 */     // GIR_Coverage, 9941,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 599: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(37107), // Rule ID 9953 //
     /*  36960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  36999 */     // MIs[2] pattern
     /*  36999 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37002 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37009 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37009 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37016 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37035 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37042 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37045 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37106 */     // GIR_Coverage, 9953,
     /*  37106 */     GIR_EraseRootFromParent_Done,
     /*  37107 */   // Label 600: @37107
     /*  37107 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(37169), // Rule ID 3953 //
     /*  37112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37148 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37167 */     GIR_RootConstrainSelectedInstOperands,
     /*  37168 */     // GIR_Coverage, 3953,
     /*  37168 */     GIR_EraseRootFromParent_Done,
     /*  37169 */   // Label 601: @37169
     /*  37169 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37326), // Rule ID 10055 //
     /*  37174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37205 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37208 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37224 */     // MIs[2] pred
     /*  37224 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37231 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37231 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37234 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37238 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37257 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37260 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37264 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37298 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37325 */     // GIR_Coverage, 10055,
     /*  37325 */     GIR_EraseRootFromParent_Done,
     /*  37326 */   // Label 602: @37326
     /*  37326 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37483), // Rule ID 10056 //
     /*  37331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37362 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37365 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37381 */     // MIs[2] pred
     /*  37381 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37388 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37482 */     // GIR_Coverage, 10056,
     /*  37482 */     GIR_EraseRootFromParent_Done,
     /*  37483 */   // Label 603: @37483
     /*  37483 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37640), // Rule ID 10057 //
     /*  37488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37519 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37522 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37531 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37538 */     // MIs[2] pred
     /*  37538 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37545 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37571 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37622 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37639 */     // GIR_Coverage, 10057,
     /*  37639 */     GIR_EraseRootFromParent_Done,
     /*  37640 */   // Label 604: @37640
     /*  37640 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37797), // Rule ID 10058 //
     /*  37645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37688 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37695 */     // MIs[2] pred
     /*  37695 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37702 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37702 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37705 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37709 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37728 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37735 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37743 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37796 */     // GIR_Coverage, 10058,
     /*  37796 */     GIR_EraseRootFromParent_Done,
     /*  37797 */   // Label 605: @37797
     /*  37797 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37833), // Rule ID 3918 //
     /*  37802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37817 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37822 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37831 */     GIR_RootConstrainSelectedInstOperands,
     /*  37832 */     // GIR_Coverage, 3918,
     /*  37832 */     GIR_EraseRootFromParent_Done,
     /*  37833 */   // Label 606: @37833
     /*  37833 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37866), // Rule ID 3923 //
     /*  37838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37853 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37864 */     GIR_RootConstrainSelectedInstOperands,
     /*  37865 */     // GIR_Coverage, 3923,
     /*  37865 */     GIR_EraseRootFromParent_Done,
     /*  37866 */   // Label 607: @37866
     /*  37866 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37902), // Rule ID 3912 //
     /*  37871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37886 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37900 */     GIR_RootConstrainSelectedInstOperands,
     /*  37901 */     // GIR_Coverage, 3912,
     /*  37901 */     GIR_EraseRootFromParent_Done,
     /*  37902 */   // Label 608: @37902
     /*  37902 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37938), // Rule ID 3916 //
     /*  37907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37922 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37936 */     GIR_RootConstrainSelectedInstOperands,
     /*  37937 */     // GIR_Coverage, 3916,
     /*  37937 */     GIR_EraseRootFromParent_Done,
     /*  37938 */   // Label 609: @37938
     /*  37938 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37968), // Rule ID 3914 //
     /*  37943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37955 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37960 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37966 */     GIR_RootConstrainSelectedInstOperands,
     /*  37967 */     // GIR_Coverage, 3914,
     /*  37967 */     GIR_Done,
     /*  37968 */   // Label 610: @37968
     /*  37968 */   GIM_Reject,
     /*  37969 */ // Label 596: @37969
     /*  37969 */ GIM_Reject,
     /*  37970 */ // Label 583: @37970
     /*  37970 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(41251),
     /*  37975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37981 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38117), // Rule ID 5401 //
     /*  37986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38019 */     // MIs[1] Operand 2
     /*  38019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38050 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38054 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38059 */     // MIs[3] Operand 2
     /*  38059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38072 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38099 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38116 */     // GIR_Coverage, 5401,
     /*  38116 */     GIR_EraseRootFromParent_Done,
     /*  38117 */   // Label 612: @38117
     /*  38117 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38253), // Rule ID 5400 //
     /*  38122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38155 */     // MIs[1] Operand 2
     /*  38155 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38182 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38186 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38190 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38195 */     // MIs[3] Operand 2
     /*  38195 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38208 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38252 */     // GIR_Coverage, 5400,
     /*  38252 */     GIR_EraseRootFromParent_Done,
     /*  38253 */   // Label 613: @38253
     /*  38253 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38389), // Rule ID 5410 //
     /*  38258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38291 */     // MIs[1] Operand 2
     /*  38291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38318 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38322 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38326 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38331 */     // MIs[3] Operand 2
     /*  38331 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38344 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38371 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38388 */     // GIR_Coverage, 5410,
     /*  38388 */     GIR_EraseRootFromParent_Done,
     /*  38389 */   // Label 614: @38389
     /*  38389 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38525), // Rule ID 5399 //
     /*  38394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38427 */     // MIs[1] Operand 2
     /*  38427 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38458 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38462 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38467 */     // MIs[3] Operand 2
     /*  38467 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38480 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38507 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38524 */     // GIR_Coverage, 5399,
     /*  38524 */     GIR_EraseRootFromParent_Done,
     /*  38525 */   // Label 615: @38525
     /*  38525 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38661), // Rule ID 5398 //
     /*  38530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38563 */     // MIs[1] Operand 2
     /*  38563 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38594 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38598 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38603 */     // MIs[3] Operand 2
     /*  38603 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38616 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38643 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38660 */     // GIR_Coverage, 5398,
     /*  38660 */     GIR_EraseRootFromParent_Done,
     /*  38661 */   // Label 616: @38661
     /*  38661 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38798), // Rule ID 3970 //
     /*  38666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38707 */     // MIs[2] Operand 2
     /*  38707 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38730 */     // MIs[3] Operand 1
     /*  38730 */     // No operand predicates
     /*  38730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38732 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38744 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38763 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38796 */     GIR_RootConstrainSelectedInstOperands,
     /*  38797 */     // GIR_Coverage, 3970,
     /*  38797 */     GIR_EraseRootFromParent_Done,
     /*  38798 */   // Label 617: @38798
     /*  38798 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38897), // Rule ID 3968 //
     /*  38803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38852 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38856 */     // MIs[3] Operand 1
     /*  38856 */     // No operand predicates
     /*  38856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38858 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38870 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38895 */     GIR_RootConstrainSelectedInstOperands,
     /*  38896 */     // GIR_Coverage, 3968,
     /*  38896 */     GIR_EraseRootFromParent_Done,
     /*  38897 */   // Label 618: @38897
     /*  38897 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38996), // Rule ID 3969 //
     /*  38902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38951 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38955 */     // MIs[3] Operand 1
     /*  38955 */     // No operand predicates
     /*  38955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38957 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38969 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38994 */     GIR_RootConstrainSelectedInstOperands,
     /*  38995 */     // GIR_Coverage, 3969,
     /*  38995 */     GIR_EraseRootFromParent_Done,
     /*  38996 */   // Label 619: @38996
     /*  38996 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(39082), // Rule ID 3963 //
     /*  39001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39061 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39080 */     GIR_RootConstrainSelectedInstOperands,
     /*  39081 */     // GIR_Coverage, 3963,
     /*  39081 */     GIR_EraseRootFromParent_Done,
     /*  39082 */   // Label 620: @39082
     /*  39082 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39168), // Rule ID 3964 //
     /*  39087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39147 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39166 */     GIR_RootConstrainSelectedInstOperands,
     /*  39167 */     // GIR_Coverage, 3964,
     /*  39167 */     GIR_EraseRootFromParent_Done,
     /*  39168 */   // Label 621: @39168
     /*  39168 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39301), // Rule ID 3976 //
     /*  39173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39214 */     // MIs[2] Operand 2
     /*  39214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39233 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39237 */     // MIs[3] Operand 1
     /*  39237 */     // No operand predicates
     /*  39237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39239 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39251 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39299 */     GIR_RootConstrainSelectedInstOperands,
     /*  39300 */     // GIR_Coverage, 3976,
     /*  39300 */     GIR_EraseRootFromParent_Done,
     /*  39301 */   // Label 622: @39301
     /*  39301 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39396), // Rule ID 3974 //
     /*  39306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39355 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39359 */     // MIs[3] Operand 1
     /*  39359 */     // No operand predicates
     /*  39359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39361 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39373 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39394 */     GIR_RootConstrainSelectedInstOperands,
     /*  39395 */     // GIR_Coverage, 3974,
     /*  39395 */     GIR_EraseRootFromParent_Done,
     /*  39396 */   // Label 623: @39396
     /*  39396 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39491), // Rule ID 3975 //
     /*  39401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39454 */     // MIs[3] Operand 1
     /*  39454 */     // No operand predicates
     /*  39454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39456 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39468 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39489 */     GIR_RootConstrainSelectedInstOperands,
     /*  39490 */     // GIR_Coverage, 3975,
     /*  39490 */     GIR_EraseRootFromParent_Done,
     /*  39491 */   // Label 624: @39491
     /*  39491 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39573), // Rule ID 124 //
     /*  39496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39556 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39571 */     GIR_RootConstrainSelectedInstOperands,
     /*  39572 */     // GIR_Coverage, 124,
     /*  39572 */     GIR_EraseRootFromParent_Done,
     /*  39573 */   // Label 625: @39573
     /*  39573 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39655), // Rule ID 126 //
     /*  39578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39638 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39653 */     GIR_RootConstrainSelectedInstOperands,
     /*  39654 */     // GIR_Coverage, 126,
     /*  39654 */     GIR_EraseRootFromParent_Done,
     /*  39655 */   // Label 626: @39655
     /*  39655 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39717), // Rule ID 3954 //
     /*  39660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39696 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39715 */     GIR_RootConstrainSelectedInstOperands,
     /*  39716 */     // GIR_Coverage, 3954,
     /*  39716 */     GIR_EraseRootFromParent_Done,
     /*  39717 */   // Label 627: @39717
     /*  39717 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39775), // Rule ID 9914 //
     /*  39722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39741 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39744 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39749 */     // MIs[1] pattern
     /*  39749 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39752 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39759 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39773 */     GIR_RootConstrainSelectedInstOperands,
     /*  39774 */     // GIR_Coverage, 9914,
     /*  39774 */     GIR_EraseRootFromParent_Done,
     /*  39775 */   // Label 628: @39775
     /*  39775 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39833), // Rule ID 9926 //
     /*  39780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39799 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39802 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39807 */     // MIs[1] pattern
     /*  39807 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39810 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39817 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39831 */     GIR_RootConstrainSelectedInstOperands,
     /*  39832 */     // GIR_Coverage, 9926,
     /*  39832 */     GIR_EraseRootFromParent_Done,
     /*  39833 */   // Label 629: @39833
     /*  39833 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39891), // Rule ID 9938 //
     /*  39838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39857 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39860 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39865 */     // MIs[1] pattern
     /*  39865 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39868 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39875 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39889 */     GIR_RootConstrainSelectedInstOperands,
     /*  39890 */     // GIR_Coverage, 9938,
     /*  39890 */     GIR_EraseRootFromParent_Done,
     /*  39891 */   // Label 630: @39891
     /*  39891 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39949), // Rule ID 9950 //
     /*  39896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39923 */     // MIs[1] pattern
     /*  39923 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39926 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39933 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39947 */     GIR_RootConstrainSelectedInstOperands,
     /*  39948 */     // GIR_Coverage, 9950,
     /*  39948 */     GIR_EraseRootFromParent_Done,
     /*  39949 */   // Label 631: @39949
     /*  39949 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(40112), // Rule ID 5365 //
     /*  39954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40000 */     // MIs[1] Operand 2
     /*  40000 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40013 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40013 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40016 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40020 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40039 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40046 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40094 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40111 */     // GIR_Coverage, 5365,
     /*  40111 */     GIR_EraseRootFromParent_Done,
     /*  40112 */   // Label 632: @40112
     /*  40112 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40275), // Rule ID 5362 //
     /*  40117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40163 */     // MIs[1] Operand 2
     /*  40163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40176 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40202 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40205 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40209 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40239 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40274 */     // GIR_Coverage, 5362,
     /*  40274 */     GIR_EraseRootFromParent_Done,
     /*  40275 */   // Label 633: @40275
     /*  40275 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40425), // Rule ID 5407 //
     /*  40280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40317 */     // MIs[1] Operand 2
     /*  40317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40330 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40424 */     // GIR_Coverage, 5407,
     /*  40424 */     GIR_EraseRootFromParent_Done,
     /*  40425 */   // Label 634: @40425
     /*  40425 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40575), // Rule ID 5413 //
     /*  40430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40467 */     // MIs[1] Operand 2
     /*  40467 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40480 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40506 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40557 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40574 */     // GIR_Coverage, 5413,
     /*  40574 */     GIR_EraseRootFromParent_Done,
     /*  40575 */   // Label 635: @40575
     /*  40575 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40725), // Rule ID 5406 //
     /*  40580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40617 */     // MIs[1] Operand 2
     /*  40617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40630 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40656 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40663 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40724 */     // GIR_Coverage, 5406,
     /*  40724 */     GIR_EraseRootFromParent_Done,
     /*  40725 */   // Label 636: @40725
     /*  40725 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40761), // Rule ID 3919 //
     /*  40730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40745 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40750 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40759 */     GIR_RootConstrainSelectedInstOperands,
     /*  40760 */     // GIR_Coverage, 3919,
     /*  40760 */     GIR_EraseRootFromParent_Done,
     /*  40761 */   // Label 637: @40761
     /*  40761 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40794), // Rule ID 3924 //
     /*  40766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40781 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40792 */     GIR_RootConstrainSelectedInstOperands,
     /*  40793 */     // GIR_Coverage, 3924,
     /*  40793 */     GIR_EraseRootFromParent_Done,
     /*  40794 */   // Label 638: @40794
     /*  40794 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40830), // Rule ID 3913 //
     /*  40799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40814 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40828 */     GIR_RootConstrainSelectedInstOperands,
     /*  40829 */     // GIR_Coverage, 3913,
     /*  40829 */     GIR_EraseRootFromParent_Done,
     /*  40830 */   // Label 639: @40830
     /*  40830 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40866), // Rule ID 3917 //
     /*  40835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40850 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40864 */     GIR_RootConstrainSelectedInstOperands,
     /*  40865 */     // GIR_Coverage, 3917,
     /*  40865 */     GIR_EraseRootFromParent_Done,
     /*  40866 */   // Label 640: @40866
     /*  40866 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40929), // Rule ID 10047 //
     /*  40871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40890 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40893 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40909 */     // MIs[1] pred
     /*  40909 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40916 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40927 */     GIR_RootConstrainSelectedInstOperands,
     /*  40928 */     // GIR_Coverage, 10047,
     /*  40928 */     GIR_EraseRootFromParent_Done,
     /*  40929 */   // Label 641: @40929
     /*  40929 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40992), // Rule ID 10048 //
     /*  40934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40953 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40956 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40972 */     // MIs[1] pred
     /*  40972 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40979 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 10048,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 642: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(41055), // Rule ID 10049 //
     /*  40997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41016 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41019 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41035 */     // MIs[1] pred
     /*  41035 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41042 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41053 */     GIR_RootConstrainSelectedInstOperands,
     /*  41054 */     // GIR_Coverage, 10049,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 643: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41118), // Rule ID 10050 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41079 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41082 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41098 */     // MIs[1] pred
     /*  41098 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41105 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41116 */     GIR_RootConstrainSelectedInstOperands,
     /*  41117 */     // GIR_Coverage, 10050,
     /*  41117 */     GIR_EraseRootFromParent_Done,
     /*  41118 */   // Label 644: @41118
     /*  41118 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41157), // Rule ID 1655 //
     /*  41123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41148 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 1655,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 645: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41193), // Rule ID 5248 //
     /*  41162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41184 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41191 */     GIR_RootConstrainSelectedInstOperands,
     /*  41192 */     // GIR_Coverage, 5248,
     /*  41192 */     GIR_EraseRootFromParent_Done,
     /*  41193 */   // Label 646: @41193
     /*  41193 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41220), // Rule ID 1644 //
     /*  41198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41213 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41218 */     GIR_RootConstrainSelectedInstOperands,
     /*  41219 */     // GIR_Coverage, 1644,
     /*  41219 */     GIR_Done,
     /*  41220 */   // Label 647: @41220
     /*  41220 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41250), // Rule ID 3915 //
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41237 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41242 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41248 */     GIR_RootConstrainSelectedInstOperands,
     /*  41249 */     // GIR_Coverage, 3915,
     /*  41249 */     GIR_Done,
     /*  41250 */   // Label 648: @41250
     /*  41250 */   GIM_Reject,
     /*  41251 */ // Label 611: @41251
     /*  41251 */ GIM_Reject,
     /*  41252 */ // Label 584: @41252
     /*  41252 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(42742),
     /*  41257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41267 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41399), // Rule ID 5397 //
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     // MIs[1] Operand 2
     /*  41301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41332 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41336 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41341 */     // MIs[3] Operand 2
     /*  41341 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41354 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41398 */     // GIR_Coverage, 5397,
     /*  41398 */     GIR_EraseRootFromParent_Done,
     /*  41399 */   // Label 650: @41399
     /*  41399 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41531), // Rule ID 5396 //
     /*  41404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41433 */     // MIs[1] Operand 2
     /*  41433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41468 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41473 */     // MIs[3] Operand 2
     /*  41473 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41486 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41530 */     // GIR_Coverage, 5396,
     /*  41530 */     GIR_EraseRootFromParent_Done,
     /*  41531 */   // Label 651: @41531
     /*  41531 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41663), // Rule ID 5409 //
     /*  41536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41565 */     // MIs[1] Operand 2
     /*  41565 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41596 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41600 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41605 */     // MIs[3] Operand 2
     /*  41605 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41616 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41618 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41645 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41662 */     // GIR_Coverage, 5409,
     /*  41662 */     GIR_EraseRootFromParent_Done,
     /*  41663 */   // Label 652: @41663
     /*  41663 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41795), // Rule ID 5395 //
     /*  41668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41697 */     // MIs[1] Operand 2
     /*  41697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41728 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41732 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41737 */     // MIs[3] Operand 2
     /*  41737 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41750 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41794 */     // GIR_Coverage, 5395,
     /*  41794 */     GIR_EraseRootFromParent_Done,
     /*  41795 */   // Label 653: @41795
     /*  41795 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41927), // Rule ID 5394 //
     /*  41800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41829 */     // MIs[1] Operand 2
     /*  41829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41869 */     // MIs[3] Operand 2
     /*  41869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41882 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41926 */     // GIR_Coverage, 5394,
     /*  41926 */     GIR_EraseRootFromParent_Done,
     /*  41927 */   // Label 654: @41927
     /*  41927 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42086), // Rule ID 5364 //
     /*  41932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41974 */     // MIs[1] Operand 2
     /*  41974 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41987 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41987 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  41990 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41994 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42013 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42016 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42020 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42068 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42085 */     // GIR_Coverage, 5364,
     /*  42085 */     GIR_EraseRootFromParent_Done,
     /*  42086 */   // Label 655: @42086
     /*  42086 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42245), // Rule ID 5361 //
     /*  42091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42133 */     // MIs[1] Operand 2
     /*  42133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42146 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42146 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42149 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42153 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42160 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42163 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42167 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42172 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42179 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42244 */     // GIR_Coverage, 5361,
     /*  42244 */     GIR_EraseRootFromParent_Done,
     /*  42245 */   // Label 656: @42245
     /*  42245 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42391), // Rule ID 5405 //
     /*  42250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42283 */     // MIs[1] Operand 2
     /*  42283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42296 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42296 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42299 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42303 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42322 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42329 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42390 */     // GIR_Coverage, 5405,
     /*  42390 */     GIR_EraseRootFromParent_Done,
     /*  42391 */   // Label 657: @42391
     /*  42391 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42537), // Rule ID 5412 //
     /*  42396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42429 */     // MIs[1] Operand 2
     /*  42429 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42442 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42468 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42475 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42478 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42519 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42536 */     // GIR_Coverage, 5412,
     /*  42536 */     GIR_EraseRootFromParent_Done,
     /*  42537 */   // Label 658: @42537
     /*  42537 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42683), // Rule ID 5404 //
     /*  42542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42575 */     // MIs[1] Operand 2
     /*  42575 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42588 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42588 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42591 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42595 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42614 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42621 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42682 */     // GIR_Coverage, 5404,
     /*  42682 */     GIR_EraseRootFromParent_Done,
     /*  42683 */   // Label 659: @42683
     /*  42683 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42718), // Rule ID 969 //
     /*  42688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42709 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42716 */     GIR_RootConstrainSelectedInstOperands,
     /*  42717 */     // GIR_Coverage, 969,
     /*  42717 */     GIR_EraseRootFromParent_Done,
     /*  42718 */   // Label 660: @42718
     /*  42718 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42741), // Rule ID 1476 //
     /*  42723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42734 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42739 */     GIR_RootConstrainSelectedInstOperands,
     /*  42740 */     // GIR_Coverage, 1476,
     /*  42740 */     GIR_Done,
     /*  42741 */   // Label 661: @42741
     /*  42741 */   GIM_Reject,
     /*  42742 */ // Label 649: @42742
     /*  42742 */ GIM_Reject,
     /*  42743 */ // Label 585: @42743
     /*  42743 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(45202),
     /*  42748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42758 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42872), // Rule ID 2048 //
     /*  42763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42827 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42831 */     // MIs[4] Operand 1
     /*  42831 */     // No operand predicates
     /*  42831 */     // MIs[2] Operand 2
     /*  42831 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42851 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42870 */     GIR_RootConstrainSelectedInstOperands,
     /*  42871 */     // GIR_Coverage, 2048,
     /*  42871 */     GIR_EraseRootFromParent_Done,
     /*  42872 */   // Label 663: @42872
     /*  42872 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42986), // Rule ID 13476 //
     /*  42877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42928 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42933 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42937 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42941 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42945 */     // MIs[4] Operand 1
     /*  42945 */     // No operand predicates
     /*  42945 */     // MIs[2] Operand 2
     /*  42945 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42956 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42965 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42984 */     GIR_RootConstrainSelectedInstOperands,
     /*  42985 */     // GIR_Coverage, 13476,
     /*  42985 */     GIR_EraseRootFromParent_Done,
     /*  42986 */   // Label 664: @42986
     /*  42986 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(43100), // Rule ID 2100 //
     /*  42991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43055 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43059 */     // MIs[4] Operand 1
     /*  43059 */     // No operand predicates
     /*  43059 */     // MIs[2] Operand 2
     /*  43059 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43079 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43098 */     GIR_RootConstrainSelectedInstOperands,
     /*  43099 */     // GIR_Coverage, 2100,
     /*  43099 */     GIR_EraseRootFromParent_Done,
     /*  43100 */   // Label 665: @43100
     /*  43100 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43214), // Rule ID 13506 //
     /*  43105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43169 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43173 */     // MIs[4] Operand 1
     /*  43173 */     // No operand predicates
     /*  43173 */     // MIs[2] Operand 2
     /*  43173 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43212 */     GIR_RootConstrainSelectedInstOperands,
     /*  43213 */     // GIR_Coverage, 13506,
     /*  43213 */     GIR_EraseRootFromParent_Done,
     /*  43214 */   // Label 666: @43214
     /*  43214 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43279), // Rule ID 1855 //
     /*  43219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43262 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43277 */     GIR_RootConstrainSelectedInstOperands,
     /*  43278 */     // GIR_Coverage, 1855,
     /*  43278 */     GIR_EraseRootFromParent_Done,
     /*  43279 */   // Label 667: @43279
     /*  43279 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43344), // Rule ID 1854 //
     /*  43284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43327 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43342 */     GIR_RootConstrainSelectedInstOperands,
     /*  43343 */     // GIR_Coverage, 1854,
     /*  43343 */     GIR_EraseRootFromParent_Done,
     /*  43344 */   // Label 668: @43344
     /*  43344 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43409), // Rule ID 1759 //
     /*  43349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43392 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43407 */     GIR_RootConstrainSelectedInstOperands,
     /*  43408 */     // GIR_Coverage, 1759,
     /*  43408 */     GIR_EraseRootFromParent_Done,
     /*  43409 */   // Label 669: @43409
     /*  43409 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43474), // Rule ID 1853 //
     /*  43414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43457 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43472 */     GIR_RootConstrainSelectedInstOperands,
     /*  43473 */     // GIR_Coverage, 1853,
     /*  43473 */     GIR_EraseRootFromParent_Done,
     /*  43474 */   // Label 670: @43474
     /*  43474 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43539), // Rule ID 1852 //
     /*  43479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43522 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43537 */     GIR_RootConstrainSelectedInstOperands,
     /*  43538 */     // GIR_Coverage, 1852,
     /*  43538 */     GIR_EraseRootFromParent_Done,
     /*  43539 */   // Label 671: @43539
     /*  43539 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43650), // Rule ID 13474 //
     /*  43544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43612 */     // MIs[4] Operand 1
     /*  43612 */     // No operand predicates
     /*  43612 */     // MIs[2] Operand 2
     /*  43612 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43630 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43648 */     GIR_RootConstrainSelectedInstOperands,
     /*  43649 */     // GIR_Coverage, 13474,
     /*  43649 */     GIR_EraseRootFromParent_Done,
     /*  43650 */   // Label 672: @43650
     /*  43650 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43761), // Rule ID 2046 //
     /*  43655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43724 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43728 */     // MIs[4] Operand 1
     /*  43728 */     // No operand predicates
     /*  43728 */     // MIs[2] Operand 2
     /*  43728 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43741 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43759 */     GIR_RootConstrainSelectedInstOperands,
     /*  43760 */     // GIR_Coverage, 2046,
     /*  43760 */     GIR_EraseRootFromParent_Done,
     /*  43761 */   // Label 673: @43761
     /*  43761 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43872), // Rule ID 13504 //
     /*  43766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43809 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43813 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43817 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43830 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43834 */     // MIs[4] Operand 1
     /*  43834 */     // No operand predicates
     /*  43834 */     // MIs[2] Operand 2
     /*  43834 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43852 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43870 */     GIR_RootConstrainSelectedInstOperands,
     /*  43871 */     // GIR_Coverage, 13504,
     /*  43871 */     GIR_EraseRootFromParent_Done,
     /*  43872 */   // Label 674: @43872
     /*  43872 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43983), // Rule ID 2098 //
     /*  43877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43950 */     // MIs[4] Operand 1
     /*  43950 */     // No operand predicates
     /*  43950 */     // MIs[2] Operand 2
     /*  43950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43961 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43963 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43981 */     GIR_RootConstrainSelectedInstOperands,
     /*  43982 */     // GIR_Coverage, 2098,
     /*  43982 */     GIR_EraseRootFromParent_Done,
     /*  43983 */   // Label 675: @43983
     /*  43983 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(44046), // Rule ID 1735 //
     /*  43988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44027 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44044 */     GIR_RootConstrainSelectedInstOperands,
     /*  44045 */     // GIR_Coverage, 1735,
     /*  44045 */     GIR_EraseRootFromParent_Done,
     /*  44046 */   // Label 676: @44046
     /*  44046 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(44109), // Rule ID 1825 //
     /*  44051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44090 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44107 */     GIR_RootConstrainSelectedInstOperands,
     /*  44108 */     // GIR_Coverage, 1825,
     /*  44108 */     GIR_EraseRootFromParent_Done,
     /*  44109 */   // Label 677: @44109
     /*  44109 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44197), // Rule ID 13475 //
     /*  44114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44170 */     // MIs[3] Operand 1
     /*  44170 */     // No operand predicates
     /*  44170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44177 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44195 */     GIR_RootConstrainSelectedInstOperands,
     /*  44196 */     // GIR_Coverage, 13475,
     /*  44196 */     GIR_EraseRootFromParent_Done,
     /*  44197 */   // Label 678: @44197
     /*  44197 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44285), // Rule ID 2047 //
     /*  44202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44263 */     // MIs[3] Operand 1
     /*  44263 */     // No operand predicates
     /*  44263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44265 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44283 */     GIR_RootConstrainSelectedInstOperands,
     /*  44284 */     // GIR_Coverage, 2047,
     /*  44284 */     GIR_EraseRootFromParent_Done,
     /*  44285 */   // Label 679: @44285
     /*  44285 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44373), // Rule ID 13505 //
     /*  44290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44342 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44346 */     // MIs[3] Operand 1
     /*  44346 */     // No operand predicates
     /*  44346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44353 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44371 */     GIR_RootConstrainSelectedInstOperands,
     /*  44372 */     // GIR_Coverage, 13505,
     /*  44372 */     GIR_EraseRootFromParent_Done,
     /*  44373 */   // Label 680: @44373
     /*  44373 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44461), // Rule ID 2099 //
     /*  44378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44435 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44439 */     // MIs[3] Operand 1
     /*  44439 */     // No operand predicates
     /*  44439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44441 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44459 */     GIR_RootConstrainSelectedInstOperands,
     /*  44460 */     // GIR_Coverage, 2099,
     /*  44460 */     GIR_EraseRootFromParent_Done,
     /*  44461 */   // Label 681: @44461
     /*  44461 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44508), // Rule ID 1867 //
     /*  44466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44494 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44506 */     GIR_RootConstrainSelectedInstOperands,
     /*  44507 */     // GIR_Coverage, 1867,
     /*  44507 */     GIR_EraseRootFromParent_Done,
     /*  44508 */   // Label 682: @44508
     /*  44508 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44555), // Rule ID 1765 //
     /*  44513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44541 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44553 */     GIR_RootConstrainSelectedInstOperands,
     /*  44554 */     // GIR_Coverage, 1765,
     /*  44554 */     GIR_EraseRootFromParent_Done,
     /*  44555 */   // Label 683: @44555
     /*  44555 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44602), // Rule ID 1866 //
     /*  44560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44588 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44600 */     GIR_RootConstrainSelectedInstOperands,
     /*  44601 */     // GIR_Coverage, 1866,
     /*  44601 */     GIR_EraseRootFromParent_Done,
     /*  44602 */   // Label 684: @44602
     /*  44602 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44661), // Rule ID 1851 //
     /*  44607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44646 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44659 */     GIR_RootConstrainSelectedInstOperands,
     /*  44660 */     // GIR_Coverage, 1851,
     /*  44660 */     GIR_EraseRootFromParent_Done,
     /*  44661 */   // Label 685: @44661
     /*  44661 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44720), // Rule ID 1850 //
     /*  44666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44705 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44718 */     GIR_RootConstrainSelectedInstOperands,
     /*  44719 */     // GIR_Coverage, 1850,
     /*  44719 */     GIR_EraseRootFromParent_Done,
     /*  44720 */   // Label 686: @44720
     /*  44720 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44779), // Rule ID 1758 //
     /*  44725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44764 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44777 */     GIR_RootConstrainSelectedInstOperands,
     /*  44778 */     // GIR_Coverage, 1758,
     /*  44778 */     GIR_EraseRootFromParent_Done,
     /*  44779 */   // Label 687: @44779
     /*  44779 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44838), // Rule ID 1849 //
     /*  44784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44823 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44836 */     GIR_RootConstrainSelectedInstOperands,
     /*  44837 */     // GIR_Coverage, 1849,
     /*  44837 */     GIR_EraseRootFromParent_Done,
     /*  44838 */   // Label 688: @44838
     /*  44838 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44897), // Rule ID 1848 //
     /*  44843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44882 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44895 */     GIR_RootConstrainSelectedInstOperands,
     /*  44896 */     // GIR_Coverage, 1848,
     /*  44896 */     GIR_EraseRootFromParent_Done,
     /*  44897 */   // Label 689: @44897
     /*  44897 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44932), // Rule ID 971 //
     /*  44902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44909 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44915 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44923 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44930 */     GIR_RootConstrainSelectedInstOperands,
     /*  44931 */     // GIR_Coverage, 971,
     /*  44931 */     GIR_EraseRootFromParent_Done,
     /*  44932 */   // Label 690: @44932
     /*  44932 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44989), // Rule ID 1734 //
     /*  44937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44972 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  44987 */     GIR_RootConstrainSelectedInstOperands,
     /*  44988 */     // GIR_Coverage, 1734,
     /*  44988 */     GIR_EraseRootFromParent_Done,
     /*  44989 */   // Label 691: @44989
     /*  44989 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45046), // Rule ID 1824 //
     /*  44994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45029 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45044 */     GIR_RootConstrainSelectedInstOperands,
     /*  45045 */     // GIR_Coverage, 1824,
     /*  45045 */     GIR_EraseRootFromParent_Done,
     /*  45046 */   // Label 692: @45046
     /*  45046 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45090), // Rule ID 1865 //
     /*  45051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45077 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45088 */     GIR_RootConstrainSelectedInstOperands,
     /*  45089 */     // GIR_Coverage, 1865,
     /*  45089 */     GIR_EraseRootFromParent_Done,
     /*  45090 */   // Label 693: @45090
     /*  45090 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45134), // Rule ID 1764 //
     /*  45095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45121 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45132 */     GIR_RootConstrainSelectedInstOperands,
     /*  45133 */     // GIR_Coverage, 1764,
     /*  45133 */     GIR_EraseRootFromParent_Done,
     /*  45134 */   // Label 694: @45134
     /*  45134 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45178), // Rule ID 1864 //
     /*  45139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45165 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45176 */     GIR_RootConstrainSelectedInstOperands,
     /*  45177 */     // GIR_Coverage, 1864,
     /*  45177 */     GIR_EraseRootFromParent_Done,
     /*  45178 */   // Label 695: @45178
     /*  45178 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45201), // Rule ID 1478 //
     /*  45183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45194 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45199 */     GIR_RootConstrainSelectedInstOperands,
     /*  45200 */     // GIR_Coverage, 1478,
     /*  45200 */     GIR_Done,
     /*  45201 */   // Label 696: @45201
     /*  45201 */   GIM_Reject,
     /*  45202 */ // Label 662: @45202
     /*  45202 */ GIM_Reject,
     /*  45203 */ // Label 586: @45203
     /*  45203 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(46693),
     /*  45208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45218 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45350), // Rule ID 5393 //
     /*  45223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     // MIs[1] Operand 2
     /*  45252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45283 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45287 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45292 */     // MIs[3] Operand 2
     /*  45292 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45305 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45332 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45349 */     // GIR_Coverage, 5393,
     /*  45349 */     GIR_EraseRootFromParent_Done,
     /*  45350 */   // Label 698: @45350
     /*  45350 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45482), // Rule ID 5392 //
     /*  45355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45384 */     // MIs[1] Operand 2
     /*  45384 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45419 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45424 */     // MIs[3] Operand 2
     /*  45424 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45437 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45481 */     // GIR_Coverage, 5392,
     /*  45481 */     GIR_EraseRootFromParent_Done,
     /*  45482 */   // Label 699: @45482
     /*  45482 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45614), // Rule ID 5408 //
     /*  45487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45516 */     // MIs[1] Operand 2
     /*  45516 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45543 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45547 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45551 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45556 */     // MIs[3] Operand 2
     /*  45556 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45569 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45596 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45613 */     // GIR_Coverage, 5408,
     /*  45613 */     GIR_EraseRootFromParent_Done,
     /*  45614 */   // Label 700: @45614
     /*  45614 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45746), // Rule ID 5391 //
     /*  45619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45648 */     // MIs[1] Operand 2
     /*  45648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45688 */     // MIs[3] Operand 2
     /*  45688 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45701 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45745 */     // GIR_Coverage, 5391,
     /*  45745 */     GIR_EraseRootFromParent_Done,
     /*  45746 */   // Label 701: @45746
     /*  45746 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45878), // Rule ID 5390 //
     /*  45751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45780 */     // MIs[1] Operand 2
     /*  45780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45811 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45820 */     // MIs[3] Operand 2
     /*  45820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45833 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45877 */     // GIR_Coverage, 5390,
     /*  45877 */     GIR_EraseRootFromParent_Done,
     /*  45878 */   // Label 702: @45878
     /*  45878 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46037), // Rule ID 5363 //
     /*  45883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45925 */     // MIs[1] Operand 2
     /*  45925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45938 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45964 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45971 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  45996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46036 */     // GIR_Coverage, 5363,
     /*  46036 */     GIR_EraseRootFromParent_Done,
     /*  46037 */   // Label 703: @46037
     /*  46037 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46196), // Rule ID 5360 //
     /*  46042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46084 */     // MIs[1] Operand 2
     /*  46084 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46097 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46123 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46130 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46178 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46195 */     // GIR_Coverage, 5360,
     /*  46195 */     GIR_EraseRootFromParent_Done,
     /*  46196 */   // Label 704: @46196
     /*  46196 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46342), // Rule ID 5403 //
     /*  46201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46234 */     // MIs[1] Operand 2
     /*  46234 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46247 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46313 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46341 */     // GIR_Coverage, 5403,
     /*  46341 */     GIR_EraseRootFromParent_Done,
     /*  46342 */   // Label 705: @46342
     /*  46342 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46488), // Rule ID 5411 //
     /*  46347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46380 */     // MIs[1] Operand 2
     /*  46380 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46393 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46419 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46426 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46470 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46487 */     // GIR_Coverage, 5411,
     /*  46487 */     GIR_EraseRootFromParent_Done,
     /*  46488 */   // Label 706: @46488
     /*  46488 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46634), // Rule ID 5402 //
     /*  46493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46526 */     // MIs[1] Operand 2
     /*  46526 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46539 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46539 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46542 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46546 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46572 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46633 */     // GIR_Coverage, 5402,
     /*  46633 */     GIR_EraseRootFromParent_Done,
     /*  46634 */   // Label 707: @46634
     /*  46634 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46669), // Rule ID 967 //
     /*  46639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46646 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46652 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46660 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46667 */     GIR_RootConstrainSelectedInstOperands,
     /*  46668 */     // GIR_Coverage, 967,
     /*  46668 */     GIR_EraseRootFromParent_Done,
     /*  46669 */   // Label 708: @46669
     /*  46669 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46692), // Rule ID 1474 //
     /*  46674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46685 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46690 */     GIR_RootConstrainSelectedInstOperands,
     /*  46691 */     // GIR_Coverage, 1474,
     /*  46691 */     GIR_Done,
     /*  46692 */   // Label 709: @46692
     /*  46692 */   GIM_Reject,
     /*  46693 */ // Label 697: @46693
     /*  46693 */ GIM_Reject,
     /*  46694 */ // Label 587: @46694
     /*  46694 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(49153),
     /*  46699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46709 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46823), // Rule ID 2045 //
     /*  46714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46761 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46774 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46778 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46782 */     // MIs[4] Operand 1
     /*  46782 */     // No operand predicates
     /*  46782 */     // MIs[2] Operand 2
     /*  46782 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46793 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46802 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46821 */     GIR_RootConstrainSelectedInstOperands,
     /*  46822 */     // GIR_Coverage, 2045,
     /*  46822 */     GIR_EraseRootFromParent_Done,
     /*  46823 */   // Label 711: @46823
     /*  46823 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46937), // Rule ID 13473 //
     /*  46828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46871 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46875 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46879 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46892 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46896 */     // MIs[4] Operand 1
     /*  46896 */     // No operand predicates
     /*  46896 */     // MIs[2] Operand 2
     /*  46896 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46907 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46916 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46935 */     GIR_RootConstrainSelectedInstOperands,
     /*  46936 */     // GIR_Coverage, 13473,
     /*  46936 */     GIR_EraseRootFromParent_Done,
     /*  46937 */   // Label 712: @46937
     /*  46937 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(47051), // Rule ID 2097 //
     /*  46942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47006 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47010 */     // MIs[4] Operand 1
     /*  47010 */     // No operand predicates
     /*  47010 */     // MIs[2] Operand 2
     /*  47010 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47030 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47049 */     GIR_RootConstrainSelectedInstOperands,
     /*  47050 */     // GIR_Coverage, 2097,
     /*  47050 */     GIR_EraseRootFromParent_Done,
     /*  47051 */   // Label 713: @47051
     /*  47051 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(47165), // Rule ID 13503 //
     /*  47056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47124 */     // MIs[4] Operand 1
     /*  47124 */     // No operand predicates
     /*  47124 */     // MIs[2] Operand 2
     /*  47124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47163 */     GIR_RootConstrainSelectedInstOperands,
     /*  47164 */     // GIR_Coverage, 13503,
     /*  47164 */     GIR_EraseRootFromParent_Done,
     /*  47165 */   // Label 714: @47165
     /*  47165 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47230), // Rule ID 1847 //
     /*  47170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47213 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47228 */     GIR_RootConstrainSelectedInstOperands,
     /*  47229 */     // GIR_Coverage, 1847,
     /*  47229 */     GIR_EraseRootFromParent_Done,
     /*  47230 */   // Label 715: @47230
     /*  47230 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47295), // Rule ID 1846 //
     /*  47235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47278 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47293 */     GIR_RootConstrainSelectedInstOperands,
     /*  47294 */     // GIR_Coverage, 1846,
     /*  47294 */     GIR_EraseRootFromParent_Done,
     /*  47295 */   // Label 716: @47295
     /*  47295 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47360), // Rule ID 1757 //
     /*  47300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47343 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47358 */     GIR_RootConstrainSelectedInstOperands,
     /*  47359 */     // GIR_Coverage, 1757,
     /*  47359 */     GIR_EraseRootFromParent_Done,
     /*  47360 */   // Label 717: @47360
     /*  47360 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47425), // Rule ID 1845 //
     /*  47365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47408 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47423 */     GIR_RootConstrainSelectedInstOperands,
     /*  47424 */     // GIR_Coverage, 1845,
     /*  47424 */     GIR_EraseRootFromParent_Done,
     /*  47425 */   // Label 718: @47425
     /*  47425 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47490), // Rule ID 1844 //
     /*  47430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47473 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47488 */     GIR_RootConstrainSelectedInstOperands,
     /*  47489 */     // GIR_Coverage, 1844,
     /*  47489 */     GIR_EraseRootFromParent_Done,
     /*  47490 */   // Label 719: @47490
     /*  47490 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47601), // Rule ID 13471 //
     /*  47495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47546 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47559 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47563 */     // MIs[4] Operand 1
     /*  47563 */     // No operand predicates
     /*  47563 */     // MIs[2] Operand 2
     /*  47563 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47581 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47599 */     GIR_RootConstrainSelectedInstOperands,
     /*  47600 */     // GIR_Coverage, 13471,
     /*  47600 */     GIR_EraseRootFromParent_Done,
     /*  47601 */   // Label 720: @47601
     /*  47601 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47712), // Rule ID 2043 //
     /*  47606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47658 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47662 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47667 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47671 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47675 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47679 */     // MIs[4] Operand 1
     /*  47679 */     // No operand predicates
     /*  47679 */     // MIs[2] Operand 2
     /*  47679 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47692 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47710 */     GIR_RootConstrainSelectedInstOperands,
     /*  47711 */     // GIR_Coverage, 2043,
     /*  47711 */     GIR_EraseRootFromParent_Done,
     /*  47712 */   // Label 721: @47712
     /*  47712 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47823), // Rule ID 13501 //
     /*  47717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47781 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47785 */     // MIs[4] Operand 1
     /*  47785 */     // No operand predicates
     /*  47785 */     // MIs[2] Operand 2
     /*  47785 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47801 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47803 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47821 */     GIR_RootConstrainSelectedInstOperands,
     /*  47822 */     // GIR_Coverage, 13501,
     /*  47822 */     GIR_EraseRootFromParent_Done,
     /*  47823 */   // Label 722: @47823
     /*  47823 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47934), // Rule ID 2095 //
     /*  47828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47884 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47897 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47901 */     // MIs[4] Operand 1
     /*  47901 */     // No operand predicates
     /*  47901 */     // MIs[2] Operand 2
     /*  47901 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47912 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47914 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47932 */     GIR_RootConstrainSelectedInstOperands,
     /*  47933 */     // GIR_Coverage, 2095,
     /*  47933 */     GIR_EraseRootFromParent_Done,
     /*  47934 */   // Label 723: @47934
     /*  47934 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47997), // Rule ID 1733 //
     /*  47939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47978 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47995 */     GIR_RootConstrainSelectedInstOperands,
     /*  47996 */     // GIR_Coverage, 1733,
     /*  47996 */     GIR_EraseRootFromParent_Done,
     /*  47997 */   // Label 724: @47997
     /*  47997 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(48060), // Rule ID 1823 //
     /*  48002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48041 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48058 */     GIR_RootConstrainSelectedInstOperands,
     /*  48059 */     // GIR_Coverage, 1823,
     /*  48059 */     GIR_EraseRootFromParent_Done,
     /*  48060 */   // Label 725: @48060
     /*  48060 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48148), // Rule ID 13472 //
     /*  48065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48117 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48121 */     // MIs[3] Operand 1
     /*  48121 */     // No operand predicates
     /*  48121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48128 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48146 */     GIR_RootConstrainSelectedInstOperands,
     /*  48147 */     // GIR_Coverage, 13472,
     /*  48147 */     GIR_EraseRootFromParent_Done,
     /*  48148 */   // Label 726: @48148
     /*  48148 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48236), // Rule ID 2044 //
     /*  48153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48214 */     // MIs[3] Operand 1
     /*  48214 */     // No operand predicates
     /*  48214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48216 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48234 */     GIR_RootConstrainSelectedInstOperands,
     /*  48235 */     // GIR_Coverage, 2044,
     /*  48235 */     GIR_EraseRootFromParent_Done,
     /*  48236 */   // Label 727: @48236
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48324), // Rule ID 13502 //
     /*  48241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48297 */     // MIs[3] Operand 1
     /*  48297 */     // No operand predicates
     /*  48297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48304 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48322 */     GIR_RootConstrainSelectedInstOperands,
     /*  48323 */     // GIR_Coverage, 13502,
     /*  48323 */     GIR_EraseRootFromParent_Done,
     /*  48324 */   // Label 728: @48324
     /*  48324 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48412), // Rule ID 2096 //
     /*  48329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48386 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48390 */     // MIs[3] Operand 1
     /*  48390 */     // No operand predicates
     /*  48390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48392 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48410 */     GIR_RootConstrainSelectedInstOperands,
     /*  48411 */     // GIR_Coverage, 2096,
     /*  48411 */     GIR_EraseRootFromParent_Done,
     /*  48412 */   // Label 729: @48412
     /*  48412 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48459), // Rule ID 1863 //
     /*  48417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48445 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48457 */     GIR_RootConstrainSelectedInstOperands,
     /*  48458 */     // GIR_Coverage, 1863,
     /*  48458 */     GIR_EraseRootFromParent_Done,
     /*  48459 */   // Label 730: @48459
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48506), // Rule ID 1763 //
     /*  48464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48492 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48504 */     GIR_RootConstrainSelectedInstOperands,
     /*  48505 */     // GIR_Coverage, 1763,
     /*  48505 */     GIR_EraseRootFromParent_Done,
     /*  48506 */   // Label 731: @48506
     /*  48506 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48553), // Rule ID 1862 //
     /*  48511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48539 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48551 */     GIR_RootConstrainSelectedInstOperands,
     /*  48552 */     // GIR_Coverage, 1862,
     /*  48552 */     GIR_EraseRootFromParent_Done,
     /*  48553 */   // Label 732: @48553
     /*  48553 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48612), // Rule ID 1843 //
     /*  48558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48597 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48610 */     GIR_RootConstrainSelectedInstOperands,
     /*  48611 */     // GIR_Coverage, 1843,
     /*  48611 */     GIR_EraseRootFromParent_Done,
     /*  48612 */   // Label 733: @48612
     /*  48612 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48671), // Rule ID 1842 //
     /*  48617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48656 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48669 */     GIR_RootConstrainSelectedInstOperands,
     /*  48670 */     // GIR_Coverage, 1842,
     /*  48670 */     GIR_EraseRootFromParent_Done,
     /*  48671 */   // Label 734: @48671
     /*  48671 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48730), // Rule ID 1756 //
     /*  48676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48715 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48728 */     GIR_RootConstrainSelectedInstOperands,
     /*  48729 */     // GIR_Coverage, 1756,
     /*  48729 */     GIR_EraseRootFromParent_Done,
     /*  48730 */   // Label 735: @48730
     /*  48730 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48789), // Rule ID 1841 //
     /*  48735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48774 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48787 */     GIR_RootConstrainSelectedInstOperands,
     /*  48788 */     // GIR_Coverage, 1841,
     /*  48788 */     GIR_EraseRootFromParent_Done,
     /*  48789 */   // Label 736: @48789
     /*  48789 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48848), // Rule ID 1840 //
     /*  48794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48833 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48846 */     GIR_RootConstrainSelectedInstOperands,
     /*  48847 */     // GIR_Coverage, 1840,
     /*  48847 */     GIR_EraseRootFromParent_Done,
     /*  48848 */   // Label 737: @48848
     /*  48848 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48883), // Rule ID 970 //
     /*  48853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48874 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48881 */     GIR_RootConstrainSelectedInstOperands,
     /*  48882 */     // GIR_Coverage, 970,
     /*  48882 */     GIR_EraseRootFromParent_Done,
     /*  48883 */   // Label 738: @48883
     /*  48883 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48940), // Rule ID 1732 //
     /*  48888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48923 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48938 */     GIR_RootConstrainSelectedInstOperands,
     /*  48939 */     // GIR_Coverage, 1732,
     /*  48939 */     GIR_EraseRootFromParent_Done,
     /*  48940 */   // Label 739: @48940
     /*  48940 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48997), // Rule ID 1822 //
     /*  48945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48980 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48995 */     GIR_RootConstrainSelectedInstOperands,
     /*  48996 */     // GIR_Coverage, 1822,
     /*  48996 */     GIR_EraseRootFromParent_Done,
     /*  48997 */   // Label 740: @48997
     /*  48997 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49041), // Rule ID 1861 //
     /*  49002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49028 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49039 */     GIR_RootConstrainSelectedInstOperands,
     /*  49040 */     // GIR_Coverage, 1861,
     /*  49040 */     GIR_EraseRootFromParent_Done,
     /*  49041 */   // Label 741: @49041
     /*  49041 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49085), // Rule ID 1762 //
     /*  49046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49072 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49083 */     GIR_RootConstrainSelectedInstOperands,
     /*  49084 */     // GIR_Coverage, 1762,
     /*  49084 */     GIR_EraseRootFromParent_Done,
     /*  49085 */   // Label 742: @49085
     /*  49085 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49129), // Rule ID 1860 //
     /*  49090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49116 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49127 */     GIR_RootConstrainSelectedInstOperands,
     /*  49128 */     // GIR_Coverage, 1860,
     /*  49128 */     GIR_EraseRootFromParent_Done,
     /*  49129 */   // Label 743: @49129
     /*  49129 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49152), // Rule ID 1477 //
     /*  49134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49145 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49150 */     GIR_RootConstrainSelectedInstOperands,
     /*  49151 */     // GIR_Coverage, 1477,
     /*  49151 */     GIR_Done,
     /*  49152 */   // Label 744: @49152
     /*  49152 */   GIM_Reject,
     /*  49153 */ // Label 710: @49153
     /*  49153 */ GIM_Reject,
     /*  49154 */ // Label 588: @49154
     /*  49154 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49228),
     /*  49159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49169 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49204), // Rule ID 965 //
     /*  49174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49181 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49187 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49195 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49202 */     GIR_RootConstrainSelectedInstOperands,
     /*  49203 */     // GIR_Coverage, 965,
     /*  49203 */     GIR_EraseRootFromParent_Done,
     /*  49204 */   // Label 746: @49204
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49227), // Rule ID 1472 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49220 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49225 */     GIR_RootConstrainSelectedInstOperands,
     /*  49226 */     // GIR_Coverage, 1472,
     /*  49226 */     GIR_Done,
     /*  49227 */   // Label 747: @49227
     /*  49227 */   GIM_Reject,
     /*  49228 */ // Label 745: @49228
     /*  49228 */ GIM_Reject,
     /*  49229 */ // Label 589: @49229
     /*  49229 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(50436),
     /*  49234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49244 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49309), // Rule ID 1839 //
     /*  49249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49292 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49307 */     GIR_RootConstrainSelectedInstOperands,
     /*  49308 */     // GIR_Coverage, 1839,
     /*  49308 */     GIR_EraseRootFromParent_Done,
     /*  49309 */   // Label 749: @49309
     /*  49309 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49374), // Rule ID 1838 //
     /*  49314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49357 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49372 */     GIR_RootConstrainSelectedInstOperands,
     /*  49373 */     // GIR_Coverage, 1838,
     /*  49373 */     GIR_EraseRootFromParent_Done,
     /*  49374 */   // Label 750: @49374
     /*  49374 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49439), // Rule ID 1755 //
     /*  49379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49422 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49437 */     GIR_RootConstrainSelectedInstOperands,
     /*  49438 */     // GIR_Coverage, 1755,
     /*  49438 */     GIR_EraseRootFromParent_Done,
     /*  49439 */   // Label 751: @49439
     /*  49439 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49504), // Rule ID 1837 //
     /*  49444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49487 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49502 */     GIR_RootConstrainSelectedInstOperands,
     /*  49503 */     // GIR_Coverage, 1837,
     /*  49503 */     GIR_EraseRootFromParent_Done,
     /*  49504 */   // Label 752: @49504
     /*  49504 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49569), // Rule ID 1836 //
     /*  49509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49552 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49567 */     GIR_RootConstrainSelectedInstOperands,
     /*  49568 */     // GIR_Coverage, 1836,
     /*  49568 */     GIR_EraseRootFromParent_Done,
     /*  49569 */   // Label 753: @49569
     /*  49569 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49632), // Rule ID 1731 //
     /*  49574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49613 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49630 */     GIR_RootConstrainSelectedInstOperands,
     /*  49631 */     // GIR_Coverage, 1731,
     /*  49631 */     GIR_EraseRootFromParent_Done,
     /*  49632 */   // Label 754: @49632
     /*  49632 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49695), // Rule ID 1821 //
     /*  49637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49676 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49693 */     GIR_RootConstrainSelectedInstOperands,
     /*  49694 */     // GIR_Coverage, 1821,
     /*  49694 */     GIR_EraseRootFromParent_Done,
     /*  49695 */   // Label 755: @49695
     /*  49695 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49742), // Rule ID 1859 //
     /*  49700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49728 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49740 */     GIR_RootConstrainSelectedInstOperands,
     /*  49741 */     // GIR_Coverage, 1859,
     /*  49741 */     GIR_EraseRootFromParent_Done,
     /*  49742 */   // Label 756: @49742
     /*  49742 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49789), // Rule ID 1761 //
     /*  49747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49775 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49787 */     GIR_RootConstrainSelectedInstOperands,
     /*  49788 */     // GIR_Coverage, 1761,
     /*  49788 */     GIR_EraseRootFromParent_Done,
     /*  49789 */   // Label 757: @49789
     /*  49789 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49836), // Rule ID 1858 //
     /*  49794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49822 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49834 */     GIR_RootConstrainSelectedInstOperands,
     /*  49835 */     // GIR_Coverage, 1858,
     /*  49835 */     GIR_EraseRootFromParent_Done,
     /*  49836 */   // Label 758: @49836
     /*  49836 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49895), // Rule ID 1835 //
     /*  49841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49880 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49893 */     GIR_RootConstrainSelectedInstOperands,
     /*  49894 */     // GIR_Coverage, 1835,
     /*  49894 */     GIR_EraseRootFromParent_Done,
     /*  49895 */   // Label 759: @49895
     /*  49895 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49954), // Rule ID 1834 //
     /*  49900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49939 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49952 */     GIR_RootConstrainSelectedInstOperands,
     /*  49953 */     // GIR_Coverage, 1834,
     /*  49953 */     GIR_EraseRootFromParent_Done,
     /*  49954 */   // Label 760: @49954
     /*  49954 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50013), // Rule ID 1754 //
     /*  49959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49998 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50011 */     GIR_RootConstrainSelectedInstOperands,
     /*  50012 */     // GIR_Coverage, 1754,
     /*  50012 */     GIR_EraseRootFromParent_Done,
     /*  50013 */   // Label 761: @50013
     /*  50013 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(50072), // Rule ID 1833 //
     /*  50018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50057 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50070 */     GIR_RootConstrainSelectedInstOperands,
     /*  50071 */     // GIR_Coverage, 1833,
     /*  50071 */     GIR_EraseRootFromParent_Done,
     /*  50072 */   // Label 762: @50072
     /*  50072 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50131), // Rule ID 1832 //
     /*  50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50116 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50129 */     GIR_RootConstrainSelectedInstOperands,
     /*  50130 */     // GIR_Coverage, 1832,
     /*  50130 */     GIR_EraseRootFromParent_Done,
     /*  50131 */   // Label 763: @50131
     /*  50131 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50166), // Rule ID 968 //
     /*  50136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50149 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50157 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50164 */     GIR_RootConstrainSelectedInstOperands,
     /*  50165 */     // GIR_Coverage, 968,
     /*  50165 */     GIR_EraseRootFromParent_Done,
     /*  50166 */   // Label 764: @50166
     /*  50166 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50223), // Rule ID 1730 //
     /*  50171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50206 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50221 */     GIR_RootConstrainSelectedInstOperands,
     /*  50222 */     // GIR_Coverage, 1730,
     /*  50222 */     GIR_EraseRootFromParent_Done,
     /*  50223 */   // Label 765: @50223
     /*  50223 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50280), // Rule ID 1820 //
     /*  50228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50263 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50278 */     GIR_RootConstrainSelectedInstOperands,
     /*  50279 */     // GIR_Coverage, 1820,
     /*  50279 */     GIR_EraseRootFromParent_Done,
     /*  50280 */   // Label 766: @50280
     /*  50280 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50324), // Rule ID 1857 //
     /*  50285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50311 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50322 */     GIR_RootConstrainSelectedInstOperands,
     /*  50323 */     // GIR_Coverage, 1857,
     /*  50323 */     GIR_EraseRootFromParent_Done,
     /*  50324 */   // Label 767: @50324
     /*  50324 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50368), // Rule ID 1760 //
     /*  50329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50355 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50366 */     GIR_RootConstrainSelectedInstOperands,
     /*  50367 */     // GIR_Coverage, 1760,
     /*  50367 */     GIR_EraseRootFromParent_Done,
     /*  50368 */   // Label 768: @50368
     /*  50368 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50412), // Rule ID 1856 //
     /*  50373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50399 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50410 */     GIR_RootConstrainSelectedInstOperands,
     /*  50411 */     // GIR_Coverage, 1856,
     /*  50411 */     GIR_EraseRootFromParent_Done,
     /*  50412 */   // Label 769: @50412
     /*  50412 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50435), // Rule ID 1475 //
     /*  50417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50428 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50433 */     GIR_RootConstrainSelectedInstOperands,
     /*  50434 */     // GIR_Coverage, 1475,
     /*  50434 */     GIR_Done,
     /*  50435 */   // Label 770: @50435
     /*  50435 */   GIM_Reject,
     /*  50436 */ // Label 748: @50436
     /*  50436 */ GIM_Reject,
     /*  50437 */ // Label 590: @50437
     /*  50437 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50511),
     /*  50442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50452 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50487), // Rule ID 966 //
     /*  50457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50478 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50485 */     GIR_RootConstrainSelectedInstOperands,
     /*  50486 */     // GIR_Coverage, 966,
     /*  50486 */     GIR_EraseRootFromParent_Done,
     /*  50487 */   // Label 772: @50487
     /*  50487 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50510), // Rule ID 1473 //
     /*  50492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50503 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50508 */     GIR_RootConstrainSelectedInstOperands,
     /*  50509 */     // GIR_Coverage, 1473,
     /*  50509 */     GIR_Done,
     /*  50510 */   // Label 773: @50510
     /*  50510 */   GIM_Reject,
     /*  50511 */ // Label 771: @50511
     /*  50511 */ GIM_Reject,
     /*  50512 */ // Label 591: @50512
     /*  50512 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50537), // Rule ID 7417 //
     /*  50517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50530 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50535 */   GIR_RootConstrainSelectedInstOperands,
     /*  50536 */   // GIR_Coverage, 7417,
     /*  50536 */   GIR_Done,
     /*  50537 */ // Label 774: @50537
     /*  50537 */ GIM_Reject,
     /*  50538 */ // Label 592: @50538
     /*  50538 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50563), // Rule ID 7416 //
     /*  50543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50556 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50561 */   GIR_RootConstrainSelectedInstOperands,
     /*  50562 */   // GIR_Coverage, 7416,
     /*  50562 */   GIR_Done,
     /*  50563 */ // Label 775: @50563
     /*  50563 */ GIM_Reject,
     /*  50564 */ // Label 593: @50564
     /*  50564 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50589), // Rule ID 7415 //
     /*  50569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50582 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50587 */   GIR_RootConstrainSelectedInstOperands,
     /*  50588 */   // GIR_Coverage, 7415,
     /*  50588 */   GIR_Done,
     /*  50589 */ // Label 776: @50589
     /*  50589 */ GIM_Reject,
     /*  50590 */ // Label 594: @50590
     /*  50590 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50615), // Rule ID 7414 //
     /*  50595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50608 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50613 */   GIR_RootConstrainSelectedInstOperands,
     /*  50614 */   // GIR_Coverage, 7414,
     /*  50614 */   GIR_Done,
     /*  50615 */ // Label 777: @50615
     /*  50615 */ GIM_Reject,
     /*  50616 */ // Label 595: @50616
     /*  50616 */ GIM_Reject,
     /*  50617 */ // Label 2: @50617
     /*  50617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 786*/ GIMT_Encode4(53137),
     /*  50628 */ /*GILLT_s32*//*Label 778*/ GIMT_Encode4(50668),
     /*  50632 */ /*GILLT_s64*//*Label 779*/ GIMT_Encode4(50825), GIMT_Encode4(0),
     /*  50640 */ /*GILLT_v2s32*//*Label 780*/ GIMT_Encode4(52061), GIMT_Encode4(0),
     /*  50648 */ /*GILLT_v4s16*//*Label 781*/ GIMT_Encode4(52399),
     /*  50652 */ /*GILLT_v4s32*//*Label 782*/ GIMT_Encode4(52737),
     /*  50656 */ /*GILLT_v8s8*//*Label 783*/ GIMT_Encode4(52903),
     /*  50660 */ /*GILLT_v8s16*//*Label 784*/ GIMT_Encode4(52937),
     /*  50664 */ /*GILLT_v16s8*//*Label 785*/ GIMT_Encode4(53103),
     /*  50668 */ // Label 778: @50668
     /*  50668 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(50824),
     /*  50673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50683 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(50738), // Rule ID 3955 //
     /*  50688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50719 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50736 */     GIR_RootConstrainSelectedInstOperands,
     /*  50737 */     // GIR_Coverage, 3955,
     /*  50737 */     GIR_EraseRootFromParent_Done,
     /*  50738 */   // Label 788: @50738
     /*  50738 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50793), // Rule ID 13756 //
     /*  50743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50774 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50791 */     GIR_RootConstrainSelectedInstOperands,
     /*  50792 */     // GIR_Coverage, 13756,
     /*  50792 */     GIR_EraseRootFromParent_Done,
     /*  50793 */   // Label 789: @50793
     /*  50793 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50823), // Rule ID 3951 //
     /*  50798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50806 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50821 */     GIR_RootConstrainSelectedInstOperands,
     /*  50822 */     // GIR_Coverage, 3951,
     /*  50822 */     GIR_EraseRootFromParent_Done,
     /*  50823 */   // Label 790: @50823
     /*  50823 */   GIM_Reject,
     /*  50824 */ // Label 787: @50824
     /*  50824 */ GIM_Reject,
     /*  50825 */ // Label 779: @50825
     /*  50825 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(52060),
     /*  50830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50840 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50986), // Rule ID 3960 //
     /*  50845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50866 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50898 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50911 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50911 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50918 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50923 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50984 */     GIR_RootConstrainSelectedInstOperands,
     /*  50985 */     // GIR_Coverage, 3960,
     /*  50985 */     GIR_EraseRootFromParent_Done,
     /*  50986 */   // Label 792: @50986
     /*  50986 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(51090), // Rule ID 3961 //
     /*  50991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51012 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51042 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51088 */     GIR_RootConstrainSelectedInstOperands,
     /*  51089 */     // GIR_Coverage, 3961,
     /*  51089 */     GIR_EraseRootFromParent_Done,
     /*  51090 */   // Label 793: @51090
     /*  51090 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51194), // Rule ID 13759 //
     /*  51095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51133 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51146 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51192 */     GIR_RootConstrainSelectedInstOperands,
     /*  51193 */     // GIR_Coverage, 13759,
     /*  51193 */     GIR_EraseRootFromParent_Done,
     /*  51194 */   // Label 794: @51194
     /*  51194 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51249), // Rule ID 3956 //
     /*  51199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51215 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51230 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51247 */     GIR_RootConstrainSelectedInstOperands,
     /*  51248 */     // GIR_Coverage, 3956,
     /*  51248 */     GIR_EraseRootFromParent_Done,
     /*  51249 */   // Label 795: @51249
     /*  51249 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51304), // Rule ID 13757 //
     /*  51254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51285 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51302 */     GIR_RootConstrainSelectedInstOperands,
     /*  51303 */     // GIR_Coverage, 13757,
     /*  51303 */     GIR_EraseRootFromParent_Done,
     /*  51304 */   // Label 796: @51304
     /*  51304 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51417), // Rule ID 3967 //
     /*  51309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51326 */     // MIs[1] Operand 2
     /*  51326 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51349 */     // MIs[2] Operand 1
     /*  51349 */     // No operand predicates
     /*  51349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51351 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51351 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51354 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51358 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51363 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51382 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51415 */     GIR_RootConstrainSelectedInstOperands,
     /*  51416 */     // GIR_Coverage, 3967,
     /*  51416 */     GIR_EraseRootFromParent_Done,
     /*  51417 */   // Label 797: @51417
     /*  51417 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51492), // Rule ID 3965 //
     /*  51422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51451 */     // MIs[2] Operand 1
     /*  51451 */     // No operand predicates
     /*  51451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51453 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51465 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51490 */     GIR_RootConstrainSelectedInstOperands,
     /*  51491 */     // GIR_Coverage, 3965,
     /*  51491 */     GIR_EraseRootFromParent_Done,
     /*  51492 */   // Label 798: @51492
     /*  51492 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51567), // Rule ID 3966 //
     /*  51497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51526 */     // MIs[2] Operand 1
     /*  51526 */     // No operand predicates
     /*  51526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51528 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51540 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51565 */     GIR_RootConstrainSelectedInstOperands,
     /*  51566 */     // GIR_Coverage, 3966,
     /*  51566 */     GIR_EraseRootFromParent_Done,
     /*  51567 */   // Label 799: @51567
     /*  51567 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51705), // Rule ID 3957 //
     /*  51572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51589 */     // MIs[1] Operand 2
     /*  51589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51617 */     // MIs[2] Operand 2
     /*  51617 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51630 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51642 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51670 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51703 */     GIR_RootConstrainSelectedInstOperands,
     /*  51704 */     // GIR_Coverage, 3957,
     /*  51704 */     GIR_EraseRootFromParent_Done,
     /*  51705 */   // Label 800: @51705
     /*  51705 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51805), // Rule ID 3958 //
     /*  51710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51727 */     // MIs[1] Operand 2
     /*  51727 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51757 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51803 */     GIR_RootConstrainSelectedInstOperands,
     /*  51804 */     // GIR_Coverage, 3958,
     /*  51804 */     GIR_EraseRootFromParent_Done,
     /*  51805 */   // Label 801: @51805
     /*  51805 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51905), // Rule ID 13758 //
     /*  51810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51844 */     // MIs[2] Operand 2
     /*  51844 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51857 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51903 */     GIR_RootConstrainSelectedInstOperands,
     /*  51904 */     // GIR_Coverage, 13758,
     /*  51904 */     GIR_EraseRootFromParent_Done,
     /*  51905 */   // Label 802: @51905
     /*  51905 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51967), // Rule ID 3959 //
     /*  51910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51946 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51965 */     GIR_RootConstrainSelectedInstOperands,
     /*  51966 */     // GIR_Coverage, 3959,
     /*  51966 */     GIR_EraseRootFromParent_Done,
     /*  51967 */   // Label 803: @51967
     /*  51967 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(52029), // Rule ID 3962 //
     /*  51972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52008 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52027 */     GIR_RootConstrainSelectedInstOperands,
     /*  52028 */     // GIR_Coverage, 3962,
     /*  52028 */     GIR_EraseRootFromParent_Done,
     /*  52029 */   // Label 804: @52029
     /*  52029 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(52059), // Rule ID 3952 //
     /*  52034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52042 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52057 */     GIR_RootConstrainSelectedInstOperands,
     /*  52058 */     // GIR_Coverage, 3952,
     /*  52058 */     GIR_EraseRootFromParent_Done,
     /*  52059 */   // Label 805: @52059
     /*  52059 */   GIM_Reject,
     /*  52060 */ // Label 791: @52060
     /*  52060 */ GIM_Reject,
     /*  52061 */ // Label 780: @52061
     /*  52061 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52398),
     /*  52066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52076 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52162), // Rule ID 13450 //
     /*  52081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52125 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52129 */     // MIs[3] Operand 1
     /*  52129 */     // No operand predicates
     /*  52129 */     // MIs[1] Operand 2
     /*  52129 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52146 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52160 */     GIR_RootConstrainSelectedInstOperands,
     /*  52161 */     // GIR_Coverage, 13450,
     /*  52161 */     GIR_EraseRootFromParent_Done,
     /*  52162 */   // Label 807: @52162
     /*  52162 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52248), // Rule ID 2034 //
     /*  52167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52215 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52219 */     // MIs[3] Operand 1
     /*  52219 */     // No operand predicates
     /*  52219 */     // MIs[1] Operand 2
     /*  52219 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52232 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52246 */     GIR_RootConstrainSelectedInstOperands,
     /*  52247 */     // GIR_Coverage, 2034,
     /*  52247 */     GIR_EraseRootFromParent_Done,
     /*  52248 */   // Label 808: @52248
     /*  52248 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52311), // Rule ID 13451 //
     /*  52253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52289 */     // MIs[2] Operand 1
     /*  52289 */     // No operand predicates
     /*  52289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52295 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52309 */     GIR_RootConstrainSelectedInstOperands,
     /*  52310 */     // GIR_Coverage, 13451,
     /*  52310 */     GIR_EraseRootFromParent_Done,
     /*  52311 */   // Label 809: @52311
     /*  52311 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52374), // Rule ID 2035 //
     /*  52316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52356 */     // MIs[2] Operand 1
     /*  52356 */     // No operand predicates
     /*  52356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52358 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52372 */     GIR_RootConstrainSelectedInstOperands,
     /*  52373 */     // GIR_Coverage, 2035,
     /*  52373 */     GIR_EraseRootFromParent_Done,
     /*  52374 */   // Label 810: @52374
     /*  52374 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52397), // Rule ID 1352 //
     /*  52379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52390 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52395 */     GIR_RootConstrainSelectedInstOperands,
     /*  52396 */     // GIR_Coverage, 1352,
     /*  52396 */     GIR_Done,
     /*  52397 */   // Label 811: @52397
     /*  52397 */   GIM_Reject,
     /*  52398 */ // Label 806: @52398
     /*  52398 */ GIM_Reject,
     /*  52399 */ // Label 781: @52399
     /*  52399 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52736),
     /*  52404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52414 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52500), // Rule ID 13447 //
     /*  52419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52463 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52467 */     // MIs[3] Operand 1
     /*  52467 */     // No operand predicates
     /*  52467 */     // MIs[1] Operand 2
     /*  52467 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52484 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52498 */     GIR_RootConstrainSelectedInstOperands,
     /*  52499 */     // GIR_Coverage, 13447,
     /*  52499 */     GIR_EraseRootFromParent_Done,
     /*  52500 */   // Label 813: @52500
     /*  52500 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52586), // Rule ID 2031 //
     /*  52505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52553 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52557 */     // MIs[3] Operand 1
     /*  52557 */     // No operand predicates
     /*  52557 */     // MIs[1] Operand 2
     /*  52557 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52570 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52584 */     GIR_RootConstrainSelectedInstOperands,
     /*  52585 */     // GIR_Coverage, 2031,
     /*  52585 */     GIR_EraseRootFromParent_Done,
     /*  52586 */   // Label 814: @52586
     /*  52586 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52649), // Rule ID 13448 //
     /*  52591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52623 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52627 */     // MIs[2] Operand 1
     /*  52627 */     // No operand predicates
     /*  52627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52633 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52647 */     GIR_RootConstrainSelectedInstOperands,
     /*  52648 */     // GIR_Coverage, 13448,
     /*  52648 */     GIR_EraseRootFromParent_Done,
     /*  52649 */   // Label 815: @52649
     /*  52649 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52712), // Rule ID 2032 //
     /*  52654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52694 */     // MIs[2] Operand 1
     /*  52694 */     // No operand predicates
     /*  52694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52696 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52710 */     GIR_RootConstrainSelectedInstOperands,
     /*  52711 */     // GIR_Coverage, 2032,
     /*  52711 */     GIR_EraseRootFromParent_Done,
     /*  52712 */   // Label 816: @52712
     /*  52712 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52735), // Rule ID 1350 //
     /*  52717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52728 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52733 */     GIR_RootConstrainSelectedInstOperands,
     /*  52734 */     // GIR_Coverage, 1350,
     /*  52734 */     GIR_Done,
     /*  52735 */   // Label 817: @52735
     /*  52735 */   GIM_Reject,
     /*  52736 */ // Label 812: @52736
     /*  52736 */ GIM_Reject,
     /*  52737 */ // Label 782: @52737
     /*  52737 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52902),
     /*  52742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52752 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52815), // Rule ID 13452 //
     /*  52757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52789 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52793 */     // MIs[2] Operand 1
     /*  52793 */     // No operand predicates
     /*  52793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52799 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52813 */     GIR_RootConstrainSelectedInstOperands,
     /*  52814 */     // GIR_Coverage, 13452,
     /*  52814 */     GIR_EraseRootFromParent_Done,
     /*  52815 */   // Label 819: @52815
     /*  52815 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52878), // Rule ID 2036 //
     /*  52820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52860 */     // MIs[2] Operand 1
     /*  52860 */     // No operand predicates
     /*  52860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52862 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52876 */     GIR_RootConstrainSelectedInstOperands,
     /*  52877 */     // GIR_Coverage, 2036,
     /*  52877 */     GIR_EraseRootFromParent_Done,
     /*  52878 */   // Label 820: @52878
     /*  52878 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52901), // Rule ID 1353 //
     /*  52883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52894 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52899 */     GIR_RootConstrainSelectedInstOperands,
     /*  52900 */     // GIR_Coverage, 1353,
     /*  52900 */     GIR_Done,
     /*  52901 */   // Label 821: @52901
     /*  52901 */   GIM_Reject,
     /*  52902 */ // Label 818: @52902
     /*  52902 */ GIM_Reject,
     /*  52903 */ // Label 783: @52903
     /*  52903 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52936), // Rule ID 1348 //
     /*  52908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52929 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52934 */   GIR_RootConstrainSelectedInstOperands,
     /*  52935 */   // GIR_Coverage, 1348,
     /*  52935 */   GIR_Done,
     /*  52936 */ // Label 822: @52936
     /*  52936 */ GIM_Reject,
     /*  52937 */ // Label 784: @52937
     /*  52937 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(53102),
     /*  52942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52952 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(53015), // Rule ID 13449 //
     /*  52957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52993 */     // MIs[2] Operand 1
     /*  52993 */     // No operand predicates
     /*  52993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52999 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53013 */     GIR_RootConstrainSelectedInstOperands,
     /*  53014 */     // GIR_Coverage, 13449,
     /*  53014 */     GIR_EraseRootFromParent_Done,
     /*  53015 */   // Label 824: @53015
     /*  53015 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53078), // Rule ID 2033 //
     /*  53020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53060 */     // MIs[2] Operand 1
     /*  53060 */     // No operand predicates
     /*  53060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53062 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53076 */     GIR_RootConstrainSelectedInstOperands,
     /*  53077 */     // GIR_Coverage, 2033,
     /*  53077 */     GIR_EraseRootFromParent_Done,
     /*  53078 */   // Label 825: @53078
     /*  53078 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53101), // Rule ID 1351 //
     /*  53083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53094 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53099 */     GIR_RootConstrainSelectedInstOperands,
     /*  53100 */     // GIR_Coverage, 1351,
     /*  53100 */     GIR_Done,
     /*  53101 */   // Label 826: @53101
     /*  53101 */   GIM_Reject,
     /*  53102 */ // Label 823: @53102
     /*  53102 */ GIM_Reject,
     /*  53103 */ // Label 785: @53103
     /*  53103 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53136), // Rule ID 1349 //
     /*  53108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53129 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53134 */   GIR_RootConstrainSelectedInstOperands,
     /*  53135 */   // GIR_Coverage, 1349,
     /*  53135 */   GIR_Done,
     /*  53136 */ // Label 827: @53136
     /*  53136 */ GIM_Reject,
     /*  53137 */ // Label 786: @53137
     /*  53137 */ GIM_Reject,
     /*  53138 */ // Label 3: @53138
     /*  53138 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 830*/ GIMT_Encode4(53219),
     /*  53149 */ /*GILLT_s32*//*Label 828*/ GIMT_Encode4(53157),
     /*  53153 */ /*GILLT_s64*//*Label 829*/ GIMT_Encode4(53188),
     /*  53157 */ // Label 828: @53157
     /*  53157 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(53187), // Rule ID 117 //
     /*  53162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53180 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53185 */   GIR_RootConstrainSelectedInstOperands,
     /*  53186 */   // GIR_Coverage, 117,
     /*  53186 */   GIR_Done,
     /*  53187 */ // Label 831: @53187
     /*  53187 */ GIM_Reject,
     /*  53188 */ // Label 829: @53188
     /*  53188 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(53218), // Rule ID 118 //
     /*  53193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53211 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53216 */   GIR_RootConstrainSelectedInstOperands,
     /*  53217 */   // GIR_Coverage, 118,
     /*  53217 */   GIR_Done,
     /*  53218 */ // Label 832: @53218
     /*  53218 */ GIM_Reject,
     /*  53219 */ // Label 830: @53219
     /*  53219 */ GIM_Reject,
     /*  53220 */ // Label 4: @53220
     /*  53220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 835*/ GIMT_Encode4(53301),
     /*  53231 */ /*GILLT_s32*//*Label 833*/ GIMT_Encode4(53239),
     /*  53235 */ /*GILLT_s64*//*Label 834*/ GIMT_Encode4(53270),
     /*  53239 */ // Label 833: @53239
     /*  53239 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(53269), // Rule ID 115 //
     /*  53244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53262 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53267 */   GIR_RootConstrainSelectedInstOperands,
     /*  53268 */   // GIR_Coverage, 115,
     /*  53268 */   GIR_Done,
     /*  53269 */ // Label 836: @53269
     /*  53269 */ GIM_Reject,
     /*  53270 */ // Label 834: @53270
     /*  53270 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(53300), // Rule ID 116 //
     /*  53275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53293 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53298 */   GIR_RootConstrainSelectedInstOperands,
     /*  53299 */   // GIR_Coverage, 116,
     /*  53299 */   GIR_Done,
     /*  53300 */ // Label 837: @53300
     /*  53300 */ GIM_Reject,
     /*  53301 */ // Label 835: @53301
     /*  53301 */ GIM_Reject,
     /*  53302 */ // Label 5: @53302
     /*  53302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 856*/ GIMT_Encode4(61047),
     /*  53313 */ /*GILLT_s32*//*Label 838*/ GIMT_Encode4(53401),
     /*  53317 */ /*GILLT_s64*//*Label 839*/ GIMT_Encode4(53899), GIMT_Encode4(0),
     /*  53325 */ /*GILLT_v2s32*//*Label 840*/ GIMT_Encode4(55334),
     /*  53329 */ /*GILLT_v2s64*//*Label 841*/ GIMT_Encode4(55494),
     /*  53333 */ /*GILLT_v4s16*//*Label 842*/ GIMT_Encode4(55654),
     /*  53337 */ /*GILLT_v4s32*//*Label 843*/ GIMT_Encode4(55814),
     /*  53341 */ /*GILLT_v8s8*//*Label 844*/ GIMT_Encode4(55974),
     /*  53345 */ /*GILLT_v8s16*//*Label 845*/ GIMT_Encode4(56134),
     /*  53349 */ /*GILLT_v16s8*//*Label 846*/ GIMT_Encode4(56294),
     /*  53353 */ /*GILLT_nxv1s1*//*Label 847*/ GIMT_Encode4(56454),
     /*  53357 */ /*GILLT_nxv2s1*//*Label 848*/ GIMT_Encode4(56995), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53369 */ /*GILLT_nxv2s64*//*Label 849*/ GIMT_Encode4(57536),
     /*  53373 */ /*GILLT_nxv4s1*//*Label 850*/ GIMT_Encode4(58008), GIMT_Encode4(0),
     /*  53381 */ /*GILLT_nxv4s32*//*Label 851*/ GIMT_Encode4(58549),
     /*  53385 */ /*GILLT_nxv8s1*//*Label 852*/ GIMT_Encode4(59021),
     /*  53389 */ /*GILLT_nxv8s16*//*Label 853*/ GIMT_Encode4(59562),
     /*  53393 */ /*GILLT_nxv16s1*//*Label 854*/ GIMT_Encode4(60034),
     /*  53397 */ /*GILLT_nxv16s8*//*Label 855*/ GIMT_Encode4(60575),
     /*  53401 */ // Label 838: @53401
     /*  53401 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53898),
     /*  53406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53412 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53467), // Rule ID 13209 //
     /*  53417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53437 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53454 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53465 */     GIR_RootConstrainSelectedInstOperands,
     /*  53466 */     // GIR_Coverage, 13209,
     /*  53466 */     GIR_EraseRootFromParent_Done,
     /*  53467 */   // Label 858: @53467
     /*  53467 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53522), // Rule ID 162 //
     /*  53472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53496 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53509 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53520 */     GIR_RootConstrainSelectedInstOperands,
     /*  53521 */     // GIR_Coverage, 162,
     /*  53521 */     GIR_EraseRootFromParent_Done,
     /*  53522 */   // Label 859: @53522
     /*  53522 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53591), // Rule ID 5660 //
     /*  53527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53564 */     // MIs[2] Operand 1
     /*  53564 */     // No operand predicates
     /*  53564 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53577 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53589 */     GIR_RootConstrainSelectedInstOperands,
     /*  53590 */     // GIR_Coverage, 5660,
     /*  53590 */     GIR_EraseRootFromParent_Done,
     /*  53591 */   // Label 860: @53591
     /*  53591 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53660), // Rule ID 5661 //
     /*  53596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53633 */     // MIs[2] Operand 1
     /*  53633 */     // No operand predicates
     /*  53633 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53646 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53658 */     GIR_RootConstrainSelectedInstOperands,
     /*  53659 */     // GIR_Coverage, 5661,
     /*  53659 */     GIR_EraseRootFromParent_Done,
     /*  53660 */   // Label 861: @53660
     /*  53660 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53713), // Rule ID 13207 //
     /*  53665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53690 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53700 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53711 */     GIR_RootConstrainSelectedInstOperands,
     /*  53712 */     // GIR_Coverage, 13207,
     /*  53712 */     GIR_EraseRootFromParent_Done,
     /*  53713 */   // Label 862: @53713
     /*  53713 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53766), // Rule ID 160 //
     /*  53718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53753 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53764 */     GIR_RootConstrainSelectedInstOperands,
     /*  53765 */     // GIR_Coverage, 160,
     /*  53765 */     GIR_EraseRootFromParent_Done,
     /*  53766 */   // Label 863: @53766
     /*  53766 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53807), // Rule ID 142 //
     /*  53771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53787 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53791 */     // MIs[1] Operand 1
     /*  53791 */     // No operand predicates
     /*  53791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53793 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53800 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 142,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 864: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53840), // Rule ID 13205 //
     /*  53812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53827 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53838 */     GIR_RootConstrainSelectedInstOperands,
     /*  53839 */     // GIR_Coverage, 13205,
     /*  53839 */     GIR_EraseRootFromParent_Done,
     /*  53840 */   // Label 865: @53840
     /*  53840 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53873), // Rule ID 158 //
     /*  53845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53860 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53871 */     GIR_RootConstrainSelectedInstOperands,
     /*  53872 */     // GIR_Coverage, 158,
     /*  53872 */     GIR_EraseRootFromParent_Done,
     /*  53873 */   // Label 866: @53873
     /*  53873 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53897), // Rule ID 156 //
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53890 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53895 */     GIR_RootConstrainSelectedInstOperands,
     /*  53896 */     // GIR_Coverage, 156,
     /*  53896 */     GIR_Done,
     /*  53897 */   // Label 867: @53897
     /*  53897 */   GIM_Reject,
     /*  53898 */ // Label 857: @53898
     /*  53898 */ GIM_Reject,
     /*  53899 */ // Label 839: @53899
     /*  53899 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(55333),
     /*  53904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53965), // Rule ID 13210 //
     /*  53915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53952 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53963 */     GIR_RootConstrainSelectedInstOperands,
     /*  53964 */     // GIR_Coverage, 13210,
     /*  53964 */     GIR_EraseRootFromParent_Done,
     /*  53965 */   // Label 869: @53965
     /*  53965 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54020), // Rule ID 163 //
     /*  53970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54007 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54018 */     GIR_RootConstrainSelectedInstOperands,
     /*  54019 */     // GIR_Coverage, 163,
     /*  54019 */     GIR_EraseRootFromParent_Done,
     /*  54020 */   // Label 870: @54020
     /*  54020 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54133), // Rule ID 5662 //
     /*  54025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54074 */     // MIs[3] Operand 1
     /*  54074 */     // No operand predicates
     /*  54074 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54087 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54132 */     // GIR_Coverage, 5662,
     /*  54132 */     GIR_EraseRootFromParent_Done,
     /*  54133 */   // Label 871: @54133
     /*  54133 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54246), // Rule ID 5663 //
     /*  54138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54183 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54187 */     // MIs[3] Operand 1
     /*  54187 */     // No operand predicates
     /*  54187 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54200 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54245 */     // GIR_Coverage, 5663,
     /*  54245 */     GIR_EraseRootFromParent_Done,
     /*  54246 */   // Label 872: @54246
     /*  54246 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54345), // Rule ID 7096 //
     /*  54251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54263 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54266 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54271 */     // MIs[1] addr
     /*  54271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54280 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54284 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54297 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54313 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54344 */     // GIR_Coverage, 7096,
     /*  54344 */     GIR_EraseRootFromParent_Done,
     /*  54345 */   // Label 873: @54345
     /*  54345 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54444), // Rule ID 7097 //
     /*  54350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54370 */     // MIs[1] addr
     /*  54370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54379 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54383 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54396 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54443 */     // GIR_Coverage, 7097,
     /*  54443 */     GIR_EraseRootFromParent_Done,
     /*  54444 */   // Label 874: @54444
     /*  54444 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54543), // Rule ID 7098 //
     /*  54449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54469 */     // MIs[1] addr
     /*  54469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54478 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54482 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54495 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54511 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54542 */     // GIR_Coverage, 7098,
     /*  54542 */     GIR_EraseRootFromParent_Done,
     /*  54543 */   // Label 875: @54543
     /*  54543 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54642), // Rule ID 7103 //
     /*  54548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54560 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54563 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54568 */     // MIs[1] addr
     /*  54568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54577 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54581 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54594 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54610 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54641 */     // GIR_Coverage, 7103,
     /*  54641 */     GIR_EraseRootFromParent_Done,
     /*  54642 */   // Label 876: @54642
     /*  54642 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54741), // Rule ID 7104 //
     /*  54647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54659 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54662 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54667 */     // MIs[1] addr
     /*  54667 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54676 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54680 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54693 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54709 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54740 */     // GIR_Coverage, 7104,
     /*  54740 */     GIR_EraseRootFromParent_Done,
     /*  54741 */   // Label 877: @54741
     /*  54741 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54840), // Rule ID 7105 //
     /*  54746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54758 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54761 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54766 */     // MIs[1] addr
     /*  54766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54775 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54779 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54792 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54808 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54839 */     // GIR_Coverage, 7105,
     /*  54839 */     GIR_EraseRootFromParent_Done,
     /*  54840 */   // Label 878: @54840
     /*  54840 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54893), // Rule ID 13208 //
     /*  54845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54870 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54880 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54891 */     GIR_RootConstrainSelectedInstOperands,
     /*  54892 */     // GIR_Coverage, 13208,
     /*  54892 */     GIR_EraseRootFromParent_Done,
     /*  54893 */   // Label 879: @54893
     /*  54893 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54946), // Rule ID 161 //
     /*  54898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54933 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54944 */     GIR_RootConstrainSelectedInstOperands,
     /*  54945 */     // GIR_Coverage, 161,
     /*  54945 */     GIR_EraseRootFromParent_Done,
     /*  54946 */   // Label 880: @54946
     /*  54946 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55046), // Rule ID 4004 //
     /*  54951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54959 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54970 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54982 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55010 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55045 */     // GIR_Coverage, 4004,
     /*  55045 */     GIR_EraseRootFromParent_Done,
     /*  55046 */   // Label 881: @55046
     /*  55046 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55087), // Rule ID 143 //
     /*  55051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55067 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55071 */     // MIs[1] Operand 1
     /*  55071 */     // No operand predicates
     /*  55071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55073 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55080 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55085 */     GIR_RootConstrainSelectedInstOperands,
     /*  55086 */     // GIR_Coverage, 143,
     /*  55086 */     GIR_EraseRootFromParent_Done,
     /*  55087 */   // Label 882: @55087
     /*  55087 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55120), // Rule ID 13206 //
     /*  55092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55107 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55118 */     GIR_RootConstrainSelectedInstOperands,
     /*  55119 */     // GIR_Coverage, 13206,
     /*  55119 */     GIR_EraseRootFromParent_Done,
     /*  55120 */   // Label 883: @55120
     /*  55120 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55153), // Rule ID 159 //
     /*  55125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55140 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55151 */     GIR_RootConstrainSelectedInstOperands,
     /*  55152 */     // GIR_Coverage, 159,
     /*  55152 */     GIR_EraseRootFromParent_Done,
     /*  55153 */   // Label 884: @55153
     /*  55153 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55217), // Rule ID 13864 //
     /*  55158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55190 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55204 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55209 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55215 */     GIR_RootConstrainSelectedInstOperands,
     /*  55216 */     // GIR_Coverage, 13864,
     /*  55216 */     GIR_EraseRootFromParent_Done,
     /*  55217 */   // Label 885: @55217
     /*  55217 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55281), // Rule ID 5044 //
     /*  55222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55258 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55264 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55268 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55273 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55279 */     GIR_RootConstrainSelectedInstOperands,
     /*  55280 */     // GIR_Coverage, 5044,
     /*  55280 */     GIR_EraseRootFromParent_Done,
     /*  55281 */   // Label 886: @55281
     /*  55281 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55305), // Rule ID 157 //
     /*  55286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55298 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55303 */     GIR_RootConstrainSelectedInstOperands,
     /*  55304 */     // GIR_Coverage, 157,
     /*  55304 */     GIR_Done,
     /*  55305 */   // Label 887: @55305
     /*  55305 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55332), // Rule ID 2484 //
     /*  55310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55325 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55330 */     GIR_RootConstrainSelectedInstOperands,
     /*  55331 */     // GIR_Coverage, 2484,
     /*  55331 */     GIR_Done,
     /*  55332 */   // Label 888: @55332
     /*  55332 */   GIM_Reject,
     /*  55333 */ // Label 868: @55333
     /*  55333 */ GIM_Reject,
     /*  55334 */ // Label 840: @55334
     /*  55334 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55493),
     /*  55339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55349 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55409), // Rule ID 13863 //
     /*  55354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55382 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55388 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55396 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55401 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55407 */     GIR_RootConstrainSelectedInstOperands,
     /*  55408 */     // GIR_Coverage, 13863,
     /*  55408 */     GIR_EraseRootFromParent_Done,
     /*  55409 */   // Label 890: @55409
     /*  55409 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55469), // Rule ID 5043 //
     /*  55414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55446 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55452 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55456 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55461 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55467 */     GIR_RootConstrainSelectedInstOperands,
     /*  55468 */     // GIR_Coverage, 5043,
     /*  55468 */     GIR_EraseRootFromParent_Done,
     /*  55469 */   // Label 891: @55469
     /*  55469 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55492), // Rule ID 2483 //
     /*  55474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55485 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55490 */     GIR_RootConstrainSelectedInstOperands,
     /*  55491 */     // GIR_Coverage, 2483,
     /*  55491 */     GIR_Done,
     /*  55492 */   // Label 892: @55492
     /*  55492 */   GIM_Reject,
     /*  55493 */ // Label 889: @55493
     /*  55493 */ GIM_Reject,
     /*  55494 */ // Label 841: @55494
     /*  55494 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55653),
     /*  55499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55509 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55569), // Rule ID 13867 //
     /*  55514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55542 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55556 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55561 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55567 */     GIR_RootConstrainSelectedInstOperands,
     /*  55568 */     // GIR_Coverage, 13867,
     /*  55568 */     GIR_EraseRootFromParent_Done,
     /*  55569 */   // Label 894: @55569
     /*  55569 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55629), // Rule ID 5047 //
     /*  55574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55606 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55616 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55621 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55627 */     GIR_RootConstrainSelectedInstOperands,
     /*  55628 */     // GIR_Coverage, 5047,
     /*  55628 */     GIR_EraseRootFromParent_Done,
     /*  55629 */   // Label 895: @55629
     /*  55629 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55652), // Rule ID 2487 //
     /*  55634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55645 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55650 */     GIR_RootConstrainSelectedInstOperands,
     /*  55651 */     // GIR_Coverage, 2487,
     /*  55651 */     GIR_Done,
     /*  55652 */   // Label 896: @55652
     /*  55652 */   GIM_Reject,
     /*  55653 */ // Label 893: @55653
     /*  55653 */ GIM_Reject,
     /*  55654 */ // Label 842: @55654
     /*  55654 */ GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55813),
     /*  55659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55669 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55729), // Rule ID 13862 //
     /*  55674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55702 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55716 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55721 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55727 */     GIR_RootConstrainSelectedInstOperands,
     /*  55728 */     // GIR_Coverage, 13862,
     /*  55728 */     GIR_EraseRootFromParent_Done,
     /*  55729 */   // Label 898: @55729
     /*  55729 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55789), // Rule ID 5042 //
     /*  55734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55766 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55776 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55781 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55787 */     GIR_RootConstrainSelectedInstOperands,
     /*  55788 */     // GIR_Coverage, 5042,
     /*  55788 */     GIR_EraseRootFromParent_Done,
     /*  55789 */   // Label 899: @55789
     /*  55789 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55812), // Rule ID 2482 //
     /*  55794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55805 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55810 */     GIR_RootConstrainSelectedInstOperands,
     /*  55811 */     // GIR_Coverage, 2482,
     /*  55811 */     GIR_Done,
     /*  55812 */   // Label 900: @55812
     /*  55812 */   GIM_Reject,
     /*  55813 */ // Label 897: @55813
     /*  55813 */ GIM_Reject,
     /*  55814 */ // Label 843: @55814
     /*  55814 */ GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55973),
     /*  55819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55829 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55889), // Rule ID 13866 //
     /*  55834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55862 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55868 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55876 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55881 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55887 */     GIR_RootConstrainSelectedInstOperands,
     /*  55888 */     // GIR_Coverage, 13866,
     /*  55888 */     GIR_EraseRootFromParent_Done,
     /*  55889 */   // Label 902: @55889
     /*  55889 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55949), // Rule ID 5046 //
     /*  55894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55926 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55936 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55941 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55947 */     GIR_RootConstrainSelectedInstOperands,
     /*  55948 */     // GIR_Coverage, 5046,
     /*  55948 */     GIR_EraseRootFromParent_Done,
     /*  55949 */   // Label 903: @55949
     /*  55949 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55972), // Rule ID 2486 //
     /*  55954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55965 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55970 */     GIR_RootConstrainSelectedInstOperands,
     /*  55971 */     // GIR_Coverage, 2486,
     /*  55971 */     GIR_Done,
     /*  55972 */   // Label 904: @55972
     /*  55972 */   GIM_Reject,
     /*  55973 */ // Label 901: @55973
     /*  55973 */ GIM_Reject,
     /*  55974 */ // Label 844: @55974
     /*  55974 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56133),
     /*  55979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55989 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56049), // Rule ID 13345 //
     /*  55994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56022 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56036 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56047 */     GIR_RootConstrainSelectedInstOperands,
     /*  56048 */     // GIR_Coverage, 13345,
     /*  56048 */     GIR_EraseRootFromParent_Done,
     /*  56049 */   // Label 906: @56049
     /*  56049 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56109), // Rule ID 1597 //
     /*  56054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56086 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56096 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56107 */     GIR_RootConstrainSelectedInstOperands,
     /*  56108 */     // GIR_Coverage, 1597,
     /*  56108 */     GIR_EraseRootFromParent_Done,
     /*  56109 */   // Label 907: @56109
     /*  56109 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56132), // Rule ID 1595 //
     /*  56114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56125 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56130 */     GIR_RootConstrainSelectedInstOperands,
     /*  56131 */     // GIR_Coverage, 1595,
     /*  56131 */     GIR_Done,
     /*  56132 */   // Label 908: @56132
     /*  56132 */   GIM_Reject,
     /*  56133 */ // Label 905: @56133
     /*  56133 */ GIM_Reject,
     /*  56134 */ // Label 845: @56134
     /*  56134 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56293),
     /*  56139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56149 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56209), // Rule ID 13865 //
     /*  56154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56182 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56196 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56201 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56207 */     GIR_RootConstrainSelectedInstOperands,
     /*  56208 */     // GIR_Coverage, 13865,
     /*  56208 */     GIR_EraseRootFromParent_Done,
     /*  56209 */   // Label 910: @56209
     /*  56209 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56269), // Rule ID 5045 //
     /*  56214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56256 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56261 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56267 */     GIR_RootConstrainSelectedInstOperands,
     /*  56268 */     // GIR_Coverage, 5045,
     /*  56268 */     GIR_EraseRootFromParent_Done,
     /*  56269 */   // Label 911: @56269
     /*  56269 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56292), // Rule ID 2485 //
     /*  56274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56285 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56290 */     GIR_RootConstrainSelectedInstOperands,
     /*  56291 */     // GIR_Coverage, 2485,
     /*  56291 */     GIR_Done,
     /*  56292 */   // Label 912: @56292
     /*  56292 */   GIM_Reject,
     /*  56293 */ // Label 909: @56293
     /*  56293 */ GIM_Reject,
     /*  56294 */ // Label 846: @56294
     /*  56294 */ GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56453),
     /*  56299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56309 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56369), // Rule ID 13346 //
     /*  56314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56342 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56356 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56367 */     GIR_RootConstrainSelectedInstOperands,
     /*  56368 */     // GIR_Coverage, 13346,
     /*  56368 */     GIR_EraseRootFromParent_Done,
     /*  56369 */   // Label 914: @56369
     /*  56369 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56429), // Rule ID 1598 //
     /*  56374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56416 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56427 */     GIR_RootConstrainSelectedInstOperands,
     /*  56428 */     // GIR_Coverage, 1598,
     /*  56428 */     GIR_EraseRootFromParent_Done,
     /*  56429 */   // Label 915: @56429
     /*  56429 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56452), // Rule ID 1596 //
     /*  56434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56445 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56450 */     GIR_RootConstrainSelectedInstOperands,
     /*  56451 */     // GIR_Coverage, 1596,
     /*  56451 */     GIR_Done,
     /*  56452 */   // Label 916: @56452
     /*  56452 */   GIM_Reject,
     /*  56453 */ // Label 913: @56453
     /*  56453 */ GIM_Reject,
     /*  56454 */ // Label 847: @56454
     /*  56454 */ GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56994),
     /*  56459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56469 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56526), // Rule ID 15059 //
     /*  56474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56505 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56511 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56524 */     GIR_RootConstrainSelectedInstOperands,
     /*  56525 */     // GIR_Coverage, 15059,
     /*  56525 */     GIR_EraseRootFromParent_Done,
     /*  56526 */   // Label 918: @56526
     /*  56526 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(56583), // Rule ID 15062 //
     /*  56531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56562 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56568 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56581 */     GIR_RootConstrainSelectedInstOperands,
     /*  56582 */     // GIR_Coverage, 15062,
     /*  56582 */     GIR_EraseRootFromParent_Done,
     /*  56583 */   // Label 919: @56583
     /*  56583 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56640), // Rule ID 15058 //
     /*  56588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56619 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56625 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56638 */     GIR_RootConstrainSelectedInstOperands,
     /*  56639 */     // GIR_Coverage, 15058,
     /*  56639 */     GIR_EraseRootFromParent_Done,
     /*  56640 */   // Label 920: @56640
     /*  56640 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56697), // Rule ID 15061 //
     /*  56645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56682 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56695 */     GIR_RootConstrainSelectedInstOperands,
     /*  56696 */     // GIR_Coverage, 15061,
     /*  56696 */     GIR_EraseRootFromParent_Done,
     /*  56697 */   // Label 921: @56697
     /*  56697 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56754), // Rule ID 15057 //
     /*  56702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56733 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56739 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56752 */     GIR_RootConstrainSelectedInstOperands,
     /*  56753 */     // GIR_Coverage, 15057,
     /*  56753 */     GIR_EraseRootFromParent_Done,
     /*  56754 */   // Label 922: @56754
     /*  56754 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56811), // Rule ID 15060 //
     /*  56759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56796 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56809 */     GIR_RootConstrainSelectedInstOperands,
     /*  56810 */     // GIR_Coverage, 15060,
     /*  56810 */     GIR_EraseRootFromParent_Done,
     /*  56811 */   // Label 923: @56811
     /*  56811 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56868), // Rule ID 8409 //
     /*  56816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56847 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56853 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56866 */     GIR_RootConstrainSelectedInstOperands,
     /*  56867 */     // GIR_Coverage, 8409,
     /*  56867 */     GIR_EraseRootFromParent_Done,
     /*  56868 */   // Label 924: @56868
     /*  56868 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56925), // Rule ID 8410 //
     /*  56873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56910 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56923 */     GIR_RootConstrainSelectedInstOperands,
     /*  56924 */     // GIR_Coverage, 8410,
     /*  56924 */     GIR_EraseRootFromParent_Done,
     /*  56925 */   // Label 925: @56925
     /*  56925 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56972), // Rule ID 10673 //
     /*  56930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56941 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56953 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56970 */     GIR_RootConstrainSelectedInstOperands,
     /*  56971 */     // GIR_Coverage, 10673,
     /*  56971 */     GIR_EraseRootFromParent_Done,
     /*  56972 */   // Label 926: @56972
     /*  56972 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56993), // Rule ID 2753 //
     /*  56977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56980 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56991 */     GIR_RootConstrainSelectedInstOperands,
     /*  56992 */     // GIR_Coverage, 2753,
     /*  56992 */     GIR_EraseRootFromParent_Done,
     /*  56993 */   // Label 927: @56993
     /*  56993 */   GIM_Reject,
     /*  56994 */ // Label 917: @56994
     /*  56994 */ GIM_Reject,
     /*  56995 */ // Label 848: @56995
     /*  56995 */ GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(57535),
     /*  57000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57010 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57067), // Rule ID 15050 //
     /*  57015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57046 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57052 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57065 */     GIR_RootConstrainSelectedInstOperands,
     /*  57066 */     // GIR_Coverage, 15050,
     /*  57066 */     GIR_EraseRootFromParent_Done,
     /*  57067 */   // Label 929: @57067
     /*  57067 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57124), // Rule ID 15053 //
     /*  57072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57103 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57109 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57122 */     GIR_RootConstrainSelectedInstOperands,
     /*  57123 */     // GIR_Coverage, 15053,
     /*  57123 */     GIR_EraseRootFromParent_Done,
     /*  57124 */   // Label 930: @57124
     /*  57124 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57181), // Rule ID 15049 //
     /*  57129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57160 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57166 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57179 */     GIR_RootConstrainSelectedInstOperands,
     /*  57180 */     // GIR_Coverage, 15049,
     /*  57180 */     GIR_EraseRootFromParent_Done,
     /*  57181 */   // Label 931: @57181
     /*  57181 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57238), // Rule ID 15052 //
     /*  57186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57223 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57236 */     GIR_RootConstrainSelectedInstOperands,
     /*  57237 */     // GIR_Coverage, 15052,
     /*  57237 */     GIR_EraseRootFromParent_Done,
     /*  57238 */   // Label 932: @57238
     /*  57238 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57295), // Rule ID 15048 //
     /*  57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57280 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57293 */     GIR_RootConstrainSelectedInstOperands,
     /*  57294 */     // GIR_Coverage, 15048,
     /*  57294 */     GIR_EraseRootFromParent_Done,
     /*  57295 */   // Label 933: @57295
     /*  57295 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57352), // Rule ID 15051 //
     /*  57300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57331 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57337 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57350 */     GIR_RootConstrainSelectedInstOperands,
     /*  57351 */     // GIR_Coverage, 15051,
     /*  57351 */     GIR_EraseRootFromParent_Done,
     /*  57352 */   // Label 934: @57352
     /*  57352 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57409), // Rule ID 8405 //
     /*  57357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57388 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57394 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57407 */     GIR_RootConstrainSelectedInstOperands,
     /*  57408 */     // GIR_Coverage, 8405,
     /*  57408 */     GIR_EraseRootFromParent_Done,
     /*  57409 */   // Label 935: @57409
     /*  57409 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57466), // Rule ID 8406 //
     /*  57414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57451 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57464 */     GIR_RootConstrainSelectedInstOperands,
     /*  57465 */     // GIR_Coverage, 8406,
     /*  57465 */     GIR_EraseRootFromParent_Done,
     /*  57466 */   // Label 936: @57466
     /*  57466 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57513), // Rule ID 10672 //
     /*  57471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57482 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57511 */     GIR_RootConstrainSelectedInstOperands,
     /*  57512 */     // GIR_Coverage, 10672,
     /*  57512 */     GIR_EraseRootFromParent_Done,
     /*  57513 */   // Label 937: @57513
     /*  57513 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57534), // Rule ID 2752 //
     /*  57518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57521 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57532 */     GIR_RootConstrainSelectedInstOperands,
     /*  57533 */     // GIR_Coverage, 2752,
     /*  57533 */     GIR_EraseRootFromParent_Done,
     /*  57534 */   // Label 938: @57534
     /*  57534 */   GIM_Reject,
     /*  57535 */ // Label 928: @57535
     /*  57535 */ GIM_Reject,
     /*  57536 */ // Label 849: @57536
     /*  57536 */ GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(58007),
     /*  57541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57551 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57606), // Rule ID 14990 //
     /*  57556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57587 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57593 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57604 */     GIR_RootConstrainSelectedInstOperands,
     /*  57605 */     // GIR_Coverage, 14990,
     /*  57605 */     GIR_EraseRootFromParent_Done,
     /*  57606 */   // Label 940: @57606
     /*  57606 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57661), // Rule ID 14993 //
     /*  57611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57648 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57659 */     GIR_RootConstrainSelectedInstOperands,
     /*  57660 */     // GIR_Coverage, 14993,
     /*  57660 */     GIR_EraseRootFromParent_Done,
     /*  57661 */   // Label 941: @57661
     /*  57661 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57716), // Rule ID 14989 //
     /*  57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57703 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57714 */     GIR_RootConstrainSelectedInstOperands,
     /*  57715 */     // GIR_Coverage, 14989,
     /*  57715 */     GIR_EraseRootFromParent_Done,
     /*  57716 */   // Label 942: @57716
     /*  57716 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57771), // Rule ID 14992 //
     /*  57721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57758 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57769 */     GIR_RootConstrainSelectedInstOperands,
     /*  57770 */     // GIR_Coverage, 14992,
     /*  57770 */     GIR_EraseRootFromParent_Done,
     /*  57771 */   // Label 943: @57771
     /*  57771 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57826), // Rule ID 14988 //
     /*  57776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57813 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57824 */     GIR_RootConstrainSelectedInstOperands,
     /*  57825 */     // GIR_Coverage, 14988,
     /*  57825 */     GIR_EraseRootFromParent_Done,
     /*  57826 */   // Label 944: @57826
     /*  57826 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57881), // Rule ID 14991 //
     /*  57831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57868 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57879 */     GIR_RootConstrainSelectedInstOperands,
     /*  57880 */     // GIR_Coverage, 14991,
     /*  57880 */     GIR_EraseRootFromParent_Done,
     /*  57881 */   // Label 945: @57881
     /*  57881 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57936), // Rule ID 7454 //
     /*  57886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57923 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57934 */     GIR_RootConstrainSelectedInstOperands,
     /*  57935 */     // GIR_Coverage, 7454,
     /*  57935 */     GIR_EraseRootFromParent_Done,
     /*  57936 */   // Label 946: @57936
     /*  57936 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57991), // Rule ID 7455 //
     /*  57941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57978 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57989 */     GIR_RootConstrainSelectedInstOperands,
     /*  57990 */     // GIR_Coverage, 7455,
     /*  57990 */     GIR_EraseRootFromParent_Done,
     /*  57991 */   // Label 947: @57991
     /*  57991 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(58006), // Rule ID 3146 //
     /*  57996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57999 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58004 */     GIR_RootConstrainSelectedInstOperands,
     /*  58005 */     // GIR_Coverage, 3146,
     /*  58005 */     GIR_Done,
     /*  58006 */   // Label 948: @58006
     /*  58006 */   GIM_Reject,
     /*  58007 */ // Label 939: @58007
     /*  58007 */ GIM_Reject,
     /*  58008 */ // Label 850: @58008
     /*  58008 */ GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58548),
     /*  58013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58023 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58080), // Rule ID 15041 //
     /*  58028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58059 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58065 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58078 */     GIR_RootConstrainSelectedInstOperands,
     /*  58079 */     // GIR_Coverage, 15041,
     /*  58079 */     GIR_EraseRootFromParent_Done,
     /*  58080 */   // Label 950: @58080
     /*  58080 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58137), // Rule ID 15044 //
     /*  58085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58116 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58122 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58135 */     GIR_RootConstrainSelectedInstOperands,
     /*  58136 */     // GIR_Coverage, 15044,
     /*  58136 */     GIR_EraseRootFromParent_Done,
     /*  58137 */   // Label 951: @58137
     /*  58137 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58194), // Rule ID 15040 //
     /*  58142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58173 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58179 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58192 */     GIR_RootConstrainSelectedInstOperands,
     /*  58193 */     // GIR_Coverage, 15040,
     /*  58193 */     GIR_EraseRootFromParent_Done,
     /*  58194 */   // Label 952: @58194
     /*  58194 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58251), // Rule ID 15043 //
     /*  58199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58230 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58236 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58249 */     GIR_RootConstrainSelectedInstOperands,
     /*  58250 */     // GIR_Coverage, 15043,
     /*  58250 */     GIR_EraseRootFromParent_Done,
     /*  58251 */   // Label 953: @58251
     /*  58251 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58308), // Rule ID 15039 //
     /*  58256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58293 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58306 */     GIR_RootConstrainSelectedInstOperands,
     /*  58307 */     // GIR_Coverage, 15039,
     /*  58307 */     GIR_EraseRootFromParent_Done,
     /*  58308 */   // Label 954: @58308
     /*  58308 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58365), // Rule ID 15042 //
     /*  58313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58344 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58350 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58363 */     GIR_RootConstrainSelectedInstOperands,
     /*  58364 */     // GIR_Coverage, 15042,
     /*  58364 */     GIR_EraseRootFromParent_Done,
     /*  58365 */   // Label 955: @58365
     /*  58365 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58422), // Rule ID 8401 //
     /*  58370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58407 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58420 */     GIR_RootConstrainSelectedInstOperands,
     /*  58421 */     // GIR_Coverage, 8401,
     /*  58421 */     GIR_EraseRootFromParent_Done,
     /*  58422 */   // Label 956: @58422
     /*  58422 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58479), // Rule ID 8402 //
     /*  58427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58458 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58464 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58477 */     GIR_RootConstrainSelectedInstOperands,
     /*  58478 */     // GIR_Coverage, 8402,
     /*  58478 */     GIR_EraseRootFromParent_Done,
     /*  58479 */   // Label 957: @58479
     /*  58479 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58526), // Rule ID 10671 //
     /*  58484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58495 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58524 */     GIR_RootConstrainSelectedInstOperands,
     /*  58525 */     // GIR_Coverage, 10671,
     /*  58525 */     GIR_EraseRootFromParent_Done,
     /*  58526 */   // Label 958: @58526
     /*  58526 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58547), // Rule ID 2751 //
     /*  58531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58534 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58545 */     GIR_RootConstrainSelectedInstOperands,
     /*  58546 */     // GIR_Coverage, 2751,
     /*  58546 */     GIR_EraseRootFromParent_Done,
     /*  58547 */   // Label 959: @58547
     /*  58547 */   GIM_Reject,
     /*  58548 */ // Label 949: @58548
     /*  58548 */ GIM_Reject,
     /*  58549 */ // Label 851: @58549
     /*  58549 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(59020),
     /*  58554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58564 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58619), // Rule ID 14981 //
     /*  58569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58606 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58617 */     GIR_RootConstrainSelectedInstOperands,
     /*  58618 */     // GIR_Coverage, 14981,
     /*  58618 */     GIR_EraseRootFromParent_Done,
     /*  58619 */   // Label 961: @58619
     /*  58619 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58674), // Rule ID 14984 //
     /*  58624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58655 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58661 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58672 */     GIR_RootConstrainSelectedInstOperands,
     /*  58673 */     // GIR_Coverage, 14984,
     /*  58673 */     GIR_EraseRootFromParent_Done,
     /*  58674 */   // Label 962: @58674
     /*  58674 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58729), // Rule ID 14980 //
     /*  58679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58710 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58716 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58727 */     GIR_RootConstrainSelectedInstOperands,
     /*  58728 */     // GIR_Coverage, 14980,
     /*  58728 */     GIR_EraseRootFromParent_Done,
     /*  58729 */   // Label 963: @58729
     /*  58729 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58784), // Rule ID 14983 //
     /*  58734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58765 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58771 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58782 */     GIR_RootConstrainSelectedInstOperands,
     /*  58783 */     // GIR_Coverage, 14983,
     /*  58783 */     GIR_EraseRootFromParent_Done,
     /*  58784 */   // Label 964: @58784
     /*  58784 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58839), // Rule ID 14979 //
     /*  58789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58826 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58837 */     GIR_RootConstrainSelectedInstOperands,
     /*  58838 */     // GIR_Coverage, 14979,
     /*  58838 */     GIR_EraseRootFromParent_Done,
     /*  58839 */   // Label 965: @58839
     /*  58839 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58894), // Rule ID 14982 //
     /*  58844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58875 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58881 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58892 */     GIR_RootConstrainSelectedInstOperands,
     /*  58893 */     // GIR_Coverage, 14982,
     /*  58893 */     GIR_EraseRootFromParent_Done,
     /*  58894 */   // Label 966: @58894
     /*  58894 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58949), // Rule ID 7450 //
     /*  58899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58930 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58936 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58947 */     GIR_RootConstrainSelectedInstOperands,
     /*  58948 */     // GIR_Coverage, 7450,
     /*  58948 */     GIR_EraseRootFromParent_Done,
     /*  58949 */   // Label 967: @58949
     /*  58949 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59004), // Rule ID 7451 //
     /*  58954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58985 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58991 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59002 */     GIR_RootConstrainSelectedInstOperands,
     /*  59003 */     // GIR_Coverage, 7451,
     /*  59003 */     GIR_EraseRootFromParent_Done,
     /*  59004 */   // Label 968: @59004
     /*  59004 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59019), // Rule ID 3145 //
     /*  59009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59012 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59017 */     GIR_RootConstrainSelectedInstOperands,
     /*  59018 */     // GIR_Coverage, 3145,
     /*  59018 */     GIR_Done,
     /*  59019 */   // Label 969: @59019
     /*  59019 */   GIM_Reject,
     /*  59020 */ // Label 960: @59020
     /*  59020 */ GIM_Reject,
     /*  59021 */ // Label 852: @59021
     /*  59021 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59561),
     /*  59026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59036 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59093), // Rule ID 15032 //
     /*  59041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59072 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59078 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59091 */     GIR_RootConstrainSelectedInstOperands,
     /*  59092 */     // GIR_Coverage, 15032,
     /*  59092 */     GIR_EraseRootFromParent_Done,
     /*  59093 */   // Label 971: @59093
     /*  59093 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59150), // Rule ID 15035 //
     /*  59098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59129 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59135 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59148 */     GIR_RootConstrainSelectedInstOperands,
     /*  59149 */     // GIR_Coverage, 15035,
     /*  59149 */     GIR_EraseRootFromParent_Done,
     /*  59150 */   // Label 972: @59150
     /*  59150 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59207), // Rule ID 15031 //
     /*  59155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59186 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59192 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59205 */     GIR_RootConstrainSelectedInstOperands,
     /*  59206 */     // GIR_Coverage, 15031,
     /*  59206 */     GIR_EraseRootFromParent_Done,
     /*  59207 */   // Label 973: @59207
     /*  59207 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59264), // Rule ID 15034 //
     /*  59212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59243 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59249 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59262 */     GIR_RootConstrainSelectedInstOperands,
     /*  59263 */     // GIR_Coverage, 15034,
     /*  59263 */     GIR_EraseRootFromParent_Done,
     /*  59264 */   // Label 974: @59264
     /*  59264 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59321), // Rule ID 15030 //
     /*  59269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59300 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59306 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59319 */     GIR_RootConstrainSelectedInstOperands,
     /*  59320 */     // GIR_Coverage, 15030,
     /*  59320 */     GIR_EraseRootFromParent_Done,
     /*  59321 */   // Label 975: @59321
     /*  59321 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59378), // Rule ID 15033 //
     /*  59326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59357 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59363 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59376 */     GIR_RootConstrainSelectedInstOperands,
     /*  59377 */     // GIR_Coverage, 15033,
     /*  59377 */     GIR_EraseRootFromParent_Done,
     /*  59378 */   // Label 976: @59378
     /*  59378 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59435), // Rule ID 8397 //
     /*  59383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59420 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59433 */     GIR_RootConstrainSelectedInstOperands,
     /*  59434 */     // GIR_Coverage, 8397,
     /*  59434 */     GIR_EraseRootFromParent_Done,
     /*  59435 */   // Label 977: @59435
     /*  59435 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59492), // Rule ID 8398 //
     /*  59440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59471 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59477 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59490 */     GIR_RootConstrainSelectedInstOperands,
     /*  59491 */     // GIR_Coverage, 8398,
     /*  59491 */     GIR_EraseRootFromParent_Done,
     /*  59492 */   // Label 978: @59492
     /*  59492 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59539), // Rule ID 10670 //
     /*  59497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59508 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59520 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59537 */     GIR_RootConstrainSelectedInstOperands,
     /*  59538 */     // GIR_Coverage, 10670,
     /*  59538 */     GIR_EraseRootFromParent_Done,
     /*  59539 */   // Label 979: @59539
     /*  59539 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59560), // Rule ID 2750 //
     /*  59544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59547 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59558 */     GIR_RootConstrainSelectedInstOperands,
     /*  59559 */     // GIR_Coverage, 2750,
     /*  59559 */     GIR_EraseRootFromParent_Done,
     /*  59560 */   // Label 980: @59560
     /*  59560 */   GIM_Reject,
     /*  59561 */ // Label 970: @59561
     /*  59561 */ GIM_Reject,
     /*  59562 */ // Label 853: @59562
     /*  59562 */ GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60033),
     /*  59567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59577 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59632), // Rule ID 14972 //
     /*  59582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59619 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59630 */     GIR_RootConstrainSelectedInstOperands,
     /*  59631 */     // GIR_Coverage, 14972,
     /*  59631 */     GIR_EraseRootFromParent_Done,
     /*  59632 */   // Label 982: @59632
     /*  59632 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59687), // Rule ID 14975 //
     /*  59637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59668 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59674 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59685 */     GIR_RootConstrainSelectedInstOperands,
     /*  59686 */     // GIR_Coverage, 14975,
     /*  59686 */     GIR_EraseRootFromParent_Done,
     /*  59687 */   // Label 983: @59687
     /*  59687 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59742), // Rule ID 14971 //
     /*  59692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59729 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59740 */     GIR_RootConstrainSelectedInstOperands,
     /*  59741 */     // GIR_Coverage, 14971,
     /*  59741 */     GIR_EraseRootFromParent_Done,
     /*  59742 */   // Label 984: @59742
     /*  59742 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59797), // Rule ID 14974 //
     /*  59747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59778 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59784 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59795 */     GIR_RootConstrainSelectedInstOperands,
     /*  59796 */     // GIR_Coverage, 14974,
     /*  59796 */     GIR_EraseRootFromParent_Done,
     /*  59797 */   // Label 985: @59797
     /*  59797 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59852), // Rule ID 14970 //
     /*  59802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59833 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59839 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59850 */     GIR_RootConstrainSelectedInstOperands,
     /*  59851 */     // GIR_Coverage, 14970,
     /*  59851 */     GIR_EraseRootFromParent_Done,
     /*  59852 */   // Label 986: @59852
     /*  59852 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59907), // Rule ID 14973 //
     /*  59857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59888 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59894 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59905 */     GIR_RootConstrainSelectedInstOperands,
     /*  59906 */     // GIR_Coverage, 14973,
     /*  59906 */     GIR_EraseRootFromParent_Done,
     /*  59907 */   // Label 987: @59907
     /*  59907 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59962), // Rule ID 7446 //
     /*  59912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59943 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59949 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59960 */     GIR_RootConstrainSelectedInstOperands,
     /*  59961 */     // GIR_Coverage, 7446,
     /*  59961 */     GIR_EraseRootFromParent_Done,
     /*  59962 */   // Label 988: @59962
     /*  59962 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60017), // Rule ID 7447 //
     /*  59967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59998 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60004 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60015 */     GIR_RootConstrainSelectedInstOperands,
     /*  60016 */     // GIR_Coverage, 7447,
     /*  60016 */     GIR_EraseRootFromParent_Done,
     /*  60017 */   // Label 989: @60017
     /*  60017 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60032), // Rule ID 3144 //
     /*  60022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60025 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60030 */     GIR_RootConstrainSelectedInstOperands,
     /*  60031 */     // GIR_Coverage, 3144,
     /*  60031 */     GIR_Done,
     /*  60032 */   // Label 990: @60032
     /*  60032 */   GIM_Reject,
     /*  60033 */ // Label 981: @60033
     /*  60033 */ GIM_Reject,
     /*  60034 */ // Label 854: @60034
     /*  60034 */ GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60574),
     /*  60039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60049 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60106), // Rule ID 15023 //
     /*  60054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60085 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60091 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60104 */     GIR_RootConstrainSelectedInstOperands,
     /*  60105 */     // GIR_Coverage, 15023,
     /*  60105 */     GIR_EraseRootFromParent_Done,
     /*  60106 */   // Label 992: @60106
     /*  60106 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60163), // Rule ID 15026 //
     /*  60111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60142 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60148 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60161 */     GIR_RootConstrainSelectedInstOperands,
     /*  60162 */     // GIR_Coverage, 15026,
     /*  60162 */     GIR_EraseRootFromParent_Done,
     /*  60163 */   // Label 993: @60163
     /*  60163 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60220), // Rule ID 15022 //
     /*  60168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60205 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60218 */     GIR_RootConstrainSelectedInstOperands,
     /*  60219 */     // GIR_Coverage, 15022,
     /*  60219 */     GIR_EraseRootFromParent_Done,
     /*  60220 */   // Label 994: @60220
     /*  60220 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60277), // Rule ID 15025 //
     /*  60225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60256 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60262 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60275 */     GIR_RootConstrainSelectedInstOperands,
     /*  60276 */     // GIR_Coverage, 15025,
     /*  60276 */     GIR_EraseRootFromParent_Done,
     /*  60277 */   // Label 995: @60277
     /*  60277 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60334), // Rule ID 15021 //
     /*  60282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60313 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60319 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60332 */     GIR_RootConstrainSelectedInstOperands,
     /*  60333 */     // GIR_Coverage, 15021,
     /*  60333 */     GIR_EraseRootFromParent_Done,
     /*  60334 */   // Label 996: @60334
     /*  60334 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60391), // Rule ID 15024 //
     /*  60339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60370 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60376 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60389 */     GIR_RootConstrainSelectedInstOperands,
     /*  60390 */     // GIR_Coverage, 15024,
     /*  60390 */     GIR_EraseRootFromParent_Done,
     /*  60391 */   // Label 997: @60391
     /*  60391 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60448), // Rule ID 8393 //
     /*  60396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60433 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60446 */     GIR_RootConstrainSelectedInstOperands,
     /*  60447 */     // GIR_Coverage, 8393,
     /*  60447 */     GIR_EraseRootFromParent_Done,
     /*  60448 */   // Label 998: @60448
     /*  60448 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60505), // Rule ID 8394 //
     /*  60453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60484 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60490 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60503 */     GIR_RootConstrainSelectedInstOperands,
     /*  60504 */     // GIR_Coverage, 8394,
     /*  60504 */     GIR_EraseRootFromParent_Done,
     /*  60505 */   // Label 999: @60505
     /*  60505 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60552), // Rule ID 10669 //
     /*  60510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60521 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60550 */     GIR_RootConstrainSelectedInstOperands,
     /*  60551 */     // GIR_Coverage, 10669,
     /*  60551 */     GIR_EraseRootFromParent_Done,
     /*  60552 */   // Label 1000: @60552
     /*  60552 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60573), // Rule ID 2749 //
     /*  60557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60560 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60571 */     GIR_RootConstrainSelectedInstOperands,
     /*  60572 */     // GIR_Coverage, 2749,
     /*  60572 */     GIR_EraseRootFromParent_Done,
     /*  60573 */   // Label 1001: @60573
     /*  60573 */   GIM_Reject,
     /*  60574 */ // Label 991: @60574
     /*  60574 */ GIM_Reject,
     /*  60575 */ // Label 855: @60575
     /*  60575 */ GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61046),
     /*  60580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60590 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60645), // Rule ID 14963 //
     /*  60595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60626 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60632 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60643 */     GIR_RootConstrainSelectedInstOperands,
     /*  60644 */     // GIR_Coverage, 14963,
     /*  60644 */     GIR_EraseRootFromParent_Done,
     /*  60645 */   // Label 1003: @60645
     /*  60645 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60700), // Rule ID 14966 //
     /*  60650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60681 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60687 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60698 */     GIR_RootConstrainSelectedInstOperands,
     /*  60699 */     // GIR_Coverage, 14966,
     /*  60699 */     GIR_EraseRootFromParent_Done,
     /*  60700 */   // Label 1004: @60700
     /*  60700 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60755), // Rule ID 14962 //
     /*  60705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60736 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60742 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60753 */     GIR_RootConstrainSelectedInstOperands,
     /*  60754 */     // GIR_Coverage, 14962,
     /*  60754 */     GIR_EraseRootFromParent_Done,
     /*  60755 */   // Label 1005: @60755
     /*  60755 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60810), // Rule ID 14965 //
     /*  60760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60791 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60797 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60808 */     GIR_RootConstrainSelectedInstOperands,
     /*  60809 */     // GIR_Coverage, 14965,
     /*  60809 */     GIR_EraseRootFromParent_Done,
     /*  60810 */   // Label 1006: @60810
     /*  60810 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60865), // Rule ID 14961 //
     /*  60815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60852 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60863 */     GIR_RootConstrainSelectedInstOperands,
     /*  60864 */     // GIR_Coverage, 14961,
     /*  60864 */     GIR_EraseRootFromParent_Done,
     /*  60865 */   // Label 1007: @60865
     /*  60865 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60920), // Rule ID 14964 //
     /*  60870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60901 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60907 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60918 */     GIR_RootConstrainSelectedInstOperands,
     /*  60919 */     // GIR_Coverage, 14964,
     /*  60919 */     GIR_EraseRootFromParent_Done,
     /*  60920 */   // Label 1008: @60920
     /*  60920 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60975), // Rule ID 7442 //
     /*  60925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60956 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60962 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60973 */     GIR_RootConstrainSelectedInstOperands,
     /*  60974 */     // GIR_Coverage, 7442,
     /*  60974 */     GIR_EraseRootFromParent_Done,
     /*  60975 */   // Label 1009: @60975
     /*  60975 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61030), // Rule ID 7443 //
     /*  60980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61011 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61017 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61028 */     GIR_RootConstrainSelectedInstOperands,
     /*  61029 */     // GIR_Coverage, 7443,
     /*  61029 */     GIR_EraseRootFromParent_Done,
     /*  61030 */   // Label 1010: @61030
     /*  61030 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(61045), // Rule ID 3143 //
     /*  61035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61038 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61043 */     GIR_RootConstrainSelectedInstOperands,
     /*  61044 */     // GIR_Coverage, 3143,
     /*  61044 */     GIR_Done,
     /*  61045 */   // Label 1011: @61045
     /*  61045 */   GIM_Reject,
     /*  61046 */ // Label 1002: @61046
     /*  61046 */ GIM_Reject,
     /*  61047 */ // Label 856: @61047
     /*  61047 */ GIM_Reject,
     /*  61048 */ // Label 6: @61048
     /*  61048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1030*/ GIMT_Encode4(72826),
     /*  61059 */ /*GILLT_s32*//*Label 1012*/ GIMT_Encode4(61147),
     /*  61063 */ /*GILLT_s64*//*Label 1013*/ GIMT_Encode4(61507), GIMT_Encode4(0),
     /*  61071 */ /*GILLT_v2s32*//*Label 1014*/ GIMT_Encode4(63406),
     /*  61075 */ /*GILLT_v2s64*//*Label 1015*/ GIMT_Encode4(64714),
     /*  61079 */ /*GILLT_v4s16*//*Label 1016*/ GIMT_Encode4(66022),
     /*  61083 */ /*GILLT_v4s32*//*Label 1017*/ GIMT_Encode4(67330),
     /*  61087 */ /*GILLT_v8s8*//*Label 1018*/ GIMT_Encode4(68638),
     /*  61091 */ /*GILLT_v8s16*//*Label 1019*/ GIMT_Encode4(69946),
     /*  61095 */ /*GILLT_v16s8*//*Label 1020*/ GIMT_Encode4(71254),
     /*  61099 */ /*GILLT_nxv1s1*//*Label 1021*/ GIMT_Encode4(72562),
     /*  61103 */ /*GILLT_nxv2s1*//*Label 1022*/ GIMT_Encode4(72594), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61115 */ /*GILLT_nxv2s64*//*Label 1023*/ GIMT_Encode4(72626),
     /*  61119 */ /*GILLT_nxv4s1*//*Label 1024*/ GIMT_Encode4(72652), GIMT_Encode4(0),
     /*  61127 */ /*GILLT_nxv4s32*//*Label 1025*/ GIMT_Encode4(72684),
     /*  61131 */ /*GILLT_nxv8s1*//*Label 1026*/ GIMT_Encode4(72710),
     /*  61135 */ /*GILLT_nxv8s16*//*Label 1027*/ GIMT_Encode4(72742),
     /*  61139 */ /*GILLT_nxv16s1*//*Label 1028*/ GIMT_Encode4(72768),
     /*  61143 */ /*GILLT_nxv16s8*//*Label 1029*/ GIMT_Encode4(72800),
     /*  61147 */ // Label 1012: @61147
     /*  61147 */ GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(61506),
     /*  61152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61158 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(61213), // Rule ID 13229 //
     /*  61163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61200 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61211 */     GIR_RootConstrainSelectedInstOperands,
     /*  61212 */     // GIR_Coverage, 13229,
     /*  61212 */     GIR_EraseRootFromParent_Done,
     /*  61213 */   // Label 1032: @61213
     /*  61213 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61268), // Rule ID 174 //
     /*  61218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61255 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61266 */     GIR_RootConstrainSelectedInstOperands,
     /*  61267 */     // GIR_Coverage, 174,
     /*  61267 */     GIR_EraseRootFromParent_Done,
     /*  61268 */   // Label 1033: @61268
     /*  61268 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61309), // Rule ID 146 //
     /*  61273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61289 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61293 */     // MIs[1] Operand 1
     /*  61293 */     // No operand predicates
     /*  61293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61295 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61302 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61307 */     GIR_RootConstrainSelectedInstOperands,
     /*  61308 */     // GIR_Coverage, 146,
     /*  61308 */     GIR_EraseRootFromParent_Done,
     /*  61309 */   // Label 1034: @61309
     /*  61309 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61342), // Rule ID 13231 //
     /*  61314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61329 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61340 */     GIR_RootConstrainSelectedInstOperands,
     /*  61341 */     // GIR_Coverage, 13231,
     /*  61341 */     GIR_EraseRootFromParent_Done,
     /*  61342 */   // Label 1035: @61342
     /*  61342 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61375), // Rule ID 178 //
     /*  61347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61362 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61373 */     GIR_RootConstrainSelectedInstOperands,
     /*  61374 */     // GIR_Coverage, 178,
     /*  61374 */     GIR_EraseRootFromParent_Done,
     /*  61375 */   // Label 1036: @61375
     /*  61375 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61428), // Rule ID 13227 //
     /*  61380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61415 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61426 */     GIR_RootConstrainSelectedInstOperands,
     /*  61427 */     // GIR_Coverage, 13227,
     /*  61427 */     GIR_EraseRootFromParent_Done,
     /*  61428 */   // Label 1037: @61428
     /*  61428 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61481), // Rule ID 172 //
     /*  61433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61468 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61479 */     GIR_RootConstrainSelectedInstOperands,
     /*  61480 */     // GIR_Coverage, 172,
     /*  61480 */     GIR_EraseRootFromParent_Done,
     /*  61481 */   // Label 1038: @61481
     /*  61481 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61505), // Rule ID 176 //
     /*  61486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61498 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61503 */     GIR_RootConstrainSelectedInstOperands,
     /*  61504 */     // GIR_Coverage, 176,
     /*  61504 */     GIR_Done,
     /*  61505 */   // Label 1039: @61505
     /*  61505 */   GIM_Reject,
     /*  61506 */ // Label 1031: @61506
     /*  61506 */ GIM_Reject,
     /*  61507 */ // Label 1013: @61507
     /*  61507 */ GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(63405),
     /*  61512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61518 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61640), // Rule ID 4017 //
     /*  61523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61564 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61568 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61603 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61607 */     // MIs[4] Rn
     /*  61607 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61612 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61616 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61627 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61629 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61638 */     GIR_RootConstrainSelectedInstOperands,
     /*  61639 */     // GIR_Coverage, 4017,
     /*  61639 */     GIR_EraseRootFromParent_Done,
     /*  61640 */   // Label 1041: @61640
     /*  61640 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61762), // Rule ID 13779 //
     /*  61645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61686 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61690 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61709 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61713 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61725 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61729 */     // MIs[4] Rn
     /*  61729 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61734 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61738 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61749 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61751 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61760 */     GIR_RootConstrainSelectedInstOperands,
     /*  61761 */     // GIR_Coverage, 13779,
     /*  61761 */     GIR_EraseRootFromParent_Done,
     /*  61762 */   // Label 1042: @61762
     /*  61762 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61817), // Rule ID 13230 //
     /*  61767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61804 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61815 */     GIR_RootConstrainSelectedInstOperands,
     /*  61816 */     // GIR_Coverage, 13230,
     /*  61816 */     GIR_EraseRootFromParent_Done,
     /*  61817 */   // Label 1043: @61817
     /*  61817 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61872), // Rule ID 175 //
     /*  61822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61846 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61859 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61870 */     GIR_RootConstrainSelectedInstOperands,
     /*  61871 */     // GIR_Coverage, 175,
     /*  61871 */     GIR_EraseRootFromParent_Done,
     /*  61872 */   // Label 1044: @61872
     /*  61872 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61981), // Rule ID 13579 //
     /*  61877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61946 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61950 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61955 */     // MIs[4] LHS
     /*  61955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61962 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61979 */     GIR_RootConstrainSelectedInstOperands,
     /*  61980 */     // GIR_Coverage, 13579,
     /*  61980 */     GIR_EraseRootFromParent_Done,
     /*  61981 */   // Label 1045: @61981
     /*  61981 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(62090), // Rule ID 13578 //
     /*  61986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62055 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62059 */     // MIs[4] LHS
     /*  62059 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62064 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62071 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62088 */     GIR_RootConstrainSelectedInstOperands,
     /*  62089 */     // GIR_Coverage, 13578,
     /*  62089 */     GIR_EraseRootFromParent_Done,
     /*  62090 */   // Label 1046: @62090
     /*  62090 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(62199), // Rule ID 13581 //
     /*  62095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62148 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62160 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62164 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62168 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62173 */     // MIs[4] LHS
     /*  62173 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62178 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62180 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62197 */     GIR_RootConstrainSelectedInstOperands,
     /*  62198 */     // GIR_Coverage, 13581,
     /*  62198 */     GIR_EraseRootFromParent_Done,
     /*  62199 */   // Label 1047: @62199
     /*  62199 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62308), // Rule ID 13580 //
     /*  62204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62257 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62263 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62269 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62277 */     // MIs[4] LHS
     /*  62277 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62282 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62287 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62289 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62306 */     GIR_RootConstrainSelectedInstOperands,
     /*  62307 */     // GIR_Coverage, 13580,
     /*  62307 */     GIR_EraseRootFromParent_Done,
     /*  62308 */   // Label 1048: @62308
     /*  62308 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62417), // Rule ID 2471 //
     /*  62313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62374 */     // MIs[3] LHS
     /*  62374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62383 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62396 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62398 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62415 */     GIR_RootConstrainSelectedInstOperands,
     /*  62416 */     // GIR_Coverage, 2471,
     /*  62416 */     GIR_EraseRootFromParent_Done,
     /*  62417 */   // Label 1049: @62417
     /*  62417 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62526), // Rule ID 13576 //
     /*  62422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62483 */     // MIs[3] LHS
     /*  62483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62492 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62505 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62507 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62524 */     GIR_RootConstrainSelectedInstOperands,
     /*  62525 */     // GIR_Coverage, 13576,
     /*  62525 */     GIR_EraseRootFromParent_Done,
     /*  62526 */   // Label 1050: @62526
     /*  62526 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62635), // Rule ID 13575 //
     /*  62531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62593 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62597 */     // MIs[3] LHS
     /*  62597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62606 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62616 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62633 */     GIR_RootConstrainSelectedInstOperands,
     /*  62634 */     // GIR_Coverage, 13575,
     /*  62634 */     GIR_EraseRootFromParent_Done,
     /*  62635 */   // Label 1051: @62635
     /*  62635 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62744), // Rule ID 13577 //
     /*  62640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62702 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62706 */     // MIs[3] LHS
     /*  62706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62715 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62725 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62742 */     GIR_RootConstrainSelectedInstOperands,
     /*  62743 */     // GIR_Coverage, 13577,
     /*  62743 */     GIR_EraseRootFromParent_Done,
     /*  62744 */   // Label 1052: @62744
     /*  62744 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62785), // Rule ID 147 //
     /*  62749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62765 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62769 */     // MIs[1] Operand 1
     /*  62769 */     // No operand predicates
     /*  62769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62771 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62778 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62783 */     GIR_RootConstrainSelectedInstOperands,
     /*  62784 */     // GIR_Coverage, 147,
     /*  62784 */     GIR_EraseRootFromParent_Done,
     /*  62785 */   // Label 1053: @62785
     /*  62785 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62818), // Rule ID 13232 //
     /*  62790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62805 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62816 */     GIR_RootConstrainSelectedInstOperands,
     /*  62817 */     // GIR_Coverage, 13232,
     /*  62817 */     GIR_EraseRootFromParent_Done,
     /*  62818 */   // Label 1054: @62818
     /*  62818 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62851), // Rule ID 179 //
     /*  62823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62838 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62849 */     GIR_RootConstrainSelectedInstOperands,
     /*  62850 */     // GIR_Coverage, 179,
     /*  62850 */     GIR_EraseRootFromParent_Done,
     /*  62851 */   // Label 1055: @62851
     /*  62851 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62918), // Rule ID 13515 //
     /*  62856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62880 */     // MIs[1] imm
     /*  62880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62892 */     // MIs[2] Operand 1
     /*  62892 */     // No operand predicates
     /*  62892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62902 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62916 */     GIR_RootConstrainSelectedInstOperands,
     /*  62917 */     // GIR_Coverage, 13515,
     /*  62917 */     GIR_EraseRootFromParent_Done,
     /*  62918 */   // Label 1056: @62918
     /*  62918 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62985), // Rule ID 13518 //
     /*  62923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62947 */     // MIs[1] imm
     /*  62947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62959 */     // MIs[2] Operand 1
     /*  62959 */     // No operand predicates
     /*  62959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62969 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62983 */     GIR_RootConstrainSelectedInstOperands,
     /*  62984 */     // GIR_Coverage, 13518,
     /*  62984 */     GIR_EraseRootFromParent_Done,
     /*  62985 */   // Label 1057: @62985
     /*  62985 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(63038), // Rule ID 13228 //
     /*  62990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63025 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63036 */     GIR_RootConstrainSelectedInstOperands,
     /*  63037 */     // GIR_Coverage, 13228,
     /*  63037 */     GIR_EraseRootFromParent_Done,
     /*  63038 */   // Label 1058: @63038
     /*  63038 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63105), // Rule ID 2122 //
     /*  63043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63071 */     // MIs[1] imm
     /*  63071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63083 */     // MIs[2] Operand 1
     /*  63083 */     // No operand predicates
     /*  63083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63089 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63103 */     GIR_RootConstrainSelectedInstOperands,
     /*  63104 */     // GIR_Coverage, 2122,
     /*  63104 */     GIR_EraseRootFromParent_Done,
     /*  63105 */   // Label 1059: @63105
     /*  63105 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63172), // Rule ID 2131 //
     /*  63110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63138 */     // MIs[1] imm
     /*  63138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63150 */     // MIs[2] Operand 1
     /*  63150 */     // No operand predicates
     /*  63150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63156 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63170 */     GIR_RootConstrainSelectedInstOperands,
     /*  63171 */     // GIR_Coverage, 2131,
     /*  63171 */     GIR_EraseRootFromParent_Done,
     /*  63172 */   // Label 1060: @63172
     /*  63172 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63225), // Rule ID 173 //
     /*  63177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63206 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63212 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63223 */     GIR_RootConstrainSelectedInstOperands,
     /*  63224 */     // GIR_Coverage, 173,
     /*  63224 */     GIR_EraseRootFromParent_Done,
     /*  63225 */   // Label 1061: @63225
     /*  63225 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63289), // Rule ID 13870 //
     /*  63230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63276 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63281 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63287 */     GIR_RootConstrainSelectedInstOperands,
     /*  63288 */     // GIR_Coverage, 13870,
     /*  63288 */     GIR_EraseRootFromParent_Done,
     /*  63289 */   // Label 1062: @63289
     /*  63289 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63353), // Rule ID 5056 //
     /*  63294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63330 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63340 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63345 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63351 */     GIR_RootConstrainSelectedInstOperands,
     /*  63352 */     // GIR_Coverage, 5056,
     /*  63352 */     GIR_EraseRootFromParent_Done,
     /*  63353 */   // Label 1063: @63353
     /*  63353 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63377), // Rule ID 177 //
     /*  63358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63370 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63375 */     GIR_RootConstrainSelectedInstOperands,
     /*  63376 */     // GIR_Coverage, 177,
     /*  63376 */     GIR_Done,
     /*  63377 */   // Label 1064: @63377
     /*  63377 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63404), // Rule ID 5062 //
     /*  63382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63397 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63402 */     GIR_RootConstrainSelectedInstOperands,
     /*  63403 */     // GIR_Coverage, 5062,
     /*  63403 */     GIR_Done,
     /*  63404 */   // Label 1065: @63404
     /*  63404 */   GIM_Reject,
     /*  63405 */ // Label 1040: @63405
     /*  63405 */ GIM_Reject,
     /*  63406 */ // Label 1014: @63406
     /*  63406 */ GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(64713),
     /*  63411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63417 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63526), // Rule ID 13572 //
     /*  63422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63470 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63495 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63500 */     // MIs[4] LHS
     /*  63500 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63505 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63507 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63524 */     GIR_RootConstrainSelectedInstOperands,
     /*  63525 */     // GIR_Coverage, 13572,
     /*  63525 */     GIR_EraseRootFromParent_Done,
     /*  63526 */   // Label 1067: @63526
     /*  63526 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63635), // Rule ID 13571 //
     /*  63531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63579 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63600 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63604 */     // MIs[4] LHS
     /*  63604 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63609 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63616 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63633 */     GIR_RootConstrainSelectedInstOperands,
     /*  63634 */     // GIR_Coverage, 13571,
     /*  63634 */     GIR_EraseRootFromParent_Done,
     /*  63635 */   // Label 1068: @63635
     /*  63635 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63744), // Rule ID 13574 //
     /*  63640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63693 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63701 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63705 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63709 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63713 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63718 */     // MIs[4] LHS
     /*  63718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63725 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63742 */     GIR_RootConstrainSelectedInstOperands,
     /*  63743 */     // GIR_Coverage, 13574,
     /*  63743 */     GIR_EraseRootFromParent_Done,
     /*  63744 */   // Label 1069: @63744
     /*  63744 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63853), // Rule ID 13573 //
     /*  63749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63818 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63822 */     // MIs[4] LHS
     /*  63822 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63827 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63832 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63834 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63851 */     GIR_RootConstrainSelectedInstOperands,
     /*  63852 */     // GIR_Coverage, 13573,
     /*  63852 */     GIR_EraseRootFromParent_Done,
     /*  63853 */   // Label 1070: @63853
     /*  63853 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63962), // Rule ID 2470 //
     /*  63858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63919 */     // MIs[3] LHS
     /*  63919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63928 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63943 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63960 */     GIR_RootConstrainSelectedInstOperands,
     /*  63961 */     // GIR_Coverage, 2470,
     /*  63961 */     GIR_EraseRootFromParent_Done,
     /*  63962 */   // Label 1071: @63962
     /*  63962 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(64071), // Rule ID 13569 //
     /*  63967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64028 */     // MIs[3] LHS
     /*  64028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64037 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64052 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64069 */     GIR_RootConstrainSelectedInstOperands,
     /*  64070 */     // GIR_Coverage, 13569,
     /*  64070 */     GIR_EraseRootFromParent_Done,
     /*  64071 */   // Label 1072: @64071
     /*  64071 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64180), // Rule ID 13568 //
     /*  64076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64142 */     // MIs[3] LHS
     /*  64142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64151 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64161 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64178 */     GIR_RootConstrainSelectedInstOperands,
     /*  64179 */     // GIR_Coverage, 13568,
     /*  64179 */     GIR_EraseRootFromParent_Done,
     /*  64180 */   // Label 1073: @64180
     /*  64180 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64289), // Rule ID 13570 //
     /*  64185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64247 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64251 */     // MIs[3] LHS
     /*  64251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64260 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64266 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64268 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64270 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64287 */     GIR_RootConstrainSelectedInstOperands,
     /*  64288 */     // GIR_Coverage, 13570,
     /*  64288 */     GIR_EraseRootFromParent_Done,
     /*  64289 */   // Label 1074: @64289
     /*  64289 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64356), // Rule ID 13535 //
     /*  64294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64318 */     // MIs[1] imm
     /*  64318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64330 */     // MIs[2] Operand 1
     /*  64330 */     // No operand predicates
     /*  64330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64340 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64354 */     GIR_RootConstrainSelectedInstOperands,
     /*  64355 */     // GIR_Coverage, 13535,
     /*  64355 */     GIR_EraseRootFromParent_Done,
     /*  64356 */   // Label 1075: @64356
     /*  64356 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64423), // Rule ID 13556 //
     /*  64361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64385 */     // MIs[1] imm
     /*  64385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64397 */     // MIs[2] Operand 1
     /*  64397 */     // No operand predicates
     /*  64397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64407 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64421 */     GIR_RootConstrainSelectedInstOperands,
     /*  64422 */     // GIR_Coverage, 13556,
     /*  64422 */     GIR_EraseRootFromParent_Done,
     /*  64423 */   // Label 1076: @64423
     /*  64423 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64490), // Rule ID 2239 //
     /*  64428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64456 */     // MIs[1] imm
     /*  64456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64468 */     // MIs[2] Operand 1
     /*  64468 */     // No operand predicates
     /*  64468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64474 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64488 */     GIR_RootConstrainSelectedInstOperands,
     /*  64489 */     // GIR_Coverage, 2239,
     /*  64489 */     GIR_EraseRootFromParent_Done,
     /*  64490 */   // Label 1077: @64490
     /*  64490 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64557), // Rule ID 2298 //
     /*  64495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64523 */     // MIs[1] imm
     /*  64523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64535 */     // MIs[2] Operand 1
     /*  64535 */     // No operand predicates
     /*  64535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64541 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64555 */     GIR_RootConstrainSelectedInstOperands,
     /*  64556 */     // GIR_Coverage, 2298,
     /*  64556 */     GIR_EraseRootFromParent_Done,
     /*  64557 */   // Label 1078: @64557
     /*  64557 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64621), // Rule ID 13869 //
     /*  64562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64594 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64608 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64613 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64619 */     GIR_RootConstrainSelectedInstOperands,
     /*  64620 */     // GIR_Coverage, 13869,
     /*  64620 */     GIR_EraseRootFromParent_Done,
     /*  64621 */   // Label 1079: @64621
     /*  64621 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64685), // Rule ID 5055 //
     /*  64626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64662 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64672 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64677 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64683 */     GIR_RootConstrainSelectedInstOperands,
     /*  64684 */     // GIR_Coverage, 5055,
     /*  64684 */     GIR_EraseRootFromParent_Done,
     /*  64685 */   // Label 1080: @64685
     /*  64685 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64712), // Rule ID 5061 //
     /*  64690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64705 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64710 */     GIR_RootConstrainSelectedInstOperands,
     /*  64711 */     // GIR_Coverage, 5061,
     /*  64711 */     GIR_Done,
     /*  64712 */   // Label 1081: @64712
     /*  64712 */   GIM_Reject,
     /*  64713 */ // Label 1066: @64713
     /*  64713 */ GIM_Reject,
     /*  64714 */ // Label 1015: @64714
     /*  64714 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(66021),
     /*  64719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64725 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64834), // Rule ID 13600 //
     /*  64730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64778 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64808 */     // MIs[4] LHS
     /*  64808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64815 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64832 */     GIR_RootConstrainSelectedInstOperands,
     /*  64833 */     // GIR_Coverage, 13600,
     /*  64833 */     GIR_EraseRootFromParent_Done,
     /*  64834 */   // Label 1083: @64834
     /*  64834 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64943), // Rule ID 13599 //
     /*  64839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64887 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64908 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64912 */     // MIs[4] LHS
     /*  64912 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64922 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64924 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64941 */     GIR_RootConstrainSelectedInstOperands,
     /*  64942 */     // GIR_Coverage, 13599,
     /*  64942 */     GIR_EraseRootFromParent_Done,
     /*  64943 */   // Label 1084: @64943
     /*  64943 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(65052), // Rule ID 13602 //
     /*  64948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65001 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65017 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65021 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65026 */     // MIs[4] LHS
     /*  65026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65033 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65050 */     GIR_RootConstrainSelectedInstOperands,
     /*  65051 */     // GIR_Coverage, 13602,
     /*  65051 */     GIR_EraseRootFromParent_Done,
     /*  65052 */   // Label 1085: @65052
     /*  65052 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65161), // Rule ID 13601 //
     /*  65057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65122 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65126 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65130 */     // MIs[4] LHS
     /*  65130 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65135 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65142 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65159 */     GIR_RootConstrainSelectedInstOperands,
     /*  65160 */     // GIR_Coverage, 13601,
     /*  65160 */     GIR_EraseRootFromParent_Done,
     /*  65161 */   // Label 1086: @65161
     /*  65161 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65270), // Rule ID 2474 //
     /*  65166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65227 */     // MIs[3] LHS
     /*  65227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65249 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65251 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65268 */     GIR_RootConstrainSelectedInstOperands,
     /*  65269 */     // GIR_Coverage, 2474,
     /*  65269 */     GIR_EraseRootFromParent_Done,
     /*  65270 */   // Label 1087: @65270
     /*  65270 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65379), // Rule ID 13597 //
     /*  65275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65336 */     // MIs[3] LHS
     /*  65336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65341 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65345 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65360 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65377 */     GIR_RootConstrainSelectedInstOperands,
     /*  65378 */     // GIR_Coverage, 13597,
     /*  65378 */     GIR_EraseRootFromParent_Done,
     /*  65379 */   // Label 1088: @65379
     /*  65379 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65488), // Rule ID 13596 //
     /*  65384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65450 */     // MIs[3] LHS
     /*  65450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65459 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65467 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65469 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65486 */     GIR_RootConstrainSelectedInstOperands,
     /*  65487 */     // GIR_Coverage, 13596,
     /*  65487 */     GIR_EraseRootFromParent_Done,
     /*  65488 */   // Label 1089: @65488
     /*  65488 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65597), // Rule ID 13598 //
     /*  65493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65555 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65559 */     // MIs[3] LHS
     /*  65559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65568 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65574 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65578 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65595 */     GIR_RootConstrainSelectedInstOperands,
     /*  65596 */     // GIR_Coverage, 13598,
     /*  65596 */     GIR_EraseRootFromParent_Done,
     /*  65597 */   // Label 1090: @65597
     /*  65597 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65664), // Rule ID 13539 //
     /*  65602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65626 */     // MIs[1] imm
     /*  65626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65638 */     // MIs[2] Operand 1
     /*  65638 */     // No operand predicates
     /*  65638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65648 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65662 */     GIR_RootConstrainSelectedInstOperands,
     /*  65663 */     // GIR_Coverage, 13539,
     /*  65663 */     GIR_EraseRootFromParent_Done,
     /*  65664 */   // Label 1091: @65664
     /*  65664 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65731), // Rule ID 13560 //
     /*  65669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65693 */     // MIs[1] imm
     /*  65693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65705 */     // MIs[2] Operand 1
     /*  65705 */     // No operand predicates
     /*  65705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65715 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65729 */     GIR_RootConstrainSelectedInstOperands,
     /*  65730 */     // GIR_Coverage, 13560,
     /*  65730 */     GIR_EraseRootFromParent_Done,
     /*  65731 */   // Label 1092: @65731
     /*  65731 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65798), // Rule ID 2243 //
     /*  65736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65764 */     // MIs[1] imm
     /*  65764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65776 */     // MIs[2] Operand 1
     /*  65776 */     // No operand predicates
     /*  65776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65782 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65796 */     GIR_RootConstrainSelectedInstOperands,
     /*  65797 */     // GIR_Coverage, 2243,
     /*  65797 */     GIR_EraseRootFromParent_Done,
     /*  65798 */   // Label 1093: @65798
     /*  65798 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65865), // Rule ID 2302 //
     /*  65803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65831 */     // MIs[1] imm
     /*  65831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65843 */     // MIs[2] Operand 1
     /*  65843 */     // No operand predicates
     /*  65843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65849 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65863 */     GIR_RootConstrainSelectedInstOperands,
     /*  65864 */     // GIR_Coverage, 2302,
     /*  65864 */     GIR_EraseRootFromParent_Done,
     /*  65865 */   // Label 1094: @65865
     /*  65865 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65929), // Rule ID 13873 //
     /*  65870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65916 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65921 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65927 */     GIR_RootConstrainSelectedInstOperands,
     /*  65928 */     // GIR_Coverage, 13873,
     /*  65928 */     GIR_EraseRootFromParent_Done,
     /*  65929 */   // Label 1095: @65929
     /*  65929 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65993), // Rule ID 5059 //
     /*  65934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65970 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65980 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65985 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65991 */     GIR_RootConstrainSelectedInstOperands,
     /*  65992 */     // GIR_Coverage, 5059,
     /*  65992 */     GIR_EraseRootFromParent_Done,
     /*  65993 */   // Label 1096: @65993
     /*  65993 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66020), // Rule ID 5065 //
     /*  65998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66013 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66018 */     GIR_RootConstrainSelectedInstOperands,
     /*  66019 */     // GIR_Coverage, 5065,
     /*  66019 */     GIR_Done,
     /*  66020 */   // Label 1097: @66020
     /*  66020 */   GIM_Reject,
     /*  66021 */ // Label 1082: @66021
     /*  66021 */ GIM_Reject,
     /*  66022 */ // Label 1016: @66022
     /*  66022 */ GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(67329),
     /*  66027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66033 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66142), // Rule ID 13565 //
     /*  66038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66086 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66099 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66103 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66107 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66111 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66116 */     // MIs[4] LHS
     /*  66116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66121 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66123 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66140 */     GIR_RootConstrainSelectedInstOperands,
     /*  66141 */     // GIR_Coverage, 13565,
     /*  66141 */     GIR_EraseRootFromParent_Done,
     /*  66142 */   // Label 1099: @66142
     /*  66142 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(66251), // Rule ID 13564 //
     /*  66147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66195 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66220 */     // MIs[4] LHS
     /*  66220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66230 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66232 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66249 */     GIR_RootConstrainSelectedInstOperands,
     /*  66250 */     // GIR_Coverage, 13564,
     /*  66250 */     GIR_EraseRootFromParent_Done,
     /*  66251 */   // Label 1100: @66251
     /*  66251 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66360), // Rule ID 13567 //
     /*  66256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66309 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66317 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66321 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66325 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66329 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66334 */     // MIs[4] LHS
     /*  66334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66339 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66341 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66358 */     GIR_RootConstrainSelectedInstOperands,
     /*  66359 */     // GIR_Coverage, 13567,
     /*  66359 */     GIR_EraseRootFromParent_Done,
     /*  66360 */   // Label 1101: @66360
     /*  66360 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66469), // Rule ID 13566 //
     /*  66365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66418 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66434 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66438 */     // MIs[4] LHS
     /*  66438 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66443 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66448 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66450 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66467 */     GIR_RootConstrainSelectedInstOperands,
     /*  66468 */     // GIR_Coverage, 13566,
     /*  66468 */     GIR_EraseRootFromParent_Done,
     /*  66469 */   // Label 1102: @66469
     /*  66469 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66578), // Rule ID 2469 //
     /*  66474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66535 */     // MIs[3] LHS
     /*  66535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66544 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66557 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66559 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66576 */     GIR_RootConstrainSelectedInstOperands,
     /*  66577 */     // GIR_Coverage, 2469,
     /*  66577 */     GIR_EraseRootFromParent_Done,
     /*  66578 */   // Label 1103: @66578
     /*  66578 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66687), // Rule ID 13562 //
     /*  66583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66644 */     // MIs[3] LHS
     /*  66644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66653 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66668 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66685 */     GIR_RootConstrainSelectedInstOperands,
     /*  66686 */     // GIR_Coverage, 13562,
     /*  66686 */     GIR_EraseRootFromParent_Done,
     /*  66687 */   // Label 1104: @66687
     /*  66687 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66796), // Rule ID 13561 //
     /*  66692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66758 */     // MIs[3] LHS
     /*  66758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66767 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66775 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66777 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66794 */     GIR_RootConstrainSelectedInstOperands,
     /*  66795 */     // GIR_Coverage, 13561,
     /*  66795 */     GIR_EraseRootFromParent_Done,
     /*  66796 */   // Label 1105: @66796
     /*  66796 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66905), // Rule ID 13563 //
     /*  66801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66863 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66867 */     // MIs[3] LHS
     /*  66867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66876 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66886 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66903 */     GIR_RootConstrainSelectedInstOperands,
     /*  66904 */     // GIR_Coverage, 13563,
     /*  66904 */     GIR_EraseRootFromParent_Done,
     /*  66905 */   // Label 1106: @66905
     /*  66905 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66972), // Rule ID 13531 //
     /*  66910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66934 */     // MIs[1] imm
     /*  66934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66946 */     // MIs[2] Operand 1
     /*  66946 */     // No operand predicates
     /*  66946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66956 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66970 */     GIR_RootConstrainSelectedInstOperands,
     /*  66971 */     // GIR_Coverage, 13531,
     /*  66971 */     GIR_EraseRootFromParent_Done,
     /*  66972 */   // Label 1107: @66972
     /*  66972 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67039), // Rule ID 13552 //
     /*  66977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67001 */     // MIs[1] imm
     /*  67001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67009 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67013 */     // MIs[2] Operand 1
     /*  67013 */     // No operand predicates
     /*  67013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67023 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67037 */     GIR_RootConstrainSelectedInstOperands,
     /*  67038 */     // GIR_Coverage, 13552,
     /*  67038 */     GIR_EraseRootFromParent_Done,
     /*  67039 */   // Label 1108: @67039
     /*  67039 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(67106), // Rule ID 2235 //
     /*  67044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67072 */     // MIs[1] imm
     /*  67072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67084 */     // MIs[2] Operand 1
     /*  67084 */     // No operand predicates
     /*  67084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67090 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67104 */     GIR_RootConstrainSelectedInstOperands,
     /*  67105 */     // GIR_Coverage, 2235,
     /*  67105 */     GIR_EraseRootFromParent_Done,
     /*  67106 */   // Label 1109: @67106
     /*  67106 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67173), // Rule ID 2294 //
     /*  67111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67139 */     // MIs[1] imm
     /*  67139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67151 */     // MIs[2] Operand 1
     /*  67151 */     // No operand predicates
     /*  67151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67157 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67171 */     GIR_RootConstrainSelectedInstOperands,
     /*  67172 */     // GIR_Coverage, 2294,
     /*  67172 */     GIR_EraseRootFromParent_Done,
     /*  67173 */   // Label 1110: @67173
     /*  67173 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67237), // Rule ID 13868 //
     /*  67178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67210 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67224 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67229 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67235 */     GIR_RootConstrainSelectedInstOperands,
     /*  67236 */     // GIR_Coverage, 13868,
     /*  67236 */     GIR_EraseRootFromParent_Done,
     /*  67237 */   // Label 1111: @67237
     /*  67237 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67301), // Rule ID 5054 //
     /*  67242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67288 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67293 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67299 */     GIR_RootConstrainSelectedInstOperands,
     /*  67300 */     // GIR_Coverage, 5054,
     /*  67300 */     GIR_EraseRootFromParent_Done,
     /*  67301 */   // Label 1112: @67301
     /*  67301 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67328), // Rule ID 5060 //
     /*  67306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67321 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67326 */     GIR_RootConstrainSelectedInstOperands,
     /*  67327 */     // GIR_Coverage, 5060,
     /*  67327 */     GIR_Done,
     /*  67328 */   // Label 1113: @67328
     /*  67328 */   GIM_Reject,
     /*  67329 */ // Label 1098: @67329
     /*  67329 */ GIM_Reject,
     /*  67330 */ // Label 1017: @67330
     /*  67330 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(68637),
     /*  67335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67341 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67450), // Rule ID 13593 //
     /*  67346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67394 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67419 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67424 */     // MIs[4] LHS
     /*  67424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67429 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67431 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67448 */     GIR_RootConstrainSelectedInstOperands,
     /*  67449 */     // GIR_Coverage, 13593,
     /*  67449 */     GIR_EraseRootFromParent_Done,
     /*  67450 */   // Label 1115: @67450
     /*  67450 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(67559), // Rule ID 13592 //
     /*  67455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67503 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67524 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67528 */     // MIs[4] LHS
     /*  67528 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67538 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67540 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67557 */     GIR_RootConstrainSelectedInstOperands,
     /*  67558 */     // GIR_Coverage, 13592,
     /*  67558 */     GIR_EraseRootFromParent_Done,
     /*  67559 */   // Label 1116: @67559
     /*  67559 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67668), // Rule ID 13595 //
     /*  67564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67617 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67623 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67625 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67629 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67633 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67637 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67642 */     // MIs[4] LHS
     /*  67642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67649 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67666 */     GIR_RootConstrainSelectedInstOperands,
     /*  67667 */     // GIR_Coverage, 13595,
     /*  67667 */     GIR_EraseRootFromParent_Done,
     /*  67668 */   // Label 1117: @67668
     /*  67668 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67777), // Rule ID 13594 //
     /*  67673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67726 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67738 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67742 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67746 */     // MIs[4] LHS
     /*  67746 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67751 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67758 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67775 */     GIR_RootConstrainSelectedInstOperands,
     /*  67776 */     // GIR_Coverage, 13594,
     /*  67776 */     GIR_EraseRootFromParent_Done,
     /*  67777 */   // Label 1118: @67777
     /*  67777 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67886), // Rule ID 2473 //
     /*  67782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67843 */     // MIs[3] LHS
     /*  67843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67852 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67865 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67867 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67884 */     GIR_RootConstrainSelectedInstOperands,
     /*  67885 */     // GIR_Coverage, 2473,
     /*  67885 */     GIR_EraseRootFromParent_Done,
     /*  67886 */   // Label 1119: @67886
     /*  67886 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67995), // Rule ID 13590 //
     /*  67891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67952 */     // MIs[3] LHS
     /*  67952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67957 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67961 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67976 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67993 */     GIR_RootConstrainSelectedInstOperands,
     /*  67994 */     // GIR_Coverage, 13590,
     /*  67994 */     GIR_EraseRootFromParent_Done,
     /*  67995 */   // Label 1120: @67995
     /*  67995 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68104), // Rule ID 13589 //
     /*  68000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68066 */     // MIs[3] LHS
     /*  68066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68075 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68085 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68102 */     GIR_RootConstrainSelectedInstOperands,
     /*  68103 */     // GIR_Coverage, 13589,
     /*  68103 */     GIR_EraseRootFromParent_Done,
     /*  68104 */   // Label 1121: @68104
     /*  68104 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68213), // Rule ID 13591 //
     /*  68109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68171 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68175 */     // MIs[3] LHS
     /*  68175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68184 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68190 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68192 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68194 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68211 */     GIR_RootConstrainSelectedInstOperands,
     /*  68212 */     // GIR_Coverage, 13591,
     /*  68212 */     GIR_EraseRootFromParent_Done,
     /*  68213 */   // Label 1122: @68213
     /*  68213 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68280), // Rule ID 13537 //
     /*  68218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68242 */     // MIs[1] imm
     /*  68242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68254 */     // MIs[2] Operand 1
     /*  68254 */     // No operand predicates
     /*  68254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68264 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68278 */     GIR_RootConstrainSelectedInstOperands,
     /*  68279 */     // GIR_Coverage, 13537,
     /*  68279 */     GIR_EraseRootFromParent_Done,
     /*  68280 */   // Label 1123: @68280
     /*  68280 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68347), // Rule ID 13558 //
     /*  68285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68309 */     // MIs[1] imm
     /*  68309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68321 */     // MIs[2] Operand 1
     /*  68321 */     // No operand predicates
     /*  68321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68331 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68345 */     GIR_RootConstrainSelectedInstOperands,
     /*  68346 */     // GIR_Coverage, 13558,
     /*  68346 */     GIR_EraseRootFromParent_Done,
     /*  68347 */   // Label 1124: @68347
     /*  68347 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68414), // Rule ID 2241 //
     /*  68352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68380 */     // MIs[1] imm
     /*  68380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68392 */     // MIs[2] Operand 1
     /*  68392 */     // No operand predicates
     /*  68392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68398 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68412 */     GIR_RootConstrainSelectedInstOperands,
     /*  68413 */     // GIR_Coverage, 2241,
     /*  68413 */     GIR_EraseRootFromParent_Done,
     /*  68414 */   // Label 1125: @68414
     /*  68414 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68481), // Rule ID 2300 //
     /*  68419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68447 */     // MIs[1] imm
     /*  68447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68459 */     // MIs[2] Operand 1
     /*  68459 */     // No operand predicates
     /*  68459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68465 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68479 */     GIR_RootConstrainSelectedInstOperands,
     /*  68480 */     // GIR_Coverage, 2300,
     /*  68480 */     GIR_EraseRootFromParent_Done,
     /*  68481 */   // Label 1126: @68481
     /*  68481 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68545), // Rule ID 13872 //
     /*  68486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68532 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68537 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68543 */     GIR_RootConstrainSelectedInstOperands,
     /*  68544 */     // GIR_Coverage, 13872,
     /*  68544 */     GIR_EraseRootFromParent_Done,
     /*  68545 */   // Label 1127: @68545
     /*  68545 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68609), // Rule ID 5058 //
     /*  68550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68586 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68592 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68596 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68601 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68607 */     GIR_RootConstrainSelectedInstOperands,
     /*  68608 */     // GIR_Coverage, 5058,
     /*  68608 */     GIR_EraseRootFromParent_Done,
     /*  68609 */   // Label 1128: @68609
     /*  68609 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68636), // Rule ID 5064 //
     /*  68614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68629 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68634 */     GIR_RootConstrainSelectedInstOperands,
     /*  68635 */     // GIR_Coverage, 5064,
     /*  68635 */     GIR_Done,
     /*  68636 */   // Label 1129: @68636
     /*  68636 */   GIM_Reject,
     /*  68637 */ // Label 1114: @68637
     /*  68637 */ GIM_Reject,
     /*  68638 */ // Label 1018: @68638
     /*  68638 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(69945),
     /*  68643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68649 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68758), // Rule ID 13353 //
     /*  68654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68702 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68715 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68719 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68723 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68727 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68732 */     // MIs[4] Rd
     /*  68732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68737 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68739 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68756 */     GIR_RootConstrainSelectedInstOperands,
     /*  68757 */     // GIR_Coverage, 13353,
     /*  68757 */     GIR_EraseRootFromParent_Done,
     /*  68758 */   // Label 1131: @68758
     /*  68758 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68867), // Rule ID 13352 //
     /*  68763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68832 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68836 */     // MIs[4] Rd
     /*  68836 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68841 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68848 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68865 */     GIR_RootConstrainSelectedInstOperands,
     /*  68866 */     // GIR_Coverage, 13352,
     /*  68866 */     GIR_EraseRootFromParent_Done,
     /*  68867 */   // Label 1132: @68867
     /*  68867 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68976), // Rule ID 13355 //
     /*  68872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68933 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68937 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68941 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68945 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68950 */     // MIs[4] Rd
     /*  68950 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68955 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68957 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68974 */     GIR_RootConstrainSelectedInstOperands,
     /*  68975 */     // GIR_Coverage, 13355,
     /*  68975 */     GIR_EraseRootFromParent_Done,
     /*  68976 */   // Label 1133: @68976
     /*  68976 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(69085), // Rule ID 13354 //
     /*  68981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69050 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69054 */     // MIs[4] Rd
     /*  69054 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69059 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69066 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69083 */     GIR_RootConstrainSelectedInstOperands,
     /*  69084 */     // GIR_Coverage, 13354,
     /*  69084 */     GIR_EraseRootFromParent_Done,
     /*  69085 */   // Label 1134: @69085
     /*  69085 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69194), // Rule ID 1605 //
     /*  69090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69151 */     // MIs[3] Rd
     /*  69151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69160 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69175 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69192 */     GIR_RootConstrainSelectedInstOperands,
     /*  69193 */     // GIR_Coverage, 1605,
     /*  69193 */     GIR_EraseRootFromParent_Done,
     /*  69194 */   // Label 1135: @69194
     /*  69194 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69303), // Rule ID 13350 //
     /*  69199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69260 */     // MIs[3] Rd
     /*  69260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69269 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69275 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69282 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69284 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69301 */     GIR_RootConstrainSelectedInstOperands,
     /*  69302 */     // GIR_Coverage, 13350,
     /*  69302 */     GIR_EraseRootFromParent_Done,
     /*  69303 */   // Label 1136: @69303
     /*  69303 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69412), // Rule ID 13349 //
     /*  69308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69374 */     // MIs[3] Rd
     /*  69374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69383 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69391 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69393 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69410 */     GIR_RootConstrainSelectedInstOperands,
     /*  69411 */     // GIR_Coverage, 13349,
     /*  69411 */     GIR_EraseRootFromParent_Done,
     /*  69412 */   // Label 1137: @69412
     /*  69412 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69521), // Rule ID 13351 //
     /*  69417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69483 */     // MIs[3] Rd
     /*  69483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69492 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69502 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69519 */     GIR_RootConstrainSelectedInstOperands,
     /*  69520 */     // GIR_Coverage, 13351,
     /*  69520 */     GIR_EraseRootFromParent_Done,
     /*  69521 */   // Label 1138: @69521
     /*  69521 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69588), // Rule ID 13527 //
     /*  69526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69550 */     // MIs[1] imm
     /*  69550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69562 */     // MIs[2] Operand 1
     /*  69562 */     // No operand predicates
     /*  69562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69572 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69586 */     GIR_RootConstrainSelectedInstOperands,
     /*  69587 */     // GIR_Coverage, 13527,
     /*  69587 */     GIR_EraseRootFromParent_Done,
     /*  69588 */   // Label 1139: @69588
     /*  69588 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69655), // Rule ID 13548 //
     /*  69593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69617 */     // MIs[1] imm
     /*  69617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69629 */     // MIs[2] Operand 1
     /*  69629 */     // No operand predicates
     /*  69629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69639 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69653 */     GIR_RootConstrainSelectedInstOperands,
     /*  69654 */     // GIR_Coverage, 13548,
     /*  69654 */     GIR_EraseRootFromParent_Done,
     /*  69655 */   // Label 1140: @69655
     /*  69655 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69722), // Rule ID 2231 //
     /*  69660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69688 */     // MIs[1] imm
     /*  69688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69696 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69700 */     // MIs[2] Operand 1
     /*  69700 */     // No operand predicates
     /*  69700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69706 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69720 */     GIR_RootConstrainSelectedInstOperands,
     /*  69721 */     // GIR_Coverage, 2231,
     /*  69721 */     GIR_EraseRootFromParent_Done,
     /*  69722 */   // Label 1141: @69722
     /*  69722 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69789), // Rule ID 2290 //
     /*  69727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69755 */     // MIs[1] imm
     /*  69755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69767 */     // MIs[2] Operand 1
     /*  69767 */     // No operand predicates
     /*  69767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69773 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69787 */     GIR_RootConstrainSelectedInstOperands,
     /*  69788 */     // GIR_Coverage, 2290,
     /*  69788 */     GIR_EraseRootFromParent_Done,
     /*  69789 */   // Label 1142: @69789
     /*  69789 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69853), // Rule ID 13347 //
     /*  69794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69826 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69840 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69851 */     GIR_RootConstrainSelectedInstOperands,
     /*  69852 */     // GIR_Coverage, 13347,
     /*  69852 */     GIR_EraseRootFromParent_Done,
     /*  69853 */   // Label 1143: @69853
     /*  69853 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69917), // Rule ID 1601 //
     /*  69858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69904 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69915 */     GIR_RootConstrainSelectedInstOperands,
     /*  69916 */     // GIR_Coverage, 1601,
     /*  69916 */     GIR_EraseRootFromParent_Done,
     /*  69917 */   // Label 1144: @69917
     /*  69917 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69944), // Rule ID 1603 //
     /*  69922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69937 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69942 */     GIR_RootConstrainSelectedInstOperands,
     /*  69943 */     // GIR_Coverage, 1603,
     /*  69943 */     GIR_Done,
     /*  69944 */   // Label 1145: @69944
     /*  69944 */   GIM_Reject,
     /*  69945 */ // Label 1130: @69945
     /*  69945 */ GIM_Reject,
     /*  69946 */ // Label 1019: @69946
     /*  69946 */ GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71253),
     /*  69951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69957 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(70066), // Rule ID 13586 //
     /*  69962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70010 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70016 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70023 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70027 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70031 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70035 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70040 */     // MIs[4] LHS
     /*  70040 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70047 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70064 */     GIR_RootConstrainSelectedInstOperands,
     /*  70065 */     // GIR_Coverage, 13586,
     /*  70065 */     GIR_EraseRootFromParent_Done,
     /*  70066 */   // Label 1147: @70066
     /*  70066 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(70175), // Rule ID 13585 //
     /*  70071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70119 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70136 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70140 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70144 */     // MIs[4] LHS
     /*  70144 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70149 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70156 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70173 */     GIR_RootConstrainSelectedInstOperands,
     /*  70174 */     // GIR_Coverage, 13585,
     /*  70174 */     GIR_EraseRootFromParent_Done,
     /*  70175 */   // Label 1148: @70175
     /*  70175 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70284), // Rule ID 13588 //
     /*  70180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70241 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70245 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70249 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70253 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70258 */     // MIs[4] LHS
     /*  70258 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70265 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70282 */     GIR_RootConstrainSelectedInstOperands,
     /*  70283 */     // GIR_Coverage, 13588,
     /*  70283 */     GIR_EraseRootFromParent_Done,
     /*  70284 */   // Label 1149: @70284
     /*  70284 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70393), // Rule ID 13587 //
     /*  70289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70342 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70362 */     // MIs[4] LHS
     /*  70362 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70367 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70372 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70374 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70391 */     GIR_RootConstrainSelectedInstOperands,
     /*  70392 */     // GIR_Coverage, 13587,
     /*  70392 */     GIR_EraseRootFromParent_Done,
     /*  70393 */   // Label 1150: @70393
     /*  70393 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70502), // Rule ID 2472 //
     /*  70398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70455 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70459 */     // MIs[3] LHS
     /*  70459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70481 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70483 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70500 */     GIR_RootConstrainSelectedInstOperands,
     /*  70501 */     // GIR_Coverage, 2472,
     /*  70501 */     GIR_EraseRootFromParent_Done,
     /*  70502 */   // Label 1151: @70502
     /*  70502 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70611), // Rule ID 13583 //
     /*  70507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70568 */     // MIs[3] LHS
     /*  70568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70577 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70583 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70590 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70592 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70609 */     GIR_RootConstrainSelectedInstOperands,
     /*  70610 */     // GIR_Coverage, 13583,
     /*  70610 */     GIR_EraseRootFromParent_Done,
     /*  70611 */   // Label 1152: @70611
     /*  70611 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70720), // Rule ID 13582 //
     /*  70616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70682 */     // MIs[3] LHS
     /*  70682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70691 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70701 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70718 */     GIR_RootConstrainSelectedInstOperands,
     /*  70719 */     // GIR_Coverage, 13582,
     /*  70719 */     GIR_EraseRootFromParent_Done,
     /*  70720 */   // Label 1153: @70720
     /*  70720 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70829), // Rule ID 13584 //
     /*  70725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70787 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70791 */     // MIs[3] LHS
     /*  70791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70808 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70810 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70827 */     GIR_RootConstrainSelectedInstOperands,
     /*  70828 */     // GIR_Coverage, 13584,
     /*  70828 */     GIR_EraseRootFromParent_Done,
     /*  70829 */   // Label 1154: @70829
     /*  70829 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70896), // Rule ID 13533 //
     /*  70834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70858 */     // MIs[1] imm
     /*  70858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70870 */     // MIs[2] Operand 1
     /*  70870 */     // No operand predicates
     /*  70870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70880 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70894 */     GIR_RootConstrainSelectedInstOperands,
     /*  70895 */     // GIR_Coverage, 13533,
     /*  70895 */     GIR_EraseRootFromParent_Done,
     /*  70896 */   // Label 1155: @70896
     /*  70896 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70963), // Rule ID 13554 //
     /*  70901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70925 */     // MIs[1] imm
     /*  70925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70937 */     // MIs[2] Operand 1
     /*  70937 */     // No operand predicates
     /*  70937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70947 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70961 */     GIR_RootConstrainSelectedInstOperands,
     /*  70962 */     // GIR_Coverage, 13554,
     /*  70962 */     GIR_EraseRootFromParent_Done,
     /*  70963 */   // Label 1156: @70963
     /*  70963 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71030), // Rule ID 2237 //
     /*  70968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70996 */     // MIs[1] imm
     /*  70996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71008 */     // MIs[2] Operand 1
     /*  71008 */     // No operand predicates
     /*  71008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71014 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71028 */     GIR_RootConstrainSelectedInstOperands,
     /*  71029 */     // GIR_Coverage, 2237,
     /*  71029 */     GIR_EraseRootFromParent_Done,
     /*  71030 */   // Label 1157: @71030
     /*  71030 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71097), // Rule ID 2296 //
     /*  71035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71063 */     // MIs[1] imm
     /*  71063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71075 */     // MIs[2] Operand 1
     /*  71075 */     // No operand predicates
     /*  71075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71081 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71095 */     GIR_RootConstrainSelectedInstOperands,
     /*  71096 */     // GIR_Coverage, 2296,
     /*  71096 */     GIR_EraseRootFromParent_Done,
     /*  71097 */   // Label 1158: @71097
     /*  71097 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71161), // Rule ID 13871 //
     /*  71102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71134 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71148 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71153 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71159 */     GIR_RootConstrainSelectedInstOperands,
     /*  71160 */     // GIR_Coverage, 13871,
     /*  71160 */     GIR_EraseRootFromParent_Done,
     /*  71161 */   // Label 1159: @71161
     /*  71161 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71225), // Rule ID 5057 //
     /*  71166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71202 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71208 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71212 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71217 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71223 */     GIR_RootConstrainSelectedInstOperands,
     /*  71224 */     // GIR_Coverage, 5057,
     /*  71224 */     GIR_EraseRootFromParent_Done,
     /*  71225 */   // Label 1160: @71225
     /*  71225 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71252), // Rule ID 5063 //
     /*  71230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71245 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71250 */     GIR_RootConstrainSelectedInstOperands,
     /*  71251 */     // GIR_Coverage, 5063,
     /*  71251 */     GIR_Done,
     /*  71252 */   // Label 1161: @71252
     /*  71252 */   GIM_Reject,
     /*  71253 */ // Label 1146: @71253
     /*  71253 */ GIM_Reject,
     /*  71254 */ // Label 1020: @71254
     /*  71254 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72561),
     /*  71259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71265 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71374), // Rule ID 13360 //
     /*  71270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71318 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71331 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71335 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71339 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71343 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71348 */     // MIs[4] Rd
     /*  71348 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71353 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71355 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71372 */     GIR_RootConstrainSelectedInstOperands,
     /*  71373 */     // GIR_Coverage, 13360,
     /*  71373 */     GIR_EraseRootFromParent_Done,
     /*  71374 */   // Label 1163: @71374
     /*  71374 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(71483), // Rule ID 13359 //
     /*  71379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71452 */     // MIs[4] Rd
     /*  71452 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71457 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71464 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71481 */     GIR_RootConstrainSelectedInstOperands,
     /*  71482 */     // GIR_Coverage, 13359,
     /*  71482 */     GIR_EraseRootFromParent_Done,
     /*  71483 */   // Label 1164: @71483
     /*  71483 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71592), // Rule ID 13362 //
     /*  71488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71557 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71561 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71566 */     // MIs[4] Rd
     /*  71566 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71573 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71590 */     GIR_RootConstrainSelectedInstOperands,
     /*  71591 */     // GIR_Coverage, 13362,
     /*  71591 */     GIR_EraseRootFromParent_Done,
     /*  71592 */   // Label 1165: @71592
     /*  71592 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71701), // Rule ID 13361 //
     /*  71597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71662 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71666 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71670 */     // MIs[4] Rd
     /*  71670 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71675 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71680 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71682 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71699 */     GIR_RootConstrainSelectedInstOperands,
     /*  71700 */     // GIR_Coverage, 13361,
     /*  71700 */     GIR_EraseRootFromParent_Done,
     /*  71701 */   // Label 1166: @71701
     /*  71701 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71810), // Rule ID 1606 //
     /*  71706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71767 */     // MIs[3] Rd
     /*  71767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71776 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71782 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71789 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71791 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71808 */     GIR_RootConstrainSelectedInstOperands,
     /*  71809 */     // GIR_Coverage, 1606,
     /*  71809 */     GIR_EraseRootFromParent_Done,
     /*  71810 */   // Label 1167: @71810
     /*  71810 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71919), // Rule ID 13357 //
     /*  71815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71876 */     // MIs[3] Rd
     /*  71876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71881 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71885 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71898 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71900 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71917 */     GIR_RootConstrainSelectedInstOperands,
     /*  71918 */     // GIR_Coverage, 13357,
     /*  71918 */     GIR_EraseRootFromParent_Done,
     /*  71919 */   // Label 1168: @71919
     /*  71919 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72028), // Rule ID 13356 //
     /*  71924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71986 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71990 */     // MIs[3] Rd
     /*  71990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71999 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72007 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72009 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72026 */     GIR_RootConstrainSelectedInstOperands,
     /*  72027 */     // GIR_Coverage, 13356,
     /*  72027 */     GIR_EraseRootFromParent_Done,
     /*  72028 */   // Label 1169: @72028
     /*  72028 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72137), // Rule ID 13358 //
     /*  72033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72099 */     // MIs[3] Rd
     /*  72099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72118 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72135 */     GIR_RootConstrainSelectedInstOperands,
     /*  72136 */     // GIR_Coverage, 13358,
     /*  72136 */     GIR_EraseRootFromParent_Done,
     /*  72137 */   // Label 1170: @72137
     /*  72137 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72204), // Rule ID 13529 //
     /*  72142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72166 */     // MIs[1] imm
     /*  72166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72178 */     // MIs[2] Operand 1
     /*  72178 */     // No operand predicates
     /*  72178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72188 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72202 */     GIR_RootConstrainSelectedInstOperands,
     /*  72203 */     // GIR_Coverage, 13529,
     /*  72203 */     GIR_EraseRootFromParent_Done,
     /*  72204 */   // Label 1171: @72204
     /*  72204 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72271), // Rule ID 13550 //
     /*  72209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72233 */     // MIs[1] imm
     /*  72233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72245 */     // MIs[2] Operand 1
     /*  72245 */     // No operand predicates
     /*  72245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72255 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72269 */     GIR_RootConstrainSelectedInstOperands,
     /*  72270 */     // GIR_Coverage, 13550,
     /*  72270 */     GIR_EraseRootFromParent_Done,
     /*  72271 */   // Label 1172: @72271
     /*  72271 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72338), // Rule ID 2233 //
     /*  72276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72304 */     // MIs[1] imm
     /*  72304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72316 */     // MIs[2] Operand 1
     /*  72316 */     // No operand predicates
     /*  72316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72322 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72336 */     GIR_RootConstrainSelectedInstOperands,
     /*  72337 */     // GIR_Coverage, 2233,
     /*  72337 */     GIR_EraseRootFromParent_Done,
     /*  72338 */   // Label 1173: @72338
     /*  72338 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72405), // Rule ID 2292 //
     /*  72343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72371 */     // MIs[1] imm
     /*  72371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72383 */     // MIs[2] Operand 1
     /*  72383 */     // No operand predicates
     /*  72383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72389 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72403 */     GIR_RootConstrainSelectedInstOperands,
     /*  72404 */     // GIR_Coverage, 2292,
     /*  72404 */     GIR_EraseRootFromParent_Done,
     /*  72405 */   // Label 1174: @72405
     /*  72405 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72469), // Rule ID 13348 //
     /*  72410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72442 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72456 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72467 */     GIR_RootConstrainSelectedInstOperands,
     /*  72468 */     // GIR_Coverage, 13348,
     /*  72468 */     GIR_EraseRootFromParent_Done,
     /*  72469 */   // Label 1175: @72469
     /*  72469 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72533), // Rule ID 1602 //
     /*  72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72510 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72520 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72531 */     GIR_RootConstrainSelectedInstOperands,
     /*  72532 */     // GIR_Coverage, 1602,
     /*  72532 */     GIR_EraseRootFromParent_Done,
     /*  72533 */   // Label 1176: @72533
     /*  72533 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72560), // Rule ID 1604 //
     /*  72538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72553 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72558 */     GIR_RootConstrainSelectedInstOperands,
     /*  72559 */     // GIR_Coverage, 1604,
     /*  72559 */     GIR_Done,
     /*  72560 */   // Label 1177: @72560
     /*  72560 */   GIM_Reject,
     /*  72561 */ // Label 1162: @72561
     /*  72561 */ GIM_Reject,
     /*  72562 */ // Label 1021: @72562
     /*  72562 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72593), // Rule ID 8432 //
     /*  72567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72580 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72585 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72587 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72589 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72591 */   GIR_RootConstrainSelectedInstOperands,
     /*  72592 */   // GIR_Coverage, 8432,
     /*  72592 */   GIR_EraseRootFromParent_Done,
     /*  72593 */ // Label 1178: @72593
     /*  72593 */ GIM_Reject,
     /*  72594 */ // Label 1022: @72594
     /*  72594 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72625), // Rule ID 8431 //
     /*  72599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72612 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72617 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72619 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72621 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72623 */   GIR_RootConstrainSelectedInstOperands,
     /*  72624 */   // GIR_Coverage, 8431,
     /*  72624 */   GIR_EraseRootFromParent_Done,
     /*  72625 */ // Label 1179: @72625
     /*  72625 */ GIM_Reject,
     /*  72626 */ // Label 1023: @72626
     /*  72626 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72651), // Rule ID 7437 //
     /*  72631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72644 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  72644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72649 */   GIR_RootConstrainSelectedInstOperands,
     /*  72650 */   // GIR_Coverage, 7437,
     /*  72650 */   GIR_Done,
     /*  72651 */ // Label 1180: @72651
     /*  72651 */ GIM_Reject,
     /*  72652 */ // Label 1024: @72652
     /*  72652 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72683), // Rule ID 8430 //
     /*  72657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  72663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  72666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72670 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  72670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72675 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72677 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72679 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72681 */   GIR_RootConstrainSelectedInstOperands,
     /*  72682 */   // GIR_Coverage, 8430,
     /*  72682 */   GIR_EraseRootFromParent_Done,
     /*  72683 */ // Label 1181: @72683
     /*  72683 */ GIM_Reject,
     /*  72684 */ // Label 1025: @72684
     /*  72684 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72709), // Rule ID 7436 //
     /*  72689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72702 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72707 */   GIR_RootConstrainSelectedInstOperands,
     /*  72708 */   // GIR_Coverage, 7436,
     /*  72708 */   GIR_Done,
     /*  72709 */ // Label 1182: @72709
     /*  72709 */ GIM_Reject,
     /*  72710 */ // Label 1026: @72710
     /*  72710 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72741), // Rule ID 8429 //
     /*  72715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72728 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72733 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72735 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72737 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72739 */   GIR_RootConstrainSelectedInstOperands,
     /*  72740 */   // GIR_Coverage, 8429,
     /*  72740 */   GIR_EraseRootFromParent_Done,
     /*  72741 */ // Label 1183: @72741
     /*  72741 */ GIM_Reject,
     /*  72742 */ // Label 1027: @72742
     /*  72742 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72767), // Rule ID 7435 //
     /*  72747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72760 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72765 */   GIR_RootConstrainSelectedInstOperands,
     /*  72766 */   // GIR_Coverage, 7435,
     /*  72766 */   GIR_Done,
     /*  72767 */ // Label 1184: @72767
     /*  72767 */ GIM_Reject,
     /*  72768 */ // Label 1028: @72768
     /*  72768 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72799), // Rule ID 8428 //
     /*  72773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72786 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72791 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72795 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72797 */   GIR_RootConstrainSelectedInstOperands,
     /*  72798 */   // GIR_Coverage, 8428,
     /*  72798 */   GIR_EraseRootFromParent_Done,
     /*  72799 */ // Label 1185: @72799
     /*  72799 */ GIM_Reject,
     /*  72800 */ // Label 1029: @72800
     /*  72800 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(72825), // Rule ID 7434 //
     /*  72805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72818 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72823 */   GIR_RootConstrainSelectedInstOperands,
     /*  72824 */   // GIR_Coverage, 7434,
     /*  72824 */   GIR_Done,
     /*  72825 */ // Label 1186: @72825
     /*  72825 */ GIM_Reject,
     /*  72826 */ // Label 1030: @72826
     /*  72826 */ GIM_Reject,
     /*  72827 */ // Label 7: @72827
     /*  72827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1205*/ GIMT_Encode4(80018),
     /*  72838 */ /*GILLT_s32*//*Label 1187*/ GIMT_Encode4(72926),
     /*  72842 */ /*GILLT_s64*//*Label 1188*/ GIMT_Encode4(73606), GIMT_Encode4(0),
     /*  72850 */ /*GILLT_v2s32*//*Label 1189*/ GIMT_Encode4(74449),
     /*  72854 */ /*GILLT_v2s64*//*Label 1190*/ GIMT_Encode4(74684),
     /*  72858 */ /*GILLT_v4s16*//*Label 1191*/ GIMT_Encode4(75373),
     /*  72862 */ /*GILLT_v4s32*//*Label 1192*/ GIMT_Encode4(75608),
     /*  72866 */ /*GILLT_v8s8*//*Label 1193*/ GIMT_Encode4(76297),
     /*  72870 */ /*GILLT_v8s16*//*Label 1194*/ GIMT_Encode4(76535),
     /*  72874 */ /*GILLT_v16s8*//*Label 1195*/ GIMT_Encode4(77224),
     /*  72878 */ /*GILLT_nxv1s1*//*Label 1196*/ GIMT_Encode4(77916),
     /*  72882 */ /*GILLT_nxv2s1*//*Label 1197*/ GIMT_Encode4(77966), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72894 */ /*GILLT_nxv2s64*//*Label 1198*/ GIMT_Encode4(78016),
     /*  72898 */ /*GILLT_nxv4s1*//*Label 1199*/ GIMT_Encode4(78479), GIMT_Encode4(0),
     /*  72906 */ /*GILLT_nxv4s32*//*Label 1200*/ GIMT_Encode4(78529),
     /*  72910 */ /*GILLT_nxv8s1*//*Label 1201*/ GIMT_Encode4(78992),
     /*  72914 */ /*GILLT_nxv8s16*//*Label 1202*/ GIMT_Encode4(79042),
     /*  72918 */ /*GILLT_nxv16s1*//*Label 1203*/ GIMT_Encode4(79505),
     /*  72922 */ /*GILLT_nxv16s8*//*Label 1204*/ GIMT_Encode4(79555),
     /*  72926 */ // Label 1187: @72926
     /*  72926 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(73605),
     /*  72931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72937 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(72995), // Rule ID 13218 //
     /*  72942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72980 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72993 */     GIR_RootConstrainSelectedInstOperands,
     /*  72994 */     // GIR_Coverage, 13218,
     /*  72994 */     GIR_EraseRootFromParent_Done,
     /*  72995 */   // Label 1207: @72995
     /*  72995 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(73050), // Rule ID 13217 //
     /*  73000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73037 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73048 */     GIR_RootConstrainSelectedInstOperands,
     /*  73049 */     // GIR_Coverage, 13217,
     /*  73049 */     GIR_EraseRootFromParent_Done,
     /*  73050 */   // Label 1208: @73050
     /*  73050 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(73108), // Rule ID 13215 //
     /*  73055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73093 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73106 */     GIR_RootConstrainSelectedInstOperands,
     /*  73107 */     // GIR_Coverage, 13215,
     /*  73107 */     GIR_EraseRootFromParent_Done,
     /*  73108 */   // Label 1209: @73108
     /*  73108 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(73166), // Rule ID 166 //
     /*  73113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73151 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73164 */     GIR_RootConstrainSelectedInstOperands,
     /*  73165 */     // GIR_Coverage, 166,
     /*  73165 */     GIR_EraseRootFromParent_Done,
     /*  73166 */   // Label 1210: @73166
     /*  73166 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(73224), // Rule ID 13216 //
     /*  73171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73209 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73222 */     GIR_RootConstrainSelectedInstOperands,
     /*  73223 */     // GIR_Coverage, 13216,
     /*  73223 */     GIR_EraseRootFromParent_Done,
     /*  73224 */   // Label 1211: @73224
     /*  73224 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(73279), // Rule ID 13219 //
     /*  73229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73253 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73266 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73277 */     GIR_RootConstrainSelectedInstOperands,
     /*  73278 */     // GIR_Coverage, 13219,
     /*  73278 */     GIR_EraseRootFromParent_Done,
     /*  73279 */   // Label 1212: @73279
     /*  73279 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(73320), // Rule ID 144 //
     /*  73284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  73288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73300 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  73304 */     // MIs[1] Operand 1
     /*  73304 */     // No operand predicates
     /*  73304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73306 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  73306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  73309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73313 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  73318 */     GIR_RootConstrainSelectedInstOperands,
     /*  73319 */     // GIR_Coverage, 144,
     /*  73319 */     GIR_EraseRootFromParent_Done,
     /*  73320 */   // Label 1213: @73320
     /*  73320 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(73353), // Rule ID 13225 //
     /*  73325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73340 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73351 */     GIR_RootConstrainSelectedInstOperands,
     /*  73352 */     // GIR_Coverage, 13225,
     /*  73352 */     GIR_EraseRootFromParent_Done,
     /*  73353 */   // Label 1214: @73353
     /*  73353 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(73386), // Rule ID 170 //
     /*  73358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73373 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73384 */     GIR_RootConstrainSelectedInstOperands,
     /*  73385 */     // GIR_Coverage, 170,
     /*  73385 */     GIR_EraseRootFromParent_Done,
     /*  73386 */   // Label 1215: @73386
     /*  73386 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(73439), // Rule ID 13211 //
     /*  73391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73426 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73437 */     GIR_RootConstrainSelectedInstOperands,
     /*  73438 */     // GIR_Coverage, 13211,
     /*  73438 */     GIR_EraseRootFromParent_Done,
     /*  73439 */   // Label 1216: @73439
     /*  73439 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(73495), // Rule ID 164 //
     /*  73444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73480 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73493 */     GIR_RootConstrainSelectedInstOperands,
     /*  73494 */     // GIR_Coverage, 164,
     /*  73494 */     GIR_EraseRootFromParent_Done,
     /*  73495 */   // Label 1217: @73495
     /*  73495 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73548), // Rule ID 13212 //
     /*  73500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73529 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73535 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73546 */     GIR_RootConstrainSelectedInstOperands,
     /*  73547 */     // GIR_Coverage, 13212,
     /*  73547 */     GIR_EraseRootFromParent_Done,
     /*  73548 */   // Label 1218: @73548
     /*  73548 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73580), // Rule ID 4002 //
     /*  73553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73565 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  73565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  73568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  73578 */     GIR_RootConstrainSelectedInstOperands,
     /*  73579 */     // GIR_Coverage, 4002,
     /*  73579 */     GIR_EraseRootFromParent_Done,
     /*  73580 */   // Label 1219: @73580
     /*  73580 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73604), // Rule ID 168 //
     /*  73585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73597 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  73602 */     GIR_RootConstrainSelectedInstOperands,
     /*  73603 */     // GIR_Coverage, 168,
     /*  73603 */     GIR_Done,
     /*  73604 */   // Label 1220: @73604
     /*  73604 */   GIM_Reject,
     /*  73605 */ // Label 1206: @73605
     /*  73605 */ GIM_Reject,
     /*  73606 */ // Label 1188: @73606
     /*  73606 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(74448),
     /*  73611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  73614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  73617 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73675), // Rule ID 13223 //
     /*  73622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73660 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73673 */     GIR_RootConstrainSelectedInstOperands,
     /*  73674 */     // GIR_Coverage, 13223,
     /*  73674 */     GIR_EraseRootFromParent_Done,
     /*  73675 */   // Label 1222: @73675
     /*  73675 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73730), // Rule ID 13222 //
     /*  73680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73717 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73728 */     GIR_RootConstrainSelectedInstOperands,
     /*  73729 */     // GIR_Coverage, 13222,
     /*  73729 */     GIR_EraseRootFromParent_Done,
     /*  73730 */   // Label 1223: @73730
     /*  73730 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73788), // Rule ID 13220 //
     /*  73735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73773 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73786 */     GIR_RootConstrainSelectedInstOperands,
     /*  73787 */     // GIR_Coverage, 13220,
     /*  73787 */     GIR_EraseRootFromParent_Done,
     /*  73788 */   // Label 1224: @73788
     /*  73788 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73846), // Rule ID 167 //
     /*  73793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73831 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73844 */     GIR_RootConstrainSelectedInstOperands,
     /*  73845 */     // GIR_Coverage, 167,
     /*  73845 */     GIR_EraseRootFromParent_Done,
     /*  73846 */   // Label 1225: @73846
     /*  73846 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73904), // Rule ID 13221 //
     /*  73851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73876 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73889 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73902 */     GIR_RootConstrainSelectedInstOperands,
     /*  73903 */     // GIR_Coverage, 13221,
     /*  73903 */     GIR_EraseRootFromParent_Done,
     /*  73904 */   // Label 1226: @73904
     /*  73904 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73959), // Rule ID 13224 //
     /*  73909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73946 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73957 */     GIR_RootConstrainSelectedInstOperands,
     /*  73958 */     // GIR_Coverage, 13224,
     /*  73958 */     GIR_EraseRootFromParent_Done,
     /*  73959 */   // Label 1227: @73959
     /*  73959 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(74059), // Rule ID 1613 //
     /*  73964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73983 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73987 */     // MIs[1] Operand 1
     /*  73987 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  74004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  74008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74022 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74028 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74034 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74042 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74044 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  74044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  74047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74057 */     GIR_RootConstrainSelectedInstOperands,
     /*  74058 */     // GIR_Coverage, 1613,
     /*  74058 */     GIR_EraseRootFromParent_Done,
     /*  74059 */   // Label 1228: @74059
     /*  74059 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(74100), // Rule ID 145 //
     /*  74064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  74068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74080 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  74084 */     // MIs[1] Operand 1
     /*  74084 */     // No operand predicates
     /*  74084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74086 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  74086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  74089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74093 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  74098 */     GIR_RootConstrainSelectedInstOperands,
     /*  74099 */     // GIR_Coverage, 145,
     /*  74099 */     GIR_EraseRootFromParent_Done,
     /*  74100 */   // Label 1229: @74100
     /*  74100 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(74133), // Rule ID 13226 //
     /*  74105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74120 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  74127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74131 */     GIR_RootConstrainSelectedInstOperands,
     /*  74132 */     // GIR_Coverage, 13226,
     /*  74132 */     GIR_EraseRootFromParent_Done,
     /*  74133 */   // Label 1230: @74133
     /*  74133 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(74166), // Rule ID 171 //
     /*  74138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  74153 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  74153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  74156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  74164 */     GIR_RootConstrainSelectedInstOperands,
     /*  74165 */     // GIR_Coverage, 171,
     /*  74165 */     GIR_EraseRootFromParent_Done,
     /*  74166 */   // Label 1231: @74166
     /*  74166 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(74219), // Rule ID 13213 //
     /*  74171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74206 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  74217 */     GIR_RootConstrainSelectedInstOperands,
     /*  74218 */     // GIR_Coverage, 13213,
     /*  74218 */     GIR_EraseRootFromParent_Done,
     /*  74219 */   // Label 1232: @74219
     /*  74219 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(74275), // Rule ID 165 //
     /*  74224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74260 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  74273 */     GIR_RootConstrainSelectedInstOperands,
     /*  74274 */     // GIR_Coverage, 165,
     /*  74274 */     GIR_EraseRootFromParent_Done,
     /*  74275 */   // Label 1233: @74275
     /*  74275 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(74328), // Rule ID 13214 //
     /*  74280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74309 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74315 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  74326 */     GIR_RootConstrainSelectedInstOperands,
     /*  74327 */     // GIR_Coverage, 13214,
     /*  74327 */     GIR_EraseRootFromParent_Done,
     /*  74328 */   // Label 1234: @74328
     /*  74328 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(74360), // Rule ID 4003 //
     /*  74333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74345 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  74345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  74348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  74358 */     GIR_RootConstrainSelectedInstOperands,
     /*  74359 */     // GIR_Coverage, 4003,
     /*  74359 */     GIR_EraseRootFromParent_Done,
     /*  74360 */   // Label 1235: @74360
     /*  74360 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(74396), // Rule ID 4951 //
     /*  74365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74387 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  74387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74394 */     GIR_RootConstrainSelectedInstOperands,
     /*  74395 */     // GIR_Coverage, 4951,
     /*  74395 */     GIR_EraseRootFromParent_Done,
     /*  74396 */   // Label 1236: @74396
     /*  74396 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(74420), // Rule ID 169 //
     /*  74401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74413 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  74418 */     GIR_RootConstrainSelectedInstOperands,
     /*  74419 */     // GIR_Coverage, 169,
     /*  74419 */     GIR_Done,
     /*  74420 */   // Label 1237: @74420
     /*  74420 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(74447), // Rule ID 5050 //
     /*  74425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74440 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  74440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74445 */     GIR_RootConstrainSelectedInstOperands,
     /*  74446 */     // GIR_Coverage, 5050,
     /*  74446 */     GIR_Done,
     /*  74447 */   // Label 1238: @74447
     /*  74447 */   GIM_Reject,
     /*  74448 */ // Label 1221: @74448
     /*  74448 */ GIM_Reject,
     /*  74449 */ // Label 1189: @74449
     /*  74449 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(74683),
     /*  74454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74464 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74560), // Rule ID 1160 //
     /*  74469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74484 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74488 */     // MIs[1] Operand 1
     /*  74488 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74523 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74531 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74535 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74545 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  74545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74558 */     GIR_RootConstrainSelectedInstOperands,
     /*  74559 */     // GIR_Coverage, 1160,
     /*  74559 */     GIR_EraseRootFromParent_Done,
     /*  74560 */   // Label 1240: @74560
     /*  74560 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74627), // Rule ID 4998 //
     /*  74565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74577 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74581 */     // MIs[1] Operand 1
     /*  74581 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74590 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74602 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74612 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  74612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74625 */     GIR_RootConstrainSelectedInstOperands,
     /*  74626 */     // GIR_Coverage, 4998,
     /*  74626 */     GIR_EraseRootFromParent_Done,
     /*  74627 */   // Label 1241: @74627
     /*  74627 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74659), // Rule ID 4949 //
     /*  74632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74640 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74646 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74650 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  74650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74657 */     GIR_RootConstrainSelectedInstOperands,
     /*  74658 */     // GIR_Coverage, 4949,
     /*  74658 */     GIR_EraseRootFromParent_Done,
     /*  74659 */   // Label 1242: @74659
     /*  74659 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74682), // Rule ID 5049 //
     /*  74664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74675 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  74675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74680 */     GIR_RootConstrainSelectedInstOperands,
     /*  74681 */     // GIR_Coverage, 5049,
     /*  74681 */     GIR_Done,
     /*  74682 */   // Label 1243: @74682
     /*  74682 */   GIM_Reject,
     /*  74683 */ // Label 1239: @74683
     /*  74683 */ GIM_Reject,
     /*  74684 */ // Label 1190: @74684
     /*  74684 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(75372),
     /*  74689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74699 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74795), // Rule ID 1162 //
     /*  74704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74723 */     // MIs[1] Operand 1
     /*  74723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74758 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74780 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74793 */     GIR_RootConstrainSelectedInstOperands,
     /*  74794 */     // GIR_Coverage, 1162,
     /*  74794 */     GIR_EraseRootFromParent_Done,
     /*  74795 */   // Label 1245: @74795
     /*  74795 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74862), // Rule ID 5000 //
     /*  74800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74812 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74816 */     // MIs[1] Operand 1
     /*  74816 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74825 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74837 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74847 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74860 */     GIR_RootConstrainSelectedInstOperands,
     /*  74861 */     // GIR_Coverage, 5000,
     /*  74861 */     GIR_EraseRootFromParent_Done,
     /*  74862 */   // Label 1246: @74862
     /*  74862 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74947), // Rule ID 13748 //
     /*  74867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74911 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74917 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74930 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74945 */     GIR_RootConstrainSelectedInstOperands,
     /*  74946 */     // GIR_Coverage, 13748,
     /*  74946 */     GIR_EraseRootFromParent_Done,
     /*  74947 */   // Label 1247: @74947
     /*  74947 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(75032), // Rule ID 13747 //
     /*  74952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75001 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75015 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75030 */     GIR_RootConstrainSelectedInstOperands,
     /*  75031 */     // GIR_Coverage, 13747,
     /*  75031 */     GIR_EraseRootFromParent_Done,
     /*  75032 */   // Label 1248: @75032
     /*  75032 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(75117), // Rule ID 13746 //
     /*  75037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75085 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75091 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75100 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75115 */     GIR_RootConstrainSelectedInstOperands,
     /*  75116 */     // GIR_Coverage, 13746,
     /*  75116 */     GIR_EraseRootFromParent_Done,
     /*  75117 */   // Label 1249: @75117
     /*  75117 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(75202), // Rule ID 3830 //
     /*  75122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75185 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75200 */     GIR_RootConstrainSelectedInstOperands,
     /*  75201 */     // GIR_Coverage, 3830,
     /*  75201 */     GIR_EraseRootFromParent_Done,
     /*  75202 */   // Label 1250: @75202
     /*  75202 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(75234), // Rule ID 4952 //
     /*  75207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75225 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  75225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75232 */     GIR_RootConstrainSelectedInstOperands,
     /*  75233 */     // GIR_Coverage, 4952,
     /*  75233 */     GIR_EraseRootFromParent_Done,
     /*  75234 */   // Label 1251: @75234
     /*  75234 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(75291), // Rule ID 3826 //
     /*  75239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75274 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75289 */     GIR_RootConstrainSelectedInstOperands,
     /*  75290 */     // GIR_Coverage, 3826,
     /*  75290 */     GIR_EraseRootFromParent_Done,
     /*  75291 */   // Label 1252: @75291
     /*  75291 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(75348), // Rule ID 13736 //
     /*  75296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75331 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75346 */     GIR_RootConstrainSelectedInstOperands,
     /*  75347 */     // GIR_Coverage, 13736,
     /*  75347 */     GIR_EraseRootFromParent_Done,
     /*  75348 */   // Label 1253: @75348
     /*  75348 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(75371), // Rule ID 5053 //
     /*  75353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75364 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  75364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75369 */     GIR_RootConstrainSelectedInstOperands,
     /*  75370 */     // GIR_Coverage, 5053,
     /*  75370 */     GIR_Done,
     /*  75371 */   // Label 1254: @75371
     /*  75371 */   GIM_Reject,
     /*  75372 */ // Label 1244: @75372
     /*  75372 */ GIM_Reject,
     /*  75373 */ // Label 1191: @75373
     /*  75373 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(75607),
     /*  75378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75388 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(75484), // Rule ID 1158 //
     /*  75393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75408 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75412 */     // MIs[1] Operand 1
     /*  75412 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75447 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75459 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75467 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75469 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  75469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75482 */     GIR_RootConstrainSelectedInstOperands,
     /*  75483 */     // GIR_Coverage, 1158,
     /*  75483 */     GIR_EraseRootFromParent_Done,
     /*  75484 */   // Label 1256: @75484
     /*  75484 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(75551), // Rule ID 4996 //
     /*  75489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75501 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75505 */     // MIs[1] Operand 1
     /*  75505 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75514 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75526 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75536 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  75536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75549 */     GIR_RootConstrainSelectedInstOperands,
     /*  75550 */     // GIR_Coverage, 4996,
     /*  75550 */     GIR_EraseRootFromParent_Done,
     /*  75551 */   // Label 1257: @75551
     /*  75551 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(75583), // Rule ID 4947 //
     /*  75556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75574 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  75574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75581 */     GIR_RootConstrainSelectedInstOperands,
     /*  75582 */     // GIR_Coverage, 4947,
     /*  75582 */     GIR_EraseRootFromParent_Done,
     /*  75583 */   // Label 1258: @75583
     /*  75583 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75606), // Rule ID 5048 //
     /*  75588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75599 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  75599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75604 */     GIR_RootConstrainSelectedInstOperands,
     /*  75605 */     // GIR_Coverage, 5048,
     /*  75605 */     GIR_Done,
     /*  75606 */   // Label 1259: @75606
     /*  75606 */   GIM_Reject,
     /*  75607 */ // Label 1255: @75607
     /*  75607 */ GIM_Reject,
     /*  75608 */ // Label 1192: @75608
     /*  75608 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(76296),
     /*  75613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75623 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75719), // Rule ID 1161 //
     /*  75628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75647 */     // MIs[1] Operand 1
     /*  75647 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75682 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75694 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75700 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75702 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75704 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75717 */     GIR_RootConstrainSelectedInstOperands,
     /*  75718 */     // GIR_Coverage, 1161,
     /*  75718 */     GIR_EraseRootFromParent_Done,
     /*  75719 */   // Label 1261: @75719
     /*  75719 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75786), // Rule ID 4999 //
     /*  75724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75740 */     // MIs[1] Operand 1
     /*  75740 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75749 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75755 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75761 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75771 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75784 */     GIR_RootConstrainSelectedInstOperands,
     /*  75785 */     // GIR_Coverage, 4999,
     /*  75785 */     GIR_EraseRootFromParent_Done,
     /*  75786 */   // Label 1262: @75786
     /*  75786 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75871), // Rule ID 13745 //
     /*  75791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75835 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75841 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75854 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75869 */     GIR_RootConstrainSelectedInstOperands,
     /*  75870 */     // GIR_Coverage, 13745,
     /*  75870 */     GIR_EraseRootFromParent_Done,
     /*  75871 */   // Label 1263: @75871
     /*  75871 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75956), // Rule ID 13744 //
     /*  75876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75939 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75954 */     GIR_RootConstrainSelectedInstOperands,
     /*  75955 */     // GIR_Coverage, 13744,
     /*  75955 */     GIR_EraseRootFromParent_Done,
     /*  75956 */   // Label 1264: @75956
     /*  75956 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(76041), // Rule ID 13743 //
     /*  75961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76009 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76024 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76039 */     GIR_RootConstrainSelectedInstOperands,
     /*  76040 */     // GIR_Coverage, 13743,
     /*  76040 */     GIR_EraseRootFromParent_Done,
     /*  76041 */   // Label 1265: @76041
     /*  76041 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(76126), // Rule ID 3829 //
     /*  76046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76099 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76105 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76109 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76124 */     GIR_RootConstrainSelectedInstOperands,
     /*  76125 */     // GIR_Coverage, 3829,
     /*  76125 */     GIR_EraseRootFromParent_Done,
     /*  76126 */   // Label 1266: @76126
     /*  76126 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(76158), // Rule ID 4950 //
     /*  76131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76139 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76149 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  76149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76156 */     GIR_RootConstrainSelectedInstOperands,
     /*  76157 */     // GIR_Coverage, 4950,
     /*  76157 */     GIR_EraseRootFromParent_Done,
     /*  76158 */   // Label 1267: @76158
     /*  76158 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(76215), // Rule ID 3825 //
     /*  76163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76198 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76213 */     GIR_RootConstrainSelectedInstOperands,
     /*  76214 */     // GIR_Coverage, 3825,
     /*  76214 */     GIR_EraseRootFromParent_Done,
     /*  76215 */   // Label 1268: @76215
     /*  76215 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(76272), // Rule ID 13735 //
     /*  76220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76255 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76270 */     GIR_RootConstrainSelectedInstOperands,
     /*  76271 */     // GIR_Coverage, 13735,
     /*  76271 */     GIR_EraseRootFromParent_Done,
     /*  76272 */   // Label 1269: @76272
     /*  76272 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(76295), // Rule ID 5052 //
     /*  76277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76288 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  76288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76293 */     GIR_RootConstrainSelectedInstOperands,
     /*  76294 */     // GIR_Coverage, 5052,
     /*  76294 */     GIR_Done,
     /*  76295 */   // Label 1270: @76295
     /*  76295 */   GIM_Reject,
     /*  76296 */ // Label 1260: @76296
     /*  76296 */ GIM_Reject,
     /*  76297 */ // Label 1193: @76297
     /*  76297 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(76534),
     /*  76302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76312 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(76408), // Rule ID 1156 //
     /*  76317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76336 */     // MIs[1] Operand 1
     /*  76336 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76383 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76391 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76393 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76406 */     GIR_RootConstrainSelectedInstOperands,
     /*  76407 */     // GIR_Coverage, 1156,
     /*  76407 */     GIR_EraseRootFromParent_Done,
     /*  76408 */   // Label 1272: @76408
     /*  76408 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(76475), // Rule ID 4994 //
     /*  76413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76425 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76429 */     // MIs[1] Operand 1
     /*  76429 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76438 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76450 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76460 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  76460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76473 */     GIR_RootConstrainSelectedInstOperands,
     /*  76474 */     // GIR_Coverage, 4994,
     /*  76474 */     GIR_EraseRootFromParent_Done,
     /*  76475 */   // Label 1273: @76475
     /*  76475 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(76510), // Rule ID 972 //
     /*  76480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76501 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  76501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  76504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76508 */     GIR_RootConstrainSelectedInstOperands,
     /*  76509 */     // GIR_Coverage, 972,
     /*  76509 */     GIR_EraseRootFromParent_Done,
     /*  76510 */   // Label 1274: @76510
     /*  76510 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76533), // Rule ID 1599 //
     /*  76515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76526 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  76531 */     GIR_RootConstrainSelectedInstOperands,
     /*  76532 */     // GIR_Coverage, 1599,
     /*  76532 */     GIR_Done,
     /*  76533 */   // Label 1275: @76533
     /*  76533 */   GIM_Reject,
     /*  76534 */ // Label 1271: @76534
     /*  76534 */ GIM_Reject,
     /*  76535 */ // Label 1194: @76535
     /*  76535 */ GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(77223),
     /*  76540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76550 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76646), // Rule ID 1159 //
     /*  76555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76570 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76574 */     // MIs[1] Operand 1
     /*  76574 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76609 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76615 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76621 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76629 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76631 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  76631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76644 */     GIR_RootConstrainSelectedInstOperands,
     /*  76645 */     // GIR_Coverage, 1159,
     /*  76645 */     GIR_EraseRootFromParent_Done,
     /*  76646 */   // Label 1277: @76646
     /*  76646 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(76713), // Rule ID 4997 //
     /*  76651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76663 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76667 */     // MIs[1] Operand 1
     /*  76667 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76676 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76682 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76688 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76694 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76698 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  76698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76711 */     GIR_RootConstrainSelectedInstOperands,
     /*  76712 */     // GIR_Coverage, 4997,
     /*  76712 */     GIR_EraseRootFromParent_Done,
     /*  76713 */   // Label 1278: @76713
     /*  76713 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76798), // Rule ID 13742 //
     /*  76718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76762 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76768 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76781 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76796 */     GIR_RootConstrainSelectedInstOperands,
     /*  76797 */     // GIR_Coverage, 13742,
     /*  76797 */     GIR_EraseRootFromParent_Done,
     /*  76798 */   // Label 1279: @76798
     /*  76798 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76883), // Rule ID 13741 //
     /*  76803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76852 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76866 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76881 */     GIR_RootConstrainSelectedInstOperands,
     /*  76882 */     // GIR_Coverage, 13741,
     /*  76882 */     GIR_EraseRootFromParent_Done,
     /*  76883 */   // Label 1280: @76883
     /*  76883 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76968), // Rule ID 13740 //
     /*  76888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76936 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76951 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76966 */     GIR_RootConstrainSelectedInstOperands,
     /*  76967 */     // GIR_Coverage, 13740,
     /*  76967 */     GIR_EraseRootFromParent_Done,
     /*  76968 */   // Label 1281: @76968
     /*  76968 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(77053), // Rule ID 3828 //
     /*  76973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77036 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77051 */     GIR_RootConstrainSelectedInstOperands,
     /*  77052 */     // GIR_Coverage, 3828,
     /*  77052 */     GIR_EraseRootFromParent_Done,
     /*  77053 */   // Label 1282: @77053
     /*  77053 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(77085), // Rule ID 4948 //
     /*  77058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77076 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  77076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77083 */     GIR_RootConstrainSelectedInstOperands,
     /*  77084 */     // GIR_Coverage, 4948,
     /*  77084 */     GIR_EraseRootFromParent_Done,
     /*  77085 */   // Label 1283: @77085
     /*  77085 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(77142), // Rule ID 3824 //
     /*  77090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77125 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77140 */     GIR_RootConstrainSelectedInstOperands,
     /*  77141 */     // GIR_Coverage, 3824,
     /*  77141 */     GIR_EraseRootFromParent_Done,
     /*  77142 */   // Label 1284: @77142
     /*  77142 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(77199), // Rule ID 13734 //
     /*  77147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  77166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77182 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  77182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77197 */     GIR_RootConstrainSelectedInstOperands,
     /*  77198 */     // GIR_Coverage, 13734,
     /*  77198 */     GIR_EraseRootFromParent_Done,
     /*  77199 */   // Label 1285: @77199
     /*  77199 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(77222), // Rule ID 5051 //
     /*  77204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77215 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  77215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77220 */     GIR_RootConstrainSelectedInstOperands,
     /*  77221 */     // GIR_Coverage, 5051,
     /*  77221 */     GIR_Done,
     /*  77222 */   // Label 1286: @77222
     /*  77222 */   GIM_Reject,
     /*  77223 */ // Label 1276: @77223
     /*  77223 */ GIM_Reject,
     /*  77224 */ // Label 1195: @77224
     /*  77224 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(77915),
     /*  77229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77239 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(77335), // Rule ID 1157 //
     /*  77244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77263 */     // MIs[1] Operand 1
     /*  77263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77298 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77304 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  77306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77320 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  77333 */     GIR_RootConstrainSelectedInstOperands,
     /*  77334 */     // GIR_Coverage, 1157,
     /*  77334 */     GIR_EraseRootFromParent_Done,
     /*  77335 */   // Label 1288: @77335
     /*  77335 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(77402), // Rule ID 4995 //
     /*  77340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77352 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77356 */     // MIs[1] Operand 1
     /*  77356 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77365 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  77373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  77377 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77387 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  77387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77400 */     GIR_RootConstrainSelectedInstOperands,
     /*  77401 */     // GIR_Coverage, 4995,
     /*  77401 */     GIR_EraseRootFromParent_Done,
     /*  77402 */   // Label 1289: @77402
     /*  77402 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(77487), // Rule ID 13739 //
     /*  77407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77470 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77485 */     GIR_RootConstrainSelectedInstOperands,
     /*  77486 */     // GIR_Coverage, 13739,
     /*  77486 */     GIR_EraseRootFromParent_Done,
     /*  77487 */   // Label 1290: @77487
     /*  77487 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(77572), // Rule ID 13738 //
     /*  77492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77555 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77570 */     GIR_RootConstrainSelectedInstOperands,
     /*  77571 */     // GIR_Coverage, 13738,
     /*  77571 */     GIR_EraseRootFromParent_Done,
     /*  77572 */   // Label 1291: @77572
     /*  77572 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77657), // Rule ID 13737 //
     /*  77577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77625 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77640 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77655 */     GIR_RootConstrainSelectedInstOperands,
     /*  77656 */     // GIR_Coverage, 13737,
     /*  77656 */     GIR_EraseRootFromParent_Done,
     /*  77657 */   // Label 1292: @77657
     /*  77657 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77742), // Rule ID 3827 //
     /*  77662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77715 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77725 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77740 */     GIR_RootConstrainSelectedInstOperands,
     /*  77741 */     // GIR_Coverage, 3827,
     /*  77741 */     GIR_EraseRootFromParent_Done,
     /*  77742 */   // Label 1293: @77742
     /*  77742 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77777), // Rule ID 973 //
     /*  77747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77768 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77775 */     GIR_RootConstrainSelectedInstOperands,
     /*  77776 */     // GIR_Coverage, 973,
     /*  77776 */     GIR_EraseRootFromParent_Done,
     /*  77777 */   // Label 1294: @77777
     /*  77777 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77834), // Rule ID 3823 //
     /*  77782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77817 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77832 */     GIR_RootConstrainSelectedInstOperands,
     /*  77833 */     // GIR_Coverage, 3823,
     /*  77833 */     GIR_EraseRootFromParent_Done,
     /*  77834 */   // Label 1295: @77834
     /*  77834 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77891), // Rule ID 13733 //
     /*  77839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77874 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77889 */     GIR_RootConstrainSelectedInstOperands,
     /*  77890 */     // GIR_Coverage, 13733,
     /*  77890 */     GIR_EraseRootFromParent_Done,
     /*  77891 */   // Label 1296: @77891
     /*  77891 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77914), // Rule ID 1600 //
     /*  77896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77907 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77912 */     GIR_RootConstrainSelectedInstOperands,
     /*  77913 */     // GIR_Coverage, 1600,
     /*  77913 */     GIR_Done,
     /*  77914 */   // Label 1297: @77914
     /*  77914 */   GIM_Reject,
     /*  77915 */ // Label 1287: @77915
     /*  77915 */ GIM_Reject,
     /*  77916 */ // Label 1196: @77916
     /*  77916 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77965), // Rule ID 8422 //
     /*  77921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77934 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77946 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77959 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77961 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77963 */   GIR_RootConstrainSelectedInstOperands,
     /*  77964 */   // GIR_Coverage, 8422,
     /*  77964 */   GIR_EraseRootFromParent_Done,
     /*  77965 */ // Label 1298: @77965
     /*  77965 */ GIM_Reject,
     /*  77966 */ // Label 1197: @77966
     /*  77966 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(78015), // Rule ID 8421 //
     /*  77971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77984 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77996 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78009 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78011 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78013 */   GIR_RootConstrainSelectedInstOperands,
     /*  78014 */   // GIR_Coverage, 8421,
     /*  78014 */   GIR_EraseRootFromParent_Done,
     /*  78015 */ // Label 1299: @78015
     /*  78015 */ GIM_Reject,
     /*  78016 */ // Label 1198: @78016
     /*  78016 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(78478),
     /*  78021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78031 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(78102), // Rule ID 15600 //
     /*  78036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78085 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78100 */     GIR_RootConstrainSelectedInstOperands,
     /*  78101 */     // GIR_Coverage, 15600,
     /*  78101 */     GIR_EraseRootFromParent_Done,
     /*  78102 */   // Label 1301: @78102
     /*  78102 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(78173), // Rule ID 15599 //
     /*  78107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78156 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78171 */     GIR_RootConstrainSelectedInstOperands,
     /*  78172 */     // GIR_Coverage, 15599,
     /*  78172 */     GIR_EraseRootFromParent_Done,
     /*  78173 */   // Label 1302: @78173
     /*  78173 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(78244), // Rule ID 15598 //
     /*  78178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78217 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78223 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78227 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78242 */     GIR_RootConstrainSelectedInstOperands,
     /*  78243 */     // GIR_Coverage, 15598,
     /*  78243 */     GIR_EraseRootFromParent_Done,
     /*  78244 */   // Label 1303: @78244
     /*  78244 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(78315), // Rule ID 11852 //
     /*  78249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78288 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78298 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78313 */     GIR_RootConstrainSelectedInstOperands,
     /*  78314 */     // GIR_Coverage, 11852,
     /*  78314 */     GIR_EraseRootFromParent_Done,
     /*  78315 */   // Label 1304: @78315
     /*  78315 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(78376), // Rule ID 11876 //
     /*  78320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  78343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78347 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78357 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78374 */     GIR_RootConstrainSelectedInstOperands,
     /*  78375 */     // GIR_Coverage, 11876,
     /*  78375 */     GIR_EraseRootFromParent_Done,
     /*  78376 */   // Label 1305: @78376
     /*  78376 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(78419), // Rule ID 13700 //
     /*  78381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78402 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78417 */     GIR_RootConstrainSelectedInstOperands,
     /*  78418 */     // GIR_Coverage, 13700,
     /*  78418 */     GIR_EraseRootFromParent_Done,
     /*  78419 */   // Label 1306: @78419
     /*  78419 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(78462), // Rule ID 3154 //
     /*  78424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78445 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78460 */     GIR_RootConstrainSelectedInstOperands,
     /*  78461 */     // GIR_Coverage, 3154,
     /*  78461 */     GIR_EraseRootFromParent_Done,
     /*  78462 */   // Label 1307: @78462
     /*  78462 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(78477), // Rule ID 7441 //
     /*  78467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78470 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  78470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78475 */     GIR_RootConstrainSelectedInstOperands,
     /*  78476 */     // GIR_Coverage, 7441,
     /*  78476 */     GIR_Done,
     /*  78477 */   // Label 1308: @78477
     /*  78477 */   GIM_Reject,
     /*  78478 */ // Label 1300: @78478
     /*  78478 */ GIM_Reject,
     /*  78479 */ // Label 1199: @78479
     /*  78479 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78528), // Rule ID 8420 //
     /*  78484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  78490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  78493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78497 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  78497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  78504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78509 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78522 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78524 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78526 */   GIR_RootConstrainSelectedInstOperands,
     /*  78527 */   // GIR_Coverage, 8420,
     /*  78527 */   GIR_EraseRootFromParent_Done,
     /*  78528 */ // Label 1309: @78528
     /*  78528 */ GIM_Reject,
     /*  78529 */ // Label 1200: @78529
     /*  78529 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(78991),
     /*  78534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78544 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(78615), // Rule ID 15597 //
     /*  78549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78588 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78594 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78598 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78613 */     GIR_RootConstrainSelectedInstOperands,
     /*  78614 */     // GIR_Coverage, 15597,
     /*  78614 */     GIR_EraseRootFromParent_Done,
     /*  78615 */   // Label 1311: @78615
     /*  78615 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78686), // Rule ID 15596 //
     /*  78620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78659 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78665 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78669 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78684 */     GIR_RootConstrainSelectedInstOperands,
     /*  78685 */     // GIR_Coverage, 15596,
     /*  78685 */     GIR_EraseRootFromParent_Done,
     /*  78686 */   // Label 1312: @78686
     /*  78686 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78757), // Rule ID 15595 //
     /*  78691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78730 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78740 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78755 */     GIR_RootConstrainSelectedInstOperands,
     /*  78756 */     // GIR_Coverage, 15595,
     /*  78756 */     GIR_EraseRootFromParent_Done,
     /*  78757 */   // Label 1313: @78757
     /*  78757 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78828), // Rule ID 11850 //
     /*  78762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78801 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78811 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78826 */     GIR_RootConstrainSelectedInstOperands,
     /*  78827 */     // GIR_Coverage, 11850,
     /*  78827 */     GIR_EraseRootFromParent_Done,
     /*  78828 */   // Label 1314: @78828
     /*  78828 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78889), // Rule ID 11874 //
     /*  78833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78852 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78860 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78870 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78887 */     GIR_RootConstrainSelectedInstOperands,
     /*  78888 */     // GIR_Coverage, 11874,
     /*  78888 */     GIR_EraseRootFromParent_Done,
     /*  78889 */   // Label 1315: @78889
     /*  78889 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78932), // Rule ID 13699 //
     /*  78894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78915 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78930 */     GIR_RootConstrainSelectedInstOperands,
     /*  78931 */     // GIR_Coverage, 13699,
     /*  78931 */     GIR_EraseRootFromParent_Done,
     /*  78932 */   // Label 1316: @78932
     /*  78932 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78975), // Rule ID 3152 //
     /*  78937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78958 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78973 */     GIR_RootConstrainSelectedInstOperands,
     /*  78974 */     // GIR_Coverage, 3152,
     /*  78974 */     GIR_EraseRootFromParent_Done,
     /*  78975 */   // Label 1317: @78975
     /*  78975 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78990), // Rule ID 7440 //
     /*  78980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78983 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78988 */     GIR_RootConstrainSelectedInstOperands,
     /*  78989 */     // GIR_Coverage, 7440,
     /*  78989 */     GIR_Done,
     /*  78990 */   // Label 1318: @78990
     /*  78990 */   GIM_Reject,
     /*  78991 */ // Label 1310: @78991
     /*  78991 */ GIM_Reject,
     /*  78992 */ // Label 1201: @78992
     /*  78992 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(79041), // Rule ID 8419 //
     /*  78997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79010 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  79017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79022 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79037 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79039 */   GIR_RootConstrainSelectedInstOperands,
     /*  79040 */   // GIR_Coverage, 8419,
     /*  79040 */   GIR_EraseRootFromParent_Done,
     /*  79041 */ // Label 1319: @79041
     /*  79041 */ GIM_Reject,
     /*  79042 */ // Label 1202: @79042
     /*  79042 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(79504),
     /*  79047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79057 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(79128), // Rule ID 15594 //
     /*  79062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79101 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79111 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79126 */     GIR_RootConstrainSelectedInstOperands,
     /*  79127 */     // GIR_Coverage, 15594,
     /*  79127 */     GIR_EraseRootFromParent_Done,
     /*  79128 */   // Label 1321: @79128
     /*  79128 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(79199), // Rule ID 15593 //
     /*  79133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79172 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79182 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79197 */     GIR_RootConstrainSelectedInstOperands,
     /*  79198 */     // GIR_Coverage, 15593,
     /*  79198 */     GIR_EraseRootFromParent_Done,
     /*  79199 */   // Label 1322: @79199
     /*  79199 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(79270), // Rule ID 15592 //
     /*  79204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79243 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79253 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79268 */     GIR_RootConstrainSelectedInstOperands,
     /*  79269 */     // GIR_Coverage, 15592,
     /*  79269 */     GIR_EraseRootFromParent_Done,
     /*  79270 */   // Label 1323: @79270
     /*  79270 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(79341), // Rule ID 11848 //
     /*  79275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79324 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79339 */     GIR_RootConstrainSelectedInstOperands,
     /*  79340 */     // GIR_Coverage, 11848,
     /*  79340 */     GIR_EraseRootFromParent_Done,
     /*  79341 */   // Label 1324: @79341
     /*  79341 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(79402), // Rule ID 11872 //
     /*  79346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79365 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  79369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79373 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79383 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79400 */     GIR_RootConstrainSelectedInstOperands,
     /*  79401 */     // GIR_Coverage, 11872,
     /*  79401 */     GIR_EraseRootFromParent_Done,
     /*  79402 */   // Label 1325: @79402
     /*  79402 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(79445), // Rule ID 13698 //
     /*  79407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79428 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79443 */     GIR_RootConstrainSelectedInstOperands,
     /*  79444 */     // GIR_Coverage, 13698,
     /*  79444 */     GIR_EraseRootFromParent_Done,
     /*  79445 */   // Label 1326: @79445
     /*  79445 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(79488), // Rule ID 3150 //
     /*  79450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79471 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79486 */     GIR_RootConstrainSelectedInstOperands,
     /*  79487 */     // GIR_Coverage, 3150,
     /*  79487 */     GIR_EraseRootFromParent_Done,
     /*  79488 */   // Label 1327: @79488
     /*  79488 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(79503), // Rule ID 7439 //
     /*  79493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79496 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  79496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79501 */     GIR_RootConstrainSelectedInstOperands,
     /*  79502 */     // GIR_Coverage, 7439,
     /*  79502 */     GIR_Done,
     /*  79503 */   // Label 1328: @79503
     /*  79503 */   GIM_Reject,
     /*  79504 */ // Label 1320: @79504
     /*  79504 */ GIM_Reject,
     /*  79505 */ // Label 1203: @79505
     /*  79505 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79554), // Rule ID 8418 //
     /*  79510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  79516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  79519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79523 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  79523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  79530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79535 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79548 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79550 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79552 */   GIR_RootConstrainSelectedInstOperands,
     /*  79553 */   // GIR_Coverage, 8418,
     /*  79553 */   GIR_EraseRootFromParent_Done,
     /*  79554 */ // Label 1329: @79554
     /*  79554 */ GIM_Reject,
     /*  79555 */ // Label 1204: @79555
     /*  79555 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(80017),
     /*  79560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79570 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79641), // Rule ID 15591 //
     /*  79575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79614 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79624 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79639 */     GIR_RootConstrainSelectedInstOperands,
     /*  79640 */     // GIR_Coverage, 15591,
     /*  79640 */     GIR_EraseRootFromParent_Done,
     /*  79641 */   // Label 1331: @79641
     /*  79641 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(79712), // Rule ID 15590 //
     /*  79646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79685 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79691 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79695 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79710 */     GIR_RootConstrainSelectedInstOperands,
     /*  79711 */     // GIR_Coverage, 15590,
     /*  79711 */     GIR_EraseRootFromParent_Done,
     /*  79712 */   // Label 1332: @79712
     /*  79712 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79783), // Rule ID 15589 //
     /*  79717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79756 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79766 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79781 */     GIR_RootConstrainSelectedInstOperands,
     /*  79782 */     // GIR_Coverage, 15589,
     /*  79782 */     GIR_EraseRootFromParent_Done,
     /*  79783 */   // Label 1333: @79783
     /*  79783 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79854), // Rule ID 11846 //
     /*  79788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79837 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79852 */     GIR_RootConstrainSelectedInstOperands,
     /*  79853 */     // GIR_Coverage, 11846,
     /*  79853 */     GIR_EraseRootFromParent_Done,
     /*  79854 */   // Label 1334: @79854
     /*  79854 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79915), // Rule ID 11870 //
     /*  79859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79896 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79913 */     GIR_RootConstrainSelectedInstOperands,
     /*  79914 */     // GIR_Coverage, 11870,
     /*  79914 */     GIR_EraseRootFromParent_Done,
     /*  79915 */   // Label 1335: @79915
     /*  79915 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79958), // Rule ID 13697 //
     /*  79920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79941 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79956 */     GIR_RootConstrainSelectedInstOperands,
     /*  79957 */     // GIR_Coverage, 13697,
     /*  79957 */     GIR_EraseRootFromParent_Done,
     /*  79958 */   // Label 1336: @79958
     /*  79958 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(80001), // Rule ID 3148 //
     /*  79963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79984 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79999 */     GIR_RootConstrainSelectedInstOperands,
     /*  80000 */     // GIR_Coverage, 3148,
     /*  80000 */     GIR_EraseRootFromParent_Done,
     /*  80001 */   // Label 1337: @80001
     /*  80001 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(80016), // Rule ID 7438 //
     /*  80006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80009 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  80009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  80014 */     GIR_RootConstrainSelectedInstOperands,
     /*  80015 */     // GIR_Coverage, 7438,
     /*  80015 */     GIR_Done,
     /*  80016 */   // Label 1338: @80016
     /*  80016 */   GIM_Reject,
     /*  80017 */ // Label 1330: @80017
     /*  80017 */ GIM_Reject,
     /*  80018 */ // Label 1205: @80018
     /*  80018 */ GIM_Reject,
     /*  80019 */ // Label 8: @80019
     /*  80019 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(87542),
     /*  80024 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  80027 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1351*/ GIMT_Encode4(87541),
     /*  80038 */   /*GILLT_v2s64*//*Label 1340*/ GIMT_Encode4(80106), GIMT_Encode4(0),
     /*  80046 */   /*GILLT_v4s32*//*Label 1341*/ GIMT_Encode4(80627), GIMT_Encode4(0),
     /*  80054 */   /*GILLT_v8s16*//*Label 1342*/ GIMT_Encode4(83039),
     /*  80058 */   /*GILLT_v16s8*//*Label 1343*/ GIMT_Encode4(85448), GIMT_Encode4(0),
     /*  80066 */   /*GILLT_nxv2s1*//*Label 1344*/ GIMT_Encode4(87359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  80082 */   /*GILLT_nxv4s1*//*Label 1345*/ GIMT_Encode4(87385),
     /*  80086 */   /*GILLT_nxv4s16*//*Label 1346*/ GIMT_Encode4(87411),
     /*  80090 */   /*GILLT_nxv4s32*//*Label 1347*/ GIMT_Encode4(87437),
     /*  80094 */   /*GILLT_nxv8s1*//*Label 1348*/ GIMT_Encode4(87463),
     /*  80098 */   /*GILLT_nxv8s16*//*Label 1349*/ GIMT_Encode4(87489),
     /*  80102 */   /*GILLT_nxv16s1*//*Label 1350*/ GIMT_Encode4(87515),
     /*  80106 */   // Label 1340: @80106
     /*  80106 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(80626),
     /*  80111 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  80114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  80117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80125 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(80187), // Rule ID 5782 //
     /*  80130 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80134 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80140 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80142 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80144 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  80144 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80147 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80151 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80160 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80162 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80165 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80167 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80170 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80173 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80176 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80181 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80186 */       // GIR_Coverage, 5782,
     /*  80186 */       GIR_EraseRootFromParent_Done,
     /*  80187 */     // Label 1353: @80187
     /*  80187 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(80249), // Rule ID 5786 //
     /*  80192 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80196 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80202 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80204 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80206 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  80206 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80209 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80213 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80218 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80222 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80224 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80227 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80229 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80232 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80235 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80243 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80248 */       // GIR_Coverage, 5786,
     /*  80248 */       GIR_EraseRootFromParent_Done,
     /*  80249 */     // Label 1354: @80249
     /*  80249 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(80307), // Rule ID 5783 //
     /*  80254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80262 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80264 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  80264 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80267 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80271 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80276 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80283 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80286 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80288 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80291 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80296 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80301 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80306 */       // GIR_Coverage, 5783,
     /*  80306 */       GIR_EraseRootFromParent_Done,
     /*  80307 */     // Label 1355: @80307
     /*  80307 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(80365), // Rule ID 5787 //
     /*  80312 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80316 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80320 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80322 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  80322 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80325 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80329 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80334 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80336 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80339 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80341 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80344 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80346 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80349 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80354 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80359 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80364 */       // GIR_Coverage, 5787,
     /*  80364 */       GIR_EraseRootFromParent_Done,
     /*  80365 */     // Label 1356: @80365
     /*  80365 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(80495), // Rule ID 5781 //
     /*  80370 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80374 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80374 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80377 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80381 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80386 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80388 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80391 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80395 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80400 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80403 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80407 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80410 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80415 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80420 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80425 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80428 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80432 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80437 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80439 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80442 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80446 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80451 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80454 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80458 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80466 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80471 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80476 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80479 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80481 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80484 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80487 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80493 */       GIR_RootConstrainSelectedInstOperands,
     /*  80494 */       // GIR_Coverage, 5781,
     /*  80494 */       GIR_EraseRootFromParent_Done,
     /*  80495 */     // Label 1357: @80495
     /*  80495 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(80625), // Rule ID 5785 //
     /*  80500 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80504 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80504 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80507 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80511 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80518 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80521 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80525 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80530 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80533 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80537 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80540 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80545 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80550 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80555 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80558 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80562 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80567 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80569 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80572 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80576 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80581 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80584 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80588 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80596 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80601 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80606 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80609 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80611 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80614 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80617 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80620 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80623 */       GIR_RootConstrainSelectedInstOperands,
     /*  80624 */       // GIR_Coverage, 5785,
     /*  80624 */       GIR_EraseRootFromParent_Done,
     /*  80625 */     // Label 1358: @80625
     /*  80625 */     GIM_Reject,
     /*  80626 */   // Label 1352: @80626
     /*  80626 */   GIM_Reject,
     /*  80627 */   // Label 1341: @80627
     /*  80627 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83038),
     /*  80632 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  80635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  80638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80642 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80771), // Rule ID 5431 //
     /*  80647 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80651 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80655 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80659 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80663 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80667 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80671 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80675 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80679 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80683 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80687 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80691 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80696 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80700 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80706 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80708 */       // MIs[2] Operand 2
     /*  80708 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80719 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80721 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80721 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80724 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80728 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80733 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80736 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80740 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80748 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80753 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80756 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80758 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80761 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80765 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80769 */       GIR_RootConstrainSelectedInstOperands,
     /*  80770 */       // GIR_Coverage, 5431,
     /*  80770 */       GIR_EraseRootFromParent_Done,
     /*  80771 */     // Label 1360: @80771
     /*  80771 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80893), // Rule ID 5427 //
     /*  80776 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80780 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80784 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80788 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80792 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80796 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80800 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80804 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80808 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80812 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80816 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80820 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80825 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80830 */       // MIs[2] Operand 2
     /*  80830 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80841 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80843 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80843 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80846 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80850 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80855 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80858 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80862 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80865 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80870 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80875 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80878 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80880 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80883 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80887 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80891 */       GIR_RootConstrainSelectedInstOperands,
     /*  80892 */       // GIR_Coverage, 5427,
     /*  80892 */       GIR_EraseRootFromParent_Done,
     /*  80893 */     // Label 1361: @80893
     /*  80893 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(81015), // Rule ID 5429 //
     /*  80898 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80902 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80906 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80910 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80914 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80918 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80922 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80926 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80930 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80934 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80938 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80942 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80947 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80952 */       // MIs[2] Operand 2
     /*  80952 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80963 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80965 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80965 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80968 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80972 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80977 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80980 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80984 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80987 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80992 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80997 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81000 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81002 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81005 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81009 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81013 */       GIR_RootConstrainSelectedInstOperands,
     /*  81014 */       // GIR_Coverage, 5429,
     /*  81014 */       GIR_EraseRootFromParent_Done,
     /*  81015 */     // Label 1362: @81015
     /*  81015 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(81117), // Rule ID 5577 //
     /*  81020 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81024 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81028 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81032 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81036 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81040 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81044 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81049 */       // MIs[2] Operand 2
     /*  81049 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  81060 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81064 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81068 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81072 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81076 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81080 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81084 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81089 */       // MIs[4] Operand 2
     /*  81089 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  81100 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81102 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81102 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  81105 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81111 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81115 */       GIR_RootConstrainSelectedInstOperands,
     /*  81116 */       // GIR_Coverage, 5577,
     /*  81116 */       GIR_EraseRootFromParent_Done,
     /*  81117 */     // Label 1363: @81117
     /*  81117 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(81246), // Rule ID 6337 //
     /*  81122 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81126 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81130 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81134 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81137 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81142 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81146 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81150 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81155 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  81159 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81161 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  81161 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  81164 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81168 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81173 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81176 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81178 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81181 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81185 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81190 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81192 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81195 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81199 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81204 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81207 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81211 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81219 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81224 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81229 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81232 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81234 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81237 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81241 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81244 */       GIR_RootConstrainSelectedInstOperands,
     /*  81245 */       // GIR_Coverage, 6337,
     /*  81245 */       GIR_EraseRootFromParent_Done,
     /*  81246 */     // Label 1364: @81246
     /*  81246 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(81288), // Rule ID 5792 //
     /*  81251 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81258 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81265 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  81265 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81268 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81270 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81275 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81278 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81283 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81286 */       GIR_RootConstrainSelectedInstOperands,
     /*  81287 */       // GIR_Coverage, 5792,
     /*  81287 */       GIR_EraseRootFromParent_Done,
     /*  81288 */     // Label 1365: @81288
     /*  81288 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(81330), // Rule ID 5796 //
     /*  81293 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81300 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81307 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  81307 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81310 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81312 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81317 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81320 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81325 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81328 */       GIR_RootConstrainSelectedInstOperands,
     /*  81329 */       // GIR_Coverage, 5796,
     /*  81329 */       GIR_EraseRootFromParent_Done,
     /*  81330 */     // Label 1366: @81330
     /*  81330 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(81453), // Rule ID 2578 //
     /*  81335 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81338 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81342 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81346 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81350 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81353 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81358 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81362 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81366 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81371 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81375 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81379 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81383 */       // MIs[2] Operand 1
     /*  81383 */       // No operand predicates
     /*  81383 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81385 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81385 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81388 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81392 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81397 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81399 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81402 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81406 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81411 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81414 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81418 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81426 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81431 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  81439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81441 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81444 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81448 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81451 */       GIR_RootConstrainSelectedInstOperands,
     /*  81452 */       // GIR_Coverage, 2578,
     /*  81452 */       GIR_EraseRootFromParent_Done,
     /*  81453 */     // Label 1367: @81453
     /*  81453 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(81576), // Rule ID 6307 //
     /*  81458 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81461 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81465 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81469 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81473 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81477 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81481 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81485 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81489 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81494 */       // MIs[2] imm
     /*  81494 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81498 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81502 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81506 */       // MIs[3] Operand 1
     /*  81506 */       // No operand predicates
     /*  81506 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81508 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81508 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81511 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81515 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81520 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81522 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81525 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81529 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81534 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81537 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81541 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81544 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81549 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81564 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81567 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81571 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81574 */       GIR_RootConstrainSelectedInstOperands,
     /*  81575 */       // GIR_Coverage, 6307,
     /*  81575 */       GIR_EraseRootFromParent_Done,
     /*  81576 */     // Label 1368: @81576
     /*  81576 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81696), // Rule ID 6343 //
     /*  81581 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81585 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81589 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81593 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81597 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81601 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81605 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81609 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81614 */       // MIs[2] imm
     /*  81614 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81618 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81622 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81626 */       // MIs[3] Operand 1
     /*  81626 */       // No operand predicates
     /*  81626 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81628 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  81628 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81631 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81635 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81640 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81642 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81645 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81649 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81654 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81657 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81661 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81664 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81674 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81679 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81682 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81684 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81687 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81691 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81694 */       GIR_RootConstrainSelectedInstOperands,
     /*  81695 */       // GIR_Coverage, 6343,
     /*  81695 */       GIR_EraseRootFromParent_Done,
     /*  81696 */     // Label 1369: @81696
     /*  81696 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81813), // Rule ID 2501 //
     /*  81701 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81704 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81708 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81712 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81716 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81719 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81724 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81728 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81732 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81737 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81742 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81744 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81744 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81747 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81751 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81756 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81758 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81761 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81765 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81770 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81773 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81777 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81780 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81785 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81790 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81795 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81798 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81800 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81803 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81807 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81811 */       GIR_RootConstrainSelectedInstOperands,
     /*  81812 */       // GIR_Coverage, 2501,
     /*  81812 */       GIR_EraseRootFromParent_Done,
     /*  81813 */     // Label 1370: @81813
     /*  81813 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81930), // Rule ID 5347 //
     /*  81818 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81821 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81825 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81829 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81833 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81836 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81841 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81845 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81849 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81854 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81859 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81861 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81861 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81864 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81868 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81873 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81875 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81878 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81882 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81887 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81890 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81894 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81897 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81902 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81907 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81912 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81915 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81917 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81920 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81924 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81928 */       GIR_RootConstrainSelectedInstOperands,
     /*  81929 */       // GIR_Coverage, 5347,
     /*  81929 */       GIR_EraseRootFromParent_Done,
     /*  81930 */     // Label 1371: @81930
     /*  81930 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(82047), // Rule ID 5350 //
     /*  81935 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81938 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81942 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81946 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81950 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81953 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81958 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81962 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81966 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81971 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81976 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81978 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81978 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81981 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81985 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81990 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81992 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81995 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81999 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82004 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82007 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82011 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82014 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82019 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82024 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82029 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  82032 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82034 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82037 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82041 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82045 */       GIR_RootConstrainSelectedInstOperands,
     /*  82046 */       // GIR_Coverage, 5350,
     /*  82046 */       GIR_EraseRootFromParent_Done,
     /*  82047 */     // Label 1372: @82047
     /*  82047 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(82164), // Rule ID 5353 //
     /*  82052 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82055 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82059 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82063 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82067 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82070 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82075 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82079 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82083 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82088 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82093 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82095 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  82095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  82149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82154 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82158 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82162 */       GIR_RootConstrainSelectedInstOperands,
     /*  82163 */       // GIR_Coverage, 5353,
     /*  82163 */       GIR_EraseRootFromParent_Done,
     /*  82164 */     // Label 1373: @82164
     /*  82164 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(82268), // Rule ID 2497 //
     /*  82169 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82172 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82176 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82180 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82184 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  82187 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  82192 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82196 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82201 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82203 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82203 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82206 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82210 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82229 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82232 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82236 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82249 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82254 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  82257 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82259 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82262 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82266 */       GIR_RootConstrainSelectedInstOperands,
     /*  82267 */       // GIR_Coverage, 2497,
     /*  82267 */       GIR_EraseRootFromParent_Done,
     /*  82268 */     // Label 1374: @82268
     /*  82268 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(82324), // Rule ID 5510 //
     /*  82273 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82277 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82281 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82285 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82290 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82294 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82298 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82302 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82307 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82309 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  82309 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  82312 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82314 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82318 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82322 */       GIR_RootConstrainSelectedInstOperands,
     /*  82323 */       // GIR_Coverage, 5510,
     /*  82323 */       GIR_EraseRootFromParent_Done,
     /*  82324 */     // Label 1375: @82324
     /*  82324 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(82390), // Rule ID 5790 //
     /*  82329 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82333 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82337 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82343 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82345 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82347 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  82347 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82350 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82354 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82359 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82363 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82365 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82368 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82370 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82373 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82376 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82379 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82384 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82389 */       // GIR_Coverage, 5790,
     /*  82389 */       GIR_EraseRootFromParent_Done,
     /*  82390 */     // Label 1376: @82390
     /*  82390 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(82456), // Rule ID 5794 //
     /*  82395 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82399 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82403 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82409 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82411 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82413 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  82413 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82416 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82420 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82425 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82429 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82431 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82434 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82436 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82439 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82442 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82445 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82450 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82455 */       // GIR_Coverage, 5794,
     /*  82455 */       GIR_EraseRootFromParent_Done,
     /*  82456 */     // Label 1377: @82456
     /*  82456 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(82549), // Rule ID 4914 //
     /*  82461 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82465 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82469 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  82473 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82477 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82482 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82484 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82484 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82487 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82491 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82496 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82498 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82501 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82505 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82510 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82513 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82520 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82525 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82530 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82535 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  82538 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82540 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82543 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82547 */       GIR_RootConstrainSelectedInstOperands,
     /*  82548 */       // GIR_Coverage, 4914,
     /*  82548 */       GIR_EraseRootFromParent_Done,
     /*  82549 */     // Label 1378: @82549
     /*  82549 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(82645), // Rule ID 4961 //
     /*  82554 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82557 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82561 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82565 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82569 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82578 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82580 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  82580 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82583 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82587 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82592 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82594 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82597 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82601 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82606 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82609 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82613 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82631 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  82634 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82636 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82639 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82643 */       GIR_RootConstrainSelectedInstOperands,
     /*  82644 */       // GIR_Coverage, 4961,
     /*  82644 */       GIR_EraseRootFromParent_Done,
     /*  82645 */     // Label 1379: @82645
     /*  82645 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82707), // Rule ID 5791 //
     /*  82650 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82654 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82658 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82662 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82664 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  82664 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82667 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82671 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82676 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82678 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82681 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82683 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82686 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82688 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82691 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82696 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82701 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82706 */       // GIR_Coverage, 5791,
     /*  82706 */       GIR_EraseRootFromParent_Done,
     /*  82707 */     // Label 1380: @82707
     /*  82707 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82769), // Rule ID 5795 //
     /*  82712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82716 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82720 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82724 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82726 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82726 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82729 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82733 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82738 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82740 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82743 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82745 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82748 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82750 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82753 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82758 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82763 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82768 */       // GIR_Coverage, 5795,
     /*  82768 */       GIR_EraseRootFromParent_Done,
     /*  82769 */     // Label 1381: @82769
     /*  82769 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82903), // Rule ID 5789 //
     /*  82774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82778 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82782 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82782 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82785 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82789 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82794 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82796 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82799 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82803 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82808 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82811 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82815 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82818 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82823 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82828 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82833 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82836 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82840 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82845 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82847 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82850 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82854 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82859 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82862 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82866 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82869 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82892 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82895 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82898 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82901 */       GIR_RootConstrainSelectedInstOperands,
     /*  82902 */       // GIR_Coverage, 5789,
     /*  82902 */       GIR_EraseRootFromParent_Done,
     /*  82903 */     // Label 1382: @82903
     /*  82903 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(83037), // Rule ID 5793 //
     /*  82908 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82912 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82916 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82916 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82919 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82923 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82928 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82930 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82933 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82937 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82942 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82945 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82949 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82952 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82957 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82962 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82967 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82970 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82974 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82979 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82981 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82984 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82988 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82993 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82996 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83000 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83003 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83008 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83013 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83018 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83021 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83029 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83032 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83035 */       GIR_RootConstrainSelectedInstOperands,
     /*  83036 */       // GIR_Coverage, 5793,
     /*  83036 */       GIR_EraseRootFromParent_Done,
     /*  83037 */     // Label 1383: @83037
     /*  83037 */     GIM_Reject,
     /*  83038 */   // Label 1359: @83038
     /*  83038 */   GIM_Reject,
     /*  83039 */   // Label 1342: @83039
     /*  83039 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85447),
     /*  83044 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  83047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  83050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83054 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(83183), // Rule ID 5425 //
     /*  83059 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83063 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83067 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83071 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83075 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83079 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83083 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83087 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83091 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83095 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83099 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83103 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83108 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83112 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83118 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83120 */       // MIs[2] Operand 2
     /*  83120 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83131 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83133 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  83133 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83136 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83140 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83145 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83148 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83152 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83155 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83160 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83165 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83168 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83170 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83173 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83177 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83181 */       GIR_RootConstrainSelectedInstOperands,
     /*  83182 */       // GIR_Coverage, 5425,
     /*  83182 */       GIR_EraseRootFromParent_Done,
     /*  83183 */     // Label 1385: @83183
     /*  83183 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(83305), // Rule ID 5421 //
     /*  83188 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83192 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83196 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83200 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83204 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83208 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83212 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83216 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83220 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  83224 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83228 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83232 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83237 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83242 */       // MIs[2] Operand 2
     /*  83242 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83253 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83255 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83255 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83258 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83262 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83267 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83270 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83274 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83277 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83282 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83287 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83290 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83292 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83295 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83299 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83303 */       GIR_RootConstrainSelectedInstOperands,
     /*  83304 */       // GIR_Coverage, 5421,
     /*  83304 */       GIR_EraseRootFromParent_Done,
     /*  83305 */     // Label 1386: @83305
     /*  83305 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(83427), // Rule ID 5423 //
     /*  83310 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83314 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83318 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83322 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83326 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83330 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83334 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83338 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83342 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  83346 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83350 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83354 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83359 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83364 */       // MIs[2] Operand 2
     /*  83364 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83375 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83377 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83377 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83380 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83384 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83389 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83392 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83396 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83399 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83404 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83409 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83412 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83414 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83417 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83421 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83425 */       GIR_RootConstrainSelectedInstOperands,
     /*  83426 */       // GIR_Coverage, 5423,
     /*  83426 */       GIR_EraseRootFromParent_Done,
     /*  83427 */     // Label 1387: @83427
     /*  83427 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(83529), // Rule ID 5576 //
     /*  83432 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83436 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83440 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83444 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83448 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83452 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83456 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83461 */       // MIs[2] Operand 2
     /*  83461 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83472 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  83476 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83480 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83484 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  83488 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83492 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83496 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83501 */       // MIs[4] Operand 2
     /*  83501 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  83512 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83514 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83514 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  83517 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83519 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  83523 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  83527 */       GIR_RootConstrainSelectedInstOperands,
     /*  83528 */       // GIR_Coverage, 5576,
     /*  83528 */       GIR_EraseRootFromParent_Done,
     /*  83529 */     // Label 1388: @83529
     /*  83529 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(83658), // Rule ID 6336 //
     /*  83534 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83538 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83542 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83546 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83549 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83554 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83558 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83562 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83567 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  83571 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83573 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  83573 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  83576 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  83580 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83585 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  83588 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  83590 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83593 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83597 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83602 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83604 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83607 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83611 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83616 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83619 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  83623 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83636 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83641 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83644 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83646 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83649 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  83653 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83656 */       GIR_RootConstrainSelectedInstOperands,
     /*  83657 */       // GIR_Coverage, 6336,
     /*  83657 */       GIR_EraseRootFromParent_Done,
     /*  83658 */     // Label 1389: @83658
     /*  83658 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83700), // Rule ID 5800 //
     /*  83663 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83670 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83677 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  83677 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83680 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83682 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83687 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83690 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83695 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83698 */       GIR_RootConstrainSelectedInstOperands,
     /*  83699 */       // GIR_Coverage, 5800,
     /*  83699 */       GIR_EraseRootFromParent_Done,
     /*  83700 */     // Label 1390: @83700
     /*  83700 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83742), // Rule ID 5804 //
     /*  83705 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83712 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83719 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83719 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83722 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83724 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83729 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83737 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83740 */       GIR_RootConstrainSelectedInstOperands,
     /*  83741 */       // GIR_Coverage, 5804,
     /*  83741 */       GIR_EraseRootFromParent_Done,
     /*  83742 */     // Label 1391: @83742
     /*  83742 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83865), // Rule ID 2576 //
     /*  83747 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83750 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83754 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83758 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83762 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83765 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83770 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83774 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83778 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83783 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83787 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83791 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83795 */       // MIs[2] Operand 1
     /*  83795 */       // No operand predicates
     /*  83795 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83797 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83797 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83800 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83804 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83809 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83811 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83814 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83818 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83823 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83826 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83830 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83833 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83838 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83843 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83853 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83856 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83860 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83863 */       GIR_RootConstrainSelectedInstOperands,
     /*  83864 */       // GIR_Coverage, 2576,
     /*  83864 */       GIR_EraseRootFromParent_Done,
     /*  83865 */     // Label 1392: @83865
     /*  83865 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83988), // Rule ID 6306 //
     /*  83870 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83873 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83877 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83881 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83885 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83889 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83893 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83897 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83901 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83906 */       // MIs[2] imm
     /*  83906 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83910 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83914 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83918 */       // MIs[3] Operand 1
     /*  83918 */       // No operand predicates
     /*  83918 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83920 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83920 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83923 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83927 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83932 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83934 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83937 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83941 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83946 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83949 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83953 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83956 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83971 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83974 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83979 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83983 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83986 */       GIR_RootConstrainSelectedInstOperands,
     /*  83987 */       // GIR_Coverage, 6306,
     /*  83987 */       GIR_EraseRootFromParent_Done,
     /*  83988 */     // Label 1393: @83988
     /*  83988 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(84108), // Rule ID 6342 //
     /*  83993 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83997 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84001 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84005 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84009 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84013 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84017 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84021 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84026 */       // MIs[2] imm
     /*  84026 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84030 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84034 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  84038 */       // MIs[3] Operand 1
     /*  84038 */       // No operand predicates
     /*  84038 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84040 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  84040 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84043 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84047 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84052 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84054 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84057 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84061 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84066 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84069 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84073 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84076 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84081 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84086 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84091 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  84094 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84096 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84099 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  84103 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  84106 */       GIR_RootConstrainSelectedInstOperands,
     /*  84107 */       // GIR_Coverage, 6342,
     /*  84107 */       GIR_EraseRootFromParent_Done,
     /*  84108 */     // Label 1394: @84108
     /*  84108 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(84225), // Rule ID 2500 //
     /*  84113 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84116 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84120 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84124 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84128 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84131 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  84136 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84140 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84144 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84149 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84154 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84156 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84156 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84159 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84163 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84168 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84170 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84173 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84177 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84182 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84185 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84189 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84192 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84197 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84202 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84207 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  84210 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84212 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84215 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84219 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84223 */       GIR_RootConstrainSelectedInstOperands,
     /*  84224 */       // GIR_Coverage, 2500,
     /*  84224 */       GIR_EraseRootFromParent_Done,
     /*  84225 */     // Label 1395: @84225
     /*  84225 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(84342), // Rule ID 5346 //
     /*  84230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84233 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84237 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84241 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84245 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84248 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  84253 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84257 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84261 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84266 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84271 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84273 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84273 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84276 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84280 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84285 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84287 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84290 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84294 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84299 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84302 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84306 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84309 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84314 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84319 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84324 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  84327 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84329 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84332 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84336 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84340 */       GIR_RootConstrainSelectedInstOperands,
     /*  84341 */       // GIR_Coverage, 5346,
     /*  84341 */       GIR_EraseRootFromParent_Done,
     /*  84342 */     // Label 1396: @84342
     /*  84342 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(84459), // Rule ID 5349 //
     /*  84347 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84350 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84354 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84358 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84362 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84365 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  84370 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84374 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84378 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84383 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84388 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84390 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84390 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84393 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84397 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84404 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84407 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84411 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84416 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84419 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84423 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84426 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84431 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84436 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84441 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  84444 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84446 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84449 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84453 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84457 */       GIR_RootConstrainSelectedInstOperands,
     /*  84458 */       // GIR_Coverage, 5349,
     /*  84458 */       GIR_EraseRootFromParent_Done,
     /*  84459 */     // Label 1397: @84459
     /*  84459 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(84576), // Rule ID 5352 //
     /*  84464 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84467 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84471 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84475 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84479 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84482 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  84487 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84491 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84495 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84500 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84505 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84507 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84507 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84510 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84514 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84519 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84521 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84524 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84528 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84533 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84536 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84540 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84543 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84548 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84553 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84558 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  84561 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84563 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84566 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84570 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84574 */       GIR_RootConstrainSelectedInstOperands,
     /*  84575 */       // GIR_Coverage, 5352,
     /*  84575 */       GIR_EraseRootFromParent_Done,
     /*  84576 */     // Label 1398: @84576
     /*  84576 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84677), // Rule ID 4908 //
     /*  84581 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84585 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84589 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84593 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  84596 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  84601 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84612 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84675 */       GIR_RootConstrainSelectedInstOperands,
     /*  84676 */       // GIR_Coverage, 4908,
     /*  84676 */       GIR_EraseRootFromParent_Done,
     /*  84677 */     // Label 1399: @84677
     /*  84677 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84733), // Rule ID 5501 //
     /*  84682 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84686 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84690 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84694 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84699 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84703 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84707 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84711 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84716 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84718 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84718 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84721 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84723 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84727 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84731 */       GIR_RootConstrainSelectedInstOperands,
     /*  84732 */       // GIR_Coverage, 5501,
     /*  84732 */       GIR_EraseRootFromParent_Done,
     /*  84733 */     // Label 1400: @84733
     /*  84733 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84799), // Rule ID 5798 //
     /*  84738 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84742 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84746 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84752 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84754 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84756 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84756 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84759 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84763 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84768 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84772 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84774 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84777 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84779 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84782 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84785 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84788 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84793 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84798 */       // GIR_Coverage, 5798,
     /*  84798 */       GIR_EraseRootFromParent_Done,
     /*  84799 */     // Label 1401: @84799
     /*  84799 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84865), // Rule ID 5802 //
     /*  84804 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84808 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84812 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84818 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84820 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84822 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84822 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84825 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84829 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84834 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84838 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84840 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84843 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84845 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84848 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84851 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84854 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84859 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84864 */       // GIR_Coverage, 5802,
     /*  84864 */       GIR_EraseRootFromParent_Done,
     /*  84865 */     // Label 1402: @84865
     /*  84865 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84958), // Rule ID 4916 //
     /*  84870 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84874 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84878 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84882 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84886 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84891 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84893 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84893 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84896 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84900 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84905 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84907 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84910 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84914 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84919 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84922 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84926 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84934 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84939 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84949 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84952 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84956 */       GIR_RootConstrainSelectedInstOperands,
     /*  84957 */       // GIR_Coverage, 4916,
     /*  84957 */       GIR_EraseRootFromParent_Done,
     /*  84958 */     // Label 1403: @84958
     /*  84958 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(85054), // Rule ID 4960 //
     /*  84963 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84966 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84970 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84974 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84978 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84987 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84989 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84989 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84992 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84996 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85001 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85015 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85022 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  85043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85048 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  85052 */       GIR_RootConstrainSelectedInstOperands,
     /*  85053 */       // GIR_Coverage, 4960,
     /*  85053 */       GIR_EraseRootFromParent_Done,
     /*  85054 */     // Label 1404: @85054
     /*  85054 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(85116), // Rule ID 5799 //
     /*  85059 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85063 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85067 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85071 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85073 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  85073 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85076 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85080 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85085 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85087 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85090 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85092 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85095 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85097 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85100 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85105 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85110 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85115 */       // GIR_Coverage, 5799,
     /*  85115 */       GIR_EraseRootFromParent_Done,
     /*  85116 */     // Label 1405: @85116
     /*  85116 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(85178), // Rule ID 5803 //
     /*  85121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85125 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85129 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85133 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85135 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  85135 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  85138 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85142 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85147 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85149 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85152 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85154 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85157 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85159 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85162 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85167 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85172 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85177 */       // GIR_Coverage, 5803,
     /*  85177 */       GIR_EraseRootFromParent_Done,
     /*  85178 */     // Label 1406: @85178
     /*  85178 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(85312), // Rule ID 5797 //
     /*  85183 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85187 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85191 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85191 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85194 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85198 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85203 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85205 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85208 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85212 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85217 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85220 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85224 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85227 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85232 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85237 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85242 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85245 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85249 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85254 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85268 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85271 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85275 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85304 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85307 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85310 */       GIR_RootConstrainSelectedInstOperands,
     /*  85311 */       // GIR_Coverage, 5797,
     /*  85311 */       GIR_EraseRootFromParent_Done,
     /*  85312 */     // Label 1407: @85312
     /*  85312 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(85446), // Rule ID 5801 //
     /*  85317 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85321 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85325 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85325 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85328 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85332 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85337 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85339 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85342 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85346 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85351 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85354 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85358 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85361 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85366 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85371 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85376 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85379 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85383 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85388 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85390 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85393 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85397 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85402 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85405 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85409 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85412 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85417 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85422 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85427 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85430 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85438 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85441 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85444 */       GIR_RootConstrainSelectedInstOperands,
     /*  85445 */       // GIR_Coverage, 5801,
     /*  85445 */       GIR_EraseRootFromParent_Done,
     /*  85446 */     // Label 1408: @85446
     /*  85446 */     GIM_Reject,
     /*  85447 */   // Label 1384: @85447
     /*  85447 */   GIM_Reject,
     /*  85448 */   // Label 1343: @85448
     /*  85448 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87358),
     /*  85453 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  85459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85463 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85592), // Rule ID 5419 //
     /*  85468 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85472 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85476 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85480 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85484 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85488 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85492 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85496 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85500 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85504 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85508 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85512 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85517 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85521 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85527 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85529 */       // MIs[2] Operand 2
     /*  85529 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85540 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85542 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  85542 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85545 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85549 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85554 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85561 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85574 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85577 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85579 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85582 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85590 */       GIR_RootConstrainSelectedInstOperands,
     /*  85591 */       // GIR_Coverage, 5419,
     /*  85591 */       GIR_EraseRootFromParent_Done,
     /*  85592 */     // Label 1410: @85592
     /*  85592 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(85714), // Rule ID 5415 //
     /*  85597 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85601 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85605 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85609 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85613 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85617 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85621 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85625 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85629 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  85633 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85637 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85641 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85646 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85651 */       // MIs[2] Operand 2
     /*  85651 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85662 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85664 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85664 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85667 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85671 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85676 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85679 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85683 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85686 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85691 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85696 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85699 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85701 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85704 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85712 */       GIR_RootConstrainSelectedInstOperands,
     /*  85713 */       // GIR_Coverage, 5415,
     /*  85713 */       GIR_EraseRootFromParent_Done,
     /*  85714 */     // Label 1411: @85714
     /*  85714 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85836), // Rule ID 5417 //
     /*  85719 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85723 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85727 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85731 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85735 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85739 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85743 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85747 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85751 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85755 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85759 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85763 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85768 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85773 */       // MIs[2] Operand 2
     /*  85773 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85784 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85786 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85786 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85789 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85793 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85798 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85801 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85805 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85808 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85813 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85818 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85821 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85823 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85826 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85830 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85834 */       GIR_RootConstrainSelectedInstOperands,
     /*  85835 */       // GIR_Coverage, 5417,
     /*  85835 */       GIR_EraseRootFromParent_Done,
     /*  85836 */     // Label 1412: @85836
     /*  85836 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85938), // Rule ID 5575 //
     /*  85841 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85845 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85849 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85853 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85857 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85861 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85865 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85870 */       // MIs[2] Operand 2
     /*  85870 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85881 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85885 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85889 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85893 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85897 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85901 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85905 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85910 */       // MIs[4] Operand 2
     /*  85910 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85921 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85923 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85928 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85932 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85936 */       GIR_RootConstrainSelectedInstOperands,
     /*  85937 */       // GIR_Coverage, 5575,
     /*  85937 */       GIR_EraseRootFromParent_Done,
     /*  85938 */     // Label 1413: @85938
     /*  85938 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(86067), // Rule ID 6335 //
     /*  85943 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85947 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85951 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85955 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85958 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85963 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85967 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85971 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85976 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85980 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85982 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85982 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85985 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85989 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85994 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  85997 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  85999 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86002 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86006 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86011 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86013 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86016 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86020 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86025 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86028 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  86032 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86040 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86045 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86050 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86053 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86055 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86058 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  86062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86065 */       GIR_RootConstrainSelectedInstOperands,
     /*  86066 */       // GIR_Coverage, 6335,
     /*  86066 */       GIR_EraseRootFromParent_Done,
     /*  86067 */     // Label 1414: @86067
     /*  86067 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(86109), // Rule ID 5808 //
     /*  86072 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86079 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  86086 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  86086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86091 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  86096 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86099 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86104 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86107 */       GIR_RootConstrainSelectedInstOperands,
     /*  86108 */       // GIR_Coverage, 5808,
     /*  86108 */       GIR_EraseRootFromParent_Done,
     /*  86109 */     // Label 1415: @86109
     /*  86109 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(86232), // Rule ID 2574 //
     /*  86114 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86117 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86121 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86125 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86129 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86132 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  86137 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86141 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  86145 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86150 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  86154 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86158 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86162 */       // MIs[2] Operand 1
     /*  86162 */       // No operand predicates
     /*  86162 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86164 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86164 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86167 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86171 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86176 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86178 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86181 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86185 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86190 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86193 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86197 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86200 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86205 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86210 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  86218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86223 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86227 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  86230 */       GIR_RootConstrainSelectedInstOperands,
     /*  86231 */       // GIR_Coverage, 2574,
     /*  86231 */       GIR_EraseRootFromParent_Done,
     /*  86232 */     // Label 1416: @86232
     /*  86232 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(86355), // Rule ID 6305 //
     /*  86237 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86240 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86244 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86248 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86252 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86256 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86260 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  86264 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86268 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86273 */       // MIs[2] imm
     /*  86273 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86277 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86281 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86285 */       // MIs[3] Operand 1
     /*  86285 */       // No operand predicates
     /*  86285 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86287 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86287 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86290 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86294 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86299 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86301 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86304 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86308 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86313 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86316 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86320 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86323 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86338 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86341 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86343 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86346 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86350 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86353 */       GIR_RootConstrainSelectedInstOperands,
     /*  86354 */       // GIR_Coverage, 6305,
     /*  86354 */       GIR_EraseRootFromParent_Done,
     /*  86355 */     // Label 1417: @86355
     /*  86355 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(86475), // Rule ID 6341 //
     /*  86360 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86364 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86368 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86372 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86376 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86380 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  86384 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86388 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86393 */       // MIs[2] imm
     /*  86393 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86397 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86401 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86405 */       // MIs[3] Operand 1
     /*  86405 */       // No operand predicates
     /*  86405 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86407 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86407 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86410 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86414 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86419 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86421 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86424 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86428 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86433 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86436 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86440 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86443 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86448 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86453 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86458 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86461 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86463 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86466 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86470 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86473 */       GIR_RootConstrainSelectedInstOperands,
     /*  86474 */       // GIR_Coverage, 6341,
     /*  86474 */       GIR_EraseRootFromParent_Done,
     /*  86475 */     // Label 1418: @86475
     /*  86475 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(86592), // Rule ID 2499 //
     /*  86480 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86483 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86487 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86491 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86495 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86498 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  86503 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86507 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86516 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86521 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86523 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86523 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86526 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86530 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86535 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86537 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86540 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86544 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86549 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86552 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86556 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86574 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  86577 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86579 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86582 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86590 */       GIR_RootConstrainSelectedInstOperands,
     /*  86591 */       // GIR_Coverage, 2499,
     /*  86591 */       GIR_EraseRootFromParent_Done,
     /*  86592 */     // Label 1419: @86592
     /*  86592 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86709), // Rule ID 5345 //
     /*  86597 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86600 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86604 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86608 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86612 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86615 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  86620 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86624 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86628 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86633 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86638 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86640 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86640 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86643 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86647 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86652 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86654 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86657 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86661 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86666 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86669 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86673 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86686 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86691 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  86694 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86696 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86699 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86703 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86707 */       GIR_RootConstrainSelectedInstOperands,
     /*  86708 */       // GIR_Coverage, 5345,
     /*  86708 */       GIR_EraseRootFromParent_Done,
     /*  86709 */     // Label 1420: @86709
     /*  86709 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86826), // Rule ID 5348 //
     /*  86714 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86717 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86721 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86725 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86729 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86732 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86737 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86741 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86745 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86750 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86755 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86757 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86757 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86760 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86764 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86769 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86771 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86774 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86778 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86783 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86786 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86790 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86793 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86798 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86803 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86808 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86811 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86813 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86816 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86820 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86824 */       GIR_RootConstrainSelectedInstOperands,
     /*  86825 */       // GIR_Coverage, 5348,
     /*  86825 */       GIR_EraseRootFromParent_Done,
     /*  86826 */     // Label 1421: @86826
     /*  86826 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86943), // Rule ID 5351 //
     /*  86831 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86834 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86838 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86842 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86846 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86849 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86854 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86858 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86862 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86867 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86872 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86874 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86874 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86877 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86881 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86886 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86888 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86891 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86895 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86900 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86903 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86907 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86910 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86915 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86920 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86925 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86928 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86930 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86933 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86937 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86941 */       GIR_RootConstrainSelectedInstOperands,
     /*  86942 */       // GIR_Coverage, 5351,
     /*  86942 */       GIR_EraseRootFromParent_Done,
     /*  86943 */     // Label 1422: @86943
     /*  86943 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86999), // Rule ID 5492 //
     /*  86948 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86952 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86956 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86960 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86965 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86969 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86973 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86977 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86982 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86984 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86984 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86987 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86989 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  86993 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  86997 */       GIR_RootConstrainSelectedInstOperands,
     /*  86998 */       // GIR_Coverage, 5492,
     /*  86998 */       GIR_EraseRootFromParent_Done,
     /*  86999 */     // Label 1423: @86999
     /*  86999 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(87065), // Rule ID 5806 //
     /*  87004 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87008 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87012 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87018 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  87020 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87022 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  87022 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87025 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  87029 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87034 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  87038 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  87043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87045 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87048 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87051 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87054 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87059 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87064 */       // GIR_Coverage, 5806,
     /*  87064 */       GIR_EraseRootFromParent_Done,
     /*  87065 */     // Label 1424: @87065
     /*  87065 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(87161), // Rule ID 4959 //
     /*  87070 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87073 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87077 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87081 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  87085 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87089 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87094 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87096 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  87096 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87099 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87103 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87108 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87110 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87113 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87117 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87122 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87125 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87129 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87132 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87137 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87147 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  87150 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87152 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87155 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87159 */       GIR_RootConstrainSelectedInstOperands,
     /*  87160 */       // GIR_Coverage, 4959,
     /*  87160 */       GIR_EraseRootFromParent_Done,
     /*  87161 */     // Label 1425: @87161
     /*  87161 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(87223), // Rule ID 5807 //
     /*  87166 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87170 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87174 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  87178 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87180 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  87180 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  87183 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87187 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87192 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  87194 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87197 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87199 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87202 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87204 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87207 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87212 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87217 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87222 */       // GIR_Coverage, 5807,
     /*  87222 */       GIR_EraseRootFromParent_Done,
     /*  87223 */     // Label 1426: @87223
     /*  87223 */     GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(87357), // Rule ID 5805 //
     /*  87228 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87232 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87236 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  87236 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  87239 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87243 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87248 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  87250 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  87253 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87257 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87262 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  87265 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  87269 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  87272 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87277 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87282 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87287 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87290 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87294 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87299 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87301 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87304 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87308 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87313 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87316 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87320 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87323 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87338 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  87341 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87343 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87346 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  87349 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  87352 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87355 */       GIR_RootConstrainSelectedInstOperands,
     /*  87356 */       // GIR_Coverage, 5805,
     /*  87356 */       GIR_EraseRootFromParent_Done,
     /*  87357 */     // Label 1427: @87357
     /*  87357 */     GIM_Reject,
     /*  87358 */   // Label 1409: @87358
     /*  87358 */   GIM_Reject,
     /*  87359 */   // Label 1344: @87359
     /*  87359 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(87384), // Rule ID 9049 //
     /*  87364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87367 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  87370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  87373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87377 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  87377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  87382 */     GIR_RootConstrainSelectedInstOperands,
     /*  87383 */     // GIR_Coverage, 9049,
     /*  87383 */     GIR_Done,
     /*  87384 */   // Label 1428: @87384
     /*  87384 */   GIM_Reject,
     /*  87385 */   // Label 1345: @87385
     /*  87385 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(87410), // Rule ID 9050 //
     /*  87390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87393 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  87396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  87399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87403 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  87403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  87408 */     GIR_RootConstrainSelectedInstOperands,
     /*  87409 */     // GIR_Coverage, 9050,
     /*  87409 */     GIR_Done,
     /*  87410 */   // Label 1429: @87410
     /*  87410 */   GIM_Reject,
     /*  87411 */   // Label 1346: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(87436), // Rule ID 9053 //
     /*  87416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87419 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  87422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  87425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87429 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  87429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87434 */     GIR_RootConstrainSelectedInstOperands,
     /*  87435 */     // GIR_Coverage, 9053,
     /*  87435 */     GIR_Done,
     /*  87436 */   // Label 1430: @87436
     /*  87436 */   GIM_Reject,
     /*  87437 */   // Label 1347: @87437
     /*  87437 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(87462), // Rule ID 9055 //
     /*  87442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87445 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  87448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  87451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87455 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  87455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87460 */     GIR_RootConstrainSelectedInstOperands,
     /*  87461 */     // GIR_Coverage, 9055,
     /*  87461 */     GIR_Done,
     /*  87462 */   // Label 1431: @87462
     /*  87462 */   GIM_Reject,
     /*  87463 */   // Label 1348: @87463
     /*  87463 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(87488), // Rule ID 9051 //
     /*  87468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87471 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  87474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  87477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87481 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  87481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  87486 */     GIR_RootConstrainSelectedInstOperands,
     /*  87487 */     // GIR_Coverage, 9051,
     /*  87487 */     GIR_Done,
     /*  87488 */   // Label 1432: @87488
     /*  87488 */   GIM_Reject,
     /*  87489 */   // Label 1349: @87489
     /*  87489 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(87514), // Rule ID 9054 //
     /*  87494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87497 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  87500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  87503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87507 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  87507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  87512 */     GIR_RootConstrainSelectedInstOperands,
     /*  87513 */     // GIR_Coverage, 9054,
     /*  87513 */     GIR_Done,
     /*  87514 */   // Label 1433: @87514
     /*  87514 */   GIM_Reject,
     /*  87515 */   // Label 1350: @87515
     /*  87515 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(87540), // Rule ID 9052 //
     /*  87520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87523 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  87526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  87529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87533 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  87533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  87538 */     GIR_RootConstrainSelectedInstOperands,
     /*  87539 */     // GIR_Coverage, 9052,
     /*  87539 */     GIR_Done,
     /*  87540 */   // Label 1434: @87540
     /*  87540 */   GIM_Reject,
     /*  87541 */   // Label 1351: @87541
     /*  87541 */   GIM_Reject,
     /*  87542 */ // Label 1339: @87542
     /*  87542 */ GIM_Reject,
     /*  87543 */ // Label 9: @87543
     /*  87543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1449*/ GIMT_Encode4(97486),
     /*  87554 */ /*GILLT_s32*//*Label 1435*/ GIMT_Encode4(87642),
     /*  87558 */ /*GILLT_s64*//*Label 1436*/ GIMT_Encode4(88023),
     /*  87562 */ /*GILLT_s128*//*Label 1437*/ GIMT_Encode4(89998),
     /*  87566 */ /*GILLT_v2s32*//*Label 1438*/ GIMT_Encode4(90644),
     /*  87570 */ /*GILLT_v2s64*//*Label 1439*/ GIMT_Encode4(91559),
     /*  87574 */ /*GILLT_v4s16*//*Label 1440*/ GIMT_Encode4(92328),
     /*  87578 */ /*GILLT_v4s32*//*Label 1441*/ GIMT_Encode4(93243),
     /*  87582 */ /*GILLT_v8s8*//*Label 1442*/ GIMT_Encode4(94088),
     /*  87586 */ /*GILLT_v8s16*//*Label 1443*/ GIMT_Encode4(94649),
     /*  87590 */ /*GILLT_v16s8*//*Label 1444*/ GIMT_Encode4(95494), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87610 */ /*GILLT_nxv2s64*//*Label 1445*/ GIMT_Encode4(95946), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87622 */ /*GILLT_nxv4s32*//*Label 1446*/ GIMT_Encode4(96395), GIMT_Encode4(0),
     /*  87630 */ /*GILLT_nxv8s16*//*Label 1447*/ GIMT_Encode4(96844), GIMT_Encode4(0),
     /*  87638 */ /*GILLT_nxv16s8*//*Label 1448*/ GIMT_Encode4(97293),
     /*  87642 */ // Label 1435: @87642
     /*  87642 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(88022),
     /*  87647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87650 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(87720), // Rule ID 7056 //
     /*  87655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87667 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87670 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87677 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  87693 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  87693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  87696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87718 */     GIR_RootConstrainSelectedInstOperands,
     /*  87719 */     // GIR_Coverage, 7056,
     /*  87719 */     GIR_EraseRootFromParent_Done,
     /*  87720 */   // Label 1451: @87720
     /*  87720 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(87790), // Rule ID 7057 //
     /*  87725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87737 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87740 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87747 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87763 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87788 */     GIR_RootConstrainSelectedInstOperands,
     /*  87789 */     // GIR_Coverage, 7057,
     /*  87789 */     GIR_EraseRootFromParent_Done,
     /*  87790 */   // Label 1452: @87790
     /*  87790 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87855), // Rule ID 7058 //
     /*  87795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87807 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87810 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87817 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87820 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87833 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87853 */     GIR_RootConstrainSelectedInstOperands,
     /*  87854 */     // GIR_Coverage, 7058,
     /*  87854 */     GIR_EraseRootFromParent_Done,
     /*  87855 */   // Label 1453: @87855
     /*  87855 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87920), // Rule ID 7059 //
     /*  87860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87872 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87875 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87882 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87898 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87918 */     GIR_RootConstrainSelectedInstOperands,
     /*  87919 */     // GIR_Coverage, 7059,
     /*  87919 */     GIR_EraseRootFromParent_Done,
     /*  87920 */   // Label 1454: @87920
     /*  87920 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87973), // Rule ID 5772 //
     /*  87925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87951 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87956 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87972 */     // GIR_Coverage, 5772,
     /*  87972 */     GIR_EraseRootFromParent_Done,
     /*  87973 */   // Label 1455: @87973
     /*  87973 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87997), // Rule ID 6667 //
     /*  87978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87986 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  87986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87996 */     // GIR_Coverage, 6667,
     /*  87996 */     GIR_Done,
     /*  87997 */   // Label 1456: @87997
     /*  87997 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(88021), // Rule ID 6668 //
     /*  88002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  88010 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  88010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88020 */     // GIR_Coverage, 6668,
     /*  88020 */     GIR_Done,
     /*  88021 */   // Label 1457: @88021
     /*  88021 */   GIM_Reject,
     /*  88022 */ // Label 1450: @88022
     /*  88022 */ GIM_Reject,
     /*  88023 */ // Label 1436: @88023
     /*  88023 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(88096), // Rule ID 7060 //
     /*  88028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88043 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88046 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88053 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88056 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88060 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88062 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  88069 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  88069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  88072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88094 */   GIR_RootConstrainSelectedInstOperands,
     /*  88095 */   // GIR_Coverage, 7060,
     /*  88095 */   GIR_EraseRootFromParent_Done,
     /*  88096 */ // Label 1458: @88096
     /*  88096 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(88169), // Rule ID 7061 //
     /*  88101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88116 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88119 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88126 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88129 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88135 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  88142 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  88142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  88145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  88157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  88162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88167 */   GIR_RootConstrainSelectedInstOperands,
     /*  88168 */   // GIR_Coverage, 7061,
     /*  88168 */   GIR_EraseRootFromParent_Done,
     /*  88169 */ // Label 1459: @88169
     /*  88169 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(88237), // Rule ID 7062 //
     /*  88174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88189 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88192 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88199 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88202 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88208 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  88215 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  88215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  88218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88235 */   GIR_RootConstrainSelectedInstOperands,
     /*  88236 */   // GIR_Coverage, 7062,
     /*  88236 */   GIR_EraseRootFromParent_Done,
     /*  88237 */ // Label 1460: @88237
     /*  88237 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(88305), // Rule ID 7063 //
     /*  88242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88257 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88260 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88267 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88270 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88276 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  88283 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  88283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  88286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88303 */   GIR_RootConstrainSelectedInstOperands,
     /*  88304 */   // GIR_Coverage, 7063,
     /*  88304 */   GIR_EraseRootFromParent_Done,
     /*  88305 */ // Label 1461: @88305
     /*  88305 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(88361), // Rule ID 5774 //
     /*  88310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  88325 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88329 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88333 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  88337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88339 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  88339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88344 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  88350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88360 */   // GIR_Coverage, 5774,
     /*  88360 */   GIR_EraseRootFromParent_Done,
     /*  88361 */ // Label 1462: @88361
     /*  88361 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(88391), // Rule ID 6642 //
     /*  88366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88380 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  88380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88390 */   // GIR_Coverage, 6642,
     /*  88390 */   GIR_Done,
     /*  88391 */ // Label 1463: @88391
     /*  88391 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(88421), // Rule ID 6643 //
     /*  88396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88410 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  88410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88420 */   // GIR_Coverage, 6643,
     /*  88420 */   GIR_Done,
     /*  88421 */ // Label 1464: @88421
     /*  88421 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(88451), // Rule ID 6644 //
     /*  88426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88440 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  88440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88450 */   // GIR_Coverage, 6644,
     /*  88450 */   GIR_Done,
     /*  88451 */ // Label 1465: @88451
     /*  88451 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(88481), // Rule ID 6645 //
     /*  88456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88470 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  88470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88480 */   // GIR_Coverage, 6645,
     /*  88480 */   GIR_Done,
     /*  88481 */ // Label 1466: @88481
     /*  88481 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(88511), // Rule ID 6646 //
     /*  88486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88500 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  88500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88510 */   // GIR_Coverage, 6646,
     /*  88510 */   GIR_Done,
     /*  88511 */ // Label 1467: @88511
     /*  88511 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(88541), // Rule ID 6647 //
     /*  88516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88530 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88540 */   // GIR_Coverage, 6647,
     /*  88540 */   GIR_Done,
     /*  88541 */ // Label 1468: @88541
     /*  88541 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(88591), // Rule ID 6653 //
     /*  88546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88560 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  88560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88572 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88589 */   GIR_RootConstrainSelectedInstOperands,
     /*  88590 */   // GIR_Coverage, 6653,
     /*  88590 */   GIR_EraseRootFromParent_Done,
     /*  88591 */ // Label 1469: @88591
     /*  88591 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(88641), // Rule ID 6654 //
     /*  88596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88610 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88622 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88639 */   GIR_RootConstrainSelectedInstOperands,
     /*  88640 */   // GIR_Coverage, 6654,
     /*  88640 */   GIR_EraseRootFromParent_Done,
     /*  88641 */ // Label 1470: @88641
     /*  88641 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88691), // Rule ID 6655 //
     /*  88646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88660 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88672 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88689 */   GIR_RootConstrainSelectedInstOperands,
     /*  88690 */   // GIR_Coverage, 6655,
     /*  88690 */   GIR_EraseRootFromParent_Done,
     /*  88691 */ // Label 1471: @88691
     /*  88691 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88741), // Rule ID 6656 //
     /*  88696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88710 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88722 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88739 */   GIR_RootConstrainSelectedInstOperands,
     /*  88740 */   // GIR_Coverage, 6656,
     /*  88740 */   GIR_EraseRootFromParent_Done,
     /*  88741 */ // Label 1472: @88741
     /*  88741 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88791), // Rule ID 6657 //
     /*  88746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88760 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88789 */   GIR_RootConstrainSelectedInstOperands,
     /*  88790 */   // GIR_Coverage, 6657,
     /*  88790 */   GIR_EraseRootFromParent_Done,
     /*  88791 */ // Label 1473: @88791
     /*  88791 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88818), // Rule ID 6658 //
     /*  88796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88807 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88812 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88817 */   // GIR_Coverage, 6658,
     /*  88817 */   GIR_Done,
     /*  88818 */ // Label 1474: @88818
     /*  88818 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88845), // Rule ID 6659 //
     /*  88823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88834 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88844 */   // GIR_Coverage, 6659,
     /*  88844 */   GIR_Done,
     /*  88845 */ // Label 1475: @88845
     /*  88845 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88872), // Rule ID 6660 //
     /*  88850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88861 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88871 */   // GIR_Coverage, 6660,
     /*  88871 */   GIR_Done,
     /*  88872 */ // Label 1476: @88872
     /*  88872 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88899), // Rule ID 6669 //
     /*  88877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88888 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88898 */   // GIR_Coverage, 6669,
     /*  88898 */   GIR_Done,
     /*  88899 */ // Label 1477: @88899
     /*  88899 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88926), // Rule ID 6670 //
     /*  88904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88915 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88925 */   // GIR_Coverage, 6670,
     /*  88925 */   GIR_Done,
     /*  88926 */ // Label 1478: @88926
     /*  88926 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88953), // Rule ID 6671 //
     /*  88931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88942 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88952 */   // GIR_Coverage, 6671,
     /*  88952 */   GIR_Done,
     /*  88953 */ // Label 1479: @88953
     /*  88953 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88985), // Rule ID 6672 //
     /*  88958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88972 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88984 */   // GIR_Coverage, 6672,
     /*  88984 */   GIR_EraseRootFromParent_Done,
     /*  88985 */ // Label 1480: @88985
     /*  88985 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(89017), // Rule ID 6673 //
     /*  88990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89004 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89016 */   // GIR_Coverage, 6673,
     /*  89016 */   GIR_EraseRootFromParent_Done,
     /*  89017 */ // Label 1481: @89017
     /*  89017 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(89049), // Rule ID 6674 //
     /*  89022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89036 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89048 */   // GIR_Coverage, 6674,
     /*  89048 */   GIR_EraseRootFromParent_Done,
     /*  89049 */ // Label 1482: @89049
     /*  89049 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(89081), // Rule ID 6675 //
     /*  89054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89068 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89080 */   // GIR_Coverage, 6675,
     /*  89080 */   GIR_EraseRootFromParent_Done,
     /*  89081 */ // Label 1483: @89081
     /*  89081 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(89113), // Rule ID 6676 //
     /*  89086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89100 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89112 */   // GIR_Coverage, 6676,
     /*  89112 */   GIR_EraseRootFromParent_Done,
     /*  89113 */ // Label 1484: @89113
     /*  89113 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(89139), // Rule ID 6677 //
     /*  89118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89132 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  89132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89137 */   GIR_RootConstrainSelectedInstOperands,
     /*  89138 */   // GIR_Coverage, 6677,
     /*  89138 */   GIR_Done,
     /*  89139 */ // Label 1485: @89139
     /*  89139 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(89165), // Rule ID 6678 //
     /*  89144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89158 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  89158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89163 */   GIR_RootConstrainSelectedInstOperands,
     /*  89164 */   // GIR_Coverage, 6678,
     /*  89164 */   GIR_Done,
     /*  89165 */ // Label 1486: @89165
     /*  89165 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(89191), // Rule ID 6679 //
     /*  89170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89184 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  89184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89189 */   GIR_RootConstrainSelectedInstOperands,
     /*  89190 */   // GIR_Coverage, 6679,
     /*  89190 */   GIR_Done,
     /*  89191 */ // Label 1487: @89191
     /*  89191 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(89217), // Rule ID 6680 //
     /*  89196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89210 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  89210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89215 */   GIR_RootConstrainSelectedInstOperands,
     /*  89216 */   // GIR_Coverage, 6680,
     /*  89216 */   GIR_Done,
     /*  89217 */ // Label 1488: @89217
     /*  89217 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(89243), // Rule ID 6681 //
     /*  89222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89236 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  89236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89241 */   GIR_RootConstrainSelectedInstOperands,
     /*  89242 */   // GIR_Coverage, 6681,
     /*  89242 */   GIR_Done,
     /*  89243 */ // Label 1489: @89243
     /*  89243 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(89272), // Rule ID 6682 //
     /*  89248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89259 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89271 */   // GIR_Coverage, 6682,
     /*  89271 */   GIR_EraseRootFromParent_Done,
     /*  89272 */ // Label 1490: @89272
     /*  89272 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(89301), // Rule ID 6683 //
     /*  89277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89288 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89300 */   // GIR_Coverage, 6683,
     /*  89300 */   GIR_EraseRootFromParent_Done,
     /*  89301 */ // Label 1491: @89301
     /*  89301 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(89333), // Rule ID 6737 //
     /*  89306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89320 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89323 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89332 */   // GIR_Coverage, 6737,
     /*  89332 */   GIR_EraseRootFromParent_Done,
     /*  89333 */ // Label 1492: @89333
     /*  89333 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(89365), // Rule ID 6738 //
     /*  89338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89352 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89364 */   // GIR_Coverage, 6738,
     /*  89364 */   GIR_EraseRootFromParent_Done,
     /*  89365 */ // Label 1493: @89365
     /*  89365 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(89397), // Rule ID 6739 //
     /*  89370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89384 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89396 */   // GIR_Coverage, 6739,
     /*  89396 */   GIR_EraseRootFromParent_Done,
     /*  89397 */ // Label 1494: @89397
     /*  89397 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(89429), // Rule ID 6740 //
     /*  89402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89416 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89419 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89428 */   // GIR_Coverage, 6740,
     /*  89428 */   GIR_EraseRootFromParent_Done,
     /*  89429 */ // Label 1495: @89429
     /*  89429 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(89461), // Rule ID 6741 //
     /*  89434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89448 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89460 */   // GIR_Coverage, 6741,
     /*  89460 */   GIR_EraseRootFromParent_Done,
     /*  89461 */ // Label 1496: @89461
     /*  89461 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(89487), // Rule ID 6742 //
     /*  89466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89480 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89485 */   GIR_RootConstrainSelectedInstOperands,
     /*  89486 */   // GIR_Coverage, 6742,
     /*  89486 */   GIR_Done,
     /*  89487 */ // Label 1497: @89487
     /*  89487 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(89513), // Rule ID 6743 //
     /*  89492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89506 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89511 */   GIR_RootConstrainSelectedInstOperands,
     /*  89512 */   // GIR_Coverage, 6743,
     /*  89512 */   GIR_Done,
     /*  89513 */ // Label 1498: @89513
     /*  89513 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(89539), // Rule ID 6744 //
     /*  89518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89532 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89537 */   GIR_RootConstrainSelectedInstOperands,
     /*  89538 */   // GIR_Coverage, 6744,
     /*  89538 */   GIR_Done,
     /*  89539 */ // Label 1499: @89539
     /*  89539 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(89565), // Rule ID 6745 //
     /*  89544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89558 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89563 */   GIR_RootConstrainSelectedInstOperands,
     /*  89564 */   // GIR_Coverage, 6745,
     /*  89564 */   GIR_Done,
     /*  89565 */ // Label 1500: @89565
     /*  89565 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(89591), // Rule ID 6746 //
     /*  89570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89584 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89589 */   GIR_RootConstrainSelectedInstOperands,
     /*  89590 */   // GIR_Coverage, 6746,
     /*  89590 */   GIR_Done,
     /*  89591 */ // Label 1501: @89591
     /*  89591 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(89620), // Rule ID 6747 //
     /*  89596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89607 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89610 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89612 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89614 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89619 */   // GIR_Coverage, 6747,
     /*  89619 */   GIR_EraseRootFromParent_Done,
     /*  89620 */ // Label 1502: @89620
     /*  89620 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(89649), // Rule ID 6748 //
     /*  89625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89636 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89648 */   // GIR_Coverage, 6748,
     /*  89648 */   GIR_EraseRootFromParent_Done,
     /*  89649 */ // Label 1503: @89649
     /*  89649 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89681), // Rule ID 6749 //
     /*  89654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89668 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89680 */   // GIR_Coverage, 6749,
     /*  89680 */   GIR_EraseRootFromParent_Done,
     /*  89681 */ // Label 1504: @89681
     /*  89681 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89713), // Rule ID 6750 //
     /*  89686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89700 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89712 */   // GIR_Coverage, 6750,
     /*  89712 */   GIR_EraseRootFromParent_Done,
     /*  89713 */ // Label 1505: @89713
     /*  89713 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89745), // Rule ID 6751 //
     /*  89718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89732 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89744 */   // GIR_Coverage, 6751,
     /*  89744 */   GIR_EraseRootFromParent_Done,
     /*  89745 */ // Label 1506: @89745
     /*  89745 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89777), // Rule ID 6752 //
     /*  89750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89764 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89767 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89769 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89776 */   // GIR_Coverage, 6752,
     /*  89776 */   GIR_EraseRootFromParent_Done,
     /*  89777 */ // Label 1507: @89777
     /*  89777 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89809), // Rule ID 6753 //
     /*  89782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89796 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89799 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89808 */   // GIR_Coverage, 6753,
     /*  89808 */   GIR_EraseRootFromParent_Done,
     /*  89809 */ // Label 1508: @89809
     /*  89809 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89835), // Rule ID 6754 //
     /*  89814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89828 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89833 */   GIR_RootConstrainSelectedInstOperands,
     /*  89834 */   // GIR_Coverage, 6754,
     /*  89834 */   GIR_Done,
     /*  89835 */ // Label 1509: @89835
     /*  89835 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89861), // Rule ID 6755 //
     /*  89840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89854 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89859 */   GIR_RootConstrainSelectedInstOperands,
     /*  89860 */   // GIR_Coverage, 6755,
     /*  89860 */   GIR_Done,
     /*  89861 */ // Label 1510: @89861
     /*  89861 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89887), // Rule ID 6756 //
     /*  89866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89880 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89885 */   GIR_RootConstrainSelectedInstOperands,
     /*  89886 */   // GIR_Coverage, 6756,
     /*  89886 */   GIR_Done,
     /*  89887 */ // Label 1511: @89887
     /*  89887 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89913), // Rule ID 6757 //
     /*  89892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89906 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89911 */   GIR_RootConstrainSelectedInstOperands,
     /*  89912 */   // GIR_Coverage, 6757,
     /*  89912 */   GIR_Done,
     /*  89913 */ // Label 1512: @89913
     /*  89913 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89939), // Rule ID 6758 //
     /*  89918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89932 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89937 */   GIR_RootConstrainSelectedInstOperands,
     /*  89938 */   // GIR_Coverage, 6758,
     /*  89938 */   GIR_Done,
     /*  89939 */ // Label 1513: @89939
     /*  89939 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89968), // Rule ID 6759 //
     /*  89944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89955 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89958 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89967 */   // GIR_Coverage, 6759,
     /*  89967 */   GIR_EraseRootFromParent_Done,
     /*  89968 */ // Label 1514: @89968
     /*  89968 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89997), // Rule ID 6760 //
     /*  89973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89984 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89987 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89989 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89991 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89996 */   // GIR_Coverage, 6760,
     /*  89996 */   GIR_EraseRootFromParent_Done,
     /*  89997 */ // Label 1515: @89997
     /*  89997 */ GIM_Reject,
     /*  89998 */ // Label 1437: @89998
     /*  89998 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(90030), // Rule ID 6774 //
     /*  90003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90017 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90029 */   // GIR_Coverage, 6774,
     /*  90029 */   GIR_EraseRootFromParent_Done,
     /*  90030 */ // Label 1516: @90030
     /*  90030 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(90062), // Rule ID 6775 //
     /*  90035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90049 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90061 */   // GIR_Coverage, 6775,
     /*  90061 */   GIR_EraseRootFromParent_Done,
     /*  90062 */ // Label 1517: @90062
     /*  90062 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(90094), // Rule ID 6776 //
     /*  90067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90081 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90084 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90086 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90093 */   // GIR_Coverage, 6776,
     /*  90093 */   GIR_EraseRootFromParent_Done,
     /*  90094 */ // Label 1518: @90094
     /*  90094 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(90126), // Rule ID 6777 //
     /*  90099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90113 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90116 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90118 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90125 */   // GIR_Coverage, 6777,
     /*  90125 */   GIR_EraseRootFromParent_Done,
     /*  90126 */ // Label 1519: @90126
     /*  90126 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(90158), // Rule ID 6778 //
     /*  90131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90145 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90148 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90150 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90157 */   // GIR_Coverage, 6778,
     /*  90157 */   GIR_EraseRootFromParent_Done,
     /*  90158 */ // Label 1520: @90158
     /*  90158 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(90190), // Rule ID 6779 //
     /*  90163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90177 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90180 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90182 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90189 */   // GIR_Coverage, 6779,
     /*  90189 */   GIR_EraseRootFromParent_Done,
     /*  90190 */ // Label 1521: @90190
     /*  90190 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(90222), // Rule ID 6780 //
     /*  90195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90209 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90221 */   // GIR_Coverage, 6780,
     /*  90221 */   GIR_EraseRootFromParent_Done,
     /*  90222 */ // Label 1522: @90222
     /*  90222 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(90255), // Rule ID 6781 //
     /*  90227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90241 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  90241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90248 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90253 */   GIR_RootConstrainSelectedInstOperands,
     /*  90254 */   // GIR_Coverage, 6781,
     /*  90254 */   GIR_EraseRootFromParent_Done,
     /*  90255 */ // Label 1523: @90255
     /*  90255 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(90326), // Rule ID 6782 //
     /*  90260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90274 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  90274 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90277 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90281 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90286 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90304 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90324 */   GIR_RootConstrainSelectedInstOperands,
     /*  90325 */   // GIR_Coverage, 6782,
     /*  90325 */   GIR_EraseRootFromParent_Done,
     /*  90326 */ // Label 1524: @90326
     /*  90326 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(90397), // Rule ID 6783 //
     /*  90331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90345 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  90345 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90348 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90352 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90357 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90363 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90366 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90370 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90375 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90395 */   GIR_RootConstrainSelectedInstOperands,
     /*  90396 */   // GIR_Coverage, 6783,
     /*  90396 */   GIR_EraseRootFromParent_Done,
     /*  90397 */ // Label 1525: @90397
     /*  90397 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(90468), // Rule ID 6784 //
     /*  90402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90416 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  90416 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90419 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90423 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90428 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90446 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90466 */   GIR_RootConstrainSelectedInstOperands,
     /*  90467 */   // GIR_Coverage, 6784,
     /*  90467 */   GIR_EraseRootFromParent_Done,
     /*  90468 */ // Label 1526: @90468
     /*  90468 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(90501), // Rule ID 6785 //
     /*  90473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90487 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  90487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90492 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90499 */   GIR_RootConstrainSelectedInstOperands,
     /*  90500 */   // GIR_Coverage, 6785,
     /*  90500 */   GIR_EraseRootFromParent_Done,
     /*  90501 */ // Label 1527: @90501
     /*  90501 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(90572), // Rule ID 6786 //
     /*  90506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90520 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  90520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90532 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90570 */   GIR_RootConstrainSelectedInstOperands,
     /*  90571 */   // GIR_Coverage, 6786,
     /*  90571 */   GIR_EraseRootFromParent_Done,
     /*  90572 */ // Label 1528: @90572
     /*  90572 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(90643), // Rule ID 6787 //
     /*  90577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90591 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  90591 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90594 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90598 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90603 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90641 */   GIR_RootConstrainSelectedInstOperands,
     /*  90642 */   // GIR_Coverage, 6787,
     /*  90642 */   GIR_EraseRootFromParent_Done,
     /*  90643 */ // Label 1529: @90643
     /*  90643 */ GIM_Reject,
     /*  90644 */ // Label 1438: @90644
     /*  90644 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90674), // Rule ID 6639 //
     /*  90649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90663 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90673 */   // GIR_Coverage, 6639,
     /*  90673 */   GIR_Done,
     /*  90674 */ // Label 1530: @90674
     /*  90674 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90704), // Rule ID 6641 //
     /*  90679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90693 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90703 */   // GIR_Coverage, 6641,
     /*  90703 */   GIR_Done,
     /*  90704 */ // Label 1531: @90704
     /*  90704 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90754), // Rule ID 6650 //
     /*  90709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90723 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90752 */   GIR_RootConstrainSelectedInstOperands,
     /*  90753 */   // GIR_Coverage, 6650,
     /*  90753 */   GIR_EraseRootFromParent_Done,
     /*  90754 */ // Label 1532: @90754
     /*  90754 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90804), // Rule ID 6652 //
     /*  90759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90773 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90785 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90802 */   GIR_RootConstrainSelectedInstOperands,
     /*  90803 */   // GIR_Coverage, 6652,
     /*  90803 */   GIR_EraseRootFromParent_Done,
     /*  90804 */ // Label 1533: @90804
     /*  90804 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90836), // Rule ID 6684 //
     /*  90809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90823 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90826 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90828 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90830 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90835 */   // GIR_Coverage, 6684,
     /*  90835 */   GIR_EraseRootFromParent_Done,
     /*  90836 */ // Label 1534: @90836
     /*  90836 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90868), // Rule ID 6685 //
     /*  90841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90855 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90858 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90860 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90862 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90867 */   // GIR_Coverage, 6685,
     /*  90867 */   GIR_EraseRootFromParent_Done,
     /*  90868 */ // Label 1535: @90868
     /*  90868 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90900), // Rule ID 6686 //
     /*  90873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90887 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90899 */   // GIR_Coverage, 6686,
     /*  90899 */   GIR_EraseRootFromParent_Done,
     /*  90900 */ // Label 1536: @90900
     /*  90900 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90932), // Rule ID 6687 //
     /*  90905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90919 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90931 */   // GIR_Coverage, 6687,
     /*  90931 */   GIR_EraseRootFromParent_Done,
     /*  90932 */ // Label 1537: @90932
     /*  90932 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90964), // Rule ID 6688 //
     /*  90937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90951 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90954 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90956 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90963 */   // GIR_Coverage, 6688,
     /*  90963 */   GIR_EraseRootFromParent_Done,
     /*  90964 */ // Label 1538: @90964
     /*  90964 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90996), // Rule ID 6689 //
     /*  90969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90983 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90986 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90995 */   // GIR_Coverage, 6689,
     /*  90995 */   GIR_EraseRootFromParent_Done,
     /*  90996 */ // Label 1539: @90996
     /*  90996 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(91022), // Rule ID 6690 //
     /*  91001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91015 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  91015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91020 */   GIR_RootConstrainSelectedInstOperands,
     /*  91021 */   // GIR_Coverage, 6690,
     /*  91021 */   GIR_Done,
     /*  91022 */ // Label 1540: @91022
     /*  91022 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(91048), // Rule ID 6691 //
     /*  91027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91041 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  91041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91046 */   GIR_RootConstrainSelectedInstOperands,
     /*  91047 */   // GIR_Coverage, 6691,
     /*  91047 */   GIR_Done,
     /*  91048 */ // Label 1541: @91048
     /*  91048 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(91074), // Rule ID 6692 //
     /*  91053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91067 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  91067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91072 */   GIR_RootConstrainSelectedInstOperands,
     /*  91073 */   // GIR_Coverage, 6692,
     /*  91073 */   GIR_Done,
     /*  91074 */ // Label 1542: @91074
     /*  91074 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(91100), // Rule ID 6693 //
     /*  91079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91093 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  91093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91098 */   GIR_RootConstrainSelectedInstOperands,
     /*  91099 */   // GIR_Coverage, 6693,
     /*  91099 */   GIR_Done,
     /*  91100 */ // Label 1543: @91100
     /*  91100 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(91126), // Rule ID 6694 //
     /*  91105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91119 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  91119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91124 */   GIR_RootConstrainSelectedInstOperands,
     /*  91125 */   // GIR_Coverage, 6694,
     /*  91125 */   GIR_Done,
     /*  91126 */ // Label 1544: @91126
     /*  91126 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(91152), // Rule ID 6695 //
     /*  91131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91145 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  91145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91150 */   GIR_RootConstrainSelectedInstOperands,
     /*  91151 */   // GIR_Coverage, 6695,
     /*  91151 */   GIR_Done,
     /*  91152 */ // Label 1545: @91152
     /*  91152 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(91181), // Rule ID 6696 //
     /*  91157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91168 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  91168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91171 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91173 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91180 */   // GIR_Coverage, 6696,
     /*  91180 */   GIR_EraseRootFromParent_Done,
     /*  91181 */ // Label 1546: @91181
     /*  91181 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(91213), // Rule ID 6761 //
     /*  91186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91200 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91203 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91205 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91212 */   // GIR_Coverage, 6761,
     /*  91212 */   GIR_EraseRootFromParent_Done,
     /*  91213 */ // Label 1547: @91213
     /*  91213 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(91245), // Rule ID 6762 //
     /*  91218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91232 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91235 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91244 */   // GIR_Coverage, 6762,
     /*  91244 */   GIR_EraseRootFromParent_Done,
     /*  91245 */ // Label 1548: @91245
     /*  91245 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(91277), // Rule ID 6763 //
     /*  91250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91264 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91276 */   // GIR_Coverage, 6763,
     /*  91276 */   GIR_EraseRootFromParent_Done,
     /*  91277 */ // Label 1549: @91277
     /*  91277 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(91309), // Rule ID 6764 //
     /*  91282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91296 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91308 */   // GIR_Coverage, 6764,
     /*  91308 */   GIR_EraseRootFromParent_Done,
     /*  91309 */ // Label 1550: @91309
     /*  91309 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(91341), // Rule ID 6765 //
     /*  91314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91328 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91340 */   // GIR_Coverage, 6765,
     /*  91340 */   GIR_EraseRootFromParent_Done,
     /*  91341 */ // Label 1551: @91341
     /*  91341 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(91373), // Rule ID 6766 //
     /*  91346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91360 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91372 */   // GIR_Coverage, 6766,
     /*  91372 */   GIR_EraseRootFromParent_Done,
     /*  91373 */ // Label 1552: @91373
     /*  91373 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(91399), // Rule ID 6767 //
     /*  91378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91392 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  91392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91397 */   GIR_RootConstrainSelectedInstOperands,
     /*  91398 */   // GIR_Coverage, 6767,
     /*  91398 */   GIR_Done,
     /*  91399 */ // Label 1553: @91399
     /*  91399 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(91425), // Rule ID 6768 //
     /*  91404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91418 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  91418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91423 */   GIR_RootConstrainSelectedInstOperands,
     /*  91424 */   // GIR_Coverage, 6768,
     /*  91424 */   GIR_Done,
     /*  91425 */ // Label 1554: @91425
     /*  91425 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(91451), // Rule ID 6769 //
     /*  91430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91444 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  91444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91449 */   GIR_RootConstrainSelectedInstOperands,
     /*  91450 */   // GIR_Coverage, 6769,
     /*  91450 */   GIR_Done,
     /*  91451 */ // Label 1555: @91451
     /*  91451 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(91477), // Rule ID 6770 //
     /*  91456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91470 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  91470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91475 */   GIR_RootConstrainSelectedInstOperands,
     /*  91476 */   // GIR_Coverage, 6770,
     /*  91476 */   GIR_Done,
     /*  91477 */ // Label 1556: @91477
     /*  91477 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(91503), // Rule ID 6771 //
     /*  91482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91496 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  91496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91501 */   GIR_RootConstrainSelectedInstOperands,
     /*  91502 */   // GIR_Coverage, 6771,
     /*  91502 */   GIR_Done,
     /*  91503 */ // Label 1557: @91503
     /*  91503 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(91529), // Rule ID 6772 //
     /*  91508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91522 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  91522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91527 */   GIR_RootConstrainSelectedInstOperands,
     /*  91528 */   // GIR_Coverage, 6772,
     /*  91528 */   GIR_Done,
     /*  91529 */ // Label 1558: @91529
     /*  91529 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(91558), // Rule ID 6773 //
     /*  91534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91545 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91557 */   // GIR_Coverage, 6773,
     /*  91557 */   GIR_EraseRootFromParent_Done,
     /*  91558 */ // Label 1559: @91558
     /*  91558 */ GIM_Reject,
     /*  91559 */ // Label 1439: @91559
     /*  91559 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(91591), // Rule ID 6788 //
     /*  91564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91578 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91581 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91590 */   // GIR_Coverage, 6788,
     /*  91590 */   GIR_EraseRootFromParent_Done,
     /*  91591 */ // Label 1560: @91591
     /*  91591 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(91623), // Rule ID 6789 //
     /*  91596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91610 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91613 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91615 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91622 */   // GIR_Coverage, 6789,
     /*  91622 */   GIR_EraseRootFromParent_Done,
     /*  91623 */ // Label 1561: @91623
     /*  91623 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(91655), // Rule ID 6790 //
     /*  91628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91642 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91654 */   // GIR_Coverage, 6790,
     /*  91654 */   GIR_EraseRootFromParent_Done,
     /*  91655 */ // Label 1562: @91655
     /*  91655 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91687), // Rule ID 6791 //
     /*  91660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91674 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91686 */   // GIR_Coverage, 6791,
     /*  91686 */   GIR_EraseRootFromParent_Done,
     /*  91687 */ // Label 1563: @91687
     /*  91687 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91719), // Rule ID 6792 //
     /*  91692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91706 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91709 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91711 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91718 */   // GIR_Coverage, 6792,
     /*  91718 */   GIR_EraseRootFromParent_Done,
     /*  91719 */ // Label 1564: @91719
     /*  91719 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91751), // Rule ID 6793 //
     /*  91724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91738 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91741 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91750 */   // GIR_Coverage, 6793,
     /*  91750 */   GIR_EraseRootFromParent_Done,
     /*  91751 */ // Label 1565: @91751
     /*  91751 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91784), // Rule ID 6794 //
     /*  91756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91770 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91775 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91782 */   GIR_RootConstrainSelectedInstOperands,
     /*  91783 */   // GIR_Coverage, 6794,
     /*  91783 */   GIR_EraseRootFromParent_Done,
     /*  91784 */ // Label 1566: @91784
     /*  91784 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91810), // Rule ID 6795 //
     /*  91789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91803 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91808 */   GIR_RootConstrainSelectedInstOperands,
     /*  91809 */   // GIR_Coverage, 6795,
     /*  91809 */   GIR_Done,
     /*  91810 */ // Label 1567: @91810
     /*  91810 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91836), // Rule ID 6796 //
     /*  91815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91829 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91834 */   GIR_RootConstrainSelectedInstOperands,
     /*  91835 */   // GIR_Coverage, 6796,
     /*  91835 */   GIR_Done,
     /*  91836 */ // Label 1568: @91836
     /*  91836 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91862), // Rule ID 6797 //
     /*  91841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91855 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91860 */   GIR_RootConstrainSelectedInstOperands,
     /*  91861 */   // GIR_Coverage, 6797,
     /*  91861 */   GIR_Done,
     /*  91862 */ // Label 1569: @91862
     /*  91862 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91888), // Rule ID 6798 //
     /*  91867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91881 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91886 */   GIR_RootConstrainSelectedInstOperands,
     /*  91887 */   // GIR_Coverage, 6798,
     /*  91887 */   GIR_Done,
     /*  91888 */ // Label 1570: @91888
     /*  91888 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91914), // Rule ID 6799 //
     /*  91893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91907 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91912 */   GIR_RootConstrainSelectedInstOperands,
     /*  91913 */   // GIR_Coverage, 6799,
     /*  91913 */   GIR_Done,
     /*  91914 */ // Label 1571: @91914
     /*  91914 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91943), // Rule ID 6800 //
     /*  91919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91930 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91933 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91942 */   // GIR_Coverage, 6800,
     /*  91942 */   GIR_EraseRootFromParent_Done,
     /*  91943 */ // Label 1572: @91943
     /*  91943 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91975), // Rule ID 6814 //
     /*  91948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91962 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91974 */   // GIR_Coverage, 6814,
     /*  91974 */   GIR_EraseRootFromParent_Done,
     /*  91975 */ // Label 1573: @91975
     /*  91975 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(92007), // Rule ID 6815 //
     /*  91980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91994 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91997 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91999 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92006 */   // GIR_Coverage, 6815,
     /*  92006 */   GIR_EraseRootFromParent_Done,
     /*  92007 */ // Label 1574: @92007
     /*  92007 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(92039), // Rule ID 6816 //
     /*  92012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92026 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92029 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92031 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92038 */   // GIR_Coverage, 6816,
     /*  92038 */   GIR_EraseRootFromParent_Done,
     /*  92039 */ // Label 1575: @92039
     /*  92039 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(92071), // Rule ID 6817 //
     /*  92044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92058 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92070 */   // GIR_Coverage, 6817,
     /*  92070 */   GIR_EraseRootFromParent_Done,
     /*  92071 */ // Label 1576: @92071
     /*  92071 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(92103), // Rule ID 6818 //
     /*  92076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92090 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92102 */   // GIR_Coverage, 6818,
     /*  92102 */   GIR_EraseRootFromParent_Done,
     /*  92103 */ // Label 1577: @92103
     /*  92103 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(92135), // Rule ID 6819 //
     /*  92108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92122 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92134 */   // GIR_Coverage, 6819,
     /*  92134 */   GIR_EraseRootFromParent_Done,
     /*  92135 */ // Label 1578: @92135
     /*  92135 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(92168), // Rule ID 6820 //
     /*  92140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92154 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  92154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92161 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92166 */   GIR_RootConstrainSelectedInstOperands,
     /*  92167 */   // GIR_Coverage, 6820,
     /*  92167 */   GIR_EraseRootFromParent_Done,
     /*  92168 */ // Label 1579: @92168
     /*  92168 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(92194), // Rule ID 6821 //
     /*  92173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92187 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  92187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92192 */   GIR_RootConstrainSelectedInstOperands,
     /*  92193 */   // GIR_Coverage, 6821,
     /*  92193 */   GIR_Done,
     /*  92194 */ // Label 1580: @92194
     /*  92194 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(92220), // Rule ID 6822 //
     /*  92199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92213 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  92213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92218 */   GIR_RootConstrainSelectedInstOperands,
     /*  92219 */   // GIR_Coverage, 6822,
     /*  92219 */   GIR_Done,
     /*  92220 */ // Label 1581: @92220
     /*  92220 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(92246), // Rule ID 6823 //
     /*  92225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92239 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  92239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  92244 */   GIR_RootConstrainSelectedInstOperands,
     /*  92245 */   // GIR_Coverage, 6823,
     /*  92245 */   GIR_Done,
     /*  92246 */ // Label 1582: @92246
     /*  92246 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(92272), // Rule ID 6824 //
     /*  92251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92265 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  92265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92270 */   GIR_RootConstrainSelectedInstOperands,
     /*  92271 */   // GIR_Coverage, 6824,
     /*  92271 */   GIR_Done,
     /*  92272 */ // Label 1583: @92272
     /*  92272 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(92298), // Rule ID 6825 //
     /*  92277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92291 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  92291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92296 */   GIR_RootConstrainSelectedInstOperands,
     /*  92297 */   // GIR_Coverage, 6825,
     /*  92297 */   GIR_Done,
     /*  92298 */ // Label 1584: @92298
     /*  92298 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(92327), // Rule ID 6826 //
     /*  92303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92314 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92317 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92326 */   // GIR_Coverage, 6826,
     /*  92326 */   GIR_EraseRootFromParent_Done,
     /*  92327 */ // Label 1585: @92327
     /*  92327 */ GIM_Reject,
     /*  92328 */ // Label 1440: @92328
     /*  92328 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(92358), // Rule ID 6638 //
     /*  92333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92347 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92357 */   // GIR_Coverage, 6638,
     /*  92357 */   GIR_Done,
     /*  92358 */ // Label 1586: @92358
     /*  92358 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(92388), // Rule ID 6640 //
     /*  92363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92377 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92387 */   // GIR_Coverage, 6640,
     /*  92387 */   GIR_Done,
     /*  92388 */ // Label 1587: @92388
     /*  92388 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(92438), // Rule ID 6649 //
     /*  92393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92407 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92419 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92436 */   GIR_RootConstrainSelectedInstOperands,
     /*  92437 */   // GIR_Coverage, 6649,
     /*  92437 */   GIR_EraseRootFromParent_Done,
     /*  92438 */ // Label 1588: @92438
     /*  92438 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(92488), // Rule ID 6651 //
     /*  92443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92457 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92469 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92486 */   GIR_RootConstrainSelectedInstOperands,
     /*  92487 */   // GIR_Coverage, 6651,
     /*  92487 */   GIR_EraseRootFromParent_Done,
     /*  92488 */ // Label 1589: @92488
     /*  92488 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(92520), // Rule ID 6697 //
     /*  92493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92507 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92510 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92519 */   // GIR_Coverage, 6697,
     /*  92519 */   GIR_EraseRootFromParent_Done,
     /*  92520 */ // Label 1590: @92520
     /*  92520 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(92552), // Rule ID 6698 //
     /*  92525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92539 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92542 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92544 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92551 */   // GIR_Coverage, 6698,
     /*  92551 */   GIR_EraseRootFromParent_Done,
     /*  92552 */ // Label 1591: @92552
     /*  92552 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(92584), // Rule ID 6699 //
     /*  92557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92571 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92583 */   // GIR_Coverage, 6699,
     /*  92583 */   GIR_EraseRootFromParent_Done,
     /*  92584 */ // Label 1592: @92584
     /*  92584 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(92616), // Rule ID 6700 //
     /*  92589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92603 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92606 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92608 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92615 */   // GIR_Coverage, 6700,
     /*  92615 */   GIR_EraseRootFromParent_Done,
     /*  92616 */ // Label 1593: @92616
     /*  92616 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(92648), // Rule ID 6701 //
     /*  92621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92635 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92638 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92647 */   // GIR_Coverage, 6701,
     /*  92647 */   GIR_EraseRootFromParent_Done,
     /*  92648 */ // Label 1594: @92648
     /*  92648 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92680), // Rule ID 6702 //
     /*  92653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92667 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92679 */   // GIR_Coverage, 6702,
     /*  92679 */   GIR_EraseRootFromParent_Done,
     /*  92680 */ // Label 1595: @92680
     /*  92680 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92706), // Rule ID 6703 //
     /*  92685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92699 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  92699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92704 */   GIR_RootConstrainSelectedInstOperands,
     /*  92705 */   // GIR_Coverage, 6703,
     /*  92705 */   GIR_Done,
     /*  92706 */ // Label 1596: @92706
     /*  92706 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92732), // Rule ID 6704 //
     /*  92711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92725 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92730 */   GIR_RootConstrainSelectedInstOperands,
     /*  92731 */   // GIR_Coverage, 6704,
     /*  92731 */   GIR_Done,
     /*  92732 */ // Label 1597: @92732
     /*  92732 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92758), // Rule ID 6705 //
     /*  92737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92751 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92756 */   GIR_RootConstrainSelectedInstOperands,
     /*  92757 */   // GIR_Coverage, 6705,
     /*  92757 */   GIR_Done,
     /*  92758 */ // Label 1598: @92758
     /*  92758 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92784), // Rule ID 6706 //
     /*  92763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92777 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92782 */   GIR_RootConstrainSelectedInstOperands,
     /*  92783 */   // GIR_Coverage, 6706,
     /*  92783 */   GIR_Done,
     /*  92784 */ // Label 1599: @92784
     /*  92784 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92810), // Rule ID 6707 //
     /*  92789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92803 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92808 */   GIR_RootConstrainSelectedInstOperands,
     /*  92809 */   // GIR_Coverage, 6707,
     /*  92809 */   GIR_Done,
     /*  92810 */ // Label 1600: @92810
     /*  92810 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92836), // Rule ID 6708 //
     /*  92815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92829 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92834 */   GIR_RootConstrainSelectedInstOperands,
     /*  92835 */   // GIR_Coverage, 6708,
     /*  92835 */   GIR_Done,
     /*  92836 */ // Label 1601: @92836
     /*  92836 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92865), // Rule ID 6709 //
     /*  92841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92852 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92855 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92857 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92864 */   // GIR_Coverage, 6709,
     /*  92864 */   GIR_EraseRootFromParent_Done,
     /*  92865 */ // Label 1602: @92865
     /*  92865 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92897), // Rule ID 6710 //
     /*  92870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92884 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92887 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92889 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92896 */   // GIR_Coverage, 6710,
     /*  92896 */   GIR_EraseRootFromParent_Done,
     /*  92897 */ // Label 1603: @92897
     /*  92897 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92929), // Rule ID 6711 //
     /*  92902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92916 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92919 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92921 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92928 */   // GIR_Coverage, 6711,
     /*  92928 */   GIR_EraseRootFromParent_Done,
     /*  92929 */ // Label 1604: @92929
     /*  92929 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92961), // Rule ID 6712 //
     /*  92934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92948 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92960 */   // GIR_Coverage, 6712,
     /*  92960 */   GIR_EraseRootFromParent_Done,
     /*  92961 */ // Label 1605: @92961
     /*  92961 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92993), // Rule ID 6713 //
     /*  92966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92980 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92992 */   // GIR_Coverage, 6713,
     /*  92992 */   GIR_EraseRootFromParent_Done,
     /*  92993 */ // Label 1606: @92993
     /*  92993 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(93025), // Rule ID 6714 //
     /*  92998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93012 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93024 */   // GIR_Coverage, 6714,
     /*  93024 */   GIR_EraseRootFromParent_Done,
     /*  93025 */ // Label 1607: @93025
     /*  93025 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(93057), // Rule ID 6715 //
     /*  93030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93044 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93056 */   // GIR_Coverage, 6715,
     /*  93056 */   GIR_EraseRootFromParent_Done,
     /*  93057 */ // Label 1608: @93057
     /*  93057 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(93083), // Rule ID 6716 //
     /*  93062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93076 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  93076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93081 */   GIR_RootConstrainSelectedInstOperands,
     /*  93082 */   // GIR_Coverage, 6716,
     /*  93082 */   GIR_Done,
     /*  93083 */ // Label 1609: @93083
     /*  93083 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(93109), // Rule ID 6717 //
     /*  93088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93102 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  93102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93107 */   GIR_RootConstrainSelectedInstOperands,
     /*  93108 */   // GIR_Coverage, 6717,
     /*  93108 */   GIR_Done,
     /*  93109 */ // Label 1610: @93109
     /*  93109 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(93135), // Rule ID 6718 //
     /*  93114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  93120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93128 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  93128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93133 */   GIR_RootConstrainSelectedInstOperands,
     /*  93134 */   // GIR_Coverage, 6718,
     /*  93134 */   GIR_Done,
     /*  93135 */ // Label 1611: @93135
     /*  93135 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(93161), // Rule ID 6719 //
     /*  93140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93154 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  93154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93159 */   GIR_RootConstrainSelectedInstOperands,
     /*  93160 */   // GIR_Coverage, 6719,
     /*  93160 */   GIR_Done,
     /*  93161 */ // Label 1612: @93161
     /*  93161 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(93187), // Rule ID 6720 //
     /*  93166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93180 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  93180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  93185 */   GIR_RootConstrainSelectedInstOperands,
     /*  93186 */   // GIR_Coverage, 6720,
     /*  93186 */   GIR_Done,
     /*  93187 */ // Label 1613: @93187
     /*  93187 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(93213), // Rule ID 6721 //
     /*  93192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93206 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  93206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93211 */   GIR_RootConstrainSelectedInstOperands,
     /*  93212 */   // GIR_Coverage, 6721,
     /*  93212 */   GIR_Done,
     /*  93213 */ // Label 1614: @93213
     /*  93213 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(93242), // Rule ID 6722 //
     /*  93218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93229 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93241 */   // GIR_Coverage, 6722,
     /*  93241 */   GIR_EraseRootFromParent_Done,
     /*  93242 */ // Label 1615: @93242
     /*  93242 */ GIM_Reject,
     /*  93243 */ // Label 1441: @93243
     /*  93243 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(93275), // Rule ID 6801 //
     /*  93248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93262 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93274 */   // GIR_Coverage, 6801,
     /*  93274 */   GIR_EraseRootFromParent_Done,
     /*  93275 */ // Label 1616: @93275
     /*  93275 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(93307), // Rule ID 6802 //
     /*  93280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93294 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93306 */   // GIR_Coverage, 6802,
     /*  93306 */   GIR_EraseRootFromParent_Done,
     /*  93307 */ // Label 1617: @93307
     /*  93307 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(93339), // Rule ID 6803 //
     /*  93312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93326 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93338 */   // GIR_Coverage, 6803,
     /*  93338 */   GIR_EraseRootFromParent_Done,
     /*  93339 */ // Label 1618: @93339
     /*  93339 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(93371), // Rule ID 6804 //
     /*  93344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93358 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93370 */   // GIR_Coverage, 6804,
     /*  93370 */   GIR_EraseRootFromParent_Done,
     /*  93371 */ // Label 1619: @93371
     /*  93371 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(93403), // Rule ID 6805 //
     /*  93376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93390 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93402 */   // GIR_Coverage, 6805,
     /*  93402 */   GIR_EraseRootFromParent_Done,
     /*  93403 */ // Label 1620: @93403
     /*  93403 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(93435), // Rule ID 6806 //
     /*  93408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93422 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93434 */   // GIR_Coverage, 6806,
     /*  93434 */   GIR_EraseRootFromParent_Done,
     /*  93435 */ // Label 1621: @93435
     /*  93435 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(93506), // Rule ID 6807 //
     /*  93440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93454 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93454 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93457 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93461 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93466 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93484 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93504 */   GIR_RootConstrainSelectedInstOperands,
     /*  93505 */   // GIR_Coverage, 6807,
     /*  93505 */   GIR_EraseRootFromParent_Done,
     /*  93506 */ // Label 1622: @93506
     /*  93506 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(93532), // Rule ID 6808 //
     /*  93511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93525 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  93525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93530 */   GIR_RootConstrainSelectedInstOperands,
     /*  93531 */   // GIR_Coverage, 6808,
     /*  93531 */   GIR_Done,
     /*  93532 */ // Label 1623: @93532
     /*  93532 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(93558), // Rule ID 6809 //
     /*  93537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93551 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  93551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93556 */   GIR_RootConstrainSelectedInstOperands,
     /*  93557 */   // GIR_Coverage, 6809,
     /*  93557 */   GIR_Done,
     /*  93558 */ // Label 1624: @93558
     /*  93558 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(93584), // Rule ID 6810 //
     /*  93563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93577 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  93577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93582 */   GIR_RootConstrainSelectedInstOperands,
     /*  93583 */   // GIR_Coverage, 6810,
     /*  93583 */   GIR_Done,
     /*  93584 */ // Label 1625: @93584
     /*  93584 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(93610), // Rule ID 6811 //
     /*  93589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93603 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  93603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93608 */   GIR_RootConstrainSelectedInstOperands,
     /*  93609 */   // GIR_Coverage, 6811,
     /*  93609 */   GIR_Done,
     /*  93610 */ // Label 1626: @93610
     /*  93610 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(93636), // Rule ID 6812 //
     /*  93615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93629 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  93629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93634 */   GIR_RootConstrainSelectedInstOperands,
     /*  93635 */   // GIR_Coverage, 6812,
     /*  93635 */   GIR_Done,
     /*  93636 */ // Label 1627: @93636
     /*  93636 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(93665), // Rule ID 6813 //
     /*  93641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93652 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93664 */   // GIR_Coverage, 6813,
     /*  93664 */   GIR_EraseRootFromParent_Done,
     /*  93665 */ // Label 1628: @93665
     /*  93665 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93697), // Rule ID 6827 //
     /*  93670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93684 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93696 */   // GIR_Coverage, 6827,
     /*  93696 */   GIR_EraseRootFromParent_Done,
     /*  93697 */ // Label 1629: @93697
     /*  93697 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93729), // Rule ID 6828 //
     /*  93702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93716 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93728 */   // GIR_Coverage, 6828,
     /*  93728 */   GIR_EraseRootFromParent_Done,
     /*  93729 */ // Label 1630: @93729
     /*  93729 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93761), // Rule ID 6829 //
     /*  93734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93748 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93760 */   // GIR_Coverage, 6829,
     /*  93760 */   GIR_EraseRootFromParent_Done,
     /*  93761 */ // Label 1631: @93761
     /*  93761 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93793), // Rule ID 6830 //
     /*  93766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93780 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93792 */   // GIR_Coverage, 6830,
     /*  93792 */   GIR_EraseRootFromParent_Done,
     /*  93793 */ // Label 1632: @93793
     /*  93793 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93825), // Rule ID 6831 //
     /*  93798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93812 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93824 */   // GIR_Coverage, 6831,
     /*  93824 */   GIR_EraseRootFromParent_Done,
     /*  93825 */ // Label 1633: @93825
     /*  93825 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93857), // Rule ID 6832 //
     /*  93830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93844 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93856 */   // GIR_Coverage, 6832,
     /*  93856 */   GIR_EraseRootFromParent_Done,
     /*  93857 */ // Label 1634: @93857
     /*  93857 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93928), // Rule ID 6833 //
     /*  93862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93876 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93876 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93879 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93883 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93888 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93926 */   GIR_RootConstrainSelectedInstOperands,
     /*  93927 */   // GIR_Coverage, 6833,
     /*  93927 */   GIR_EraseRootFromParent_Done,
     /*  93928 */ // Label 1635: @93928
     /*  93928 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93954), // Rule ID 6834 //
     /*  93933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93947 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93952 */   GIR_RootConstrainSelectedInstOperands,
     /*  93953 */   // GIR_Coverage, 6834,
     /*  93953 */   GIR_Done,
     /*  93954 */ // Label 1636: @93954
     /*  93954 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93980), // Rule ID 6835 //
     /*  93959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93973 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  93973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93978 */   GIR_RootConstrainSelectedInstOperands,
     /*  93979 */   // GIR_Coverage, 6835,
     /*  93979 */   GIR_Done,
     /*  93980 */ // Label 1637: @93980
     /*  93980 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(94006), // Rule ID 6836 //
     /*  93985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93999 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  93999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  94004 */   GIR_RootConstrainSelectedInstOperands,
     /*  94005 */   // GIR_Coverage, 6836,
     /*  94005 */   GIR_Done,
     /*  94006 */ // Label 1638: @94006
     /*  94006 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(94032), // Rule ID 6837 //
     /*  94011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94025 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  94025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  94030 */   GIR_RootConstrainSelectedInstOperands,
     /*  94031 */   // GIR_Coverage, 6837,
     /*  94031 */   GIR_Done,
     /*  94032 */ // Label 1639: @94032
     /*  94032 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(94058), // Rule ID 6838 //
     /*  94037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94051 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  94051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94056 */   GIR_RootConstrainSelectedInstOperands,
     /*  94057 */   // GIR_Coverage, 6838,
     /*  94057 */   GIR_Done,
     /*  94058 */ // Label 1640: @94058
     /*  94058 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(94087), // Rule ID 6839 //
     /*  94063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94074 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  94074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94086 */   // GIR_Coverage, 6839,
     /*  94086 */   GIR_EraseRootFromParent_Done,
     /*  94087 */ // Label 1641: @94087
     /*  94087 */ GIM_Reject,
     /*  94088 */ // Label 1442: @94088
     /*  94088 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(94162), // Rule ID 5668 //
     /*  94093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  94108 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  94112 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94119 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  94119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  94126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94131 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  94135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  94140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94145 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  94151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94161 */   // GIR_Coverage, 5668,
     /*  94161 */   GIR_EraseRootFromParent_Done,
     /*  94162 */ // Label 1642: @94162
     /*  94162 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(94192), // Rule ID 6637 //
     /*  94167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94181 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  94181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94191 */   // GIR_Coverage, 6637,
     /*  94191 */   GIR_Done,
     /*  94192 */ // Label 1643: @94192
     /*  94192 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(94242), // Rule ID 6648 //
     /*  94197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94211 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  94211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  94227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94240 */   GIR_RootConstrainSelectedInstOperands,
     /*  94241 */   // GIR_Coverage, 6648,
     /*  94241 */   GIR_EraseRootFromParent_Done,
     /*  94242 */ // Label 1644: @94242
     /*  94242 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(94274), // Rule ID 6723 //
     /*  94247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94261 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94273 */   // GIR_Coverage, 6723,
     /*  94273 */   GIR_EraseRootFromParent_Done,
     /*  94274 */ // Label 1645: @94274
     /*  94274 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(94306), // Rule ID 6724 //
     /*  94279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94293 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94305 */   // GIR_Coverage, 6724,
     /*  94305 */   GIR_EraseRootFromParent_Done,
     /*  94306 */ // Label 1646: @94306
     /*  94306 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(94338), // Rule ID 6725 //
     /*  94311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94325 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94337 */   // GIR_Coverage, 6725,
     /*  94337 */   GIR_EraseRootFromParent_Done,
     /*  94338 */ // Label 1647: @94338
     /*  94338 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(94370), // Rule ID 6726 //
     /*  94343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94357 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94369 */   // GIR_Coverage, 6726,
     /*  94369 */   GIR_EraseRootFromParent_Done,
     /*  94370 */ // Label 1648: @94370
     /*  94370 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(94402), // Rule ID 6727 //
     /*  94375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94389 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94401 */   // GIR_Coverage, 6727,
     /*  94401 */   GIR_EraseRootFromParent_Done,
     /*  94402 */ // Label 1649: @94402
     /*  94402 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(94434), // Rule ID 6728 //
     /*  94407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94421 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94433 */   // GIR_Coverage, 6728,
     /*  94433 */   GIR_EraseRootFromParent_Done,
     /*  94434 */ // Label 1650: @94434
     /*  94434 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(94466), // Rule ID 6729 //
     /*  94439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94453 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94465 */   // GIR_Coverage, 6729,
     /*  94465 */   GIR_EraseRootFromParent_Done,
     /*  94466 */ // Label 1651: @94466
     /*  94466 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(94492), // Rule ID 6730 //
     /*  94471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94485 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  94485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94490 */   GIR_RootConstrainSelectedInstOperands,
     /*  94491 */   // GIR_Coverage, 6730,
     /*  94491 */   GIR_Done,
     /*  94492 */ // Label 1652: @94492
     /*  94492 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(94518), // Rule ID 6731 //
     /*  94497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94511 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  94511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94516 */   GIR_RootConstrainSelectedInstOperands,
     /*  94517 */   // GIR_Coverage, 6731,
     /*  94517 */   GIR_Done,
     /*  94518 */ // Label 1653: @94518
     /*  94518 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(94544), // Rule ID 6732 //
     /*  94523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94537 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  94537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94542 */   GIR_RootConstrainSelectedInstOperands,
     /*  94543 */   // GIR_Coverage, 6732,
     /*  94543 */   GIR_Done,
     /*  94544 */ // Label 1654: @94544
     /*  94544 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(94570), // Rule ID 6733 //
     /*  94549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94563 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  94563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94568 */   GIR_RootConstrainSelectedInstOperands,
     /*  94569 */   // GIR_Coverage, 6733,
     /*  94569 */   GIR_Done,
     /*  94570 */ // Label 1655: @94570
     /*  94570 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(94596), // Rule ID 6734 //
     /*  94575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94589 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  94589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94594 */   GIR_RootConstrainSelectedInstOperands,
     /*  94595 */   // GIR_Coverage, 6734,
     /*  94595 */   GIR_Done,
     /*  94596 */ // Label 1656: @94596
     /*  94596 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(94622), // Rule ID 6735 //
     /*  94601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94615 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  94615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94620 */   GIR_RootConstrainSelectedInstOperands,
     /*  94621 */   // GIR_Coverage, 6735,
     /*  94621 */   GIR_Done,
     /*  94622 */ // Label 1657: @94622
     /*  94622 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(94648), // Rule ID 6736 //
     /*  94627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94641 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  94641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94646 */   GIR_RootConstrainSelectedInstOperands,
     /*  94647 */   // GIR_Coverage, 6736,
     /*  94647 */   GIR_Done,
     /*  94648 */ // Label 1658: @94648
     /*  94648 */ GIM_Reject,
     /*  94649 */ // Label 1443: @94649
     /*  94649 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94681), // Rule ID 6840 //
     /*  94654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94668 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94680 */   // GIR_Coverage, 6840,
     /*  94680 */   GIR_EraseRootFromParent_Done,
     /*  94681 */ // Label 1659: @94681
     /*  94681 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94713), // Rule ID 6841 //
     /*  94686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94700 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94712 */   // GIR_Coverage, 6841,
     /*  94712 */   GIR_EraseRootFromParent_Done,
     /*  94713 */ // Label 1660: @94713
     /*  94713 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94745), // Rule ID 6842 //
     /*  94718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94732 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94744 */   // GIR_Coverage, 6842,
     /*  94744 */   GIR_EraseRootFromParent_Done,
     /*  94745 */ // Label 1661: @94745
     /*  94745 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94777), // Rule ID 6843 //
     /*  94750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94764 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94767 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94769 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94776 */   // GIR_Coverage, 6843,
     /*  94776 */   GIR_EraseRootFromParent_Done,
     /*  94777 */ // Label 1662: @94777
     /*  94777 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94809), // Rule ID 6844 //
     /*  94782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94796 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94799 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94808 */   // GIR_Coverage, 6844,
     /*  94808 */   GIR_EraseRootFromParent_Done,
     /*  94809 */ // Label 1663: @94809
     /*  94809 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94841), // Rule ID 6845 //
     /*  94814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94828 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94840 */   // GIR_Coverage, 6845,
     /*  94840 */   GIR_EraseRootFromParent_Done,
     /*  94841 */ // Label 1664: @94841
     /*  94841 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94912), // Rule ID 6846 //
     /*  94846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94860 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94860 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94863 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94867 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94872 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94910 */   GIR_RootConstrainSelectedInstOperands,
     /*  94911 */   // GIR_Coverage, 6846,
     /*  94911 */   GIR_EraseRootFromParent_Done,
     /*  94912 */ // Label 1665: @94912
     /*  94912 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94938), // Rule ID 6847 //
     /*  94917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94931 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94936 */   GIR_RootConstrainSelectedInstOperands,
     /*  94937 */   // GIR_Coverage, 6847,
     /*  94937 */   GIR_Done,
     /*  94938 */ // Label 1666: @94938
     /*  94938 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94964), // Rule ID 6848 //
     /*  94943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94957 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94962 */   GIR_RootConstrainSelectedInstOperands,
     /*  94963 */   // GIR_Coverage, 6848,
     /*  94963 */   GIR_Done,
     /*  94964 */ // Label 1667: @94964
     /*  94964 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94990), // Rule ID 6849 //
     /*  94969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94983 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  94983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94988 */   GIR_RootConstrainSelectedInstOperands,
     /*  94989 */   // GIR_Coverage, 6849,
     /*  94989 */   GIR_Done,
     /*  94990 */ // Label 1668: @94990
     /*  94990 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(95016), // Rule ID 6850 //
     /*  94995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95009 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  95009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95014 */   GIR_RootConstrainSelectedInstOperands,
     /*  95015 */   // GIR_Coverage, 6850,
     /*  95015 */   GIR_Done,
     /*  95016 */ // Label 1669: @95016
     /*  95016 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(95042), // Rule ID 6851 //
     /*  95021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95035 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  95035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95040 */   GIR_RootConstrainSelectedInstOperands,
     /*  95041 */   // GIR_Coverage, 6851,
     /*  95041 */   GIR_Done,
     /*  95042 */ // Label 1670: @95042
     /*  95042 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(95071), // Rule ID 6852 //
     /*  95047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95058 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  95058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95070 */   // GIR_Coverage, 6852,
     /*  95070 */   GIR_EraseRootFromParent_Done,
     /*  95071 */ // Label 1671: @95071
     /*  95071 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(95103), // Rule ID 6853 //
     /*  95076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95090 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95102 */   // GIR_Coverage, 6853,
     /*  95102 */   GIR_EraseRootFromParent_Done,
     /*  95103 */ // Label 1672: @95103
     /*  95103 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(95135), // Rule ID 6854 //
     /*  95108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95122 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95134 */   // GIR_Coverage, 6854,
     /*  95134 */   GIR_EraseRootFromParent_Done,
     /*  95135 */ // Label 1673: @95135
     /*  95135 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(95167), // Rule ID 6855 //
     /*  95140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95154 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95166 */   // GIR_Coverage, 6855,
     /*  95166 */   GIR_EraseRootFromParent_Done,
     /*  95167 */ // Label 1674: @95167
     /*  95167 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(95199), // Rule ID 6856 //
     /*  95172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95186 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95198 */   // GIR_Coverage, 6856,
     /*  95198 */   GIR_EraseRootFromParent_Done,
     /*  95199 */ // Label 1675: @95199
     /*  95199 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(95231), // Rule ID 6857 //
     /*  95204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95218 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95230 */   // GIR_Coverage, 6857,
     /*  95230 */   GIR_EraseRootFromParent_Done,
     /*  95231 */ // Label 1676: @95231
     /*  95231 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(95263), // Rule ID 6858 //
     /*  95236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95250 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95262 */   // GIR_Coverage, 6858,
     /*  95262 */   GIR_EraseRootFromParent_Done,
     /*  95263 */ // Label 1677: @95263
     /*  95263 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(95334), // Rule ID 6859 //
     /*  95268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95282 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95294 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95312 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95332 */   GIR_RootConstrainSelectedInstOperands,
     /*  95333 */   // GIR_Coverage, 6859,
     /*  95333 */   GIR_EraseRootFromParent_Done,
     /*  95334 */ // Label 1678: @95334
     /*  95334 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(95360), // Rule ID 6860 //
     /*  95339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95353 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  95353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95358 */   GIR_RootConstrainSelectedInstOperands,
     /*  95359 */   // GIR_Coverage, 6860,
     /*  95359 */   GIR_Done,
     /*  95360 */ // Label 1679: @95360
     /*  95360 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(95386), // Rule ID 6861 //
     /*  95365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95379 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  95379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95384 */   GIR_RootConstrainSelectedInstOperands,
     /*  95385 */   // GIR_Coverage, 6861,
     /*  95385 */   GIR_Done,
     /*  95386 */ // Label 1680: @95386
     /*  95386 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(95412), // Rule ID 6862 //
     /*  95391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95405 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  95405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95410 */   GIR_RootConstrainSelectedInstOperands,
     /*  95411 */   // GIR_Coverage, 6862,
     /*  95411 */   GIR_Done,
     /*  95412 */ // Label 1681: @95412
     /*  95412 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(95438), // Rule ID 6863 //
     /*  95417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95431 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  95431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95436 */   GIR_RootConstrainSelectedInstOperands,
     /*  95437 */   // GIR_Coverage, 6863,
     /*  95437 */   GIR_Done,
     /*  95438 */ // Label 1682: @95438
     /*  95438 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(95464), // Rule ID 6864 //
     /*  95443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95457 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  95457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95462 */   GIR_RootConstrainSelectedInstOperands,
     /*  95463 */   // GIR_Coverage, 6864,
     /*  95463 */   GIR_Done,
     /*  95464 */ // Label 1683: @95464
     /*  95464 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(95493), // Rule ID 6865 //
     /*  95469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95480 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95492 */   // GIR_Coverage, 6865,
     /*  95492 */   GIR_EraseRootFromParent_Done,
     /*  95493 */ // Label 1684: @95493
     /*  95493 */ GIM_Reject,
     /*  95494 */ // Label 1444: @95494
     /*  95494 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(95526), // Rule ID 6866 //
     /*  95499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95513 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95525 */   // GIR_Coverage, 6866,
     /*  95525 */   GIR_EraseRootFromParent_Done,
     /*  95526 */ // Label 1685: @95526
     /*  95526 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(95558), // Rule ID 6867 //
     /*  95531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95545 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95557 */   // GIR_Coverage, 6867,
     /*  95557 */   GIR_EraseRootFromParent_Done,
     /*  95558 */ // Label 1686: @95558
     /*  95558 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(95590), // Rule ID 6868 //
     /*  95563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95577 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95580 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95582 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95589 */   // GIR_Coverage, 6868,
     /*  95589 */   GIR_EraseRootFromParent_Done,
     /*  95590 */ // Label 1687: @95590
     /*  95590 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(95622), // Rule ID 6869 //
     /*  95595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95609 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95621 */   // GIR_Coverage, 6869,
     /*  95621 */   GIR_EraseRootFromParent_Done,
     /*  95622 */ // Label 1688: @95622
     /*  95622 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(95654), // Rule ID 6870 //
     /*  95627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95641 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95653 */   // GIR_Coverage, 6870,
     /*  95653 */   GIR_EraseRootFromParent_Done,
     /*  95654 */ // Label 1689: @95654
     /*  95654 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95686), // Rule ID 6871 //
     /*  95659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95673 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95685 */   // GIR_Coverage, 6871,
     /*  95685 */   GIR_EraseRootFromParent_Done,
     /*  95686 */ // Label 1690: @95686
     /*  95686 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95718), // Rule ID 6872 //
     /*  95691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95705 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95717 */   // GIR_Coverage, 6872,
     /*  95717 */   GIR_EraseRootFromParent_Done,
     /*  95718 */ // Label 1691: @95718
     /*  95718 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95789), // Rule ID 6873 //
     /*  95723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95737 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95737 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95740 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95744 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95749 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95767 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95787 */   GIR_RootConstrainSelectedInstOperands,
     /*  95788 */   // GIR_Coverage, 6873,
     /*  95788 */   GIR_EraseRootFromParent_Done,
     /*  95789 */ // Label 1692: @95789
     /*  95789 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95815), // Rule ID 6874 //
     /*  95794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95808 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95813 */   GIR_RootConstrainSelectedInstOperands,
     /*  95814 */   // GIR_Coverage, 6874,
     /*  95814 */   GIR_Done,
     /*  95815 */ // Label 1693: @95815
     /*  95815 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95841), // Rule ID 6875 //
     /*  95820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95834 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95839 */   GIR_RootConstrainSelectedInstOperands,
     /*  95840 */   // GIR_Coverage, 6875,
     /*  95840 */   GIR_Done,
     /*  95841 */ // Label 1694: @95841
     /*  95841 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95867), // Rule ID 6876 //
     /*  95846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95860 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95865 */   GIR_RootConstrainSelectedInstOperands,
     /*  95866 */   // GIR_Coverage, 6876,
     /*  95866 */   GIR_Done,
     /*  95867 */ // Label 1695: @95867
     /*  95867 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95893), // Rule ID 6877 //
     /*  95872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95886 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95891 */   GIR_RootConstrainSelectedInstOperands,
     /*  95892 */   // GIR_Coverage, 6877,
     /*  95892 */   GIR_Done,
     /*  95893 */ // Label 1696: @95893
     /*  95893 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95919), // Rule ID 6878 //
     /*  95898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95912 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95917 */   GIR_RootConstrainSelectedInstOperands,
     /*  95918 */   // GIR_Coverage, 6878,
     /*  95918 */   GIR_Done,
     /*  95919 */ // Label 1697: @95919
     /*  95919 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95945), // Rule ID 6879 //
     /*  95924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95938 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95943 */   GIR_RootConstrainSelectedInstOperands,
     /*  95944 */   // GIR_Coverage, 6879,
     /*  95944 */   GIR_Done,
     /*  95945 */ // Label 1698: @95945
     /*  95945 */ GIM_Reject,
     /*  95946 */ // Label 1445: @95946
     /*  95946 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95978), // Rule ID 10550 //
     /*  95951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95965 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95968 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95970 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95977 */   // GIR_Coverage, 10550,
     /*  95977 */   GIR_EraseRootFromParent_Done,
     /*  95978 */ // Label 1699: @95978
     /*  95978 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(96010), // Rule ID 10551 //
     /*  95983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95997 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96000 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96002 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96009 */   // GIR_Coverage, 10551,
     /*  96009 */   GIR_EraseRootFromParent_Done,
     /*  96010 */ // Label 1700: @96010
     /*  96010 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(96042), // Rule ID 10552 //
     /*  96015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96029 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96032 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96041 */   // GIR_Coverage, 10552,
     /*  96041 */   GIR_EraseRootFromParent_Done,
     /*  96042 */ // Label 1701: @96042
     /*  96042 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(96074), // Rule ID 10553 //
     /*  96047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96061 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96064 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96066 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96073 */   // GIR_Coverage, 10553,
     /*  96073 */   GIR_EraseRootFromParent_Done,
     /*  96074 */ // Label 1702: @96074
     /*  96074 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(96106), // Rule ID 10554 //
     /*  96079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96093 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96105 */   // GIR_Coverage, 10554,
     /*  96105 */   GIR_EraseRootFromParent_Done,
     /*  96106 */ // Label 1703: @96106
     /*  96106 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(96138), // Rule ID 10555 //
     /*  96111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96125 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96128 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96137 */   // GIR_Coverage, 10555,
     /*  96137 */   GIR_EraseRootFromParent_Done,
     /*  96138 */ // Label 1704: @96138
     /*  96138 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(96170), // Rule ID 10568 //
     /*  96143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96157 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96160 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96162 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96169 */   // GIR_Coverage, 10568,
     /*  96169 */   GIR_EraseRootFromParent_Done,
     /*  96170 */ // Label 1705: @96170
     /*  96170 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(96202), // Rule ID 10569 //
     /*  96175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96189 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96192 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96201 */   // GIR_Coverage, 10569,
     /*  96201 */   GIR_EraseRootFromParent_Done,
     /*  96202 */ // Label 1706: @96202
     /*  96202 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(96234), // Rule ID 10570 //
     /*  96207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96221 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96233 */   // GIR_Coverage, 10570,
     /*  96233 */   GIR_EraseRootFromParent_Done,
     /*  96234 */ // Label 1707: @96234
     /*  96234 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(96266), // Rule ID 10571 //
     /*  96239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96253 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96265 */   // GIR_Coverage, 10571,
     /*  96265 */   GIR_EraseRootFromParent_Done,
     /*  96266 */ // Label 1708: @96266
     /*  96266 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(96298), // Rule ID 10572 //
     /*  96271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96285 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96297 */   // GIR_Coverage, 10572,
     /*  96297 */   GIR_EraseRootFromParent_Done,
     /*  96298 */ // Label 1709: @96298
     /*  96298 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(96330), // Rule ID 10573 //
     /*  96303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96317 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96329 */   // GIR_Coverage, 10573,
     /*  96329 */   GIR_EraseRootFromParent_Done,
     /*  96330 */ // Label 1710: @96330
     /*  96330 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(96362), // Rule ID 10578 //
     /*  96335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96349 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96361 */   // GIR_Coverage, 10578,
     /*  96361 */   GIR_EraseRootFromParent_Done,
     /*  96362 */ // Label 1711: @96362
     /*  96362 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(96394), // Rule ID 10579 //
     /*  96367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96381 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96393 */   // GIR_Coverage, 10579,
     /*  96393 */   GIR_EraseRootFromParent_Done,
     /*  96394 */ // Label 1712: @96394
     /*  96394 */ GIM_Reject,
     /*  96395 */ // Label 1446: @96395
     /*  96395 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(96427), // Rule ID 10544 //
     /*  96400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96414 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96426 */   // GIR_Coverage, 10544,
     /*  96426 */   GIR_EraseRootFromParent_Done,
     /*  96427 */ // Label 1713: @96427
     /*  96427 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(96459), // Rule ID 10545 //
     /*  96432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96446 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96458 */   // GIR_Coverage, 10545,
     /*  96458 */   GIR_EraseRootFromParent_Done,
     /*  96459 */ // Label 1714: @96459
     /*  96459 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(96491), // Rule ID 10546 //
     /*  96464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96478 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96490 */   // GIR_Coverage, 10546,
     /*  96490 */   GIR_EraseRootFromParent_Done,
     /*  96491 */ // Label 1715: @96491
     /*  96491 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(96523), // Rule ID 10547 //
     /*  96496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96510 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96522 */   // GIR_Coverage, 10547,
     /*  96522 */   GIR_EraseRootFromParent_Done,
     /*  96523 */ // Label 1716: @96523
     /*  96523 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(96555), // Rule ID 10548 //
     /*  96528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96542 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96554 */   // GIR_Coverage, 10548,
     /*  96554 */   GIR_EraseRootFromParent_Done,
     /*  96555 */ // Label 1717: @96555
     /*  96555 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(96587), // Rule ID 10549 //
     /*  96560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96574 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96586 */   // GIR_Coverage, 10549,
     /*  96586 */   GIR_EraseRootFromParent_Done,
     /*  96587 */ // Label 1718: @96587
     /*  96587 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(96619), // Rule ID 10562 //
     /*  96592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96606 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96618 */   // GIR_Coverage, 10562,
     /*  96618 */   GIR_EraseRootFromParent_Done,
     /*  96619 */ // Label 1719: @96619
     /*  96619 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(96651), // Rule ID 10563 //
     /*  96624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96638 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96650 */   // GIR_Coverage, 10563,
     /*  96650 */   GIR_EraseRootFromParent_Done,
     /*  96651 */ // Label 1720: @96651
     /*  96651 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96683), // Rule ID 10564 //
     /*  96656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96670 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96682 */   // GIR_Coverage, 10564,
     /*  96682 */   GIR_EraseRootFromParent_Done,
     /*  96683 */ // Label 1721: @96683
     /*  96683 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96715), // Rule ID 10565 //
     /*  96688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96702 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96714 */   // GIR_Coverage, 10565,
     /*  96714 */   GIR_EraseRootFromParent_Done,
     /*  96715 */ // Label 1722: @96715
     /*  96715 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96747), // Rule ID 10566 //
     /*  96720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96734 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96737 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96739 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96746 */   // GIR_Coverage, 10566,
     /*  96746 */   GIR_EraseRootFromParent_Done,
     /*  96747 */ // Label 1723: @96747
     /*  96747 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96779), // Rule ID 10567 //
     /*  96752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96766 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96778 */   // GIR_Coverage, 10567,
     /*  96778 */   GIR_EraseRootFromParent_Done,
     /*  96779 */ // Label 1724: @96779
     /*  96779 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96811), // Rule ID 10576 //
     /*  96784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96798 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96810 */   // GIR_Coverage, 10576,
     /*  96810 */   GIR_EraseRootFromParent_Done,
     /*  96811 */ // Label 1725: @96811
     /*  96811 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96843), // Rule ID 10577 //
     /*  96816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96830 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96842 */   // GIR_Coverage, 10577,
     /*  96842 */   GIR_EraseRootFromParent_Done,
     /*  96843 */ // Label 1726: @96843
     /*  96843 */ GIM_Reject,
     /*  96844 */ // Label 1447: @96844
     /*  96844 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96876), // Rule ID 10538 //
     /*  96849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96863 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96866 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96868 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96875 */   // GIR_Coverage, 10538,
     /*  96875 */   GIR_EraseRootFromParent_Done,
     /*  96876 */ // Label 1727: @96876
     /*  96876 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96908), // Rule ID 10539 //
     /*  96881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96895 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96898 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96900 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96907 */   // GIR_Coverage, 10539,
     /*  96907 */   GIR_EraseRootFromParent_Done,
     /*  96908 */ // Label 1728: @96908
     /*  96908 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96940), // Rule ID 10540 //
     /*  96913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96927 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96930 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96932 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96939 */   // GIR_Coverage, 10540,
     /*  96939 */   GIR_EraseRootFromParent_Done,
     /*  96940 */ // Label 1729: @96940
     /*  96940 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96972), // Rule ID 10541 //
     /*  96945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96959 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96962 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96971 */   // GIR_Coverage, 10541,
     /*  96971 */   GIR_EraseRootFromParent_Done,
     /*  96972 */ // Label 1730: @96972
     /*  96972 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(97004), // Rule ID 10542 //
     /*  96977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96991 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97003 */   // GIR_Coverage, 10542,
     /*  97003 */   GIR_EraseRootFromParent_Done,
     /*  97004 */ // Label 1731: @97004
     /*  97004 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(97036), // Rule ID 10543 //
     /*  97009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97023 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97028 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97035 */   // GIR_Coverage, 10543,
     /*  97035 */   GIR_EraseRootFromParent_Done,
     /*  97036 */ // Label 1732: @97036
     /*  97036 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(97068), // Rule ID 10556 //
     /*  97041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97055 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97058 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97060 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97067 */   // GIR_Coverage, 10556,
     /*  97067 */   GIR_EraseRootFromParent_Done,
     /*  97068 */ // Label 1733: @97068
     /*  97068 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(97100), // Rule ID 10557 //
     /*  97073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97087 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97090 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97092 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97099 */   // GIR_Coverage, 10557,
     /*  97099 */   GIR_EraseRootFromParent_Done,
     /*  97100 */ // Label 1734: @97100
     /*  97100 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(97132), // Rule ID 10558 //
     /*  97105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97119 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97122 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97124 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97131 */   // GIR_Coverage, 10558,
     /*  97131 */   GIR_EraseRootFromParent_Done,
     /*  97132 */ // Label 1735: @97132
     /*  97132 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(97164), // Rule ID 10559 //
     /*  97137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97151 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97163 */   // GIR_Coverage, 10559,
     /*  97163 */   GIR_EraseRootFromParent_Done,
     /*  97164 */ // Label 1736: @97164
     /*  97164 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(97196), // Rule ID 10560 //
     /*  97169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97183 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97186 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97188 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97195 */   // GIR_Coverage, 10560,
     /*  97195 */   GIR_EraseRootFromParent_Done,
     /*  97196 */ // Label 1737: @97196
     /*  97196 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(97228), // Rule ID 10561 //
     /*  97201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97215 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97218 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97220 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97227 */   // GIR_Coverage, 10561,
     /*  97227 */   GIR_EraseRootFromParent_Done,
     /*  97228 */ // Label 1738: @97228
     /*  97228 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(97260), // Rule ID 10574 //
     /*  97233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97247 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97259 */   // GIR_Coverage, 10574,
     /*  97259 */   GIR_EraseRootFromParent_Done,
     /*  97260 */ // Label 1739: @97260
     /*  97260 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(97292), // Rule ID 10575 //
     /*  97265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97279 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97282 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97284 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97291 */   // GIR_Coverage, 10575,
     /*  97291 */   GIR_EraseRootFromParent_Done,
     /*  97292 */ // Label 1740: @97292
     /*  97292 */ GIM_Reject,
     /*  97293 */ // Label 1448: @97293
     /*  97293 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(97325), // Rule ID 10532 //
     /*  97298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97312 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97315 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97324 */   // GIR_Coverage, 10532,
     /*  97324 */   GIR_EraseRootFromParent_Done,
     /*  97325 */ // Label 1741: @97325
     /*  97325 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(97357), // Rule ID 10533 //
     /*  97330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97344 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97347 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97356 */   // GIR_Coverage, 10533,
     /*  97356 */   GIR_EraseRootFromParent_Done,
     /*  97357 */ // Label 1742: @97357
     /*  97357 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(97389), // Rule ID 10534 //
     /*  97362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97376 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97379 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97381 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97388 */   // GIR_Coverage, 10534,
     /*  97388 */   GIR_EraseRootFromParent_Done,
     /*  97389 */ // Label 1743: @97389
     /*  97389 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(97421), // Rule ID 10535 //
     /*  97394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97408 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97411 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97420 */   // GIR_Coverage, 10535,
     /*  97420 */   GIR_EraseRootFromParent_Done,
     /*  97421 */ // Label 1744: @97421
     /*  97421 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(97453), // Rule ID 10536 //
     /*  97426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97440 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97443 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97452 */   // GIR_Coverage, 10536,
     /*  97452 */   GIR_EraseRootFromParent_Done,
     /*  97453 */ // Label 1745: @97453
     /*  97453 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(97485), // Rule ID 10537 //
     /*  97458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  97461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97472 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97475 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97484 */   // GIR_Coverage, 10537,
     /*  97484 */   GIR_EraseRootFromParent_Done,
     /*  97485 */ // Label 1746: @97485
     /*  97485 */ GIM_Reject,
     /*  97486 */ // Label 1449: @97486
     /*  97486 */ GIM_Reject,
     /*  97487 */ // Label 10: @97487
     /*  97487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1755*/ GIMT_Encode4(97977),
     /*  97498 */ /*GILLT_s16*//*Label 1747*/ GIMT_Encode4(97538),
     /*  97502 */ /*GILLT_s32*//*Label 1748*/ GIMT_Encode4(97569),
     /*  97506 */ /*GILLT_s64*//*Label 1749*/ GIMT_Encode4(97600), GIMT_Encode4(0),
     /*  97514 */ /*GILLT_v2s32*//*Label 1750*/ GIMT_Encode4(97631),
     /*  97518 */ /*GILLT_v2s64*//*Label 1751*/ GIMT_Encode4(97662),
     /*  97522 */ /*GILLT_v4s16*//*Label 1752*/ GIMT_Encode4(97693),
     /*  97526 */ /*GILLT_v4s32*//*Label 1753*/ GIMT_Encode4(97724), GIMT_Encode4(0),
     /*  97534 */ /*GILLT_v8s16*//*Label 1754*/ GIMT_Encode4(97755),
     /*  97538 */ // Label 1747: @97538
     /*  97538 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(97568), // Rule ID 564 //
     /*  97543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97557 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  97562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97566 */   GIR_RootConstrainSelectedInstOperands,
     /*  97567 */   // GIR_Coverage, 564,
     /*  97567 */   GIR_Done,
     /*  97568 */ // Label 1756: @97568
     /*  97568 */ GIM_Reject,
     /*  97569 */ // Label 1748: @97569
     /*  97569 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(97599), // Rule ID 566 //
     /*  97574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97588 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  97593 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97597 */   GIR_RootConstrainSelectedInstOperands,
     /*  97598 */   // GIR_Coverage, 566,
     /*  97598 */   GIR_Done,
     /*  97599 */ // Label 1757: @97599
     /*  97599 */ GIM_Reject,
     /*  97600 */ // Label 1749: @97600
     /*  97600 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97630), // Rule ID 568 //
     /*  97605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97619 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  97624 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97628 */   GIR_RootConstrainSelectedInstOperands,
     /*  97629 */   // GIR_Coverage, 568,
     /*  97629 */   GIR_Done,
     /*  97630 */ // Label 1758: @97630
     /*  97630 */ GIM_Reject,
     /*  97631 */ // Label 1750: @97631
     /*  97631 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97661), // Rule ID 933 //
     /*  97636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97650 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  97655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97659 */   GIR_RootConstrainSelectedInstOperands,
     /*  97660 */   // GIR_Coverage, 933,
     /*  97660 */   GIR_Done,
     /*  97661 */ // Label 1759: @97661
     /*  97661 */ GIM_Reject,
     /*  97662 */ // Label 1751: @97662
     /*  97662 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97692), // Rule ID 937 //
     /*  97667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97681 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  97686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97690 */   GIR_RootConstrainSelectedInstOperands,
     /*  97691 */   // GIR_Coverage, 937,
     /*  97691 */   GIR_Done,
     /*  97692 */ // Label 1760: @97692
     /*  97692 */ GIM_Reject,
     /*  97693 */ // Label 1752: @97693
     /*  97693 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97723), // Rule ID 929 //
     /*  97698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97712 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97717 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97721 */   GIR_RootConstrainSelectedInstOperands,
     /*  97722 */   // GIR_Coverage, 929,
     /*  97722 */   GIR_Done,
     /*  97723 */ // Label 1761: @97723
     /*  97723 */ GIM_Reject,
     /*  97724 */ // Label 1753: @97724
     /*  97724 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97754), // Rule ID 935 //
     /*  97729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97743 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97748 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97752 */   GIR_RootConstrainSelectedInstOperands,
     /*  97753 */   // GIR_Coverage, 935,
     /*  97753 */   GIR_Done,
     /*  97754 */ // Label 1762: @97754
     /*  97754 */ GIM_Reject,
     /*  97755 */ // Label 1754: @97755
     /*  97755 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97976),
     /*  97760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97771 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97790), // Rule ID 931 //
     /*  97776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97779 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97788 */     GIR_RootConstrainSelectedInstOperands,
     /*  97789 */     // GIR_Coverage, 931,
     /*  97789 */     GIR_Done,
     /*  97790 */   // Label 1764: @97790
     /*  97790 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97975), // Rule ID 6998 //
     /*  97795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97798 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97798 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97801 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97805 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97810 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97816 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97819 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97823 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97828 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97833 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97836 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97840 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97845 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97851 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97856 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97861 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97864 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97868 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97873 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97878 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97881 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97885 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97890 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97907 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97944 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97973 */     GIR_RootConstrainSelectedInstOperands,
     /*  97974 */     // GIR_Coverage, 6998,
     /*  97974 */     GIR_EraseRootFromParent_Done,
     /*  97975 */   // Label 1765: @97975
     /*  97975 */   GIM_Reject,
     /*  97976 */ // Label 1763: @97976
     /*  97976 */ GIM_Reject,
     /*  97977 */ // Label 1755: @97977
     /*  97977 */ GIM_Reject,
     /*  97978 */ // Label 11: @97978
     /*  97978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1774*/ GIMT_Encode4(98468),
     /*  97989 */ /*GILLT_s16*//*Label 1766*/ GIMT_Encode4(98029),
     /*  97993 */ /*GILLT_s32*//*Label 1767*/ GIMT_Encode4(98060),
     /*  97997 */ /*GILLT_s64*//*Label 1768*/ GIMT_Encode4(98091), GIMT_Encode4(0),
     /*  98005 */ /*GILLT_v2s32*//*Label 1769*/ GIMT_Encode4(98122),
     /*  98009 */ /*GILLT_v2s64*//*Label 1770*/ GIMT_Encode4(98153),
     /*  98013 */ /*GILLT_v4s16*//*Label 1771*/ GIMT_Encode4(98184),
     /*  98017 */ /*GILLT_v4s32*//*Label 1772*/ GIMT_Encode4(98215), GIMT_Encode4(0),
     /*  98025 */ /*GILLT_v8s16*//*Label 1773*/ GIMT_Encode4(98246),
     /*  98029 */ // Label 1766: @98029
     /*  98029 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(98059), // Rule ID 528 //
     /*  98034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98048 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  98053 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98057 */   GIR_RootConstrainSelectedInstOperands,
     /*  98058 */   // GIR_Coverage, 528,
     /*  98058 */   GIR_Done,
     /*  98059 */ // Label 1775: @98059
     /*  98059 */ GIM_Reject,
     /*  98060 */ // Label 1767: @98060
     /*  98060 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98090), // Rule ID 530 //
     /*  98065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98079 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  98084 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98088 */   GIR_RootConstrainSelectedInstOperands,
     /*  98089 */   // GIR_Coverage, 530,
     /*  98089 */   GIR_Done,
     /*  98090 */ // Label 1776: @98090
     /*  98090 */ GIM_Reject,
     /*  98091 */ // Label 1768: @98091
     /*  98091 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98121), // Rule ID 532 //
     /*  98096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98110 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  98115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98119 */   GIR_RootConstrainSelectedInstOperands,
     /*  98120 */   // GIR_Coverage, 532,
     /*  98120 */   GIR_Done,
     /*  98121 */ // Label 1777: @98121
     /*  98121 */ GIM_Reject,
     /*  98122 */ // Label 1769: @98122
     /*  98122 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98152), // Rule ID 873 //
     /*  98127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98141 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  98146 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98150 */   GIR_RootConstrainSelectedInstOperands,
     /*  98151 */   // GIR_Coverage, 873,
     /*  98151 */   GIR_Done,
     /*  98152 */ // Label 1778: @98152
     /*  98152 */ GIM_Reject,
     /*  98153 */ // Label 1770: @98153
     /*  98153 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98183), // Rule ID 877 //
     /*  98158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98172 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  98177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98181 */   GIR_RootConstrainSelectedInstOperands,
     /*  98182 */   // GIR_Coverage, 877,
     /*  98182 */   GIR_Done,
     /*  98183 */ // Label 1779: @98183
     /*  98183 */ GIM_Reject,
     /*  98184 */ // Label 1771: @98184
     /*  98184 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98214), // Rule ID 869 //
     /*  98189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98203 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  98208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98212 */   GIR_RootConstrainSelectedInstOperands,
     /*  98213 */   // GIR_Coverage, 869,
     /*  98213 */   GIR_Done,
     /*  98214 */ // Label 1780: @98214
     /*  98214 */ GIM_Reject,
     /*  98215 */ // Label 1772: @98215
     /*  98215 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98245), // Rule ID 875 //
     /*  98220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98234 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98239 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98243 */   GIR_RootConstrainSelectedInstOperands,
     /*  98244 */   // GIR_Coverage, 875,
     /*  98244 */   GIR_Done,
     /*  98245 */ // Label 1781: @98245
     /*  98245 */ GIM_Reject,
     /*  98246 */ // Label 1773: @98246
     /*  98246 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98467),
     /*  98251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98262 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98281), // Rule ID 871 //
     /*  98267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98270 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  98275 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98279 */     GIR_RootConstrainSelectedInstOperands,
     /*  98280 */     // GIR_Coverage, 871,
     /*  98280 */     GIR_Done,
     /*  98281 */   // Label 1783: @98281
     /*  98281 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98466), // Rule ID 6992 //
     /*  98286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98289 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98289 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98292 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98296 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98301 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98307 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98310 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98314 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98319 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98324 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98327 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98331 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98336 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98342 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98347 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98352 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98355 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98359 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98364 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98369 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98372 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98376 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98381 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98386 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98389 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98393 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98398 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98429 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98432 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98464 */     GIR_RootConstrainSelectedInstOperands,
     /*  98465 */     // GIR_Coverage, 6992,
     /*  98465 */     GIR_EraseRootFromParent_Done,
     /*  98466 */   // Label 1784: @98466
     /*  98466 */   GIM_Reject,
     /*  98467 */ // Label 1782: @98467
     /*  98467 */ GIM_Reject,
     /*  98468 */ // Label 1774: @98468
     /*  98468 */ GIM_Reject,
     /*  98469 */ // Label 12: @98469
     /*  98469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1787*/ GIMT_Encode4(98736),
     /*  98480 */ /*GILLT_s32*//*Label 1785*/ GIMT_Encode4(98488),
     /*  98484 */ /*GILLT_s64*//*Label 1786*/ GIMT_Encode4(98612),
     /*  98488 */ // Label 1785: @98488
     /*  98488 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98531), // Rule ID 4785 //
     /*  98493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98503 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  98524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98529 */   GIR_RootConstrainSelectedInstOperands,
     /*  98530 */   // GIR_Coverage, 4785,
     /*  98530 */   GIR_EraseRootFromParent_Done,
     /*  98531 */ // Label 1788: @98531
     /*  98531 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98571), // Rule ID 4791 //
     /*  98536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98543 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  98564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98569 */   GIR_RootConstrainSelectedInstOperands,
     /*  98570 */   // GIR_Coverage, 4791,
     /*  98570 */   GIR_EraseRootFromParent_Done,
     /*  98571 */ // Label 1789: @98571
     /*  98571 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98611), // Rule ID 4793 //
     /*  98576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98583 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  98604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98609 */   GIR_RootConstrainSelectedInstOperands,
     /*  98610 */   // GIR_Coverage, 4793,
     /*  98610 */   GIR_EraseRootFromParent_Done,
     /*  98611 */ // Label 1790: @98611
     /*  98611 */ GIM_Reject,
     /*  98612 */ // Label 1786: @98612
     /*  98612 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98655), // Rule ID 4787 //
     /*  98617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98627 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98639 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98653 */   GIR_RootConstrainSelectedInstOperands,
     /*  98654 */   // GIR_Coverage, 4787,
     /*  98654 */   GIR_EraseRootFromParent_Done,
     /*  98655 */ // Label 1791: @98655
     /*  98655 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98695), // Rule ID 4795 //
     /*  98660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98667 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98679 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98693 */   GIR_RootConstrainSelectedInstOperands,
     /*  98694 */   // GIR_Coverage, 4795,
     /*  98694 */   GIR_EraseRootFromParent_Done,
     /*  98695 */ // Label 1792: @98695
     /*  98695 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98735), // Rule ID 4797 //
     /*  98700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98707 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98733 */   GIR_RootConstrainSelectedInstOperands,
     /*  98734 */   // GIR_Coverage, 4797,
     /*  98734 */   GIR_EraseRootFromParent_Done,
     /*  98735 */ // Label 1793: @98735
     /*  98735 */ GIM_Reject,
     /*  98736 */ // Label 1787: @98736
     /*  98736 */ GIM_Reject,
     /*  98737 */ // Label 13: @98737
     /*  98737 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98886),
     /*  98742 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98745 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1798*/ GIMT_Encode4(98885),
     /*  98756 */   /*GILLT_s16*//*Label 1795*/ GIMT_Encode4(98768),
     /*  98760 */   /*GILLT_s32*//*Label 1796*/ GIMT_Encode4(98809),
     /*  98764 */   /*GILLT_s64*//*Label 1797*/ GIMT_Encode4(98847),
     /*  98768 */   // Label 1795: @98768
     /*  98768 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98808), // Rule ID 4789 //
     /*  98773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98780 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98806 */     GIR_RootConstrainSelectedInstOperands,
     /*  98807 */     // GIR_Coverage, 4789,
     /*  98807 */     GIR_EraseRootFromParent_Done,
     /*  98808 */   // Label 1799: @98808
     /*  98808 */   GIM_Reject,
     /*  98809 */   // Label 1796: @98809
     /*  98809 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98846), // Rule ID 4799 //
     /*  98814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98818 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98844 */     GIR_RootConstrainSelectedInstOperands,
     /*  98845 */     // GIR_Coverage, 4799,
     /*  98845 */     GIR_EraseRootFromParent_Done,
     /*  98846 */   // Label 1800: @98846
     /*  98846 */   GIM_Reject,
     /*  98847 */   // Label 1797: @98847
     /*  98847 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(98884), // Rule ID 4801 //
     /*  98852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98856 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98882 */     GIR_RootConstrainSelectedInstOperands,
     /*  98883 */     // GIR_Coverage, 4801,
     /*  98883 */     GIR_EraseRootFromParent_Done,
     /*  98884 */   // Label 1801: @98884
     /*  98884 */   GIM_Reject,
     /*  98885 */   // Label 1798: @98885
     /*  98885 */   GIM_Reject,
     /*  98886 */ // Label 1794: @98886
     /*  98886 */ GIM_Reject,
     /*  98887 */ // Label 14: @98887
     /*  98887 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1810*/ GIMT_Encode4(99377),
     /*  98898 */ /*GILLT_s16*//*Label 1802*/ GIMT_Encode4(98938),
     /*  98902 */ /*GILLT_s32*//*Label 1803*/ GIMT_Encode4(98969),
     /*  98906 */ /*GILLT_s64*//*Label 1804*/ GIMT_Encode4(99000), GIMT_Encode4(0),
     /*  98914 */ /*GILLT_v2s32*//*Label 1805*/ GIMT_Encode4(99031),
     /*  98918 */ /*GILLT_v2s64*//*Label 1806*/ GIMT_Encode4(99062),
     /*  98922 */ /*GILLT_v4s16*//*Label 1807*/ GIMT_Encode4(99093),
     /*  98926 */ /*GILLT_v4s32*//*Label 1808*/ GIMT_Encode4(99124), GIMT_Encode4(0),
     /*  98934 */ /*GILLT_v8s16*//*Label 1809*/ GIMT_Encode4(99155),
     /*  98938 */ // Label 1802: @98938
     /*  98938 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(98968), // Rule ID 546 //
     /*  98943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98957 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  98962 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98966 */   GIR_RootConstrainSelectedInstOperands,
     /*  98967 */   // GIR_Coverage, 546,
     /*  98967 */   GIR_Done,
     /*  98968 */ // Label 1811: @98968
     /*  98968 */ GIM_Reject,
     /*  98969 */ // Label 1803: @98969
     /*  98969 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(98999), // Rule ID 548 //
     /*  98974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98988 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  98993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98997 */   GIR_RootConstrainSelectedInstOperands,
     /*  98998 */   // GIR_Coverage, 548,
     /*  98998 */   GIR_Done,
     /*  98999 */ // Label 1812: @98999
     /*  98999 */ GIM_Reject,
     /*  99000 */ // Label 1804: @99000
     /*  99000 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99030), // Rule ID 550 //
     /*  99005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  99011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99019 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  99019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  99024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99028 */   GIR_RootConstrainSelectedInstOperands,
     /*  99029 */   // GIR_Coverage, 550,
     /*  99029 */   GIR_Done,
     /*  99030 */ // Label 1813: @99030
     /*  99030 */ GIM_Reject,
     /*  99031 */ // Label 1805: @99031
     /*  99031 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99061), // Rule ID 903 //
     /*  99036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99050 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  99050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  99055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99059 */   GIR_RootConstrainSelectedInstOperands,
     /*  99060 */   // GIR_Coverage, 903,
     /*  99060 */   GIR_Done,
     /*  99061 */ // Label 1814: @99061
     /*  99061 */ GIM_Reject,
     /*  99062 */ // Label 1806: @99062
     /*  99062 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99092), // Rule ID 907 //
     /*  99067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99081 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  99081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  99086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99090 */   GIR_RootConstrainSelectedInstOperands,
     /*  99091 */   // GIR_Coverage, 907,
     /*  99091 */   GIR_Done,
     /*  99092 */ // Label 1815: @99092
     /*  99092 */ GIM_Reject,
     /*  99093 */ // Label 1807: @99093
     /*  99093 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99123), // Rule ID 899 //
     /*  99098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99112 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  99112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  99117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99121 */   GIR_RootConstrainSelectedInstOperands,
     /*  99122 */   // GIR_Coverage, 899,
     /*  99122 */   GIR_Done,
     /*  99123 */ // Label 1816: @99123
     /*  99123 */ GIM_Reject,
     /*  99124 */ // Label 1808: @99124
     /*  99124 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99154), // Rule ID 905 //
     /*  99129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99143 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  99143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99148 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99152 */   GIR_RootConstrainSelectedInstOperands,
     /*  99153 */   // GIR_Coverage, 905,
     /*  99153 */   GIR_Done,
     /*  99154 */ // Label 1817: @99154
     /*  99154 */ GIM_Reject,
     /*  99155 */ // Label 1809: @99155
     /*  99155 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99376),
     /*  99160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99171 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(99190), // Rule ID 901 //
     /*  99176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  99179 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  99179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  99184 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  99188 */     GIR_RootConstrainSelectedInstOperands,
     /*  99189 */     // GIR_Coverage, 901,
     /*  99189 */     GIR_Done,
     /*  99190 */   // Label 1819: @99190
     /*  99190 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(99375), // Rule ID 6994 //
     /*  99195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  99198 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  99198 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  99201 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  99205 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99210 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  99216 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  99219 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99223 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99228 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  99231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  99233 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  99236 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99240 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99245 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  99251 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99256 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99261 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  99264 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  99268 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99273 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  99276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  99278 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  99281 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99285 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99290 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  99293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99295 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  99298 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  99302 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99307 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99338 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  99344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  99365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  99373 */     GIR_RootConstrainSelectedInstOperands,
     /*  99374 */     // GIR_Coverage, 6994,
     /*  99374 */     GIR_EraseRootFromParent_Done,
     /*  99375 */   // Label 1820: @99375
     /*  99375 */   GIM_Reject,
     /*  99376 */ // Label 1818: @99376
     /*  99376 */ GIM_Reject,
     /*  99377 */ // Label 1810: @99377
     /*  99377 */ GIM_Reject,
     /*  99378 */ // Label 15: @99378
     /*  99378 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99410), // Rule ID 3904 //
     /*  99383 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  99386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99390 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  99390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  99393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99395 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  99405 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  99408 */   GIR_RootConstrainSelectedInstOperands,
     /*  99409 */   // GIR_Coverage, 3904,
     /*  99409 */   GIR_EraseRootFromParent_Done,
     /*  99410 */ // Label 1821: @99410
     /*  99410 */ GIM_Reject,
     /*  99411 */ // Label 16: @99411
     /*  99411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1842*/ GIMT_Encode4(108284),
     /*  99422 */ /*GILLT_s8*//*Label 1822*/ GIMT_Encode4(99518),
     /*  99426 */ /*GILLT_s16*//*Label 1823*/ GIMT_Encode4(99694),
     /*  99430 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(99870),
     /*  99434 */ /*GILLT_s64*//*Label 1825*/ GIMT_Encode4(102232),
     /*  99438 */ /*GILLT_s128*//*Label 1826*/ GIMT_Encode4(104913),
     /*  99442 */ /*GILLT_v2s32*//*Label 1827*/ GIMT_Encode4(105122),
     /*  99446 */ /*GILLT_v2s64*//*Label 1828*/ GIMT_Encode4(105500),
     /*  99450 */ /*GILLT_v4s16*//*Label 1829*/ GIMT_Encode4(105878),
     /*  99454 */ /*GILLT_v4s32*//*Label 1830*/ GIMT_Encode4(106256),
     /*  99458 */ /*GILLT_v8s8*//*Label 1831*/ GIMT_Encode4(106634),
     /*  99462 */ /*GILLT_v8s16*//*Label 1832*/ GIMT_Encode4(106842),
     /*  99466 */ /*GILLT_v16s8*//*Label 1833*/ GIMT_Encode4(107220), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99478 */ /*GILLT_nxv2s16*//*Label 1834*/ GIMT_Encode4(107428),
     /*  99482 */ /*GILLT_nxv2s32*//*Label 1835*/ GIMT_Encode4(107492),
     /*  99486 */ /*GILLT_nxv2s64*//*Label 1836*/ GIMT_Encode4(107556), GIMT_Encode4(0),
     /*  99494 */ /*GILLT_nxv4s16*//*Label 1837*/ GIMT_Encode4(107730),
     /*  99498 */ /*GILLT_nxv4s32*//*Label 1838*/ GIMT_Encode4(107794), GIMT_Encode4(0),
     /*  99506 */ /*GILLT_nxv8s16*//*Label 1839*/ GIMT_Encode4(107968),
     /*  99510 */ /*GILLT_nxv16s1*//*Label 1840*/ GIMT_Encode4(108142),
     /*  99514 */ /*GILLT_nxv16s8*//*Label 1841*/ GIMT_Encode4(108186),
     /*  99518 */ // Label 1822: @99518
     /*  99518 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(99693),
     /*  99523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  99534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99538 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(99579), // Rule ID 237 //
     /*  99543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99553 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  99556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99577 */     GIR_RootConstrainSelectedInstOperands,
     /*  99578 */     // GIR_Coverage, 237,
     /*  99578 */     GIR_EraseRootFromParent_Done,
     /*  99579 */   // Label 1844: @99579
     /*  99579 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(99620), // Rule ID 238 //
     /*  99584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99594 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  99597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99618 */     GIR_RootConstrainSelectedInstOperands,
     /*  99619 */     // GIR_Coverage, 238,
     /*  99619 */     GIR_EraseRootFromParent_Done,
     /*  99620 */   // Label 1845: @99620
     /*  99620 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(99656), // Rule ID 261 //
     /*  99625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99635 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  99635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  99638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99654 */     GIR_RootConstrainSelectedInstOperands,
     /*  99655 */     // GIR_Coverage, 261,
     /*  99655 */     GIR_EraseRootFromParent_Done,
     /*  99656 */   // Label 1846: @99656
     /*  99656 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99692), // Rule ID 282 //
     /*  99661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99671 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  99674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99690 */     GIR_RootConstrainSelectedInstOperands,
     /*  99691 */     // GIR_Coverage, 282,
     /*  99691 */     GIR_EraseRootFromParent_Done,
     /*  99692 */   // Label 1847: @99692
     /*  99692 */   GIM_Reject,
     /*  99693 */ // Label 1843: @99693
     /*  99693 */ GIM_Reject,
     /*  99694 */ // Label 1823: @99694
     /*  99694 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99869),
     /*  99699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99714 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99755), // Rule ID 239 //
     /*  99719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99729 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99753 */     GIR_RootConstrainSelectedInstOperands,
     /*  99754 */     // GIR_Coverage, 239,
     /*  99754 */     GIR_EraseRootFromParent_Done,
     /*  99755 */   // Label 1849: @99755
     /*  99755 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99796), // Rule ID 240 //
     /*  99760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99770 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99794 */     GIR_RootConstrainSelectedInstOperands,
     /*  99795 */     // GIR_Coverage, 240,
     /*  99795 */     GIR_EraseRootFromParent_Done,
     /*  99796 */   // Label 1850: @99796
     /*  99796 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99832), // Rule ID 262 //
     /*  99801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99811 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99830 */     GIR_RootConstrainSelectedInstOperands,
     /*  99831 */     // GIR_Coverage, 262,
     /*  99831 */     GIR_EraseRootFromParent_Done,
     /*  99832 */   // Label 1851: @99832
     /*  99832 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99868), // Rule ID 283 //
     /*  99837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99847 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99866 */     GIR_RootConstrainSelectedInstOperands,
     /*  99867 */     // GIR_Coverage, 283,
     /*  99867 */     GIR_EraseRootFromParent_Done,
     /*  99868 */   // Label 1852: @99868
     /*  99868 */   GIM_Reject,
     /*  99869 */ // Label 1848: @99869
     /*  99869 */ GIM_Reject,
     /*  99870 */ // Label 1824: @99870
     /*  99870 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99923), // Rule ID 233 //
     /*  99875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99897 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99917 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99921 */   GIR_RootConstrainSelectedInstOperands,
     /*  99922 */   // GIR_Coverage, 233,
     /*  99922 */   GIR_EraseRootFromParent_Done,
     /*  99923 */ // Label 1853: @99923
     /*  99923 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99976), // Rule ID 234 //
     /*  99928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99950 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99974 */   GIR_RootConstrainSelectedInstOperands,
     /*  99975 */   // GIR_Coverage, 234,
     /*  99975 */   GIR_EraseRootFromParent_Done,
     /*  99976 */ // Label 1854: @99976
     /*  99976 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100032), // Rule ID 241 //
     /*  99981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100006 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 100009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100030 */   GIR_RootConstrainSelectedInstOperands,
     /* 100031 */   // GIR_Coverage, 241,
     /* 100031 */   GIR_EraseRootFromParent_Done,
     /* 100032 */ // Label 1855: @100032
     /* 100032 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100088), // Rule ID 242 //
     /* 100037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100043 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100062 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 100065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100082 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100086 */   GIR_RootConstrainSelectedInstOperands,
     /* 100087 */   // GIR_Coverage, 242,
     /* 100087 */   GIR_EraseRootFromParent_Done,
     /* 100088 */ // Label 1856: @100088
     /* 100088 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100148), // Rule ID 4120 //
     /* 100093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100096 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100122 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 100122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100146 */   GIR_RootConstrainSelectedInstOperands,
     /* 100147 */   // GIR_Coverage, 4120,
     /* 100147 */   GIR_EraseRootFromParent_Done,
     /* 100148 */ // Label 1857: @100148
     /* 100148 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100208), // Rule ID 4121 //
     /* 100153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100156 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100175 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100182 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 100182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100206 */   GIR_RootConstrainSelectedInstOperands,
     /* 100207 */   // GIR_Coverage, 4121,
     /* 100207 */   GIR_EraseRootFromParent_Done,
     /* 100208 */ // Label 1858: @100208
     /* 100208 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100268), // Rule ID 4122 //
     /* 100213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100216 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100220 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100231 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100242 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100266 */   GIR_RootConstrainSelectedInstOperands,
     /* 100267 */   // GIR_Coverage, 4122,
     /* 100267 */   GIR_EraseRootFromParent_Done,
     /* 100268 */ // Label 1859: @100268
     /* 100268 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100328), // Rule ID 4123 //
     /* 100273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100302 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100326 */   GIR_RootConstrainSelectedInstOperands,
     /* 100327 */   // GIR_Coverage, 4123,
     /* 100327 */   GIR_EraseRootFromParent_Done,
     /* 100328 */ // Label 1860: @100328
     /* 100328 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100388), // Rule ID 4124 //
     /* 100333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100336 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100362 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100386 */   GIR_RootConstrainSelectedInstOperands,
     /* 100387 */   // GIR_Coverage, 4124,
     /* 100387 */   GIR_EraseRootFromParent_Done,
     /* 100388 */ // Label 1861: @100388
     /* 100388 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100448), // Rule ID 4125 //
     /* 100393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100396 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100422 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100446 */   GIR_RootConstrainSelectedInstOperands,
     /* 100447 */   // GIR_Coverage, 4125,
     /* 100447 */   GIR_EraseRootFromParent_Done,
     /* 100448 */ // Label 1862: @100448
     /* 100448 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100496), // Rule ID 260 //
     /* 100453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100456 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100464 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100468 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100475 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100494 */   GIR_RootConstrainSelectedInstOperands,
     /* 100495 */   // GIR_Coverage, 260,
     /* 100495 */   GIR_EraseRootFromParent_Done,
     /* 100496 */ // Label 1863: @100496
     /* 100496 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100547), // Rule ID 263 //
     /* 100501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100526 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 100529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100545 */   GIR_RootConstrainSelectedInstOperands,
     /* 100546 */   // GIR_Coverage, 263,
     /* 100546 */   GIR_EraseRootFromParent_Done,
     /* 100547 */ // Label 1864: @100547
     /* 100547 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100606), // Rule ID 7046 //
     /* 100552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100562 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100580 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100604 */   GIR_RootConstrainSelectedInstOperands,
     /* 100605 */   // GIR_Coverage, 7046,
     /* 100605 */   GIR_EraseRootFromParent_Done,
     /* 100606 */ // Label 1865: @100606
     /* 100606 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100665), // Rule ID 7047 //
     /* 100611 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100621 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100639 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100663 */   GIR_RootConstrainSelectedInstOperands,
     /* 100664 */   // GIR_Coverage, 7047,
     /* 100664 */   GIR_EraseRootFromParent_Done,
     /* 100665 */ // Label 1866: @100665
     /* 100665 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100728), // Rule ID 7024 //
     /* 100670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100673 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100684 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100702 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 100702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100726 */   GIR_RootConstrainSelectedInstOperands,
     /* 100727 */   // GIR_Coverage, 7024,
     /* 100727 */   GIR_EraseRootFromParent_Done,
     /* 100728 */ // Label 1867: @100728
     /* 100728 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100791), // Rule ID 7026 //
     /* 100733 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100736 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100740 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100747 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100765 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 100765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100789 */   GIR_RootConstrainSelectedInstOperands,
     /* 100790 */   // GIR_Coverage, 7026,
     /* 100790 */   GIR_EraseRootFromParent_Done,
     /* 100791 */ // Label 1868: @100791
     /* 100791 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100854), // Rule ID 7036 //
     /* 100796 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100799 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100828 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100852 */   GIR_RootConstrainSelectedInstOperands,
     /* 100853 */   // GIR_Coverage, 7036,
     /* 100853 */   GIR_EraseRootFromParent_Done,
     /* 100854 */ // Label 1869: @100854
     /* 100854 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100917), // Rule ID 7038 //
     /* 100859 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100862 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100873 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100891 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100915 */   GIR_RootConstrainSelectedInstOperands,
     /* 100916 */   // GIR_Coverage, 7038,
     /* 100916 */   GIR_EraseRootFromParent_Done,
     /* 100917 */ // Label 1870: @100917
     /* 100917 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100965), // Rule ID 281 //
     /* 100922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100925 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100933 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100937 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100944 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100963 */   GIR_RootConstrainSelectedInstOperands,
     /* 100964 */   // GIR_Coverage, 281,
     /* 100964 */   GIR_EraseRootFromParent_Done,
     /* 100965 */ // Label 1871: @100965
     /* 100965 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101016), // Rule ID 284 //
     /* 100970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100995 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 100998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101014 */   GIR_RootConstrainSelectedInstOperands,
     /* 101015 */   // GIR_Coverage, 284,
     /* 101015 */   GIR_EraseRootFromParent_Done,
     /* 101016 */ // Label 1872: @101016
     /* 101016 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101070), // Rule ID 7048 //
     /* 101021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101031 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 101049 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 101049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 101052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101068 */   GIR_RootConstrainSelectedInstOperands,
     /* 101069 */   // GIR_Coverage, 7048,
     /* 101069 */   GIR_EraseRootFromParent_Done,
     /* 101070 */ // Label 1873: @101070
     /* 101070 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101124), // Rule ID 7049 //
     /* 101075 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101085 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101092 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101096 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101103 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15860>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 101106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101122 */   GIR_RootConstrainSelectedInstOperands,
     /* 101123 */   // GIR_Coverage, 7049,
     /* 101123 */   GIR_EraseRootFromParent_Done,
     /* 101124 */ // Label 1874: @101124
     /* 101124 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101181), // Rule ID 7408 //
     /* 101129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101132 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101135 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101160 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15837>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 101163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101179 */   GIR_RootConstrainSelectedInstOperands,
     /* 101180 */   // GIR_Coverage, 7408,
     /* 101180 */   GIR_EraseRootFromParent_Done,
     /* 101181 */ // Label 1875: @101181
     /* 101181 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(101236), // Rule ID 4147 //
     /* 101186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101189 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101193 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101215 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101234 */   GIR_RootConstrainSelectedInstOperands,
     /* 101235 */   // GIR_Coverage, 4147,
     /* 101235 */   GIR_EraseRootFromParent_Done,
     /* 101236 */ // Label 1876: @101236
     /* 101236 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(101291), // Rule ID 4148 //
     /* 101241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101270 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101289 */   GIR_RootConstrainSelectedInstOperands,
     /* 101290 */   // GIR_Coverage, 4148,
     /* 101290 */   GIR_EraseRootFromParent_Done,
     /* 101291 */ // Label 1877: @101291
     /* 101291 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(101346), // Rule ID 4149 //
     /* 101296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101299 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101303 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101325 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101344 */   GIR_RootConstrainSelectedInstOperands,
     /* 101345 */   // GIR_Coverage, 4149,
     /* 101345 */   GIR_EraseRootFromParent_Done,
     /* 101346 */ // Label 1878: @101346
     /* 101346 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101401), // Rule ID 4170 //
     /* 101351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101354 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101380 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101399 */   GIR_RootConstrainSelectedInstOperands,
     /* 101400 */   // GIR_Coverage, 4170,
     /* 101400 */   GIR_EraseRootFromParent_Done,
     /* 101401 */ // Label 1879: @101401
     /* 101401 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101456), // Rule ID 4171 //
     /* 101406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101409 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101413 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101435 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101454 */   GIR_RootConstrainSelectedInstOperands,
     /* 101455 */   // GIR_Coverage, 4171,
     /* 101455 */   GIR_EraseRootFromParent_Done,
     /* 101456 */ // Label 1880: @101456
     /* 101456 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101511), // Rule ID 4172 //
     /* 101461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101464 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101490 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101509 */   GIR_RootConstrainSelectedInstOperands,
     /* 101510 */   // GIR_Coverage, 4172,
     /* 101510 */   GIR_EraseRootFromParent_Done,
     /* 101511 */ // Label 1881: @101511
     /* 101511 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101569), // Rule ID 7028 //
     /* 101516 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101519 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101530 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101541 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101548 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101567 */   GIR_RootConstrainSelectedInstOperands,
     /* 101568 */   // GIR_Coverage, 7028,
     /* 101568 */   GIR_EraseRootFromParent_Done,
     /* 101569 */ // Label 1882: @101569
     /* 101569 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101627), // Rule ID 7030 //
     /* 101574 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101577 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101588 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101599 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101606 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15844>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101625 */   GIR_RootConstrainSelectedInstOperands,
     /* 101626 */   // GIR_Coverage, 7030,
     /* 101626 */   GIR_EraseRootFromParent_Done,
     /* 101627 */ // Label 1883: @101627
     /* 101627 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101685), // Rule ID 7040 //
     /* 101632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101646 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101664 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101683 */   GIR_RootConstrainSelectedInstOperands,
     /* 101684 */   // GIR_Coverage, 7040,
     /* 101684 */   GIR_EraseRootFromParent_Done,
     /* 101685 */ // Label 1884: @101685
     /* 101685 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101743), // Rule ID 7042 //
     /* 101690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101704 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101722 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15852>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101741 */   GIR_RootConstrainSelectedInstOperands,
     /* 101742 */   // GIR_Coverage, 7042,
     /* 101742 */   GIR_EraseRootFromParent_Done,
     /* 101743 */ // Label 1885: @101743
     /* 101743 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101804), // Rule ID 7404 //
     /* 101748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101783 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15833>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 101786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101802 */   GIR_RootConstrainSelectedInstOperands,
     /* 101803 */   // GIR_Coverage, 7404,
     /* 101803 */   GIR_EraseRootFromParent_Done,
     /* 101804 */ // Label 1886: @101804
     /* 101804 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101865), // Rule ID 7406 //
     /* 101809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101844 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15835>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 101847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101863 */   GIR_RootConstrainSelectedInstOperands,
     /* 101864 */   // GIR_Coverage, 7406,
     /* 101864 */   GIR_EraseRootFromParent_Done,
     /* 101865 */ // Label 1887: @101865
     /* 101865 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101905), // Rule ID 7018 //
     /* 101870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101873 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101890 */   // MIs[0] ptr
     /* 101890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101898 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15837>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 101903 */   GIR_RootConstrainSelectedInstOperands,
     /* 101904 */   // GIR_Coverage, 7018,
     /* 101904 */   GIR_Done,
     /* 101905 */ // Label 1888: @101905
     /* 101905 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101942), // Rule ID 7044 //
     /* 101910 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101927 */   // MIs[0] ptr
     /* 101927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101935 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101940 */   GIR_RootConstrainSelectedInstOperands,
     /* 101941 */   // GIR_Coverage, 7044,
     /* 101941 */   GIR_Done,
     /* 101942 */ // Label 1889: @101942
     /* 101942 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101979), // Rule ID 7045 //
     /* 101947 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101950 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101964 */   // MIs[0] ptr
     /* 101964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101972 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15837>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101977 */   GIR_RootConstrainSelectedInstOperands,
     /* 101978 */   // GIR_Coverage, 7045,
     /* 101978 */   GIR_Done,
     /* 101979 */ // Label 1890: @101979
     /* 101979 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(102023), // Rule ID 7014 //
     /* 101984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101987 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101990 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102008 */   // MIs[0] ptr
     /* 102008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102016 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15833>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 102021 */   GIR_RootConstrainSelectedInstOperands,
     /* 102022 */   // GIR_Coverage, 7014,
     /* 102022 */   GIR_Done,
     /* 102023 */ // Label 1891: @102023
     /* 102023 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(102067), // Rule ID 7016 //
     /* 102028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 102031 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102034 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102052 */   // MIs[0] ptr
     /* 102052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102060 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15835>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 102065 */   GIR_RootConstrainSelectedInstOperands,
     /* 102066 */   // GIR_Coverage, 7016,
     /* 102066 */   GIR_Done,
     /* 102067 */ // Label 1892: @102067
     /* 102067 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(102108), // Rule ID 7020 //
     /* 102072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102075 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102086 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102093 */   // MIs[0] ptr
     /* 102093 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102101 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15841>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102106 */   GIR_RootConstrainSelectedInstOperands,
     /* 102107 */   // GIR_Coverage, 7020,
     /* 102107 */   GIR_Done,
     /* 102108 */ // Label 1893: @102108
     /* 102108 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(102149), // Rule ID 7022 //
     /* 102113 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102116 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102134 */   // MIs[0] ptr
     /* 102134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102142 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15833>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 102147 */   GIR_RootConstrainSelectedInstOperands,
     /* 102148 */   // GIR_Coverage, 7022,
     /* 102148 */   GIR_Done,
     /* 102149 */ // Label 1894: @102149
     /* 102149 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(102190), // Rule ID 7032 //
     /* 102154 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 102171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102175 */   // MIs[0] ptr
     /* 102175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102183 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15849>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102188 */   GIR_RootConstrainSelectedInstOperands,
     /* 102189 */   // GIR_Coverage, 7032,
     /* 102189 */   GIR_Done,
     /* 102190 */ // Label 1895: @102190
     /* 102190 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102231), // Rule ID 7034 //
     /* 102195 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102198 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102216 */   // MIs[0] ptr
     /* 102216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102224 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15835>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 102224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 102229 */   GIR_RootConstrainSelectedInstOperands,
     /* 102230 */   // GIR_Coverage, 7034,
     /* 102230 */   GIR_Done,
     /* 102231 */ // Label 1896: @102231
     /* 102231 */ GIM_Reject,
     /* 102232 */ // Label 1825: @102232
     /* 102232 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102285), // Rule ID 235 //
     /* 102237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102240 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102259 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102283 */   GIR_RootConstrainSelectedInstOperands,
     /* 102284 */   // GIR_Coverage, 235,
     /* 102284 */   GIR_EraseRootFromParent_Done,
     /* 102285 */ // Label 1897: @102285
     /* 102285 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102338), // Rule ID 236 //
     /* 102290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102293 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102312 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102336 */   GIR_RootConstrainSelectedInstOperands,
     /* 102337 */   // GIR_Coverage, 236,
     /* 102337 */   GIR_EraseRootFromParent_Done,
     /* 102338 */ // Label 1898: @102338
     /* 102338 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102394), // Rule ID 243 //
     /* 102343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102368 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102392 */   GIR_RootConstrainSelectedInstOperands,
     /* 102393 */   // GIR_Coverage, 243,
     /* 102393 */   GIR_EraseRootFromParent_Done,
     /* 102394 */ // Label 1899: @102394
     /* 102394 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102450), // Rule ID 244 //
     /* 102399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102424 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102448 */   GIR_RootConstrainSelectedInstOperands,
     /* 102449 */   // GIR_Coverage, 244,
     /* 102449 */   GIR_EraseRootFromParent_Done,
     /* 102450 */ // Label 1900: @102450
     /* 102450 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102503), // Rule ID 4086 //
     /* 102455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102477 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102501 */   GIR_RootConstrainSelectedInstOperands,
     /* 102502 */   // GIR_Coverage, 4086,
     /* 102502 */   GIR_EraseRootFromParent_Done,
     /* 102503 */ // Label 1901: @102503
     /* 102503 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102556), // Rule ID 4087 //
     /* 102508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102530 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102554 */   GIR_RootConstrainSelectedInstOperands,
     /* 102555 */   // GIR_Coverage, 4087,
     /* 102555 */   GIR_EraseRootFromParent_Done,
     /* 102556 */ // Label 1902: @102556
     /* 102556 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102609), // Rule ID 4088 //
     /* 102561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102583 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102607 */   GIR_RootConstrainSelectedInstOperands,
     /* 102608 */   // GIR_Coverage, 4088,
     /* 102608 */   GIR_EraseRootFromParent_Done,
     /* 102609 */ // Label 1903: @102609
     /* 102609 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102662), // Rule ID 4089 //
     /* 102614 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102617 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102629 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102636 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102660 */   GIR_RootConstrainSelectedInstOperands,
     /* 102661 */   // GIR_Coverage, 4089,
     /* 102661 */   GIR_EraseRootFromParent_Done,
     /* 102662 */ // Label 1904: @102662
     /* 102662 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102754), // Rule ID 4112 //
     /* 102667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102670 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102696 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102723 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102753 */   // GIR_Coverage, 4112,
     /* 102753 */   GIR_EraseRootFromParent_Done,
     /* 102754 */ // Label 1905: @102754
     /* 102754 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102846), // Rule ID 4113 //
     /* 102759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102762 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102766 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102781 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102788 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102815 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102845 */   // GIR_Coverage, 4113,
     /* 102845 */   GIR_EraseRootFromParent_Done,
     /* 102846 */ // Label 1906: @102846
     /* 102846 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102938), // Rule ID 4114 //
     /* 102851 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102854 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102858 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102880 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102907 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102927 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102937 */   // GIR_Coverage, 4114,
     /* 102937 */   GIR_EraseRootFromParent_Done,
     /* 102938 */ // Label 1907: @102938
     /* 102938 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(103030), // Rule ID 4115 //
     /* 102943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102946 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102950 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 102972 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 102979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102999 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103029 */   // GIR_Coverage, 4115,
     /* 103029 */   GIR_EraseRootFromParent_Done,
     /* 103030 */ // Label 1908: @103030
     /* 103030 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(103122), // Rule ID 4116 //
     /* 103035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103038 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 103064 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 103071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103091 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103121 */   // GIR_Coverage, 4116,
     /* 103121 */   GIR_EraseRootFromParent_Done,
     /* 103122 */ // Label 1909: @103122
     /* 103122 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(103214), // Rule ID 4117 //
     /* 103127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103130 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103149 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 103156 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 103163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103183 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103213 */   // GIR_Coverage, 4117,
     /* 103213 */   GIR_EraseRootFromParent_Done,
     /* 103214 */ // Label 1910: @103214
     /* 103214 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(103306), // Rule ID 4118 //
     /* 103219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 103248 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 103255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103275 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103305 */   // GIR_Coverage, 4118,
     /* 103305 */   GIR_EraseRootFromParent_Done,
     /* 103306 */ // Label 1911: @103306
     /* 103306 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(103398), // Rule ID 4119 //
     /* 103311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103314 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103333 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103340 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 103347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103367 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103397 */   // GIR_Coverage, 4119,
     /* 103397 */   GIR_EraseRootFromParent_Done,
     /* 103398 */ // Label 1912: @103398
     /* 103398 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(103446), // Rule ID 259 //
     /* 103403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103425 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103444 */   GIR_RootConstrainSelectedInstOperands,
     /* 103445 */   // GIR_Coverage, 259,
     /* 103445 */   GIR_EraseRootFromParent_Done,
     /* 103446 */ // Label 1913: @103446
     /* 103446 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(103497), // Rule ID 264 //
     /* 103451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103457 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103476 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103495 */   GIR_RootConstrainSelectedInstOperands,
     /* 103496 */   // GIR_Coverage, 264,
     /* 103496 */   GIR_EraseRootFromParent_Done,
     /* 103497 */ // Label 1914: @103497
     /* 103497 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(103556), // Rule ID 7052 //
     /* 103502 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103512 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103530 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 103533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103554 */   GIR_RootConstrainSelectedInstOperands,
     /* 103555 */   // GIR_Coverage, 7052,
     /* 103555 */   GIR_EraseRootFromParent_Done,
     /* 103556 */ // Label 1915: @103556
     /* 103556 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103615), // Rule ID 7053 //
     /* 103561 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103564 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103571 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103589 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 103592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103613 */   GIR_RootConstrainSelectedInstOperands,
     /* 103614 */   // GIR_Coverage, 7053,
     /* 103614 */   GIR_EraseRootFromParent_Done,
     /* 103615 */ // Label 1916: @103615
     /* 103615 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103663), // Rule ID 280 //
     /* 103620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103642 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103661 */   GIR_RootConstrainSelectedInstOperands,
     /* 103662 */   // GIR_Coverage, 280,
     /* 103662 */   GIR_EraseRootFromParent_Done,
     /* 103663 */ // Label 1917: @103663
     /* 103663 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103714), // Rule ID 285 //
     /* 103668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103671 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103693 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103712 */   GIR_RootConstrainSelectedInstOperands,
     /* 103713 */   // GIR_Coverage, 285,
     /* 103713 */   GIR_EraseRootFromParent_Done,
     /* 103714 */ // Label 1918: @103714
     /* 103714 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103768), // Rule ID 7054 //
     /* 103719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103729 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103747 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103766 */   GIR_RootConstrainSelectedInstOperands,
     /* 103767 */   // GIR_Coverage, 7054,
     /* 103767 */   GIR_EraseRootFromParent_Done,
     /* 103768 */ // Label 1919: @103768
     /* 103768 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103822), // Rule ID 7055 //
     /* 103773 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103776 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103783 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103801 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15868>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103820 */   GIR_RootConstrainSelectedInstOperands,
     /* 103821 */   // GIR_Coverage, 7055,
     /* 103821 */   GIR_EraseRootFromParent_Done,
     /* 103822 */ // Label 1920: @103822
     /* 103822 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103879), // Rule ID 7409 //
     /* 103827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 103830 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103858 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15839>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 103861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103877 */   GIR_RootConstrainSelectedInstOperands,
     /* 103878 */   // GIR_Coverage, 7409,
     /* 103878 */   GIR_EraseRootFromParent_Done,
     /* 103879 */ // Label 1921: @103879
     /* 103879 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103927), // Rule ID 4133 //
     /* 103884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103899 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103906 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103925 */   GIR_RootConstrainSelectedInstOperands,
     /* 103926 */   // GIR_Coverage, 4133,
     /* 103926 */   GIR_EraseRootFromParent_Done,
     /* 103927 */ // Label 1922: @103927
     /* 103927 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103975), // Rule ID 4134 //
     /* 103932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103954 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103973 */   GIR_RootConstrainSelectedInstOperands,
     /* 103974 */   // GIR_Coverage, 4134,
     /* 103974 */   GIR_EraseRootFromParent_Done,
     /* 103975 */ // Label 1923: @103975
     /* 103975 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(104062), // Rule ID 4150 //
     /* 103980 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103983 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104009 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104009 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104012 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 104016 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104031 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104061 */   // GIR_Coverage, 4150,
     /* 104061 */   GIR_EraseRootFromParent_Done,
     /* 104062 */ // Label 1924: @104062
     /* 104062 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(104149), // Rule ID 4151 //
     /* 104067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104070 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104074 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104085 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104089 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104096 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 104103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104118 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104148 */   // GIR_Coverage, 4151,
     /* 104148 */   GIR_EraseRootFromParent_Done,
     /* 104149 */ // Label 1925: @104149
     /* 104149 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(104236), // Rule ID 4152 //
     /* 104154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104183 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104205 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104235 */   // GIR_Coverage, 4152,
     /* 104235 */   GIR_EraseRootFromParent_Done,
     /* 104236 */ // Label 1926: @104236
     /* 104236 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(104323), // Rule ID 4153 //
     /* 104241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104270 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104292 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104322 */   // GIR_Coverage, 4153,
     /* 104322 */   GIR_EraseRootFromParent_Done,
     /* 104323 */ // Label 1927: @104323
     /* 104323 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(104371), // Rule ID 4161 //
     /* 104328 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104350 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104369 */   GIR_RootConstrainSelectedInstOperands,
     /* 104370 */   // GIR_Coverage, 4161,
     /* 104370 */   GIR_EraseRootFromParent_Done,
     /* 104371 */ // Label 1928: @104371
     /* 104371 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(104419), // Rule ID 4162 //
     /* 104376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104391 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104398 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104417 */   GIR_RootConstrainSelectedInstOperands,
     /* 104418 */   // GIR_Coverage, 4162,
     /* 104418 */   GIR_EraseRootFromParent_Done,
     /* 104419 */ // Label 1929: @104419
     /* 104419 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(104506), // Rule ID 4173 //
     /* 104424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104427 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104453 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 104460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104475 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104505 */   // GIR_Coverage, 4173,
     /* 104505 */   GIR_EraseRootFromParent_Done,
     /* 104506 */ // Label 1930: @104506
     /* 104506 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(104593), // Rule ID 4174 //
     /* 104511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104514 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104533 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104540 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 104547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104562 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104592 */   // GIR_Coverage, 4174,
     /* 104592 */   GIR_EraseRootFromParent_Done,
     /* 104593 */ // Label 1931: @104593
     /* 104593 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(104680), // Rule ID 4175 //
     /* 104598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104601 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104627 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104649 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104679 */   // GIR_Coverage, 4175,
     /* 104679 */   GIR_EraseRootFromParent_Done,
     /* 104680 */ // Label 1932: @104680
     /* 104680 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104767), // Rule ID 4176 //
     /* 104685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104688 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104714 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104736 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104756 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104766 */   // GIR_Coverage, 4176,
     /* 104766 */   GIR_EraseRootFromParent_Done,
     /* 104767 */ // Label 1933: @104767
     /* 104767 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104807), // Rule ID 7019 //
     /* 104772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104792 */   // MIs[0] ptr
     /* 104792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104800 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15839>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104805 */   GIR_RootConstrainSelectedInstOperands,
     /* 104806 */   // GIR_Coverage, 7019,
     /* 104806 */   GIR_Done,
     /* 104807 */ // Label 1934: @104807
     /* 104807 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104844), // Rule ID 7050 //
     /* 104812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104829 */   // MIs[0] ptr
     /* 104829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104837 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104842 */   GIR_RootConstrainSelectedInstOperands,
     /* 104843 */   // GIR_Coverage, 7050,
     /* 104843 */   GIR_Done,
     /* 104844 */ // Label 1935: @104844
     /* 104844 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104881), // Rule ID 7051 //
     /* 104849 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104866 */   // MIs[0] ptr
     /* 104866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104874 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15839>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104879 */   GIR_RootConstrainSelectedInstOperands,
     /* 104880 */   // GIR_Coverage, 7051,
     /* 104880 */   GIR_Done,
     /* 104881 */ // Label 1936: @104881
     /* 104881 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104912), // Rule ID 6397 //
     /* 104886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104897 */   // MIs[0] Rn
     /* 104897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104905 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104910 */   GIR_RootConstrainSelectedInstOperands,
     /* 104911 */   // GIR_Coverage, 6397,
     /* 104911 */   GIR_Done,
     /* 104912 */ // Label 1937: @104912
     /* 104912 */ GIM_Reject,
     /* 104913 */ // Label 1826: @104913
     /* 104913 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(105121),
     /* 104918 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104921 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104929 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104933 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104974), // Rule ID 245 //
     /* 104938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104948 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104972 */     GIR_RootConstrainSelectedInstOperands,
     /* 104973 */     // GIR_Coverage, 245,
     /* 104973 */     GIR_EraseRootFromParent_Done,
     /* 104974 */   // Label 1939: @104974
     /* 104974 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(105015), // Rule ID 246 //
     /* 104979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104989 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105013 */     GIR_RootConstrainSelectedInstOperands,
     /* 105014 */     // GIR_Coverage, 246,
     /* 105014 */     GIR_EraseRootFromParent_Done,
     /* 105015 */   // Label 1940: @105015
     /* 105015 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(105051), // Rule ID 265 //
     /* 105020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105030 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105049 */     GIR_RootConstrainSelectedInstOperands,
     /* 105050 */     // GIR_Coverage, 265,
     /* 105050 */     GIR_EraseRootFromParent_Done,
     /* 105051 */   // Label 1941: @105051
     /* 105051 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(105087), // Rule ID 286 //
     /* 105056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 105059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105066 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105085 */     GIR_RootConstrainSelectedInstOperands,
     /* 105086 */     // GIR_Coverage, 286,
     /* 105086 */     GIR_EraseRootFromParent_Done,
     /* 105087 */   // Label 1942: @105087
     /* 105087 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(105120), // Rule ID 4142 //
     /* 105092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105099 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105118 */     GIR_RootConstrainSelectedInstOperands,
     /* 105119 */     // GIR_Coverage, 4142,
     /* 105119 */     GIR_EraseRootFromParent_Done,
     /* 105120 */   // Label 1943: @105120
     /* 105120 */   GIM_Reject,
     /* 105121 */ // Label 1938: @105121
     /* 105121 */ GIM_Reject,
     /* 105122 */ // Label 1827: @105122
     /* 105122 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(105499),
     /* 105127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105138 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(105183), // Rule ID 4076 //
     /* 105143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105157 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105181 */     GIR_RootConstrainSelectedInstOperands,
     /* 105182 */     // GIR_Coverage, 4076,
     /* 105182 */     GIR_EraseRootFromParent_Done,
     /* 105183 */   // Label 1945: @105183
     /* 105183 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(105228), // Rule ID 4077 //
     /* 105188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105202 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105226 */     GIR_RootConstrainSelectedInstOperands,
     /* 105227 */     // GIR_Coverage, 4077,
     /* 105227 */     GIR_EraseRootFromParent_Done,
     /* 105228 */   // Label 1946: @105228
     /* 105228 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(105273), // Rule ID 4078 //
     /* 105233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105247 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105271 */     GIR_RootConstrainSelectedInstOperands,
     /* 105272 */     // GIR_Coverage, 4078,
     /* 105272 */     GIR_EraseRootFromParent_Done,
     /* 105273 */   // Label 1947: @105273
     /* 105273 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(105318), // Rule ID 4079 //
     /* 105278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105292 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105316 */     GIR_RootConstrainSelectedInstOperands,
     /* 105317 */     // GIR_Coverage, 4079,
     /* 105317 */     GIR_EraseRootFromParent_Done,
     /* 105318 */   // Label 1948: @105318
     /* 105318 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(105358), // Rule ID 4128 //
     /* 105323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105337 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105356 */     GIR_RootConstrainSelectedInstOperands,
     /* 105357 */     // GIR_Coverage, 4128,
     /* 105357 */     GIR_EraseRootFromParent_Done,
     /* 105358 */   // Label 1949: @105358
     /* 105358 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(105398), // Rule ID 4131 //
     /* 105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105377 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 105397 */     // GIR_Coverage, 4131,
     /* 105397 */     GIR_EraseRootFromParent_Done,
     /* 105398 */   // Label 1950: @105398
     /* 105398 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(105438), // Rule ID 4156 //
     /* 105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105417 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105436 */     GIR_RootConstrainSelectedInstOperands,
     /* 105437 */     // GIR_Coverage, 4156,
     /* 105437 */     GIR_EraseRootFromParent_Done,
     /* 105438 */   // Label 1951: @105438
     /* 105438 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(105478), // Rule ID 4157 //
     /* 105443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105457 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105476 */     GIR_RootConstrainSelectedInstOperands,
     /* 105477 */     // GIR_Coverage, 4157,
     /* 105477 */     GIR_EraseRootFromParent_Done,
     /* 105478 */   // Label 1952: @105478
     /* 105478 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(105498), // Rule ID 6396 //
     /* 105483 */     // MIs[0] Rn
     /* 105483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105491 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 105496 */     GIR_RootConstrainSelectedInstOperands,
     /* 105497 */     // GIR_Coverage, 6396,
     /* 105497 */     GIR_Done,
     /* 105498 */   // Label 1953: @105498
     /* 105498 */   GIM_Reject,
     /* 105499 */ // Label 1944: @105499
     /* 105499 */ GIM_Reject,
     /* 105500 */ // Label 1828: @105500
     /* 105500 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(105877),
     /* 105505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105516 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(105561), // Rule ID 4090 //
     /* 105521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105535 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105559 */     GIR_RootConstrainSelectedInstOperands,
     /* 105560 */     // GIR_Coverage, 4090,
     /* 105560 */     GIR_EraseRootFromParent_Done,
     /* 105561 */   // Label 1955: @105561
     /* 105561 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(105606), // Rule ID 4091 //
     /* 105566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105580 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105604 */     GIR_RootConstrainSelectedInstOperands,
     /* 105605 */     // GIR_Coverage, 4091,
     /* 105605 */     GIR_EraseRootFromParent_Done,
     /* 105606 */   // Label 1956: @105606
     /* 105606 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(105651), // Rule ID 4092 //
     /* 105611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105625 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105649 */     GIR_RootConstrainSelectedInstOperands,
     /* 105650 */     // GIR_Coverage, 4092,
     /* 105650 */     GIR_EraseRootFromParent_Done,
     /* 105651 */   // Label 1957: @105651
     /* 105651 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(105696), // Rule ID 4093 //
     /* 105656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105670 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105694 */     GIR_RootConstrainSelectedInstOperands,
     /* 105695 */     // GIR_Coverage, 4093,
     /* 105695 */     GIR_EraseRootFromParent_Done,
     /* 105696 */   // Label 1958: @105696
     /* 105696 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105736), // Rule ID 4136 //
     /* 105701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105715 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105734 */     GIR_RootConstrainSelectedInstOperands,
     /* 105735 */     // GIR_Coverage, 4136,
     /* 105735 */     GIR_EraseRootFromParent_Done,
     /* 105736 */   // Label 1959: @105736
     /* 105736 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105776), // Rule ID 4140 //
     /* 105741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105755 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105774 */     GIR_RootConstrainSelectedInstOperands,
     /* 105775 */     // GIR_Coverage, 4140,
     /* 105775 */     GIR_EraseRootFromParent_Done,
     /* 105776 */   // Label 1960: @105776
     /* 105776 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105816), // Rule ID 4163 //
     /* 105781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105795 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105814 */     GIR_RootConstrainSelectedInstOperands,
     /* 105815 */     // GIR_Coverage, 4163,
     /* 105815 */     GIR_EraseRootFromParent_Done,
     /* 105816 */   // Label 1961: @105816
     /* 105816 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105856), // Rule ID 4164 //
     /* 105821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105835 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105854 */     GIR_RootConstrainSelectedInstOperands,
     /* 105855 */     // GIR_Coverage, 4164,
     /* 105855 */     GIR_EraseRootFromParent_Done,
     /* 105856 */   // Label 1962: @105856
     /* 105856 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105876), // Rule ID 6393 //
     /* 105861 */     // MIs[0] Rn
     /* 105861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105869 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105874 */     GIR_RootConstrainSelectedInstOperands,
     /* 105875 */     // GIR_Coverage, 6393,
     /* 105875 */     GIR_Done,
     /* 105876 */   // Label 1963: @105876
     /* 105876 */   GIM_Reject,
     /* 105877 */ // Label 1954: @105877
     /* 105877 */ GIM_Reject,
     /* 105878 */ // Label 1829: @105878
     /* 105878 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(106255),
     /* 105883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105894 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105939), // Rule ID 4082 //
     /* 105899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105913 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105937 */     GIR_RootConstrainSelectedInstOperands,
     /* 105938 */     // GIR_Coverage, 4082,
     /* 105938 */     GIR_EraseRootFromParent_Done,
     /* 105939 */   // Label 1965: @105939
     /* 105939 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105984), // Rule ID 4083 //
     /* 105944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105958 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105982 */     GIR_RootConstrainSelectedInstOperands,
     /* 105983 */     // GIR_Coverage, 4083,
     /* 105983 */     GIR_EraseRootFromParent_Done,
     /* 105984 */   // Label 1966: @105984
     /* 105984 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(106029), // Rule ID 4084 //
     /* 105989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106003 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106027 */     GIR_RootConstrainSelectedInstOperands,
     /* 106028 */     // GIR_Coverage, 4084,
     /* 106028 */     GIR_EraseRootFromParent_Done,
     /* 106029 */   // Label 1967: @106029
     /* 106029 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(106074), // Rule ID 4085 //
     /* 106034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106048 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106072 */     GIR_RootConstrainSelectedInstOperands,
     /* 106073 */     // GIR_Coverage, 4085,
     /* 106073 */     GIR_EraseRootFromParent_Done,
     /* 106074 */   // Label 1968: @106074
     /* 106074 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(106114), // Rule ID 4130 //
     /* 106079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106093 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106112 */     GIR_RootConstrainSelectedInstOperands,
     /* 106113 */     // GIR_Coverage, 4130,
     /* 106113 */     GIR_EraseRootFromParent_Done,
     /* 106114 */   // Label 1969: @106114
     /* 106114 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(106154), // Rule ID 4132 //
     /* 106119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106133 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106152 */     GIR_RootConstrainSelectedInstOperands,
     /* 106153 */     // GIR_Coverage, 4132,
     /* 106153 */     GIR_EraseRootFromParent_Done,
     /* 106154 */   // Label 1970: @106154
     /* 106154 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(106194), // Rule ID 4158 //
     /* 106159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106173 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106192 */     GIR_RootConstrainSelectedInstOperands,
     /* 106193 */     // GIR_Coverage, 4158,
     /* 106193 */     GIR_EraseRootFromParent_Done,
     /* 106194 */   // Label 1971: @106194
     /* 106194 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(106234), // Rule ID 4160 //
     /* 106199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106213 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106232 */     GIR_RootConstrainSelectedInstOperands,
     /* 106233 */     // GIR_Coverage, 4160,
     /* 106233 */     GIR_EraseRootFromParent_Done,
     /* 106234 */   // Label 1972: @106234
     /* 106234 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(106254), // Rule ID 6395 //
     /* 106239 */     // MIs[0] Rn
     /* 106239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106247 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 106252 */     GIR_RootConstrainSelectedInstOperands,
     /* 106253 */     // GIR_Coverage, 6395,
     /* 106253 */     GIR_Done,
     /* 106254 */   // Label 1973: @106254
     /* 106254 */   GIM_Reject,
     /* 106255 */ // Label 1964: @106255
     /* 106255 */ GIM_Reject,
     /* 106256 */ // Label 1830: @106256
     /* 106256 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(106633),
     /* 106261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106272 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(106317), // Rule ID 4094 //
     /* 106277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106291 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106315 */     GIR_RootConstrainSelectedInstOperands,
     /* 106316 */     // GIR_Coverage, 4094,
     /* 106316 */     GIR_EraseRootFromParent_Done,
     /* 106317 */   // Label 1975: @106317
     /* 106317 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(106362), // Rule ID 4095 //
     /* 106322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106336 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106360 */     GIR_RootConstrainSelectedInstOperands,
     /* 106361 */     // GIR_Coverage, 4095,
     /* 106361 */     GIR_EraseRootFromParent_Done,
     /* 106362 */   // Label 1976: @106362
     /* 106362 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(106407), // Rule ID 4096 //
     /* 106367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106381 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106405 */     GIR_RootConstrainSelectedInstOperands,
     /* 106406 */     // GIR_Coverage, 4096,
     /* 106406 */     GIR_EraseRootFromParent_Done,
     /* 106407 */   // Label 1977: @106407
     /* 106407 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(106452), // Rule ID 4097 //
     /* 106412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106426 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106450 */     GIR_RootConstrainSelectedInstOperands,
     /* 106451 */     // GIR_Coverage, 4097,
     /* 106451 */     GIR_EraseRootFromParent_Done,
     /* 106452 */   // Label 1978: @106452
     /* 106452 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(106492), // Rule ID 4135 //
     /* 106457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106471 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106490 */     GIR_RootConstrainSelectedInstOperands,
     /* 106491 */     // GIR_Coverage, 4135,
     /* 106491 */     GIR_EraseRootFromParent_Done,
     /* 106492 */   // Label 1979: @106492
     /* 106492 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(106532), // Rule ID 4139 //
     /* 106497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106511 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106530 */     GIR_RootConstrainSelectedInstOperands,
     /* 106531 */     // GIR_Coverage, 4139,
     /* 106531 */     GIR_EraseRootFromParent_Done,
     /* 106532 */   // Label 1980: @106532
     /* 106532 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(106572), // Rule ID 4165 //
     /* 106537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106551 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106570 */     GIR_RootConstrainSelectedInstOperands,
     /* 106571 */     // GIR_Coverage, 4165,
     /* 106571 */     GIR_EraseRootFromParent_Done,
     /* 106572 */   // Label 1981: @106572
     /* 106572 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(106612), // Rule ID 4166 //
     /* 106577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106591 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106610 */     GIR_RootConstrainSelectedInstOperands,
     /* 106611 */     // GIR_Coverage, 4166,
     /* 106611 */     GIR_EraseRootFromParent_Done,
     /* 106612 */   // Label 1982: @106612
     /* 106612 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106632), // Rule ID 6392 //
     /* 106617 */     // MIs[0] Rn
     /* 106617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106625 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 106630 */     GIR_RootConstrainSelectedInstOperands,
     /* 106631 */     // GIR_Coverage, 6392,
     /* 106631 */     GIR_Done,
     /* 106632 */   // Label 1983: @106632
     /* 106632 */   GIM_Reject,
     /* 106633 */ // Label 1974: @106633
     /* 106633 */ GIM_Reject,
     /* 106634 */ // Label 1831: @106634
     /* 106634 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(106841),
     /* 106639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106650 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(106695), // Rule ID 4080 //
     /* 106655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106669 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106693 */     GIR_RootConstrainSelectedInstOperands,
     /* 106694 */     // GIR_Coverage, 4080,
     /* 106694 */     GIR_EraseRootFromParent_Done,
     /* 106695 */   // Label 1985: @106695
     /* 106695 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106740), // Rule ID 4081 //
     /* 106700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106714 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106738 */     GIR_RootConstrainSelectedInstOperands,
     /* 106739 */     // GIR_Coverage, 4081,
     /* 106739 */     GIR_EraseRootFromParent_Done,
     /* 106740 */   // Label 1986: @106740
     /* 106740 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106780), // Rule ID 4129 //
     /* 106745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106759 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106778 */     GIR_RootConstrainSelectedInstOperands,
     /* 106779 */     // GIR_Coverage, 4129,
     /* 106779 */     GIR_EraseRootFromParent_Done,
     /* 106780 */   // Label 1987: @106780
     /* 106780 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106820), // Rule ID 4159 //
     /* 106785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106799 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106818 */     GIR_RootConstrainSelectedInstOperands,
     /* 106819 */     // GIR_Coverage, 4159,
     /* 106819 */     GIR_EraseRootFromParent_Done,
     /* 106820 */   // Label 1988: @106820
     /* 106820 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106840), // Rule ID 6394 //
     /* 106825 */     // MIs[0] Rn
     /* 106825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106833 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106838 */     GIR_RootConstrainSelectedInstOperands,
     /* 106839 */     // GIR_Coverage, 6394,
     /* 106839 */     GIR_Done,
     /* 106840 */   // Label 1989: @106840
     /* 106840 */   GIM_Reject,
     /* 106841 */ // Label 1984: @106841
     /* 106841 */ GIM_Reject,
     /* 106842 */ // Label 1832: @106842
     /* 106842 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(107219),
     /* 106847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106858 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106903), // Rule ID 4098 //
     /* 106863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106877 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106901 */     GIR_RootConstrainSelectedInstOperands,
     /* 106902 */     // GIR_Coverage, 4098,
     /* 106902 */     GIR_EraseRootFromParent_Done,
     /* 106903 */   // Label 1991: @106903
     /* 106903 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(106948), // Rule ID 4099 //
     /* 106908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106922 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106946 */     GIR_RootConstrainSelectedInstOperands,
     /* 106947 */     // GIR_Coverage, 4099,
     /* 106947 */     GIR_EraseRootFromParent_Done,
     /* 106948 */   // Label 1992: @106948
     /* 106948 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(106993), // Rule ID 4100 //
     /* 106953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106967 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106991 */     GIR_RootConstrainSelectedInstOperands,
     /* 106992 */     // GIR_Coverage, 4100,
     /* 106992 */     GIR_EraseRootFromParent_Done,
     /* 106993 */   // Label 1993: @106993
     /* 106993 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(107038), // Rule ID 4101 //
     /* 106998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107012 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107036 */     GIR_RootConstrainSelectedInstOperands,
     /* 107037 */     // GIR_Coverage, 4101,
     /* 107037 */     GIR_EraseRootFromParent_Done,
     /* 107038 */   // Label 1994: @107038
     /* 107038 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(107078), // Rule ID 4138 //
     /* 107043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107057 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107076 */     GIR_RootConstrainSelectedInstOperands,
     /* 107077 */     // GIR_Coverage, 4138,
     /* 107077 */     GIR_EraseRootFromParent_Done,
     /* 107078 */   // Label 1995: @107078
     /* 107078 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(107118), // Rule ID 4141 //
     /* 107083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107097 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107116 */     GIR_RootConstrainSelectedInstOperands,
     /* 107117 */     // GIR_Coverage, 4141,
     /* 107117 */     GIR_EraseRootFromParent_Done,
     /* 107118 */   // Label 1996: @107118
     /* 107118 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(107158), // Rule ID 4167 //
     /* 107123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107137 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107156 */     GIR_RootConstrainSelectedInstOperands,
     /* 107157 */     // GIR_Coverage, 4167,
     /* 107157 */     GIR_EraseRootFromParent_Done,
     /* 107158 */   // Label 1997: @107158
     /* 107158 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(107198), // Rule ID 4169 //
     /* 107163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107177 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107196 */     GIR_RootConstrainSelectedInstOperands,
     /* 107197 */     // GIR_Coverage, 4169,
     /* 107197 */     GIR_EraseRootFromParent_Done,
     /* 107198 */   // Label 1998: @107198
     /* 107198 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(107218), // Rule ID 6391 //
     /* 107203 */     // MIs[0] Rn
     /* 107203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107211 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 107216 */     GIR_RootConstrainSelectedInstOperands,
     /* 107217 */     // GIR_Coverage, 6391,
     /* 107217 */     GIR_Done,
     /* 107218 */   // Label 1999: @107218
     /* 107218 */   GIM_Reject,
     /* 107219 */ // Label 1990: @107219
     /* 107219 */ GIM_Reject,
     /* 107220 */ // Label 1833: @107220
     /* 107220 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(107427),
     /* 107225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107236 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(107281), // Rule ID 4102 //
     /* 107241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 107255 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 107255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 107258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107279 */     GIR_RootConstrainSelectedInstOperands,
     /* 107280 */     // GIR_Coverage, 4102,
     /* 107280 */     GIR_EraseRootFromParent_Done,
     /* 107281 */   // Label 2001: @107281
     /* 107281 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(107326), // Rule ID 4103 //
     /* 107286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107300 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107324 */     GIR_RootConstrainSelectedInstOperands,
     /* 107325 */     // GIR_Coverage, 4103,
     /* 107325 */     GIR_EraseRootFromParent_Done,
     /* 107326 */   // Label 2002: @107326
     /* 107326 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(107366), // Rule ID 4137 //
     /* 107331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107345 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107364 */     GIR_RootConstrainSelectedInstOperands,
     /* 107365 */     // GIR_Coverage, 4137,
     /* 107365 */     GIR_EraseRootFromParent_Done,
     /* 107366 */   // Label 2003: @107366
     /* 107366 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(107406), // Rule ID 4168 //
     /* 107371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107385 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107404 */     GIR_RootConstrainSelectedInstOperands,
     /* 107405 */     // GIR_Coverage, 4168,
     /* 107405 */     GIR_EraseRootFromParent_Done,
     /* 107406 */   // Label 2004: @107406
     /* 107406 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(107426), // Rule ID 6390 //
     /* 107411 */     // MIs[0] Rn
     /* 107411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107419 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 107424 */     GIR_RootConstrainSelectedInstOperands,
     /* 107425 */     // GIR_Coverage, 6390,
     /* 107425 */     GIR_Done,
     /* 107426 */   // Label 2005: @107426
     /* 107426 */   GIM_Reject,
     /* 107427 */ // Label 2000: @107427
     /* 107427 */ GIM_Reject,
     /* 107428 */ // Label 1834: @107428
     /* 107428 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(107491), // Rule ID 10934 //
     /* 107433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107447 */   // MIs[0] base
     /* 107447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107455 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107467 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 107475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107489 */   GIR_RootConstrainSelectedInstOperands,
     /* 107490 */   // GIR_Coverage, 10934,
     /* 107490 */   GIR_EraseRootFromParent_Done,
     /* 107491 */ // Label 2006: @107491
     /* 107491 */ GIM_Reject,
     /* 107492 */ // Label 1835: @107492
     /* 107492 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(107555), // Rule ID 10940 //
     /* 107497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107511 */   // MIs[0] base
     /* 107511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107519 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107531 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 107539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107544 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107553 */   GIR_RootConstrainSelectedInstOperands,
     /* 107554 */   // GIR_Coverage, 10940,
     /* 107554 */   GIR_EraseRootFromParent_Done,
     /* 107555 */ // Label 2007: @107555
     /* 107555 */ GIM_Reject,
     /* 107556 */ // Label 1836: @107556
     /* 107556 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(107729),
     /* 107561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107576 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(107624), // Rule ID 10925 //
     /* 107581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107588 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107613 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107622 */     GIR_RootConstrainSelectedInstOperands,
     /* 107623 */     // GIR_Coverage, 10925,
     /* 107623 */     GIR_EraseRootFromParent_Done,
     /* 107624 */   // Label 2009: @107624
     /* 107624 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107672), // Rule ID 10943 //
     /* 107629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107636 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107661 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107670 */     GIR_RootConstrainSelectedInstOperands,
     /* 107671 */     // GIR_Coverage, 10943,
     /* 107671 */     GIR_EraseRootFromParent_Done,
     /* 107672 */   // Label 2010: @107672
     /* 107672 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(107700), // Rule ID 10970 //
     /* 107677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107684 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107689 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107698 */     GIR_RootConstrainSelectedInstOperands,
     /* 107699 */     // GIR_Coverage, 10970,
     /* 107699 */     GIR_EraseRootFromParent_Done,
     /* 107700 */   // Label 2011: @107700
     /* 107700 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107728), // Rule ID 10982 //
     /* 107705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107712 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107717 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107726 */     GIR_RootConstrainSelectedInstOperands,
     /* 107727 */     // GIR_Coverage, 10982,
     /* 107727 */     GIR_EraseRootFromParent_Done,
     /* 107728 */   // Label 2012: @107728
     /* 107728 */   GIM_Reject,
     /* 107729 */ // Label 2008: @107729
     /* 107729 */ GIM_Reject,
     /* 107730 */ // Label 1837: @107730
     /* 107730 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107793), // Rule ID 10931 //
     /* 107735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107741 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107749 */   // MIs[0] base
     /* 107749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107757 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107769 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107782 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107791 */   GIR_RootConstrainSelectedInstOperands,
     /* 107792 */   // GIR_Coverage, 10931,
     /* 107792 */   GIR_EraseRootFromParent_Done,
     /* 107793 */ // Label 2013: @107793
     /* 107793 */ GIM_Reject,
     /* 107794 */ // Label 1838: @107794
     /* 107794 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107967),
     /* 107799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107802 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107814 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107862), // Rule ID 10913 //
     /* 107819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107826 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107851 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107860 */     GIR_RootConstrainSelectedInstOperands,
     /* 107861 */     // GIR_Coverage, 10913,
     /* 107861 */     GIR_EraseRootFromParent_Done,
     /* 107862 */   // Label 2015: @107862
     /* 107862 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107910), // Rule ID 10937 //
     /* 107867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107874 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107899 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107908 */     GIR_RootConstrainSelectedInstOperands,
     /* 107909 */     // GIR_Coverage, 10937,
     /* 107909 */     GIR_EraseRootFromParent_Done,
     /* 107910 */   // Label 2016: @107910
     /* 107910 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107938), // Rule ID 10966 //
     /* 107915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107922 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107927 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107936 */     GIR_RootConstrainSelectedInstOperands,
     /* 107937 */     // GIR_Coverage, 10966,
     /* 107937 */     GIR_EraseRootFromParent_Done,
     /* 107938 */   // Label 2017: @107938
     /* 107938 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107966), // Rule ID 10978 //
     /* 107943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107950 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107955 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107964 */     GIR_RootConstrainSelectedInstOperands,
     /* 107965 */     // GIR_Coverage, 10978,
     /* 107965 */     GIR_EraseRootFromParent_Done,
     /* 107966 */   // Label 2018: @107966
     /* 107966 */   GIM_Reject,
     /* 107967 */ // Label 2014: @107967
     /* 107967 */ GIM_Reject,
     /* 107968 */ // Label 1839: @107968
     /* 107968 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(108141),
     /* 107973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107988 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(108036), // Rule ID 10892 //
     /* 107993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108000 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108025 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108034 */     GIR_RootConstrainSelectedInstOperands,
     /* 108035 */     // GIR_Coverage, 10892,
     /* 108035 */     GIR_EraseRootFromParent_Done,
     /* 108036 */   // Label 2020: @108036
     /* 108036 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(108084), // Rule ID 10928 //
     /* 108041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108048 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 108055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 108068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108073 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108082 */     GIR_RootConstrainSelectedInstOperands,
     /* 108083 */     // GIR_Coverage, 10928,
     /* 108083 */     GIR_EraseRootFromParent_Done,
     /* 108084 */   // Label 2021: @108084
     /* 108084 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(108112), // Rule ID 10962 //
     /* 108089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108096 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108101 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108110 */     GIR_RootConstrainSelectedInstOperands,
     /* 108111 */     // GIR_Coverage, 10962,
     /* 108111 */     GIR_EraseRootFromParent_Done,
     /* 108112 */   // Label 2022: @108112
     /* 108112 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108140), // Rule ID 10974 //
     /* 108117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108124 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108129 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108138 */     GIR_RootConstrainSelectedInstOperands,
     /* 108139 */     // GIR_Coverage, 10974,
     /* 108139 */     GIR_EraseRootFromParent_Done,
     /* 108140 */   // Label 2023: @108140
     /* 108140 */   GIM_Reject,
     /* 108141 */ // Label 2019: @108141
     /* 108141 */ GIM_Reject,
     /* 108142 */ // Label 1840: @108142
     /* 108142 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(108185), // Rule ID 2428 //
     /* 108147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108153 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 108161 */   // MIs[0] base
     /* 108161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108169 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 108172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 108174 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108183 */   GIR_RootConstrainSelectedInstOperands,
     /* 108184 */   // GIR_Coverage, 2428,
     /* 108184 */   GIR_EraseRootFromParent_Done,
     /* 108185 */ // Label 2024: @108185
     /* 108185 */ GIM_Reject,
     /* 108186 */ // Label 1841: @108186
     /* 108186 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108283),
     /* 108191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108194 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 108202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108206 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108254), // Rule ID 10860 //
     /* 108211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 108214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108218 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 108221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 108225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 108233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 108238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108243 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108252 */     GIR_RootConstrainSelectedInstOperands,
     /* 108253 */     // GIR_Coverage, 10860,
     /* 108253 */     GIR_EraseRootFromParent_Done,
     /* 108254 */   // Label 2026: @108254
     /* 108254 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108282), // Rule ID 10958 //
     /* 108259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108266 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108271 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108280 */     GIR_RootConstrainSelectedInstOperands,
     /* 108281 */     // GIR_Coverage, 10958,
     /* 108281 */     GIR_EraseRootFromParent_Done,
     /* 108282 */   // Label 2027: @108282
     /* 108282 */   GIM_Reject,
     /* 108283 */ // Label 2025: @108283
     /* 108283 */ GIM_Reject,
     /* 108284 */ // Label 1842: @108284
     /* 108284 */ GIM_Reject,
     /* 108285 */ // Label 17: @108285
     /* 108285 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2030*/ GIMT_Encode4(109334),
     /* 108296 */ /*GILLT_s32*//*Label 2028*/ GIMT_Encode4(108304),
     /* 108300 */ /*GILLT_s64*//*Label 2029*/ GIMT_Encode4(108718),
     /* 108304 */ // Label 2028: @108304
     /* 108304 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(108717),
     /* 108309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108312 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108365), // Rule ID 247 //
     /* 108317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108339 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 108342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108363 */     GIR_RootConstrainSelectedInstOperands,
     /* 108364 */     // GIR_Coverage, 247,
     /* 108364 */     GIR_EraseRootFromParent_Done,
     /* 108365 */   // Label 2032: @108365
     /* 108365 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(108418), // Rule ID 248 //
     /* 108370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108392 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 108395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108416 */     GIR_RootConstrainSelectedInstOperands,
     /* 108417 */     // GIR_Coverage, 248,
     /* 108417 */     GIR_EraseRootFromParent_Done,
     /* 108418 */   // Label 2033: @108418
     /* 108418 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108471), // Rule ID 251 //
     /* 108423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108445 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 108448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108469 */     GIR_RootConstrainSelectedInstOperands,
     /* 108470 */     // GIR_Coverage, 251,
     /* 108470 */     GIR_EraseRootFromParent_Done,
     /* 108471 */   // Label 2034: @108471
     /* 108471 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108524), // Rule ID 252 //
     /* 108476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108498 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 108501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108522 */     GIR_RootConstrainSelectedInstOperands,
     /* 108523 */     // GIR_Coverage, 252,
     /* 108523 */     GIR_EraseRootFromParent_Done,
     /* 108524 */   // Label 2035: @108524
     /* 108524 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108572), // Rule ID 268 //
     /* 108529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108551 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 108554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108570 */     GIR_RootConstrainSelectedInstOperands,
     /* 108571 */     // GIR_Coverage, 268,
     /* 108571 */     GIR_EraseRootFromParent_Done,
     /* 108572 */   // Label 2036: @108572
     /* 108572 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108620), // Rule ID 270 //
     /* 108577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108599 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 108602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108618 */     GIR_RootConstrainSelectedInstOperands,
     /* 108619 */     // GIR_Coverage, 270,
     /* 108619 */     GIR_EraseRootFromParent_Done,
     /* 108620 */   // Label 2037: @108620
     /* 108620 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108668), // Rule ID 289 //
     /* 108625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108647 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 108650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108666 */     GIR_RootConstrainSelectedInstOperands,
     /* 108667 */     // GIR_Coverage, 289,
     /* 108667 */     GIR_EraseRootFromParent_Done,
     /* 108668 */   // Label 2038: @108668
     /* 108668 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108716), // Rule ID 291 //
     /* 108673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108695 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 108698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108714 */     GIR_RootConstrainSelectedInstOperands,
     /* 108715 */     // GIR_Coverage, 291,
     /* 108715 */     GIR_EraseRootFromParent_Done,
     /* 108716 */   // Label 2039: @108716
     /* 108716 */   GIM_Reject,
     /* 108717 */ // Label 2031: @108717
     /* 108717 */ GIM_Reject,
     /* 108718 */ // Label 2029: @108718
     /* 108718 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(109333),
     /* 108723 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108726 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108779), // Rule ID 249 //
     /* 108731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108753 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 108756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108777 */     GIR_RootConstrainSelectedInstOperands,
     /* 108778 */     // GIR_Coverage, 249,
     /* 108778 */     GIR_EraseRootFromParent_Done,
     /* 108779 */   // Label 2041: @108779
     /* 108779 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(108832), // Rule ID 250 //
     /* 108784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108806 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108830 */     GIR_RootConstrainSelectedInstOperands,
     /* 108831 */     // GIR_Coverage, 250,
     /* 108831 */     GIR_EraseRootFromParent_Done,
     /* 108832 */   // Label 2042: @108832
     /* 108832 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108885), // Rule ID 253 //
     /* 108837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108859 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108883 */     GIR_RootConstrainSelectedInstOperands,
     /* 108884 */     // GIR_Coverage, 253,
     /* 108884 */     GIR_EraseRootFromParent_Done,
     /* 108885 */   // Label 2043: @108885
     /* 108885 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108938), // Rule ID 254 //
     /* 108890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108912 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 108915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108936 */     GIR_RootConstrainSelectedInstOperands,
     /* 108937 */     // GIR_Coverage, 254,
     /* 108937 */     GIR_EraseRootFromParent_Done,
     /* 108938 */   // Label 2044: @108938
     /* 108938 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108991), // Rule ID 255 //
     /* 108943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 108965 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 108965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 108968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108989 */     GIR_RootConstrainSelectedInstOperands,
     /* 108990 */     // GIR_Coverage, 255,
     /* 108990 */     GIR_EraseRootFromParent_Done,
     /* 108991 */   // Label 2045: @108991
     /* 108991 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109044), // Rule ID 256 //
     /* 108996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109018 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 109021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109042 */     GIR_RootConstrainSelectedInstOperands,
     /* 109043 */     // GIR_Coverage, 256,
     /* 109043 */     GIR_EraseRootFromParent_Done,
     /* 109044 */   // Label 2046: @109044
     /* 109044 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109092), // Rule ID 269 //
     /* 109049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109071 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 109074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109090 */     GIR_RootConstrainSelectedInstOperands,
     /* 109091 */     // GIR_Coverage, 269,
     /* 109091 */     GIR_EraseRootFromParent_Done,
     /* 109092 */   // Label 2047: @109092
     /* 109092 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109140), // Rule ID 271 //
     /* 109097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109119 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 109122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109138 */     GIR_RootConstrainSelectedInstOperands,
     /* 109139 */     // GIR_Coverage, 271,
     /* 109139 */     GIR_EraseRootFromParent_Done,
     /* 109140 */   // Label 2048: @109140
     /* 109140 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109188), // Rule ID 272 //
     /* 109145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 109167 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 109167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 109170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109186 */     GIR_RootConstrainSelectedInstOperands,
     /* 109187 */     // GIR_Coverage, 272,
     /* 109187 */     GIR_EraseRootFromParent_Done,
     /* 109188 */   // Label 2049: @109188
     /* 109188 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109236), // Rule ID 290 //
     /* 109193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109215 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 109218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109234 */     GIR_RootConstrainSelectedInstOperands,
     /* 109235 */     // GIR_Coverage, 290,
     /* 109235 */     GIR_EraseRootFromParent_Done,
     /* 109236 */   // Label 2050: @109236
     /* 109236 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109284), // Rule ID 292 //
     /* 109241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109263 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 109266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109282 */     GIR_RootConstrainSelectedInstOperands,
     /* 109283 */     // GIR_Coverage, 292,
     /* 109283 */     GIR_EraseRootFromParent_Done,
     /* 109284 */   // Label 2051: @109284
     /* 109284 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109332), // Rule ID 293 //
     /* 109289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 109311 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 109314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109330 */     GIR_RootConstrainSelectedInstOperands,
     /* 109331 */     // GIR_Coverage, 293,
     /* 109331 */     GIR_EraseRootFromParent_Done,
     /* 109332 */   // Label 2052: @109332
     /* 109332 */   GIM_Reject,
     /* 109333 */ // Label 2040: @109333
     /* 109333 */ GIM_Reject,
     /* 109334 */ // Label 2030: @109334
     /* 109334 */ GIM_Reject,
     /* 109335 */ // Label 18: @109335
     /* 109335 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2055*/ GIMT_Encode4(112383),
     /* 109346 */ /*GILLT_s32*//*Label 2053*/ GIMT_Encode4(109354),
     /* 109350 */ /*GILLT_s64*//*Label 2054*/ GIMT_Encode4(110893),
     /* 109354 */ // Label 2053: @109354
     /* 109354 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109410), // Rule ID 229 //
     /* 109359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109384 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109408 */   GIR_RootConstrainSelectedInstOperands,
     /* 109409 */   // GIR_Coverage, 229,
     /* 109409 */   GIR_EraseRootFromParent_Done,
     /* 109410 */ // Label 2056: @109410
     /* 109410 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109466), // Rule ID 230 //
     /* 109415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109440 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109464 */   GIR_RootConstrainSelectedInstOperands,
     /* 109465 */   // GIR_Coverage, 230,
     /* 109465 */   GIR_EraseRootFromParent_Done,
     /* 109466 */ // Label 2057: @109466
     /* 109466 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109522), // Rule ID 231 //
     /* 109471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109496 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109520 */   GIR_RootConstrainSelectedInstOperands,
     /* 109521 */   // GIR_Coverage, 231,
     /* 109521 */   GIR_EraseRootFromParent_Done,
     /* 109522 */ // Label 2058: @109522
     /* 109522 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109578), // Rule ID 232 //
     /* 109527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109552 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109576 */   GIR_RootConstrainSelectedInstOperands,
     /* 109577 */   // GIR_Coverage, 232,
     /* 109577 */   GIR_EraseRootFromParent_Done,
     /* 109578 */ // Label 2059: @109578
     /* 109578 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109634), // Rule ID 4126 //
     /* 109583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109608 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109632 */   GIR_RootConstrainSelectedInstOperands,
     /* 109633 */   // GIR_Coverage, 4126,
     /* 109633 */   GIR_EraseRootFromParent_Done,
     /* 109634 */ // Label 2060: @109634
     /* 109634 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109690), // Rule ID 4127 //
     /* 109639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109664 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109688 */   GIR_RootConstrainSelectedInstOperands,
     /* 109689 */   // GIR_Coverage, 4127,
     /* 109689 */   GIR_EraseRootFromParent_Done,
     /* 109690 */ // Label 2061: @109690
     /* 109690 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109741), // Rule ID 266 //
     /* 109695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109720 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109739 */   GIR_RootConstrainSelectedInstOperands,
     /* 109740 */   // GIR_Coverage, 266,
     /* 109740 */   GIR_EraseRootFromParent_Done,
     /* 109741 */ // Label 2062: @109741
     /* 109741 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109792), // Rule ID 267 //
     /* 109746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109771 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109790 */   GIR_RootConstrainSelectedInstOperands,
     /* 109791 */   // GIR_Coverage, 267,
     /* 109791 */   GIR_EraseRootFromParent_Done,
     /* 109792 */ // Label 2063: @109792
     /* 109792 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109851), // Rule ID 7025 //
     /* 109797 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109807 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109825 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109849 */   GIR_RootConstrainSelectedInstOperands,
     /* 109850 */   // GIR_Coverage, 7025,
     /* 109850 */   GIR_EraseRootFromParent_Done,
     /* 109851 */ // Label 2064: @109851
     /* 109851 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109910), // Rule ID 7027 //
     /* 109856 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109866 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109884 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109908 */   GIR_RootConstrainSelectedInstOperands,
     /* 109909 */   // GIR_Coverage, 7027,
     /* 109909 */   GIR_EraseRootFromParent_Done,
     /* 109910 */ // Label 2065: @109910
     /* 109910 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109969), // Rule ID 7037 //
     /* 109915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109925 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109943 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109967 */   GIR_RootConstrainSelectedInstOperands,
     /* 109968 */   // GIR_Coverage, 7037,
     /* 109968 */   GIR_EraseRootFromParent_Done,
     /* 109969 */ // Label 2066: @109969
     /* 109969 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110028), // Rule ID 7039 //
     /* 109974 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109984 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110002 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 110002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110026 */   GIR_RootConstrainSelectedInstOperands,
     /* 110027 */   // GIR_Coverage, 7039,
     /* 110027 */   GIR_EraseRootFromParent_Done,
     /* 110028 */ // Label 2067: @110028
     /* 110028 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110079), // Rule ID 287 //
     /* 110033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110036 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110051 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110058 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110077 */   GIR_RootConstrainSelectedInstOperands,
     /* 110078 */   // GIR_Coverage, 287,
     /* 110078 */   GIR_EraseRootFromParent_Done,
     /* 110079 */ // Label 2068: @110079
     /* 110079 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110130), // Rule ID 288 //
     /* 110084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110087 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110109 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 110109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110128 */   GIR_RootConstrainSelectedInstOperands,
     /* 110129 */   // GIR_Coverage, 288,
     /* 110129 */   GIR_EraseRootFromParent_Done,
     /* 110130 */ // Label 2069: @110130
     /* 110130 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110181), // Rule ID 4145 //
     /* 110135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110138 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110160 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110179 */   GIR_RootConstrainSelectedInstOperands,
     /* 110180 */   // GIR_Coverage, 4145,
     /* 110180 */   GIR_EraseRootFromParent_Done,
     /* 110181 */ // Label 2070: @110181
     /* 110181 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110232), // Rule ID 4177 //
     /* 110186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110211 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110230 */   GIR_RootConstrainSelectedInstOperands,
     /* 110231 */   // GIR_Coverage, 4177,
     /* 110231 */   GIR_EraseRootFromParent_Done,
     /* 110232 */ // Label 2071: @110232
     /* 110232 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110283), // Rule ID 4178 //
     /* 110237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110262 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110281 */   GIR_RootConstrainSelectedInstOperands,
     /* 110282 */   // GIR_Coverage, 4178,
     /* 110282 */   GIR_EraseRootFromParent_Done,
     /* 110283 */ // Label 2072: @110283
     /* 110283 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110334), // Rule ID 4179 //
     /* 110288 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110313 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110332 */   GIR_RootConstrainSelectedInstOperands,
     /* 110333 */   // GIR_Coverage, 4179,
     /* 110333 */   GIR_EraseRootFromParent_Done,
     /* 110334 */ // Label 2073: @110334
     /* 110334 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110388), // Rule ID 7029 //
     /* 110339 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110349 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110367 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15844>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110386 */   GIR_RootConstrainSelectedInstOperands,
     /* 110387 */   // GIR_Coverage, 7029,
     /* 110387 */   GIR_EraseRootFromParent_Done,
     /* 110388 */ // Label 2074: @110388
     /* 110388 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110442), // Rule ID 7031 //
     /* 110393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110403 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110421 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15844>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110440 */   GIR_RootConstrainSelectedInstOperands,
     /* 110441 */   // GIR_Coverage, 7031,
     /* 110441 */   GIR_EraseRootFromParent_Done,
     /* 110442 */ // Label 2075: @110442
     /* 110442 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110496), // Rule ID 7041 //
     /* 110447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110457 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110464 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110468 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110475 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15852>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110494 */   GIR_RootConstrainSelectedInstOperands,
     /* 110495 */   // GIR_Coverage, 7041,
     /* 110495 */   GIR_EraseRootFromParent_Done,
     /* 110496 */ // Label 2076: @110496
     /* 110496 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110550), // Rule ID 7043 //
     /* 110501 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110511 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110529 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15852>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110548 */   GIR_RootConstrainSelectedInstOperands,
     /* 110549 */   // GIR_Coverage, 7043,
     /* 110549 */   GIR_EraseRootFromParent_Done,
     /* 110550 */ // Label 2077: @110550
     /* 110550 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110607), // Rule ID 7405 //
     /* 110555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110558 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110575 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110586 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15833>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 110589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110605 */   GIR_RootConstrainSelectedInstOperands,
     /* 110606 */   // GIR_Coverage, 7405,
     /* 110606 */   GIR_EraseRootFromParent_Done,
     /* 110607 */ // Label 2078: @110607
     /* 110607 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110664), // Rule ID 7407 //
     /* 110612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110615 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110643 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15835>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 110646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110662 */   GIR_RootConstrainSelectedInstOperands,
     /* 110663 */   // GIR_Coverage, 7407,
     /* 110663 */   GIR_EraseRootFromParent_Done,
     /* 110664 */ // Label 2079: @110664
     /* 110664 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110704), // Rule ID 7015 //
     /* 110669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110672 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110675 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110689 */   // MIs[0] ptr
     /* 110689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110697 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15833>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 110702 */   GIR_RootConstrainSelectedInstOperands,
     /* 110703 */   // GIR_Coverage, 7015,
     /* 110703 */   GIR_Done,
     /* 110704 */ // Label 2080: @110704
     /* 110704 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110744), // Rule ID 7017 //
     /* 110709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 110712 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110715 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110729 */   // MIs[0] ptr
     /* 110729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110737 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15835>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 110742 */   GIR_RootConstrainSelectedInstOperands,
     /* 110743 */   // GIR_Coverage, 7017,
     /* 110743 */   GIR_Done,
     /* 110744 */ // Label 2081: @110744
     /* 110744 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110781), // Rule ID 7021 //
     /* 110749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110766 */   // MIs[0] ptr
     /* 110766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110774 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15841>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110779 */   GIR_RootConstrainSelectedInstOperands,
     /* 110780 */   // GIR_Coverage, 7021,
     /* 110780 */   GIR_Done,
     /* 110781 */ // Label 2082: @110781
     /* 110781 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110818), // Rule ID 7023 //
     /* 110786 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110803 */   // MIs[0] ptr
     /* 110803 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110811 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15833>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110816 */   GIR_RootConstrainSelectedInstOperands,
     /* 110817 */   // GIR_Coverage, 7023,
     /* 110817 */   GIR_Done,
     /* 110818 */ // Label 2083: @110818
     /* 110818 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110855), // Rule ID 7033 //
     /* 110823 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110826 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110840 */   // MIs[0] ptr
     /* 110840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110848 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15849>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110853 */   GIR_RootConstrainSelectedInstOperands,
     /* 110854 */   // GIR_Coverage, 7033,
     /* 110854 */   GIR_Done,
     /* 110855 */ // Label 2084: @110855
     /* 110855 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110892), // Rule ID 7035 //
     /* 110860 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110877 */   // MIs[0] ptr
     /* 110877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110885 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15835>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110890 */   GIR_RootConstrainSelectedInstOperands,
     /* 110891 */   // GIR_Coverage, 7035,
     /* 110891 */   GIR_Done,
     /* 110892 */ // Label 2085: @110892
     /* 110892 */ GIM_Reject,
     /* 110893 */ // Label 2054: @110893
     /* 110893 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(112382),
     /* 110898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110901 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110986), // Rule ID 4104 //
     /* 110906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110928 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110985 */     // GIR_Coverage, 4104,
     /* 110985 */     GIR_EraseRootFromParent_Done,
     /* 110986 */   // Label 2087: @110986
     /* 110986 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(111071), // Rule ID 4105 //
     /* 110991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111013 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111070 */     // GIR_Coverage, 4105,
     /* 111070 */     GIR_EraseRootFromParent_Done,
     /* 111071 */   // Label 2088: @111071
     /* 111071 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(111156), // Rule ID 4106 //
     /* 111076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111098 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 111105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111155 */     // GIR_Coverage, 4106,
     /* 111155 */     GIR_EraseRootFromParent_Done,
     /* 111156 */   // Label 2089: @111156
     /* 111156 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(111241), // Rule ID 4107 //
     /* 111161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111183 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 111190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111210 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111240 */     // GIR_Coverage, 4107,
     /* 111240 */     GIR_EraseRootFromParent_Done,
     /* 111241 */   // Label 2090: @111241
     /* 111241 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(111326), // Rule ID 4108 //
     /* 111246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 111268 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 111275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111325 */     // GIR_Coverage, 4108,
     /* 111325 */     GIR_EraseRootFromParent_Done,
     /* 111326 */   // Label 2091: @111326
     /* 111326 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111411), // Rule ID 4109 //
     /* 111331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 111353 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 111360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111380 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111410 */     // GIR_Coverage, 4109,
     /* 111410 */     GIR_EraseRootFromParent_Done,
     /* 111411 */   // Label 2092: @111411
     /* 111411 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111496), // Rule ID 4110 //
     /* 111416 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111438 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111465 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111495 */     // GIR_Coverage, 4110,
     /* 111495 */     GIR_EraseRootFromParent_Done,
     /* 111496 */   // Label 2093: @111496
     /* 111496 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111581), // Rule ID 4111 //
     /* 111501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111523 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111550 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111580 */     // GIR_Coverage, 4111,
     /* 111580 */     GIR_EraseRootFromParent_Done,
     /* 111581 */   // Label 2094: @111581
     /* 111581 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111661), // Rule ID 4143 //
     /* 111586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111608 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111630 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111660 */     // GIR_Coverage, 4143,
     /* 111660 */     GIR_EraseRootFromParent_Done,
     /* 111661 */   // Label 2095: @111661
     /* 111661 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111741), // Rule ID 4144 //
     /* 111666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111688 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 111695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111740 */     // GIR_Coverage, 4144,
     /* 111740 */     GIR_EraseRootFromParent_Done,
     /* 111741 */   // Label 2096: @111741
     /* 111741 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111821), // Rule ID 4146 //
     /* 111746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111768 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111790 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111820 */     // GIR_Coverage, 4146,
     /* 111820 */     GIR_EraseRootFromParent_Done,
     /* 111821 */   // Label 2097: @111821
     /* 111821 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111901), // Rule ID 4154 //
     /* 111826 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111848 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111900 */     // GIR_Coverage, 4154,
     /* 111900 */     GIR_EraseRootFromParent_Done,
     /* 111901 */   // Label 2098: @111901
     /* 111901 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111981), // Rule ID 4180 //
     /* 111906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 111928 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 111935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111980 */     // GIR_Coverage, 4180,
     /* 111980 */     GIR_EraseRootFromParent_Done,
     /* 111981 */   // Label 2099: @111981
     /* 111981 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(112061), // Rule ID 4181 //
     /* 111986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112008 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112030 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112060 */     // GIR_Coverage, 4181,
     /* 112060 */     GIR_EraseRootFromParent_Done,
     /* 112061 */   // Label 2100: @112061
     /* 112061 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(112141), // Rule ID 4182 //
     /* 112066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112088 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112140 */     // GIR_Coverage, 4182,
     /* 112140 */     GIR_EraseRootFromParent_Done,
     /* 112141 */   // Label 2101: @112141
     /* 112141 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(112221), // Rule ID 4183 //
     /* 112146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112168 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112220 */     // GIR_Coverage, 4183,
     /* 112220 */     GIR_EraseRootFromParent_Done,
     /* 112221 */   // Label 2102: @112221
     /* 112221 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(112301), // Rule ID 4184 //
     /* 112226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112248 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 112255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112270 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112300 */     // GIR_Coverage, 4184,
     /* 112300 */     GIR_EraseRootFromParent_Done,
     /* 112301 */   // Label 2103: @112301
     /* 112301 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(112381), // Rule ID 4185 //
     /* 112306 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112328 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 112328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 112335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112350 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112380 */     // GIR_Coverage, 4185,
     /* 112380 */     GIR_EraseRootFromParent_Done,
     /* 112381 */   // Label 2104: @112381
     /* 112381 */   GIM_Reject,
     /* 112382 */ // Label 2086: @112382
     /* 112382 */ GIM_Reject,
     /* 112383 */ // Label 2055: @112383
     /* 112383 */ GIM_Reject,
     /* 112384 */ // Label 19: @112384
     /* 112384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2125*/ GIMT_Encode4(125909),
     /* 112395 */ /*GILLT_s8*//*Label 2105*/ GIMT_Encode4(112491),
     /* 112399 */ /*GILLT_s16*//*Label 2106*/ GIMT_Encode4(112858),
     /* 112403 */ /*GILLT_s32*//*Label 2107*/ GIMT_Encode4(113997),
     /* 112407 */ /*GILLT_s64*//*Label 2108*/ GIMT_Encode4(118592),
     /* 112411 */ /*GILLT_s128*//*Label 2109*/ GIMT_Encode4(122361),
     /* 112415 */ /*GILLT_v2s32*//*Label 2110*/ GIMT_Encode4(122567),
     /* 112419 */ /*GILLT_v2s64*//*Label 2111*/ GIMT_Encode4(122973),
     /* 112423 */ /*GILLT_v4s16*//*Label 2112*/ GIMT_Encode4(123423),
     /* 112427 */ /*GILLT_v4s32*//*Label 2113*/ GIMT_Encode4(123829),
     /* 112431 */ /*GILLT_v8s8*//*Label 2114*/ GIMT_Encode4(124235),
     /* 112435 */ /*GILLT_v8s16*//*Label 2115*/ GIMT_Encode4(124455),
     /* 112439 */ /*GILLT_v16s8*//*Label 2116*/ GIMT_Encode4(124861), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112451 */ /*GILLT_nxv2s16*//*Label 2117*/ GIMT_Encode4(125081),
     /* 112455 */ /*GILLT_nxv2s32*//*Label 2118*/ GIMT_Encode4(125141),
     /* 112459 */ /*GILLT_nxv2s64*//*Label 2119*/ GIMT_Encode4(125201), GIMT_Encode4(0),
     /* 112467 */ /*GILLT_nxv4s16*//*Label 2120*/ GIMT_Encode4(125371),
     /* 112471 */ /*GILLT_nxv4s32*//*Label 2121*/ GIMT_Encode4(125431), GIMT_Encode4(0),
     /* 112479 */ /*GILLT_nxv8s16*//*Label 2122*/ GIMT_Encode4(125601),
     /* 112483 */ /*GILLT_nxv16s1*//*Label 2123*/ GIMT_Encode4(125771),
     /* 112487 */ /*GILLT_nxv16s8*//*Label 2124*/ GIMT_Encode4(125815),
     /* 112491 */ // Label 2105: @112491
     /* 112491 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112857),
     /* 112496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112503 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112571), // Rule ID 13170 //
     /* 112508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112541 */     // MIs[2] Operand 1
     /* 112541 */     // No operand predicates
     /* 112541 */     // MIs[0] Rn
     /* 112541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112551 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112569 */     GIR_RootConstrainSelectedInstOperands,
     /* 112570 */     // GIR_Coverage, 13170,
     /* 112570 */     GIR_EraseRootFromParent_Done,
     /* 112571 */   // Label 2127: @112571
     /* 112571 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112670), // Rule ID 13171 //
     /* 112576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112609 */     // MIs[2] Operand 1
     /* 112609 */     // No operand predicates
     /* 112609 */     // MIs[0] Rn
     /* 112609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112619 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112668 */     GIR_RootConstrainSelectedInstOperands,
     /* 112669 */     // GIR_Coverage, 13171,
     /* 112669 */     GIR_EraseRootFromParent_Done,
     /* 112670 */   // Label 2128: @112670
     /* 112670 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112719), // Rule ID 303 //
     /* 112675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112693 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 112696 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112717 */     GIR_RootConstrainSelectedInstOperands,
     /* 112718 */     // GIR_Coverage, 303,
     /* 112718 */     GIR_EraseRootFromParent_Done,
     /* 112719 */   // Label 2129: @112719
     /* 112719 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112768), // Rule ID 304 //
     /* 112724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112742 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 112745 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112766 */     GIR_RootConstrainSelectedInstOperands,
     /* 112767 */     // GIR_Coverage, 304,
     /* 112767 */     GIR_EraseRootFromParent_Done,
     /* 112768 */   // Label 2130: @112768
     /* 112768 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112812), // Rule ID 313 //
     /* 112773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112791 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 112794 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112810 */     GIR_RootConstrainSelectedInstOperands,
     /* 112811 */     // GIR_Coverage, 313,
     /* 112811 */     GIR_EraseRootFromParent_Done,
     /* 112812 */   // Label 2131: @112812
     /* 112812 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112856), // Rule ID 321 //
     /* 112817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112835 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 112835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 112838 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112854 */     GIR_RootConstrainSelectedInstOperands,
     /* 112855 */     // GIR_Coverage, 321,
     /* 112855 */     GIR_EraseRootFromParent_Done,
     /* 112856 */   // Label 2132: @112856
     /* 112856 */   GIM_Reject,
     /* 112857 */ // Label 2126: @112857
     /* 112857 */ GIM_Reject,
     /* 112858 */ // Label 2106: @112858
     /* 112858 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(113996),
     /* 112863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112870 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112969), // Rule ID 4482 //
     /* 112875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112913 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112967 */     GIR_RootConstrainSelectedInstOperands,
     /* 112968 */     // GIR_Coverage, 4482,
     /* 112968 */     GIR_EraseRootFromParent_Done,
     /* 112969 */   // Label 2134: @112969
     /* 112969 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113068), // Rule ID 4483 //
     /* 112974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113012 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113066 */     GIR_RootConstrainSelectedInstOperands,
     /* 113067 */     // GIR_Coverage, 4483,
     /* 113067 */     GIR_EraseRootFromParent_Done,
     /* 113068 */   // Label 2135: @113068
     /* 113068 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113167), // Rule ID 13168 //
     /* 113073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113094 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113111 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113165 */     GIR_RootConstrainSelectedInstOperands,
     /* 113166 */     // GIR_Coverage, 13168,
     /* 113166 */     GIR_EraseRootFromParent_Done,
     /* 113167 */   // Label 2136: @113167
     /* 113167 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113266), // Rule ID 13169 //
     /* 113172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113210 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113264 */     GIR_RootConstrainSelectedInstOperands,
     /* 113265 */     // GIR_Coverage, 13169,
     /* 113265 */     GIR_EraseRootFromParent_Done,
     /* 113266 */   // Label 2137: @113266
     /* 113266 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113360), // Rule ID 4511 //
     /* 113271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113292 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113309 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113358 */     GIR_RootConstrainSelectedInstOperands,
     /* 113359 */     // GIR_Coverage, 4511,
     /* 113359 */     GIR_EraseRootFromParent_Done,
     /* 113360 */   // Label 2138: @113360
     /* 113360 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(113454), // Rule ID 4538 //
     /* 113365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113403 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113415 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113452 */     GIR_RootConstrainSelectedInstOperands,
     /* 113453 */     // GIR_Coverage, 4538,
     /* 113453 */     GIR_EraseRootFromParent_Done,
     /* 113454 */   // Label 2139: @113454
     /* 113454 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113548), // Rule ID 13167 //
     /* 113459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113480 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113497 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113509 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113546 */     GIR_RootConstrainSelectedInstOperands,
     /* 113547 */     // GIR_Coverage, 13167,
     /* 113547 */     GIR_EraseRootFromParent_Done,
     /* 113548 */   // Label 2140: @113548
     /* 113548 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113642), // Rule ID 13173 //
     /* 113553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113574 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 113591 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113603 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113640 */     GIR_RootConstrainSelectedInstOperands,
     /* 113641 */     // GIR_Coverage, 13173,
     /* 113641 */     GIR_EraseRootFromParent_Done,
     /* 113642 */   // Label 2141: @113642
     /* 113642 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113710), // Rule ID 6457 //
     /* 113647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113680 */     // MIs[2] Operand 1
     /* 113680 */     // No operand predicates
     /* 113680 */     // MIs[0] Rn
     /* 113680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113690 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113708 */     GIR_RootConstrainSelectedInstOperands,
     /* 113709 */     // GIR_Coverage, 6457,
     /* 113709 */     GIR_EraseRootFromParent_Done,
     /* 113710 */   // Label 2142: @113710
     /* 113710 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113809), // Rule ID 6462 //
     /* 113715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113748 */     // MIs[2] Operand 1
     /* 113748 */     // No operand predicates
     /* 113748 */     // MIs[0] Rn
     /* 113748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113758 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 113773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113777 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 113780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113807 */     GIR_RootConstrainSelectedInstOperands,
     /* 113808 */     // GIR_Coverage, 6462,
     /* 113808 */     GIR_EraseRootFromParent_Done,
     /* 113809 */   // Label 2143: @113809
     /* 113809 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113858), // Rule ID 305 //
     /* 113814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113832 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113835 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113856 */     GIR_RootConstrainSelectedInstOperands,
     /* 113857 */     // GIR_Coverage, 305,
     /* 113857 */     GIR_EraseRootFromParent_Done,
     /* 113858 */   // Label 2144: @113858
     /* 113858 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113907), // Rule ID 306 //
     /* 113863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113881 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113884 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113905 */     GIR_RootConstrainSelectedInstOperands,
     /* 113906 */     // GIR_Coverage, 306,
     /* 113906 */     GIR_EraseRootFromParent_Done,
     /* 113907 */   // Label 2145: @113907
     /* 113907 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113951), // Rule ID 314 //
     /* 113912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113930 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113933 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113949 */     GIR_RootConstrainSelectedInstOperands,
     /* 113950 */     // GIR_Coverage, 314,
     /* 113950 */     GIR_EraseRootFromParent_Done,
     /* 113951 */   // Label 2146: @113951
     /* 113951 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113995), // Rule ID 322 //
     /* 113956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113974 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113977 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113993 */     GIR_RootConstrainSelectedInstOperands,
     /* 113994 */     // GIR_Coverage, 322,
     /* 113994 */     GIR_EraseRootFromParent_Done,
     /* 113995 */   // Label 2147: @113995
     /* 113995 */   GIM_Reject,
     /* 113996 */ // Label 2133: @113996
     /* 113996 */ GIM_Reject,
     /* 113997 */ // Label 2107: @113997
     /* 113997 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(114110), // Rule ID 4480 //
     /* 114002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114005 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114024 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114028 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114032 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114037 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114045 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114047 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 114054 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 114054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114066 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 114085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114108 */   GIR_RootConstrainSelectedInstOperands,
     /* 114109 */   // GIR_Coverage, 4480,
     /* 114109 */   GIR_EraseRootFromParent_Done,
     /* 114110 */ // Label 2148: @114110
     /* 114110 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(114223), // Rule ID 4481 //
     /* 114115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114137 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114145 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114150 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 114167 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 114167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114179 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 114198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114221 */   GIR_RootConstrainSelectedInstOperands,
     /* 114222 */   // GIR_Coverage, 4481,
     /* 114222 */   GIR_EraseRootFromParent_Done,
     /* 114223 */ // Label 2149: @114223
     /* 114223 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(114329), // Rule ID 4484 //
     /* 114228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114243 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114251 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114256 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114273 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114285 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114327 */   GIR_RootConstrainSelectedInstOperands,
     /* 114328 */   // GIR_Coverage, 4484,
     /* 114328 */   GIR_EraseRootFromParent_Done,
     /* 114329 */ // Label 2150: @114329
     /* 114329 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(114435), // Rule ID 4485 //
     /* 114334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114337 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114349 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114353 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114357 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114362 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114370 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114379 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114391 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114402 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114433 */   GIR_RootConstrainSelectedInstOperands,
     /* 114434 */   // GIR_Coverage, 4485,
     /* 114434 */   GIR_EraseRootFromParent_Done,
     /* 114435 */ // Label 2151: @114435
     /* 114435 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114541), // Rule ID 4486 //
     /* 114440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114455 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114468 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114485 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114497 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114539 */   GIR_RootConstrainSelectedInstOperands,
     /* 114540 */   // GIR_Coverage, 4486,
     /* 114540 */   GIR_EraseRootFromParent_Done,
     /* 114541 */ // Label 2152: @114541
     /* 114541 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114647), // Rule ID 4487 //
     /* 114546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114561 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114565 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114569 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114574 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114591 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114603 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114614 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114645 */   GIR_RootConstrainSelectedInstOperands,
     /* 114646 */   // GIR_Coverage, 4487,
     /* 114646 */   GIR_EraseRootFromParent_Done,
     /* 114647 */ // Label 2153: @114647
     /* 114647 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114753), // Rule ID 13175 //
     /* 114652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114667 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114671 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114675 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114680 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114688 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114697 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114709 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114720 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114751 */   GIR_RootConstrainSelectedInstOperands,
     /* 114752 */   // GIR_Coverage, 13175,
     /* 114752 */   GIR_EraseRootFromParent_Done,
     /* 114753 */ // Label 2154: @114753
     /* 114753 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114859), // Rule ID 13176 //
     /* 114758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114773 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114777 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114781 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114786 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114803 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114815 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114857 */   GIR_RootConstrainSelectedInstOperands,
     /* 114858 */   // GIR_Coverage, 13176,
     /* 114858 */   GIR_EraseRootFromParent_Done,
     /* 114859 */ // Label 2155: @114859
     /* 114859 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114967), // Rule ID 4510 //
     /* 114864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114867 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114871 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114890 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114894 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114899 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114916 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114928 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114965 */   GIR_RootConstrainSelectedInstOperands,
     /* 114966 */   // GIR_Coverage, 4510,
     /* 114966 */   GIR_EraseRootFromParent_Done,
     /* 114967 */ // Label 2156: @114967
     /* 114967 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(115068), // Rule ID 4512 //
     /* 114972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114995 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115000 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115017 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115029 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115035 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115040 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115066 */   GIR_RootConstrainSelectedInstOperands,
     /* 115067 */   // GIR_Coverage, 4512,
     /* 115067 */   GIR_EraseRootFromParent_Done,
     /* 115068 */ // Label 2157: @115068
     /* 115068 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(115169), // Rule ID 4513 //
     /* 115073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115096 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115101 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115105 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115118 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115130 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115136 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115167 */   GIR_RootConstrainSelectedInstOperands,
     /* 115168 */   // GIR_Coverage, 4513,
     /* 115168 */   GIR_EraseRootFromParent_Done,
     /* 115169 */ // Label 2158: @115169
     /* 115169 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(115277), // Rule ID 4537 //
     /* 115174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115177 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115181 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115209 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115217 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115226 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115238 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 115244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115249 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 115257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115275 */   GIR_RootConstrainSelectedInstOperands,
     /* 115276 */   // GIR_Coverage, 4537,
     /* 115276 */   GIR_EraseRootFromParent_Done,
     /* 115277 */ // Label 2159: @115277
     /* 115277 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(115378), // Rule ID 4539 //
     /* 115282 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115285 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115289 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115293 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115297 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115301 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115310 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115327 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115339 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115376 */   GIR_RootConstrainSelectedInstOperands,
     /* 115377 */   // GIR_Coverage, 4539,
     /* 115377 */   GIR_EraseRootFromParent_Done,
     /* 115378 */ // Label 2160: @115378
     /* 115378 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(115479), // Rule ID 4540 //
     /* 115383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115386 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115411 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115428 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115440 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115477 */   GIR_RootConstrainSelectedInstOperands,
     /* 115478 */   // GIR_Coverage, 4540,
     /* 115478 */   GIR_EraseRootFromParent_Done,
     /* 115479 */ // Label 2161: @115479
     /* 115479 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(115580), // Rule ID 13172 //
     /* 115484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115503 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115507 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115512 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115529 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115529 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115532 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115536 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115541 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115547 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115573 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115578 */   GIR_RootConstrainSelectedInstOperands,
     /* 115579 */   // GIR_Coverage, 13172,
     /* 115579 */   GIR_EraseRootFromParent_Done,
     /* 115580 */ // Label 2162: @115580
     /* 115580 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115681), // Rule ID 13174 //
     /* 115585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115613 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115621 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 115630 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115642 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115648 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115679 */   GIR_RootConstrainSelectedInstOperands,
     /* 115680 */   // GIR_Coverage, 13174,
     /* 115680 */   GIR_EraseRootFromParent_Done,
     /* 115681 */ // Label 2163: @115681
     /* 115681 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115763), // Rule ID 6451 //
     /* 115686 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115689 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115721 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115725 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115729 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115733 */   // MIs[2] Operand 1
     /* 115733 */   // No operand predicates
     /* 115733 */   // MIs[0] Rn
     /* 115733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115741 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115743 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115746 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115750 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115753 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115761 */   GIR_RootConstrainSelectedInstOperands,
     /* 115762 */   // GIR_Coverage, 6451,
     /* 115762 */   GIR_EraseRootFromParent_Done,
     /* 115763 */ // Label 2164: @115763
     /* 115763 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115845), // Rule ID 6452 //
     /* 115768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115790 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115794 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115798 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115803 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115807 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115811 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115815 */   // MIs[2] Operand 1
     /* 115815 */   // No operand predicates
     /* 115815 */   // MIs[0] Rn
     /* 115815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115823 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115825 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115828 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115832 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115835 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115843 */   GIR_RootConstrainSelectedInstOperands,
     /* 115844 */   // GIR_Coverage, 6452,
     /* 115844 */   GIR_EraseRootFromParent_Done,
     /* 115845 */ // Label 2165: @115845
     /* 115845 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115920), // Rule ID 6453 //
     /* 115850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115865 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115869 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115878 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115882 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115886 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115890 */   // MIs[2] Operand 1
     /* 115890 */   // No operand predicates
     /* 115890 */   // MIs[0] Rn
     /* 115890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115898 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115900 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115903 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115910 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115918 */   GIR_RootConstrainSelectedInstOperands,
     /* 115919 */   // GIR_Coverage, 6453,
     /* 115919 */   GIR_EraseRootFromParent_Done,
     /* 115920 */ // Label 2166: @115920
     /* 115920 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115995), // Rule ID 6454 //
     /* 115925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115944 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115948 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115953 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115957 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115961 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115965 */   // MIs[2] Operand 1
     /* 115965 */   // No operand predicates
     /* 115965 */   // MIs[0] Rn
     /* 115965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115973 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115975 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115978 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115982 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115985 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115993 */   GIR_RootConstrainSelectedInstOperands,
     /* 115994 */   // GIR_Coverage, 6454,
     /* 115994 */   GIR_EraseRootFromParent_Done,
     /* 115995 */ // Label 2167: @115995
     /* 115995 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(116108), // Rule ID 6458 //
     /* 116000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116003 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116014 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116022 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 116026 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116030 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116035 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116039 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116043 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 116047 */   // MIs[2] Operand 1
     /* 116047 */   // No operand predicates
     /* 116047 */   // MIs[0] Rn
     /* 116047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116055 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116057 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116069 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116072 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116076 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116079 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 116092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116095 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116098 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116106 */   GIR_RootConstrainSelectedInstOperands,
     /* 116107 */   // GIR_Coverage, 6458,
     /* 116107 */   GIR_EraseRootFromParent_Done,
     /* 116108 */ // Label 2168: @116108
     /* 116108 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(116221), // Rule ID 6459 //
     /* 116113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116116 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116148 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116152 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116156 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 116160 */   // MIs[2] Operand 1
     /* 116160 */   // No operand predicates
     /* 116160 */   // MIs[0] Rn
     /* 116160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116168 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116170 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116182 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116185 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116189 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 116205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116208 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116211 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116219 */   GIR_RootConstrainSelectedInstOperands,
     /* 116220 */   // GIR_Coverage, 6459,
     /* 116220 */   GIR_EraseRootFromParent_Done,
     /* 116221 */ // Label 2169: @116221
     /* 116221 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(116327), // Rule ID 6460 //
     /* 116226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116249 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116254 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116258 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116262 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116266 */   // MIs[2] Operand 1
     /* 116266 */   // No operand predicates
     /* 116266 */   // MIs[0] Rn
     /* 116266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116274 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116276 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116288 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116295 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116314 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116325 */   GIR_RootConstrainSelectedInstOperands,
     /* 116326 */   // GIR_Coverage, 6460,
     /* 116326 */   GIR_EraseRootFromParent_Done,
     /* 116327 */ // Label 2170: @116327
     /* 116327 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(116433), // Rule ID 6461 //
     /* 116332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116360 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116364 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116368 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116372 */   // MIs[2] Operand 1
     /* 116372 */   // No operand predicates
     /* 116372 */   // MIs[0] Rn
     /* 116372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116380 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116382 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116394 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116401 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116420 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116423 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116425 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116431 */   GIR_RootConstrainSelectedInstOperands,
     /* 116432 */   // GIR_Coverage, 6461,
     /* 116432 */   GIR_EraseRootFromParent_Done,
     /* 116433 */ // Label 2171: @116433
     /* 116433 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(116493), // Rule ID 295 //
     /* 116438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116441 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116445 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116460 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116467 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116470 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116491 */   GIR_RootConstrainSelectedInstOperands,
     /* 116492 */   // GIR_Coverage, 295,
     /* 116492 */   GIR_EraseRootFromParent_Done,
     /* 116493 */ // Label 2172: @116493
     /* 116493 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(116553), // Rule ID 296 //
     /* 116498 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116501 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116527 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116530 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116547 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116551 */   GIR_RootConstrainSelectedInstOperands,
     /* 116552 */   // GIR_Coverage, 296,
     /* 116552 */   GIR_EraseRootFromParent_Done,
     /* 116553 */ // Label 2173: @116553
     /* 116553 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(116613), // Rule ID 297 //
     /* 116558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116561 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116565 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116587 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116590 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116611 */   GIR_RootConstrainSelectedInstOperands,
     /* 116612 */   // GIR_Coverage, 297,
     /* 116612 */   GIR_EraseRootFromParent_Done,
     /* 116613 */ // Label 2174: @116613
     /* 116613 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(116673), // Rule ID 298 //
     /* 116618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116621 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116647 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116650 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116671 */   GIR_RootConstrainSelectedInstOperands,
     /* 116672 */   // GIR_Coverage, 298,
     /* 116672 */   GIR_EraseRootFromParent_Done,
     /* 116673 */ // Label 2175: @116673
     /* 116673 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116726), // Rule ID 299 //
     /* 116678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116700 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116703 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116724 */   GIR_RootConstrainSelectedInstOperands,
     /* 116725 */   // GIR_Coverage, 299,
     /* 116725 */   GIR_EraseRootFromParent_Done,
     /* 116726 */ // Label 2176: @116726
     /* 116726 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116779), // Rule ID 300 //
     /* 116731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116753 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116756 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116777 */   GIR_RootConstrainSelectedInstOperands,
     /* 116778 */   // GIR_Coverage, 300,
     /* 116778 */   GIR_EraseRootFromParent_Done,
     /* 116779 */ // Label 2177: @116779
     /* 116779 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116835), // Rule ID 307 //
     /* 116784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116790 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116809 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116812 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116833 */   GIR_RootConstrainSelectedInstOperands,
     /* 116834 */   // GIR_Coverage, 307,
     /* 116834 */   GIR_EraseRootFromParent_Done,
     /* 116835 */ // Label 2178: @116835
     /* 116835 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116891), // Rule ID 308 //
     /* 116840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116865 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116868 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116889 */   GIR_RootConstrainSelectedInstOperands,
     /* 116890 */   // GIR_Coverage, 308,
     /* 116890 */   GIR_EraseRootFromParent_Done,
     /* 116891 */ // Label 2179: @116891
     /* 116891 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116943), // Rule ID 312 //
     /* 116896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116918 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116921 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116941 */   GIR_RootConstrainSelectedInstOperands,
     /* 116942 */   // GIR_Coverage, 312,
     /* 116942 */   GIR_EraseRootFromParent_Done,
     /* 116943 */ // Label 2180: @116943
     /* 116943 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116994), // Rule ID 315 //
     /* 116948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116973 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116976 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116992 */   GIR_RootConstrainSelectedInstOperands,
     /* 116993 */   // GIR_Coverage, 315,
     /* 116993 */   GIR_EraseRootFromParent_Done,
     /* 116994 */ // Label 2181: @116994
     /* 116994 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(117053), // Rule ID 317 //
     /* 116999 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117002 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117006 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117017 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117028 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117031 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117051 */   GIR_RootConstrainSelectedInstOperands,
     /* 117052 */   // GIR_Coverage, 317,
     /* 117052 */   GIR_EraseRootFromParent_Done,
     /* 117053 */ // Label 2182: @117053
     /* 117053 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(117112), // Rule ID 318 //
     /* 117058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117061 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117087 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117090 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117110 */   GIR_RootConstrainSelectedInstOperands,
     /* 117111 */   // GIR_Coverage, 318,
     /* 117111 */   GIR_EraseRootFromParent_Done,
     /* 117112 */ // Label 2183: @117112
     /* 117112 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(117189), // Rule ID 7084 //
     /* 117117 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117127 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117130 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117134 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117138 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117147 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117160 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 117163 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117187 */   GIR_RootConstrainSelectedInstOperands,
     /* 117188 */   // GIR_Coverage, 7084,
     /* 117188 */   GIR_EraseRootFromParent_Done,
     /* 117189 */ // Label 2184: @117189
     /* 117189 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(117266), // Rule ID 7085 //
     /* 117194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117197 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117204 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117207 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117215 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117219 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117237 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 117240 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117264 */   GIR_RootConstrainSelectedInstOperands,
     /* 117265 */   // GIR_Coverage, 7085,
     /* 117265 */   GIR_EraseRootFromParent_Done,
     /* 117266 */ // Label 2185: @117266
     /* 117266 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(117325), // Rule ID 7065 //
     /* 117271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117281 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117299 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15883>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 117302 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117323 */   GIR_RootConstrainSelectedInstOperands,
     /* 117324 */   // GIR_Coverage, 7065,
     /* 117324 */   GIR_EraseRootFromParent_Done,
     /* 117325 */ // Label 2186: @117325
     /* 117325 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(117384), // Rule ID 7066 //
     /* 117330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117340 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117358 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15883>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 117361 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117382 */   GIR_RootConstrainSelectedInstOperands,
     /* 117383 */   // GIR_Coverage, 7066,
     /* 117383 */   GIR_EraseRootFromParent_Done,
     /* 117384 */ // Label 2187: @117384
     /* 117384 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(117443), // Rule ID 7070 //
     /* 117389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117399 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117417 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15890>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 117420 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117441 */   GIR_RootConstrainSelectedInstOperands,
     /* 117442 */   // GIR_Coverage, 7070,
     /* 117442 */   GIR_EraseRootFromParent_Done,
     /* 117443 */ // Label 2188: @117443
     /* 117443 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(117502), // Rule ID 7071 //
     /* 117448 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117458 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117476 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15890>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 117479 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117500 */   GIR_RootConstrainSelectedInstOperands,
     /* 117501 */   // GIR_Coverage, 7071,
     /* 117501 */   GIR_EraseRootFromParent_Done,
     /* 117502 */ // Label 2189: @117502
     /* 117502 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(117561), // Rule ID 7075 //
     /* 117507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117535 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 117538 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117559 */   GIR_RootConstrainSelectedInstOperands,
     /* 117560 */   // GIR_Coverage, 7075,
     /* 117560 */   GIR_EraseRootFromParent_Done,
     /* 117561 */ // Label 2190: @117561
     /* 117561 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(117620), // Rule ID 7076 //
     /* 117566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117576 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117594 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 117597 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117618 */   GIR_RootConstrainSelectedInstOperands,
     /* 117619 */   // GIR_Coverage, 7076,
     /* 117619 */   GIR_EraseRootFromParent_Done,
     /* 117620 */ // Label 2191: @117620
     /* 117620 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117692), // Rule ID 7086 //
     /* 117625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117635 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117646 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117668 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117690 */   GIR_RootConstrainSelectedInstOperands,
     /* 117691 */   // GIR_Coverage, 7086,
     /* 117691 */   GIR_EraseRootFromParent_Done,
     /* 117692 */ // Label 2192: @117692
     /* 117692 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117764), // Rule ID 7087 //
     /* 117697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117707 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117718 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117722 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117740 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117762 */   GIR_RootConstrainSelectedInstOperands,
     /* 117763 */   // GIR_Coverage, 7087,
     /* 117763 */   GIR_EraseRootFromParent_Done,
     /* 117764 */ // Label 2193: @117764
     /* 117764 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117816), // Rule ID 320 //
     /* 117769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117780 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117791 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117794 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117814 */   GIR_RootConstrainSelectedInstOperands,
     /* 117815 */   // GIR_Coverage, 320,
     /* 117815 */   GIR_EraseRootFromParent_Done,
     /* 117816 */ // Label 2194: @117816
     /* 117816 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117867), // Rule ID 323 //
     /* 117821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117846 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117849 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117865 */   GIR_RootConstrainSelectedInstOperands,
     /* 117866 */   // GIR_Coverage, 323,
     /* 117866 */   GIR_EraseRootFromParent_Done,
     /* 117867 */ // Label 2195: @117867
     /* 117867 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117926), // Rule ID 326 //
     /* 117872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117901 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117904 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117924 */   GIR_RootConstrainSelectedInstOperands,
     /* 117925 */   // GIR_Coverage, 326,
     /* 117925 */   GIR_EraseRootFromParent_Done,
     /* 117926 */ // Label 2196: @117926
     /* 117926 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117985), // Rule ID 327 //
     /* 117931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117934 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117960 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117963 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117983 */   GIR_RootConstrainSelectedInstOperands,
     /* 117984 */   // GIR_Coverage, 327,
     /* 117984 */   GIR_EraseRootFromParent_Done,
     /* 117985 */ // Label 2197: @117985
     /* 117985 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(118039), // Rule ID 7067 //
     /* 117990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118018 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15883>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 118021 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118037 */   GIR_RootConstrainSelectedInstOperands,
     /* 118038 */   // GIR_Coverage, 7067,
     /* 118038 */   GIR_EraseRootFromParent_Done,
     /* 118039 */ // Label 2198: @118039
     /* 118039 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(118093), // Rule ID 7068 //
     /* 118044 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118054 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118072 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15883>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 118075 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118091 */   GIR_RootConstrainSelectedInstOperands,
     /* 118092 */   // GIR_Coverage, 7068,
     /* 118092 */   GIR_EraseRootFromParent_Done,
     /* 118093 */ // Label 2199: @118093
     /* 118093 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(118147), // Rule ID 7072 //
     /* 118098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118108 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118119 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118126 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15890>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 118129 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118145 */   GIR_RootConstrainSelectedInstOperands,
     /* 118146 */   // GIR_Coverage, 7072,
     /* 118146 */   GIR_EraseRootFromParent_Done,
     /* 118147 */ // Label 2200: @118147
     /* 118147 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(118201), // Rule ID 7073 //
     /* 118152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118162 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118180 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15890>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 118183 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118199 */   GIR_RootConstrainSelectedInstOperands,
     /* 118200 */   // GIR_Coverage, 7073,
     /* 118200 */   GIR_EraseRootFromParent_Done,
     /* 118201 */ // Label 2201: @118201
     /* 118201 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(118255), // Rule ID 7077 //
     /* 118206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118216 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118234 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 118237 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118253 */   GIR_RootConstrainSelectedInstOperands,
     /* 118254 */   // GIR_Coverage, 7077,
     /* 118254 */   GIR_EraseRootFromParent_Done,
     /* 118255 */ // Label 2202: @118255
     /* 118255 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(118309), // Rule ID 7078 //
     /* 118260 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118263 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118270 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118288 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15897>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 118291 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118307 */   GIR_RootConstrainSelectedInstOperands,
     /* 118308 */   // GIR_Coverage, 7078,
     /* 118308 */   GIR_EraseRootFromParent_Done,
     /* 118309 */ // Label 2203: @118309
     /* 118309 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(118366), // Rule ID 7410 //
     /* 118314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118317 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118345 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15881>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 118348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118364 */   GIR_RootConstrainSelectedInstOperands,
     /* 118365 */   // GIR_Coverage, 7410,
     /* 118365 */   GIR_EraseRootFromParent_Done,
     /* 118366 */ // Label 2204: @118366
     /* 118366 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(118423), // Rule ID 7411 //
     /* 118371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118384 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118402 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15888>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 118405 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118421 */   GIR_RootConstrainSelectedInstOperands,
     /* 118422 */   // GIR_Coverage, 7411,
     /* 118422 */   GIR_EraseRootFromParent_Done,
     /* 118423 */ // Label 2205: @118423
     /* 118423 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(118480), // Rule ID 7412 //
     /* 118428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118431 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118441 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118459 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15895>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 118462 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118478 */   GIR_RootConstrainSelectedInstOperands,
     /* 118479 */   // GIR_Coverage, 7412,
     /* 118479 */   GIR_EraseRootFromParent_Done,
     /* 118480 */ // Label 2206: @118480
     /* 118480 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(118517), // Rule ID 7064 //
     /* 118485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118495 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118502 */   // MIs[0] ptr
     /* 118502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118510 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15881>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 118515 */   GIR_RootConstrainSelectedInstOperands,
     /* 118516 */   // GIR_Coverage, 7064,
     /* 118516 */   GIR_Done,
     /* 118517 */ // Label 2207: @118517
     /* 118517 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(118554), // Rule ID 7069 //
     /* 118522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118532 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118539 */   // MIs[0] ptr
     /* 118539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118547 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15888>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 118552 */   GIR_RootConstrainSelectedInstOperands,
     /* 118553 */   // GIR_Coverage, 7069,
     /* 118553 */   GIR_Done,
     /* 118554 */ // Label 2208: @118554
     /* 118554 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118591), // Rule ID 7074 //
     /* 118559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118569 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118576 */   // MIs[0] ptr
     /* 118576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118584 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15895>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 118589 */   GIR_RootConstrainSelectedInstOperands,
     /* 118590 */   // GIR_Coverage, 7074,
     /* 118590 */   GIR_Done,
     /* 118591 */ // Label 2209: @118591
     /* 118591 */ GIM_Reject,
     /* 118592 */ // Label 2108: @118592
     /* 118592 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118698), // Rule ID 4488 //
     /* 118597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118612 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118620 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118625 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118642 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118654 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118660 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118665 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118673 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118696 */   GIR_RootConstrainSelectedInstOperands,
     /* 118697 */   // GIR_Coverage, 4488,
     /* 118697 */   GIR_EraseRootFromParent_Done,
     /* 118698 */ // Label 2210: @118698
     /* 118698 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118804), // Rule ID 4489 //
     /* 118703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118718 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118731 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118741 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118748 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118760 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118802 */   GIR_RootConstrainSelectedInstOperands,
     /* 118803 */   // GIR_Coverage, 4489,
     /* 118803 */   GIR_EraseRootFromParent_Done,
     /* 118804 */ // Label 2211: @118804
     /* 118804 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118910), // Rule ID 4490 //
     /* 118809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118824 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118832 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118837 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118847 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118854 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118866 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118908 */   GIR_RootConstrainSelectedInstOperands,
     /* 118909 */   // GIR_Coverage, 4490,
     /* 118909 */   GIR_EraseRootFromParent_Done,
     /* 118910 */ // Label 2212: @118910
     /* 118910 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(119016), // Rule ID 4491 //
     /* 118915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118960 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119014 */   GIR_RootConstrainSelectedInstOperands,
     /* 119015 */   // GIR_Coverage, 4491,
     /* 119015 */   GIR_EraseRootFromParent_Done,
     /* 119016 */ // Label 2213: @119016
     /* 119016 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(119117), // Rule ID 4514 //
     /* 119021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119036 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119040 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119044 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119049 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119059 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119066 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119078 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119115 */   GIR_RootConstrainSelectedInstOperands,
     /* 119116 */   // GIR_Coverage, 4514,
     /* 119116 */   GIR_EraseRootFromParent_Done,
     /* 119117 */ // Label 2214: @119117
     /* 119117 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(119218), // Rule ID 4515 //
     /* 119122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119125 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119137 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119145 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119150 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119167 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119179 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119216 */   GIR_RootConstrainSelectedInstOperands,
     /* 119217 */   // GIR_Coverage, 4515,
     /* 119217 */   GIR_EraseRootFromParent_Done,
     /* 119218 */ // Label 2215: @119218
     /* 119218 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(119319), // Rule ID 4541 //
     /* 119223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119238 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119242 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119246 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119251 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119268 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119280 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119317 */   GIR_RootConstrainSelectedInstOperands,
     /* 119318 */   // GIR_Coverage, 4541,
     /* 119318 */   GIR_EraseRootFromParent_Done,
     /* 119319 */ // Label 2216: @119319
     /* 119319 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(119420), // Rule ID 4542 //
     /* 119324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119343 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119347 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119352 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119369 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119381 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119418 */   GIR_RootConstrainSelectedInstOperands,
     /* 119419 */   // GIR_Coverage, 4542,
     /* 119419 */   GIR_EraseRootFromParent_Done,
     /* 119420 */ // Label 2217: @119420
     /* 119420 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(119495), // Rule ID 6455 //
     /* 119425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119428 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119440 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119453 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119457 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119461 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119465 */   // MIs[2] Operand 1
     /* 119465 */   // No operand predicates
     /* 119465 */   // MIs[0] Rn
     /* 119465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119473 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119475 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119482 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119485 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119493 */   GIR_RootConstrainSelectedInstOperands,
     /* 119494 */   // GIR_Coverage, 6455,
     /* 119494 */   GIR_EraseRootFromParent_Done,
     /* 119495 */ // Label 2218: @119495
     /* 119495 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(119570), // Rule ID 6456 //
     /* 119500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119536 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119540 */   // MIs[2] Operand 1
     /* 119540 */   // No operand predicates
     /* 119540 */   // MIs[0] Rn
     /* 119540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119548 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119550 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119557 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119568 */   GIR_RootConstrainSelectedInstOperands,
     /* 119569 */   // GIR_Coverage, 6456,
     /* 119569 */   GIR_EraseRootFromParent_Done,
     /* 119570 */ // Label 2219: @119570
     /* 119570 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(119623), // Rule ID 301 //
     /* 119575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119597 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 119600 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119621 */   GIR_RootConstrainSelectedInstOperands,
     /* 119622 */   // GIR_Coverage, 301,
     /* 119622 */   GIR_EraseRootFromParent_Done,
     /* 119623 */ // Label 2220: @119623
     /* 119623 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119676), // Rule ID 302 //
     /* 119628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119631 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119650 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 119653 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119674 */   GIR_RootConstrainSelectedInstOperands,
     /* 119675 */   // GIR_Coverage, 302,
     /* 119675 */   GIR_EraseRootFromParent_Done,
     /* 119676 */ // Label 2221: @119676
     /* 119676 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119732), // Rule ID 309 //
     /* 119681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119706 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119709 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119730 */   GIR_RootConstrainSelectedInstOperands,
     /* 119731 */   // GIR_Coverage, 309,
     /* 119731 */   GIR_EraseRootFromParent_Done,
     /* 119732 */ // Label 2222: @119732
     /* 119732 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119788), // Rule ID 310 //
     /* 119737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119762 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119765 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119782 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119786 */   GIR_RootConstrainSelectedInstOperands,
     /* 119787 */   // GIR_Coverage, 310,
     /* 119787 */   GIR_EraseRootFromParent_Done,
     /* 119788 */ // Label 2223: @119788
     /* 119788 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119877), // Rule ID 4446 //
     /* 119793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119796 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119815 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119822 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 119822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119834 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119875 */   GIR_RootConstrainSelectedInstOperands,
     /* 119876 */   // GIR_Coverage, 4446,
     /* 119876 */   GIR_EraseRootFromParent_Done,
     /* 119877 */ // Label 2224: @119877
     /* 119877 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119966), // Rule ID 4447 //
     /* 119882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119885 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119911 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119923 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 119942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119964 */   GIR_RootConstrainSelectedInstOperands,
     /* 119965 */   // GIR_Coverage, 4447,
     /* 119965 */   GIR_EraseRootFromParent_Done,
     /* 119966 */ // Label 2225: @119966
     /* 119966 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(120055), // Rule ID 4448 //
     /* 119971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119993 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120000 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 120000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120012 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 120031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120053 */   GIR_RootConstrainSelectedInstOperands,
     /* 120054 */   // GIR_Coverage, 4448,
     /* 120054 */   GIR_EraseRootFromParent_Done,
     /* 120055 */ // Label 2226: @120055
     /* 120055 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(120144), // Rule ID 4449 //
     /* 120060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120063 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120089 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 120089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120101 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 120120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120142 */   GIR_RootConstrainSelectedInstOperands,
     /* 120143 */   // GIR_Coverage, 4449,
     /* 120143 */   GIR_EraseRootFromParent_Done,
     /* 120144 */ // Label 2227: @120144
     /* 120144 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(120233), // Rule ID 4450 //
     /* 120149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120178 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 120178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120190 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 120209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120231 */   GIR_RootConstrainSelectedInstOperands,
     /* 120232 */   // GIR_Coverage, 4450,
     /* 120232 */   GIR_EraseRootFromParent_Done,
     /* 120233 */ // Label 2228: @120233
     /* 120233 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(120322), // Rule ID 4451 //
     /* 120238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120241 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120245 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120256 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120260 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120267 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 120267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120279 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120285 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 120298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120320 */   GIR_RootConstrainSelectedInstOperands,
     /* 120321 */   // GIR_Coverage, 4451,
     /* 120321 */   GIR_EraseRootFromParent_Done,
     /* 120322 */ // Label 2229: @120322
     /* 120322 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(120375), // Rule ID 4462 //
     /* 120327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120349 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120352 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120373 */   GIR_RootConstrainSelectedInstOperands,
     /* 120374 */   // GIR_Coverage, 4462,
     /* 120374 */   GIR_EraseRootFromParent_Done,
     /* 120375 */ // Label 2230: @120375
     /* 120375 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(120428), // Rule ID 4463 //
     /* 120380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120402 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120405 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120426 */   GIR_RootConstrainSelectedInstOperands,
     /* 120427 */   // GIR_Coverage, 4463,
     /* 120427 */   GIR_EraseRootFromParent_Done,
     /* 120428 */ // Label 2231: @120428
     /* 120428 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(120481), // Rule ID 4464 //
     /* 120433 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120436 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120455 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120458 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120479 */   GIR_RootConstrainSelectedInstOperands,
     /* 120480 */   // GIR_Coverage, 4464,
     /* 120480 */   GIR_EraseRootFromParent_Done,
     /* 120481 */ // Label 2232: @120481
     /* 120481 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(120534), // Rule ID 4465 //
     /* 120486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120489 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120508 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120511 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120532 */   GIR_RootConstrainSelectedInstOperands,
     /* 120533 */   // GIR_Coverage, 4465,
     /* 120533 */   GIR_EraseRootFromParent_Done,
     /* 120534 */ // Label 2233: @120534
     /* 120534 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(120586), // Rule ID 311 //
     /* 120539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120561 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120564 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120584 */   GIR_RootConstrainSelectedInstOperands,
     /* 120585 */   // GIR_Coverage, 311,
     /* 120585 */   GIR_EraseRootFromParent_Done,
     /* 120586 */ // Label 2234: @120586
     /* 120586 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(120637), // Rule ID 316 //
     /* 120591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120616 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120619 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120635 */   GIR_RootConstrainSelectedInstOperands,
     /* 120636 */   // GIR_Coverage, 316,
     /* 120636 */   GIR_EraseRootFromParent_Done,
     /* 120637 */ // Label 2235: @120637
     /* 120637 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120685), // Rule ID 4492 //
     /* 120642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120645 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120664 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120667 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120683 */   GIR_RootConstrainSelectedInstOperands,
     /* 120684 */   // GIR_Coverage, 4492,
     /* 120684 */   GIR_EraseRootFromParent_Done,
     /* 120685 */ // Label 2236: @120685
     /* 120685 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120733), // Rule ID 4493 //
     /* 120690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120712 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120715 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120727 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120731 */   GIR_RootConstrainSelectedInstOperands,
     /* 120732 */   // GIR_Coverage, 4493,
     /* 120732 */   GIR_EraseRootFromParent_Done,
     /* 120733 */ // Label 2237: @120733
     /* 120733 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120817), // Rule ID 4507 //
     /* 120738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120741 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120760 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120767 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120779 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120785 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 120798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120811 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120815 */   GIR_RootConstrainSelectedInstOperands,
     /* 120816 */   // GIR_Coverage, 4507,
     /* 120816 */   GIR_EraseRootFromParent_Done,
     /* 120817 */ // Label 2238: @120817
     /* 120817 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120901), // Rule ID 4508 //
     /* 120822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120825 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120851 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120863 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120899 */   GIR_RootConstrainSelectedInstOperands,
     /* 120900 */   // GIR_Coverage, 4508,
     /* 120900 */   GIR_EraseRootFromParent_Done,
     /* 120901 */ // Label 2239: @120901
     /* 120901 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120985), // Rule ID 4509 //
     /* 120906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120909 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120935 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120947 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 120966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120983 */   GIR_RootConstrainSelectedInstOperands,
     /* 120984 */   // GIR_Coverage, 4509,
     /* 120984 */   GIR_EraseRootFromParent_Done,
     /* 120985 */ // Label 2240: @120985
     /* 120985 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(121062), // Rule ID 7088 //
     /* 120990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121026 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121033 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121060 */   GIR_RootConstrainSelectedInstOperands,
     /* 121061 */   // GIR_Coverage, 7088,
     /* 121061 */   GIR_EraseRootFromParent_Done,
     /* 121062 */ // Label 2241: @121062
     /* 121062 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(121139), // Rule ID 7089 //
     /* 121067 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121077 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121092 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121110 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121113 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121137 */   GIR_RootConstrainSelectedInstOperands,
     /* 121138 */   // GIR_Coverage, 7089,
     /* 121138 */   GIR_EraseRootFromParent_Done,
     /* 121139 */ // Label 2242: @121139
     /* 121139 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(121198), // Rule ID 7080 //
     /* 121144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121154 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121172 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 121175 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121196 */   GIR_RootConstrainSelectedInstOperands,
     /* 121197 */   // GIR_Coverage, 7080,
     /* 121197 */   GIR_EraseRootFromParent_Done,
     /* 121198 */ // Label 2243: @121198
     /* 121198 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(121257), // Rule ID 7081 //
     /* 121203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121213 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121231 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 121234 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121255 */   GIR_RootConstrainSelectedInstOperands,
     /* 121256 */   // GIR_Coverage, 7081,
     /* 121256 */   GIR_EraseRootFromParent_Done,
     /* 121257 */ // Label 2244: @121257
     /* 121257 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(121329), // Rule ID 7090 //
     /* 121262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121272 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121287 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121305 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 121305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121308 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121327 */   GIR_RootConstrainSelectedInstOperands,
     /* 121328 */   // GIR_Coverage, 7090,
     /* 121328 */   GIR_EraseRootFromParent_Done,
     /* 121329 */ // Label 2245: @121329
     /* 121329 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(121401), // Rule ID 7091 //
     /* 121334 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121344 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121355 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121377 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121380 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121399 */   GIR_RootConstrainSelectedInstOperands,
     /* 121400 */   // GIR_Coverage, 7091,
     /* 121400 */   GIR_EraseRootFromParent_Done,
     /* 121401 */ // Label 2246: @121401
     /* 121401 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(121498), // Rule ID 7402 //
     /* 121406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121419 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121430 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121434 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 121438 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121442 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121446 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 121450 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121455 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 121459 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121463 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121467 */   // MIs[3] Operand 1
     /* 121467 */   // No operand predicates
     /* 121467 */   // MIs[0] Rn
     /* 121467 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121475 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 121477 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15902>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121480 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 121484 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 121487 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 121496 */   GIR_RootConstrainSelectedInstOperands,
     /* 121497 */   // GIR_Coverage, 7402,
     /* 121497 */   GIR_EraseRootFromParent_Done,
     /* 121498 */ // Label 2247: @121498
     /* 121498 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(121550), // Rule ID 319 //
     /* 121503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121525 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121528 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 121534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121548 */   GIR_RootConstrainSelectedInstOperands,
     /* 121549 */   // GIR_Coverage, 319,
     /* 121549 */   GIR_EraseRootFromParent_Done,
     /* 121550 */ // Label 2248: @121550
     /* 121550 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(121601), // Rule ID 324 //
     /* 121555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121580 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121583 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121599 */   GIR_RootConstrainSelectedInstOperands,
     /* 121600 */   // GIR_Coverage, 324,
     /* 121600 */   GIR_EraseRootFromParent_Done,
     /* 121601 */ // Label 2249: @121601
     /* 121601 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(121655), // Rule ID 7082 //
     /* 121606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121616 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121627 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121634 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 121637 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121653 */   GIR_RootConstrainSelectedInstOperands,
     /* 121654 */   // GIR_Coverage, 7082,
     /* 121654 */   GIR_EraseRootFromParent_Done,
     /* 121655 */ // Label 2250: @121655
     /* 121655 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121709), // Rule ID 7083 //
     /* 121660 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121670 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121688 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15904>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121691 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121707 */   GIR_RootConstrainSelectedInstOperands,
     /* 121708 */   // GIR_Coverage, 7083,
     /* 121708 */   GIR_EraseRootFromParent_Done,
     /* 121709 */ // Label 2251: @121709
     /* 121709 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121766), // Rule ID 7413 //
     /* 121714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 121717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121745 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15902>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 121748 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121764 */   GIR_RootConstrainSelectedInstOperands,
     /* 121765 */   // GIR_Coverage, 7413,
     /* 121765 */   GIR_EraseRootFromParent_Done,
     /* 121766 */ // Label 2252: @121766
     /* 121766 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121814), // Rule ID 4516 //
     /* 121771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121774 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121786 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121793 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121796 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121812 */   GIR_RootConstrainSelectedInstOperands,
     /* 121813 */   // GIR_Coverage, 4516,
     /* 121813 */   GIR_EraseRootFromParent_Done,
     /* 121814 */ // Label 2253: @121814
     /* 121814 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121862), // Rule ID 4517 //
     /* 121819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121841 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121844 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121860 */   GIR_RootConstrainSelectedInstOperands,
     /* 121861 */   // GIR_Coverage, 4517,
     /* 121861 */   GIR_EraseRootFromParent_Done,
     /* 121862 */ // Label 2254: @121862
     /* 121862 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121946), // Rule ID 4532 //
     /* 121867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121870 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121874 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121896 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121908 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 121927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121944 */   GIR_RootConstrainSelectedInstOperands,
     /* 121945 */   // GIR_Coverage, 4532,
     /* 121945 */   GIR_EraseRootFromParent_Done,
     /* 121946 */ // Label 2255: @121946
     /* 121946 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(122030), // Rule ID 4533 //
     /* 121951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121954 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121980 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121992 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 122011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122028 */   GIR_RootConstrainSelectedInstOperands,
     /* 122029 */   // GIR_Coverage, 4533,
     /* 122029 */   GIR_EraseRootFromParent_Done,
     /* 122030 */ // Label 2256: @122030
     /* 122030 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(122114), // Rule ID 4534 //
     /* 122035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122038 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 122064 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122076 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 122082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 122095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122112 */   GIR_RootConstrainSelectedInstOperands,
     /* 122113 */   // GIR_Coverage, 4534,
     /* 122113 */   GIR_EraseRootFromParent_Done,
     /* 122114 */ // Label 2257: @122114
     /* 122114 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(122198), // Rule ID 7401 //
     /* 122119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122122 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122132 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 122143 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 122147 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122151 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122156 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 122160 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122164 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 122168 */   // MIs[2] Operand 1
     /* 122168 */   // No operand predicates
     /* 122168 */   // MIs[0] Rn
     /* 122168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122176 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122178 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15902>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 122178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122181 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122185 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 122188 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122196 */   GIR_RootConstrainSelectedInstOperands,
     /* 122197 */   // GIR_Coverage, 7401,
     /* 122197 */   GIR_EraseRootFromParent_Done,
     /* 122198 */ // Label 2258: @122198
     /* 122198 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(122296), // Rule ID 7403 //
     /* 122203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 122206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 122223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 122227 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 122231 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122236 */   // MIs[0] Rn
     /* 122236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122246 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15902>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 122246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 122249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122258 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 122265 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 122268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 122281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122287 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122294 */   GIR_RootConstrainSelectedInstOperands,
     /* 122295 */   // GIR_Coverage, 7403,
     /* 122295 */   GIR_EraseRootFromParent_Done,
     /* 122296 */ // Label 2259: @122296
     /* 122296 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(122333), // Rule ID 7079 //
     /* 122301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122318 */   // MIs[0] ptr
     /* 122318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122326 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15902>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 122326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 122331 */   GIR_RootConstrainSelectedInstOperands,
     /* 122332 */   // GIR_Coverage, 7079,
     /* 122332 */   GIR_Done,
     /* 122333 */ // Label 2260: @122333
     /* 122333 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(122360), // Rule ID 6405 //
     /* 122338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122345 */   // MIs[0] Rn
     /* 122345 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122353 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 122358 */   GIR_RootConstrainSelectedInstOperands,
     /* 122359 */   // GIR_Coverage, 6405,
     /* 122359 */   GIR_Done,
     /* 122360 */ // Label 2261: @122360
     /* 122360 */ GIM_Reject,
     /* 122361 */ // Label 2109: @122361
     /* 122361 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(122566),
     /* 122366 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122369 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122381 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(122422), // Rule ID 4444 //
     /* 122386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122396 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122399 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122420 */     GIR_RootConstrainSelectedInstOperands,
     /* 122421 */     // GIR_Coverage, 4444,
     /* 122421 */     GIR_EraseRootFromParent_Done,
     /* 122422 */   // Label 2263: @122422
     /* 122422 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(122463), // Rule ID 4445 //
     /* 122427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122437 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122440 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122461 */     GIR_RootConstrainSelectedInstOperands,
     /* 122462 */     // GIR_Coverage, 4445,
     /* 122462 */     GIR_EraseRootFromParent_Done,
     /* 122463 */   // Label 2264: @122463
     /* 122463 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(122496), // Rule ID 4499 //
     /* 122468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122475 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122478 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122494 */     GIR_RootConstrainSelectedInstOperands,
     /* 122495 */     // GIR_Coverage, 4499,
     /* 122495 */     GIR_EraseRootFromParent_Done,
     /* 122496 */   // Label 2265: @122496
     /* 122496 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(122529), // Rule ID 4523 //
     /* 122501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122508 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122511 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122527 */     GIR_RootConstrainSelectedInstOperands,
     /* 122528 */     // GIR_Coverage, 4523,
     /* 122528 */     GIR_EraseRootFromParent_Done,
     /* 122529 */   // Label 2266: @122529
     /* 122529 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(122565), // Rule ID 325 //
     /* 122534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122544 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122547 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122563 */     GIR_RootConstrainSelectedInstOperands,
     /* 122564 */     // GIR_Coverage, 325,
     /* 122564 */     GIR_EraseRootFromParent_Done,
     /* 122565 */   // Label 2267: @122565
     /* 122565 */   GIM_Reject,
     /* 122566 */ // Label 2262: @122566
     /* 122566 */ GIM_Reject,
     /* 122567 */ // Label 2110: @122567
     /* 122567 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(122972),
     /* 122572 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122575 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122579 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(122628), // Rule ID 4452 //
     /* 122584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122602 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122605 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122626 */     GIR_RootConstrainSelectedInstOperands,
     /* 122627 */     // GIR_Coverage, 4452,
     /* 122627 */     GIR_EraseRootFromParent_Done,
     /* 122628 */   // Label 2269: @122628
     /* 122628 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(122677), // Rule ID 4453 //
     /* 122633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122651 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122654 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122675 */     GIR_RootConstrainSelectedInstOperands,
     /* 122676 */     // GIR_Coverage, 4453,
     /* 122676 */     GIR_EraseRootFromParent_Done,
     /* 122677 */   // Label 2270: @122677
     /* 122677 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122726), // Rule ID 4454 //
     /* 122682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122700 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122703 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122724 */     GIR_RootConstrainSelectedInstOperands,
     /* 122725 */     // GIR_Coverage, 4454,
     /* 122725 */     GIR_EraseRootFromParent_Done,
     /* 122726 */   // Label 2271: @122726
     /* 122726 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122775), // Rule ID 4455 //
     /* 122731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122749 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122752 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122773 */     GIR_RootConstrainSelectedInstOperands,
     /* 122774 */     // GIR_Coverage, 4455,
     /* 122774 */     GIR_EraseRootFromParent_Done,
     /* 122775 */   // Label 2272: @122775
     /* 122775 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122819), // Rule ID 4494 //
     /* 122780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122798 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122801 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122817 */     GIR_RootConstrainSelectedInstOperands,
     /* 122818 */     // GIR_Coverage, 4494,
     /* 122818 */     GIR_EraseRootFromParent_Done,
     /* 122819 */   // Label 2273: @122819
     /* 122819 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122863), // Rule ID 4497 //
     /* 122824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122842 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122845 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122861 */     GIR_RootConstrainSelectedInstOperands,
     /* 122862 */     // GIR_Coverage, 4497,
     /* 122862 */     GIR_EraseRootFromParent_Done,
     /* 122863 */   // Label 2274: @122863
     /* 122863 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122907), // Rule ID 4518 //
     /* 122868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122886 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122889 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122905 */     GIR_RootConstrainSelectedInstOperands,
     /* 122906 */     // GIR_Coverage, 4518,
     /* 122906 */     GIR_EraseRootFromParent_Done,
     /* 122907 */   // Label 2275: @122907
     /* 122907 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122951), // Rule ID 4521 //
     /* 122912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122930 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122933 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122949 */     GIR_RootConstrainSelectedInstOperands,
     /* 122950 */     // GIR_Coverage, 4521,
     /* 122950 */     GIR_EraseRootFromParent_Done,
     /* 122951 */   // Label 2276: @122951
     /* 122951 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(122971), // Rule ID 6404 //
     /* 122956 */     // MIs[0] Rn
     /* 122956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122964 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 122969 */     GIR_RootConstrainSelectedInstOperands,
     /* 122970 */     // GIR_Coverage, 6404,
     /* 122970 */     GIR_Done,
     /* 122971 */   // Label 2277: @122971
     /* 122971 */   GIM_Reject,
     /* 122972 */ // Label 2268: @122972
     /* 122972 */ GIM_Reject,
     /* 122973 */ // Label 2111: @122973
     /* 122973 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(123422),
     /* 122978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122985 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(123034), // Rule ID 4466 //
     /* 122990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123008 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123011 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123032 */     GIR_RootConstrainSelectedInstOperands,
     /* 123033 */     // GIR_Coverage, 4466,
     /* 123033 */     GIR_EraseRootFromParent_Done,
     /* 123034 */   // Label 2279: @123034
     /* 123034 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(123083), // Rule ID 4467 //
     /* 123039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123057 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123060 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123081 */     GIR_RootConstrainSelectedInstOperands,
     /* 123082 */     // GIR_Coverage, 4467,
     /* 123082 */     GIR_EraseRootFromParent_Done,
     /* 123083 */   // Label 2280: @123083
     /* 123083 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(123132), // Rule ID 4468 //
     /* 123088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123106 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123109 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123130 */     GIR_RootConstrainSelectedInstOperands,
     /* 123131 */     // GIR_Coverage, 4468,
     /* 123131 */     GIR_EraseRootFromParent_Done,
     /* 123132 */   // Label 2281: @123132
     /* 123132 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(123181), // Rule ID 4469 //
     /* 123137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123155 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123158 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123179 */     GIR_RootConstrainSelectedInstOperands,
     /* 123180 */     // GIR_Coverage, 4469,
     /* 123180 */     GIR_EraseRootFromParent_Done,
     /* 123181 */   // Label 2282: @123181
     /* 123181 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(123225), // Rule ID 4501 //
     /* 123186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123204 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123207 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123223 */     GIR_RootConstrainSelectedInstOperands,
     /* 123224 */     // GIR_Coverage, 4501,
     /* 123224 */     GIR_EraseRootFromParent_Done,
     /* 123225 */   // Label 2283: @123225
     /* 123225 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(123269), // Rule ID 4505 //
     /* 123230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123248 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123251 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123267 */     GIR_RootConstrainSelectedInstOperands,
     /* 123268 */     // GIR_Coverage, 4505,
     /* 123268 */     GIR_EraseRootFromParent_Done,
     /* 123269 */   // Label 2284: @123269
     /* 123269 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(123313), // Rule ID 4525 //
     /* 123274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123292 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123295 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123311 */     GIR_RootConstrainSelectedInstOperands,
     /* 123312 */     // GIR_Coverage, 4525,
     /* 123312 */     GIR_EraseRootFromParent_Done,
     /* 123313 */   // Label 2285: @123313
     /* 123313 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(123357), // Rule ID 4529 //
     /* 123318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123336 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123339 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123355 */     GIR_RootConstrainSelectedInstOperands,
     /* 123356 */     // GIR_Coverage, 4529,
     /* 123356 */     GIR_EraseRootFromParent_Done,
     /* 123357 */   // Label 2286: @123357
     /* 123357 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(123401), // Rule ID 4530 //
     /* 123362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123380 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123383 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123399 */     GIR_RootConstrainSelectedInstOperands,
     /* 123400 */     // GIR_Coverage, 4530,
     /* 123400 */     GIR_EraseRootFromParent_Done,
     /* 123401 */   // Label 2287: @123401
     /* 123401 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(123421), // Rule ID 6401 //
     /* 123406 */     // MIs[0] Rn
     /* 123406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123414 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 123419 */     GIR_RootConstrainSelectedInstOperands,
     /* 123420 */     // GIR_Coverage, 6401,
     /* 123420 */     GIR_Done,
     /* 123421 */   // Label 2288: @123421
     /* 123421 */   GIM_Reject,
     /* 123422 */ // Label 2278: @123422
     /* 123422 */ GIM_Reject,
     /* 123423 */ // Label 2112: @123423
     /* 123423 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(123828),
     /* 123428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123435 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(123484), // Rule ID 4456 //
     /* 123440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123458 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123461 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123482 */     GIR_RootConstrainSelectedInstOperands,
     /* 123483 */     // GIR_Coverage, 4456,
     /* 123483 */     GIR_EraseRootFromParent_Done,
     /* 123484 */   // Label 2290: @123484
     /* 123484 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(123533), // Rule ID 4457 //
     /* 123489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123507 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123510 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123531 */     GIR_RootConstrainSelectedInstOperands,
     /* 123532 */     // GIR_Coverage, 4457,
     /* 123532 */     GIR_EraseRootFromParent_Done,
     /* 123533 */   // Label 2291: @123533
     /* 123533 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(123582), // Rule ID 4460 //
     /* 123538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123556 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123559 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123580 */     GIR_RootConstrainSelectedInstOperands,
     /* 123581 */     // GIR_Coverage, 4460,
     /* 123581 */     GIR_EraseRootFromParent_Done,
     /* 123582 */   // Label 2292: @123582
     /* 123582 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(123631), // Rule ID 4461 //
     /* 123587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123605 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123608 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123629 */     GIR_RootConstrainSelectedInstOperands,
     /* 123630 */     // GIR_Coverage, 4461,
     /* 123630 */     GIR_EraseRootFromParent_Done,
     /* 123631 */   // Label 2293: @123631
     /* 123631 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(123675), // Rule ID 4496 //
     /* 123636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123654 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123657 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123673 */     GIR_RootConstrainSelectedInstOperands,
     /* 123674 */     // GIR_Coverage, 4496,
     /* 123674 */     GIR_EraseRootFromParent_Done,
     /* 123675 */   // Label 2294: @123675
     /* 123675 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(123719), // Rule ID 4498 //
     /* 123680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123698 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123701 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123717 */     GIR_RootConstrainSelectedInstOperands,
     /* 123718 */     // GIR_Coverage, 4498,
     /* 123718 */     GIR_EraseRootFromParent_Done,
     /* 123719 */   // Label 2295: @123719
     /* 123719 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123763), // Rule ID 4520 //
     /* 123724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123742 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123745 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123761 */     GIR_RootConstrainSelectedInstOperands,
     /* 123762 */     // GIR_Coverage, 4520,
     /* 123762 */     GIR_EraseRootFromParent_Done,
     /* 123763 */   // Label 2296: @123763
     /* 123763 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123807), // Rule ID 4522 //
     /* 123768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123786 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123789 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123805 */     GIR_RootConstrainSelectedInstOperands,
     /* 123806 */     // GIR_Coverage, 4522,
     /* 123806 */     GIR_EraseRootFromParent_Done,
     /* 123807 */   // Label 2297: @123807
     /* 123807 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123827), // Rule ID 6403 //
     /* 123812 */     // MIs[0] Rn
     /* 123812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123820 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 123825 */     GIR_RootConstrainSelectedInstOperands,
     /* 123826 */     // GIR_Coverage, 6403,
     /* 123826 */     GIR_Done,
     /* 123827 */   // Label 2298: @123827
     /* 123827 */   GIM_Reject,
     /* 123828 */ // Label 2289: @123828
     /* 123828 */ GIM_Reject,
     /* 123829 */ // Label 2113: @123829
     /* 123829 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(124234),
     /* 123834 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123837 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123841 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123890), // Rule ID 4470 //
     /* 123846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123864 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123867 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123888 */     GIR_RootConstrainSelectedInstOperands,
     /* 123889 */     // GIR_Coverage, 4470,
     /* 123889 */     GIR_EraseRootFromParent_Done,
     /* 123890 */   // Label 2300: @123890
     /* 123890 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(123939), // Rule ID 4471 //
     /* 123895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123913 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123916 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123937 */     GIR_RootConstrainSelectedInstOperands,
     /* 123938 */     // GIR_Coverage, 4471,
     /* 123938 */     GIR_EraseRootFromParent_Done,
     /* 123939 */   // Label 2301: @123939
     /* 123939 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123988), // Rule ID 4472 //
     /* 123944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123962 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123965 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123986 */     GIR_RootConstrainSelectedInstOperands,
     /* 123987 */     // GIR_Coverage, 4472,
     /* 123987 */     GIR_EraseRootFromParent_Done,
     /* 123988 */   // Label 2302: @123988
     /* 123988 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(124037), // Rule ID 4473 //
     /* 123993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124011 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124014 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124035 */     GIR_RootConstrainSelectedInstOperands,
     /* 124036 */     // GIR_Coverage, 4473,
     /* 124036 */     GIR_EraseRootFromParent_Done,
     /* 124037 */   // Label 2303: @124037
     /* 124037 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(124081), // Rule ID 4500 //
     /* 124042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124060 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124063 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124079 */     GIR_RootConstrainSelectedInstOperands,
     /* 124080 */     // GIR_Coverage, 4500,
     /* 124080 */     GIR_EraseRootFromParent_Done,
     /* 124081 */   // Label 2304: @124081
     /* 124081 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(124125), // Rule ID 4504 //
     /* 124086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124104 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124107 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124123 */     GIR_RootConstrainSelectedInstOperands,
     /* 124124 */     // GIR_Coverage, 4504,
     /* 124124 */     GIR_EraseRootFromParent_Done,
     /* 124125 */   // Label 2305: @124125
     /* 124125 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(124169), // Rule ID 4524 //
     /* 124130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124148 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124151 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124167 */     GIR_RootConstrainSelectedInstOperands,
     /* 124168 */     // GIR_Coverage, 4524,
     /* 124168 */     GIR_EraseRootFromParent_Done,
     /* 124169 */   // Label 2306: @124169
     /* 124169 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(124213), // Rule ID 4528 //
     /* 124174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124192 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124195 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124211 */     GIR_RootConstrainSelectedInstOperands,
     /* 124212 */     // GIR_Coverage, 4528,
     /* 124212 */     GIR_EraseRootFromParent_Done,
     /* 124213 */   // Label 2307: @124213
     /* 124213 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(124233), // Rule ID 6400 //
     /* 124218 */     // MIs[0] Rn
     /* 124218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124226 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 124231 */     GIR_RootConstrainSelectedInstOperands,
     /* 124232 */     // GIR_Coverage, 6400,
     /* 124232 */     GIR_Done,
     /* 124233 */   // Label 2308: @124233
     /* 124233 */   GIM_Reject,
     /* 124234 */ // Label 2299: @124234
     /* 124234 */ GIM_Reject,
     /* 124235 */ // Label 2114: @124235
     /* 124235 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(124454),
     /* 124240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124243 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124247 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(124296), // Rule ID 4458 //
     /* 124252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124270 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 124273 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124294 */     GIR_RootConstrainSelectedInstOperands,
     /* 124295 */     // GIR_Coverage, 4458,
     /* 124295 */     GIR_EraseRootFromParent_Done,
     /* 124296 */   // Label 2310: @124296
     /* 124296 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(124345), // Rule ID 4459 //
     /* 124301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124319 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 124322 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124343 */     GIR_RootConstrainSelectedInstOperands,
     /* 124344 */     // GIR_Coverage, 4459,
     /* 124344 */     GIR_EraseRootFromParent_Done,
     /* 124345 */   // Label 2311: @124345
     /* 124345 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(124389), // Rule ID 4495 //
     /* 124350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124368 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 124371 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124387 */     GIR_RootConstrainSelectedInstOperands,
     /* 124388 */     // GIR_Coverage, 4495,
     /* 124388 */     GIR_EraseRootFromParent_Done,
     /* 124389 */   // Label 2312: @124389
     /* 124389 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(124433), // Rule ID 4519 //
     /* 124394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124412 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 124415 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124431 */     GIR_RootConstrainSelectedInstOperands,
     /* 124432 */     // GIR_Coverage, 4519,
     /* 124432 */     GIR_EraseRootFromParent_Done,
     /* 124433 */   // Label 2313: @124433
     /* 124433 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(124453), // Rule ID 6402 //
     /* 124438 */     // MIs[0] Rn
     /* 124438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124446 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 124451 */     GIR_RootConstrainSelectedInstOperands,
     /* 124452 */     // GIR_Coverage, 6402,
     /* 124452 */     GIR_Done,
     /* 124453 */   // Label 2314: @124453
     /* 124453 */   GIM_Reject,
     /* 124454 */ // Label 2309: @124454
     /* 124454 */ GIM_Reject,
     /* 124455 */ // Label 2115: @124455
     /* 124455 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(124860),
     /* 124460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124463 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124467 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(124516), // Rule ID 4474 //
     /* 124472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124490 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124493 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124514 */     GIR_RootConstrainSelectedInstOperands,
     /* 124515 */     // GIR_Coverage, 4474,
     /* 124515 */     GIR_EraseRootFromParent_Done,
     /* 124516 */   // Label 2316: @124516
     /* 124516 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(124565), // Rule ID 4475 //
     /* 124521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124539 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124542 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124563 */     GIR_RootConstrainSelectedInstOperands,
     /* 124564 */     // GIR_Coverage, 4475,
     /* 124564 */     GIR_EraseRootFromParent_Done,
     /* 124565 */   // Label 2317: @124565
     /* 124565 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(124614), // Rule ID 4478 //
     /* 124570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124588 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124591 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124612 */     GIR_RootConstrainSelectedInstOperands,
     /* 124613 */     // GIR_Coverage, 4478,
     /* 124613 */     GIR_EraseRootFromParent_Done,
     /* 124614 */   // Label 2318: @124614
     /* 124614 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(124663), // Rule ID 4479 //
     /* 124619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124637 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124640 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124661 */     GIR_RootConstrainSelectedInstOperands,
     /* 124662 */     // GIR_Coverage, 4479,
     /* 124662 */     GIR_EraseRootFromParent_Done,
     /* 124663 */   // Label 2319: @124663
     /* 124663 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(124707), // Rule ID 4503 //
     /* 124668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124686 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124689 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124705 */     GIR_RootConstrainSelectedInstOperands,
     /* 124706 */     // GIR_Coverage, 4503,
     /* 124706 */     GIR_EraseRootFromParent_Done,
     /* 124707 */   // Label 2320: @124707
     /* 124707 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124751), // Rule ID 4506 //
     /* 124712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124730 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124733 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124749 */     GIR_RootConstrainSelectedInstOperands,
     /* 124750 */     // GIR_Coverage, 4506,
     /* 124750 */     GIR_EraseRootFromParent_Done,
     /* 124751 */   // Label 2321: @124751
     /* 124751 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124795), // Rule ID 4527 //
     /* 124756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124774 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124777 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124793 */     GIR_RootConstrainSelectedInstOperands,
     /* 124794 */     // GIR_Coverage, 4527,
     /* 124794 */     GIR_EraseRootFromParent_Done,
     /* 124795 */   // Label 2322: @124795
     /* 124795 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124839), // Rule ID 4531 //
     /* 124800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124818 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124821 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 124838 */     // GIR_Coverage, 4531,
     /* 124838 */     GIR_EraseRootFromParent_Done,
     /* 124839 */   // Label 2323: @124839
     /* 124839 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124859), // Rule ID 6399 //
     /* 124844 */     // MIs[0] Rn
     /* 124844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124852 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124857 */     GIR_RootConstrainSelectedInstOperands,
     /* 124858 */     // GIR_Coverage, 6399,
     /* 124858 */     GIR_Done,
     /* 124859 */   // Label 2324: @124859
     /* 124859 */   GIM_Reject,
     /* 124860 */ // Label 2315: @124860
     /* 124860 */ GIM_Reject,
     /* 124861 */ // Label 2116: @124861
     /* 124861 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(125080),
     /* 124866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124873 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124922), // Rule ID 4476 //
     /* 124878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124896 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124899 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124920 */     GIR_RootConstrainSelectedInstOperands,
     /* 124921 */     // GIR_Coverage, 4476,
     /* 124921 */     GIR_EraseRootFromParent_Done,
     /* 124922 */   // Label 2326: @124922
     /* 124922 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(124971), // Rule ID 4477 //
     /* 124927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124945 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124948 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124969 */     GIR_RootConstrainSelectedInstOperands,
     /* 124970 */     // GIR_Coverage, 4477,
     /* 124970 */     GIR_EraseRootFromParent_Done,
     /* 124971 */   // Label 2327: @124971
     /* 124971 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(125015), // Rule ID 4502 //
     /* 124976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124994 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124997 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125013 */     GIR_RootConstrainSelectedInstOperands,
     /* 125014 */     // GIR_Coverage, 4502,
     /* 125014 */     GIR_EraseRootFromParent_Done,
     /* 125015 */   // Label 2328: @125015
     /* 125015 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(125059), // Rule ID 4526 //
     /* 125020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125038 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 125041 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 125043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125057 */     GIR_RootConstrainSelectedInstOperands,
     /* 125058 */     // GIR_Coverage, 4526,
     /* 125058 */     GIR_EraseRootFromParent_Done,
     /* 125059 */   // Label 2329: @125059
     /* 125059 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(125079), // Rule ID 6398 //
     /* 125064 */     // MIs[0] Rn
     /* 125064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125072 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 125072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 125077 */     GIR_RootConstrainSelectedInstOperands,
     /* 125078 */     // GIR_Coverage, 6398,
     /* 125078 */     GIR_Done,
     /* 125079 */   // Label 2330: @125079
     /* 125079 */   GIM_Reject,
     /* 125080 */ // Label 2325: @125080
     /* 125080 */ GIM_Reject,
     /* 125081 */ // Label 2117: @125081
     /* 125081 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(125140), // Rule ID 10850 //
     /* 125086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125096 */   // MIs[0] base
     /* 125096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125104 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125116 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 125124 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125129 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125138 */   GIR_RootConstrainSelectedInstOperands,
     /* 125139 */   // GIR_Coverage, 10850,
     /* 125139 */   GIR_EraseRootFromParent_Done,
     /* 125140 */ // Label 2331: @125140
     /* 125140 */ GIM_Reject,
     /* 125141 */ // Label 2118: @125141
     /* 125141 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(125200), // Rule ID 10856 //
     /* 125146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125156 */   // MIs[0] base
     /* 125156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125164 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125176 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 125184 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125189 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125198 */   GIR_RootConstrainSelectedInstOperands,
     /* 125199 */   // GIR_Coverage, 10856,
     /* 125199 */   GIR_EraseRootFromParent_Done,
     /* 125200 */ // Label 2332: @125200
     /* 125200 */ GIM_Reject,
     /* 125201 */ // Label 2119: @125201
     /* 125201 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(125370),
     /* 125206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(125265), // Rule ID 10841 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125229 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125249 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125254 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125263 */     GIR_RootConstrainSelectedInstOperands,
     /* 125264 */     // GIR_Coverage, 10841,
     /* 125264 */     GIR_EraseRootFromParent_Done,
     /* 125265 */   // Label 2334: @125265
     /* 125265 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(125313), // Rule ID 10859 //
     /* 125270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125277 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 125284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 125297 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125302 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125311 */     GIR_RootConstrainSelectedInstOperands,
     /* 125312 */     // GIR_Coverage, 10859,
     /* 125312 */     GIR_EraseRootFromParent_Done,
     /* 125313 */   // Label 2335: @125313
     /* 125313 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(125341), // Rule ID 10971 //
     /* 125318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125325 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125328 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125330 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125339 */     GIR_RootConstrainSelectedInstOperands,
     /* 125340 */     // GIR_Coverage, 10971,
     /* 125340 */     GIR_EraseRootFromParent_Done,
     /* 125341 */   // Label 2336: @125341
     /* 125341 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(125369), // Rule ID 10983 //
     /* 125346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125353 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125356 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125358 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125367 */     GIR_RootConstrainSelectedInstOperands,
     /* 125368 */     // GIR_Coverage, 10983,
     /* 125368 */     GIR_EraseRootFromParent_Done,
     /* 125369 */   // Label 2337: @125369
     /* 125369 */   GIM_Reject,
     /* 125370 */ // Label 2333: @125370
     /* 125370 */ GIM_Reject,
     /* 125371 */ // Label 2120: @125371
     /* 125371 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(125430), // Rule ID 10847 //
     /* 125376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125386 */   // MIs[0] base
     /* 125386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125394 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125406 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 125414 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125419 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125428 */   GIR_RootConstrainSelectedInstOperands,
     /* 125429 */   // GIR_Coverage, 10847,
     /* 125429 */   GIR_EraseRootFromParent_Done,
     /* 125430 */ // Label 2338: @125430
     /* 125430 */ GIM_Reject,
     /* 125431 */ // Label 2121: @125431
     /* 125431 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(125600),
     /* 125436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125447 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(125495), // Rule ID 10835 //
     /* 125452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125459 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125479 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125484 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125493 */     GIR_RootConstrainSelectedInstOperands,
     /* 125494 */     // GIR_Coverage, 10835,
     /* 125494 */     GIR_EraseRootFromParent_Done,
     /* 125495 */   // Label 2340: @125495
     /* 125495 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(125543), // Rule ID 10853 //
     /* 125500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125507 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125527 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125532 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125541 */     GIR_RootConstrainSelectedInstOperands,
     /* 125542 */     // GIR_Coverage, 10853,
     /* 125542 */     GIR_EraseRootFromParent_Done,
     /* 125543 */   // Label 2341: @125543
     /* 125543 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(125571), // Rule ID 10967 //
     /* 125548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125555 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125558 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125560 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125569 */     GIR_RootConstrainSelectedInstOperands,
     /* 125570 */     // GIR_Coverage, 10967,
     /* 125570 */     GIR_EraseRootFromParent_Done,
     /* 125571 */   // Label 2342: @125571
     /* 125571 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(125599), // Rule ID 10979 //
     /* 125576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125583 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125586 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125588 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125597 */     GIR_RootConstrainSelectedInstOperands,
     /* 125598 */     // GIR_Coverage, 10979,
     /* 125598 */     GIR_EraseRootFromParent_Done,
     /* 125599 */   // Label 2343: @125599
     /* 125599 */   GIM_Reject,
     /* 125600 */ // Label 2339: @125600
     /* 125600 */ GIM_Reject,
     /* 125601 */ // Label 2122: @125601
     /* 125601 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(125770),
     /* 125606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125609 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125617 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(125665), // Rule ID 10826 //
     /* 125622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125629 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125649 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125654 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125663 */     GIR_RootConstrainSelectedInstOperands,
     /* 125664 */     // GIR_Coverage, 10826,
     /* 125664 */     GIR_EraseRootFromParent_Done,
     /* 125665 */   // Label 2345: @125665
     /* 125665 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(125713), // Rule ID 10844 //
     /* 125670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125677 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125689 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125697 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125702 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125711 */     GIR_RootConstrainSelectedInstOperands,
     /* 125712 */     // GIR_Coverage, 10844,
     /* 125712 */     GIR_EraseRootFromParent_Done,
     /* 125713 */   // Label 2346: @125713
     /* 125713 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125741), // Rule ID 10963 //
     /* 125718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125725 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125728 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125730 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125739 */     GIR_RootConstrainSelectedInstOperands,
     /* 125740 */     // GIR_Coverage, 10963,
     /* 125740 */     GIR_EraseRootFromParent_Done,
     /* 125741 */   // Label 2347: @125741
     /* 125741 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125769), // Rule ID 10975 //
     /* 125746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125753 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125756 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125758 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125767 */     GIR_RootConstrainSelectedInstOperands,
     /* 125768 */     // GIR_Coverage, 10975,
     /* 125768 */     GIR_EraseRootFromParent_Done,
     /* 125769 */   // Label 2348: @125769
     /* 125769 */   GIM_Reject,
     /* 125770 */ // Label 2344: @125770
     /* 125770 */ GIM_Reject,
     /* 125771 */ // Label 2123: @125771
     /* 125771 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125814), // Rule ID 2430 //
     /* 125776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 125790 */   // MIs[0] base
     /* 125790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125798 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 125801 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 125803 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125812 */   GIR_RootConstrainSelectedInstOperands,
     /* 125813 */   // GIR_Coverage, 2430,
     /* 125813 */   GIR_EraseRootFromParent_Done,
     /* 125814 */ // Label 2349: @125814
     /* 125814 */ GIM_Reject,
     /* 125815 */ // Label 2124: @125815
     /* 125815 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(125908),
     /* 125820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125831 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(125879), // Rule ID 10812 //
     /* 125836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125843 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125863 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125868 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125877 */     GIR_RootConstrainSelectedInstOperands,
     /* 125878 */     // GIR_Coverage, 10812,
     /* 125878 */     GIR_EraseRootFromParent_Done,
     /* 125879 */   // Label 2351: @125879
     /* 125879 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(125907), // Rule ID 10959 //
     /* 125884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125891 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125894 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125896 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125905 */     GIR_RootConstrainSelectedInstOperands,
     /* 125906 */     // GIR_Coverage, 10959,
     /* 125906 */     GIR_EraseRootFromParent_Done,
     /* 125907 */   // Label 2352: @125907
     /* 125907 */   GIM_Reject,
     /* 125908 */ // Label 2350: @125908
     /* 125908 */ GIM_Reject,
     /* 125909 */ // Label 2125: @125909
     /* 125909 */ GIM_Reject,
     /* 125910 */ // Label 20: @125910
     /* 125910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2355*/ GIMT_Encode4(127260),
     /* 125921 */ /*GILLT_s32*//*Label 2353*/ GIMT_Encode4(125929),
     /* 125925 */ /*GILLT_s64*//*Label 2354*/ GIMT_Encode4(126947),
     /* 125929 */ // Label 2353: @125929
     /* 125929 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(126946),
     /* 125934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125940 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(125995), // Rule ID 7302 //
     /* 125945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125962 */     // MIs[0] Rn
     /* 125962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125978 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 125981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125993 */     GIR_RootConstrainSelectedInstOperands,
     /* 125994 */     // GIR_Coverage, 7302,
     /* 125994 */     GIR_EraseRootFromParent_Done,
     /* 125995 */   // Label 2357: @125995
     /* 125995 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(126050), // Rule ID 7303 //
     /* 126000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126017 */     // MIs[0] Rn
     /* 126017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126033 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 126036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126048 */     GIR_RootConstrainSelectedInstOperands,
     /* 126049 */     // GIR_Coverage, 7303,
     /* 126049 */     GIR_EraseRootFromParent_Done,
     /* 126050 */   // Label 2358: @126050
     /* 126050 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(126105), // Rule ID 7304 //
     /* 126055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126072 */     // MIs[0] Rn
     /* 126072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126088 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 126091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126103 */     GIR_RootConstrainSelectedInstOperands,
     /* 126104 */     // GIR_Coverage, 7304,
     /* 126104 */     GIR_EraseRootFromParent_Done,
     /* 126105 */   // Label 2359: @126105
     /* 126105 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(126160), // Rule ID 7305 //
     /* 126110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126113 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126127 */     // MIs[0] Rn
     /* 126127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126143 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126158 */     GIR_RootConstrainSelectedInstOperands,
     /* 126159 */     // GIR_Coverage, 7305,
     /* 126159 */     GIR_EraseRootFromParent_Done,
     /* 126160 */   // Label 2360: @126160
     /* 126160 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(126215), // Rule ID 7306 //
     /* 126165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126168 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126182 */     // MIs[0] Rn
     /* 126182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126198 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 126201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126213 */     GIR_RootConstrainSelectedInstOperands,
     /* 126214 */     // GIR_Coverage, 7306,
     /* 126214 */     GIR_EraseRootFromParent_Done,
     /* 126215 */   // Label 2361: @126215
     /* 126215 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(126270), // Rule ID 7307 //
     /* 126220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126237 */     // MIs[0] Rn
     /* 126237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126253 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 126256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126268 */     GIR_RootConstrainSelectedInstOperands,
     /* 126269 */     // GIR_Coverage, 7307,
     /* 126269 */     GIR_EraseRootFromParent_Done,
     /* 126270 */   // Label 2362: @126270
     /* 126270 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(126325), // Rule ID 7308 //
     /* 126275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126292 */     // MIs[0] Rn
     /* 126292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126308 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 126311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126323 */     GIR_RootConstrainSelectedInstOperands,
     /* 126324 */     // GIR_Coverage, 7308,
     /* 126324 */     GIR_EraseRootFromParent_Done,
     /* 126325 */   // Label 2363: @126325
     /* 126325 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(126380), // Rule ID 7309 //
     /* 126330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126347 */     // MIs[0] Rn
     /* 126347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126363 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 126366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126378 */     GIR_RootConstrainSelectedInstOperands,
     /* 126379 */     // GIR_Coverage, 7309,
     /* 126379 */     GIR_EraseRootFromParent_Done,
     /* 126380 */   // Label 2364: @126380
     /* 126380 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(126435), // Rule ID 7310 //
     /* 126385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126402 */     // MIs[0] Rn
     /* 126402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126418 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126433 */     GIR_RootConstrainSelectedInstOperands,
     /* 126434 */     // GIR_Coverage, 7310,
     /* 126434 */     GIR_EraseRootFromParent_Done,
     /* 126435 */   // Label 2365: @126435
     /* 126435 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(126490), // Rule ID 7311 //
     /* 126440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126457 */     // MIs[0] Rn
     /* 126457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126473 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126488 */     GIR_RootConstrainSelectedInstOperands,
     /* 126489 */     // GIR_Coverage, 7311,
     /* 126489 */     GIR_EraseRootFromParent_Done,
     /* 126490 */   // Label 2366: @126490
     /* 126490 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(126545), // Rule ID 7312 //
     /* 126495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126512 */     // MIs[0] Rn
     /* 126512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126528 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 126531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126543 */     GIR_RootConstrainSelectedInstOperands,
     /* 126544 */     // GIR_Coverage, 7312,
     /* 126544 */     GIR_EraseRootFromParent_Done,
     /* 126545 */   // Label 2367: @126545
     /* 126545 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(126600), // Rule ID 7313 //
     /* 126550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126560 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126567 */     // MIs[0] Rn
     /* 126567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126583 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 126586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126598 */     GIR_RootConstrainSelectedInstOperands,
     /* 126599 */     // GIR_Coverage, 7313,
     /* 126599 */     GIR_EraseRootFromParent_Done,
     /* 126600 */   // Label 2368: @126600
     /* 126600 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(126655), // Rule ID 7314 //
     /* 126605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126622 */     // MIs[0] Rn
     /* 126622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126638 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 126641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126653 */     GIR_RootConstrainSelectedInstOperands,
     /* 126654 */     // GIR_Coverage, 7314,
     /* 126654 */     GIR_EraseRootFromParent_Done,
     /* 126655 */   // Label 2369: @126655
     /* 126655 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126710), // Rule ID 7315 //
     /* 126660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126677 */     // MIs[0] Rn
     /* 126677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126693 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126708 */     GIR_RootConstrainSelectedInstOperands,
     /* 126709 */     // GIR_Coverage, 7315,
     /* 126709 */     GIR_EraseRootFromParent_Done,
     /* 126710 */   // Label 2370: @126710
     /* 126710 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126765), // Rule ID 7316 //
     /* 126715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126732 */     // MIs[0] Rn
     /* 126732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126748 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126763 */     GIR_RootConstrainSelectedInstOperands,
     /* 126764 */     // GIR_Coverage, 7316,
     /* 126764 */     GIR_EraseRootFromParent_Done,
     /* 126765 */   // Label 2371: @126765
     /* 126765 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126825), // Rule ID 13099 //
     /* 126770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126784 */     // MIs[0] addr
     /* 126784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126800 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 126806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126808 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126813 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126815 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126817 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126823 */     GIR_RootConstrainSelectedInstOperands,
     /* 126824 */     // GIR_Coverage, 13099,
     /* 126824 */     GIR_EraseRootFromParent_Done,
     /* 126825 */   // Label 2372: @126825
     /* 126825 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126885), // Rule ID 13100 //
     /* 126830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126844 */     // MIs[0] addr
     /* 126844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126860 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126868 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126873 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126875 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126877 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126883 */     GIR_RootConstrainSelectedInstOperands,
     /* 126884 */     // GIR_Coverage, 13100,
     /* 126884 */     GIR_EraseRootFromParent_Done,
     /* 126885 */   // Label 2373: @126885
     /* 126885 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126945), // Rule ID 13101 //
     /* 126890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126904 */     // MIs[0] addr
     /* 126904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126920 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 126926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126928 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126933 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126935 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126937 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126943 */     GIR_RootConstrainSelectedInstOperands,
     /* 126944 */     // GIR_Coverage, 13101,
     /* 126944 */     GIR_EraseRootFromParent_Done,
     /* 126945 */   // Label 2374: @126945
     /* 126945 */   GIM_Reject,
     /* 126946 */ // Label 2356: @126946
     /* 126946 */ GIM_Reject,
     /* 126947 */ // Label 2354: @126947
     /* 126947 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(127259),
     /* 126952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 126958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126965 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(127013), // Rule ID 2589 //
     /* 126970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126980 */     // MIs[0] Rn
     /* 126980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126996 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 126999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127011 */     GIR_RootConstrainSelectedInstOperands,
     /* 127012 */     // GIR_Coverage, 2589,
     /* 127012 */     GIR_EraseRootFromParent_Done,
     /* 127013 */   // Label 2376: @127013
     /* 127013 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(127061), // Rule ID 2590 //
     /* 127018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127028 */     // MIs[0] Rn
     /* 127028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127044 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 127047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127059 */     GIR_RootConstrainSelectedInstOperands,
     /* 127060 */     // GIR_Coverage, 2590,
     /* 127060 */     GIR_EraseRootFromParent_Done,
     /* 127061 */   // Label 2377: @127061
     /* 127061 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(127109), // Rule ID 2591 //
     /* 127066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127076 */     // MIs[0] Rn
     /* 127076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127092 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 127095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127107 */     GIR_RootConstrainSelectedInstOperands,
     /* 127108 */     // GIR_Coverage, 2591,
     /* 127108 */     GIR_EraseRootFromParent_Done,
     /* 127109 */   // Label 2378: @127109
     /* 127109 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(127157), // Rule ID 2592 //
     /* 127114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127117 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127124 */     // MIs[0] Rn
     /* 127124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127140 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127155 */     GIR_RootConstrainSelectedInstOperands,
     /* 127156 */     // GIR_Coverage, 2592,
     /* 127156 */     GIR_EraseRootFromParent_Done,
     /* 127157 */   // Label 2379: @127157
     /* 127157 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(127205), // Rule ID 2593 //
     /* 127162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127172 */     // MIs[0] Rn
     /* 127172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127188 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 127188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 127191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 127193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 127195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 127197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127203 */     GIR_RootConstrainSelectedInstOperands,
     /* 127204 */     // GIR_Coverage, 2593,
     /* 127204 */     GIR_EraseRootFromParent_Done,
     /* 127205 */   // Label 2380: @127205
     /* 127205 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(127258), // Rule ID 13102 //
     /* 127210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 127213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127217 */     // MIs[0] addr
     /* 127217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127233 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 127233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 127239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127241 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 127246 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 127248 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 127250 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 127252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127256 */     GIR_RootConstrainSelectedInstOperands,
     /* 127257 */     // GIR_Coverage, 13102,
     /* 127257 */     GIR_EraseRootFromParent_Done,
     /* 127258 */   // Label 2381: @127258
     /* 127258 */   GIM_Reject,
     /* 127259 */ // Label 2375: @127259
     /* 127259 */ GIM_Reject,
     /* 127260 */ // Label 2355: @127260
     /* 127260 */ GIM_Reject,
     /* 127261 */ // Label 21: @127261
     /* 127261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2384*/ GIMT_Encode4(128252),
     /* 127272 */ /*GILLT_s32*//*Label 2382*/ GIMT_Encode4(127280),
     /* 127276 */ /*GILLT_s64*//*Label 2383*/ GIMT_Encode4(128025),
     /* 127280 */ // Label 2382: @127280
     /* 127280 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(128024),
     /* 127285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127288 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(127337), // Rule ID 7287 //
     /* 127293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127310 */     // MIs[0] Rn
     /* 127310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127322 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 127325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127335 */     GIR_RootConstrainSelectedInstOperands,
     /* 127336 */     // GIR_Coverage, 7287,
     /* 127336 */     GIR_EraseRootFromParent_Done,
     /* 127337 */   // Label 2386: @127337
     /* 127337 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(127386), // Rule ID 7288 //
     /* 127342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127345 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127352 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127359 */     // MIs[0] Rn
     /* 127359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127371 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 127374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127384 */     GIR_RootConstrainSelectedInstOperands,
     /* 127385 */     // GIR_Coverage, 7288,
     /* 127385 */     GIR_EraseRootFromParent_Done,
     /* 127386 */   // Label 2387: @127386
     /* 127386 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(127435), // Rule ID 7289 //
     /* 127391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127408 */     // MIs[0] Rn
     /* 127408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127420 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 127423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127433 */     GIR_RootConstrainSelectedInstOperands,
     /* 127434 */     // GIR_Coverage, 7289,
     /* 127434 */     GIR_EraseRootFromParent_Done,
     /* 127435 */   // Label 2388: @127435
     /* 127435 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(127484), // Rule ID 7290 //
     /* 127440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127457 */     // MIs[0] Rn
     /* 127457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127469 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127482 */     GIR_RootConstrainSelectedInstOperands,
     /* 127483 */     // GIR_Coverage, 7290,
     /* 127483 */     GIR_EraseRootFromParent_Done,
     /* 127484 */   // Label 2389: @127484
     /* 127484 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(127533), // Rule ID 7291 //
     /* 127489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127506 */     // MIs[0] Rn
     /* 127506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127518 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127531 */     GIR_RootConstrainSelectedInstOperands,
     /* 127532 */     // GIR_Coverage, 7291,
     /* 127532 */     GIR_EraseRootFromParent_Done,
     /* 127533 */   // Label 2390: @127533
     /* 127533 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(127582), // Rule ID 7292 //
     /* 127538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127555 */     // MIs[0] Rn
     /* 127555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127567 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 127570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127580 */     GIR_RootConstrainSelectedInstOperands,
     /* 127581 */     // GIR_Coverage, 7292,
     /* 127581 */     GIR_EraseRootFromParent_Done,
     /* 127582 */   // Label 2391: @127582
     /* 127582 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(127631), // Rule ID 7293 //
     /* 127587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127604 */     // MIs[0] Rn
     /* 127604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127616 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 127619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127629 */     GIR_RootConstrainSelectedInstOperands,
     /* 127630 */     // GIR_Coverage, 7293,
     /* 127630 */     GIR_EraseRootFromParent_Done,
     /* 127631 */   // Label 2392: @127631
     /* 127631 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(127680), // Rule ID 7294 //
     /* 127636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127653 */     // MIs[0] Rn
     /* 127653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127665 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 127668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127678 */     GIR_RootConstrainSelectedInstOperands,
     /* 127679 */     // GIR_Coverage, 7294,
     /* 127679 */     GIR_EraseRootFromParent_Done,
     /* 127680 */   // Label 2393: @127680
     /* 127680 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127729), // Rule ID 7295 //
     /* 127685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127702 */     // MIs[0] Rn
     /* 127702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127714 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127727 */     GIR_RootConstrainSelectedInstOperands,
     /* 127728 */     // GIR_Coverage, 7295,
     /* 127728 */     GIR_EraseRootFromParent_Done,
     /* 127729 */   // Label 2394: @127729
     /* 127729 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127778), // Rule ID 7296 //
     /* 127734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127751 */     // MIs[0] Rn
     /* 127751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127763 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127776 */     GIR_RootConstrainSelectedInstOperands,
     /* 127777 */     // GIR_Coverage, 7296,
     /* 127777 */     GIR_EraseRootFromParent_Done,
     /* 127778 */   // Label 2395: @127778
     /* 127778 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127827), // Rule ID 7297 //
     /* 127783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127800 */     // MIs[0] Rn
     /* 127800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127812 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 127815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127825 */     GIR_RootConstrainSelectedInstOperands,
     /* 127826 */     // GIR_Coverage, 7297,
     /* 127826 */     GIR_EraseRootFromParent_Done,
     /* 127827 */   // Label 2396: @127827
     /* 127827 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127876), // Rule ID 7298 //
     /* 127832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127849 */     // MIs[0] Rn
     /* 127849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127861 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127874 */     GIR_RootConstrainSelectedInstOperands,
     /* 127875 */     // GIR_Coverage, 7298,
     /* 127875 */     GIR_EraseRootFromParent_Done,
     /* 127876 */   // Label 2397: @127876
     /* 127876 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127925), // Rule ID 7299 //
     /* 127881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127898 */     // MIs[0] Rn
     /* 127898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127910 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 127913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127923 */     GIR_RootConstrainSelectedInstOperands,
     /* 127924 */     // GIR_Coverage, 7299,
     /* 127924 */     GIR_EraseRootFromParent_Done,
     /* 127925 */   // Label 2398: @127925
     /* 127925 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127974), // Rule ID 7300 //
     /* 127930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127947 */     // MIs[0] Rn
     /* 127947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127959 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127972 */     GIR_RootConstrainSelectedInstOperands,
     /* 127973 */     // GIR_Coverage, 7300,
     /* 127973 */     GIR_EraseRootFromParent_Done,
     /* 127974 */   // Label 2399: @127974
     /* 127974 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(128023), // Rule ID 7301 //
     /* 127979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127996 */     // MIs[0] Rn
     /* 127996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128008 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 128011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128021 */     GIR_RootConstrainSelectedInstOperands,
     /* 128022 */     // GIR_Coverage, 7301,
     /* 128022 */     GIR_EraseRootFromParent_Done,
     /* 128023 */   // Label 2400: @128023
     /* 128023 */   GIM_Reject,
     /* 128024 */ // Label 2385: @128024
     /* 128024 */ GIM_Reject,
     /* 128025 */ // Label 2383: @128025
     /* 128025 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(128251),
     /* 128030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128033 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128040 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(128082), // Rule ID 7282 //
     /* 128045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128055 */     // MIs[0] Rn
     /* 128055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128067 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 128070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128080 */     GIR_RootConstrainSelectedInstOperands,
     /* 128081 */     // GIR_Coverage, 7282,
     /* 128081 */     GIR_EraseRootFromParent_Done,
     /* 128082 */   // Label 2402: @128082
     /* 128082 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(128124), // Rule ID 7283 //
     /* 128087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128097 */     // MIs[0] Rn
     /* 128097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128109 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 128112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128122 */     GIR_RootConstrainSelectedInstOperands,
     /* 128123 */     // GIR_Coverage, 7283,
     /* 128123 */     GIR_EraseRootFromParent_Done,
     /* 128124 */   // Label 2403: @128124
     /* 128124 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(128166), // Rule ID 7284 //
     /* 128129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128139 */     // MIs[0] Rn
     /* 128139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128151 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 128154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128164 */     GIR_RootConstrainSelectedInstOperands,
     /* 128165 */     // GIR_Coverage, 7284,
     /* 128165 */     GIR_EraseRootFromParent_Done,
     /* 128166 */   // Label 2404: @128166
     /* 128166 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(128208), // Rule ID 7285 //
     /* 128171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128181 */     // MIs[0] Rn
     /* 128181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128193 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128206 */     GIR_RootConstrainSelectedInstOperands,
     /* 128207 */     // GIR_Coverage, 7285,
     /* 128207 */     GIR_EraseRootFromParent_Done,
     /* 128208 */   // Label 2405: @128208
     /* 128208 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(128250), // Rule ID 7286 //
     /* 128213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128223 */     // MIs[0] Rn
     /* 128223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128235 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 128238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128248 */     GIR_RootConstrainSelectedInstOperands,
     /* 128249 */     // GIR_Coverage, 7286,
     /* 128249 */     GIR_EraseRootFromParent_Done,
     /* 128250 */   // Label 2406: @128250
     /* 128250 */   GIM_Reject,
     /* 128251 */ // Label 2401: @128251
     /* 128251 */ GIM_Reject,
     /* 128252 */ // Label 2384: @128252
     /* 128252 */ GIM_Reject,
     /* 128253 */ // Label 22: @128253
     /* 128253 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2409*/ GIMT_Encode4(129244),
     /* 128264 */ /*GILLT_s32*//*Label 2407*/ GIMT_Encode4(128272),
     /* 128268 */ /*GILLT_s64*//*Label 2408*/ GIMT_Encode4(129017),
     /* 128272 */ // Label 2407: @128272
     /* 128272 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(129016),
     /* 128277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128280 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(128329), // Rule ID 7127 //
     /* 128285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128302 */     // MIs[0] Rn
     /* 128302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128314 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128327 */     GIR_RootConstrainSelectedInstOperands,
     /* 128328 */     // GIR_Coverage, 7127,
     /* 128328 */     GIR_EraseRootFromParent_Done,
     /* 128329 */   // Label 2411: @128329
     /* 128329 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(128378), // Rule ID 7128 //
     /* 128334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128351 */     // MIs[0] Rn
     /* 128351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128363 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128376 */     GIR_RootConstrainSelectedInstOperands,
     /* 128377 */     // GIR_Coverage, 7128,
     /* 128377 */     GIR_EraseRootFromParent_Done,
     /* 128378 */   // Label 2412: @128378
     /* 128378 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(128427), // Rule ID 7129 //
     /* 128383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128400 */     // MIs[0] Rn
     /* 128400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128412 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128425 */     GIR_RootConstrainSelectedInstOperands,
     /* 128426 */     // GIR_Coverage, 7129,
     /* 128426 */     GIR_EraseRootFromParent_Done,
     /* 128427 */   // Label 2413: @128427
     /* 128427 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(128476), // Rule ID 7130 //
     /* 128432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128449 */     // MIs[0] Rn
     /* 128449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128461 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128474 */     GIR_RootConstrainSelectedInstOperands,
     /* 128475 */     // GIR_Coverage, 7130,
     /* 128475 */     GIR_EraseRootFromParent_Done,
     /* 128476 */   // Label 2414: @128476
     /* 128476 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(128525), // Rule ID 7131 //
     /* 128481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128498 */     // MIs[0] Rn
     /* 128498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128510 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128523 */     GIR_RootConstrainSelectedInstOperands,
     /* 128524 */     // GIR_Coverage, 7131,
     /* 128524 */     GIR_EraseRootFromParent_Done,
     /* 128525 */   // Label 2415: @128525
     /* 128525 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(128574), // Rule ID 7132 //
     /* 128530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128547 */     // MIs[0] Rn
     /* 128547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128559 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128572 */     GIR_RootConstrainSelectedInstOperands,
     /* 128573 */     // GIR_Coverage, 7132,
     /* 128573 */     GIR_EraseRootFromParent_Done,
     /* 128574 */   // Label 2416: @128574
     /* 128574 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(128623), // Rule ID 7133 //
     /* 128579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128596 */     // MIs[0] Rn
     /* 128596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128608 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128621 */     GIR_RootConstrainSelectedInstOperands,
     /* 128622 */     // GIR_Coverage, 7133,
     /* 128622 */     GIR_EraseRootFromParent_Done,
     /* 128623 */   // Label 2417: @128623
     /* 128623 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(128672), // Rule ID 7134 //
     /* 128628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128645 */     // MIs[0] Rn
     /* 128645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128657 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128670 */     GIR_RootConstrainSelectedInstOperands,
     /* 128671 */     // GIR_Coverage, 7134,
     /* 128671 */     GIR_EraseRootFromParent_Done,
     /* 128672 */   // Label 2418: @128672
     /* 128672 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128721), // Rule ID 7135 //
     /* 128677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128694 */     // MIs[0] Rn
     /* 128694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128706 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128719 */     GIR_RootConstrainSelectedInstOperands,
     /* 128720 */     // GIR_Coverage, 7135,
     /* 128720 */     GIR_EraseRootFromParent_Done,
     /* 128721 */   // Label 2419: @128721
     /* 128721 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128770), // Rule ID 7136 //
     /* 128726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128743 */     // MIs[0] Rn
     /* 128743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128755 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128768 */     GIR_RootConstrainSelectedInstOperands,
     /* 128769 */     // GIR_Coverage, 7136,
     /* 128769 */     GIR_EraseRootFromParent_Done,
     /* 128770 */   // Label 2420: @128770
     /* 128770 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128819), // Rule ID 7137 //
     /* 128775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128792 */     // MIs[0] Rn
     /* 128792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128804 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 128807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128817 */     GIR_RootConstrainSelectedInstOperands,
     /* 128818 */     // GIR_Coverage, 7137,
     /* 128818 */     GIR_EraseRootFromParent_Done,
     /* 128819 */   // Label 2421: @128819
     /* 128819 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128868), // Rule ID 7138 //
     /* 128824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128841 */     // MIs[0] Rn
     /* 128841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128853 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128866 */     GIR_RootConstrainSelectedInstOperands,
     /* 128867 */     // GIR_Coverage, 7138,
     /* 128867 */     GIR_EraseRootFromParent_Done,
     /* 128868 */   // Label 2422: @128868
     /* 128868 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128917), // Rule ID 7139 //
     /* 128873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128890 */     // MIs[0] Rn
     /* 128890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128902 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128915 */     GIR_RootConstrainSelectedInstOperands,
     /* 128916 */     // GIR_Coverage, 7139,
     /* 128916 */     GIR_EraseRootFromParent_Done,
     /* 128917 */   // Label 2423: @128917
     /* 128917 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128966), // Rule ID 7140 //
     /* 128922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128939 */     // MIs[0] Rn
     /* 128939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128951 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128964 */     GIR_RootConstrainSelectedInstOperands,
     /* 128965 */     // GIR_Coverage, 7140,
     /* 128965 */     GIR_EraseRootFromParent_Done,
     /* 128966 */   // Label 2424: @128966
     /* 128966 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(129015), // Rule ID 7141 //
     /* 128971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128988 */     // MIs[0] Rn
     /* 128988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129000 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129013 */     GIR_RootConstrainSelectedInstOperands,
     /* 129014 */     // GIR_Coverage, 7141,
     /* 129014 */     GIR_EraseRootFromParent_Done,
     /* 129015 */   // Label 2425: @129015
     /* 129015 */   GIM_Reject,
     /* 129016 */ // Label 2410: @129016
     /* 129016 */ GIM_Reject,
     /* 129017 */ // Label 2408: @129017
     /* 129017 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(129243),
     /* 129022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129032 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(129074), // Rule ID 2579 //
     /* 129037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129047 */     // MIs[0] Rn
     /* 129047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129059 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129072 */     GIR_RootConstrainSelectedInstOperands,
     /* 129073 */     // GIR_Coverage, 2579,
     /* 129073 */     GIR_EraseRootFromParent_Done,
     /* 129074 */   // Label 2427: @129074
     /* 129074 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(129116), // Rule ID 2580 //
     /* 129079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129089 */     // MIs[0] Rn
     /* 129089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129101 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129114 */     GIR_RootConstrainSelectedInstOperands,
     /* 129115 */     // GIR_Coverage, 2580,
     /* 129115 */     GIR_EraseRootFromParent_Done,
     /* 129116 */   // Label 2428: @129116
     /* 129116 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(129158), // Rule ID 2581 //
     /* 129121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129131 */     // MIs[0] Rn
     /* 129131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129143 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129156 */     GIR_RootConstrainSelectedInstOperands,
     /* 129157 */     // GIR_Coverage, 2581,
     /* 129157 */     GIR_EraseRootFromParent_Done,
     /* 129158 */   // Label 2429: @129158
     /* 129158 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(129200), // Rule ID 2582 //
     /* 129163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129166 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129173 */     // MIs[0] Rn
     /* 129173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129185 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129198 */     GIR_RootConstrainSelectedInstOperands,
     /* 129199 */     // GIR_Coverage, 2582,
     /* 129199 */     GIR_EraseRootFromParent_Done,
     /* 129200 */   // Label 2430: @129200
     /* 129200 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(129242), // Rule ID 2583 //
     /* 129205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129215 */     // MIs[0] Rn
     /* 129215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129227 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129240 */     GIR_RootConstrainSelectedInstOperands,
     /* 129241 */     // GIR_Coverage, 2583,
     /* 129241 */     GIR_EraseRootFromParent_Done,
     /* 129242 */   // Label 2431: @129242
     /* 129242 */   GIM_Reject,
     /* 129243 */ // Label 2426: @129243
     /* 129243 */ GIM_Reject,
     /* 129244 */ // Label 2409: @129244
     /* 129244 */ GIM_Reject,
     /* 129245 */ // Label 23: @129245
     /* 129245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2434*/ GIMT_Encode4(130736),
     /* 129256 */ /*GILLT_s32*//*Label 2432*/ GIMT_Encode4(129264),
     /* 129260 */ /*GILLT_s64*//*Label 2433*/ GIMT_Encode4(130384),
     /* 129264 */ // Label 2432: @129264
     /* 129264 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(130383),
     /* 129269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129272 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(129346), // Rule ID 7322 //
     /* 129277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129294 */     // MIs[0] Rn
     /* 129294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129306 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129318 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 129333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129344 */     GIR_RootConstrainSelectedInstOperands,
     /* 129345 */     // GIR_Coverage, 7322,
     /* 129345 */     GIR_EraseRootFromParent_Done,
     /* 129346 */   // Label 2436: @129346
     /* 129346 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(129420), // Rule ID 7323 //
     /* 129351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129368 */     // MIs[0] Rn
     /* 129368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129380 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129392 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 129407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129418 */     GIR_RootConstrainSelectedInstOperands,
     /* 129419 */     // GIR_Coverage, 7323,
     /* 129419 */     GIR_EraseRootFromParent_Done,
     /* 129420 */   // Label 2437: @129420
     /* 129420 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(129494), // Rule ID 7324 //
     /* 129425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129442 */     // MIs[0] Rn
     /* 129442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129454 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129466 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 129481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129492 */     GIR_RootConstrainSelectedInstOperands,
     /* 129493 */     // GIR_Coverage, 7324,
     /* 129493 */     GIR_EraseRootFromParent_Done,
     /* 129494 */   // Label 2438: @129494
     /* 129494 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(129568), // Rule ID 7325 //
     /* 129499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129516 */     // MIs[0] Rn
     /* 129516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129528 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129540 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129566 */     GIR_RootConstrainSelectedInstOperands,
     /* 129567 */     // GIR_Coverage, 7325,
     /* 129567 */     GIR_EraseRootFromParent_Done,
     /* 129568 */   // Label 2439: @129568
     /* 129568 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(129642), // Rule ID 7326 //
     /* 129573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129590 */     // MIs[0] Rn
     /* 129590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129602 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129614 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129640 */     GIR_RootConstrainSelectedInstOperands,
     /* 129641 */     // GIR_Coverage, 7326,
     /* 129641 */     GIR_EraseRootFromParent_Done,
     /* 129642 */   // Label 2440: @129642
     /* 129642 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129716), // Rule ID 7327 //
     /* 129647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129664 */     // MIs[0] Rn
     /* 129664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129676 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129688 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 129703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129714 */     GIR_RootConstrainSelectedInstOperands,
     /* 129715 */     // GIR_Coverage, 7327,
     /* 129715 */     GIR_EraseRootFromParent_Done,
     /* 129716 */   // Label 2441: @129716
     /* 129716 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129790), // Rule ID 7328 //
     /* 129721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129738 */     // MIs[0] Rn
     /* 129738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129750 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129762 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 129777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129788 */     GIR_RootConstrainSelectedInstOperands,
     /* 129789 */     // GIR_Coverage, 7328,
     /* 129789 */     GIR_EraseRootFromParent_Done,
     /* 129790 */   // Label 2442: @129790
     /* 129790 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129864), // Rule ID 7329 //
     /* 129795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129798 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129812 */     // MIs[0] Rn
     /* 129812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129824 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129836 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129862 */     GIR_RootConstrainSelectedInstOperands,
     /* 129863 */     // GIR_Coverage, 7329,
     /* 129863 */     GIR_EraseRootFromParent_Done,
     /* 129864 */   // Label 2443: @129864
     /* 129864 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129938), // Rule ID 7330 //
     /* 129869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129886 */     // MIs[0] Rn
     /* 129886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129898 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129910 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129936 */     GIR_RootConstrainSelectedInstOperands,
     /* 129937 */     // GIR_Coverage, 7330,
     /* 129937 */     GIR_EraseRootFromParent_Done,
     /* 129938 */   // Label 2444: @129938
     /* 129938 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(130012), // Rule ID 7331 //
     /* 129943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129960 */     // MIs[0] Rn
     /* 129960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129972 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129984 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130010 */     GIR_RootConstrainSelectedInstOperands,
     /* 130011 */     // GIR_Coverage, 7331,
     /* 130011 */     GIR_EraseRootFromParent_Done,
     /* 130012 */   // Label 2445: @130012
     /* 130012 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(130086), // Rule ID 7332 //
     /* 130017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130020 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130027 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130034 */     // MIs[0] Rn
     /* 130034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130046 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 130073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130084 */     GIR_RootConstrainSelectedInstOperands,
     /* 130085 */     // GIR_Coverage, 7332,
     /* 130085 */     GIR_EraseRootFromParent_Done,
     /* 130086 */   // Label 2446: @130086
     /* 130086 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(130160), // Rule ID 7333 //
     /* 130091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130094 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130101 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130108 */     // MIs[0] Rn
     /* 130108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130120 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130132 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 130147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130158 */     GIR_RootConstrainSelectedInstOperands,
     /* 130159 */     // GIR_Coverage, 7333,
     /* 130159 */     GIR_EraseRootFromParent_Done,
     /* 130160 */   // Label 2447: @130160
     /* 130160 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(130234), // Rule ID 7334 //
     /* 130165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130168 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130182 */     // MIs[0] Rn
     /* 130182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130194 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130206 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 130221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130232 */     GIR_RootConstrainSelectedInstOperands,
     /* 130233 */     // GIR_Coverage, 7334,
     /* 130233 */     GIR_EraseRootFromParent_Done,
     /* 130234 */   // Label 2448: @130234
     /* 130234 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(130308), // Rule ID 7335 //
     /* 130239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130256 */     // MIs[0] Rn
     /* 130256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130268 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130280 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130306 */     GIR_RootConstrainSelectedInstOperands,
     /* 130307 */     // GIR_Coverage, 7335,
     /* 130307 */     GIR_EraseRootFromParent_Done,
     /* 130308 */   // Label 2449: @130308
     /* 130308 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(130382), // Rule ID 7336 //
     /* 130313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130330 */     // MIs[0] Rn
     /* 130330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130342 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130354 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130380 */     GIR_RootConstrainSelectedInstOperands,
     /* 130381 */     // GIR_Coverage, 7336,
     /* 130381 */     GIR_EraseRootFromParent_Done,
     /* 130382 */   // Label 2450: @130382
     /* 130382 */   GIM_Reject,
     /* 130383 */ // Label 2435: @130383
     /* 130383 */ GIM_Reject,
     /* 130384 */ // Label 2433: @130384
     /* 130384 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(130735),
     /* 130389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130399 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(130466), // Rule ID 7317 //
     /* 130404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130414 */     // MIs[0] Rn
     /* 130414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130426 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130438 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 130453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130464 */     GIR_RootConstrainSelectedInstOperands,
     /* 130465 */     // GIR_Coverage, 7317,
     /* 130465 */     GIR_EraseRootFromParent_Done,
     /* 130466 */   // Label 2452: @130466
     /* 130466 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(130533), // Rule ID 7318 //
     /* 130471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130481 */     // MIs[0] Rn
     /* 130481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130493 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130505 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 130520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130531 */     GIR_RootConstrainSelectedInstOperands,
     /* 130532 */     // GIR_Coverage, 7318,
     /* 130532 */     GIR_EraseRootFromParent_Done,
     /* 130533 */   // Label 2453: @130533
     /* 130533 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(130600), // Rule ID 7319 //
     /* 130538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130548 */     // MIs[0] Rn
     /* 130548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130560 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 130587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130598 */     GIR_RootConstrainSelectedInstOperands,
     /* 130599 */     // GIR_Coverage, 7319,
     /* 130599 */     GIR_EraseRootFromParent_Done,
     /* 130600 */   // Label 2454: @130600
     /* 130600 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(130667), // Rule ID 7320 //
     /* 130605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130615 */     // MIs[0] Rn
     /* 130615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130627 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130665 */     GIR_RootConstrainSelectedInstOperands,
     /* 130666 */     // GIR_Coverage, 7320,
     /* 130666 */     GIR_EraseRootFromParent_Done,
     /* 130667 */   // Label 2455: @130667
     /* 130667 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(130734), // Rule ID 7321 //
     /* 130672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130682 */     // MIs[0] Rn
     /* 130682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130694 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130706 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130732 */     GIR_RootConstrainSelectedInstOperands,
     /* 130733 */     // GIR_Coverage, 7321,
     /* 130733 */     GIR_EraseRootFromParent_Done,
     /* 130734 */   // Label 2456: @130734
     /* 130734 */   GIM_Reject,
     /* 130735 */ // Label 2451: @130735
     /* 130735 */ GIM_Reject,
     /* 130736 */ // Label 2434: @130736
     /* 130736 */ GIM_Reject,
     /* 130737 */ // Label 24: @130737
     /* 130737 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2459*/ GIMT_Encode4(132228),
     /* 130748 */ /*GILLT_s32*//*Label 2457*/ GIMT_Encode4(130756),
     /* 130752 */ /*GILLT_s64*//*Label 2458*/ GIMT_Encode4(131876),
     /* 130756 */ // Label 2457: @130756
     /* 130756 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(131875),
     /* 130761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130764 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(130838), // Rule ID 7342 //
     /* 130769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130786 */     // MIs[0] Rn
     /* 130786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130798 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130810 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 130825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130836 */     GIR_RootConstrainSelectedInstOperands,
     /* 130837 */     // GIR_Coverage, 7342,
     /* 130837 */     GIR_EraseRootFromParent_Done,
     /* 130838 */   // Label 2461: @130838
     /* 130838 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(130912), // Rule ID 7343 //
     /* 130843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130860 */     // MIs[0] Rn
     /* 130860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130872 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130884 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 130899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130910 */     GIR_RootConstrainSelectedInstOperands,
     /* 130911 */     // GIR_Coverage, 7343,
     /* 130911 */     GIR_EraseRootFromParent_Done,
     /* 130912 */   // Label 2462: @130912
     /* 130912 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130986), // Rule ID 7344 //
     /* 130917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130934 */     // MIs[0] Rn
     /* 130934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130946 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130958 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 130973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130984 */     GIR_RootConstrainSelectedInstOperands,
     /* 130985 */     // GIR_Coverage, 7344,
     /* 130985 */     GIR_EraseRootFromParent_Done,
     /* 130986 */   // Label 2463: @130986
     /* 130986 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(131060), // Rule ID 7345 //
     /* 130991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131008 */     // MIs[0] Rn
     /* 131008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131020 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131032 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131058 */     GIR_RootConstrainSelectedInstOperands,
     /* 131059 */     // GIR_Coverage, 7345,
     /* 131059 */     GIR_EraseRootFromParent_Done,
     /* 131060 */   // Label 2464: @131060
     /* 131060 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(131134), // Rule ID 7346 //
     /* 131065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131082 */     // MIs[0] Rn
     /* 131082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131094 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131106 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 131121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131132 */     GIR_RootConstrainSelectedInstOperands,
     /* 131133 */     // GIR_Coverage, 7346,
     /* 131133 */     GIR_EraseRootFromParent_Done,
     /* 131134 */   // Label 2465: @131134
     /* 131134 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(131208), // Rule ID 7347 //
     /* 131139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131156 */     // MIs[0] Rn
     /* 131156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131168 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131180 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 131195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131206 */     GIR_RootConstrainSelectedInstOperands,
     /* 131207 */     // GIR_Coverage, 7347,
     /* 131207 */     GIR_EraseRootFromParent_Done,
     /* 131208 */   // Label 2466: @131208
     /* 131208 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(131282), // Rule ID 7348 //
     /* 131213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131230 */     // MIs[0] Rn
     /* 131230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131242 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131254 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 131269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131280 */     GIR_RootConstrainSelectedInstOperands,
     /* 131281 */     // GIR_Coverage, 7348,
     /* 131281 */     GIR_EraseRootFromParent_Done,
     /* 131282 */   // Label 2467: @131282
     /* 131282 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(131356), // Rule ID 7349 //
     /* 131287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131290 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131304 */     // MIs[0] Rn
     /* 131304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131316 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131328 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 131343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131354 */     GIR_RootConstrainSelectedInstOperands,
     /* 131355 */     // GIR_Coverage, 7349,
     /* 131355 */     GIR_EraseRootFromParent_Done,
     /* 131356 */   // Label 2468: @131356
     /* 131356 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(131430), // Rule ID 7350 //
     /* 131361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131364 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131378 */     // MIs[0] Rn
     /* 131378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131390 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131402 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131428 */     GIR_RootConstrainSelectedInstOperands,
     /* 131429 */     // GIR_Coverage, 7350,
     /* 131429 */     GIR_EraseRootFromParent_Done,
     /* 131430 */   // Label 2469: @131430
     /* 131430 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(131504), // Rule ID 7351 //
     /* 131435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131438 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131445 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131452 */     // MIs[0] Rn
     /* 131452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131464 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131476 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131502 */     GIR_RootConstrainSelectedInstOperands,
     /* 131503 */     // GIR_Coverage, 7351,
     /* 131503 */     GIR_EraseRootFromParent_Done,
     /* 131504 */   // Label 2470: @131504
     /* 131504 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(131578), // Rule ID 7352 //
     /* 131509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131512 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131526 */     // MIs[0] Rn
     /* 131526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131538 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131550 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 131565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131576 */     GIR_RootConstrainSelectedInstOperands,
     /* 131577 */     // GIR_Coverage, 7352,
     /* 131577 */     GIR_EraseRootFromParent_Done,
     /* 131578 */   // Label 2471: @131578
     /* 131578 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(131652), // Rule ID 7353 //
     /* 131583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131600 */     // MIs[0] Rn
     /* 131600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131612 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131624 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 131639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131650 */     GIR_RootConstrainSelectedInstOperands,
     /* 131651 */     // GIR_Coverage, 7353,
     /* 131651 */     GIR_EraseRootFromParent_Done,
     /* 131652 */   // Label 2472: @131652
     /* 131652 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131726), // Rule ID 7354 //
     /* 131657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131674 */     // MIs[0] Rn
     /* 131674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131686 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131698 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 131713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131724 */     GIR_RootConstrainSelectedInstOperands,
     /* 131725 */     // GIR_Coverage, 7354,
     /* 131725 */     GIR_EraseRootFromParent_Done,
     /* 131726 */   // Label 2473: @131726
     /* 131726 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131800), // Rule ID 7355 //
     /* 131731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131748 */     // MIs[0] Rn
     /* 131748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131760 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131772 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131798 */     GIR_RootConstrainSelectedInstOperands,
     /* 131799 */     // GIR_Coverage, 7355,
     /* 131799 */     GIR_EraseRootFromParent_Done,
     /* 131800 */   // Label 2474: @131800
     /* 131800 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131874), // Rule ID 7356 //
     /* 131805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131822 */     // MIs[0] Rn
     /* 131822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131834 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131846 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131872 */     GIR_RootConstrainSelectedInstOperands,
     /* 131873 */     // GIR_Coverage, 7356,
     /* 131873 */     GIR_EraseRootFromParent_Done,
     /* 131874 */   // Label 2475: @131874
     /* 131874 */   GIM_Reject,
     /* 131875 */ // Label 2460: @131875
     /* 131875 */ GIM_Reject,
     /* 131876 */ // Label 2458: @131876
     /* 131876 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(132227),
     /* 131881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131891 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131958), // Rule ID 7337 //
     /* 131896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131906 */     // MIs[0] Rn
     /* 131906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131918 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131930 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 131945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131956 */     GIR_RootConstrainSelectedInstOperands,
     /* 131957 */     // GIR_Coverage, 7337,
     /* 131957 */     GIR_EraseRootFromParent_Done,
     /* 131958 */   // Label 2477: @131958
     /* 131958 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(132025), // Rule ID 7338 //
     /* 131963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131973 */     // MIs[0] Rn
     /* 131973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131985 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131997 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 132012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132023 */     GIR_RootConstrainSelectedInstOperands,
     /* 132024 */     // GIR_Coverage, 7338,
     /* 132024 */     GIR_EraseRootFromParent_Done,
     /* 132025 */   // Label 2478: @132025
     /* 132025 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(132092), // Rule ID 7339 //
     /* 132030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132040 */     // MIs[0] Rn
     /* 132040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132052 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 132079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132090 */     GIR_RootConstrainSelectedInstOperands,
     /* 132091 */     // GIR_Coverage, 7339,
     /* 132091 */     GIR_EraseRootFromParent_Done,
     /* 132092 */   // Label 2479: @132092
     /* 132092 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(132159), // Rule ID 7340 //
     /* 132097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132107 */     // MIs[0] Rn
     /* 132107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132119 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132131 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132157 */     GIR_RootConstrainSelectedInstOperands,
     /* 132158 */     // GIR_Coverage, 7340,
     /* 132158 */     GIR_EraseRootFromParent_Done,
     /* 132159 */   // Label 2480: @132159
     /* 132159 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(132226), // Rule ID 7341 //
     /* 132164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132167 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132174 */     // MIs[0] Rn
     /* 132174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132186 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 132186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 132193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132198 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 132204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 132208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 132213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132224 */     GIR_RootConstrainSelectedInstOperands,
     /* 132225 */     // GIR_Coverage, 7341,
     /* 132225 */     GIR_EraseRootFromParent_Done,
     /* 132226 */   // Label 2481: @132226
     /* 132226 */   GIM_Reject,
     /* 132227 */ // Label 2476: @132227
     /* 132227 */ GIM_Reject,
     /* 132228 */ // Label 2459: @132228
     /* 132228 */ GIM_Reject,
     /* 132229 */ // Label 25: @132229
     /* 132229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2484*/ GIMT_Encode4(133220),
     /* 132240 */ /*GILLT_s32*//*Label 2482*/ GIMT_Encode4(132248),
     /* 132244 */ /*GILLT_s64*//*Label 2483*/ GIMT_Encode4(132993),
     /* 132248 */ // Label 2482: @132248
     /* 132248 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(132992),
     /* 132253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132256 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(132305), // Rule ID 7147 //
     /* 132261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132278 */     // MIs[0] Rn
     /* 132278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132290 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 132293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132303 */     GIR_RootConstrainSelectedInstOperands,
     /* 132304 */     // GIR_Coverage, 7147,
     /* 132304 */     GIR_EraseRootFromParent_Done,
     /* 132305 */   // Label 2486: @132305
     /* 132305 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(132354), // Rule ID 7148 //
     /* 132310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132327 */     // MIs[0] Rn
     /* 132327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132339 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 132342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132352 */     GIR_RootConstrainSelectedInstOperands,
     /* 132353 */     // GIR_Coverage, 7148,
     /* 132353 */     GIR_EraseRootFromParent_Done,
     /* 132354 */   // Label 2487: @132354
     /* 132354 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(132403), // Rule ID 7149 //
     /* 132359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132376 */     // MIs[0] Rn
     /* 132376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132388 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 132391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132401 */     GIR_RootConstrainSelectedInstOperands,
     /* 132402 */     // GIR_Coverage, 7149,
     /* 132402 */     GIR_EraseRootFromParent_Done,
     /* 132403 */   // Label 2488: @132403
     /* 132403 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(132452), // Rule ID 7150 //
     /* 132408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132425 */     // MIs[0] Rn
     /* 132425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132437 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132450 */     GIR_RootConstrainSelectedInstOperands,
     /* 132451 */     // GIR_Coverage, 7150,
     /* 132451 */     GIR_EraseRootFromParent_Done,
     /* 132452 */   // Label 2489: @132452
     /* 132452 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(132501), // Rule ID 7151 //
     /* 132457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132474 */     // MIs[0] Rn
     /* 132474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132486 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132499 */     GIR_RootConstrainSelectedInstOperands,
     /* 132500 */     // GIR_Coverage, 7151,
     /* 132500 */     GIR_EraseRootFromParent_Done,
     /* 132501 */   // Label 2490: @132501
     /* 132501 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(132550), // Rule ID 7152 //
     /* 132506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132523 */     // MIs[0] Rn
     /* 132523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132535 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 132538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132548 */     GIR_RootConstrainSelectedInstOperands,
     /* 132549 */     // GIR_Coverage, 7152,
     /* 132549 */     GIR_EraseRootFromParent_Done,
     /* 132550 */   // Label 2491: @132550
     /* 132550 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(132599), // Rule ID 7153 //
     /* 132555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132572 */     // MIs[0] Rn
     /* 132572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132584 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 132587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132597 */     GIR_RootConstrainSelectedInstOperands,
     /* 132598 */     // GIR_Coverage, 7153,
     /* 132598 */     GIR_EraseRootFromParent_Done,
     /* 132599 */   // Label 2492: @132599
     /* 132599 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(132648), // Rule ID 7154 //
     /* 132604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132621 */     // MIs[0] Rn
     /* 132621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132633 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 132636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132646 */     GIR_RootConstrainSelectedInstOperands,
     /* 132647 */     // GIR_Coverage, 7154,
     /* 132647 */     GIR_EraseRootFromParent_Done,
     /* 132648 */   // Label 2493: @132648
     /* 132648 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(132697), // Rule ID 7155 //
     /* 132653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132670 */     // MIs[0] Rn
     /* 132670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132682 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132695 */     GIR_RootConstrainSelectedInstOperands,
     /* 132696 */     // GIR_Coverage, 7155,
     /* 132696 */     GIR_EraseRootFromParent_Done,
     /* 132697 */   // Label 2494: @132697
     /* 132697 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132746), // Rule ID 7156 //
     /* 132702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132719 */     // MIs[0] Rn
     /* 132719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132731 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132744 */     GIR_RootConstrainSelectedInstOperands,
     /* 132745 */     // GIR_Coverage, 7156,
     /* 132745 */     GIR_EraseRootFromParent_Done,
     /* 132746 */   // Label 2495: @132746
     /* 132746 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132795), // Rule ID 7157 //
     /* 132751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132768 */     // MIs[0] Rn
     /* 132768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132780 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 132783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132793 */     GIR_RootConstrainSelectedInstOperands,
     /* 132794 */     // GIR_Coverage, 7157,
     /* 132794 */     GIR_EraseRootFromParent_Done,
     /* 132795 */   // Label 2496: @132795
     /* 132795 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132844), // Rule ID 7158 //
     /* 132800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132817 */     // MIs[0] Rn
     /* 132817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132829 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 132832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132842 */     GIR_RootConstrainSelectedInstOperands,
     /* 132843 */     // GIR_Coverage, 7158,
     /* 132843 */     GIR_EraseRootFromParent_Done,
     /* 132844 */   // Label 2497: @132844
     /* 132844 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132893), // Rule ID 7159 //
     /* 132849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132866 */     // MIs[0] Rn
     /* 132866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132878 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132891 */     GIR_RootConstrainSelectedInstOperands,
     /* 132892 */     // GIR_Coverage, 7159,
     /* 132892 */     GIR_EraseRootFromParent_Done,
     /* 132893 */   // Label 2498: @132893
     /* 132893 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132942), // Rule ID 7160 //
     /* 132898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132915 */     // MIs[0] Rn
     /* 132915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132927 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132940 */     GIR_RootConstrainSelectedInstOperands,
     /* 132941 */     // GIR_Coverage, 7160,
     /* 132941 */     GIR_EraseRootFromParent_Done,
     /* 132942 */   // Label 2499: @132942
     /* 132942 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132991), // Rule ID 7161 //
     /* 132947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132964 */     // MIs[0] Rn
     /* 132964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132976 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132989 */     GIR_RootConstrainSelectedInstOperands,
     /* 132990 */     // GIR_Coverage, 7161,
     /* 132990 */     GIR_EraseRootFromParent_Done,
     /* 132991 */   // Label 2500: @132991
     /* 132991 */   GIM_Reject,
     /* 132992 */ // Label 2485: @132992
     /* 132992 */ GIM_Reject,
     /* 132993 */ // Label 2483: @132993
     /* 132993 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(133219),
     /* 132998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133001 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133008 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(133050), // Rule ID 7142 //
     /* 133013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133023 */     // MIs[0] Rn
     /* 133023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133035 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 133038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133048 */     GIR_RootConstrainSelectedInstOperands,
     /* 133049 */     // GIR_Coverage, 7142,
     /* 133049 */     GIR_EraseRootFromParent_Done,
     /* 133050 */   // Label 2502: @133050
     /* 133050 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(133092), // Rule ID 7143 //
     /* 133055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133065 */     // MIs[0] Rn
     /* 133065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133077 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 133080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133090 */     GIR_RootConstrainSelectedInstOperands,
     /* 133091 */     // GIR_Coverage, 7143,
     /* 133091 */     GIR_EraseRootFromParent_Done,
     /* 133092 */   // Label 2503: @133092
     /* 133092 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(133134), // Rule ID 7144 //
     /* 133097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133107 */     // MIs[0] Rn
     /* 133107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133119 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 133122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133132 */     GIR_RootConstrainSelectedInstOperands,
     /* 133133 */     // GIR_Coverage, 7144,
     /* 133133 */     GIR_EraseRootFromParent_Done,
     /* 133134 */   // Label 2504: @133134
     /* 133134 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(133176), // Rule ID 7145 //
     /* 133139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133149 */     // MIs[0] Rn
     /* 133149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133161 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133174 */     GIR_RootConstrainSelectedInstOperands,
     /* 133175 */     // GIR_Coverage, 7145,
     /* 133175 */     GIR_EraseRootFromParent_Done,
     /* 133176 */   // Label 2505: @133176
     /* 133176 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(133218), // Rule ID 7146 //
     /* 133181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133191 */     // MIs[0] Rn
     /* 133191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133203 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 133206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133216 */     GIR_RootConstrainSelectedInstOperands,
     /* 133217 */     // GIR_Coverage, 7146,
     /* 133217 */     GIR_EraseRootFromParent_Done,
     /* 133218 */   // Label 2506: @133218
     /* 133218 */   GIM_Reject,
     /* 133219 */ // Label 2501: @133219
     /* 133219 */ GIM_Reject,
     /* 133220 */ // Label 2484: @133220
     /* 133220 */ GIM_Reject,
     /* 133221 */ // Label 26: @133221
     /* 133221 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2509*/ GIMT_Encode4(134212),
     /* 133232 */ /*GILLT_s32*//*Label 2507*/ GIMT_Encode4(133240),
     /* 133236 */ /*GILLT_s64*//*Label 2508*/ GIMT_Encode4(133985),
     /* 133240 */ // Label 2507: @133240
     /* 133240 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(133984),
     /* 133245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133248 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(133297), // Rule ID 7167 //
     /* 133253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133270 */     // MIs[0] Rn
     /* 133270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133282 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 133285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133295 */     GIR_RootConstrainSelectedInstOperands,
     /* 133296 */     // GIR_Coverage, 7167,
     /* 133296 */     GIR_EraseRootFromParent_Done,
     /* 133297 */   // Label 2511: @133297
     /* 133297 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(133346), // Rule ID 7168 //
     /* 133302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133319 */     // MIs[0] Rn
     /* 133319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133331 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 133334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133344 */     GIR_RootConstrainSelectedInstOperands,
     /* 133345 */     // GIR_Coverage, 7168,
     /* 133345 */     GIR_EraseRootFromParent_Done,
     /* 133346 */   // Label 2512: @133346
     /* 133346 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(133395), // Rule ID 7169 //
     /* 133351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133368 */     // MIs[0] Rn
     /* 133368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133380 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 133383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133393 */     GIR_RootConstrainSelectedInstOperands,
     /* 133394 */     // GIR_Coverage, 7169,
     /* 133394 */     GIR_EraseRootFromParent_Done,
     /* 133395 */   // Label 2513: @133395
     /* 133395 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(133444), // Rule ID 7170 //
     /* 133400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133417 */     // MIs[0] Rn
     /* 133417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133429 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133442 */     GIR_RootConstrainSelectedInstOperands,
     /* 133443 */     // GIR_Coverage, 7170,
     /* 133443 */     GIR_EraseRootFromParent_Done,
     /* 133444 */   // Label 2514: @133444
     /* 133444 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(133493), // Rule ID 7171 //
     /* 133449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133466 */     // MIs[0] Rn
     /* 133466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133478 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133491 */     GIR_RootConstrainSelectedInstOperands,
     /* 133492 */     // GIR_Coverage, 7171,
     /* 133492 */     GIR_EraseRootFromParent_Done,
     /* 133493 */   // Label 2515: @133493
     /* 133493 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(133542), // Rule ID 7172 //
     /* 133498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133515 */     // MIs[0] Rn
     /* 133515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133527 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 133530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133540 */     GIR_RootConstrainSelectedInstOperands,
     /* 133541 */     // GIR_Coverage, 7172,
     /* 133541 */     GIR_EraseRootFromParent_Done,
     /* 133542 */   // Label 2516: @133542
     /* 133542 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(133591), // Rule ID 7173 //
     /* 133547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133564 */     // MIs[0] Rn
     /* 133564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133576 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 133579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133589 */     GIR_RootConstrainSelectedInstOperands,
     /* 133590 */     // GIR_Coverage, 7173,
     /* 133590 */     GIR_EraseRootFromParent_Done,
     /* 133591 */   // Label 2517: @133591
     /* 133591 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(133640), // Rule ID 7174 //
     /* 133596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133613 */     // MIs[0] Rn
     /* 133613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133625 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 133628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133638 */     GIR_RootConstrainSelectedInstOperands,
     /* 133639 */     // GIR_Coverage, 7174,
     /* 133639 */     GIR_EraseRootFromParent_Done,
     /* 133640 */   // Label 2518: @133640
     /* 133640 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(133689), // Rule ID 7175 //
     /* 133645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133662 */     // MIs[0] Rn
     /* 133662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133674 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133687 */     GIR_RootConstrainSelectedInstOperands,
     /* 133688 */     // GIR_Coverage, 7175,
     /* 133688 */     GIR_EraseRootFromParent_Done,
     /* 133689 */   // Label 2519: @133689
     /* 133689 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133738), // Rule ID 7176 //
     /* 133694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133711 */     // MIs[0] Rn
     /* 133711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133723 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133736 */     GIR_RootConstrainSelectedInstOperands,
     /* 133737 */     // GIR_Coverage, 7176,
     /* 133737 */     GIR_EraseRootFromParent_Done,
     /* 133738 */   // Label 2520: @133738
     /* 133738 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133787), // Rule ID 7177 //
     /* 133743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133760 */     // MIs[0] Rn
     /* 133760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133772 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 133775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133785 */     GIR_RootConstrainSelectedInstOperands,
     /* 133786 */     // GIR_Coverage, 7177,
     /* 133786 */     GIR_EraseRootFromParent_Done,
     /* 133787 */   // Label 2521: @133787
     /* 133787 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133836), // Rule ID 7178 //
     /* 133792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133809 */     // MIs[0] Rn
     /* 133809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133821 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 133824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133834 */     GIR_RootConstrainSelectedInstOperands,
     /* 133835 */     // GIR_Coverage, 7178,
     /* 133835 */     GIR_EraseRootFromParent_Done,
     /* 133836 */   // Label 2522: @133836
     /* 133836 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133885), // Rule ID 7179 //
     /* 133841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133858 */     // MIs[0] Rn
     /* 133858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133870 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133883 */     GIR_RootConstrainSelectedInstOperands,
     /* 133884 */     // GIR_Coverage, 7179,
     /* 133884 */     GIR_EraseRootFromParent_Done,
     /* 133885 */   // Label 2523: @133885
     /* 133885 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133934), // Rule ID 7180 //
     /* 133890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133907 */     // MIs[0] Rn
     /* 133907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133919 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133932 */     GIR_RootConstrainSelectedInstOperands,
     /* 133933 */     // GIR_Coverage, 7180,
     /* 133933 */     GIR_EraseRootFromParent_Done,
     /* 133934 */   // Label 2524: @133934
     /* 133934 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133983), // Rule ID 7181 //
     /* 133939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133956 */     // MIs[0] Rn
     /* 133956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133968 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133981 */     GIR_RootConstrainSelectedInstOperands,
     /* 133982 */     // GIR_Coverage, 7181,
     /* 133982 */     GIR_EraseRootFromParent_Done,
     /* 133983 */   // Label 2525: @133983
     /* 133983 */   GIM_Reject,
     /* 133984 */ // Label 2510: @133984
     /* 133984 */ GIM_Reject,
     /* 133985 */ // Label 2508: @133985
     /* 133985 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(134211),
     /* 133990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134000 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(134042), // Rule ID 7162 //
     /* 134005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134015 */     // MIs[0] Rn
     /* 134015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134027 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 134030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134040 */     GIR_RootConstrainSelectedInstOperands,
     /* 134041 */     // GIR_Coverage, 7162,
     /* 134041 */     GIR_EraseRootFromParent_Done,
     /* 134042 */   // Label 2527: @134042
     /* 134042 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(134084), // Rule ID 7163 //
     /* 134047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134057 */     // MIs[0] Rn
     /* 134057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134069 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 134072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134082 */     GIR_RootConstrainSelectedInstOperands,
     /* 134083 */     // GIR_Coverage, 7163,
     /* 134083 */     GIR_EraseRootFromParent_Done,
     /* 134084 */   // Label 2528: @134084
     /* 134084 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(134126), // Rule ID 7164 //
     /* 134089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134099 */     // MIs[0] Rn
     /* 134099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134111 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 134114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134124 */     GIR_RootConstrainSelectedInstOperands,
     /* 134125 */     // GIR_Coverage, 7164,
     /* 134125 */     GIR_EraseRootFromParent_Done,
     /* 134126 */   // Label 2529: @134126
     /* 134126 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(134168), // Rule ID 7165 //
     /* 134131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134134 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134141 */     // MIs[0] Rn
     /* 134141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134153 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134166 */     GIR_RootConstrainSelectedInstOperands,
     /* 134167 */     // GIR_Coverage, 7165,
     /* 134167 */     GIR_EraseRootFromParent_Done,
     /* 134168 */   // Label 2530: @134168
     /* 134168 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(134210), // Rule ID 7166 //
     /* 134173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134183 */     // MIs[0] Rn
     /* 134183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134195 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 134198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134208 */     GIR_RootConstrainSelectedInstOperands,
     /* 134209 */     // GIR_Coverage, 7166,
     /* 134209 */     GIR_EraseRootFromParent_Done,
     /* 134210 */   // Label 2531: @134210
     /* 134210 */   GIM_Reject,
     /* 134211 */ // Label 2526: @134211
     /* 134211 */ GIM_Reject,
     /* 134212 */ // Label 2509: @134212
     /* 134212 */ GIM_Reject,
     /* 134213 */ // Label 27: @134213
     /* 134213 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2534*/ GIMT_Encode4(135204),
     /* 134224 */ /*GILLT_s32*//*Label 2532*/ GIMT_Encode4(134232),
     /* 134228 */ /*GILLT_s64*//*Label 2533*/ GIMT_Encode4(134977),
     /* 134232 */ // Label 2532: @134232
     /* 134232 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(134976),
     /* 134237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134240 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(134289), // Rule ID 7207 //
     /* 134245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134262 */     // MIs[0] Rn
     /* 134262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134274 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 134277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134287 */     GIR_RootConstrainSelectedInstOperands,
     /* 134288 */     // GIR_Coverage, 7207,
     /* 134288 */     GIR_EraseRootFromParent_Done,
     /* 134289 */   // Label 2536: @134289
     /* 134289 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(134338), // Rule ID 7208 //
     /* 134294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134311 */     // MIs[0] Rn
     /* 134311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134323 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 134326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134336 */     GIR_RootConstrainSelectedInstOperands,
     /* 134337 */     // GIR_Coverage, 7208,
     /* 134337 */     GIR_EraseRootFromParent_Done,
     /* 134338 */   // Label 2537: @134338
     /* 134338 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(134387), // Rule ID 7209 //
     /* 134343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134360 */     // MIs[0] Rn
     /* 134360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134372 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 134375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134385 */     GIR_RootConstrainSelectedInstOperands,
     /* 134386 */     // GIR_Coverage, 7209,
     /* 134386 */     GIR_EraseRootFromParent_Done,
     /* 134387 */   // Label 2538: @134387
     /* 134387 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(134436), // Rule ID 7210 //
     /* 134392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134409 */     // MIs[0] Rn
     /* 134409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134421 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134434 */     GIR_RootConstrainSelectedInstOperands,
     /* 134435 */     // GIR_Coverage, 7210,
     /* 134435 */     GIR_EraseRootFromParent_Done,
     /* 134436 */   // Label 2539: @134436
     /* 134436 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(134485), // Rule ID 7211 //
     /* 134441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134458 */     // MIs[0] Rn
     /* 134458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134470 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134483 */     GIR_RootConstrainSelectedInstOperands,
     /* 134484 */     // GIR_Coverage, 7211,
     /* 134484 */     GIR_EraseRootFromParent_Done,
     /* 134485 */   // Label 2540: @134485
     /* 134485 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(134534), // Rule ID 7212 //
     /* 134490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134507 */     // MIs[0] Rn
     /* 134507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134519 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 134522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134532 */     GIR_RootConstrainSelectedInstOperands,
     /* 134533 */     // GIR_Coverage, 7212,
     /* 134533 */     GIR_EraseRootFromParent_Done,
     /* 134534 */   // Label 2541: @134534
     /* 134534 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(134583), // Rule ID 7213 //
     /* 134539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134556 */     // MIs[0] Rn
     /* 134556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134568 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 134571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134581 */     GIR_RootConstrainSelectedInstOperands,
     /* 134582 */     // GIR_Coverage, 7213,
     /* 134582 */     GIR_EraseRootFromParent_Done,
     /* 134583 */   // Label 2542: @134583
     /* 134583 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(134632), // Rule ID 7214 //
     /* 134588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134605 */     // MIs[0] Rn
     /* 134605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134617 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 134620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134630 */     GIR_RootConstrainSelectedInstOperands,
     /* 134631 */     // GIR_Coverage, 7214,
     /* 134631 */     GIR_EraseRootFromParent_Done,
     /* 134632 */   // Label 2543: @134632
     /* 134632 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(134681), // Rule ID 7215 //
     /* 134637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134654 */     // MIs[0] Rn
     /* 134654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134666 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134679 */     GIR_RootConstrainSelectedInstOperands,
     /* 134680 */     // GIR_Coverage, 7215,
     /* 134680 */     GIR_EraseRootFromParent_Done,
     /* 134681 */   // Label 2544: @134681
     /* 134681 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134730), // Rule ID 7216 //
     /* 134686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134703 */     // MIs[0] Rn
     /* 134703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134715 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134728 */     GIR_RootConstrainSelectedInstOperands,
     /* 134729 */     // GIR_Coverage, 7216,
     /* 134729 */     GIR_EraseRootFromParent_Done,
     /* 134730 */   // Label 2545: @134730
     /* 134730 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134779), // Rule ID 7217 //
     /* 134735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134752 */     // MIs[0] Rn
     /* 134752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134764 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 134767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134777 */     GIR_RootConstrainSelectedInstOperands,
     /* 134778 */     // GIR_Coverage, 7217,
     /* 134778 */     GIR_EraseRootFromParent_Done,
     /* 134779 */   // Label 2546: @134779
     /* 134779 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134828), // Rule ID 7218 //
     /* 134784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134801 */     // MIs[0] Rn
     /* 134801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134813 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 134816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134826 */     GIR_RootConstrainSelectedInstOperands,
     /* 134827 */     // GIR_Coverage, 7218,
     /* 134827 */     GIR_EraseRootFromParent_Done,
     /* 134828 */   // Label 2547: @134828
     /* 134828 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134877), // Rule ID 7219 //
     /* 134833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134850 */     // MIs[0] Rn
     /* 134850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134862 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134875 */     GIR_RootConstrainSelectedInstOperands,
     /* 134876 */     // GIR_Coverage, 7219,
     /* 134876 */     GIR_EraseRootFromParent_Done,
     /* 134877 */   // Label 2548: @134877
     /* 134877 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134926), // Rule ID 7220 //
     /* 134882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134899 */     // MIs[0] Rn
     /* 134899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134911 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134924 */     GIR_RootConstrainSelectedInstOperands,
     /* 134925 */     // GIR_Coverage, 7220,
     /* 134925 */     GIR_EraseRootFromParent_Done,
     /* 134926 */   // Label 2549: @134926
     /* 134926 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134975), // Rule ID 7221 //
     /* 134931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134948 */     // MIs[0] Rn
     /* 134948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134960 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134973 */     GIR_RootConstrainSelectedInstOperands,
     /* 134974 */     // GIR_Coverage, 7221,
     /* 134974 */     GIR_EraseRootFromParent_Done,
     /* 134975 */   // Label 2550: @134975
     /* 134975 */   GIM_Reject,
     /* 134976 */ // Label 2535: @134976
     /* 134976 */ GIM_Reject,
     /* 134977 */ // Label 2533: @134977
     /* 134977 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(135203),
     /* 134982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134985 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134992 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(135034), // Rule ID 7202 //
     /* 134997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135007 */     // MIs[0] Rn
     /* 135007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135019 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 135022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135032 */     GIR_RootConstrainSelectedInstOperands,
     /* 135033 */     // GIR_Coverage, 7202,
     /* 135033 */     GIR_EraseRootFromParent_Done,
     /* 135034 */   // Label 2552: @135034
     /* 135034 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(135076), // Rule ID 7203 //
     /* 135039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135049 */     // MIs[0] Rn
     /* 135049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135061 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 135064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135074 */     GIR_RootConstrainSelectedInstOperands,
     /* 135075 */     // GIR_Coverage, 7203,
     /* 135075 */     GIR_EraseRootFromParent_Done,
     /* 135076 */   // Label 2553: @135076
     /* 135076 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(135118), // Rule ID 7204 //
     /* 135081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135091 */     // MIs[0] Rn
     /* 135091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135103 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 135106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135116 */     GIR_RootConstrainSelectedInstOperands,
     /* 135117 */     // GIR_Coverage, 7204,
     /* 135117 */     GIR_EraseRootFromParent_Done,
     /* 135118 */   // Label 2554: @135118
     /* 135118 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(135160), // Rule ID 7205 //
     /* 135123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135133 */     // MIs[0] Rn
     /* 135133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135145 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135158 */     GIR_RootConstrainSelectedInstOperands,
     /* 135159 */     // GIR_Coverage, 7205,
     /* 135159 */     GIR_EraseRootFromParent_Done,
     /* 135160 */   // Label 2555: @135160
     /* 135160 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(135202), // Rule ID 7206 //
     /* 135165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135175 */     // MIs[0] Rn
     /* 135175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135187 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 135190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135200 */     GIR_RootConstrainSelectedInstOperands,
     /* 135201 */     // GIR_Coverage, 7206,
     /* 135201 */     GIR_EraseRootFromParent_Done,
     /* 135202 */   // Label 2556: @135202
     /* 135202 */   GIM_Reject,
     /* 135203 */ // Label 2551: @135203
     /* 135203 */ GIM_Reject,
     /* 135204 */ // Label 2534: @135204
     /* 135204 */ GIM_Reject,
     /* 135205 */ // Label 28: @135205
     /* 135205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2559*/ GIMT_Encode4(136196),
     /* 135216 */ /*GILLT_s32*//*Label 2557*/ GIMT_Encode4(135224),
     /* 135220 */ /*GILLT_s64*//*Label 2558*/ GIMT_Encode4(135969),
     /* 135224 */ // Label 2557: @135224
     /* 135224 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(135968),
     /* 135229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135232 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(135281), // Rule ID 7227 //
     /* 135237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135254 */     // MIs[0] Rn
     /* 135254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135266 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 135269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135279 */     GIR_RootConstrainSelectedInstOperands,
     /* 135280 */     // GIR_Coverage, 7227,
     /* 135280 */     GIR_EraseRootFromParent_Done,
     /* 135281 */   // Label 2561: @135281
     /* 135281 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(135330), // Rule ID 7228 //
     /* 135286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135303 */     // MIs[0] Rn
     /* 135303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135315 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 135318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135328 */     GIR_RootConstrainSelectedInstOperands,
     /* 135329 */     // GIR_Coverage, 7228,
     /* 135329 */     GIR_EraseRootFromParent_Done,
     /* 135330 */   // Label 2562: @135330
     /* 135330 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(135379), // Rule ID 7229 //
     /* 135335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135352 */     // MIs[0] Rn
     /* 135352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135364 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 135367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135377 */     GIR_RootConstrainSelectedInstOperands,
     /* 135378 */     // GIR_Coverage, 7229,
     /* 135378 */     GIR_EraseRootFromParent_Done,
     /* 135379 */   // Label 2563: @135379
     /* 135379 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(135428), // Rule ID 7230 //
     /* 135384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135401 */     // MIs[0] Rn
     /* 135401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135413 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135426 */     GIR_RootConstrainSelectedInstOperands,
     /* 135427 */     // GIR_Coverage, 7230,
     /* 135427 */     GIR_EraseRootFromParent_Done,
     /* 135428 */   // Label 2564: @135428
     /* 135428 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(135477), // Rule ID 7231 //
     /* 135433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135450 */     // MIs[0] Rn
     /* 135450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135462 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135475 */     GIR_RootConstrainSelectedInstOperands,
     /* 135476 */     // GIR_Coverage, 7231,
     /* 135476 */     GIR_EraseRootFromParent_Done,
     /* 135477 */   // Label 2565: @135477
     /* 135477 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(135526), // Rule ID 7232 //
     /* 135482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */     // MIs[0] Rn
     /* 135499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135511 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 135514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135524 */     GIR_RootConstrainSelectedInstOperands,
     /* 135525 */     // GIR_Coverage, 7232,
     /* 135525 */     GIR_EraseRootFromParent_Done,
     /* 135526 */   // Label 2566: @135526
     /* 135526 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(135575), // Rule ID 7233 //
     /* 135531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135548 */     // MIs[0] Rn
     /* 135548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135560 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 135563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135573 */     GIR_RootConstrainSelectedInstOperands,
     /* 135574 */     // GIR_Coverage, 7233,
     /* 135574 */     GIR_EraseRootFromParent_Done,
     /* 135575 */   // Label 2567: @135575
     /* 135575 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(135624), // Rule ID 7234 //
     /* 135580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135597 */     // MIs[0] Rn
     /* 135597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135609 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 135612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135622 */     GIR_RootConstrainSelectedInstOperands,
     /* 135623 */     // GIR_Coverage, 7234,
     /* 135623 */     GIR_EraseRootFromParent_Done,
     /* 135624 */   // Label 2568: @135624
     /* 135624 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(135673), // Rule ID 7235 //
     /* 135629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135646 */     // MIs[0] Rn
     /* 135646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135658 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135671 */     GIR_RootConstrainSelectedInstOperands,
     /* 135672 */     // GIR_Coverage, 7235,
     /* 135672 */     GIR_EraseRootFromParent_Done,
     /* 135673 */   // Label 2569: @135673
     /* 135673 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135722), // Rule ID 7236 //
     /* 135678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135695 */     // MIs[0] Rn
     /* 135695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135707 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135720 */     GIR_RootConstrainSelectedInstOperands,
     /* 135721 */     // GIR_Coverage, 7236,
     /* 135721 */     GIR_EraseRootFromParent_Done,
     /* 135722 */   // Label 2570: @135722
     /* 135722 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135771), // Rule ID 7237 //
     /* 135727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135744 */     // MIs[0] Rn
     /* 135744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135756 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 135759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135769 */     GIR_RootConstrainSelectedInstOperands,
     /* 135770 */     // GIR_Coverage, 7237,
     /* 135770 */     GIR_EraseRootFromParent_Done,
     /* 135771 */   // Label 2571: @135771
     /* 135771 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135820), // Rule ID 7238 //
     /* 135776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135793 */     // MIs[0] Rn
     /* 135793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135805 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 135808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135818 */     GIR_RootConstrainSelectedInstOperands,
     /* 135819 */     // GIR_Coverage, 7238,
     /* 135819 */     GIR_EraseRootFromParent_Done,
     /* 135820 */   // Label 2572: @135820
     /* 135820 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135869), // Rule ID 7239 //
     /* 135825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135842 */     // MIs[0] Rn
     /* 135842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135854 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135867 */     GIR_RootConstrainSelectedInstOperands,
     /* 135868 */     // GIR_Coverage, 7239,
     /* 135868 */     GIR_EraseRootFromParent_Done,
     /* 135869 */   // Label 2573: @135869
     /* 135869 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135918), // Rule ID 7240 //
     /* 135874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135891 */     // MIs[0] Rn
     /* 135891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135903 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135916 */     GIR_RootConstrainSelectedInstOperands,
     /* 135917 */     // GIR_Coverage, 7240,
     /* 135917 */     GIR_EraseRootFromParent_Done,
     /* 135918 */   // Label 2574: @135918
     /* 135918 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135967), // Rule ID 7241 //
     /* 135923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135940 */     // MIs[0] Rn
     /* 135940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135952 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135965 */     GIR_RootConstrainSelectedInstOperands,
     /* 135966 */     // GIR_Coverage, 7241,
     /* 135966 */     GIR_EraseRootFromParent_Done,
     /* 135967 */   // Label 2575: @135967
     /* 135967 */   GIM_Reject,
     /* 135968 */ // Label 2560: @135968
     /* 135968 */ GIM_Reject,
     /* 135969 */ // Label 2558: @135969
     /* 135969 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(136195),
     /* 135974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135984 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(136026), // Rule ID 7222 //
     /* 135989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135999 */     // MIs[0] Rn
     /* 135999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136011 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 136014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136024 */     GIR_RootConstrainSelectedInstOperands,
     /* 136025 */     // GIR_Coverage, 7222,
     /* 136025 */     GIR_EraseRootFromParent_Done,
     /* 136026 */   // Label 2577: @136026
     /* 136026 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(136068), // Rule ID 7223 //
     /* 136031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136041 */     // MIs[0] Rn
     /* 136041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136053 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 136056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136066 */     GIR_RootConstrainSelectedInstOperands,
     /* 136067 */     // GIR_Coverage, 7223,
     /* 136067 */     GIR_EraseRootFromParent_Done,
     /* 136068 */   // Label 2578: @136068
     /* 136068 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(136110), // Rule ID 7224 //
     /* 136073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136076 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136083 */     // MIs[0] Rn
     /* 136083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136095 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 136098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136108 */     GIR_RootConstrainSelectedInstOperands,
     /* 136109 */     // GIR_Coverage, 7224,
     /* 136109 */     GIR_EraseRootFromParent_Done,
     /* 136110 */   // Label 2579: @136110
     /* 136110 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(136152), // Rule ID 7225 //
     /* 136115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136125 */     // MIs[0] Rn
     /* 136125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136137 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136150 */     GIR_RootConstrainSelectedInstOperands,
     /* 136151 */     // GIR_Coverage, 7225,
     /* 136151 */     GIR_EraseRootFromParent_Done,
     /* 136152 */   // Label 2580: @136152
     /* 136152 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(136194), // Rule ID 7226 //
     /* 136157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136167 */     // MIs[0] Rn
     /* 136167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136179 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 136182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136192 */     GIR_RootConstrainSelectedInstOperands,
     /* 136193 */     // GIR_Coverage, 7226,
     /* 136193 */     GIR_EraseRootFromParent_Done,
     /* 136194 */   // Label 2581: @136194
     /* 136194 */   GIM_Reject,
     /* 136195 */ // Label 2576: @136195
     /* 136195 */ GIM_Reject,
     /* 136196 */ // Label 2559: @136196
     /* 136196 */ GIM_Reject,
     /* 136197 */ // Label 29: @136197
     /* 136197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2584*/ GIMT_Encode4(137188),
     /* 136208 */ /*GILLT_s32*//*Label 2582*/ GIMT_Encode4(136216),
     /* 136212 */ /*GILLT_s64*//*Label 2583*/ GIMT_Encode4(136961),
     /* 136216 */ // Label 2582: @136216
     /* 136216 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(136960),
     /* 136221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136224 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(136273), // Rule ID 7247 //
     /* 136229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136246 */     // MIs[0] Rn
     /* 136246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136258 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 136261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136271 */     GIR_RootConstrainSelectedInstOperands,
     /* 136272 */     // GIR_Coverage, 7247,
     /* 136272 */     GIR_EraseRootFromParent_Done,
     /* 136273 */   // Label 2586: @136273
     /* 136273 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(136322), // Rule ID 7248 //
     /* 136278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136295 */     // MIs[0] Rn
     /* 136295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136307 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 136310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136320 */     GIR_RootConstrainSelectedInstOperands,
     /* 136321 */     // GIR_Coverage, 7248,
     /* 136321 */     GIR_EraseRootFromParent_Done,
     /* 136322 */   // Label 2587: @136322
     /* 136322 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(136371), // Rule ID 7249 //
     /* 136327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136344 */     // MIs[0] Rn
     /* 136344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136356 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 136359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136369 */     GIR_RootConstrainSelectedInstOperands,
     /* 136370 */     // GIR_Coverage, 7249,
     /* 136370 */     GIR_EraseRootFromParent_Done,
     /* 136371 */   // Label 2588: @136371
     /* 136371 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(136420), // Rule ID 7250 //
     /* 136376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136393 */     // MIs[0] Rn
     /* 136393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136405 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136418 */     GIR_RootConstrainSelectedInstOperands,
     /* 136419 */     // GIR_Coverage, 7250,
     /* 136419 */     GIR_EraseRootFromParent_Done,
     /* 136420 */   // Label 2589: @136420
     /* 136420 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(136469), // Rule ID 7251 //
     /* 136425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136442 */     // MIs[0] Rn
     /* 136442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136454 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136467 */     GIR_RootConstrainSelectedInstOperands,
     /* 136468 */     // GIR_Coverage, 7251,
     /* 136468 */     GIR_EraseRootFromParent_Done,
     /* 136469 */   // Label 2590: @136469
     /* 136469 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(136518), // Rule ID 7252 //
     /* 136474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136491 */     // MIs[0] Rn
     /* 136491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136503 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 136506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136516 */     GIR_RootConstrainSelectedInstOperands,
     /* 136517 */     // GIR_Coverage, 7252,
     /* 136517 */     GIR_EraseRootFromParent_Done,
     /* 136518 */   // Label 2591: @136518
     /* 136518 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(136567), // Rule ID 7253 //
     /* 136523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136540 */     // MIs[0] Rn
     /* 136540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136552 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 136555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136565 */     GIR_RootConstrainSelectedInstOperands,
     /* 136566 */     // GIR_Coverage, 7253,
     /* 136566 */     GIR_EraseRootFromParent_Done,
     /* 136567 */   // Label 2592: @136567
     /* 136567 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(136616), // Rule ID 7254 //
     /* 136572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136589 */     // MIs[0] Rn
     /* 136589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136601 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 136604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136614 */     GIR_RootConstrainSelectedInstOperands,
     /* 136615 */     // GIR_Coverage, 7254,
     /* 136615 */     GIR_EraseRootFromParent_Done,
     /* 136616 */   // Label 2593: @136616
     /* 136616 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(136665), // Rule ID 7255 //
     /* 136621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136638 */     // MIs[0] Rn
     /* 136638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136650 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136663 */     GIR_RootConstrainSelectedInstOperands,
     /* 136664 */     // GIR_Coverage, 7255,
     /* 136664 */     GIR_EraseRootFromParent_Done,
     /* 136665 */   // Label 2594: @136665
     /* 136665 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136714), // Rule ID 7256 //
     /* 136670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136687 */     // MIs[0] Rn
     /* 136687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136699 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136712 */     GIR_RootConstrainSelectedInstOperands,
     /* 136713 */     // GIR_Coverage, 7256,
     /* 136713 */     GIR_EraseRootFromParent_Done,
     /* 136714 */   // Label 2595: @136714
     /* 136714 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136763), // Rule ID 7257 //
     /* 136719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136736 */     // MIs[0] Rn
     /* 136736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136748 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 136751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136761 */     GIR_RootConstrainSelectedInstOperands,
     /* 136762 */     // GIR_Coverage, 7257,
     /* 136762 */     GIR_EraseRootFromParent_Done,
     /* 136763 */   // Label 2596: @136763
     /* 136763 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136812), // Rule ID 7258 //
     /* 136768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136785 */     // MIs[0] Rn
     /* 136785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136797 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 136800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136810 */     GIR_RootConstrainSelectedInstOperands,
     /* 136811 */     // GIR_Coverage, 7258,
     /* 136811 */     GIR_EraseRootFromParent_Done,
     /* 136812 */   // Label 2597: @136812
     /* 136812 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136861), // Rule ID 7259 //
     /* 136817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136834 */     // MIs[0] Rn
     /* 136834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136846 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136859 */     GIR_RootConstrainSelectedInstOperands,
     /* 136860 */     // GIR_Coverage, 7259,
     /* 136860 */     GIR_EraseRootFromParent_Done,
     /* 136861 */   // Label 2598: @136861
     /* 136861 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136910), // Rule ID 7260 //
     /* 136866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136883 */     // MIs[0] Rn
     /* 136883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136895 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136908 */     GIR_RootConstrainSelectedInstOperands,
     /* 136909 */     // GIR_Coverage, 7260,
     /* 136909 */     GIR_EraseRootFromParent_Done,
     /* 136910 */   // Label 2599: @136910
     /* 136910 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136959), // Rule ID 7261 //
     /* 136915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136932 */     // MIs[0] Rn
     /* 136932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136944 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136957 */     GIR_RootConstrainSelectedInstOperands,
     /* 136958 */     // GIR_Coverage, 7261,
     /* 136958 */     GIR_EraseRootFromParent_Done,
     /* 136959 */   // Label 2600: @136959
     /* 136959 */   GIM_Reject,
     /* 136960 */ // Label 2585: @136960
     /* 136960 */ GIM_Reject,
     /* 136961 */ // Label 2583: @136961
     /* 136961 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(137187),
     /* 136966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136976 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(137018), // Rule ID 7242 //
     /* 136981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136991 */     // MIs[0] Rn
     /* 136991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137003 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 137006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137016 */     GIR_RootConstrainSelectedInstOperands,
     /* 137017 */     // GIR_Coverage, 7242,
     /* 137017 */     GIR_EraseRootFromParent_Done,
     /* 137018 */   // Label 2602: @137018
     /* 137018 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(137060), // Rule ID 7243 //
     /* 137023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137033 */     // MIs[0] Rn
     /* 137033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137045 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 137048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137058 */     GIR_RootConstrainSelectedInstOperands,
     /* 137059 */     // GIR_Coverage, 7243,
     /* 137059 */     GIR_EraseRootFromParent_Done,
     /* 137060 */   // Label 2603: @137060
     /* 137060 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(137102), // Rule ID 7244 //
     /* 137065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137068 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137075 */     // MIs[0] Rn
     /* 137075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137087 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 137090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137100 */     GIR_RootConstrainSelectedInstOperands,
     /* 137101 */     // GIR_Coverage, 7244,
     /* 137101 */     GIR_EraseRootFromParent_Done,
     /* 137102 */   // Label 2604: @137102
     /* 137102 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(137144), // Rule ID 7245 //
     /* 137107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137117 */     // MIs[0] Rn
     /* 137117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137129 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137142 */     GIR_RootConstrainSelectedInstOperands,
     /* 137143 */     // GIR_Coverage, 7245,
     /* 137143 */     GIR_EraseRootFromParent_Done,
     /* 137144 */   // Label 2605: @137144
     /* 137144 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(137186), // Rule ID 7246 //
     /* 137149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137159 */     // MIs[0] Rn
     /* 137159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137171 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 137174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137184 */     GIR_RootConstrainSelectedInstOperands,
     /* 137185 */     // GIR_Coverage, 7246,
     /* 137185 */     GIR_EraseRootFromParent_Done,
     /* 137186 */   // Label 2606: @137186
     /* 137186 */   GIM_Reject,
     /* 137187 */ // Label 2601: @137187
     /* 137187 */ GIM_Reject,
     /* 137188 */ // Label 2584: @137188
     /* 137188 */ GIM_Reject,
     /* 137189 */ // Label 30: @137189
     /* 137189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2609*/ GIMT_Encode4(138180),
     /* 137200 */ /*GILLT_s32*//*Label 2607*/ GIMT_Encode4(137208),
     /* 137204 */ /*GILLT_s64*//*Label 2608*/ GIMT_Encode4(137953),
     /* 137208 */ // Label 2607: @137208
     /* 137208 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(137952),
     /* 137213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137216 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(137265), // Rule ID 7267 //
     /* 137221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137224 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137238 */     // MIs[0] Rn
     /* 137238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137250 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 137253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137263 */     GIR_RootConstrainSelectedInstOperands,
     /* 137264 */     // GIR_Coverage, 7267,
     /* 137264 */     GIR_EraseRootFromParent_Done,
     /* 137265 */   // Label 2611: @137265
     /* 137265 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(137314), // Rule ID 7268 //
     /* 137270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137287 */     // MIs[0] Rn
     /* 137287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137299 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 137302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137312 */     GIR_RootConstrainSelectedInstOperands,
     /* 137313 */     // GIR_Coverage, 7268,
     /* 137313 */     GIR_EraseRootFromParent_Done,
     /* 137314 */   // Label 2612: @137314
     /* 137314 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(137363), // Rule ID 7269 //
     /* 137319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137336 */     // MIs[0] Rn
     /* 137336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137348 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 137351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137361 */     GIR_RootConstrainSelectedInstOperands,
     /* 137362 */     // GIR_Coverage, 7269,
     /* 137362 */     GIR_EraseRootFromParent_Done,
     /* 137363 */   // Label 2613: @137363
     /* 137363 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(137412), // Rule ID 7270 //
     /* 137368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137385 */     // MIs[0] Rn
     /* 137385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137397 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137410 */     GIR_RootConstrainSelectedInstOperands,
     /* 137411 */     // GIR_Coverage, 7270,
     /* 137411 */     GIR_EraseRootFromParent_Done,
     /* 137412 */   // Label 2614: @137412
     /* 137412 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(137461), // Rule ID 7271 //
     /* 137417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137434 */     // MIs[0] Rn
     /* 137434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137446 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137459 */     GIR_RootConstrainSelectedInstOperands,
     /* 137460 */     // GIR_Coverage, 7271,
     /* 137460 */     GIR_EraseRootFromParent_Done,
     /* 137461 */   // Label 2615: @137461
     /* 137461 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(137510), // Rule ID 7272 //
     /* 137466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137483 */     // MIs[0] Rn
     /* 137483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137495 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 137498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137508 */     GIR_RootConstrainSelectedInstOperands,
     /* 137509 */     // GIR_Coverage, 7272,
     /* 137509 */     GIR_EraseRootFromParent_Done,
     /* 137510 */   // Label 2616: @137510
     /* 137510 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(137559), // Rule ID 7273 //
     /* 137515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137532 */     // MIs[0] Rn
     /* 137532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137544 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 137547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137557 */     GIR_RootConstrainSelectedInstOperands,
     /* 137558 */     // GIR_Coverage, 7273,
     /* 137558 */     GIR_EraseRootFromParent_Done,
     /* 137559 */   // Label 2617: @137559
     /* 137559 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(137608), // Rule ID 7274 //
     /* 137564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137581 */     // MIs[0] Rn
     /* 137581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137593 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 137596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137606 */     GIR_RootConstrainSelectedInstOperands,
     /* 137607 */     // GIR_Coverage, 7274,
     /* 137607 */     GIR_EraseRootFromParent_Done,
     /* 137608 */   // Label 2618: @137608
     /* 137608 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(137657), // Rule ID 7275 //
     /* 137613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137630 */     // MIs[0] Rn
     /* 137630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137642 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137655 */     GIR_RootConstrainSelectedInstOperands,
     /* 137656 */     // GIR_Coverage, 7275,
     /* 137656 */     GIR_EraseRootFromParent_Done,
     /* 137657 */   // Label 2619: @137657
     /* 137657 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137706), // Rule ID 7276 //
     /* 137662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137679 */     // MIs[0] Rn
     /* 137679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137691 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137704 */     GIR_RootConstrainSelectedInstOperands,
     /* 137705 */     // GIR_Coverage, 7276,
     /* 137705 */     GIR_EraseRootFromParent_Done,
     /* 137706 */   // Label 2620: @137706
     /* 137706 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137755), // Rule ID 7277 //
     /* 137711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137728 */     // MIs[0] Rn
     /* 137728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137740 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 137743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137753 */     GIR_RootConstrainSelectedInstOperands,
     /* 137754 */     // GIR_Coverage, 7277,
     /* 137754 */     GIR_EraseRootFromParent_Done,
     /* 137755 */   // Label 2621: @137755
     /* 137755 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137804), // Rule ID 7278 //
     /* 137760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137777 */     // MIs[0] Rn
     /* 137777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137789 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 137792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137802 */     GIR_RootConstrainSelectedInstOperands,
     /* 137803 */     // GIR_Coverage, 7278,
     /* 137803 */     GIR_EraseRootFromParent_Done,
     /* 137804 */   // Label 2622: @137804
     /* 137804 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137853), // Rule ID 7279 //
     /* 137809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137826 */     // MIs[0] Rn
     /* 137826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137838 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 137841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137851 */     GIR_RootConstrainSelectedInstOperands,
     /* 137852 */     // GIR_Coverage, 7279,
     /* 137852 */     GIR_EraseRootFromParent_Done,
     /* 137853 */   // Label 2623: @137853
     /* 137853 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137902), // Rule ID 7280 //
     /* 137858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137875 */     // MIs[0] Rn
     /* 137875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137887 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137900 */     GIR_RootConstrainSelectedInstOperands,
     /* 137901 */     // GIR_Coverage, 7280,
     /* 137901 */     GIR_EraseRootFromParent_Done,
     /* 137902 */   // Label 2624: @137902
     /* 137902 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137951), // Rule ID 7281 //
     /* 137907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137924 */     // MIs[0] Rn
     /* 137924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137936 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137949 */     GIR_RootConstrainSelectedInstOperands,
     /* 137950 */     // GIR_Coverage, 7281,
     /* 137950 */     GIR_EraseRootFromParent_Done,
     /* 137951 */   // Label 2625: @137951
     /* 137951 */   GIM_Reject,
     /* 137952 */ // Label 2610: @137952
     /* 137952 */ GIM_Reject,
     /* 137953 */ // Label 2608: @137953
     /* 137953 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(138179),
     /* 137958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137961 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137968 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(138010), // Rule ID 7262 //
     /* 137973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137983 */     // MIs[0] Rn
     /* 137983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137995 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 137998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138008 */     GIR_RootConstrainSelectedInstOperands,
     /* 138009 */     // GIR_Coverage, 7262,
     /* 138009 */     GIR_EraseRootFromParent_Done,
     /* 138010 */   // Label 2627: @138010
     /* 138010 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(138052), // Rule ID 7263 //
     /* 138015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138025 */     // MIs[0] Rn
     /* 138025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138037 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 138040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138050 */     GIR_RootConstrainSelectedInstOperands,
     /* 138051 */     // GIR_Coverage, 7263,
     /* 138051 */     GIR_EraseRootFromParent_Done,
     /* 138052 */   // Label 2628: @138052
     /* 138052 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(138094), // Rule ID 7264 //
     /* 138057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138060 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138067 */     // MIs[0] Rn
     /* 138067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138079 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 138082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138092 */     GIR_RootConstrainSelectedInstOperands,
     /* 138093 */     // GIR_Coverage, 7264,
     /* 138093 */     GIR_EraseRootFromParent_Done,
     /* 138094 */   // Label 2629: @138094
     /* 138094 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(138136), // Rule ID 7265 //
     /* 138099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138109 */     // MIs[0] Rn
     /* 138109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138121 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138134 */     GIR_RootConstrainSelectedInstOperands,
     /* 138135 */     // GIR_Coverage, 7265,
     /* 138135 */     GIR_EraseRootFromParent_Done,
     /* 138136 */   // Label 2630: @138136
     /* 138136 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(138178), // Rule ID 7266 //
     /* 138141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 138144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138151 */     // MIs[0] Rn
     /* 138151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138163 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 138163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 138166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138176 */     GIR_RootConstrainSelectedInstOperands,
     /* 138177 */     // GIR_Coverage, 7266,
     /* 138177 */     GIR_EraseRootFromParent_Done,
     /* 138178 */   // Label 2631: @138178
     /* 138178 */   GIM_Reject,
     /* 138179 */ // Label 2626: @138179
     /* 138179 */ GIM_Reject,
     /* 138180 */ // Label 2609: @138180
     /* 138180 */ GIM_Reject,
     /* 138181 */ // Label 31: @138181
     /* 138181 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2635*/ GIMT_Encode4(138885),
     /* 138192 */ /*GILLT_s16*//*Label 2632*/ GIMT_Encode4(138204),
     /* 138196 */ /*GILLT_s32*//*Label 2633*/ GIMT_Encode4(138431),
     /* 138200 */ /*GILLT_s64*//*Label 2634*/ GIMT_Encode4(138658),
     /* 138204 */ // Label 2632: @138204
     /* 138204 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(138430),
     /* 138209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138212 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138219 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(138261), // Rule ID 2584 //
     /* 138224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138234 */     // MIs[0] Rn
     /* 138234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138246 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 138249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138259 */     GIR_RootConstrainSelectedInstOperands,
     /* 138260 */     // GIR_Coverage, 2584,
     /* 138260 */     GIR_EraseRootFromParent_Done,
     /* 138261 */   // Label 2637: @138261
     /* 138261 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(138303), // Rule ID 2585 //
     /* 138266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138276 */     // MIs[0] Rn
     /* 138276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138288 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 138291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138301 */     GIR_RootConstrainSelectedInstOperands,
     /* 138302 */     // GIR_Coverage, 2585,
     /* 138302 */     GIR_EraseRootFromParent_Done,
     /* 138303 */   // Label 2638: @138303
     /* 138303 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(138345), // Rule ID 2586 //
     /* 138308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138318 */     // MIs[0] Rn
     /* 138318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138330 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 138333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138343 */     GIR_RootConstrainSelectedInstOperands,
     /* 138344 */     // GIR_Coverage, 2586,
     /* 138344 */     GIR_EraseRootFromParent_Done,
     /* 138345 */   // Label 2639: @138345
     /* 138345 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(138387), // Rule ID 2587 //
     /* 138350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138360 */     // MIs[0] Rn
     /* 138360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138372 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138385 */     GIR_RootConstrainSelectedInstOperands,
     /* 138386 */     // GIR_Coverage, 2587,
     /* 138386 */     GIR_EraseRootFromParent_Done,
     /* 138387 */   // Label 2640: @138387
     /* 138387 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(138429), // Rule ID 2588 //
     /* 138392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138402 */     // MIs[0] Rn
     /* 138402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138414 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138427 */     GIR_RootConstrainSelectedInstOperands,
     /* 138428 */     // GIR_Coverage, 2588,
     /* 138428 */     GIR_EraseRootFromParent_Done,
     /* 138429 */   // Label 2641: @138429
     /* 138429 */   GIM_Reject,
     /* 138430 */ // Label 2636: @138430
     /* 138430 */ GIM_Reject,
     /* 138431 */ // Label 2633: @138431
     /* 138431 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(138657),
     /* 138436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138439 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138446 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(138488), // Rule ID 7357 //
     /* 138451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138461 */     // MIs[0] Rn
     /* 138461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138473 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 138476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138486 */     GIR_RootConstrainSelectedInstOperands,
     /* 138487 */     // GIR_Coverage, 7357,
     /* 138487 */     GIR_EraseRootFromParent_Done,
     /* 138488 */   // Label 2643: @138488
     /* 138488 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(138530), // Rule ID 7358 //
     /* 138493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138496 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138503 */     // MIs[0] Rn
     /* 138503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138515 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 138518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138528 */     GIR_RootConstrainSelectedInstOperands,
     /* 138529 */     // GIR_Coverage, 7358,
     /* 138529 */     GIR_EraseRootFromParent_Done,
     /* 138530 */   // Label 2644: @138530
     /* 138530 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138572), // Rule ID 7359 //
     /* 138535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138545 */     // MIs[0] Rn
     /* 138545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138557 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 138560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138570 */     GIR_RootConstrainSelectedInstOperands,
     /* 138571 */     // GIR_Coverage, 7359,
     /* 138571 */     GIR_EraseRootFromParent_Done,
     /* 138572 */   // Label 2645: @138572
     /* 138572 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(138614), // Rule ID 7360 //
     /* 138577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138587 */     // MIs[0] Rn
     /* 138587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138599 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138612 */     GIR_RootConstrainSelectedInstOperands,
     /* 138613 */     // GIR_Coverage, 7360,
     /* 138613 */     GIR_EraseRootFromParent_Done,
     /* 138614 */   // Label 2646: @138614
     /* 138614 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(138656), // Rule ID 7361 //
     /* 138619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138622 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138629 */     // MIs[0] Rn
     /* 138629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138641 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138654 */     GIR_RootConstrainSelectedInstOperands,
     /* 138655 */     // GIR_Coverage, 7361,
     /* 138655 */     GIR_EraseRootFromParent_Done,
     /* 138656 */   // Label 2647: @138656
     /* 138656 */   GIM_Reject,
     /* 138657 */ // Label 2642: @138657
     /* 138657 */ GIM_Reject,
     /* 138658 */ // Label 2634: @138658
     /* 138658 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(138884),
     /* 138663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138673 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(138715), // Rule ID 7362 //
     /* 138678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138688 */     // MIs[0] Rn
     /* 138688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138700 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 138703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138713 */     GIR_RootConstrainSelectedInstOperands,
     /* 138714 */     // GIR_Coverage, 7362,
     /* 138714 */     GIR_EraseRootFromParent_Done,
     /* 138715 */   // Label 2649: @138715
     /* 138715 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138757), // Rule ID 7363 //
     /* 138720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138730 */     // MIs[0] Rn
     /* 138730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138742 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 138745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138755 */     GIR_RootConstrainSelectedInstOperands,
     /* 138756 */     // GIR_Coverage, 7363,
     /* 138756 */     GIR_EraseRootFromParent_Done,
     /* 138757 */   // Label 2650: @138757
     /* 138757 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(138799), // Rule ID 7364 //
     /* 138762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138772 */     // MIs[0] Rn
     /* 138772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138784 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 138787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138797 */     GIR_RootConstrainSelectedInstOperands,
     /* 138798 */     // GIR_Coverage, 7364,
     /* 138798 */     GIR_EraseRootFromParent_Done,
     /* 138799 */   // Label 2651: @138799
     /* 138799 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(138841), // Rule ID 7365 //
     /* 138804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138814 */     // MIs[0] Rn
     /* 138814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138826 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138839 */     GIR_RootConstrainSelectedInstOperands,
     /* 138840 */     // GIR_Coverage, 7365,
     /* 138840 */     GIR_EraseRootFromParent_Done,
     /* 138841 */   // Label 2652: @138841
     /* 138841 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(138883), // Rule ID 7366 //
     /* 138846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138856 */     // MIs[0] Rn
     /* 138856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138868 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138881 */     GIR_RootConstrainSelectedInstOperands,
     /* 138882 */     // GIR_Coverage, 7366,
     /* 138882 */     GIR_EraseRootFromParent_Done,
     /* 138883 */   // Label 2653: @138883
     /* 138883 */   GIM_Reject,
     /* 138884 */ // Label 2648: @138884
     /* 138884 */ GIM_Reject,
     /* 138885 */ // Label 2635: @138885
     /* 138885 */ GIM_Reject,
     /* 138886 */ // Label 32: @138886
     /* 138886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2657*/ GIMT_Encode4(139590),
     /* 138897 */ /*GILLT_s16*//*Label 2654*/ GIMT_Encode4(138909),
     /* 138901 */ /*GILLT_s32*//*Label 2655*/ GIMT_Encode4(139136),
     /* 138905 */ /*GILLT_s64*//*Label 2656*/ GIMT_Encode4(139363),
     /* 138909 */ // Label 2654: @138909
     /* 138909 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(139135),
     /* 138914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138924 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(138966), // Rule ID 7367 //
     /* 138929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138939 */     // MIs[0] Rn
     /* 138939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138951 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 138954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138964 */     GIR_RootConstrainSelectedInstOperands,
     /* 138965 */     // GIR_Coverage, 7367,
     /* 138965 */     GIR_EraseRootFromParent_Done,
     /* 138966 */   // Label 2659: @138966
     /* 138966 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(139008), // Rule ID 7368 //
     /* 138971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138981 */     // MIs[0] Rn
     /* 138981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138993 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 138996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139006 */     GIR_RootConstrainSelectedInstOperands,
     /* 139007 */     // GIR_Coverage, 7368,
     /* 139007 */     GIR_EraseRootFromParent_Done,
     /* 139008 */   // Label 2660: @139008
     /* 139008 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(139050), // Rule ID 7369 //
     /* 139013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139023 */     // MIs[0] Rn
     /* 139023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139035 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 139038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139048 */     GIR_RootConstrainSelectedInstOperands,
     /* 139049 */     // GIR_Coverage, 7369,
     /* 139049 */     GIR_EraseRootFromParent_Done,
     /* 139050 */   // Label 2661: @139050
     /* 139050 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(139092), // Rule ID 7370 //
     /* 139055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139065 */     // MIs[0] Rn
     /* 139065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139077 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139090 */     GIR_RootConstrainSelectedInstOperands,
     /* 139091 */     // GIR_Coverage, 7370,
     /* 139091 */     GIR_EraseRootFromParent_Done,
     /* 139092 */   // Label 2662: @139092
     /* 139092 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(139134), // Rule ID 7371 //
     /* 139097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139107 */     // MIs[0] Rn
     /* 139107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139119 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 139122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139132 */     GIR_RootConstrainSelectedInstOperands,
     /* 139133 */     // GIR_Coverage, 7371,
     /* 139133 */     GIR_EraseRootFromParent_Done,
     /* 139134 */   // Label 2663: @139134
     /* 139134 */   GIM_Reject,
     /* 139135 */ // Label 2658: @139135
     /* 139135 */ GIM_Reject,
     /* 139136 */ // Label 2655: @139136
     /* 139136 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(139362),
     /* 139141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139151 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(139193), // Rule ID 7372 //
     /* 139156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139166 */     // MIs[0] Rn
     /* 139166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139178 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 139181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139191 */     GIR_RootConstrainSelectedInstOperands,
     /* 139192 */     // GIR_Coverage, 7372,
     /* 139192 */     GIR_EraseRootFromParent_Done,
     /* 139193 */   // Label 2665: @139193
     /* 139193 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(139235), // Rule ID 7373 //
     /* 139198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139208 */     // MIs[0] Rn
     /* 139208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139220 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 139223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139233 */     GIR_RootConstrainSelectedInstOperands,
     /* 139234 */     // GIR_Coverage, 7373,
     /* 139234 */     GIR_EraseRootFromParent_Done,
     /* 139235 */   // Label 2666: @139235
     /* 139235 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(139277), // Rule ID 7374 //
     /* 139240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139250 */     // MIs[0] Rn
     /* 139250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139262 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 139265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139275 */     GIR_RootConstrainSelectedInstOperands,
     /* 139276 */     // GIR_Coverage, 7374,
     /* 139276 */     GIR_EraseRootFromParent_Done,
     /* 139277 */   // Label 2667: @139277
     /* 139277 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(139319), // Rule ID 7375 //
     /* 139282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139292 */     // MIs[0] Rn
     /* 139292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139304 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139317 */     GIR_RootConstrainSelectedInstOperands,
     /* 139318 */     // GIR_Coverage, 7375,
     /* 139318 */     GIR_EraseRootFromParent_Done,
     /* 139319 */   // Label 2668: @139319
     /* 139319 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(139361), // Rule ID 7376 //
     /* 139324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139334 */     // MIs[0] Rn
     /* 139334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139346 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139359 */     GIR_RootConstrainSelectedInstOperands,
     /* 139360 */     // GIR_Coverage, 7376,
     /* 139360 */     GIR_EraseRootFromParent_Done,
     /* 139361 */   // Label 2669: @139361
     /* 139361 */   GIM_Reject,
     /* 139362 */ // Label 2664: @139362
     /* 139362 */ GIM_Reject,
     /* 139363 */ // Label 2656: @139363
     /* 139363 */ GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(139589),
     /* 139368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139378 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(139420), // Rule ID 7377 //
     /* 139383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139393 */     // MIs[0] Rn
     /* 139393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139405 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 139408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139418 */     GIR_RootConstrainSelectedInstOperands,
     /* 139419 */     // GIR_Coverage, 7377,
     /* 139419 */     GIR_EraseRootFromParent_Done,
     /* 139420 */   // Label 2671: @139420
     /* 139420 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(139462), // Rule ID 7378 //
     /* 139425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139435 */     // MIs[0] Rn
     /* 139435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139447 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 139450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139460 */     GIR_RootConstrainSelectedInstOperands,
     /* 139461 */     // GIR_Coverage, 7378,
     /* 139461 */     GIR_EraseRootFromParent_Done,
     /* 139462 */   // Label 2672: @139462
     /* 139462 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(139504), // Rule ID 7379 //
     /* 139467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139477 */     // MIs[0] Rn
     /* 139477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139489 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 139492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139502 */     GIR_RootConstrainSelectedInstOperands,
     /* 139503 */     // GIR_Coverage, 7379,
     /* 139503 */     GIR_EraseRootFromParent_Done,
     /* 139504 */   // Label 2673: @139504
     /* 139504 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(139546), // Rule ID 7380 //
     /* 139509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139519 */     // MIs[0] Rn
     /* 139519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139531 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139544 */     GIR_RootConstrainSelectedInstOperands,
     /* 139545 */     // GIR_Coverage, 7380,
     /* 139545 */     GIR_EraseRootFromParent_Done,
     /* 139546 */   // Label 2674: @139546
     /* 139546 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(139588), // Rule ID 7381 //
     /* 139551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139561 */     // MIs[0] Rn
     /* 139561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139573 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139586 */     GIR_RootConstrainSelectedInstOperands,
     /* 139587 */     // GIR_Coverage, 7381,
     /* 139587 */     GIR_EraseRootFromParent_Done,
     /* 139588 */   // Label 2675: @139588
     /* 139588 */   GIM_Reject,
     /* 139589 */ // Label 2670: @139589
     /* 139589 */ GIM_Reject,
     /* 139590 */ // Label 2657: @139590
     /* 139590 */ GIM_Reject,
     /* 139591 */ // Label 33: @139591
     /* 139591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(140295),
     /* 139602 */ /*GILLT_s16*//*Label 2676*/ GIMT_Encode4(139614),
     /* 139606 */ /*GILLT_s32*//*Label 2677*/ GIMT_Encode4(139841),
     /* 139610 */ /*GILLT_s64*//*Label 2678*/ GIMT_Encode4(140068),
     /* 139614 */ // Label 2676: @139614
     /* 139614 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(139840),
     /* 139619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139629 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(139671), // Rule ID 7382 //
     /* 139634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139644 */     // MIs[0] Rn
     /* 139644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139656 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 139659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139669 */     GIR_RootConstrainSelectedInstOperands,
     /* 139670 */     // GIR_Coverage, 7382,
     /* 139670 */     GIR_EraseRootFromParent_Done,
     /* 139671 */   // Label 2681: @139671
     /* 139671 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(139713), // Rule ID 7383 //
     /* 139676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139686 */     // MIs[0] Rn
     /* 139686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139698 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 139701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139711 */     GIR_RootConstrainSelectedInstOperands,
     /* 139712 */     // GIR_Coverage, 7383,
     /* 139712 */     GIR_EraseRootFromParent_Done,
     /* 139713 */   // Label 2682: @139713
     /* 139713 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139755), // Rule ID 7384 //
     /* 139718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139728 */     // MIs[0] Rn
     /* 139728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139740 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 139743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139753 */     GIR_RootConstrainSelectedInstOperands,
     /* 139754 */     // GIR_Coverage, 7384,
     /* 139754 */     GIR_EraseRootFromParent_Done,
     /* 139755 */   // Label 2683: @139755
     /* 139755 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139797), // Rule ID 7385 //
     /* 139760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139770 */     // MIs[0] Rn
     /* 139770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139782 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139795 */     GIR_RootConstrainSelectedInstOperands,
     /* 139796 */     // GIR_Coverage, 7385,
     /* 139796 */     GIR_EraseRootFromParent_Done,
     /* 139797 */   // Label 2684: @139797
     /* 139797 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139839), // Rule ID 7386 //
     /* 139802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139812 */     // MIs[0] Rn
     /* 139812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139824 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139837 */     GIR_RootConstrainSelectedInstOperands,
     /* 139838 */     // GIR_Coverage, 7386,
     /* 139838 */     GIR_EraseRootFromParent_Done,
     /* 139839 */   // Label 2685: @139839
     /* 139839 */   GIM_Reject,
     /* 139840 */ // Label 2680: @139840
     /* 139840 */ GIM_Reject,
     /* 139841 */ // Label 2677: @139841
     /* 139841 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(140067),
     /* 139846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139856 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139898), // Rule ID 7387 //
     /* 139861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139871 */     // MIs[0] Rn
     /* 139871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139883 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139896 */     GIR_RootConstrainSelectedInstOperands,
     /* 139897 */     // GIR_Coverage, 7387,
     /* 139897 */     GIR_EraseRootFromParent_Done,
     /* 139898 */   // Label 2687: @139898
     /* 139898 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139940), // Rule ID 7388 //
     /* 139903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139913 */     // MIs[0] Rn
     /* 139913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139925 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 139928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139938 */     GIR_RootConstrainSelectedInstOperands,
     /* 139939 */     // GIR_Coverage, 7388,
     /* 139939 */     GIR_EraseRootFromParent_Done,
     /* 139940 */   // Label 2688: @139940
     /* 139940 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139982), // Rule ID 7389 //
     /* 139945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139955 */     // MIs[0] Rn
     /* 139955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139967 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 139970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139980 */     GIR_RootConstrainSelectedInstOperands,
     /* 139981 */     // GIR_Coverage, 7389,
     /* 139981 */     GIR_EraseRootFromParent_Done,
     /* 139982 */   // Label 2689: @139982
     /* 139982 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(140024), // Rule ID 7390 //
     /* 139987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139997 */     // MIs[0] Rn
     /* 139997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140009 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140022 */     GIR_RootConstrainSelectedInstOperands,
     /* 140023 */     // GIR_Coverage, 7390,
     /* 140023 */     GIR_EraseRootFromParent_Done,
     /* 140024 */   // Label 2690: @140024
     /* 140024 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(140066), // Rule ID 7391 //
     /* 140029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140039 */     // MIs[0] Rn
     /* 140039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140051 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 140054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140064 */     GIR_RootConstrainSelectedInstOperands,
     /* 140065 */     // GIR_Coverage, 7391,
     /* 140065 */     GIR_EraseRootFromParent_Done,
     /* 140066 */   // Label 2691: @140066
     /* 140066 */   GIM_Reject,
     /* 140067 */ // Label 2686: @140067
     /* 140067 */ GIM_Reject,
     /* 140068 */ // Label 2678: @140068
     /* 140068 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(140294),
     /* 140073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140076 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140083 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(140125), // Rule ID 7392 //
     /* 140088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 140094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140098 */     // MIs[0] Rn
     /* 140098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140110 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 140113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140123 */     GIR_RootConstrainSelectedInstOperands,
     /* 140124 */     // GIR_Coverage, 7392,
     /* 140124 */     GIR_EraseRootFromParent_Done,
     /* 140125 */   // Label 2693: @140125
     /* 140125 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(140167), // Rule ID 7393 //
     /* 140130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 140136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140140 */     // MIs[0] Rn
     /* 140140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140152 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 140155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140165 */     GIR_RootConstrainSelectedInstOperands,
     /* 140166 */     // GIR_Coverage, 7393,
     /* 140166 */     GIR_EraseRootFromParent_Done,
     /* 140167 */   // Label 2694: @140167
     /* 140167 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(140209), // Rule ID 7394 //
     /* 140172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140175 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140182 */     // MIs[0] Rn
     /* 140182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140194 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 140197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140207 */     GIR_RootConstrainSelectedInstOperands,
     /* 140208 */     // GIR_Coverage, 7394,
     /* 140208 */     GIR_EraseRootFromParent_Done,
     /* 140209 */   // Label 2695: @140209
     /* 140209 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(140251), // Rule ID 7395 //
     /* 140214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 140220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140224 */     // MIs[0] Rn
     /* 140224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140236 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140249 */     GIR_RootConstrainSelectedInstOperands,
     /* 140250 */     // GIR_Coverage, 7395,
     /* 140250 */     GIR_EraseRootFromParent_Done,
     /* 140251 */   // Label 2696: @140251
     /* 140251 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(140293), // Rule ID 7396 //
     /* 140256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 140259 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 140262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140266 */     // MIs[0] Rn
     /* 140266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140278 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 140278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 140281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 140283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 140285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140291 */     GIR_RootConstrainSelectedInstOperands,
     /* 140292 */     // GIR_Coverage, 7396,
     /* 140292 */     GIR_EraseRootFromParent_Done,
     /* 140293 */   // Label 2697: @140293
     /* 140293 */   GIM_Reject,
     /* 140294 */ // Label 2692: @140294
     /* 140294 */ GIM_Reject,
     /* 140295 */ // Label 2679: @140295
     /* 140295 */ GIM_Reject,
     /* 140296 */ // Label 34: @140296
     /* 140296 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(140323), // Rule ID 7012 //
     /* 140301 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140304 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 140308 */   // MIs[0] Operand 1
     /* 140308 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 140311 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 140311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 140314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 140317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140321 */   GIR_RootConstrainSelectedInstOperands,
     /* 140322 */   // GIR_Coverage, 7012,
     /* 140322 */   GIR_EraseRootFromParent_Done,
     /* 140323 */ // Label 2698: @140323
     /* 140323 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(140346), // Rule ID 7013 //
     /* 140328 */   // MIs[0] Operand 0
     /* 140328 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 140331 */   // MIs[0] Operand 1
     /* 140331 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 140334 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 140334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 140337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 140340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140344 */   GIR_RootConstrainSelectedInstOperands,
     /* 140345 */   // GIR_Coverage, 7013,
     /* 140345 */   GIR_EraseRootFromParent_Done,
     /* 140346 */ // Label 2699: @140346
     /* 140346 */ GIM_Reject,
     /* 140347 */ // Label 35: @140347
     /* 140347 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(152874),
     /* 140352 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 140355 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(140446), // Rule ID 6491 //
     /* 140360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 140363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 140368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 140386 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 140389 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 140394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140398 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 140402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140414 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 140414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 140417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 140421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 140430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 140434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 140439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140444 */     GIR_RootConstrainSelectedInstOperands,
     /* 140445 */     // GIR_Coverage, 6491,
     /* 140445 */     GIR_EraseRootFromParent_Done,
     /* 140446 */   // Label 2701: @140446
     /* 140446 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(140537), // Rule ID 6492 //
     /* 140451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 140454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 140459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 140477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 140480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 140485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140489 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 140493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140505 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 140505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 140508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 140512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140517 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 140521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 140525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 140530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140535 */     GIR_RootConstrainSelectedInstOperands,
     /* 140536 */     // GIR_Coverage, 6492,
     /* 140536 */     GIR_EraseRootFromParent_Done,
     /* 140537 */   // Label 2702: @140537
     /* 140537 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(140598), // Rule ID 4898 //
     /* 140542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 140547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 140565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140574 */     // MIs[1] Operand 2
     /* 140574 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 140585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140587 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 140587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 140590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 140596 */     GIR_RootConstrainSelectedInstOperands,
     /* 140597 */     // GIR_Coverage, 4898,
     /* 140597 */     GIR_EraseRootFromParent_Done,
     /* 140598 */   // Label 2703: @140598
     /* 140598 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(140638), // Rule ID 2651 //
     /* 140603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 140611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140618 */     // MIs[0] pattern
     /* 140618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140626 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 140629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140631 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140636 */     GIR_RootConstrainSelectedInstOperands,
     /* 140637 */     // GIR_Coverage, 2651,
     /* 140637 */     GIR_EraseRootFromParent_Done,
     /* 140638 */   // Label 2704: @140638
     /* 140638 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(140678), // Rule ID 9903 //
     /* 140643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 140651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140658 */     // MIs[0] pattern
     /* 140658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140666 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 140669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140671 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140676 */     GIR_RootConstrainSelectedInstOperands,
     /* 140677 */     // GIR_Coverage, 9903,
     /* 140677 */     GIR_EraseRootFromParent_Done,
     /* 140678 */   // Label 2705: @140678
     /* 140678 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140718), // Rule ID 9906 //
     /* 140683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 140691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140698 */     // MIs[0] pattern
     /* 140698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140706 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 140709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140711 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140716 */     GIR_RootConstrainSelectedInstOperands,
     /* 140717 */     // GIR_Coverage, 9906,
     /* 140717 */     GIR_EraseRootFromParent_Done,
     /* 140718 */   // Label 2706: @140718
     /* 140718 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140758), // Rule ID 9909 //
     /* 140723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 140731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140738 */     // MIs[0] pattern
     /* 140738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140746 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 140749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140751 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140756 */     GIR_RootConstrainSelectedInstOperands,
     /* 140757 */     // GIR_Coverage, 9909,
     /* 140757 */     GIR_EraseRootFromParent_Done,
     /* 140758 */   // Label 2707: @140758
     /* 140758 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140797), // Rule ID 66 //
     /* 140763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 140766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 140771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140785 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 140788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 140795 */     GIR_RootConstrainSelectedInstOperands,
     /* 140796 */     // GIR_Coverage, 66,
     /* 140796 */     GIR_EraseRootFromParent_Done,
     /* 140797 */   // Label 2708: @140797
     /* 140797 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140833), // Rule ID 346 //
     /* 140802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140824 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 140827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140831 */     GIR_RootConstrainSelectedInstOperands,
     /* 140832 */     // GIR_Coverage, 346,
     /* 140832 */     GIR_EraseRootFromParent_Done,
     /* 140833 */   // Label 2709: @140833
     /* 140833 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140869), // Rule ID 347 //
     /* 140838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140860 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 140863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140867 */     GIR_RootConstrainSelectedInstOperands,
     /* 140868 */     // GIR_Coverage, 347,
     /* 140868 */     GIR_EraseRootFromParent_Done,
     /* 140869 */   // Label 2710: @140869
     /* 140869 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140905), // Rule ID 348 //
     /* 140874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140896 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 140899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140903 */     GIR_RootConstrainSelectedInstOperands,
     /* 140904 */     // GIR_Coverage, 348,
     /* 140904 */     GIR_EraseRootFromParent_Done,
     /* 140905 */   // Label 2711: @140905
     /* 140905 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140941), // Rule ID 349 //
     /* 140910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140932 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 140935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140939 */     GIR_RootConstrainSelectedInstOperands,
     /* 140940 */     // GIR_Coverage, 349,
     /* 140940 */     GIR_EraseRootFromParent_Done,
     /* 140941 */   // Label 2712: @140941
     /* 140941 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140977), // Rule ID 350 //
     /* 140946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140968 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 140971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140975 */     GIR_RootConstrainSelectedInstOperands,
     /* 140976 */     // GIR_Coverage, 350,
     /* 140976 */     GIR_EraseRootFromParent_Done,
     /* 140977 */   // Label 2713: @140977
     /* 140977 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(141013), // Rule ID 351 //
     /* 140982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141004 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 141007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141011 */     GIR_RootConstrainSelectedInstOperands,
     /* 141012 */     // GIR_Coverage, 351,
     /* 141012 */     GIR_EraseRootFromParent_Done,
     /* 141013 */   // Label 2714: @141013
     /* 141013 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(141049), // Rule ID 352 //
     /* 141018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141040 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 141043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141047 */     GIR_RootConstrainSelectedInstOperands,
     /* 141048 */     // GIR_Coverage, 352,
     /* 141048 */     GIR_EraseRootFromParent_Done,
     /* 141049 */   // Label 2715: @141049
     /* 141049 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(141085), // Rule ID 353 //
     /* 141054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141076 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 141079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141083 */     GIR_RootConstrainSelectedInstOperands,
     /* 141084 */     // GIR_Coverage, 353,
     /* 141084 */     GIR_EraseRootFromParent_Done,
     /* 141085 */   // Label 2716: @141085
     /* 141085 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(141121), // Rule ID 354 //
     /* 141090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141112 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 141115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141119 */     GIR_RootConstrainSelectedInstOperands,
     /* 141120 */     // GIR_Coverage, 354,
     /* 141120 */     GIR_EraseRootFromParent_Done,
     /* 141121 */   // Label 2717: @141121
     /* 141121 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(141157), // Rule ID 355 //
     /* 141126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141148 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 141151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141155 */     GIR_RootConstrainSelectedInstOperands,
     /* 141156 */     // GIR_Coverage, 355,
     /* 141156 */     GIR_EraseRootFromParent_Done,
     /* 141157 */   // Label 2718: @141157
     /* 141157 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(141193), // Rule ID 356 //
     /* 141162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141184 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 141187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141191 */     GIR_RootConstrainSelectedInstOperands,
     /* 141192 */     // GIR_Coverage, 356,
     /* 141192 */     GIR_EraseRootFromParent_Done,
     /* 141193 */   // Label 2719: @141193
     /* 141193 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(141229), // Rule ID 357 //
     /* 141198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141220 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 141223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141227 */     GIR_RootConstrainSelectedInstOperands,
     /* 141228 */     // GIR_Coverage, 357,
     /* 141228 */     GIR_EraseRootFromParent_Done,
     /* 141229 */   // Label 2720: @141229
     /* 141229 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(141265), // Rule ID 358 //
     /* 141234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141256 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 141259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141263 */     GIR_RootConstrainSelectedInstOperands,
     /* 141264 */     // GIR_Coverage, 358,
     /* 141264 */     GIR_EraseRootFromParent_Done,
     /* 141265 */   // Label 2721: @141265
     /* 141265 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(141301), // Rule ID 359 //
     /* 141270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141292 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 141295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141299 */     GIR_RootConstrainSelectedInstOperands,
     /* 141300 */     // GIR_Coverage, 359,
     /* 141300 */     GIR_EraseRootFromParent_Done,
     /* 141301 */   // Label 2722: @141301
     /* 141301 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(141337), // Rule ID 360 //
     /* 141306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141328 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 141331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141335 */     GIR_RootConstrainSelectedInstOperands,
     /* 141336 */     // GIR_Coverage, 360,
     /* 141336 */     GIR_EraseRootFromParent_Done,
     /* 141337 */   // Label 2723: @141337
     /* 141337 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(141373), // Rule ID 361 //
     /* 141342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141364 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 141367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141371 */     GIR_RootConstrainSelectedInstOperands,
     /* 141372 */     // GIR_Coverage, 361,
     /* 141372 */     GIR_EraseRootFromParent_Done,
     /* 141373 */   // Label 2724: @141373
     /* 141373 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(141409), // Rule ID 362 //
     /* 141378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141400 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 141403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141407 */     GIR_RootConstrainSelectedInstOperands,
     /* 141408 */     // GIR_Coverage, 362,
     /* 141408 */     GIR_EraseRootFromParent_Done,
     /* 141409 */   // Label 2725: @141409
     /* 141409 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(141445), // Rule ID 363 //
     /* 141414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141436 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 141439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141443 */     GIR_RootConstrainSelectedInstOperands,
     /* 141444 */     // GIR_Coverage, 363,
     /* 141444 */     GIR_EraseRootFromParent_Done,
     /* 141445 */   // Label 2726: @141445
     /* 141445 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(141481), // Rule ID 364 //
     /* 141450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141472 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 141475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141479 */     GIR_RootConstrainSelectedInstOperands,
     /* 141480 */     // GIR_Coverage, 364,
     /* 141480 */     GIR_EraseRootFromParent_Done,
     /* 141481 */   // Label 2727: @141481
     /* 141481 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(141517), // Rule ID 365 //
     /* 141486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141508 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 141511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141515 */     GIR_RootConstrainSelectedInstOperands,
     /* 141516 */     // GIR_Coverage, 365,
     /* 141516 */     GIR_EraseRootFromParent_Done,
     /* 141517 */   // Label 2728: @141517
     /* 141517 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(141553), // Rule ID 366 //
     /* 141522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141544 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 141547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141551 */     GIR_RootConstrainSelectedInstOperands,
     /* 141552 */     // GIR_Coverage, 366,
     /* 141552 */     GIR_EraseRootFromParent_Done,
     /* 141553 */   // Label 2729: @141553
     /* 141553 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141589), // Rule ID 367 //
     /* 141558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141580 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 141583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141587 */     GIR_RootConstrainSelectedInstOperands,
     /* 141588 */     // GIR_Coverage, 367,
     /* 141588 */     GIR_EraseRootFromParent_Done,
     /* 141589 */   // Label 2730: @141589
     /* 141589 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141625), // Rule ID 368 //
     /* 141594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141616 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 141619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141623 */     GIR_RootConstrainSelectedInstOperands,
     /* 141624 */     // GIR_Coverage, 368,
     /* 141624 */     GIR_EraseRootFromParent_Done,
     /* 141625 */   // Label 2731: @141625
     /* 141625 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141661), // Rule ID 369 //
     /* 141630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141652 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 141655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141659 */     GIR_RootConstrainSelectedInstOperands,
     /* 141660 */     // GIR_Coverage, 369,
     /* 141660 */     GIR_EraseRootFromParent_Done,
     /* 141661 */   // Label 2732: @141661
     /* 141661 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141697), // Rule ID 370 //
     /* 141666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141688 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 141691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141695 */     GIR_RootConstrainSelectedInstOperands,
     /* 141696 */     // GIR_Coverage, 370,
     /* 141696 */     GIR_EraseRootFromParent_Done,
     /* 141697 */   // Label 2733: @141697
     /* 141697 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141733), // Rule ID 371 //
     /* 141702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141724 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 141727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141731 */     GIR_RootConstrainSelectedInstOperands,
     /* 141732 */     // GIR_Coverage, 371,
     /* 141732 */     GIR_EraseRootFromParent_Done,
     /* 141733 */   // Label 2734: @141733
     /* 141733 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141769), // Rule ID 372 //
     /* 141738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141760 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 141763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141767 */     GIR_RootConstrainSelectedInstOperands,
     /* 141768 */     // GIR_Coverage, 372,
     /* 141768 */     GIR_EraseRootFromParent_Done,
     /* 141769 */   // Label 2735: @141769
     /* 141769 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141805), // Rule ID 373 //
     /* 141774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141796 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 141799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141803 */     GIR_RootConstrainSelectedInstOperands,
     /* 141804 */     // GIR_Coverage, 373,
     /* 141804 */     GIR_EraseRootFromParent_Done,
     /* 141805 */   // Label 2736: @141805
     /* 141805 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141841), // Rule ID 374 //
     /* 141810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141832 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 141835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141839 */     GIR_RootConstrainSelectedInstOperands,
     /* 141840 */     // GIR_Coverage, 374,
     /* 141840 */     GIR_EraseRootFromParent_Done,
     /* 141841 */   // Label 2737: @141841
     /* 141841 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141877), // Rule ID 375 //
     /* 141846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141868 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 141871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141875 */     GIR_RootConstrainSelectedInstOperands,
     /* 141876 */     // GIR_Coverage, 375,
     /* 141876 */     GIR_EraseRootFromParent_Done,
     /* 141877 */   // Label 2738: @141877
     /* 141877 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141913), // Rule ID 376 //
     /* 141882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141904 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 141907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141911 */     GIR_RootConstrainSelectedInstOperands,
     /* 141912 */     // GIR_Coverage, 376,
     /* 141912 */     GIR_EraseRootFromParent_Done,
     /* 141913 */   // Label 2739: @141913
     /* 141913 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141949), // Rule ID 377 //
     /* 141918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141940 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 141943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141947 */     GIR_RootConstrainSelectedInstOperands,
     /* 141948 */     // GIR_Coverage, 377,
     /* 141948 */     GIR_EraseRootFromParent_Done,
     /* 141949 */   // Label 2740: @141949
     /* 141949 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141985), // Rule ID 378 //
     /* 141954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141976 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 141979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141983 */     GIR_RootConstrainSelectedInstOperands,
     /* 141984 */     // GIR_Coverage, 378,
     /* 141984 */     GIR_EraseRootFromParent_Done,
     /* 141985 */   // Label 2741: @141985
     /* 141985 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(142021), // Rule ID 379 //
     /* 141990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142012 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 142015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142019 */     GIR_RootConstrainSelectedInstOperands,
     /* 142020 */     // GIR_Coverage, 379,
     /* 142020 */     GIR_EraseRootFromParent_Done,
     /* 142021 */   // Label 2742: @142021
     /* 142021 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(142057), // Rule ID 380 //
     /* 142026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142048 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 142051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142055 */     GIR_RootConstrainSelectedInstOperands,
     /* 142056 */     // GIR_Coverage, 380,
     /* 142056 */     GIR_EraseRootFromParent_Done,
     /* 142057 */   // Label 2743: @142057
     /* 142057 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(142093), // Rule ID 381 //
     /* 142062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142084 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 142087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142091 */     GIR_RootConstrainSelectedInstOperands,
     /* 142092 */     // GIR_Coverage, 381,
     /* 142092 */     GIR_EraseRootFromParent_Done,
     /* 142093 */   // Label 2744: @142093
     /* 142093 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(142129), // Rule ID 382 //
     /* 142098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142120 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 142123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142127 */     GIR_RootConstrainSelectedInstOperands,
     /* 142128 */     // GIR_Coverage, 382,
     /* 142128 */     GIR_EraseRootFromParent_Done,
     /* 142129 */   // Label 2745: @142129
     /* 142129 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(142165), // Rule ID 383 //
     /* 142134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142156 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 142159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142163 */     GIR_RootConstrainSelectedInstOperands,
     /* 142164 */     // GIR_Coverage, 383,
     /* 142164 */     GIR_EraseRootFromParent_Done,
     /* 142165 */   // Label 2746: @142165
     /* 142165 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(142201), // Rule ID 384 //
     /* 142170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142192 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 142195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142199 */     GIR_RootConstrainSelectedInstOperands,
     /* 142200 */     // GIR_Coverage, 384,
     /* 142200 */     GIR_EraseRootFromParent_Done,
     /* 142201 */   // Label 2747: @142201
     /* 142201 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(142237), // Rule ID 385 //
     /* 142206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142228 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 142231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142235 */     GIR_RootConstrainSelectedInstOperands,
     /* 142236 */     // GIR_Coverage, 385,
     /* 142236 */     GIR_EraseRootFromParent_Done,
     /* 142237 */   // Label 2748: @142237
     /* 142237 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(142273), // Rule ID 386 //
     /* 142242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142264 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 142267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142271 */     GIR_RootConstrainSelectedInstOperands,
     /* 142272 */     // GIR_Coverage, 386,
     /* 142272 */     GIR_EraseRootFromParent_Done,
     /* 142273 */   // Label 2749: @142273
     /* 142273 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(142309), // Rule ID 387 //
     /* 142278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142300 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 142303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142307 */     GIR_RootConstrainSelectedInstOperands,
     /* 142308 */     // GIR_Coverage, 387,
     /* 142308 */     GIR_EraseRootFromParent_Done,
     /* 142309 */   // Label 2750: @142309
     /* 142309 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(142345), // Rule ID 388 //
     /* 142314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142336 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 142336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 142339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142343 */     GIR_RootConstrainSelectedInstOperands,
     /* 142344 */     // GIR_Coverage, 388,
     /* 142344 */     GIR_EraseRootFromParent_Done,
     /* 142345 */   // Label 2751: @142345
     /* 142345 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(142381), // Rule ID 389 //
     /* 142350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142372 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 142375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142379 */     GIR_RootConstrainSelectedInstOperands,
     /* 142380 */     // GIR_Coverage, 389,
     /* 142380 */     GIR_EraseRootFromParent_Done,
     /* 142381 */   // Label 2752: @142381
     /* 142381 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(142417), // Rule ID 390 //
     /* 142386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142408 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 142411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142415 */     GIR_RootConstrainSelectedInstOperands,
     /* 142416 */     // GIR_Coverage, 390,
     /* 142416 */     GIR_EraseRootFromParent_Done,
     /* 142417 */   // Label 2753: @142417
     /* 142417 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(142453), // Rule ID 391 //
     /* 142422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142444 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 142447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142451 */     GIR_RootConstrainSelectedInstOperands,
     /* 142452 */     // GIR_Coverage, 391,
     /* 142452 */     GIR_EraseRootFromParent_Done,
     /* 142453 */   // Label 2754: @142453
     /* 142453 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(142489), // Rule ID 392 //
     /* 142458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142480 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 142483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142487 */     GIR_RootConstrainSelectedInstOperands,
     /* 142488 */     // GIR_Coverage, 392,
     /* 142488 */     GIR_EraseRootFromParent_Done,
     /* 142489 */   // Label 2755: @142489
     /* 142489 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(142525), // Rule ID 393 //
     /* 142494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142516 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 142519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142523 */     GIR_RootConstrainSelectedInstOperands,
     /* 142524 */     // GIR_Coverage, 393,
     /* 142524 */     GIR_EraseRootFromParent_Done,
     /* 142525 */   // Label 2756: @142525
     /* 142525 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(142561), // Rule ID 575 //
     /* 142530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 142538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142552 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 142555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142559 */     GIR_RootConstrainSelectedInstOperands,
     /* 142560 */     // GIR_Coverage, 575,
     /* 142560 */     GIR_EraseRootFromParent_Done,
     /* 142561 */   // Label 2757: @142561
     /* 142561 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142597), // Rule ID 576 //
     /* 142566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 142574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142588 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 142591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142595 */     GIR_RootConstrainSelectedInstOperands,
     /* 142596 */     // GIR_Coverage, 576,
     /* 142596 */     GIR_EraseRootFromParent_Done,
     /* 142597 */   // Label 2758: @142597
     /* 142597 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142633), // Rule ID 577 //
     /* 142602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 142610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142624 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 142627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142631 */     GIR_RootConstrainSelectedInstOperands,
     /* 142632 */     // GIR_Coverage, 577,
     /* 142632 */     GIR_EraseRootFromParent_Done,
     /* 142633 */   // Label 2759: @142633
     /* 142633 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142669), // Rule ID 578 //
     /* 142638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 142646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142660 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 142663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142667 */     GIR_RootConstrainSelectedInstOperands,
     /* 142668 */     // GIR_Coverage, 578,
     /* 142668 */     GIR_EraseRootFromParent_Done,
     /* 142669 */   // Label 2760: @142669
     /* 142669 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142705), // Rule ID 579 //
     /* 142674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 142682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142696 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 142699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142703 */     GIR_RootConstrainSelectedInstOperands,
     /* 142704 */     // GIR_Coverage, 579,
     /* 142704 */     GIR_EraseRootFromParent_Done,
     /* 142705 */   // Label 2761: @142705
     /* 142705 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142741), // Rule ID 580 //
     /* 142710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 142718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142732 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 142735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142739 */     GIR_RootConstrainSelectedInstOperands,
     /* 142740 */     // GIR_Coverage, 580,
     /* 142740 */     GIR_EraseRootFromParent_Done,
     /* 142741 */   // Label 2762: @142741
     /* 142741 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142777), // Rule ID 581 //
     /* 142746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 142754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142768 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 142771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142775 */     GIR_RootConstrainSelectedInstOperands,
     /* 142776 */     // GIR_Coverage, 581,
     /* 142776 */     GIR_EraseRootFromParent_Done,
     /* 142777 */   // Label 2763: @142777
     /* 142777 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142813), // Rule ID 582 //
     /* 142782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 142790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142804 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 142807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142811 */     GIR_RootConstrainSelectedInstOperands,
     /* 142812 */     // GIR_Coverage, 582,
     /* 142812 */     GIR_EraseRootFromParent_Done,
     /* 142813 */   // Label 2764: @142813
     /* 142813 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142849), // Rule ID 710 //
     /* 142818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 142829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142840 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 142843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142847 */     GIR_RootConstrainSelectedInstOperands,
     /* 142848 */     // GIR_Coverage, 710,
     /* 142848 */     GIR_EraseRootFromParent_Done,
     /* 142849 */   // Label 2765: @142849
     /* 142849 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142885), // Rule ID 711 //
     /* 142854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142876 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 142879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142883 */     GIR_RootConstrainSelectedInstOperands,
     /* 142884 */     // GIR_Coverage, 711,
     /* 142884 */     GIR_EraseRootFromParent_Done,
     /* 142885 */   // Label 2766: @142885
     /* 142885 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142921), // Rule ID 712 //
     /* 142890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142912 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 142915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142919 */     GIR_RootConstrainSelectedInstOperands,
     /* 142920 */     // GIR_Coverage, 712,
     /* 142920 */     GIR_EraseRootFromParent_Done,
     /* 142921 */   // Label 2767: @142921
     /* 142921 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142957), // Rule ID 713 //
     /* 142926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142948 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 142951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142955 */     GIR_RootConstrainSelectedInstOperands,
     /* 142956 */     // GIR_Coverage, 713,
     /* 142956 */     GIR_EraseRootFromParent_Done,
     /* 142957 */   // Label 2768: @142957
     /* 142957 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142993), // Rule ID 714 //
     /* 142962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142984 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 142984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 142987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142991 */     GIR_RootConstrainSelectedInstOperands,
     /* 142992 */     // GIR_Coverage, 714,
     /* 142992 */     GIR_EraseRootFromParent_Done,
     /* 142993 */   // Label 2769: @142993
     /* 142993 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(143029), // Rule ID 715 //
     /* 142998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 143006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143020 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 143020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 143023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143027 */     GIR_RootConstrainSelectedInstOperands,
     /* 143028 */     // GIR_Coverage, 715,
     /* 143028 */     GIR_EraseRootFromParent_Done,
     /* 143029 */   // Label 2770: @143029
     /* 143029 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(143065), // Rule ID 796 //
     /* 143034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143056 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 143059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143063 */     GIR_RootConstrainSelectedInstOperands,
     /* 143064 */     // GIR_Coverage, 796,
     /* 143064 */     GIR_EraseRootFromParent_Done,
     /* 143065 */   // Label 2771: @143065
     /* 143065 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(143101), // Rule ID 797 //
     /* 143070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 143095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143099 */     GIR_RootConstrainSelectedInstOperands,
     /* 143100 */     // GIR_Coverage, 797,
     /* 143100 */     GIR_EraseRootFromParent_Done,
     /* 143101 */   // Label 2772: @143101
     /* 143101 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(143137), // Rule ID 798 //
     /* 143106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 143131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143135 */     GIR_RootConstrainSelectedInstOperands,
     /* 143136 */     // GIR_Coverage, 798,
     /* 143136 */     GIR_EraseRootFromParent_Done,
     /* 143137 */   // Label 2773: @143137
     /* 143137 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(143173), // Rule ID 799 //
     /* 143142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 143167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143171 */     GIR_RootConstrainSelectedInstOperands,
     /* 143172 */     // GIR_Coverage, 799,
     /* 143172 */     GIR_EraseRootFromParent_Done,
     /* 143173 */   // Label 2774: @143173
     /* 143173 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(143209), // Rule ID 800 //
     /* 143178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 143186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143200 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 143203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143207 */     GIR_RootConstrainSelectedInstOperands,
     /* 143208 */     // GIR_Coverage, 800,
     /* 143208 */     GIR_EraseRootFromParent_Done,
     /* 143209 */   // Label 2775: @143209
     /* 143209 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(143245), // Rule ID 801 //
     /* 143214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143236 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 143239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143243 */     GIR_RootConstrainSelectedInstOperands,
     /* 143244 */     // GIR_Coverage, 801,
     /* 143244 */     GIR_EraseRootFromParent_Done,
     /* 143245 */   // Label 2776: @143245
     /* 143245 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(143281), // Rule ID 802 //
     /* 143250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 143275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143279 */     GIR_RootConstrainSelectedInstOperands,
     /* 143280 */     // GIR_Coverage, 802,
     /* 143280 */     GIR_EraseRootFromParent_Done,
     /* 143281 */   // Label 2777: @143281
     /* 143281 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(143317), // Rule ID 803 //
     /* 143286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143308 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 143311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143315 */     GIR_RootConstrainSelectedInstOperands,
     /* 143316 */     // GIR_Coverage, 803,
     /* 143316 */     GIR_EraseRootFromParent_Done,
     /* 143317 */   // Label 2778: @143317
     /* 143317 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(143353), // Rule ID 804 //
     /* 143322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 143347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143351 */     GIR_RootConstrainSelectedInstOperands,
     /* 143352 */     // GIR_Coverage, 804,
     /* 143352 */     GIR_EraseRootFromParent_Done,
     /* 143353 */   // Label 2779: @143353
     /* 143353 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(143389), // Rule ID 805 //
     /* 143358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143380 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 143383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143387 */     GIR_RootConstrainSelectedInstOperands,
     /* 143388 */     // GIR_Coverage, 805,
     /* 143388 */     GIR_EraseRootFromParent_Done,
     /* 143389 */   // Label 2780: @143389
     /* 143389 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(143425), // Rule ID 806 //
     /* 143394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143416 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 143419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143423 */     GIR_RootConstrainSelectedInstOperands,
     /* 143424 */     // GIR_Coverage, 806,
     /* 143424 */     GIR_EraseRootFromParent_Done,
     /* 143425 */   // Label 2781: @143425
     /* 143425 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(143461), // Rule ID 807 //
     /* 143430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 143455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143459 */     GIR_RootConstrainSelectedInstOperands,
     /* 143460 */     // GIR_Coverage, 807,
     /* 143460 */     GIR_EraseRootFromParent_Done,
     /* 143461 */   // Label 2782: @143461
     /* 143461 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(143497), // Rule ID 808 //
     /* 143466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143488 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 143491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143495 */     GIR_RootConstrainSelectedInstOperands,
     /* 143496 */     // GIR_Coverage, 808,
     /* 143496 */     GIR_EraseRootFromParent_Done,
     /* 143497 */   // Label 2783: @143497
     /* 143497 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(143533), // Rule ID 809 //
     /* 143502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143524 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 143527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143531 */     GIR_RootConstrainSelectedInstOperands,
     /* 143532 */     // GIR_Coverage, 809,
     /* 143532 */     GIR_EraseRootFromParent_Done,
     /* 143533 */   // Label 2784: @143533
     /* 143533 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(143569), // Rule ID 810 //
     /* 143538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143560 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 143563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143567 */     GIR_RootConstrainSelectedInstOperands,
     /* 143568 */     // GIR_Coverage, 810,
     /* 143568 */     GIR_EraseRootFromParent_Done,
     /* 143569 */   // Label 2785: @143569
     /* 143569 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143605), // Rule ID 811 //
     /* 143574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143596 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 143599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143603 */     GIR_RootConstrainSelectedInstOperands,
     /* 143604 */     // GIR_Coverage, 811,
     /* 143604 */     GIR_EraseRootFromParent_Done,
     /* 143605 */   // Label 2786: @143605
     /* 143605 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143641), // Rule ID 812 //
     /* 143610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 143635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143639 */     GIR_RootConstrainSelectedInstOperands,
     /* 143640 */     // GIR_Coverage, 812,
     /* 143640 */     GIR_EraseRootFromParent_Done,
     /* 143641 */   // Label 2787: @143641
     /* 143641 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143677), // Rule ID 813 //
     /* 143646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143668 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 143671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143675 */     GIR_RootConstrainSelectedInstOperands,
     /* 143676 */     // GIR_Coverage, 813,
     /* 143676 */     GIR_EraseRootFromParent_Done,
     /* 143677 */   // Label 2788: @143677
     /* 143677 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143713), // Rule ID 814 //
     /* 143682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143704 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 143707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143711 */     GIR_RootConstrainSelectedInstOperands,
     /* 143712 */     // GIR_Coverage, 814,
     /* 143712 */     GIR_EraseRootFromParent_Done,
     /* 143713 */   // Label 2789: @143713
     /* 143713 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143749), // Rule ID 815 //
     /* 143718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143740 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 143743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143747 */     GIR_RootConstrainSelectedInstOperands,
     /* 143748 */     // GIR_Coverage, 815,
     /* 143748 */     GIR_EraseRootFromParent_Done,
     /* 143749 */   // Label 2790: @143749
     /* 143749 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143785), // Rule ID 816 //
     /* 143754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143776 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 143779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143783 */     GIR_RootConstrainSelectedInstOperands,
     /* 143784 */     // GIR_Coverage, 816,
     /* 143784 */     GIR_EraseRootFromParent_Done,
     /* 143785 */   // Label 2791: @143785
     /* 143785 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143821), // Rule ID 817 //
     /* 143790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143812 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 143815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143819 */     GIR_RootConstrainSelectedInstOperands,
     /* 143820 */     // GIR_Coverage, 817,
     /* 143820 */     GIR_EraseRootFromParent_Done,
     /* 143821 */   // Label 2792: @143821
     /* 143821 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143857), // Rule ID 818 //
     /* 143826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143848 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143855 */     GIR_RootConstrainSelectedInstOperands,
     /* 143856 */     // GIR_Coverage, 818,
     /* 143856 */     GIR_EraseRootFromParent_Done,
     /* 143857 */   // Label 2793: @143857
     /* 143857 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143893), // Rule ID 819 //
     /* 143862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143884 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 143887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143891 */     GIR_RootConstrainSelectedInstOperands,
     /* 143892 */     // GIR_Coverage, 819,
     /* 143892 */     GIR_EraseRootFromParent_Done,
     /* 143893 */   // Label 2794: @143893
     /* 143893 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143929), // Rule ID 820 //
     /* 143898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143920 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 143923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143927 */     GIR_RootConstrainSelectedInstOperands,
     /* 143928 */     // GIR_Coverage, 820,
     /* 143928 */     GIR_EraseRootFromParent_Done,
     /* 143929 */   // Label 2795: @143929
     /* 143929 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143965), // Rule ID 821 //
     /* 143934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143956 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 143959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143963 */     GIR_RootConstrainSelectedInstOperands,
     /* 143964 */     // GIR_Coverage, 821,
     /* 143964 */     GIR_EraseRootFromParent_Done,
     /* 143965 */   // Label 2796: @143965
     /* 143965 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(144001), // Rule ID 822 //
     /* 143970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143992 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 143995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143999 */     GIR_RootConstrainSelectedInstOperands,
     /* 144000 */     // GIR_Coverage, 822,
     /* 144000 */     GIR_EraseRootFromParent_Done,
     /* 144001 */   // Label 2797: @144001
     /* 144001 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(144037), // Rule ID 823 //
     /* 144006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 144014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144028 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 144031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144035 */     GIR_RootConstrainSelectedInstOperands,
     /* 144036 */     // GIR_Coverage, 823,
     /* 144036 */     GIR_EraseRootFromParent_Done,
     /* 144037 */   // Label 2798: @144037
     /* 144037 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(144073), // Rule ID 824 //
     /* 144042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 144050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 144067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144071 */     GIR_RootConstrainSelectedInstOperands,
     /* 144072 */     // GIR_Coverage, 824,
     /* 144072 */     GIR_EraseRootFromParent_Done,
     /* 144073 */   // Label 2799: @144073
     /* 144073 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(144109), // Rule ID 825 //
     /* 144078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 144086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144100 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 144103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144107 */     GIR_RootConstrainSelectedInstOperands,
     /* 144108 */     // GIR_Coverage, 825,
     /* 144108 */     GIR_EraseRootFromParent_Done,
     /* 144109 */   // Label 2800: @144109
     /* 144109 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(144145), // Rule ID 826 //
     /* 144114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 144122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144136 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 144139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144143 */     GIR_RootConstrainSelectedInstOperands,
     /* 144144 */     // GIR_Coverage, 826,
     /* 144144 */     GIR_EraseRootFromParent_Done,
     /* 144145 */   // Label 2801: @144145
     /* 144145 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(144181), // Rule ID 827 //
     /* 144150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 144158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144172 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 144175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144179 */     GIR_RootConstrainSelectedInstOperands,
     /* 144180 */     // GIR_Coverage, 827,
     /* 144180 */     GIR_EraseRootFromParent_Done,
     /* 144181 */   // Label 2802: @144181
     /* 144181 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(144217), // Rule ID 828 //
     /* 144186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 144194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144208 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 144211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144215 */     GIR_RootConstrainSelectedInstOperands,
     /* 144216 */     // GIR_Coverage, 828,
     /* 144216 */     GIR_EraseRootFromParent_Done,
     /* 144217 */   // Label 2803: @144217
     /* 144217 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(144253), // Rule ID 829 //
     /* 144222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 144230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 144247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144251 */     GIR_RootConstrainSelectedInstOperands,
     /* 144252 */     // GIR_Coverage, 829,
     /* 144252 */     GIR_EraseRootFromParent_Done,
     /* 144253 */   // Label 2804: @144253
     /* 144253 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(144289), // Rule ID 830 //
     /* 144258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 144266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144280 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 144283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144287 */     GIR_RootConstrainSelectedInstOperands,
     /* 144288 */     // GIR_Coverage, 830,
     /* 144288 */     GIR_EraseRootFromParent_Done,
     /* 144289 */   // Label 2805: @144289
     /* 144289 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(144325), // Rule ID 831 //
     /* 144294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144316 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 144316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 144319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144323 */     GIR_RootConstrainSelectedInstOperands,
     /* 144324 */     // GIR_Coverage, 831,
     /* 144324 */     GIR_EraseRootFromParent_Done,
     /* 144325 */   // Label 2806: @144325
     /* 144325 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(144361), // Rule ID 832 //
     /* 144330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144352 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 144355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144359 */     GIR_RootConstrainSelectedInstOperands,
     /* 144360 */     // GIR_Coverage, 832,
     /* 144360 */     GIR_EraseRootFromParent_Done,
     /* 144361 */   // Label 2807: @144361
     /* 144361 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(144397), // Rule ID 833 //
     /* 144366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144388 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 144391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144395 */     GIR_RootConstrainSelectedInstOperands,
     /* 144396 */     // GIR_Coverage, 833,
     /* 144396 */     GIR_EraseRootFromParent_Done,
     /* 144397 */   // Label 2808: @144397
     /* 144397 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(144433), // Rule ID 834 //
     /* 144402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 144427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144431 */     GIR_RootConstrainSelectedInstOperands,
     /* 144432 */     // GIR_Coverage, 834,
     /* 144432 */     GIR_EraseRootFromParent_Done,
     /* 144433 */   // Label 2809: @144433
     /* 144433 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(144469), // Rule ID 835 //
     /* 144438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144460 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 144463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144467 */     GIR_RootConstrainSelectedInstOperands,
     /* 144468 */     // GIR_Coverage, 835,
     /* 144468 */     GIR_EraseRootFromParent_Done,
     /* 144469 */   // Label 2810: @144469
     /* 144469 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(144505), // Rule ID 836 //
     /* 144474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 144482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144496 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 144496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 144499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144503 */     GIR_RootConstrainSelectedInstOperands,
     /* 144504 */     // GIR_Coverage, 836,
     /* 144504 */     GIR_EraseRootFromParent_Done,
     /* 144505 */   // Label 2811: @144505
     /* 144505 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(144541), // Rule ID 863 //
     /* 144510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144532 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 144535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144539 */     GIR_RootConstrainSelectedInstOperands,
     /* 144540 */     // GIR_Coverage, 863,
     /* 144540 */     GIR_EraseRootFromParent_Done,
     /* 144541 */   // Label 2812: @144541
     /* 144541 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(144577), // Rule ID 864 //
     /* 144546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144568 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 144571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144575 */     GIR_RootConstrainSelectedInstOperands,
     /* 144576 */     // GIR_Coverage, 864,
     /* 144576 */     GIR_EraseRootFromParent_Done,
     /* 144577 */   // Label 2813: @144577
     /* 144577 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144613), // Rule ID 865 //
     /* 144582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144604 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 144607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144611 */     GIR_RootConstrainSelectedInstOperands,
     /* 144612 */     // GIR_Coverage, 865,
     /* 144612 */     GIR_EraseRootFromParent_Done,
     /* 144613 */   // Label 2814: @144613
     /* 144613 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144649), // Rule ID 866 //
     /* 144618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144640 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 144643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144647 */     GIR_RootConstrainSelectedInstOperands,
     /* 144648 */     // GIR_Coverage, 866,
     /* 144648 */     GIR_EraseRootFromParent_Done,
     /* 144649 */   // Label 2815: @144649
     /* 144649 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144685), // Rule ID 867 //
     /* 144654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144676 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 144679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144683 */     GIR_RootConstrainSelectedInstOperands,
     /* 144684 */     // GIR_Coverage, 867,
     /* 144684 */     GIR_EraseRootFromParent_Done,
     /* 144685 */   // Label 2816: @144685
     /* 144685 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144721), // Rule ID 938 //
     /* 144690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144712 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 144715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144719 */     GIR_RootConstrainSelectedInstOperands,
     /* 144720 */     // GIR_Coverage, 938,
     /* 144720 */     GIR_EraseRootFromParent_Done,
     /* 144721 */   // Label 2817: @144721
     /* 144721 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144757), // Rule ID 939 //
     /* 144726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144748 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 144751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144755 */     GIR_RootConstrainSelectedInstOperands,
     /* 144756 */     // GIR_Coverage, 939,
     /* 144756 */     GIR_EraseRootFromParent_Done,
     /* 144757 */   // Label 2818: @144757
     /* 144757 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144793), // Rule ID 940 //
     /* 144762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144784 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 144787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144791 */     GIR_RootConstrainSelectedInstOperands,
     /* 144792 */     // GIR_Coverage, 940,
     /* 144792 */     GIR_EraseRootFromParent_Done,
     /* 144793 */   // Label 2819: @144793
     /* 144793 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144829), // Rule ID 941 //
     /* 144798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144820 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 144823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144827 */     GIR_RootConstrainSelectedInstOperands,
     /* 144828 */     // GIR_Coverage, 941,
     /* 144828 */     GIR_EraseRootFromParent_Done,
     /* 144829 */   // Label 2820: @144829
     /* 144829 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144865), // Rule ID 942 //
     /* 144834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144856 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 144859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144863 */     GIR_RootConstrainSelectedInstOperands,
     /* 144864 */     // GIR_Coverage, 942,
     /* 144864 */     GIR_EraseRootFromParent_Done,
     /* 144865 */   // Label 2821: @144865
     /* 144865 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144901), // Rule ID 943 //
     /* 144870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144892 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 144895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144899 */     GIR_RootConstrainSelectedInstOperands,
     /* 144900 */     // GIR_Coverage, 943,
     /* 144900 */     GIR_EraseRootFromParent_Done,
     /* 144901 */   // Label 2822: @144901
     /* 144901 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144937), // Rule ID 944 //
     /* 144906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144928 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 144931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144935 */     GIR_RootConstrainSelectedInstOperands,
     /* 144936 */     // GIR_Coverage, 944,
     /* 144936 */     GIR_EraseRootFromParent_Done,
     /* 144937 */   // Label 2823: @144937
     /* 144937 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144973), // Rule ID 945 //
     /* 144942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144964 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 144967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144971 */     GIR_RootConstrainSelectedInstOperands,
     /* 144972 */     // GIR_Coverage, 945,
     /* 144972 */     GIR_EraseRootFromParent_Done,
     /* 144973 */   // Label 2824: @144973
     /* 144973 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(145009), // Rule ID 946 //
     /* 144978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145000 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 145000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 145003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145007 */     GIR_RootConstrainSelectedInstOperands,
     /* 145008 */     // GIR_Coverage, 946,
     /* 145008 */     GIR_EraseRootFromParent_Done,
     /* 145009 */   // Label 2825: @145009
     /* 145009 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(145045), // Rule ID 947 //
     /* 145014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 145017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 145022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145036 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 145036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 145039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145043 */     GIR_RootConstrainSelectedInstOperands,
     /* 145044 */     // GIR_Coverage, 947,
     /* 145044 */     GIR_EraseRootFromParent_Done,
     /* 145045 */   // Label 2826: @145045
     /* 145045 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(145081), // Rule ID 948 //
     /* 145050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 145053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 145058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145072 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 145075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145079 */     GIR_RootConstrainSelectedInstOperands,
     /* 145080 */     // GIR_Coverage, 948,
     /* 145080 */     GIR_EraseRootFromParent_Done,
     /* 145081 */   // Label 2827: @145081
     /* 145081 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(145117), // Rule ID 949 //
     /* 145086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 145089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 145094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145108 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 145108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 145111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145115 */     GIR_RootConstrainSelectedInstOperands,
     /* 145116 */     // GIR_Coverage, 949,
     /* 145116 */     GIR_EraseRootFromParent_Done,
     /* 145117 */   // Label 2828: @145117
     /* 145117 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(145153), // Rule ID 950 //
     /* 145122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 145130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145144 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 145147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145151 */     GIR_RootConstrainSelectedInstOperands,
     /* 145152 */     // GIR_Coverage, 950,
     /* 145152 */     GIR_EraseRootFromParent_Done,
     /* 145153 */   // Label 2829: @145153
     /* 145153 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(145189), // Rule ID 951 //
     /* 145158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 145166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145180 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 145183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145187 */     GIR_RootConstrainSelectedInstOperands,
     /* 145188 */     // GIR_Coverage, 951,
     /* 145188 */     GIR_EraseRootFromParent_Done,
     /* 145189 */   // Label 2830: @145189
     /* 145189 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(145225), // Rule ID 952 //
     /* 145194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 145202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145216 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 145216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 145219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145223 */     GIR_RootConstrainSelectedInstOperands,
     /* 145224 */     // GIR_Coverage, 952,
     /* 145224 */     GIR_EraseRootFromParent_Done,
     /* 145225 */   // Label 2831: @145225
     /* 145225 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(145261), // Rule ID 953 //
     /* 145230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 145238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145252 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 145255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145259 */     GIR_RootConstrainSelectedInstOperands,
     /* 145260 */     // GIR_Coverage, 953,
     /* 145260 */     GIR_EraseRootFromParent_Done,
     /* 145261 */   // Label 2832: @145261
     /* 145261 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(145297), // Rule ID 954 //
     /* 145266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 145274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145288 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 145288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 145291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145295 */     GIR_RootConstrainSelectedInstOperands,
     /* 145296 */     // GIR_Coverage, 954,
     /* 145296 */     GIR_EraseRootFromParent_Done,
     /* 145297 */   // Label 2833: @145297
     /* 145297 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(145333), // Rule ID 1001 //
     /* 145302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145324 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 145324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 145327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145331 */     GIR_RootConstrainSelectedInstOperands,
     /* 145332 */     // GIR_Coverage, 1001,
     /* 145332 */     GIR_EraseRootFromParent_Done,
     /* 145333 */   // Label 2834: @145333
     /* 145333 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(145369), // Rule ID 1003 //
     /* 145338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145360 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 145363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145367 */     GIR_RootConstrainSelectedInstOperands,
     /* 145368 */     // GIR_Coverage, 1003,
     /* 145368 */     GIR_EraseRootFromParent_Done,
     /* 145369 */   // Label 2835: @145369
     /* 145369 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(145405), // Rule ID 1005 //
     /* 145374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145396 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 145399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145403 */     GIR_RootConstrainSelectedInstOperands,
     /* 145404 */     // GIR_Coverage, 1005,
     /* 145404 */     GIR_EraseRootFromParent_Done,
     /* 145405 */   // Label 2836: @145405
     /* 145405 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(145441), // Rule ID 1007 //
     /* 145410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145432 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 145435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145439 */     GIR_RootConstrainSelectedInstOperands,
     /* 145440 */     // GIR_Coverage, 1007,
     /* 145440 */     GIR_EraseRootFromParent_Done,
     /* 145441 */   // Label 2837: @145441
     /* 145441 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(145477), // Rule ID 1009 //
     /* 145446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145468 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 145471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145475 */     GIR_RootConstrainSelectedInstOperands,
     /* 145476 */     // GIR_Coverage, 1009,
     /* 145476 */     GIR_EraseRootFromParent_Done,
     /* 145477 */   // Label 2838: @145477
     /* 145477 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(145513), // Rule ID 1011 //
     /* 145482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145504 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 145507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145511 */     GIR_RootConstrainSelectedInstOperands,
     /* 145512 */     // GIR_Coverage, 1011,
     /* 145512 */     GIR_EraseRootFromParent_Done,
     /* 145513 */   // Label 2839: @145513
     /* 145513 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(145549), // Rule ID 1022 //
     /* 145518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 145529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145540 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 145543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145547 */     GIR_RootConstrainSelectedInstOperands,
     /* 145548 */     // GIR_Coverage, 1022,
     /* 145548 */     GIR_EraseRootFromParent_Done,
     /* 145549 */   // Label 2840: @145549
     /* 145549 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145585), // Rule ID 1023 //
     /* 145554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145576 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 145579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145583 */     GIR_RootConstrainSelectedInstOperands,
     /* 145584 */     // GIR_Coverage, 1023,
     /* 145584 */     GIR_EraseRootFromParent_Done,
     /* 145585 */   // Label 2841: @145585
     /* 145585 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145621), // Rule ID 1024 //
     /* 145590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145612 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 145615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145619 */     GIR_RootConstrainSelectedInstOperands,
     /* 145620 */     // GIR_Coverage, 1024,
     /* 145620 */     GIR_EraseRootFromParent_Done,
     /* 145621 */   // Label 2842: @145621
     /* 145621 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145657), // Rule ID 1025 //
     /* 145626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145648 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 145651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145655 */     GIR_RootConstrainSelectedInstOperands,
     /* 145656 */     // GIR_Coverage, 1025,
     /* 145656 */     GIR_EraseRootFromParent_Done,
     /* 145657 */   // Label 2843: @145657
     /* 145657 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145693), // Rule ID 1026 //
     /* 145662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145684 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145691 */     GIR_RootConstrainSelectedInstOperands,
     /* 145692 */     // GIR_Coverage, 1026,
     /* 145692 */     GIR_EraseRootFromParent_Done,
     /* 145693 */   // Label 2844: @145693
     /* 145693 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145729), // Rule ID 1027 //
     /* 145698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 145723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145727 */     GIR_RootConstrainSelectedInstOperands,
     /* 145728 */     // GIR_Coverage, 1027,
     /* 145728 */     GIR_EraseRootFromParent_Done,
     /* 145729 */   // Label 2845: @145729
     /* 145729 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145765), // Rule ID 1028 //
     /* 145734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145756 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 145759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145763 */     GIR_RootConstrainSelectedInstOperands,
     /* 145764 */     // GIR_Coverage, 1028,
     /* 145764 */     GIR_EraseRootFromParent_Done,
     /* 145765 */   // Label 2846: @145765
     /* 145765 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145801), // Rule ID 1029 //
     /* 145770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 145781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145792 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 145795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145799 */     GIR_RootConstrainSelectedInstOperands,
     /* 145800 */     // GIR_Coverage, 1029,
     /* 145800 */     GIR_EraseRootFromParent_Done,
     /* 145801 */   // Label 2847: @145801
     /* 145801 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145837), // Rule ID 1030 //
     /* 145806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145828 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 145831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145835 */     GIR_RootConstrainSelectedInstOperands,
     /* 145836 */     // GIR_Coverage, 1030,
     /* 145836 */     GIR_EraseRootFromParent_Done,
     /* 145837 */   // Label 2848: @145837
     /* 145837 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145873), // Rule ID 1031 //
     /* 145842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145864 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 145867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145871 */     GIR_RootConstrainSelectedInstOperands,
     /* 145872 */     // GIR_Coverage, 1031,
     /* 145872 */     GIR_EraseRootFromParent_Done,
     /* 145873 */   // Label 2849: @145873
     /* 145873 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145909), // Rule ID 1032 //
     /* 145878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145900 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 145903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145907 */     GIR_RootConstrainSelectedInstOperands,
     /* 145908 */     // GIR_Coverage, 1032,
     /* 145908 */     GIR_EraseRootFromParent_Done,
     /* 145909 */   // Label 2850: @145909
     /* 145909 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145945), // Rule ID 1033 //
     /* 145914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145936 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 145939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145943 */     GIR_RootConstrainSelectedInstOperands,
     /* 145944 */     // GIR_Coverage, 1033,
     /* 145944 */     GIR_EraseRootFromParent_Done,
     /* 145945 */   // Label 2851: @145945
     /* 145945 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145981), // Rule ID 1034 //
     /* 145950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 145975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145979 */     GIR_RootConstrainSelectedInstOperands,
     /* 145980 */     // GIR_Coverage, 1034,
     /* 145980 */     GIR_EraseRootFromParent_Done,
     /* 145981 */   // Label 2852: @145981
     /* 145981 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(146017), // Rule ID 1035 //
     /* 145986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146008 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 146008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 146011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146015 */     GIR_RootConstrainSelectedInstOperands,
     /* 146016 */     // GIR_Coverage, 1035,
     /* 146016 */     GIR_EraseRootFromParent_Done,
     /* 146017 */   // Label 2853: @146017
     /* 146017 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(146053), // Rule ID 1062 //
     /* 146022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 146036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146044 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 146044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 146047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146051 */     GIR_RootConstrainSelectedInstOperands,
     /* 146052 */     // GIR_Coverage, 1062,
     /* 146052 */     GIR_EraseRootFromParent_Done,
     /* 146053 */   // Label 2854: @146053
     /* 146053 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(146089), // Rule ID 1064 //
     /* 146058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 146069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 146080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 146083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146087 */     GIR_RootConstrainSelectedInstOperands,
     /* 146088 */     // GIR_Coverage, 1064,
     /* 146088 */     GIR_EraseRootFromParent_Done,
     /* 146089 */   // Label 2855: @146089
     /* 146089 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(146125), // Rule ID 1066 //
     /* 146094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146116 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 146116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 146119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146123 */     GIR_RootConstrainSelectedInstOperands,
     /* 146124 */     // GIR_Coverage, 1066,
     /* 146124 */     GIR_EraseRootFromParent_Done,
     /* 146125 */   // Label 2856: @146125
     /* 146125 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(146161), // Rule ID 1068 //
     /* 146130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 146152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 146155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146159 */     GIR_RootConstrainSelectedInstOperands,
     /* 146160 */     // GIR_Coverage, 1068,
     /* 146160 */     GIR_EraseRootFromParent_Done,
     /* 146161 */   // Label 2857: @146161
     /* 146161 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(146197), // Rule ID 1070 //
     /* 146166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146188 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 146188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 146191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146195 */     GIR_RootConstrainSelectedInstOperands,
     /* 146196 */     // GIR_Coverage, 1070,
     /* 146196 */     GIR_EraseRootFromParent_Done,
     /* 146197 */   // Label 2858: @146197
     /* 146197 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(146233), // Rule ID 1072 //
     /* 146202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 146210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 146224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 146227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146231 */     GIR_RootConstrainSelectedInstOperands,
     /* 146232 */     // GIR_Coverage, 1072,
     /* 146232 */     GIR_EraseRootFromParent_Done,
     /* 146233 */   // Label 2859: @146233
     /* 146233 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(146269), // Rule ID 1086 //
     /* 146238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 146246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146260 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 146260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 146263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146267 */     GIR_RootConstrainSelectedInstOperands,
     /* 146268 */     // GIR_Coverage, 1086,
     /* 146268 */     GIR_EraseRootFromParent_Done,
     /* 146269 */   // Label 2860: @146269
     /* 146269 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(146305), // Rule ID 1087 //
     /* 146274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 146282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 146296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 146299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146303 */     GIR_RootConstrainSelectedInstOperands,
     /* 146304 */     // GIR_Coverage, 1087,
     /* 146304 */     GIR_EraseRootFromParent_Done,
     /* 146305 */   // Label 2861: @146305
     /* 146305 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(146341), // Rule ID 1088 //
     /* 146310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 146318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 146321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146332 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 146332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146339 */     GIR_RootConstrainSelectedInstOperands,
     /* 146340 */     // GIR_Coverage, 1088,
     /* 146340 */     GIR_EraseRootFromParent_Done,
     /* 146341 */   // Label 2862: @146341
     /* 146341 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(146377), // Rule ID 1089 //
     /* 146346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 146354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 146368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 146371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146375 */     GIR_RootConstrainSelectedInstOperands,
     /* 146376 */     // GIR_Coverage, 1089,
     /* 146376 */     GIR_EraseRootFromParent_Done,
     /* 146377 */   // Label 2863: @146377
     /* 146377 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(146413), // Rule ID 1653 //
     /* 146382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 146390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146404 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 146407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146411 */     GIR_RootConstrainSelectedInstOperands,
     /* 146412 */     // GIR_Coverage, 1653,
     /* 146412 */     GIR_EraseRootFromParent_Done,
     /* 146413 */   // Label 2864: @146413
     /* 146413 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(146449), // Rule ID 1659 //
     /* 146418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146440 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 146440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146447 */     GIR_RootConstrainSelectedInstOperands,
     /* 146448 */     // GIR_Coverage, 1659,
     /* 146448 */     GIR_EraseRootFromParent_Done,
     /* 146449 */   // Label 2865: @146449
     /* 146449 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(146485), // Rule ID 1660 //
     /* 146454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146476 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 146479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146483 */     GIR_RootConstrainSelectedInstOperands,
     /* 146484 */     // GIR_Coverage, 1660,
     /* 146484 */     GIR_EraseRootFromParent_Done,
     /* 146485 */   // Label 2866: @146485
     /* 146485 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(146521), // Rule ID 1661 //
     /* 146490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 146498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146512 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 146512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 146515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146519 */     GIR_RootConstrainSelectedInstOperands,
     /* 146520 */     // GIR_Coverage, 1661,
     /* 146520 */     GIR_EraseRootFromParent_Done,
     /* 146521 */   // Label 2867: @146521
     /* 146521 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(146557), // Rule ID 1662 //
     /* 146526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 146534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146548 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 146551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146555 */     GIR_RootConstrainSelectedInstOperands,
     /* 146556 */     // GIR_Coverage, 1662,
     /* 146556 */     GIR_EraseRootFromParent_Done,
     /* 146557 */   // Label 2868: @146557
     /* 146557 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146593), // Rule ID 1663 //
     /* 146562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 146570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146584 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 146587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146591 */     GIR_RootConstrainSelectedInstOperands,
     /* 146592 */     // GIR_Coverage, 1663,
     /* 146592 */     GIR_EraseRootFromParent_Done,
     /* 146593 */   // Label 2869: @146593
     /* 146593 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146629), // Rule ID 1664 //
     /* 146598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 146606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146620 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 146623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146627 */     GIR_RootConstrainSelectedInstOperands,
     /* 146628 */     // GIR_Coverage, 1664,
     /* 146628 */     GIR_EraseRootFromParent_Done,
     /* 146629 */   // Label 2870: @146629
     /* 146629 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146665), // Rule ID 1670 //
     /* 146634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 146642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146656 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 146659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146663 */     GIR_RootConstrainSelectedInstOperands,
     /* 146664 */     // GIR_Coverage, 1670,
     /* 146664 */     GIR_EraseRootFromParent_Done,
     /* 146665 */   // Label 2871: @146665
     /* 146665 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146701), // Rule ID 1943 //
     /* 146670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146692 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 146695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146699 */     GIR_RootConstrainSelectedInstOperands,
     /* 146700 */     // GIR_Coverage, 1943,
     /* 146700 */     GIR_EraseRootFromParent_Done,
     /* 146701 */   // Label 2872: @146701
     /* 146701 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146737), // Rule ID 1945 //
     /* 146706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146728 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 146731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146735 */     GIR_RootConstrainSelectedInstOperands,
     /* 146736 */     // GIR_Coverage, 1945,
     /* 146736 */     GIR_EraseRootFromParent_Done,
     /* 146737 */   // Label 2873: @146737
     /* 146737 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146773), // Rule ID 1947 //
     /* 146742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146764 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 146767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146771 */     GIR_RootConstrainSelectedInstOperands,
     /* 146772 */     // GIR_Coverage, 1947,
     /* 146772 */     GIR_EraseRootFromParent_Done,
     /* 146773 */   // Label 2874: @146773
     /* 146773 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146809), // Rule ID 1949 //
     /* 146778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146800 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 146803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146807 */     GIR_RootConstrainSelectedInstOperands,
     /* 146808 */     // GIR_Coverage, 1949,
     /* 146808 */     GIR_EraseRootFromParent_Done,
     /* 146809 */   // Label 2875: @146809
     /* 146809 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146845), // Rule ID 1951 //
     /* 146814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146836 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 146839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146843 */     GIR_RootConstrainSelectedInstOperands,
     /* 146844 */     // GIR_Coverage, 1951,
     /* 146844 */     GIR_EraseRootFromParent_Done,
     /* 146845 */   // Label 2876: @146845
     /* 146845 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146881), // Rule ID 1953 //
     /* 146850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146872 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 146875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146879 */     GIR_RootConstrainSelectedInstOperands,
     /* 146880 */     // GIR_Coverage, 1953,
     /* 146880 */     GIR_EraseRootFromParent_Done,
     /* 146881 */   // Label 2877: @146881
     /* 146881 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146917), // Rule ID 1955 //
     /* 146886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146908 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 146911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146915 */     GIR_RootConstrainSelectedInstOperands,
     /* 146916 */     // GIR_Coverage, 1955,
     /* 146916 */     GIR_EraseRootFromParent_Done,
     /* 146917 */   // Label 2878: @146917
     /* 146917 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146953), // Rule ID 1957 //
     /* 146922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146944 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 146947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146951 */     GIR_RootConstrainSelectedInstOperands,
     /* 146952 */     // GIR_Coverage, 1957,
     /* 146952 */     GIR_EraseRootFromParent_Done,
     /* 146953 */   // Label 2879: @146953
     /* 146953 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146989), // Rule ID 1959 //
     /* 146958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146980 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 146983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146987 */     GIR_RootConstrainSelectedInstOperands,
     /* 146988 */     // GIR_Coverage, 1959,
     /* 146988 */     GIR_EraseRootFromParent_Done,
     /* 146989 */   // Label 2880: @146989
     /* 146989 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(147025), // Rule ID 1961 //
     /* 146994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 147002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147016 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 147016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 147019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147023 */     GIR_RootConstrainSelectedInstOperands,
     /* 147024 */     // GIR_Coverage, 1961,
     /* 147024 */     GIR_EraseRootFromParent_Done,
     /* 147025 */   // Label 2881: @147025
     /* 147025 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(147061), // Rule ID 1963 //
     /* 147030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 147033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 147038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147052 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 147052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 147055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147059 */     GIR_RootConstrainSelectedInstOperands,
     /* 147060 */     // GIR_Coverage, 1963,
     /* 147060 */     GIR_EraseRootFromParent_Done,
     /* 147061 */   // Label 2882: @147061
     /* 147061 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(147097), // Rule ID 1965 //
     /* 147066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 147074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147088 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 147088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 147091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147095 */     GIR_RootConstrainSelectedInstOperands,
     /* 147096 */     // GIR_Coverage, 1965,
     /* 147096 */     GIR_EraseRootFromParent_Done,
     /* 147097 */   // Label 2883: @147097
     /* 147097 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(147133), // Rule ID 2305 //
     /* 147102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 147105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 147110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147124 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 147127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147131 */     GIR_RootConstrainSelectedInstOperands,
     /* 147132 */     // GIR_Coverage, 2305,
     /* 147132 */     GIR_EraseRootFromParent_Done,
     /* 147133 */   // Label 2884: @147133
     /* 147133 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(147169), // Rule ID 2306 //
     /* 147138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 147141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 147146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 147149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147160 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 147163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147167 */     GIR_RootConstrainSelectedInstOperands,
     /* 147168 */     // GIR_Coverage, 2306,
     /* 147168 */     GIR_EraseRootFromParent_Done,
     /* 147169 */   // Label 2885: @147169
     /* 147169 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(147205), // Rule ID 2314 //
     /* 147174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 147177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 147182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147196 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 147196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 147199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147203 */     GIR_RootConstrainSelectedInstOperands,
     /* 147204 */     // GIR_Coverage, 2314,
     /* 147204 */     GIR_EraseRootFromParent_Done,
     /* 147205 */   // Label 2886: @147205
     /* 147205 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(147241), // Rule ID 2515 //
     /* 147210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 147218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147232 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 147235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147239 */     GIR_RootConstrainSelectedInstOperands,
     /* 147240 */     // GIR_Coverage, 2515,
     /* 147240 */     GIR_EraseRootFromParent_Done,
     /* 147241 */   // Label 2887: @147241
     /* 147241 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(147280), // Rule ID 3548 //
     /* 147246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 147254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 147257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 147260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 147268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 147271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147278 */     GIR_RootConstrainSelectedInstOperands,
     /* 147279 */     // GIR_Coverage, 3548,
     /* 147279 */     GIR_EraseRootFromParent_Done,
     /* 147280 */   // Label 2888: @147280
     /* 147280 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(147319), // Rule ID 3549 //
     /* 147285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 147293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 147296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 147299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147307 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 147307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 147310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147317 */     GIR_RootConstrainSelectedInstOperands,
     /* 147318 */     // GIR_Coverage, 3549,
     /* 147318 */     GIR_EraseRootFromParent_Done,
     /* 147319 */   // Label 2889: @147319
     /* 147319 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(147358), // Rule ID 3550 //
     /* 147324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 147332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 147335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 147338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 147346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 147349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147356 */     GIR_RootConstrainSelectedInstOperands,
     /* 147357 */     // GIR_Coverage, 3550,
     /* 147357 */     GIR_EraseRootFromParent_Done,
     /* 147358 */   // Label 2890: @147358
     /* 147358 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(147397), // Rule ID 3551 //
     /* 147363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 147371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 147374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 147377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147385 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 147385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 147388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147395 */     GIR_RootConstrainSelectedInstOperands,
     /* 147396 */     // GIR_Coverage, 3551,
     /* 147396 */     GIR_EraseRootFromParent_Done,
     /* 147397 */   // Label 2891: @147397
     /* 147397 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(147453), // Rule ID 3555 //
     /* 147402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 147413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1629:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 147424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 147441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147451 */     GIR_RootConstrainSelectedInstOperands,
     /* 147452 */     // GIR_Coverage, 3555,
     /* 147452 */     GIR_EraseRootFromParent_Done,
     /* 147453 */   // Label 2892: @147453
     /* 147453 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(147509), // Rule ID 3556 //
     /* 147458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 147469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 147472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 147480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 147497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147507 */     GIR_RootConstrainSelectedInstOperands,
     /* 147508 */     // GIR_Coverage, 3556,
     /* 147508 */     GIR_EraseRootFromParent_Done,
     /* 147509 */   // Label 2893: @147509
     /* 147509 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(147565), // Rule ID 3557 //
     /* 147514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 147525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 147528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 147536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 147553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147563 */     GIR_RootConstrainSelectedInstOperands,
     /* 147564 */     // GIR_Coverage, 3557,
     /* 147564 */     GIR_EraseRootFromParent_Done,
     /* 147565 */   // Label 2894: @147565
     /* 147565 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(147621), // Rule ID 3558 //
     /* 147570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 147581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 147584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 147592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 147609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147619 */     GIR_RootConstrainSelectedInstOperands,
     /* 147620 */     // GIR_Coverage, 3558,
     /* 147620 */     GIR_EraseRootFromParent_Done,
     /* 147621 */   // Label 2895: @147621
     /* 147621 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(147654), // Rule ID 4009 //
     /* 147626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 147631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147645 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 147645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 147648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147652 */     GIR_RootConstrainSelectedInstOperands,
     /* 147653 */     // GIR_Coverage, 4009,
     /* 147653 */     GIR_EraseRootFromParent_Done,
     /* 147654 */   // Label 2896: @147654
     /* 147654 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147719), // Rule ID 4010 //
     /* 147659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 147664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147678 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 147678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 147685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 147708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147718 */     // GIR_Coverage, 4010,
     /* 147718 */     GIR_EraseRootFromParent_Done,
     /* 147719 */   // Label 2897: @147719
     /* 147719 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147752), // Rule ID 4780 //
     /* 147724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 147729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147743 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 147746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147750 */     GIR_RootConstrainSelectedInstOperands,
     /* 147751 */     // GIR_Coverage, 4780,
     /* 147751 */     GIR_EraseRootFromParent_Done,
     /* 147752 */   // Label 2898: @147752
     /* 147752 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147785), // Rule ID 4781 //
     /* 147757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 147762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147776 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 147779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147783 */     GIR_RootConstrainSelectedInstOperands,
     /* 147784 */     // GIR_Coverage, 4781,
     /* 147784 */     GIR_EraseRootFromParent_Done,
     /* 147785 */   // Label 2899: @147785
     /* 147785 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147818), // Rule ID 4782 //
     /* 147790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 147795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147809 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 147812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147816 */     GIR_RootConstrainSelectedInstOperands,
     /* 147817 */     // GIR_Coverage, 4782,
     /* 147817 */     GIR_EraseRootFromParent_Done,
     /* 147818 */   // Label 2900: @147818
     /* 147818 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147851), // Rule ID 4783 //
     /* 147823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 147828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147842 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 147845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147849 */     GIR_RootConstrainSelectedInstOperands,
     /* 147850 */     // GIR_Coverage, 4783,
     /* 147850 */     GIR_EraseRootFromParent_Done,
     /* 147851 */   // Label 2901: @147851
     /* 147851 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147884), // Rule ID 4897 //
     /* 147856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 147861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147875 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 147875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 147878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147882 */     GIR_RootConstrainSelectedInstOperands,
     /* 147883 */     // GIR_Coverage, 4897,
     /* 147883 */     GIR_EraseRootFromParent_Done,
     /* 147884 */   // Label 2902: @147884
     /* 147884 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147917), // Rule ID 4907 //
     /* 147889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 147894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147908 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 147908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 147911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147915 */     GIR_RootConstrainSelectedInstOperands,
     /* 147916 */     // GIR_Coverage, 4907,
     /* 147916 */     GIR_EraseRootFromParent_Done,
     /* 147917 */   // Label 2903: @147917
     /* 147917 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147953), // Rule ID 5249 //
     /* 147922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147944 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 147947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147951 */     GIR_RootConstrainSelectedInstOperands,
     /* 147952 */     // GIR_Coverage, 5249,
     /* 147952 */     GIR_EraseRootFromParent_Done,
     /* 147953 */   // Label 2904: @147953
     /* 147953 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147986), // Rule ID 5252 //
     /* 147958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 147963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147977 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 147980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147984 */     GIR_RootConstrainSelectedInstOperands,
     /* 147985 */     // GIR_Coverage, 5252,
     /* 147985 */     GIR_EraseRootFromParent_Done,
     /* 147986 */   // Label 2905: @147986
     /* 147986 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(148019), // Rule ID 5253 //
     /* 147991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 147996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148010 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 148013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148017 */     GIR_RootConstrainSelectedInstOperands,
     /* 148018 */     // GIR_Coverage, 5253,
     /* 148018 */     GIR_EraseRootFromParent_Done,
     /* 148019 */   // Label 2906: @148019
     /* 148019 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(148052), // Rule ID 5254 //
     /* 148024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 148029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148043 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 148046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148050 */     GIR_RootConstrainSelectedInstOperands,
     /* 148051 */     // GIR_Coverage, 5254,
     /* 148051 */     GIR_EraseRootFromParent_Done,
     /* 148052 */   // Label 2907: @148052
     /* 148052 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(148085), // Rule ID 5255 //
     /* 148057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 148062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148076 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 148079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148083 */     GIR_RootConstrainSelectedInstOperands,
     /* 148084 */     // GIR_Coverage, 5255,
     /* 148084 */     GIR_EraseRootFromParent_Done,
     /* 148085 */   // Label 2908: @148085
     /* 148085 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(148118), // Rule ID 5256 //
     /* 148090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 148095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148109 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 148112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148116 */     GIR_RootConstrainSelectedInstOperands,
     /* 148117 */     // GIR_Coverage, 5256,
     /* 148117 */     GIR_EraseRootFromParent_Done,
     /* 148118 */   // Label 2909: @148118
     /* 148118 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(148151), // Rule ID 5257 //
     /* 148123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 148128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148142 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 148145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148149 */     GIR_RootConstrainSelectedInstOperands,
     /* 148150 */     // GIR_Coverage, 5257,
     /* 148150 */     GIR_EraseRootFromParent_Done,
     /* 148151 */   // Label 2910: @148151
     /* 148151 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(148184), // Rule ID 5258 //
     /* 148156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 148161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148175 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 148178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148182 */     GIR_RootConstrainSelectedInstOperands,
     /* 148183 */     // GIR_Coverage, 5258,
     /* 148183 */     GIR_EraseRootFromParent_Done,
     /* 148184 */   // Label 2911: @148184
     /* 148184 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(148217), // Rule ID 5259 //
     /* 148189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 148194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148208 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 148211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148215 */     GIR_RootConstrainSelectedInstOperands,
     /* 148216 */     // GIR_Coverage, 5259,
     /* 148216 */     GIR_EraseRootFromParent_Done,
     /* 148217 */   // Label 2912: @148217
     /* 148217 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(148250), // Rule ID 5260 //
     /* 148222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 148227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148241 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 148244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148248 */     GIR_RootConstrainSelectedInstOperands,
     /* 148249 */     // GIR_Coverage, 5260,
     /* 148249 */     GIR_EraseRootFromParent_Done,
     /* 148250 */   // Label 2913: @148250
     /* 148250 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(148283), // Rule ID 5261 //
     /* 148255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 148260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148274 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 148277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148281 */     GIR_RootConstrainSelectedInstOperands,
     /* 148282 */     // GIR_Coverage, 5261,
     /* 148282 */     GIR_EraseRootFromParent_Done,
     /* 148283 */   // Label 2914: @148283
     /* 148283 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(148316), // Rule ID 5262 //
     /* 148288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 148299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148307 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 148307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 148310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148314 */     GIR_RootConstrainSelectedInstOperands,
     /* 148315 */     // GIR_Coverage, 5262,
     /* 148315 */     GIR_EraseRootFromParent_Done,
     /* 148316 */   // Label 2915: @148316
     /* 148316 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(148349), // Rule ID 5263 //
     /* 148321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148340 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 148343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148347 */     GIR_RootConstrainSelectedInstOperands,
     /* 148348 */     // GIR_Coverage, 5263,
     /* 148348 */     GIR_EraseRootFromParent_Done,
     /* 148349 */   // Label 2916: @148349
     /* 148349 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(148382), // Rule ID 5264 //
     /* 148354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148373 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 148376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148380 */     GIR_RootConstrainSelectedInstOperands,
     /* 148381 */     // GIR_Coverage, 5264,
     /* 148381 */     GIR_EraseRootFromParent_Done,
     /* 148382 */   // Label 2917: @148382
     /* 148382 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(148415), // Rule ID 5265 //
     /* 148387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148406 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 148409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148413 */     GIR_RootConstrainSelectedInstOperands,
     /* 148414 */     // GIR_Coverage, 5265,
     /* 148414 */     GIR_EraseRootFromParent_Done,
     /* 148415 */   // Label 2918: @148415
     /* 148415 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(148448), // Rule ID 5277 //
     /* 148420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 148431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148439 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 148439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 148442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148446 */     GIR_RootConstrainSelectedInstOperands,
     /* 148447 */     // GIR_Coverage, 5277,
     /* 148447 */     GIR_EraseRootFromParent_Done,
     /* 148448 */   // Label 2919: @148448
     /* 148448 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(148481), // Rule ID 5278 //
     /* 148453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148472 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 148475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148479 */     GIR_RootConstrainSelectedInstOperands,
     /* 148480 */     // GIR_Coverage, 5278,
     /* 148480 */     GIR_EraseRootFromParent_Done,
     /* 148481 */   // Label 2920: @148481
     /* 148481 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148514), // Rule ID 5279 //
     /* 148486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148505 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 148508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148512 */     GIR_RootConstrainSelectedInstOperands,
     /* 148513 */     // GIR_Coverage, 5279,
     /* 148513 */     GIR_EraseRootFromParent_Done,
     /* 148514 */   // Label 2921: @148514
     /* 148514 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148547), // Rule ID 5280 //
     /* 148519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 148530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148538 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 148538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 148541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148545 */     GIR_RootConstrainSelectedInstOperands,
     /* 148546 */     // GIR_Coverage, 5280,
     /* 148546 */     GIR_EraseRootFromParent_Done,
     /* 148547 */   // Label 2922: @148547
     /* 148547 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148580), // Rule ID 5281 //
     /* 148552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148571 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 148574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148578 */     GIR_RootConstrainSelectedInstOperands,
     /* 148579 */     // GIR_Coverage, 5281,
     /* 148579 */     GIR_EraseRootFromParent_Done,
     /* 148580 */   // Label 2923: @148580
     /* 148580 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148613), // Rule ID 5282 //
     /* 148585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148604 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 148607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148611 */     GIR_RootConstrainSelectedInstOperands,
     /* 148612 */     // GIR_Coverage, 5282,
     /* 148612 */     GIR_EraseRootFromParent_Done,
     /* 148613 */   // Label 2924: @148613
     /* 148613 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148646), // Rule ID 5283 //
     /* 148618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148637 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 148640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148644 */     GIR_RootConstrainSelectedInstOperands,
     /* 148645 */     // GIR_Coverage, 5283,
     /* 148645 */     GIR_EraseRootFromParent_Done,
     /* 148646 */   // Label 2925: @148646
     /* 148646 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148679), // Rule ID 5613 //
     /* 148651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148670 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 148673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148677 */     GIR_RootConstrainSelectedInstOperands,
     /* 148678 */     // GIR_Coverage, 5613,
     /* 148678 */     GIR_EraseRootFromParent_Done,
     /* 148679 */   // Label 2926: @148679
     /* 148679 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148764), // Rule ID 5614 //
     /* 148684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148703 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 148703 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 148706 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 148710 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 148728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148737 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 148757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148762 */     GIR_RootConstrainSelectedInstOperands,
     /* 148763 */     // GIR_Coverage, 5614,
     /* 148763 */     GIR_EraseRootFromParent_Done,
     /* 148764 */   // Label 2927: @148764
     /* 148764 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148797), // Rule ID 5615 //
     /* 148769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148788 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 148791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148795 */     GIR_RootConstrainSelectedInstOperands,
     /* 148796 */     // GIR_Coverage, 5615,
     /* 148796 */     GIR_EraseRootFromParent_Done,
     /* 148797 */   // Label 2928: @148797
     /* 148797 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148830), // Rule ID 5617 //
     /* 148802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148821 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 148824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148828 */     GIR_RootConstrainSelectedInstOperands,
     /* 148829 */     // GIR_Coverage, 5617,
     /* 148829 */     GIR_EraseRootFromParent_Done,
     /* 148830 */   // Label 2929: @148830
     /* 148830 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148863), // Rule ID 5619 //
     /* 148835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148854 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 148857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148861 */     GIR_RootConstrainSelectedInstOperands,
     /* 148862 */     // GIR_Coverage, 5619,
     /* 148862 */     GIR_EraseRootFromParent_Done,
     /* 148863 */   // Label 2930: @148863
     /* 148863 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148896), // Rule ID 5621 //
     /* 148868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148887 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 148890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148894 */     GIR_RootConstrainSelectedInstOperands,
     /* 148895 */     // GIR_Coverage, 5621,
     /* 148895 */     GIR_EraseRootFromParent_Done,
     /* 148896 */   // Label 2931: @148896
     /* 148896 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148929), // Rule ID 5623 //
     /* 148901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148920 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 148923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148927 */     GIR_RootConstrainSelectedInstOperands,
     /* 148928 */     // GIR_Coverage, 5623,
     /* 148928 */     GIR_EraseRootFromParent_Done,
     /* 148929 */   // Label 2932: @148929
     /* 148929 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148962), // Rule ID 5625 //
     /* 148934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148953 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 148956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148960 */     GIR_RootConstrainSelectedInstOperands,
     /* 148961 */     // GIR_Coverage, 5625,
     /* 148961 */     GIR_EraseRootFromParent_Done,
     /* 148962 */   // Label 2933: @148962
     /* 148962 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148995), // Rule ID 5627 //
     /* 148967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148986 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 148989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148993 */     GIR_RootConstrainSelectedInstOperands,
     /* 148994 */     // GIR_Coverage, 5627,
     /* 148994 */     GIR_EraseRootFromParent_Done,
     /* 148995 */   // Label 2934: @148995
     /* 148995 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(149028), // Rule ID 5629 //
     /* 149000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 149005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149019 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 149019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 149022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149026 */     GIR_RootConstrainSelectedInstOperands,
     /* 149027 */     // GIR_Coverage, 5629,
     /* 149027 */     GIR_EraseRootFromParent_Done,
     /* 149028 */   // Label 2935: @149028
     /* 149028 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(149061), // Rule ID 5631 //
     /* 149033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 149038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149052 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 149052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 149055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149059 */     GIR_RootConstrainSelectedInstOperands,
     /* 149060 */     // GIR_Coverage, 5631,
     /* 149060 */     GIR_EraseRootFromParent_Done,
     /* 149061 */   // Label 2936: @149061
     /* 149061 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(149094), // Rule ID 13106 //
     /* 149066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149085 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 149088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149092 */     GIR_RootConstrainSelectedInstOperands,
     /* 149093 */     // GIR_Coverage, 13106,
     /* 149093 */     GIR_EraseRootFromParent_Done,
     /* 149094 */   // Label 2937: @149094
     /* 149094 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(149127), // Rule ID 13108 //
     /* 149099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149118 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 149121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149125 */     GIR_RootConstrainSelectedInstOperands,
     /* 149126 */     // GIR_Coverage, 13108,
     /* 149126 */     GIR_EraseRootFromParent_Done,
     /* 149127 */   // Label 2938: @149127
     /* 149127 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(149160), // Rule ID 13110 //
     /* 149132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149151 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 149154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149158 */     GIR_RootConstrainSelectedInstOperands,
     /* 149159 */     // GIR_Coverage, 13110,
     /* 149159 */     GIR_EraseRootFromParent_Done,
     /* 149160 */   // Label 2939: @149160
     /* 149160 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(149193), // Rule ID 13112 //
     /* 149165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149184 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 149187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149191 */     GIR_RootConstrainSelectedInstOperands,
     /* 149192 */     // GIR_Coverage, 13112,
     /* 149192 */     GIR_EraseRootFromParent_Done,
     /* 149193 */   // Label 2940: @149193
     /* 149193 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(149308), // Rule ID 13113 //
     /* 149198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149217 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149217 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149220 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 149224 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149229 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149307 */     // GIR_Coverage, 13113,
     /* 149307 */     GIR_EraseRootFromParent_Done,
     /* 149308 */   // Label 2941: @149308
     /* 149308 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(149341), // Rule ID 13115 //
     /* 149313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149332 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 149335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149339 */     GIR_RootConstrainSelectedInstOperands,
     /* 149340 */     // GIR_Coverage, 13115,
     /* 149340 */     GIR_EraseRootFromParent_Done,
     /* 149341 */   // Label 2942: @149341
     /* 149341 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(149374), // Rule ID 13117 //
     /* 149346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149365 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 149368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149372 */     GIR_RootConstrainSelectedInstOperands,
     /* 149373 */     // GIR_Coverage, 13117,
     /* 149373 */     GIR_EraseRootFromParent_Done,
     /* 149374 */   // Label 2943: @149374
     /* 149374 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(149407), // Rule ID 13119 //
     /* 149379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149398 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 149401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149405 */     GIR_RootConstrainSelectedInstOperands,
     /* 149406 */     // GIR_Coverage, 13119,
     /* 149406 */     GIR_EraseRootFromParent_Done,
     /* 149407 */   // Label 2944: @149407
     /* 149407 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(149440), // Rule ID 13121 //
     /* 149412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149431 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 149434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149438 */     GIR_RootConstrainSelectedInstOperands,
     /* 149439 */     // GIR_Coverage, 13121,
     /* 149439 */     GIR_EraseRootFromParent_Done,
     /* 149440 */   // Label 2945: @149440
     /* 149440 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149555), // Rule ID 13122 //
     /* 149445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149464 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 149471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149476 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149514 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149537 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149554 */     // GIR_Coverage, 13122,
     /* 149554 */     GIR_EraseRootFromParent_Done,
     /* 149555 */   // Label 2946: @149555
     /* 149555 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149674), // Rule ID 13123 //
     /* 149560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149579 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149579 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149582 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 149586 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149591 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149595 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149656 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149673 */     // GIR_Coverage, 13123,
     /* 149673 */     GIR_EraseRootFromParent_Done,
     /* 149674 */   // Label 2947: @149674
     /* 149674 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149789), // Rule ID 13124 //
     /* 149679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149698 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149710 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149788 */     // GIR_Coverage, 13124,
     /* 149788 */     GIR_EraseRootFromParent_Done,
     /* 149789 */   // Label 2948: @149789
     /* 149789 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149908), // Rule ID 13125 //
     /* 149794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149813 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 149820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149825 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149829 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149864 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149907 */     // GIR_Coverage, 13125,
     /* 149907 */     GIR_EraseRootFromParent_Done,
     /* 149908 */   // Label 2949: @149908
     /* 149908 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(150023), // Rule ID 13126 //
     /* 149913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149932 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149932 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149935 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149939 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149944 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 150012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150022 */     // GIR_Coverage, 13126,
     /* 150022 */     GIR_EraseRootFromParent_Done,
     /* 150023 */   // Label 2950: @150023
     /* 150023 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(150056), // Rule ID 13128 //
     /* 150028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150047 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 150050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150054 */     GIR_RootConstrainSelectedInstOperands,
     /* 150055 */     // GIR_Coverage, 13128,
     /* 150055 */     GIR_EraseRootFromParent_Done,
     /* 150056 */   // Label 2951: @150056
     /* 150056 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(150089), // Rule ID 13130 //
     /* 150061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150080 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 150083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150087 */     GIR_RootConstrainSelectedInstOperands,
     /* 150088 */     // GIR_Coverage, 13130,
     /* 150088 */     GIR_EraseRootFromParent_Done,
     /* 150089 */   // Label 2952: @150089
     /* 150089 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(150122), // Rule ID 13132 //
     /* 150094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150113 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 150116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150120 */     GIR_RootConstrainSelectedInstOperands,
     /* 150121 */     // GIR_Coverage, 13132,
     /* 150121 */     GIR_EraseRootFromParent_Done,
     /* 150122 */   // Label 2953: @150122
     /* 150122 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(150155), // Rule ID 13134 //
     /* 150127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150146 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 150149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150153 */     GIR_RootConstrainSelectedInstOperands,
     /* 150154 */     // GIR_Coverage, 13134,
     /* 150154 */     GIR_EraseRootFromParent_Done,
     /* 150155 */   // Label 2954: @150155
     /* 150155 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(150270), // Rule ID 13135 //
     /* 150160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150179 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 150186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150191 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150252 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150269 */     // GIR_Coverage, 13135,
     /* 150269 */     GIR_EraseRootFromParent_Done,
     /* 150270 */   // Label 2955: @150270
     /* 150270 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(150389), // Rule ID 13136 //
     /* 150275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 150280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150294 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 150301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150306 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150310 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150371 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150388 */     // GIR_Coverage, 13136,
     /* 150388 */     GIR_EraseRootFromParent_Done,
     /* 150389 */   // Label 2956: @150389
     /* 150389 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(150422), // Rule ID 13138 //
     /* 150394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150413 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 150416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150420 */     GIR_RootConstrainSelectedInstOperands,
     /* 150421 */     // GIR_Coverage, 13138,
     /* 150421 */     GIR_EraseRootFromParent_Done,
     /* 150422 */   // Label 2957: @150422
     /* 150422 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(150455), // Rule ID 13140 //
     /* 150427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150446 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 150449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150453 */     GIR_RootConstrainSelectedInstOperands,
     /* 150454 */     // GIR_Coverage, 13140,
     /* 150454 */     GIR_EraseRootFromParent_Done,
     /* 150455 */   // Label 2958: @150455
     /* 150455 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(150488), // Rule ID 13142 //
     /* 150460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150479 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 150482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150486 */     GIR_RootConstrainSelectedInstOperands,
     /* 150487 */     // GIR_Coverage, 13142,
     /* 150487 */     GIR_EraseRootFromParent_Done,
     /* 150488 */   // Label 2959: @150488
     /* 150488 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(150521), // Rule ID 13144 //
     /* 150493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150512 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 150515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150519 */     GIR_RootConstrainSelectedInstOperands,
     /* 150520 */     // GIR_Coverage, 13144,
     /* 150520 */     GIR_EraseRootFromParent_Done,
     /* 150521 */   // Label 2960: @150521
     /* 150521 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(150636), // Rule ID 13145 //
     /* 150526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150545 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 150552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150557 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150618 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150635 */     // GIR_Coverage, 13145,
     /* 150635 */     GIR_EraseRootFromParent_Done,
     /* 150636 */   // Label 2961: @150636
     /* 150636 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(150755), // Rule ID 13146 //
     /* 150641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150660 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150660 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150663 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 150667 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150672 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150676 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150754 */     // GIR_Coverage, 13146,
     /* 150754 */     GIR_EraseRootFromParent_Done,
     /* 150755 */   // Label 2962: @150755
     /* 150755 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150788), // Rule ID 13148 //
     /* 150760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150779 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 150782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150786 */     GIR_RootConstrainSelectedInstOperands,
     /* 150787 */     // GIR_Coverage, 13148,
     /* 150787 */     GIR_EraseRootFromParent_Done,
     /* 150788 */   // Label 2963: @150788
     /* 150788 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150821), // Rule ID 13150 //
     /* 150793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150812 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 150815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150819 */     GIR_RootConstrainSelectedInstOperands,
     /* 150820 */     // GIR_Coverage, 13150,
     /* 150820 */     GIR_EraseRootFromParent_Done,
     /* 150821 */   // Label 2964: @150821
     /* 150821 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150854), // Rule ID 13152 //
     /* 150826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150845 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 150848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150852 */     GIR_RootConstrainSelectedInstOperands,
     /* 150853 */     // GIR_Coverage, 13152,
     /* 150853 */     GIR_EraseRootFromParent_Done,
     /* 150854 */   // Label 2965: @150854
     /* 150854 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150887), // Rule ID 13154 //
     /* 150859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150878 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 150881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150885 */     GIR_RootConstrainSelectedInstOperands,
     /* 150886 */     // GIR_Coverage, 13154,
     /* 150886 */     GIR_EraseRootFromParent_Done,
     /* 150887 */   // Label 2966: @150887
     /* 150887 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(151002), // Rule ID 13155 //
     /* 150892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150911 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 150918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150923 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151001 */     // GIR_Coverage, 13155,
     /* 151001 */     GIR_EraseRootFromParent_Done,
     /* 151002 */   // Label 2967: @151002
     /* 151002 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(151121), // Rule ID 13156 //
     /* 151007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 151012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151026 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151026 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151029 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 151033 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151038 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151042 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151103 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151120 */     // GIR_Coverage, 13156,
     /* 151120 */     GIR_EraseRootFromParent_Done,
     /* 151121 */   // Label 2968: @151121
     /* 151121 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(151154), // Rule ID 13158 //
     /* 151126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 151137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151145 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 151145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 151148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151152 */     GIR_RootConstrainSelectedInstOperands,
     /* 151153 */     // GIR_Coverage, 13158,
     /* 151153 */     GIR_EraseRootFromParent_Done,
     /* 151154 */   // Label 2969: @151154
     /* 151154 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(151187), // Rule ID 13160 //
     /* 151159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 151167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 151170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 151174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151178 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 151178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 151181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151185 */     GIR_RootConstrainSelectedInstOperands,
     /* 151186 */     // GIR_Coverage, 13160,
     /* 151186 */     GIR_EraseRootFromParent_Done,
     /* 151187 */   // Label 2970: @151187
     /* 151187 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(151220), // Rule ID 13162 //
     /* 151192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151211 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 151211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 151214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151218 */     GIR_RootConstrainSelectedInstOperands,
     /* 151219 */     // GIR_Coverage, 13162,
     /* 151219 */     GIR_EraseRootFromParent_Done,
     /* 151220 */   // Label 2971: @151220
     /* 151220 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(151253), // Rule ID 13164 //
     /* 151225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151244 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 151244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 151247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151251 */     GIR_RootConstrainSelectedInstOperands,
     /* 151252 */     // GIR_Coverage, 13164,
     /* 151252 */     GIR_EraseRootFromParent_Done,
     /* 151253 */   // Label 2972: @151253
     /* 151253 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(151368), // Rule ID 13165 //
     /* 151258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151277 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151277 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 151280 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 151284 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151289 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 151330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151350 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151367 */     // GIR_Coverage, 13165,
     /* 151367 */     GIR_EraseRootFromParent_Done,
     /* 151368 */   // Label 2973: @151368
     /* 151368 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(151487), // Rule ID 13166 //
     /* 151373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151392 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151392 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151395 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 151399 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151404 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151408 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151486 */     // GIR_Coverage, 13166,
     /* 151486 */     GIR_EraseRootFromParent_Done,
     /* 151487 */   // Label 2974: @151487
     /* 151487 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(151519), // Rule ID 2393 //
     /* 151492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 151500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 151513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151517 */     GIR_RootConstrainSelectedInstOperands,
     /* 151518 */     // GIR_Coverage, 2393,
     /* 151518 */     GIR_EraseRootFromParent_Done,
     /* 151519 */   // Label 2975: @151519
     /* 151519 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(151551), // Rule ID 2394 //
     /* 151524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 151532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 151545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151549 */     GIR_RootConstrainSelectedInstOperands,
     /* 151550 */     // GIR_Coverage, 2394,
     /* 151550 */     GIR_EraseRootFromParent_Done,
     /* 151551 */   // Label 2976: @151551
     /* 151551 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(151583), // Rule ID 2395 //
     /* 151556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 151564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151574 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 151577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151581 */     GIR_RootConstrainSelectedInstOperands,
     /* 151582 */     // GIR_Coverage, 2395,
     /* 151582 */     GIR_EraseRootFromParent_Done,
     /* 151583 */   // Label 2977: @151583
     /* 151583 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(151615), // Rule ID 3093 //
     /* 151588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151606 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 151609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151613 */     GIR_RootConstrainSelectedInstOperands,
     /* 151614 */     // GIR_Coverage, 3093,
     /* 151614 */     GIR_EraseRootFromParent_Done,
     /* 151615 */   // Label 2978: @151615
     /* 151615 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(151647), // Rule ID 3094 //
     /* 151620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 151641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151645 */     GIR_RootConstrainSelectedInstOperands,
     /* 151646 */     // GIR_Coverage, 3094,
     /* 151646 */     GIR_EraseRootFromParent_Done,
     /* 151647 */   // Label 2979: @151647
     /* 151647 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(151679), // Rule ID 3095 //
     /* 151652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 151673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151677 */     GIR_RootConstrainSelectedInstOperands,
     /* 151678 */     // GIR_Coverage, 3095,
     /* 151678 */     GIR_EraseRootFromParent_Done,
     /* 151679 */   // Label 2980: @151679
     /* 151679 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(151711), // Rule ID 3349 //
     /* 151684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 151695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 151702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151709 */     GIR_RootConstrainSelectedInstOperands,
     /* 151710 */     // GIR_Coverage, 3349,
     /* 151710 */     GIR_EraseRootFromParent_Done,
     /* 151711 */   // Label 2981: @151711
     /* 151711 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(151743), // Rule ID 3350 //
     /* 151716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151741 */     GIR_RootConstrainSelectedInstOperands,
     /* 151742 */     // GIR_Coverage, 3350,
     /* 151742 */     GIR_EraseRootFromParent_Done,
     /* 151743 */   // Label 2982: @151743
     /* 151743 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(151775), // Rule ID 3351 //
     /* 151748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151766 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151773 */     GIR_RootConstrainSelectedInstOperands,
     /* 151774 */     // GIR_Coverage, 3351,
     /* 151774 */     GIR_EraseRootFromParent_Done,
     /* 151775 */   // Label 2983: @151775
     /* 151775 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151807), // Rule ID 3430 //
     /* 151780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 151783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 151801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151805 */     GIR_RootConstrainSelectedInstOperands,
     /* 151806 */     // GIR_Coverage, 3430,
     /* 151806 */     GIR_EraseRootFromParent_Done,
     /* 151807 */   // Label 2984: @151807
     /* 151807 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151839), // Rule ID 3431 //
     /* 151812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 151815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 151833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151837 */     GIR_RootConstrainSelectedInstOperands,
     /* 151838 */     // GIR_Coverage, 3431,
     /* 151838 */     GIR_EraseRootFromParent_Done,
     /* 151839 */   // Label 2985: @151839
     /* 151839 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151871), // Rule ID 3432 //
     /* 151844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 151847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 151855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151862 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 151865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151869 */     GIR_RootConstrainSelectedInstOperands,
     /* 151870 */     // GIR_Coverage, 3432,
     /* 151870 */     GIR_EraseRootFromParent_Done,
     /* 151871 */   // Label 2986: @151871
     /* 151871 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151903), // Rule ID 3458 //
     /* 151876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 151884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 151897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151901 */     GIR_RootConstrainSelectedInstOperands,
     /* 151902 */     // GIR_Coverage, 3458,
     /* 151902 */     GIR_EraseRootFromParent_Done,
     /* 151903 */   // Label 2987: @151903
     /* 151903 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151935), // Rule ID 4625 //
     /* 151908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151926 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 151929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151933 */     GIR_RootConstrainSelectedInstOperands,
     /* 151934 */     // GIR_Coverage, 4625,
     /* 151934 */     GIR_EraseRootFromParent_Done,
     /* 151935 */   // Label 2988: @151935
     /* 151935 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151967), // Rule ID 4626 //
     /* 151940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151958 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 151961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151965 */     GIR_RootConstrainSelectedInstOperands,
     /* 151966 */     // GIR_Coverage, 4626,
     /* 151966 */     GIR_EraseRootFromParent_Done,
     /* 151967 */   // Label 2989: @151967
     /* 151967 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151996), // Rule ID 4627 //
     /* 151972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151987 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 151990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151994 */     GIR_RootConstrainSelectedInstOperands,
     /* 151995 */     // GIR_Coverage, 4627,
     /* 151995 */     GIR_EraseRootFromParent_Done,
     /* 151996 */   // Label 2990: @151996
     /* 151996 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(152025), // Rule ID 4628 //
     /* 152001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152016 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 152016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 152019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152023 */     GIR_RootConstrainSelectedInstOperands,
     /* 152024 */     // GIR_Coverage, 4628,
     /* 152024 */     GIR_EraseRootFromParent_Done,
     /* 152025 */   // Label 2991: @152025
     /* 152025 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(152054), // Rule ID 4629 //
     /* 152030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152045 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 152045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 152048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152052 */     GIR_RootConstrainSelectedInstOperands,
     /* 152053 */     // GIR_Coverage, 4629,
     /* 152053 */     GIR_EraseRootFromParent_Done,
     /* 152054 */   // Label 2992: @152054
     /* 152054 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(152083), // Rule ID 4630 //
     /* 152059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152074 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 152074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 152077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152081 */     GIR_RootConstrainSelectedInstOperands,
     /* 152082 */     // GIR_Coverage, 4630,
     /* 152082 */     GIR_EraseRootFromParent_Done,
     /* 152083 */   // Label 2993: @152083
     /* 152083 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(152115), // Rule ID 4637 //
     /* 152088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 152091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152106 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 152106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 152109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152113 */     GIR_RootConstrainSelectedInstOperands,
     /* 152114 */     // GIR_Coverage, 4637,
     /* 152114 */     GIR_EraseRootFromParent_Done,
     /* 152115 */   // Label 2994: @152115
     /* 152115 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(152147), // Rule ID 4638 //
     /* 152120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 152123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152138 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 152138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 152141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152145 */     GIR_RootConstrainSelectedInstOperands,
     /* 152146 */     // GIR_Coverage, 4638,
     /* 152146 */     GIR_EraseRootFromParent_Done,
     /* 152147 */   // Label 2995: @152147
     /* 152147 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(152176), // Rule ID 4639 //
     /* 152152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152167 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 152167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 152170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152174 */     GIR_RootConstrainSelectedInstOperands,
     /* 152175 */     // GIR_Coverage, 4639,
     /* 152175 */     GIR_EraseRootFromParent_Done,
     /* 152176 */   // Label 2996: @152176
     /* 152176 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(152205), // Rule ID 4640 //
     /* 152181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152196 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 152196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 152199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152203 */     GIR_RootConstrainSelectedInstOperands,
     /* 152204 */     // GIR_Coverage, 4640,
     /* 152204 */     GIR_EraseRootFromParent_Done,
     /* 152205 */   // Label 2997: @152205
     /* 152205 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(152234), // Rule ID 4641 //
     /* 152210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152225 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 152225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 152228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152232 */     GIR_RootConstrainSelectedInstOperands,
     /* 152233 */     // GIR_Coverage, 4641,
     /* 152233 */     GIR_EraseRootFromParent_Done,
     /* 152234 */   // Label 2998: @152234
     /* 152234 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(152263), // Rule ID 4642 //
     /* 152239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152254 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 152254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 152257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152261 */     GIR_RootConstrainSelectedInstOperands,
     /* 152262 */     // GIR_Coverage, 4642,
     /* 152262 */     GIR_EraseRootFromParent_Done,
     /* 152263 */   // Label 2999: @152263
     /* 152263 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(152292), // Rule ID 4937 //
     /* 152268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 152276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152283 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 152283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 152286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152290 */     GIR_RootConstrainSelectedInstOperands,
     /* 152291 */     // GIR_Coverage, 4937,
     /* 152291 */     GIR_EraseRootFromParent_Done,
     /* 152292 */   // Label 3000: @152292
     /* 152292 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(152321), // Rule ID 4938 //
     /* 152297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 152305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 152312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 152315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152319 */     GIR_RootConstrainSelectedInstOperands,
     /* 152320 */     // GIR_Coverage, 4938,
     /* 152320 */     GIR_EraseRootFromParent_Done,
     /* 152321 */   // Label 3001: @152321
     /* 152321 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(152350), // Rule ID 4939 //
     /* 152326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 152334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152341 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 152341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 152344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152348 */     GIR_RootConstrainSelectedInstOperands,
     /* 152349 */     // GIR_Coverage, 4939,
     /* 152349 */     GIR_EraseRootFromParent_Done,
     /* 152350 */   // Label 3002: @152350
     /* 152350 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(152379), // Rule ID 4940 //
     /* 152355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152370 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 152370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 152373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152377 */     GIR_RootConstrainSelectedInstOperands,
     /* 152378 */     // GIR_Coverage, 4940,
     /* 152378 */     GIR_EraseRootFromParent_Done,
     /* 152379 */   // Label 3003: @152379
     /* 152379 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(152408), // Rule ID 4941 //
     /* 152384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152399 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 152399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 152402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152406 */     GIR_RootConstrainSelectedInstOperands,
     /* 152407 */     // GIR_Coverage, 4941,
     /* 152407 */     GIR_EraseRootFromParent_Done,
     /* 152408 */   // Label 3004: @152408
     /* 152408 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(152437), // Rule ID 4942 //
     /* 152413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 152421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152428 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 152428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 152431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152435 */     GIR_RootConstrainSelectedInstOperands,
     /* 152436 */     // GIR_Coverage, 4942,
     /* 152436 */     GIR_EraseRootFromParent_Done,
     /* 152437 */   // Label 3005: @152437
     /* 152437 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(152466), // Rule ID 4943 //
     /* 152442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 152450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152457 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 152457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 152460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152464 */     GIR_RootConstrainSelectedInstOperands,
     /* 152465 */     // GIR_Coverage, 4943,
     /* 152465 */     GIR_EraseRootFromParent_Done,
     /* 152466 */   // Label 3006: @152466
     /* 152466 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(152495), // Rule ID 4944 //
     /* 152471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 152479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152486 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 152486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 152489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152493 */     GIR_RootConstrainSelectedInstOperands,
     /* 152494 */     // GIR_Coverage, 4944,
     /* 152494 */     GIR_EraseRootFromParent_Done,
     /* 152495 */   // Label 3007: @152495
     /* 152495 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(152524), // Rule ID 4945 //
     /* 152500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152515 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 152515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 152518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152522 */     GIR_RootConstrainSelectedInstOperands,
     /* 152523 */     // GIR_Coverage, 4945,
     /* 152523 */     GIR_EraseRootFromParent_Done,
     /* 152524 */   // Label 3008: @152524
     /* 152524 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(152553), // Rule ID 4946 //
     /* 152529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152544 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 152544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 152547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152551 */     GIR_RootConstrainSelectedInstOperands,
     /* 152552 */     // GIR_Coverage, 4946,
     /* 152552 */     GIR_EraseRootFromParent_Done,
     /* 152553 */   // Label 3009: @152553
     /* 152553 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152585), // Rule ID 8381 //
     /* 152558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 152569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 152572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1660:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 152576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152583 */     GIR_RootConstrainSelectedInstOperands,
     /* 152584 */     // GIR_Coverage, 8381,
     /* 152584 */     GIR_EraseRootFromParent_Done,
     /* 152585 */   // Label 3010: @152585
     /* 152585 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152617), // Rule ID 8382 //
     /* 152590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 152601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 152604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1660:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 152608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152615 */     GIR_RootConstrainSelectedInstOperands,
     /* 152616 */     // GIR_Coverage, 8382,
     /* 152616 */     GIR_EraseRootFromParent_Done,
     /* 152617 */   // Label 3011: @152617
     /* 152617 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(152649), // Rule ID 8383 //
     /* 152622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 152633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 152636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1660:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 152640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152647 */     GIR_RootConstrainSelectedInstOperands,
     /* 152648 */     // GIR_Coverage, 8383,
     /* 152648 */     GIR_EraseRootFromParent_Done,
     /* 152649 */   // Label 3012: @152649
     /* 152649 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152681), // Rule ID 11792 //
     /* 152654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 152668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152672 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 152672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 152675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152679 */     GIR_RootConstrainSelectedInstOperands,
     /* 152680 */     // GIR_Coverage, 11792,
     /* 152680 */     GIR_EraseRootFromParent_Done,
     /* 152681 */   // Label 3013: @152681
     /* 152681 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152713), // Rule ID 11793 //
     /* 152686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 152697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 152700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 152704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 152707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152711 */     GIR_RootConstrainSelectedInstOperands,
     /* 152712 */     // GIR_Coverage, 11793,
     /* 152712 */     GIR_EraseRootFromParent_Done,
     /* 152713 */   // Label 3014: @152713
     /* 152713 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152745), // Rule ID 11794 //
     /* 152718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 152729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 152732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 152736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 152739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152743 */     GIR_RootConstrainSelectedInstOperands,
     /* 152744 */     // GIR_Coverage, 11794,
     /* 152744 */     GIR_EraseRootFromParent_Done,
     /* 152745 */   // Label 3015: @152745
     /* 152745 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152777), // Rule ID 11795 //
     /* 152750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 152764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 152768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 152771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152775 */     GIR_RootConstrainSelectedInstOperands,
     /* 152776 */     // GIR_Coverage, 11795,
     /* 152776 */     GIR_EraseRootFromParent_Done,
     /* 152777 */   // Label 3016: @152777
     /* 152777 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152809), // Rule ID 11796 //
     /* 152782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 152793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 152796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 152800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 152803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152807 */     GIR_RootConstrainSelectedInstOperands,
     /* 152808 */     // GIR_Coverage, 11796,
     /* 152808 */     GIR_EraseRootFromParent_Done,
     /* 152809 */   // Label 3017: @152809
     /* 152809 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152841), // Rule ID 11797 //
     /* 152814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 152825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 152828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 152832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 152835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152839 */     GIR_RootConstrainSelectedInstOperands,
     /* 152840 */     // GIR_Coverage, 11797,
     /* 152840 */     GIR_EraseRootFromParent_Done,
     /* 152841 */   // Label 3018: @152841
     /* 152841 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152873), // Rule ID 11952 //
     /* 152846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 152849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 152854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 152860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 152864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 152867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 152869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152871 */     GIR_RootConstrainSelectedInstOperands,
     /* 152872 */     // GIR_Coverage, 11952,
     /* 152872 */     GIR_EraseRootFromParent_Done,
     /* 152873 */   // Label 3019: @152873
     /* 152873 */   GIM_Reject,
     /* 152874 */ // Label 2700: @152874
     /* 152874 */ GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(199188),
     /* 152879 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 152882 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(153066), // Rule ID 2568 //
     /* 152887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152936 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152939 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152948 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152977 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152981 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152985 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152998 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153002 */     // MIs[5] Operand 1
     /* 153002 */     // No operand predicates
     /* 153002 */     // MIs[3] Operand 2
     /* 153002 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 153013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153017 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 153019 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153031 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 153050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 153061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 153064 */     GIR_RootConstrainSelectedInstOperands,
     /* 153065 */     // GIR_Coverage, 2568,
     /* 153065 */     GIR_EraseRootFromParent_Done,
     /* 153066 */   // Label 3021: @153066
     /* 153066 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153250), // Rule ID 6261 //
     /* 153071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153120 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153123 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153132 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 153157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153161 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 153169 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153174 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 153178 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153182 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153186 */     // MIs[5] Operand 1
     /* 153186 */     // No operand predicates
     /* 153186 */     // MIs[3] Operand 2
     /* 153186 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 153197 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153201 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 153203 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153215 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 153234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 153245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 153248 */     GIR_RootConstrainSelectedInstOperands,
     /* 153249 */     // GIR_Coverage, 6261,
     /* 153249 */     GIR_EraseRootFromParent_Done,
     /* 153250 */   // Label 3022: @153250
     /* 153250 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153390), // Rule ID 2057 //
     /* 153255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153288 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153291 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153300 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153324 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153328 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153332 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153345 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153349 */     // MIs[4] Operand 1
     /* 153349 */     // No operand predicates
     /* 153349 */     // MIs[2] Operand 2
     /* 153349 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 153360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 153372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153388 */     GIR_RootConstrainSelectedInstOperands,
     /* 153389 */     // GIR_Coverage, 2057,
     /* 153389 */     GIR_EraseRootFromParent_Done,
     /* 153390 */   // Label 3023: @153390
     /* 153390 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153530), // Rule ID 2064 //
     /* 153395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153472 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153477 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153481 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153485 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153489 */     // MIs[4] Operand 1
     /* 153489 */     // No operand predicates
     /* 153489 */     // MIs[2] Operand 2
     /* 153489 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 153500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 153512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153528 */     GIR_RootConstrainSelectedInstOperands,
     /* 153529 */     // GIR_Coverage, 2064,
     /* 153529 */     GIR_EraseRootFromParent_Done,
     /* 153530 */   // Label 3024: @153530
     /* 153530 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153670), // Rule ID 2060 //
     /* 153535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153568 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153571 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153580 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153621 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153625 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153629 */     // MIs[4] Operand 1
     /* 153629 */     // No operand predicates
     /* 153629 */     // MIs[2] Operand 2
     /* 153629 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 153640 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153649 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 153652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153668 */     GIR_RootConstrainSelectedInstOperands,
     /* 153669 */     // GIR_Coverage, 2060,
     /* 153669 */     GIR_EraseRootFromParent_Done,
     /* 153670 */   // Label 3025: @153670
     /* 153670 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153810), // Rule ID 2067 //
     /* 153675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153708 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153711 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153752 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153761 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153765 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153769 */     // MIs[4] Operand 1
     /* 153769 */     // No operand predicates
     /* 153769 */     // MIs[2] Operand 2
     /* 153769 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 153780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153789 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 153792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153808 */     GIR_RootConstrainSelectedInstOperands,
     /* 153809 */     // GIR_Coverage, 2067,
     /* 153809 */     GIR_EraseRootFromParent_Done,
     /* 153810 */   // Label 3026: @153810
     /* 153810 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153947), // Rule ID 2055 //
     /* 153815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153848 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153851 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153860 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153906 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153910 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153914 */     // MIs[4] Operand 1
     /* 153914 */     // No operand predicates
     /* 153914 */     // MIs[2] Operand 2
     /* 153914 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153927 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 153930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153945 */     GIR_RootConstrainSelectedInstOperands,
     /* 153946 */     // GIR_Coverage, 2055,
     /* 153946 */     GIR_EraseRootFromParent_Done,
     /* 153947 */   // Label 3027: @153947
     /* 153947 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(154084), // Rule ID 2062 //
     /* 153952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153985 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153988 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153997 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154030 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154034 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154047 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154051 */     // MIs[4] Operand 1
     /* 154051 */     // No operand predicates
     /* 154051 */     // MIs[2] Operand 2
     /* 154051 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 154062 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154064 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 154067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154082 */     GIR_RootConstrainSelectedInstOperands,
     /* 154083 */     // GIR_Coverage, 2062,
     /* 154083 */     GIR_EraseRootFromParent_Done,
     /* 154084 */   // Label 3028: @154084
     /* 154084 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(154221), // Rule ID 2058 //
     /* 154089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154122 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154125 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154134 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154167 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154180 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154184 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154188 */     // MIs[4] Operand 1
     /* 154188 */     // No operand predicates
     /* 154188 */     // MIs[2] Operand 2
     /* 154188 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 154199 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154201 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 154204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154219 */     GIR_RootConstrainSelectedInstOperands,
     /* 154220 */     // GIR_Coverage, 2058,
     /* 154220 */     GIR_EraseRootFromParent_Done,
     /* 154221 */   // Label 3029: @154221
     /* 154221 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(154358), // Rule ID 2065 //
     /* 154226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154259 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154262 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154271 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 154284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 154296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154317 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154321 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154325 */     // MIs[4] Operand 1
     /* 154325 */     // No operand predicates
     /* 154325 */     // MIs[2] Operand 2
     /* 154325 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 154336 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154338 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 154341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154356 */     GIR_RootConstrainSelectedInstOperands,
     /* 154357 */     // GIR_Coverage, 2065,
     /* 154357 */     GIR_EraseRootFromParent_Done,
     /* 154358 */   // Label 3030: @154358
     /* 154358 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154519), // Rule ID 2569 //
     /* 154363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154412 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154415 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154424 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154441 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154445 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154449 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154458 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154462 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154466 */     // MIs[4] Operand 1
     /* 154466 */     // No operand predicates
     /* 154466 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154472 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154484 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 154503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154517 */     GIR_RootConstrainSelectedInstOperands,
     /* 154518 */     // GIR_Coverage, 2569,
     /* 154518 */     GIR_EraseRootFromParent_Done,
     /* 154519 */   // Label 3031: @154519
     /* 154519 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154680), // Rule ID 6262 //
     /* 154524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154615 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154619 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154623 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154627 */     // MIs[4] Operand 1
     /* 154627 */     // No operand predicates
     /* 154627 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154631 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154633 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154645 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 154664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154678 */     GIR_RootConstrainSelectedInstOperands,
     /* 154679 */     // GIR_Coverage, 6262,
     /* 154679 */     GIR_EraseRootFromParent_Done,
     /* 154680 */   // Label 3032: @154680
     /* 154680 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154790), // Rule ID 2085 //
     /* 154685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154747 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154751 */     // MIs[3] Operand 1
     /* 154751 */     // No operand predicates
     /* 154751 */     // MIs[1] Operand 2
     /* 154751 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 154762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154771 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 154774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154788 */     GIR_RootConstrainSelectedInstOperands,
     /* 154789 */     // GIR_Coverage, 2085,
     /* 154789 */     GIR_EraseRootFromParent_Done,
     /* 154790 */   // Label 3033: @154790
     /* 154790 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154900), // Rule ID 2088 //
     /* 154795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154857 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154861 */     // MIs[3] Operand 1
     /* 154861 */     // No operand predicates
     /* 154861 */     // MIs[1] Operand 2
     /* 154861 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 154872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154881 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 154884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154898 */     GIR_RootConstrainSelectedInstOperands,
     /* 154899 */     // GIR_Coverage, 2088,
     /* 154899 */     GIR_EraseRootFromParent_Done,
     /* 154900 */   // Label 3034: @154900
     /* 154900 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154989), // Rule ID 1743 //
     /* 154905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154938 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154941 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154950 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154970 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 154973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154987 */     GIR_RootConstrainSelectedInstOperands,
     /* 154988 */     // GIR_Coverage, 1743,
     /* 154988 */     GIR_EraseRootFromParent_Done,
     /* 154989 */   // Label 3035: @154989
     /* 154989 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(155078), // Rule ID 1745 //
     /* 154994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155030 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155059 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 155059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 155062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 155076 */     GIR_RootConstrainSelectedInstOperands,
     /* 155077 */     // GIR_Coverage, 1745,
     /* 155077 */     GIR_EraseRootFromParent_Done,
     /* 155078 */   // Label 3036: @155078
     /* 155078 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(155167), // Rule ID 1747 //
     /* 155083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155116 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155119 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 155141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 155148 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 155165 */     GIR_RootConstrainSelectedInstOperands,
     /* 155166 */     // GIR_Coverage, 1747,
     /* 155166 */     GIR_EraseRootFromParent_Done,
     /* 155167 */   // Label 3037: @155167
     /* 155167 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(155256), // Rule ID 1749 //
     /* 155172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155217 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 155237 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 155237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 155240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 155249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 155254 */     GIR_RootConstrainSelectedInstOperands,
     /* 155255 */     // GIR_Coverage, 1749,
     /* 155255 */     GIR_EraseRootFromParent_Done,
     /* 155256 */   // Label 3038: @155256
     /* 155256 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(155378), // Rule ID 6913 //
     /* 155261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 155266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155296 */     // MIs[1] Operand 2
     /* 155296 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155315 */     // MIs[2] Rn
     /* 155315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155320 */     // MIs[2] Operand 2
     /* 155320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155333 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 155333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 155340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155360 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155377 */     // GIR_Coverage, 6913,
     /* 155377 */     GIR_EraseRootFromParent_Done,
     /* 155378 */   // Label 3039: @155378
     /* 155378 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(155500), // Rule ID 6915 //
     /* 155383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 155388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155418 */     // MIs[1] Operand 2
     /* 155418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155437 */     // MIs[2] Rn
     /* 155437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155442 */     // MIs[2] Operand 2
     /* 155442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155455 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 155455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 155462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155499 */     // GIR_Coverage, 6915,
     /* 155499 */     GIR_EraseRootFromParent_Done,
     /* 155500 */   // Label 3040: @155500
     /* 155500 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(155622), // Rule ID 6917 //
     /* 155505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 155510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 155513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 155516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 155519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 155535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155540 */     // MIs[1] Operand 2
     /* 155540 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155559 */     // MIs[2] Rn
     /* 155559 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155564 */     // MIs[2] Operand 2
     /* 155564 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 155575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155577 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 155577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 155584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155621 */     // GIR_Coverage, 6917,
     /* 155621 */     GIR_EraseRootFromParent_Done,
     /* 155622 */   // Label 3041: @155622
     /* 155622 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155744), // Rule ID 6919 //
     /* 155627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 155632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155662 */     // MIs[1] Operand 2
     /* 155662 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155681 */     // MIs[2] Rn
     /* 155681 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155686 */     // MIs[2] Operand 2
     /* 155686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155699 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 155699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 155706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155743 */     // GIR_Coverage, 6919,
     /* 155743 */     GIR_EraseRootFromParent_Done,
     /* 155744 */   // Label 3042: @155744
     /* 155744 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(155866), // Rule ID 6921 //
     /* 155749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 155754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155784 */     // MIs[1] Operand 2
     /* 155784 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155803 */     // MIs[2] Rn
     /* 155803 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155808 */     // MIs[2] Operand 2
     /* 155808 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155821 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 155821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 155828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155865 */     // GIR_Coverage, 6921,
     /* 155865 */     GIR_EraseRootFromParent_Done,
     /* 155866 */   // Label 3043: @155866
     /* 155866 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(156049), // Rule ID 2567 //
     /* 155871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155920 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155923 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155932 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155952 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155952 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155955 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155959 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155978 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155981 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155985 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 156034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 156044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156047 */     GIR_RootConstrainSelectedInstOperands,
     /* 156048 */     // GIR_Coverage, 2567,
     /* 156048 */     GIR_EraseRootFromParent_Done,
     /* 156049 */   // Label 3044: @156049
     /* 156049 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(156232), // Rule ID 6260 //
     /* 156054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156103 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 156106 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156115 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156129 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156135 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 156135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 156138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 156142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 156149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 156152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 156156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 156164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 156168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 156171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 156217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 156227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156230 */     GIR_RootConstrainSelectedInstOperands,
     /* 156231 */     // GIR_Coverage, 6260,
     /* 156231 */     GIR_EraseRootFromParent_Done,
     /* 156232 */   // Label 3045: @156232
     /* 156232 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(156336), // Rule ID 13417 //
     /* 156237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156299 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156303 */     // MIs[3] Operand 1
     /* 156303 */     // No operand predicates
     /* 156303 */     // MIs[1] Operand 2
     /* 156303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156320 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 156323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156334 */     GIR_RootConstrainSelectedInstOperands,
     /* 156335 */     // GIR_Coverage, 13417,
     /* 156335 */     GIR_EraseRootFromParent_Done,
     /* 156336 */   // Label 3046: @156336
     /* 156336 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(156440), // Rule ID 13420 //
     /* 156341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156407 */     // MIs[3] Operand 1
     /* 156407 */     // No operand predicates
     /* 156407 */     // MIs[1] Operand 2
     /* 156407 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156424 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 156427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156438 */     GIR_RootConstrainSelectedInstOperands,
     /* 156439 */     // GIR_Coverage, 13420,
     /* 156439 */     GIR_EraseRootFromParent_Done,
     /* 156440 */   // Label 3047: @156440
     /* 156440 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(156571), // Rule ID 2524 //
     /* 156445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156520 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156524 */     // MIs[3] Operand 1
     /* 156524 */     // No operand predicates
     /* 156524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156526 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156538 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156569 */     GIR_RootConstrainSelectedInstOperands,
     /* 156570 */     // GIR_Coverage, 2524,
     /* 156570 */     GIR_EraseRootFromParent_Done,
     /* 156571 */   // Label 3048: @156571
     /* 156571 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(156702), // Rule ID 2525 //
     /* 156576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156618 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156651 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156655 */     // MIs[3] Operand 1
     /* 156655 */     // No operand predicates
     /* 156655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156657 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156700 */     GIR_RootConstrainSelectedInstOperands,
     /* 156701 */     // GIR_Coverage, 2525,
     /* 156701 */     GIR_EraseRootFromParent_Done,
     /* 156702 */   // Label 3049: @156702
     /* 156702 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(156833), // Rule ID 2526 //
     /* 156707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156749 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156786 */     // MIs[3] Operand 1
     /* 156786 */     // No operand predicates
     /* 156786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156788 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156800 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156831 */     GIR_RootConstrainSelectedInstOperands,
     /* 156832 */     // GIR_Coverage, 2526,
     /* 156832 */     GIR_EraseRootFromParent_Done,
     /* 156833 */   // Label 3050: @156833
     /* 156833 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(156964), // Rule ID 13603 //
     /* 156838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156892 */     // MIs[2] Operand 1
     /* 156892 */     // No operand predicates
     /* 156892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156908 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156913 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156919 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156931 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156962 */     GIR_RootConstrainSelectedInstOperands,
     /* 156963 */     // GIR_Coverage, 13603,
     /* 156963 */     GIR_EraseRootFromParent_Done,
     /* 156964 */   // Label 3051: @156964
     /* 156964 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(157095), // Rule ID 13604 //
     /* 156969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157023 */     // MIs[2] Operand 1
     /* 157023 */     // No operand predicates
     /* 157023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 157027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157035 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 157039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157044 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 157048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157050 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 157050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 157068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 157081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157093 */     GIR_RootConstrainSelectedInstOperands,
     /* 157094 */     // GIR_Coverage, 13604,
     /* 157094 */     GIR_EraseRootFromParent_Done,
     /* 157095 */   // Label 3052: @157095
     /* 157095 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(157226), // Rule ID 13605 //
     /* 157100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 157133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 157146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 157154 */     // MIs[2] Operand 1
     /* 157154 */     // No operand predicates
     /* 157154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 157158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 157166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 157170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157175 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 157179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157181 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 157181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157193 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 157199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 157212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 157221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 157224 */     GIR_RootConstrainSelectedInstOperands,
     /* 157225 */     // GIR_Coverage, 13605,
     /* 157225 */     GIR_EraseRootFromParent_Done,
     /* 157226 */   // Label 3053: @157226
     /* 157226 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(157340), // Rule ID 2056 //
     /* 157231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157264 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157267 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157276 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157314 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157318 */     // MIs[3] Operand 1
     /* 157318 */     // No operand predicates
     /* 157318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157320 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 157323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157338 */     GIR_RootConstrainSelectedInstOperands,
     /* 157339 */     // GIR_Coverage, 2056,
     /* 157339 */     GIR_EraseRootFromParent_Done,
     /* 157340 */   // Label 3054: @157340
     /* 157340 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(157454), // Rule ID 2063 //
     /* 157345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157428 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157432 */     // MIs[3] Operand 1
     /* 157432 */     // No operand predicates
     /* 157432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 157437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157452 */     GIR_RootConstrainSelectedInstOperands,
     /* 157453 */     // GIR_Coverage, 2063,
     /* 157453 */     GIR_EraseRootFromParent_Done,
     /* 157454 */   // Label 3055: @157454
     /* 157454 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157568), // Rule ID 2059 //
     /* 157459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157492 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157495 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157504 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157542 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157546 */     // MIs[3] Operand 1
     /* 157546 */     // No operand predicates
     /* 157546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157548 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 157551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157566 */     GIR_RootConstrainSelectedInstOperands,
     /* 157567 */     // GIR_Coverage, 2059,
     /* 157567 */     GIR_EraseRootFromParent_Done,
     /* 157568 */   // Label 3056: @157568
     /* 157568 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157682), // Rule ID 2066 //
     /* 157573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157656 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157660 */     // MIs[3] Operand 1
     /* 157660 */     // No operand predicates
     /* 157660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157662 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 157665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157680 */     GIR_RootConstrainSelectedInstOperands,
     /* 157681 */     // GIR_Coverage, 2066,
     /* 157681 */     GIR_EraseRootFromParent_Done,
     /* 157682 */   // Label 3057: @157682
     /* 157682 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157796), // Rule ID 2061 //
     /* 157687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157720 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157723 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157732 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157770 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157774 */     // MIs[3] Operand 1
     /* 157774 */     // No operand predicates
     /* 157774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157776 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 157779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157794 */     GIR_RootConstrainSelectedInstOperands,
     /* 157795 */     // GIR_Coverage, 2061,
     /* 157795 */     GIR_EraseRootFromParent_Done,
     /* 157796 */   // Label 3058: @157796
     /* 157796 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157910), // Rule ID 2068 //
     /* 157801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157834 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157837 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157846 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157884 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157888 */     // MIs[3] Operand 1
     /* 157888 */     // No operand predicates
     /* 157888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157890 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 157893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157908 */     GIR_RootConstrainSelectedInstOperands,
     /* 157909 */     // GIR_Coverage, 2068,
     /* 157909 */     GIR_EraseRootFromParent_Done,
     /* 157910 */   // Label 3059: @157910
     /* 157910 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(158014), // Rule ID 1987 //
     /* 157915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157985 */     // MIs[3] Operand 1
     /* 157985 */     // No operand predicates
     /* 157985 */     // MIs[1] Operand 2
     /* 157985 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157998 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 158001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158012 */     GIR_RootConstrainSelectedInstOperands,
     /* 158013 */     // GIR_Coverage, 1987,
     /* 158013 */     GIR_EraseRootFromParent_Done,
     /* 158014 */   // Label 3060: @158014
     /* 158014 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(158118), // Rule ID 2017 //
     /* 158019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 158027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 158030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158085 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158089 */     // MIs[3] Operand 1
     /* 158089 */     // No operand predicates
     /* 158089 */     // MIs[1] Operand 2
     /* 158089 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158102 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 158105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158116 */     GIR_RootConstrainSelectedInstOperands,
     /* 158117 */     // GIR_Coverage, 2017,
     /* 158117 */     GIR_EraseRootFromParent_Done,
     /* 158118 */   // Label 3061: @158118
     /* 158118 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(158222), // Rule ID 2024 //
     /* 158123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 158131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 158134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158193 */     // MIs[3] Operand 1
     /* 158193 */     // No operand predicates
     /* 158193 */     // MIs[1] Operand 2
     /* 158193 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 158209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158220 */     GIR_RootConstrainSelectedInstOperands,
     /* 158221 */     // GIR_Coverage, 2024,
     /* 158221 */     GIR_EraseRootFromParent_Done,
     /* 158222 */   // Label 3062: @158222
     /* 158222 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(158326), // Rule ID 2083 //
     /* 158227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158297 */     // MIs[3] Operand 1
     /* 158297 */     // No operand predicates
     /* 158297 */     // MIs[1] Operand 2
     /* 158297 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 158313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158324 */     GIR_RootConstrainSelectedInstOperands,
     /* 158325 */     // GIR_Coverage, 2083,
     /* 158325 */     GIR_EraseRootFromParent_Done,
     /* 158326 */   // Label 3063: @158326
     /* 158326 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(158430), // Rule ID 1990 //
     /* 158331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158401 */     // MIs[3] Operand 1
     /* 158401 */     // No operand predicates
     /* 158401 */     // MIs[1] Operand 2
     /* 158401 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158414 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 158417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158428 */     GIR_RootConstrainSelectedInstOperands,
     /* 158429 */     // GIR_Coverage, 1990,
     /* 158429 */     GIR_EraseRootFromParent_Done,
     /* 158430 */   // Label 3064: @158430
     /* 158430 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(158534), // Rule ID 2020 //
     /* 158435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 158443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158501 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158505 */     // MIs[3] Operand 1
     /* 158505 */     // No operand predicates
     /* 158505 */     // MIs[1] Operand 2
     /* 158505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158518 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 158521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158532 */     GIR_RootConstrainSelectedInstOperands,
     /* 158533 */     // GIR_Coverage, 2020,
     /* 158533 */     GIR_EraseRootFromParent_Done,
     /* 158534 */   // Label 3065: @158534
     /* 158534 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(158638), // Rule ID 2027 //
     /* 158539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 158547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158605 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158609 */     // MIs[3] Operand 1
     /* 158609 */     // No operand predicates
     /* 158609 */     // MIs[1] Operand 2
     /* 158609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158622 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 158625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158636 */     GIR_RootConstrainSelectedInstOperands,
     /* 158637 */     // GIR_Coverage, 2027,
     /* 158637 */     GIR_EraseRootFromParent_Done,
     /* 158638 */   // Label 3066: @158638
     /* 158638 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(158742), // Rule ID 2086 //
     /* 158643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158709 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158713 */     // MIs[3] Operand 1
     /* 158713 */     // No operand predicates
     /* 158713 */     // MIs[1] Operand 2
     /* 158713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158726 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 158729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158740 */     GIR_RootConstrainSelectedInstOperands,
     /* 158741 */     // GIR_Coverage, 2086,
     /* 158741 */     GIR_EraseRootFromParent_Done,
     /* 158742 */   // Label 3067: @158742
     /* 158742 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158799), // Rule ID 1751 //
     /* 158747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 158775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 158782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 158782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 158785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158797 */     GIR_RootConstrainSelectedInstOperands,
     /* 158798 */     // GIR_Coverage, 1751,
     /* 158798 */     GIR_EraseRootFromParent_Done,
     /* 158799 */   // Label 3068: @158799
     /* 158799 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158856), // Rule ID 1753 //
     /* 158804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 158832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 158839 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 158839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 158842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158854 */     GIR_RootConstrainSelectedInstOperands,
     /* 158855 */     // GIR_Coverage, 1753,
     /* 158855 */     GIR_EraseRootFromParent_Done,
     /* 158856 */   // Label 3069: @158856
     /* 158856 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158966), // Rule ID 6279 //
     /* 158861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 158866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 158887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158900 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 158911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 158923 */     // MIs[2] Operand 1
     /* 158923 */     // No operand predicates
     /* 158923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158925 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 158925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158937 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 158956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 158964 */     GIR_RootConstrainSelectedInstOperands,
     /* 158965 */     // GIR_Coverage, 6279,
     /* 158965 */     GIR_EraseRootFromParent_Done,
     /* 158966 */   // Label 3070: @158966
     /* 158966 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(159063), // Rule ID 13874 //
     /* 158971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159023 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 159023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159035 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 159041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 159054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159061 */     GIR_RootConstrainSelectedInstOperands,
     /* 159062 */     // GIR_Coverage, 13874,
     /* 159062 */     GIR_EraseRootFromParent_Done,
     /* 159063 */   // Label 3071: @159063
     /* 159063 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(159160), // Rule ID 13875 //
     /* 159068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159120 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159132 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159158 */     GIR_RootConstrainSelectedInstOperands,
     /* 159159 */     // GIR_Coverage, 13875,
     /* 159159 */     GIR_EraseRootFromParent_Done,
     /* 159160 */   // Label 3072: @159160
     /* 159160 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(159257), // Rule ID 13876 //
     /* 159165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159217 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 159217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 159220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159229 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 159235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 159248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159255 */     GIR_RootConstrainSelectedInstOperands,
     /* 159256 */     // GIR_Coverage, 13876,
     /* 159256 */     GIR_EraseRootFromParent_Done,
     /* 159257 */   // Label 3073: @159257
     /* 159257 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(159340), // Rule ID 1742 //
     /* 159262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159295 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159298 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159323 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 159323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 159326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159338 */     GIR_RootConstrainSelectedInstOperands,
     /* 159339 */     // GIR_Coverage, 1742,
     /* 159339 */     GIR_EraseRootFromParent_Done,
     /* 159340 */   // Label 3074: @159340
     /* 159340 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(159423), // Rule ID 1744 //
     /* 159345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159406 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 159406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 159409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159421 */     GIR_RootConstrainSelectedInstOperands,
     /* 159422 */     // GIR_Coverage, 1744,
     /* 159422 */     GIR_EraseRootFromParent_Done,
     /* 159423 */   // Label 3075: @159423
     /* 159423 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(159506), // Rule ID 1746 //
     /* 159428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159473 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159489 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 159489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 159492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159504 */     GIR_RootConstrainSelectedInstOperands,
     /* 159505 */     // GIR_Coverage, 1746,
     /* 159505 */     GIR_EraseRootFromParent_Done,
     /* 159506 */   // Label 3076: @159506
     /* 159506 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(159589), // Rule ID 1748 //
     /* 159511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159544 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159547 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159572 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 159572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 159575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159587 */     GIR_RootConstrainSelectedInstOperands,
     /* 159588 */     // GIR_Coverage, 1748,
     /* 159588 */     GIR_EraseRootFromParent_Done,
     /* 159589 */   // Label 3077: @159589
     /* 159589 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159669), // Rule ID 5237 //
     /* 159594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159624 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159627 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159636 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159652 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 159652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 159655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159667 */     GIR_RootConstrainSelectedInstOperands,
     /* 159668 */     // GIR_Coverage, 5237,
     /* 159668 */     GIR_EraseRootFromParent_Done,
     /* 159669 */   // Label 3078: @159669
     /* 159669 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159749), // Rule ID 5238 //
     /* 159674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159704 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159707 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159732 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 159732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 159735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159747 */     GIR_RootConstrainSelectedInstOperands,
     /* 159748 */     // GIR_Coverage, 5238,
     /* 159748 */     GIR_EraseRootFromParent_Done,
     /* 159749 */   // Label 3079: @159749
     /* 159749 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159846), // Rule ID 5234 //
     /* 159754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 159757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 159771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159800 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159806 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 159806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159818 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 159824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 159837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159844 */     GIR_RootConstrainSelectedInstOperands,
     /* 159845 */     // GIR_Coverage, 5234,
     /* 159845 */     GIR_EraseRootFromParent_Done,
     /* 159846 */   // Label 3080: @159846
     /* 159846 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159943), // Rule ID 5235 //
     /* 159851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159897 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159903 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159915 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159941 */     GIR_RootConstrainSelectedInstOperands,
     /* 159942 */     // GIR_Coverage, 5235,
     /* 159942 */     GIR_EraseRootFromParent_Done,
     /* 159943 */   // Label 3081: @159943
     /* 159943 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(160040), // Rule ID 5236 //
     /* 159948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160000 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 160000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 160003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160012 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 160018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 160031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160038 */     GIR_RootConstrainSelectedInstOperands,
     /* 160039 */     // GIR_Coverage, 5236,
     /* 160039 */     GIR_EraseRootFromParent_Done,
     /* 160040 */   // Label 3082: @160040
     /* 160040 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(160121), // Rule ID 13418 //
     /* 160045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160099 */     // MIs[2] Operand 1
     /* 160099 */     // No operand predicates
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160105 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 160108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160119 */     GIR_RootConstrainSelectedInstOperands,
     /* 160120 */     // GIR_Coverage, 13418,
     /* 160120 */     GIR_EraseRootFromParent_Done,
     /* 160121 */   // Label 3083: @160121
     /* 160121 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(160202), // Rule ID 13419 //
     /* 160126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160176 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160180 */     // MIs[2] Operand 1
     /* 160180 */     // No operand predicates
     /* 160180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160186 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160200 */     GIR_RootConstrainSelectedInstOperands,
     /* 160201 */     // GIR_Coverage, 13419,
     /* 160201 */     GIR_EraseRootFromParent_Done,
     /* 160202 */   // Label 3084: @160202
     /* 160202 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(160283), // Rule ID 13421 //
     /* 160207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160261 */     // MIs[2] Operand 1
     /* 160261 */     // No operand predicates
     /* 160261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160267 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 160270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160281 */     GIR_RootConstrainSelectedInstOperands,
     /* 160282 */     // GIR_Coverage, 13421,
     /* 160282 */     GIR_EraseRootFromParent_Done,
     /* 160283 */   // Label 3085: @160283
     /* 160283 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(160364), // Rule ID 13422 //
     /* 160288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160338 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160342 */     // MIs[2] Operand 1
     /* 160342 */     // No operand predicates
     /* 160342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160348 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 160351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160362 */     GIR_RootConstrainSelectedInstOperands,
     /* 160363 */     // GIR_Coverage, 13422,
     /* 160363 */     GIR_EraseRootFromParent_Done,
     /* 160364 */   // Label 3086: @160364
     /* 160364 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(160445), // Rule ID 13423 //
     /* 160369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 160386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 160398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160419 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160423 */     // MIs[2] Operand 1
     /* 160423 */     // No operand predicates
     /* 160423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160429 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 160432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160443 */     GIR_RootConstrainSelectedInstOperands,
     /* 160444 */     // GIR_Coverage, 13423,
     /* 160444 */     GIR_EraseRootFromParent_Done,
     /* 160445 */   // Label 3087: @160445
     /* 160445 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(160526), // Rule ID 13424 //
     /* 160450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160504 */     // MIs[2] Operand 1
     /* 160504 */     // No operand predicates
     /* 160504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160510 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 160513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160524 */     GIR_RootConstrainSelectedInstOperands,
     /* 160525 */     // GIR_Coverage, 13424,
     /* 160525 */     GIR_EraseRootFromParent_Done,
     /* 160526 */   // Label 3088: @160526
     /* 160526 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160607), // Rule ID 13425 //
     /* 160531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160585 */     // MIs[2] Operand 1
     /* 160585 */     // No operand predicates
     /* 160585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160591 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 160594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160605 */     GIR_RootConstrainSelectedInstOperands,
     /* 160606 */     // GIR_Coverage, 13425,
     /* 160606 */     GIR_EraseRootFromParent_Done,
     /* 160607 */   // Label 3089: @160607
     /* 160607 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160688), // Rule ID 13426 //
     /* 160612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160662 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160666 */     // MIs[2] Operand 1
     /* 160666 */     // No operand predicates
     /* 160666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160672 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 160675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160686 */     GIR_RootConstrainSelectedInstOperands,
     /* 160687 */     // GIR_Coverage, 13426,
     /* 160687 */     GIR_EraseRootFromParent_Done,
     /* 160688 */   // Label 3090: @160688
     /* 160688 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160794), // Rule ID 6276 //
     /* 160693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 160719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 160723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160728 */     // MIs[1] Operand 2
     /* 160728 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 160739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 160743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160747 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 160751 */     // MIs[2] Operand 1
     /* 160751 */     // No operand predicates
     /* 160751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160753 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 160753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160765 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 160771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 160784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 160792 */     GIR_RootConstrainSelectedInstOperands,
     /* 160793 */     // GIR_Coverage, 6276,
     /* 160793 */     GIR_EraseRootFromParent_Done,
     /* 160794 */   // Label 3091: @160794
     /* 160794 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160875), // Rule ID 1988 //
     /* 160799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160857 */     // MIs[2] Operand 1
     /* 160857 */     // No operand predicates
     /* 160857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160859 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 160862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160873 */     GIR_RootConstrainSelectedInstOperands,
     /* 160874 */     // GIR_Coverage, 1988,
     /* 160874 */     GIR_EraseRootFromParent_Done,
     /* 160875 */   // Label 3092: @160875
     /* 160875 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160956), // Rule ID 1989 //
     /* 160880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160938 */     // MIs[2] Operand 1
     /* 160938 */     // No operand predicates
     /* 160938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160940 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160954 */     GIR_RootConstrainSelectedInstOperands,
     /* 160955 */     // GIR_Coverage, 1989,
     /* 160955 */     GIR_EraseRootFromParent_Done,
     /* 160956 */   // Label 3093: @160956
     /* 160956 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(161037), // Rule ID 2018 //
     /* 160961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161019 */     // MIs[2] Operand 1
     /* 161019 */     // No operand predicates
     /* 161019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161021 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 161024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161035 */     GIR_RootConstrainSelectedInstOperands,
     /* 161036 */     // GIR_Coverage, 2018,
     /* 161036 */     GIR_EraseRootFromParent_Done,
     /* 161037 */   // Label 3094: @161037
     /* 161037 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(161118), // Rule ID 2019 //
     /* 161042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161100 */     // MIs[2] Operand 1
     /* 161100 */     // No operand predicates
     /* 161100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161102 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 161105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161116 */     GIR_RootConstrainSelectedInstOperands,
     /* 161117 */     // GIR_Coverage, 2019,
     /* 161117 */     GIR_EraseRootFromParent_Done,
     /* 161118 */   // Label 3095: @161118
     /* 161118 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(161199), // Rule ID 2025 //
     /* 161123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161181 */     // MIs[2] Operand 1
     /* 161181 */     // No operand predicates
     /* 161181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161183 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 161186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161197 */     GIR_RootConstrainSelectedInstOperands,
     /* 161198 */     // GIR_Coverage, 2025,
     /* 161198 */     GIR_EraseRootFromParent_Done,
     /* 161199 */   // Label 3096: @161199
     /* 161199 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(161280), // Rule ID 2026 //
     /* 161204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161262 */     // MIs[2] Operand 1
     /* 161262 */     // No operand predicates
     /* 161262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161264 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 161267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161278 */     GIR_RootConstrainSelectedInstOperands,
     /* 161279 */     // GIR_Coverage, 2026,
     /* 161279 */     GIR_EraseRootFromParent_Done,
     /* 161280 */   // Label 3097: @161280
     /* 161280 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(161361), // Rule ID 2084 //
     /* 161285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 161318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161339 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161343 */     // MIs[2] Operand 1
     /* 161343 */     // No operand predicates
     /* 161343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161345 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 161348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161359 */     GIR_RootConstrainSelectedInstOperands,
     /* 161360 */     // GIR_Coverage, 2084,
     /* 161360 */     GIR_EraseRootFromParent_Done,
     /* 161361 */   // Label 3098: @161361
     /* 161361 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(161442), // Rule ID 1991 //
     /* 161366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161424 */     // MIs[2] Operand 1
     /* 161424 */     // No operand predicates
     /* 161424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161426 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 161429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161440 */     GIR_RootConstrainSelectedInstOperands,
     /* 161441 */     // GIR_Coverage, 1991,
     /* 161441 */     GIR_EraseRootFromParent_Done,
     /* 161442 */   // Label 3099: @161442
     /* 161442 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(161523), // Rule ID 1992 //
     /* 161447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161505 */     // MIs[2] Operand 1
     /* 161505 */     // No operand predicates
     /* 161505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161507 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 161510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161521 */     GIR_RootConstrainSelectedInstOperands,
     /* 161522 */     // GIR_Coverage, 1992,
     /* 161522 */     GIR_EraseRootFromParent_Done,
     /* 161523 */   // Label 3100: @161523
     /* 161523 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(161604), // Rule ID 2021 //
     /* 161528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161582 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161586 */     // MIs[2] Operand 1
     /* 161586 */     // No operand predicates
     /* 161586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 161591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161602 */     GIR_RootConstrainSelectedInstOperands,
     /* 161603 */     // GIR_Coverage, 2021,
     /* 161603 */     GIR_EraseRootFromParent_Done,
     /* 161604 */   // Label 3101: @161604
     /* 161604 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161685), // Rule ID 2022 //
     /* 161609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161667 */     // MIs[2] Operand 1
     /* 161667 */     // No operand predicates
     /* 161667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161669 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 161672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161683 */     GIR_RootConstrainSelectedInstOperands,
     /* 161684 */     // GIR_Coverage, 2022,
     /* 161684 */     GIR_EraseRootFromParent_Done,
     /* 161685 */   // Label 3102: @161685
     /* 161685 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161766), // Rule ID 2028 //
     /* 161690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161748 */     // MIs[2] Operand 1
     /* 161748 */     // No operand predicates
     /* 161748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161750 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 161753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161764 */     GIR_RootConstrainSelectedInstOperands,
     /* 161765 */     // GIR_Coverage, 2028,
     /* 161765 */     GIR_EraseRootFromParent_Done,
     /* 161766 */   // Label 3103: @161766
     /* 161766 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161847), // Rule ID 2029 //
     /* 161771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161829 */     // MIs[2] Operand 1
     /* 161829 */     // No operand predicates
     /* 161829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161831 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 161834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161845 */     GIR_RootConstrainSelectedInstOperands,
     /* 161846 */     // GIR_Coverage, 2029,
     /* 161846 */     GIR_EraseRootFromParent_Done,
     /* 161847 */   // Label 3104: @161847
     /* 161847 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161928), // Rule ID 2087 //
     /* 161852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161910 */     // MIs[2] Operand 1
     /* 161910 */     // No operand predicates
     /* 161910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161912 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 161915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161926 */     GIR_RootConstrainSelectedInstOperands,
     /* 161927 */     // GIR_Coverage, 2087,
     /* 161927 */     GIR_EraseRootFromParent_Done,
     /* 161928 */   // Label 3105: @161928
     /* 161928 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(162009), // Rule ID 1993 //
     /* 161933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161987 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161991 */     // MIs[2] Operand 1
     /* 161991 */     // No operand predicates
     /* 161991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161993 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162007 */     GIR_RootConstrainSelectedInstOperands,
     /* 162008 */     // GIR_Coverage, 1993,
     /* 162008 */     GIR_EraseRootFromParent_Done,
     /* 162009 */   // Label 3106: @162009
     /* 162009 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(162090), // Rule ID 1994 //
     /* 162014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 162031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 162060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 162072 */     // MIs[2] Operand 1
     /* 162072 */     // No operand predicates
     /* 162072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162074 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 162077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162088 */     GIR_RootConstrainSelectedInstOperands,
     /* 162089 */     // GIR_Coverage, 1994,
     /* 162089 */     GIR_EraseRootFromParent_Done,
     /* 162090 */   // Label 3107: @162090
     /* 162090 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(162171), // Rule ID 1995 //
     /* 162095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162153 */     // MIs[2] Operand 1
     /* 162153 */     // No operand predicates
     /* 162153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162155 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 162158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162169 */     GIR_RootConstrainSelectedInstOperands,
     /* 162170 */     // GIR_Coverage, 1995,
     /* 162170 */     GIR_EraseRootFromParent_Done,
     /* 162171 */   // Label 3108: @162171
     /* 162171 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(162252), // Rule ID 1996 //
     /* 162176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 162184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 162193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 162234 */     // MIs[2] Operand 1
     /* 162234 */     // No operand predicates
     /* 162234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162236 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 162239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162250 */     GIR_RootConstrainSelectedInstOperands,
     /* 162251 */     // GIR_Coverage, 1996,
     /* 162251 */     GIR_EraseRootFromParent_Done,
     /* 162252 */   // Label 3109: @162252
     /* 162252 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(162333), // Rule ID 2023 //
     /* 162257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 162265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162311 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162315 */     // MIs[2] Operand 1
     /* 162315 */     // No operand predicates
     /* 162315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162317 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 162320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162331 */     GIR_RootConstrainSelectedInstOperands,
     /* 162332 */     // GIR_Coverage, 2023,
     /* 162332 */     GIR_EraseRootFromParent_Done,
     /* 162333 */   // Label 3110: @162333
     /* 162333 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(162414), // Rule ID 2030 //
     /* 162338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162396 */     // MIs[2] Operand 1
     /* 162396 */     // No operand predicates
     /* 162396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162398 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 162401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162412 */     GIR_RootConstrainSelectedInstOperands,
     /* 162413 */     // GIR_Coverage, 2030,
     /* 162413 */     GIR_EraseRootFromParent_Done,
     /* 162414 */   // Label 3111: @162414
     /* 162414 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(162492), // Rule ID 6263 //
     /* 162419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 162424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162474 */     // MIs[2] Operand 1
     /* 162474 */     // No operand predicates
     /* 162474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162476 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 162476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 162479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 162487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162490 */     GIR_RootConstrainSelectedInstOperands,
     /* 162491 */     // GIR_Coverage, 6263,
     /* 162491 */     GIR_EraseRootFromParent_Done,
     /* 162492 */   // Label 3112: @162492
     /* 162492 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(162552), // Rule ID 6329 //
     /* 162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 162523 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 162523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 162526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 162543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162550 */     GIR_RootConstrainSelectedInstOperands,
     /* 162551 */     // GIR_Coverage, 6329,
     /* 162551 */     GIR_EraseRootFromParent_Done,
     /* 162552 */   // Label 3113: @162552
     /* 162552 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(162612), // Rule ID 6330 //
     /* 162557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 162583 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 162583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 162586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 162603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162610 */     GIR_RootConstrainSelectedInstOperands,
     /* 162611 */     // GIR_Coverage, 6330,
     /* 162611 */     GIR_EraseRootFromParent_Done,
     /* 162612 */   // Label 3114: @162612
     /* 162612 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(162672), // Rule ID 6331 //
     /* 162617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 162643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 162643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 162646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162655 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162670 */     GIR_RootConstrainSelectedInstOperands,
     /* 162671 */     // GIR_Coverage, 6331,
     /* 162671 */     GIR_EraseRootFromParent_Done,
     /* 162672 */   // Label 3115: @162672
     /* 162672 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(162719), // Rule ID 3897 //
     /* 162677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162699 */     // MIs[0] Operand 3
     /* 162699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 162710 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 162713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162717 */     GIR_RootConstrainSelectedInstOperands,
     /* 162718 */     // GIR_Coverage, 3897,
     /* 162718 */     GIR_EraseRootFromParent_Done,
     /* 162719 */   // Label 3116: @162719
     /* 162719 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162766), // Rule ID 3898 //
     /* 162724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162746 */     // MIs[0] Operand 3
     /* 162746 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 162757 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 162760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162764 */     GIR_RootConstrainSelectedInstOperands,
     /* 162765 */     // GIR_Coverage, 3898,
     /* 162765 */     GIR_EraseRootFromParent_Done,
     /* 162766 */   // Label 3117: @162766
     /* 162766 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162813), // Rule ID 3899 //
     /* 162771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162793 */     // MIs[0] Operand 3
     /* 162793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 162804 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162811 */     GIR_RootConstrainSelectedInstOperands,
     /* 162812 */     // GIR_Coverage, 3899,
     /* 162812 */     GIR_EraseRootFromParent_Done,
     /* 162813 */   // Label 3118: @162813
     /* 162813 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162860), // Rule ID 3900 //
     /* 162818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162840 */     // MIs[0] Operand 3
     /* 162840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 162851 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162858 */     GIR_RootConstrainSelectedInstOperands,
     /* 162859 */     // GIR_Coverage, 3900,
     /* 162859 */     GIR_EraseRootFromParent_Done,
     /* 162860 */   // Label 3119: @162860
     /* 162860 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162906), // Rule ID 3544 //
     /* 162865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 162876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162887 */     // MIs[0] Idx
     /* 162887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 162895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 162895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 162898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162904 */     GIR_RootConstrainSelectedInstOperands,
     /* 162905 */     // GIR_Coverage, 3544,
     /* 162905 */     GIR_EraseRootFromParent_Done,
     /* 162906 */   // Label 3120: @162906
     /* 162906 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162952), // Rule ID 3545 //
     /* 162911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 162922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162933 */     // MIs[0] Idx
     /* 162933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 162941 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 162941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 162944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162950 */     GIR_RootConstrainSelectedInstOperands,
     /* 162951 */     // GIR_Coverage, 3545,
     /* 162951 */     GIR_EraseRootFromParent_Done,
     /* 162952 */   // Label 3121: @162952
     /* 162952 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162998), // Rule ID 3546 //
     /* 162957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 162968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162979 */     // MIs[0] Idx
     /* 162979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 162987 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 162987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 162990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162996 */     GIR_RootConstrainSelectedInstOperands,
     /* 162997 */     // GIR_Coverage, 3546,
     /* 162997 */     GIR_EraseRootFromParent_Done,
     /* 162998 */   // Label 3122: @162998
     /* 162998 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(163044), // Rule ID 3547 //
     /* 163003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 163011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 163014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 163017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 163021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163025 */     // MIs[0] Idx
     /* 163025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 163033 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 163033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 163036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 163038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 163040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 163042 */     GIR_RootConstrainSelectedInstOperands,
     /* 163043 */     // GIR_Coverage, 3547,
     /* 163043 */     GIR_EraseRootFromParent_Done,
     /* 163044 */   // Label 3123: @163044
     /* 163044 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(163100), // Rule ID 2109 //
     /* 163049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 163057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163086 */     // MIs[1] Operand 1
     /* 163086 */     // No operand predicates
     /* 163086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163088 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 163091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163098 */     GIR_RootConstrainSelectedInstOperands,
     /* 163099 */     // GIR_Coverage, 2109,
     /* 163099 */     GIR_EraseRootFromParent_Done,
     /* 163100 */   // Label 3124: @163100
     /* 163100 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(163156), // Rule ID 2110 //
     /* 163105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 163113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163142 */     // MIs[1] Operand 1
     /* 163142 */     // No operand predicates
     /* 163142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163144 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 163147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163154 */     GIR_RootConstrainSelectedInstOperands,
     /* 163155 */     // GIR_Coverage, 2110,
     /* 163155 */     GIR_EraseRootFromParent_Done,
     /* 163156 */   // Label 3125: @163156
     /* 163156 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(163212), // Rule ID 2115 //
     /* 163161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 163169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163198 */     // MIs[1] Operand 1
     /* 163198 */     // No operand predicates
     /* 163198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163200 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 163203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163210 */     GIR_RootConstrainSelectedInstOperands,
     /* 163211 */     // GIR_Coverage, 2115,
     /* 163211 */     GIR_EraseRootFromParent_Done,
     /* 163212 */   // Label 3126: @163212
     /* 163212 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(163268), // Rule ID 2116 //
     /* 163217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 163225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163254 */     // MIs[1] Operand 1
     /* 163254 */     // No operand predicates
     /* 163254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163256 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 163259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163266 */     GIR_RootConstrainSelectedInstOperands,
     /* 163267 */     // GIR_Coverage, 2116,
     /* 163267 */     GIR_EraseRootFromParent_Done,
     /* 163268 */   // Label 3127: @163268
     /* 163268 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(163324), // Rule ID 2123 //
     /* 163273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 163281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163310 */     // MIs[1] Operand 1
     /* 163310 */     // No operand predicates
     /* 163310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163312 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 163315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163322 */     GIR_RootConstrainSelectedInstOperands,
     /* 163323 */     // GIR_Coverage, 2123,
     /* 163323 */     GIR_EraseRootFromParent_Done,
     /* 163324 */   // Label 3128: @163324
     /* 163324 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(163380), // Rule ID 2126 //
     /* 163329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 163337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163366 */     // MIs[1] Operand 1
     /* 163366 */     // No operand predicates
     /* 163366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163368 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 163371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163378 */     GIR_RootConstrainSelectedInstOperands,
     /* 163379 */     // GIR_Coverage, 2126,
     /* 163379 */     GIR_EraseRootFromParent_Done,
     /* 163380 */   // Label 3129: @163380
     /* 163380 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(163436), // Rule ID 2148 //
     /* 163385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 163422 */     // MIs[1] Operand 1
     /* 163422 */     // No operand predicates
     /* 163422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163424 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 163427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163434 */     GIR_RootConstrainSelectedInstOperands,
     /* 163435 */     // GIR_Coverage, 2148,
     /* 163435 */     GIR_EraseRootFromParent_Done,
     /* 163436 */   // Label 3130: @163436
     /* 163436 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(163492), // Rule ID 2150 //
     /* 163441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 163478 */     // MIs[1] Operand 1
     /* 163478 */     // No operand predicates
     /* 163478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163480 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 163483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163490 */     GIR_RootConstrainSelectedInstOperands,
     /* 163491 */     // GIR_Coverage, 2150,
     /* 163491 */     GIR_EraseRootFromParent_Done,
     /* 163492 */   // Label 3131: @163492
     /* 163492 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(163548), // Rule ID 2152 //
     /* 163497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 163534 */     // MIs[1] Operand 1
     /* 163534 */     // No operand predicates
     /* 163534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163536 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 163539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163546 */     GIR_RootConstrainSelectedInstOperands,
     /* 163547 */     // GIR_Coverage, 2152,
     /* 163547 */     GIR_EraseRootFromParent_Done,
     /* 163548 */   // Label 3132: @163548
     /* 163548 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(163601), // Rule ID 6264 //
     /* 163553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163587 */     // MIs[1] Operand 1
     /* 163587 */     // No operand predicates
     /* 163587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163589 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 163592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163599 */     GIR_RootConstrainSelectedInstOperands,
     /* 163600 */     // GIR_Coverage, 6264,
     /* 163600 */     GIR_EraseRootFromParent_Done,
     /* 163601 */   // Label 3133: @163601
     /* 163601 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(163654), // Rule ID 6265 //
     /* 163606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163640 */     // MIs[1] Operand 1
     /* 163640 */     // No operand predicates
     /* 163640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163642 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 163645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163652 */     GIR_RootConstrainSelectedInstOperands,
     /* 163653 */     // GIR_Coverage, 6265,
     /* 163653 */     GIR_EraseRootFromParent_Done,
     /* 163654 */   // Label 3134: @163654
     /* 163654 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(163707), // Rule ID 6266 //
     /* 163659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163693 */     // MIs[1] Operand 1
     /* 163693 */     // No operand predicates
     /* 163693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163695 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 163698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163705 */     GIR_RootConstrainSelectedInstOperands,
     /* 163706 */     // GIR_Coverage, 6266,
     /* 163706 */     GIR_EraseRootFromParent_Done,
     /* 163707 */   // Label 3135: @163707
     /* 163707 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163760), // Rule ID 6267 //
     /* 163712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163746 */     // MIs[1] Operand 1
     /* 163746 */     // No operand predicates
     /* 163746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163748 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163758 */     GIR_RootConstrainSelectedInstOperands,
     /* 163759 */     // GIR_Coverage, 6267,
     /* 163759 */     GIR_EraseRootFromParent_Done,
     /* 163760 */   // Label 3136: @163760
     /* 163760 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163813), // Rule ID 6268 //
     /* 163765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163799 */     // MIs[1] Operand 1
     /* 163799 */     // No operand predicates
     /* 163799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163801 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 163804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163811 */     GIR_RootConstrainSelectedInstOperands,
     /* 163812 */     // GIR_Coverage, 6268,
     /* 163812 */     GIR_EraseRootFromParent_Done,
     /* 163813 */   // Label 3137: @163813
     /* 163813 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163866), // Rule ID 6269 //
     /* 163818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163852 */     // MIs[1] Operand 1
     /* 163852 */     // No operand predicates
     /* 163852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163854 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163864 */     GIR_RootConstrainSelectedInstOperands,
     /* 163865 */     // GIR_Coverage, 6269,
     /* 163865 */     GIR_EraseRootFromParent_Done,
     /* 163866 */   // Label 3138: @163866
     /* 163866 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163919), // Rule ID 6270 //
     /* 163871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163905 */     // MIs[1] Operand 1
     /* 163905 */     // No operand predicates
     /* 163905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163907 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 163910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163917 */     GIR_RootConstrainSelectedInstOperands,
     /* 163918 */     // GIR_Coverage, 6270,
     /* 163918 */     GIR_EraseRootFromParent_Done,
     /* 163919 */   // Label 3139: @163919
     /* 163919 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163972), // Rule ID 6271 //
     /* 163924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163958 */     // MIs[1] Operand 1
     /* 163958 */     // No operand predicates
     /* 163958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163960 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163970 */     GIR_RootConstrainSelectedInstOperands,
     /* 163971 */     // GIR_Coverage, 6271,
     /* 163971 */     GIR_EraseRootFromParent_Done,
     /* 163972 */   // Label 3140: @163972
     /* 163972 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(164025), // Rule ID 6272 //
     /* 163977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164011 */     // MIs[1] Operand 1
     /* 164011 */     // No operand predicates
     /* 164011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164013 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 164013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 164016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164023 */     GIR_RootConstrainSelectedInstOperands,
     /* 164024 */     // GIR_Coverage, 6272,
     /* 164024 */     GIR_EraseRootFromParent_Done,
     /* 164025 */   // Label 3141: @164025
     /* 164025 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(164078), // Rule ID 6273 //
     /* 164030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 164035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164064 */     // MIs[1] Operand 1
     /* 164064 */     // No operand predicates
     /* 164064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164066 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 164066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 164069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164076 */     GIR_RootConstrainSelectedInstOperands,
     /* 164077 */     // GIR_Coverage, 6273,
     /* 164077 */     GIR_EraseRootFromParent_Done,
     /* 164078 */   // Label 3142: @164078
     /* 164078 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(164131), // Rule ID 6274 //
     /* 164083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 164088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164117 */     // MIs[1] Operand 1
     /* 164117 */     // No operand predicates
     /* 164117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164119 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 164119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 164122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164129 */     GIR_RootConstrainSelectedInstOperands,
     /* 164130 */     // GIR_Coverage, 6274,
     /* 164130 */     GIR_EraseRootFromParent_Done,
     /* 164131 */   // Label 3143: @164131
     /* 164131 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(164184), // Rule ID 6275 //
     /* 164136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 164141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164170 */     // MIs[1] Operand 1
     /* 164170 */     // No operand predicates
     /* 164170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164172 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 164172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 164175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164182 */     GIR_RootConstrainSelectedInstOperands,
     /* 164183 */     // GIR_Coverage, 6275,
     /* 164183 */     GIR_EraseRootFromParent_Done,
     /* 164184 */   // Label 3144: @164184
     /* 164184 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(164266), // Rule ID 6277 //
     /* 164189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 164194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164223 */     // MIs[1] Operand 1
     /* 164223 */     // No operand predicates
     /* 164223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164225 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 164256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164264 */     GIR_RootConstrainSelectedInstOperands,
     /* 164265 */     // GIR_Coverage, 6277,
     /* 164265 */     GIR_EraseRootFromParent_Done,
     /* 164266 */   // Label 3145: @164266
     /* 164266 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(164348), // Rule ID 6278 //
     /* 164271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 164276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164305 */     // MIs[1] Operand 1
     /* 164305 */     // No operand predicates
     /* 164305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164307 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 164338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164346 */     GIR_RootConstrainSelectedInstOperands,
     /* 164347 */     // GIR_Coverage, 6278,
     /* 164347 */     GIR_EraseRootFromParent_Done,
     /* 164348 */   // Label 3146: @164348
     /* 164348 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(164430), // Rule ID 6280 //
     /* 164353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 164358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164387 */     // MIs[1] Operand 1
     /* 164387 */     // No operand predicates
     /* 164387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164389 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 164420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164428 */     GIR_RootConstrainSelectedInstOperands,
     /* 164429 */     // GIR_Coverage, 6280,
     /* 164429 */     GIR_EraseRootFromParent_Done,
     /* 164430 */   // Label 3147: @164430
     /* 164430 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(164512), // Rule ID 6281 //
     /* 164435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 164440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164469 */     // MIs[1] Operand 1
     /* 164469 */     // No operand predicates
     /* 164469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164471 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 164502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164510 */     GIR_RootConstrainSelectedInstOperands,
     /* 164511 */     // GIR_Coverage, 6281,
     /* 164511 */     GIR_EraseRootFromParent_Done,
     /* 164512 */   // Label 3148: @164512
     /* 164512 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(164618), // Rule ID 6282 //
     /* 164517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 164522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164551 */     // MIs[1] Operand 1
     /* 164551 */     // No operand predicates
     /* 164551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164553 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 164553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 164560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164565 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 164577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164617 */     // GIR_Coverage, 6282,
     /* 164617 */     GIR_EraseRootFromParent_Done,
     /* 164618 */   // Label 3149: @164618
     /* 164618 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(164724), // Rule ID 6283 //
     /* 164623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 164628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164657 */     // MIs[1] Operand 1
     /* 164657 */     // No operand predicates
     /* 164657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164659 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 164666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164723 */     // GIR_Coverage, 6283,
     /* 164723 */     GIR_EraseRootFromParent_Done,
     /* 164724 */   // Label 3150: @164724
     /* 164724 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(164830), // Rule ID 6284 //
     /* 164729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 164734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164763 */     // MIs[1] Operand 1
     /* 164763 */     // No operand predicates
     /* 164763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164765 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 164765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 164789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164829 */     // GIR_Coverage, 6284,
     /* 164829 */     GIR_EraseRootFromParent_Done,
     /* 164830 */   // Label 3151: @164830
     /* 164830 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(164936), // Rule ID 6285 //
     /* 164835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 164840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164869 */     // MIs[1] Operand 1
     /* 164869 */     // No operand predicates
     /* 164869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164871 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164935 */     // GIR_Coverage, 6285,
     /* 164935 */     GIR_EraseRootFromParent_Done,
     /* 164936 */   // Label 3152: @164936
     /* 164936 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164994), // Rule ID 6974 //
     /* 164941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 164946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 164975 */     // MIs[1] Operand 1
     /* 164975 */     // No operand predicates
     /* 164975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164977 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 164977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 164980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164984 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 164989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 164992 */     GIR_RootConstrainSelectedInstOperands,
     /* 164993 */     // GIR_Coverage, 6974,
     /* 164993 */     GIR_EraseRootFromParent_Done,
     /* 164994 */   // Label 3153: @164994
     /* 164994 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(165036), // Rule ID 3045 //
     /* 164999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 165007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165017 */     // MIs[0] Op2
     /* 165017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 165028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165034 */     GIR_RootConstrainSelectedInstOperands,
     /* 165035 */     // GIR_Coverage, 3045,
     /* 165035 */     GIR_EraseRootFromParent_Done,
     /* 165036 */   // Label 3154: @165036
     /* 165036 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(165078), // Rule ID 3046 //
     /* 165041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 165049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165059 */     // MIs[0] Op2
     /* 165059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 165070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165076 */     GIR_RootConstrainSelectedInstOperands,
     /* 165077 */     // GIR_Coverage, 3046,
     /* 165077 */     GIR_EraseRootFromParent_Done,
     /* 165078 */   // Label 3155: @165078
     /* 165078 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(165120), // Rule ID 3047 //
     /* 165083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 165091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165101 */     // MIs[0] Op2
     /* 165101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 165112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165118 */     GIR_RootConstrainSelectedInstOperands,
     /* 165119 */     // GIR_Coverage, 3047,
     /* 165119 */     GIR_EraseRootFromParent_Done,
     /* 165120 */   // Label 3156: @165120
     /* 165120 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(165162), // Rule ID 3081 //
     /* 165125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 165133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165143 */     // MIs[0] Op2
     /* 165143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165151 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 165154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165160 */     GIR_RootConstrainSelectedInstOperands,
     /* 165161 */     // GIR_Coverage, 3081,
     /* 165161 */     GIR_EraseRootFromParent_Done,
     /* 165162 */   // Label 3157: @165162
     /* 165162 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(165204), // Rule ID 3082 //
     /* 165167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 165175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165185 */     // MIs[0] Op2
     /* 165185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 165196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165202 */     GIR_RootConstrainSelectedInstOperands,
     /* 165203 */     // GIR_Coverage, 3082,
     /* 165203 */     GIR_EraseRootFromParent_Done,
     /* 165204 */   // Label 3158: @165204
     /* 165204 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(165246), // Rule ID 3083 //
     /* 165209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 165217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165227 */     // MIs[0] Op2
     /* 165227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 165238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165244 */     GIR_RootConstrainSelectedInstOperands,
     /* 165245 */     // GIR_Coverage, 3083,
     /* 165245 */     GIR_EraseRootFromParent_Done,
     /* 165246 */   // Label 3159: @165246
     /* 165246 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(165288), // Rule ID 3530 //
     /* 165251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165269 */     // MIs[0] Op2
     /* 165269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 165277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1345:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 165277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 165280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165286 */     GIR_RootConstrainSelectedInstOperands,
     /* 165287 */     // GIR_Coverage, 3530,
     /* 165287 */     GIR_EraseRootFromParent_Done,
     /* 165288 */   // Label 3160: @165288
     /* 165288 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(165330), // Rule ID 3531 //
     /* 165293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165311 */     // MIs[0] Op2
     /* 165311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 165319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1345:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 165319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 165322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165328 */     GIR_RootConstrainSelectedInstOperands,
     /* 165329 */     // GIR_Coverage, 3531,
     /* 165329 */     GIR_EraseRootFromParent_Done,
     /* 165330 */   // Label 3161: @165330
     /* 165330 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(165372), // Rule ID 3532 //
     /* 165335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165353 */     // MIs[0] Op2
     /* 165353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 165361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1345:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 165361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 165364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165370 */     GIR_RootConstrainSelectedInstOperands,
     /* 165371 */     // GIR_Coverage, 3532,
     /* 165371 */     GIR_EraseRootFromParent_Done,
     /* 165372 */   // Label 3162: @165372
     /* 165372 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(165414), // Rule ID 3533 //
     /* 165377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165395 */     // MIs[0] Op2
     /* 165395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 165403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1345:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 165403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 165406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165412 */     GIR_RootConstrainSelectedInstOperands,
     /* 165413 */     // GIR_Coverage, 3533,
     /* 165413 */     GIR_EraseRootFromParent_Done,
     /* 165414 */   // Label 3163: @165414
     /* 165414 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(165456), // Rule ID 3534 //
     /* 165419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165437 */     // MIs[0] Op2
     /* 165437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 165445 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 165445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 165448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165454 */     GIR_RootConstrainSelectedInstOperands,
     /* 165455 */     // GIR_Coverage, 3534,
     /* 165455 */     GIR_EraseRootFromParent_Done,
     /* 165456 */   // Label 3164: @165456
     /* 165456 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(165498), // Rule ID 3535 //
     /* 165461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165479 */     // MIs[0] Op2
     /* 165479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165482 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 165487 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 165487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 165490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165496 */     GIR_RootConstrainSelectedInstOperands,
     /* 165497 */     // GIR_Coverage, 3535,
     /* 165497 */     GIR_EraseRootFromParent_Done,
     /* 165498 */   // Label 3165: @165498
     /* 165498 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(165540), // Rule ID 3536 //
     /* 165503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165521 */     // MIs[0] Op2
     /* 165521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 165529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 165529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 165532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165538 */     GIR_RootConstrainSelectedInstOperands,
     /* 165539 */     // GIR_Coverage, 3536,
     /* 165539 */     GIR_EraseRootFromParent_Done,
     /* 165540 */   // Label 3166: @165540
     /* 165540 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(165582), // Rule ID 11729 //
     /* 165545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165563 */     // MIs[0] Op2
     /* 165563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 165574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165580 */     GIR_RootConstrainSelectedInstOperands,
     /* 165581 */     // GIR_Coverage, 11729,
     /* 165581 */     GIR_EraseRootFromParent_Done,
     /* 165582 */   // Label 3167: @165582
     /* 165582 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(165624), // Rule ID 11730 //
     /* 165587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165605 */     // MIs[0] Op2
     /* 165605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165613 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 165616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165622 */     GIR_RootConstrainSelectedInstOperands,
     /* 165623 */     // GIR_Coverage, 11730,
     /* 165623 */     GIR_EraseRootFromParent_Done,
     /* 165624 */   // Label 3168: @165624
     /* 165624 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(165666), // Rule ID 11731 //
     /* 165629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165647 */     // MIs[0] Op2
     /* 165647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 165658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165664 */     GIR_RootConstrainSelectedInstOperands,
     /* 165665 */     // GIR_Coverage, 11731,
     /* 165665 */     GIR_EraseRootFromParent_Done,
     /* 165666 */   // Label 3169: @165666
     /* 165666 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(165708), // Rule ID 11732 //
     /* 165671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165689 */     // MIs[0] Op2
     /* 165689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165697 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 165700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165706 */     GIR_RootConstrainSelectedInstOperands,
     /* 165707 */     // GIR_Coverage, 11732,
     /* 165707 */     GIR_EraseRootFromParent_Done,
     /* 165708 */   // Label 3170: @165708
     /* 165708 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(165750), // Rule ID 11733 //
     /* 165713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165731 */     // MIs[0] Op2
     /* 165731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 165742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165748 */     GIR_RootConstrainSelectedInstOperands,
     /* 165749 */     // GIR_Coverage, 11733,
     /* 165749 */     GIR_EraseRootFromParent_Done,
     /* 165750 */   // Label 3171: @165750
     /* 165750 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165792), // Rule ID 11734 //
     /* 165755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165773 */     // MIs[0] Op2
     /* 165773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165781 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 165784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165790 */     GIR_RootConstrainSelectedInstOperands,
     /* 165791 */     // GIR_Coverage, 11734,
     /* 165791 */     GIR_EraseRootFromParent_Done,
     /* 165792 */   // Label 3172: @165792
     /* 165792 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165834), // Rule ID 11736 //
     /* 165797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165815 */     // MIs[0] Op2
     /* 165815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165818 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 165826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165832 */     GIR_RootConstrainSelectedInstOperands,
     /* 165833 */     // GIR_Coverage, 11736,
     /* 165833 */     GIR_EraseRootFromParent_Done,
     /* 165834 */   // Label 3173: @165834
     /* 165834 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165876), // Rule ID 11738 //
     /* 165839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165857 */     // MIs[0] Op2
     /* 165857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 165868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165874 */     GIR_RootConstrainSelectedInstOperands,
     /* 165875 */     // GIR_Coverage, 11738,
     /* 165875 */     GIR_EraseRootFromParent_Done,
     /* 165876 */   // Label 3174: @165876
     /* 165876 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165918), // Rule ID 11740 //
     /* 165881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165899 */     // MIs[0] Op2
     /* 165899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165907 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 165910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165916 */     GIR_RootConstrainSelectedInstOperands,
     /* 165917 */     // GIR_Coverage, 11740,
     /* 165917 */     GIR_EraseRootFromParent_Done,
     /* 165918 */   // Label 3175: @165918
     /* 165918 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165960), // Rule ID 11741 //
     /* 165923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165941 */     // MIs[0] Op2
     /* 165941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 165952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165958 */     GIR_RootConstrainSelectedInstOperands,
     /* 165959 */     // GIR_Coverage, 11741,
     /* 165959 */     GIR_EraseRootFromParent_Done,
     /* 165960 */   // Label 3176: @165960
     /* 165960 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(166002), // Rule ID 11742 //
     /* 165965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165983 */     // MIs[0] Op2
     /* 165983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 165994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166000 */     GIR_RootConstrainSelectedInstOperands,
     /* 166001 */     // GIR_Coverage, 11742,
     /* 166001 */     GIR_EraseRootFromParent_Done,
     /* 166002 */   // Label 3177: @166002
     /* 166002 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(166044), // Rule ID 11743 //
     /* 166007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 166015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166025 */     // MIs[0] Op2
     /* 166025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 166036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166042 */     GIR_RootConstrainSelectedInstOperands,
     /* 166043 */     // GIR_Coverage, 11743,
     /* 166043 */     GIR_EraseRootFromParent_Done,
     /* 166044 */   // Label 3178: @166044
     /* 166044 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(166086), // Rule ID 11744 //
     /* 166049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 166057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166067 */     // MIs[0] Op2
     /* 166067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 166075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 166075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 166078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166084 */     GIR_RootConstrainSelectedInstOperands,
     /* 166085 */     // GIR_Coverage, 11744,
     /* 166085 */     GIR_EraseRootFromParent_Done,
     /* 166086 */   // Label 3179: @166086
     /* 166086 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(166128), // Rule ID 11745 //
     /* 166091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 166099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166109 */     // MIs[0] Op2
     /* 166109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 166120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166126 */     GIR_RootConstrainSelectedInstOperands,
     /* 166127 */     // GIR_Coverage, 11745,
     /* 166127 */     GIR_EraseRootFromParent_Done,
     /* 166128 */   // Label 3180: @166128
     /* 166128 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(166170), // Rule ID 11746 //
     /* 166133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 166141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166151 */     // MIs[0] Op2
     /* 166151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 166162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166168 */     GIR_RootConstrainSelectedInstOperands,
     /* 166169 */     // GIR_Coverage, 11746,
     /* 166169 */     GIR_EraseRootFromParent_Done,
     /* 166170 */   // Label 3181: @166170
     /* 166170 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(166212), // Rule ID 11747 //
     /* 166175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 166183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166193 */     // MIs[0] Op2
     /* 166193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 166201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 166201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 166204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166210 */     GIR_RootConstrainSelectedInstOperands,
     /* 166211 */     // GIR_Coverage, 11747,
     /* 166211 */     GIR_EraseRootFromParent_Done,
     /* 166212 */   // Label 3182: @166212
     /* 166212 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(166254), // Rule ID 11748 //
     /* 166217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 166225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166235 */     // MIs[0] Op2
     /* 166235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 166246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166252 */     GIR_RootConstrainSelectedInstOperands,
     /* 166253 */     // GIR_Coverage, 11748,
     /* 166253 */     GIR_EraseRootFromParent_Done,
     /* 166254 */   // Label 3183: @166254
     /* 166254 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(166296), // Rule ID 11749 //
     /* 166259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 166267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166277 */     // MIs[0] Op2
     /* 166277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 166288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166294 */     GIR_RootConstrainSelectedInstOperands,
     /* 166295 */     // GIR_Coverage, 11749,
     /* 166295 */     GIR_EraseRootFromParent_Done,
     /* 166296 */   // Label 3184: @166296
     /* 166296 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(166338), // Rule ID 11750 //
     /* 166301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 166309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166319 */     // MIs[0] Op2
     /* 166319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 166327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 166327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 166330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166336 */     GIR_RootConstrainSelectedInstOperands,
     /* 166337 */     // GIR_Coverage, 11750,
     /* 166337 */     GIR_EraseRootFromParent_Done,
     /* 166338 */   // Label 3185: @166338
     /* 166338 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(166380), // Rule ID 11751 //
     /* 166343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 166351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166361 */     // MIs[0] Op2
     /* 166361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 166372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166378 */     GIR_RootConstrainSelectedInstOperands,
     /* 166379 */     // GIR_Coverage, 11751,
     /* 166379 */     GIR_EraseRootFromParent_Done,
     /* 166380 */   // Label 3186: @166380
     /* 166380 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(166422), // Rule ID 11752 //
     /* 166385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 166393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166403 */     // MIs[0] Op2
     /* 166403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 166414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166420 */     GIR_RootConstrainSelectedInstOperands,
     /* 166421 */     // GIR_Coverage, 11752,
     /* 166421 */     GIR_EraseRootFromParent_Done,
     /* 166422 */   // Label 3187: @166422
     /* 166422 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(166464), // Rule ID 11810 //
     /* 166427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166445 */     // MIs[0] Op2
     /* 166445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 166456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166462 */     GIR_RootConstrainSelectedInstOperands,
     /* 166463 */     // GIR_Coverage, 11810,
     /* 166463 */     GIR_EraseRootFromParent_Done,
     /* 166464 */   // Label 3188: @166464
     /* 166464 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(166506), // Rule ID 11811 //
     /* 166469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166487 */     // MIs[0] Op2
     /* 166487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 166498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166504 */     GIR_RootConstrainSelectedInstOperands,
     /* 166505 */     // GIR_Coverage, 11811,
     /* 166505 */     GIR_EraseRootFromParent_Done,
     /* 166506 */   // Label 3189: @166506
     /* 166506 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(166548), // Rule ID 11812 //
     /* 166511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166529 */     // MIs[0] Op2
     /* 166529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 166540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166546 */     GIR_RootConstrainSelectedInstOperands,
     /* 166547 */     // GIR_Coverage, 11812,
     /* 166547 */     GIR_EraseRootFromParent_Done,
     /* 166548 */   // Label 3190: @166548
     /* 166548 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(166590), // Rule ID 11813 //
     /* 166553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166571 */     // MIs[0] Op2
     /* 166571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166579 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 166582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166588 */     GIR_RootConstrainSelectedInstOperands,
     /* 166589 */     // GIR_Coverage, 11813,
     /* 166589 */     GIR_EraseRootFromParent_Done,
     /* 166590 */   // Label 3191: @166590
     /* 166590 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(166632), // Rule ID 11814 //
     /* 166595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166613 */     // MIs[0] Op2
     /* 166613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 166624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166630 */     GIR_RootConstrainSelectedInstOperands,
     /* 166631 */     // GIR_Coverage, 11814,
     /* 166631 */     GIR_EraseRootFromParent_Done,
     /* 166632 */   // Label 3192: @166632
     /* 166632 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(166674), // Rule ID 11815 //
     /* 166637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166655 */     // MIs[0] Op2
     /* 166655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166663 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 166666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166672 */     GIR_RootConstrainSelectedInstOperands,
     /* 166673 */     // GIR_Coverage, 11815,
     /* 166673 */     GIR_EraseRootFromParent_Done,
     /* 166674 */   // Label 3193: @166674
     /* 166674 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166716), // Rule ID 11816 //
     /* 166679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166697 */     // MIs[0] Op2
     /* 166697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166705 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 166708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166714 */     GIR_RootConstrainSelectedInstOperands,
     /* 166715 */     // GIR_Coverage, 11816,
     /* 166715 */     GIR_EraseRootFromParent_Done,
     /* 166716 */   // Label 3194: @166716
     /* 166716 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166758), // Rule ID 11817 //
     /* 166721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166739 */     // MIs[0] Op2
     /* 166739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 166750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166756 */     GIR_RootConstrainSelectedInstOperands,
     /* 166757 */     // GIR_Coverage, 11817,
     /* 166757 */     GIR_EraseRootFromParent_Done,
     /* 166758 */   // Label 3195: @166758
     /* 166758 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166800), // Rule ID 11818 //
     /* 166763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166781 */     // MIs[0] Op2
     /* 166781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 166792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166798 */     GIR_RootConstrainSelectedInstOperands,
     /* 166799 */     // GIR_Coverage, 11818,
     /* 166799 */     GIR_EraseRootFromParent_Done,
     /* 166800 */   // Label 3196: @166800
     /* 166800 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166852), // Rule ID 2132 //
     /* 166805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166838 */     // MIs[1] Operand 1
     /* 166838 */     // No operand predicates
     /* 166838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 166843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166850 */     GIR_RootConstrainSelectedInstOperands,
     /* 166851 */     // GIR_Coverage, 2132,
     /* 166851 */     GIR_EraseRootFromParent_Done,
     /* 166852 */   // Label 3197: @166852
     /* 166852 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166904), // Rule ID 2133 //
     /* 166857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166890 */     // MIs[1] Operand 1
     /* 166890 */     // No operand predicates
     /* 166890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 166895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166902 */     GIR_RootConstrainSelectedInstOperands,
     /* 166903 */     // GIR_Coverage, 2133,
     /* 166903 */     GIR_EraseRootFromParent_Done,
     /* 166904 */   // Label 3198: @166904
     /* 166904 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166956), // Rule ID 2134 //
     /* 166909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166942 */     // MIs[1] Operand 1
     /* 166942 */     // No operand predicates
     /* 166942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166944 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 166947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166954 */     GIR_RootConstrainSelectedInstOperands,
     /* 166955 */     // GIR_Coverage, 2134,
     /* 166955 */     GIR_EraseRootFromParent_Done,
     /* 166956 */   // Label 3199: @166956
     /* 166956 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(167008), // Rule ID 2135 //
     /* 166961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166994 */     // MIs[1] Operand 1
     /* 166994 */     // No operand predicates
     /* 166994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166996 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 166999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167006 */     GIR_RootConstrainSelectedInstOperands,
     /* 167007 */     // GIR_Coverage, 2135,
     /* 167007 */     GIR_EraseRootFromParent_Done,
     /* 167008 */   // Label 3200: @167008
     /* 167008 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(167060), // Rule ID 2136 //
     /* 167013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 167021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167046 */     // MIs[1] Operand 1
     /* 167046 */     // No operand predicates
     /* 167046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167048 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 167051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167058 */     GIR_RootConstrainSelectedInstOperands,
     /* 167059 */     // GIR_Coverage, 2136,
     /* 167059 */     GIR_EraseRootFromParent_Done,
     /* 167060 */   // Label 3201: @167060
     /* 167060 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(167112), // Rule ID 2137 //
     /* 167065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 167073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167098 */     // MIs[1] Operand 1
     /* 167098 */     // No operand predicates
     /* 167098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167100 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 167103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167110 */     GIR_RootConstrainSelectedInstOperands,
     /* 167111 */     // GIR_Coverage, 2137,
     /* 167111 */     GIR_EraseRootFromParent_Done,
     /* 167112 */   // Label 3202: @167112
     /* 167112 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(167164), // Rule ID 2138 //
     /* 167117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 167125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167150 */     // MIs[1] Operand 1
     /* 167150 */     // No operand predicates
     /* 167150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167152 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 167155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167162 */     GIR_RootConstrainSelectedInstOperands,
     /* 167163 */     // GIR_Coverage, 2138,
     /* 167163 */     GIR_EraseRootFromParent_Done,
     /* 167164 */   // Label 3203: @167164
     /* 167164 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(167216), // Rule ID 2139 //
     /* 167169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 167177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167202 */     // MIs[1] Operand 1
     /* 167202 */     // No operand predicates
     /* 167202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167204 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 167207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167214 */     GIR_RootConstrainSelectedInstOperands,
     /* 167215 */     // GIR_Coverage, 2139,
     /* 167215 */     GIR_EraseRootFromParent_Done,
     /* 167216 */   // Label 3204: @167216
     /* 167216 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(167268), // Rule ID 2140 //
     /* 167221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 167229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167254 */     // MIs[1] Operand 1
     /* 167254 */     // No operand predicates
     /* 167254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 167259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167266 */     GIR_RootConstrainSelectedInstOperands,
     /* 167267 */     // GIR_Coverage, 2140,
     /* 167267 */     GIR_EraseRootFromParent_Done,
     /* 167268 */   // Label 3205: @167268
     /* 167268 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(167320), // Rule ID 2141 //
     /* 167273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 167281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167306 */     // MIs[1] Operand 1
     /* 167306 */     // No operand predicates
     /* 167306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167308 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 167311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167318 */     GIR_RootConstrainSelectedInstOperands,
     /* 167319 */     // GIR_Coverage, 2141,
     /* 167319 */     GIR_EraseRootFromParent_Done,
     /* 167320 */   // Label 3206: @167320
     /* 167320 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(167372), // Rule ID 2142 //
     /* 167325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167358 */     // MIs[1] Operand 1
     /* 167358 */     // No operand predicates
     /* 167358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167360 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 167363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167370 */     GIR_RootConstrainSelectedInstOperands,
     /* 167371 */     // GIR_Coverage, 2142,
     /* 167371 */     GIR_EraseRootFromParent_Done,
     /* 167372 */   // Label 3207: @167372
     /* 167372 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(167424), // Rule ID 2143 //
     /* 167377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167410 */     // MIs[1] Operand 1
     /* 167410 */     // No operand predicates
     /* 167410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167412 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167422 */     GIR_RootConstrainSelectedInstOperands,
     /* 167423 */     // GIR_Coverage, 2143,
     /* 167423 */     GIR_EraseRootFromParent_Done,
     /* 167424 */   // Label 3208: @167424
     /* 167424 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(167476), // Rule ID 2144 //
     /* 167429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167462 */     // MIs[1] Operand 1
     /* 167462 */     // No operand predicates
     /* 167462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167464 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 167467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167474 */     GIR_RootConstrainSelectedInstOperands,
     /* 167475 */     // GIR_Coverage, 2144,
     /* 167475 */     GIR_EraseRootFromParent_Done,
     /* 167476 */   // Label 3209: @167476
     /* 167476 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(167528), // Rule ID 2145 //
     /* 167481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167514 */     // MIs[1] Operand 1
     /* 167514 */     // No operand predicates
     /* 167514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 167519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167526 */     GIR_RootConstrainSelectedInstOperands,
     /* 167527 */     // GIR_Coverage, 2145,
     /* 167527 */     GIR_EraseRootFromParent_Done,
     /* 167528 */   // Label 3210: @167528
     /* 167528 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(167580), // Rule ID 2146 //
     /* 167533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167566 */     // MIs[1] Operand 1
     /* 167566 */     // No operand predicates
     /* 167566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 167571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167578 */     GIR_RootConstrainSelectedInstOperands,
     /* 167579 */     // GIR_Coverage, 2146,
     /* 167579 */     GIR_EraseRootFromParent_Done,
     /* 167580 */   // Label 3211: @167580
     /* 167580 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(167632), // Rule ID 2244 //
     /* 167585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167618 */     // MIs[1] Operand 1
     /* 167618 */     // No operand predicates
     /* 167618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167620 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 167623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167630 */     GIR_RootConstrainSelectedInstOperands,
     /* 167631 */     // GIR_Coverage, 2244,
     /* 167631 */     GIR_EraseRootFromParent_Done,
     /* 167632 */   // Label 3212: @167632
     /* 167632 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(167684), // Rule ID 2245 //
     /* 167637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167670 */     // MIs[1] Operand 1
     /* 167670 */     // No operand predicates
     /* 167670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167672 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 167675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167682 */     GIR_RootConstrainSelectedInstOperands,
     /* 167683 */     // GIR_Coverage, 2245,
     /* 167683 */     GIR_EraseRootFromParent_Done,
     /* 167684 */   // Label 3213: @167684
     /* 167684 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167736), // Rule ID 2246 //
     /* 167689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167722 */     // MIs[1] Operand 1
     /* 167722 */     // No operand predicates
     /* 167722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167724 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 167727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167734 */     GIR_RootConstrainSelectedInstOperands,
     /* 167735 */     // GIR_Coverage, 2246,
     /* 167735 */     GIR_EraseRootFromParent_Done,
     /* 167736 */   // Label 3214: @167736
     /* 167736 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167788), // Rule ID 2247 //
     /* 167741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167774 */     // MIs[1] Operand 1
     /* 167774 */     // No operand predicates
     /* 167774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167776 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 167779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167786 */     GIR_RootConstrainSelectedInstOperands,
     /* 167787 */     // GIR_Coverage, 2247,
     /* 167787 */     GIR_EraseRootFromParent_Done,
     /* 167788 */   // Label 3215: @167788
     /* 167788 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167840), // Rule ID 2248 //
     /* 167793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167826 */     // MIs[1] Operand 1
     /* 167826 */     // No operand predicates
     /* 167826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167828 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 167831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167838 */     GIR_RootConstrainSelectedInstOperands,
     /* 167839 */     // GIR_Coverage, 2248,
     /* 167839 */     GIR_EraseRootFromParent_Done,
     /* 167840 */   // Label 3216: @167840
     /* 167840 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167885), // Rule ID 63 //
     /* 167845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 167848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 167853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 167874 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 167874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 167877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167883 */     GIR_RootConstrainSelectedInstOperands,
     /* 167884 */     // GIR_Coverage, 63,
     /* 167884 */     GIR_EraseRootFromParent_Done,
     /* 167885 */   // Label 3217: @167885
     /* 167885 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167930), // Rule ID 129 //
     /* 167890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 167898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167919 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 167922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167928 */     GIR_RootConstrainSelectedInstOperands,
     /* 167929 */     // GIR_Coverage, 129,
     /* 167929 */     GIR_EraseRootFromParent_Done,
     /* 167930 */   // Label 3218: @167930
     /* 167930 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167975), // Rule ID 130 //
     /* 167935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 167943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167964 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 167967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167973 */     GIR_RootConstrainSelectedInstOperands,
     /* 167974 */     // GIR_Coverage, 130,
     /* 167974 */     GIR_EraseRootFromParent_Done,
     /* 167975 */   // Label 3219: @167975
     /* 167975 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(168020), // Rule ID 131 //
     /* 167980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 167988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168009 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 168009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 168012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168018 */     GIR_RootConstrainSelectedInstOperands,
     /* 168019 */     // GIR_Coverage, 131,
     /* 168019 */     GIR_EraseRootFromParent_Done,
     /* 168020 */   // Label 3220: @168020
     /* 168020 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(168065), // Rule ID 132 //
     /* 168025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 168028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 168033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 168042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 168054 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 168054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 168057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168063 */     GIR_RootConstrainSelectedInstOperands,
     /* 168064 */     // GIR_Coverage, 132,
     /* 168064 */     GIR_EraseRootFromParent_Done,
     /* 168065 */   // Label 3221: @168065
     /* 168065 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(168110), // Rule ID 133 //
     /* 168070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 168073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 168078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168099 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 168099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 168102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168108 */     GIR_RootConstrainSelectedInstOperands,
     /* 168109 */     // GIR_Coverage, 133,
     /* 168109 */     GIR_EraseRootFromParent_Done,
     /* 168110 */   // Label 3222: @168110
     /* 168110 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(168155), // Rule ID 134 //
     /* 168115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 168118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 168123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168144 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 168144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 168147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168153 */     GIR_RootConstrainSelectedInstOperands,
     /* 168154 */     // GIR_Coverage, 134,
     /* 168154 */     GIR_EraseRootFromParent_Done,
     /* 168155 */   // Label 3223: @168155
     /* 168155 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(168200), // Rule ID 135 //
     /* 168160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 168163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 168168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 168177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168189 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 168189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 168192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168198 */     GIR_RootConstrainSelectedInstOperands,
     /* 168199 */     // GIR_Coverage, 135,
     /* 168199 */     GIR_EraseRootFromParent_Done,
     /* 168200 */   // Label 3224: @168200
     /* 168200 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(168245), // Rule ID 136 //
     /* 168205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 168208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 168213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 168222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 168230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 168234 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 168234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 168237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168243 */     GIR_RootConstrainSelectedInstOperands,
     /* 168244 */     // GIR_Coverage, 136,
     /* 168244 */     GIR_EraseRootFromParent_Done,
     /* 168245 */   // Label 3225: @168245
     /* 168245 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(168290), // Rule ID 1042 //
     /* 168250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168279 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 168279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 168282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168288 */     GIR_RootConstrainSelectedInstOperands,
     /* 168289 */     // GIR_Coverage, 1042,
     /* 168289 */     GIR_EraseRootFromParent_Done,
     /* 168290 */   // Label 3226: @168290
     /* 168290 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(168335), // Rule ID 1043 //
     /* 168295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 168324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 168327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168333 */     GIR_RootConstrainSelectedInstOperands,
     /* 168334 */     // GIR_Coverage, 1043,
     /* 168334 */     GIR_EraseRootFromParent_Done,
     /* 168335 */   // Label 3227: @168335
     /* 168335 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(168380), // Rule ID 1044 //
     /* 168340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168369 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 168369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 168372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168378 */     GIR_RootConstrainSelectedInstOperands,
     /* 168379 */     // GIR_Coverage, 1044,
     /* 168379 */     GIR_EraseRootFromParent_Done,
     /* 168380 */   // Label 3228: @168380
     /* 168380 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(168425), // Rule ID 1045 //
     /* 168385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168414 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 168414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 168417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168423 */     GIR_RootConstrainSelectedInstOperands,
     /* 168424 */     // GIR_Coverage, 1045,
     /* 168424 */     GIR_EraseRootFromParent_Done,
     /* 168425 */   // Label 3229: @168425
     /* 168425 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(168470), // Rule ID 1046 //
     /* 168430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168459 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 168459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 168462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 168469 */     // GIR_Coverage, 1046,
     /* 168469 */     GIR_EraseRootFromParent_Done,
     /* 168470 */   // Label 3230: @168470
     /* 168470 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(168515), // Rule ID 1047 //
     /* 168475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 168504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 168507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168513 */     GIR_RootConstrainSelectedInstOperands,
     /* 168514 */     // GIR_Coverage, 1047,
     /* 168514 */     GIR_EraseRootFromParent_Done,
     /* 168515 */   // Label 3231: @168515
     /* 168515 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(168560), // Rule ID 1048 //
     /* 168520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168549 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 168552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168558 */     GIR_RootConstrainSelectedInstOperands,
     /* 168559 */     // GIR_Coverage, 1048,
     /* 168559 */     GIR_EraseRootFromParent_Done,
     /* 168560 */   // Label 3232: @168560
     /* 168560 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(168605), // Rule ID 1090 //
     /* 168565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168594 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 168594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 168597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168603 */     GIR_RootConstrainSelectedInstOperands,
     /* 168604 */     // GIR_Coverage, 1090,
     /* 168604 */     GIR_EraseRootFromParent_Done,
     /* 168605 */   // Label 3233: @168605
     /* 168605 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(168650), // Rule ID 1091 //
     /* 168610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168639 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 168639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 168642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168648 */     GIR_RootConstrainSelectedInstOperands,
     /* 168649 */     // GIR_Coverage, 1091,
     /* 168649 */     GIR_EraseRootFromParent_Done,
     /* 168650 */   // Label 3234: @168650
     /* 168650 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168695), // Rule ID 1092 //
     /* 168655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168684 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 168684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 168687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168693 */     GIR_RootConstrainSelectedInstOperands,
     /* 168694 */     // GIR_Coverage, 1092,
     /* 168694 */     GIR_EraseRootFromParent_Done,
     /* 168695 */   // Label 3235: @168695
     /* 168695 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168740), // Rule ID 1093 //
     /* 168700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168729 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 168729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 168732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168738 */     GIR_RootConstrainSelectedInstOperands,
     /* 168739 */     // GIR_Coverage, 1093,
     /* 168739 */     GIR_EraseRootFromParent_Done,
     /* 168740 */   // Label 3236: @168740
     /* 168740 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168785), // Rule ID 1094 //
     /* 168745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 168774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 168777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168783 */     GIR_RootConstrainSelectedInstOperands,
     /* 168784 */     // GIR_Coverage, 1094,
     /* 168784 */     GIR_EraseRootFromParent_Done,
     /* 168785 */   // Label 3237: @168785
     /* 168785 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168830), // Rule ID 1095 //
     /* 168790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 168819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 168822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168828 */     GIR_RootConstrainSelectedInstOperands,
     /* 168829 */     // GIR_Coverage, 1095,
     /* 168829 */     GIR_EraseRootFromParent_Done,
     /* 168830 */   // Label 3238: @168830
     /* 168830 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168875), // Rule ID 1096 //
     /* 168835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168864 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 168867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168873 */     GIR_RootConstrainSelectedInstOperands,
     /* 168874 */     // GIR_Coverage, 1096,
     /* 168874 */     GIR_EraseRootFromParent_Done,
     /* 168875 */   // Label 3239: @168875
     /* 168875 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168920), // Rule ID 1108 //
     /* 168880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168909 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 168912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168918 */     GIR_RootConstrainSelectedInstOperands,
     /* 168919 */     // GIR_Coverage, 1108,
     /* 168919 */     GIR_EraseRootFromParent_Done,
     /* 168920 */   // Label 3240: @168920
     /* 168920 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168965), // Rule ID 1110 //
     /* 168925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168954 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 168957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168963 */     GIR_RootConstrainSelectedInstOperands,
     /* 168964 */     // GIR_Coverage, 1110,
     /* 168964 */     GIR_EraseRootFromParent_Done,
     /* 168965 */   // Label 3241: @168965
     /* 168965 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(169010), // Rule ID 1112 //
     /* 168970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168999 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 169002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169008 */     GIR_RootConstrainSelectedInstOperands,
     /* 169009 */     // GIR_Coverage, 1112,
     /* 169009 */     GIR_EraseRootFromParent_Done,
     /* 169010 */   // Label 3242: @169010
     /* 169010 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(169055), // Rule ID 1114 //
     /* 169015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 169023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 169047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169053 */     GIR_RootConstrainSelectedInstOperands,
     /* 169054 */     // GIR_Coverage, 1114,
     /* 169054 */     GIR_EraseRootFromParent_Done,
     /* 169055 */   // Label 3243: @169055
     /* 169055 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(169100), // Rule ID 1116 //
     /* 169060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 169068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169089 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 169092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169098 */     GIR_RootConstrainSelectedInstOperands,
     /* 169099 */     // GIR_Coverage, 1116,
     /* 169099 */     GIR_EraseRootFromParent_Done,
     /* 169100 */   // Label 3244: @169100
     /* 169100 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(169145), // Rule ID 1118 //
     /* 169105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 169113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 169137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169143 */     GIR_RootConstrainSelectedInstOperands,
     /* 169144 */     // GIR_Coverage, 1118,
     /* 169144 */     GIR_EraseRootFromParent_Done,
     /* 169145 */   // Label 3245: @169145
     /* 169145 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(169190), // Rule ID 1120 //
     /* 169150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 169158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169179 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 169182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169188 */     GIR_RootConstrainSelectedInstOperands,
     /* 169189 */     // GIR_Coverage, 1120,
     /* 169189 */     GIR_EraseRootFromParent_Done,
     /* 169190 */   // Label 3246: @169190
     /* 169190 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(169235), // Rule ID 1163 //
     /* 169195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169224 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 169227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169233 */     GIR_RootConstrainSelectedInstOperands,
     /* 169234 */     // GIR_Coverage, 1163,
     /* 169234 */     GIR_EraseRootFromParent_Done,
     /* 169235 */   // Label 3247: @169235
     /* 169235 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(169280), // Rule ID 1164 //
     /* 169240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169269 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 169272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169278 */     GIR_RootConstrainSelectedInstOperands,
     /* 169279 */     // GIR_Coverage, 1164,
     /* 169279 */     GIR_EraseRootFromParent_Done,
     /* 169280 */   // Label 3248: @169280
     /* 169280 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(169325), // Rule ID 1165 //
     /* 169285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169314 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 169317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169323 */     GIR_RootConstrainSelectedInstOperands,
     /* 169324 */     // GIR_Coverage, 1165,
     /* 169324 */     GIR_EraseRootFromParent_Done,
     /* 169325 */   // Label 3249: @169325
     /* 169325 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(169370), // Rule ID 1166 //
     /* 169330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169359 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 169362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169368 */     GIR_RootConstrainSelectedInstOperands,
     /* 169369 */     // GIR_Coverage, 1166,
     /* 169369 */     GIR_EraseRootFromParent_Done,
     /* 169370 */   // Label 3250: @169370
     /* 169370 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(169415), // Rule ID 1167 //
     /* 169375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169404 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 169407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169413 */     GIR_RootConstrainSelectedInstOperands,
     /* 169414 */     // GIR_Coverage, 1167,
     /* 169414 */     GIR_EraseRootFromParent_Done,
     /* 169415 */   // Label 3251: @169415
     /* 169415 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(169460), // Rule ID 1169 //
     /* 169420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169449 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 169452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169458 */     GIR_RootConstrainSelectedInstOperands,
     /* 169459 */     // GIR_Coverage, 1169,
     /* 169459 */     GIR_EraseRootFromParent_Done,
     /* 169460 */   // Label 3252: @169460
     /* 169460 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(169505), // Rule ID 1171 //
     /* 169465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169494 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 169497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169503 */     GIR_RootConstrainSelectedInstOperands,
     /* 169504 */     // GIR_Coverage, 1171,
     /* 169504 */     GIR_EraseRootFromParent_Done,
     /* 169505 */   // Label 3253: @169505
     /* 169505 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(169550), // Rule ID 1173 //
     /* 169510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169539 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 169542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169548 */     GIR_RootConstrainSelectedInstOperands,
     /* 169549 */     // GIR_Coverage, 1173,
     /* 169549 */     GIR_EraseRootFromParent_Done,
     /* 169550 */   // Label 3254: @169550
     /* 169550 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(169595), // Rule ID 1175 //
     /* 169555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169584 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 169587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169593 */     GIR_RootConstrainSelectedInstOperands,
     /* 169594 */     // GIR_Coverage, 1175,
     /* 169594 */     GIR_EraseRootFromParent_Done,
     /* 169595 */   // Label 3255: @169595
     /* 169595 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(169640), // Rule ID 1177 //
     /* 169600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169629 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 169632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169638 */     GIR_RootConstrainSelectedInstOperands,
     /* 169639 */     // GIR_Coverage, 1177,
     /* 169639 */     GIR_EraseRootFromParent_Done,
     /* 169640 */   // Label 3256: @169640
     /* 169640 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169685), // Rule ID 1179 //
     /* 169645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169674 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 169677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169683 */     GIR_RootConstrainSelectedInstOperands,
     /* 169684 */     // GIR_Coverage, 1179,
     /* 169684 */     GIR_EraseRootFromParent_Done,
     /* 169685 */   // Label 3257: @169685
     /* 169685 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169730), // Rule ID 1181 //
     /* 169690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169719 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 169722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169728 */     GIR_RootConstrainSelectedInstOperands,
     /* 169729 */     // GIR_Coverage, 1181,
     /* 169729 */     GIR_EraseRootFromParent_Done,
     /* 169730 */   // Label 3258: @169730
     /* 169730 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169775), // Rule ID 1183 //
     /* 169735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169764 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 169767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169773 */     GIR_RootConstrainSelectedInstOperands,
     /* 169774 */     // GIR_Coverage, 1183,
     /* 169774 */     GIR_EraseRootFromParent_Done,
     /* 169775 */   // Label 3259: @169775
     /* 169775 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169820), // Rule ID 1185 //
     /* 169780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169809 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 169812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169818 */     GIR_RootConstrainSelectedInstOperands,
     /* 169819 */     // GIR_Coverage, 1185,
     /* 169819 */     GIR_EraseRootFromParent_Done,
     /* 169820 */   // Label 3260: @169820
     /* 169820 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169865), // Rule ID 1187 //
     /* 169825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169854 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 169857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169863 */     GIR_RootConstrainSelectedInstOperands,
     /* 169864 */     // GIR_Coverage, 1187,
     /* 169864 */     GIR_EraseRootFromParent_Done,
     /* 169865 */   // Label 3261: @169865
     /* 169865 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169910), // Rule ID 1189 //
     /* 169870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169899 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 169902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169908 */     GIR_RootConstrainSelectedInstOperands,
     /* 169909 */     // GIR_Coverage, 1189,
     /* 169909 */     GIR_EraseRootFromParent_Done,
     /* 169910 */   // Label 3262: @169910
     /* 169910 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169955), // Rule ID 1191 //
     /* 169915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169944 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 169947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169953 */     GIR_RootConstrainSelectedInstOperands,
     /* 169954 */     // GIR_Coverage, 1191,
     /* 169954 */     GIR_EraseRootFromParent_Done,
     /* 169955 */   // Label 3263: @169955
     /* 169955 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(170000), // Rule ID 1193 //
     /* 169960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169989 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 169992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169998 */     GIR_RootConstrainSelectedInstOperands,
     /* 169999 */     // GIR_Coverage, 1193,
     /* 169999 */     GIR_EraseRootFromParent_Done,
     /* 170000 */   // Label 3264: @170000
     /* 170000 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(170045), // Rule ID 1195 //
     /* 170005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 170013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170034 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 170037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170043 */     GIR_RootConstrainSelectedInstOperands,
     /* 170044 */     // GIR_Coverage, 1195,
     /* 170044 */     GIR_EraseRootFromParent_Done,
     /* 170045 */   // Label 3265: @170045
     /* 170045 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(170090), // Rule ID 1197 //
     /* 170050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 170058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170079 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 170082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170088 */     GIR_RootConstrainSelectedInstOperands,
     /* 170089 */     // GIR_Coverage, 1197,
     /* 170089 */     GIR_EraseRootFromParent_Done,
     /* 170090 */   // Label 3266: @170090
     /* 170090 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(170135), // Rule ID 1233 //
     /* 170095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 170103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170124 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 170127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170133 */     GIR_RootConstrainSelectedInstOperands,
     /* 170134 */     // GIR_Coverage, 1233,
     /* 170134 */     GIR_EraseRootFromParent_Done,
     /* 170135 */   // Label 3267: @170135
     /* 170135 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(170180), // Rule ID 1234 //
     /* 170140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 170148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170169 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 170172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170178 */     GIR_RootConstrainSelectedInstOperands,
     /* 170179 */     // GIR_Coverage, 1234,
     /* 170179 */     GIR_EraseRootFromParent_Done,
     /* 170180 */   // Label 3268: @170180
     /* 170180 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(170225), // Rule ID 1235 //
     /* 170185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 170193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170214 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 170217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170223 */     GIR_RootConstrainSelectedInstOperands,
     /* 170224 */     // GIR_Coverage, 1235,
     /* 170224 */     GIR_EraseRootFromParent_Done,
     /* 170225 */   // Label 3269: @170225
     /* 170225 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(170270), // Rule ID 1236 //
     /* 170230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 170238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170259 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 170262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170268 */     GIR_RootConstrainSelectedInstOperands,
     /* 170269 */     // GIR_Coverage, 1236,
     /* 170269 */     GIR_EraseRootFromParent_Done,
     /* 170270 */   // Label 3270: @170270
     /* 170270 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(170315), // Rule ID 1237 //
     /* 170275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 170283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170304 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 170307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170313 */     GIR_RootConstrainSelectedInstOperands,
     /* 170314 */     // GIR_Coverage, 1237,
     /* 170314 */     GIR_EraseRootFromParent_Done,
     /* 170315 */   // Label 3271: @170315
     /* 170315 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(170360), // Rule ID 1248 //
     /* 170320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170349 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 170352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170358 */     GIR_RootConstrainSelectedInstOperands,
     /* 170359 */     // GIR_Coverage, 1248,
     /* 170359 */     GIR_EraseRootFromParent_Done,
     /* 170360 */   // Label 3272: @170360
     /* 170360 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(170405), // Rule ID 1249 //
     /* 170365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170394 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 170397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170403 */     GIR_RootConstrainSelectedInstOperands,
     /* 170404 */     // GIR_Coverage, 1249,
     /* 170404 */     GIR_EraseRootFromParent_Done,
     /* 170405 */   // Label 3273: @170405
     /* 170405 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(170450), // Rule ID 1250 //
     /* 170410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170439 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 170442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170448 */     GIR_RootConstrainSelectedInstOperands,
     /* 170449 */     // GIR_Coverage, 1250,
     /* 170449 */     GIR_EraseRootFromParent_Done,
     /* 170450 */   // Label 3274: @170450
     /* 170450 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(170495), // Rule ID 1251 //
     /* 170455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170484 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 170487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170493 */     GIR_RootConstrainSelectedInstOperands,
     /* 170494 */     // GIR_Coverage, 1251,
     /* 170494 */     GIR_EraseRootFromParent_Done,
     /* 170495 */   // Label 3275: @170495
     /* 170495 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(170540), // Rule ID 1252 //
     /* 170500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170529 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 170532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170538 */     GIR_RootConstrainSelectedInstOperands,
     /* 170539 */     // GIR_Coverage, 1252,
     /* 170539 */     GIR_EraseRootFromParent_Done,
     /* 170540 */   // Label 3276: @170540
     /* 170540 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(170585), // Rule ID 1263 //
     /* 170545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170574 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 170577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170583 */     GIR_RootConstrainSelectedInstOperands,
     /* 170584 */     // GIR_Coverage, 1263,
     /* 170584 */     GIR_EraseRootFromParent_Done,
     /* 170585 */   // Label 3277: @170585
     /* 170585 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(170630), // Rule ID 1264 //
     /* 170590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170619 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 170622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170628 */     GIR_RootConstrainSelectedInstOperands,
     /* 170629 */     // GIR_Coverage, 1264,
     /* 170629 */     GIR_EraseRootFromParent_Done,
     /* 170630 */   // Label 3278: @170630
     /* 170630 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170675), // Rule ID 1265 //
     /* 170635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170664 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 170667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 1265,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3279: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170720), // Rule ID 1266 //
     /* 170680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170709 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 170712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170718 */     GIR_RootConstrainSelectedInstOperands,
     /* 170719 */     // GIR_Coverage, 1266,
     /* 170719 */     GIR_EraseRootFromParent_Done,
     /* 170720 */   // Label 3280: @170720
     /* 170720 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170765), // Rule ID 1267 //
     /* 170725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170754 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 170757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170763 */     GIR_RootConstrainSelectedInstOperands,
     /* 170764 */     // GIR_Coverage, 1267,
     /* 170764 */     GIR_EraseRootFromParent_Done,
     /* 170765 */   // Label 3281: @170765
     /* 170765 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170810), // Rule ID 1278 //
     /* 170770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170799 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 170802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170808 */     GIR_RootConstrainSelectedInstOperands,
     /* 170809 */     // GIR_Coverage, 1278,
     /* 170809 */     GIR_EraseRootFromParent_Done,
     /* 170810 */   // Label 3282: @170810
     /* 170810 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170855), // Rule ID 1279 //
     /* 170815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170844 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 170847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170853 */     GIR_RootConstrainSelectedInstOperands,
     /* 170854 */     // GIR_Coverage, 1279,
     /* 170854 */     GIR_EraseRootFromParent_Done,
     /* 170855 */   // Label 3283: @170855
     /* 170855 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170900), // Rule ID 1280 //
     /* 170860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170889 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 170892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170898 */     GIR_RootConstrainSelectedInstOperands,
     /* 170899 */     // GIR_Coverage, 1280,
     /* 170899 */     GIR_EraseRootFromParent_Done,
     /* 170900 */   // Label 3284: @170900
     /* 170900 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170945), // Rule ID 1281 //
     /* 170905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170934 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 170937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170943 */     GIR_RootConstrainSelectedInstOperands,
     /* 170944 */     // GIR_Coverage, 1281,
     /* 170944 */     GIR_EraseRootFromParent_Done,
     /* 170945 */   // Label 3285: @170945
     /* 170945 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170990), // Rule ID 1282 //
     /* 170950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170979 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 170982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170988 */     GIR_RootConstrainSelectedInstOperands,
     /* 170989 */     // GIR_Coverage, 1282,
     /* 170989 */     GIR_EraseRootFromParent_Done,
     /* 170990 */   // Label 3286: @170990
     /* 170990 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(171035), // Rule ID 1313 //
     /* 170995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171024 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 171027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171033 */     GIR_RootConstrainSelectedInstOperands,
     /* 171034 */     // GIR_Coverage, 1313,
     /* 171034 */     GIR_EraseRootFromParent_Done,
     /* 171035 */   // Label 3287: @171035
     /* 171035 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(171080), // Rule ID 1314 //
     /* 171040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171069 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 171072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171078 */     GIR_RootConstrainSelectedInstOperands,
     /* 171079 */     // GIR_Coverage, 1314,
     /* 171079 */     GIR_EraseRootFromParent_Done,
     /* 171080 */   // Label 3288: @171080
     /* 171080 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(171125), // Rule ID 1315 //
     /* 171085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171114 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 171117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171123 */     GIR_RootConstrainSelectedInstOperands,
     /* 171124 */     // GIR_Coverage, 1315,
     /* 171124 */     GIR_EraseRootFromParent_Done,
     /* 171125 */   // Label 3289: @171125
     /* 171125 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(171170), // Rule ID 1316 //
     /* 171130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171159 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 171162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171168 */     GIR_RootConstrainSelectedInstOperands,
     /* 171169 */     // GIR_Coverage, 1316,
     /* 171169 */     GIR_EraseRootFromParent_Done,
     /* 171170 */   // Label 3290: @171170
     /* 171170 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(171215), // Rule ID 1317 //
     /* 171175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171204 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 171207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171213 */     GIR_RootConstrainSelectedInstOperands,
     /* 171214 */     // GIR_Coverage, 1317,
     /* 171214 */     GIR_EraseRootFromParent_Done,
     /* 171215 */   // Label 3291: @171215
     /* 171215 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(171260), // Rule ID 1328 //
     /* 171220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171249 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 171252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171258 */     GIR_RootConstrainSelectedInstOperands,
     /* 171259 */     // GIR_Coverage, 1328,
     /* 171259 */     GIR_EraseRootFromParent_Done,
     /* 171260 */   // Label 3292: @171260
     /* 171260 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(171305), // Rule ID 1329 //
     /* 171265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171294 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 171297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171303 */     GIR_RootConstrainSelectedInstOperands,
     /* 171304 */     // GIR_Coverage, 1329,
     /* 171304 */     GIR_EraseRootFromParent_Done,
     /* 171305 */   // Label 3293: @171305
     /* 171305 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(171350), // Rule ID 1330 //
     /* 171310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171339 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 171342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171348 */     GIR_RootConstrainSelectedInstOperands,
     /* 171349 */     // GIR_Coverage, 1330,
     /* 171349 */     GIR_EraseRootFromParent_Done,
     /* 171350 */   // Label 3294: @171350
     /* 171350 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(171395), // Rule ID 1331 //
     /* 171355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171384 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 171387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171393 */     GIR_RootConstrainSelectedInstOperands,
     /* 171394 */     // GIR_Coverage, 1331,
     /* 171394 */     GIR_EraseRootFromParent_Done,
     /* 171395 */   // Label 3295: @171395
     /* 171395 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(171440), // Rule ID 1332 //
     /* 171400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171429 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 171432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171438 */     GIR_RootConstrainSelectedInstOperands,
     /* 171439 */     // GIR_Coverage, 1332,
     /* 171439 */     GIR_EraseRootFromParent_Done,
     /* 171440 */   // Label 3296: @171440
     /* 171440 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(171485), // Rule ID 1333 //
     /* 171445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171474 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 171477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171483 */     GIR_RootConstrainSelectedInstOperands,
     /* 171484 */     // GIR_Coverage, 1333,
     /* 171484 */     GIR_EraseRootFromParent_Done,
     /* 171485 */   // Label 3297: @171485
     /* 171485 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(171530), // Rule ID 1334 //
     /* 171490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171519 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 171522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171528 */     GIR_RootConstrainSelectedInstOperands,
     /* 171529 */     // GIR_Coverage, 1334,
     /* 171529 */     GIR_EraseRootFromParent_Done,
     /* 171530 */   // Label 3298: @171530
     /* 171530 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(171575), // Rule ID 1335 //
     /* 171535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171564 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 171567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171573 */     GIR_RootConstrainSelectedInstOperands,
     /* 171574 */     // GIR_Coverage, 1335,
     /* 171574 */     GIR_EraseRootFromParent_Done,
     /* 171575 */   // Label 3299: @171575
     /* 171575 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(171620), // Rule ID 1336 //
     /* 171580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171609 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 171612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171618 */     GIR_RootConstrainSelectedInstOperands,
     /* 171619 */     // GIR_Coverage, 1336,
     /* 171619 */     GIR_EraseRootFromParent_Done,
     /* 171620 */   // Label 3300: @171620
     /* 171620 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171665), // Rule ID 1337 //
     /* 171625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171654 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 171657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171663 */     GIR_RootConstrainSelectedInstOperands,
     /* 171664 */     // GIR_Coverage, 1337,
     /* 171664 */     GIR_EraseRootFromParent_Done,
     /* 171665 */   // Label 3301: @171665
     /* 171665 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171710), // Rule ID 1354 //
     /* 171670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 171678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171699 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 171702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171708 */     GIR_RootConstrainSelectedInstOperands,
     /* 171709 */     // GIR_Coverage, 1354,
     /* 171709 */     GIR_EraseRootFromParent_Done,
     /* 171710 */   // Label 3302: @171710
     /* 171710 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171755), // Rule ID 1355 //
     /* 171715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 171723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171744 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 171747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171753 */     GIR_RootConstrainSelectedInstOperands,
     /* 171754 */     // GIR_Coverage, 1355,
     /* 171754 */     GIR_EraseRootFromParent_Done,
     /* 171755 */   // Label 3303: @171755
     /* 171755 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171800), // Rule ID 1369 //
     /* 171760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171789 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 171792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171798 */     GIR_RootConstrainSelectedInstOperands,
     /* 171799 */     // GIR_Coverage, 1369,
     /* 171799 */     GIR_EraseRootFromParent_Done,
     /* 171800 */   // Label 3304: @171800
     /* 171800 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171845), // Rule ID 1371 //
     /* 171805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171834 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 171837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171843 */     GIR_RootConstrainSelectedInstOperands,
     /* 171844 */     // GIR_Coverage, 1371,
     /* 171844 */     GIR_EraseRootFromParent_Done,
     /* 171845 */   // Label 3305: @171845
     /* 171845 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171890), // Rule ID 1373 //
     /* 171850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171879 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 171882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171888 */     GIR_RootConstrainSelectedInstOperands,
     /* 171889 */     // GIR_Coverage, 1373,
     /* 171889 */     GIR_EraseRootFromParent_Done,
     /* 171890 */   // Label 3306: @171890
     /* 171890 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171935), // Rule ID 1375 //
     /* 171895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171924 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 171927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171933 */     GIR_RootConstrainSelectedInstOperands,
     /* 171934 */     // GIR_Coverage, 1375,
     /* 171934 */     GIR_EraseRootFromParent_Done,
     /* 171935 */   // Label 3307: @171935
     /* 171935 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171980), // Rule ID 1377 //
     /* 171940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171969 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 171972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171978 */     GIR_RootConstrainSelectedInstOperands,
     /* 171979 */     // GIR_Coverage, 1377,
     /* 171979 */     GIR_EraseRootFromParent_Done,
     /* 171980 */   // Label 3308: @171980
     /* 171980 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(172025), // Rule ID 1379 //
     /* 171985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172014 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 172017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172023 */     GIR_RootConstrainSelectedInstOperands,
     /* 172024 */     // GIR_Coverage, 1379,
     /* 172024 */     GIR_EraseRootFromParent_Done,
     /* 172025 */   // Label 3309: @172025
     /* 172025 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(172070), // Rule ID 1386 //
     /* 172030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172059 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 172062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172068 */     GIR_RootConstrainSelectedInstOperands,
     /* 172069 */     // GIR_Coverage, 1386,
     /* 172069 */     GIR_EraseRootFromParent_Done,
     /* 172070 */   // Label 3310: @172070
     /* 172070 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(172115), // Rule ID 1387 //
     /* 172075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172104 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 172107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172113 */     GIR_RootConstrainSelectedInstOperands,
     /* 172114 */     // GIR_Coverage, 1387,
     /* 172114 */     GIR_EraseRootFromParent_Done,
     /* 172115 */   // Label 3311: @172115
     /* 172115 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(172160), // Rule ID 1388 //
     /* 172120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172149 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 172152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172158 */     GIR_RootConstrainSelectedInstOperands,
     /* 172159 */     // GIR_Coverage, 1388,
     /* 172159 */     GIR_EraseRootFromParent_Done,
     /* 172160 */   // Label 3312: @172160
     /* 172160 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(172205), // Rule ID 1389 //
     /* 172165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172194 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 172197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172203 */     GIR_RootConstrainSelectedInstOperands,
     /* 172204 */     // GIR_Coverage, 1389,
     /* 172204 */     GIR_EraseRootFromParent_Done,
     /* 172205 */   // Label 3313: @172205
     /* 172205 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(172250), // Rule ID 1390 //
     /* 172210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172239 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 172242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172248 */     GIR_RootConstrainSelectedInstOperands,
     /* 172249 */     // GIR_Coverage, 1390,
     /* 172249 */     GIR_EraseRootFromParent_Done,
     /* 172250 */   // Label 3314: @172250
     /* 172250 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(172295), // Rule ID 1391 //
     /* 172255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 172263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 172287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172293 */     GIR_RootConstrainSelectedInstOperands,
     /* 172294 */     // GIR_Coverage, 1391,
     /* 172294 */     GIR_EraseRootFromParent_Done,
     /* 172295 */   // Label 3315: @172295
     /* 172295 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(172340), // Rule ID 1392 //
     /* 172300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172329 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 172332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172338 */     GIR_RootConstrainSelectedInstOperands,
     /* 172339 */     // GIR_Coverage, 1392,
     /* 172339 */     GIR_EraseRootFromParent_Done,
     /* 172340 */   // Label 3316: @172340
     /* 172340 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(172385), // Rule ID 1393 //
     /* 172345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172374 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 172377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172383 */     GIR_RootConstrainSelectedInstOperands,
     /* 172384 */     // GIR_Coverage, 1393,
     /* 172384 */     GIR_EraseRootFromParent_Done,
     /* 172385 */   // Label 3317: @172385
     /* 172385 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(172430), // Rule ID 1394 //
     /* 172390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172419 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 172422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172428 */     GIR_RootConstrainSelectedInstOperands,
     /* 172429 */     // GIR_Coverage, 1394,
     /* 172429 */     GIR_EraseRootFromParent_Done,
     /* 172430 */   // Label 3318: @172430
     /* 172430 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(172475), // Rule ID 1395 //
     /* 172435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 172467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172473 */     GIR_RootConstrainSelectedInstOperands,
     /* 172474 */     // GIR_Coverage, 1395,
     /* 172474 */     GIR_EraseRootFromParent_Done,
     /* 172475 */   // Label 3319: @172475
     /* 172475 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(172520), // Rule ID 1396 //
     /* 172480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172509 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 172512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172518 */     GIR_RootConstrainSelectedInstOperands,
     /* 172519 */     // GIR_Coverage, 1396,
     /* 172519 */     GIR_EraseRootFromParent_Done,
     /* 172520 */   // Label 3320: @172520
     /* 172520 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(172565), // Rule ID 1397 //
     /* 172525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172554 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 172557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172563 */     GIR_RootConstrainSelectedInstOperands,
     /* 172564 */     // GIR_Coverage, 1397,
     /* 172564 */     GIR_EraseRootFromParent_Done,
     /* 172565 */   // Label 3321: @172565
     /* 172565 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(172610), // Rule ID 1404 //
     /* 172570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172599 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 172602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172608 */     GIR_RootConstrainSelectedInstOperands,
     /* 172609 */     // GIR_Coverage, 1404,
     /* 172609 */     GIR_EraseRootFromParent_Done,
     /* 172610 */   // Label 3322: @172610
     /* 172610 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172655), // Rule ID 1405 //
     /* 172615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172644 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 172647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172653 */     GIR_RootConstrainSelectedInstOperands,
     /* 172654 */     // GIR_Coverage, 1405,
     /* 172654 */     GIR_EraseRootFromParent_Done,
     /* 172655 */   // Label 3323: @172655
     /* 172655 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172700), // Rule ID 1406 //
     /* 172660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172689 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 172692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172698 */     GIR_RootConstrainSelectedInstOperands,
     /* 172699 */     // GIR_Coverage, 1406,
     /* 172699 */     GIR_EraseRootFromParent_Done,
     /* 172700 */   // Label 3324: @172700
     /* 172700 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172745), // Rule ID 1407 //
     /* 172705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172734 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 172737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172743 */     GIR_RootConstrainSelectedInstOperands,
     /* 172744 */     // GIR_Coverage, 1407,
     /* 172744 */     GIR_EraseRootFromParent_Done,
     /* 172745 */   // Label 3325: @172745
     /* 172745 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172790), // Rule ID 1408 //
     /* 172750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172779 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 172782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172788 */     GIR_RootConstrainSelectedInstOperands,
     /* 172789 */     // GIR_Coverage, 1408,
     /* 172789 */     GIR_EraseRootFromParent_Done,
     /* 172790 */   // Label 3326: @172790
     /* 172790 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172835), // Rule ID 1409 //
     /* 172795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 172827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172833 */     GIR_RootConstrainSelectedInstOperands,
     /* 172834 */     // GIR_Coverage, 1409,
     /* 172834 */     GIR_EraseRootFromParent_Done,
     /* 172835 */   // Label 3327: @172835
     /* 172835 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172880), // Rule ID 1416 //
     /* 172840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172869 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 172872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172878 */     GIR_RootConstrainSelectedInstOperands,
     /* 172879 */     // GIR_Coverage, 1416,
     /* 172879 */     GIR_EraseRootFromParent_Done,
     /* 172880 */   // Label 3328: @172880
     /* 172880 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172925), // Rule ID 1417 //
     /* 172885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172914 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 172917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172923 */     GIR_RootConstrainSelectedInstOperands,
     /* 172924 */     // GIR_Coverage, 1417,
     /* 172924 */     GIR_EraseRootFromParent_Done,
     /* 172925 */   // Label 3329: @172925
     /* 172925 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172970), // Rule ID 1418 //
     /* 172930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172959 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 172962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172968 */     GIR_RootConstrainSelectedInstOperands,
     /* 172969 */     // GIR_Coverage, 1418,
     /* 172969 */     GIR_EraseRootFromParent_Done,
     /* 172970 */   // Label 3330: @172970
     /* 172970 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(173015), // Rule ID 1419 //
     /* 172975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 173007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173013 */     GIR_RootConstrainSelectedInstOperands,
     /* 173014 */     // GIR_Coverage, 1419,
     /* 173014 */     GIR_EraseRootFromParent_Done,
     /* 173015 */   // Label 3331: @173015
     /* 173015 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(173060), // Rule ID 1420 //
     /* 173020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173049 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 173052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173058 */     GIR_RootConstrainSelectedInstOperands,
     /* 173059 */     // GIR_Coverage, 1420,
     /* 173059 */     GIR_EraseRootFromParent_Done,
     /* 173060 */   // Label 3332: @173060
     /* 173060 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(173105), // Rule ID 1421 //
     /* 173065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 173097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173103 */     GIR_RootConstrainSelectedInstOperands,
     /* 173104 */     // GIR_Coverage, 1421,
     /* 173104 */     GIR_EraseRootFromParent_Done,
     /* 173105 */   // Label 3333: @173105
     /* 173105 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(173150), // Rule ID 1422 //
     /* 173110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 173142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173148 */     GIR_RootConstrainSelectedInstOperands,
     /* 173149 */     // GIR_Coverage, 1422,
     /* 173149 */     GIR_EraseRootFromParent_Done,
     /* 173150 */   // Label 3334: @173150
     /* 173150 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(173195), // Rule ID 1423 //
     /* 173155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 173163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173184 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 173187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173193 */     GIR_RootConstrainSelectedInstOperands,
     /* 173194 */     // GIR_Coverage, 1423,
     /* 173194 */     GIR_EraseRootFromParent_Done,
     /* 173195 */   // Label 3335: @173195
     /* 173195 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(173240), // Rule ID 1424 //
     /* 173200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 173208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173229 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 173232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173238 */     GIR_RootConstrainSelectedInstOperands,
     /* 173239 */     // GIR_Coverage, 1424,
     /* 173239 */     GIR_EraseRootFromParent_Done,
     /* 173240 */   // Label 3336: @173240
     /* 173240 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(173285), // Rule ID 1425 //
     /* 173245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 173253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173274 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 173277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173283 */     GIR_RootConstrainSelectedInstOperands,
     /* 173284 */     // GIR_Coverage, 1425,
     /* 173284 */     GIR_EraseRootFromParent_Done,
     /* 173285 */   // Label 3337: @173285
     /* 173285 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(173330), // Rule ID 1426 //
     /* 173290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 173298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 173322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173328 */     GIR_RootConstrainSelectedInstOperands,
     /* 173329 */     // GIR_Coverage, 1426,
     /* 173329 */     GIR_EraseRootFromParent_Done,
     /* 173330 */   // Label 3338: @173330
     /* 173330 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(173375), // Rule ID 1427 //
     /* 173335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173364 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 173367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173373 */     GIR_RootConstrainSelectedInstOperands,
     /* 173374 */     // GIR_Coverage, 1427,
     /* 173374 */     GIR_EraseRootFromParent_Done,
     /* 173375 */   // Label 3339: @173375
     /* 173375 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(173420), // Rule ID 1428 //
     /* 173380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173409 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 173412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173418 */     GIR_RootConstrainSelectedInstOperands,
     /* 173419 */     // GIR_Coverage, 1428,
     /* 173419 */     GIR_EraseRootFromParent_Done,
     /* 173420 */   // Label 3340: @173420
     /* 173420 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(173465), // Rule ID 1429 //
     /* 173425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173454 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 173457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173463 */     GIR_RootConstrainSelectedInstOperands,
     /* 173464 */     // GIR_Coverage, 1429,
     /* 173464 */     GIR_EraseRootFromParent_Done,
     /* 173465 */   // Label 3341: @173465
     /* 173465 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(173510), // Rule ID 1430 //
     /* 173470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173499 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 173502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173508 */     GIR_RootConstrainSelectedInstOperands,
     /* 173509 */     // GIR_Coverage, 1430,
     /* 173509 */     GIR_EraseRootFromParent_Done,
     /* 173510 */   // Label 3342: @173510
     /* 173510 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(173555), // Rule ID 1431 //
     /* 173515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173544 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 173547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173553 */     GIR_RootConstrainSelectedInstOperands,
     /* 173554 */     // GIR_Coverage, 1431,
     /* 173554 */     GIR_EraseRootFromParent_Done,
     /* 173555 */   // Label 3343: @173555
     /* 173555 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(173600), // Rule ID 1432 //
     /* 173560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173589 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 173592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173598 */     GIR_RootConstrainSelectedInstOperands,
     /* 173599 */     // GIR_Coverage, 1432,
     /* 173599 */     GIR_EraseRootFromParent_Done,
     /* 173600 */   // Label 3344: @173600
     /* 173600 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173645), // Rule ID 1433 //
     /* 173605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173634 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 173637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173643 */     GIR_RootConstrainSelectedInstOperands,
     /* 173644 */     // GIR_Coverage, 1433,
     /* 173644 */     GIR_EraseRootFromParent_Done,
     /* 173645 */   // Label 3345: @173645
     /* 173645 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173690), // Rule ID 1434 //
     /* 173650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173679 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 173682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173688 */     GIR_RootConstrainSelectedInstOperands,
     /* 173689 */     // GIR_Coverage, 1434,
     /* 173689 */     GIR_EraseRootFromParent_Done,
     /* 173690 */   // Label 3346: @173690
     /* 173690 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173735), // Rule ID 1435 //
     /* 173695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173724 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 173727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173733 */     GIR_RootConstrainSelectedInstOperands,
     /* 173734 */     // GIR_Coverage, 1435,
     /* 173734 */     GIR_EraseRootFromParent_Done,
     /* 173735 */   // Label 3347: @173735
     /* 173735 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173780), // Rule ID 1436 //
     /* 173740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 173772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173778 */     GIR_RootConstrainSelectedInstOperands,
     /* 173779 */     // GIR_Coverage, 1436,
     /* 173779 */     GIR_EraseRootFromParent_Done,
     /* 173780 */   // Label 3348: @173780
     /* 173780 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173825), // Rule ID 1437 //
     /* 173785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 173817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173823 */     GIR_RootConstrainSelectedInstOperands,
     /* 173824 */     // GIR_Coverage, 1437,
     /* 173824 */     GIR_EraseRootFromParent_Done,
     /* 173825 */   // Label 3349: @173825
     /* 173825 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173870), // Rule ID 1438 //
     /* 173830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173859 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 173862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173868 */     GIR_RootConstrainSelectedInstOperands,
     /* 173869 */     // GIR_Coverage, 1438,
     /* 173869 */     GIR_EraseRootFromParent_Done,
     /* 173870 */   // Label 3350: @173870
     /* 173870 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173915), // Rule ID 1439 //
     /* 173875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173904 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 173907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173913 */     GIR_RootConstrainSelectedInstOperands,
     /* 173914 */     // GIR_Coverage, 1439,
     /* 173914 */     GIR_EraseRootFromParent_Done,
     /* 173915 */   // Label 3351: @173915
     /* 173915 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173960), // Rule ID 1440 //
     /* 173920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173949 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 173952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173958 */     GIR_RootConstrainSelectedInstOperands,
     /* 173959 */     // GIR_Coverage, 1440,
     /* 173959 */     GIR_EraseRootFromParent_Done,
     /* 173960 */   // Label 3352: @173960
     /* 173960 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(174005), // Rule ID 1441 //
     /* 173965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173994 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 173997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174003 */     GIR_RootConstrainSelectedInstOperands,
     /* 174004 */     // GIR_Coverage, 1441,
     /* 174004 */     GIR_EraseRootFromParent_Done,
     /* 174005 */   // Label 3353: @174005
     /* 174005 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(174050), // Rule ID 1442 //
     /* 174010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 174018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174039 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 174042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174048 */     GIR_RootConstrainSelectedInstOperands,
     /* 174049 */     // GIR_Coverage, 1442,
     /* 174049 */     GIR_EraseRootFromParent_Done,
     /* 174050 */   // Label 3354: @174050
     /* 174050 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(174095), // Rule ID 1443 //
     /* 174055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 174063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 174087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174093 */     GIR_RootConstrainSelectedInstOperands,
     /* 174094 */     // GIR_Coverage, 1443,
     /* 174094 */     GIR_EraseRootFromParent_Done,
     /* 174095 */   // Label 3355: @174095
     /* 174095 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(174140), // Rule ID 1444 //
     /* 174100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 174108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174129 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 174132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174138 */     GIR_RootConstrainSelectedInstOperands,
     /* 174139 */     // GIR_Coverage, 1444,
     /* 174139 */     GIR_EraseRootFromParent_Done,
     /* 174140 */   // Label 3356: @174140
     /* 174140 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(174185), // Rule ID 1445 //
     /* 174145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174174 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 174177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174183 */     GIR_RootConstrainSelectedInstOperands,
     /* 174184 */     // GIR_Coverage, 1445,
     /* 174184 */     GIR_EraseRootFromParent_Done,
     /* 174185 */   // Label 3357: @174185
     /* 174185 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(174230), // Rule ID 1446 //
     /* 174190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174219 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 174222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174228 */     GIR_RootConstrainSelectedInstOperands,
     /* 174229 */     // GIR_Coverage, 1446,
     /* 174229 */     GIR_EraseRootFromParent_Done,
     /* 174230 */   // Label 3358: @174230
     /* 174230 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(174275), // Rule ID 1447 //
     /* 174235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 174267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174273 */     GIR_RootConstrainSelectedInstOperands,
     /* 174274 */     // GIR_Coverage, 1447,
     /* 174274 */     GIR_EraseRootFromParent_Done,
     /* 174275 */   // Label 3359: @174275
     /* 174275 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(174320), // Rule ID 1448 //
     /* 174280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174309 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 174312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174318 */     GIR_RootConstrainSelectedInstOperands,
     /* 174319 */     // GIR_Coverage, 1448,
     /* 174319 */     GIR_EraseRootFromParent_Done,
     /* 174320 */   // Label 3360: @174320
     /* 174320 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(174365), // Rule ID 1449 //
     /* 174325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174354 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 174357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174363 */     GIR_RootConstrainSelectedInstOperands,
     /* 174364 */     // GIR_Coverage, 1449,
     /* 174364 */     GIR_EraseRootFromParent_Done,
     /* 174365 */   // Label 3361: @174365
     /* 174365 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(174410), // Rule ID 1450 //
     /* 174370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174399 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 174402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174408 */     GIR_RootConstrainSelectedInstOperands,
     /* 174409 */     // GIR_Coverage, 1450,
     /* 174409 */     GIR_EraseRootFromParent_Done,
     /* 174410 */   // Label 3362: @174410
     /* 174410 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(174455), // Rule ID 1451 //
     /* 174415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 174447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174453 */     GIR_RootConstrainSelectedInstOperands,
     /* 174454 */     // GIR_Coverage, 1451,
     /* 174454 */     GIR_EraseRootFromParent_Done,
     /* 174455 */   // Label 3363: @174455
     /* 174455 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(174500), // Rule ID 1458 //
     /* 174460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174489 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 174492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174498 */     GIR_RootConstrainSelectedInstOperands,
     /* 174499 */     // GIR_Coverage, 1458,
     /* 174499 */     GIR_EraseRootFromParent_Done,
     /* 174500 */   // Label 3364: @174500
     /* 174500 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(174545), // Rule ID 1459 //
     /* 174505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174534 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 174537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174543 */     GIR_RootConstrainSelectedInstOperands,
     /* 174544 */     // GIR_Coverage, 1459,
     /* 174544 */     GIR_EraseRootFromParent_Done,
     /* 174545 */   // Label 3365: @174545
     /* 174545 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174590), // Rule ID 1460 //
     /* 174550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174579 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 174582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174588 */     GIR_RootConstrainSelectedInstOperands,
     /* 174589 */     // GIR_Coverage, 1460,
     /* 174589 */     GIR_EraseRootFromParent_Done,
     /* 174590 */   // Label 3366: @174590
     /* 174590 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(174635), // Rule ID 1461 //
     /* 174595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174624 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 174627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174633 */     GIR_RootConstrainSelectedInstOperands,
     /* 174634 */     // GIR_Coverage, 1461,
     /* 174634 */     GIR_EraseRootFromParent_Done,
     /* 174635 */   // Label 3367: @174635
     /* 174635 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174680), // Rule ID 1462 //
     /* 174640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174669 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 174672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174678 */     GIR_RootConstrainSelectedInstOperands,
     /* 174679 */     // GIR_Coverage, 1462,
     /* 174679 */     GIR_EraseRootFromParent_Done,
     /* 174680 */   // Label 3368: @174680
     /* 174680 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174725), // Rule ID 1463 //
     /* 174685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174714 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 174717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174723 */     GIR_RootConstrainSelectedInstOperands,
     /* 174724 */     // GIR_Coverage, 1463,
     /* 174724 */     GIR_EraseRootFromParent_Done,
     /* 174725 */   // Label 3369: @174725
     /* 174725 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174770), // Rule ID 1464 //
     /* 174730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174759 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 174762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174768 */     GIR_RootConstrainSelectedInstOperands,
     /* 174769 */     // GIR_Coverage, 1464,
     /* 174769 */     GIR_EraseRootFromParent_Done,
     /* 174770 */   // Label 3370: @174770
     /* 174770 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174815), // Rule ID 1465 //
     /* 174775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174804 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 174807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174813 */     GIR_RootConstrainSelectedInstOperands,
     /* 174814 */     // GIR_Coverage, 1465,
     /* 174814 */     GIR_EraseRootFromParent_Done,
     /* 174815 */   // Label 3371: @174815
     /* 174815 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174860), // Rule ID 1466 //
     /* 174820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174849 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 174852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174858 */     GIR_RootConstrainSelectedInstOperands,
     /* 174859 */     // GIR_Coverage, 1466,
     /* 174859 */     GIR_EraseRootFromParent_Done,
     /* 174860 */   // Label 3372: @174860
     /* 174860 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174905), // Rule ID 1467 //
     /* 174865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174894 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 174897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174903 */     GIR_RootConstrainSelectedInstOperands,
     /* 174904 */     // GIR_Coverage, 1467,
     /* 174904 */     GIR_EraseRootFromParent_Done,
     /* 174905 */   // Label 3373: @174905
     /* 174905 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174950), // Rule ID 1468 //
     /* 174910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174939 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 174942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174948 */     GIR_RootConstrainSelectedInstOperands,
     /* 174949 */     // GIR_Coverage, 1468,
     /* 174949 */     GIR_EraseRootFromParent_Done,
     /* 174950 */   // Label 3374: @174950
     /* 174950 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174995), // Rule ID 1469 //
     /* 174955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174984 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 174987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174993 */     GIR_RootConstrainSelectedInstOperands,
     /* 174994 */     // GIR_Coverage, 1469,
     /* 174994 */     GIR_EraseRootFromParent_Done,
     /* 174995 */   // Label 3375: @174995
     /* 174995 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(175040), // Rule ID 1470 //
     /* 175000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 175008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175029 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 175032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175038 */     GIR_RootConstrainSelectedInstOperands,
     /* 175039 */     // GIR_Coverage, 1470,
     /* 175039 */     GIR_EraseRootFromParent_Done,
     /* 175040 */   // Label 3376: @175040
     /* 175040 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(175085), // Rule ID 1471 //
     /* 175045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 175053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175074 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 175077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175083 */     GIR_RootConstrainSelectedInstOperands,
     /* 175084 */     // GIR_Coverage, 1471,
     /* 175084 */     GIR_EraseRootFromParent_Done,
     /* 175085 */   // Label 3377: @175085
     /* 175085 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(175130), // Rule ID 1492 //
     /* 175090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175119 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 175122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175128 */     GIR_RootConstrainSelectedInstOperands,
     /* 175129 */     // GIR_Coverage, 1492,
     /* 175129 */     GIR_EraseRootFromParent_Done,
     /* 175130 */   // Label 3378: @175130
     /* 175130 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(175175), // Rule ID 1494 //
     /* 175135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175164 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 175167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175173 */     GIR_RootConstrainSelectedInstOperands,
     /* 175174 */     // GIR_Coverage, 1494,
     /* 175174 */     GIR_EraseRootFromParent_Done,
     /* 175175 */   // Label 3379: @175175
     /* 175175 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(175220), // Rule ID 1496 //
     /* 175180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175209 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 175212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175218 */     GIR_RootConstrainSelectedInstOperands,
     /* 175219 */     // GIR_Coverage, 1496,
     /* 175219 */     GIR_EraseRootFromParent_Done,
     /* 175220 */   // Label 3380: @175220
     /* 175220 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(175265), // Rule ID 1498 //
     /* 175225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175254 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 175257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175263 */     GIR_RootConstrainSelectedInstOperands,
     /* 175264 */     // GIR_Coverage, 1498,
     /* 175264 */     GIR_EraseRootFromParent_Done,
     /* 175265 */   // Label 3381: @175265
     /* 175265 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(175310), // Rule ID 1500 //
     /* 175270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175299 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 175302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175308 */     GIR_RootConstrainSelectedInstOperands,
     /* 175309 */     // GIR_Coverage, 1500,
     /* 175309 */     GIR_EraseRootFromParent_Done,
     /* 175310 */   // Label 3382: @175310
     /* 175310 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(175355), // Rule ID 1502 //
     /* 175315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 175323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 175347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175353 */     GIR_RootConstrainSelectedInstOperands,
     /* 175354 */     // GIR_Coverage, 1502,
     /* 175354 */     GIR_EraseRootFromParent_Done,
     /* 175355 */   // Label 3383: @175355
     /* 175355 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(175400), // Rule ID 1509 //
     /* 175360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175389 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 175392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175398 */     GIR_RootConstrainSelectedInstOperands,
     /* 175399 */     // GIR_Coverage, 1509,
     /* 175399 */     GIR_EraseRootFromParent_Done,
     /* 175400 */   // Label 3384: @175400
     /* 175400 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(175445), // Rule ID 1510 //
     /* 175405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175434 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 175437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175443 */     GIR_RootConstrainSelectedInstOperands,
     /* 175444 */     // GIR_Coverage, 1510,
     /* 175444 */     GIR_EraseRootFromParent_Done,
     /* 175445 */   // Label 3385: @175445
     /* 175445 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(175490), // Rule ID 1511 //
     /* 175450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175479 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 175482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175488 */     GIR_RootConstrainSelectedInstOperands,
     /* 175489 */     // GIR_Coverage, 1511,
     /* 175489 */     GIR_EraseRootFromParent_Done,
     /* 175490 */   // Label 3386: @175490
     /* 175490 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(175535), // Rule ID 1512 //
     /* 175495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 175527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175533 */     GIR_RootConstrainSelectedInstOperands,
     /* 175534 */     // GIR_Coverage, 1512,
     /* 175534 */     GIR_EraseRootFromParent_Done,
     /* 175535 */   // Label 3387: @175535
     /* 175535 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175580), // Rule ID 1513 //
     /* 175540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175569 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 175572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175578 */     GIR_RootConstrainSelectedInstOperands,
     /* 175579 */     // GIR_Coverage, 1513,
     /* 175579 */     GIR_EraseRootFromParent_Done,
     /* 175580 */   // Label 3388: @175580
     /* 175580 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175625), // Rule ID 1514 //
     /* 175585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175614 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 175617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175623 */     GIR_RootConstrainSelectedInstOperands,
     /* 175624 */     // GIR_Coverage, 1514,
     /* 175624 */     GIR_EraseRootFromParent_Done,
     /* 175625 */   // Label 3389: @175625
     /* 175625 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175670), // Rule ID 1515 //
     /* 175630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175659 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 175662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175668 */     GIR_RootConstrainSelectedInstOperands,
     /* 175669 */     // GIR_Coverage, 1515,
     /* 175669 */     GIR_EraseRootFromParent_Done,
     /* 175670 */   // Label 3390: @175670
     /* 175670 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175715), // Rule ID 1516 //
     /* 175675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175704 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 175707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175713 */     GIR_RootConstrainSelectedInstOperands,
     /* 175714 */     // GIR_Coverage, 1516,
     /* 175714 */     GIR_EraseRootFromParent_Done,
     /* 175715 */   // Label 3391: @175715
     /* 175715 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175760), // Rule ID 1517 //
     /* 175720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175749 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 175752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175758 */     GIR_RootConstrainSelectedInstOperands,
     /* 175759 */     // GIR_Coverage, 1517,
     /* 175759 */     GIR_EraseRootFromParent_Done,
     /* 175760 */   // Label 3392: @175760
     /* 175760 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175805), // Rule ID 1518 //
     /* 175765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175794 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 175797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175803 */     GIR_RootConstrainSelectedInstOperands,
     /* 175804 */     // GIR_Coverage, 1518,
     /* 175804 */     GIR_EraseRootFromParent_Done,
     /* 175805 */   // Label 3393: @175805
     /* 175805 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175850), // Rule ID 1519 //
     /* 175810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175839 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 175842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175848 */     GIR_RootConstrainSelectedInstOperands,
     /* 175849 */     // GIR_Coverage, 1519,
     /* 175849 */     GIR_EraseRootFromParent_Done,
     /* 175850 */   // Label 3394: @175850
     /* 175850 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175895), // Rule ID 1520 //
     /* 175855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175884 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 175887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175893 */     GIR_RootConstrainSelectedInstOperands,
     /* 175894 */     // GIR_Coverage, 1520,
     /* 175894 */     GIR_EraseRootFromParent_Done,
     /* 175895 */   // Label 3395: @175895
     /* 175895 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175940), // Rule ID 1527 //
     /* 175900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175929 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 175932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175938 */     GIR_RootConstrainSelectedInstOperands,
     /* 175939 */     // GIR_Coverage, 1527,
     /* 175939 */     GIR_EraseRootFromParent_Done,
     /* 175940 */   // Label 3396: @175940
     /* 175940 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175985), // Rule ID 1528 //
     /* 175945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175974 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 175977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175983 */     GIR_RootConstrainSelectedInstOperands,
     /* 175984 */     // GIR_Coverage, 1528,
     /* 175984 */     GIR_EraseRootFromParent_Done,
     /* 175985 */   // Label 3397: @175985
     /* 175985 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(176030), // Rule ID 1529 //
     /* 175990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176019 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 176022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176028 */     GIR_RootConstrainSelectedInstOperands,
     /* 176029 */     // GIR_Coverage, 1529,
     /* 176029 */     GIR_EraseRootFromParent_Done,
     /* 176030 */   // Label 3398: @176030
     /* 176030 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(176075), // Rule ID 1530 //
     /* 176035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 176043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 176067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176073 */     GIR_RootConstrainSelectedInstOperands,
     /* 176074 */     // GIR_Coverage, 1530,
     /* 176074 */     GIR_EraseRootFromParent_Done,
     /* 176075 */   // Label 3399: @176075
     /* 176075 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(176120), // Rule ID 1531 //
     /* 176080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 176088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176109 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 176112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176118 */     GIR_RootConstrainSelectedInstOperands,
     /* 176119 */     // GIR_Coverage, 1531,
     /* 176119 */     GIR_EraseRootFromParent_Done,
     /* 176120 */   // Label 3400: @176120
     /* 176120 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(176165), // Rule ID 1532 //
     /* 176125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 176133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176154 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 176157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176163 */     GIR_RootConstrainSelectedInstOperands,
     /* 176164 */     // GIR_Coverage, 1532,
     /* 176164 */     GIR_EraseRootFromParent_Done,
     /* 176165 */   // Label 3401: @176165
     /* 176165 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(176210), // Rule ID 1539 //
     /* 176170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176199 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 176202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176208 */     GIR_RootConstrainSelectedInstOperands,
     /* 176209 */     // GIR_Coverage, 1539,
     /* 176209 */     GIR_EraseRootFromParent_Done,
     /* 176210 */   // Label 3402: @176210
     /* 176210 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(176255), // Rule ID 1540 //
     /* 176215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176244 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 176247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176253 */     GIR_RootConstrainSelectedInstOperands,
     /* 176254 */     // GIR_Coverage, 1540,
     /* 176254 */     GIR_EraseRootFromParent_Done,
     /* 176255 */   // Label 3403: @176255
     /* 176255 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(176300), // Rule ID 1541 //
     /* 176260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176289 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 176292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176298 */     GIR_RootConstrainSelectedInstOperands,
     /* 176299 */     // GIR_Coverage, 1541,
     /* 176299 */     GIR_EraseRootFromParent_Done,
     /* 176300 */   // Label 3404: @176300
     /* 176300 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(176345), // Rule ID 1542 //
     /* 176305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176334 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 176337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176343 */     GIR_RootConstrainSelectedInstOperands,
     /* 176344 */     // GIR_Coverage, 1542,
     /* 176344 */     GIR_EraseRootFromParent_Done,
     /* 176345 */   // Label 3405: @176345
     /* 176345 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(176390), // Rule ID 1543 //
     /* 176350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176379 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 176382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176388 */     GIR_RootConstrainSelectedInstOperands,
     /* 176389 */     // GIR_Coverage, 1543,
     /* 176389 */     GIR_EraseRootFromParent_Done,
     /* 176390 */   // Label 3406: @176390
     /* 176390 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(176435), // Rule ID 1544 //
     /* 176395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 176427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176433 */     GIR_RootConstrainSelectedInstOperands,
     /* 176434 */     // GIR_Coverage, 1544,
     /* 176434 */     GIR_EraseRootFromParent_Done,
     /* 176435 */   // Label 3407: @176435
     /* 176435 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176480), // Rule ID 1545 //
     /* 176440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176469 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 176472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176478 */     GIR_RootConstrainSelectedInstOperands,
     /* 176479 */     // GIR_Coverage, 1545,
     /* 176479 */     GIR_EraseRootFromParent_Done,
     /* 176480 */   // Label 3408: @176480
     /* 176480 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176525), // Rule ID 1546 //
     /* 176485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176514 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 176517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176523 */     GIR_RootConstrainSelectedInstOperands,
     /* 176524 */     // GIR_Coverage, 1546,
     /* 176524 */     GIR_EraseRootFromParent_Done,
     /* 176525 */   // Label 3409: @176525
     /* 176525 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176570), // Rule ID 1547 //
     /* 176530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 176562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176568 */     GIR_RootConstrainSelectedInstOperands,
     /* 176569 */     // GIR_Coverage, 1547,
     /* 176569 */     GIR_EraseRootFromParent_Done,
     /* 176570 */   // Label 3410: @176570
     /* 176570 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176615), // Rule ID 1548 //
     /* 176575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 176607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176613 */     GIR_RootConstrainSelectedInstOperands,
     /* 176614 */     // GIR_Coverage, 1548,
     /* 176614 */     GIR_EraseRootFromParent_Done,
     /* 176615 */   // Label 3411: @176615
     /* 176615 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176660), // Rule ID 1549 //
     /* 176620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176649 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 176652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176658 */     GIR_RootConstrainSelectedInstOperands,
     /* 176659 */     // GIR_Coverage, 1549,
     /* 176659 */     GIR_EraseRootFromParent_Done,
     /* 176660 */   // Label 3412: @176660
     /* 176660 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176705), // Rule ID 1550 //
     /* 176665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176694 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 176697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176703 */     GIR_RootConstrainSelectedInstOperands,
     /* 176704 */     // GIR_Coverage, 1550,
     /* 176704 */     GIR_EraseRootFromParent_Done,
     /* 176705 */   // Label 3413: @176705
     /* 176705 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176750), // Rule ID 1551 //
     /* 176710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 176742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176748 */     GIR_RootConstrainSelectedInstOperands,
     /* 176749 */     // GIR_Coverage, 1551,
     /* 176749 */     GIR_EraseRootFromParent_Done,
     /* 176750 */   // Label 3414: @176750
     /* 176750 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176795), // Rule ID 1552 //
     /* 176755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 176787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176793 */     GIR_RootConstrainSelectedInstOperands,
     /* 176794 */     // GIR_Coverage, 1552,
     /* 176794 */     GIR_EraseRootFromParent_Done,
     /* 176795 */   // Label 3415: @176795
     /* 176795 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176840), // Rule ID 1553 //
     /* 176800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176829 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 176832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176838 */     GIR_RootConstrainSelectedInstOperands,
     /* 176839 */     // GIR_Coverage, 1553,
     /* 176839 */     GIR_EraseRootFromParent_Done,
     /* 176840 */   // Label 3416: @176840
     /* 176840 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176885), // Rule ID 1554 //
     /* 176845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176874 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 176877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176883 */     GIR_RootConstrainSelectedInstOperands,
     /* 176884 */     // GIR_Coverage, 1554,
     /* 176884 */     GIR_EraseRootFromParent_Done,
     /* 176885 */   // Label 3417: @176885
     /* 176885 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176930), // Rule ID 1555 //
     /* 176890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176919 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 176922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176928 */     GIR_RootConstrainSelectedInstOperands,
     /* 176929 */     // GIR_Coverage, 1555,
     /* 176929 */     GIR_EraseRootFromParent_Done,
     /* 176930 */   // Label 3418: @176930
     /* 176930 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176975), // Rule ID 1556 //
     /* 176935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 176967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176973 */     GIR_RootConstrainSelectedInstOperands,
     /* 176974 */     // GIR_Coverage, 1556,
     /* 176974 */     GIR_EraseRootFromParent_Done,
     /* 176975 */   // Label 3419: @176975
     /* 176975 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(177020), // Rule ID 1557 //
     /* 176980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177009 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 177012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177018 */     GIR_RootConstrainSelectedInstOperands,
     /* 177019 */     // GIR_Coverage, 1557,
     /* 177019 */     GIR_EraseRootFromParent_Done,
     /* 177020 */   // Label 3420: @177020
     /* 177020 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(177065), // Rule ID 1558 //
     /* 177025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 177033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 177057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177063 */     GIR_RootConstrainSelectedInstOperands,
     /* 177064 */     // GIR_Coverage, 1558,
     /* 177064 */     GIR_EraseRootFromParent_Done,
     /* 177065 */   // Label 3421: @177065
     /* 177065 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(177110), // Rule ID 1559 //
     /* 177070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 177078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177099 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 177102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177108 */     GIR_RootConstrainSelectedInstOperands,
     /* 177109 */     // GIR_Coverage, 1559,
     /* 177109 */     GIR_EraseRootFromParent_Done,
     /* 177110 */   // Label 3422: @177110
     /* 177110 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(177155), // Rule ID 1560 //
     /* 177115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177144 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 177147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177153 */     GIR_RootConstrainSelectedInstOperands,
     /* 177154 */     // GIR_Coverage, 1560,
     /* 177154 */     GIR_EraseRootFromParent_Done,
     /* 177155 */   // Label 3423: @177155
     /* 177155 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(177200), // Rule ID 1561 //
     /* 177160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177189 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 177192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177198 */     GIR_RootConstrainSelectedInstOperands,
     /* 177199 */     // GIR_Coverage, 1561,
     /* 177199 */     GIR_EraseRootFromParent_Done,
     /* 177200 */   // Label 3424: @177200
     /* 177200 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(177245), // Rule ID 1562 //
     /* 177205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177234 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 177237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177243 */     GIR_RootConstrainSelectedInstOperands,
     /* 177244 */     // GIR_Coverage, 1562,
     /* 177244 */     GIR_EraseRootFromParent_Done,
     /* 177245 */   // Label 3425: @177245
     /* 177245 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(177290), // Rule ID 1563 //
     /* 177250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 177282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177288 */     GIR_RootConstrainSelectedInstOperands,
     /* 177289 */     // GIR_Coverage, 1563,
     /* 177289 */     GIR_EraseRootFromParent_Done,
     /* 177290 */   // Label 3426: @177290
     /* 177290 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(177335), // Rule ID 1564 //
     /* 177295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177324 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 177327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177333 */     GIR_RootConstrainSelectedInstOperands,
     /* 177334 */     // GIR_Coverage, 1564,
     /* 177334 */     GIR_EraseRootFromParent_Done,
     /* 177335 */   // Label 3427: @177335
     /* 177335 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(177380), // Rule ID 1565 //
     /* 177340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 177372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177378 */     GIR_RootConstrainSelectedInstOperands,
     /* 177379 */     // GIR_Coverage, 1565,
     /* 177379 */     GIR_EraseRootFromParent_Done,
     /* 177380 */   // Label 3428: @177380
     /* 177380 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(177425), // Rule ID 1566 //
     /* 177385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177414 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 177417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177423 */     GIR_RootConstrainSelectedInstOperands,
     /* 177424 */     // GIR_Coverage, 1566,
     /* 177424 */     GIR_EraseRootFromParent_Done,
     /* 177425 */   // Label 3429: @177425
     /* 177425 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(177470), // Rule ID 1573 //
     /* 177430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177459 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 177462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177468 */     GIR_RootConstrainSelectedInstOperands,
     /* 177469 */     // GIR_Coverage, 1573,
     /* 177469 */     GIR_EraseRootFromParent_Done,
     /* 177470 */   // Label 3430: @177470
     /* 177470 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(177515), // Rule ID 1574 //
     /* 177475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177504 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 177507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177513 */     GIR_RootConstrainSelectedInstOperands,
     /* 177514 */     // GIR_Coverage, 1574,
     /* 177514 */     GIR_EraseRootFromParent_Done,
     /* 177515 */   // Label 3431: @177515
     /* 177515 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(177560), // Rule ID 1575 //
     /* 177520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177549 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 177552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177558 */     GIR_RootConstrainSelectedInstOperands,
     /* 177559 */     // GIR_Coverage, 1575,
     /* 177559 */     GIR_EraseRootFromParent_Done,
     /* 177560 */   // Label 3432: @177560
     /* 177560 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(177605), // Rule ID 1576 //
     /* 177565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177594 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 177597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177603 */     GIR_RootConstrainSelectedInstOperands,
     /* 177604 */     // GIR_Coverage, 1576,
     /* 177604 */     GIR_EraseRootFromParent_Done,
     /* 177605 */   // Label 3433: @177605
     /* 177605 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177650), // Rule ID 1577 //
     /* 177610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177639 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 177642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177648 */     GIR_RootConstrainSelectedInstOperands,
     /* 177649 */     // GIR_Coverage, 1577,
     /* 177649 */     GIR_EraseRootFromParent_Done,
     /* 177650 */   // Label 3434: @177650
     /* 177650 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177695), // Rule ID 1578 //
     /* 177655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177684 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 177687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177693 */     GIR_RootConstrainSelectedInstOperands,
     /* 177694 */     // GIR_Coverage, 1578,
     /* 177694 */     GIR_EraseRootFromParent_Done,
     /* 177695 */   // Label 3435: @177695
     /* 177695 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177740), // Rule ID 1579 //
     /* 177700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177729 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 177732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177738 */     GIR_RootConstrainSelectedInstOperands,
     /* 177739 */     // GIR_Coverage, 1579,
     /* 177739 */     GIR_EraseRootFromParent_Done,
     /* 177740 */   // Label 3436: @177740
     /* 177740 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177785), // Rule ID 1580 //
     /* 177745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177774 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 177777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177783 */     GIR_RootConstrainSelectedInstOperands,
     /* 177784 */     // GIR_Coverage, 1580,
     /* 177784 */     GIR_EraseRootFromParent_Done,
     /* 177785 */   // Label 3437: @177785
     /* 177785 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177830), // Rule ID 1581 //
     /* 177790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177819 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 177822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177828 */     GIR_RootConstrainSelectedInstOperands,
     /* 177829 */     // GIR_Coverage, 1581,
     /* 177829 */     GIR_EraseRootFromParent_Done,
     /* 177830 */   // Label 3438: @177830
     /* 177830 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177875), // Rule ID 1582 //
     /* 177835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177864 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 177867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177873 */     GIR_RootConstrainSelectedInstOperands,
     /* 177874 */     // GIR_Coverage, 1582,
     /* 177874 */     GIR_EraseRootFromParent_Done,
     /* 177875 */   // Label 3439: @177875
     /* 177875 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177920), // Rule ID 1583 //
     /* 177880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177909 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 177912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177918 */     GIR_RootConstrainSelectedInstOperands,
     /* 177919 */     // GIR_Coverage, 1583,
     /* 177919 */     GIR_EraseRootFromParent_Done,
     /* 177920 */   // Label 3440: @177920
     /* 177920 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177965), // Rule ID 1584 //
     /* 177925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177954 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 177957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177963 */     GIR_RootConstrainSelectedInstOperands,
     /* 177964 */     // GIR_Coverage, 1584,
     /* 177964 */     GIR_EraseRootFromParent_Done,
     /* 177965 */   // Label 3441: @177965
     /* 177965 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(178010), // Rule ID 1585 //
     /* 177970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 178002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178008 */     GIR_RootConstrainSelectedInstOperands,
     /* 178009 */     // GIR_Coverage, 1585,
     /* 178009 */     GIR_EraseRootFromParent_Done,
     /* 178010 */   // Label 3442: @178010
     /* 178010 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(178055), // Rule ID 1586 //
     /* 178015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 178023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 178047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178053 */     GIR_RootConstrainSelectedInstOperands,
     /* 178054 */     // GIR_Coverage, 1586,
     /* 178054 */     GIR_EraseRootFromParent_Done,
     /* 178055 */   // Label 3443: @178055
     /* 178055 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(178100), // Rule ID 1614 //
     /* 178060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 178068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178089 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 178092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178098 */     GIR_RootConstrainSelectedInstOperands,
     /* 178099 */     // GIR_Coverage, 1614,
     /* 178099 */     GIR_EraseRootFromParent_Done,
     /* 178100 */   // Label 3444: @178100
     /* 178100 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(178145), // Rule ID 1615 //
     /* 178105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 178113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178134 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 178137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178143 */     GIR_RootConstrainSelectedInstOperands,
     /* 178144 */     // GIR_Coverage, 1615,
     /* 178144 */     GIR_EraseRootFromParent_Done,
     /* 178145 */   // Label 3445: @178145
     /* 178145 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(178190), // Rule ID 1616 //
     /* 178150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 178158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178179 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 178182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178188 */     GIR_RootConstrainSelectedInstOperands,
     /* 178189 */     // GIR_Coverage, 1616,
     /* 178189 */     GIR_EraseRootFromParent_Done,
     /* 178190 */   // Label 3446: @178190
     /* 178190 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(178235), // Rule ID 1617 //
     /* 178195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 178203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178224 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 178227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178233 */     GIR_RootConstrainSelectedInstOperands,
     /* 178234 */     // GIR_Coverage, 1617,
     /* 178234 */     GIR_EraseRootFromParent_Done,
     /* 178235 */   // Label 3447: @178235
     /* 178235 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(178280), // Rule ID 1618 //
     /* 178240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 178248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178269 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 178272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178278 */     GIR_RootConstrainSelectedInstOperands,
     /* 178279 */     // GIR_Coverage, 1618,
     /* 178279 */     GIR_EraseRootFromParent_Done,
     /* 178280 */   // Label 3448: @178280
     /* 178280 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(178325), // Rule ID 1619 //
     /* 178285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 178293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178314 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 178317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178323 */     GIR_RootConstrainSelectedInstOperands,
     /* 178324 */     // GIR_Coverage, 1619,
     /* 178324 */     GIR_EraseRootFromParent_Done,
     /* 178325 */   // Label 3449: @178325
     /* 178325 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(178370), // Rule ID 1620 //
     /* 178330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 178338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178359 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 178362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178368 */     GIR_RootConstrainSelectedInstOperands,
     /* 178369 */     // GIR_Coverage, 1620,
     /* 178369 */     GIR_EraseRootFromParent_Done,
     /* 178370 */   // Label 3450: @178370
     /* 178370 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(178415), // Rule ID 1627 //
     /* 178375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178404 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178413 */     GIR_RootConstrainSelectedInstOperands,
     /* 178414 */     // GIR_Coverage, 1627,
     /* 178414 */     GIR_EraseRootFromParent_Done,
     /* 178415 */   // Label 3451: @178415
     /* 178415 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(178460), // Rule ID 1628 //
     /* 178420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178449 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 178452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178458 */     GIR_RootConstrainSelectedInstOperands,
     /* 178459 */     // GIR_Coverage, 1628,
     /* 178459 */     GIR_EraseRootFromParent_Done,
     /* 178460 */   // Label 3452: @178460
     /* 178460 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(178505), // Rule ID 1629 //
     /* 178465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178494 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 178497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178503 */     GIR_RootConstrainSelectedInstOperands,
     /* 178504 */     // GIR_Coverage, 1629,
     /* 178504 */     GIR_EraseRootFromParent_Done,
     /* 178505 */   // Label 3453: @178505
     /* 178505 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(178550), // Rule ID 1630 //
     /* 178510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178539 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 178542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178548 */     GIR_RootConstrainSelectedInstOperands,
     /* 178549 */     // GIR_Coverage, 1630,
     /* 178549 */     GIR_EraseRootFromParent_Done,
     /* 178550 */   // Label 3454: @178550
     /* 178550 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(178595), // Rule ID 1631 //
     /* 178555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178584 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 178587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178593 */     GIR_RootConstrainSelectedInstOperands,
     /* 178594 */     // GIR_Coverage, 1631,
     /* 178594 */     GIR_EraseRootFromParent_Done,
     /* 178595 */   // Label 3455: @178595
     /* 178595 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(178640), // Rule ID 1632 //
     /* 178600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178629 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 178632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178638 */     GIR_RootConstrainSelectedInstOperands,
     /* 178639 */     // GIR_Coverage, 1632,
     /* 178639 */     GIR_EraseRootFromParent_Done,
     /* 178640 */   // Label 3456: @178640
     /* 178640 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178685), // Rule ID 1633 //
     /* 178645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178674 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 178677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178683 */     GIR_RootConstrainSelectedInstOperands,
     /* 178684 */     // GIR_Coverage, 1633,
     /* 178684 */     GIR_EraseRootFromParent_Done,
     /* 178685 */   // Label 3457: @178685
     /* 178685 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178730), // Rule ID 1634 //
     /* 178690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178719 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 178722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178728 */     GIR_RootConstrainSelectedInstOperands,
     /* 178729 */     // GIR_Coverage, 1634,
     /* 178729 */     GIR_EraseRootFromParent_Done,
     /* 178730 */   // Label 3458: @178730
     /* 178730 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178775), // Rule ID 1635 //
     /* 178735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178764 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 178767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178773 */     GIR_RootConstrainSelectedInstOperands,
     /* 178774 */     // GIR_Coverage, 1635,
     /* 178774 */     GIR_EraseRootFromParent_Done,
     /* 178775 */   // Label 3459: @178775
     /* 178775 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178820), // Rule ID 1636 //
     /* 178780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178809 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 178812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178818 */     GIR_RootConstrainSelectedInstOperands,
     /* 178819 */     // GIR_Coverage, 1636,
     /* 178819 */     GIR_EraseRootFromParent_Done,
     /* 178820 */   // Label 3460: @178820
     /* 178820 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178865), // Rule ID 1637 //
     /* 178825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178854 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 178857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178863 */     GIR_RootConstrainSelectedInstOperands,
     /* 178864 */     // GIR_Coverage, 1637,
     /* 178864 */     GIR_EraseRootFromParent_Done,
     /* 178865 */   // Label 3461: @178865
     /* 178865 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178910), // Rule ID 1638 //
     /* 178870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178899 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 178902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178908 */     GIR_RootConstrainSelectedInstOperands,
     /* 178909 */     // GIR_Coverage, 1638,
     /* 178909 */     GIR_EraseRootFromParent_Done,
     /* 178910 */   // Label 3462: @178910
     /* 178910 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178955), // Rule ID 1639 //
     /* 178915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178944 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178953 */     GIR_RootConstrainSelectedInstOperands,
     /* 178954 */     // GIR_Coverage, 1639,
     /* 178954 */     GIR_EraseRootFromParent_Done,
     /* 178955 */   // Label 3463: @178955
     /* 178955 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(179000), // Rule ID 1640 //
     /* 178960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178989 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178998 */     GIR_RootConstrainSelectedInstOperands,
     /* 178999 */     // GIR_Coverage, 1640,
     /* 178999 */     GIR_EraseRootFromParent_Done,
     /* 179000 */   // Label 3464: @179000
     /* 179000 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(179045), // Rule ID 1641 //
     /* 179005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 179013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179034 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 179037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179043 */     GIR_RootConstrainSelectedInstOperands,
     /* 179044 */     // GIR_Coverage, 1641,
     /* 179044 */     GIR_EraseRootFromParent_Done,
     /* 179045 */   // Label 3465: @179045
     /* 179045 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(179090), // Rule ID 1642 //
     /* 179050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 179058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179079 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 179082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179088 */     GIR_RootConstrainSelectedInstOperands,
     /* 179089 */     // GIR_Coverage, 1642,
     /* 179089 */     GIR_EraseRootFromParent_Done,
     /* 179090 */   // Label 3466: @179090
     /* 179090 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(179135), // Rule ID 1643 //
     /* 179095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 179103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179124 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 179127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179133 */     GIR_RootConstrainSelectedInstOperands,
     /* 179134 */     // GIR_Coverage, 1643,
     /* 179134 */     GIR_EraseRootFromParent_Done,
     /* 179135 */   // Label 3467: @179135
     /* 179135 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(179180), // Rule ID 1645 //
     /* 179140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 179148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179169 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 179172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179178 */     GIR_RootConstrainSelectedInstOperands,
     /* 179179 */     // GIR_Coverage, 1645,
     /* 179179 */     GIR_EraseRootFromParent_Done,
     /* 179180 */   // Label 3468: @179180
     /* 179180 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(179225), // Rule ID 1646 //
     /* 179185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 179193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179214 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 179217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179223 */     GIR_RootConstrainSelectedInstOperands,
     /* 179224 */     // GIR_Coverage, 1646,
     /* 179224 */     GIR_EraseRootFromParent_Done,
     /* 179225 */   // Label 3469: @179225
     /* 179225 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(179270), // Rule ID 1647 //
     /* 179230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 179238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179259 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 179262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179268 */     GIR_RootConstrainSelectedInstOperands,
     /* 179269 */     // GIR_Coverage, 1647,
     /* 179269 */     GIR_EraseRootFromParent_Done,
     /* 179270 */   // Label 3470: @179270
     /* 179270 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(179315), // Rule ID 1648 //
     /* 179275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 179283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179304 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 179307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179313 */     GIR_RootConstrainSelectedInstOperands,
     /* 179314 */     // GIR_Coverage, 1648,
     /* 179314 */     GIR_EraseRootFromParent_Done,
     /* 179315 */   // Label 3471: @179315
     /* 179315 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(179360), // Rule ID 1649 //
     /* 179320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 179328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179349 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 179352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179358 */     GIR_RootConstrainSelectedInstOperands,
     /* 179359 */     // GIR_Coverage, 1649,
     /* 179359 */     GIR_EraseRootFromParent_Done,
     /* 179360 */   // Label 3472: @179360
     /* 179360 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(179405), // Rule ID 1650 //
     /* 179365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179394 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 179397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179403 */     GIR_RootConstrainSelectedInstOperands,
     /* 179404 */     // GIR_Coverage, 1650,
     /* 179404 */     GIR_EraseRootFromParent_Done,
     /* 179405 */   // Label 3473: @179405
     /* 179405 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(179450), // Rule ID 1651 //
     /* 179410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 179418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179439 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 179439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 179442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179448 */     GIR_RootConstrainSelectedInstOperands,
     /* 179449 */     // GIR_Coverage, 1651,
     /* 179449 */     GIR_EraseRootFromParent_Done,
     /* 179450 */   // Label 3474: @179450
     /* 179450 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(179495), // Rule ID 1665 //
     /* 179455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 179463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179484 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 179484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 179487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179493 */     GIR_RootConstrainSelectedInstOperands,
     /* 179494 */     // GIR_Coverage, 1665,
     /* 179494 */     GIR_EraseRootFromParent_Done,
     /* 179495 */   // Label 3475: @179495
     /* 179495 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(179540), // Rule ID 1666 //
     /* 179500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 179508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179529 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 179529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 179532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179538 */     GIR_RootConstrainSelectedInstOperands,
     /* 179539 */     // GIR_Coverage, 1666,
     /* 179539 */     GIR_EraseRootFromParent_Done,
     /* 179540 */   // Label 3476: @179540
     /* 179540 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(179585), // Rule ID 1671 //
     /* 179545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 179553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179574 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 179574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 179577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179583 */     GIR_RootConstrainSelectedInstOperands,
     /* 179584 */     // GIR_Coverage, 1671,
     /* 179584 */     GIR_EraseRootFromParent_Done,
     /* 179585 */   // Label 3477: @179585
     /* 179585 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(179630), // Rule ID 1672 //
     /* 179590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 179598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179619 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 179619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 179622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179628 */     GIR_RootConstrainSelectedInstOperands,
     /* 179629 */     // GIR_Coverage, 1672,
     /* 179629 */     GIR_EraseRootFromParent_Done,
     /* 179630 */   // Label 3478: @179630
     /* 179630 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179675), // Rule ID 1673 //
     /* 179635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179664 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 179667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179673 */     GIR_RootConstrainSelectedInstOperands,
     /* 179674 */     // GIR_Coverage, 1673,
     /* 179674 */     GIR_EraseRootFromParent_Done,
     /* 179675 */   // Label 3479: @179675
     /* 179675 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179720), // Rule ID 1674 //
     /* 179680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179709 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 179712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179718 */     GIR_RootConstrainSelectedInstOperands,
     /* 179719 */     // GIR_Coverage, 1674,
     /* 179719 */     GIR_EraseRootFromParent_Done,
     /* 179720 */   // Label 3480: @179720
     /* 179720 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179765), // Rule ID 1675 //
     /* 179725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179754 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 179757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179763 */     GIR_RootConstrainSelectedInstOperands,
     /* 179764 */     // GIR_Coverage, 1675,
     /* 179764 */     GIR_EraseRootFromParent_Done,
     /* 179765 */   // Label 3481: @179765
     /* 179765 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179810), // Rule ID 1676 //
     /* 179770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179799 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 179802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179808 */     GIR_RootConstrainSelectedInstOperands,
     /* 179809 */     // GIR_Coverage, 1676,
     /* 179809 */     GIR_EraseRootFromParent_Done,
     /* 179810 */   // Label 3482: @179810
     /* 179810 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179855), // Rule ID 1677 //
     /* 179815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179844 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 179847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179853 */     GIR_RootConstrainSelectedInstOperands,
     /* 179854 */     // GIR_Coverage, 1677,
     /* 179854 */     GIR_EraseRootFromParent_Done,
     /* 179855 */   // Label 3483: @179855
     /* 179855 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179900), // Rule ID 1678 //
     /* 179860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179889 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 179892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179898 */     GIR_RootConstrainSelectedInstOperands,
     /* 179899 */     // GIR_Coverage, 1678,
     /* 179899 */     GIR_EraseRootFromParent_Done,
     /* 179900 */   // Label 3484: @179900
     /* 179900 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179945), // Rule ID 1679 //
     /* 179905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179934 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179943 */     GIR_RootConstrainSelectedInstOperands,
     /* 179944 */     // GIR_Coverage, 1679,
     /* 179944 */     GIR_EraseRootFromParent_Done,
     /* 179945 */   // Label 3485: @179945
     /* 179945 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179990), // Rule ID 1680 //
     /* 179950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179979 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179988 */     GIR_RootConstrainSelectedInstOperands,
     /* 179989 */     // GIR_Coverage, 1680,
     /* 179989 */     GIR_EraseRootFromParent_Done,
     /* 179990 */   // Label 3486: @179990
     /* 179990 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(180035), // Rule ID 1681 //
     /* 179995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 180003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180024 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 180024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 180027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180033 */     GIR_RootConstrainSelectedInstOperands,
     /* 180034 */     // GIR_Coverage, 1681,
     /* 180034 */     GIR_EraseRootFromParent_Done,
     /* 180035 */   // Label 3487: @180035
     /* 180035 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(180080), // Rule ID 1682 //
     /* 180040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 180048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 180051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180069 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 180069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 180072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180078 */     GIR_RootConstrainSelectedInstOperands,
     /* 180079 */     // GIR_Coverage, 1682,
     /* 180079 */     GIR_EraseRootFromParent_Done,
     /* 180080 */   // Label 3488: @180080
     /* 180080 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(180125), // Rule ID 1683 //
     /* 180085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 180093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180114 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 180114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 180117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180123 */     GIR_RootConstrainSelectedInstOperands,
     /* 180124 */     // GIR_Coverage, 1683,
     /* 180124 */     GIR_EraseRootFromParent_Done,
     /* 180125 */   // Label 3489: @180125
     /* 180125 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(180170), // Rule ID 1684 //
     /* 180130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 180138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180159 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 180159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 180162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180168 */     GIR_RootConstrainSelectedInstOperands,
     /* 180169 */     // GIR_Coverage, 1684,
     /* 180169 */     GIR_EraseRootFromParent_Done,
     /* 180170 */   // Label 3490: @180170
     /* 180170 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(180215), // Rule ID 1750 //
     /* 180175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180204 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 180204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 180207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180213 */     GIR_RootConstrainSelectedInstOperands,
     /* 180214 */     // GIR_Coverage, 1750,
     /* 180214 */     GIR_EraseRootFromParent_Done,
     /* 180215 */   // Label 3491: @180215
     /* 180215 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(180260), // Rule ID 1752 //
     /* 180220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180249 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 180249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 180252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180258 */     GIR_RootConstrainSelectedInstOperands,
     /* 180259 */     // GIR_Coverage, 1752,
     /* 180259 */     GIR_EraseRootFromParent_Done,
     /* 180260 */   // Label 3492: @180260
     /* 180260 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(180305), // Rule ID 2303 //
     /* 180265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 180268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 180273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 180276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 180279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 180282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180294 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 180294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 180297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180303 */     GIR_RootConstrainSelectedInstOperands,
     /* 180304 */     // GIR_Coverage, 2303,
     /* 180304 */     GIR_EraseRootFromParent_Done,
     /* 180305 */   // Label 3493: @180305
     /* 180305 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(180350), // Rule ID 2304 //
     /* 180310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 180313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 180318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 180321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 180324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 180327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180339 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 180339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 180342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180348 */     GIR_RootConstrainSelectedInstOperands,
     /* 180349 */     // GIR_Coverage, 2304,
     /* 180349 */     GIR_EraseRootFromParent_Done,
     /* 180350 */   // Label 3494: @180350
     /* 180350 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(180395), // Rule ID 2315 //
     /* 180355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 180358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 180363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 180384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 180387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180393 */     GIR_RootConstrainSelectedInstOperands,
     /* 180394 */     // GIR_Coverage, 2315,
     /* 180394 */     GIR_EraseRootFromParent_Done,
     /* 180395 */   // Label 3495: @180395
     /* 180395 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(180440), // Rule ID 2316 //
     /* 180400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 180403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 180408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180429 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 180429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 180432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180438 */     GIR_RootConstrainSelectedInstOperands,
     /* 180439 */     // GIR_Coverage, 2316,
     /* 180439 */     GIR_EraseRootFromParent_Done,
     /* 180440 */   // Label 3496: @180440
     /* 180440 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(180485), // Rule ID 2339 //
     /* 180445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180474 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 180474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 180477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180483 */     GIR_RootConstrainSelectedInstOperands,
     /* 180484 */     // GIR_Coverage, 2339,
     /* 180484 */     GIR_EraseRootFromParent_Done,
     /* 180485 */   // Label 3497: @180485
     /* 180485 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(180530), // Rule ID 2340 //
     /* 180490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180519 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 180519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 180522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180528 */     GIR_RootConstrainSelectedInstOperands,
     /* 180529 */     // GIR_Coverage, 2340,
     /* 180529 */     GIR_EraseRootFromParent_Done,
     /* 180530 */   // Label 3498: @180530
     /* 180530 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(180575), // Rule ID 2341 //
     /* 180535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180564 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 180564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 180567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180573 */     GIR_RootConstrainSelectedInstOperands,
     /* 180574 */     // GIR_Coverage, 2341,
     /* 180574 */     GIR_EraseRootFromParent_Done,
     /* 180575 */   // Label 3499: @180575
     /* 180575 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(180620), // Rule ID 2342 //
     /* 180580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180609 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 180609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 180612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180618 */     GIR_RootConstrainSelectedInstOperands,
     /* 180619 */     // GIR_Coverage, 2342,
     /* 180619 */     GIR_EraseRootFromParent_Done,
     /* 180620 */   // Label 3500: @180620
     /* 180620 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180665), // Rule ID 2343 //
     /* 180625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180654 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 180654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 180657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180663 */     GIR_RootConstrainSelectedInstOperands,
     /* 180664 */     // GIR_Coverage, 2343,
     /* 180664 */     GIR_EraseRootFromParent_Done,
     /* 180665 */   // Label 3501: @180665
     /* 180665 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180710), // Rule ID 2344 //
     /* 180670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180699 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 180702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180708 */     GIR_RootConstrainSelectedInstOperands,
     /* 180709 */     // GIR_Coverage, 2344,
     /* 180709 */     GIR_EraseRootFromParent_Done,
     /* 180710 */   // Label 3502: @180710
     /* 180710 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180755), // Rule ID 2347 //
     /* 180715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180744 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 180747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180753 */     GIR_RootConstrainSelectedInstOperands,
     /* 180754 */     // GIR_Coverage, 2347,
     /* 180754 */     GIR_EraseRootFromParent_Done,
     /* 180755 */   // Label 3503: @180755
     /* 180755 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180800), // Rule ID 2350 //
     /* 180760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180789 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 180792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180798 */     GIR_RootConstrainSelectedInstOperands,
     /* 180799 */     // GIR_Coverage, 2350,
     /* 180799 */     GIR_EraseRootFromParent_Done,
     /* 180800 */   // Label 3504: @180800
     /* 180800 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180845), // Rule ID 2353 //
     /* 180805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180834 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 180837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180843 */     GIR_RootConstrainSelectedInstOperands,
     /* 180844 */     // GIR_Coverage, 2353,
     /* 180844 */     GIR_EraseRootFromParent_Done,
     /* 180845 */   // Label 3505: @180845
     /* 180845 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180890), // Rule ID 2356 //
     /* 180850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180879 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 180882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180888 */     GIR_RootConstrainSelectedInstOperands,
     /* 180889 */     // GIR_Coverage, 2356,
     /* 180889 */     GIR_EraseRootFromParent_Done,
     /* 180890 */   // Label 3506: @180890
     /* 180890 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180935), // Rule ID 2359 //
     /* 180895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180924 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 180927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180933 */     GIR_RootConstrainSelectedInstOperands,
     /* 180934 */     // GIR_Coverage, 2359,
     /* 180934 */     GIR_EraseRootFromParent_Done,
     /* 180935 */   // Label 3507: @180935
     /* 180935 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180980), // Rule ID 2362 //
     /* 180940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180969 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 180972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180978 */     GIR_RootConstrainSelectedInstOperands,
     /* 180979 */     // GIR_Coverage, 2362,
     /* 180979 */     GIR_EraseRootFromParent_Done,
     /* 180980 */   // Label 3508: @180980
     /* 180980 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(181025), // Rule ID 2365 //
     /* 180985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181014 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 181014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 181017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181023 */     GIR_RootConstrainSelectedInstOperands,
     /* 181024 */     // GIR_Coverage, 2365,
     /* 181024 */     GIR_EraseRootFromParent_Done,
     /* 181025 */   // Label 3509: @181025
     /* 181025 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(181070), // Rule ID 2368 //
     /* 181030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 181033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 181038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181059 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 181059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 181062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181068 */     GIR_RootConstrainSelectedInstOperands,
     /* 181069 */     // GIR_Coverage, 2368,
     /* 181069 */     GIR_EraseRootFromParent_Done,
     /* 181070 */   // Label 3510: @181070
     /* 181070 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(181115), // Rule ID 2371 //
     /* 181075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 181078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 181083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181104 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 181104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 181107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181113 */     GIR_RootConstrainSelectedInstOperands,
     /* 181114 */     // GIR_Coverage, 2371,
     /* 181114 */     GIR_EraseRootFromParent_Done,
     /* 181115 */   // Label 3511: @181115
     /* 181115 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(181160), // Rule ID 2508 //
     /* 181120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 181128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181149 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 181152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181158 */     GIR_RootConstrainSelectedInstOperands,
     /* 181159 */     // GIR_Coverage, 2508,
     /* 181159 */     GIR_EraseRootFromParent_Done,
     /* 181160 */   // Label 3512: @181160
     /* 181160 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(181205), // Rule ID 2509 //
     /* 181165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 181173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181194 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 181197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181203 */     GIR_RootConstrainSelectedInstOperands,
     /* 181204 */     // GIR_Coverage, 2509,
     /* 181204 */     GIR_EraseRootFromParent_Done,
     /* 181205 */   // Label 3513: @181205
     /* 181205 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(181250), // Rule ID 2510 //
     /* 181210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 181218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181239 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 181242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181248 */     GIR_RootConstrainSelectedInstOperands,
     /* 181249 */     // GIR_Coverage, 2510,
     /* 181249 */     GIR_EraseRootFromParent_Done,
     /* 181250 */   // Label 3514: @181250
     /* 181250 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(181295), // Rule ID 2511 //
     /* 181255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 181263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181284 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 181287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181293 */     GIR_RootConstrainSelectedInstOperands,
     /* 181294 */     // GIR_Coverage, 2511,
     /* 181294 */     GIR_EraseRootFromParent_Done,
     /* 181295 */   // Label 3515: @181295
     /* 181295 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(181340), // Rule ID 2516 //
     /* 181300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 181308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181329 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 181329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 181332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181338 */     GIR_RootConstrainSelectedInstOperands,
     /* 181339 */     // GIR_Coverage, 2516,
     /* 181339 */     GIR_EraseRootFromParent_Done,
     /* 181340 */   // Label 3516: @181340
     /* 181340 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(181385), // Rule ID 2634 //
     /* 181345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181374 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 181377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181383 */     GIR_RootConstrainSelectedInstOperands,
     /* 181384 */     // GIR_Coverage, 2634,
     /* 181384 */     GIR_EraseRootFromParent_Done,
     /* 181385 */   // Label 3517: @181385
     /* 181385 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(181430), // Rule ID 2635 //
     /* 181390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181419 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 181422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181428 */     GIR_RootConstrainSelectedInstOperands,
     /* 181429 */     // GIR_Coverage, 2635,
     /* 181429 */     GIR_EraseRootFromParent_Done,
     /* 181430 */   // Label 3518: @181430
     /* 181430 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(181475), // Rule ID 2636 //
     /* 181435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181464 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 181467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181473 */     GIR_RootConstrainSelectedInstOperands,
     /* 181474 */     // GIR_Coverage, 2636,
     /* 181474 */     GIR_EraseRootFromParent_Done,
     /* 181475 */   // Label 3519: @181475
     /* 181475 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(181520), // Rule ID 2637 //
     /* 181480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181509 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 181512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181518 */     GIR_RootConstrainSelectedInstOperands,
     /* 181519 */     // GIR_Coverage, 2637,
     /* 181519 */     GIR_EraseRootFromParent_Done,
     /* 181520 */   // Label 3520: @181520
     /* 181520 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(181565), // Rule ID 2638 //
     /* 181525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181554 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 181557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181563 */     GIR_RootConstrainSelectedInstOperands,
     /* 181564 */     // GIR_Coverage, 2638,
     /* 181564 */     GIR_EraseRootFromParent_Done,
     /* 181565 */   // Label 3521: @181565
     /* 181565 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(181610), // Rule ID 2639 //
     /* 181570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181599 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 181602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181608 */     GIR_RootConstrainSelectedInstOperands,
     /* 181609 */     // GIR_Coverage, 2639,
     /* 181609 */     GIR_EraseRootFromParent_Done,
     /* 181610 */   // Label 3522: @181610
     /* 181610 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181655), // Rule ID 2640 //
     /* 181615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181644 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 181647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181653 */     GIR_RootConstrainSelectedInstOperands,
     /* 181654 */     // GIR_Coverage, 2640,
     /* 181654 */     GIR_EraseRootFromParent_Done,
     /* 181655 */   // Label 3523: @181655
     /* 181655 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181700), // Rule ID 2641 //
     /* 181660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181689 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 181692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181698 */     GIR_RootConstrainSelectedInstOperands,
     /* 181699 */     // GIR_Coverage, 2641,
     /* 181699 */     GIR_EraseRootFromParent_Done,
     /* 181700 */   // Label 3524: @181700
     /* 181700 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181745), // Rule ID 3815 //
     /* 181705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 181708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 181713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 181734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 181737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181743 */     GIR_RootConstrainSelectedInstOperands,
     /* 181744 */     // GIR_Coverage, 3815,
     /* 181744 */     GIR_EraseRootFromParent_Done,
     /* 181745 */   // Label 3525: @181745
     /* 181745 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181790), // Rule ID 3843 //
     /* 181750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 181753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 181758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181779 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 181779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 181782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181788 */     GIR_RootConstrainSelectedInstOperands,
     /* 181789 */     // GIR_Coverage, 3843,
     /* 181789 */     GIR_EraseRootFromParent_Done,
     /* 181790 */   // Label 3526: @181790
     /* 181790 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181835), // Rule ID 3853 //
     /* 181795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 181798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 181803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 181827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181833 */     GIR_RootConstrainSelectedInstOperands,
     /* 181834 */     // GIR_Coverage, 3853,
     /* 181834 */     GIR_EraseRootFromParent_Done,
     /* 181835 */   // Label 3527: @181835
     /* 181835 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181880), // Rule ID 3854 //
     /* 181840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 181843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 181848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181869 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 181872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181878 */     GIR_RootConstrainSelectedInstOperands,
     /* 181879 */     // GIR_Coverage, 3854,
     /* 181879 */     GIR_EraseRootFromParent_Done,
     /* 181880 */   // Label 3528: @181880
     /* 181880 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181928), // Rule ID 3855 //
     /* 181885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181914 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 181914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181926 */     GIR_RootConstrainSelectedInstOperands,
     /* 181927 */     // GIR_Coverage, 3855,
     /* 181927 */     GIR_EraseRootFromParent_Done,
     /* 181928 */   // Label 3529: @181928
     /* 181928 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181976), // Rule ID 3856 //
     /* 181933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181962 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 181962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181974 */     GIR_RootConstrainSelectedInstOperands,
     /* 181975 */     // GIR_Coverage, 3856,
     /* 181975 */     GIR_EraseRootFromParent_Done,
     /* 181976 */   // Label 3530: @181976
     /* 181976 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(182024), // Rule ID 3857 //
     /* 181981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182010 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 182010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 182013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182022 */     GIR_RootConstrainSelectedInstOperands,
     /* 182023 */     // GIR_Coverage, 3857,
     /* 182023 */     GIR_EraseRootFromParent_Done,
     /* 182024 */   // Label 3531: @182024
     /* 182024 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(182072), // Rule ID 3858 //
     /* 182029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 182032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 182037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 182040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 182046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182058 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 182058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 182061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 182070 */     GIR_RootConstrainSelectedInstOperands,
     /* 182071 */     // GIR_Coverage, 3858,
     /* 182071 */     GIR_EraseRootFromParent_Done,
     /* 182072 */   // Label 3532: @182072
     /* 182072 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(182120), // Rule ID 3859 //
     /* 182077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 182085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182106 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 182106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 182109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182118 */     GIR_RootConstrainSelectedInstOperands,
     /* 182119 */     // GIR_Coverage, 3859,
     /* 182119 */     GIR_EraseRootFromParent_Done,
     /* 182120 */   // Label 3533: @182120
     /* 182120 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(182168), // Rule ID 3860 //
     /* 182125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 182133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 182139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 182142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182154 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 182154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 182157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 182166 */     GIR_RootConstrainSelectedInstOperands,
     /* 182167 */     // GIR_Coverage, 3860,
     /* 182167 */     GIR_EraseRootFromParent_Done,
     /* 182168 */   // Label 3534: @182168
     /* 182168 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(182216), // Rule ID 3861 //
     /* 182173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 182181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182202 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 182202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 182205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182214 */     GIR_RootConstrainSelectedInstOperands,
     /* 182215 */     // GIR_Coverage, 3861,
     /* 182215 */     GIR_EraseRootFromParent_Done,
     /* 182216 */   // Label 3535: @182216
     /* 182216 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(182264), // Rule ID 3862 //
     /* 182221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 182229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 182232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 182238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182250 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 182250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 182253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 182262 */     GIR_RootConstrainSelectedInstOperands,
     /* 182263 */     // GIR_Coverage, 3862,
     /* 182263 */     GIR_EraseRootFromParent_Done,
     /* 182264 */   // Label 3536: @182264
     /* 182264 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(182312), // Rule ID 3863 //
     /* 182269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 182277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182298 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 182298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 182301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182310 */     GIR_RootConstrainSelectedInstOperands,
     /* 182311 */     // GIR_Coverage, 3863,
     /* 182311 */     GIR_EraseRootFromParent_Done,
     /* 182312 */   // Label 3537: @182312
     /* 182312 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(182360), // Rule ID 3864 //
     /* 182317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 182320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 182325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 182328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 182334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182346 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 182346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 182349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 182358 */     GIR_RootConstrainSelectedInstOperands,
     /* 182359 */     // GIR_Coverage, 3864,
     /* 182359 */     GIR_EraseRootFromParent_Done,
     /* 182360 */   // Label 3538: @182360
     /* 182360 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(182402), // Rule ID 3929 //
     /* 182365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 182370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182391 */     // (intrinsic_wo_chain:{ *:[i32] } 2169:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 182391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 182394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182400 */     GIR_RootConstrainSelectedInstOperands,
     /* 182401 */     // GIR_Coverage, 3929,
     /* 182401 */     GIR_EraseRootFromParent_Done,
     /* 182402 */   // Label 3539: @182402
     /* 182402 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(182444), // Rule ID 3930 //
     /* 182407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 182412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182433 */     // (intrinsic_wo_chain:{ *:[i64] } 2169:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 182433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 182436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182442 */     GIR_RootConstrainSelectedInstOperands,
     /* 182443 */     // GIR_Coverage, 3930,
     /* 182443 */     GIR_EraseRootFromParent_Done,
     /* 182444 */   // Label 3540: @182444
     /* 182444 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(182486), // Rule ID 3931 //
     /* 182449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 182454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182475 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 182475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 182478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182484 */     GIR_RootConstrainSelectedInstOperands,
     /* 182485 */     // GIR_Coverage, 3931,
     /* 182485 */     GIR_EraseRootFromParent_Done,
     /* 182486 */   // Label 3541: @182486
     /* 182486 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(182528), // Rule ID 3932 //
     /* 182491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 182496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182517 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 182517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 182520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182526 */     GIR_RootConstrainSelectedInstOperands,
     /* 182527 */     // GIR_Coverage, 3932,
     /* 182527 */     GIR_EraseRootFromParent_Done,
     /* 182528 */   // Label 3542: @182528
     /* 182528 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(182570), // Rule ID 5207 //
     /* 182533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 182538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182559 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 182562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182568 */     GIR_RootConstrainSelectedInstOperands,
     /* 182569 */     // GIR_Coverage, 5207,
     /* 182569 */     GIR_EraseRootFromParent_Done,
     /* 182570 */   // Label 3543: @182570
     /* 182570 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(182615), // Rule ID 5211 //
     /* 182575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182604 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 182607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182613 */     GIR_RootConstrainSelectedInstOperands,
     /* 182614 */     // GIR_Coverage, 5211,
     /* 182614 */     GIR_EraseRootFromParent_Done,
     /* 182615 */   // Label 3544: @182615
     /* 182615 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182660), // Rule ID 5215 //
     /* 182620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 182628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182649 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182658 */     GIR_RootConstrainSelectedInstOperands,
     /* 182659 */     // GIR_Coverage, 5215,
     /* 182659 */     GIR_EraseRootFromParent_Done,
     /* 182660 */   // Label 3545: @182660
     /* 182660 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182705), // Rule ID 5216 //
     /* 182665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 182673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182694 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 182697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182703 */     GIR_RootConstrainSelectedInstOperands,
     /* 182704 */     // GIR_Coverage, 5216,
     /* 182704 */     GIR_EraseRootFromParent_Done,
     /* 182705 */   // Label 3546: @182705
     /* 182705 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182750), // Rule ID 5217 //
     /* 182710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 182718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182739 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 182742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182748 */     GIR_RootConstrainSelectedInstOperands,
     /* 182749 */     // GIR_Coverage, 5217,
     /* 182749 */     GIR_EraseRootFromParent_Done,
     /* 182750 */   // Label 3547: @182750
     /* 182750 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182795), // Rule ID 5218 //
     /* 182755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 182763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182784 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 182787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182793 */     GIR_RootConstrainSelectedInstOperands,
     /* 182794 */     // GIR_Coverage, 5218,
     /* 182794 */     GIR_EraseRootFromParent_Done,
     /* 182795 */   // Label 3548: @182795
     /* 182795 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182840), // Rule ID 5219 //
     /* 182800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 182808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182829 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 182832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182838 */     GIR_RootConstrainSelectedInstOperands,
     /* 182839 */     // GIR_Coverage, 5219,
     /* 182839 */     GIR_EraseRootFromParent_Done,
     /* 182840 */   // Label 3549: @182840
     /* 182840 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182885), // Rule ID 5220 //
     /* 182845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182874 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 182877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182883 */     GIR_RootConstrainSelectedInstOperands,
     /* 182884 */     // GIR_Coverage, 5220,
     /* 182884 */     GIR_EraseRootFromParent_Done,
     /* 182885 */   // Label 3550: @182885
     /* 182885 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182930), // Rule ID 5221 //
     /* 182890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182919 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 182922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182928 */     GIR_RootConstrainSelectedInstOperands,
     /* 182929 */     // GIR_Coverage, 5221,
     /* 182929 */     GIR_EraseRootFromParent_Done,
     /* 182930 */   // Label 3551: @182930
     /* 182930 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182975), // Rule ID 5222 //
     /* 182935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182964 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 182967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182973 */     GIR_RootConstrainSelectedInstOperands,
     /* 182974 */     // GIR_Coverage, 5222,
     /* 182974 */     GIR_EraseRootFromParent_Done,
     /* 182975 */   // Label 3552: @182975
     /* 182975 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(183020), // Rule ID 5223 //
     /* 182980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183009 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 183012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183018 */     GIR_RootConstrainSelectedInstOperands,
     /* 183019 */     // GIR_Coverage, 5223,
     /* 183019 */     GIR_EraseRootFromParent_Done,
     /* 183020 */   // Label 3553: @183020
     /* 183020 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(183065), // Rule ID 5224 //
     /* 183025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 183033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183054 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 183057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183063 */     GIR_RootConstrainSelectedInstOperands,
     /* 183064 */     // GIR_Coverage, 5224,
     /* 183064 */     GIR_EraseRootFromParent_Done,
     /* 183065 */   // Label 3554: @183065
     /* 183065 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(183110), // Rule ID 5225 //
     /* 183070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 183078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183099 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 183102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183108 */     GIR_RootConstrainSelectedInstOperands,
     /* 183109 */     // GIR_Coverage, 5225,
     /* 183109 */     GIR_EraseRootFromParent_Done,
     /* 183110 */   // Label 3555: @183110
     /* 183110 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(183155), // Rule ID 5226 //
     /* 183115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 183123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183144 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 183147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183153 */     GIR_RootConstrainSelectedInstOperands,
     /* 183154 */     // GIR_Coverage, 5226,
     /* 183154 */     GIR_EraseRootFromParent_Done,
     /* 183155 */   // Label 3556: @183155
     /* 183155 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(183200), // Rule ID 5227 //
     /* 183160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 183168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183189 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 183192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183198 */     GIR_RootConstrainSelectedInstOperands,
     /* 183199 */     // GIR_Coverage, 5227,
     /* 183199 */     GIR_EraseRootFromParent_Done,
     /* 183200 */   // Label 3557: @183200
     /* 183200 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(183245), // Rule ID 5228 //
     /* 183205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 183213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183234 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 183237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183243 */     GIR_RootConstrainSelectedInstOperands,
     /* 183244 */     // GIR_Coverage, 5228,
     /* 183244 */     GIR_EraseRootFromParent_Done,
     /* 183245 */   // Label 3558: @183245
     /* 183245 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(183290), // Rule ID 5229 //
     /* 183250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 183258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183279 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 183282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183288 */     GIR_RootConstrainSelectedInstOperands,
     /* 183289 */     // GIR_Coverage, 5229,
     /* 183289 */     GIR_EraseRootFromParent_Done,
     /* 183290 */   // Label 3559: @183290
     /* 183290 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(183335), // Rule ID 5230 //
     /* 183295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 183303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183324 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 183327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183333 */     GIR_RootConstrainSelectedInstOperands,
     /* 183334 */     // GIR_Coverage, 5230,
     /* 183334 */     GIR_EraseRootFromParent_Done,
     /* 183335 */   // Label 3560: @183335
     /* 183335 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(183380), // Rule ID 5231 //
     /* 183340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 183348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183369 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 183372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183378 */     GIR_RootConstrainSelectedInstOperands,
     /* 183379 */     // GIR_Coverage, 5231,
     /* 183379 */     GIR_EraseRootFromParent_Done,
     /* 183380 */   // Label 3561: @183380
     /* 183380 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183425), // Rule ID 5250 //
     /* 183385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 183393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183414 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 183414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 183417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183423 */     GIR_RootConstrainSelectedInstOperands,
     /* 183424 */     // GIR_Coverage, 5250,
     /* 183424 */     GIR_EraseRootFromParent_Done,
     /* 183425 */   // Label 3562: @183425
     /* 183425 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183467), // Rule ID 5584 //
     /* 183430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 183435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 183438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 183441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 183444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183456 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 183456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 183459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 183465 */     GIR_RootConstrainSelectedInstOperands,
     /* 183466 */     // GIR_Coverage, 5584,
     /* 183466 */     GIR_EraseRootFromParent_Done,
     /* 183467 */   // Label 3563: @183467
     /* 183467 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(183509), // Rule ID 5585 //
     /* 183472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 183477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 183480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 183483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 183486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183498 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 183498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 183501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 183505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183507 */     GIR_RootConstrainSelectedInstOperands,
     /* 183508 */     // GIR_Coverage, 5585,
     /* 183508 */     GIR_EraseRootFromParent_Done,
     /* 183509 */   // Label 3564: @183509
     /* 183509 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(183606), // Rule ID 6286 //
     /* 183514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 183519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 183528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183540 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 183540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 183547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 183560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183605 */     // GIR_Coverage, 6286,
     /* 183605 */     GIR_EraseRootFromParent_Done,
     /* 183606 */   // Label 3565: @183606
     /* 183606 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183703), // Rule ID 6287 //
     /* 183611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 183616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 183625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183637 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 183637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 183644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183653 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 183657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183702 */     // GIR_Coverage, 6287,
     /* 183702 */     GIR_EraseRootFromParent_Done,
     /* 183703 */   // Label 3566: @183703
     /* 183703 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183745), // Rule ID 6932 //
     /* 183708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 183713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183734 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 183737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183743 */     GIR_RootConstrainSelectedInstOperands,
     /* 183744 */     // GIR_Coverage, 6932,
     /* 183744 */     GIR_EraseRootFromParent_Done,
     /* 183745 */   // Label 3567: @183745
     /* 183745 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183787), // Rule ID 6933 //
     /* 183750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 183755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183776 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 183779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183785 */     GIR_RootConstrainSelectedInstOperands,
     /* 183786 */     // GIR_Coverage, 6933,
     /* 183786 */     GIR_EraseRootFromParent_Done,
     /* 183787 */   // Label 3568: @183787
     /* 183787 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183829), // Rule ID 6934 //
     /* 183792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 183797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183818 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 183821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183827 */     GIR_RootConstrainSelectedInstOperands,
     /* 183828 */     // GIR_Coverage, 6934,
     /* 183828 */     GIR_EraseRootFromParent_Done,
     /* 183829 */   // Label 3569: @183829
     /* 183829 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183871), // Rule ID 6935 //
     /* 183834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 183839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183860 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 183863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183869 */     GIR_RootConstrainSelectedInstOperands,
     /* 183870 */     // GIR_Coverage, 6935,
     /* 183870 */     GIR_EraseRootFromParent_Done,
     /* 183871 */   // Label 3570: @183871
     /* 183871 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183919), // Rule ID 6975 //
     /* 183876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183902 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 183902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 183905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 183914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 183917 */     GIR_RootConstrainSelectedInstOperands,
     /* 183918 */     // GIR_Coverage, 6975,
     /* 183918 */     GIR_EraseRootFromParent_Done,
     /* 183919 */   // Label 3571: @183919
     /* 183919 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183964), // Rule ID 10003 //
     /* 183924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183953 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 183956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183962 */     GIR_RootConstrainSelectedInstOperands,
     /* 183963 */     // GIR_Coverage, 10003,
     /* 183963 */     GIR_EraseRootFromParent_Done,
     /* 183964 */   // Label 3572: @183964
     /* 183964 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184009), // Rule ID 10004 //
     /* 183969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183998 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 184001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184007 */     GIR_RootConstrainSelectedInstOperands,
     /* 184008 */     // GIR_Coverage, 10004,
     /* 184008 */     GIR_EraseRootFromParent_Done,
     /* 184009 */   // Label 3573: @184009
     /* 184009 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(184054), // Rule ID 10005 //
     /* 184014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 184022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184043 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 184046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184052 */     GIR_RootConstrainSelectedInstOperands,
     /* 184053 */     // GIR_Coverage, 10005,
     /* 184053 */     GIR_EraseRootFromParent_Done,
     /* 184054 */   // Label 3574: @184054
     /* 184054 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(184099), // Rule ID 10006 //
     /* 184059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 184067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184088 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 184091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184097 */     GIR_RootConstrainSelectedInstOperands,
     /* 184098 */     // GIR_Coverage, 10006,
     /* 184098 */     GIR_EraseRootFromParent_Done,
     /* 184099 */   // Label 3575: @184099
     /* 184099 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(184144), // Rule ID 10015 //
     /* 184104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 184112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184133 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 184136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184142 */     GIR_RootConstrainSelectedInstOperands,
     /* 184143 */     // GIR_Coverage, 10015,
     /* 184143 */     GIR_EraseRootFromParent_Done,
     /* 184144 */   // Label 3576: @184144
     /* 184144 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(184189), // Rule ID 10016 //
     /* 184149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 184157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184178 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 184181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184187 */     GIR_RootConstrainSelectedInstOperands,
     /* 184188 */     // GIR_Coverage, 10016,
     /* 184188 */     GIR_EraseRootFromParent_Done,
     /* 184189 */   // Label 3577: @184189
     /* 184189 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(184234), // Rule ID 10017 //
     /* 184194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 184202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184223 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 184226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184232 */     GIR_RootConstrainSelectedInstOperands,
     /* 184233 */     // GIR_Coverage, 10017,
     /* 184233 */     GIR_EraseRootFromParent_Done,
     /* 184234 */   // Label 3578: @184234
     /* 184234 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(184279), // Rule ID 10018 //
     /* 184239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 184247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184268 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 184271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184277 */     GIR_RootConstrainSelectedInstOperands,
     /* 184278 */     // GIR_Coverage, 10018,
     /* 184278 */     GIR_EraseRootFromParent_Done,
     /* 184279 */   // Label 3579: @184279
     /* 184279 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(184324), // Rule ID 10019 //
     /* 184284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184313 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 184316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184322 */     GIR_RootConstrainSelectedInstOperands,
     /* 184323 */     // GIR_Coverage, 10019,
     /* 184323 */     GIR_EraseRootFromParent_Done,
     /* 184324 */   // Label 3580: @184324
     /* 184324 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(184369), // Rule ID 10020 //
     /* 184329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184358 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 184361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184367 */     GIR_RootConstrainSelectedInstOperands,
     /* 184368 */     // GIR_Coverage, 10020,
     /* 184368 */     GIR_EraseRootFromParent_Done,
     /* 184369 */   // Label 3581: @184369
     /* 184369 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(184414), // Rule ID 10021 //
     /* 184374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184403 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 184406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184412 */     GIR_RootConstrainSelectedInstOperands,
     /* 184413 */     // GIR_Coverage, 10021,
     /* 184413 */     GIR_EraseRootFromParent_Done,
     /* 184414 */   // Label 3582: @184414
     /* 184414 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(184459), // Rule ID 10022 //
     /* 184419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184448 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 184451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184457 */     GIR_RootConstrainSelectedInstOperands,
     /* 184458 */     // GIR_Coverage, 10022,
     /* 184458 */     GIR_EraseRootFromParent_Done,
     /* 184459 */   // Label 3583: @184459
     /* 184459 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184504), // Rule ID 10023 //
     /* 184464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184493 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 184496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184502 */     GIR_RootConstrainSelectedInstOperands,
     /* 184503 */     // GIR_Coverage, 10023,
     /* 184503 */     GIR_EraseRootFromParent_Done,
     /* 184504 */   // Label 3584: @184504
     /* 184504 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184549), // Rule ID 10024 //
     /* 184509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184538 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 184541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184547 */     GIR_RootConstrainSelectedInstOperands,
     /* 184548 */     // GIR_Coverage, 10024,
     /* 184548 */     GIR_EraseRootFromParent_Done,
     /* 184549 */   // Label 3585: @184549
     /* 184549 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184594), // Rule ID 10025 //
     /* 184554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184583 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 184586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184592 */     GIR_RootConstrainSelectedInstOperands,
     /* 184593 */     // GIR_Coverage, 10025,
     /* 184593 */     GIR_EraseRootFromParent_Done,
     /* 184594 */   // Label 3586: @184594
     /* 184594 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184639), // Rule ID 10026 //
     /* 184599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184628 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 184631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184637 */     GIR_RootConstrainSelectedInstOperands,
     /* 184638 */     // GIR_Coverage, 10026,
     /* 184638 */     GIR_EraseRootFromParent_Done,
     /* 184639 */   // Label 3587: @184639
     /* 184639 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184685), // Rule ID 138 //
     /* 184644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 184647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 184652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184662 */     // MIs[0] Rn
     /* 184662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 184666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184674 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 184677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184683 */     GIR_RootConstrainSelectedInstOperands,
     /* 184684 */     // GIR_Coverage, 138,
     /* 184684 */     GIR_EraseRootFromParent_Done,
     /* 184685 */   // Label 3588: @184685
     /* 184685 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184732), // Rule ID 139 //
     /* 184690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 184693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 184698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184705 */     // MIs[0] Rn
     /* 184705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 184709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184713 */     // MIs[0] Rm
     /* 184713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 184717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184721 */     // (intrinsic_wo_chain:{ *:[i64] } 1242:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 184721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 184724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184730 */     GIR_RootConstrainSelectedInstOperands,
     /* 184731 */     // GIR_Coverage, 139,
     /* 184731 */     GIR_EraseRootFromParent_Done,
     /* 184732 */   // Label 3589: @184732
     /* 184732 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184769), // Rule ID 2399 //
     /* 184737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 184745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2151:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 184761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184767 */     GIR_RootConstrainSelectedInstOperands,
     /* 184768 */     // GIR_Coverage, 2399,
     /* 184768 */     GIR_EraseRootFromParent_Done,
     /* 184769 */   // Label 3590: @184769
     /* 184769 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184806), // Rule ID 2400 //
     /* 184774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 184782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 184798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184804 */     GIR_RootConstrainSelectedInstOperands,
     /* 184805 */     // GIR_Coverage, 2400,
     /* 184805 */     GIR_EraseRootFromParent_Done,
     /* 184806 */   // Label 3591: @184806
     /* 184806 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184843), // Rule ID 2401 //
     /* 184811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 184819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 184835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184841 */     GIR_RootConstrainSelectedInstOperands,
     /* 184842 */     // GIR_Coverage, 2401,
     /* 184842 */     GIR_EraseRootFromParent_Done,
     /* 184843 */   // Label 3592: @184843
     /* 184843 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184880), // Rule ID 2403 //
     /* 184848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 184856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2156:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 184872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184878 */     GIR_RootConstrainSelectedInstOperands,
     /* 184879 */     // GIR_Coverage, 2403,
     /* 184879 */     GIR_EraseRootFromParent_Done,
     /* 184880 */   // Label 3593: @184880
     /* 184880 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184917), // Rule ID 2404 //
     /* 184885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 184893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 184909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184915 */     GIR_RootConstrainSelectedInstOperands,
     /* 184916 */     // GIR_Coverage, 2404,
     /* 184916 */     GIR_EraseRootFromParent_Done,
     /* 184917 */   // Label 3594: @184917
     /* 184917 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184954), // Rule ID 2405 //
     /* 184922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 184930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184943 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 184946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184952 */     GIR_RootConstrainSelectedInstOperands,
     /* 184953 */     // GIR_Coverage, 2405,
     /* 184953 */     GIR_EraseRootFromParent_Done,
     /* 184954 */   // Label 3595: @184954
     /* 184954 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184991), // Rule ID 2407 //
     /* 184959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 184967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184980 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2077:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 184983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184989 */     GIR_RootConstrainSelectedInstOperands,
     /* 184990 */     // GIR_Coverage, 2407,
     /* 184990 */     GIR_EraseRootFromParent_Done,
     /* 184991 */   // Label 3596: @184991
     /* 184991 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185028), // Rule ID 2408 //
     /* 184996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 185004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 185020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185026 */     GIR_RootConstrainSelectedInstOperands,
     /* 185027 */     // GIR_Coverage, 2408,
     /* 185027 */     GIR_EraseRootFromParent_Done,
     /* 185028 */   // Label 3597: @185028
     /* 185028 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185065), // Rule ID 2409 //
     /* 185033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 185041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185054 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 185057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185063 */     GIR_RootConstrainSelectedInstOperands,
     /* 185064 */     // GIR_Coverage, 2409,
     /* 185064 */     GIR_EraseRootFromParent_Done,
     /* 185065 */   // Label 3598: @185065
     /* 185065 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185102), // Rule ID 2411 //
     /* 185070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 185078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185091 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 185094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185100 */     GIR_RootConstrainSelectedInstOperands,
     /* 185101 */     // GIR_Coverage, 2411,
     /* 185101 */     GIR_EraseRootFromParent_Done,
     /* 185102 */   // Label 3599: @185102
     /* 185102 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185139), // Rule ID 2412 //
     /* 185107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 185115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 185131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185137 */     GIR_RootConstrainSelectedInstOperands,
     /* 185138 */     // GIR_Coverage, 2412,
     /* 185138 */     GIR_EraseRootFromParent_Done,
     /* 185139 */   // Label 3600: @185139
     /* 185139 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(185176), // Rule ID 2413 //
     /* 185144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 185152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185165 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 185168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185174 */     GIR_RootConstrainSelectedInstOperands,
     /* 185175 */     // GIR_Coverage, 2413,
     /* 185175 */     GIR_EraseRootFromParent_Done,
     /* 185176 */   // Label 3601: @185176
     /* 185176 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(185213), // Rule ID 2415 //
     /* 185181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 185189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 185205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185211 */     GIR_RootConstrainSelectedInstOperands,
     /* 185212 */     // GIR_Coverage, 2415,
     /* 185212 */     GIR_EraseRootFromParent_Done,
     /* 185213 */   // Label 3602: @185213
     /* 185213 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(185250), // Rule ID 2416 //
     /* 185218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 185226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185239 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 185242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185248 */     GIR_RootConstrainSelectedInstOperands,
     /* 185249 */     // GIR_Coverage, 2416,
     /* 185249 */     GIR_EraseRootFromParent_Done,
     /* 185250 */   // Label 3603: @185250
     /* 185250 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(185287), // Rule ID 2417 //
     /* 185255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 185263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 185279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185285 */     GIR_RootConstrainSelectedInstOperands,
     /* 185286 */     // GIR_Coverage, 2417,
     /* 185286 */     GIR_EraseRootFromParent_Done,
     /* 185287 */   // Label 3604: @185287
     /* 185287 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(185324), // Rule ID 2419 //
     /* 185292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 185300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1926:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 185316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185322 */     GIR_RootConstrainSelectedInstOperands,
     /* 185323 */     // GIR_Coverage, 2419,
     /* 185323 */     GIR_EraseRootFromParent_Done,
     /* 185324 */   // Label 3605: @185324
     /* 185324 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(185361), // Rule ID 2420 //
     /* 185329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 185337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 185353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185359 */     GIR_RootConstrainSelectedInstOperands,
     /* 185360 */     // GIR_Coverage, 2420,
     /* 185360 */     GIR_EraseRootFromParent_Done,
     /* 185361 */   // Label 3606: @185361
     /* 185361 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(185398), // Rule ID 2421 //
     /* 185366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 185374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185387 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 185390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185396 */     GIR_RootConstrainSelectedInstOperands,
     /* 185397 */     // GIR_Coverage, 2421,
     /* 185397 */     GIR_EraseRootFromParent_Done,
     /* 185398 */   // Label 3607: @185398
     /* 185398 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(185435), // Rule ID 2422 //
     /* 185403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 185406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 185411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1546:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 185424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 185427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 185431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 185433 */     GIR_RootConstrainSelectedInstOperands,
     /* 185434 */     // GIR_Coverage, 2422,
     /* 185434 */     GIR_EraseRootFromParent_Done,
     /* 185435 */   // Label 3608: @185435
     /* 185435 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(185475), // Rule ID 2621 //
     /* 185440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 185448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185461 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 185464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185473 */     GIR_RootConstrainSelectedInstOperands,
     /* 185474 */     // GIR_Coverage, 2621,
     /* 185474 */     GIR_EraseRootFromParent_Done,
     /* 185475 */   // Label 3609: @185475
     /* 185475 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185515), // Rule ID 2622 //
     /* 185480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 185504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185513 */     GIR_RootConstrainSelectedInstOperands,
     /* 185514 */     // GIR_Coverage, 2622,
     /* 185514 */     GIR_EraseRootFromParent_Done,
     /* 185515 */   // Label 3610: @185515
     /* 185515 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185555), // Rule ID 2623 //
     /* 185520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 185534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185541 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 185544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185553 */     GIR_RootConstrainSelectedInstOperands,
     /* 185554 */     // GIR_Coverage, 2623,
     /* 185554 */     GIR_EraseRootFromParent_Done,
     /* 185555 */   // Label 3611: @185555
     /* 185555 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185595), // Rule ID 2624 //
     /* 185560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185581 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 185584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185593 */     GIR_RootConstrainSelectedInstOperands,
     /* 185594 */     // GIR_Coverage, 2624,
     /* 185594 */     GIR_EraseRootFromParent_Done,
     /* 185595 */   // Label 3612: @185595
     /* 185595 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185635), // Rule ID 2625 //
     /* 185600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185621 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 185624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185633 */     GIR_RootConstrainSelectedInstOperands,
     /* 185634 */     // GIR_Coverage, 2625,
     /* 185634 */     GIR_EraseRootFromParent_Done,
     /* 185635 */   // Label 3613: @185635
     /* 185635 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185672), // Rule ID 2642 //
     /* 185640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185661 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 185664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185670 */     GIR_RootConstrainSelectedInstOperands,
     /* 185671 */     // GIR_Coverage, 2642,
     /* 185671 */     GIR_EraseRootFromParent_Done,
     /* 185672 */   // Label 3614: @185672
     /* 185672 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185709), // Rule ID 2643 //
     /* 185677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 185701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185707 */     GIR_RootConstrainSelectedInstOperands,
     /* 185708 */     // GIR_Coverage, 2643,
     /* 185708 */     GIR_EraseRootFromParent_Done,
     /* 185709 */   // Label 3615: @185709
     /* 185709 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185746), // Rule ID 2644 //
     /* 185714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 185738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185744 */     GIR_RootConstrainSelectedInstOperands,
     /* 185745 */     // GIR_Coverage, 2644,
     /* 185745 */     GIR_EraseRootFromParent_Done,
     /* 185746 */   // Label 3616: @185746
     /* 185746 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185783), // Rule ID 2645 //
     /* 185751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185772 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 185775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185781 */     GIR_RootConstrainSelectedInstOperands,
     /* 185782 */     // GIR_Coverage, 2645,
     /* 185782 */     GIR_EraseRootFromParent_Done,
     /* 185783 */   // Label 3617: @185783
     /* 185783 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185820), // Rule ID 2646 //
     /* 185788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 185802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185809 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 185812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185818 */     GIR_RootConstrainSelectedInstOperands,
     /* 185819 */     // GIR_Coverage, 2646,
     /* 185819 */     GIR_EraseRootFromParent_Done,
     /* 185820 */   // Label 3618: @185820
     /* 185820 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185857), // Rule ID 2647 //
     /* 185825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185846 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 185849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185855 */     GIR_RootConstrainSelectedInstOperands,
     /* 185856 */     // GIR_Coverage, 2647,
     /* 185856 */     GIR_EraseRootFromParent_Done,
     /* 185857 */   // Label 3619: @185857
     /* 185857 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185894), // Rule ID 2648 //
     /* 185862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185883 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 185886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185892 */     GIR_RootConstrainSelectedInstOperands,
     /* 185893 */     // GIR_Coverage, 2648,
     /* 185893 */     GIR_EraseRootFromParent_Done,
     /* 185894 */   // Label 3620: @185894
     /* 185894 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185931), // Rule ID 2826 //
     /* 185899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185920 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 185923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185929 */     GIR_RootConstrainSelectedInstOperands,
     /* 185930 */     // GIR_Coverage, 2826,
     /* 185930 */     GIR_EraseRootFromParent_Done,
     /* 185931 */   // Label 3621: @185931
     /* 185931 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185968), // Rule ID 2827 //
     /* 185936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185957 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 185960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185966 */     GIR_RootConstrainSelectedInstOperands,
     /* 185967 */     // GIR_Coverage, 2827,
     /* 185967 */     GIR_EraseRootFromParent_Done,
     /* 185968 */   // Label 3622: @185968
     /* 185968 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186005), // Rule ID 2828 //
     /* 185973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185994 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 185997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186003 */     GIR_RootConstrainSelectedInstOperands,
     /* 186004 */     // GIR_Coverage, 2828,
     /* 186004 */     GIR_EraseRootFromParent_Done,
     /* 186005 */   // Label 3623: @186005
     /* 186005 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(186042), // Rule ID 2999 //
     /* 186010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 186018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 186034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186040 */     GIR_RootConstrainSelectedInstOperands,
     /* 186041 */     // GIR_Coverage, 2999,
     /* 186041 */     GIR_EraseRootFromParent_Done,
     /* 186042 */   // Label 3624: @186042
     /* 186042 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(186079), // Rule ID 3000 //
     /* 186047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 186055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 186071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186077 */     GIR_RootConstrainSelectedInstOperands,
     /* 186078 */     // GIR_Coverage, 3000,
     /* 186078 */     GIR_EraseRootFromParent_Done,
     /* 186079 */   // Label 3625: @186079
     /* 186079 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(186116), // Rule ID 3001 //
     /* 186084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 186092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 186108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186114 */     GIR_RootConstrainSelectedInstOperands,
     /* 186115 */     // GIR_Coverage, 3001,
     /* 186115 */     GIR_EraseRootFromParent_Done,
     /* 186116 */   // Label 3626: @186116
     /* 186116 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(186153), // Rule ID 3002 //
     /* 186121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 186129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 186145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186151 */     GIR_RootConstrainSelectedInstOperands,
     /* 186152 */     // GIR_Coverage, 3002,
     /* 186152 */     GIR_EraseRootFromParent_Done,
     /* 186153 */   // Label 3627: @186153
     /* 186153 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(186190), // Rule ID 3003 //
     /* 186158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 186166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186179 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 186182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186188 */     GIR_RootConstrainSelectedInstOperands,
     /* 186189 */     // GIR_Coverage, 3003,
     /* 186189 */     GIR_EraseRootFromParent_Done,
     /* 186190 */   // Label 3628: @186190
     /* 186190 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(186227), // Rule ID 3025 //
     /* 186195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 186203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 186219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186225 */     GIR_RootConstrainSelectedInstOperands,
     /* 186226 */     // GIR_Coverage, 3025,
     /* 186226 */     GIR_EraseRootFromParent_Done,
     /* 186227 */   // Label 3629: @186227
     /* 186227 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(186264), // Rule ID 3026 //
     /* 186232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 186240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 186256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186262 */     GIR_RootConstrainSelectedInstOperands,
     /* 186263 */     // GIR_Coverage, 3026,
     /* 186263 */     GIR_EraseRootFromParent_Done,
     /* 186264 */   // Label 3630: @186264
     /* 186264 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(186301), // Rule ID 3027 //
     /* 186269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 186277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 186293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186299 */     GIR_RootConstrainSelectedInstOperands,
     /* 186300 */     // GIR_Coverage, 3027,
     /* 186300 */     GIR_EraseRootFromParent_Done,
     /* 186301 */   // Label 3631: @186301
     /* 186301 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(186338), // Rule ID 3031 //
     /* 186306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 186309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 186314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1631:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 186330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186336 */     GIR_RootConstrainSelectedInstOperands,
     /* 186337 */     // GIR_Coverage, 3031,
     /* 186337 */     GIR_EraseRootFromParent_Done,
     /* 186338 */   // Label 3632: @186338
     /* 186338 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(186375), // Rule ID 3032 //
     /* 186343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 186351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 186367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186373 */     GIR_RootConstrainSelectedInstOperands,
     /* 186374 */     // GIR_Coverage, 3032,
     /* 186374 */     GIR_EraseRootFromParent_Done,
     /* 186375 */   // Label 3633: @186375
     /* 186375 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186412), // Rule ID 3033 //
     /* 186380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 186388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 186404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186410 */     GIR_RootConstrainSelectedInstOperands,
     /* 186411 */     // GIR_Coverage, 3033,
     /* 186411 */     GIR_EraseRootFromParent_Done,
     /* 186412 */   // Label 3634: @186412
     /* 186412 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186449), // Rule ID 3034 //
     /* 186417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 186441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186447 */     GIR_RootConstrainSelectedInstOperands,
     /* 186448 */     // GIR_Coverage, 3034,
     /* 186448 */     GIR_EraseRootFromParent_Done,
     /* 186449 */   // Label 3635: @186449
     /* 186449 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186486), // Rule ID 3035 //
     /* 186454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 186478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186484 */     GIR_RootConstrainSelectedInstOperands,
     /* 186485 */     // GIR_Coverage, 3035,
     /* 186485 */     GIR_EraseRootFromParent_Done,
     /* 186486 */   // Label 3636: @186486
     /* 186486 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186523), // Rule ID 3036 //
     /* 186491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 186515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186521 */     GIR_RootConstrainSelectedInstOperands,
     /* 186522 */     // GIR_Coverage, 3036,
     /* 186522 */     GIR_EraseRootFromParent_Done,
     /* 186523 */   // Label 3637: @186523
     /* 186523 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186560), // Rule ID 3037 //
     /* 186528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 186552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186558 */     GIR_RootConstrainSelectedInstOperands,
     /* 186559 */     // GIR_Coverage, 3037,
     /* 186559 */     GIR_EraseRootFromParent_Done,
     /* 186560 */   // Label 3638: @186560
     /* 186560 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186597), // Rule ID 3038 //
     /* 186565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 186589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186595 */     GIR_RootConstrainSelectedInstOperands,
     /* 186596 */     // GIR_Coverage, 3038,
     /* 186596 */     GIR_EraseRootFromParent_Done,
     /* 186597 */   // Label 3639: @186597
     /* 186597 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186634), // Rule ID 3039 //
     /* 186602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 186626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186632 */     GIR_RootConstrainSelectedInstOperands,
     /* 186633 */     // GIR_Coverage, 3039,
     /* 186633 */     GIR_EraseRootFromParent_Done,
     /* 186634 */   // Label 3640: @186634
     /* 186634 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186671), // Rule ID 3040 //
     /* 186639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 186663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186669 */     GIR_RootConstrainSelectedInstOperands,
     /* 186670 */     // GIR_Coverage, 3040,
     /* 186670 */     GIR_EraseRootFromParent_Done,
     /* 186671 */   // Label 3641: @186671
     /* 186671 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186708), // Rule ID 3087 //
     /* 186676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186697 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 186700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186706 */     GIR_RootConstrainSelectedInstOperands,
     /* 186707 */     // GIR_Coverage, 3087,
     /* 186707 */     GIR_EraseRootFromParent_Done,
     /* 186708 */   // Label 3642: @186708
     /* 186708 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186745), // Rule ID 3088 //
     /* 186713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1250:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 186737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186743 */     GIR_RootConstrainSelectedInstOperands,
     /* 186744 */     // GIR_Coverage, 3088,
     /* 186744 */     GIR_EraseRootFromParent_Done,
     /* 186745 */   // Label 3643: @186745
     /* 186745 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186782), // Rule ID 3089 //
     /* 186750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1250:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 186774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186780 */     GIR_RootConstrainSelectedInstOperands,
     /* 186781 */     // GIR_Coverage, 3089,
     /* 186781 */     GIR_EraseRootFromParent_Done,
     /* 186782 */   // Label 3644: @186782
     /* 186782 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186819), // Rule ID 3096 //
     /* 186787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 186811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186817 */     GIR_RootConstrainSelectedInstOperands,
     /* 186818 */     // GIR_Coverage, 3096,
     /* 186818 */     GIR_EraseRootFromParent_Done,
     /* 186819 */   // Label 3645: @186819
     /* 186819 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186856), // Rule ID 3097 //
     /* 186824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 186848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186854 */     GIR_RootConstrainSelectedInstOperands,
     /* 186855 */     // GIR_Coverage, 3097,
     /* 186855 */     GIR_EraseRootFromParent_Done,
     /* 186856 */   // Label 3646: @186856
     /* 186856 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186893), // Rule ID 3098 //
     /* 186861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 186885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186891 */     GIR_RootConstrainSelectedInstOperands,
     /* 186892 */     // GIR_Coverage, 3098,
     /* 186892 */     GIR_EraseRootFromParent_Done,
     /* 186893 */   // Label 3647: @186893
     /* 186893 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186933), // Rule ID 3202 //
     /* 186898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186919 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 186922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186931 */     GIR_RootConstrainSelectedInstOperands,
     /* 186932 */     // GIR_Coverage, 3202,
     /* 186932 */     GIR_EraseRootFromParent_Done,
     /* 186933 */   // Label 3648: @186933
     /* 186933 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186973), // Rule ID 3203 //
     /* 186938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 186962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186971 */     GIR_RootConstrainSelectedInstOperands,
     /* 186972 */     // GIR_Coverage, 3203,
     /* 186972 */     GIR_EraseRootFromParent_Done,
     /* 186973 */   // Label 3649: @186973
     /* 186973 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187013), // Rule ID 3204 //
     /* 186978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186999 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 187002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187011 */     GIR_RootConstrainSelectedInstOperands,
     /* 187012 */     // GIR_Coverage, 3204,
     /* 187012 */     GIR_EraseRootFromParent_Done,
     /* 187013 */   // Label 3650: @187013
     /* 187013 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(187053), // Rule ID 3205 //
     /* 187018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 187026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 187042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187051 */     GIR_RootConstrainSelectedInstOperands,
     /* 187052 */     // GIR_Coverage, 3205,
     /* 187052 */     GIR_EraseRootFromParent_Done,
     /* 187053 */   // Label 3651: @187053
     /* 187053 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(187093), // Rule ID 3210 //
     /* 187058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 187066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 187082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187091 */     GIR_RootConstrainSelectedInstOperands,
     /* 187092 */     // GIR_Coverage, 3210,
     /* 187092 */     GIR_EraseRootFromParent_Done,
     /* 187093 */   // Label 3652: @187093
     /* 187093 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(187133), // Rule ID 3211 //
     /* 187098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 187106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187119 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 187122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187131 */     GIR_RootConstrainSelectedInstOperands,
     /* 187132 */     // GIR_Coverage, 3211,
     /* 187132 */     GIR_EraseRootFromParent_Done,
     /* 187133 */   // Label 3653: @187133
     /* 187133 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(187173), // Rule ID 3212 //
     /* 187138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 187146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187159 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 187162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187171 */     GIR_RootConstrainSelectedInstOperands,
     /* 187172 */     // GIR_Coverage, 3212,
     /* 187172 */     GIR_EraseRootFromParent_Done,
     /* 187173 */   // Label 3654: @187173
     /* 187173 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(187213), // Rule ID 3213 //
     /* 187178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 187186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187199 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 187202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187211 */     GIR_RootConstrainSelectedInstOperands,
     /* 187212 */     // GIR_Coverage, 3213,
     /* 187212 */     GIR_EraseRootFromParent_Done,
     /* 187213 */   // Label 3655: @187213
     /* 187213 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187250), // Rule ID 3402 //
     /* 187218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 187221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 187226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 187242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187248 */     GIR_RootConstrainSelectedInstOperands,
     /* 187249 */     // GIR_Coverage, 3402,
     /* 187249 */     GIR_EraseRootFromParent_Done,
     /* 187250 */   // Label 3656: @187250
     /* 187250 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187287), // Rule ID 3403 //
     /* 187255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 187258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 187263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187276 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 187279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187285 */     GIR_RootConstrainSelectedInstOperands,
     /* 187286 */     // GIR_Coverage, 3403,
     /* 187286 */     GIR_EraseRootFromParent_Done,
     /* 187287 */   // Label 3657: @187287
     /* 187287 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(187324), // Rule ID 3404 //
     /* 187292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 187295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 187300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187313 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 187316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187322 */     GIR_RootConstrainSelectedInstOperands,
     /* 187323 */     // GIR_Coverage, 3404,
     /* 187323 */     GIR_EraseRootFromParent_Done,
     /* 187324 */   // Label 3658: @187324
     /* 187324 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187361), // Rule ID 3405 //
     /* 187329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 187332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 187337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 187353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187359 */     GIR_RootConstrainSelectedInstOperands,
     /* 187360 */     // GIR_Coverage, 3405,
     /* 187360 */     GIR_EraseRootFromParent_Done,
     /* 187361 */   // Label 3659: @187361
     /* 187361 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187398), // Rule ID 3427 //
     /* 187366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187387 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 187390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187396 */     GIR_RootConstrainSelectedInstOperands,
     /* 187397 */     // GIR_Coverage, 3427,
     /* 187397 */     GIR_EraseRootFromParent_Done,
     /* 187398 */   // Label 3660: @187398
     /* 187398 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187435), // Rule ID 3428 //
     /* 187403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 187427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187433 */     GIR_RootConstrainSelectedInstOperands,
     /* 187434 */     // GIR_Coverage, 3428,
     /* 187434 */     GIR_EraseRootFromParent_Done,
     /* 187435 */   // Label 3661: @187435
     /* 187435 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187472), // Rule ID 3429 //
     /* 187440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187461 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 187464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187470 */     GIR_RootConstrainSelectedInstOperands,
     /* 187471 */     // GIR_Coverage, 3429,
     /* 187471 */     GIR_EraseRootFromParent_Done,
     /* 187472 */   // Label 3662: @187472
     /* 187472 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187509), // Rule ID 3451 //
     /* 187477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 187485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187498 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 187501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187507 */     GIR_RootConstrainSelectedInstOperands,
     /* 187508 */     // GIR_Coverage, 3451,
     /* 187508 */     GIR_EraseRootFromParent_Done,
     /* 187509 */   // Label 3663: @187509
     /* 187509 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187546), // Rule ID 3456 //
     /* 187514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 187517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 187522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 187538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187544 */     GIR_RootConstrainSelectedInstOperands,
     /* 187545 */     // GIR_Coverage, 3456,
     /* 187545 */     GIR_EraseRootFromParent_Done,
     /* 187546 */   // Label 3664: @187546
     /* 187546 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187583), // Rule ID 3457 //
     /* 187551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 187554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 187559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 187575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187581 */     GIR_RootConstrainSelectedInstOperands,
     /* 187582 */     // GIR_Coverage, 3457,
     /* 187582 */     GIR_EraseRootFromParent_Done,
     /* 187583 */   // Label 3665: @187583
     /* 187583 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187620), // Rule ID 3466 //
     /* 187588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187609 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187618 */     GIR_RootConstrainSelectedInstOperands,
     /* 187619 */     // GIR_Coverage, 3466,
     /* 187619 */     GIR_EraseRootFromParent_Done,
     /* 187620 */   // Label 3666: @187620
     /* 187620 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187657), // Rule ID 3467 //
     /* 187625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187655 */     GIR_RootConstrainSelectedInstOperands,
     /* 187656 */     // GIR_Coverage, 3467,
     /* 187656 */     GIR_EraseRootFromParent_Done,
     /* 187657 */   // Label 3667: @187657
     /* 187657 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187694), // Rule ID 3468 //
     /* 187662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187683 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187692 */     GIR_RootConstrainSelectedInstOperands,
     /* 187693 */     // GIR_Coverage, 3468,
     /* 187693 */     GIR_EraseRootFromParent_Done,
     /* 187694 */   // Label 3668: @187694
     /* 187694 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187731), // Rule ID 3469 //
     /* 187699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187729 */     GIR_RootConstrainSelectedInstOperands,
     /* 187730 */     // GIR_Coverage, 3469,
     /* 187730 */     GIR_EraseRootFromParent_Done,
     /* 187731 */   // Label 3669: @187731
     /* 187731 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187768), // Rule ID 3470 //
     /* 187736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187757 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187766 */     GIR_RootConstrainSelectedInstOperands,
     /* 187767 */     // GIR_Coverage, 3470,
     /* 187767 */     GIR_EraseRootFromParent_Done,
     /* 187768 */   // Label 3670: @187768
     /* 187768 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187805), // Rule ID 3471 //
     /* 187773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187803 */     GIR_RootConstrainSelectedInstOperands,
     /* 187804 */     // GIR_Coverage, 3471,
     /* 187804 */     GIR_EraseRootFromParent_Done,
     /* 187805 */   // Label 3671: @187805
     /* 187805 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187842), // Rule ID 3472 //
     /* 187810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187831 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187840 */     GIR_RootConstrainSelectedInstOperands,
     /* 187841 */     // GIR_Coverage, 3472,
     /* 187841 */     GIR_EraseRootFromParent_Done,
     /* 187842 */   // Label 3672: @187842
     /* 187842 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187879), // Rule ID 3527 //
     /* 187847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187868 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 187871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187877 */     GIR_RootConstrainSelectedInstOperands,
     /* 187878 */     // GIR_Coverage, 3527,
     /* 187878 */     GIR_EraseRootFromParent_Done,
     /* 187879 */   // Label 3673: @187879
     /* 187879 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187916), // Rule ID 3528 //
     /* 187884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187905 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 187908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187914 */     GIR_RootConstrainSelectedInstOperands,
     /* 187915 */     // GIR_Coverage, 3528,
     /* 187915 */     GIR_EraseRootFromParent_Done,
     /* 187916 */   // Label 3674: @187916
     /* 187916 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187953), // Rule ID 3529 //
     /* 187921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187942 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 187945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187951 */     GIR_RootConstrainSelectedInstOperands,
     /* 187952 */     // GIR_Coverage, 3529,
     /* 187952 */     GIR_EraseRootFromParent_Done,
     /* 187953 */   // Label 3675: @187953
     /* 187953 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187990), // Rule ID 3559 //
     /* 187958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187979 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 187982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187988 */     GIR_RootConstrainSelectedInstOperands,
     /* 187989 */     // GIR_Coverage, 3559,
     /* 187989 */     GIR_EraseRootFromParent_Done,
     /* 187990 */   // Label 3676: @187990
     /* 187990 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(188027), // Rule ID 3560 //
     /* 187995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 188003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 188009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188016 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 188019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 188021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188025 */     GIR_RootConstrainSelectedInstOperands,
     /* 188026 */     // GIR_Coverage, 3560,
     /* 188026 */     GIR_EraseRootFromParent_Done,
     /* 188027 */   // Label 3677: @188027
     /* 188027 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(188064), // Rule ID 3561 //
     /* 188032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 188040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 188046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188053 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 188056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 188058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188062 */     GIR_RootConstrainSelectedInstOperands,
     /* 188063 */     // GIR_Coverage, 3561,
     /* 188063 */     GIR_EraseRootFromParent_Done,
     /* 188064 */   // Label 3678: @188064
     /* 188064 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(188101), // Rule ID 3562 //
     /* 188069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 188077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 188083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188090 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 188093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 188095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188099 */     GIR_RootConstrainSelectedInstOperands,
     /* 188100 */     // GIR_Coverage, 3562,
     /* 188100 */     GIR_EraseRootFromParent_Done,
     /* 188101 */   // Label 3679: @188101
     /* 188101 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(188138), // Rule ID 3563 //
     /* 188106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2162:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 188130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188136 */     GIR_RootConstrainSelectedInstOperands,
     /* 188137 */     // GIR_Coverage, 3563,
     /* 188137 */     GIR_EraseRootFromParent_Done,
     /* 188138 */   // Label 3680: @188138
     /* 188138 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(188175), // Rule ID 3564 //
     /* 188143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2162:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 188167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188173 */     GIR_RootConstrainSelectedInstOperands,
     /* 188174 */     // GIR_Coverage, 3564,
     /* 188174 */     GIR_EraseRootFromParent_Done,
     /* 188175 */   // Label 3681: @188175
     /* 188175 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188212), // Rule ID 3565 //
     /* 188180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 188204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188210 */     GIR_RootConstrainSelectedInstOperands,
     /* 188211 */     // GIR_Coverage, 3565,
     /* 188211 */     GIR_EraseRootFromParent_Done,
     /* 188212 */   // Label 3682: @188212
     /* 188212 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188249), // Rule ID 3566 //
     /* 188217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 188241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188247 */     GIR_RootConstrainSelectedInstOperands,
     /* 188248 */     // GIR_Coverage, 3566,
     /* 188248 */     GIR_EraseRootFromParent_Done,
     /* 188249 */   // Label 3683: @188249
     /* 188249 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188286), // Rule ID 3567 //
     /* 188254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2162:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 188275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 188278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188284 */     GIR_RootConstrainSelectedInstOperands,
     /* 188285 */     // GIR_Coverage, 3567,
     /* 188285 */     GIR_EraseRootFromParent_Done,
     /* 188286 */   // Label 3684: @188286
     /* 188286 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188323), // Rule ID 3568 //
     /* 188291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 188312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 188315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188321 */     GIR_RootConstrainSelectedInstOperands,
     /* 188322 */     // GIR_Coverage, 3568,
     /* 188322 */     GIR_EraseRootFromParent_Done,
     /* 188323 */   // Label 3685: @188323
     /* 188323 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188360), // Rule ID 3569 //
     /* 188328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 188336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188349 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2162:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 188349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 188352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188358 */     GIR_RootConstrainSelectedInstOperands,
     /* 188359 */     // GIR_Coverage, 3569,
     /* 188359 */     GIR_EraseRootFromParent_Done,
     /* 188360 */   // Label 3686: @188360
     /* 188360 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188397), // Rule ID 3570 //
     /* 188365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 188389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188395 */     GIR_RootConstrainSelectedInstOperands,
     /* 188396 */     // GIR_Coverage, 3570,
     /* 188396 */     GIR_EraseRootFromParent_Done,
     /* 188397 */   // Label 3687: @188397
     /* 188397 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188434), // Rule ID 3571 //
     /* 188402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 188426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188432 */     GIR_RootConstrainSelectedInstOperands,
     /* 188433 */     // GIR_Coverage, 3571,
     /* 188433 */     GIR_EraseRootFromParent_Done,
     /* 188434 */   // Label 3688: @188434
     /* 188434 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188471), // Rule ID 3572 //
     /* 188439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 188463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188469 */     GIR_RootConstrainSelectedInstOperands,
     /* 188470 */     // GIR_Coverage, 3572,
     /* 188470 */     GIR_EraseRootFromParent_Done,
     /* 188471 */   // Label 3689: @188471
     /* 188471 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188508), // Rule ID 3573 //
     /* 188476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 188500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188506 */     GIR_RootConstrainSelectedInstOperands,
     /* 188507 */     // GIR_Coverage, 3573,
     /* 188507 */     GIR_EraseRootFromParent_Done,
     /* 188508 */   // Label 3690: @188508
     /* 188508 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188545), // Rule ID 3574 //
     /* 188513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1917:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 188537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188543 */     GIR_RootConstrainSelectedInstOperands,
     /* 188544 */     // GIR_Coverage, 3574,
     /* 188544 */     GIR_EraseRootFromParent_Done,
     /* 188545 */   // Label 3691: @188545
     /* 188545 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188582), // Rule ID 3575 //
     /* 188550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1917:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 188574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188580 */     GIR_RootConstrainSelectedInstOperands,
     /* 188581 */     // GIR_Coverage, 3575,
     /* 188581 */     GIR_EraseRootFromParent_Done,
     /* 188582 */   // Label 3692: @188582
     /* 188582 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188619), // Rule ID 3576 //
     /* 188587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1917:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 188611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188617 */     GIR_RootConstrainSelectedInstOperands,
     /* 188618 */     // GIR_Coverage, 3576,
     /* 188618 */     GIR_EraseRootFromParent_Done,
     /* 188619 */   // Label 3693: @188619
     /* 188619 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188656), // Rule ID 8386 //
     /* 188624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 188632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 188638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 188641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188645 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 188645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 188648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188654 */     GIR_RootConstrainSelectedInstOperands,
     /* 188655 */     // GIR_Coverage, 8386,
     /* 188655 */     GIR_EraseRootFromParent_Done,
     /* 188656 */   // Label 3694: @188656
     /* 188656 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188693), // Rule ID 8862 //
     /* 188661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 188669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 188685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188691 */     GIR_RootConstrainSelectedInstOperands,
     /* 188692 */     // GIR_Coverage, 8862,
     /* 188692 */     GIR_EraseRootFromParent_Done,
     /* 188693 */   // Label 3695: @188693
     /* 188693 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188730), // Rule ID 8863 //
     /* 188698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 188722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188728 */     GIR_RootConstrainSelectedInstOperands,
     /* 188729 */     // GIR_Coverage, 8863,
     /* 188729 */     GIR_EraseRootFromParent_Done,
     /* 188730 */   // Label 3696: @188730
     /* 188730 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188767), // Rule ID 8864 //
     /* 188735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 188759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188765 */     GIR_RootConstrainSelectedInstOperands,
     /* 188766 */     // GIR_Coverage, 8864,
     /* 188766 */     GIR_EraseRootFromParent_Done,
     /* 188767 */   // Label 3697: @188767
     /* 188767 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188804), // Rule ID 8865 //
     /* 188772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 188796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188802 */     GIR_RootConstrainSelectedInstOperands,
     /* 188803 */     // GIR_Coverage, 8865,
     /* 188803 */     GIR_EraseRootFromParent_Done,
     /* 188804 */   // Label 3698: @188804
     /* 188804 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188841), // Rule ID 8866 //
     /* 188809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 188817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 188833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188839 */     GIR_RootConstrainSelectedInstOperands,
     /* 188840 */     // GIR_Coverage, 8866,
     /* 188840 */     GIR_EraseRootFromParent_Done,
     /* 188841 */   // Label 3699: @188841
     /* 188841 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188878), // Rule ID 8867 //
     /* 188846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 188870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188876 */     GIR_RootConstrainSelectedInstOperands,
     /* 188877 */     // GIR_Coverage, 8867,
     /* 188877 */     GIR_EraseRootFromParent_Done,
     /* 188878 */   // Label 3700: @188878
     /* 188878 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188915), // Rule ID 8868 //
     /* 188883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188913 */     GIR_RootConstrainSelectedInstOperands,
     /* 188914 */     // GIR_Coverage, 8868,
     /* 188914 */     GIR_EraseRootFromParent_Done,
     /* 188915 */   // Label 3701: @188915
     /* 188915 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188952), // Rule ID 8869 //
     /* 188920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 188944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188950 */     GIR_RootConstrainSelectedInstOperands,
     /* 188951 */     // GIR_Coverage, 8869,
     /* 188951 */     GIR_EraseRootFromParent_Done,
     /* 188952 */   // Label 3702: @188952
     /* 188952 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188992), // Rule ID 9869 //
     /* 188957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188978 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 188981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188990 */     GIR_RootConstrainSelectedInstOperands,
     /* 188991 */     // GIR_Coverage, 9869,
     /* 188991 */     GIR_EraseRootFromParent_Done,
     /* 188992 */   // Label 3703: @188992
     /* 188992 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(189032), // Rule ID 9870 //
     /* 188997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 189021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189030 */     GIR_RootConstrainSelectedInstOperands,
     /* 189031 */     // GIR_Coverage, 9870,
     /* 189031 */     GIR_EraseRootFromParent_Done,
     /* 189032 */   // Label 3704: @189032
     /* 189032 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(189072), // Rule ID 9871 //
     /* 189037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189058 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 189061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189070 */     GIR_RootConstrainSelectedInstOperands,
     /* 189071 */     // GIR_Coverage, 9871,
     /* 189071 */     GIR_EraseRootFromParent_Done,
     /* 189072 */   // Label 3705: @189072
     /* 189072 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(189112), // Rule ID 9872 //
     /* 189077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 189101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189110 */     GIR_RootConstrainSelectedInstOperands,
     /* 189111 */     // GIR_Coverage, 9872,
     /* 189111 */     GIR_EraseRootFromParent_Done,
     /* 189112 */   // Label 3706: @189112
     /* 189112 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(189152), // Rule ID 9873 //
     /* 189117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 189141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189150 */     GIR_RootConstrainSelectedInstOperands,
     /* 189151 */     // GIR_Coverage, 9873,
     /* 189151 */     GIR_EraseRootFromParent_Done,
     /* 189152 */   // Label 3707: @189152
     /* 189152 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(189192), // Rule ID 9874 //
     /* 189157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 189181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189190 */     GIR_RootConstrainSelectedInstOperands,
     /* 189191 */     // GIR_Coverage, 9874,
     /* 189191 */     GIR_EraseRootFromParent_Done,
     /* 189192 */   // Label 3708: @189192
     /* 189192 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189232), // Rule ID 9875 //
     /* 189197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 189221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189230 */     GIR_RootConstrainSelectedInstOperands,
     /* 189231 */     // GIR_Coverage, 9875,
     /* 189231 */     GIR_EraseRootFromParent_Done,
     /* 189232 */   // Label 3709: @189232
     /* 189232 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189272), // Rule ID 9876 //
     /* 189237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 189261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189270 */     GIR_RootConstrainSelectedInstOperands,
     /* 189271 */     // GIR_Coverage, 9876,
     /* 189271 */     GIR_EraseRootFromParent_Done,
     /* 189272 */   // Label 3710: @189272
     /* 189272 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189312), // Rule ID 9881 //
     /* 189277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 189301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189310 */     GIR_RootConstrainSelectedInstOperands,
     /* 189311 */     // GIR_Coverage, 9881,
     /* 189311 */     GIR_EraseRootFromParent_Done,
     /* 189312 */   // Label 3711: @189312
     /* 189312 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189352), // Rule ID 9882 //
     /* 189317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 189341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189350 */     GIR_RootConstrainSelectedInstOperands,
     /* 189351 */     // GIR_Coverage, 9882,
     /* 189351 */     GIR_EraseRootFromParent_Done,
     /* 189352 */   // Label 3712: @189352
     /* 189352 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189392), // Rule ID 9883 //
     /* 189357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 189381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189390 */     GIR_RootConstrainSelectedInstOperands,
     /* 189391 */     // GIR_Coverage, 9883,
     /* 189391 */     GIR_EraseRootFromParent_Done,
     /* 189392 */   // Label 3713: @189392
     /* 189392 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(189432), // Rule ID 9884 //
     /* 189397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 189421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189430 */     GIR_RootConstrainSelectedInstOperands,
     /* 189431 */     // GIR_Coverage, 9884,
     /* 189431 */     GIR_EraseRootFromParent_Done,
     /* 189432 */   // Label 3714: @189432
     /* 189432 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189472), // Rule ID 9885 //
     /* 189437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 189461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189470 */     GIR_RootConstrainSelectedInstOperands,
     /* 189471 */     // GIR_Coverage, 9885,
     /* 189471 */     GIR_EraseRootFromParent_Done,
     /* 189472 */   // Label 3715: @189472
     /* 189472 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(189512), // Rule ID 9886 //
     /* 189477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 189501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189510 */     GIR_RootConstrainSelectedInstOperands,
     /* 189511 */     // GIR_Coverage, 9886,
     /* 189511 */     GIR_EraseRootFromParent_Done,
     /* 189512 */   // Label 3716: @189512
     /* 189512 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189552), // Rule ID 9887 //
     /* 189517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189538 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 189541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189550 */     GIR_RootConstrainSelectedInstOperands,
     /* 189551 */     // GIR_Coverage, 9887,
     /* 189551 */     GIR_EraseRootFromParent_Done,
     /* 189552 */   // Label 3717: @189552
     /* 189552 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(189592), // Rule ID 9888 //
     /* 189557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189578 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 189581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189590 */     GIR_RootConstrainSelectedInstOperands,
     /* 189591 */     // GIR_Coverage, 9888,
     /* 189591 */     GIR_EraseRootFromParent_Done,
     /* 189592 */   // Label 3718: @189592
     /* 189592 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189632), // Rule ID 9889 //
     /* 189597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189618 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 189621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189630 */     GIR_RootConstrainSelectedInstOperands,
     /* 189631 */     // GIR_Coverage, 9889,
     /* 189631 */     GIR_EraseRootFromParent_Done,
     /* 189632 */   // Label 3719: @189632
     /* 189632 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189672), // Rule ID 9890 //
     /* 189637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 189661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189670 */     GIR_RootConstrainSelectedInstOperands,
     /* 189671 */     // GIR_Coverage, 9890,
     /* 189671 */     GIR_EraseRootFromParent_Done,
     /* 189672 */   // Label 3720: @189672
     /* 189672 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189712), // Rule ID 9891 //
     /* 189677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 189701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189710 */     GIR_RootConstrainSelectedInstOperands,
     /* 189711 */     // GIR_Coverage, 9891,
     /* 189711 */     GIR_EraseRootFromParent_Done,
     /* 189712 */   // Label 3721: @189712
     /* 189712 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189752), // Rule ID 9892 //
     /* 189717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 189741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189750 */     GIR_RootConstrainSelectedInstOperands,
     /* 189751 */     // GIR_Coverage, 9892,
     /* 189751 */     GIR_EraseRootFromParent_Done,
     /* 189752 */   // Label 3722: @189752
     /* 189752 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189792), // Rule ID 9897 //
     /* 189757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 189781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189790 */     GIR_RootConstrainSelectedInstOperands,
     /* 189791 */     // GIR_Coverage, 9897,
     /* 189791 */     GIR_EraseRootFromParent_Done,
     /* 189792 */   // Label 3723: @189792
     /* 189792 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189832), // Rule ID 9898 //
     /* 189797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 189821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189830 */     GIR_RootConstrainSelectedInstOperands,
     /* 189831 */     // GIR_Coverage, 9898,
     /* 189831 */     GIR_EraseRootFromParent_Done,
     /* 189832 */   // Label 3724: @189832
     /* 189832 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189872), // Rule ID 9899 //
     /* 189837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 189861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189870 */     GIR_RootConstrainSelectedInstOperands,
     /* 189871 */     // GIR_Coverage, 9899,
     /* 189871 */     GIR_EraseRootFromParent_Done,
     /* 189872 */   // Label 3725: @189872
     /* 189872 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189912), // Rule ID 9900 //
     /* 189877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 189901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189910 */     GIR_RootConstrainSelectedInstOperands,
     /* 189911 */     // GIR_Coverage, 9900,
     /* 189911 */     GIR_EraseRootFromParent_Done,
     /* 189912 */   // Label 3726: @189912
     /* 189912 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189949), // Rule ID 10059 //
     /* 189917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 189941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189947 */     GIR_RootConstrainSelectedInstOperands,
     /* 189948 */     // GIR_Coverage, 10059,
     /* 189948 */     GIR_EraseRootFromParent_Done,
     /* 189949 */   // Label 3727: @189949
     /* 189949 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189986), // Rule ID 10060 //
     /* 189954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 189978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189984 */     GIR_RootConstrainSelectedInstOperands,
     /* 189985 */     // GIR_Coverage, 10060,
     /* 189985 */     GIR_EraseRootFromParent_Done,
     /* 189986 */   // Label 3728: @189986
     /* 189986 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(190023), // Rule ID 10061 //
     /* 189991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 190008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 190012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 190015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190021 */     GIR_RootConstrainSelectedInstOperands,
     /* 190022 */     // GIR_Coverage, 10061,
     /* 190022 */     GIR_EraseRootFromParent_Done,
     /* 190023 */   // Label 3729: @190023
     /* 190023 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(190060), // Rule ID 10062 //
     /* 190028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 190036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 190045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 190049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 190052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190058 */     GIR_RootConstrainSelectedInstOperands,
     /* 190059 */     // GIR_Coverage, 10062,
     /* 190059 */     GIR_EraseRootFromParent_Done,
     /* 190060 */   // Label 3730: @190060
     /* 190060 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(190097), // Rule ID 10063 //
     /* 190065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 190073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 190082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 190086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 190089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190095 */     GIR_RootConstrainSelectedInstOperands,
     /* 190096 */     // GIR_Coverage, 10063,
     /* 190096 */     GIR_EraseRootFromParent_Done,
     /* 190097 */   // Label 3731: @190097
     /* 190097 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(190134), // Rule ID 10064 //
     /* 190102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 190110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 190119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 190123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 190126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190132 */     GIR_RootConstrainSelectedInstOperands,
     /* 190133 */     // GIR_Coverage, 10064,
     /* 190133 */     GIR_EraseRootFromParent_Done,
     /* 190134 */   // Label 3732: @190134
     /* 190134 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(190171), // Rule ID 10065 //
     /* 190139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 190147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 190156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 190160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 190163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190169 */     GIR_RootConstrainSelectedInstOperands,
     /* 190170 */     // GIR_Coverage, 10065,
     /* 190170 */     GIR_EraseRootFromParent_Done,
     /* 190171 */   // Label 3733: @190171
     /* 190171 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(190208), // Rule ID 10066 //
     /* 190176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 190184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 190193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 190197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 190200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190206 */     GIR_RootConstrainSelectedInstOperands,
     /* 190207 */     // GIR_Coverage, 10066,
     /* 190207 */     GIR_EraseRootFromParent_Done,
     /* 190208 */   // Label 3734: @190208
     /* 190208 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(190245), // Rule ID 10067 //
     /* 190213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 190216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 190221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 190230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 190234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 190237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 190239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190243 */     GIR_RootConstrainSelectedInstOperands,
     /* 190244 */     // GIR_Coverage, 10067,
     /* 190244 */     GIR_EraseRootFromParent_Done,
     /* 190245 */   // Label 3735: @190245
     /* 190245 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190282), // Rule ID 11255 //
     /* 190250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2159:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190280 */     GIR_RootConstrainSelectedInstOperands,
     /* 190281 */     // GIR_Coverage, 11255,
     /* 190281 */     GIR_EraseRootFromParent_Done,
     /* 190282 */   // Label 3736: @190282
     /* 190282 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190319), // Rule ID 11256 //
     /* 190287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2159:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190317 */     GIR_RootConstrainSelectedInstOperands,
     /* 190318 */     // GIR_Coverage, 11256,
     /* 190318 */     GIR_EraseRootFromParent_Done,
     /* 190319 */   // Label 3737: @190319
     /* 190319 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190356), // Rule ID 11257 //
     /* 190324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190345 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2159:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190354 */     GIR_RootConstrainSelectedInstOperands,
     /* 190355 */     // GIR_Coverage, 11257,
     /* 190355 */     GIR_EraseRootFromParent_Done,
     /* 190356 */   // Label 3738: @190356
     /* 190356 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190393), // Rule ID 11258 //
     /* 190361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2159:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190391 */     GIR_RootConstrainSelectedInstOperands,
     /* 190392 */     // GIR_Coverage, 11258,
     /* 190392 */     GIR_EraseRootFromParent_Done,
     /* 190393 */   // Label 3739: @190393
     /* 190393 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(190430), // Rule ID 11259 //
     /* 190398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190419 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190428 */     GIR_RootConstrainSelectedInstOperands,
     /* 190429 */     // GIR_Coverage, 11259,
     /* 190429 */     GIR_EraseRootFromParent_Done,
     /* 190430 */   // Label 3740: @190430
     /* 190430 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(190467), // Rule ID 11260 //
     /* 190435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2159:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190465 */     GIR_RootConstrainSelectedInstOperands,
     /* 190466 */     // GIR_Coverage, 11260,
     /* 190466 */     GIR_EraseRootFromParent_Done,
     /* 190467 */   // Label 3741: @190467
     /* 190467 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(190504), // Rule ID 11261 //
     /* 190472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190493 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2159:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190502 */     GIR_RootConstrainSelectedInstOperands,
     /* 190503 */     // GIR_Coverage, 11261,
     /* 190503 */     GIR_EraseRootFromParent_Done,
     /* 190504 */   // Label 3742: @190504
     /* 190504 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190541), // Rule ID 11262 //
     /* 190509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190539 */     GIR_RootConstrainSelectedInstOperands,
     /* 190540 */     // GIR_Coverage, 11262,
     /* 190540 */     GIR_EraseRootFromParent_Done,
     /* 190541 */   // Label 3743: @190541
     /* 190541 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190578), // Rule ID 11263 //
     /* 190546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190576 */     GIR_RootConstrainSelectedInstOperands,
     /* 190577 */     // GIR_Coverage, 11263,
     /* 190577 */     GIR_EraseRootFromParent_Done,
     /* 190578 */   // Label 3744: @190578
     /* 190578 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190615), // Rule ID 11264 //
     /* 190583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190604 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190613 */     GIR_RootConstrainSelectedInstOperands,
     /* 190614 */     // GIR_Coverage, 11264,
     /* 190614 */     GIR_EraseRootFromParent_Done,
     /* 190615 */   // Label 3745: @190615
     /* 190615 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190652), // Rule ID 11265 //
     /* 190620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190650 */     GIR_RootConstrainSelectedInstOperands,
     /* 190651 */     // GIR_Coverage, 11265,
     /* 190651 */     GIR_EraseRootFromParent_Done,
     /* 190652 */   // Label 3746: @190652
     /* 190652 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190689), // Rule ID 11266 //
     /* 190657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190678 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190687 */     GIR_RootConstrainSelectedInstOperands,
     /* 190688 */     // GIR_Coverage, 11266,
     /* 190688 */     GIR_EraseRootFromParent_Done,
     /* 190689 */   // Label 3747: @190689
     /* 190689 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190726), // Rule ID 11267 //
     /* 190694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190724 */     GIR_RootConstrainSelectedInstOperands,
     /* 190725 */     // GIR_Coverage, 11267,
     /* 190725 */     GIR_EraseRootFromParent_Done,
     /* 190726 */   // Label 3748: @190726
     /* 190726 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190763), // Rule ID 11268 //
     /* 190731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190752 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190761 */     GIR_RootConstrainSelectedInstOperands,
     /* 190762 */     // GIR_Coverage, 11268,
     /* 190762 */     GIR_EraseRootFromParent_Done,
     /* 190763 */   // Label 3749: @190763
     /* 190763 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190800), // Rule ID 11269 //
     /* 190768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190789 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2085:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190798 */     GIR_RootConstrainSelectedInstOperands,
     /* 190799 */     // GIR_Coverage, 11269,
     /* 190799 */     GIR_EraseRootFromParent_Done,
     /* 190800 */   // Label 3750: @190800
     /* 190800 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190837), // Rule ID 11270 //
     /* 190805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2085:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190835 */     GIR_RootConstrainSelectedInstOperands,
     /* 190836 */     // GIR_Coverage, 11270,
     /* 190836 */     GIR_EraseRootFromParent_Done,
     /* 190837 */   // Label 3751: @190837
     /* 190837 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190874), // Rule ID 11271 //
     /* 190842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190863 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2085:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190872 */     GIR_RootConstrainSelectedInstOperands,
     /* 190873 */     // GIR_Coverage, 11271,
     /* 190873 */     GIR_EraseRootFromParent_Done,
     /* 190874 */   // Label 3752: @190874
     /* 190874 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190911), // Rule ID 11272 //
     /* 190879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2085:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190909 */     GIR_RootConstrainSelectedInstOperands,
     /* 190910 */     // GIR_Coverage, 11272,
     /* 190910 */     GIR_EraseRootFromParent_Done,
     /* 190911 */   // Label 3753: @190911
     /* 190911 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190948), // Rule ID 11273 //
     /* 190916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190937 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2085:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190946 */     GIR_RootConstrainSelectedInstOperands,
     /* 190947 */     // GIR_Coverage, 11273,
     /* 190947 */     GIR_EraseRootFromParent_Done,
     /* 190948 */   // Label 3754: @190948
     /* 190948 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190985), // Rule ID 11274 //
     /* 190953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2085:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190983 */     GIR_RootConstrainSelectedInstOperands,
     /* 190984 */     // GIR_Coverage, 11274,
     /* 190984 */     GIR_EraseRootFromParent_Done,
     /* 190985 */   // Label 3755: @190985
     /* 190985 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(191022), // Rule ID 11275 //
     /* 190990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191011 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2085:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 191014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191020 */     GIR_RootConstrainSelectedInstOperands,
     /* 191021 */     // GIR_Coverage, 11275,
     /* 191021 */     GIR_EraseRootFromParent_Done,
     /* 191022 */   // Label 3756: @191022
     /* 191022 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(191059), // Rule ID 11276 //
     /* 191027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191057 */     GIR_RootConstrainSelectedInstOperands,
     /* 191058 */     // GIR_Coverage, 11276,
     /* 191058 */     GIR_EraseRootFromParent_Done,
     /* 191059 */   // Label 3757: @191059
     /* 191059 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(191096), // Rule ID 11277 //
     /* 191064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191094 */     GIR_RootConstrainSelectedInstOperands,
     /* 191095 */     // GIR_Coverage, 11277,
     /* 191095 */     GIR_EraseRootFromParent_Done,
     /* 191096 */   // Label 3758: @191096
     /* 191096 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(191133), // Rule ID 11278 //
     /* 191101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191131 */     GIR_RootConstrainSelectedInstOperands,
     /* 191132 */     // GIR_Coverage, 11278,
     /* 191132 */     GIR_EraseRootFromParent_Done,
     /* 191133 */   // Label 3759: @191133
     /* 191133 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(191170), // Rule ID 11279 //
     /* 191138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191168 */     GIR_RootConstrainSelectedInstOperands,
     /* 191169 */     // GIR_Coverage, 11279,
     /* 191169 */     GIR_EraseRootFromParent_Done,
     /* 191170 */   // Label 3760: @191170
     /* 191170 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(191207), // Rule ID 11280 //
     /* 191175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191196 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191205 */     GIR_RootConstrainSelectedInstOperands,
     /* 191206 */     // GIR_Coverage, 11280,
     /* 191206 */     GIR_EraseRootFromParent_Done,
     /* 191207 */   // Label 3761: @191207
     /* 191207 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191244), // Rule ID 11281 //
     /* 191212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191242 */     GIR_RootConstrainSelectedInstOperands,
     /* 191243 */     // GIR_Coverage, 11281,
     /* 191243 */     GIR_EraseRootFromParent_Done,
     /* 191244 */   // Label 3762: @191244
     /* 191244 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191281), // Rule ID 11282 //
     /* 191249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 191257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191270 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 191273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191279 */     GIR_RootConstrainSelectedInstOperands,
     /* 191280 */     // GIR_Coverage, 11282,
     /* 191280 */     GIR_EraseRootFromParent_Done,
     /* 191281 */   // Label 3763: @191281
     /* 191281 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191318), // Rule ID 11283 //
     /* 191286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191316 */     GIR_RootConstrainSelectedInstOperands,
     /* 191317 */     // GIR_Coverage, 11283,
     /* 191317 */     GIR_EraseRootFromParent_Done,
     /* 191318 */   // Label 3764: @191318
     /* 191318 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(191355), // Rule ID 11284 //
     /* 191323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191353 */     GIR_RootConstrainSelectedInstOperands,
     /* 191354 */     // GIR_Coverage, 11284,
     /* 191354 */     GIR_EraseRootFromParent_Done,
     /* 191355 */   // Label 3765: @191355
     /* 191355 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(191392), // Rule ID 11285 //
     /* 191360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191381 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191390 */     GIR_RootConstrainSelectedInstOperands,
     /* 191391 */     // GIR_Coverage, 11285,
     /* 191391 */     GIR_EraseRootFromParent_Done,
     /* 191392 */   // Label 3766: @191392
     /* 191392 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(191429), // Rule ID 11286 //
     /* 191397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191427 */     GIR_RootConstrainSelectedInstOperands,
     /* 191428 */     // GIR_Coverage, 11286,
     /* 191428 */     GIR_EraseRootFromParent_Done,
     /* 191429 */   // Label 3767: @191429
     /* 191429 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(191466), // Rule ID 11287 //
     /* 191434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191464 */     GIR_RootConstrainSelectedInstOperands,
     /* 191465 */     // GIR_Coverage, 11287,
     /* 191465 */     GIR_EraseRootFromParent_Done,
     /* 191466 */   // Label 3768: @191466
     /* 191466 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(191503), // Rule ID 11288 //
     /* 191471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191492 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191501 */     GIR_RootConstrainSelectedInstOperands,
     /* 191502 */     // GIR_Coverage, 11288,
     /* 191502 */     GIR_EraseRootFromParent_Done,
     /* 191503 */   // Label 3769: @191503
     /* 191503 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191540), // Rule ID 11289 //
     /* 191508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191538 */     GIR_RootConstrainSelectedInstOperands,
     /* 191539 */     // GIR_Coverage, 11289,
     /* 191539 */     GIR_EraseRootFromParent_Done,
     /* 191540 */   // Label 3770: @191540
     /* 191540 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(191577), // Rule ID 11309 //
     /* 191545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191566 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 191569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191575 */     GIR_RootConstrainSelectedInstOperands,
     /* 191576 */     // GIR_Coverage, 11309,
     /* 191576 */     GIR_EraseRootFromParent_Done,
     /* 191577 */   // Label 3771: @191577
     /* 191577 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191614), // Rule ID 11310 //
     /* 191582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191603 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 191606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191612 */     GIR_RootConstrainSelectedInstOperands,
     /* 191613 */     // GIR_Coverage, 11310,
     /* 191613 */     GIR_EraseRootFromParent_Done,
     /* 191614 */   // Label 3772: @191614
     /* 191614 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191651), // Rule ID 11311 //
     /* 191619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 191643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191649 */     GIR_RootConstrainSelectedInstOperands,
     /* 191650 */     // GIR_Coverage, 11311,
     /* 191650 */     GIR_EraseRootFromParent_Done,
     /* 191651 */   // Label 3773: @191651
     /* 191651 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191688), // Rule ID 11312 //
     /* 191656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 191680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191686 */     GIR_RootConstrainSelectedInstOperands,
     /* 191687 */     // GIR_Coverage, 11312,
     /* 191687 */     GIR_EraseRootFromParent_Done,
     /* 191688 */   // Label 3774: @191688
     /* 191688 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191725), // Rule ID 11600 //
     /* 191693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 191717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191723 */     GIR_RootConstrainSelectedInstOperands,
     /* 191724 */     // GIR_Coverage, 11600,
     /* 191724 */     GIR_EraseRootFromParent_Done,
     /* 191725 */   // Label 3775: @191725
     /* 191725 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191762), // Rule ID 11601 //
     /* 191730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191751 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 191754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191760 */     GIR_RootConstrainSelectedInstOperands,
     /* 191761 */     // GIR_Coverage, 11601,
     /* 191761 */     GIR_EraseRootFromParent_Done,
     /* 191762 */   // Label 3776: @191762
     /* 191762 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191799), // Rule ID 11602 //
     /* 191767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 191791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191797 */     GIR_RootConstrainSelectedInstOperands,
     /* 191798 */     // GIR_Coverage, 11602,
     /* 191798 */     GIR_EraseRootFromParent_Done,
     /* 191799 */   // Label 3777: @191799
     /* 191799 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191836), // Rule ID 11603 //
     /* 191804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 191828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191834 */     GIR_RootConstrainSelectedInstOperands,
     /* 191835 */     // GIR_Coverage, 11603,
     /* 191835 */     GIR_EraseRootFromParent_Done,
     /* 191836 */   // Label 3778: @191836
     /* 191836 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191873), // Rule ID 11604 //
     /* 191841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 191865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191871 */     GIR_RootConstrainSelectedInstOperands,
     /* 191872 */     // GIR_Coverage, 11604,
     /* 191872 */     GIR_EraseRootFromParent_Done,
     /* 191873 */   // Label 3779: @191873
     /* 191873 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191910), // Rule ID 11605 //
     /* 191878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 191902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191908 */     GIR_RootConstrainSelectedInstOperands,
     /* 191909 */     // GIR_Coverage, 11605,
     /* 191909 */     GIR_EraseRootFromParent_Done,
     /* 191910 */   // Label 3780: @191910
     /* 191910 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191947), // Rule ID 11606 //
     /* 191915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 191939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191945 */     GIR_RootConstrainSelectedInstOperands,
     /* 191946 */     // GIR_Coverage, 11606,
     /* 191946 */     GIR_EraseRootFromParent_Done,
     /* 191947 */   // Label 3781: @191947
     /* 191947 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191984), // Rule ID 11607 //
     /* 191952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 191976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191982 */     GIR_RootConstrainSelectedInstOperands,
     /* 191983 */     // GIR_Coverage, 11607,
     /* 191983 */     GIR_EraseRootFromParent_Done,
     /* 191984 */   // Label 3782: @191984
     /* 191984 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(192021), // Rule ID 11608 //
     /* 191989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 192013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192019 */     GIR_RootConstrainSelectedInstOperands,
     /* 192020 */     // GIR_Coverage, 11608,
     /* 192020 */     GIR_EraseRootFromParent_Done,
     /* 192021 */   // Label 3783: @192021
     /* 192021 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(192058), // Rule ID 11609 //
     /* 192026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 192034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192047 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 192050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192056 */     GIR_RootConstrainSelectedInstOperands,
     /* 192057 */     // GIR_Coverage, 11609,
     /* 192057 */     GIR_EraseRootFromParent_Done,
     /* 192058 */   // Label 3784: @192058
     /* 192058 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(192095), // Rule ID 11610 //
     /* 192063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 192071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 192087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192093 */     GIR_RootConstrainSelectedInstOperands,
     /* 192094 */     // GIR_Coverage, 11610,
     /* 192094 */     GIR_EraseRootFromParent_Done,
     /* 192095 */   // Label 3785: @192095
     /* 192095 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(192132), // Rule ID 11611 //
     /* 192100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 192108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 192124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192130 */     GIR_RootConstrainSelectedInstOperands,
     /* 192131 */     // GIR_Coverage, 11611,
     /* 192131 */     GIR_EraseRootFromParent_Done,
     /* 192132 */   // Label 3786: @192132
     /* 192132 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(192169), // Rule ID 11612 //
     /* 192137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 192145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 192161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192167 */     GIR_RootConstrainSelectedInstOperands,
     /* 192168 */     // GIR_Coverage, 11612,
     /* 192168 */     GIR_EraseRootFromParent_Done,
     /* 192169 */   // Label 3787: @192169
     /* 192169 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192206), // Rule ID 11613 //
     /* 192174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 192182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 192198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192204 */     GIR_RootConstrainSelectedInstOperands,
     /* 192205 */     // GIR_Coverage, 11613,
     /* 192205 */     GIR_EraseRootFromParent_Done,
     /* 192206 */   // Label 3788: @192206
     /* 192206 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192243), // Rule ID 11614 //
     /* 192211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 192219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 192235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192241 */     GIR_RootConstrainSelectedInstOperands,
     /* 192242 */     // GIR_Coverage, 11614,
     /* 192242 */     GIR_EraseRootFromParent_Done,
     /* 192243 */   // Label 3789: @192243
     /* 192243 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(192280), // Rule ID 11615 //
     /* 192248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 192256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 192272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192278 */     GIR_RootConstrainSelectedInstOperands,
     /* 192279 */     // GIR_Coverage, 11615,
     /* 192279 */     GIR_EraseRootFromParent_Done,
     /* 192280 */   // Label 3790: @192280
     /* 192280 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(192317), // Rule ID 11616 //
     /* 192285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 192293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 192309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192315 */     GIR_RootConstrainSelectedInstOperands,
     /* 192316 */     // GIR_Coverage, 11616,
     /* 192316 */     GIR_EraseRootFromParent_Done,
     /* 192317 */   // Label 3791: @192317
     /* 192317 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(192354), // Rule ID 11617 //
     /* 192322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 192330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 192346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192352 */     GIR_RootConstrainSelectedInstOperands,
     /* 192353 */     // GIR_Coverage, 11617,
     /* 192353 */     GIR_EraseRootFromParent_Done,
     /* 192354 */   // Label 3792: @192354
     /* 192354 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(192391), // Rule ID 11618 //
     /* 192359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 192383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192389 */     GIR_RootConstrainSelectedInstOperands,
     /* 192390 */     // GIR_Coverage, 11618,
     /* 192390 */     GIR_EraseRootFromParent_Done,
     /* 192391 */   // Label 3793: @192391
     /* 192391 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(192428), // Rule ID 11619 //
     /* 192396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 192420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192426 */     GIR_RootConstrainSelectedInstOperands,
     /* 192427 */     // GIR_Coverage, 11619,
     /* 192427 */     GIR_EraseRootFromParent_Done,
     /* 192428 */   // Label 3794: @192428
     /* 192428 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(192465), // Rule ID 11620 //
     /* 192433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 192457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192463 */     GIR_RootConstrainSelectedInstOperands,
     /* 192464 */     // GIR_Coverage, 11620,
     /* 192464 */     GIR_EraseRootFromParent_Done,
     /* 192465 */   // Label 3795: @192465
     /* 192465 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(192502), // Rule ID 11621 //
     /* 192470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 192494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192500 */     GIR_RootConstrainSelectedInstOperands,
     /* 192501 */     // GIR_Coverage, 11621,
     /* 192501 */     GIR_EraseRootFromParent_Done,
     /* 192502 */   // Label 3796: @192502
     /* 192502 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(192539), // Rule ID 11622 //
     /* 192507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 192531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192537 */     GIR_RootConstrainSelectedInstOperands,
     /* 192538 */     // GIR_Coverage, 11622,
     /* 192538 */     GIR_EraseRootFromParent_Done,
     /* 192539 */   // Label 3797: @192539
     /* 192539 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192576), // Rule ID 11623 //
     /* 192544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192565 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 192568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192574 */     GIR_RootConstrainSelectedInstOperands,
     /* 192575 */     // GIR_Coverage, 11623,
     /* 192575 */     GIR_EraseRootFromParent_Done,
     /* 192576 */   // Label 3798: @192576
     /* 192576 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192613), // Rule ID 11624 //
     /* 192581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 192605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192611 */     GIR_RootConstrainSelectedInstOperands,
     /* 192612 */     // GIR_Coverage, 11624,
     /* 192612 */     GIR_EraseRootFromParent_Done,
     /* 192613 */   // Label 3799: @192613
     /* 192613 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192650), // Rule ID 11625 //
     /* 192618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 192642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192648 */     GIR_RootConstrainSelectedInstOperands,
     /* 192649 */     // GIR_Coverage, 11625,
     /* 192649 */     GIR_EraseRootFromParent_Done,
     /* 192650 */   // Label 3800: @192650
     /* 192650 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192687), // Rule ID 11626 //
     /* 192655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 192679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192685 */     GIR_RootConstrainSelectedInstOperands,
     /* 192686 */     // GIR_Coverage, 11626,
     /* 192686 */     GIR_EraseRootFromParent_Done,
     /* 192687 */   // Label 3801: @192687
     /* 192687 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192724), // Rule ID 11627 //
     /* 192692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192713 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 192716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192722 */     GIR_RootConstrainSelectedInstOperands,
     /* 192723 */     // GIR_Coverage, 11627,
     /* 192723 */     GIR_EraseRootFromParent_Done,
     /* 192724 */   // Label 3802: @192724
     /* 192724 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192761), // Rule ID 11628 //
     /* 192729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 192753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192759 */     GIR_RootConstrainSelectedInstOperands,
     /* 192760 */     // GIR_Coverage, 11628,
     /* 192760 */     GIR_EraseRootFromParent_Done,
     /* 192761 */   // Label 3803: @192761
     /* 192761 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192798), // Rule ID 11629 //
     /* 192766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 192790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192796 */     GIR_RootConstrainSelectedInstOperands,
     /* 192797 */     // GIR_Coverage, 11629,
     /* 192797 */     GIR_EraseRootFromParent_Done,
     /* 192798 */   // Label 3804: @192798
     /* 192798 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192835), // Rule ID 11630 //
     /* 192803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 192827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192833 */     GIR_RootConstrainSelectedInstOperands,
     /* 192834 */     // GIR_Coverage, 11630,
     /* 192834 */     GIR_EraseRootFromParent_Done,
     /* 192835 */   // Label 3805: @192835
     /* 192835 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192872), // Rule ID 11631 //
     /* 192840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 192864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192870 */     GIR_RootConstrainSelectedInstOperands,
     /* 192871 */     // GIR_Coverage, 11631,
     /* 192871 */     GIR_EraseRootFromParent_Done,
     /* 192872 */   // Label 3806: @192872
     /* 192872 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192909), // Rule ID 11632 //
     /* 192877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 192901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192907 */     GIR_RootConstrainSelectedInstOperands,
     /* 192908 */     // GIR_Coverage, 11632,
     /* 192908 */     GIR_EraseRootFromParent_Done,
     /* 192909 */   // Label 3807: @192909
     /* 192909 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192946), // Rule ID 11642 //
     /* 192914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 192938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192944 */     GIR_RootConstrainSelectedInstOperands,
     /* 192945 */     // GIR_Coverage, 11642,
     /* 192945 */     GIR_EraseRootFromParent_Done,
     /* 192946 */   // Label 3808: @192946
     /* 192946 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192983), // Rule ID 11643 //
     /* 192951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 192975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192981 */     GIR_RootConstrainSelectedInstOperands,
     /* 192982 */     // GIR_Coverage, 11643,
     /* 192982 */     GIR_EraseRootFromParent_Done,
     /* 192983 */   // Label 3809: @192983
     /* 192983 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(193020), // Rule ID 11644 //
     /* 192988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 193012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193018 */     GIR_RootConstrainSelectedInstOperands,
     /* 193019 */     // GIR_Coverage, 11644,
     /* 193019 */     GIR_EraseRootFromParent_Done,
     /* 193020 */   // Label 3810: @193020
     /* 193020 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(193057), // Rule ID 11645 //
     /* 193025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 193033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 193049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193055 */     GIR_RootConstrainSelectedInstOperands,
     /* 193056 */     // GIR_Coverage, 11645,
     /* 193056 */     GIR_EraseRootFromParent_Done,
     /* 193057 */   // Label 3811: @193057
     /* 193057 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(193094), // Rule ID 11646 //
     /* 193062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 193070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 193086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193092 */     GIR_RootConstrainSelectedInstOperands,
     /* 193093 */     // GIR_Coverage, 11646,
     /* 193093 */     GIR_EraseRootFromParent_Done,
     /* 193094 */   // Label 3812: @193094
     /* 193094 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(193131), // Rule ID 11647 //
     /* 193099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 193107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 193123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193129 */     GIR_RootConstrainSelectedInstOperands,
     /* 193130 */     // GIR_Coverage, 11647,
     /* 193130 */     GIR_EraseRootFromParent_Done,
     /* 193131 */   // Label 3813: @193131
     /* 193131 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(193168), // Rule ID 11648 //
     /* 193136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 193144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193157 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 193160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193166 */     GIR_RootConstrainSelectedInstOperands,
     /* 193167 */     // GIR_Coverage, 11648,
     /* 193167 */     GIR_EraseRootFromParent_Done,
     /* 193168 */   // Label 3814: @193168
     /* 193168 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193205), // Rule ID 11649 //
     /* 193173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 193181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 193197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193203 */     GIR_RootConstrainSelectedInstOperands,
     /* 193204 */     // GIR_Coverage, 11649,
     /* 193204 */     GIR_EraseRootFromParent_Done,
     /* 193205 */   // Label 3815: @193205
     /* 193205 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193242), // Rule ID 11650 //
     /* 193210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 193218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193231 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 193234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193240 */     GIR_RootConstrainSelectedInstOperands,
     /* 193241 */     // GIR_Coverage, 11650,
     /* 193241 */     GIR_EraseRootFromParent_Done,
     /* 193242 */   // Label 3816: @193242
     /* 193242 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193279), // Rule ID 11651 //
     /* 193247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 193255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 193271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193277 */     GIR_RootConstrainSelectedInstOperands,
     /* 193278 */     // GIR_Coverage, 11651,
     /* 193278 */     GIR_EraseRootFromParent_Done,
     /* 193279 */   // Label 3817: @193279
     /* 193279 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(193316), // Rule ID 11652 //
     /* 193284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 193292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 193308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193314 */     GIR_RootConstrainSelectedInstOperands,
     /* 193315 */     // GIR_Coverage, 11652,
     /* 193315 */     GIR_EraseRootFromParent_Done,
     /* 193316 */   // Label 3818: @193316
     /* 193316 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(193353), // Rule ID 11653 //
     /* 193321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 193329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 193345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193351 */     GIR_RootConstrainSelectedInstOperands,
     /* 193352 */     // GIR_Coverage, 11653,
     /* 193352 */     GIR_EraseRootFromParent_Done,
     /* 193353 */   // Label 3819: @193353
     /* 193353 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(193390), // Rule ID 11654 //
     /* 193358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1801:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 193382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193388 */     GIR_RootConstrainSelectedInstOperands,
     /* 193389 */     // GIR_Coverage, 11654,
     /* 193389 */     GIR_EraseRootFromParent_Done,
     /* 193390 */   // Label 3820: @193390
     /* 193390 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(193427), // Rule ID 11655 //
     /* 193395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 193419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193425 */     GIR_RootConstrainSelectedInstOperands,
     /* 193426 */     // GIR_Coverage, 11655,
     /* 193426 */     GIR_EraseRootFromParent_Done,
     /* 193427 */   // Label 3821: @193427
     /* 193427 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(193464), // Rule ID 11656 //
     /* 193432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 193456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193462 */     GIR_RootConstrainSelectedInstOperands,
     /* 193463 */     // GIR_Coverage, 11656,
     /* 193463 */     GIR_EraseRootFromParent_Done,
     /* 193464 */   // Label 3822: @193464
     /* 193464 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(193501), // Rule ID 11657 //
     /* 193469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 193493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193499 */     GIR_RootConstrainSelectedInstOperands,
     /* 193500 */     // GIR_Coverage, 11657,
     /* 193500 */     GIR_EraseRootFromParent_Done,
     /* 193501 */   // Label 3823: @193501
     /* 193501 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(193538), // Rule ID 11658 //
     /* 193506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 193530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193536 */     GIR_RootConstrainSelectedInstOperands,
     /* 193537 */     // GIR_Coverage, 11658,
     /* 193537 */     GIR_EraseRootFromParent_Done,
     /* 193538 */   // Label 3824: @193538
     /* 193538 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(193575), // Rule ID 11659 //
     /* 193543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 193567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193573 */     GIR_RootConstrainSelectedInstOperands,
     /* 193574 */     // GIR_Coverage, 11659,
     /* 193574 */     GIR_EraseRootFromParent_Done,
     /* 193575 */   // Label 3825: @193575
     /* 193575 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193612), // Rule ID 11660 //
     /* 193580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 193604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193610 */     GIR_RootConstrainSelectedInstOperands,
     /* 193611 */     // GIR_Coverage, 11660,
     /* 193611 */     GIR_EraseRootFromParent_Done,
     /* 193612 */   // Label 3826: @193612
     /* 193612 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193649), // Rule ID 11661 //
     /* 193617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 193641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193647 */     GIR_RootConstrainSelectedInstOperands,
     /* 193648 */     // GIR_Coverage, 11661,
     /* 193648 */     GIR_EraseRootFromParent_Done,
     /* 193649 */   // Label 3827: @193649
     /* 193649 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193686), // Rule ID 11662 //
     /* 193654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 193678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193684 */     GIR_RootConstrainSelectedInstOperands,
     /* 193685 */     // GIR_Coverage, 11662,
     /* 193685 */     GIR_EraseRootFromParent_Done,
     /* 193686 */   // Label 3828: @193686
     /* 193686 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193723), // Rule ID 11663 //
     /* 193691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 193715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193721 */     GIR_RootConstrainSelectedInstOperands,
     /* 193722 */     // GIR_Coverage, 11663,
     /* 193722 */     GIR_EraseRootFromParent_Done,
     /* 193723 */   // Label 3829: @193723
     /* 193723 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193760), // Rule ID 11664 //
     /* 193728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 193752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193758 */     GIR_RootConstrainSelectedInstOperands,
     /* 193759 */     // GIR_Coverage, 11664,
     /* 193759 */     GIR_EraseRootFromParent_Done,
     /* 193760 */   // Label 3830: @193760
     /* 193760 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193797), // Rule ID 11665 //
     /* 193765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 193789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193795 */     GIR_RootConstrainSelectedInstOperands,
     /* 193796 */     // GIR_Coverage, 11665,
     /* 193796 */     GIR_EraseRootFromParent_Done,
     /* 193797 */   // Label 3831: @193797
     /* 193797 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193834), // Rule ID 11666 //
     /* 193802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 193826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193832 */     GIR_RootConstrainSelectedInstOperands,
     /* 193833 */     // GIR_Coverage, 11666,
     /* 193833 */     GIR_EraseRootFromParent_Done,
     /* 193834 */   // Label 3832: @193834
     /* 193834 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193871), // Rule ID 11667 //
     /* 193839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 193863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193869 */     GIR_RootConstrainSelectedInstOperands,
     /* 193870 */     // GIR_Coverage, 11667,
     /* 193870 */     GIR_EraseRootFromParent_Done,
     /* 193871 */   // Label 3833: @193871
     /* 193871 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193908), // Rule ID 11668 //
     /* 193876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193897 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 193900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193906 */     GIR_RootConstrainSelectedInstOperands,
     /* 193907 */     // GIR_Coverage, 11668,
     /* 193907 */     GIR_EraseRootFromParent_Done,
     /* 193908 */   // Label 3834: @193908
     /* 193908 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193945), // Rule ID 11669 //
     /* 193913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 193937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193943 */     GIR_RootConstrainSelectedInstOperands,
     /* 193944 */     // GIR_Coverage, 11669,
     /* 193944 */     GIR_EraseRootFromParent_Done,
     /* 193945 */   // Label 3835: @193945
     /* 193945 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193982), // Rule ID 11670 //
     /* 193950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 193974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193980 */     GIR_RootConstrainSelectedInstOperands,
     /* 193981 */     // GIR_Coverage, 11670,
     /* 193981 */     GIR_EraseRootFromParent_Done,
     /* 193982 */   // Label 3836: @193982
     /* 193982 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(194019), // Rule ID 11671 //
     /* 193987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194008 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 194011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194017 */     GIR_RootConstrainSelectedInstOperands,
     /* 194018 */     // GIR_Coverage, 11671,
     /* 194018 */     GIR_EraseRootFromParent_Done,
     /* 194019 */   // Label 3837: @194019
     /* 194019 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(194056), // Rule ID 11672 //
     /* 194024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 194032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194045 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 194048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194054 */     GIR_RootConstrainSelectedInstOperands,
     /* 194055 */     // GIR_Coverage, 11672,
     /* 194055 */     GIR_EraseRootFromParent_Done,
     /* 194056 */   // Label 3838: @194056
     /* 194056 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(194093), // Rule ID 11673 //
     /* 194061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 194069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 194085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194091 */     GIR_RootConstrainSelectedInstOperands,
     /* 194092 */     // GIR_Coverage, 11673,
     /* 194092 */     GIR_EraseRootFromParent_Done,
     /* 194093 */   // Label 3839: @194093
     /* 194093 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(194130), // Rule ID 11774 //
     /* 194098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 194106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 194122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194128 */     GIR_RootConstrainSelectedInstOperands,
     /* 194129 */     // GIR_Coverage, 11774,
     /* 194129 */     GIR_EraseRootFromParent_Done,
     /* 194130 */   // Label 3840: @194130
     /* 194130 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(194167), // Rule ID 11775 //
     /* 194135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 194143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 194159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194165 */     GIR_RootConstrainSelectedInstOperands,
     /* 194166 */     // GIR_Coverage, 11775,
     /* 194166 */     GIR_EraseRootFromParent_Done,
     /* 194167 */   // Label 3841: @194167
     /* 194167 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194204), // Rule ID 11776 //
     /* 194172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 194180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 194196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194202 */     GIR_RootConstrainSelectedInstOperands,
     /* 194203 */     // GIR_Coverage, 11776,
     /* 194203 */     GIR_EraseRootFromParent_Done,
     /* 194204 */   // Label 3842: @194204
     /* 194204 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(194241), // Rule ID 11777 //
     /* 194209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 194217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 194233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194239 */     GIR_RootConstrainSelectedInstOperands,
     /* 194240 */     // GIR_Coverage, 11777,
     /* 194240 */     GIR_EraseRootFromParent_Done,
     /* 194241 */   // Label 3843: @194241
     /* 194241 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(194278), // Rule ID 11778 //
     /* 194246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 194254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 194270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194276 */     GIR_RootConstrainSelectedInstOperands,
     /* 194277 */     // GIR_Coverage, 11778,
     /* 194277 */     GIR_EraseRootFromParent_Done,
     /* 194278 */   // Label 3844: @194278
     /* 194278 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(194315), // Rule ID 11779 //
     /* 194283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 194291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194313 */     GIR_RootConstrainSelectedInstOperands,
     /* 194314 */     // GIR_Coverage, 11779,
     /* 194314 */     GIR_EraseRootFromParent_Done,
     /* 194315 */   // Label 3845: @194315
     /* 194315 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(194352), // Rule ID 11780 //
     /* 194320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 194328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 194344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194350 */     GIR_RootConstrainSelectedInstOperands,
     /* 194351 */     // GIR_Coverage, 11780,
     /* 194351 */     GIR_EraseRootFromParent_Done,
     /* 194352 */   // Label 3846: @194352
     /* 194352 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(194389), // Rule ID 11781 //
     /* 194357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 194365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 194381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194387 */     GIR_RootConstrainSelectedInstOperands,
     /* 194388 */     // GIR_Coverage, 11781,
     /* 194388 */     GIR_EraseRootFromParent_Done,
     /* 194389 */   // Label 3847: @194389
     /* 194389 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(194426), // Rule ID 11782 //
     /* 194394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 194402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 194418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194424 */     GIR_RootConstrainSelectedInstOperands,
     /* 194425 */     // GIR_Coverage, 11782,
     /* 194425 */     GIR_EraseRootFromParent_Done,
     /* 194426 */   // Label 3848: @194426
     /* 194426 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(194463), // Rule ID 11798 //
     /* 194431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 194455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194461 */     GIR_RootConstrainSelectedInstOperands,
     /* 194462 */     // GIR_Coverage, 11798,
     /* 194462 */     GIR_EraseRootFromParent_Done,
     /* 194463 */   // Label 3849: @194463
     /* 194463 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(194500), // Rule ID 11799 //
     /* 194468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 194492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194498 */     GIR_RootConstrainSelectedInstOperands,
     /* 194499 */     // GIR_Coverage, 11799,
     /* 194499 */     GIR_EraseRootFromParent_Done,
     /* 194500 */   // Label 3850: @194500
     /* 194500 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(194537), // Rule ID 11800 //
     /* 194505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 194529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194535 */     GIR_RootConstrainSelectedInstOperands,
     /* 194536 */     // GIR_Coverage, 11800,
     /* 194536 */     GIR_EraseRootFromParent_Done,
     /* 194537 */   // Label 3851: @194537
     /* 194537 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(194574), // Rule ID 11801 //
     /* 194542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 194566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194572 */     GIR_RootConstrainSelectedInstOperands,
     /* 194573 */     // GIR_Coverage, 11801,
     /* 194573 */     GIR_EraseRootFromParent_Done,
     /* 194574 */   // Label 3852: @194574
     /* 194574 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194611), // Rule ID 11802 //
     /* 194579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 194603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194609 */     GIR_RootConstrainSelectedInstOperands,
     /* 194610 */     // GIR_Coverage, 11802,
     /* 194610 */     GIR_EraseRootFromParent_Done,
     /* 194611 */   // Label 3853: @194611
     /* 194611 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194648), // Rule ID 11803 //
     /* 194616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 194640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194646 */     GIR_RootConstrainSelectedInstOperands,
     /* 194647 */     // GIR_Coverage, 11803,
     /* 194647 */     GIR_EraseRootFromParent_Done,
     /* 194648 */   // Label 3854: @194648
     /* 194648 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194685), // Rule ID 11819 //
     /* 194653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 194677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194683 */     GIR_RootConstrainSelectedInstOperands,
     /* 194684 */     // GIR_Coverage, 11819,
     /* 194684 */     GIR_EraseRootFromParent_Done,
     /* 194685 */   // Label 3855: @194685
     /* 194685 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194722), // Rule ID 11820 //
     /* 194690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 194714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194720 */     GIR_RootConstrainSelectedInstOperands,
     /* 194721 */     // GIR_Coverage, 11820,
     /* 194721 */     GIR_EraseRootFromParent_Done,
     /* 194722 */   // Label 3856: @194722
     /* 194722 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194759), // Rule ID 11821 //
     /* 194727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 194751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194757 */     GIR_RootConstrainSelectedInstOperands,
     /* 194758 */     // GIR_Coverage, 11821,
     /* 194758 */     GIR_EraseRootFromParent_Done,
     /* 194759 */   // Label 3857: @194759
     /* 194759 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194796), // Rule ID 11822 //
     /* 194764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 194788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194794 */     GIR_RootConstrainSelectedInstOperands,
     /* 194795 */     // GIR_Coverage, 11822,
     /* 194795 */     GIR_EraseRootFromParent_Done,
     /* 194796 */   // Label 3858: @194796
     /* 194796 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194833), // Rule ID 11823 //
     /* 194801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 194825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194831 */     GIR_RootConstrainSelectedInstOperands,
     /* 194832 */     // GIR_Coverage, 11823,
     /* 194832 */     GIR_EraseRootFromParent_Done,
     /* 194833 */   // Label 3859: @194833
     /* 194833 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194870), // Rule ID 11824 //
     /* 194838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 194862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194868 */     GIR_RootConstrainSelectedInstOperands,
     /* 194869 */     // GIR_Coverage, 11824,
     /* 194869 */     GIR_EraseRootFromParent_Done,
     /* 194870 */   // Label 3860: @194870
     /* 194870 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194910), // Rule ID 11899 //
     /* 194875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 194899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194908 */     GIR_RootConstrainSelectedInstOperands,
     /* 194909 */     // GIR_Coverage, 11899,
     /* 194909 */     GIR_EraseRootFromParent_Done,
     /* 194910 */   // Label 3861: @194910
     /* 194910 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194950), // Rule ID 11900 //
     /* 194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 194939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194948 */     GIR_RootConstrainSelectedInstOperands,
     /* 194949 */     // GIR_Coverage, 11900,
     /* 194949 */     GIR_EraseRootFromParent_Done,
     /* 194950 */   // Label 3862: @194950
     /* 194950 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194990), // Rule ID 11901 //
     /* 194955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 194979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194988 */     GIR_RootConstrainSelectedInstOperands,
     /* 194989 */     // GIR_Coverage, 11901,
     /* 194989 */     GIR_EraseRootFromParent_Done,
     /* 194990 */   // Label 3863: @194990
     /* 194990 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(195030), // Rule ID 11902 //
     /* 194995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 195019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195028 */     GIR_RootConstrainSelectedInstOperands,
     /* 195029 */     // GIR_Coverage, 11902,
     /* 195029 */     GIR_EraseRootFromParent_Done,
     /* 195030 */   // Label 3864: @195030
     /* 195030 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(195070), // Rule ID 11903 //
     /* 195035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 195059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195068 */     GIR_RootConstrainSelectedInstOperands,
     /* 195069 */     // GIR_Coverage, 11903,
     /* 195069 */     GIR_EraseRootFromParent_Done,
     /* 195070 */   // Label 3865: @195070
     /* 195070 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(195110), // Rule ID 11904 //
     /* 195075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195096 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 195099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195108 */     GIR_RootConstrainSelectedInstOperands,
     /* 195109 */     // GIR_Coverage, 11904,
     /* 195109 */     GIR_EraseRootFromParent_Done,
     /* 195110 */   // Label 3866: @195110
     /* 195110 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(195150), // Rule ID 11905 //
     /* 195115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 195139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195148 */     GIR_RootConstrainSelectedInstOperands,
     /* 195149 */     // GIR_Coverage, 11905,
     /* 195149 */     GIR_EraseRootFromParent_Done,
     /* 195150 */   // Label 3867: @195150
     /* 195150 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(195190), // Rule ID 11906 //
     /* 195155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195176 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 195179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195188 */     GIR_RootConstrainSelectedInstOperands,
     /* 195189 */     // GIR_Coverage, 11906,
     /* 195189 */     GIR_EraseRootFromParent_Done,
     /* 195190 */   // Label 3868: @195190
     /* 195190 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(195230), // Rule ID 11911 //
     /* 195195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 195219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195228 */     GIR_RootConstrainSelectedInstOperands,
     /* 195229 */     // GIR_Coverage, 11911,
     /* 195229 */     GIR_EraseRootFromParent_Done,
     /* 195230 */   // Label 3869: @195230
     /* 195230 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(195270), // Rule ID 11912 //
     /* 195235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 195259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195268 */     GIR_RootConstrainSelectedInstOperands,
     /* 195269 */     // GIR_Coverage, 11912,
     /* 195269 */     GIR_EraseRootFromParent_Done,
     /* 195270 */   // Label 3870: @195270
     /* 195270 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(195310), // Rule ID 11913 //
     /* 195275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195308 */     GIR_RootConstrainSelectedInstOperands,
     /* 195309 */     // GIR_Coverage, 11913,
     /* 195309 */     GIR_EraseRootFromParent_Done,
     /* 195310 */   // Label 3871: @195310
     /* 195310 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(195350), // Rule ID 11914 //
     /* 195315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 195339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195348 */     GIR_RootConstrainSelectedInstOperands,
     /* 195349 */     // GIR_Coverage, 11914,
     /* 195349 */     GIR_EraseRootFromParent_Done,
     /* 195350 */   // Label 3872: @195350
     /* 195350 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(195390), // Rule ID 11915 //
     /* 195355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 195379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195388 */     GIR_RootConstrainSelectedInstOperands,
     /* 195389 */     // GIR_Coverage, 11915,
     /* 195389 */     GIR_EraseRootFromParent_Done,
     /* 195390 */   // Label 3873: @195390
     /* 195390 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(195430), // Rule ID 11916 //
     /* 195395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 195419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195428 */     GIR_RootConstrainSelectedInstOperands,
     /* 195429 */     // GIR_Coverage, 11916,
     /* 195429 */     GIR_EraseRootFromParent_Done,
     /* 195430 */   // Label 3874: @195430
     /* 195430 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(195470), // Rule ID 11917 //
     /* 195435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 195459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195468 */     GIR_RootConstrainSelectedInstOperands,
     /* 195469 */     // GIR_Coverage, 11917,
     /* 195469 */     GIR_EraseRootFromParent_Done,
     /* 195470 */   // Label 3875: @195470
     /* 195470 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(195510), // Rule ID 11918 //
     /* 195475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 195499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195508 */     GIR_RootConstrainSelectedInstOperands,
     /* 195509 */     // GIR_Coverage, 11918,
     /* 195509 */     GIR_EraseRootFromParent_Done,
     /* 195510 */   // Label 3876: @195510
     /* 195510 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(195550), // Rule ID 11923 //
     /* 195515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 195539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195548 */     GIR_RootConstrainSelectedInstOperands,
     /* 195549 */     // GIR_Coverage, 11923,
     /* 195549 */     GIR_EraseRootFromParent_Done,
     /* 195550 */   // Label 3877: @195550
     /* 195550 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(195590), // Rule ID 11924 //
     /* 195555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 195579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195588 */     GIR_RootConstrainSelectedInstOperands,
     /* 195589 */     // GIR_Coverage, 11924,
     /* 195589 */     GIR_EraseRootFromParent_Done,
     /* 195590 */   // Label 3878: @195590
     /* 195590 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195630), // Rule ID 11925 //
     /* 195595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 195619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195628 */     GIR_RootConstrainSelectedInstOperands,
     /* 195629 */     // GIR_Coverage, 11925,
     /* 195629 */     GIR_EraseRootFromParent_Done,
     /* 195630 */   // Label 3879: @195630
     /* 195630 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195670), // Rule ID 11926 //
     /* 195635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 195659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195668 */     GIR_RootConstrainSelectedInstOperands,
     /* 195669 */     // GIR_Coverage, 11926,
     /* 195669 */     GIR_EraseRootFromParent_Done,
     /* 195670 */   // Label 3880: @195670
     /* 195670 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195710), // Rule ID 11927 //
     /* 195675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 195699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195708 */     GIR_RootConstrainSelectedInstOperands,
     /* 195709 */     // GIR_Coverage, 11927,
     /* 195709 */     GIR_EraseRootFromParent_Done,
     /* 195710 */   // Label 3881: @195710
     /* 195710 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195750), // Rule ID 11928 //
     /* 195715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 195739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195748 */     GIR_RootConstrainSelectedInstOperands,
     /* 195749 */     // GIR_Coverage, 11928,
     /* 195749 */     GIR_EraseRootFromParent_Done,
     /* 195750 */   // Label 3882: @195750
     /* 195750 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195790), // Rule ID 11929 //
     /* 195755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 195779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195788 */     GIR_RootConstrainSelectedInstOperands,
     /* 195789 */     // GIR_Coverage, 11929,
     /* 195789 */     GIR_EraseRootFromParent_Done,
     /* 195790 */   // Label 3883: @195790
     /* 195790 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195830), // Rule ID 11930 //
     /* 195795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 195819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195828 */     GIR_RootConstrainSelectedInstOperands,
     /* 195829 */     // GIR_Coverage, 11930,
     /* 195829 */     GIR_EraseRootFromParent_Done,
     /* 195830 */   // Label 3884: @195830
     /* 195830 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195870), // Rule ID 11935 //
     /* 195835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 195859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195868 */     GIR_RootConstrainSelectedInstOperands,
     /* 195869 */     // GIR_Coverage, 11935,
     /* 195869 */     GIR_EraseRootFromParent_Done,
     /* 195870 */   // Label 3885: @195870
     /* 195870 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195910), // Rule ID 11936 //
     /* 195875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 195899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195908 */     GIR_RootConstrainSelectedInstOperands,
     /* 195909 */     // GIR_Coverage, 11936,
     /* 195909 */     GIR_EraseRootFromParent_Done,
     /* 195910 */   // Label 3886: @195910
     /* 195910 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195950), // Rule ID 11937 //
     /* 195915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 195939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195948 */     GIR_RootConstrainSelectedInstOperands,
     /* 195949 */     // GIR_Coverage, 11937,
     /* 195949 */     GIR_EraseRootFromParent_Done,
     /* 195950 */   // Label 3887: @195950
     /* 195950 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195990), // Rule ID 11938 //
     /* 195955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 195979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195988 */     GIR_RootConstrainSelectedInstOperands,
     /* 195989 */     // GIR_Coverage, 11938,
     /* 195989 */     GIR_EraseRootFromParent_Done,
     /* 195990 */   // Label 3888: @195990
     /* 195990 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(196030), // Rule ID 11939 //
     /* 195995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 196006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 196016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 196019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196028 */     GIR_RootConstrainSelectedInstOperands,
     /* 196029 */     // GIR_Coverage, 11939,
     /* 196029 */     GIR_EraseRootFromParent_Done,
     /* 196030 */   // Label 3889: @196030
     /* 196030 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(196070), // Rule ID 11940 //
     /* 196035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 196046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196056 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 196056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 196059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196068 */     GIR_RootConstrainSelectedInstOperands,
     /* 196069 */     // GIR_Coverage, 11940,
     /* 196069 */     GIR_EraseRootFromParent_Done,
     /* 196070 */   // Label 3890: @196070
     /* 196070 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(196110), // Rule ID 11941 //
     /* 196075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 196086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 196096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 196099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196108 */     GIR_RootConstrainSelectedInstOperands,
     /* 196109 */     // GIR_Coverage, 11941,
     /* 196109 */     GIR_EraseRootFromParent_Done,
     /* 196110 */   // Label 3891: @196110
     /* 196110 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(196150), // Rule ID 11942 //
     /* 196115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 196118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 196123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 196126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 196136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 196136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 196139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 196141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 196148 */     GIR_RootConstrainSelectedInstOperands,
     /* 196149 */     // GIR_Coverage, 11942,
     /* 196149 */     GIR_EraseRootFromParent_Done,
     /* 196150 */   // Label 3892: @196150
     /* 196150 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(196187), // Rule ID 11951 //
     /* 196155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 196158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 196163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196176 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 196179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196185 */     GIR_RootConstrainSelectedInstOperands,
     /* 196186 */     // GIR_Coverage, 11951,
     /* 196186 */     GIR_EraseRootFromParent_Done,
     /* 196187 */   // Label 3893: @196187
     /* 196187 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(196224), // Rule ID 11953 //
     /* 196192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 196195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 196200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 196216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196222 */     GIR_RootConstrainSelectedInstOperands,
     /* 196223 */     // GIR_Coverage, 11953,
     /* 196223 */     GIR_EraseRootFromParent_Done,
     /* 196224 */   // Label 3894: @196224
     /* 196224 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(196261), // Rule ID 11954 //
     /* 196229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 196232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 196237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 196253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196259 */     GIR_RootConstrainSelectedInstOperands,
     /* 196260 */     // GIR_Coverage, 11954,
     /* 196260 */     GIR_EraseRootFromParent_Done,
     /* 196261 */   // Label 3895: @196261
     /* 196261 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(196298), // Rule ID 11955 //
     /* 196266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 196269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 196274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 196290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196296 */     GIR_RootConstrainSelectedInstOperands,
     /* 196297 */     // GIR_Coverage, 11955,
     /* 196297 */     GIR_EraseRootFromParent_Done,
     /* 196298 */   // Label 3896: @196298
     /* 196298 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(196335), // Rule ID 11956 //
     /* 196303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 196327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196333 */     GIR_RootConstrainSelectedInstOperands,
     /* 196334 */     // GIR_Coverage, 11956,
     /* 196334 */     GIR_EraseRootFromParent_Done,
     /* 196335 */   // Label 3897: @196335
     /* 196335 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(196372), // Rule ID 11957 //
     /* 196340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 196364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196370 */     GIR_RootConstrainSelectedInstOperands,
     /* 196371 */     // GIR_Coverage, 11957,
     /* 196371 */     GIR_EraseRootFromParent_Done,
     /* 196372 */   // Label 3898: @196372
     /* 196372 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(196409), // Rule ID 11958 //
     /* 196377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 196401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196407 */     GIR_RootConstrainSelectedInstOperands,
     /* 196408 */     // GIR_Coverage, 11958,
     /* 196408 */     GIR_EraseRootFromParent_Done,
     /* 196409 */   // Label 3899: @196409
     /* 196409 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(196446), // Rule ID 11959 //
     /* 196414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 196438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196444 */     GIR_RootConstrainSelectedInstOperands,
     /* 196445 */     // GIR_Coverage, 11959,
     /* 196445 */     GIR_EraseRootFromParent_Done,
     /* 196446 */   // Label 3900: @196446
     /* 196446 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(196483), // Rule ID 11960 //
     /* 196451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1289:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 196475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196481 */     GIR_RootConstrainSelectedInstOperands,
     /* 196482 */     // GIR_Coverage, 11960,
     /* 196482 */     GIR_EraseRootFromParent_Done,
     /* 196483 */   // Label 3901: @196483
     /* 196483 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(196520), // Rule ID 11961 //
     /* 196488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1289:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 196512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196518 */     GIR_RootConstrainSelectedInstOperands,
     /* 196519 */     // GIR_Coverage, 11961,
     /* 196519 */     GIR_EraseRootFromParent_Done,
     /* 196520 */   // Label 3902: @196520
     /* 196520 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(196557), // Rule ID 11962 //
     /* 196525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1289:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 196549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196555 */     GIR_RootConstrainSelectedInstOperands,
     /* 196556 */     // GIR_Coverage, 11962,
     /* 196556 */     GIR_EraseRootFromParent_Done,
     /* 196557 */   // Label 3903: @196557
     /* 196557 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196594), // Rule ID 11963 //
     /* 196562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1289:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 196586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196592 */     GIR_RootConstrainSelectedInstOperands,
     /* 196593 */     // GIR_Coverage, 11963,
     /* 196593 */     GIR_EraseRootFromParent_Done,
     /* 196594 */   // Label 3904: @196594
     /* 196594 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196631), // Rule ID 12076 //
     /* 196599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196620 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 196623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196629 */     GIR_RootConstrainSelectedInstOperands,
     /* 196630 */     // GIR_Coverage, 12076,
     /* 196630 */     GIR_EraseRootFromParent_Done,
     /* 196631 */   // Label 3905: @196631
     /* 196631 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196668), // Rule ID 12077 //
     /* 196636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196657 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 196660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196666 */     GIR_RootConstrainSelectedInstOperands,
     /* 196667 */     // GIR_Coverage, 12077,
     /* 196667 */     GIR_EraseRootFromParent_Done,
     /* 196668 */   // Label 3906: @196668
     /* 196668 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196705), // Rule ID 12078 //
     /* 196673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196694 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 196697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196703 */     GIR_RootConstrainSelectedInstOperands,
     /* 196704 */     // GIR_Coverage, 12078,
     /* 196704 */     GIR_EraseRootFromParent_Done,
     /* 196705 */   // Label 3907: @196705
     /* 196705 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196742), // Rule ID 12079 //
     /* 196710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196731 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 196734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196740 */     GIR_RootConstrainSelectedInstOperands,
     /* 196741 */     // GIR_Coverage, 12079,
     /* 196741 */     GIR_EraseRootFromParent_Done,
     /* 196742 */   // Label 3908: @196742
     /* 196742 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196779), // Rule ID 12080 //
     /* 196747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196768 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 196771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196777 */     GIR_RootConstrainSelectedInstOperands,
     /* 196778 */     // GIR_Coverage, 12080,
     /* 196778 */     GIR_EraseRootFromParent_Done,
     /* 196779 */   // Label 3909: @196779
     /* 196779 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196816), // Rule ID 12081 //
     /* 196784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196805 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 196808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196814 */     GIR_RootConstrainSelectedInstOperands,
     /* 196815 */     // GIR_Coverage, 12081,
     /* 196815 */     GIR_EraseRootFromParent_Done,
     /* 196816 */   // Label 3910: @196816
     /* 196816 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196853), // Rule ID 12082 //
     /* 196821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196842 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 196845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196851 */     GIR_RootConstrainSelectedInstOperands,
     /* 196852 */     // GIR_Coverage, 12082,
     /* 196852 */     GIR_EraseRootFromParent_Done,
     /* 196853 */   // Label 3911: @196853
     /* 196853 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196890), // Rule ID 12083 //
     /* 196858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196879 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 196882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196888 */     GIR_RootConstrainSelectedInstOperands,
     /* 196889 */     // GIR_Coverage, 12083,
     /* 196889 */     GIR_EraseRootFromParent_Done,
     /* 196890 */   // Label 3912: @196890
     /* 196890 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196927), // Rule ID 12084 //
     /* 196895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196916 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 196919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196925 */     GIR_RootConstrainSelectedInstOperands,
     /* 196926 */     // GIR_Coverage, 12084,
     /* 196926 */     GIR_EraseRootFromParent_Done,
     /* 196927 */   // Label 3913: @196927
     /* 196927 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196964), // Rule ID 12085 //
     /* 196932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196953 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 196956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196962 */     GIR_RootConstrainSelectedInstOperands,
     /* 196963 */     // GIR_Coverage, 12085,
     /* 196963 */     GIR_EraseRootFromParent_Done,
     /* 196964 */   // Label 3914: @196964
     /* 196964 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(197001), // Rule ID 12086 //
     /* 196969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196990 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 196993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196999 */     GIR_RootConstrainSelectedInstOperands,
     /* 197000 */     // GIR_Coverage, 12086,
     /* 197000 */     GIR_EraseRootFromParent_Done,
     /* 197001 */   // Label 3915: @197001
     /* 197001 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(197038), // Rule ID 12087 //
     /* 197006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 197014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197027 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 197030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197036 */     GIR_RootConstrainSelectedInstOperands,
     /* 197037 */     // GIR_Coverage, 12087,
     /* 197037 */     GIR_EraseRootFromParent_Done,
     /* 197038 */   // Label 3916: @197038
     /* 197038 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(197075), // Rule ID 12088 //
     /* 197043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 197051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197064 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1353:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 197067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197073 */     GIR_RootConstrainSelectedInstOperands,
     /* 197074 */     // GIR_Coverage, 12088,
     /* 197074 */     GIR_EraseRootFromParent_Done,
     /* 197075 */   // Label 3917: @197075
     /* 197075 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(197112), // Rule ID 12089 //
     /* 197080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 197088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197101 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 197104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197110 */     GIR_RootConstrainSelectedInstOperands,
     /* 197111 */     // GIR_Coverage, 12089,
     /* 197111 */     GIR_EraseRootFromParent_Done,
     /* 197112 */   // Label 3918: @197112
     /* 197112 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(197149), // Rule ID 12090 //
     /* 197117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 197125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197138 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 197141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197147 */     GIR_RootConstrainSelectedInstOperands,
     /* 197148 */     // GIR_Coverage, 12090,
     /* 197148 */     GIR_EraseRootFromParent_Done,
     /* 197149 */   // Label 3919: @197149
     /* 197149 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(197186), // Rule ID 12091 //
     /* 197154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 197162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197175 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 197178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197184 */     GIR_RootConstrainSelectedInstOperands,
     /* 197185 */     // GIR_Coverage, 12091,
     /* 197185 */     GIR_EraseRootFromParent_Done,
     /* 197186 */   // Label 3920: @197186
     /* 197186 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(197223), // Rule ID 12092 //
     /* 197191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 197199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197212 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 197215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197221 */     GIR_RootConstrainSelectedInstOperands,
     /* 197222 */     // GIR_Coverage, 12092,
     /* 197222 */     GIR_EraseRootFromParent_Done,
     /* 197223 */   // Label 3921: @197223
     /* 197223 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197260), // Rule ID 12093 //
     /* 197228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 197236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197249 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 197252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197258 */     GIR_RootConstrainSelectedInstOperands,
     /* 197259 */     // GIR_Coverage, 12093,
     /* 197259 */     GIR_EraseRootFromParent_Done,
     /* 197260 */   // Label 3922: @197260
     /* 197260 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197297), // Rule ID 12094 //
     /* 197265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 197273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197286 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 197289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197295 */     GIR_RootConstrainSelectedInstOperands,
     /* 197296 */     // GIR_Coverage, 12094,
     /* 197296 */     GIR_EraseRootFromParent_Done,
     /* 197297 */   // Label 3923: @197297
     /* 197297 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197334), // Rule ID 12095 //
     /* 197302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 197310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197323 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 197326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197332 */     GIR_RootConstrainSelectedInstOperands,
     /* 197333 */     // GIR_Coverage, 12095,
     /* 197333 */     GIR_EraseRootFromParent_Done,
     /* 197334 */   // Label 3924: @197334
     /* 197334 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(197371), // Rule ID 12096 //
     /* 197339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197360 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 197363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197369 */     GIR_RootConstrainSelectedInstOperands,
     /* 197370 */     // GIR_Coverage, 12096,
     /* 197370 */     GIR_EraseRootFromParent_Done,
     /* 197371 */   // Label 3925: @197371
     /* 197371 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(197408), // Rule ID 12097 //
     /* 197376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197397 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 197400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197406 */     GIR_RootConstrainSelectedInstOperands,
     /* 197407 */     // GIR_Coverage, 12097,
     /* 197407 */     GIR_EraseRootFromParent_Done,
     /* 197408 */   // Label 3926: @197408
     /* 197408 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(197445), // Rule ID 12098 //
     /* 197413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 197437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197443 */     GIR_RootConstrainSelectedInstOperands,
     /* 197444 */     // GIR_Coverage, 12098,
     /* 197444 */     GIR_EraseRootFromParent_Done,
     /* 197445 */   // Label 3927: @197445
     /* 197445 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(197482), // Rule ID 12099 //
     /* 197450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197471 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 197474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197480 */     GIR_RootConstrainSelectedInstOperands,
     /* 197481 */     // GIR_Coverage, 12099,
     /* 197481 */     GIR_EraseRootFromParent_Done,
     /* 197482 */   // Label 3928: @197482
     /* 197482 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(197519), // Rule ID 12100 //
     /* 197487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197508 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 197511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197517 */     GIR_RootConstrainSelectedInstOperands,
     /* 197518 */     // GIR_Coverage, 12100,
     /* 197518 */     GIR_EraseRootFromParent_Done,
     /* 197519 */   // Label 3929: @197519
     /* 197519 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197556), // Rule ID 12101 //
     /* 197524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197545 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 197548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197554 */     GIR_RootConstrainSelectedInstOperands,
     /* 197555 */     // GIR_Coverage, 12101,
     /* 197555 */     GIR_EraseRootFromParent_Done,
     /* 197556 */   // Label 3930: @197556
     /* 197556 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197593), // Rule ID 12102 //
     /* 197561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197582 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 197585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197591 */     GIR_RootConstrainSelectedInstOperands,
     /* 197592 */     // GIR_Coverage, 12102,
     /* 197592 */     GIR_EraseRootFromParent_Done,
     /* 197593 */   // Label 3931: @197593
     /* 197593 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197630), // Rule ID 12103 //
     /* 197598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197619 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 197622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197628 */     GIR_RootConstrainSelectedInstOperands,
     /* 197629 */     // GIR_Coverage, 12103,
     /* 197629 */     GIR_EraseRootFromParent_Done,
     /* 197630 */   // Label 3932: @197630
     /* 197630 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197667), // Rule ID 12104 //
     /* 197635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197656 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 197659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197665 */     GIR_RootConstrainSelectedInstOperands,
     /* 197666 */     // GIR_Coverage, 12104,
     /* 197666 */     GIR_EraseRootFromParent_Done,
     /* 197667 */   // Label 3933: @197667
     /* 197667 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197704), // Rule ID 12105 //
     /* 197672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197693 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 197696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197702 */     GIR_RootConstrainSelectedInstOperands,
     /* 197703 */     // GIR_Coverage, 12105,
     /* 197703 */     GIR_EraseRootFromParent_Done,
     /* 197704 */   // Label 3934: @197704
     /* 197704 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197741), // Rule ID 12106 //
     /* 197709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 197733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197739 */     GIR_RootConstrainSelectedInstOperands,
     /* 197740 */     // GIR_Coverage, 12106,
     /* 197740 */     GIR_EraseRootFromParent_Done,
     /* 197741 */   // Label 3935: @197741
     /* 197741 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197778), // Rule ID 12107 //
     /* 197746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197767 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 197770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197776 */     GIR_RootConstrainSelectedInstOperands,
     /* 197777 */     // GIR_Coverage, 12107,
     /* 197777 */     GIR_EraseRootFromParent_Done,
     /* 197778 */   // Label 3936: @197778
     /* 197778 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197815), // Rule ID 12108 //
     /* 197783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197804 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 197807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197813 */     GIR_RootConstrainSelectedInstOperands,
     /* 197814 */     // GIR_Coverage, 12108,
     /* 197814 */     GIR_EraseRootFromParent_Done,
     /* 197815 */   // Label 3937: @197815
     /* 197815 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197852), // Rule ID 12109 //
     /* 197820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197841 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 197844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197850 */     GIR_RootConstrainSelectedInstOperands,
     /* 197851 */     // GIR_Coverage, 12109,
     /* 197851 */     GIR_EraseRootFromParent_Done,
     /* 197852 */   // Label 3938: @197852
     /* 197852 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197889), // Rule ID 12110 //
     /* 197857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 197881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197887 */     GIR_RootConstrainSelectedInstOperands,
     /* 197888 */     // GIR_Coverage, 12110,
     /* 197888 */     GIR_EraseRootFromParent_Done,
     /* 197889 */   // Label 3939: @197889
     /* 197889 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197926), // Rule ID 12111 //
     /* 197894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197915 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 197918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197924 */     GIR_RootConstrainSelectedInstOperands,
     /* 197925 */     // GIR_Coverage, 12111,
     /* 197925 */     GIR_EraseRootFromParent_Done,
     /* 197926 */   // Label 3940: @197926
     /* 197926 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197963), // Rule ID 12112 //
     /* 197931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197952 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 197955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197961 */     GIR_RootConstrainSelectedInstOperands,
     /* 197962 */     // GIR_Coverage, 12112,
     /* 197962 */     GIR_EraseRootFromParent_Done,
     /* 197963 */   // Label 3941: @197963
     /* 197963 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198000), // Rule ID 12113 //
     /* 197968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197989 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 197992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197998 */     GIR_RootConstrainSelectedInstOperands,
     /* 197999 */     // GIR_Coverage, 12113,
     /* 197999 */     GIR_EraseRootFromParent_Done,
     /* 198000 */   // Label 3942: @198000
     /* 198000 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198037), // Rule ID 12114 //
     /* 198005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 198013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 198029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198035 */     GIR_RootConstrainSelectedInstOperands,
     /* 198036 */     // GIR_Coverage, 12114,
     /* 198036 */     GIR_EraseRootFromParent_Done,
     /* 198037 */   // Label 3943: @198037
     /* 198037 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(198074), // Rule ID 12115 //
     /* 198042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 198050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198063 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 198066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198072 */     GIR_RootConstrainSelectedInstOperands,
     /* 198073 */     // GIR_Coverage, 12115,
     /* 198073 */     GIR_EraseRootFromParent_Done,
     /* 198074 */   // Label 3944: @198074
     /* 198074 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(198111), // Rule ID 12116 //
     /* 198079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 198103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198109 */     GIR_RootConstrainSelectedInstOperands,
     /* 198110 */     // GIR_Coverage, 12116,
     /* 198110 */     GIR_EraseRootFromParent_Done,
     /* 198111 */   // Label 3945: @198111
     /* 198111 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(198148), // Rule ID 12117 //
     /* 198116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198137 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 198140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198146 */     GIR_RootConstrainSelectedInstOperands,
     /* 198147 */     // GIR_Coverage, 12117,
     /* 198147 */     GIR_EraseRootFromParent_Done,
     /* 198148 */   // Label 3946: @198148
     /* 198148 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(198185), // Rule ID 12118 //
     /* 198153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 198177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198183 */     GIR_RootConstrainSelectedInstOperands,
     /* 198184 */     // GIR_Coverage, 12118,
     /* 198184 */     GIR_EraseRootFromParent_Done,
     /* 198185 */   // Label 3947: @198185
     /* 198185 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198222), // Rule ID 12119 //
     /* 198190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 198214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198220 */     GIR_RootConstrainSelectedInstOperands,
     /* 198221 */     // GIR_Coverage, 12119,
     /* 198221 */     GIR_EraseRootFromParent_Done,
     /* 198222 */   // Label 3948: @198222
     /* 198222 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198259), // Rule ID 12120 //
     /* 198227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198248 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 198251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198257 */     GIR_RootConstrainSelectedInstOperands,
     /* 198258 */     // GIR_Coverage, 12120,
     /* 198258 */     GIR_EraseRootFromParent_Done,
     /* 198259 */   // Label 3949: @198259
     /* 198259 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198296), // Rule ID 12121 //
     /* 198264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198285 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 198288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198294 */     GIR_RootConstrainSelectedInstOperands,
     /* 198295 */     // GIR_Coverage, 12121,
     /* 198295 */     GIR_EraseRootFromParent_Done,
     /* 198296 */   // Label 3950: @198296
     /* 198296 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198333), // Rule ID 12122 //
     /* 198301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 198309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198322 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 198325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198331 */     GIR_RootConstrainSelectedInstOperands,
     /* 198332 */     // GIR_Coverage, 12122,
     /* 198332 */     GIR_EraseRootFromParent_Done,
     /* 198333 */   // Label 3951: @198333
     /* 198333 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198370), // Rule ID 12123 //
     /* 198338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2088:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 198362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198368 */     GIR_RootConstrainSelectedInstOperands,
     /* 198369 */     // GIR_Coverage, 12123,
     /* 198369 */     GIR_EraseRootFromParent_Done,
     /* 198370 */   // Label 3952: @198370
     /* 198370 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(198407), // Rule ID 12124 //
     /* 198375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2088:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 198399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198405 */     GIR_RootConstrainSelectedInstOperands,
     /* 198406 */     // GIR_Coverage, 12124,
     /* 198406 */     GIR_EraseRootFromParent_Done,
     /* 198407 */   // Label 3953: @198407
     /* 198407 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(198444), // Rule ID 12125 //
     /* 198412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2088:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 198436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198442 */     GIR_RootConstrainSelectedInstOperands,
     /* 198443 */     // GIR_Coverage, 12125,
     /* 198443 */     GIR_EraseRootFromParent_Done,
     /* 198444 */   // Label 3954: @198444
     /* 198444 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(198481), // Rule ID 12126 //
     /* 198449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2088:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 198473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198479 */     GIR_RootConstrainSelectedInstOperands,
     /* 198480 */     // GIR_Coverage, 12126,
     /* 198480 */     GIR_EraseRootFromParent_Done,
     /* 198481 */   // Label 3955: @198481
     /* 198481 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(198518), // Rule ID 12127 //
     /* 198486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2088:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 198510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198516 */     GIR_RootConstrainSelectedInstOperands,
     /* 198517 */     // GIR_Coverage, 12127,
     /* 198517 */     GIR_EraseRootFromParent_Done,
     /* 198518 */   // Label 3956: @198518
     /* 198518 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198555), // Rule ID 12128 //
     /* 198523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2088:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 198547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198553 */     GIR_RootConstrainSelectedInstOperands,
     /* 198554 */     // GIR_Coverage, 12128,
     /* 198554 */     GIR_EraseRootFromParent_Done,
     /* 198555 */   // Label 3957: @198555
     /* 198555 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198592), // Rule ID 12129 //
     /* 198560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198581 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2088:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 198584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198590 */     GIR_RootConstrainSelectedInstOperands,
     /* 198591 */     // GIR_Coverage, 12129,
     /* 198591 */     GIR_EraseRootFromParent_Done,
     /* 198592 */   // Label 3958: @198592
     /* 198592 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198629), // Rule ID 12130 //
     /* 198597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 198621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198627 */     GIR_RootConstrainSelectedInstOperands,
     /* 198628 */     // GIR_Coverage, 12130,
     /* 198628 */     GIR_EraseRootFromParent_Done,
     /* 198629 */   // Label 3959: @198629
     /* 198629 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198666), // Rule ID 12131 //
     /* 198634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 198658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198664 */     GIR_RootConstrainSelectedInstOperands,
     /* 198665 */     // GIR_Coverage, 12131,
     /* 198665 */     GIR_EraseRootFromParent_Done,
     /* 198666 */   // Label 3960: @198666
     /* 198666 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198703), // Rule ID 12132 //
     /* 198671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 198695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198701 */     GIR_RootConstrainSelectedInstOperands,
     /* 198702 */     // GIR_Coverage, 12132,
     /* 198702 */     GIR_EraseRootFromParent_Done,
     /* 198703 */   // Label 3961: @198703
     /* 198703 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198740), // Rule ID 12133 //
     /* 198708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 198732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198738 */     GIR_RootConstrainSelectedInstOperands,
     /* 198739 */     // GIR_Coverage, 12133,
     /* 198739 */     GIR_EraseRootFromParent_Done,
     /* 198740 */   // Label 3962: @198740
     /* 198740 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198777), // Rule ID 12134 //
     /* 198745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198766 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 198769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198775 */     GIR_RootConstrainSelectedInstOperands,
     /* 198776 */     // GIR_Coverage, 12134,
     /* 198776 */     GIR_EraseRootFromParent_Done,
     /* 198777 */   // Label 3963: @198777
     /* 198777 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198814), // Rule ID 12135 //
     /* 198782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 198806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198812 */     GIR_RootConstrainSelectedInstOperands,
     /* 198813 */     // GIR_Coverage, 12135,
     /* 198813 */     GIR_EraseRootFromParent_Done,
     /* 198814 */   // Label 3964: @198814
     /* 198814 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198851), // Rule ID 12136 //
     /* 198819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198840 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 198843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198849 */     GIR_RootConstrainSelectedInstOperands,
     /* 198850 */     // GIR_Coverage, 12136,
     /* 198850 */     GIR_EraseRootFromParent_Done,
     /* 198851 */   // Label 3965: @198851
     /* 198851 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198893), // Rule ID 3218 //
     /* 198856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 198864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198871 */     // MIs[0] Op1
     /* 198871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198875 */     // MIs[0] Op2
     /* 198875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 198882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198891 */     GIR_RootConstrainSelectedInstOperands,
     /* 198892 */     // GIR_Coverage, 3218,
     /* 198892 */     GIR_EraseRootFromParent_Done,
     /* 198893 */   // Label 3966: @198893
     /* 198893 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198935), // Rule ID 3219 //
     /* 198898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 198906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198913 */     // MIs[0] Op1
     /* 198913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198917 */     // MIs[0] Op2
     /* 198917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198921 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 198924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198933 */     GIR_RootConstrainSelectedInstOperands,
     /* 198934 */     // GIR_Coverage, 3219,
     /* 198934 */     GIR_EraseRootFromParent_Done,
     /* 198935 */   // Label 3967: @198935
     /* 198935 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198977), // Rule ID 3220 //
     /* 198940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 198948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198955 */     // MIs[0] Op1
     /* 198955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198959 */     // MIs[0] Op2
     /* 198959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198963 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 198966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198975 */     GIR_RootConstrainSelectedInstOperands,
     /* 198976 */     // GIR_Coverage, 3220,
     /* 198976 */     GIR_EraseRootFromParent_Done,
     /* 198977 */   // Label 3968: @198977
     /* 198977 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199019), // Rule ID 3221 //
     /* 198982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 198990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198997 */     // MIs[0] Op1
     /* 198997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199001 */     // MIs[0] Op2
     /* 199001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199005 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 199005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 199008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 199017 */     GIR_RootConstrainSelectedInstOperands,
     /* 199018 */     // GIR_Coverage, 3221,
     /* 199018 */     GIR_EraseRootFromParent_Done,
     /* 199019 */   // Label 3969: @199019
     /* 199019 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199061), // Rule ID 11947 //
     /* 199024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 199027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 199032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 199035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199039 */     // MIs[0] Op1
     /* 199039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199043 */     // MIs[0] Op2
     /* 199043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199047 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 199047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 199050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 199059 */     GIR_RootConstrainSelectedInstOperands,
     /* 199060 */     // GIR_Coverage, 11947,
     /* 199060 */     GIR_EraseRootFromParent_Done,
     /* 199061 */   // Label 3970: @199061
     /* 199061 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199103), // Rule ID 11948 //
     /* 199066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 199069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 199074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 199077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199081 */     // MIs[0] Op1
     /* 199081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199085 */     // MIs[0] Op2
     /* 199085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199089 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 199089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 199092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 199101 */     GIR_RootConstrainSelectedInstOperands,
     /* 199102 */     // GIR_Coverage, 11948,
     /* 199102 */     GIR_EraseRootFromParent_Done,
     /* 199103 */   // Label 3971: @199103
     /* 199103 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(199145), // Rule ID 11949 //
     /* 199108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 199111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 199116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 199119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199123 */     // MIs[0] Op1
     /* 199123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199127 */     // MIs[0] Op2
     /* 199127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199131 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 199131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 199134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 199143 */     GIR_RootConstrainSelectedInstOperands,
     /* 199144 */     // GIR_Coverage, 11949,
     /* 199144 */     GIR_EraseRootFromParent_Done,
     /* 199145 */   // Label 3972: @199145
     /* 199145 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(199187), // Rule ID 11950 //
     /* 199150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 199153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 199158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 199161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 199165 */     // MIs[0] Op1
     /* 199165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 199169 */     // MIs[0] Op2
     /* 199169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 199173 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 199173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 199176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 199178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 199180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 199182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 199185 */     GIR_RootConstrainSelectedInstOperands,
     /* 199186 */     // GIR_Coverage, 11950,
     /* 199186 */     GIR_EraseRootFromParent_Done,
     /* 199187 */   // Label 3973: @199187
     /* 199187 */   GIM_Reject,
     /* 199188 */ // Label 3020: @199188
     /* 199188 */ GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(242971),
     /* 199193 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 199196 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199309), // Rule ID 2069 //
     /* 199201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199274 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199278 */     // MIs[3] Operand 1
     /* 199278 */     // No operand predicates
     /* 199278 */     // MIs[1] Operand 2
     /* 199278 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199291 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 199294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199307 */     GIR_RootConstrainSelectedInstOperands,
     /* 199308 */     // GIR_Coverage, 2069,
     /* 199308 */     GIR_EraseRootFromParent_Done,
     /* 199309 */   // Label 3975: @199309
     /* 199309 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199422), // Rule ID 2076 //
     /* 199314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199391 */     // MIs[3] Operand 1
     /* 199391 */     // No operand predicates
     /* 199391 */     // MIs[1] Operand 2
     /* 199391 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199404 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 199407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199420 */     GIR_RootConstrainSelectedInstOperands,
     /* 199421 */     // GIR_Coverage, 2076,
     /* 199421 */     GIR_EraseRootFromParent_Done,
     /* 199422 */   // Label 3976: @199422
     /* 199422 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199535), // Rule ID 2072 //
     /* 199427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199504 */     // MIs[3] Operand 1
     /* 199504 */     // No operand predicates
     /* 199504 */     // MIs[1] Operand 2
     /* 199504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199517 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 199520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199533 */     GIR_RootConstrainSelectedInstOperands,
     /* 199534 */     // GIR_Coverage, 2072,
     /* 199534 */     GIR_EraseRootFromParent_Done,
     /* 199535 */   // Label 3977: @199535
     /* 199535 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199648), // Rule ID 2079 //
     /* 199540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199613 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199617 */     // MIs[3] Operand 1
     /* 199617 */     // No operand predicates
     /* 199617 */     // MIs[1] Operand 2
     /* 199617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 199633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199646 */     GIR_RootConstrainSelectedInstOperands,
     /* 199647 */     // GIR_Coverage, 2079,
     /* 199647 */     GIR_EraseRootFromParent_Done,
     /* 199648 */   // Label 3978: @199648
     /* 199648 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199753), // Rule ID 3869 //
     /* 199653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199730 */     // MIs[3] Operand 1
     /* 199730 */     // No operand predicates
     /* 199730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199732 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199751 */     GIR_RootConstrainSelectedInstOperands,
     /* 199752 */     // GIR_Coverage, 3869,
     /* 199752 */     GIR_EraseRootFromParent_Done,
     /* 199753 */   // Label 3979: @199753
     /* 199753 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199858), // Rule ID 3870 //
     /* 199758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199835 */     // MIs[3] Operand 1
     /* 199835 */     // No operand predicates
     /* 199835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199837 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199856 */     GIR_RootConstrainSelectedInstOperands,
     /* 199857 */     // GIR_Coverage, 3870,
     /* 199857 */     GIR_EraseRootFromParent_Done,
     /* 199858 */   // Label 3980: @199858
     /* 199858 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199963), // Rule ID 3871 //
     /* 199863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199936 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199940 */     // MIs[3] Operand 1
     /* 199940 */     // No operand predicates
     /* 199940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199942 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199961 */     GIR_RootConstrainSelectedInstOperands,
     /* 199962 */     // GIR_Coverage, 3871,
     /* 199962 */     GIR_EraseRootFromParent_Done,
     /* 199963 */   // Label 3981: @199963
     /* 199963 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200068), // Rule ID 3872 //
     /* 199968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 200012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200041 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200045 */     // MIs[3] Operand 1
     /* 200045 */     // No operand predicates
     /* 200045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200047 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 200050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200066 */     GIR_RootConstrainSelectedInstOperands,
     /* 200067 */     // GIR_Coverage, 3872,
     /* 200067 */     GIR_EraseRootFromParent_Done,
     /* 200068 */   // Label 3982: @200068
     /* 200068 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200173), // Rule ID 3877 //
     /* 200073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 200081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 200093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200146 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200150 */     // MIs[3] Operand 1
     /* 200150 */     // No operand predicates
     /* 200150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200152 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 200152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200171 */     GIR_RootConstrainSelectedInstOperands,
     /* 200172 */     // GIR_Coverage, 3877,
     /* 200172 */     GIR_EraseRootFromParent_Done,
     /* 200173 */   // Label 3983: @200173
     /* 200173 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(200278), // Rule ID 3878 //
     /* 200178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 200186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 200198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200255 */     // MIs[3] Operand 1
     /* 200255 */     // No operand predicates
     /* 200255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200257 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 200257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200276 */     GIR_RootConstrainSelectedInstOperands,
     /* 200277 */     // GIR_Coverage, 3878,
     /* 200277 */     GIR_EraseRootFromParent_Done,
     /* 200278 */   // Label 3984: @200278
     /* 200278 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200383), // Rule ID 3879 //
     /* 200283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 200291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 200303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200360 */     // MIs[3] Operand 1
     /* 200360 */     // No operand predicates
     /* 200360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200362 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 200362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 200381 */     GIR_RootConstrainSelectedInstOperands,
     /* 200382 */     // GIR_Coverage, 3879,
     /* 200382 */     GIR_EraseRootFromParent_Done,
     /* 200383 */   // Label 3985: @200383
     /* 200383 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200488), // Rule ID 3880 //
     /* 200388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 200396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 200408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200461 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200465 */     // MIs[3] Operand 1
     /* 200465 */     // No operand predicates
     /* 200465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200467 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200486 */     GIR_RootConstrainSelectedInstOperands,
     /* 200487 */     // GIR_Coverage, 3880,
     /* 200487 */     GIR_EraseRootFromParent_Done,
     /* 200488 */   // Label 3986: @200488
     /* 200488 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200593), // Rule ID 3893 //
     /* 200493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 200501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200570 */     // MIs[3] Operand 1
     /* 200570 */     // No operand predicates
     /* 200570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200572 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 200572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200591 */     GIR_RootConstrainSelectedInstOperands,
     /* 200592 */     // GIR_Coverage, 3893,
     /* 200592 */     GIR_EraseRootFromParent_Done,
     /* 200593 */   // Label 3987: @200593
     /* 200593 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200698), // Rule ID 3894 //
     /* 200598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 200606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200671 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200675 */     // MIs[3] Operand 1
     /* 200675 */     // No operand predicates
     /* 200675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200677 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 200677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200696 */     GIR_RootConstrainSelectedInstOperands,
     /* 200697 */     // GIR_Coverage, 3894,
     /* 200697 */     GIR_EraseRootFromParent_Done,
     /* 200698 */   // Label 3988: @200698
     /* 200698 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200803), // Rule ID 3895 //
     /* 200703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 200711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200776 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200780 */     // MIs[3] Operand 1
     /* 200780 */     // No operand predicates
     /* 200780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200782 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 200782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 200801 */     GIR_RootConstrainSelectedInstOperands,
     /* 200802 */     // GIR_Coverage, 3895,
     /* 200802 */     GIR_EraseRootFromParent_Done,
     /* 200803 */   // Label 3989: @200803
     /* 200803 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200908), // Rule ID 3896 //
     /* 200808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 200816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200885 */     // MIs[3] Operand 1
     /* 200885 */     // No operand predicates
     /* 200885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200887 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200906 */     GIR_RootConstrainSelectedInstOperands,
     /* 200907 */     // GIR_Coverage, 3896,
     /* 200907 */     GIR_EraseRootFromParent_Done,
     /* 200908 */   // Label 3990: @200908
     /* 200908 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200962), // Rule ID 59 //
     /* 200913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200938 */     // MIs[0] Operand 3
     /* 200938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 200949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200953 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 200956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200960 */     GIR_RootConstrainSelectedInstOperands,
     /* 200961 */     // GIR_Coverage, 59,
     /* 200961 */     GIR_EraseRootFromParent_Done,
     /* 200962 */   // Label 3991: @200962
     /* 200962 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(201016), // Rule ID 60 //
     /* 200967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200992 */     // MIs[0] Operand 3
     /* 200992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 201003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 201007 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 201007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 201010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201014 */     GIR_RootConstrainSelectedInstOperands,
     /* 201015 */     // GIR_Coverage, 60,
     /* 201015 */     GIR_EraseRootFromParent_Done,
     /* 201016 */   // Label 3992: @201016
     /* 201016 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(201070), // Rule ID 61 //
     /* 201021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201046 */     // MIs[0] Operand 3
     /* 201046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 201057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 201061 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 201061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 201064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201068 */     GIR_RootConstrainSelectedInstOperands,
     /* 201069 */     // GIR_Coverage, 61,
     /* 201069 */     GIR_EraseRootFromParent_Done,
     /* 201070 */   // Label 3993: @201070
     /* 201070 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(201124), // Rule ID 62 //
     /* 201075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201100 */     // MIs[0] Operand 3
     /* 201100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 201111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 201115 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 201115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201122 */     GIR_RootConstrainSelectedInstOperands,
     /* 201123 */     // GIR_Coverage, 62,
     /* 201123 */     GIR_EraseRootFromParent_Done,
     /* 201124 */   // Label 3994: @201124
     /* 201124 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(201180), // Rule ID 2652 //
     /* 201129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 201137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201151 */     // MIs[0] pattern
     /* 201151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201159 */     // MIs[0] imm4
     /* 201159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 201170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201174 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201176 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201178 */     GIR_RootConstrainSelectedInstOperands,
     /* 201179 */     // GIR_Coverage, 2652,
     /* 201179 */     GIR_EraseRootFromParent_Done,
     /* 201180 */   // Label 3995: @201180
     /* 201180 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(201236), // Rule ID 2661 //
     /* 201185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 201193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201207 */     // MIs[0] pattern
     /* 201207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201215 */     // MIs[0] imm4
     /* 201215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201223 */     // (intrinsic_wo_chain:{ *:[i32] } 2016:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 201226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201230 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201232 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201234 */     GIR_RootConstrainSelectedInstOperands,
     /* 201235 */     // GIR_Coverage, 2661,
     /* 201235 */     GIR_EraseRootFromParent_Done,
     /* 201236 */   // Label 3996: @201236
     /* 201236 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(201292), // Rule ID 2662 //
     /* 201241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 201249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201263 */     // MIs[0] pattern
     /* 201263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201271 */     // MIs[0] imm4
     /* 201271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201279 */     // (intrinsic_wo_chain:{ *:[i64] } 1806:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 201282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201286 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201288 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201290 */     GIR_RootConstrainSelectedInstOperands,
     /* 201291 */     // GIR_Coverage, 2662,
     /* 201291 */     GIR_EraseRootFromParent_Done,
     /* 201292 */   // Label 3997: @201292
     /* 201292 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(201348), // Rule ID 9958 //
     /* 201297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 201305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201319 */     // MIs[0] pattern
     /* 201319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201327 */     // MIs[0] imm4
     /* 201327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201335 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 201338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201342 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201346 */     GIR_RootConstrainSelectedInstOperands,
     /* 201347 */     // GIR_Coverage, 9958,
     /* 201347 */     GIR_EraseRootFromParent_Done,
     /* 201348 */   // Label 3998: @201348
     /* 201348 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(201404), // Rule ID 9959 //
     /* 201353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 201361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201375 */     // MIs[0] pattern
     /* 201375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201383 */     // MIs[0] imm4
     /* 201383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201391 */     // (intrinsic_wo_chain:{ *:[i64] } 2017:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 201394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201398 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201400 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201402 */     GIR_RootConstrainSelectedInstOperands,
     /* 201403 */     // GIR_Coverage, 9959,
     /* 201403 */     GIR_EraseRootFromParent_Done,
     /* 201404 */   // Label 3999: @201404
     /* 201404 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(201460), // Rule ID 9960 //
     /* 201409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 201417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201431 */     // MIs[0] pattern
     /* 201431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201439 */     // MIs[0] imm4
     /* 201439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201447 */     // (intrinsic_wo_chain:{ *:[i64] } 1772:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 201450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201454 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201456 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201458 */     GIR_RootConstrainSelectedInstOperands,
     /* 201459 */     // GIR_Coverage, 9960,
     /* 201459 */     GIR_EraseRootFromParent_Done,
     /* 201460 */   // Label 4000: @201460
     /* 201460 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(201516), // Rule ID 9961 //
     /* 201465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 201473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201487 */     // MIs[0] pattern
     /* 201487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201495 */     // MIs[0] imm4
     /* 201495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201503 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 201506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201510 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201512 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201514 */     GIR_RootConstrainSelectedInstOperands,
     /* 201515 */     // GIR_Coverage, 9961,
     /* 201515 */     GIR_EraseRootFromParent_Done,
     /* 201516 */   // Label 4001: @201516
     /* 201516 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201572), // Rule ID 9964 //
     /* 201521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 201529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201543 */     // MIs[0] pattern
     /* 201543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201551 */     // MIs[0] imm4
     /* 201551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201559 */     // (intrinsic_wo_chain:{ *:[i32] } 2022:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 201562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201566 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201568 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201570 */     GIR_RootConstrainSelectedInstOperands,
     /* 201571 */     // GIR_Coverage, 9964,
     /* 201571 */     GIR_EraseRootFromParent_Done,
     /* 201572 */   // Label 4002: @201572
     /* 201572 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201628), // Rule ID 9967 //
     /* 201577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 201585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201599 */     // MIs[0] pattern
     /* 201599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201607 */     // MIs[0] imm4
     /* 201607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201615 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 201618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201622 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201624 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201626 */     GIR_RootConstrainSelectedInstOperands,
     /* 201627 */     // GIR_Coverage, 9967,
     /* 201627 */     GIR_EraseRootFromParent_Done,
     /* 201628 */   // Label 4003: @201628
     /* 201628 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201684), // Rule ID 9968 //
     /* 201633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 201641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201655 */     // MIs[0] pattern
     /* 201655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201663 */     // MIs[0] imm4
     /* 201663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201671 */     // (intrinsic_wo_chain:{ *:[i64] } 1812:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 201674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201678 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201680 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201682 */     GIR_RootConstrainSelectedInstOperands,
     /* 201683 */     // GIR_Coverage, 9968,
     /* 201683 */     GIR_EraseRootFromParent_Done,
     /* 201684 */   // Label 4004: @201684
     /* 201684 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201740), // Rule ID 9969 //
     /* 201689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 201697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201711 */     // MIs[0] pattern
     /* 201711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201719 */     // MIs[0] imm4
     /* 201719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201727 */     // (intrinsic_wo_chain:{ *:[i64] } 2023:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 201730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201734 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201736 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201738 */     GIR_RootConstrainSelectedInstOperands,
     /* 201739 */     // GIR_Coverage, 9969,
     /* 201739 */     GIR_EraseRootFromParent_Done,
     /* 201740 */   // Label 4005: @201740
     /* 201740 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201796), // Rule ID 9970 //
     /* 201745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 201753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201767 */     // MIs[0] pattern
     /* 201767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201775 */     // MIs[0] imm4
     /* 201775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201783 */     // (intrinsic_wo_chain:{ *:[i64] } 1778:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 201786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201790 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201792 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201794 */     GIR_RootConstrainSelectedInstOperands,
     /* 201795 */     // GIR_Coverage, 9970,
     /* 201795 */     GIR_EraseRootFromParent_Done,
     /* 201796 */   // Label 4006: @201796
     /* 201796 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201852), // Rule ID 9971 //
     /* 201801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 201809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201823 */     // MIs[0] pattern
     /* 201823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201831 */     // MIs[0] imm4
     /* 201831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201839 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 201842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201846 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201848 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201850 */     GIR_RootConstrainSelectedInstOperands,
     /* 201851 */     // GIR_Coverage, 9971,
     /* 201851 */     GIR_EraseRootFromParent_Done,
     /* 201852 */   // Label 4007: @201852
     /* 201852 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201908), // Rule ID 9974 //
     /* 201857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 201865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201879 */     // MIs[0] pattern
     /* 201879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201887 */     // MIs[0] imm4
     /* 201887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201895 */     // (intrinsic_wo_chain:{ *:[i32] } 2028:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 201898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201902 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201904 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201906 */     GIR_RootConstrainSelectedInstOperands,
     /* 201907 */     // GIR_Coverage, 9974,
     /* 201907 */     GIR_EraseRootFromParent_Done,
     /* 201908 */   // Label 4008: @201908
     /* 201908 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201964), // Rule ID 9977 //
     /* 201913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 201921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201935 */     // MIs[0] pattern
     /* 201935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201943 */     // MIs[0] imm4
     /* 201943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201951 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 201954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201958 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201960 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201962 */     GIR_RootConstrainSelectedInstOperands,
     /* 201963 */     // GIR_Coverage, 9977,
     /* 201963 */     GIR_EraseRootFromParent_Done,
     /* 201964 */   // Label 4009: @201964
     /* 201964 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(202020), // Rule ID 9978 //
     /* 201969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 201977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201991 */     // MIs[0] pattern
     /* 201991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201999 */     // MIs[0] imm4
     /* 201999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202007 */     // (intrinsic_wo_chain:{ *:[i64] } 1818:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 202010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202014 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202016 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202018 */     GIR_RootConstrainSelectedInstOperands,
     /* 202019 */     // GIR_Coverage, 9978,
     /* 202019 */     GIR_EraseRootFromParent_Done,
     /* 202020 */   // Label 4010: @202020
     /* 202020 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(202076), // Rule ID 9979 //
     /* 202025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 202033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202047 */     // MIs[0] pattern
     /* 202047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202055 */     // MIs[0] imm4
     /* 202055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202063 */     // (intrinsic_wo_chain:{ *:[i64] } 2029:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 202066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202070 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202072 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202074 */     GIR_RootConstrainSelectedInstOperands,
     /* 202075 */     // GIR_Coverage, 9979,
     /* 202075 */     GIR_EraseRootFromParent_Done,
     /* 202076 */   // Label 4011: @202076
     /* 202076 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(202132), // Rule ID 9980 //
     /* 202081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 202089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202103 */     // MIs[0] pattern
     /* 202103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202111 */     // MIs[0] imm4
     /* 202111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202119 */     // (intrinsic_wo_chain:{ *:[i64] } 1784:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 202122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202126 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202128 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202130 */     GIR_RootConstrainSelectedInstOperands,
     /* 202131 */     // GIR_Coverage, 9980,
     /* 202131 */     GIR_EraseRootFromParent_Done,
     /* 202132 */   // Label 4012: @202132
     /* 202132 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(202188), // Rule ID 9981 //
     /* 202137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 202145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202159 */     // MIs[0] pattern
     /* 202159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202167 */     // MIs[0] imm4
     /* 202167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202175 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 202178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202182 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202184 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202186 */     GIR_RootConstrainSelectedInstOperands,
     /* 202187 */     // GIR_Coverage, 9981,
     /* 202187 */     GIR_EraseRootFromParent_Done,
     /* 202188 */   // Label 4013: @202188
     /* 202188 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(202244), // Rule ID 9984 //
     /* 202193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 202201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202215 */     // MIs[0] pattern
     /* 202215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202218 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202223 */     // MIs[0] imm4
     /* 202223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202231 */     // (intrinsic_wo_chain:{ *:[i32] } 2019:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 202234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202238 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202240 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202242 */     GIR_RootConstrainSelectedInstOperands,
     /* 202243 */     // GIR_Coverage, 9984,
     /* 202243 */     GIR_EraseRootFromParent_Done,
     /* 202244 */   // Label 4014: @202244
     /* 202244 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(202300), // Rule ID 9987 //
     /* 202249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 202257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202271 */     // MIs[0] pattern
     /* 202271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202279 */     // MIs[0] imm4
     /* 202279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202287 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 202290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202294 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202296 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202298 */     GIR_RootConstrainSelectedInstOperands,
     /* 202299 */     // GIR_Coverage, 9987,
     /* 202299 */     GIR_EraseRootFromParent_Done,
     /* 202300 */   // Label 4015: @202300
     /* 202300 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(202356), // Rule ID 9988 //
     /* 202305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 202313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202327 */     // MIs[0] pattern
     /* 202327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202335 */     // MIs[0] imm4
     /* 202335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202343 */     // (intrinsic_wo_chain:{ *:[i64] } 1809:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 202346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202350 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202352 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202354 */     GIR_RootConstrainSelectedInstOperands,
     /* 202355 */     // GIR_Coverage, 9988,
     /* 202355 */     GIR_EraseRootFromParent_Done,
     /* 202356 */   // Label 4016: @202356
     /* 202356 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(202412), // Rule ID 9989 //
     /* 202361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 202369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202383 */     // MIs[0] pattern
     /* 202383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202391 */     // MIs[0] imm4
     /* 202391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202399 */     // (intrinsic_wo_chain:{ *:[i64] } 2020:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 202402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202406 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202408 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202410 */     GIR_RootConstrainSelectedInstOperands,
     /* 202411 */     // GIR_Coverage, 9989,
     /* 202411 */     GIR_EraseRootFromParent_Done,
     /* 202412 */   // Label 4017: @202412
     /* 202412 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(202468), // Rule ID 9990 //
     /* 202417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 202425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202439 */     // MIs[0] pattern
     /* 202439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202447 */     // MIs[0] imm4
     /* 202447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202455 */     // (intrinsic_wo_chain:{ *:[i64] } 1775:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 202458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202462 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202464 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202466 */     GIR_RootConstrainSelectedInstOperands,
     /* 202467 */     // GIR_Coverage, 9990,
     /* 202467 */     GIR_EraseRootFromParent_Done,
     /* 202468 */   // Label 4018: @202468
     /* 202468 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(202524), // Rule ID 9991 //
     /* 202473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 202481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202495 */     // MIs[0] pattern
     /* 202495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202503 */     // MIs[0] imm4
     /* 202503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202511 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202518 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202520 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202522 */     GIR_RootConstrainSelectedInstOperands,
     /* 202523 */     // GIR_Coverage, 9991,
     /* 202523 */     GIR_EraseRootFromParent_Done,
     /* 202524 */   // Label 4019: @202524
     /* 202524 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(202580), // Rule ID 9992 //
     /* 202529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 202537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202551 */     // MIs[0] pattern
     /* 202551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202559 */     // MIs[0] imm4
     /* 202559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 202570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202574 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202576 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202578 */     GIR_RootConstrainSelectedInstOperands,
     /* 202579 */     // GIR_Coverage, 9992,
     /* 202579 */     GIR_EraseRootFromParent_Done,
     /* 202580 */   // Label 4020: @202580
     /* 202580 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202636), // Rule ID 9993 //
     /* 202585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 202593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202607 */     // MIs[0] pattern
     /* 202607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202615 */     // MIs[0] imm4
     /* 202615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 202626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202630 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202632 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202634 */     GIR_RootConstrainSelectedInstOperands,
     /* 202635 */     // GIR_Coverage, 9993,
     /* 202635 */     GIR_EraseRootFromParent_Done,
     /* 202636 */   // Label 4021: @202636
     /* 202636 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202692), // Rule ID 9994 //
     /* 202641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 202649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202663 */     // MIs[0] pattern
     /* 202663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202671 */     // MIs[0] imm4
     /* 202671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 202682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202686 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202688 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202690 */     GIR_RootConstrainSelectedInstOperands,
     /* 202691 */     // GIR_Coverage, 9994,
     /* 202691 */     GIR_EraseRootFromParent_Done,
     /* 202692 */   // Label 4022: @202692
     /* 202692 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202748), // Rule ID 9995 //
     /* 202697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 202705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202719 */     // MIs[0] pattern
     /* 202719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202727 */     // MIs[0] imm4
     /* 202727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 202738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202742 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202744 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202746 */     GIR_RootConstrainSelectedInstOperands,
     /* 202747 */     // GIR_Coverage, 9995,
     /* 202747 */     GIR_EraseRootFromParent_Done,
     /* 202748 */   // Label 4023: @202748
     /* 202748 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202804), // Rule ID 9996 //
     /* 202753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 202761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202775 */     // MIs[0] pattern
     /* 202775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202783 */     // MIs[0] imm4
     /* 202783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 202794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202798 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202800 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202802 */     GIR_RootConstrainSelectedInstOperands,
     /* 202803 */     // GIR_Coverage, 9996,
     /* 202803 */     GIR_EraseRootFromParent_Done,
     /* 202804 */   // Label 4024: @202804
     /* 202804 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202860), // Rule ID 9997 //
     /* 202809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 202817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202831 */     // MIs[0] pattern
     /* 202831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202839 */     // MIs[0] imm4
     /* 202839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 202850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202854 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202856 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202858 */     GIR_RootConstrainSelectedInstOperands,
     /* 202859 */     // GIR_Coverage, 9997,
     /* 202859 */     GIR_EraseRootFromParent_Done,
     /* 202860 */   // Label 4025: @202860
     /* 202860 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202916), // Rule ID 9998 //
     /* 202865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 202873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202887 */     // MIs[0] pattern
     /* 202887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202895 */     // MIs[0] imm4
     /* 202895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 202906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202910 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202912 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202914 */     GIR_RootConstrainSelectedInstOperands,
     /* 202915 */     // GIR_Coverage, 9998,
     /* 202915 */     GIR_EraseRootFromParent_Done,
     /* 202916 */   // Label 4026: @202916
     /* 202916 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202972), // Rule ID 9999 //
     /* 202921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 202929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202943 */     // MIs[0] pattern
     /* 202943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202951 */     // MIs[0] imm4
     /* 202951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 202962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202968 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202970 */     GIR_RootConstrainSelectedInstOperands,
     /* 202971 */     // GIR_Coverage, 9999,
     /* 202971 */     GIR_EraseRootFromParent_Done,
     /* 202972 */   // Label 4027: @202972
     /* 202972 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203028), // Rule ID 10000 //
     /* 202977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 202985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202999 */     // MIs[0] pattern
     /* 202999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203007 */     // MIs[0] imm4
     /* 203007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2018:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 203018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 203022 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203024 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203026 */     GIR_RootConstrainSelectedInstOperands,
     /* 203027 */     // GIR_Coverage, 10000,
     /* 203027 */     GIR_EraseRootFromParent_Done,
     /* 203028 */   // Label 4028: @203028
     /* 203028 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(203084), // Rule ID 10001 //
     /* 203033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 203041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203055 */     // MIs[0] pattern
     /* 203055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203063 */     // MIs[0] imm4
     /* 203063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 203074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 203078 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203080 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203082 */     GIR_RootConstrainSelectedInstOperands,
     /* 203083 */     // GIR_Coverage, 10001,
     /* 203083 */     GIR_EraseRootFromParent_Done,
     /* 203084 */   // Label 4029: @203084
     /* 203084 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(203140), // Rule ID 10002 //
     /* 203089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 203097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203111 */     // MIs[0] pattern
     /* 203111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 203114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 203119 */     // MIs[0] imm4
     /* 203119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 203127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 203127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 203130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 203134 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 203136 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 203138 */     GIR_RootConstrainSelectedInstOperands,
     /* 203139 */     // GIR_Coverage, 10002,
     /* 203139 */     GIR_EraseRootFromParent_Done,
     /* 203140 */   // Label 4030: @203140
     /* 203140 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(203230), // Rule ID 47 //
     /* 203145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 203153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203210 */     // MIs[2] Operand 1
     /* 203210 */     // No operand predicates
     /* 203210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203212 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 203215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203228 */     GIR_RootConstrainSelectedInstOperands,
     /* 203229 */     // GIR_Coverage, 47,
     /* 203229 */     GIR_EraseRootFromParent_Done,
     /* 203230 */   // Label 4031: @203230
     /* 203230 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(203320), // Rule ID 48 //
     /* 203235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 203243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203296 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203300 */     // MIs[2] Operand 1
     /* 203300 */     // No operand predicates
     /* 203300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203302 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 203305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203318 */     GIR_RootConstrainSelectedInstOperands,
     /* 203319 */     // GIR_Coverage, 48,
     /* 203319 */     GIR_EraseRootFromParent_Done,
     /* 203320 */   // Label 4032: @203320
     /* 203320 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(203410), // Rule ID 49 //
     /* 203325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 203333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203386 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203390 */     // MIs[2] Operand 1
     /* 203390 */     // No operand predicates
     /* 203390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203392 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 203395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203408 */     GIR_RootConstrainSelectedInstOperands,
     /* 203409 */     // GIR_Coverage, 49,
     /* 203409 */     GIR_EraseRootFromParent_Done,
     /* 203410 */   // Label 4033: @203410
     /* 203410 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(203500), // Rule ID 50 //
     /* 203415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 203423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203476 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203480 */     // MIs[2] Operand 1
     /* 203480 */     // No operand predicates
     /* 203480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203482 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 203485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203498 */     GIR_RootConstrainSelectedInstOperands,
     /* 203499 */     // GIR_Coverage, 50,
     /* 203499 */     GIR_EraseRootFromParent_Done,
     /* 203500 */   // Label 4034: @203500
     /* 203500 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(203590), // Rule ID 51 //
     /* 203505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 203513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203570 */     // MIs[2] Operand 1
     /* 203570 */     // No operand predicates
     /* 203570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203572 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 203575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203588 */     GIR_RootConstrainSelectedInstOperands,
     /* 203589 */     // GIR_Coverage, 51,
     /* 203589 */     GIR_EraseRootFromParent_Done,
     /* 203590 */   // Label 4035: @203590
     /* 203590 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(203680), // Rule ID 52 //
     /* 203595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 203603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203660 */     // MIs[2] Operand 1
     /* 203660 */     // No operand predicates
     /* 203660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203662 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 203665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203678 */     GIR_RootConstrainSelectedInstOperands,
     /* 203679 */     // GIR_Coverage, 52,
     /* 203679 */     GIR_EraseRootFromParent_Done,
     /* 203680 */   // Label 4036: @203680
     /* 203680 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203770), // Rule ID 53 //
     /* 203685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 203693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203750 */     // MIs[2] Operand 1
     /* 203750 */     // No operand predicates
     /* 203750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203752 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 203755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203768 */     GIR_RootConstrainSelectedInstOperands,
     /* 203769 */     // GIR_Coverage, 53,
     /* 203769 */     GIR_EraseRootFromParent_Done,
     /* 203770 */   // Label 4037: @203770
     /* 203770 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203860), // Rule ID 54 //
     /* 203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 203783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203840 */     // MIs[2] Operand 1
     /* 203840 */     // No operand predicates
     /* 203840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203842 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 203845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203858 */     GIR_RootConstrainSelectedInstOperands,
     /* 203859 */     // GIR_Coverage, 54,
     /* 203859 */     GIR_EraseRootFromParent_Done,
     /* 203860 */   // Label 4038: @203860
     /* 203860 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203950), // Rule ID 2070 //
     /* 203865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203926 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203930 */     // MIs[2] Operand 1
     /* 203930 */     // No operand predicates
     /* 203930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203932 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 203935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203948 */     GIR_RootConstrainSelectedInstOperands,
     /* 203949 */     // GIR_Coverage, 2070,
     /* 203949 */     GIR_EraseRootFromParent_Done,
     /* 203950 */   // Label 4039: @203950
     /* 203950 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(204040), // Rule ID 2071 //
     /* 203955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204020 */     // MIs[2] Operand 1
     /* 204020 */     // No operand predicates
     /* 204020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204022 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 204025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204038 */     GIR_RootConstrainSelectedInstOperands,
     /* 204039 */     // GIR_Coverage, 2071,
     /* 204039 */     GIR_EraseRootFromParent_Done,
     /* 204040 */   // Label 4040: @204040
     /* 204040 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(204130), // Rule ID 2077 //
     /* 204045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 204056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 204059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 204062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 204065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204110 */     // MIs[2] Operand 1
     /* 204110 */     // No operand predicates
     /* 204110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204112 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 204115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204128 */     GIR_RootConstrainSelectedInstOperands,
     /* 204129 */     // GIR_Coverage, 2077,
     /* 204129 */     GIR_EraseRootFromParent_Done,
     /* 204130 */   // Label 4041: @204130
     /* 204130 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(204220), // Rule ID 2078 //
     /* 204135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 204149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 204152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 204155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 204175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 204179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 204188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204196 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 204200 */     // MIs[2] Operand 1
     /* 204200 */     // No operand predicates
     /* 204200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204202 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 204205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204218 */     GIR_RootConstrainSelectedInstOperands,
     /* 204219 */     // GIR_Coverage, 2078,
     /* 204219 */     GIR_EraseRootFromParent_Done,
     /* 204220 */   // Label 4042: @204220
     /* 204220 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(204310), // Rule ID 2073 //
     /* 204225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 204233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 204242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 204245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204290 */     // MIs[2] Operand 1
     /* 204290 */     // No operand predicates
     /* 204290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204292 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 204295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204308 */     GIR_RootConstrainSelectedInstOperands,
     /* 204309 */     // GIR_Coverage, 2073,
     /* 204309 */     GIR_EraseRootFromParent_Done,
     /* 204310 */   // Label 4043: @204310
     /* 204310 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(204400), // Rule ID 2074 //
     /* 204315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 204323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 204332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 204335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204380 */     // MIs[2] Operand 1
     /* 204380 */     // No operand predicates
     /* 204380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 204385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204398 */     GIR_RootConstrainSelectedInstOperands,
     /* 204399 */     // GIR_Coverage, 2074,
     /* 204399 */     GIR_EraseRootFromParent_Done,
     /* 204400 */   // Label 4044: @204400
     /* 204400 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(204490), // Rule ID 2080 //
     /* 204405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 204422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 204425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204470 */     // MIs[2] Operand 1
     /* 204470 */     // No operand predicates
     /* 204470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204472 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 204475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204488 */     GIR_RootConstrainSelectedInstOperands,
     /* 204489 */     // GIR_Coverage, 2080,
     /* 204489 */     GIR_EraseRootFromParent_Done,
     /* 204490 */   // Label 4045: @204490
     /* 204490 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(204580), // Rule ID 2081 //
     /* 204495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 204512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 204515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204560 */     // MIs[2] Operand 1
     /* 204560 */     // No operand predicates
     /* 204560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 204565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204578 */     GIR_RootConstrainSelectedInstOperands,
     /* 204579 */     // GIR_Coverage, 2081,
     /* 204579 */     GIR_EraseRootFromParent_Done,
     /* 204580 */   // Label 4046: @204580
     /* 204580 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204670), // Rule ID 2075 //
     /* 204585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 204593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 204596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 204605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 204625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204650 */     // MIs[2] Operand 1
     /* 204650 */     // No operand predicates
     /* 204650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204652 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 204655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204668 */     GIR_RootConstrainSelectedInstOperands,
     /* 204669 */     // GIR_Coverage, 2075,
     /* 204669 */     GIR_EraseRootFromParent_Done,
     /* 204670 */   // Label 4047: @204670
     /* 204670 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204760), // Rule ID 2082 //
     /* 204675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 204686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 204695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 204715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204736 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204740 */     // MIs[2] Operand 1
     /* 204740 */     // No operand predicates
     /* 204740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204742 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 204745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204758 */     GIR_RootConstrainSelectedInstOperands,
     /* 204759 */     // GIR_Coverage, 2082,
     /* 204759 */     GIR_EraseRootFromParent_Done,
     /* 204760 */   // Label 4048: @204760
     /* 204760 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204837), // Rule ID 2781 //
     /* 204765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204817 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204821 */     // MIs[2] Operand 1
     /* 204821 */     // No operand predicates
     /* 204821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204823 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204835 */     GIR_RootConstrainSelectedInstOperands,
     /* 204836 */     // GIR_Coverage, 2781,
     /* 204836 */     GIR_EraseRootFromParent_Done,
     /* 204837 */   // Label 4049: @204837
     /* 204837 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204914), // Rule ID 2782 //
     /* 204842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204894 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204898 */     // MIs[2] Operand 1
     /* 204898 */     // No operand predicates
     /* 204898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204912 */     GIR_RootConstrainSelectedInstOperands,
     /* 204913 */     // GIR_Coverage, 2782,
     /* 204913 */     GIR_EraseRootFromParent_Done,
     /* 204914 */   // Label 4050: @204914
     /* 204914 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204991), // Rule ID 2783 //
     /* 204919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204971 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204975 */     // MIs[2] Operand 1
     /* 204975 */     // No operand predicates
     /* 204975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204977 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204989 */     GIR_RootConstrainSelectedInstOperands,
     /* 204990 */     // GIR_Coverage, 2783,
     /* 204990 */     GIR_EraseRootFromParent_Done,
     /* 204991 */   // Label 4051: @204991
     /* 204991 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(205068), // Rule ID 2784 //
     /* 204996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 205004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205048 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205052 */     // MIs[2] Operand 1
     /* 205052 */     // No operand predicates
     /* 205052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 205057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205066 */     GIR_RootConstrainSelectedInstOperands,
     /* 205067 */     // GIR_Coverage, 2784,
     /* 205067 */     GIR_EraseRootFromParent_Done,
     /* 205068 */   // Label 4052: @205068
     /* 205068 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(205145), // Rule ID 2785 //
     /* 205073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 205081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205125 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205129 */     // MIs[2] Operand 1
     /* 205129 */     // No operand predicates
     /* 205129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205131 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 205134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205143 */     GIR_RootConstrainSelectedInstOperands,
     /* 205144 */     // GIR_Coverage, 2785,
     /* 205144 */     GIR_EraseRootFromParent_Done,
     /* 205145 */   // Label 4053: @205145
     /* 205145 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205222), // Rule ID 2786 //
     /* 205150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 205158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205202 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205206 */     // MIs[2] Operand 1
     /* 205206 */     // No operand predicates
     /* 205206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205208 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 205211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205220 */     GIR_RootConstrainSelectedInstOperands,
     /* 205221 */     // GIR_Coverage, 2786,
     /* 205221 */     GIR_EraseRootFromParent_Done,
     /* 205222 */   // Label 4054: @205222
     /* 205222 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205299), // Rule ID 7845 //
     /* 205227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205279 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205283 */     // MIs[2] Operand 1
     /* 205283 */     // No operand predicates
     /* 205283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205285 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 205288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205297 */     GIR_RootConstrainSelectedInstOperands,
     /* 205298 */     // GIR_Coverage, 7845,
     /* 205298 */     GIR_EraseRootFromParent_Done,
     /* 205299 */   // Label 4055: @205299
     /* 205299 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205376), // Rule ID 7846 //
     /* 205304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205356 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205360 */     // MIs[2] Operand 1
     /* 205360 */     // No operand predicates
     /* 205360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 205365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205374 */     GIR_RootConstrainSelectedInstOperands,
     /* 205375 */     // GIR_Coverage, 7846,
     /* 205375 */     GIR_EraseRootFromParent_Done,
     /* 205376 */   // Label 4056: @205376
     /* 205376 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205453), // Rule ID 7847 //
     /* 205381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205433 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205437 */     // MIs[2] Operand 1
     /* 205437 */     // No operand predicates
     /* 205437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205439 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 205442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205451 */     GIR_RootConstrainSelectedInstOperands,
     /* 205452 */     // GIR_Coverage, 7847,
     /* 205452 */     GIR_EraseRootFromParent_Done,
     /* 205453 */   // Label 4057: @205453
     /* 205453 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205530), // Rule ID 7848 //
     /* 205458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205510 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205514 */     // MIs[2] Operand 1
     /* 205514 */     // No operand predicates
     /* 205514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 205519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205528 */     GIR_RootConstrainSelectedInstOperands,
     /* 205529 */     // GIR_Coverage, 7848,
     /* 205529 */     GIR_EraseRootFromParent_Done,
     /* 205530 */   // Label 4058: @205530
     /* 205530 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205607), // Rule ID 7849 //
     /* 205535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205587 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205591 */     // MIs[2] Operand 1
     /* 205591 */     // No operand predicates
     /* 205591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205593 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 205596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205605 */     GIR_RootConstrainSelectedInstOperands,
     /* 205606 */     // GIR_Coverage, 7849,
     /* 205606 */     GIR_EraseRootFromParent_Done,
     /* 205607 */   // Label 4059: @205607
     /* 205607 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205684), // Rule ID 7850 //
     /* 205612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205664 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205668 */     // MIs[2] Operand 1
     /* 205668 */     // No operand predicates
     /* 205668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205670 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 205673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205682 */     GIR_RootConstrainSelectedInstOperands,
     /* 205683 */     // GIR_Coverage, 7850,
     /* 205683 */     GIR_EraseRootFromParent_Done,
     /* 205684 */   // Label 4060: @205684
     /* 205684 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205761), // Rule ID 7851 //
     /* 205689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205741 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205745 */     // MIs[2] Operand 1
     /* 205745 */     // No operand predicates
     /* 205745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205747 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 205750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205759 */     GIR_RootConstrainSelectedInstOperands,
     /* 205760 */     // GIR_Coverage, 7851,
     /* 205760 */     GIR_EraseRootFromParent_Done,
     /* 205761 */   // Label 4061: @205761
     /* 205761 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205838), // Rule ID 7852 //
     /* 205766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205818 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205822 */     // MIs[2] Operand 1
     /* 205822 */     // No operand predicates
     /* 205822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 205827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205836 */     GIR_RootConstrainSelectedInstOperands,
     /* 205837 */     // GIR_Coverage, 7852,
     /* 205837 */     GIR_EraseRootFromParent_Done,
     /* 205838 */   // Label 4062: @205838
     /* 205838 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205915), // Rule ID 7853 //
     /* 205843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205895 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205899 */     // MIs[2] Operand 1
     /* 205899 */     // No operand predicates
     /* 205899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205901 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205913 */     GIR_RootConstrainSelectedInstOperands,
     /* 205914 */     // GIR_Coverage, 7853,
     /* 205914 */     GIR_EraseRootFromParent_Done,
     /* 205915 */   // Label 4063: @205915
     /* 205915 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205992), // Rule ID 7854 //
     /* 205920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205972 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205976 */     // MIs[2] Operand 1
     /* 205976 */     // No operand predicates
     /* 205976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205978 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205990 */     GIR_RootConstrainSelectedInstOperands,
     /* 205991 */     // GIR_Coverage, 7854,
     /* 205991 */     GIR_EraseRootFromParent_Done,
     /* 205992 */   // Label 4064: @205992
     /* 205992 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(206069), // Rule ID 7855 //
     /* 205997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 206005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206049 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206053 */     // MIs[2] Operand 1
     /* 206053 */     // No operand predicates
     /* 206053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206055 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 206058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206067 */     GIR_RootConstrainSelectedInstOperands,
     /* 206068 */     // GIR_Coverage, 7855,
     /* 206068 */     GIR_EraseRootFromParent_Done,
     /* 206069 */   // Label 4065: @206069
     /* 206069 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(206146), // Rule ID 7856 //
     /* 206074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 206082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206126 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 206130 */     // MIs[2] Operand 1
     /* 206130 */     // No operand predicates
     /* 206130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206132 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 206135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206144 */     GIR_RootConstrainSelectedInstOperands,
     /* 206145 */     // GIR_Coverage, 7856,
     /* 206145 */     GIR_EraseRootFromParent_Done,
     /* 206146 */   // Label 4066: @206146
     /* 206146 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(206223), // Rule ID 7857 //
     /* 206151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206203 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206207 */     // MIs[2] Operand 1
     /* 206207 */     // No operand predicates
     /* 206207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206209 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 206212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206221 */     GIR_RootConstrainSelectedInstOperands,
     /* 206222 */     // GIR_Coverage, 7857,
     /* 206222 */     GIR_EraseRootFromParent_Done,
     /* 206223 */   // Label 4067: @206223
     /* 206223 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(206300), // Rule ID 7858 //
     /* 206228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206280 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206284 */     // MIs[2] Operand 1
     /* 206284 */     // No operand predicates
     /* 206284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 206289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206298 */     GIR_RootConstrainSelectedInstOperands,
     /* 206299 */     // GIR_Coverage, 7858,
     /* 206299 */     GIR_EraseRootFromParent_Done,
     /* 206300 */   // Label 4068: @206300
     /* 206300 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(206377), // Rule ID 7859 //
     /* 206305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206357 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206361 */     // MIs[2] Operand 1
     /* 206361 */     // No operand predicates
     /* 206361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206363 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 206366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206375 */     GIR_RootConstrainSelectedInstOperands,
     /* 206376 */     // GIR_Coverage, 7859,
     /* 206376 */     GIR_EraseRootFromParent_Done,
     /* 206377 */   // Label 4069: @206377
     /* 206377 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(206454), // Rule ID 7860 //
     /* 206382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206434 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206438 */     // MIs[2] Operand 1
     /* 206438 */     // No operand predicates
     /* 206438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 206443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206452 */     GIR_RootConstrainSelectedInstOperands,
     /* 206453 */     // GIR_Coverage, 7860,
     /* 206453 */     GIR_EraseRootFromParent_Done,
     /* 206454 */   // Label 4070: @206454
     /* 206454 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(206531), // Rule ID 7861 //
     /* 206459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206511 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206515 */     // MIs[2] Operand 1
     /* 206515 */     // No operand predicates
     /* 206515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206517 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 206520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206529 */     GIR_RootConstrainSelectedInstOperands,
     /* 206530 */     // GIR_Coverage, 7861,
     /* 206530 */     GIR_EraseRootFromParent_Done,
     /* 206531 */   // Label 4071: @206531
     /* 206531 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206608), // Rule ID 7862 //
     /* 206536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206588 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206592 */     // MIs[2] Operand 1
     /* 206592 */     // No operand predicates
     /* 206592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 206597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206606 */     GIR_RootConstrainSelectedInstOperands,
     /* 206607 */     // GIR_Coverage, 7862,
     /* 206607 */     GIR_EraseRootFromParent_Done,
     /* 206608 */   // Label 4072: @206608
     /* 206608 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206685), // Rule ID 7863 //
     /* 206613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206665 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206669 */     // MIs[2] Operand 1
     /* 206669 */     // No operand predicates
     /* 206669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 206674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206683 */     GIR_RootConstrainSelectedInstOperands,
     /* 206684 */     // GIR_Coverage, 7863,
     /* 206684 */     GIR_EraseRootFromParent_Done,
     /* 206685 */   // Label 4073: @206685
     /* 206685 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206762), // Rule ID 7864 //
     /* 206690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206742 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206746 */     // MIs[2] Operand 1
     /* 206746 */     // No operand predicates
     /* 206746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206748 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 206751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206760 */     GIR_RootConstrainSelectedInstOperands,
     /* 206761 */     // GIR_Coverage, 7864,
     /* 206761 */     GIR_EraseRootFromParent_Done,
     /* 206762 */   // Label 4074: @206762
     /* 206762 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206839), // Rule ID 7865 //
     /* 206767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206819 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206823 */     // MIs[2] Operand 1
     /* 206823 */     // No operand predicates
     /* 206823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206837 */     GIR_RootConstrainSelectedInstOperands,
     /* 206838 */     // GIR_Coverage, 7865,
     /* 206838 */     GIR_EraseRootFromParent_Done,
     /* 206839 */   // Label 4075: @206839
     /* 206839 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206916), // Rule ID 7866 //
     /* 206844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206896 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206900 */     // MIs[2] Operand 1
     /* 206900 */     // No operand predicates
     /* 206900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206914 */     GIR_RootConstrainSelectedInstOperands,
     /* 206915 */     // GIR_Coverage, 7866,
     /* 206915 */     GIR_EraseRootFromParent_Done,
     /* 206916 */   // Label 4076: @206916
     /* 206916 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206993), // Rule ID 7867 //
     /* 206921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206973 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206977 */     // MIs[2] Operand 1
     /* 206977 */     // No operand predicates
     /* 206977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206991 */     GIR_RootConstrainSelectedInstOperands,
     /* 206992 */     // GIR_Coverage, 7867,
     /* 206992 */     GIR_EraseRootFromParent_Done,
     /* 206993 */   // Label 4077: @206993
     /* 206993 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(207070), // Rule ID 7868 //
     /* 206998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 207006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207050 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207054 */     // MIs[2] Operand 1
     /* 207054 */     // No operand predicates
     /* 207054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207056 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 207059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207068 */     GIR_RootConstrainSelectedInstOperands,
     /* 207069 */     // GIR_Coverage, 7868,
     /* 207069 */     GIR_EraseRootFromParent_Done,
     /* 207070 */   // Label 4078: @207070
     /* 207070 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(207147), // Rule ID 7869 //
     /* 207075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207127 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207131 */     // MIs[2] Operand 1
     /* 207131 */     // No operand predicates
     /* 207131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207133 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 207136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207145 */     GIR_RootConstrainSelectedInstOperands,
     /* 207146 */     // GIR_Coverage, 7869,
     /* 207146 */     GIR_EraseRootFromParent_Done,
     /* 207147 */   // Label 4079: @207147
     /* 207147 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(207224), // Rule ID 7870 //
     /* 207152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207204 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207208 */     // MIs[2] Operand 1
     /* 207208 */     // No operand predicates
     /* 207208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 207213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207222 */     GIR_RootConstrainSelectedInstOperands,
     /* 207223 */     // GIR_Coverage, 7870,
     /* 207223 */     GIR_EraseRootFromParent_Done,
     /* 207224 */   // Label 4080: @207224
     /* 207224 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(207301), // Rule ID 7871 //
     /* 207229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207281 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207285 */     // MIs[2] Operand 1
     /* 207285 */     // No operand predicates
     /* 207285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207287 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 207290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207299 */     GIR_RootConstrainSelectedInstOperands,
     /* 207300 */     // GIR_Coverage, 7871,
     /* 207300 */     GIR_EraseRootFromParent_Done,
     /* 207301 */   // Label 4081: @207301
     /* 207301 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(207378), // Rule ID 7872 //
     /* 207306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207358 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207362 */     // MIs[2] Operand 1
     /* 207362 */     // No operand predicates
     /* 207362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 207367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207376 */     GIR_RootConstrainSelectedInstOperands,
     /* 207377 */     // GIR_Coverage, 7872,
     /* 207377 */     GIR_EraseRootFromParent_Done,
     /* 207378 */   // Label 4082: @207378
     /* 207378 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(207455), // Rule ID 7873 //
     /* 207383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207435 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207439 */     // MIs[2] Operand 1
     /* 207439 */     // No operand predicates
     /* 207439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207441 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 207444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207453 */     GIR_RootConstrainSelectedInstOperands,
     /* 207454 */     // GIR_Coverage, 7873,
     /* 207454 */     GIR_EraseRootFromParent_Done,
     /* 207455 */   // Label 4083: @207455
     /* 207455 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(207532), // Rule ID 7874 //
     /* 207460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207512 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207516 */     // MIs[2] Operand 1
     /* 207516 */     // No operand predicates
     /* 207516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207518 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 207521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207530 */     GIR_RootConstrainSelectedInstOperands,
     /* 207531 */     // GIR_Coverage, 7874,
     /* 207531 */     GIR_EraseRootFromParent_Done,
     /* 207532 */   // Label 4084: @207532
     /* 207532 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(207609), // Rule ID 7875 //
     /* 207537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207589 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207593 */     // MIs[2] Operand 1
     /* 207593 */     // No operand predicates
     /* 207593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207595 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 207598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207607 */     GIR_RootConstrainSelectedInstOperands,
     /* 207608 */     // GIR_Coverage, 7875,
     /* 207608 */     GIR_EraseRootFromParent_Done,
     /* 207609 */   // Label 4085: @207609
     /* 207609 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(207686), // Rule ID 7876 //
     /* 207614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207666 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207670 */     // MIs[2] Operand 1
     /* 207670 */     // No operand predicates
     /* 207670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207672 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 207675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207684 */     GIR_RootConstrainSelectedInstOperands,
     /* 207685 */     // GIR_Coverage, 7876,
     /* 207685 */     GIR_EraseRootFromParent_Done,
     /* 207686 */   // Label 4086: @207686
     /* 207686 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207763), // Rule ID 7877 //
     /* 207691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207743 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207747 */     // MIs[2] Operand 1
     /* 207747 */     // No operand predicates
     /* 207747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207749 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 207752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207761 */     GIR_RootConstrainSelectedInstOperands,
     /* 207762 */     // GIR_Coverage, 7877,
     /* 207762 */     GIR_EraseRootFromParent_Done,
     /* 207763 */   // Label 4087: @207763
     /* 207763 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207840), // Rule ID 7878 //
     /* 207768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207820 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207824 */     // MIs[2] Operand 1
     /* 207824 */     // No operand predicates
     /* 207824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207826 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 207829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207838 */     GIR_RootConstrainSelectedInstOperands,
     /* 207839 */     // GIR_Coverage, 7878,
     /* 207839 */     GIR_EraseRootFromParent_Done,
     /* 207840 */   // Label 4088: @207840
     /* 207840 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207917), // Rule ID 7879 //
     /* 207845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207897 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207901 */     // MIs[2] Operand 1
     /* 207901 */     // No operand predicates
     /* 207901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207903 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207915 */     GIR_RootConstrainSelectedInstOperands,
     /* 207916 */     // GIR_Coverage, 7879,
     /* 207916 */     GIR_EraseRootFromParent_Done,
     /* 207917 */   // Label 4089: @207917
     /* 207917 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207994), // Rule ID 7880 //
     /* 207922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207974 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207978 */     // MIs[2] Operand 1
     /* 207978 */     // No operand predicates
     /* 207978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207980 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207992 */     GIR_RootConstrainSelectedInstOperands,
     /* 207993 */     // GIR_Coverage, 7880,
     /* 207993 */     GIR_EraseRootFromParent_Done,
     /* 207994 */   // Label 4090: @207994
     /* 207994 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(208071), // Rule ID 7881 //
     /* 207999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208051 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208055 */     // MIs[2] Operand 1
     /* 208055 */     // No operand predicates
     /* 208055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208057 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 208057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208069 */     GIR_RootConstrainSelectedInstOperands,
     /* 208070 */     // GIR_Coverage, 7881,
     /* 208070 */     GIR_EraseRootFromParent_Done,
     /* 208071 */   // Label 4091: @208071
     /* 208071 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(208148), // Rule ID 7882 //
     /* 208076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 208090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 208096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 208120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208128 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208132 */     // MIs[2] Operand 1
     /* 208132 */     // No operand predicates
     /* 208132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208134 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 208134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 208137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208146 */     GIR_RootConstrainSelectedInstOperands,
     /* 208147 */     // GIR_Coverage, 7882,
     /* 208147 */     GIR_EraseRootFromParent_Done,
     /* 208148 */   // Label 4092: @208148
     /* 208148 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(208225), // Rule ID 7883 //
     /* 208153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208205 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208209 */     // MIs[2] Operand 1
     /* 208209 */     // No operand predicates
     /* 208209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208211 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 208211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 208214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208223 */     GIR_RootConstrainSelectedInstOperands,
     /* 208224 */     // GIR_Coverage, 7883,
     /* 208224 */     GIR_EraseRootFromParent_Done,
     /* 208225 */   // Label 4093: @208225
     /* 208225 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(208302), // Rule ID 7884 //
     /* 208230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 208244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 208250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 208274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208282 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208286 */     // MIs[2] Operand 1
     /* 208286 */     // No operand predicates
     /* 208286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208288 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 208288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 208291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208300 */     GIR_RootConstrainSelectedInstOperands,
     /* 208301 */     // GIR_Coverage, 7884,
     /* 208301 */     GIR_EraseRootFromParent_Done,
     /* 208302 */   // Label 4094: @208302
     /* 208302 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(208379), // Rule ID 7885 //
     /* 208307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208359 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208363 */     // MIs[2] Operand 1
     /* 208363 */     // No operand predicates
     /* 208363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208365 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 208368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208377 */     GIR_RootConstrainSelectedInstOperands,
     /* 208378 */     // GIR_Coverage, 7885,
     /* 208378 */     GIR_EraseRootFromParent_Done,
     /* 208379 */   // Label 4095: @208379
     /* 208379 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(208456), // Rule ID 7886 //
     /* 208384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208436 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208440 */     // MIs[2] Operand 1
     /* 208440 */     // No operand predicates
     /* 208440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208442 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 208445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208454 */     GIR_RootConstrainSelectedInstOperands,
     /* 208455 */     // GIR_Coverage, 7886,
     /* 208455 */     GIR_EraseRootFromParent_Done,
     /* 208456 */   // Label 4096: @208456
     /* 208456 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(208512), // Rule ID 55 //
     /* 208461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208486 */     // MIs[0] Operand 3
     /* 208486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 208497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208501 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208510 */     GIR_RootConstrainSelectedInstOperands,
     /* 208511 */     // GIR_Coverage, 55,
     /* 208511 */     GIR_EraseRootFromParent_Done,
     /* 208512 */   // Label 4097: @208512
     /* 208512 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(208568), // Rule ID 56 //
     /* 208517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208542 */     // MIs[0] Operand 3
     /* 208542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 208553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208557 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 208560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208566 */     GIR_RootConstrainSelectedInstOperands,
     /* 208567 */     // GIR_Coverage, 56,
     /* 208567 */     GIR_EraseRootFromParent_Done,
     /* 208568 */   // Label 4098: @208568
     /* 208568 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(208624), // Rule ID 57 //
     /* 208573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208598 */     // MIs[0] Operand 3
     /* 208598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 208609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208613 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 208616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208622 */     GIR_RootConstrainSelectedInstOperands,
     /* 208623 */     // GIR_Coverage, 57,
     /* 208623 */     GIR_EraseRootFromParent_Done,
     /* 208624 */   // Label 4099: @208624
     /* 208624 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(208680), // Rule ID 58 //
     /* 208629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208654 */     // MIs[0] Operand 3
     /* 208654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 208665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208669 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 208672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208678 */     GIR_RootConstrainSelectedInstOperands,
     /* 208679 */     // GIR_Coverage, 58,
     /* 208679 */     GIR_EraseRootFromParent_Done,
     /* 208680 */   // Label 4100: @208680
     /* 208680 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(208735), // Rule ID 2799 //
     /* 208685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208714 */     // MIs[0] imm
     /* 208714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208717 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208722 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 208725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208731 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208733 */     GIR_RootConstrainSelectedInstOperands,
     /* 208734 */     // GIR_Coverage, 2799,
     /* 208734 */     GIR_EraseRootFromParent_Done,
     /* 208735 */   // Label 4101: @208735
     /* 208735 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(208790), // Rule ID 2800 //
     /* 208740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208769 */     // MIs[0] imm
     /* 208769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208777 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 208780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208786 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208788 */     GIR_RootConstrainSelectedInstOperands,
     /* 208789 */     // GIR_Coverage, 2800,
     /* 208789 */     GIR_EraseRootFromParent_Done,
     /* 208790 */   // Label 4102: @208790
     /* 208790 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(208845), // Rule ID 2801 //
     /* 208795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208824 */     // MIs[0] imm
     /* 208824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 208835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208841 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 2801,
     /* 208844 */     GIR_EraseRootFromParent_Done,
     /* 208845 */   // Label 4103: @208845
     /* 208845 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208900), // Rule ID 3552 //
     /* 208850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208879 */     // MIs[0] Idx
     /* 208879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 208887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 208887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 208890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208898 */     GIR_RootConstrainSelectedInstOperands,
     /* 208899 */     // GIR_Coverage, 3552,
     /* 208899 */     GIR_EraseRootFromParent_Done,
     /* 208900 */   // Label 4104: @208900
     /* 208900 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208955), // Rule ID 3553 //
     /* 208905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208934 */     // MIs[0] Idx
     /* 208934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 208942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 208942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 208945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208953 */     GIR_RootConstrainSelectedInstOperands,
     /* 208954 */     // GIR_Coverage, 3553,
     /* 208954 */     GIR_EraseRootFromParent_Done,
     /* 208955 */   // Label 4105: @208955
     /* 208955 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(209010), // Rule ID 3554 //
     /* 208960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208989 */     // MIs[0] Idx
     /* 208989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 208997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 208997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 209000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 209004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 209006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 209008 */     GIR_RootConstrainSelectedInstOperands,
     /* 209009 */     // GIR_Coverage, 3554,
     /* 209009 */     GIR_EraseRootFromParent_Done,
     /* 209010 */   // Label 4106: @209010
     /* 209010 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(209065), // Rule ID 3844 //
     /* 209015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 209023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209044 */     // MIs[0] imm
     /* 209044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 209052 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 209052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 209055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 209061 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 209063 */     GIR_RootConstrainSelectedInstOperands,
     /* 209064 */     // GIR_Coverage, 3844,
     /* 209064 */     GIR_EraseRootFromParent_Done,
     /* 209065 */   // Label 4107: @209065
     /* 209065 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(209112), // Rule ID 2853 //
     /* 209070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 209078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209091 */     // MIs[0] idx
     /* 209091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209099 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 209099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 209102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209108 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209110 */     GIR_RootConstrainSelectedInstOperands,
     /* 209111 */     // GIR_Coverage, 2853,
     /* 209111 */     GIR_EraseRootFromParent_Done,
     /* 209112 */   // Label 4108: @209112
     /* 209112 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(209159), // Rule ID 2854 //
     /* 209117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 209125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209138 */     // MIs[0] idx
     /* 209138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209146 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 209146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 209149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209155 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209157 */     GIR_RootConstrainSelectedInstOperands,
     /* 209158 */     // GIR_Coverage, 2854,
     /* 209158 */     GIR_EraseRootFromParent_Done,
     /* 209159 */   // Label 4109: @209159
     /* 209159 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(209206), // Rule ID 2855 //
     /* 209164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 209167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 209172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209185 */     // MIs[0] idx
     /* 209185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209193 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 209193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 209196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209202 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209204 */     GIR_RootConstrainSelectedInstOperands,
     /* 209205 */     // GIR_Coverage, 2855,
     /* 209205 */     GIR_EraseRootFromParent_Done,
     /* 209206 */   // Label 4110: @209206
     /* 209206 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(209253), // Rule ID 3004 //
     /* 209211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 209219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209232 */     // MIs[0] Op3
     /* 209232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 209243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209251 */     GIR_RootConstrainSelectedInstOperands,
     /* 209252 */     // GIR_Coverage, 3004,
     /* 209252 */     GIR_EraseRootFromParent_Done,
     /* 209253 */   // Label 4111: @209253
     /* 209253 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(209300), // Rule ID 3005 //
     /* 209258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 209266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209279 */     // MIs[0] Op3
     /* 209279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 209290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209298 */     GIR_RootConstrainSelectedInstOperands,
     /* 209299 */     // GIR_Coverage, 3005,
     /* 209299 */     GIR_EraseRootFromParent_Done,
     /* 209300 */   // Label 4112: @209300
     /* 209300 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(209347), // Rule ID 3006 //
     /* 209305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 209313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209326 */     // MIs[0] Op3
     /* 209326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 209337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209345 */     GIR_RootConstrainSelectedInstOperands,
     /* 209346 */     // GIR_Coverage, 3006,
     /* 209346 */     GIR_EraseRootFromParent_Done,
     /* 209347 */   // Label 4113: @209347
     /* 209347 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(209394), // Rule ID 3007 //
     /* 209352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 209360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209373 */     // MIs[0] Op3
     /* 209373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 209384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209392 */     GIR_RootConstrainSelectedInstOperands,
     /* 209393 */     // GIR_Coverage, 3007,
     /* 209393 */     GIR_EraseRootFromParent_Done,
     /* 209394 */   // Label 4114: @209394
     /* 209394 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(209441), // Rule ID 3008 //
     /* 209399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 209407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209420 */     // MIs[0] Op3
     /* 209420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209439 */     GIR_RootConstrainSelectedInstOperands,
     /* 209440 */     // GIR_Coverage, 3008,
     /* 209440 */     GIR_EraseRootFromParent_Done,
     /* 209441 */   // Label 4115: @209441
     /* 209441 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(209488), // Rule ID 3056 //
     /* 209446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209467 */     // MIs[0] Op3
     /* 209467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209475 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 209478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209486 */     GIR_RootConstrainSelectedInstOperands,
     /* 209487 */     // GIR_Coverage, 3056,
     /* 209487 */     GIR_EraseRootFromParent_Done,
     /* 209488 */   // Label 4116: @209488
     /* 209488 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(209535), // Rule ID 3058 //
     /* 209493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209514 */     // MIs[0] Op3
     /* 209514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 209525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209533 */     GIR_RootConstrainSelectedInstOperands,
     /* 209534 */     // GIR_Coverage, 3058,
     /* 209534 */     GIR_EraseRootFromParent_Done,
     /* 209535 */   // Label 4117: @209535
     /* 209535 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(209582), // Rule ID 3060 //
     /* 209540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209561 */     // MIs[0] Op3
     /* 209561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 209572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209580 */     GIR_RootConstrainSelectedInstOperands,
     /* 209581 */     // GIR_Coverage, 3060,
     /* 209581 */     GIR_EraseRootFromParent_Done,
     /* 209582 */   // Label 4118: @209582
     /* 209582 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(209629), // Rule ID 3062 //
     /* 209587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209608 */     // MIs[0] Op3
     /* 209608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 209619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209627 */     GIR_RootConstrainSelectedInstOperands,
     /* 209628 */     // GIR_Coverage, 3062,
     /* 209628 */     GIR_EraseRootFromParent_Done,
     /* 209629 */   // Label 4119: @209629
     /* 209629 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(209676), // Rule ID 3084 //
     /* 209634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209655 */     // MIs[0] Op3
     /* 209655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209663 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 209666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209674 */     GIR_RootConstrainSelectedInstOperands,
     /* 209675 */     // GIR_Coverage, 3084,
     /* 209675 */     GIR_EraseRootFromParent_Done,
     /* 209676 */   // Label 4120: @209676
     /* 209676 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(209723), // Rule ID 3085 //
     /* 209681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209702 */     // MIs[0] Op3
     /* 209702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 209713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209721 */     GIR_RootConstrainSelectedInstOperands,
     /* 209722 */     // GIR_Coverage, 3085,
     /* 209722 */     GIR_EraseRootFromParent_Done,
     /* 209723 */   // Label 4121: @209723
     /* 209723 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209770), // Rule ID 3086 //
     /* 209728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209749 */     // MIs[0] Op3
     /* 209749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 209760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209768 */     GIR_RootConstrainSelectedInstOperands,
     /* 209769 */     // GIR_Coverage, 3086,
     /* 209769 */     GIR_EraseRootFromParent_Done,
     /* 209770 */   // Label 4122: @209770
     /* 209770 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209817), // Rule ID 3155 //
     /* 209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209796 */     // MIs[0] Op3
     /* 209796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209804 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 209807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209815 */     GIR_RootConstrainSelectedInstOperands,
     /* 209816 */     // GIR_Coverage, 3155,
     /* 209816 */     GIR_EraseRootFromParent_Done,
     /* 209817 */   // Label 4123: @209817
     /* 209817 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209864), // Rule ID 3156 //
     /* 209822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209843 */     // MIs[0] Op3
     /* 209843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 209854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209862 */     GIR_RootConstrainSelectedInstOperands,
     /* 209863 */     // GIR_Coverage, 3156,
     /* 209863 */     GIR_EraseRootFromParent_Done,
     /* 209864 */   // Label 4124: @209864
     /* 209864 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209911), // Rule ID 3157 //
     /* 209869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209890 */     // MIs[0] Op3
     /* 209890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 209901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209909 */     GIR_RootConstrainSelectedInstOperands,
     /* 209910 */     // GIR_Coverage, 3157,
     /* 209910 */     GIR_EraseRootFromParent_Done,
     /* 209911 */   // Label 4125: @209911
     /* 209911 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209958), // Rule ID 3158 //
     /* 209916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209937 */     // MIs[0] Op3
     /* 209937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 209948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209956 */     GIR_RootConstrainSelectedInstOperands,
     /* 209957 */     // GIR_Coverage, 3158,
     /* 209957 */     GIR_EraseRootFromParent_Done,
     /* 209958 */   // Label 4126: @209958
     /* 209958 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(210005), // Rule ID 3537 //
     /* 209963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 209966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 209971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209984 */     // MIs[0] Op3
     /* 209984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 209992 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1357:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 209992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 209995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210003 */     GIR_RootConstrainSelectedInstOperands,
     /* 210004 */     // GIR_Coverage, 3537,
     /* 210004 */     GIR_EraseRootFromParent_Done,
     /* 210005 */   // Label 4127: @210005
     /* 210005 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(210052), // Rule ID 3585 //
     /* 210010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 210018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210031 */     // MIs[0] Op3
     /* 210031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 210039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 210039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 210042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210050 */     GIR_RootConstrainSelectedInstOperands,
     /* 210051 */     // GIR_Coverage, 3585,
     /* 210051 */     GIR_EraseRootFromParent_Done,
     /* 210052 */   // Label 4128: @210052
     /* 210052 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(210099), // Rule ID 3586 //
     /* 210057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 210065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210078 */     // MIs[0] Op3
     /* 210078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 210086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 210089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210097 */     GIR_RootConstrainSelectedInstOperands,
     /* 210098 */     // GIR_Coverage, 3586,
     /* 210098 */     GIR_EraseRootFromParent_Done,
     /* 210099 */   // Label 4129: @210099
     /* 210099 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(210146), // Rule ID 3587 //
     /* 210104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 210112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210125 */     // MIs[0] Op3
     /* 210125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 210133 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1596:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 210133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210144 */     GIR_RootConstrainSelectedInstOperands,
     /* 210145 */     // GIR_Coverage, 3587,
     /* 210145 */     GIR_EraseRootFromParent_Done,
     /* 210146 */   // Label 4130: @210146
     /* 210146 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(210193), // Rule ID 3588 //
     /* 210151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 210159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210172 */     // MIs[0] Op3
     /* 210172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 210180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 210180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 210183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210191 */     GIR_RootConstrainSelectedInstOperands,
     /* 210192 */     // GIR_Coverage, 3588,
     /* 210192 */     GIR_EraseRootFromParent_Done,
     /* 210193 */   // Label 4131: @210193
     /* 210193 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(210240), // Rule ID 3589 //
     /* 210198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 210206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210219 */     // MIs[0] Op3
     /* 210219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 210227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 210227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 210230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210238 */     GIR_RootConstrainSelectedInstOperands,
     /* 210239 */     // GIR_Coverage, 3589,
     /* 210239 */     GIR_EraseRootFromParent_Done,
     /* 210240 */   // Label 4132: @210240
     /* 210240 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(210287), // Rule ID 3590 //
     /* 210245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 210248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 210253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210266 */     // MIs[0] Op3
     /* 210266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 210274 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 210274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 210277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210285 */     GIR_RootConstrainSelectedInstOperands,
     /* 210286 */     // GIR_Coverage, 3590,
     /* 210286 */     GIR_EraseRootFromParent_Done,
     /* 210287 */   // Label 4133: @210287
     /* 210287 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(210334), // Rule ID 11303 //
     /* 210292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 210300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210313 */     // MIs[0] Op3
     /* 210313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 210324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210332 */     GIR_RootConstrainSelectedInstOperands,
     /* 210333 */     // GIR_Coverage, 11303,
     /* 210333 */     GIR_EraseRootFromParent_Done,
     /* 210334 */   // Label 4134: @210334
     /* 210334 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(210381), // Rule ID 11304 //
     /* 210339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 210347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210360 */     // MIs[0] Op3
     /* 210360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 210371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210379 */     GIR_RootConstrainSelectedInstOperands,
     /* 210380 */     // GIR_Coverage, 11304,
     /* 210380 */     GIR_EraseRootFromParent_Done,
     /* 210381 */   // Label 4135: @210381
     /* 210381 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(210428), // Rule ID 11305 //
     /* 210386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 210394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210407 */     // MIs[0] Op3
     /* 210407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 210418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210426 */     GIR_RootConstrainSelectedInstOperands,
     /* 210427 */     // GIR_Coverage, 11305,
     /* 210427 */     GIR_EraseRootFromParent_Done,
     /* 210428 */   // Label 4136: @210428
     /* 210428 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(210475), // Rule ID 11306 //
     /* 210433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210454 */     // MIs[0] Op3
     /* 210454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210473 */     GIR_RootConstrainSelectedInstOperands,
     /* 210474 */     // GIR_Coverage, 11306,
     /* 210474 */     GIR_EraseRootFromParent_Done,
     /* 210475 */   // Label 4137: @210475
     /* 210475 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(210522), // Rule ID 11307 //
     /* 210480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210501 */     // MIs[0] Op3
     /* 210501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 210512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210520 */     GIR_RootConstrainSelectedInstOperands,
     /* 210521 */     // GIR_Coverage, 11307,
     /* 210521 */     GIR_EraseRootFromParent_Done,
     /* 210522 */   // Label 4138: @210522
     /* 210522 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(210569), // Rule ID 11308 //
     /* 210527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210548 */     // MIs[0] Op3
     /* 210548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 210559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210567 */     GIR_RootConstrainSelectedInstOperands,
     /* 210568 */     // GIR_Coverage, 11308,
     /* 210568 */     GIR_EraseRootFromParent_Done,
     /* 210569 */   // Label 4139: @210569
     /* 210569 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(210616), // Rule ID 11331 //
     /* 210574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 210582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210595 */     // MIs[0] Op3
     /* 210595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210603 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 210606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210614 */     GIR_RootConstrainSelectedInstOperands,
     /* 210615 */     // GIR_Coverage, 11331,
     /* 210615 */     GIR_EraseRootFromParent_Done,
     /* 210616 */   // Label 4140: @210616
     /* 210616 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210663), // Rule ID 11332 //
     /* 210621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 210629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210642 */     // MIs[0] Op3
     /* 210642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 210653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210661 */     GIR_RootConstrainSelectedInstOperands,
     /* 210662 */     // GIR_Coverage, 11332,
     /* 210662 */     GIR_EraseRootFromParent_Done,
     /* 210663 */   // Label 4141: @210663
     /* 210663 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210710), // Rule ID 11333 //
     /* 210668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 210676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210689 */     // MIs[0] Op3
     /* 210689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 210700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210708 */     GIR_RootConstrainSelectedInstOperands,
     /* 210709 */     // GIR_Coverage, 11333,
     /* 210709 */     GIR_EraseRootFromParent_Done,
     /* 210710 */   // Label 4142: @210710
     /* 210710 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210757), // Rule ID 11334 //
     /* 210715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 210723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210736 */     // MIs[0] Op3
     /* 210736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 210747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210755 */     GIR_RootConstrainSelectedInstOperands,
     /* 210756 */     // GIR_Coverage, 11334,
     /* 210756 */     GIR_EraseRootFromParent_Done,
     /* 210757 */   // Label 4143: @210757
     /* 210757 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210804), // Rule ID 11335 //
     /* 210762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 210770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210783 */     // MIs[0] Op3
     /* 210783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 210794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210802 */     GIR_RootConstrainSelectedInstOperands,
     /* 210803 */     // GIR_Coverage, 11335,
     /* 210803 */     GIR_EraseRootFromParent_Done,
     /* 210804 */   // Label 4144: @210804
     /* 210804 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210851), // Rule ID 11336 //
     /* 210809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 210817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210830 */     // MIs[0] Op3
     /* 210830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 210841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210849 */     GIR_RootConstrainSelectedInstOperands,
     /* 210850 */     // GIR_Coverage, 11336,
     /* 210850 */     GIR_EraseRootFromParent_Done,
     /* 210851 */   // Label 4145: @210851
     /* 210851 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210898), // Rule ID 11337 //
     /* 210856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210877 */     // MIs[0] Op3
     /* 210877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 210888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210896 */     GIR_RootConstrainSelectedInstOperands,
     /* 210897 */     // GIR_Coverage, 11337,
     /* 210897 */     GIR_EraseRootFromParent_Done,
     /* 210898 */   // Label 4146: @210898
     /* 210898 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210945), // Rule ID 11338 //
     /* 210903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210924 */     // MIs[0] Op3
     /* 210924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 210935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210943 */     GIR_RootConstrainSelectedInstOperands,
     /* 210944 */     // GIR_Coverage, 11338,
     /* 210944 */     GIR_EraseRootFromParent_Done,
     /* 210945 */   // Label 4147: @210945
     /* 210945 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210992), // Rule ID 11339 //
     /* 210950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210971 */     // MIs[0] Op3
     /* 210971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210974 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 210982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210990 */     GIR_RootConstrainSelectedInstOperands,
     /* 210991 */     // GIR_Coverage, 11339,
     /* 210991 */     GIR_EraseRootFromParent_Done,
     /* 210992 */   // Label 4148: @210992
     /* 210992 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(211039), // Rule ID 11340 //
     /* 210997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 211005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211018 */     // MIs[0] Op3
     /* 211018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 211026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 211026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 211029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211037 */     GIR_RootConstrainSelectedInstOperands,
     /* 211038 */     // GIR_Coverage, 11340,
     /* 211038 */     GIR_EraseRootFromParent_Done,
     /* 211039 */   // Label 4149: @211039
     /* 211039 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(211086), // Rule ID 11584 //
     /* 211044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 211052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211065 */     // MIs[0] Op3
     /* 211065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211073 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 211076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211084 */     GIR_RootConstrainSelectedInstOperands,
     /* 211085 */     // GIR_Coverage, 11584,
     /* 211085 */     GIR_EraseRootFromParent_Done,
     /* 211086 */   // Label 4150: @211086
     /* 211086 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(211133), // Rule ID 11585 //
     /* 211091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 211099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211112 */     // MIs[0] Op3
     /* 211112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 211123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211131 */     GIR_RootConstrainSelectedInstOperands,
     /* 211132 */     // GIR_Coverage, 11585,
     /* 211132 */     GIR_EraseRootFromParent_Done,
     /* 211133 */   // Label 4151: @211133
     /* 211133 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(211180), // Rule ID 11586 //
     /* 211138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 211146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211159 */     // MIs[0] Op3
     /* 211159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211178 */     GIR_RootConstrainSelectedInstOperands,
     /* 211179 */     // GIR_Coverage, 11586,
     /* 211179 */     GIR_EraseRootFromParent_Done,
     /* 211180 */   // Label 4152: @211180
     /* 211180 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(211227), // Rule ID 11587 //
     /* 211185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 211193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211206 */     // MIs[0] Op3
     /* 211206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 211217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211225 */     GIR_RootConstrainSelectedInstOperands,
     /* 211226 */     // GIR_Coverage, 11587,
     /* 211226 */     GIR_EraseRootFromParent_Done,
     /* 211227 */   // Label 4153: @211227
     /* 211227 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(211274), // Rule ID 11588 //
     /* 211232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 211240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211253 */     // MIs[0] Op3
     /* 211253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 211264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211272 */     GIR_RootConstrainSelectedInstOperands,
     /* 211273 */     // GIR_Coverage, 11588,
     /* 211273 */     GIR_EraseRootFromParent_Done,
     /* 211274 */   // Label 4154: @211274
     /* 211274 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(211321), // Rule ID 11590 //
     /* 211279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 211287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211300 */     // MIs[0] Op3
     /* 211300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 211311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211319 */     GIR_RootConstrainSelectedInstOperands,
     /* 211320 */     // GIR_Coverage, 11590,
     /* 211320 */     GIR_EraseRootFromParent_Done,
     /* 211321 */   // Label 4155: @211321
     /* 211321 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(211368), // Rule ID 11592 //
     /* 211326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 211334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211347 */     // MIs[0] Op3
     /* 211347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 211358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211366 */     GIR_RootConstrainSelectedInstOperands,
     /* 211367 */     // GIR_Coverage, 11592,
     /* 211367 */     GIR_EraseRootFromParent_Done,
     /* 211368 */   // Label 4156: @211368
     /* 211368 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(211415), // Rule ID 11594 //
     /* 211373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 211381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211394 */     // MIs[0] Op3
     /* 211394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 211405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211413 */     GIR_RootConstrainSelectedInstOperands,
     /* 211414 */     // GIR_Coverage, 11594,
     /* 211414 */     GIR_EraseRootFromParent_Done,
     /* 211415 */   // Label 4157: @211415
     /* 211415 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(211462), // Rule ID 11596 //
     /* 211420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211441 */     // MIs[0] Op3
     /* 211441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 211449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 211449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 211452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211460 */     GIR_RootConstrainSelectedInstOperands,
     /* 211461 */     // GIR_Coverage, 11596,
     /* 211461 */     GIR_EraseRootFromParent_Done,
     /* 211462 */   // Label 4158: @211462
     /* 211462 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(211509), // Rule ID 11597 //
     /* 211467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211488 */     // MIs[0] Op3
     /* 211488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 211496 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 211496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 211499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211507 */     GIR_RootConstrainSelectedInstOperands,
     /* 211508 */     // GIR_Coverage, 11597,
     /* 211508 */     GIR_EraseRootFromParent_Done,
     /* 211509 */   // Label 4159: @211509
     /* 211509 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(211556), // Rule ID 11598 //
     /* 211514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211535 */     // MIs[0] Op3
     /* 211535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 211543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 211543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 211546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211554 */     GIR_RootConstrainSelectedInstOperands,
     /* 211555 */     // GIR_Coverage, 11598,
     /* 211555 */     GIR_EraseRootFromParent_Done,
     /* 211556 */   // Label 4160: @211556
     /* 211556 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211603), // Rule ID 11599 //
     /* 211561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211582 */     // MIs[0] Op3
     /* 211582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 211590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 211590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 211593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211601 */     GIR_RootConstrainSelectedInstOperands,
     /* 211602 */     // GIR_Coverage, 11599,
     /* 211602 */     GIR_EraseRootFromParent_Done,
     /* 211603 */   // Label 4161: @211603
     /* 211603 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211650), // Rule ID 11674 //
     /* 211608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211629 */     // MIs[0] Op3
     /* 211629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211637 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 211640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211648 */     GIR_RootConstrainSelectedInstOperands,
     /* 211649 */     // GIR_Coverage, 11674,
     /* 211649 */     GIR_EraseRootFromParent_Done,
     /* 211650 */   // Label 4162: @211650
     /* 211650 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211697), // Rule ID 11676 //
     /* 211655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211676 */     // MIs[0] Op3
     /* 211676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 211687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211695 */     GIR_RootConstrainSelectedInstOperands,
     /* 211696 */     // GIR_Coverage, 11676,
     /* 211696 */     GIR_EraseRootFromParent_Done,
     /* 211697 */   // Label 4163: @211697
     /* 211697 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211744), // Rule ID 11678 //
     /* 211702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211723 */     // MIs[0] Op3
     /* 211723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 211734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211742 */     GIR_RootConstrainSelectedInstOperands,
     /* 211743 */     // GIR_Coverage, 11678,
     /* 211743 */     GIR_EraseRootFromParent_Done,
     /* 211744 */   // Label 4164: @211744
     /* 211744 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211791), // Rule ID 11680 //
     /* 211749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211770 */     // MIs[0] Op3
     /* 211770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 211781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211789 */     GIR_RootConstrainSelectedInstOperands,
     /* 211790 */     // GIR_Coverage, 11680,
     /* 211790 */     GIR_EraseRootFromParent_Done,
     /* 211791 */   // Label 4165: @211791
     /* 211791 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211838), // Rule ID 11682 //
     /* 211796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211817 */     // MIs[0] Op3
     /* 211817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 211828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211836 */     GIR_RootConstrainSelectedInstOperands,
     /* 211837 */     // GIR_Coverage, 11682,
     /* 211837 */     GIR_EraseRootFromParent_Done,
     /* 211838 */   // Label 4166: @211838
     /* 211838 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211885), // Rule ID 11683 //
     /* 211843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211864 */     // MIs[0] Op3
     /* 211864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 211875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211883 */     GIR_RootConstrainSelectedInstOperands,
     /* 211884 */     // GIR_Coverage, 11683,
     /* 211884 */     GIR_EraseRootFromParent_Done,
     /* 211885 */   // Label 4167: @211885
     /* 211885 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211932), // Rule ID 11684 //
     /* 211890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211911 */     // MIs[0] Op3
     /* 211911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 211922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211930 */     GIR_RootConstrainSelectedInstOperands,
     /* 211931 */     // GIR_Coverage, 11684,
     /* 211931 */     GIR_EraseRootFromParent_Done,
     /* 211932 */   // Label 4168: @211932
     /* 211932 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211979), // Rule ID 11685 //
     /* 211937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211958 */     // MIs[0] Op3
     /* 211958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 211969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211977 */     GIR_RootConstrainSelectedInstOperands,
     /* 211978 */     // GIR_Coverage, 11685,
     /* 211978 */     GIR_EraseRootFromParent_Done,
     /* 211979 */   // Label 4169: @211979
     /* 211979 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(212026), // Rule ID 11690 //
     /* 211984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212005 */     // MIs[0] Op3
     /* 212005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212013 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 212018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212024 */     GIR_RootConstrainSelectedInstOperands,
     /* 212025 */     // GIR_Coverage, 11690,
     /* 212025 */     GIR_EraseRootFromParent_Done,
     /* 212026 */   // Label 4170: @212026
     /* 212026 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(212073), // Rule ID 11691 //
     /* 212031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 212039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212052 */     // MIs[0] Op3
     /* 212052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 212063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 212065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212071 */     GIR_RootConstrainSelectedInstOperands,
     /* 212072 */     // GIR_Coverage, 11691,
     /* 212072 */     GIR_EraseRootFromParent_Done,
     /* 212073 */   // Label 4171: @212073
     /* 212073 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(212120), // Rule ID 11692 //
     /* 212078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 212086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212099 */     // MIs[0] Op3
     /* 212099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212107 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 212110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 212112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212118 */     GIR_RootConstrainSelectedInstOperands,
     /* 212119 */     // GIR_Coverage, 11692,
     /* 212119 */     GIR_EraseRootFromParent_Done,
     /* 212120 */   // Label 4172: @212120
     /* 212120 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(212167), // Rule ID 11693 //
     /* 212125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 212133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212146 */     // MIs[0] Op3
     /* 212146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 212154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 212154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 212157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 212159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212165 */     GIR_RootConstrainSelectedInstOperands,
     /* 212166 */     // GIR_Coverage, 11693,
     /* 212166 */     GIR_EraseRootFromParent_Done,
     /* 212167 */   // Label 4173: @212167
     /* 212167 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(212214), // Rule ID 11753 //
     /* 212172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 212180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212193 */     // MIs[0] Op3
     /* 212193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212201 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 212204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212212 */     GIR_RootConstrainSelectedInstOperands,
     /* 212213 */     // GIR_Coverage, 11753,
     /* 212213 */     GIR_EraseRootFromParent_Done,
     /* 212214 */   // Label 4174: @212214
     /* 212214 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(212261), // Rule ID 11754 //
     /* 212219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 212227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212240 */     // MIs[0] Op3
     /* 212240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 212251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212259 */     GIR_RootConstrainSelectedInstOperands,
     /* 212260 */     // GIR_Coverage, 11754,
     /* 212260 */     GIR_EraseRootFromParent_Done,
     /* 212261 */   // Label 4175: @212261
     /* 212261 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(212308), // Rule ID 11755 //
     /* 212266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 212274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212287 */     // MIs[0] Op3
     /* 212287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 212298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212306 */     GIR_RootConstrainSelectedInstOperands,
     /* 212307 */     // GIR_Coverage, 11755,
     /* 212307 */     GIR_EraseRootFromParent_Done,
     /* 212308 */   // Label 4176: @212308
     /* 212308 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(212355), // Rule ID 11756 //
     /* 212313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 212321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212334 */     // MIs[0] Op3
     /* 212334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 212345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212353 */     GIR_RootConstrainSelectedInstOperands,
     /* 212354 */     // GIR_Coverage, 11756,
     /* 212354 */     GIR_EraseRootFromParent_Done,
     /* 212355 */   // Label 4177: @212355
     /* 212355 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(212402), // Rule ID 11757 //
     /* 212360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 212368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212381 */     // MIs[0] Op3
     /* 212381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 212392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212400 */     GIR_RootConstrainSelectedInstOperands,
     /* 212401 */     // GIR_Coverage, 11757,
     /* 212401 */     GIR_EraseRootFromParent_Done,
     /* 212402 */   // Label 4178: @212402
     /* 212402 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(212449), // Rule ID 11758 //
     /* 212407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 212415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212428 */     // MIs[0] Op3
     /* 212428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 212439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212447 */     GIR_RootConstrainSelectedInstOperands,
     /* 212448 */     // GIR_Coverage, 11758,
     /* 212448 */     GIR_EraseRootFromParent_Done,
     /* 212449 */   // Label 4179: @212449
     /* 212449 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(212496), // Rule ID 11759 //
     /* 212454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212475 */     // MIs[0] Op3
     /* 212475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212483 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 212486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212494 */     GIR_RootConstrainSelectedInstOperands,
     /* 212495 */     // GIR_Coverage, 11759,
     /* 212495 */     GIR_EraseRootFromParent_Done,
     /* 212496 */   // Label 4180: @212496
     /* 212496 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(212543), // Rule ID 11760 //
     /* 212501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212522 */     // MIs[0] Op3
     /* 212522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 212533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212541 */     GIR_RootConstrainSelectedInstOperands,
     /* 212542 */     // GIR_Coverage, 11760,
     /* 212542 */     GIR_EraseRootFromParent_Done,
     /* 212543 */   // Label 4181: @212543
     /* 212543 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212590), // Rule ID 11761 //
     /* 212548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212569 */     // MIs[0] Op3
     /* 212569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 212580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212588 */     GIR_RootConstrainSelectedInstOperands,
     /* 212589 */     // GIR_Coverage, 11761,
     /* 212589 */     GIR_EraseRootFromParent_Done,
     /* 212590 */   // Label 4182: @212590
     /* 212590 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212637), // Rule ID 11762 //
     /* 212595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212616 */     // MIs[0] Op3
     /* 212616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 212627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212635 */     GIR_RootConstrainSelectedInstOperands,
     /* 212636 */     // GIR_Coverage, 11762,
     /* 212636 */     GIR_EraseRootFromParent_Done,
     /* 212637 */   // Label 4183: @212637
     /* 212637 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212684), // Rule ID 11763 //
     /* 212642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212663 */     // MIs[0] Op3
     /* 212663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 212674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212682 */     GIR_RootConstrainSelectedInstOperands,
     /* 212683 */     // GIR_Coverage, 11763,
     /* 212683 */     GIR_EraseRootFromParent_Done,
     /* 212684 */   // Label 4184: @212684
     /* 212684 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212731), // Rule ID 11764 //
     /* 212689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212710 */     // MIs[0] Op3
     /* 212710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 212721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212729 */     GIR_RootConstrainSelectedInstOperands,
     /* 212730 */     // GIR_Coverage, 11764,
     /* 212730 */     GIR_EraseRootFromParent_Done,
     /* 212731 */   // Label 4185: @212731
     /* 212731 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212778), // Rule ID 11765 //
     /* 212736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212757 */     // MIs[0] Op3
     /* 212757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 212768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212776 */     GIR_RootConstrainSelectedInstOperands,
     /* 212777 */     // GIR_Coverage, 11765,
     /* 212777 */     GIR_EraseRootFromParent_Done,
     /* 212778 */   // Label 4186: @212778
     /* 212778 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212825), // Rule ID 11766 //
     /* 212783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212804 */     // MIs[0] Op3
     /* 212804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 212815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212823 */     GIR_RootConstrainSelectedInstOperands,
     /* 212824 */     // GIR_Coverage, 11766,
     /* 212824 */     GIR_EraseRootFromParent_Done,
     /* 212825 */   // Label 4187: @212825
     /* 212825 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212872), // Rule ID 11767 //
     /* 212830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212851 */     // MIs[0] Op3
     /* 212851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 212862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212870 */     GIR_RootConstrainSelectedInstOperands,
     /* 212871 */     // GIR_Coverage, 11767,
     /* 212871 */     GIR_EraseRootFromParent_Done,
     /* 212872 */   // Label 4188: @212872
     /* 212872 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212919), // Rule ID 11768 //
     /* 212877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212898 */     // MIs[0] Op3
     /* 212898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 212909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212917 */     GIR_RootConstrainSelectedInstOperands,
     /* 212918 */     // GIR_Coverage, 11768,
     /* 212918 */     GIR_EraseRootFromParent_Done,
     /* 212919 */   // Label 4189: @212919
     /* 212919 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212966), // Rule ID 11769 //
     /* 212924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212945 */     // MIs[0] Op3
     /* 212945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 212956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212964 */     GIR_RootConstrainSelectedInstOperands,
     /* 212965 */     // GIR_Coverage, 11769,
     /* 212965 */     GIR_EraseRootFromParent_Done,
     /* 212966 */   // Label 4190: @212966
     /* 212966 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(213013), // Rule ID 11770 //
     /* 212971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212992 */     // MIs[0] Op3
     /* 212992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 213003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213011 */     GIR_RootConstrainSelectedInstOperands,
     /* 213012 */     // GIR_Coverage, 11770,
     /* 213012 */     GIR_EraseRootFromParent_Done,
     /* 213013 */   // Label 4191: @213013
     /* 213013 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(213060), // Rule ID 11771 //
     /* 213018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 213026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213039 */     // MIs[0] Op3
     /* 213039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 213047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 213047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 213050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213058 */     GIR_RootConstrainSelectedInstOperands,
     /* 213059 */     // GIR_Coverage, 11771,
     /* 213059 */     GIR_EraseRootFromParent_Done,
     /* 213060 */   // Label 4192: @213060
     /* 213060 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(213107), // Rule ID 11772 //
     /* 213065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 213073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213086 */     // MIs[0] Op3
     /* 213086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 213094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 213094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 213097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213105 */     GIR_RootConstrainSelectedInstOperands,
     /* 213106 */     // GIR_Coverage, 11772,
     /* 213106 */     GIR_EraseRootFromParent_Done,
     /* 213107 */   // Label 4193: @213107
     /* 213107 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(213154), // Rule ID 11773 //
     /* 213112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 213120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213133 */     // MIs[0] Op3
     /* 213133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 213136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 213141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 213141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 213144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213152 */     GIR_RootConstrainSelectedInstOperands,
     /* 213153 */     // GIR_Coverage, 11773,
     /* 213153 */     GIR_EraseRootFromParent_Done,
     /* 213154 */   // Label 4194: @213154
     /* 213154 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(213221), // Rule ID 2604 //
     /* 213159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 213167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 213210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213219 */     GIR_RootConstrainSelectedInstOperands,
     /* 213220 */     // GIR_Coverage, 2604,
     /* 213220 */     GIR_EraseRootFromParent_Done,
     /* 213221 */   // Label 4195: @213221
     /* 213221 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(213288), // Rule ID 7684 //
     /* 213226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 213277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213286 */     GIR_RootConstrainSelectedInstOperands,
     /* 213287 */     // GIR_Coverage, 7684,
     /* 213287 */     GIR_EraseRootFromParent_Done,
     /* 213288 */   // Label 4196: @213288
     /* 213288 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(213355), // Rule ID 7686 //
     /* 213293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 213344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213353 */     GIR_RootConstrainSelectedInstOperands,
     /* 213354 */     // GIR_Coverage, 7686,
     /* 213354 */     GIR_EraseRootFromParent_Done,
     /* 213355 */   // Label 4197: @213355
     /* 213355 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(213422), // Rule ID 7688 //
     /* 213360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 213411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213420 */     GIR_RootConstrainSelectedInstOperands,
     /* 213421 */     // GIR_Coverage, 7688,
     /* 213421 */     GIR_EraseRootFromParent_Done,
     /* 213422 */   // Label 4198: @213422
     /* 213422 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(213489), // Rule ID 7690 //
     /* 213427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 213478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213487 */     GIR_RootConstrainSelectedInstOperands,
     /* 213488 */     // GIR_Coverage, 7690,
     /* 213488 */     GIR_EraseRootFromParent_Done,
     /* 213489 */   // Label 4199: @213489
     /* 213489 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(213556), // Rule ID 7720 //
     /* 213494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 213545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213554 */     GIR_RootConstrainSelectedInstOperands,
     /* 213555 */     // GIR_Coverage, 7720,
     /* 213555 */     GIR_EraseRootFromParent_Done,
     /* 213556 */   // Label 4200: @213556
     /* 213556 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(213623), // Rule ID 7722 //
     /* 213561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 213612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213621 */     GIR_RootConstrainSelectedInstOperands,
     /* 213622 */     // GIR_Coverage, 7722,
     /* 213622 */     GIR_EraseRootFromParent_Done,
     /* 213623 */   // Label 4201: @213623
     /* 213623 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213690), // Rule ID 7724 //
     /* 213628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213688 */     GIR_RootConstrainSelectedInstOperands,
     /* 213689 */     // GIR_Coverage, 7724,
     /* 213689 */     GIR_EraseRootFromParent_Done,
     /* 213690 */   // Label 4202: @213690
     /* 213690 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213757), // Rule ID 7726 //
     /* 213695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 213746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213755 */     GIR_RootConstrainSelectedInstOperands,
     /* 213756 */     // GIR_Coverage, 7726,
     /* 213756 */     GIR_EraseRootFromParent_Done,
     /* 213757 */   // Label 4203: @213757
     /* 213757 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213824), // Rule ID 7732 //
     /* 213762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 213813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213822 */     GIR_RootConstrainSelectedInstOperands,
     /* 213823 */     // GIR_Coverage, 7732,
     /* 213823 */     GIR_EraseRootFromParent_Done,
     /* 213824 */   // Label 4204: @213824
     /* 213824 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213891), // Rule ID 7734 //
     /* 213829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 213880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213889 */     GIR_RootConstrainSelectedInstOperands,
     /* 213890 */     // GIR_Coverage, 7734,
     /* 213890 */     GIR_EraseRootFromParent_Done,
     /* 213891 */   // Label 4205: @213891
     /* 213891 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213958), // Rule ID 7736 //
     /* 213896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 213947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213956 */     GIR_RootConstrainSelectedInstOperands,
     /* 213957 */     // GIR_Coverage, 7736,
     /* 213957 */     GIR_EraseRootFromParent_Done,
     /* 213958 */   // Label 4206: @213958
     /* 213958 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(214025), // Rule ID 7738 //
     /* 213963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 214014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214023 */     GIR_RootConstrainSelectedInstOperands,
     /* 214024 */     // GIR_Coverage, 7738,
     /* 214024 */     GIR_EraseRootFromParent_Done,
     /* 214025 */   // Label 4207: @214025
     /* 214025 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(214092), // Rule ID 11466 //
     /* 214030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 214038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 214081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214090 */     GIR_RootConstrainSelectedInstOperands,
     /* 214091 */     // GIR_Coverage, 11466,
     /* 214091 */     GIR_EraseRootFromParent_Done,
     /* 214092 */   // Label 4208: @214092
     /* 214092 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(214159), // Rule ID 11468 //
     /* 214097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 214148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214157 */     GIR_RootConstrainSelectedInstOperands,
     /* 214158 */     // GIR_Coverage, 11468,
     /* 214158 */     GIR_EraseRootFromParent_Done,
     /* 214159 */   // Label 4209: @214159
     /* 214159 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(214226), // Rule ID 11470 //
     /* 214164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 214215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214224 */     GIR_RootConstrainSelectedInstOperands,
     /* 214225 */     // GIR_Coverage, 11470,
     /* 214225 */     GIR_EraseRootFromParent_Done,
     /* 214226 */   // Label 4210: @214226
     /* 214226 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(214293), // Rule ID 11472 //
     /* 214231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 214282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214291 */     GIR_RootConstrainSelectedInstOperands,
     /* 214292 */     // GIR_Coverage, 11472,
     /* 214292 */     GIR_EraseRootFromParent_Done,
     /* 214293 */   // Label 4211: @214293
     /* 214293 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(214360), // Rule ID 11474 //
     /* 214298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 214349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214358 */     GIR_RootConstrainSelectedInstOperands,
     /* 214359 */     // GIR_Coverage, 11474,
     /* 214359 */     GIR_EraseRootFromParent_Done,
     /* 214360 */   // Label 4212: @214360
     /* 214360 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(214427), // Rule ID 11480 //
     /* 214365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 214416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214425 */     GIR_RootConstrainSelectedInstOperands,
     /* 214426 */     // GIR_Coverage, 11480,
     /* 214426 */     GIR_EraseRootFromParent_Done,
     /* 214427 */   // Label 4213: @214427
     /* 214427 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(214494), // Rule ID 11482 //
     /* 214432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214492 */     GIR_RootConstrainSelectedInstOperands,
     /* 214493 */     // GIR_Coverage, 11482,
     /* 214493 */     GIR_EraseRootFromParent_Done,
     /* 214494 */   // Label 4214: @214494
     /* 214494 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(214561), // Rule ID 11484 //
     /* 214499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 214550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214559 */     GIR_RootConstrainSelectedInstOperands,
     /* 214560 */     // GIR_Coverage, 11484,
     /* 214560 */     GIR_EraseRootFromParent_Done,
     /* 214561 */   // Label 4215: @214561
     /* 214561 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(214628), // Rule ID 11486 //
     /* 214566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 214617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214626 */     GIR_RootConstrainSelectedInstOperands,
     /* 214627 */     // GIR_Coverage, 11486,
     /* 214627 */     GIR_EraseRootFromParent_Done,
     /* 214628 */   // Label 4216: @214628
     /* 214628 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(214682), // Rule ID 30 //
     /* 214633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 214641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214669 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 214672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214680 */     GIR_RootConstrainSelectedInstOperands,
     /* 214681 */     // GIR_Coverage, 30,
     /* 214681 */     GIR_EraseRootFromParent_Done,
     /* 214682 */   // Label 4217: @214682
     /* 214682 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(214736), // Rule ID 31 //
     /* 214687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 214695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 214726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214734 */     GIR_RootConstrainSelectedInstOperands,
     /* 214735 */     // GIR_Coverage, 31,
     /* 214735 */     GIR_EraseRootFromParent_Done,
     /* 214736 */   // Label 4218: @214736
     /* 214736 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(214790), // Rule ID 32 //
     /* 214741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 214749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 214780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214788 */     GIR_RootConstrainSelectedInstOperands,
     /* 214789 */     // GIR_Coverage, 32,
     /* 214789 */     GIR_EraseRootFromParent_Done,
     /* 214790 */   // Label 4219: @214790
     /* 214790 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(214844), // Rule ID 39 //
     /* 214795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214831 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 214834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214842 */     GIR_RootConstrainSelectedInstOperands,
     /* 214843 */     // GIR_Coverage, 39,
     /* 214843 */     GIR_EraseRootFromParent_Done,
     /* 214844 */   // Label 4220: @214844
     /* 214844 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(214898), // Rule ID 40 //
     /* 214849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214885 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 214888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214896 */     GIR_RootConstrainSelectedInstOperands,
     /* 214897 */     // GIR_Coverage, 40,
     /* 214897 */     GIR_EraseRootFromParent_Done,
     /* 214898 */   // Label 4221: @214898
     /* 214898 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(214952), // Rule ID 41 //
     /* 214903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214939 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 214942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214950 */     GIR_RootConstrainSelectedInstOperands,
     /* 214951 */     // GIR_Coverage, 41,
     /* 214951 */     GIR_EraseRootFromParent_Done,
     /* 214952 */   // Label 4222: @214952
     /* 214952 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(215006), // Rule ID 42 //
     /* 214957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214993 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 214996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215004 */     GIR_RootConstrainSelectedInstOperands,
     /* 215005 */     // GIR_Coverage, 42,
     /* 215005 */     GIR_EraseRootFromParent_Done,
     /* 215006 */   // Label 4223: @215006
     /* 215006 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(215060), // Rule ID 43 //
     /* 215011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 215014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 215019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215047 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 215047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 215050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215058 */     GIR_RootConstrainSelectedInstOperands,
     /* 215059 */     // GIR_Coverage, 43,
     /* 215059 */     GIR_EraseRootFromParent_Done,
     /* 215060 */   // Label 4224: @215060
     /* 215060 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(215114), // Rule ID 44 //
     /* 215065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 215068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 215073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215101 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 215101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 215104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215112 */     GIR_RootConstrainSelectedInstOperands,
     /* 215113 */     // GIR_Coverage, 44,
     /* 215113 */     GIR_EraseRootFromParent_Done,
     /* 215114 */   // Label 4225: @215114
     /* 215114 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(215168), // Rule ID 45 //
     /* 215119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 215122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 215127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215155 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 215155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 215158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215166 */     GIR_RootConstrainSelectedInstOperands,
     /* 215167 */     // GIR_Coverage, 45,
     /* 215167 */     GIR_EraseRootFromParent_Done,
     /* 215168 */   // Label 4226: @215168
     /* 215168 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(215222), // Rule ID 46 //
     /* 215173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 215176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 215181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215209 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 215209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 215212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215220 */     GIR_RootConstrainSelectedInstOperands,
     /* 215221 */     // GIR_Coverage, 46,
     /* 215221 */     GIR_EraseRootFromParent_Done,
     /* 215222 */   // Label 4227: @215222
     /* 215222 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(215276), // Rule ID 1587 //
     /* 215227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215263 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 215263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 215266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215274 */     GIR_RootConstrainSelectedInstOperands,
     /* 215275 */     // GIR_Coverage, 1587,
     /* 215275 */     GIR_EraseRootFromParent_Done,
     /* 215276 */   // Label 4228: @215276
     /* 215276 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(215330), // Rule ID 1588 //
     /* 215281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215317 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 215317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 215320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215328 */     GIR_RootConstrainSelectedInstOperands,
     /* 215329 */     // GIR_Coverage, 1588,
     /* 215329 */     GIR_EraseRootFromParent_Done,
     /* 215330 */   // Label 4229: @215330
     /* 215330 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(215384), // Rule ID 1589 //
     /* 215335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215371 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 215371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 215374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215382 */     GIR_RootConstrainSelectedInstOperands,
     /* 215383 */     // GIR_Coverage, 1589,
     /* 215383 */     GIR_EraseRootFromParent_Done,
     /* 215384 */   // Label 4230: @215384
     /* 215384 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(215438), // Rule ID 1590 //
     /* 215389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215425 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 215428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215436 */     GIR_RootConstrainSelectedInstOperands,
     /* 215437 */     // GIR_Coverage, 1590,
     /* 215437 */     GIR_EraseRootFromParent_Done,
     /* 215438 */   // Label 4231: @215438
     /* 215438 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(215492), // Rule ID 1591 //
     /* 215443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215479 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 215479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 215482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215490 */     GIR_RootConstrainSelectedInstOperands,
     /* 215491 */     // GIR_Coverage, 1591,
     /* 215491 */     GIR_EraseRootFromParent_Done,
     /* 215492 */   // Label 4232: @215492
     /* 215492 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(215546), // Rule ID 1592 //
     /* 215497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215533 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 215533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 215536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215544 */     GIR_RootConstrainSelectedInstOperands,
     /* 215545 */     // GIR_Coverage, 1592,
     /* 215545 */     GIR_EraseRootFromParent_Done,
     /* 215546 */   // Label 4233: @215546
     /* 215546 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(215600), // Rule ID 1593 //
     /* 215551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215587 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 215587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 215590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215598 */     GIR_RootConstrainSelectedInstOperands,
     /* 215599 */     // GIR_Coverage, 1593,
     /* 215599 */     GIR_EraseRootFromParent_Done,
     /* 215600 */   // Label 4234: @215600
     /* 215600 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(215654), // Rule ID 1594 //
     /* 215605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 215644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215652 */     GIR_RootConstrainSelectedInstOperands,
     /* 215653 */     // GIR_Coverage, 1594,
     /* 215653 */     GIR_EraseRootFromParent_Done,
     /* 215654 */   // Label 4235: @215654
     /* 215654 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(215708), // Rule ID 2307 //
     /* 215659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 215667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 215698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215706 */     GIR_RootConstrainSelectedInstOperands,
     /* 215707 */     // GIR_Coverage, 2307,
     /* 215707 */     GIR_EraseRootFromParent_Done,
     /* 215708 */   // Label 4236: @215708
     /* 215708 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(215762), // Rule ID 2308 //
     /* 215713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 215721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215749 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215760 */     GIR_RootConstrainSelectedInstOperands,
     /* 215761 */     // GIR_Coverage, 2308,
     /* 215761 */     GIR_EraseRootFromParent_Done,
     /* 215762 */   // Label 4237: @215762
     /* 215762 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215816), // Rule ID 2309 //
     /* 215767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 215775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215803 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 215806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215814 */     GIR_RootConstrainSelectedInstOperands,
     /* 215815 */     // GIR_Coverage, 2309,
     /* 215815 */     GIR_EraseRootFromParent_Done,
     /* 215816 */   // Label 4238: @215816
     /* 215816 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215870), // Rule ID 2310 //
     /* 215821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 215829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215857 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 215860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215868 */     GIR_RootConstrainSelectedInstOperands,
     /* 215869 */     // GIR_Coverage, 2310,
     /* 215869 */     GIR_EraseRootFromParent_Done,
     /* 215870 */   // Label 4239: @215870
     /* 215870 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215924), // Rule ID 2311 //
     /* 215875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 215883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215911 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 215914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215922 */     GIR_RootConstrainSelectedInstOperands,
     /* 215923 */     // GIR_Coverage, 2311,
     /* 215923 */     GIR_EraseRootFromParent_Done,
     /* 215924 */   // Label 4240: @215924
     /* 215924 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215978), // Rule ID 2312 //
     /* 215929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 215937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215965 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 215968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215976 */     GIR_RootConstrainSelectedInstOperands,
     /* 215977 */     // GIR_Coverage, 2312,
     /* 215977 */     GIR_EraseRootFromParent_Done,
     /* 215978 */   // Label 4241: @215978
     /* 215978 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(216032), // Rule ID 2313 //
     /* 215983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 215991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 216019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 216022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216030 */     GIR_RootConstrainSelectedInstOperands,
     /* 216031 */     // GIR_Coverage, 2313,
     /* 216031 */     GIR_EraseRootFromParent_Done,
     /* 216032 */   // Label 4242: @216032
     /* 216032 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(216089), // Rule ID 3640 //
     /* 216037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 216045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 216057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 216061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 216073 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 216073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 216076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 216080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 216082 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 216084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216087 */     GIR_RootConstrainSelectedInstOperands,
     /* 216088 */     // GIR_Coverage, 3640,
     /* 216088 */     GIR_EraseRootFromParent_Done,
     /* 216089 */   // Label 4243: @216089
     /* 216089 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(216146), // Rule ID 3641 //
     /* 216094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 216102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 216111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 216114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 216118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 216130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 216130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 216133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 216137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 216139 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 216141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216144 */     GIR_RootConstrainSelectedInstOperands,
     /* 216145 */     // GIR_Coverage, 3641,
     /* 216145 */     GIR_EraseRootFromParent_Done,
     /* 216146 */   // Label 4244: @216146
     /* 216146 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(216203), // Rule ID 3642 //
     /* 216151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 216159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 216168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 216171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 216175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 216187 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 216187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 216190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 216194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 216196 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 216198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216201 */     GIR_RootConstrainSelectedInstOperands,
     /* 216202 */     // GIR_Coverage, 3642,
     /* 216202 */     GIR_EraseRootFromParent_Done,
     /* 216203 */   // Label 4245: @216203
     /* 216203 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(216260), // Rule ID 3643 //
     /* 216208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 216216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 216225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 216228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 216232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 216244 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 216244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 216247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 216251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 216253 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 216255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216258 */     GIR_RootConstrainSelectedInstOperands,
     /* 216259 */     // GIR_Coverage, 3643,
     /* 216259 */     GIR_EraseRootFromParent_Done,
     /* 216260 */   // Label 4246: @216260
     /* 216260 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(216314), // Rule ID 3816 //
     /* 216265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 216273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216301 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 216304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216312 */     GIR_RootConstrainSelectedInstOperands,
     /* 216313 */     // GIR_Coverage, 3816,
     /* 216313 */     GIR_EraseRootFromParent_Done,
     /* 216314 */   // Label 4247: @216314
     /* 216314 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(216368), // Rule ID 3817 //
     /* 216319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 216327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216355 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 216358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216366 */     GIR_RootConstrainSelectedInstOperands,
     /* 216367 */     // GIR_Coverage, 3817,
     /* 216367 */     GIR_EraseRootFromParent_Done,
     /* 216368 */   // Label 4248: @216368
     /* 216368 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(216422), // Rule ID 3818 //
     /* 216373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 216381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216409 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 216412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216420 */     GIR_RootConstrainSelectedInstOperands,
     /* 216421 */     // GIR_Coverage, 3818,
     /* 216421 */     GIR_EraseRootFromParent_Done,
     /* 216422 */   // Label 4249: @216422
     /* 216422 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(216476), // Rule ID 3819 //
     /* 216427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216463 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216474 */     GIR_RootConstrainSelectedInstOperands,
     /* 216475 */     // GIR_Coverage, 3819,
     /* 216475 */     GIR_EraseRootFromParent_Done,
     /* 216476 */   // Label 4250: @216476
     /* 216476 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(216530), // Rule ID 3820 //
     /* 216481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216517 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216528 */     GIR_RootConstrainSelectedInstOperands,
     /* 216529 */     // GIR_Coverage, 3820,
     /* 216529 */     GIR_EraseRootFromParent_Done,
     /* 216530 */   // Label 4251: @216530
     /* 216530 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(216584), // Rule ID 3821 //
     /* 216535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216582 */     GIR_RootConstrainSelectedInstOperands,
     /* 216583 */     // GIR_Coverage, 3821,
     /* 216583 */     GIR_EraseRootFromParent_Done,
     /* 216584 */   // Label 4252: @216584
     /* 216584 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(216638), // Rule ID 3822 //
     /* 216589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216625 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216636 */     GIR_RootConstrainSelectedInstOperands,
     /* 216637 */     // GIR_Coverage, 3822,
     /* 216637 */     GIR_EraseRootFromParent_Done,
     /* 216638 */   // Label 4253: @216638
     /* 216638 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(216692), // Rule ID 3831 //
     /* 216643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216690 */     GIR_RootConstrainSelectedInstOperands,
     /* 216691 */     // GIR_Coverage, 3831,
     /* 216691 */     GIR_EraseRootFromParent_Done,
     /* 216692 */   // Label 4254: @216692
     /* 216692 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(216746), // Rule ID 3832 //
     /* 216697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216733 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216744 */     GIR_RootConstrainSelectedInstOperands,
     /* 216745 */     // GIR_Coverage, 3832,
     /* 216745 */     GIR_EraseRootFromParent_Done,
     /* 216746 */   // Label 4255: @216746
     /* 216746 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216800), // Rule ID 3833 //
     /* 216751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216798 */     GIR_RootConstrainSelectedInstOperands,
     /* 216799 */     // GIR_Coverage, 3833,
     /* 216799 */     GIR_EraseRootFromParent_Done,
     /* 216800 */   // Label 4256: @216800
     /* 216800 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216854), // Rule ID 3834 //
     /* 216805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216841 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216852 */     GIR_RootConstrainSelectedInstOperands,
     /* 216853 */     // GIR_Coverage, 3834,
     /* 216853 */     GIR_EraseRootFromParent_Done,
     /* 216854 */   // Label 4257: @216854
     /* 216854 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216908), // Rule ID 3835 //
     /* 216859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216895 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216906 */     GIR_RootConstrainSelectedInstOperands,
     /* 216907 */     // GIR_Coverage, 3835,
     /* 216907 */     GIR_EraseRootFromParent_Done,
     /* 216908 */   // Label 4258: @216908
     /* 216908 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216962), // Rule ID 3836 //
     /* 216913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216949 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216960 */     GIR_RootConstrainSelectedInstOperands,
     /* 216961 */     // GIR_Coverage, 3836,
     /* 216961 */     GIR_EraseRootFromParent_Done,
     /* 216962 */   // Label 4259: @216962
     /* 216962 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(217016), // Rule ID 3837 //
     /* 216967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217003 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 217006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217014 */     GIR_RootConstrainSelectedInstOperands,
     /* 217015 */     // GIR_Coverage, 3837,
     /* 217015 */     GIR_EraseRootFromParent_Done,
     /* 217016 */   // Label 4260: @217016
     /* 217016 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(217070), // Rule ID 3838 //
     /* 217021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 217029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217057 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 217060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217068 */     GIR_RootConstrainSelectedInstOperands,
     /* 217069 */     // GIR_Coverage, 3838,
     /* 217069 */     GIR_EraseRootFromParent_Done,
     /* 217070 */   // Label 4261: @217070
     /* 217070 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(217124), // Rule ID 3839 //
     /* 217075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 217083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217111 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 217111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 217114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217122 */     GIR_RootConstrainSelectedInstOperands,
     /* 217123 */     // GIR_Coverage, 3839,
     /* 217123 */     GIR_EraseRootFromParent_Done,
     /* 217124 */   // Label 4262: @217124
     /* 217124 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(217178), // Rule ID 3840 //
     /* 217129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 217137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217165 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 217165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 217168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217176 */     GIR_RootConstrainSelectedInstOperands,
     /* 217177 */     // GIR_Coverage, 3840,
     /* 217177 */     GIR_EraseRootFromParent_Done,
     /* 217178 */   // Label 4263: @217178
     /* 217178 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(217232), // Rule ID 3841 //
     /* 217183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 217191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217219 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 217222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217230 */     GIR_RootConstrainSelectedInstOperands,
     /* 217231 */     // GIR_Coverage, 3841,
     /* 217231 */     GIR_EraseRootFromParent_Done,
     /* 217232 */   // Label 4264: @217232
     /* 217232 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(217286), // Rule ID 3842 //
     /* 217237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 217240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 217245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217273 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 217273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 217276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217284 */     GIR_RootConstrainSelectedInstOperands,
     /* 217285 */     // GIR_Coverage, 3842,
     /* 217285 */     GIR_EraseRootFromParent_Done,
     /* 217286 */   // Label 4265: @217286
     /* 217286 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(217340), // Rule ID 3846 //
     /* 217291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 217294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 217299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217327 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 217327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 217330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 217332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 217334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 217336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 217338 */     GIR_RootConstrainSelectedInstOperands,
     /* 217339 */     // GIR_Coverage, 3846,
     /* 217339 */     GIR_EraseRootFromParent_Done,
     /* 217340 */   // Label 4266: @217340
     /* 217340 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(217394), // Rule ID 3847 //
     /* 217345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 217348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 217353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217381 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 217384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217392 */     GIR_RootConstrainSelectedInstOperands,
     /* 217393 */     // GIR_Coverage, 3847,
     /* 217393 */     GIR_EraseRootFromParent_Done,
     /* 217394 */   // Label 4267: @217394
     /* 217394 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(217448), // Rule ID 3848 //
     /* 217399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 217402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 217407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217435 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 217438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217446 */     GIR_RootConstrainSelectedInstOperands,
     /* 217447 */     // GIR_Coverage, 3848,
     /* 217447 */     GIR_EraseRootFromParent_Done,
     /* 217448 */   // Label 4268: @217448
     /* 217448 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(217505), // Rule ID 3865 //
     /* 217453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217489 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 217489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217503 */     GIR_RootConstrainSelectedInstOperands,
     /* 217504 */     // GIR_Coverage, 3865,
     /* 217504 */     GIR_EraseRootFromParent_Done,
     /* 217505 */   // Label 4269: @217505
     /* 217505 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(217562), // Rule ID 3866 //
     /* 217510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217546 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 217546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217560 */     GIR_RootConstrainSelectedInstOperands,
     /* 217561 */     // GIR_Coverage, 3866,
     /* 217561 */     GIR_EraseRootFromParent_Done,
     /* 217562 */   // Label 4270: @217562
     /* 217562 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(217619), // Rule ID 3867 //
     /* 217567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217603 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 217603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217617 */     GIR_RootConstrainSelectedInstOperands,
     /* 217618 */     // GIR_Coverage, 3867,
     /* 217618 */     GIR_EraseRootFromParent_Done,
     /* 217619 */   // Label 4271: @217619
     /* 217619 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(217676), // Rule ID 3868 //
     /* 217624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217660 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 217660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217674 */     GIR_RootConstrainSelectedInstOperands,
     /* 217675 */     // GIR_Coverage, 3868,
     /* 217675 */     GIR_EraseRootFromParent_Done,
     /* 217676 */   // Label 4272: @217676
     /* 217676 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(217733), // Rule ID 3873 //
     /* 217681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217717 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 217717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217731 */     GIR_RootConstrainSelectedInstOperands,
     /* 217732 */     // GIR_Coverage, 3873,
     /* 217732 */     GIR_EraseRootFromParent_Done,
     /* 217733 */   // Label 4273: @217733
     /* 217733 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217790), // Rule ID 3874 //
     /* 217738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217774 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 217774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217788 */     GIR_RootConstrainSelectedInstOperands,
     /* 217789 */     // GIR_Coverage, 3874,
     /* 217789 */     GIR_EraseRootFromParent_Done,
     /* 217790 */   // Label 4274: @217790
     /* 217790 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217847), // Rule ID 3875 //
     /* 217795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217831 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 217831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217845 */     GIR_RootConstrainSelectedInstOperands,
     /* 217846 */     // GIR_Coverage, 3875,
     /* 217846 */     GIR_EraseRootFromParent_Done,
     /* 217847 */   // Label 4275: @217847
     /* 217847 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217904), // Rule ID 3876 //
     /* 217852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217888 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 217888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217902 */     GIR_RootConstrainSelectedInstOperands,
     /* 217903 */     // GIR_Coverage, 3876,
     /* 217903 */     GIR_EraseRootFromParent_Done,
     /* 217904 */   // Label 4276: @217904
     /* 217904 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217961), // Rule ID 3881 //
     /* 217909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217945 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 217945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217959 */     GIR_RootConstrainSelectedInstOperands,
     /* 217960 */     // GIR_Coverage, 3881,
     /* 217960 */     GIR_EraseRootFromParent_Done,
     /* 217961 */   // Label 4277: @217961
     /* 217961 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(218018), // Rule ID 3882 //
     /* 217966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218002 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 218002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 218005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218016 */     GIR_RootConstrainSelectedInstOperands,
     /* 218017 */     // GIR_Coverage, 3882,
     /* 218017 */     GIR_EraseRootFromParent_Done,
     /* 218018 */   // Label 4278: @218018
     /* 218018 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(218075), // Rule ID 3883 //
     /* 218023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 218040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 218043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218059 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 218059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 218062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218073 */     GIR_RootConstrainSelectedInstOperands,
     /* 218074 */     // GIR_Coverage, 3883,
     /* 218074 */     GIR_EraseRootFromParent_Done,
     /* 218075 */   // Label 4279: @218075
     /* 218075 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(218132), // Rule ID 3884 //
     /* 218080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 218097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 218100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218116 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 218116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 218119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218130 */     GIR_RootConstrainSelectedInstOperands,
     /* 218131 */     // GIR_Coverage, 3884,
     /* 218131 */     GIR_EraseRootFromParent_Done,
     /* 218132 */   // Label 4280: @218132
     /* 218132 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(218189), // Rule ID 3885 //
     /* 218137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218173 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 218173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 218176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218187 */     GIR_RootConstrainSelectedInstOperands,
     /* 218188 */     // GIR_Coverage, 3885,
     /* 218188 */     GIR_EraseRootFromParent_Done,
     /* 218189 */   // Label 4281: @218189
     /* 218189 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(218246), // Rule ID 3886 //
     /* 218194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218230 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 218230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 218233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218244 */     GIR_RootConstrainSelectedInstOperands,
     /* 218245 */     // GIR_Coverage, 3886,
     /* 218245 */     GIR_EraseRootFromParent_Done,
     /* 218246 */   // Label 4282: @218246
     /* 218246 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(218303), // Rule ID 3887 //
     /* 218251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218287 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 218287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 218290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218301 */     GIR_RootConstrainSelectedInstOperands,
     /* 218302 */     // GIR_Coverage, 3887,
     /* 218302 */     GIR_EraseRootFromParent_Done,
     /* 218303 */   // Label 4283: @218303
     /* 218303 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(218360), // Rule ID 3888 //
     /* 218308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 218319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 218322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 218325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 218328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218344 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 218344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 218347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218358 */     GIR_RootConstrainSelectedInstOperands,
     /* 218359 */     // GIR_Coverage, 3888,
     /* 218359 */     GIR_EraseRootFromParent_Done,
     /* 218360 */   // Label 4284: @218360
     /* 218360 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(218417), // Rule ID 3889 //
     /* 218365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218401 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 218401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218415 */     GIR_RootConstrainSelectedInstOperands,
     /* 218416 */     // GIR_Coverage, 3889,
     /* 218416 */     GIR_EraseRootFromParent_Done,
     /* 218417 */   // Label 4285: @218417
     /* 218417 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(218474), // Rule ID 3890 //
     /* 218422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218458 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 218458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218472 */     GIR_RootConstrainSelectedInstOperands,
     /* 218473 */     // GIR_Coverage, 3890,
     /* 218473 */     GIR_EraseRootFromParent_Done,
     /* 218474 */   // Label 4286: @218474
     /* 218474 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(218531), // Rule ID 3891 //
     /* 218479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218515 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 218515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218529 */     GIR_RootConstrainSelectedInstOperands,
     /* 218530 */     // GIR_Coverage, 3891,
     /* 218530 */     GIR_EraseRootFromParent_Done,
     /* 218531 */   // Label 4287: @218531
     /* 218531 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(218588), // Rule ID 3892 //
     /* 218536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218572 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 218572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 3892,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4288: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(218642), // Rule ID 5232 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 218610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218629 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 218629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 218632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218640 */     GIR_RootConstrainSelectedInstOperands,
     /* 218641 */     // GIR_Coverage, 5232,
     /* 218641 */     GIR_EraseRootFromParent_Done,
     /* 218642 */   // Label 4289: @218642
     /* 218642 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(218696), // Rule ID 5233 //
     /* 218647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 218650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 218664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 218667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218683 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 218683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 218686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218694 */     GIR_RootConstrainSelectedInstOperands,
     /* 218695 */     // GIR_Coverage, 5233,
     /* 218695 */     GIR_EraseRootFromParent_Done,
     /* 218696 */   // Label 4290: @218696
     /* 218696 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(218747), // Rule ID 5586 //
     /* 218701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 218706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 218709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 218712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 218718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218734 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 218734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 218737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 218745 */     GIR_RootConstrainSelectedInstOperands,
     /* 218746 */     // GIR_Coverage, 5586,
     /* 218746 */     GIR_EraseRootFromParent_Done,
     /* 218747 */   // Label 4291: @218747
     /* 218747 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(218798), // Rule ID 5587 //
     /* 218752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 218757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218785 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 218785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 218788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 218794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 218796 */     GIR_RootConstrainSelectedInstOperands,
     /* 218797 */     // GIR_Coverage, 5587,
     /* 218797 */     GIR_EraseRootFromParent_Done,
     /* 218798 */   // Label 4292: @218798
     /* 218798 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218840), // Rule ID 2699 //
     /* 218803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 218817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 218830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218838 */     GIR_RootConstrainSelectedInstOperands,
     /* 218839 */     // GIR_Coverage, 2699,
     /* 218839 */     GIR_EraseRootFromParent_Done,
     /* 218840 */   // Label 4293: @218840
     /* 218840 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218882), // Rule ID 2700 //
     /* 218845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218880 */     GIR_RootConstrainSelectedInstOperands,
     /* 218881 */     // GIR_Coverage, 2700,
     /* 218881 */     GIR_EraseRootFromParent_Done,
     /* 218882 */   // Label 4294: @218882
     /* 218882 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218924), // Rule ID 2701 //
     /* 218887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218922 */     GIR_RootConstrainSelectedInstOperands,
     /* 218923 */     // GIR_Coverage, 2701,
     /* 218923 */     GIR_EraseRootFromParent_Done,
     /* 218924 */   // Label 4295: @218924
     /* 218924 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218966), // Rule ID 2702 //
     /* 218929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218964 */     GIR_RootConstrainSelectedInstOperands,
     /* 218965 */     // GIR_Coverage, 2702,
     /* 218965 */     GIR_EraseRootFromParent_Done,
     /* 218966 */   // Label 4296: @218966
     /* 218966 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(219008), // Rule ID 2703 //
     /* 218971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219006 */     GIR_RootConstrainSelectedInstOperands,
     /* 219007 */     // GIR_Coverage, 2703,
     /* 219007 */     GIR_EraseRootFromParent_Done,
     /* 219008 */   // Label 4297: @219008
     /* 219008 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(219050), // Rule ID 2704 //
     /* 219013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 219021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219037 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 219040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219048 */     GIR_RootConstrainSelectedInstOperands,
     /* 219049 */     // GIR_Coverage, 2704,
     /* 219049 */     GIR_EraseRootFromParent_Done,
     /* 219050 */   // Label 4298: @219050
     /* 219050 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(219092), // Rule ID 2705 //
     /* 219055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 219063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 219082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219090 */     GIR_RootConstrainSelectedInstOperands,
     /* 219091 */     // GIR_Coverage, 2705,
     /* 219091 */     GIR_EraseRootFromParent_Done,
     /* 219092 */   // Label 4299: @219092
     /* 219092 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(219134), // Rule ID 2744 //
     /* 219097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 219105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219121 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1264:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 219124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219132 */     GIR_RootConstrainSelectedInstOperands,
     /* 219133 */     // GIR_Coverage, 2744,
     /* 219133 */     GIR_EraseRootFromParent_Done,
     /* 219134 */   // Label 4300: @219134
     /* 219134 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(219176), // Rule ID 2745 //
     /* 219139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 219147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 219150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 219159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219163 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 219163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 219166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219174 */     GIR_RootConstrainSelectedInstOperands,
     /* 219175 */     // GIR_Coverage, 2745,
     /* 219175 */     GIR_EraseRootFromParent_Done,
     /* 219176 */   // Label 4301: @219176
     /* 219176 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(219218), // Rule ID 2746 //
     /* 219181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 219189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 219192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 219201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 219205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 219208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219216 */     GIR_RootConstrainSelectedInstOperands,
     /* 219217 */     // GIR_Coverage, 2746,
     /* 219217 */     GIR_EraseRootFromParent_Done,
     /* 219218 */   // Label 4302: @219218
     /* 219218 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(219260), // Rule ID 2747 //
     /* 219223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 219231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 219234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 219243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219247 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 219247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 219250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219258 */     GIR_RootConstrainSelectedInstOperands,
     /* 219259 */     // GIR_Coverage, 2747,
     /* 219259 */     GIR_EraseRootFromParent_Done,
     /* 219260 */   // Label 4303: @219260
     /* 219260 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(219302), // Rule ID 2748 //
     /* 219265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 219273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 219276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 219279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 219282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 219285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219289 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1264:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 219289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 219292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219300 */     GIR_RootConstrainSelectedInstOperands,
     /* 219301 */     // GIR_Coverage, 2748,
     /* 219301 */     GIR_EraseRootFromParent_Done,
     /* 219302 */   // Label 4304: @219302
     /* 219302 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(219344), // Rule ID 2787 //
     /* 219307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219331 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 219334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219342 */     GIR_RootConstrainSelectedInstOperands,
     /* 219343 */     // GIR_Coverage, 2787,
     /* 219343 */     GIR_EraseRootFromParent_Done,
     /* 219344 */   // Label 4305: @219344
     /* 219344 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(219386), // Rule ID 2789 //
     /* 219349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219373 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 219376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219384 */     GIR_RootConstrainSelectedInstOperands,
     /* 219385 */     // GIR_Coverage, 2789,
     /* 219385 */     GIR_EraseRootFromParent_Done,
     /* 219386 */   // Label 4306: @219386
     /* 219386 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(219428), // Rule ID 2791 //
     /* 219391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219415 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 219418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219426 */     GIR_RootConstrainSelectedInstOperands,
     /* 219427 */     // GIR_Coverage, 2791,
     /* 219427 */     GIR_EraseRootFromParent_Done,
     /* 219428 */   // Label 4307: @219428
     /* 219428 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(219470), // Rule ID 2793 //
     /* 219433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219457 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1537:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 219460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219468 */     GIR_RootConstrainSelectedInstOperands,
     /* 219469 */     // GIR_Coverage, 2793,
     /* 219469 */     GIR_EraseRootFromParent_Done,
     /* 219470 */   // Label 4308: @219470
     /* 219470 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(219512), // Rule ID 2794 //
     /* 219475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 219502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219510 */     GIR_RootConstrainSelectedInstOperands,
     /* 219511 */     // GIR_Coverage, 2794,
     /* 219511 */     GIR_EraseRootFromParent_Done,
     /* 219512 */   // Label 4309: @219512
     /* 219512 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(219554), // Rule ID 2795 //
     /* 219517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 219544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219552 */     GIR_RootConstrainSelectedInstOperands,
     /* 219553 */     // GIR_Coverage, 2795,
     /* 219553 */     GIR_EraseRootFromParent_Done,
     /* 219554 */   // Label 4310: @219554
     /* 219554 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(219596), // Rule ID 2864 //
     /* 219559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 219567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 219586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219594 */     GIR_RootConstrainSelectedInstOperands,
     /* 219595 */     // GIR_Coverage, 2864,
     /* 219595 */     GIR_EraseRootFromParent_Done,
     /* 219596 */   // Label 4311: @219596
     /* 219596 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(219638), // Rule ID 2865 //
     /* 219601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 219609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219625 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1400:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 219628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219636 */     GIR_RootConstrainSelectedInstOperands,
     /* 219637 */     // GIR_Coverage, 2865,
     /* 219637 */     GIR_EraseRootFromParent_Done,
     /* 219638 */   // Label 4312: @219638
     /* 219638 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(219680), // Rule ID 2866 //
     /* 219643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 219651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219667 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 219670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219678 */     GIR_RootConstrainSelectedInstOperands,
     /* 219679 */     // GIR_Coverage, 2866,
     /* 219679 */     GIR_EraseRootFromParent_Done,
     /* 219680 */   // Label 4313: @219680
     /* 219680 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(219722), // Rule ID 2867 //
     /* 219685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 219693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219709 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1396:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 219712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219720 */     GIR_RootConstrainSelectedInstOperands,
     /* 219721 */     // GIR_Coverage, 2867,
     /* 219721 */     GIR_EraseRootFromParent_Done,
     /* 219722 */   // Label 4314: @219722
     /* 219722 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219764), // Rule ID 2868 //
     /* 219727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 219735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219751 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 219754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219762 */     GIR_RootConstrainSelectedInstOperands,
     /* 219763 */     // GIR_Coverage, 2868,
     /* 219763 */     GIR_EraseRootFromParent_Done,
     /* 219764 */   // Label 4315: @219764
     /* 219764 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219806), // Rule ID 2869 //
     /* 219769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219793 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 219796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219804 */     GIR_RootConstrainSelectedInstOperands,
     /* 219805 */     // GIR_Coverage, 2869,
     /* 219805 */     GIR_EraseRootFromParent_Done,
     /* 219806 */   // Label 4316: @219806
     /* 219806 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219848), // Rule ID 2870 //
     /* 219811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219835 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 219838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219846 */     GIR_RootConstrainSelectedInstOperands,
     /* 219847 */     // GIR_Coverage, 2870,
     /* 219847 */     GIR_EraseRootFromParent_Done,
     /* 219848 */   // Label 4317: @219848
     /* 219848 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219890), // Rule ID 2871 //
     /* 219853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219877 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 219880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219888 */     GIR_RootConstrainSelectedInstOperands,
     /* 219889 */     // GIR_Coverage, 2871,
     /* 219889 */     GIR_EraseRootFromParent_Done,
     /* 219890 */   // Label 4318: @219890
     /* 219890 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219932), // Rule ID 2882 //
     /* 219895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 219903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219919 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219930 */     GIR_RootConstrainSelectedInstOperands,
     /* 219931 */     // GIR_Coverage, 2882,
     /* 219931 */     GIR_EraseRootFromParent_Done,
     /* 219932 */   // Label 4319: @219932
     /* 219932 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219974), // Rule ID 2884 //
     /* 219937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 219945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219961 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 219964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219972 */     GIR_RootConstrainSelectedInstOperands,
     /* 219973 */     // GIR_Coverage, 2884,
     /* 219973 */     GIR_EraseRootFromParent_Done,
     /* 219974 */   // Label 4320: @219974
     /* 219974 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(220016), // Rule ID 2892 //
     /* 219979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 220003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 220006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220014 */     GIR_RootConstrainSelectedInstOperands,
     /* 220015 */     // GIR_Coverage, 2892,
     /* 220015 */     GIR_EraseRootFromParent_Done,
     /* 220016 */   // Label 4321: @220016
     /* 220016 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(220058), // Rule ID 2893 //
     /* 220021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 220029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 220045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 220048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220056 */     GIR_RootConstrainSelectedInstOperands,
     /* 220057 */     // GIR_Coverage, 2893,
     /* 220057 */     GIR_EraseRootFromParent_Done,
     /* 220058 */   // Label 4322: @220058
     /* 220058 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(220100), // Rule ID 2894 //
     /* 220063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 220071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 220090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220098 */     GIR_RootConstrainSelectedInstOperands,
     /* 220099 */     // GIR_Coverage, 2894,
     /* 220099 */     GIR_EraseRootFromParent_Done,
     /* 220100 */   // Label 4323: @220100
     /* 220100 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(220142), // Rule ID 2898 //
     /* 220105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 220113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220129 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 220132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220140 */     GIR_RootConstrainSelectedInstOperands,
     /* 220141 */     // GIR_Coverage, 2898,
     /* 220141 */     GIR_EraseRootFromParent_Done,
     /* 220142 */   // Label 4324: @220142
     /* 220142 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(220184), // Rule ID 2943 //
     /* 220147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 220155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 220174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220182 */     GIR_RootConstrainSelectedInstOperands,
     /* 220183 */     // GIR_Coverage, 2943,
     /* 220183 */     GIR_EraseRootFromParent_Done,
     /* 220184 */   // Label 4325: @220184
     /* 220184 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(220226), // Rule ID 2944 //
     /* 220189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 220197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 220216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220224 */     GIR_RootConstrainSelectedInstOperands,
     /* 220225 */     // GIR_Coverage, 2944,
     /* 220225 */     GIR_EraseRootFromParent_Done,
     /* 220226 */   // Label 4326: @220226
     /* 220226 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(220268), // Rule ID 2973 //
     /* 220231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 220239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220255 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1822:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 220258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220266 */     GIR_RootConstrainSelectedInstOperands,
     /* 220267 */     // GIR_Coverage, 2973,
     /* 220267 */     GIR_EraseRootFromParent_Done,
     /* 220268 */   // Label 4327: @220268
     /* 220268 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(220310), // Rule ID 2974 //
     /* 220273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 220281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1822:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 220300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220308 */     GIR_RootConstrainSelectedInstOperands,
     /* 220309 */     // GIR_Coverage, 2974,
     /* 220309 */     GIR_EraseRootFromParent_Done,
     /* 220310 */   // Label 4328: @220310
     /* 220310 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(220352), // Rule ID 2975 //
     /* 220315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 220323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1822:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 220342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220350 */     GIR_RootConstrainSelectedInstOperands,
     /* 220351 */     // GIR_Coverage, 2975,
     /* 220351 */     GIR_EraseRootFromParent_Done,
     /* 220352 */   // Label 4329: @220352
     /* 220352 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(220394), // Rule ID 2976 //
     /* 220357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 220365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220381 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1822:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 220384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220392 */     GIR_RootConstrainSelectedInstOperands,
     /* 220393 */     // GIR_Coverage, 2976,
     /* 220393 */     GIR_EraseRootFromParent_Done,
     /* 220394 */   // Label 4330: @220394
     /* 220394 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(220436), // Rule ID 2977 //
     /* 220399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220423 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 220426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220434 */     GIR_RootConstrainSelectedInstOperands,
     /* 220435 */     // GIR_Coverage, 2977,
     /* 220435 */     GIR_EraseRootFromParent_Done,
     /* 220436 */   // Label 4331: @220436
     /* 220436 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(220478), // Rule ID 2978 //
     /* 220441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 220468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220476 */     GIR_RootConstrainSelectedInstOperands,
     /* 220477 */     // GIR_Coverage, 2978,
     /* 220477 */     GIR_EraseRootFromParent_Done,
     /* 220478 */   // Label 4332: @220478
     /* 220478 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(220520), // Rule ID 2979 //
     /* 220483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 220510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220518 */     GIR_RootConstrainSelectedInstOperands,
     /* 220519 */     // GIR_Coverage, 2979,
     /* 220519 */     GIR_EraseRootFromParent_Done,
     /* 220520 */   // Label 4333: @220520
     /* 220520 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220562), // Rule ID 3009 //
     /* 220525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220549 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 220552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220560 */     GIR_RootConstrainSelectedInstOperands,
     /* 220561 */     // GIR_Coverage, 3009,
     /* 220561 */     GIR_EraseRootFromParent_Done,
     /* 220562 */   // Label 4334: @220562
     /* 220562 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220604), // Rule ID 3011 //
     /* 220567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 220594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220602 */     GIR_RootConstrainSelectedInstOperands,
     /* 220603 */     // GIR_Coverage, 3011,
     /* 220603 */     GIR_EraseRootFromParent_Done,
     /* 220604 */   // Label 4335: @220604
     /* 220604 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220646), // Rule ID 3013 //
     /* 220609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 220636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220644 */     GIR_RootConstrainSelectedInstOperands,
     /* 220645 */     // GIR_Coverage, 3013,
     /* 220645 */     GIR_EraseRootFromParent_Done,
     /* 220646 */   // Label 4336: @220646
     /* 220646 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220688), // Rule ID 3015 //
     /* 220651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 220678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220686 */     GIR_RootConstrainSelectedInstOperands,
     /* 220687 */     // GIR_Coverage, 3015,
     /* 220687 */     GIR_EraseRootFromParent_Done,
     /* 220688 */   // Label 4337: @220688
     /* 220688 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220730), // Rule ID 3017 //
     /* 220693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 220720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220728 */     GIR_RootConstrainSelectedInstOperands,
     /* 220729 */     // GIR_Coverage, 3017,
     /* 220729 */     GIR_EraseRootFromParent_Done,
     /* 220730 */   // Label 4338: @220730
     /* 220730 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220772), // Rule ID 3018 //
     /* 220735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 220762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220770 */     GIR_RootConstrainSelectedInstOperands,
     /* 220771 */     // GIR_Coverage, 3018,
     /* 220771 */     GIR_EraseRootFromParent_Done,
     /* 220772 */   // Label 4339: @220772
     /* 220772 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220814), // Rule ID 3019 //
     /* 220777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 220804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220812 */     GIR_RootConstrainSelectedInstOperands,
     /* 220813 */     // GIR_Coverage, 3019,
     /* 220813 */     GIR_EraseRootFromParent_Done,
     /* 220814 */   // Label 4340: @220814
     /* 220814 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220856), // Rule ID 3020 //
     /* 220819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 220827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 220846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220854 */     GIR_RootConstrainSelectedInstOperands,
     /* 220855 */     // GIR_Coverage, 3020,
     /* 220855 */     GIR_EraseRootFromParent_Done,
     /* 220856 */   // Label 4341: @220856
     /* 220856 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220898), // Rule ID 3021 //
     /* 220861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220885 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 220888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220896 */     GIR_RootConstrainSelectedInstOperands,
     /* 220897 */     // GIR_Coverage, 3021,
     /* 220897 */     GIR_EraseRootFromParent_Done,
     /* 220898 */   // Label 4342: @220898
     /* 220898 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220940), // Rule ID 3022 //
     /* 220903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220927 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 220930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220938 */     GIR_RootConstrainSelectedInstOperands,
     /* 220939 */     // GIR_Coverage, 3022,
     /* 220939 */     GIR_EraseRootFromParent_Done,
     /* 220940 */   // Label 4343: @220940
     /* 220940 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220982), // Rule ID 3023 //
     /* 220945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 220972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220980 */     GIR_RootConstrainSelectedInstOperands,
     /* 220981 */     // GIR_Coverage, 3023,
     /* 220981 */     GIR_EraseRootFromParent_Done,
     /* 220982 */   // Label 4344: @220982
     /* 220982 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(221024), // Rule ID 3024 //
     /* 220987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 221014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221022 */     GIR_RootConstrainSelectedInstOperands,
     /* 221023 */     // GIR_Coverage, 3024,
     /* 221023 */     GIR_EraseRootFromParent_Done,
     /* 221024 */   // Label 4345: @221024
     /* 221024 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(221066), // Rule ID 3041 //
     /* 221029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 221037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221053 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 221056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221064 */     GIR_RootConstrainSelectedInstOperands,
     /* 221065 */     // GIR_Coverage, 3041,
     /* 221065 */     GIR_EraseRootFromParent_Done,
     /* 221066 */   // Label 4346: @221066
     /* 221066 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(221108), // Rule ID 3042 //
     /* 221071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 221079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 221098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221106 */     GIR_RootConstrainSelectedInstOperands,
     /* 221107 */     // GIR_Coverage, 3042,
     /* 221107 */     GIR_EraseRootFromParent_Done,
     /* 221108 */   // Label 4347: @221108
     /* 221108 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(221150), // Rule ID 3043 //
     /* 221113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 221121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 221140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221148 */     GIR_RootConstrainSelectedInstOperands,
     /* 221149 */     // GIR_Coverage, 3043,
     /* 221149 */     GIR_EraseRootFromParent_Done,
     /* 221150 */   // Label 4348: @221150
     /* 221150 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(221192), // Rule ID 3044 //
     /* 221155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 221163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 221182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221190 */     GIR_RootConstrainSelectedInstOperands,
     /* 221191 */     // GIR_Coverage, 3044,
     /* 221191 */     GIR_EraseRootFromParent_Done,
     /* 221192 */   // Label 4349: @221192
     /* 221192 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(221234), // Rule ID 3068 //
     /* 221197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 221205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221221 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 221224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221232 */     GIR_RootConstrainSelectedInstOperands,
     /* 221233 */     // GIR_Coverage, 3068,
     /* 221233 */     GIR_EraseRootFromParent_Done,
     /* 221234 */   // Label 4350: @221234
     /* 221234 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(221276), // Rule ID 3070 //
     /* 221239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 221247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221263 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 221266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221274 */     GIR_RootConstrainSelectedInstOperands,
     /* 221275 */     // GIR_Coverage, 3070,
     /* 221275 */     GIR_EraseRootFromParent_Done,
     /* 221276 */   // Label 4351: @221276
     /* 221276 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(221318), // Rule ID 3072 //
     /* 221281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 221289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 221308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221316 */     GIR_RootConstrainSelectedInstOperands,
     /* 221317 */     // GIR_Coverage, 3072,
     /* 221317 */     GIR_EraseRootFromParent_Done,
     /* 221318 */   // Label 4352: @221318
     /* 221318 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(221360), // Rule ID 3074 //
     /* 221323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 221331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221347 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 221350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221358 */     GIR_RootConstrainSelectedInstOperands,
     /* 221359 */     // GIR_Coverage, 3074,
     /* 221359 */     GIR_EraseRootFromParent_Done,
     /* 221360 */   // Label 4353: @221360
     /* 221360 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(221402), // Rule ID 3076 //
     /* 221365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 221392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221400 */     GIR_RootConstrainSelectedInstOperands,
     /* 221401 */     // GIR_Coverage, 3076,
     /* 221401 */     GIR_EraseRootFromParent_Done,
     /* 221402 */   // Label 4354: @221402
     /* 221402 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(221444), // Rule ID 3077 //
     /* 221407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 221434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221442 */     GIR_RootConstrainSelectedInstOperands,
     /* 221443 */     // GIR_Coverage, 3077,
     /* 221443 */     GIR_EraseRootFromParent_Done,
     /* 221444 */   // Label 4355: @221444
     /* 221444 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(221486), // Rule ID 3078 //
     /* 221449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221473 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 221476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221484 */     GIR_RootConstrainSelectedInstOperands,
     /* 221485 */     // GIR_Coverage, 3078,
     /* 221485 */     GIR_EraseRootFromParent_Done,
     /* 221486 */   // Label 4356: @221486
     /* 221486 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(221528), // Rule ID 3079 //
     /* 221491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 221499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 221518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221526 */     GIR_RootConstrainSelectedInstOperands,
     /* 221527 */     // GIR_Coverage, 3079,
     /* 221527 */     GIR_EraseRootFromParent_Done,
     /* 221528 */   // Label 4357: @221528
     /* 221528 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221570), // Rule ID 3080 //
     /* 221533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 221541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 221560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221568 */     GIR_RootConstrainSelectedInstOperands,
     /* 221569 */     // GIR_Coverage, 3080,
     /* 221569 */     GIR_EraseRootFromParent_Done,
     /* 221570 */   // Label 4358: @221570
     /* 221570 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221612), // Rule ID 3090 //
     /* 221575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221599 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 221602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221610 */     GIR_RootConstrainSelectedInstOperands,
     /* 221611 */     // GIR_Coverage, 3090,
     /* 221611 */     GIR_EraseRootFromParent_Done,
     /* 221612 */   // Label 4359: @221612
     /* 221612 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221654), // Rule ID 3091 //
     /* 221617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221641 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 221644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221652 */     GIR_RootConstrainSelectedInstOperands,
     /* 221653 */     // GIR_Coverage, 3091,
     /* 221653 */     GIR_EraseRootFromParent_Done,
     /* 221654 */   // Label 4360: @221654
     /* 221654 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221696), // Rule ID 3092 //
     /* 221659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221683 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 221686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221694 */     GIR_RootConstrainSelectedInstOperands,
     /* 221695 */     // GIR_Coverage, 3092,
     /* 221695 */     GIR_EraseRootFromParent_Done,
     /* 221696 */   // Label 4361: @221696
     /* 221696 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221738), // Rule ID 3109 //
     /* 221701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221725 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 221725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 221728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221736 */     GIR_RootConstrainSelectedInstOperands,
     /* 221737 */     // GIR_Coverage, 3109,
     /* 221737 */     GIR_EraseRootFromParent_Done,
     /* 221738 */   // Label 4362: @221738
     /* 221738 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221780), // Rule ID 3110 //
     /* 221743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 221760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 221767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 221770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221778 */     GIR_RootConstrainSelectedInstOperands,
     /* 221779 */     // GIR_Coverage, 3110,
     /* 221779 */     GIR_EraseRootFromParent_Done,
     /* 221780 */   // Label 4363: @221780
     /* 221780 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221822), // Rule ID 3111 //
     /* 221785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 221809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 221812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221820 */     GIR_RootConstrainSelectedInstOperands,
     /* 221821 */     // GIR_Coverage, 3111,
     /* 221821 */     GIR_EraseRootFromParent_Done,
     /* 221822 */   // Label 4364: @221822
     /* 221822 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221864), // Rule ID 3112 //
     /* 221827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 221851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 221854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221862 */     GIR_RootConstrainSelectedInstOperands,
     /* 221863 */     // GIR_Coverage, 3112,
     /* 221863 */     GIR_EraseRootFromParent_Done,
     /* 221864 */   // Label 4365: @221864
     /* 221864 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221906), // Rule ID 3147 //
     /* 221869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221893 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221904 */     GIR_RootConstrainSelectedInstOperands,
     /* 221905 */     // GIR_Coverage, 3147,
     /* 221905 */     GIR_EraseRootFromParent_Done,
     /* 221906 */   // Label 4366: @221906
     /* 221906 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221948), // Rule ID 3149 //
     /* 221911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221946 */     GIR_RootConstrainSelectedInstOperands,
     /* 221947 */     // GIR_Coverage, 3149,
     /* 221947 */     GIR_EraseRootFromParent_Done,
     /* 221948 */   // Label 4367: @221948
     /* 221948 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221990), // Rule ID 3151 //
     /* 221953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221988 */     GIR_RootConstrainSelectedInstOperands,
     /* 221989 */     // GIR_Coverage, 3151,
     /* 221989 */     GIR_EraseRootFromParent_Done,
     /* 221990 */   // Label 4368: @221990
     /* 221990 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(222032), // Rule ID 3153 //
     /* 221995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 222003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 222022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222030 */     GIR_RootConstrainSelectedInstOperands,
     /* 222031 */     // GIR_Coverage, 3153,
     /* 222031 */     GIR_EraseRootFromParent_Done,
     /* 222032 */   // Label 4369: @222032
     /* 222032 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(222077), // Rule ID 3192 //
     /* 222037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 222045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222061 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 222064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222075 */     GIR_RootConstrainSelectedInstOperands,
     /* 222076 */     // GIR_Coverage, 3192,
     /* 222076 */     GIR_EraseRootFromParent_Done,
     /* 222077 */   // Label 4370: @222077
     /* 222077 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(222122), // Rule ID 3193 //
     /* 222082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 222090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 222109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222120 */     GIR_RootConstrainSelectedInstOperands,
     /* 222121 */     // GIR_Coverage, 3193,
     /* 222121 */     GIR_EraseRootFromParent_Done,
     /* 222122 */   // Label 4371: @222122
     /* 222122 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(222167), // Rule ID 3194 //
     /* 222127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 222135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 222154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222165 */     GIR_RootConstrainSelectedInstOperands,
     /* 222166 */     // GIR_Coverage, 3194,
     /* 222166 */     GIR_EraseRootFromParent_Done,
     /* 222167 */   // Label 4372: @222167
     /* 222167 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(222212), // Rule ID 3195 //
     /* 222172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 222180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 222199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222210 */     GIR_RootConstrainSelectedInstOperands,
     /* 222211 */     // GIR_Coverage, 3195,
     /* 222211 */     GIR_EraseRootFromParent_Done,
     /* 222212 */   // Label 4373: @222212
     /* 222212 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(222257), // Rule ID 3196 //
     /* 222217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 222225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222241 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 222244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222255 */     GIR_RootConstrainSelectedInstOperands,
     /* 222256 */     // GIR_Coverage, 3196,
     /* 222256 */     GIR_EraseRootFromParent_Done,
     /* 222257 */   // Label 4374: @222257
     /* 222257 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(222302), // Rule ID 3197 //
     /* 222262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 222270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 222289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222300 */     GIR_RootConstrainSelectedInstOperands,
     /* 222301 */     // GIR_Coverage, 3197,
     /* 222301 */     GIR_EraseRootFromParent_Done,
     /* 222302 */   // Label 4375: @222302
     /* 222302 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(222344), // Rule ID 3252 //
     /* 222307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 222315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222331 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 222334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222342 */     GIR_RootConstrainSelectedInstOperands,
     /* 222343 */     // GIR_Coverage, 3252,
     /* 222343 */     GIR_EraseRootFromParent_Done,
     /* 222344 */   // Label 4376: @222344
     /* 222344 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(222386), // Rule ID 3253 //
     /* 222349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 222357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222373 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 222376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222384 */     GIR_RootConstrainSelectedInstOperands,
     /* 222385 */     // GIR_Coverage, 3253,
     /* 222385 */     GIR_EraseRootFromParent_Done,
     /* 222386 */   // Label 4377: @222386
     /* 222386 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(222428), // Rule ID 3254 //
     /* 222391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 222399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222415 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 222418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222426 */     GIR_RootConstrainSelectedInstOperands,
     /* 222427 */     // GIR_Coverage, 3254,
     /* 222427 */     GIR_EraseRootFromParent_Done,
     /* 222428 */   // Label 4378: @222428
     /* 222428 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(222470), // Rule ID 3306 //
     /* 222433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 222460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222468 */     GIR_RootConstrainSelectedInstOperands,
     /* 222469 */     // GIR_Coverage, 3306,
     /* 222469 */     GIR_EraseRootFromParent_Done,
     /* 222470 */   // Label 4379: @222470
     /* 222470 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(222512), // Rule ID 3307 //
     /* 222475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 222502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222510 */     GIR_RootConstrainSelectedInstOperands,
     /* 222511 */     // GIR_Coverage, 3307,
     /* 222511 */     GIR_EraseRootFromParent_Done,
     /* 222512 */   // Label 4380: @222512
     /* 222512 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222554), // Rule ID 3308 //
     /* 222517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 222544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222552 */     GIR_RootConstrainSelectedInstOperands,
     /* 222553 */     // GIR_Coverage, 3308,
     /* 222553 */     GIR_EraseRootFromParent_Done,
     /* 222554 */   // Label 4381: @222554
     /* 222554 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222596), // Rule ID 3309 //
     /* 222559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 222586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222594 */     GIR_RootConstrainSelectedInstOperands,
     /* 222595 */     // GIR_Coverage, 3309,
     /* 222595 */     GIR_EraseRootFromParent_Done,
     /* 222596 */   // Label 4382: @222596
     /* 222596 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222638), // Rule ID 3318 //
     /* 222601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222625 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 222628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222636 */     GIR_RootConstrainSelectedInstOperands,
     /* 222637 */     // GIR_Coverage, 3318,
     /* 222637 */     GIR_EraseRootFromParent_Done,
     /* 222638 */   // Label 4383: @222638
     /* 222638 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222680), // Rule ID 3319 //
     /* 222643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222667 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 222670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222678 */     GIR_RootConstrainSelectedInstOperands,
     /* 222679 */     // GIR_Coverage, 3319,
     /* 222679 */     GIR_EraseRootFromParent_Done,
     /* 222680 */   // Label 4384: @222680
     /* 222680 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222722), // Rule ID 3320 //
     /* 222685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 222712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222720 */     GIR_RootConstrainSelectedInstOperands,
     /* 222721 */     // GIR_Coverage, 3320,
     /* 222721 */     GIR_EraseRootFromParent_Done,
     /* 222722 */   // Label 4385: @222722
     /* 222722 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222764), // Rule ID 3359 //
     /* 222727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222751 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 222754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222762 */     GIR_RootConstrainSelectedInstOperands,
     /* 222763 */     // GIR_Coverage, 3359,
     /* 222763 */     GIR_EraseRootFromParent_Done,
     /* 222764 */   // Label 4386: @222764
     /* 222764 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222806), // Rule ID 3360 //
     /* 222769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222804 */     GIR_RootConstrainSelectedInstOperands,
     /* 222805 */     // GIR_Coverage, 3360,
     /* 222805 */     GIR_EraseRootFromParent_Done,
     /* 222806 */   // Label 4387: @222806
     /* 222806 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222848), // Rule ID 3361 //
     /* 222811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222846 */     GIR_RootConstrainSelectedInstOperands,
     /* 222847 */     // GIR_Coverage, 3361,
     /* 222847 */     GIR_EraseRootFromParent_Done,
     /* 222848 */   // Label 4388: @222848
     /* 222848 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222890), // Rule ID 3362 //
     /* 222853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222888 */     GIR_RootConstrainSelectedInstOperands,
     /* 222889 */     // GIR_Coverage, 3362,
     /* 222889 */     GIR_EraseRootFromParent_Done,
     /* 222890 */   // Label 4389: @222890
     /* 222890 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222932), // Rule ID 3363 //
     /* 222895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222919 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222930 */     GIR_RootConstrainSelectedInstOperands,
     /* 222931 */     // GIR_Coverage, 3363,
     /* 222931 */     GIR_EraseRootFromParent_Done,
     /* 222932 */   // Label 4390: @222932
     /* 222932 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222974), // Rule ID 3364 //
     /* 222937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222961 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222972 */     GIR_RootConstrainSelectedInstOperands,
     /* 222973 */     // GIR_Coverage, 3364,
     /* 222973 */     GIR_EraseRootFromParent_Done,
     /* 222974 */   // Label 4391: @222974
     /* 222974 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(223016), // Rule ID 3365 //
     /* 222979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223003 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 223006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223014 */     GIR_RootConstrainSelectedInstOperands,
     /* 223015 */     // GIR_Coverage, 3365,
     /* 223015 */     GIR_EraseRootFromParent_Done,
     /* 223016 */   // Label 4392: @223016
     /* 223016 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(223058), // Rule ID 3448 //
     /* 223021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 223029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 223041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223045 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 223045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 223048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223056 */     GIR_RootConstrainSelectedInstOperands,
     /* 223057 */     // GIR_Coverage, 3448,
     /* 223057 */     GIR_EraseRootFromParent_Done,
     /* 223058 */   // Label 4393: @223058
     /* 223058 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(223100), // Rule ID 3449 //
     /* 223063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 223071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 223083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223087 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 223087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 223090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 223092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223098 */     GIR_RootConstrainSelectedInstOperands,
     /* 223099 */     // GIR_Coverage, 3449,
     /* 223099 */     GIR_EraseRootFromParent_Done,
     /* 223100 */   // Label 4394: @223100
     /* 223100 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(223142), // Rule ID 3450 //
     /* 223105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 223113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 223125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223129 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 223129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 223132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223140 */     GIR_RootConstrainSelectedInstOperands,
     /* 223141 */     // GIR_Coverage, 3450,
     /* 223141 */     GIR_EraseRootFromParent_Done,
     /* 223142 */   // Label 4395: @223142
     /* 223142 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(223187), // Rule ID 3452 //
     /* 223147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 223150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 223155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 223158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223171 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 223174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223185 */     GIR_RootConstrainSelectedInstOperands,
     /* 223186 */     // GIR_Coverage, 3452,
     /* 223186 */     GIR_EraseRootFromParent_Done,
     /* 223187 */   // Label 4396: @223187
     /* 223187 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(223232), // Rule ID 3453 //
     /* 223192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 223195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 223200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 223203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 223216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 223219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 223221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 223230 */     GIR_RootConstrainSelectedInstOperands,
     /* 223231 */     // GIR_Coverage, 3453,
     /* 223231 */     GIR_EraseRootFromParent_Done,
     /* 223232 */   // Label 4397: @223232
     /* 223232 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(223274), // Rule ID 3454 //
     /* 223237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 223240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 223245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 223264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223272 */     GIR_RootConstrainSelectedInstOperands,
     /* 223273 */     // GIR_Coverage, 3454,
     /* 223273 */     GIR_EraseRootFromParent_Done,
     /* 223274 */   // Label 4398: @223274
     /* 223274 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(223316), // Rule ID 3455 //
     /* 223279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 223282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 223287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1545:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 223306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223314 */     GIR_RootConstrainSelectedInstOperands,
     /* 223315 */     // GIR_Coverage, 3455,
     /* 223315 */     GIR_EraseRootFromParent_Done,
     /* 223316 */   // Label 4399: @223316
     /* 223316 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(223358), // Rule ID 3460 //
     /* 223321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 223324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 223329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 223348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223356 */     GIR_RootConstrainSelectedInstOperands,
     /* 223357 */     // GIR_Coverage, 3460,
     /* 223357 */     GIR_EraseRootFromParent_Done,
     /* 223358 */   // Label 4400: @223358
     /* 223358 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(223400), // Rule ID 3499 //
     /* 223363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223387 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 223390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223398 */     GIR_RootConstrainSelectedInstOperands,
     /* 223399 */     // GIR_Coverage, 3499,
     /* 223399 */     GIR_EraseRootFromParent_Done,
     /* 223400 */   // Label 4401: @223400
     /* 223400 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(223442), // Rule ID 3501 //
     /* 223405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223429 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 223432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223440 */     GIR_RootConstrainSelectedInstOperands,
     /* 223441 */     // GIR_Coverage, 3501,
     /* 223441 */     GIR_EraseRootFromParent_Done,
     /* 223442 */   // Label 4402: @223442
     /* 223442 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(223484), // Rule ID 3503 //
     /* 223447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223471 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 223474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223482 */     GIR_RootConstrainSelectedInstOperands,
     /* 223483 */     // GIR_Coverage, 3503,
     /* 223483 */     GIR_EraseRootFromParent_Done,
     /* 223484 */   // Label 4403: @223484
     /* 223484 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(223526), // Rule ID 3505 //
     /* 223489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 223497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 223516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223524 */     GIR_RootConstrainSelectedInstOperands,
     /* 223525 */     // GIR_Coverage, 3505,
     /* 223525 */     GIR_EraseRootFromParent_Done,
     /* 223526 */   // Label 4404: @223526
     /* 223526 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223568), // Rule ID 3632 //
     /* 223531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223566 */     GIR_RootConstrainSelectedInstOperands,
     /* 223567 */     // GIR_Coverage, 3632,
     /* 223567 */     GIR_EraseRootFromParent_Done,
     /* 223568 */   // Label 4405: @223568
     /* 223568 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223610), // Rule ID 3634 //
     /* 223573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 223600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223608 */     GIR_RootConstrainSelectedInstOperands,
     /* 223609 */     // GIR_Coverage, 3634,
     /* 223609 */     GIR_EraseRootFromParent_Done,
     /* 223610 */   // Label 4406: @223610
     /* 223610 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223652), // Rule ID 3636 //
     /* 223615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 223642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223650 */     GIR_RootConstrainSelectedInstOperands,
     /* 223651 */     // GIR_Coverage, 3636,
     /* 223651 */     GIR_EraseRootFromParent_Done,
     /* 223652 */   // Label 4407: @223652
     /* 223652 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223694), // Rule ID 3638 //
     /* 223657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 223684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223692 */     GIR_RootConstrainSelectedInstOperands,
     /* 223693 */     // GIR_Coverage, 3638,
     /* 223693 */     GIR_EraseRootFromParent_Done,
     /* 223694 */   // Label 4408: @223694
     /* 223694 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223736), // Rule ID 7466 //
     /* 223699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223723 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 223726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223734 */     GIR_RootConstrainSelectedInstOperands,
     /* 223735 */     // GIR_Coverage, 7466,
     /* 223735 */     GIR_EraseRootFromParent_Done,
     /* 223736 */   // Label 4409: @223736
     /* 223736 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223778), // Rule ID 7468 //
     /* 223741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 223768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223776 */     GIR_RootConstrainSelectedInstOperands,
     /* 223777 */     // GIR_Coverage, 7468,
     /* 223777 */     GIR_EraseRootFromParent_Done,
     /* 223778 */   // Label 4410: @223778
     /* 223778 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223820), // Rule ID 7470 //
     /* 223783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223807 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 223810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223818 */     GIR_RootConstrainSelectedInstOperands,
     /* 223819 */     // GIR_Coverage, 7470,
     /* 223819 */     GIR_EraseRootFromParent_Done,
     /* 223820 */   // Label 4411: @223820
     /* 223820 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223862), // Rule ID 7472 //
     /* 223825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 223852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223860 */     GIR_RootConstrainSelectedInstOperands,
     /* 223861 */     // GIR_Coverage, 7472,
     /* 223861 */     GIR_EraseRootFromParent_Done,
     /* 223862 */   // Label 4412: @223862
     /* 223862 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223904), // Rule ID 7490 //
     /* 223867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 223894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223902 */     GIR_RootConstrainSelectedInstOperands,
     /* 223903 */     // GIR_Coverage, 7490,
     /* 223903 */     GIR_EraseRootFromParent_Done,
     /* 223904 */   // Label 4413: @223904
     /* 223904 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223946), // Rule ID 7491 //
     /* 223909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 223936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223944 */     GIR_RootConstrainSelectedInstOperands,
     /* 223945 */     // GIR_Coverage, 7491,
     /* 223945 */     GIR_EraseRootFromParent_Done,
     /* 223946 */   // Label 4414: @223946
     /* 223946 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223988), // Rule ID 7492 //
     /* 223951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 223978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223986 */     GIR_RootConstrainSelectedInstOperands,
     /* 223987 */     // GIR_Coverage, 7492,
     /* 223987 */     GIR_EraseRootFromParent_Done,
     /* 223988 */   // Label 4415: @223988
     /* 223988 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(224030), // Rule ID 7493 //
     /* 223993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 224001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224028 */     GIR_RootConstrainSelectedInstOperands,
     /* 224029 */     // GIR_Coverage, 7493,
     /* 224029 */     GIR_EraseRootFromParent_Done,
     /* 224030 */   // Label 4416: @224030
     /* 224030 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(224072), // Rule ID 7606 //
     /* 224035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 224043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 224062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224070 */     GIR_RootConstrainSelectedInstOperands,
     /* 224071 */     // GIR_Coverage, 7606,
     /* 224071 */     GIR_EraseRootFromParent_Done,
     /* 224072 */   // Label 4417: @224072
     /* 224072 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(224114), // Rule ID 7607 //
     /* 224077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 224085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 224104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224112 */     GIR_RootConstrainSelectedInstOperands,
     /* 224113 */     // GIR_Coverage, 7607,
     /* 224113 */     GIR_EraseRootFromParent_Done,
     /* 224114 */   // Label 4418: @224114
     /* 224114 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(224156), // Rule ID 7608 //
     /* 224119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 224127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 224146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224154 */     GIR_RootConstrainSelectedInstOperands,
     /* 224155 */     // GIR_Coverage, 7608,
     /* 224155 */     GIR_EraseRootFromParent_Done,
     /* 224156 */   // Label 4419: @224156
     /* 224156 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(224198), // Rule ID 7609 //
     /* 224161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 224169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 224188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224196 */     GIR_RootConstrainSelectedInstOperands,
     /* 224197 */     // GIR_Coverage, 7609,
     /* 224197 */     GIR_EraseRootFromParent_Done,
     /* 224198 */   // Label 4420: @224198
     /* 224198 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(224240), // Rule ID 7610 //
     /* 224203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 224211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 224230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224238 */     GIR_RootConstrainSelectedInstOperands,
     /* 224239 */     // GIR_Coverage, 7610,
     /* 224239 */     GIR_EraseRootFromParent_Done,
     /* 224240 */   // Label 4421: @224240
     /* 224240 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(224282), // Rule ID 7611 //
     /* 224245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 224253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 224272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224280 */     GIR_RootConstrainSelectedInstOperands,
     /* 224281 */     // GIR_Coverage, 7611,
     /* 224281 */     GIR_EraseRootFromParent_Done,
     /* 224282 */   // Label 4422: @224282
     /* 224282 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(224324), // Rule ID 7612 //
     /* 224287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 224295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 224314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224322 */     GIR_RootConstrainSelectedInstOperands,
     /* 224323 */     // GIR_Coverage, 7612,
     /* 224323 */     GIR_EraseRootFromParent_Done,
     /* 224324 */   // Label 4423: @224324
     /* 224324 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(224366), // Rule ID 7613 //
     /* 224329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 224337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 224356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224364 */     GIR_RootConstrainSelectedInstOperands,
     /* 224365 */     // GIR_Coverage, 7613,
     /* 224365 */     GIR_EraseRootFromParent_Done,
     /* 224366 */   // Label 4424: @224366
     /* 224366 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(224408), // Rule ID 7622 //
     /* 224371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 224379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 224398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224406 */     GIR_RootConstrainSelectedInstOperands,
     /* 224407 */     // GIR_Coverage, 7622,
     /* 224407 */     GIR_EraseRootFromParent_Done,
     /* 224408 */   // Label 4425: @224408
     /* 224408 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(224450), // Rule ID 7623 //
     /* 224413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 224421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 224440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224448 */     GIR_RootConstrainSelectedInstOperands,
     /* 224449 */     // GIR_Coverage, 7623,
     /* 224449 */     GIR_EraseRootFromParent_Done,
     /* 224450 */   // Label 4426: @224450
     /* 224450 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(224492), // Rule ID 7624 //
     /* 224455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 224463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224490 */     GIR_RootConstrainSelectedInstOperands,
     /* 224491 */     // GIR_Coverage, 7624,
     /* 224491 */     GIR_EraseRootFromParent_Done,
     /* 224492 */   // Label 4427: @224492
     /* 224492 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224534), // Rule ID 7625 //
     /* 224497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 224505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 224524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224532 */     GIR_RootConstrainSelectedInstOperands,
     /* 224533 */     // GIR_Coverage, 7625,
     /* 224533 */     GIR_EraseRootFromParent_Done,
     /* 224534 */   // Label 4428: @224534
     /* 224534 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224576), // Rule ID 7626 //
     /* 224539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 224547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 224566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224574 */     GIR_RootConstrainSelectedInstOperands,
     /* 224575 */     // GIR_Coverage, 7626,
     /* 224575 */     GIR_EraseRootFromParent_Done,
     /* 224576 */   // Label 4429: @224576
     /* 224576 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224618), // Rule ID 7627 //
     /* 224581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 224589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 224608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224616 */     GIR_RootConstrainSelectedInstOperands,
     /* 224617 */     // GIR_Coverage, 7627,
     /* 224617 */     GIR_EraseRootFromParent_Done,
     /* 224618 */   // Label 4430: @224618
     /* 224618 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224660), // Rule ID 7716 //
     /* 224623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 224647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 224650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224658 */     GIR_RootConstrainSelectedInstOperands,
     /* 224659 */     // GIR_Coverage, 7716,
     /* 224659 */     GIR_EraseRootFromParent_Done,
     /* 224660 */   // Label 4431: @224660
     /* 224660 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224702), // Rule ID 7717 //
     /* 224665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224689 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224700 */     GIR_RootConstrainSelectedInstOperands,
     /* 224701 */     // GIR_Coverage, 7717,
     /* 224701 */     GIR_EraseRootFromParent_Done,
     /* 224702 */   // Label 4432: @224702
     /* 224702 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224744), // Rule ID 7718 //
     /* 224707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224731 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 224734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224742 */     GIR_RootConstrainSelectedInstOperands,
     /* 224743 */     // GIR_Coverage, 7718,
     /* 224743 */     GIR_EraseRootFromParent_Done,
     /* 224744 */   // Label 4433: @224744
     /* 224744 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224786), // Rule ID 7719 //
     /* 224749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 224776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224784 */     GIR_RootConstrainSelectedInstOperands,
     /* 224785 */     // GIR_Coverage, 7719,
     /* 224785 */     GIR_EraseRootFromParent_Done,
     /* 224786 */   // Label 4434: @224786
     /* 224786 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224828), // Rule ID 7728 //
     /* 224791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224815 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 224815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 224818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224826 */     GIR_RootConstrainSelectedInstOperands,
     /* 224827 */     // GIR_Coverage, 7728,
     /* 224827 */     GIR_EraseRootFromParent_Done,
     /* 224828 */   // Label 4435: @224828
     /* 224828 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224870), // Rule ID 7729 //
     /* 224833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 224860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224868 */     GIR_RootConstrainSelectedInstOperands,
     /* 224869 */     // GIR_Coverage, 7729,
     /* 224869 */     GIR_EraseRootFromParent_Done,
     /* 224870 */   // Label 4436: @224870
     /* 224870 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224912), // Rule ID 7730 //
     /* 224875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 224902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224910 */     GIR_RootConstrainSelectedInstOperands,
     /* 224911 */     // GIR_Coverage, 7730,
     /* 224911 */     GIR_EraseRootFromParent_Done,
     /* 224912 */   // Label 4437: @224912
     /* 224912 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224954), // Rule ID 7731 //
     /* 224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 224944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224952 */     GIR_RootConstrainSelectedInstOperands,
     /* 224953 */     // GIR_Coverage, 7731,
     /* 224953 */     GIR_EraseRootFromParent_Done,
     /* 224954 */   // Label 4438: @224954
     /* 224954 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224996), // Rule ID 7810 //
     /* 224959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 224986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224994 */     GIR_RootConstrainSelectedInstOperands,
     /* 224995 */     // GIR_Coverage, 7810,
     /* 224995 */     GIR_EraseRootFromParent_Done,
     /* 224996 */   // Label 4439: @224996
     /* 224996 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(225038), // Rule ID 7811 //
     /* 225001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 225009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 225028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225036 */     GIR_RootConstrainSelectedInstOperands,
     /* 225037 */     // GIR_Coverage, 7811,
     /* 225037 */     GIR_EraseRootFromParent_Done,
     /* 225038 */   // Label 4440: @225038
     /* 225038 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(225080), // Rule ID 7812 //
     /* 225043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 225051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 225070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225078 */     GIR_RootConstrainSelectedInstOperands,
     /* 225079 */     // GIR_Coverage, 7812,
     /* 225079 */     GIR_EraseRootFromParent_Done,
     /* 225080 */   // Label 4441: @225080
     /* 225080 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(225122), // Rule ID 7813 //
     /* 225085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 225093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 225112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225120 */     GIR_RootConstrainSelectedInstOperands,
     /* 225121 */     // GIR_Coverage, 7813,
     /* 225121 */     GIR_EraseRootFromParent_Done,
     /* 225122 */   // Label 4442: @225122
     /* 225122 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(225164), // Rule ID 7814 //
     /* 225127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 225135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225151 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 225154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225162 */     GIR_RootConstrainSelectedInstOperands,
     /* 225163 */     // GIR_Coverage, 7814,
     /* 225163 */     GIR_EraseRootFromParent_Done,
     /* 225164 */   // Label 4443: @225164
     /* 225164 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(225206), // Rule ID 7815 //
     /* 225169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 225177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 225196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225204 */     GIR_RootConstrainSelectedInstOperands,
     /* 225205 */     // GIR_Coverage, 7815,
     /* 225205 */     GIR_EraseRootFromParent_Done,
     /* 225206 */   // Label 4444: @225206
     /* 225206 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(225248), // Rule ID 7816 //
     /* 225211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 225219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225235 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 225238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225246 */     GIR_RootConstrainSelectedInstOperands,
     /* 225247 */     // GIR_Coverage, 7816,
     /* 225247 */     GIR_EraseRootFromParent_Done,
     /* 225248 */   // Label 4445: @225248
     /* 225248 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(225290), // Rule ID 7817 //
     /* 225253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 225261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 225280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225288 */     GIR_RootConstrainSelectedInstOperands,
     /* 225289 */     // GIR_Coverage, 7817,
     /* 225289 */     GIR_EraseRootFromParent_Done,
     /* 225290 */   // Label 4446: @225290
     /* 225290 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(225332), // Rule ID 8013 //
     /* 225295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 225303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225319 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 225322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225330 */     GIR_RootConstrainSelectedInstOperands,
     /* 225331 */     // GIR_Coverage, 8013,
     /* 225331 */     GIR_EraseRootFromParent_Done,
     /* 225332 */   // Label 4447: @225332
     /* 225332 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(225374), // Rule ID 8015 //
     /* 225337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 225345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 225364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225372 */     GIR_RootConstrainSelectedInstOperands,
     /* 225373 */     // GIR_Coverage, 8015,
     /* 225373 */     GIR_EraseRootFromParent_Done,
     /* 225374 */   // Label 4448: @225374
     /* 225374 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225416), // Rule ID 8017 //
     /* 225379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 225387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225403 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 225406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225414 */     GIR_RootConstrainSelectedInstOperands,
     /* 225415 */     // GIR_Coverage, 8017,
     /* 225415 */     GIR_EraseRootFromParent_Done,
     /* 225416 */   // Label 4449: @225416
     /* 225416 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225458), // Rule ID 8025 //
     /* 225421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225445 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 225448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225456 */     GIR_RootConstrainSelectedInstOperands,
     /* 225457 */     // GIR_Coverage, 8025,
     /* 225457 */     GIR_EraseRootFromParent_Done,
     /* 225458 */   // Label 4450: @225458
     /* 225458 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225500), // Rule ID 8027 //
     /* 225463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225487 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 225490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225498 */     GIR_RootConstrainSelectedInstOperands,
     /* 225499 */     // GIR_Coverage, 8027,
     /* 225499 */     GIR_EraseRootFromParent_Done,
     /* 225500 */   // Label 4451: @225500
     /* 225500 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225542), // Rule ID 8029 //
     /* 225505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 225532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225540 */     GIR_RootConstrainSelectedInstOperands,
     /* 225541 */     // GIR_Coverage, 8029,
     /* 225541 */     GIR_EraseRootFromParent_Done,
     /* 225542 */   // Label 4452: @225542
     /* 225542 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225584), // Rule ID 8067 //
     /* 225547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225571 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 225574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225582 */     GIR_RootConstrainSelectedInstOperands,
     /* 225583 */     // GIR_Coverage, 8067,
     /* 225583 */     GIR_EraseRootFromParent_Done,
     /* 225584 */   // Label 4453: @225584
     /* 225584 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225626), // Rule ID 8068 //
     /* 225589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225624 */     GIR_RootConstrainSelectedInstOperands,
     /* 225625 */     // GIR_Coverage, 8068,
     /* 225625 */     GIR_EraseRootFromParent_Done,
     /* 225626 */   // Label 4454: @225626
     /* 225626 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225668), // Rule ID 8069 //
     /* 225631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225655 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 225658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225666 */     GIR_RootConstrainSelectedInstOperands,
     /* 225667 */     // GIR_Coverage, 8069,
     /* 225667 */     GIR_EraseRootFromParent_Done,
     /* 225668 */   // Label 4455: @225668
     /* 225668 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225710), // Rule ID 8070 //
     /* 225673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225697 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 225700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225708 */     GIR_RootConstrainSelectedInstOperands,
     /* 225709 */     // GIR_Coverage, 8070,
     /* 225709 */     GIR_EraseRootFromParent_Done,
     /* 225710 */   // Label 4456: @225710
     /* 225710 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225752), // Rule ID 8071 //
     /* 225715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 225742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225750 */     GIR_RootConstrainSelectedInstOperands,
     /* 225751 */     // GIR_Coverage, 8071,
     /* 225751 */     GIR_EraseRootFromParent_Done,
     /* 225752 */   // Label 4457: @225752
     /* 225752 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225794), // Rule ID 8072 //
     /* 225757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 225784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225792 */     GIR_RootConstrainSelectedInstOperands,
     /* 225793 */     // GIR_Coverage, 8072,
     /* 225793 */     GIR_EraseRootFromParent_Done,
     /* 225794 */   // Label 4458: @225794
     /* 225794 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225836), // Rule ID 8073 //
     /* 225799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225823 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 225826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225834 */     GIR_RootConstrainSelectedInstOperands,
     /* 225835 */     // GIR_Coverage, 8073,
     /* 225835 */     GIR_EraseRootFromParent_Done,
     /* 225836 */   // Label 4459: @225836
     /* 225836 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225878), // Rule ID 8074 //
     /* 225841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225865 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225876 */     GIR_RootConstrainSelectedInstOperands,
     /* 225877 */     // GIR_Coverage, 8074,
     /* 225877 */     GIR_EraseRootFromParent_Done,
     /* 225878 */   // Label 4460: @225878
     /* 225878 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225920), // Rule ID 8075 //
     /* 225883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225907 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 225910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225918 */     GIR_RootConstrainSelectedInstOperands,
     /* 225919 */     // GIR_Coverage, 8075,
     /* 225919 */     GIR_EraseRootFromParent_Done,
     /* 225920 */   // Label 4461: @225920
     /* 225920 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225962), // Rule ID 8076 //
     /* 225925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225949 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 225952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225960 */     GIR_RootConstrainSelectedInstOperands,
     /* 225961 */     // GIR_Coverage, 8076,
     /* 225961 */     GIR_EraseRootFromParent_Done,
     /* 225962 */   // Label 4462: @225962
     /* 225962 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(226004), // Rule ID 8077 //
     /* 225967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225991 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 225994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226002 */     GIR_RootConstrainSelectedInstOperands,
     /* 226003 */     // GIR_Coverage, 8077,
     /* 226003 */     GIR_EraseRootFromParent_Done,
     /* 226004 */   // Label 4463: @226004
     /* 226004 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(226046), // Rule ID 8078 //
     /* 226009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 226017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226033 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 226036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226044 */     GIR_RootConstrainSelectedInstOperands,
     /* 226045 */     // GIR_Coverage, 8078,
     /* 226045 */     GIR_EraseRootFromParent_Done,
     /* 226046 */   // Label 4464: @226046
     /* 226046 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(226088), // Rule ID 8115 //
     /* 226051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226075 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 226078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226086 */     GIR_RootConstrainSelectedInstOperands,
     /* 226087 */     // GIR_Coverage, 8115,
     /* 226087 */     GIR_EraseRootFromParent_Done,
     /* 226088 */   // Label 4465: @226088
     /* 226088 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(226130), // Rule ID 8117 //
     /* 226093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 226104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 226110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 226113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226117 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 226117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 226120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226128 */     GIR_RootConstrainSelectedInstOperands,
     /* 226129 */     // GIR_Coverage, 8117,
     /* 226129 */     GIR_EraseRootFromParent_Done,
     /* 226130 */   // Label 4466: @226130
     /* 226130 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(226172), // Rule ID 8119 //
     /* 226135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 226146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 226152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 226155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226159 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 226159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 226162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226170 */     GIR_RootConstrainSelectedInstOperands,
     /* 226171 */     // GIR_Coverage, 8119,
     /* 226171 */     GIR_EraseRootFromParent_Done,
     /* 226172 */   // Label 4467: @226172
     /* 226172 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(226214), // Rule ID 8121 //
     /* 226177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226201 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 226204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226212 */     GIR_RootConstrainSelectedInstOperands,
     /* 226213 */     // GIR_Coverage, 8121,
     /* 226213 */     GIR_EraseRootFromParent_Done,
     /* 226214 */   // Label 4468: @226214
     /* 226214 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(226256), // Rule ID 8123 //
     /* 226219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 226230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 226236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 226239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226243 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 226243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 226246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226254 */     GIR_RootConstrainSelectedInstOperands,
     /* 226255 */     // GIR_Coverage, 8123,
     /* 226255 */     GIR_EraseRootFromParent_Done,
     /* 226256 */   // Label 4469: @226256
     /* 226256 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(226298), // Rule ID 8125 //
     /* 226261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 226269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226285 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 226288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226296 */     GIR_RootConstrainSelectedInstOperands,
     /* 226297 */     // GIR_Coverage, 8125,
     /* 226297 */     GIR_EraseRootFromParent_Done,
     /* 226298 */   // Label 4470: @226298
     /* 226298 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(226340), // Rule ID 8127 //
     /* 226303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226327 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 226330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226338 */     GIR_RootConstrainSelectedInstOperands,
     /* 226339 */     // GIR_Coverage, 8127,
     /* 226339 */     GIR_EraseRootFromParent_Done,
     /* 226340 */   // Label 4471: @226340
     /* 226340 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(226382), // Rule ID 8128 //
     /* 226345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 226356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 226362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 226365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226369 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 226369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 226372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226380 */     GIR_RootConstrainSelectedInstOperands,
     /* 226381 */     // GIR_Coverage, 8128,
     /* 226381 */     GIR_EraseRootFromParent_Done,
     /* 226382 */   // Label 4472: @226382
     /* 226382 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(226424), // Rule ID 8129 //
     /* 226387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 226398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 226404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 226407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226411 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 226411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 226414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226422 */     GIR_RootConstrainSelectedInstOperands,
     /* 226423 */     // GIR_Coverage, 8129,
     /* 226423 */     GIR_EraseRootFromParent_Done,
     /* 226424 */   // Label 4473: @226424
     /* 226424 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(226466), // Rule ID 8130 //
     /* 226429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226453 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 226456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226464 */     GIR_RootConstrainSelectedInstOperands,
     /* 226465 */     // GIR_Coverage, 8130,
     /* 226465 */     GIR_EraseRootFromParent_Done,
     /* 226466 */   // Label 4474: @226466
     /* 226466 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(226508), // Rule ID 8131 //
     /* 226471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 226482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 226488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 226491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 226495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 226498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226506 */     GIR_RootConstrainSelectedInstOperands,
     /* 226507 */     // GIR_Coverage, 8131,
     /* 226507 */     GIR_EraseRootFromParent_Done,
     /* 226508 */   // Label 4475: @226508
     /* 226508 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(226550), // Rule ID 8132 //
     /* 226513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226537 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 226540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226548 */     GIR_RootConstrainSelectedInstOperands,
     /* 226549 */     // GIR_Coverage, 8132,
     /* 226549 */     GIR_EraseRootFromParent_Done,
     /* 226550 */   // Label 4476: @226550
     /* 226550 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226592), // Rule ID 8385 //
     /* 226555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 226563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 226582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226590 */     GIR_RootConstrainSelectedInstOperands,
     /* 226591 */     // GIR_Coverage, 8385,
     /* 226591 */     GIR_EraseRootFromParent_Done,
     /* 226592 */   // Label 4477: @226592
     /* 226592 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226634), // Rule ID 8387 //
     /* 226597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 226605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226621 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226632 */     GIR_RootConstrainSelectedInstOperands,
     /* 226633 */     // GIR_Coverage, 8387,
     /* 226633 */     GIR_EraseRootFromParent_Done,
     /* 226634 */   // Label 4478: @226634
     /* 226634 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226676), // Rule ID 8388 //
     /* 226639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226663 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226674 */     GIR_RootConstrainSelectedInstOperands,
     /* 226675 */     // GIR_Coverage, 8388,
     /* 226675 */     GIR_EraseRootFromParent_Done,
     /* 226676 */   // Label 4479: @226676
     /* 226676 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226718), // Rule ID 8389 //
     /* 226681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226705 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226716 */     GIR_RootConstrainSelectedInstOperands,
     /* 226717 */     // GIR_Coverage, 8389,
     /* 226717 */     GIR_EraseRootFromParent_Done,
     /* 226718 */   // Label 4480: @226718
     /* 226718 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226760), // Rule ID 8390 //
     /* 226723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226747 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226758 */     GIR_RootConstrainSelectedInstOperands,
     /* 226759 */     // GIR_Coverage, 8390,
     /* 226759 */     GIR_EraseRootFromParent_Done,
     /* 226760 */   // Label 4481: @226760
     /* 226760 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226802), // Rule ID 8391 //
     /* 226765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226789 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226800 */     GIR_RootConstrainSelectedInstOperands,
     /* 226801 */     // GIR_Coverage, 8391,
     /* 226801 */     GIR_EraseRootFromParent_Done,
     /* 226802 */   // Label 4482: @226802
     /* 226802 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226844), // Rule ID 8392 //
     /* 226807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226831 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1292:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226842 */     GIR_RootConstrainSelectedInstOperands,
     /* 226843 */     // GIR_Coverage, 8392,
     /* 226843 */     GIR_EraseRootFromParent_Done,
     /* 226844 */   // Label 4483: @226844
     /* 226844 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226886), // Rule ID 8413 //
     /* 226849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226873 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1350:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226884 */     GIR_RootConstrainSelectedInstOperands,
     /* 226885 */     // GIR_Coverage, 8413,
     /* 226885 */     GIR_EraseRootFromParent_Done,
     /* 226886 */   // Label 4484: @226886
     /* 226886 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226928), // Rule ID 8414 //
     /* 226891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226926 */     GIR_RootConstrainSelectedInstOperands,
     /* 226927 */     // GIR_Coverage, 8414,
     /* 226927 */     GIR_EraseRootFromParent_Done,
     /* 226928 */   // Label 4485: @226928
     /* 226928 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226970), // Rule ID 8415 //
     /* 226933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226957 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226968 */     GIR_RootConstrainSelectedInstOperands,
     /* 226969 */     // GIR_Coverage, 8415,
     /* 226969 */     GIR_EraseRootFromParent_Done,
     /* 226970 */   // Label 4486: @226970
     /* 226970 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(227012), // Rule ID 8416 //
     /* 226975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226999 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 227002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227010 */     GIR_RootConstrainSelectedInstOperands,
     /* 227011 */     // GIR_Coverage, 8416,
     /* 227011 */     GIR_EraseRootFromParent_Done,
     /* 227012 */   // Label 4487: @227012
     /* 227012 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(227054), // Rule ID 8417 //
     /* 227017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 227025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227041 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1350:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 227044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227052 */     GIR_RootConstrainSelectedInstOperands,
     /* 227053 */     // GIR_Coverage, 8417,
     /* 227053 */     GIR_EraseRootFromParent_Done,
     /* 227054 */   // Label 4488: @227054
     /* 227054 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(227096), // Rule ID 8433 //
     /* 227059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 227067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 227086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227094 */     GIR_RootConstrainSelectedInstOperands,
     /* 227095 */     // GIR_Coverage, 8433,
     /* 227095 */     GIR_EraseRootFromParent_Done,
     /* 227096 */   // Label 4489: @227096
     /* 227096 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(227138), // Rule ID 8434 //
     /* 227101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 227109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 227128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227136 */     GIR_RootConstrainSelectedInstOperands,
     /* 227137 */     // GIR_Coverage, 8434,
     /* 227137 */     GIR_EraseRootFromParent_Done,
     /* 227138 */   // Label 4490: @227138
     /* 227138 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(227180), // Rule ID 8435 //
     /* 227143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 227151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 227170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227178 */     GIR_RootConstrainSelectedInstOperands,
     /* 227179 */     // GIR_Coverage, 8435,
     /* 227179 */     GIR_EraseRootFromParent_Done,
     /* 227180 */   // Label 4491: @227180
     /* 227180 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(227222), // Rule ID 8436 //
     /* 227185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 227193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227209 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 227212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227220 */     GIR_RootConstrainSelectedInstOperands,
     /* 227221 */     // GIR_Coverage, 8436,
     /* 227221 */     GIR_EraseRootFromParent_Done,
     /* 227222 */   // Label 4492: @227222
     /* 227222 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(227264), // Rule ID 8437 //
     /* 227227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 227235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227251 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 227254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227262 */     GIR_RootConstrainSelectedInstOperands,
     /* 227263 */     // GIR_Coverage, 8437,
     /* 227263 */     GIR_EraseRootFromParent_Done,
     /* 227264 */   // Label 4493: @227264
     /* 227264 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(227306), // Rule ID 8438 //
     /* 227269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227304 */     GIR_RootConstrainSelectedInstOperands,
     /* 227305 */     // GIR_Coverage, 8438,
     /* 227305 */     GIR_EraseRootFromParent_Done,
     /* 227306 */   // Label 4494: @227306
     /* 227306 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(227348), // Rule ID 8439 //
     /* 227311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227346 */     GIR_RootConstrainSelectedInstOperands,
     /* 227347 */     // GIR_Coverage, 8439,
     /* 227347 */     GIR_EraseRootFromParent_Done,
     /* 227348 */   // Label 4495: @227348
     /* 227348 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227390), // Rule ID 8440 //
     /* 227353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227377 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227388 */     GIR_RootConstrainSelectedInstOperands,
     /* 227389 */     // GIR_Coverage, 8440,
     /* 227389 */     GIR_EraseRootFromParent_Done,
     /* 227390 */   // Label 4496: @227390
     /* 227390 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227432), // Rule ID 8441 //
     /* 227395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227430 */     GIR_RootConstrainSelectedInstOperands,
     /* 227431 */     // GIR_Coverage, 8441,
     /* 227431 */     GIR_EraseRootFromParent_Done,
     /* 227432 */   // Label 4497: @227432
     /* 227432 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227474), // Rule ID 8442 //
     /* 227437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227461 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1617:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227472 */     GIR_RootConstrainSelectedInstOperands,
     /* 227473 */     // GIR_Coverage, 8442,
     /* 227473 */     GIR_EraseRootFromParent_Done,
     /* 227474 */   // Label 4498: @227474
     /* 227474 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227516), // Rule ID 8443 //
     /* 227479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227514 */     GIR_RootConstrainSelectedInstOperands,
     /* 227515 */     // GIR_Coverage, 8443,
     /* 227515 */     GIR_EraseRootFromParent_Done,
     /* 227516 */   // Label 4499: @227516
     /* 227516 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227558), // Rule ID 8444 //
     /* 227521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227545 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227556 */     GIR_RootConstrainSelectedInstOperands,
     /* 227557 */     // GIR_Coverage, 8444,
     /* 227557 */     GIR_EraseRootFromParent_Done,
     /* 227558 */   // Label 4500: @227558
     /* 227558 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227600), // Rule ID 8445 //
     /* 227563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227587 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1615:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227598 */     GIR_RootConstrainSelectedInstOperands,
     /* 227599 */     // GIR_Coverage, 8445,
     /* 227599 */     GIR_EraseRootFromParent_Done,
     /* 227600 */   // Label 4501: @227600
     /* 227600 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227642), // Rule ID 8446 //
     /* 227605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227629 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1615:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227640 */     GIR_RootConstrainSelectedInstOperands,
     /* 227641 */     // GIR_Coverage, 8446,
     /* 227641 */     GIR_EraseRootFromParent_Done,
     /* 227642 */   // Label 4502: @227642
     /* 227642 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227684), // Rule ID 8447 //
     /* 227647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227671 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1615:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227682 */     GIR_RootConstrainSelectedInstOperands,
     /* 227683 */     // GIR_Coverage, 8447,
     /* 227683 */     GIR_EraseRootFromParent_Done,
     /* 227684 */   // Label 4503: @227684
     /* 227684 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227726), // Rule ID 8448 //
     /* 227689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227724 */     GIR_RootConstrainSelectedInstOperands,
     /* 227725 */     // GIR_Coverage, 8448,
     /* 227725 */     GIR_EraseRootFromParent_Done,
     /* 227726 */   // Label 4504: @227726
     /* 227726 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227768), // Rule ID 8449 //
     /* 227731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227766 */     GIR_RootConstrainSelectedInstOperands,
     /* 227767 */     // GIR_Coverage, 8449,
     /* 227767 */     GIR_EraseRootFromParent_Done,
     /* 227768 */   // Label 4505: @227768
     /* 227768 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227810), // Rule ID 8450 //
     /* 227773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227797 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227808 */     GIR_RootConstrainSelectedInstOperands,
     /* 227809 */     // GIR_Coverage, 8450,
     /* 227809 */     GIR_EraseRootFromParent_Done,
     /* 227810 */   // Label 4506: @227810
     /* 227810 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227852), // Rule ID 8451 //
     /* 227815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227850 */     GIR_RootConstrainSelectedInstOperands,
     /* 227851 */     // GIR_Coverage, 8451,
     /* 227851 */     GIR_EraseRootFromParent_Done,
     /* 227852 */   // Label 4507: @227852
     /* 227852 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227894), // Rule ID 8452 //
     /* 227857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227881 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1611:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227892 */     GIR_RootConstrainSelectedInstOperands,
     /* 227893 */     // GIR_Coverage, 8452,
     /* 227893 */     GIR_EraseRootFromParent_Done,
     /* 227894 */   // Label 4508: @227894
     /* 227894 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227936), // Rule ID 8460 //
     /* 227899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227923 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 227926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227934 */     GIR_RootConstrainSelectedInstOperands,
     /* 227935 */     // GIR_Coverage, 8460,
     /* 227935 */     GIR_EraseRootFromParent_Done,
     /* 227936 */   // Label 4509: @227936
     /* 227936 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227978), // Rule ID 8461 //
     /* 227941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227976 */     GIR_RootConstrainSelectedInstOperands,
     /* 227977 */     // GIR_Coverage, 8461,
     /* 227977 */     GIR_EraseRootFromParent_Done,
     /* 227978 */   // Label 4510: @227978
     /* 227978 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(228020), // Rule ID 8462 //
     /* 227983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 228010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228018 */     GIR_RootConstrainSelectedInstOperands,
     /* 228019 */     // GIR_Coverage, 8462,
     /* 228019 */     GIR_EraseRootFromParent_Done,
     /* 228020 */   // Label 4511: @228020
     /* 228020 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(228062), // Rule ID 8463 //
     /* 228025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 228033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 228052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228060 */     GIR_RootConstrainSelectedInstOperands,
     /* 228061 */     // GIR_Coverage, 8463,
     /* 228061 */     GIR_EraseRootFromParent_Done,
     /* 228062 */   // Label 4512: @228062
     /* 228062 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(228104), // Rule ID 8464 //
     /* 228067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 228075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 228094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228102 */     GIR_RootConstrainSelectedInstOperands,
     /* 228103 */     // GIR_Coverage, 8464,
     /* 228103 */     GIR_EraseRootFromParent_Done,
     /* 228104 */   // Label 4513: @228104
     /* 228104 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(228146), // Rule ID 8465 //
     /* 228109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 228117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 228136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228144 */     GIR_RootConstrainSelectedInstOperands,
     /* 228145 */     // GIR_Coverage, 8465,
     /* 228145 */     GIR_EraseRootFromParent_Done,
     /* 228146 */   // Label 4514: @228146
     /* 228146 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(228188), // Rule ID 8466 //
     /* 228151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 228159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 228178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228186 */     GIR_RootConstrainSelectedInstOperands,
     /* 228187 */     // GIR_Coverage, 8466,
     /* 228187 */     GIR_EraseRootFromParent_Done,
     /* 228188 */   // Label 4515: @228188
     /* 228188 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(228233), // Rule ID 9162 //
     /* 228193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 228201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228217 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 228220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228231 */     GIR_RootConstrainSelectedInstOperands,
     /* 228232 */     // GIR_Coverage, 9162,
     /* 228232 */     GIR_EraseRootFromParent_Done,
     /* 228233 */   // Label 4516: @228233
     /* 228233 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(228278), // Rule ID 9163 //
     /* 228238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 228246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 228265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228276 */     GIR_RootConstrainSelectedInstOperands,
     /* 228277 */     // GIR_Coverage, 9163,
     /* 228277 */     GIR_EraseRootFromParent_Done,
     /* 228278 */   // Label 4517: @228278
     /* 228278 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(228323), // Rule ID 9164 //
     /* 228283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 228291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228307 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 228310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228321 */     GIR_RootConstrainSelectedInstOperands,
     /* 228322 */     // GIR_Coverage, 9164,
     /* 228322 */     GIR_EraseRootFromParent_Done,
     /* 228323 */   // Label 4518: @228323
     /* 228323 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(228368), // Rule ID 9165 //
     /* 228328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 228336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228352 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 228355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228366 */     GIR_RootConstrainSelectedInstOperands,
     /* 228367 */     // GIR_Coverage, 9165,
     /* 228367 */     GIR_EraseRootFromParent_Done,
     /* 228368 */   // Label 4519: @228368
     /* 228368 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228413), // Rule ID 9166 //
     /* 228373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 228381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228411 */     GIR_RootConstrainSelectedInstOperands,
     /* 228412 */     // GIR_Coverage, 9166,
     /* 228412 */     GIR_EraseRootFromParent_Done,
     /* 228413 */   // Label 4520: @228413
     /* 228413 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228458), // Rule ID 9167 //
     /* 228418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 228426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 228445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228456 */     GIR_RootConstrainSelectedInstOperands,
     /* 228457 */     // GIR_Coverage, 9167,
     /* 228457 */     GIR_EraseRootFromParent_Done,
     /* 228458 */   // Label 4521: @228458
     /* 228458 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(228503), // Rule ID 9168 //
     /* 228463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 228490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228501 */     GIR_RootConstrainSelectedInstOperands,
     /* 228502 */     // GIR_Coverage, 9168,
     /* 228502 */     GIR_EraseRootFromParent_Done,
     /* 228503 */   // Label 4522: @228503
     /* 228503 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(228548), // Rule ID 9169 //
     /* 228508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 228535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228546 */     GIR_RootConstrainSelectedInstOperands,
     /* 228547 */     // GIR_Coverage, 9169,
     /* 228547 */     GIR_EraseRootFromParent_Done,
     /* 228548 */   // Label 4523: @228548
     /* 228548 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228593), // Rule ID 9170 //
     /* 228553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 228580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228591 */     GIR_RootConstrainSelectedInstOperands,
     /* 228592 */     // GIR_Coverage, 9170,
     /* 228592 */     GIR_EraseRootFromParent_Done,
     /* 228593 */   // Label 4524: @228593
     /* 228593 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228638), // Rule ID 9171 //
     /* 228598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 228625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228636 */     GIR_RootConstrainSelectedInstOperands,
     /* 228637 */     // GIR_Coverage, 9171,
     /* 228637 */     GIR_EraseRootFromParent_Done,
     /* 228638 */   // Label 4525: @228638
     /* 228638 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228683), // Rule ID 9172 //
     /* 228643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228667 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 228670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228681 */     GIR_RootConstrainSelectedInstOperands,
     /* 228682 */     // GIR_Coverage, 9172,
     /* 228682 */     GIR_EraseRootFromParent_Done,
     /* 228683 */   // Label 4526: @228683
     /* 228683 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228728), // Rule ID 9173 //
     /* 228688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 228715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228726 */     GIR_RootConstrainSelectedInstOperands,
     /* 228727 */     // GIR_Coverage, 9173,
     /* 228727 */     GIR_EraseRootFromParent_Done,
     /* 228728 */   // Label 4527: @228728
     /* 228728 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228773), // Rule ID 9174 //
     /* 228733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228757 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1323:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 228760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228771 */     GIR_RootConstrainSelectedInstOperands,
     /* 228772 */     // GIR_Coverage, 9174,
     /* 228772 */     GIR_EraseRootFromParent_Done,
     /* 228773 */   // Label 4528: @228773
     /* 228773 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228818), // Rule ID 9175 //
     /* 228778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 228805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228816 */     GIR_RootConstrainSelectedInstOperands,
     /* 228817 */     // GIR_Coverage, 9175,
     /* 228817 */     GIR_EraseRootFromParent_Done,
     /* 228818 */   // Label 4529: @228818
     /* 228818 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228863), // Rule ID 9176 //
     /* 228823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228847 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 228850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228861 */     GIR_RootConstrainSelectedInstOperands,
     /* 228862 */     // GIR_Coverage, 9176,
     /* 228862 */     GIR_EraseRootFromParent_Done,
     /* 228863 */   // Label 4530: @228863
     /* 228863 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228908), // Rule ID 9177 //
     /* 228868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 228895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228906 */     GIR_RootConstrainSelectedInstOperands,
     /* 228907 */     // GIR_Coverage, 9177,
     /* 228907 */     GIR_EraseRootFromParent_Done,
     /* 228908 */   // Label 4531: @228908
     /* 228908 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228953), // Rule ID 9178 //
     /* 228913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 228940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228951 */     GIR_RootConstrainSelectedInstOperands,
     /* 228952 */     // GIR_Coverage, 9178,
     /* 228952 */     GIR_EraseRootFromParent_Done,
     /* 228953 */   // Label 4532: @228953
     /* 228953 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228998), // Rule ID 9179 //
     /* 228958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 228985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228996 */     GIR_RootConstrainSelectedInstOperands,
     /* 228997 */     // GIR_Coverage, 9179,
     /* 228997 */     GIR_EraseRootFromParent_Done,
     /* 228998 */   // Label 4533: @228998
     /* 228998 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(229043), // Rule ID 9180 //
     /* 229003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 229011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 229030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229041 */     GIR_RootConstrainSelectedInstOperands,
     /* 229042 */     // GIR_Coverage, 9180,
     /* 229042 */     GIR_EraseRootFromParent_Done,
     /* 229043 */   // Label 4534: @229043
     /* 229043 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(229088), // Rule ID 9181 //
     /* 229048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 229056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 229075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229086 */     GIR_RootConstrainSelectedInstOperands,
     /* 229087 */     // GIR_Coverage, 9181,
     /* 229087 */     GIR_EraseRootFromParent_Done,
     /* 229088 */   // Label 4535: @229088
     /* 229088 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(229133), // Rule ID 9182 //
     /* 229093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 229101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 229120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229131 */     GIR_RootConstrainSelectedInstOperands,
     /* 229132 */     // GIR_Coverage, 9182,
     /* 229132 */     GIR_EraseRootFromParent_Done,
     /* 229133 */   // Label 4536: @229133
     /* 229133 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(229178), // Rule ID 9183 //
     /* 229138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 229146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 229149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 229165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229176 */     GIR_RootConstrainSelectedInstOperands,
     /* 229177 */     // GIR_Coverage, 9183,
     /* 229177 */     GIR_EraseRootFromParent_Done,
     /* 229178 */   // Label 4537: @229178
     /* 229178 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(229223), // Rule ID 9184 //
     /* 229183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 229191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 229210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229221 */     GIR_RootConstrainSelectedInstOperands,
     /* 229222 */     // GIR_Coverage, 9184,
     /* 229222 */     GIR_EraseRootFromParent_Done,
     /* 229223 */   // Label 4538: @229223
     /* 229223 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(229268), // Rule ID 9185 //
     /* 229228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 229236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229252 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 229255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 229266 */     GIR_RootConstrainSelectedInstOperands,
     /* 229267 */     // GIR_Coverage, 9185,
     /* 229267 */     GIR_EraseRootFromParent_Done,
     /* 229268 */   // Label 4539: @229268
     /* 229268 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(229310), // Rule ID 9582 //
     /* 229273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 229281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 229284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229297 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 229300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229308 */     GIR_RootConstrainSelectedInstOperands,
     /* 229309 */     // GIR_Coverage, 9582,
     /* 229309 */     GIR_EraseRootFromParent_Done,
     /* 229310 */   // Label 4540: @229310
     /* 229310 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(229352), // Rule ID 9583 //
     /* 229315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 229323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 229326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 229342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229350 */     GIR_RootConstrainSelectedInstOperands,
     /* 229351 */     // GIR_Coverage, 9583,
     /* 229351 */     GIR_EraseRootFromParent_Done,
     /* 229352 */   // Label 4541: @229352
     /* 229352 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(229394), // Rule ID 9584 //
     /* 229357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 229365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229381 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 229384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229392 */     GIR_RootConstrainSelectedInstOperands,
     /* 229393 */     // GIR_Coverage, 9584,
     /* 229393 */     GIR_EraseRootFromParent_Done,
     /* 229394 */   // Label 4542: @229394
     /* 229394 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(229436), // Rule ID 10122 //
     /* 229399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 229426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229434 */     GIR_RootConstrainSelectedInstOperands,
     /* 229435 */     // GIR_Coverage, 10122,
     /* 229435 */     GIR_EraseRootFromParent_Done,
     /* 229436 */   // Label 4543: @229436
     /* 229436 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(229478), // Rule ID 10123 //
     /* 229441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 229468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229476 */     GIR_RootConstrainSelectedInstOperands,
     /* 229477 */     // GIR_Coverage, 10123,
     /* 229477 */     GIR_EraseRootFromParent_Done,
     /* 229478 */   // Label 4544: @229478
     /* 229478 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(229520), // Rule ID 10124 //
     /* 229483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 229510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229518 */     GIR_RootConstrainSelectedInstOperands,
     /* 229519 */     // GIR_Coverage, 10124,
     /* 229519 */     GIR_EraseRootFromParent_Done,
     /* 229520 */   // Label 4545: @229520
     /* 229520 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229562), // Rule ID 10125 //
     /* 229525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 229552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229560 */     GIR_RootConstrainSelectedInstOperands,
     /* 229561 */     // GIR_Coverage, 10125,
     /* 229561 */     GIR_EraseRootFromParent_Done,
     /* 229562 */   // Label 4546: @229562
     /* 229562 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229604), // Rule ID 10126 //
     /* 229567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 229594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229602 */     GIR_RootConstrainSelectedInstOperands,
     /* 229603 */     // GIR_Coverage, 10126,
     /* 229603 */     GIR_EraseRootFromParent_Done,
     /* 229604 */   // Label 4547: @229604
     /* 229604 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229646), // Rule ID 10127 //
     /* 229609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229633 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 229636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229644 */     GIR_RootConstrainSelectedInstOperands,
     /* 229645 */     // GIR_Coverage, 10127,
     /* 229645 */     GIR_EraseRootFromParent_Done,
     /* 229646 */   // Label 4548: @229646
     /* 229646 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229688), // Rule ID 10128 //
     /* 229651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229675 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 229678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229686 */     GIR_RootConstrainSelectedInstOperands,
     /* 229687 */     // GIR_Coverage, 10128,
     /* 229687 */     GIR_EraseRootFromParent_Done,
     /* 229688 */   // Label 4549: @229688
     /* 229688 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229730), // Rule ID 10129 //
     /* 229693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 229720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229728 */     GIR_RootConstrainSelectedInstOperands,
     /* 229729 */     // GIR_Coverage, 10129,
     /* 229729 */     GIR_EraseRootFromParent_Done,
     /* 229730 */   // Label 4550: @229730
     /* 229730 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229772), // Rule ID 10142 //
     /* 229735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 229762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229770 */     GIR_RootConstrainSelectedInstOperands,
     /* 229771 */     // GIR_Coverage, 10142,
     /* 229771 */     GIR_EraseRootFromParent_Done,
     /* 229772 */   // Label 4551: @229772
     /* 229772 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229814), // Rule ID 10143 //
     /* 229777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 229804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229812 */     GIR_RootConstrainSelectedInstOperands,
     /* 229813 */     // GIR_Coverage, 10143,
     /* 229813 */     GIR_EraseRootFromParent_Done,
     /* 229814 */   // Label 4552: @229814
     /* 229814 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229856), // Rule ID 10144 //
     /* 229819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229843 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 229846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229854 */     GIR_RootConstrainSelectedInstOperands,
     /* 229855 */     // GIR_Coverage, 10144,
     /* 229855 */     GIR_EraseRootFromParent_Done,
     /* 229856 */   // Label 4553: @229856
     /* 229856 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229898), // Rule ID 10145 //
     /* 229861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229885 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 229888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229896 */     GIR_RootConstrainSelectedInstOperands,
     /* 229897 */     // GIR_Coverage, 10145,
     /* 229897 */     GIR_EraseRootFromParent_Done,
     /* 229898 */   // Label 4554: @229898
     /* 229898 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229940), // Rule ID 10146 //
     /* 229903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229927 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 229930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229938 */     GIR_RootConstrainSelectedInstOperands,
     /* 229939 */     // GIR_Coverage, 10146,
     /* 229939 */     GIR_EraseRootFromParent_Done,
     /* 229940 */   // Label 4555: @229940
     /* 229940 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229982), // Rule ID 10147 //
     /* 229945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 229972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229980 */     GIR_RootConstrainSelectedInstOperands,
     /* 229981 */     // GIR_Coverage, 10147,
     /* 229981 */     GIR_EraseRootFromParent_Done,
     /* 229982 */   // Label 4556: @229982
     /* 229982 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(230024), // Rule ID 10174 //
     /* 229987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 229995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230011 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 230014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230022 */     GIR_RootConstrainSelectedInstOperands,
     /* 230023 */     // GIR_Coverage, 10174,
     /* 230023 */     GIR_EraseRootFromParent_Done,
     /* 230024 */   // Label 4557: @230024
     /* 230024 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(230066), // Rule ID 10178 //
     /* 230029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 230037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230053 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 230056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230064 */     GIR_RootConstrainSelectedInstOperands,
     /* 230065 */     // GIR_Coverage, 10178,
     /* 230065 */     GIR_EraseRootFromParent_Done,
     /* 230066 */   // Label 4558: @230066
     /* 230066 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(230108), // Rule ID 10182 //
     /* 230071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 230079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230095 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 230098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230106 */     GIR_RootConstrainSelectedInstOperands,
     /* 230107 */     // GIR_Coverage, 10182,
     /* 230107 */     GIR_EraseRootFromParent_Done,
     /* 230108 */   // Label 4559: @230108
     /* 230108 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(230150), // Rule ID 10186 //
     /* 230113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 230121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230137 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 230140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230148 */     GIR_RootConstrainSelectedInstOperands,
     /* 230149 */     // GIR_Coverage, 10186,
     /* 230149 */     GIR_EraseRootFromParent_Done,
     /* 230150 */   // Label 4560: @230150
     /* 230150 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(230192), // Rule ID 10190 //
     /* 230155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 230163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230179 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1703:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 230182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230190 */     GIR_RootConstrainSelectedInstOperands,
     /* 230191 */     // GIR_Coverage, 10190,
     /* 230191 */     GIR_EraseRootFromParent_Done,
     /* 230192 */   // Label 4561: @230192
     /* 230192 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(230234), // Rule ID 10191 //
     /* 230197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 230205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230221 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1950:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 230224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230232 */     GIR_RootConstrainSelectedInstOperands,
     /* 230233 */     // GIR_Coverage, 10191,
     /* 230233 */     GIR_EraseRootFromParent_Done,
     /* 230234 */   // Label 4562: @230234
     /* 230234 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(230276), // Rule ID 10192 //
     /* 230239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 230247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230263 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1947:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 230266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230274 */     GIR_RootConstrainSelectedInstOperands,
     /* 230275 */     // GIR_Coverage, 10192,
     /* 230275 */     GIR_EraseRootFromParent_Done,
     /* 230276 */   // Label 4563: @230276
     /* 230276 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(230318), // Rule ID 10196 //
     /* 230281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 230289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230305 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1702:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 230308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230316 */     GIR_RootConstrainSelectedInstOperands,
     /* 230317 */     // GIR_Coverage, 10196,
     /* 230317 */     GIR_EraseRootFromParent_Done,
     /* 230318 */   // Label 4564: @230318
     /* 230318 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(230360), // Rule ID 10200 //
     /* 230323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 230331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230347 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1700:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 230350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230358 */     GIR_RootConstrainSelectedInstOperands,
     /* 230359 */     // GIR_Coverage, 10200,
     /* 230359 */     GIR_EraseRootFromParent_Done,
     /* 230360 */   // Label 4565: @230360
     /* 230360 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(230402), // Rule ID 10204 //
     /* 230365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 230373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230389 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 230392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230400 */     GIR_RootConstrainSelectedInstOperands,
     /* 230401 */     // GIR_Coverage, 10204,
     /* 230401 */     GIR_EraseRootFromParent_Done,
     /* 230402 */   // Label 4566: @230402
     /* 230402 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(230444), // Rule ID 10208 //
     /* 230407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 230415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230431 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1949:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 230434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230442 */     GIR_RootConstrainSelectedInstOperands,
     /* 230443 */     // GIR_Coverage, 10208,
     /* 230443 */     GIR_EraseRootFromParent_Done,
     /* 230444 */   // Label 4567: @230444
     /* 230444 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(230486), // Rule ID 10212 //
     /* 230449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 230457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230473 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 230476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230484 */     GIR_RootConstrainSelectedInstOperands,
     /* 230485 */     // GIR_Coverage, 10212,
     /* 230485 */     GIR_EraseRootFromParent_Done,
     /* 230486 */   // Label 4568: @230486
     /* 230486 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(230528), // Rule ID 10222 //
     /* 230491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 230499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 230518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230526 */     GIR_RootConstrainSelectedInstOperands,
     /* 230527 */     // GIR_Coverage, 10222,
     /* 230527 */     GIR_EraseRootFromParent_Done,
     /* 230528 */   // Label 4569: @230528
     /* 230528 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230570), // Rule ID 10223 //
     /* 230533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 230541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 230560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230568 */     GIR_RootConstrainSelectedInstOperands,
     /* 230569 */     // GIR_Coverage, 10223,
     /* 230569 */     GIR_EraseRootFromParent_Done,
     /* 230570 */   // Label 4570: @230570
     /* 230570 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230612), // Rule ID 10224 //
     /* 230575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 230583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 230602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230610 */     GIR_RootConstrainSelectedInstOperands,
     /* 230611 */     // GIR_Coverage, 10224,
     /* 230611 */     GIR_EraseRootFromParent_Done,
     /* 230612 */   // Label 4571: @230612
     /* 230612 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230654), // Rule ID 10228 //
     /* 230617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 230625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 230644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230652 */     GIR_RootConstrainSelectedInstOperands,
     /* 230653 */     // GIR_Coverage, 10228,
     /* 230653 */     GIR_EraseRootFromParent_Done,
     /* 230654 */   // Label 4572: @230654
     /* 230654 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230696), // Rule ID 10232 //
     /* 230659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 230667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 230686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230694 */     GIR_RootConstrainSelectedInstOperands,
     /* 230695 */     // GIR_Coverage, 10232,
     /* 230695 */     GIR_EraseRootFromParent_Done,
     /* 230696 */   // Label 4573: @230696
     /* 230696 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230738), // Rule ID 10236 //
     /* 230701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 230709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 230728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230736 */     GIR_RootConstrainSelectedInstOperands,
     /* 230737 */     // GIR_Coverage, 10236,
     /* 230737 */     GIR_EraseRootFromParent_Done,
     /* 230738 */   // Label 4574: @230738
     /* 230738 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230780), // Rule ID 10240 //
     /* 230743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 230751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230767 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 230770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230778 */     GIR_RootConstrainSelectedInstOperands,
     /* 230779 */     // GIR_Coverage, 10240,
     /* 230779 */     GIR_EraseRootFromParent_Done,
     /* 230780 */   // Label 4575: @230780
     /* 230780 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230822), // Rule ID 10244 //
     /* 230785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 230793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 230812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230820 */     GIR_RootConstrainSelectedInstOperands,
     /* 230821 */     // GIR_Coverage, 10244,
     /* 230821 */     GIR_EraseRootFromParent_Done,
     /* 230822 */   // Label 4576: @230822
     /* 230822 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230864), // Rule ID 11241 //
     /* 230827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 230835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 230854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230862 */     GIR_RootConstrainSelectedInstOperands,
     /* 230863 */     // GIR_Coverage, 11241,
     /* 230863 */     GIR_EraseRootFromParent_Done,
     /* 230864 */   // Label 4577: @230864
     /* 230864 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230906), // Rule ID 11242 //
     /* 230869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 230877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 230896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230904 */     GIR_RootConstrainSelectedInstOperands,
     /* 230905 */     // GIR_Coverage, 11242,
     /* 230905 */     GIR_EraseRootFromParent_Done,
     /* 230906 */   // Label 4578: @230906
     /* 230906 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230948), // Rule ID 11244 //
     /* 230911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 230914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230935 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 230938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230946 */     GIR_RootConstrainSelectedInstOperands,
     /* 230947 */     // GIR_Coverage, 11244,
     /* 230947 */     GIR_EraseRootFromParent_Done,
     /* 230948 */   // Label 4579: @230948
     /* 230948 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230990), // Rule ID 11245 //
     /* 230953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 230956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230977 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 230980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230988 */     GIR_RootConstrainSelectedInstOperands,
     /* 230989 */     // GIR_Coverage, 11245,
     /* 230989 */     GIR_EraseRootFromParent_Done,
     /* 230990 */   // Label 4580: @230990
     /* 230990 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(231032), // Rule ID 11299 //
     /* 230995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 231003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 231022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231030 */     GIR_RootConstrainSelectedInstOperands,
     /* 231031 */     // GIR_Coverage, 11299,
     /* 231031 */     GIR_EraseRootFromParent_Done,
     /* 231032 */   // Label 4581: @231032
     /* 231032 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(231074), // Rule ID 11300 //
     /* 231037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 231045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231061 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 231064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231072 */     GIR_RootConstrainSelectedInstOperands,
     /* 231073 */     // GIR_Coverage, 11300,
     /* 231073 */     GIR_EraseRootFromParent_Done,
     /* 231074 */   // Label 4582: @231074
     /* 231074 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(231116), // Rule ID 11301 //
     /* 231079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 231087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231103 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 231106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231114 */     GIR_RootConstrainSelectedInstOperands,
     /* 231115 */     // GIR_Coverage, 11301,
     /* 231115 */     GIR_EraseRootFromParent_Done,
     /* 231116 */   // Label 4583: @231116
     /* 231116 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(231158), // Rule ID 11302 //
     /* 231121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 231129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231145 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 231148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231156 */     GIR_RootConstrainSelectedInstOperands,
     /* 231157 */     // GIR_Coverage, 11302,
     /* 231157 */     GIR_EraseRootFromParent_Done,
     /* 231158 */   // Label 4584: @231158
     /* 231158 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(231200), // Rule ID 11355 //
     /* 231163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 231171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 231190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231198 */     GIR_RootConstrainSelectedInstOperands,
     /* 231199 */     // GIR_Coverage, 11355,
     /* 231199 */     GIR_EraseRootFromParent_Done,
     /* 231200 */   // Label 4585: @231200
     /* 231200 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(231242), // Rule ID 11356 //
     /* 231205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 231213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231229 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 231232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231240 */     GIR_RootConstrainSelectedInstOperands,
     /* 231241 */     // GIR_Coverage, 11356,
     /* 231241 */     GIR_EraseRootFromParent_Done,
     /* 231242 */   // Label 4586: @231242
     /* 231242 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(231284), // Rule ID 11357 //
     /* 231247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 231255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 231274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231282 */     GIR_RootConstrainSelectedInstOperands,
     /* 231283 */     // GIR_Coverage, 11357,
     /* 231283 */     GIR_EraseRootFromParent_Done,
     /* 231284 */   // Label 4587: @231284
     /* 231284 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(231326), // Rule ID 11358 //
     /* 231289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 231297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231313 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 231316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231324 */     GIR_RootConstrainSelectedInstOperands,
     /* 231325 */     // GIR_Coverage, 11358,
     /* 231325 */     GIR_EraseRootFromParent_Done,
     /* 231326 */   // Label 4588: @231326
     /* 231326 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(231368), // Rule ID 11359 //
     /* 231331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 231339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 231358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231366 */     GIR_RootConstrainSelectedInstOperands,
     /* 231367 */     // GIR_Coverage, 11359,
     /* 231367 */     GIR_EraseRootFromParent_Done,
     /* 231368 */   // Label 4589: @231368
     /* 231368 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(231410), // Rule ID 11360 //
     /* 231373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 231381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231397 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 231400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231408 */     GIR_RootConstrainSelectedInstOperands,
     /* 231409 */     // GIR_Coverage, 11360,
     /* 231409 */     GIR_EraseRootFromParent_Done,
     /* 231410 */   // Label 4590: @231410
     /* 231410 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(231452), // Rule ID 11361 //
     /* 231415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231439 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 231442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231450 */     GIR_RootConstrainSelectedInstOperands,
     /* 231451 */     // GIR_Coverage, 11361,
     /* 231451 */     GIR_EraseRootFromParent_Done,
     /* 231452 */   // Label 4591: @231452
     /* 231452 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(231494), // Rule ID 11362 //
     /* 231457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 231484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231492 */     GIR_RootConstrainSelectedInstOperands,
     /* 231493 */     // GIR_Coverage, 11362,
     /* 231493 */     GIR_EraseRootFromParent_Done,
     /* 231494 */   // Label 4592: @231494
     /* 231494 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(231536), // Rule ID 11363 //
     /* 231499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 231526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231534 */     GIR_RootConstrainSelectedInstOperands,
     /* 231535 */     // GIR_Coverage, 11363,
     /* 231535 */     GIR_EraseRootFromParent_Done,
     /* 231536 */   // Label 4593: @231536
     /* 231536 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231578), // Rule ID 11364 //
     /* 231541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231565 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 231568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231576 */     GIR_RootConstrainSelectedInstOperands,
     /* 231577 */     // GIR_Coverage, 11364,
     /* 231577 */     GIR_EraseRootFromParent_Done,
     /* 231578 */   // Label 4594: @231578
     /* 231578 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231620), // Rule ID 11365 //
     /* 231583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 231610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231618 */     GIR_RootConstrainSelectedInstOperands,
     /* 231619 */     // GIR_Coverage, 11365,
     /* 231619 */     GIR_EraseRootFromParent_Done,
     /* 231620 */   // Label 4595: @231620
     /* 231620 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231662), // Rule ID 11366 //
     /* 231625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 231652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231660 */     GIR_RootConstrainSelectedInstOperands,
     /* 231661 */     // GIR_Coverage, 11366,
     /* 231661 */     GIR_EraseRootFromParent_Done,
     /* 231662 */   // Label 4596: @231662
     /* 231662 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231704), // Rule ID 11367 //
     /* 231667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 231694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231702 */     GIR_RootConstrainSelectedInstOperands,
     /* 231703 */     // GIR_Coverage, 11367,
     /* 231703 */     GIR_EraseRootFromParent_Done,
     /* 231704 */   // Label 4597: @231704
     /* 231704 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231746), // Rule ID 11368 //
     /* 231709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 231736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231744 */     GIR_RootConstrainSelectedInstOperands,
     /* 231745 */     // GIR_Coverage, 11368,
     /* 231745 */     GIR_EraseRootFromParent_Done,
     /* 231746 */   // Label 4598: @231746
     /* 231746 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231788), // Rule ID 11369 //
     /* 231751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 231778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231786 */     GIR_RootConstrainSelectedInstOperands,
     /* 231787 */     // GIR_Coverage, 11369,
     /* 231787 */     GIR_EraseRootFromParent_Done,
     /* 231788 */   // Label 4599: @231788
     /* 231788 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231830), // Rule ID 11370 //
     /* 231793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 231820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231828 */     GIR_RootConstrainSelectedInstOperands,
     /* 231829 */     // GIR_Coverage, 11370,
     /* 231829 */     GIR_EraseRootFromParent_Done,
     /* 231830 */   // Label 4600: @231830
     /* 231830 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231872), // Rule ID 11371 //
     /* 231835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 231862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231870 */     GIR_RootConstrainSelectedInstOperands,
     /* 231871 */     // GIR_Coverage, 11371,
     /* 231871 */     GIR_EraseRootFromParent_Done,
     /* 231872 */   // Label 4601: @231872
     /* 231872 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231914), // Rule ID 11372 //
     /* 231877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231901 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 231904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231912 */     GIR_RootConstrainSelectedInstOperands,
     /* 231913 */     // GIR_Coverage, 11372,
     /* 231913 */     GIR_EraseRootFromParent_Done,
     /* 231914 */   // Label 4602: @231914
     /* 231914 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231956), // Rule ID 11373 //
     /* 231919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 231946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231954 */     GIR_RootConstrainSelectedInstOperands,
     /* 231955 */     // GIR_Coverage, 11373,
     /* 231955 */     GIR_EraseRootFromParent_Done,
     /* 231956 */   // Label 4603: @231956
     /* 231956 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231998), // Rule ID 11374 //
     /* 231961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 231988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231996 */     GIR_RootConstrainSelectedInstOperands,
     /* 231997 */     // GIR_Coverage, 11374,
     /* 231997 */     GIR_EraseRootFromParent_Done,
     /* 231998 */   // Label 4604: @231998
     /* 231998 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(232040), // Rule ID 11375 //
     /* 232003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 232011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 232030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232038 */     GIR_RootConstrainSelectedInstOperands,
     /* 232039 */     // GIR_Coverage, 11375,
     /* 232039 */     GIR_EraseRootFromParent_Done,
     /* 232040 */   // Label 4605: @232040
     /* 232040 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(232082), // Rule ID 11384 //
     /* 232045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 232053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 232072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232080 */     GIR_RootConstrainSelectedInstOperands,
     /* 232081 */     // GIR_Coverage, 11384,
     /* 232081 */     GIR_EraseRootFromParent_Done,
     /* 232082 */   // Label 4606: @232082
     /* 232082 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(232124), // Rule ID 11385 //
     /* 232087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 232095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 232114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232122 */     GIR_RootConstrainSelectedInstOperands,
     /* 232123 */     // GIR_Coverage, 11385,
     /* 232123 */     GIR_EraseRootFromParent_Done,
     /* 232124 */   // Label 4607: @232124
     /* 232124 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(232166), // Rule ID 11386 //
     /* 232129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 232137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 232156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232164 */     GIR_RootConstrainSelectedInstOperands,
     /* 232165 */     // GIR_Coverage, 11386,
     /* 232165 */     GIR_EraseRootFromParent_Done,
     /* 232166 */   // Label 4608: @232166
     /* 232166 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(232208), // Rule ID 11387 //
     /* 232171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 232179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 232198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232206 */     GIR_RootConstrainSelectedInstOperands,
     /* 232207 */     // GIR_Coverage, 11387,
     /* 232207 */     GIR_EraseRootFromParent_Done,
     /* 232208 */   // Label 4609: @232208
     /* 232208 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(232250), // Rule ID 11388 //
     /* 232213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 232221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 232240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232248 */     GIR_RootConstrainSelectedInstOperands,
     /* 232249 */     // GIR_Coverage, 11388,
     /* 232249 */     GIR_EraseRootFromParent_Done,
     /* 232250 */   // Label 4610: @232250
     /* 232250 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(232292), // Rule ID 11389 //
     /* 232255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 232263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 232282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232290 */     GIR_RootConstrainSelectedInstOperands,
     /* 232291 */     // GIR_Coverage, 11389,
     /* 232291 */     GIR_EraseRootFromParent_Done,
     /* 232292 */   // Label 4611: @232292
     /* 232292 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(232334), // Rule ID 11390 //
     /* 232297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 232305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 232324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232332 */     GIR_RootConstrainSelectedInstOperands,
     /* 232333 */     // GIR_Coverage, 11390,
     /* 232333 */     GIR_EraseRootFromParent_Done,
     /* 232334 */   // Label 4612: @232334
     /* 232334 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(232376), // Rule ID 11391 //
     /* 232339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 232347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232363 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 232366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232374 */     GIR_RootConstrainSelectedInstOperands,
     /* 232375 */     // GIR_Coverage, 11391,
     /* 232375 */     GIR_EraseRootFromParent_Done,
     /* 232376 */   // Label 4613: @232376
     /* 232376 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(232418), // Rule ID 11392 //
     /* 232381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 232389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 232408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232416 */     GIR_RootConstrainSelectedInstOperands,
     /* 232417 */     // GIR_Coverage, 11392,
     /* 232417 */     GIR_EraseRootFromParent_Done,
     /* 232418 */   // Label 4614: @232418
     /* 232418 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(232460), // Rule ID 11393 //
     /* 232423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232447 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 232450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232458 */     GIR_RootConstrainSelectedInstOperands,
     /* 232459 */     // GIR_Coverage, 11393,
     /* 232459 */     GIR_EraseRootFromParent_Done,
     /* 232460 */   // Label 4615: @232460
     /* 232460 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(232502), // Rule ID 11394 //
     /* 232465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 232492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232500 */     GIR_RootConstrainSelectedInstOperands,
     /* 232501 */     // GIR_Coverage, 11394,
     /* 232501 */     GIR_EraseRootFromParent_Done,
     /* 232502 */   // Label 4616: @232502
     /* 232502 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(232544), // Rule ID 11395 //
     /* 232507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 232534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232542 */     GIR_RootConstrainSelectedInstOperands,
     /* 232543 */     // GIR_Coverage, 11395,
     /* 232543 */     GIR_EraseRootFromParent_Done,
     /* 232544 */   // Label 4617: @232544
     /* 232544 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232586), // Rule ID 11396 //
     /* 232549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 232576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232584 */     GIR_RootConstrainSelectedInstOperands,
     /* 232585 */     // GIR_Coverage, 11396,
     /* 232585 */     GIR_EraseRootFromParent_Done,
     /* 232586 */   // Label 4618: @232586
     /* 232586 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232628), // Rule ID 11397 //
     /* 232591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 232618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232626 */     GIR_RootConstrainSelectedInstOperands,
     /* 232627 */     // GIR_Coverage, 11397,
     /* 232627 */     GIR_EraseRootFromParent_Done,
     /* 232628 */   // Label 4619: @232628
     /* 232628 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232670), // Rule ID 11398 //
     /* 232633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 232660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232668 */     GIR_RootConstrainSelectedInstOperands,
     /* 232669 */     // GIR_Coverage, 11398,
     /* 232669 */     GIR_EraseRootFromParent_Done,
     /* 232670 */   // Label 4620: @232670
     /* 232670 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232712), // Rule ID 11399 //
     /* 232675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 232702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232710 */     GIR_RootConstrainSelectedInstOperands,
     /* 232711 */     // GIR_Coverage, 11399,
     /* 232711 */     GIR_EraseRootFromParent_Done,
     /* 232712 */   // Label 4621: @232712
     /* 232712 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232754), // Rule ID 11400 //
     /* 232717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 232744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232752 */     GIR_RootConstrainSelectedInstOperands,
     /* 232753 */     // GIR_Coverage, 11400,
     /* 232753 */     GIR_EraseRootFromParent_Done,
     /* 232754 */   // Label 4622: @232754
     /* 232754 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232796), // Rule ID 11401 //
     /* 232759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232783 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 232786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232794 */     GIR_RootConstrainSelectedInstOperands,
     /* 232795 */     // GIR_Coverage, 11401,
     /* 232795 */     GIR_EraseRootFromParent_Done,
     /* 232796 */   // Label 4623: @232796
     /* 232796 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232838), // Rule ID 11402 //
     /* 232801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 232828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232836 */     GIR_RootConstrainSelectedInstOperands,
     /* 232837 */     // GIR_Coverage, 11402,
     /* 232837 */     GIR_EraseRootFromParent_Done,
     /* 232838 */   // Label 4624: @232838
     /* 232838 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232880), // Rule ID 11404 //
     /* 232843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 232870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232878 */     GIR_RootConstrainSelectedInstOperands,
     /* 232879 */     // GIR_Coverage, 11404,
     /* 232879 */     GIR_EraseRootFromParent_Done,
     /* 232880 */   // Label 4625: @232880
     /* 232880 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232922), // Rule ID 11406 //
     /* 232885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 232912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232920 */     GIR_RootConstrainSelectedInstOperands,
     /* 232921 */     // GIR_Coverage, 11406,
     /* 232921 */     GIR_EraseRootFromParent_Done,
     /* 232922 */   // Label 4626: @232922
     /* 232922 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232964), // Rule ID 11408 //
     /* 232927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 232954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232962 */     GIR_RootConstrainSelectedInstOperands,
     /* 232963 */     // GIR_Coverage, 11408,
     /* 232963 */     GIR_EraseRootFromParent_Done,
     /* 232964 */   // Label 4627: @232964
     /* 232964 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(233006), // Rule ID 11410 //
     /* 232969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 232996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233004 */     GIR_RootConstrainSelectedInstOperands,
     /* 233005 */     // GIR_Coverage, 11410,
     /* 233005 */     GIR_EraseRootFromParent_Done,
     /* 233006 */   // Label 4628: @233006
     /* 233006 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(233048), // Rule ID 11411 //
     /* 233011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 233019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233035 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 233038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233046 */     GIR_RootConstrainSelectedInstOperands,
     /* 233047 */     // GIR_Coverage, 11411,
     /* 233047 */     GIR_EraseRootFromParent_Done,
     /* 233048 */   // Label 4629: @233048
     /* 233048 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(233090), // Rule ID 11412 //
     /* 233053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 233061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 233080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233088 */     GIR_RootConstrainSelectedInstOperands,
     /* 233089 */     // GIR_Coverage, 11412,
     /* 233089 */     GIR_EraseRootFromParent_Done,
     /* 233090 */   // Label 4630: @233090
     /* 233090 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(233132), // Rule ID 11413 //
     /* 233095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 233103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233119 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 233122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233130 */     GIR_RootConstrainSelectedInstOperands,
     /* 233131 */     // GIR_Coverage, 11413,
     /* 233131 */     GIR_EraseRootFromParent_Done,
     /* 233132 */   // Label 4631: @233132
     /* 233132 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(233174), // Rule ID 11414 //
     /* 233137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 233145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 233164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233172 */     GIR_RootConstrainSelectedInstOperands,
     /* 233173 */     // GIR_Coverage, 11414,
     /* 233173 */     GIR_EraseRootFromParent_Done,
     /* 233174 */   // Label 4632: @233174
     /* 233174 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(233216), // Rule ID 11415 //
     /* 233179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 233187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233203 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 233206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233214 */     GIR_RootConstrainSelectedInstOperands,
     /* 233215 */     // GIR_Coverage, 11415,
     /* 233215 */     GIR_EraseRootFromParent_Done,
     /* 233216 */   // Label 4633: @233216
     /* 233216 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(233258), // Rule ID 11416 //
     /* 233221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 233229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 233248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233256 */     GIR_RootConstrainSelectedInstOperands,
     /* 233257 */     // GIR_Coverage, 11416,
     /* 233257 */     GIR_EraseRootFromParent_Done,
     /* 233258 */   // Label 4634: @233258
     /* 233258 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(233300), // Rule ID 11417 //
     /* 233263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 233271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 233290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233298 */     GIR_RootConstrainSelectedInstOperands,
     /* 233299 */     // GIR_Coverage, 11417,
     /* 233299 */     GIR_EraseRootFromParent_Done,
     /* 233300 */   // Label 4635: @233300
     /* 233300 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(233342), // Rule ID 11418 //
     /* 233305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233329 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 233332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233340 */     GIR_RootConstrainSelectedInstOperands,
     /* 233341 */     // GIR_Coverage, 11418,
     /* 233341 */     GIR_EraseRootFromParent_Done,
     /* 233342 */   // Label 4636: @233342
     /* 233342 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(233384), // Rule ID 11420 //
     /* 233347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 233374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233382 */     GIR_RootConstrainSelectedInstOperands,
     /* 233383 */     // GIR_Coverage, 11420,
     /* 233383 */     GIR_EraseRootFromParent_Done,
     /* 233384 */   // Label 4637: @233384
     /* 233384 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(233426), // Rule ID 11422 //
     /* 233389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 233416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233424 */     GIR_RootConstrainSelectedInstOperands,
     /* 233425 */     // GIR_Coverage, 11422,
     /* 233425 */     GIR_EraseRootFromParent_Done,
     /* 233426 */   // Label 4638: @233426
     /* 233426 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(233468), // Rule ID 11424 //
     /* 233431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 233458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233466 */     GIR_RootConstrainSelectedInstOperands,
     /* 233467 */     // GIR_Coverage, 11424,
     /* 233467 */     GIR_EraseRootFromParent_Done,
     /* 233468 */   // Label 4639: @233468
     /* 233468 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(233510), // Rule ID 11426 //
     /* 233473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233497 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 233500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233508 */     GIR_RootConstrainSelectedInstOperands,
     /* 233509 */     // GIR_Coverage, 11426,
     /* 233509 */     GIR_EraseRootFromParent_Done,
     /* 233510 */   // Label 4640: @233510
     /* 233510 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(233552), // Rule ID 11428 //
     /* 233515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 233542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233550 */     GIR_RootConstrainSelectedInstOperands,
     /* 233551 */     // GIR_Coverage, 11428,
     /* 233551 */     GIR_EraseRootFromParent_Done,
     /* 233552 */   // Label 4641: @233552
     /* 233552 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233594), // Rule ID 11430 //
     /* 233557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 233584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233592 */     GIR_RootConstrainSelectedInstOperands,
     /* 233593 */     // GIR_Coverage, 11430,
     /* 233593 */     GIR_EraseRootFromParent_Done,
     /* 233594 */   // Label 4642: @233594
     /* 233594 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233636), // Rule ID 11432 //
     /* 233599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 233626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233634 */     GIR_RootConstrainSelectedInstOperands,
     /* 233635 */     // GIR_Coverage, 11432,
     /* 233635 */     GIR_EraseRootFromParent_Done,
     /* 233636 */   // Label 4643: @233636
     /* 233636 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233678), // Rule ID 11434 //
     /* 233641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 233668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233676 */     GIR_RootConstrainSelectedInstOperands,
     /* 233677 */     // GIR_Coverage, 11434,
     /* 233677 */     GIR_EraseRootFromParent_Done,
     /* 233678 */   // Label 4644: @233678
     /* 233678 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233720), // Rule ID 11435 //
     /* 233683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 233710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233718 */     GIR_RootConstrainSelectedInstOperands,
     /* 233719 */     // GIR_Coverage, 11435,
     /* 233719 */     GIR_EraseRootFromParent_Done,
     /* 233720 */   // Label 4645: @233720
     /* 233720 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233762), // Rule ID 11436 //
     /* 233725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 233752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233760 */     GIR_RootConstrainSelectedInstOperands,
     /* 233761 */     // GIR_Coverage, 11436,
     /* 233761 */     GIR_EraseRootFromParent_Done,
     /* 233762 */   // Label 4646: @233762
     /* 233762 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233804), // Rule ID 11437 //
     /* 233767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 233794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233802 */     GIR_RootConstrainSelectedInstOperands,
     /* 233803 */     // GIR_Coverage, 11437,
     /* 233803 */     GIR_EraseRootFromParent_Done,
     /* 233804 */   // Label 4647: @233804
     /* 233804 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233846), // Rule ID 11438 //
     /* 233809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 233836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233844 */     GIR_RootConstrainSelectedInstOperands,
     /* 233845 */     // GIR_Coverage, 11438,
     /* 233845 */     GIR_EraseRootFromParent_Done,
     /* 233846 */   // Label 4648: @233846
     /* 233846 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233888), // Rule ID 11439 //
     /* 233851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233875 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 233878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233886 */     GIR_RootConstrainSelectedInstOperands,
     /* 233887 */     // GIR_Coverage, 11439,
     /* 233887 */     GIR_EraseRootFromParent_Done,
     /* 233888 */   // Label 4649: @233888
     /* 233888 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233930), // Rule ID 11440 //
     /* 233893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 233920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233928 */     GIR_RootConstrainSelectedInstOperands,
     /* 233929 */     // GIR_Coverage, 11440,
     /* 233929 */     GIR_EraseRootFromParent_Done,
     /* 233930 */   // Label 4650: @233930
     /* 233930 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233972), // Rule ID 11441 //
     /* 233935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 233962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233970 */     GIR_RootConstrainSelectedInstOperands,
     /* 233971 */     // GIR_Coverage, 11441,
     /* 233971 */     GIR_EraseRootFromParent_Done,
     /* 233972 */   // Label 4651: @233972
     /* 233972 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(234014), // Rule ID 11442 //
     /* 233977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 234004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234012 */     GIR_RootConstrainSelectedInstOperands,
     /* 234013 */     // GIR_Coverage, 11442,
     /* 234013 */     GIR_EraseRootFromParent_Done,
     /* 234014 */   // Label 4652: @234014
     /* 234014 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(234056), // Rule ID 11443 //
     /* 234019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 234027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 234046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234054 */     GIR_RootConstrainSelectedInstOperands,
     /* 234055 */     // GIR_Coverage, 11443,
     /* 234055 */     GIR_EraseRootFromParent_Done,
     /* 234056 */   // Label 4653: @234056
     /* 234056 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(234098), // Rule ID 11444 //
     /* 234061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 234069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234085 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 234088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 234090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234096 */     GIR_RootConstrainSelectedInstOperands,
     /* 234097 */     // GIR_Coverage, 11444,
     /* 234097 */     GIR_EraseRootFromParent_Done,
     /* 234098 */   // Label 4654: @234098
     /* 234098 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(234140), // Rule ID 11445 //
     /* 234103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 234111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 234130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234138 */     GIR_RootConstrainSelectedInstOperands,
     /* 234139 */     // GIR_Coverage, 11445,
     /* 234139 */     GIR_EraseRootFromParent_Done,
     /* 234140 */   // Label 4655: @234140
     /* 234140 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(234182), // Rule ID 11446 //
     /* 234145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 234153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 234172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234180 */     GIR_RootConstrainSelectedInstOperands,
     /* 234181 */     // GIR_Coverage, 11446,
     /* 234181 */     GIR_EraseRootFromParent_Done,
     /* 234182 */   // Label 4656: @234182
     /* 234182 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(234224), // Rule ID 11447 //
     /* 234187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 234195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 234214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234222 */     GIR_RootConstrainSelectedInstOperands,
     /* 234223 */     // GIR_Coverage, 11447,
     /* 234223 */     GIR_EraseRootFromParent_Done,
     /* 234224 */   // Label 4657: @234224
     /* 234224 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(234266), // Rule ID 11448 //
     /* 234229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 234237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 234256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234264 */     GIR_RootConstrainSelectedInstOperands,
     /* 234265 */     // GIR_Coverage, 11448,
     /* 234265 */     GIR_EraseRootFromParent_Done,
     /* 234266 */   // Label 4658: @234266
     /* 234266 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(234308), // Rule ID 11449 //
     /* 234271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 234298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234306 */     GIR_RootConstrainSelectedInstOperands,
     /* 234307 */     // GIR_Coverage, 11449,
     /* 234307 */     GIR_EraseRootFromParent_Done,
     /* 234308 */   // Label 4659: @234308
     /* 234308 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(234350), // Rule ID 11450 //
     /* 234313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 234340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234348 */     GIR_RootConstrainSelectedInstOperands,
     /* 234349 */     // GIR_Coverage, 11450,
     /* 234349 */     GIR_EraseRootFromParent_Done,
     /* 234350 */   // Label 4660: @234350
     /* 234350 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(234392), // Rule ID 11451 //
     /* 234355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 234382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234390 */     GIR_RootConstrainSelectedInstOperands,
     /* 234391 */     // GIR_Coverage, 11451,
     /* 234391 */     GIR_EraseRootFromParent_Done,
     /* 234392 */   // Label 4661: @234392
     /* 234392 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(234434), // Rule ID 11452 //
     /* 234397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 234424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234432 */     GIR_RootConstrainSelectedInstOperands,
     /* 234433 */     // GIR_Coverage, 11452,
     /* 234433 */     GIR_EraseRootFromParent_Done,
     /* 234434 */   // Label 4662: @234434
     /* 234434 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(234476), // Rule ID 11453 //
     /* 234439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 234466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234474 */     GIR_RootConstrainSelectedInstOperands,
     /* 234475 */     // GIR_Coverage, 11453,
     /* 234475 */     GIR_EraseRootFromParent_Done,
     /* 234476 */   // Label 4663: @234476
     /* 234476 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(234518), // Rule ID 11454 //
     /* 234481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 234508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234516 */     GIR_RootConstrainSelectedInstOperands,
     /* 234517 */     // GIR_Coverage, 11454,
     /* 234517 */     GIR_EraseRootFromParent_Done,
     /* 234518 */   // Label 4664: @234518
     /* 234518 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234560), // Rule ID 11455 //
     /* 234523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 234550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234558 */     GIR_RootConstrainSelectedInstOperands,
     /* 234559 */     // GIR_Coverage, 11455,
     /* 234559 */     GIR_EraseRootFromParent_Done,
     /* 234560 */   // Label 4665: @234560
     /* 234560 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234602), // Rule ID 11456 //
     /* 234565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 234592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234600 */     GIR_RootConstrainSelectedInstOperands,
     /* 234601 */     // GIR_Coverage, 11456,
     /* 234601 */     GIR_EraseRootFromParent_Done,
     /* 234602 */   // Label 4666: @234602
     /* 234602 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234644), // Rule ID 11457 //
     /* 234607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 234634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234642 */     GIR_RootConstrainSelectedInstOperands,
     /* 234643 */     // GIR_Coverage, 11457,
     /* 234643 */     GIR_EraseRootFromParent_Done,
     /* 234644 */   // Label 4667: @234644
     /* 234644 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234686), // Rule ID 11458 //
     /* 234649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 234676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234684 */     GIR_RootConstrainSelectedInstOperands,
     /* 234685 */     // GIR_Coverage, 11458,
     /* 234685 */     GIR_EraseRootFromParent_Done,
     /* 234686 */   // Label 4668: @234686
     /* 234686 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234728), // Rule ID 11459 //
     /* 234691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 234718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234726 */     GIR_RootConstrainSelectedInstOperands,
     /* 234727 */     // GIR_Coverage, 11459,
     /* 234727 */     GIR_EraseRootFromParent_Done,
     /* 234728 */   // Label 4669: @234728
     /* 234728 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234770), // Rule ID 11460 //
     /* 234733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 234760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234768 */     GIR_RootConstrainSelectedInstOperands,
     /* 234769 */     // GIR_Coverage, 11460,
     /* 234769 */     GIR_EraseRootFromParent_Done,
     /* 234770 */   // Label 4670: @234770
     /* 234770 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234812), // Rule ID 11461 //
     /* 234775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 234802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234810 */     GIR_RootConstrainSelectedInstOperands,
     /* 234811 */     // GIR_Coverage, 11461,
     /* 234811 */     GIR_EraseRootFromParent_Done,
     /* 234812 */   // Label 4671: @234812
     /* 234812 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234854), // Rule ID 11462 //
     /* 234817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 234844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234852 */     GIR_RootConstrainSelectedInstOperands,
     /* 234853 */     // GIR_Coverage, 11462,
     /* 234853 */     GIR_EraseRootFromParent_Done,
     /* 234854 */   // Label 4672: @234854
     /* 234854 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234896), // Rule ID 11463 //
     /* 234859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 234886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234894 */     GIR_RootConstrainSelectedInstOperands,
     /* 234895 */     // GIR_Coverage, 11463,
     /* 234895 */     GIR_EraseRootFromParent_Done,
     /* 234896 */   // Label 4673: @234896
     /* 234896 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234938), // Rule ID 11464 //
     /* 234901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 234928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234936 */     GIR_RootConstrainSelectedInstOperands,
     /* 234937 */     // GIR_Coverage, 11464,
     /* 234937 */     GIR_EraseRootFromParent_Done,
     /* 234938 */   // Label 4674: @234938
     /* 234938 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234980), // Rule ID 11465 //
     /* 234943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 234951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 234970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234978 */     GIR_RootConstrainSelectedInstOperands,
     /* 234979 */     // GIR_Coverage, 11465,
     /* 234979 */     GIR_EraseRootFromParent_Done,
     /* 234980 */   // Label 4675: @234980
     /* 234980 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(235022), // Rule ID 11476 //
     /* 234985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235009 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 235012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235020 */     GIR_RootConstrainSelectedInstOperands,
     /* 235021 */     // GIR_Coverage, 11476,
     /* 235021 */     GIR_EraseRootFromParent_Done,
     /* 235022 */   // Label 4676: @235022
     /* 235022 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(235064), // Rule ID 11477 //
     /* 235027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 235035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 235054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235062 */     GIR_RootConstrainSelectedInstOperands,
     /* 235063 */     // GIR_Coverage, 11477,
     /* 235063 */     GIR_EraseRootFromParent_Done,
     /* 235064 */   // Label 4677: @235064
     /* 235064 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(235106), // Rule ID 11478 //
     /* 235069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 235077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 235096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235104 */     GIR_RootConstrainSelectedInstOperands,
     /* 235105 */     // GIR_Coverage, 11478,
     /* 235105 */     GIR_EraseRootFromParent_Done,
     /* 235106 */   // Label 4678: @235106
     /* 235106 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(235148), // Rule ID 11479 //
     /* 235111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 235119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 235138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235146 */     GIR_RootConstrainSelectedInstOperands,
     /* 235147 */     // GIR_Coverage, 11479,
     /* 235147 */     GIR_EraseRootFromParent_Done,
     /* 235148 */   // Label 4679: @235148
     /* 235148 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(235190), // Rule ID 11488 //
     /* 235153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 235161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 235180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235188 */     GIR_RootConstrainSelectedInstOperands,
     /* 235189 */     // GIR_Coverage, 11488,
     /* 235189 */     GIR_EraseRootFromParent_Done,
     /* 235190 */   // Label 4680: @235190
     /* 235190 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(235232), // Rule ID 11489 //
     /* 235195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 235203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235219 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 235222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235230 */     GIR_RootConstrainSelectedInstOperands,
     /* 235231 */     // GIR_Coverage, 11489,
     /* 235231 */     GIR_EraseRootFromParent_Done,
     /* 235232 */   // Label 4681: @235232
     /* 235232 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(235274), // Rule ID 11490 //
     /* 235237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 235245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235261 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 235264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235272 */     GIR_RootConstrainSelectedInstOperands,
     /* 235273 */     // GIR_Coverage, 11490,
     /* 235273 */     GIR_EraseRootFromParent_Done,
     /* 235274 */   // Label 4682: @235274
     /* 235274 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(235316), // Rule ID 11491 //
     /* 235279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 235287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 235306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235314 */     GIR_RootConstrainSelectedInstOperands,
     /* 235315 */     // GIR_Coverage, 11491,
     /* 235315 */     GIR_EraseRootFromParent_Done,
     /* 235316 */   // Label 4683: @235316
     /* 235316 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(235358), // Rule ID 11492 //
     /* 235321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1996:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 235348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235356 */     GIR_RootConstrainSelectedInstOperands,
     /* 235357 */     // GIR_Coverage, 11492,
     /* 235357 */     GIR_EraseRootFromParent_Done,
     /* 235358 */   // Label 4684: @235358
     /* 235358 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(235400), // Rule ID 11493 //
     /* 235363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235387 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 235390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235398 */     GIR_RootConstrainSelectedInstOperands,
     /* 235399 */     // GIR_Coverage, 11493,
     /* 235399 */     GIR_EraseRootFromParent_Done,
     /* 235400 */   // Label 4685: @235400
     /* 235400 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(235442), // Rule ID 11494 //
     /* 235405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 235432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235440 */     GIR_RootConstrainSelectedInstOperands,
     /* 235441 */     // GIR_Coverage, 11494,
     /* 235441 */     GIR_EraseRootFromParent_Done,
     /* 235442 */   // Label 4686: @235442
     /* 235442 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(235484), // Rule ID 11495 //
     /* 235447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235471 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 235474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235482 */     GIR_RootConstrainSelectedInstOperands,
     /* 235483 */     // GIR_Coverage, 11495,
     /* 235483 */     GIR_EraseRootFromParent_Done,
     /* 235484 */   // Label 4687: @235484
     /* 235484 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(235526), // Rule ID 11496 //
     /* 235489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235513 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 235516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235524 */     GIR_RootConstrainSelectedInstOperands,
     /* 235525 */     // GIR_Coverage, 11496,
     /* 235525 */     GIR_EraseRootFromParent_Done,
     /* 235526 */   // Label 4688: @235526
     /* 235526 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235568), // Rule ID 11497 //
     /* 235531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235555 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 235558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235566 */     GIR_RootConstrainSelectedInstOperands,
     /* 235567 */     // GIR_Coverage, 11497,
     /* 235567 */     GIR_EraseRootFromParent_Done,
     /* 235568 */   // Label 4689: @235568
     /* 235568 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235610), // Rule ID 11498 //
     /* 235573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 235600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235608 */     GIR_RootConstrainSelectedInstOperands,
     /* 235609 */     // GIR_Coverage, 11498,
     /* 235609 */     GIR_EraseRootFromParent_Done,
     /* 235610 */   // Label 4690: @235610
     /* 235610 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235652), // Rule ID 11499 //
     /* 235615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 235642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235650 */     GIR_RootConstrainSelectedInstOperands,
     /* 235651 */     // GIR_Coverage, 11499,
     /* 235651 */     GIR_EraseRootFromParent_Done,
     /* 235652 */   // Label 4691: @235652
     /* 235652 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235694), // Rule ID 11500 //
     /* 235657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 235684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235692 */     GIR_RootConstrainSelectedInstOperands,
     /* 235693 */     // GIR_Coverage, 11500,
     /* 235693 */     GIR_EraseRootFromParent_Done,
     /* 235694 */   // Label 4692: @235694
     /* 235694 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235736), // Rule ID 11501 //
     /* 235699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 235726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235734 */     GIR_RootConstrainSelectedInstOperands,
     /* 235735 */     // GIR_Coverage, 11501,
     /* 235735 */     GIR_EraseRootFromParent_Done,
     /* 235736 */   // Label 4693: @235736
     /* 235736 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235778), // Rule ID 11502 //
     /* 235741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 235768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235776 */     GIR_RootConstrainSelectedInstOperands,
     /* 235777 */     // GIR_Coverage, 11502,
     /* 235777 */     GIR_EraseRootFromParent_Done,
     /* 235778 */   // Label 4694: @235778
     /* 235778 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235820), // Rule ID 11503 //
     /* 235783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 235810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235818 */     GIR_RootConstrainSelectedInstOperands,
     /* 235819 */     // GIR_Coverage, 11503,
     /* 235819 */     GIR_EraseRootFromParent_Done,
     /* 235820 */   // Label 4695: @235820
     /* 235820 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235862), // Rule ID 11504 //
     /* 235825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 235852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235860 */     GIR_RootConstrainSelectedInstOperands,
     /* 235861 */     // GIR_Coverage, 11504,
     /* 235861 */     GIR_EraseRootFromParent_Done,
     /* 235862 */   // Label 4696: @235862
     /* 235862 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235904), // Rule ID 11505 //
     /* 235867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 235894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235902 */     GIR_RootConstrainSelectedInstOperands,
     /* 235903 */     // GIR_Coverage, 11505,
     /* 235903 */     GIR_EraseRootFromParent_Done,
     /* 235904 */   // Label 4697: @235904
     /* 235904 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235946), // Rule ID 11506 //
     /* 235909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 235936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235944 */     GIR_RootConstrainSelectedInstOperands,
     /* 235945 */     // GIR_Coverage, 11506,
     /* 235945 */     GIR_EraseRootFromParent_Done,
     /* 235946 */   // Label 4698: @235946
     /* 235946 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235988), // Rule ID 11507 //
     /* 235951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 235978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235986 */     GIR_RootConstrainSelectedInstOperands,
     /* 235987 */     // GIR_Coverage, 11507,
     /* 235987 */     GIR_EraseRootFromParent_Done,
     /* 235988 */   // Label 4699: @235988
     /* 235988 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(236030), // Rule ID 11508 //
     /* 235993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 236001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236017 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2061:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 236020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236028 */     GIR_RootConstrainSelectedInstOperands,
     /* 236029 */     // GIR_Coverage, 11508,
     /* 236029 */     GIR_EraseRootFromParent_Done,
     /* 236030 */   // Label 4700: @236030
     /* 236030 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(236072), // Rule ID 11509 //
     /* 236035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 236043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2061:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 236062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236070 */     GIR_RootConstrainSelectedInstOperands,
     /* 236071 */     // GIR_Coverage, 11509,
     /* 236071 */     GIR_EraseRootFromParent_Done,
     /* 236072 */   // Label 4701: @236072
     /* 236072 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(236114), // Rule ID 11510 //
     /* 236077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 236085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 236104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236112 */     GIR_RootConstrainSelectedInstOperands,
     /* 236113 */     // GIR_Coverage, 11510,
     /* 236113 */     GIR_EraseRootFromParent_Done,
     /* 236114 */   // Label 4702: @236114
     /* 236114 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(236156), // Rule ID 11511 //
     /* 236119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 236127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236143 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2061:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 236146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236154 */     GIR_RootConstrainSelectedInstOperands,
     /* 236155 */     // GIR_Coverage, 11511,
     /* 236155 */     GIR_EraseRootFromParent_Done,
     /* 236156 */   // Label 4703: @236156
     /* 236156 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(236198), // Rule ID 11512 //
     /* 236161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 236169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 236188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236196 */     GIR_RootConstrainSelectedInstOperands,
     /* 236197 */     // GIR_Coverage, 11512,
     /* 236197 */     GIR_EraseRootFromParent_Done,
     /* 236198 */   // Label 4704: @236198
     /* 236198 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(236240), // Rule ID 11513 //
     /* 236203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 236211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 236230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236238 */     GIR_RootConstrainSelectedInstOperands,
     /* 236239 */     // GIR_Coverage, 11513,
     /* 236239 */     GIR_EraseRootFromParent_Done,
     /* 236240 */   // Label 4705: @236240
     /* 236240 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(236282), // Rule ID 11514 //
     /* 236245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 236253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 236272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236280 */     GIR_RootConstrainSelectedInstOperands,
     /* 236281 */     // GIR_Coverage, 11514,
     /* 236281 */     GIR_EraseRootFromParent_Done,
     /* 236282 */   // Label 4706: @236282
     /* 236282 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(236324), // Rule ID 11515 //
     /* 236287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 236295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 236314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236322 */     GIR_RootConstrainSelectedInstOperands,
     /* 236323 */     // GIR_Coverage, 11515,
     /* 236323 */     GIR_EraseRootFromParent_Done,
     /* 236324 */   // Label 4707: @236324
     /* 236324 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(236366), // Rule ID 11516 //
     /* 236329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 236356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236364 */     GIR_RootConstrainSelectedInstOperands,
     /* 236365 */     // GIR_Coverage, 11516,
     /* 236365 */     GIR_EraseRootFromParent_Done,
     /* 236366 */   // Label 4708: @236366
     /* 236366 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(236408), // Rule ID 11517 //
     /* 236371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 236398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236406 */     GIR_RootConstrainSelectedInstOperands,
     /* 236407 */     // GIR_Coverage, 11517,
     /* 236407 */     GIR_EraseRootFromParent_Done,
     /* 236408 */   // Label 4709: @236408
     /* 236408 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(236450), // Rule ID 11518 //
     /* 236413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 236440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236448 */     GIR_RootConstrainSelectedInstOperands,
     /* 236449 */     // GIR_Coverage, 11518,
     /* 236449 */     GIR_EraseRootFromParent_Done,
     /* 236450 */   // Label 4710: @236450
     /* 236450 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(236492), // Rule ID 11519 //
     /* 236455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236479 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 236482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236490 */     GIR_RootConstrainSelectedInstOperands,
     /* 236491 */     // GIR_Coverage, 11519,
     /* 236491 */     GIR_EraseRootFromParent_Done,
     /* 236492 */   // Label 4711: @236492
     /* 236492 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(236534), // Rule ID 11520 //
     /* 236497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236521 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 236524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236532 */     GIR_RootConstrainSelectedInstOperands,
     /* 236533 */     // GIR_Coverage, 11520,
     /* 236533 */     GIR_EraseRootFromParent_Done,
     /* 236534 */   // Label 4712: @236534
     /* 236534 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236576), // Rule ID 11521 //
     /* 236539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236563 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 236566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236574 */     GIR_RootConstrainSelectedInstOperands,
     /* 236575 */     // GIR_Coverage, 11521,
     /* 236575 */     GIR_EraseRootFromParent_Done,
     /* 236576 */   // Label 4713: @236576
     /* 236576 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236618), // Rule ID 11522 //
     /* 236581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 236608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236616 */     GIR_RootConstrainSelectedInstOperands,
     /* 236617 */     // GIR_Coverage, 11522,
     /* 236617 */     GIR_EraseRootFromParent_Done,
     /* 236618 */   // Label 4714: @236618
     /* 236618 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236660), // Rule ID 11523 //
     /* 236623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236647 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 236650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236658 */     GIR_RootConstrainSelectedInstOperands,
     /* 236659 */     // GIR_Coverage, 11523,
     /* 236659 */     GIR_EraseRootFromParent_Done,
     /* 236660 */   // Label 4715: @236660
     /* 236660 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236702), // Rule ID 11524 //
     /* 236665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 236692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236700 */     GIR_RootConstrainSelectedInstOperands,
     /* 236701 */     // GIR_Coverage, 11524,
     /* 236701 */     GIR_EraseRootFromParent_Done,
     /* 236702 */   // Label 4716: @236702
     /* 236702 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236744), // Rule ID 11525 //
     /* 236707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 236734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236742 */     GIR_RootConstrainSelectedInstOperands,
     /* 236743 */     // GIR_Coverage, 11525,
     /* 236743 */     GIR_EraseRootFromParent_Done,
     /* 236744 */   // Label 4717: @236744
     /* 236744 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236786), // Rule ID 11526 //
     /* 236749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 236776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236784 */     GIR_RootConstrainSelectedInstOperands,
     /* 236785 */     // GIR_Coverage, 11526,
     /* 236785 */     GIR_EraseRootFromParent_Done,
     /* 236786 */   // Label 4718: @236786
     /* 236786 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236828), // Rule ID 11527 //
     /* 236791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 236818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236826 */     GIR_RootConstrainSelectedInstOperands,
     /* 236827 */     // GIR_Coverage, 11527,
     /* 236827 */     GIR_EraseRootFromParent_Done,
     /* 236828 */   // Label 4719: @236828
     /* 236828 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236870), // Rule ID 11528 //
     /* 236833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236857 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 236860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236868 */     GIR_RootConstrainSelectedInstOperands,
     /* 236869 */     // GIR_Coverage, 11528,
     /* 236869 */     GIR_EraseRootFromParent_Done,
     /* 236870 */   // Label 4720: @236870
     /* 236870 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236912), // Rule ID 11529 //
     /* 236875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 236902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236910 */     GIR_RootConstrainSelectedInstOperands,
     /* 236911 */     // GIR_Coverage, 11529,
     /* 236911 */     GIR_EraseRootFromParent_Done,
     /* 236912 */   // Label 4721: @236912
     /* 236912 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236954), // Rule ID 11530 //
     /* 236917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 236944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236952 */     GIR_RootConstrainSelectedInstOperands,
     /* 236953 */     // GIR_Coverage, 11530,
     /* 236953 */     GIR_EraseRootFromParent_Done,
     /* 236954 */   // Label 4722: @236954
     /* 236954 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236996), // Rule ID 11531 //
     /* 236959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 236986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236994 */     GIR_RootConstrainSelectedInstOperands,
     /* 236995 */     // GIR_Coverage, 11531,
     /* 236995 */     GIR_EraseRootFromParent_Done,
     /* 236996 */   // Label 4723: @236996
     /* 236996 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(237038), // Rule ID 11532 //
     /* 237001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 237009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237025 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 237028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237036 */     GIR_RootConstrainSelectedInstOperands,
     /* 237037 */     // GIR_Coverage, 11532,
     /* 237037 */     GIR_EraseRootFromParent_Done,
     /* 237038 */   // Label 4724: @237038
     /* 237038 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(237080), // Rule ID 11533 //
     /* 237043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 237051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237067 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 237070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237078 */     GIR_RootConstrainSelectedInstOperands,
     /* 237079 */     // GIR_Coverage, 11533,
     /* 237079 */     GIR_EraseRootFromParent_Done,
     /* 237080 */   // Label 4725: @237080
     /* 237080 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(237122), // Rule ID 11534 //
     /* 237085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 237093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237109 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 237112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237120 */     GIR_RootConstrainSelectedInstOperands,
     /* 237121 */     // GIR_Coverage, 11534,
     /* 237121 */     GIR_EraseRootFromParent_Done,
     /* 237122 */   // Label 4726: @237122
     /* 237122 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(237164), // Rule ID 11535 //
     /* 237127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 237135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237151 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 237154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237162 */     GIR_RootConstrainSelectedInstOperands,
     /* 237163 */     // GIR_Coverage, 11535,
     /* 237163 */     GIR_EraseRootFromParent_Done,
     /* 237164 */   // Label 4727: @237164
     /* 237164 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(237206), // Rule ID 11536 //
     /* 237169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 237177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 237196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237204 */     GIR_RootConstrainSelectedInstOperands,
     /* 237205 */     // GIR_Coverage, 11536,
     /* 237205 */     GIR_EraseRootFromParent_Done,
     /* 237206 */   // Label 4728: @237206
     /* 237206 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(237248), // Rule ID 11537 //
     /* 237211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 237219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 237238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237246 */     GIR_RootConstrainSelectedInstOperands,
     /* 237247 */     // GIR_Coverage, 11537,
     /* 237247 */     GIR_EraseRootFromParent_Done,
     /* 237248 */   // Label 4729: @237248
     /* 237248 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(237290), // Rule ID 11538 //
     /* 237253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 237261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 237280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237288 */     GIR_RootConstrainSelectedInstOperands,
     /* 237289 */     // GIR_Coverage, 11538,
     /* 237289 */     GIR_EraseRootFromParent_Done,
     /* 237290 */   // Label 4730: @237290
     /* 237290 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(237332), // Rule ID 11539 //
     /* 237295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 237303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237319 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 237322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237330 */     GIR_RootConstrainSelectedInstOperands,
     /* 237331 */     // GIR_Coverage, 11539,
     /* 237331 */     GIR_EraseRootFromParent_Done,
     /* 237332 */   // Label 4731: @237332
     /* 237332 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(237374), // Rule ID 11540 //
     /* 237337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 237364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237372 */     GIR_RootConstrainSelectedInstOperands,
     /* 237373 */     // GIR_Coverage, 11540,
     /* 237373 */     GIR_EraseRootFromParent_Done,
     /* 237374 */   // Label 4732: @237374
     /* 237374 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(237416), // Rule ID 11541 //
     /* 237379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237403 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 237406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237414 */     GIR_RootConstrainSelectedInstOperands,
     /* 237415 */     // GIR_Coverage, 11541,
     /* 237415 */     GIR_EraseRootFromParent_Done,
     /* 237416 */   // Label 4733: @237416
     /* 237416 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(237458), // Rule ID 11542 //
     /* 237421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 237448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237456 */     GIR_RootConstrainSelectedInstOperands,
     /* 237457 */     // GIR_Coverage, 11542,
     /* 237457 */     GIR_EraseRootFromParent_Done,
     /* 237458 */   // Label 4734: @237458
     /* 237458 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(237500), // Rule ID 11543 //
     /* 237463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2030:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 237490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237498 */     GIR_RootConstrainSelectedInstOperands,
     /* 237499 */     // GIR_Coverage, 11543,
     /* 237499 */     GIR_EraseRootFromParent_Done,
     /* 237500 */   // Label 4735: @237500
     /* 237500 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(237542), // Rule ID 11706 //
     /* 237505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237529 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 237532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237540 */     GIR_RootConstrainSelectedInstOperands,
     /* 237541 */     // GIR_Coverage, 11706,
     /* 237541 */     GIR_EraseRootFromParent_Done,
     /* 237542 */   // Label 4736: @237542
     /* 237542 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237584), // Rule ID 11708 //
     /* 237547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237571 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 237574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237582 */     GIR_RootConstrainSelectedInstOperands,
     /* 237583 */     // GIR_Coverage, 11708,
     /* 237583 */     GIR_EraseRootFromParent_Done,
     /* 237584 */   // Label 4737: @237584
     /* 237584 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237626), // Rule ID 11710 //
     /* 237589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 237616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237624 */     GIR_RootConstrainSelectedInstOperands,
     /* 237625 */     // GIR_Coverage, 11710,
     /* 237625 */     GIR_EraseRootFromParent_Done,
     /* 237626 */   // Label 4738: @237626
     /* 237626 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237668), // Rule ID 11712 //
     /* 237631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 237658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237666 */     GIR_RootConstrainSelectedInstOperands,
     /* 237667 */     // GIR_Coverage, 11712,
     /* 237667 */     GIR_EraseRootFromParent_Done,
     /* 237668 */   // Label 4739: @237668
     /* 237668 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237710), // Rule ID 11714 //
     /* 237673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237697 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 237700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237708 */     GIR_RootConstrainSelectedInstOperands,
     /* 237709 */     // GIR_Coverage, 11714,
     /* 237709 */     GIR_EraseRootFromParent_Done,
     /* 237710 */   // Label 4740: @237710
     /* 237710 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237752), // Rule ID 11715 //
     /* 237715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 237742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237750 */     GIR_RootConstrainSelectedInstOperands,
     /* 237751 */     // GIR_Coverage, 11715,
     /* 237751 */     GIR_EraseRootFromParent_Done,
     /* 237752 */   // Label 4741: @237752
     /* 237752 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237794), // Rule ID 11716 //
     /* 237757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 237784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237792 */     GIR_RootConstrainSelectedInstOperands,
     /* 237793 */     // GIR_Coverage, 11716,
     /* 237793 */     GIR_EraseRootFromParent_Done,
     /* 237794 */   // Label 4742: @237794
     /* 237794 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237836), // Rule ID 11717 //
     /* 237799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 237826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237834 */     GIR_RootConstrainSelectedInstOperands,
     /* 237835 */     // GIR_Coverage, 11717,
     /* 237835 */     GIR_EraseRootFromParent_Done,
     /* 237836 */   // Label 4743: @237836
     /* 237836 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237878), // Rule ID 11718 //
     /* 237841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 237868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237876 */     GIR_RootConstrainSelectedInstOperands,
     /* 237877 */     // GIR_Coverage, 11718,
     /* 237877 */     GIR_EraseRootFromParent_Done,
     /* 237878 */   // Label 4744: @237878
     /* 237878 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237920), // Rule ID 11719 //
     /* 237883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 237910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237918 */     GIR_RootConstrainSelectedInstOperands,
     /* 237919 */     // GIR_Coverage, 11719,
     /* 237919 */     GIR_EraseRootFromParent_Done,
     /* 237920 */   // Label 4745: @237920
     /* 237920 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237962), // Rule ID 11720 //
     /* 237925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 237952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237960 */     GIR_RootConstrainSelectedInstOperands,
     /* 237961 */     // GIR_Coverage, 11720,
     /* 237961 */     GIR_EraseRootFromParent_Done,
     /* 237962 */   // Label 4746: @237962
     /* 237962 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(238004), // Rule ID 11721 //
     /* 237967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237991 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 237994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238002 */     GIR_RootConstrainSelectedInstOperands,
     /* 238003 */     // GIR_Coverage, 11721,
     /* 238003 */     GIR_EraseRootFromParent_Done,
     /* 238004 */   // Label 4747: @238004
     /* 238004 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(238046), // Rule ID 11722 //
     /* 238009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 238017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 238036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238044 */     GIR_RootConstrainSelectedInstOperands,
     /* 238045 */     // GIR_Coverage, 11722,
     /* 238045 */     GIR_EraseRootFromParent_Done,
     /* 238046 */   // Label 4748: @238046
     /* 238046 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(238088), // Rule ID 11723 //
     /* 238051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 238059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 238078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238086 */     GIR_RootConstrainSelectedInstOperands,
     /* 238087 */     // GIR_Coverage, 11723,
     /* 238087 */     GIR_EraseRootFromParent_Done,
     /* 238088 */   // Label 4749: @238088
     /* 238088 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(238130), // Rule ID 11724 //
     /* 238093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 238101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 238120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238128 */     GIR_RootConstrainSelectedInstOperands,
     /* 238129 */     // GIR_Coverage, 11724,
     /* 238129 */     GIR_EraseRootFromParent_Done,
     /* 238130 */   // Label 4750: @238130
     /* 238130 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(238172), // Rule ID 11725 //
     /* 238135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 238143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 238162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238170 */     GIR_RootConstrainSelectedInstOperands,
     /* 238171 */     // GIR_Coverage, 11725,
     /* 238171 */     GIR_EraseRootFromParent_Done,
     /* 238172 */   // Label 4751: @238172
     /* 238172 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(238214), // Rule ID 11726 //
     /* 238177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 238185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238201 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 238204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238212 */     GIR_RootConstrainSelectedInstOperands,
     /* 238213 */     // GIR_Coverage, 11726,
     /* 238213 */     GIR_EraseRootFromParent_Done,
     /* 238214 */   // Label 4752: @238214
     /* 238214 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(238256), // Rule ID 11727 //
     /* 238219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 238227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238243 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 238246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238254 */     GIR_RootConstrainSelectedInstOperands,
     /* 238255 */     // GIR_Coverage, 11727,
     /* 238255 */     GIR_EraseRootFromParent_Done,
     /* 238256 */   // Label 4753: @238256
     /* 238256 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(238298), // Rule ID 11728 //
     /* 238261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 238269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 238288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238296 */     GIR_RootConstrainSelectedInstOperands,
     /* 238297 */     // GIR_Coverage, 11728,
     /* 238297 */     GIR_EraseRootFromParent_Done,
     /* 238298 */   // Label 4754: @238298
     /* 238298 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(238340), // Rule ID 11783 //
     /* 238303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 238311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 238330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238338 */     GIR_RootConstrainSelectedInstOperands,
     /* 238339 */     // GIR_Coverage, 11783,
     /* 238339 */     GIR_EraseRootFromParent_Done,
     /* 238340 */   // Label 4755: @238340
     /* 238340 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(238382), // Rule ID 11784 //
     /* 238345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 238353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 238372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238380 */     GIR_RootConstrainSelectedInstOperands,
     /* 238381 */     // GIR_Coverage, 11784,
     /* 238381 */     GIR_EraseRootFromParent_Done,
     /* 238382 */   // Label 4756: @238382
     /* 238382 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(238424), // Rule ID 11785 //
     /* 238387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 238395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 238414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238422 */     GIR_RootConstrainSelectedInstOperands,
     /* 238423 */     // GIR_Coverage, 11785,
     /* 238423 */     GIR_EraseRootFromParent_Done,
     /* 238424 */   // Label 4757: @238424
     /* 238424 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(238466), // Rule ID 11786 //
     /* 238429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238464 */     GIR_RootConstrainSelectedInstOperands,
     /* 238465 */     // GIR_Coverage, 11786,
     /* 238465 */     GIR_EraseRootFromParent_Done,
     /* 238466 */   // Label 4758: @238466
     /* 238466 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(238508), // Rule ID 11787 //
     /* 238471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 238498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238506 */     GIR_RootConstrainSelectedInstOperands,
     /* 238507 */     // GIR_Coverage, 11787,
     /* 238507 */     GIR_EraseRootFromParent_Done,
     /* 238508 */   // Label 4759: @238508
     /* 238508 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(238550), // Rule ID 11788 //
     /* 238513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 238540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238548 */     GIR_RootConstrainSelectedInstOperands,
     /* 238549 */     // GIR_Coverage, 11788,
     /* 238549 */     GIR_EraseRootFromParent_Done,
     /* 238550 */   // Label 4760: @238550
     /* 238550 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238592), // Rule ID 11789 //
     /* 238555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238579 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 238582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238590 */     GIR_RootConstrainSelectedInstOperands,
     /* 238591 */     // GIR_Coverage, 11789,
     /* 238591 */     GIR_EraseRootFromParent_Done,
     /* 238592 */   // Label 4761: @238592
     /* 238592 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238634), // Rule ID 11790 //
     /* 238597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 238624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238632 */     GIR_RootConstrainSelectedInstOperands,
     /* 238633 */     // GIR_Coverage, 11790,
     /* 238633 */     GIR_EraseRootFromParent_Done,
     /* 238634 */   // Label 4762: @238634
     /* 238634 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238676), // Rule ID 11791 //
     /* 238639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238663 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 238666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238674 */     GIR_RootConstrainSelectedInstOperands,
     /* 238675 */     // GIR_Coverage, 11791,
     /* 238675 */     GIR_EraseRootFromParent_Done,
     /* 238676 */   // Label 4763: @238676
     /* 238676 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238721), // Rule ID 11804 //
     /* 238681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 238689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238705 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 238708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238719 */     GIR_RootConstrainSelectedInstOperands,
     /* 238720 */     // GIR_Coverage, 11804,
     /* 238720 */     GIR_EraseRootFromParent_Done,
     /* 238721 */   // Label 4764: @238721
     /* 238721 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238766), // Rule ID 11805 //
     /* 238726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 238734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238750 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 238753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238764 */     GIR_RootConstrainSelectedInstOperands,
     /* 238765 */     // GIR_Coverage, 11805,
     /* 238765 */     GIR_EraseRootFromParent_Done,
     /* 238766 */   // Label 4765: @238766
     /* 238766 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238808), // Rule ID 11806 //
     /* 238771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1354:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 238798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238806 */     GIR_RootConstrainSelectedInstOperands,
     /* 238807 */     // GIR_Coverage, 11806,
     /* 238807 */     GIR_EraseRootFromParent_Done,
     /* 238808 */   // Label 4766: @238808
     /* 238808 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238850), // Rule ID 11807 //
     /* 238813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1354:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 238840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238848 */     GIR_RootConstrainSelectedInstOperands,
     /* 238849 */     // GIR_Coverage, 11807,
     /* 238849 */     GIR_EraseRootFromParent_Done,
     /* 238850 */   // Label 4767: @238850
     /* 238850 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238892), // Rule ID 11808 //
     /* 238855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1354:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 238882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238890 */     GIR_RootConstrainSelectedInstOperands,
     /* 238891 */     // GIR_Coverage, 11808,
     /* 238891 */     GIR_EraseRootFromParent_Done,
     /* 238892 */   // Label 4768: @238892
     /* 238892 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238934), // Rule ID 11809 //
     /* 238897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1354:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 238924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238932 */     GIR_RootConstrainSelectedInstOperands,
     /* 238933 */     // GIR_Coverage, 11809,
     /* 238933 */     GIR_EraseRootFromParent_Done,
     /* 238934 */   // Label 4769: @238934
     /* 238934 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238976), // Rule ID 11825 //
     /* 238939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238963 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1437:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 238966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238974 */     GIR_RootConstrainSelectedInstOperands,
     /* 238975 */     // GIR_Coverage, 11825,
     /* 238975 */     GIR_EraseRootFromParent_Done,
     /* 238976 */   // Label 4770: @238976
     /* 238976 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(239018), // Rule ID 11826 //
     /* 238981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239005 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1437:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 239008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239016 */     GIR_RootConstrainSelectedInstOperands,
     /* 239017 */     // GIR_Coverage, 11826,
     /* 239017 */     GIR_EraseRootFromParent_Done,
     /* 239018 */   // Label 4771: @239018
     /* 239018 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(239060), // Rule ID 11827 //
     /* 239023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 239031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239047 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1437:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 239050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239058 */     GIR_RootConstrainSelectedInstOperands,
     /* 239059 */     // GIR_Coverage, 11827,
     /* 239059 */     GIR_EraseRootFromParent_Done,
     /* 239060 */   // Label 4772: @239060
     /* 239060 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(239102), // Rule ID 11828 //
     /* 239065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 239073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239089 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 239092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239100 */     GIR_RootConstrainSelectedInstOperands,
     /* 239101 */     // GIR_Coverage, 11828,
     /* 239101 */     GIR_EraseRootFromParent_Done,
     /* 239102 */   // Label 4773: @239102
     /* 239102 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(239144), // Rule ID 11829 //
     /* 239107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 239115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239131 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 239134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239142 */     GIR_RootConstrainSelectedInstOperands,
     /* 239143 */     // GIR_Coverage, 11829,
     /* 239143 */     GIR_EraseRootFromParent_Done,
     /* 239144 */   // Label 4774: @239144
     /* 239144 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(239186), // Rule ID 11830 //
     /* 239149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 239157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239173 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 239176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239184 */     GIR_RootConstrainSelectedInstOperands,
     /* 239185 */     // GIR_Coverage, 11830,
     /* 239185 */     GIR_EraseRootFromParent_Done,
     /* 239186 */   // Label 4775: @239186
     /* 239186 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(239228), // Rule ID 11831 //
     /* 239191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 239199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239215 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1440:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 239218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239226 */     GIR_RootConstrainSelectedInstOperands,
     /* 239227 */     // GIR_Coverage, 11831,
     /* 239227 */     GIR_EraseRootFromParent_Done,
     /* 239228 */   // Label 4776: @239228
     /* 239228 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(239270), // Rule ID 11832 //
     /* 239233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 239241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239257 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1440:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 239260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239268 */     GIR_RootConstrainSelectedInstOperands,
     /* 239269 */     // GIR_Coverage, 11832,
     /* 239269 */     GIR_EraseRootFromParent_Done,
     /* 239270 */   // Label 4777: @239270
     /* 239270 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(239312), // Rule ID 11833 //
     /* 239275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 239283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239299 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1440:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 239302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239310 */     GIR_RootConstrainSelectedInstOperands,
     /* 239311 */     // GIR_Coverage, 11833,
     /* 239311 */     GIR_EraseRootFromParent_Done,
     /* 239312 */   // Label 4778: @239312
     /* 239312 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(239354), // Rule ID 11834 //
     /* 239317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 239325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239341 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1458:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 239344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239352 */     GIR_RootConstrainSelectedInstOperands,
     /* 239353 */     // GIR_Coverage, 11834,
     /* 239353 */     GIR_EraseRootFromParent_Done,
     /* 239354 */   // Label 4779: @239354
     /* 239354 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(239396), // Rule ID 11835 //
     /* 239359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 239367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239383 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 239386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239394 */     GIR_RootConstrainSelectedInstOperands,
     /* 239395 */     // GIR_Coverage, 11835,
     /* 239395 */     GIR_EraseRootFromParent_Done,
     /* 239396 */   // Label 4780: @239396
     /* 239396 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(239438), // Rule ID 11836 //
     /* 239401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 239409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1458:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 239428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239436 */     GIR_RootConstrainSelectedInstOperands,
     /* 239437 */     // GIR_Coverage, 11836,
     /* 239437 */     GIR_EraseRootFromParent_Done,
     /* 239438 */   // Label 4781: @239438
     /* 239438 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(239480), // Rule ID 11841 //
     /* 239443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 239451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239467 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 239470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239478 */     GIR_RootConstrainSelectedInstOperands,
     /* 239479 */     // GIR_Coverage, 11841,
     /* 239479 */     GIR_EraseRootFromParent_Done,
     /* 239480 */   // Label 4782: @239480
     /* 239480 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(239522), // Rule ID 11842 //
     /* 239485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 239493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239509 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 239512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239520 */     GIR_RootConstrainSelectedInstOperands,
     /* 239521 */     // GIR_Coverage, 11842,
     /* 239521 */     GIR_EraseRootFromParent_Done,
     /* 239522 */   // Label 4783: @239522
     /* 239522 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239564), // Rule ID 11843 //
     /* 239527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 239535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239551 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 239554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239562 */     GIR_RootConstrainSelectedInstOperands,
     /* 239563 */     // GIR_Coverage, 11843,
     /* 239563 */     GIR_EraseRootFromParent_Done,
     /* 239564 */   // Label 4784: @239564
     /* 239564 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239606), // Rule ID 11844 //
     /* 239569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 239577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239593 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 239596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239604 */     GIR_RootConstrainSelectedInstOperands,
     /* 239605 */     // GIR_Coverage, 11844,
     /* 239605 */     GIR_EraseRootFromParent_Done,
     /* 239606 */   // Label 4785: @239606
     /* 239606 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239648), // Rule ID 11845 //
     /* 239611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239635 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239646 */     GIR_RootConstrainSelectedInstOperands,
     /* 239647 */     // GIR_Coverage, 11845,
     /* 239647 */     GIR_EraseRootFromParent_Done,
     /* 239648 */   // Label 4786: @239648
     /* 239648 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239690), // Rule ID 11847 //
     /* 239653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1271:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239688 */     GIR_RootConstrainSelectedInstOperands,
     /* 239689 */     // GIR_Coverage, 11847,
     /* 239689 */     GIR_EraseRootFromParent_Done,
     /* 239690 */   // Label 4787: @239690
     /* 239690 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239732), // Rule ID 11849 //
     /* 239695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1271:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239730 */     GIR_RootConstrainSelectedInstOperands,
     /* 239731 */     // GIR_Coverage, 11849,
     /* 239731 */     GIR_EraseRootFromParent_Done,
     /* 239732 */   // Label 4788: @239732
     /* 239732 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239774), // Rule ID 11851 //
     /* 239737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1271:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239772 */     GIR_RootConstrainSelectedInstOperands,
     /* 239773 */     // GIR_Coverage, 11851,
     /* 239773 */     GIR_EraseRootFromParent_Done,
     /* 239774 */   // Label 4789: @239774
     /* 239774 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239816), // Rule ID 11853 //
     /* 239779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239803 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239814 */     GIR_RootConstrainSelectedInstOperands,
     /* 239815 */     // GIR_Coverage, 11853,
     /* 239815 */     GIR_EraseRootFromParent_Done,
     /* 239816 */   // Label 4790: @239816
     /* 239816 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239858), // Rule ID 11855 //
     /* 239821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239856 */     GIR_RootConstrainSelectedInstOperands,
     /* 239857 */     // GIR_Coverage, 11855,
     /* 239857 */     GIR_EraseRootFromParent_Done,
     /* 239858 */   // Label 4791: @239858
     /* 239858 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239900), // Rule ID 11857 //
     /* 239863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239898 */     GIR_RootConstrainSelectedInstOperands,
     /* 239899 */     // GIR_Coverage, 11857,
     /* 239899 */     GIR_EraseRootFromParent_Done,
     /* 239900 */   // Label 4792: @239900
     /* 239900 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239942), // Rule ID 11859 //
     /* 239905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239929 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239940 */     GIR_RootConstrainSelectedInstOperands,
     /* 239941 */     // GIR_Coverage, 11859,
     /* 239941 */     GIR_EraseRootFromParent_Done,
     /* 239942 */   // Label 4793: @239942
     /* 239942 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239984), // Rule ID 11861 //
     /* 239947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239971 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1301:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239982 */     GIR_RootConstrainSelectedInstOperands,
     /* 239983 */     // GIR_Coverage, 11861,
     /* 239983 */     GIR_EraseRootFromParent_Done,
     /* 239984 */   // Label 4794: @239984
     /* 239984 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(240026), // Rule ID 11862 //
     /* 239989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1301:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 240016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240024 */     GIR_RootConstrainSelectedInstOperands,
     /* 240025 */     // GIR_Coverage, 11862,
     /* 240025 */     GIR_EraseRootFromParent_Done,
     /* 240026 */   // Label 4795: @240026
     /* 240026 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(240068), // Rule ID 11863 //
     /* 240031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 240039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1301:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 240058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240066 */     GIR_RootConstrainSelectedInstOperands,
     /* 240067 */     // GIR_Coverage, 11863,
     /* 240067 */     GIR_EraseRootFromParent_Done,
     /* 240068 */   // Label 4796: @240068
     /* 240068 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(240110), // Rule ID 11864 //
     /* 240073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 240081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240097 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1301:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 240100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240108 */     GIR_RootConstrainSelectedInstOperands,
     /* 240109 */     // GIR_Coverage, 11864,
     /* 240109 */     GIR_EraseRootFromParent_Done,
     /* 240110 */   // Label 4797: @240110
     /* 240110 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(240152), // Rule ID 11865 //
     /* 240115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 240123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240139 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 240142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240150 */     GIR_RootConstrainSelectedInstOperands,
     /* 240151 */     // GIR_Coverage, 11865,
     /* 240151 */     GIR_EraseRootFromParent_Done,
     /* 240152 */   // Label 4798: @240152
     /* 240152 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(240194), // Rule ID 11866 //
     /* 240157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 240165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 240184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240192 */     GIR_RootConstrainSelectedInstOperands,
     /* 240193 */     // GIR_Coverage, 11866,
     /* 240193 */     GIR_EraseRootFromParent_Done,
     /* 240194 */   // Label 4799: @240194
     /* 240194 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(240236), // Rule ID 11867 //
     /* 240199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 240207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 240226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240234 */     GIR_RootConstrainSelectedInstOperands,
     /* 240235 */     // GIR_Coverage, 11867,
     /* 240235 */     GIR_EraseRootFromParent_Done,
     /* 240236 */   // Label 4800: @240236
     /* 240236 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(240278), // Rule ID 11868 //
     /* 240241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 240249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240265 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 240268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240276 */     GIR_RootConstrainSelectedInstOperands,
     /* 240277 */     // GIR_Coverage, 11868,
     /* 240277 */     GIR_EraseRootFromParent_Done,
     /* 240278 */   // Label 4801: @240278
     /* 240278 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(240320), // Rule ID 11869 //
     /* 240283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240307 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1612:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240318 */     GIR_RootConstrainSelectedInstOperands,
     /* 240319 */     // GIR_Coverage, 11869,
     /* 240319 */     GIR_EraseRootFromParent_Done,
     /* 240320 */   // Label 4802: @240320
     /* 240320 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(240362), // Rule ID 11871 //
     /* 240325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240360 */     GIR_RootConstrainSelectedInstOperands,
     /* 240361 */     // GIR_Coverage, 11871,
     /* 240361 */     GIR_EraseRootFromParent_Done,
     /* 240362 */   // Label 4803: @240362
     /* 240362 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(240404), // Rule ID 11873 //
     /* 240367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240402 */     GIR_RootConstrainSelectedInstOperands,
     /* 240403 */     // GIR_Coverage, 11873,
     /* 240403 */     GIR_EraseRootFromParent_Done,
     /* 240404 */   // Label 4804: @240404
     /* 240404 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(240446), // Rule ID 11875 //
     /* 240409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240433 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240444 */     GIR_RootConstrainSelectedInstOperands,
     /* 240445 */     // GIR_Coverage, 11875,
     /* 240445 */     GIR_EraseRootFromParent_Done,
     /* 240446 */   // Label 4805: @240446
     /* 240446 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(240488), // Rule ID 11964 //
     /* 240451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240475 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 240478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240486 */     GIR_RootConstrainSelectedInstOperands,
     /* 240487 */     // GIR_Coverage, 11964,
     /* 240487 */     GIR_EraseRootFromParent_Done,
     /* 240488 */   // Label 4806: @240488
     /* 240488 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240530), // Rule ID 11966 //
     /* 240493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 240520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240528 */     GIR_RootConstrainSelectedInstOperands,
     /* 240529 */     // GIR_Coverage, 11966,
     /* 240529 */     GIR_EraseRootFromParent_Done,
     /* 240530 */   // Label 4807: @240530
     /* 240530 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240572), // Rule ID 11968 //
     /* 240535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 240562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240570 */     GIR_RootConstrainSelectedInstOperands,
     /* 240571 */     // GIR_Coverage, 11968,
     /* 240571 */     GIR_EraseRootFromParent_Done,
     /* 240572 */   // Label 4808: @240572
     /* 240572 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240614), // Rule ID 11970 //
     /* 240577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 240604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240612 */     GIR_RootConstrainSelectedInstOperands,
     /* 240613 */     // GIR_Coverage, 11970,
     /* 240613 */     GIR_EraseRootFromParent_Done,
     /* 240614 */   // Label 4809: @240614
     /* 240614 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240656), // Rule ID 11972 //
     /* 240619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 240627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240643 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 240646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240654 */     GIR_RootConstrainSelectedInstOperands,
     /* 240655 */     // GIR_Coverage, 11972,
     /* 240655 */     GIR_EraseRootFromParent_Done,
     /* 240656 */   // Label 4810: @240656
     /* 240656 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240698), // Rule ID 11974 //
     /* 240661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 240669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 240688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240696 */     GIR_RootConstrainSelectedInstOperands,
     /* 240697 */     // GIR_Coverage, 11974,
     /* 240697 */     GIR_EraseRootFromParent_Done,
     /* 240698 */   // Label 4811: @240698
     /* 240698 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240740), // Rule ID 12137 //
     /* 240703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 240730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240738 */     GIR_RootConstrainSelectedInstOperands,
     /* 240739 */     // GIR_Coverage, 12137,
     /* 240739 */     GIR_EraseRootFromParent_Done,
     /* 240740 */   // Label 4812: @240740
     /* 240740 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240782), // Rule ID 12138 //
     /* 240745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240780 */     GIR_RootConstrainSelectedInstOperands,
     /* 240781 */     // GIR_Coverage, 12138,
     /* 240781 */     GIR_EraseRootFromParent_Done,
     /* 240782 */   // Label 4813: @240782
     /* 240782 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240824), // Rule ID 12139 //
     /* 240787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240811 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240822 */     GIR_RootConstrainSelectedInstOperands,
     /* 240823 */     // GIR_Coverage, 12139,
     /* 240823 */     GIR_EraseRootFromParent_Done,
     /* 240824 */   // Label 4814: @240824
     /* 240824 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240866), // Rule ID 12140 //
     /* 240829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240853 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240864 */     GIR_RootConstrainSelectedInstOperands,
     /* 240865 */     // GIR_Coverage, 12140,
     /* 240865 */     GIR_EraseRootFromParent_Done,
     /* 240866 */   // Label 4815: @240866
     /* 240866 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240908), // Rule ID 12141 //
     /* 240871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240895 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240906 */     GIR_RootConstrainSelectedInstOperands,
     /* 240907 */     // GIR_Coverage, 12141,
     /* 240907 */     GIR_EraseRootFromParent_Done,
     /* 240908 */   // Label 4816: @240908
     /* 240908 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240950), // Rule ID 12142 //
     /* 240913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240937 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240948 */     GIR_RootConstrainSelectedInstOperands,
     /* 240949 */     // GIR_Coverage, 12142,
     /* 240949 */     GIR_EraseRootFromParent_Done,
     /* 240950 */   // Label 4817: @240950
     /* 240950 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240992), // Rule ID 12143 //
     /* 240955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240990 */     GIR_RootConstrainSelectedInstOperands,
     /* 240991 */     // GIR_Coverage, 12143,
     /* 240991 */     GIR_EraseRootFromParent_Done,
     /* 240992 */   // Label 4818: @240992
     /* 240992 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(241034), // Rule ID 12488 //
     /* 240997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 241005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 241024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241032 */     GIR_RootConstrainSelectedInstOperands,
     /* 241033 */     // GIR_Coverage, 12488,
     /* 241033 */     GIR_EraseRootFromParent_Done,
     /* 241034 */   // Label 4819: @241034
     /* 241034 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(241076), // Rule ID 12489 //
     /* 241039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 241047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241063 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 241066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241074 */     GIR_RootConstrainSelectedInstOperands,
     /* 241075 */     // GIR_Coverage, 12489,
     /* 241075 */     GIR_EraseRootFromParent_Done,
     /* 241076 */   // Label 4820: @241076
     /* 241076 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(241118), // Rule ID 12490 //
     /* 241081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 241089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241105 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 241108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241116 */     GIR_RootConstrainSelectedInstOperands,
     /* 241117 */     // GIR_Coverage, 12490,
     /* 241117 */     GIR_EraseRootFromParent_Done,
     /* 241118 */   // Label 4821: @241118
     /* 241118 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(241160), // Rule ID 12491 //
     /* 241123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 241131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241147 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 241150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241158 */     GIR_RootConstrainSelectedInstOperands,
     /* 241159 */     // GIR_Coverage, 12491,
     /* 241159 */     GIR_EraseRootFromParent_Done,
     /* 241160 */   // Label 4822: @241160
     /* 241160 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(241202), // Rule ID 12492 //
     /* 241165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 241173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241189 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 241192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241200 */     GIR_RootConstrainSelectedInstOperands,
     /* 241201 */     // GIR_Coverage, 12492,
     /* 241201 */     GIR_EraseRootFromParent_Done,
     /* 241202 */   // Label 4823: @241202
     /* 241202 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(241244), // Rule ID 12493 //
     /* 241207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 241215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 241234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241242 */     GIR_RootConstrainSelectedInstOperands,
     /* 241243 */     // GIR_Coverage, 12493,
     /* 241243 */     GIR_EraseRootFromParent_Done,
     /* 241244 */   // Label 4824: @241244
     /* 241244 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(241286), // Rule ID 12494 //
     /* 241249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241273 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 241276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241284 */     GIR_RootConstrainSelectedInstOperands,
     /* 241285 */     // GIR_Coverage, 12494,
     /* 241285 */     GIR_EraseRootFromParent_Done,
     /* 241286 */   // Label 4825: @241286
     /* 241286 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(241328), // Rule ID 12497 //
     /* 241291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241315 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 241318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241326 */     GIR_RootConstrainSelectedInstOperands,
     /* 241327 */     // GIR_Coverage, 12497,
     /* 241327 */     GIR_EraseRootFromParent_Done,
     /* 241328 */   // Label 4826: @241328
     /* 241328 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(241370), // Rule ID 12500 //
     /* 241333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241357 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 241360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241368 */     GIR_RootConstrainSelectedInstOperands,
     /* 241369 */     // GIR_Coverage, 12500,
     /* 241369 */     GIR_EraseRootFromParent_Done,
     /* 241370 */   // Label 4827: @241370
     /* 241370 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(241412), // Rule ID 12503 //
     /* 241375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241399 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 241402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241410 */     GIR_RootConstrainSelectedInstOperands,
     /* 241411 */     // GIR_Coverage, 12503,
     /* 241411 */     GIR_EraseRootFromParent_Done,
     /* 241412 */   // Label 4828: @241412
     /* 241412 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241454), // Rule ID 12506 //
     /* 241417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241441 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 241444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241452 */     GIR_RootConstrainSelectedInstOperands,
     /* 241453 */     // GIR_Coverage, 12506,
     /* 241453 */     GIR_EraseRootFromParent_Done,
     /* 241454 */   // Label 4829: @241454
     /* 241454 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241496), // Rule ID 12509 //
     /* 241459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241483 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 241486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241494 */     GIR_RootConstrainSelectedInstOperands,
     /* 241495 */     // GIR_Coverage, 12509,
     /* 241495 */     GIR_EraseRootFromParent_Done,
     /* 241496 */   // Label 4830: @241496
     /* 241496 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241538), // Rule ID 12512 //
     /* 241501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241536 */     GIR_RootConstrainSelectedInstOperands,
     /* 241537 */     // GIR_Coverage, 12512,
     /* 241537 */     GIR_EraseRootFromParent_Done,
     /* 241538 */   // Label 4831: @241538
     /* 241538 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241580), // Rule ID 12515 //
     /* 241543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241567 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241578 */     GIR_RootConstrainSelectedInstOperands,
     /* 241579 */     // GIR_Coverage, 12515,
     /* 241579 */     GIR_EraseRootFromParent_Done,
     /* 241580 */   // Label 4832: @241580
     /* 241580 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241622), // Rule ID 12518 //
     /* 241585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241609 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241620 */     GIR_RootConstrainSelectedInstOperands,
     /* 241621 */     // GIR_Coverage, 12518,
     /* 241621 */     GIR_EraseRootFromParent_Done,
     /* 241622 */   // Label 4833: @241622
     /* 241622 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241664), // Rule ID 12521 //
     /* 241627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 241654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241662 */     GIR_RootConstrainSelectedInstOperands,
     /* 241663 */     // GIR_Coverage, 12521,
     /* 241663 */     GIR_EraseRootFromParent_Done,
     /* 241664 */   // Label 4834: @241664
     /* 241664 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241706), // Rule ID 12524 //
     /* 241669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241693 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 241696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241704 */     GIR_RootConstrainSelectedInstOperands,
     /* 241705 */     // GIR_Coverage, 12524,
     /* 241705 */     GIR_EraseRootFromParent_Done,
     /* 241706 */   // Label 4835: @241706
     /* 241706 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241748), // Rule ID 12527 //
     /* 241711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241735 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 241738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241746 */     GIR_RootConstrainSelectedInstOperands,
     /* 241747 */     // GIR_Coverage, 12527,
     /* 241747 */     GIR_EraseRootFromParent_Done,
     /* 241748 */   // Label 4836: @241748
     /* 241748 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241891), // Rule ID 5588 //
     /* 241753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241774 */     // MIs[0] idx
     /* 241774 */     // No operand predicates
     /* 241774 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241777 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241781 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241791 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241795 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241800 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241803 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241807 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241815 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241851 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241887 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241889 */     GIR_RootConstrainSelectedInstOperands,
     /* 241890 */     // GIR_Coverage, 5588,
     /* 241890 */     GIR_EraseRootFromParent_Done,
     /* 241891 */   // Label 4837: @241891
     /* 241891 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241982), // Rule ID 5589 //
     /* 241896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241917 */     // MIs[0] idx
     /* 241917 */     // No operand predicates
     /* 241917 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241943 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241978 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241980 */     GIR_RootConstrainSelectedInstOperands,
     /* 241981 */     // GIR_Coverage, 5589,
     /* 241981 */     GIR_EraseRootFromParent_Done,
     /* 241982 */   // Label 4838: @241982
     /* 241982 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(242073), // Rule ID 5590 //
     /* 241987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242008 */     // MIs[0] idx
     /* 242008 */     // No operand predicates
     /* 242008 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 242062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242069 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242071 */     GIR_RootConstrainSelectedInstOperands,
     /* 242072 */     // GIR_Coverage, 5590,
     /* 242072 */     GIR_EraseRootFromParent_Done,
     /* 242073 */   // Label 4839: @242073
     /* 242073 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(242112), // Rule ID 5591 //
     /* 242078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242099 */     // MIs[0] idx
     /* 242099 */     // No operand predicates
     /* 242099 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 242102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242108 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242110 */     GIR_RootConstrainSelectedInstOperands,
     /* 242111 */     // GIR_Coverage, 5591,
     /* 242111 */     GIR_EraseRootFromParent_Done,
     /* 242112 */   // Label 4840: @242112
     /* 242112 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(242255), // Rule ID 5592 //
     /* 242117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242138 */     // MIs[0] idx
     /* 242138 */     // No operand predicates
     /* 242138 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242138 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 242141 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242145 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 242152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 242155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242164 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 242167 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242171 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 242174 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242179 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242184 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 242251 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242253 */     GIR_RootConstrainSelectedInstOperands,
     /* 242254 */     // GIR_Coverage, 5592,
     /* 242254 */     GIR_EraseRootFromParent_Done,
     /* 242255 */   // Label 4841: @242255
     /* 242255 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(242346), // Rule ID 5593 //
     /* 242260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242281 */     // MIs[0] idx
     /* 242281 */     // No operand predicates
     /* 242281 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242342 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242344 */     GIR_RootConstrainSelectedInstOperands,
     /* 242345 */     // GIR_Coverage, 5593,
     /* 242345 */     GIR_EraseRootFromParent_Done,
     /* 242346 */   // Label 4842: @242346
     /* 242346 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(242437), // Rule ID 5594 //
     /* 242351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242372 */     // MIs[0] idx
     /* 242372 */     // No operand predicates
     /* 242372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242372 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242375 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242379 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242433 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242435 */     GIR_RootConstrainSelectedInstOperands,
     /* 242436 */     // GIR_Coverage, 5594,
     /* 242436 */     GIR_EraseRootFromParent_Done,
     /* 242437 */   // Label 4843: @242437
     /* 242437 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(242476), // Rule ID 5595 //
     /* 242442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242463 */     // MIs[0] idx
     /* 242463 */     // No operand predicates
     /* 242463 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242472 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242474 */     GIR_RootConstrainSelectedInstOperands,
     /* 242475 */     // GIR_Coverage, 5595,
     /* 242475 */     GIR_EraseRootFromParent_Done,
     /* 242476 */   // Label 4844: @242476
     /* 242476 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(242619), // Rule ID 5596 //
     /* 242481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242502 */     // MIs[0] idx
     /* 242502 */     // No operand predicates
     /* 242502 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242502 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 242505 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242509 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 242516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 242519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242528 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 242531 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242535 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 242538 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242548 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 242615 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242617 */     GIR_RootConstrainSelectedInstOperands,
     /* 242618 */     // GIR_Coverage, 5596,
     /* 242618 */     GIR_EraseRootFromParent_Done,
     /* 242619 */   // Label 4845: @242619
     /* 242619 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(242710), // Rule ID 5597 //
     /* 242624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242645 */     // MIs[0] idx
     /* 242645 */     // No operand predicates
     /* 242645 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242645 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242648 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242652 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242671 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242706 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242708 */     GIR_RootConstrainSelectedInstOperands,
     /* 242709 */     // GIR_Coverage, 5597,
     /* 242709 */     GIR_EraseRootFromParent_Done,
     /* 242710 */   // Label 4846: @242710
     /* 242710 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(242801), // Rule ID 5598 //
     /* 242715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242736 */     // MIs[0] idx
     /* 242736 */     // No operand predicates
     /* 242736 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242797 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242799 */     GIR_RootConstrainSelectedInstOperands,
     /* 242800 */     // GIR_Coverage, 5598,
     /* 242800 */     GIR_EraseRootFromParent_Done,
     /* 242801 */   // Label 4847: @242801
     /* 242801 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(242840), // Rule ID 5599 //
     /* 242806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242827 */     // MIs[0] idx
     /* 242827 */     // No operand predicates
     /* 242827 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242836 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242838 */     GIR_RootConstrainSelectedInstOperands,
     /* 242839 */     // GIR_Coverage, 5599,
     /* 242839 */     GIR_EraseRootFromParent_Done,
     /* 242840 */   // Label 4848: @242840
     /* 242840 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(242879), // Rule ID 5600 //
     /* 242845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 242853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242866 */     // MIs[0] idx
     /* 242866 */     // No operand predicates
     /* 242866 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242875 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242877 */     GIR_RootConstrainSelectedInstOperands,
     /* 242878 */     // GIR_Coverage, 5600,
     /* 242878 */     GIR_EraseRootFromParent_Done,
     /* 242879 */   // Label 4849: @242879
     /* 242879 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242970), // Rule ID 5601 //
     /* 242884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 242892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242905 */     // MIs[0] idx
     /* 242905 */     // No operand predicates
     /* 242905 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242966 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242968 */     GIR_RootConstrainSelectedInstOperands,
     /* 242969 */     // GIR_Coverage, 5601,
     /* 242969 */     GIR_EraseRootFromParent_Done,
     /* 242970 */   // Label 4850: @242970
     /* 242970 */   GIM_Reject,
     /* 242971 */ // Label 3974: @242971
     /* 242971 */ GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(250082),
     /* 242976 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 242979 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(243026), // Rule ID 2965 //
     /* 242984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 243007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243011 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 243011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 243014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243024 */     GIR_RootConstrainSelectedInstOperands,
     /* 243025 */     // GIR_Coverage, 2965,
     /* 243025 */     GIR_EraseRootFromParent_Done,
     /* 243026 */   // Label 4852: @243026
     /* 243026 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(243073), // Rule ID 2967 //
     /* 243031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 243039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243058 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 243058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 243061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243071 */     GIR_RootConstrainSelectedInstOperands,
     /* 243072 */     // GIR_Coverage, 2967,
     /* 243072 */     GIR_EraseRootFromParent_Done,
     /* 243073 */   // Label 4853: @243073
     /* 243073 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(243120), // Rule ID 2969 //
     /* 243078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 243086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 243105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 243108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243118 */     GIR_RootConstrainSelectedInstOperands,
     /* 243119 */     // GIR_Coverage, 2969,
     /* 243119 */     GIR_EraseRootFromParent_Done,
     /* 243120 */   // Label 4854: @243120
     /* 243120 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(243167), // Rule ID 2971 //
     /* 243125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 243133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 243152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 243155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243165 */     GIR_RootConstrainSelectedInstOperands,
     /* 243166 */     // GIR_Coverage, 2971,
     /* 243166 */     GIR_EraseRootFromParent_Done,
     /* 243167 */   // Label 4855: @243167
     /* 243167 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(243214), // Rule ID 7562 //
     /* 243172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 243180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 243195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243199 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 243199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 243202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243212 */     GIR_RootConstrainSelectedInstOperands,
     /* 243213 */     // GIR_Coverage, 7562,
     /* 243213 */     GIR_EraseRootFromParent_Done,
     /* 243214 */   // Label 4856: @243214
     /* 243214 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(243261), // Rule ID 7564 //
     /* 243219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 243227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 243242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 243246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 243249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243259 */     GIR_RootConstrainSelectedInstOperands,
     /* 243260 */     // GIR_Coverage, 7564,
     /* 243260 */     GIR_EraseRootFromParent_Done,
     /* 243261 */   // Label 4857: @243261
     /* 243261 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(243308), // Rule ID 7566 //
     /* 243266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 243274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 243289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243293 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 243293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 243296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243306 */     GIR_RootConstrainSelectedInstOperands,
     /* 243307 */     // GIR_Coverage, 7566,
     /* 243307 */     GIR_EraseRootFromParent_Done,
     /* 243308 */   // Label 4858: @243308
     /* 243308 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(243355), // Rule ID 7568 //
     /* 243313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 243321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 243340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 243343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243353 */     GIR_RootConstrainSelectedInstOperands,
     /* 243354 */     // GIR_Coverage, 7568,
     /* 243354 */     GIR_EraseRootFromParent_Done,
     /* 243355 */   // Label 4859: @243355
     /* 243355 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(243435), // Rule ID 5708 //
     /* 243360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 243377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 243400 */     // MIs[1] Operand 1
     /* 243400 */     // No operand predicates
     /* 243400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243412 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 243416 */     // MIs[2] Operand 1
     /* 243416 */     // No operand predicates
     /* 243416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 243418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 243421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243433 */     GIR_RootConstrainSelectedInstOperands,
     /* 243434 */     // GIR_Coverage, 5708,
     /* 243434 */     GIR_EraseRootFromParent_Done,
     /* 243435 */   // Label 4860: @243435
     /* 243435 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(243515), // Rule ID 5709 //
     /* 243440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 243457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 243480 */     // MIs[1] Operand 1
     /* 243480 */     // No operand predicates
     /* 243480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243492 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 243496 */     // MIs[2] Operand 1
     /* 243496 */     // No operand predicates
     /* 243496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243498 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 243498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 243501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243513 */     GIR_RootConstrainSelectedInstOperands,
     /* 243514 */     // GIR_Coverage, 5709,
     /* 243514 */     GIR_EraseRootFromParent_Done,
     /* 243515 */   // Label 4861: @243515
     /* 243515 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(243595), // Rule ID 5710 //
     /* 243520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 243560 */     // MIs[1] Operand 1
     /* 243560 */     // No operand predicates
     /* 243560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 243576 */     // MIs[2] Operand 1
     /* 243576 */     // No operand predicates
     /* 243576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243578 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 243578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 243581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243593 */     GIR_RootConstrainSelectedInstOperands,
     /* 243594 */     // GIR_Coverage, 5710,
     /* 243594 */     GIR_EraseRootFromParent_Done,
     /* 243595 */   // Label 4862: @243595
     /* 243595 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(243675), // Rule ID 5711 //
     /* 243600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 243608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 243611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 243617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 243640 */     // MIs[1] Operand 1
     /* 243640 */     // No operand predicates
     /* 243640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 243656 */     // MIs[2] Operand 1
     /* 243656 */     // No operand predicates
     /* 243656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243658 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 243658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 243661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243673 */     GIR_RootConstrainSelectedInstOperands,
     /* 243674 */     // GIR_Coverage, 5711,
     /* 243674 */     GIR_EraseRootFromParent_Done,
     /* 243675 */   // Label 4863: @243675
     /* 243675 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(243739), // Rule ID 3849 //
     /* 243680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 243688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243716 */     // MIs[0] imm
     /* 243716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 243727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243735 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243737 */     GIR_RootConstrainSelectedInstOperands,
     /* 243738 */     // GIR_Coverage, 3849,
     /* 243738 */     GIR_EraseRootFromParent_Done,
     /* 243739 */   // Label 4864: @243739
     /* 243739 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(243803), // Rule ID 3850 //
     /* 243744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 243752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243780 */     // MIs[0] imm
     /* 243780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243788 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 243791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243799 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243801 */     GIR_RootConstrainSelectedInstOperands,
     /* 243802 */     // GIR_Coverage, 3850,
     /* 243802 */     GIR_EraseRootFromParent_Done,
     /* 243803 */   // Label 4865: @243803
     /* 243803 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(243867), // Rule ID 3851 //
     /* 243808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 243816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243844 */     // MIs[0] imm
     /* 243844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243852 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 243855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243863 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243865 */     GIR_RootConstrainSelectedInstOperands,
     /* 243866 */     // GIR_Coverage, 3851,
     /* 243866 */     GIR_EraseRootFromParent_Done,
     /* 243867 */   // Label 4866: @243867
     /* 243867 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(243931), // Rule ID 3852 //
     /* 243872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 243880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243908 */     // MIs[0] imm
     /* 243908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 243919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243927 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243929 */     GIR_RootConstrainSelectedInstOperands,
     /* 243930 */     // GIR_Coverage, 3852,
     /* 243930 */     GIR_EraseRootFromParent_Done,
     /* 243931 */   // Label 4867: @243931
     /* 243931 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(243983), // Rule ID 2850 //
     /* 243936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243960 */     // MIs[0] idx
     /* 243960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 243971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243979 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243981 */     GIR_RootConstrainSelectedInstOperands,
     /* 243982 */     // GIR_Coverage, 2850,
     /* 243982 */     GIR_EraseRootFromParent_Done,
     /* 243983 */   // Label 4868: @243983
     /* 243983 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(244035), // Rule ID 2851 //
     /* 243988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244012 */     // MIs[0] idx
     /* 244012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 244023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244031 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244033 */     GIR_RootConstrainSelectedInstOperands,
     /* 244034 */     // GIR_Coverage, 2851,
     /* 244034 */     GIR_EraseRootFromParent_Done,
     /* 244035 */   // Label 4869: @244035
     /* 244035 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(244087), // Rule ID 2852 //
     /* 244040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 244048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244064 */     // MIs[0] idx
     /* 244064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 244075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244083 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244085 */     GIR_RootConstrainSelectedInstOperands,
     /* 244086 */     // GIR_Coverage, 2852,
     /* 244086 */     GIR_EraseRootFromParent_Done,
     /* 244087 */   // Label 4870: @244087
     /* 244087 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(244139), // Rule ID 2980 //
     /* 244092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 244100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244116 */     // MIs[0] Op4
     /* 244116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 244127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244135 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244137 */     GIR_RootConstrainSelectedInstOperands,
     /* 244138 */     // GIR_Coverage, 2980,
     /* 244138 */     GIR_EraseRootFromParent_Done,
     /* 244139 */   // Label 4871: @244139
     /* 244139 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(244191), // Rule ID 2981 //
     /* 244144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 244152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244168 */     // MIs[0] Op4
     /* 244168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 244179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244187 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244189 */     GIR_RootConstrainSelectedInstOperands,
     /* 244190 */     // GIR_Coverage, 2981,
     /* 244190 */     GIR_EraseRootFromParent_Done,
     /* 244191 */   // Label 4872: @244191
     /* 244191 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(244243), // Rule ID 2982 //
     /* 244196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 244204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244220 */     // MIs[0] Op4
     /* 244220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 244231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244241 */     GIR_RootConstrainSelectedInstOperands,
     /* 244242 */     // GIR_Coverage, 2982,
     /* 244242 */     GIR_EraseRootFromParent_Done,
     /* 244243 */   // Label 4873: @244243
     /* 244243 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(244295), // Rule ID 2983 //
     /* 244248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 244256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244272 */     // MIs[0] Op4
     /* 244272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 244283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244293 */     GIR_RootConstrainSelectedInstOperands,
     /* 244294 */     // GIR_Coverage, 2983,
     /* 244294 */     GIR_EraseRootFromParent_Done,
     /* 244295 */   // Label 4874: @244295
     /* 244295 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(244347), // Rule ID 2984 //
     /* 244300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 244308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244324 */     // MIs[0] Op4
     /* 244324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 244335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244343 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244345 */     GIR_RootConstrainSelectedInstOperands,
     /* 244346 */     // GIR_Coverage, 2984,
     /* 244346 */     GIR_EraseRootFromParent_Done,
     /* 244347 */   // Label 4875: @244347
     /* 244347 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(244399), // Rule ID 2987 //
     /* 244352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 244360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244376 */     // MIs[0] Op4
     /* 244376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 244387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244395 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244397 */     GIR_RootConstrainSelectedInstOperands,
     /* 244398 */     // GIR_Coverage, 2987,
     /* 244398 */     GIR_EraseRootFromParent_Done,
     /* 244399 */   // Label 4876: @244399
     /* 244399 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(244451), // Rule ID 2988 //
     /* 244404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 244412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244428 */     // MIs[0] Op4
     /* 244428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 244439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244447 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244449 */     GIR_RootConstrainSelectedInstOperands,
     /* 244450 */     // GIR_Coverage, 2988,
     /* 244450 */     GIR_EraseRootFromParent_Done,
     /* 244451 */   // Label 4877: @244451
     /* 244451 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(244503), // Rule ID 3462 //
     /* 244456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 244459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 244464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244480 */     // MIs[0] Op4
     /* 244480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 244491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244499 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244501 */     GIR_RootConstrainSelectedInstOperands,
     /* 244502 */     // GIR_Coverage, 3462,
     /* 244502 */     GIR_EraseRootFromParent_Done,
     /* 244503 */   // Label 4878: @244503
     /* 244503 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(244555), // Rule ID 3506 //
     /* 244508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 244511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 244516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244532 */     // MIs[0] Op4
     /* 244532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 244543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244551 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244553 */     GIR_RootConstrainSelectedInstOperands,
     /* 244554 */     // GIR_Coverage, 3506,
     /* 244554 */     GIR_EraseRootFromParent_Done,
     /* 244555 */   // Label 4879: @244555
     /* 244555 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(244607), // Rule ID 7636 //
     /* 244560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 244568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244584 */     // MIs[0] Op4
     /* 244584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1957:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 244595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244603 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244605 */     GIR_RootConstrainSelectedInstOperands,
     /* 244606 */     // GIR_Coverage, 7636,
     /* 244606 */     GIR_EraseRootFromParent_Done,
     /* 244607 */   // Label 4880: @244607
     /* 244607 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(244659), // Rule ID 7637 //
     /* 244612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 244620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244636 */     // MIs[0] Op4
     /* 244636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1957:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 244647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244655 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244657 */     GIR_RootConstrainSelectedInstOperands,
     /* 244658 */     // GIR_Coverage, 7637,
     /* 244658 */     GIR_EraseRootFromParent_Done,
     /* 244659 */   // Label 4881: @244659
     /* 244659 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(244711), // Rule ID 8277 //
     /* 244664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244688 */     // MIs[0] idx
     /* 244688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244696 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 244696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 244699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244707 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244709 */     GIR_RootConstrainSelectedInstOperands,
     /* 244710 */     // GIR_Coverage, 8277,
     /* 244710 */     GIR_EraseRootFromParent_Done,
     /* 244711 */   // Label 4882: @244711
     /* 244711 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(244763), // Rule ID 8278 //
     /* 244716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244740 */     // MIs[0] idx
     /* 244740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 244751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244759 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244761 */     GIR_RootConstrainSelectedInstOperands,
     /* 244762 */     // GIR_Coverage, 8278,
     /* 244762 */     GIR_EraseRootFromParent_Done,
     /* 244763 */   // Label 4883: @244763
     /* 244763 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(244815), // Rule ID 8279 //
     /* 244768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244792 */     // MIs[0] idx
     /* 244792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244800 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 244803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244811 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244813 */     GIR_RootConstrainSelectedInstOperands,
     /* 244814 */     // GIR_Coverage, 8279,
     /* 244814 */     GIR_EraseRootFromParent_Done,
     /* 244815 */   // Label 4884: @244815
     /* 244815 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(244867), // Rule ID 11243 //
     /* 244820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 244823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 244828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244844 */     // MIs[0] Op4
     /* 244844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 244855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244865 */     GIR_RootConstrainSelectedInstOperands,
     /* 244866 */     // GIR_Coverage, 11243,
     /* 244866 */     GIR_EraseRootFromParent_Done,
     /* 244867 */   // Label 4885: @244867
     /* 244867 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(244919), // Rule ID 11290 //
     /* 244872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244896 */     // MIs[0] Op4
     /* 244896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 244907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244917 */     GIR_RootConstrainSelectedInstOperands,
     /* 244918 */     // GIR_Coverage, 11290,
     /* 244918 */     GIR_EraseRootFromParent_Done,
     /* 244919 */   // Label 4886: @244919
     /* 244919 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(244971), // Rule ID 11291 //
     /* 244924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244948 */     // MIs[0] Op4
     /* 244948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 244959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244967 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244969 */     GIR_RootConstrainSelectedInstOperands,
     /* 244970 */     // GIR_Coverage, 11291,
     /* 244970 */     GIR_EraseRootFromParent_Done,
     /* 244971 */   // Label 4887: @244971
     /* 244971 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(245023), // Rule ID 11292 //
     /* 244976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245000 */     // MIs[0] Op4
     /* 245000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245008 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 245011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245019 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245021 */     GIR_RootConstrainSelectedInstOperands,
     /* 245022 */     // GIR_Coverage, 11292,
     /* 245022 */     GIR_EraseRootFromParent_Done,
     /* 245023 */   // Label 4888: @245023
     /* 245023 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(245075), // Rule ID 11293 //
     /* 245028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 245036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245052 */     // MIs[0] Op4
     /* 245052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 245063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245071 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245073 */     GIR_RootConstrainSelectedInstOperands,
     /* 245074 */     // GIR_Coverage, 11293,
     /* 245074 */     GIR_EraseRootFromParent_Done,
     /* 245075 */   // Label 4889: @245075
     /* 245075 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(245127), // Rule ID 11294 //
     /* 245080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 245088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245104 */     // MIs[0] Op4
     /* 245104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 245115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245123 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245125 */     GIR_RootConstrainSelectedInstOperands,
     /* 245126 */     // GIR_Coverage, 11294,
     /* 245126 */     GIR_EraseRootFromParent_Done,
     /* 245127 */   // Label 4890: @245127
     /* 245127 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(245179), // Rule ID 11295 //
     /* 245132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 245140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245156 */     // MIs[0] Op4
     /* 245156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 245167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245175 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245177 */     GIR_RootConstrainSelectedInstOperands,
     /* 245178 */     // GIR_Coverage, 11295,
     /* 245178 */     GIR_EraseRootFromParent_Done,
     /* 245179 */   // Label 4891: @245179
     /* 245179 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(245231), // Rule ID 11296 //
     /* 245184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 245192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 245198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245208 */     // MIs[0] Op4
     /* 245208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 245219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245229 */     GIR_RootConstrainSelectedInstOperands,
     /* 245230 */     // GIR_Coverage, 11296,
     /* 245230 */     GIR_EraseRootFromParent_Done,
     /* 245231 */   // Label 4892: @245231
     /* 245231 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(245283), // Rule ID 11297 //
     /* 245236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 245244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245260 */     // MIs[0] Op4
     /* 245260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 245271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245279 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245281 */     GIR_RootConstrainSelectedInstOperands,
     /* 245282 */     // GIR_Coverage, 11297,
     /* 245282 */     GIR_EraseRootFromParent_Done,
     /* 245283 */   // Label 4893: @245283
     /* 245283 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(245335), // Rule ID 11298 //
     /* 245288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 245296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245312 */     // MIs[0] Op4
     /* 245312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 245320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 245320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 245323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245331 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245333 */     GIR_RootConstrainSelectedInstOperands,
     /* 245334 */     // GIR_Coverage, 11298,
     /* 245334 */     GIR_EraseRootFromParent_Done,
     /* 245335 */   // Label 4894: @245335
     /* 245335 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(245387), // Rule ID 11341 //
     /* 245340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 245348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245364 */     // MIs[0] Op4
     /* 245364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245383 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245385 */     GIR_RootConstrainSelectedInstOperands,
     /* 245386 */     // GIR_Coverage, 11341,
     /* 245386 */     GIR_EraseRootFromParent_Done,
     /* 245387 */   // Label 4895: @245387
     /* 245387 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(245439), // Rule ID 11342 //
     /* 245392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 245400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245416 */     // MIs[0] Op4
     /* 245416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 245427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245435 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245437 */     GIR_RootConstrainSelectedInstOperands,
     /* 245438 */     // GIR_Coverage, 11342,
     /* 245438 */     GIR_EraseRootFromParent_Done,
     /* 245439 */   // Label 4896: @245439
     /* 245439 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(245491), // Rule ID 11343 //
     /* 245444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 245452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245468 */     // MIs[0] Op4
     /* 245468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 245479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245489 */     GIR_RootConstrainSelectedInstOperands,
     /* 245490 */     // GIR_Coverage, 11343,
     /* 245490 */     GIR_EraseRootFromParent_Done,
     /* 245491 */   // Label 4897: @245491
     /* 245491 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(245543), // Rule ID 11344 //
     /* 245496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 245504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245520 */     // MIs[0] Op4
     /* 245520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245528 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 245531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245541 */     GIR_RootConstrainSelectedInstOperands,
     /* 245542 */     // GIR_Coverage, 11344,
     /* 245542 */     GIR_EraseRootFromParent_Done,
     /* 245543 */   // Label 4898: @245543
     /* 245543 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(245595), // Rule ID 11345 //
     /* 245548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 245556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245572 */     // MIs[0] Op4
     /* 245572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 245583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245593 */     GIR_RootConstrainSelectedInstOperands,
     /* 245594 */     // GIR_Coverage, 11345,
     /* 245594 */     GIR_EraseRootFromParent_Done,
     /* 245595 */   // Label 4899: @245595
     /* 245595 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(245647), // Rule ID 11346 //
     /* 245600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 245608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245624 */     // MIs[0] Op4
     /* 245624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 245635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245643 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245645 */     GIR_RootConstrainSelectedInstOperands,
     /* 245646 */     // GIR_Coverage, 11346,
     /* 245646 */     GIR_EraseRootFromParent_Done,
     /* 245647 */   // Label 4900: @245647
     /* 245647 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(245699), // Rule ID 11347 //
     /* 245652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 245660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245676 */     // MIs[0] Op4
     /* 245676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245695 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245697 */     GIR_RootConstrainSelectedInstOperands,
     /* 245698 */     // GIR_Coverage, 11347,
     /* 245698 */     GIR_EraseRootFromParent_Done,
     /* 245699 */   // Label 4901: @245699
     /* 245699 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(245751), // Rule ID 11348 //
     /* 245704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 245712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245728 */     // MIs[0] Op4
     /* 245728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 245739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245749 */     GIR_RootConstrainSelectedInstOperands,
     /* 245750 */     // GIR_Coverage, 11348,
     /* 245750 */     GIR_EraseRootFromParent_Done,
     /* 245751 */   // Label 4902: @245751
     /* 245751 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(245803), // Rule ID 11349 //
     /* 245756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 245764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245780 */     // MIs[0] Op4
     /* 245780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 245791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245799 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245801 */     GIR_RootConstrainSelectedInstOperands,
     /* 245802 */     // GIR_Coverage, 11349,
     /* 245802 */     GIR_EraseRootFromParent_Done,
     /* 245803 */   // Label 4903: @245803
     /* 245803 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245855), // Rule ID 11350 //
     /* 245808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 245816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245832 */     // MIs[0] Op4
     /* 245832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 245843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245853 */     GIR_RootConstrainSelectedInstOperands,
     /* 245854 */     // GIR_Coverage, 11350,
     /* 245854 */     GIR_EraseRootFromParent_Done,
     /* 245855 */   // Label 4904: @245855
     /* 245855 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(245907), // Rule ID 11351 //
     /* 245860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245884 */     // MIs[0] Op4
     /* 245884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 245895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245903 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245905 */     GIR_RootConstrainSelectedInstOperands,
     /* 245906 */     // GIR_Coverage, 11351,
     /* 245906 */     GIR_EraseRootFromParent_Done,
     /* 245907 */   // Label 4905: @245907
     /* 245907 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245959), // Rule ID 11352 //
     /* 245912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245936 */     // MIs[0] Op4
     /* 245936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 245947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245955 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245957 */     GIR_RootConstrainSelectedInstOperands,
     /* 245958 */     // GIR_Coverage, 11352,
     /* 245958 */     GIR_EraseRootFromParent_Done,
     /* 245959 */   // Label 4906: @245959
     /* 245959 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(246011), // Rule ID 11353 //
     /* 245964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245988 */     // MIs[0] Op4
     /* 245988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 245999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246009 */     GIR_RootConstrainSelectedInstOperands,
     /* 246010 */     // GIR_Coverage, 11353,
     /* 246010 */     GIR_EraseRootFromParent_Done,
     /* 246011 */   // Label 4907: @246011
     /* 246011 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(246063), // Rule ID 11354 //
     /* 246016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 246024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246040 */     // MIs[0] Op4
     /* 246040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 246051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246061 */     GIR_RootConstrainSelectedInstOperands,
     /* 246062 */     // GIR_Coverage, 11354,
     /* 246062 */     GIR_EraseRootFromParent_Done,
     /* 246063 */   // Label 4908: @246063
     /* 246063 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(246115), // Rule ID 11376 //
     /* 246068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 246076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246092 */     // MIs[0] Op4
     /* 246092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 246103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246113 */     GIR_RootConstrainSelectedInstOperands,
     /* 246114 */     // GIR_Coverage, 11376,
     /* 246114 */     GIR_EraseRootFromParent_Done,
     /* 246115 */   // Label 4909: @246115
     /* 246115 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(246167), // Rule ID 11377 //
     /* 246120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 246128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246144 */     // MIs[0] Op4
     /* 246144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 246155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246165 */     GIR_RootConstrainSelectedInstOperands,
     /* 246166 */     // GIR_Coverage, 11377,
     /* 246166 */     GIR_EraseRootFromParent_Done,
     /* 246167 */   // Label 4910: @246167
     /* 246167 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(246219), // Rule ID 11378 //
     /* 246172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 246180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246196 */     // MIs[0] Op4
     /* 246196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 246207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246217 */     GIR_RootConstrainSelectedInstOperands,
     /* 246218 */     // GIR_Coverage, 11378,
     /* 246218 */     GIR_EraseRootFromParent_Done,
     /* 246219 */   // Label 4911: @246219
     /* 246219 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(246271), // Rule ID 11379 //
     /* 246224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 246232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246248 */     // MIs[0] Op4
     /* 246248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 246259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246269 */     GIR_RootConstrainSelectedInstOperands,
     /* 246270 */     // GIR_Coverage, 11379,
     /* 246270 */     GIR_EraseRootFromParent_Done,
     /* 246271 */   // Label 4912: @246271
     /* 246271 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(246323), // Rule ID 11380 //
     /* 246276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 246284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246300 */     // MIs[0] Op4
     /* 246300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 246311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246321 */     GIR_RootConstrainSelectedInstOperands,
     /* 246322 */     // GIR_Coverage, 11380,
     /* 246322 */     GIR_EraseRootFromParent_Done,
     /* 246323 */   // Label 4913: @246323
     /* 246323 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(246375), // Rule ID 11381 //
     /* 246328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 246336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246352 */     // MIs[0] Op4
     /* 246352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 246363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246371 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246373 */     GIR_RootConstrainSelectedInstOperands,
     /* 246374 */     // GIR_Coverage, 11381,
     /* 246374 */     GIR_EraseRootFromParent_Done,
     /* 246375 */   // Label 4914: @246375
     /* 246375 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(246427), // Rule ID 11382 //
     /* 246380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 246388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246404 */     // MIs[0] Op4
     /* 246404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 246415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246425 */     GIR_RootConstrainSelectedInstOperands,
     /* 246426 */     // GIR_Coverage, 11382,
     /* 246426 */     GIR_EraseRootFromParent_Done,
     /* 246427 */   // Label 4915: @246427
     /* 246427 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(246479), // Rule ID 11383 //
     /* 246432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 246440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246456 */     // MIs[0] Op4
     /* 246456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 246467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246477 */     GIR_RootConstrainSelectedInstOperands,
     /* 246478 */     // GIR_Coverage, 11383,
     /* 246478 */     GIR_EraseRootFromParent_Done,
     /* 246479 */   // Label 4916: @246479
     /* 246479 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(246531), // Rule ID 11837 //
     /* 246484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 246492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246508 */     // MIs[0] Op4
     /* 246508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 246519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246529 */     GIR_RootConstrainSelectedInstOperands,
     /* 246530 */     // GIR_Coverage, 11837,
     /* 246530 */     GIR_EraseRootFromParent_Done,
     /* 246531 */   // Label 4917: @246531
     /* 246531 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(246583), // Rule ID 11838 //
     /* 246536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 246544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246560 */     // MIs[0] Op4
     /* 246560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246568 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 246571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246581 */     GIR_RootConstrainSelectedInstOperands,
     /* 246582 */     // GIR_Coverage, 11838,
     /* 246582 */     GIR_EraseRootFromParent_Done,
     /* 246583 */   // Label 4918: @246583
     /* 246583 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(246635), // Rule ID 11839 //
     /* 246588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 246596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246612 */     // MIs[0] Op4
     /* 246612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 246623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246633 */     GIR_RootConstrainSelectedInstOperands,
     /* 246634 */     // GIR_Coverage, 11839,
     /* 246634 */     GIR_EraseRootFromParent_Done,
     /* 246635 */   // Label 4919: @246635
     /* 246635 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(246687), // Rule ID 11840 //
     /* 246640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 246648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246664 */     // MIs[0] Op4
     /* 246664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246672 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 246675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246685 */     GIR_RootConstrainSelectedInstOperands,
     /* 246686 */     // GIR_Coverage, 11840,
     /* 246686 */     GIR_EraseRootFromParent_Done,
     /* 246687 */   // Label 4920: @246687
     /* 246687 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246739), // Rule ID 11973 //
     /* 246692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 246700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246716 */     // MIs[0] Op4
     /* 246716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246724 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 246727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246737 */     GIR_RootConstrainSelectedInstOperands,
     /* 246738 */     // GIR_Coverage, 11973,
     /* 246738 */     GIR_EraseRootFromParent_Done,
     /* 246739 */   // Label 4921: @246739
     /* 246739 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246791), // Rule ID 11975 //
     /* 246744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 246752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246768 */     // MIs[0] Op4
     /* 246768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246789 */     GIR_RootConstrainSelectedInstOperands,
     /* 246790 */     // GIR_Coverage, 11975,
     /* 246790 */     GIR_EraseRootFromParent_Done,
     /* 246791 */   // Label 4922: @246791
     /* 246791 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246838), // Rule ID 2829 //
     /* 246796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246823 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246836 */     GIR_RootConstrainSelectedInstOperands,
     /* 246837 */     // GIR_Coverage, 2829,
     /* 246837 */     GIR_EraseRootFromParent_Done,
     /* 246838 */   // Label 4923: @246838
     /* 246838 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246885), // Rule ID 2832 //
     /* 246843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246883 */     GIR_RootConstrainSelectedInstOperands,
     /* 246884 */     // GIR_Coverage, 2832,
     /* 246884 */     GIR_EraseRootFromParent_Done,
     /* 246885 */   // Label 4924: @246885
     /* 246885 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246932), // Rule ID 2835 //
     /* 246890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246917 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246928 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246930 */     GIR_RootConstrainSelectedInstOperands,
     /* 246931 */     // GIR_Coverage, 2835,
     /* 246931 */     GIR_EraseRootFromParent_Done,
     /* 246932 */   // Label 4925: @246932
     /* 246932 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246979), // Rule ID 2838 //
     /* 246937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246977 */     GIR_RootConstrainSelectedInstOperands,
     /* 246978 */     // GIR_Coverage, 2838,
     /* 246978 */     GIR_EraseRootFromParent_Done,
     /* 246979 */   // Label 4926: @246979
     /* 246979 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(247026), // Rule ID 2841 //
     /* 246984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247011 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 247014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247024 */     GIR_RootConstrainSelectedInstOperands,
     /* 247025 */     // GIR_Coverage, 2841,
     /* 247025 */     GIR_EraseRootFromParent_Done,
     /* 247026 */   // Label 4927: @247026
     /* 247026 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(247073), // Rule ID 2844 //
     /* 247031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 247039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247058 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 247061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247071 */     GIR_RootConstrainSelectedInstOperands,
     /* 247072 */     // GIR_Coverage, 2844,
     /* 247072 */     GIR_EraseRootFromParent_Done,
     /* 247073 */   // Label 4928: @247073
     /* 247073 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(247120), // Rule ID 2847 //
     /* 247078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 247086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247105 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 247108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247116 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247118 */     GIR_RootConstrainSelectedInstOperands,
     /* 247119 */     // GIR_Coverage, 2847,
     /* 247119 */     GIR_EraseRootFromParent_Done,
     /* 247120 */   // Label 4929: @247120
     /* 247120 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(247167), // Rule ID 2848 //
     /* 247125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 247133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 247155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247165 */     GIR_RootConstrainSelectedInstOperands,
     /* 247166 */     // GIR_Coverage, 2848,
     /* 247166 */     GIR_EraseRootFromParent_Done,
     /* 247167 */   // Label 4930: @247167
     /* 247167 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(247214), // Rule ID 2849 //
     /* 247172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 247180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 247202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247212 */     GIR_RootConstrainSelectedInstOperands,
     /* 247213 */     // GIR_Coverage, 2849,
     /* 247213 */     GIR_EraseRootFromParent_Done,
     /* 247214 */   // Label 4931: @247214
     /* 247214 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(247261), // Rule ID 2945 //
     /* 247219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 247227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 247249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247257 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247259 */     GIR_RootConstrainSelectedInstOperands,
     /* 247260 */     // GIR_Coverage, 2945,
     /* 247260 */     GIR_EraseRootFromParent_Done,
     /* 247261 */   // Label 4932: @247261
     /* 247261 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(247308), // Rule ID 2948 //
     /* 247266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 247274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 247296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247304 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247306 */     GIR_RootConstrainSelectedInstOperands,
     /* 247307 */     // GIR_Coverage, 2948,
     /* 247307 */     GIR_EraseRootFromParent_Done,
     /* 247308 */   // Label 4933: @247308
     /* 247308 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(247355), // Rule ID 2951 //
     /* 247313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 247321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 247343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247353 */     GIR_RootConstrainSelectedInstOperands,
     /* 247354 */     // GIR_Coverage, 2951,
     /* 247354 */     GIR_EraseRootFromParent_Done,
     /* 247355 */   // Label 4934: @247355
     /* 247355 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(247402), // Rule ID 2954 //
     /* 247360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 247368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 247390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247398 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247400 */     GIR_RootConstrainSelectedInstOperands,
     /* 247401 */     // GIR_Coverage, 2954,
     /* 247401 */     GIR_EraseRootFromParent_Done,
     /* 247402 */   // Label 4935: @247402
     /* 247402 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(247449), // Rule ID 2957 //
     /* 247407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247434 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 247437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247447 */     GIR_RootConstrainSelectedInstOperands,
     /* 247448 */     // GIR_Coverage, 2957,
     /* 247448 */     GIR_EraseRootFromParent_Done,
     /* 247449 */   // Label 4936: @247449
     /* 247449 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(247496), // Rule ID 2959 //
     /* 247454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 247484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247494 */     GIR_RootConstrainSelectedInstOperands,
     /* 247495 */     // GIR_Coverage, 2959,
     /* 247495 */     GIR_EraseRootFromParent_Done,
     /* 247496 */   // Label 4937: @247496
     /* 247496 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(247543), // Rule ID 2961 //
     /* 247501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247528 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247541 */     GIR_RootConstrainSelectedInstOperands,
     /* 247542 */     // GIR_Coverage, 2961,
     /* 247542 */     GIR_EraseRootFromParent_Done,
     /* 247543 */   // Label 4938: @247543
     /* 247543 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(247590), // Rule ID 2963 //
     /* 247548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247575 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 247578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247588 */     GIR_RootConstrainSelectedInstOperands,
     /* 247589 */     // GIR_Coverage, 2963,
     /* 247589 */     GIR_EraseRootFromParent_Done,
     /* 247590 */   // Label 4939: @247590
     /* 247590 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(247637), // Rule ID 7542 //
     /* 247595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247622 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247635 */     GIR_RootConstrainSelectedInstOperands,
     /* 247636 */     // GIR_Coverage, 7542,
     /* 247636 */     GIR_EraseRootFromParent_Done,
     /* 247637 */   // Label 4940: @247637
     /* 247637 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(247684), // Rule ID 7545 //
     /* 247642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 247672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247680 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247682 */     GIR_RootConstrainSelectedInstOperands,
     /* 247683 */     // GIR_Coverage, 7545,
     /* 247683 */     GIR_EraseRootFromParent_Done,
     /* 247684 */   // Label 4941: @247684
     /* 247684 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(247731), // Rule ID 7548 //
     /* 247689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 247719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247729 */     GIR_RootConstrainSelectedInstOperands,
     /* 247730 */     // GIR_Coverage, 7548,
     /* 247730 */     GIR_EraseRootFromParent_Done,
     /* 247731 */   // Label 4942: @247731
     /* 247731 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247778), // Rule ID 7551 //
     /* 247736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 247766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247774 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247776 */     GIR_RootConstrainSelectedInstOperands,
     /* 247777 */     // GIR_Coverage, 7551,
     /* 247777 */     GIR_EraseRootFromParent_Done,
     /* 247778 */   // Label 4943: @247778
     /* 247778 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247825), // Rule ID 7554 //
     /* 247783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 247813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247821 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247823 */     GIR_RootConstrainSelectedInstOperands,
     /* 247824 */     // GIR_Coverage, 7554,
     /* 247824 */     GIR_EraseRootFromParent_Done,
     /* 247825 */   // Label 4944: @247825
     /* 247825 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247872), // Rule ID 7556 //
     /* 247830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 247860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247868 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247870 */     GIR_RootConstrainSelectedInstOperands,
     /* 247871 */     // GIR_Coverage, 7556,
     /* 247871 */     GIR_EraseRootFromParent_Done,
     /* 247872 */   // Label 4945: @247872
     /* 247872 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247919), // Rule ID 7558 //
     /* 247877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 247907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247915 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247917 */     GIR_RootConstrainSelectedInstOperands,
     /* 247918 */     // GIR_Coverage, 7558,
     /* 247918 */     GIR_EraseRootFromParent_Done,
     /* 247919 */   // Label 4946: @247919
     /* 247919 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247966), // Rule ID 7560 //
     /* 247924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 247954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247962 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247964 */     GIR_RootConstrainSelectedInstOperands,
     /* 247965 */     // GIR_Coverage, 7560,
     /* 247965 */     GIR_EraseRootFromParent_Done,
     /* 247966 */   // Label 4947: @247966
     /* 247966 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(248013), // Rule ID 8190 //
     /* 247971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247998 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248011 */     GIR_RootConstrainSelectedInstOperands,
     /* 248012 */     // GIR_Coverage, 8190,
     /* 248012 */     GIR_EraseRootFromParent_Done,
     /* 248013 */   // Label 4948: @248013
     /* 248013 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(248060), // Rule ID 8193 //
     /* 248018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 248026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248045 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 248048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248056 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248058 */     GIR_RootConstrainSelectedInstOperands,
     /* 248059 */     // GIR_Coverage, 8193,
     /* 248059 */     GIR_EraseRootFromParent_Done,
     /* 248060 */   // Label 4949: @248060
     /* 248060 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(248107), // Rule ID 8196 //
     /* 248065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 248073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248092 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 248095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248103 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248105 */     GIR_RootConstrainSelectedInstOperands,
     /* 248106 */     // GIR_Coverage, 8196,
     /* 248106 */     GIR_EraseRootFromParent_Done,
     /* 248107 */   // Label 4950: @248107
     /* 248107 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(248154), // Rule ID 8199 //
     /* 248112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 248120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 248142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248150 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248152 */     GIR_RootConstrainSelectedInstOperands,
     /* 248153 */     // GIR_Coverage, 8199,
     /* 248153 */     GIR_EraseRootFromParent_Done,
     /* 248154 */   // Label 4951: @248154
     /* 248154 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(248201), // Rule ID 8202 //
     /* 248159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 248167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248186 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 248189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248197 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248199 */     GIR_RootConstrainSelectedInstOperands,
     /* 248200 */     // GIR_Coverage, 8202,
     /* 248200 */     GIR_EraseRootFromParent_Done,
     /* 248201 */   // Label 4952: @248201
     /* 248201 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(248248), // Rule ID 8205 //
     /* 248206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 248214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248233 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 248236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248246 */     GIR_RootConstrainSelectedInstOperands,
     /* 248247 */     // GIR_Coverage, 8205,
     /* 248247 */     GIR_EraseRootFromParent_Done,
     /* 248248 */   // Label 4953: @248248
     /* 248248 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(248295), // Rule ID 8208 //
     /* 248253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 248283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248291 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248293 */     GIR_RootConstrainSelectedInstOperands,
     /* 248294 */     // GIR_Coverage, 8208,
     /* 248294 */     GIR_EraseRootFromParent_Done,
     /* 248295 */   // Label 4954: @248295
     /* 248295 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(248342), // Rule ID 8209 //
     /* 248300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248327 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 248330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248340 */     GIR_RootConstrainSelectedInstOperands,
     /* 248341 */     // GIR_Coverage, 8209,
     /* 248341 */     GIR_EraseRootFromParent_Done,
     /* 248342 */   // Label 4955: @248342
     /* 248342 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(248389), // Rule ID 8210 //
     /* 248347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248374 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 248377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248387 */     GIR_RootConstrainSelectedInstOperands,
     /* 248388 */     // GIR_Coverage, 8210,
     /* 248388 */     GIR_EraseRootFromParent_Done,
     /* 248389 */   // Label 4956: @248389
     /* 248389 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(248436), // Rule ID 8211 //
     /* 248394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 248424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248434 */     GIR_RootConstrainSelectedInstOperands,
     /* 248435 */     // GIR_Coverage, 8211,
     /* 248435 */     GIR_EraseRootFromParent_Done,
     /* 248436 */   // Label 4957: @248436
     /* 248436 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(248483), // Rule ID 8212 //
     /* 248441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248468 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 248471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248479 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248481 */     GIR_RootConstrainSelectedInstOperands,
     /* 248482 */     // GIR_Coverage, 8212,
     /* 248482 */     GIR_EraseRootFromParent_Done,
     /* 248483 */   // Label 4958: @248483
     /* 248483 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(248530), // Rule ID 8213 //
     /* 248488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248515 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 248518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248528 */     GIR_RootConstrainSelectedInstOperands,
     /* 248529 */     // GIR_Coverage, 8213,
     /* 248529 */     GIR_EraseRootFromParent_Done,
     /* 248530 */   // Label 4959: @248530
     /* 248530 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(248577), // Rule ID 8214 //
     /* 248535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248575 */     GIR_RootConstrainSelectedInstOperands,
     /* 248576 */     // GIR_Coverage, 8214,
     /* 248576 */     GIR_EraseRootFromParent_Done,
     /* 248577 */   // Label 4960: @248577
     /* 248577 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(248624), // Rule ID 8215 //
     /* 248582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248609 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248622 */     GIR_RootConstrainSelectedInstOperands,
     /* 248623 */     // GIR_Coverage, 8215,
     /* 248623 */     GIR_EraseRootFromParent_Done,
     /* 248624 */   // Label 4961: @248624
     /* 248624 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(248671), // Rule ID 8216 //
     /* 248629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248656 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248669 */     GIR_RootConstrainSelectedInstOperands,
     /* 248670 */     // GIR_Coverage, 8216,
     /* 248670 */     GIR_EraseRootFromParent_Done,
     /* 248671 */   // Label 4962: @248671
     /* 248671 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248718), // Rule ID 8217 //
     /* 248676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248703 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 248706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248716 */     GIR_RootConstrainSelectedInstOperands,
     /* 248717 */     // GIR_Coverage, 8217,
     /* 248717 */     GIR_EraseRootFromParent_Done,
     /* 248718 */   // Label 4963: @248718
     /* 248718 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248765), // Rule ID 8218 //
     /* 248723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248750 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 248753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248763 */     GIR_RootConstrainSelectedInstOperands,
     /* 248764 */     // GIR_Coverage, 8218,
     /* 248764 */     GIR_EraseRootFromParent_Done,
     /* 248765 */   // Label 4964: @248765
     /* 248765 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248812), // Rule ID 8219 //
     /* 248770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248797 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 248800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248808 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248810 */     GIR_RootConstrainSelectedInstOperands,
     /* 248811 */     // GIR_Coverage, 8219,
     /* 248811 */     GIR_EraseRootFromParent_Done,
     /* 248812 */   // Label 4965: @248812
     /* 248812 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248859), // Rule ID 8220 //
     /* 248817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 248847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248855 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248857 */     GIR_RootConstrainSelectedInstOperands,
     /* 248858 */     // GIR_Coverage, 8220,
     /* 248858 */     GIR_EraseRootFromParent_Done,
     /* 248859 */   // Label 4966: @248859
     /* 248859 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248906), // Rule ID 8221 //
     /* 248864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 248894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248902 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248904 */     GIR_RootConstrainSelectedInstOperands,
     /* 248905 */     // GIR_Coverage, 8221,
     /* 248905 */     GIR_EraseRootFromParent_Done,
     /* 248906 */   // Label 4967: @248906
     /* 248906 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248953), // Rule ID 8222 //
     /* 248911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248938 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 248941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248951 */     GIR_RootConstrainSelectedInstOperands,
     /* 248952 */     // GIR_Coverage, 8222,
     /* 248952 */     GIR_EraseRootFromParent_Done,
     /* 248953 */   // Label 4968: @248953
     /* 248953 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(249000), // Rule ID 8223 //
     /* 248958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248985 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 248988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248998 */     GIR_RootConstrainSelectedInstOperands,
     /* 248999 */     // GIR_Coverage, 8223,
     /* 248999 */     GIR_EraseRootFromParent_Done,
     /* 249000 */   // Label 4969: @249000
     /* 249000 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(249047), // Rule ID 8224 //
     /* 249005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 249013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249032 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 249035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249045 */     GIR_RootConstrainSelectedInstOperands,
     /* 249046 */     // GIR_Coverage, 8224,
     /* 249046 */     GIR_EraseRootFromParent_Done,
     /* 249047 */   // Label 4970: @249047
     /* 249047 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(249094), // Rule ID 8225 //
     /* 249052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 249060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 249082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249090 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249092 */     GIR_RootConstrainSelectedInstOperands,
     /* 249093 */     // GIR_Coverage, 8225,
     /* 249093 */     GIR_EraseRootFromParent_Done,
     /* 249094 */   // Label 4971: @249094
     /* 249094 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(249141), // Rule ID 8226 //
     /* 249099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 249107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249126 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249139 */     GIR_RootConstrainSelectedInstOperands,
     /* 249140 */     // GIR_Coverage, 8226,
     /* 249140 */     GIR_EraseRootFromParent_Done,
     /* 249141 */   // Label 4972: @249141
     /* 249141 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(249188), // Rule ID 8227 //
     /* 249146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 249154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249173 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 249176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249184 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249186 */     GIR_RootConstrainSelectedInstOperands,
     /* 249187 */     // GIR_Coverage, 8227,
     /* 249187 */     GIR_EraseRootFromParent_Done,
     /* 249188 */   // Label 4973: @249188
     /* 249188 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(249235), // Rule ID 8228 //
     /* 249193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 249201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249220 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 249223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249231 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249233 */     GIR_RootConstrainSelectedInstOperands,
     /* 249234 */     // GIR_Coverage, 8228,
     /* 249234 */     GIR_EraseRootFromParent_Done,
     /* 249235 */   // Label 4974: @249235
     /* 249235 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(249282), // Rule ID 8229 //
     /* 249240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249267 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 249270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249278 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249280 */     GIR_RootConstrainSelectedInstOperands,
     /* 249281 */     // GIR_Coverage, 8229,
     /* 249281 */     GIR_EraseRootFromParent_Done,
     /* 249282 */   // Label 4975: @249282
     /* 249282 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(249329), // Rule ID 8232 //
     /* 249287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 249317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249327 */     GIR_RootConstrainSelectedInstOperands,
     /* 249328 */     // GIR_Coverage, 8232,
     /* 249328 */     GIR_EraseRootFromParent_Done,
     /* 249329 */   // Label 4976: @249329
     /* 249329 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(249376), // Rule ID 8235 //
     /* 249334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249361 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 249364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249374 */     GIR_RootConstrainSelectedInstOperands,
     /* 249375 */     // GIR_Coverage, 8235,
     /* 249375 */     GIR_EraseRootFromParent_Done,
     /* 249376 */   // Label 4977: @249376
     /* 249376 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(249423), // Rule ID 8238 //
     /* 249381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 249411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249419 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249421 */     GIR_RootConstrainSelectedInstOperands,
     /* 249422 */     // GIR_Coverage, 8238,
     /* 249422 */     GIR_EraseRootFromParent_Done,
     /* 249423 */   // Label 4978: @249423
     /* 249423 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(249470), // Rule ID 8241 //
     /* 249428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249455 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 249458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249468 */     GIR_RootConstrainSelectedInstOperands,
     /* 249469 */     // GIR_Coverage, 8241,
     /* 249469 */     GIR_EraseRootFromParent_Done,
     /* 249470 */   // Label 4979: @249470
     /* 249470 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(249517), // Rule ID 8244 //
     /* 249475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249502 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 249505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249515 */     GIR_RootConstrainSelectedInstOperands,
     /* 249516 */     // GIR_Coverage, 8244,
     /* 249516 */     GIR_EraseRootFromParent_Done,
     /* 249517 */   // Label 4980: @249517
     /* 249517 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(249564), // Rule ID 8247 //
     /* 249522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249549 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249560 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249562 */     GIR_RootConstrainSelectedInstOperands,
     /* 249563 */     // GIR_Coverage, 8247,
     /* 249563 */     GIR_EraseRootFromParent_Done,
     /* 249564 */   // Label 4981: @249564
     /* 249564 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(249611), // Rule ID 8250 //
     /* 249569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249609 */     GIR_RootConstrainSelectedInstOperands,
     /* 249610 */     // GIR_Coverage, 8250,
     /* 249610 */     GIR_EraseRootFromParent_Done,
     /* 249611 */   // Label 4982: @249611
     /* 249611 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249658), // Rule ID 8253 //
     /* 249616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249643 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249654 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249656 */     GIR_RootConstrainSelectedInstOperands,
     /* 249657 */     // GIR_Coverage, 8253,
     /* 249657 */     GIR_EraseRootFromParent_Done,
     /* 249658 */   // Label 4983: @249658
     /* 249658 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249705), // Rule ID 8256 //
     /* 249663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 249693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249703 */     GIR_RootConstrainSelectedInstOperands,
     /* 249704 */     // GIR_Coverage, 8256,
     /* 249704 */     GIR_EraseRootFromParent_Done,
     /* 249705 */   // Label 4984: @249705
     /* 249705 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249752), // Rule ID 8259 //
     /* 249710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249737 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 249740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249748 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249750 */     GIR_RootConstrainSelectedInstOperands,
     /* 249751 */     // GIR_Coverage, 8259,
     /* 249751 */     GIR_EraseRootFromParent_Done,
     /* 249752 */   // Label 4985: @249752
     /* 249752 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249799), // Rule ID 8262 //
     /* 249757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 249787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249795 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249797 */     GIR_RootConstrainSelectedInstOperands,
     /* 249798 */     // GIR_Coverage, 8262,
     /* 249798 */     GIR_EraseRootFromParent_Done,
     /* 249799 */   // Label 4986: @249799
     /* 249799 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249846), // Rule ID 8265 //
     /* 249804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249831 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249842 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249844 */     GIR_RootConstrainSelectedInstOperands,
     /* 249845 */     // GIR_Coverage, 8265,
     /* 249845 */     GIR_EraseRootFromParent_Done,
     /* 249846 */   // Label 4987: @249846
     /* 249846 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249893), // Rule ID 8267 //
     /* 249851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249878 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249889 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249891 */     GIR_RootConstrainSelectedInstOperands,
     /* 249892 */     // GIR_Coverage, 8267,
     /* 249892 */     GIR_EraseRootFromParent_Done,
     /* 249893 */   // Label 4988: @249893
     /* 249893 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249940), // Rule ID 8269 //
     /* 249898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249925 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249936 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249938 */     GIR_RootConstrainSelectedInstOperands,
     /* 249939 */     // GIR_Coverage, 8269,
     /* 249939 */     GIR_EraseRootFromParent_Done,
     /* 249940 */   // Label 4989: @249940
     /* 249940 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249987), // Rule ID 8271 //
     /* 249945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249985 */     GIR_RootConstrainSelectedInstOperands,
     /* 249986 */     // GIR_Coverage, 8271,
     /* 249986 */     GIR_EraseRootFromParent_Done,
     /* 249987 */   // Label 4990: @249987
     /* 249987 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(250034), // Rule ID 8273 //
     /* 249992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 250000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 250003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 250009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 250012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 250015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250019 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 250019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 250022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250030 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250032 */     GIR_RootConstrainSelectedInstOperands,
     /* 250033 */     // GIR_Coverage, 8273,
     /* 250033 */     GIR_EraseRootFromParent_Done,
     /* 250034 */   // Label 4991: @250034
     /* 250034 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(250081), // Rule ID 8275 //
     /* 250039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 250042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 250047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 250062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250066 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 250066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 250069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250077 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 250079 */     GIR_RootConstrainSelectedInstOperands,
     /* 250080 */     // GIR_Coverage, 8275,
     /* 250080 */     GIR_EraseRootFromParent_Done,
     /* 250081 */   // Label 4992: @250081
     /* 250081 */   GIM_Reject,
     /* 250082 */ // Label 4851: @250082
     /* 250082 */ GIM_Reject,
     /* 250083 */ // Label 36: @250083
     /* 250083 */ GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(250161),
     /* 250088 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 250091 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(250113), // Rule ID 78 //
     /* 250096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 250104 */     // (intrinsic_void 2166:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 250104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 250107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250111 */     GIR_RootConstrainSelectedInstOperands,
     /* 250112 */     // GIR_Coverage, 78,
     /* 250112 */     GIR_EraseRootFromParent_Done,
     /* 250113 */   // Label 4994: @250113
     /* 250113 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(250138), // Rule ID 2386 //
     /* 250118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 250126 */     // (intrinsic_void 1716:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 250126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 250129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 250132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250136 */     GIR_RootConstrainSelectedInstOperands,
     /* 250137 */     // GIR_Coverage, 2386,
     /* 250137 */     GIR_EraseRootFromParent_Done,
     /* 250138 */   // Label 4995: @250138
     /* 250138 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(250160), // Rule ID 7126 //
     /* 250143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 250148 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 250148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 250151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 250154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250158 */     GIR_RootConstrainSelectedInstOperands,
     /* 250159 */     // GIR_Coverage, 7126,
     /* 250159 */     GIR_EraseRootFromParent_Done,
     /* 250160 */   // Label 4996: @250160
     /* 250160 */   GIM_Reject,
     /* 250161 */ // Label 4993: @250161
     /* 250161 */ GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(250761),
     /* 250166 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 250169 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(250201), // Rule ID 79 //
     /* 250174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 250182 */     // MIs[0] imm
     /* 250182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 250190 */     // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 250190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 250193 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 250195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250199 */     GIR_RootConstrainSelectedInstOperands,
     /* 250200 */     // GIR_Coverage, 79,
     /* 250200 */     GIR_EraseRootFromParent_Done,
     /* 250201 */   // Label 4998: @250201
     /* 250201 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(250226), // Rule ID 227 //
     /* 250206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 250211 */     // MIs[0] imm
     /* 250211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 250219 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 250219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 250222 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 250224 */     GIR_RootConstrainSelectedInstOperands,
     /* 250225 */     // GIR_Coverage, 227,
     /* 250225 */     GIR_EraseRootFromParent_Done,
     /* 250226 */   // Label 4999: @250226
     /* 250226 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(250251), // Rule ID 228 //
     /* 250231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 250236 */     // MIs[0] imm
     /* 250236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 250244 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 250244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 250247 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 250249 */     GIR_RootConstrainSelectedInstOperands,
     /* 250250 */     // GIR_Coverage, 228,
     /* 250250 */     GIR_EraseRootFromParent_Done,
     /* 250251 */   // Label 5000: @250251
     /* 250251 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(250283), // Rule ID 3624 //
     /* 250256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 250259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 250264 */     // MIs[0] imm
     /* 250264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 250267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 250272 */     // (intrinsic_void 1222:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 250272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 250277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250281 */     GIR_RootConstrainSelectedInstOperands,
     /* 250282 */     // GIR_Coverage, 3624,
     /* 250282 */     GIR_EraseRootFromParent_Done,
     /* 250283 */   // Label 5001: @250283
     /* 250283 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(250323), // Rule ID 16 //
     /* 250288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 250293 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 250308 */     // MIs[1] Operand 1
     /* 250308 */     // No operand predicates
     /* 250308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250310 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 250310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 250313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 250316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250321 */     GIR_RootConstrainSelectedInstOperands,
     /* 250322 */     // GIR_Coverage, 16,
     /* 250322 */     GIR_EraseRootFromParent_Done,
     /* 250323 */   // Label 5002: @250323
     /* 250323 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(250363), // Rule ID 17 //
     /* 250328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 250333 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250348 */     // MIs[1] Operand 1
     /* 250348 */     // No operand predicates
     /* 250348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250350 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 250350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 250353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250361 */     GIR_RootConstrainSelectedInstOperands,
     /* 250362 */     // GIR_Coverage, 17,
     /* 250362 */     GIR_EraseRootFromParent_Done,
     /* 250363 */   // Label 5003: @250363
     /* 250363 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(250403), // Rule ID 18 //
     /* 250368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 250373 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250388 */     // MIs[1] Operand 1
     /* 250388 */     // No operand predicates
     /* 250388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250390 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 250390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 250393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250401 */     GIR_RootConstrainSelectedInstOperands,
     /* 250402 */     // GIR_Coverage, 18,
     /* 250402 */     GIR_EraseRootFromParent_Done,
     /* 250403 */   // Label 5004: @250403
     /* 250403 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250443), // Rule ID 19 //
     /* 250408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 250413 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250428 */     // MIs[1] Operand 1
     /* 250428 */     // No operand predicates
     /* 250428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250430 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 250430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 250433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250441 */     GIR_RootConstrainSelectedInstOperands,
     /* 250442 */     // GIR_Coverage, 19,
     /* 250442 */     GIR_EraseRootFromParent_Done,
     /* 250443 */   // Label 5005: @250443
     /* 250443 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250467), // Rule ID 72 //
     /* 250448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 250453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250460 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 250460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 250463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250465 */     GIR_RootConstrainSelectedInstOperands,
     /* 250466 */     // GIR_Coverage, 72,
     /* 250466 */     GIR_EraseRootFromParent_Done,
     /* 250467 */   // Label 5006: @250467
     /* 250467 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250491), // Rule ID 74 //
     /* 250472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 250477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250484 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 250484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 250487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250489 */     GIR_RootConstrainSelectedInstOperands,
     /* 250490 */     // GIR_Coverage, 74,
     /* 250490 */     GIR_EraseRootFromParent_Done,
     /* 250491 */   // Label 5007: @250491
     /* 250491 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250522), // Rule ID 77 //
     /* 250496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 250504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250511 */     // (intrinsic_w_chain:{ *:[i64] } 2167:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 250511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 250514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250520 */     GIR_RootConstrainSelectedInstOperands,
     /* 250521 */     // GIR_Coverage, 77,
     /* 250521 */     GIR_EraseRootFromParent_Done,
     /* 250522 */   // Label 5008: @250522
     /* 250522 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250549), // Rule ID 80 //
     /* 250527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 250535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250542 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 250542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 250545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250547 */     GIR_RootConstrainSelectedInstOperands,
     /* 250548 */     // GIR_Coverage, 80,
     /* 250548 */     GIR_EraseRootFromParent_Done,
     /* 250549 */   // Label 5009: @250549
     /* 250549 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250580), // Rule ID 2385 //
     /* 250554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 250562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 250565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250569 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1666:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 250569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 250572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 250574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250578 */     GIR_RootConstrainSelectedInstOperands,
     /* 250579 */     // GIR_Coverage, 2385,
     /* 250579 */     GIR_EraseRootFromParent_Done,
     /* 250580 */   // Label 5010: @250580
     /* 250580 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250620), // Rule ID 12759 //
     /* 250585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 250588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 250593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250600 */     // (intrinsic_w_chain:{ *:[i64] } 891:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 250600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 250603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250605 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 250615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 250618 */     GIR_RootConstrainSelectedInstOperands,
     /* 250619 */     // GIR_Coverage, 12759,
     /* 250619 */     GIR_EraseRootFromParent_Done,
     /* 250620 */   // Label 5011: @250620
     /* 250620 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250654), // Rule ID 2387 //
     /* 250625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 250633 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 250636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250640 */     // (intrinsic_void 2146:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 250640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 250643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 250645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 250648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250652 */     GIR_RootConstrainSelectedInstOperands,
     /* 250653 */     // GIR_Coverage, 2387,
     /* 250653 */     GIR_EraseRootFromParent_Done,
     /* 250654 */   // Label 5012: @250654
     /* 250654 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250677), // Rule ID 73 //
     /* 250659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 250664 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250667 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 250667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 250670 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 250675 */     GIR_RootConstrainSelectedInstOperands,
     /* 250676 */     // GIR_Coverage, 73,
     /* 250676 */     GIR_EraseRootFromParent_Done,
     /* 250677 */   // Label 5013: @250677
     /* 250677 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250700), // Rule ID 75 //
     /* 250682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 250687 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250690 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 250690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 250693 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 250698 */     GIR_RootConstrainSelectedInstOperands,
     /* 250699 */     // GIR_Coverage, 75,
     /* 250699 */     GIR_EraseRootFromParent_Done,
     /* 250700 */   // Label 5014: @250700
     /* 250700 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250727), // Rule ID 76 //
     /* 250705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 250710 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250713 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 250713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 250716 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 250721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250725 */     GIR_RootConstrainSelectedInstOperands,
     /* 250726 */     // GIR_Coverage, 76,
     /* 250726 */     GIR_EraseRootFromParent_Done,
     /* 250727 */   // Label 5015: @250727
     /* 250727 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250760), // Rule ID 12758 //
     /* 250732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 250735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 250740 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250743 */     // (intrinsic_void 966:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 250743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 250746 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 250756 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250758 */     GIR_RootConstrainSelectedInstOperands,
     /* 250759 */     // GIR_Coverage, 12758,
     /* 250759 */     GIR_EraseRootFromParent_Done,
     /* 250760 */   // Label 5016: @250760
     /* 250760 */   GIM_Reject,
     /* 250761 */ // Label 4997: @250761
     /* 250761 */ GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(251732),
     /* 250766 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 250769 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250845), // Rule ID 7092 //
     /* 250774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250786 */     // MIs[0] addr
     /* 250786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 250798 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 250805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250814 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250844 */     // GIR_Coverage, 7092,
     /* 250844 */     GIR_EraseRootFromParent_Done,
     /* 250845 */   // Label 5018: @250845
     /* 250845 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250921), // Rule ID 7093 //
     /* 250850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250862 */     // MIs[0] addr
     /* 250862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 250874 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 250881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250920 */     // GIR_Coverage, 7093,
     /* 250920 */     GIR_EraseRootFromParent_Done,
     /* 250921 */   // Label 5019: @250921
     /* 250921 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250997), // Rule ID 7094 //
     /* 250926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250938 */     // MIs[0] addr
     /* 250938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 250950 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 250957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250966 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250996 */     // GIR_Coverage, 7094,
     /* 250996 */     GIR_EraseRootFromParent_Done,
     /* 250997 */   // Label 5020: @250997
     /* 250997 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(251039), // Rule ID 7095 //
     /* 251002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 251007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251014 */     // MIs[0] addr
     /* 251014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 251026 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 251026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 251029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 251031 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 251033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251037 */     GIR_RootConstrainSelectedInstOperands,
     /* 251038 */     // GIR_Coverage, 7095,
     /* 251038 */     GIR_EraseRootFromParent_Done,
     /* 251039 */   // Label 5021: @251039
     /* 251039 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(251115), // Rule ID 7099 //
     /* 251044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 251049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251056 */     // MIs[0] addr
     /* 251056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 251068 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 251068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 251075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 251084 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 251093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 251104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251114 */     // GIR_Coverage, 7099,
     /* 251114 */     GIR_EraseRootFromParent_Done,
     /* 251115 */   // Label 5022: @251115
     /* 251115 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(251191), // Rule ID 7100 //
     /* 251120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 251125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251132 */     // MIs[0] addr
     /* 251132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 251144 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 251144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 251151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 251160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 251169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 251180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251190 */     // GIR_Coverage, 7100,
     /* 251190 */     GIR_EraseRootFromParent_Done,
     /* 251191 */   // Label 5023: @251191
     /* 251191 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(251267), // Rule ID 7101 //
     /* 251196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 251201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251208 */     // MIs[0] addr
     /* 251208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 251220 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 251220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 251227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 251236 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 251245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 251256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 251261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251266 */     // GIR_Coverage, 7101,
     /* 251266 */     GIR_EraseRootFromParent_Done,
     /* 251267 */   // Label 5024: @251267
     /* 251267 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(251309), // Rule ID 7102 //
     /* 251272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 251277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251284 */     // MIs[0] addr
     /* 251284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 251288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 251296 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 251296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 251299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 251301 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 251303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251307 */     GIR_RootConstrainSelectedInstOperands,
     /* 251308 */     // GIR_Coverage, 7102,
     /* 251308 */     GIR_EraseRootFromParent_Done,
     /* 251309 */   // Label 5025: @251309
     /* 251309 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251349), // Rule ID 20 //
     /* 251314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 251317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 251322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251336 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 251336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 251339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 251341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251347 */     GIR_RootConstrainSelectedInstOperands,
     /* 251348 */     // GIR_Coverage, 20,
     /* 251348 */     GIR_EraseRootFromParent_Done,
     /* 251349 */   // Label 5026: @251349
     /* 251349 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251389), // Rule ID 2384 //
     /* 251354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 251362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 251365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 251372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 251376 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 251376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 251379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 251381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 251383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251387 */     GIR_RootConstrainSelectedInstOperands,
     /* 251388 */     // GIR_Coverage, 2384,
     /* 251388 */     GIR_EraseRootFromParent_Done,
     /* 251389 */   // Label 5027: @251389
     /* 251389 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251429), // Rule ID 2495 //
     /* 251394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 251402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 251408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251416 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 251416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 251419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251427 */     GIR_RootConstrainSelectedInstOperands,
     /* 251428 */     // GIR_Coverage, 2495,
     /* 251428 */     GIR_EraseRootFromParent_Done,
     /* 251429 */   // Label 5028: @251429
     /* 251429 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251469), // Rule ID 2496 //
     /* 251434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 251442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 251448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251456 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 251456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 251459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251467 */     GIR_RootConstrainSelectedInstOperands,
     /* 251468 */     // GIR_Coverage, 2496,
     /* 251468 */     GIR_EraseRootFromParent_Done,
     /* 251469 */   // Label 5029: @251469
     /* 251469 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251509), // Rule ID 6979 //
     /* 251474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 251482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 251488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251496 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 251496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 251499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251507 */     GIR_RootConstrainSelectedInstOperands,
     /* 251508 */     // GIR_Coverage, 6979,
     /* 251508 */     GIR_EraseRootFromParent_Done,
     /* 251509 */   // Label 5030: @251509
     /* 251509 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251549), // Rule ID 6980 //
     /* 251514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 251522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 251528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251536 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 251536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 251539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251547 */     GIR_RootConstrainSelectedInstOperands,
     /* 251548 */     // GIR_Coverage, 6980,
     /* 251548 */     GIR_EraseRootFromParent_Done,
     /* 251549 */   // Label 5031: @251549
     /* 251549 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251585), // Rule ID 3577 //
     /* 251554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 251562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251572 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 251575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251583 */     GIR_RootConstrainSelectedInstOperands,
     /* 251584 */     // GIR_Coverage, 3577,
     /* 251584 */     GIR_EraseRootFromParent_Done,
     /* 251585 */   // Label 5032: @251585
     /* 251585 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251623), // Rule ID 4001 //
     /* 251590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 251593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 251598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251608 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 251608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 251611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 251619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 251621 */     GIR_RootConstrainSelectedInstOperands,
     /* 251622 */     // GIR_Coverage, 4001,
     /* 251622 */     GIR_EraseRootFromParent_Done,
     /* 251623 */   // Label 5033: @251623
     /* 251623 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251659), // Rule ID 12484 //
     /* 251628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 251636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251646 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 251649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251657 */     GIR_RootConstrainSelectedInstOperands,
     /* 251658 */     // GIR_Coverage, 12484,
     /* 251658 */     GIR_EraseRootFromParent_Done,
     /* 251659 */   // Label 5034: @251659
     /* 251659 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251695), // Rule ID 12485 //
     /* 251664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 251672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251682 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 251685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251693 */     GIR_RootConstrainSelectedInstOperands,
     /* 251694 */     // GIR_Coverage, 12485,
     /* 251694 */     GIR_EraseRootFromParent_Done,
     /* 251695 */   // Label 5035: @251695
     /* 251695 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251731), // Rule ID 12486 //
     /* 251700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 251708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251718 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 251721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251729 */     GIR_RootConstrainSelectedInstOperands,
     /* 251730 */     // GIR_Coverage, 12486,
     /* 251730 */     GIR_EraseRootFromParent_Done,
     /* 251731 */   // Label 5036: @251731
     /* 251731 */   GIM_Reject,
     /* 251732 */ // Label 5017: @251732
     /* 251732 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(255900),
     /* 251737 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 251740 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251837), // Rule ID 7110 //
     /* 251745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251793 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251804 */     // MIs[0] addr
     /* 251804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251818 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251827 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251835 */     GIR_RootConstrainSelectedInstOperands,
     /* 251836 */     // GIR_Coverage, 7110,
     /* 251836 */     GIR_EraseRootFromParent_Done,
     /* 251837 */   // Label 5038: @251837
     /* 251837 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251934), // Rule ID 7111 //
     /* 251842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251890 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251901 */     // MIs[0] addr
     /* 251901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251915 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251924 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251932 */     GIR_RootConstrainSelectedInstOperands,
     /* 251933 */     // GIR_Coverage, 7111,
     /* 251933 */     GIR_EraseRootFromParent_Done,
     /* 251934 */   // Label 5039: @251934
     /* 251934 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(252031), // Rule ID 7120 //
     /* 251939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251987 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251998 */     // MIs[0] addr
     /* 251998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 252010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 252012 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 252015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 252021 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 252029 */     GIR_RootConstrainSelectedInstOperands,
     /* 252030 */     // GIR_Coverage, 7120,
     /* 252030 */     GIR_EraseRootFromParent_Done,
     /* 252031 */   // Label 5040: @252031
     /* 252031 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(252128), // Rule ID 7121 //
     /* 252036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 252067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 252075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 252079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252084 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 252095 */     // MIs[0] addr
     /* 252095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 252107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 252109 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 252112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 252118 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 252126 */     GIR_RootConstrainSelectedInstOperands,
     /* 252127 */     // GIR_Coverage, 7121,
     /* 252127 */     GIR_EraseRootFromParent_Done,
     /* 252128 */   // Label 5041: @252128
     /* 252128 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(252239), // Rule ID 7113 //
     /* 252133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252169 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 252180 */     // MIs[0] addr
     /* 252180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 252192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252194 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252206 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 252225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252237 */     GIR_RootConstrainSelectedInstOperands,
     /* 252238 */     // GIR_Coverage, 7113,
     /* 252238 */     GIR_EraseRootFromParent_Done,
     /* 252239 */   // Label 5042: @252239
     /* 252239 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252350), // Rule ID 7114 //
     /* 252244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252280 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 252291 */     // MIs[0] addr
     /* 252291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 252303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252305 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 252336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252341 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252348 */     GIR_RootConstrainSelectedInstOperands,
     /* 252349 */     // GIR_Coverage, 7114,
     /* 252349 */     GIR_EraseRootFromParent_Done,
     /* 252350 */   // Label 5043: @252350
     /* 252350 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252461), // Rule ID 7115 //
     /* 252355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252391 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 252402 */     // MIs[0] addr
     /* 252402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252416 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252428 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252452 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252459 */     GIR_RootConstrainSelectedInstOperands,
     /* 252460 */     // GIR_Coverage, 7115,
     /* 252460 */     GIR_EraseRootFromParent_Done,
     /* 252461 */   // Label 5044: @252461
     /* 252461 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252572), // Rule ID 7123 //
     /* 252466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252502 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 252513 */     // MIs[0] addr
     /* 252513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 252525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252527 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252539 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 252558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252563 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252570 */     GIR_RootConstrainSelectedInstOperands,
     /* 252571 */     // GIR_Coverage, 7123,
     /* 252571 */     GIR_EraseRootFromParent_Done,
     /* 252572 */   // Label 5045: @252572
     /* 252572 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252683), // Rule ID 7124 //
     /* 252577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252613 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 252624 */     // MIs[0] addr
     /* 252624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 252636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252638 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252650 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 252669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252681 */     GIR_RootConstrainSelectedInstOperands,
     /* 252682 */     // GIR_Coverage, 7124,
     /* 252682 */     GIR_EraseRootFromParent_Done,
     /* 252683 */   // Label 5046: @252683
     /* 252683 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252794), // Rule ID 7125 //
     /* 252688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252724 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 252735 */     // MIs[0] addr
     /* 252735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252749 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252761 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252785 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252792 */     GIR_RootConstrainSelectedInstOperands,
     /* 252793 */     // GIR_Coverage, 7125,
     /* 252793 */     GIR_EraseRootFromParent_Done,
     /* 252794 */   // Label 5047: @252794
     /* 252794 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252845), // Rule ID 70 //
     /* 252799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 252804 */     // MIs[0] ptr
     /* 252804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252812 */     // MIs[0] accessinfo
     /* 252812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252815 */     // MIs[0] fixed_shadow
     /* 252815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252818 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 252821 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252823 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252825 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252843 */     GIR_RootConstrainSelectedInstOperands,
     /* 252844 */     // GIR_Coverage, 70,
     /* 252844 */     GIR_EraseRootFromParent_Done,
     /* 252845 */   // Label 5048: @252845
     /* 252845 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252896), // Rule ID 71 //
     /* 252850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 252855 */     // MIs[0] ptr
     /* 252855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252863 */     // MIs[0] accessinfo
     /* 252863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252866 */     // MIs[0] fixed_shadow
     /* 252866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252869 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 252872 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252874 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252876 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252894 */     GIR_RootConstrainSelectedInstOperands,
     /* 252895 */     // GIR_Coverage, 71,
     /* 252895 */     GIR_EraseRootFromParent_Done,
     /* 252896 */   // Label 5049: @252896
     /* 252896 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252965), // Rule ID 7112 //
     /* 252901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252933 */     // MIs[0] addr
     /* 252933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252947 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252956 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252963 */     GIR_RootConstrainSelectedInstOperands,
     /* 252964 */     // GIR_Coverage, 7112,
     /* 252964 */     GIR_EraseRootFromParent_Done,
     /* 252965 */   // Label 5050: @252965
     /* 252965 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(253034), // Rule ID 7122 //
     /* 252970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253002 */     // MIs[0] addr
     /* 253002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 253014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253016 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 253019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 253025 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253032 */     GIR_RootConstrainSelectedInstOperands,
     /* 253033 */     // GIR_Coverage, 7122,
     /* 253033 */     GIR_EraseRootFromParent_Done,
     /* 253034 */   // Label 5051: @253034
     /* 253034 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(253076), // Rule ID 3601 //
     /* 253039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 253047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253053 */     // MIs[0] tile
     /* 253053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253061 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 253064 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253074 */     GIR_RootConstrainSelectedInstOperands,
     /* 253075 */     // GIR_Coverage, 3601,
     /* 253075 */     GIR_EraseRootFromParent_Done,
     /* 253076 */   // Label 5052: @253076
     /* 253076 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(253118), // Rule ID 3605 //
     /* 253081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 253089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253095 */     // MIs[0] tile
     /* 253095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253098 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253103 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 253106 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253116 */     GIR_RootConstrainSelectedInstOperands,
     /* 253117 */     // GIR_Coverage, 3605,
     /* 253117 */     GIR_EraseRootFromParent_Done,
     /* 253118 */   // Label 5053: @253118
     /* 253118 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(253160), // Rule ID 3609 //
     /* 253123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 253131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253137 */     // MIs[0] tile
     /* 253137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253145 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 253148 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253158 */     GIR_RootConstrainSelectedInstOperands,
     /* 253159 */     // GIR_Coverage, 3609,
     /* 253159 */     GIR_EraseRootFromParent_Done,
     /* 253160 */   // Label 5054: @253160
     /* 253160 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(253202), // Rule ID 3779 //
     /* 253165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 253168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 253173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253179 */     // MIs[0] tile
     /* 253179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253187 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 253190 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253200 */     GIR_RootConstrainSelectedInstOperands,
     /* 253201 */     // GIR_Coverage, 3779,
     /* 253201 */     GIR_EraseRootFromParent_Done,
     /* 253202 */   // Label 5055: @253202
     /* 253202 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(253244), // Rule ID 3783 //
     /* 253207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 253210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 253215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253221 */     // MIs[0] tile
     /* 253221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253229 */     // (intrinsic_void 875:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 253232 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253242 */     GIR_RootConstrainSelectedInstOperands,
     /* 253243 */     // GIR_Coverage, 3783,
     /* 253243 */     GIR_EraseRootFromParent_Done,
     /* 253244 */   // Label 5056: @253244
     /* 253244 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(253286), // Rule ID 3787 //
     /* 253249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 253257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253263 */     // MIs[0] tile
     /* 253263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253271 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 253274 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253284 */     GIR_RootConstrainSelectedInstOperands,
     /* 253285 */     // GIR_Coverage, 3787,
     /* 253285 */     GIR_EraseRootFromParent_Done,
     /* 253286 */   // Label 5057: @253286
     /* 253286 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(253328), // Rule ID 3791 //
     /* 253291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 253294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 253299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253305 */     // MIs[0] tile
     /* 253305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253313 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 253316 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253326 */     GIR_RootConstrainSelectedInstOperands,
     /* 253327 */     // GIR_Coverage, 3791,
     /* 253327 */     GIR_EraseRootFromParent_Done,
     /* 253328 */   // Label 5058: @253328
     /* 253328 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(253370), // Rule ID 3795 //
     /* 253333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 253341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253347 */     // MIs[0] tile
     /* 253347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253355 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 253358 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253368 */     GIR_RootConstrainSelectedInstOperands,
     /* 253369 */     // GIR_Coverage, 3795,
     /* 253369 */     GIR_EraseRootFromParent_Done,
     /* 253370 */   // Label 5059: @253370
     /* 253370 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(253412), // Rule ID 3799 //
     /* 253375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 253378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 253383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253389 */     // MIs[0] tile
     /* 253389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253397 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 253400 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253410 */     GIR_RootConstrainSelectedInstOperands,
     /* 253411 */     // GIR_Coverage, 3799,
     /* 253411 */     GIR_EraseRootFromParent_Done,
     /* 253412 */   // Label 5060: @253412
     /* 253412 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(253454), // Rule ID 12563 //
     /* 253417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 253425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253431 */     // MIs[0] tile
     /* 253431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253439 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 253442 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253452 */     GIR_RootConstrainSelectedInstOperands,
     /* 253453 */     // GIR_Coverage, 12563,
     /* 253453 */     GIR_EraseRootFromParent_Done,
     /* 253454 */   // Label 5061: @253454
     /* 253454 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(253496), // Rule ID 12567 //
     /* 253459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 253467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253473 */     // MIs[0] tile
     /* 253473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253481 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 253484 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253494 */     GIR_RootConstrainSelectedInstOperands,
     /* 253495 */     // GIR_Coverage, 12567,
     /* 253495 */     GIR_EraseRootFromParent_Done,
     /* 253496 */   // Label 5062: @253496
     /* 253496 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253538), // Rule ID 12571 //
     /* 253501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 253509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253515 */     // MIs[0] tile
     /* 253515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253523 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 253526 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253536 */     GIR_RootConstrainSelectedInstOperands,
     /* 253537 */     // GIR_Coverage, 12571,
     /* 253537 */     GIR_EraseRootFromParent_Done,
     /* 253538 */   // Label 5063: @253538
     /* 253538 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(253580), // Rule ID 12575 //
     /* 253543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 253551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253557 */     // MIs[0] tile
     /* 253557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253565 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 253568 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253578 */     GIR_RootConstrainSelectedInstOperands,
     /* 253579 */     // GIR_Coverage, 12575,
     /* 253579 */     GIR_EraseRootFromParent_Done,
     /* 253580 */   // Label 5064: @253580
     /* 253580 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253622), // Rule ID 12579 //
     /* 253585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 253593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253599 */     // MIs[0] tile
     /* 253599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253607 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 253610 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253620 */     GIR_RootConstrainSelectedInstOperands,
     /* 253621 */     // GIR_Coverage, 12579,
     /* 253621 */     GIR_EraseRootFromParent_Done,
     /* 253622 */   // Label 5065: @253622
     /* 253622 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253664), // Rule ID 12583 //
     /* 253627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 253635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253641 */     // MIs[0] tile
     /* 253641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253649 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 253652 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253662 */     GIR_RootConstrainSelectedInstOperands,
     /* 253663 */     // GIR_Coverage, 12583,
     /* 253663 */     GIR_EraseRootFromParent_Done,
     /* 253664 */   // Label 5066: @253664
     /* 253664 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253706), // Rule ID 12587 //
     /* 253669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 253677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253683 */     // MIs[0] tile
     /* 253683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253691 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 253694 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253704 */     GIR_RootConstrainSelectedInstOperands,
     /* 253705 */     // GIR_Coverage, 12587,
     /* 253705 */     GIR_EraseRootFromParent_Done,
     /* 253706 */   // Label 5067: @253706
     /* 253706 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253748), // Rule ID 12591 //
     /* 253711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 253719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253725 */     // MIs[0] tile
     /* 253725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253733 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 253736 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253746 */     GIR_RootConstrainSelectedInstOperands,
     /* 253747 */     // GIR_Coverage, 12591,
     /* 253747 */     GIR_EraseRootFromParent_Done,
     /* 253748 */   // Label 5068: @253748
     /* 253748 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253790), // Rule ID 12595 //
     /* 253753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 253761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253767 */     // MIs[0] tile
     /* 253767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253775 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 253778 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253788 */     GIR_RootConstrainSelectedInstOperands,
     /* 253789 */     // GIR_Coverage, 12595,
     /* 253789 */     GIR_EraseRootFromParent_Done,
     /* 253790 */   // Label 5069: @253790
     /* 253790 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253832), // Rule ID 12599 //
     /* 253795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 253803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253809 */     // MIs[0] tile
     /* 253809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253817 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 253820 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253830 */     GIR_RootConstrainSelectedInstOperands,
     /* 253831 */     // GIR_Coverage, 12599,
     /* 253831 */     GIR_EraseRootFromParent_Done,
     /* 253832 */   // Label 5070: @253832
     /* 253832 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253874), // Rule ID 12603 //
     /* 253837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 253845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253851 */     // MIs[0] tile
     /* 253851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253859 */     // (intrinsic_void 1027:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 253862 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253872 */     GIR_RootConstrainSelectedInstOperands,
     /* 253873 */     // GIR_Coverage, 12603,
     /* 253873 */     GIR_EraseRootFromParent_Done,
     /* 253874 */   // Label 5071: @253874
     /* 253874 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253916), // Rule ID 12607 //
     /* 253879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 253887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253893 */     // MIs[0] tile
     /* 253893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253901 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 253904 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253914 */     GIR_RootConstrainSelectedInstOperands,
     /* 253915 */     // GIR_Coverage, 12607,
     /* 253915 */     GIR_EraseRootFromParent_Done,
     /* 253916 */   // Label 5072: @253916
     /* 253916 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253958), // Rule ID 12611 //
     /* 253921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 253929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253935 */     // MIs[0] tile
     /* 253935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253938 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253943 */     // (intrinsic_void 1079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 253946 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253956 */     GIR_RootConstrainSelectedInstOperands,
     /* 253957 */     // GIR_Coverage, 12611,
     /* 253957 */     GIR_EraseRootFromParent_Done,
     /* 253958 */   // Label 5073: @253958
     /* 253958 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(254000), // Rule ID 12615 //
     /* 253963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 253971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253977 */     // MIs[0] tile
     /* 253977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253985 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253998 */     GIR_RootConstrainSelectedInstOperands,
     /* 253999 */     // GIR_Coverage, 12615,
     /* 253999 */     GIR_EraseRootFromParent_Done,
     /* 254000 */   // Label 5074: @254000
     /* 254000 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(254042), // Rule ID 12619 //
     /* 254005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 254008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 254013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254019 */     // MIs[0] tile
     /* 254019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254027 */     // (intrinsic_void 1162:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 254030 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254040 */     GIR_RootConstrainSelectedInstOperands,
     /* 254041 */     // GIR_Coverage, 12619,
     /* 254041 */     GIR_EraseRootFromParent_Done,
     /* 254042 */   // Label 5075: @254042
     /* 254042 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(254084), // Rule ID 12623 //
     /* 254047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 254050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 254055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254061 */     // MIs[0] tile
     /* 254061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254069 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 254072 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254082 */     GIR_RootConstrainSelectedInstOperands,
     /* 254083 */     // GIR_Coverage, 12623,
     /* 254083 */     GIR_EraseRootFromParent_Done,
     /* 254084 */   // Label 5076: @254084
     /* 254084 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(254126), // Rule ID 12627 //
     /* 254089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 254092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 254097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254103 */     // MIs[0] tile
     /* 254103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254111 */     // (intrinsic_void 1196:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 254111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 254114 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254124 */     GIR_RootConstrainSelectedInstOperands,
     /* 254125 */     // GIR_Coverage, 12627,
     /* 254125 */     GIR_EraseRootFromParent_Done,
     /* 254126 */   // Label 5077: @254126
     /* 254126 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(254168), // Rule ID 13082 //
     /* 254131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 254139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254145 */     // MIs[0] tile
     /* 254145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254153 */     // (intrinsic_void 924:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 254156 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254166 */     GIR_RootConstrainSelectedInstOperands,
     /* 254167 */     // GIR_Coverage, 13082,
     /* 254167 */     GIR_EraseRootFromParent_Done,
     /* 254168 */   // Label 5078: @254168
     /* 254168 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(254210), // Rule ID 13086 //
     /* 254173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 254176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 254181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254187 */     // MIs[0] tile
     /* 254187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254195 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 254195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 254198 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254208 */     GIR_RootConstrainSelectedInstOperands,
     /* 254209 */     // GIR_Coverage, 13086,
     /* 254209 */     GIR_EraseRootFromParent_Done,
     /* 254210 */   // Label 5079: @254210
     /* 254210 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(254252), // Rule ID 13090 //
     /* 254215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 254218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 254223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254229 */     // MIs[0] tile
     /* 254229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 254237 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 254237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 254240 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254250 */     GIR_RootConstrainSelectedInstOperands,
     /* 254251 */     // GIR_Coverage, 13090,
     /* 254251 */     GIR_EraseRootFromParent_Done,
     /* 254252 */   // Label 5080: @254252
     /* 254252 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(254294), // Rule ID 13094 //
     /* 254257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 254260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 254265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254271 */     // MIs[0] tile
     /* 254271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254279 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 254279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 254282 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254292 */     GIR_RootConstrainSelectedInstOperands,
     /* 254293 */     // GIR_Coverage, 13094,
     /* 254293 */     GIR_EraseRootFromParent_Done,
     /* 254294 */   // Label 5081: @254294
     /* 254294 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(254348), // Rule ID 8829 //
     /* 254299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 254307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 254310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254314 */     // MIs[0] base
     /* 254314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254322 */     // MIs[0] prfop
     /* 254322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254330 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 254333 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 254335 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 254337 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 254339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254346 */     GIR_RootConstrainSelectedInstOperands,
     /* 254347 */     // GIR_Coverage, 8829,
     /* 254347 */     GIR_EraseRootFromParent_Done,
     /* 254348 */   // Label 5082: @254348
     /* 254348 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(254402), // Rule ID 8832 //
     /* 254353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 254361 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 254364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254368 */     // MIs[0] base
     /* 254368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254376 */     // MIs[0] prfop
     /* 254376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254384 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 254387 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 254389 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 254391 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 254393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254400 */     GIR_RootConstrainSelectedInstOperands,
     /* 254401 */     // GIR_Coverage, 8832,
     /* 254401 */     GIR_EraseRootFromParent_Done,
     /* 254402 */   // Label 5083: @254402
     /* 254402 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(254456), // Rule ID 8835 //
     /* 254407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 254415 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254422 */     // MIs[0] base
     /* 254422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254430 */     // MIs[0] prfop
     /* 254430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254438 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 254441 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 254443 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 254445 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 254447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254454 */     GIR_RootConstrainSelectedInstOperands,
     /* 254455 */     // GIR_Coverage, 8835,
     /* 254455 */     GIR_EraseRootFromParent_Done,
     /* 254456 */   // Label 5084: @254456
     /* 254456 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(254510), // Rule ID 8838 //
     /* 254461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 254469 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254476 */     // MIs[0] base
     /* 254476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254484 */     // MIs[0] prfop
     /* 254484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254487 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254492 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 254495 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 254497 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 254499 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 254501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254508 */     GIR_RootConstrainSelectedInstOperands,
     /* 254509 */     // GIR_Coverage, 8838,
     /* 254509 */     GIR_EraseRootFromParent_Done,
     /* 254510 */   // Label 5085: @254510
     /* 254510 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(254564), // Rule ID 15 //
     /* 254515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 254520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 254523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 254537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254541 */     // MIs[1] Operand 1
     /* 254541 */     // No operand predicates
     /* 254541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254547 */     // (intrinsic_w_chain:{ *:[i64] } 1232:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 254547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 254550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 254555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 254557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254562 */     GIR_RootConstrainSelectedInstOperands,
     /* 254563 */     // GIR_Coverage, 15,
     /* 254563 */     GIR_EraseRootFromParent_Done,
     /* 254564 */   // Label 5086: @254564
     /* 254564 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(254632), // Rule ID 68 //
     /* 254569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 254574 */     // MIs[0] Operand 1
     /* 254574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 254582 */     // MIs[0] ptr
     /* 254582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254590 */     // MIs[0] accessinfo
     /* 254590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254593 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 254593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254597 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 254607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 254610 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 254612 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 254614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254630 */     GIR_RootConstrainSelectedInstOperands,
     /* 254631 */     // GIR_Coverage, 68,
     /* 254631 */     GIR_EraseRootFromParent_Done,
     /* 254632 */   // Label 5087: @254632
     /* 254632 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254700), // Rule ID 69 //
     /* 254637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 254642 */     // MIs[0] Operand 1
     /* 254642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 254650 */     // MIs[0] ptr
     /* 254650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254658 */     // MIs[0] accessinfo
     /* 254658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254661 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 254661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254665 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 254675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 254678 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 254680 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 254682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254698 */     GIR_RootConstrainSelectedInstOperands,
     /* 254699 */     // GIR_Coverage, 69,
     /* 254699 */     GIR_EraseRootFromParent_Done,
     /* 254700 */   // Label 5088: @254700
     /* 254700 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254780), // Rule ID 7106 //
     /* 254705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254724 */     // MIs[0] addr
     /* 254724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 254736 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254748 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 254767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254772 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254778 */     GIR_RootConstrainSelectedInstOperands,
     /* 254779 */     // GIR_Coverage, 7106,
     /* 254779 */     GIR_EraseRootFromParent_Done,
     /* 254780 */   // Label 5089: @254780
     /* 254780 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254860), // Rule ID 7107 //
     /* 254785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254804 */     // MIs[0] addr
     /* 254804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 254816 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254828 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 254847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254852 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254858 */     GIR_RootConstrainSelectedInstOperands,
     /* 254859 */     // GIR_Coverage, 7107,
     /* 254859 */     GIR_EraseRootFromParent_Done,
     /* 254860 */   // Label 5090: @254860
     /* 254860 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254940), // Rule ID 7108 //
     /* 254865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254884 */     // MIs[0] addr
     /* 254884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 254896 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254908 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 254927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254932 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254938 */     GIR_RootConstrainSelectedInstOperands,
     /* 254939 */     // GIR_Coverage, 7108,
     /* 254939 */     GIR_EraseRootFromParent_Done,
     /* 254940 */   // Label 5091: @254940
     /* 254940 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254991), // Rule ID 7109 //
     /* 254945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254964 */     // MIs[0] addr
     /* 254964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 254976 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 254979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254981 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254983 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254989 */     GIR_RootConstrainSelectedInstOperands,
     /* 254990 */     // GIR_Coverage, 7109,
     /* 254990 */     GIR_EraseRootFromParent_Done,
     /* 254991 */   // Label 5092: @254991
     /* 254991 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(255071), // Rule ID 7116 //
     /* 254996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 255001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 255007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255015 */     // MIs[0] addr
     /* 255015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 255027 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 255027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 255045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 255058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 255060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255063 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 255065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255069 */     GIR_RootConstrainSelectedInstOperands,
     /* 255070 */     // GIR_Coverage, 7116,
     /* 255070 */     GIR_EraseRootFromParent_Done,
     /* 255071 */   // Label 5093: @255071
     /* 255071 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(255151), // Rule ID 7117 //
     /* 255076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 255081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 255087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255095 */     // MIs[0] addr
     /* 255095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 255107 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 255107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 255125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 255138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 255140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255143 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 255145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255149 */     GIR_RootConstrainSelectedInstOperands,
     /* 255150 */     // GIR_Coverage, 7117,
     /* 255150 */     GIR_EraseRootFromParent_Done,
     /* 255151 */   // Label 5094: @255151
     /* 255151 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(255231), // Rule ID 7118 //
     /* 255156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 255161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 255167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255175 */     // MIs[0] addr
     /* 255175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 255187 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 255187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 255205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 255218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 255220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255223 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 255225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255229 */     GIR_RootConstrainSelectedInstOperands,
     /* 255230 */     // GIR_Coverage, 7118,
     /* 255230 */     GIR_EraseRootFromParent_Done,
     /* 255231 */   // Label 5095: @255231
     /* 255231 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(255282), // Rule ID 7119 //
     /* 255236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 255241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 255247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255255 */     // MIs[0] addr
     /* 255255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 255267 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 255267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 255270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 255272 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 255274 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 255276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255280 */     GIR_RootConstrainSelectedInstOperands,
     /* 255281 */     // GIR_Coverage, 7119,
     /* 255281 */     GIR_EraseRootFromParent_Done,
     /* 255282 */   // Label 5096: @255282
     /* 255282 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(255331), // Rule ID 2488 //
     /* 255287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 255290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 255295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 255298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 255304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255316 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 255316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 255319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 255325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255329 */     GIR_RootConstrainSelectedInstOperands,
     /* 255330 */     // GIR_Coverage, 2488,
     /* 255330 */     GIR_EraseRootFromParent_Done,
     /* 255331 */   // Label 5097: @255331
     /* 255331 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(255380), // Rule ID 2489 //
     /* 255336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 255339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 255344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 255347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255365 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 255365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 255368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 255374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255378 */     GIR_RootConstrainSelectedInstOperands,
     /* 255379 */     // GIR_Coverage, 2489,
     /* 255379 */     GIR_EraseRootFromParent_Done,
     /* 255380 */   // Label 5098: @255380
     /* 255380 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(255429), // Rule ID 2490 //
     /* 255385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 255388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 255393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 255396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 255399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255414 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 255414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 255417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 255423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255427 */     GIR_RootConstrainSelectedInstOperands,
     /* 255428 */     // GIR_Coverage, 2490,
     /* 255428 */     GIR_EraseRootFromParent_Done,
     /* 255429 */   // Label 5099: @255429
     /* 255429 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(255482), // Rule ID 8715 //
     /* 255434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 255442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255456 */     // MIs[0] base
     /* 255456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255464 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 255467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255471 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255480 */     GIR_RootConstrainSelectedInstOperands,
     /* 255481 */     // GIR_Coverage, 8715,
     /* 255481 */     GIR_EraseRootFromParent_Done,
     /* 255482 */   // Label 5100: @255482
     /* 255482 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(255535), // Rule ID 8718 //
     /* 255487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 255495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255509 */     // MIs[0] base
     /* 255509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255517 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 255520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255524 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255533 */     GIR_RootConstrainSelectedInstOperands,
     /* 255534 */     // GIR_Coverage, 8718,
     /* 255534 */     GIR_EraseRootFromParent_Done,
     /* 255535 */   // Label 5101: @255535
     /* 255535 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(255588), // Rule ID 8727 //
     /* 255540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 255548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255562 */     // MIs[0] base
     /* 255562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255570 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 255573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255577 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255586 */     GIR_RootConstrainSelectedInstOperands,
     /* 255587 */     // GIR_Coverage, 8727,
     /* 255587 */     GIR_EraseRootFromParent_Done,
     /* 255588 */   // Label 5102: @255588
     /* 255588 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(255641), // Rule ID 8730 //
     /* 255593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 255601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255615 */     // MIs[0] base
     /* 255615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255623 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 255626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255630 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255639 */     GIR_RootConstrainSelectedInstOperands,
     /* 255640 */     // GIR_Coverage, 8730,
     /* 255640 */     GIR_EraseRootFromParent_Done,
     /* 255641 */   // Label 5103: @255641
     /* 255641 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(255687), // Rule ID 137 //
     /* 255646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 255649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 255654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 255657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255664 */     // MIs[0] Rn
     /* 255664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255676 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 255676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 255679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 255685 */     GIR_RootConstrainSelectedInstOperands,
     /* 255686 */     // GIR_Coverage, 137,
     /* 255686 */     GIR_EraseRootFromParent_Done,
     /* 255687 */   // Label 5104: @255687
     /* 255687 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(255740), // Rule ID 8721 //
     /* 255692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 255700 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 255703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255714 */     // MIs[0] base
     /* 255714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255722 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 255725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255729 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255738 */     GIR_RootConstrainSelectedInstOperands,
     /* 255739 */     // GIR_Coverage, 8721,
     /* 255739 */     GIR_EraseRootFromParent_Done,
     /* 255740 */   // Label 5105: @255740
     /* 255740 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(255793), // Rule ID 8724 //
     /* 255745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 255753 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 255756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255767 */     // MIs[0] base
     /* 255767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255775 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 255778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255782 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255791 */     GIR_RootConstrainSelectedInstOperands,
     /* 255792 */     // GIR_Coverage, 8724,
     /* 255792 */     GIR_EraseRootFromParent_Done,
     /* 255793 */   // Label 5106: @255793
     /* 255793 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(255846), // Rule ID 8733 //
     /* 255798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 255806 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 255809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255820 */     // MIs[0] base
     /* 255820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255828 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 255831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255835 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255844 */     GIR_RootConstrainSelectedInstOperands,
     /* 255845 */     // GIR_Coverage, 8733,
     /* 255845 */     GIR_EraseRootFromParent_Done,
     /* 255846 */   // Label 5107: @255846
     /* 255846 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255899), // Rule ID 8736 //
     /* 255851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 255859 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 255862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255873 */     // MIs[0] base
     /* 255873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255881 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 255884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255888 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255897 */     GIR_RootConstrainSelectedInstOperands,
     /* 255898 */     // GIR_Coverage, 8736,
     /* 255898 */     GIR_EraseRootFromParent_Done,
     /* 255899 */   // Label 5108: @255899
     /* 255899 */   GIM_Reject,
     /* 255900 */ // Label 5037: @255900
     /* 255900 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(258605),
     /* 255905 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 255908 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255979), // Rule ID 3413 //
     /* 255913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255921 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 255942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 255950 */     // MIs[1] Operand 1
     /* 255950 */     // No operand predicates
     /* 255950 */     // MIs[0] prfop
     /* 255950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255960 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 255960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 255963 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 255972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255977 */     GIR_RootConstrainSelectedInstOperands,
     /* 255978 */     // GIR_Coverage, 3413,
     /* 255978 */     GIR_EraseRootFromParent_Done,
     /* 255979 */   // Label 5110: @255979
     /* 255979 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(256050), // Rule ID 3426 //
     /* 255984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255992 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 256001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 256013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 256021 */     // MIs[1] Operand 1
     /* 256021 */     // No operand predicates
     /* 256021 */     // MIs[0] prfop
     /* 256021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256031 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 256031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 256034 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 256040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 256043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 256048 */     GIR_RootConstrainSelectedInstOperands,
     /* 256049 */     // GIR_Coverage, 3426,
     /* 256049 */     GIR_EraseRootFromParent_Done,
     /* 256050 */   // Label 5111: @256050
     /* 256050 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(256109), // Rule ID 3613 //
     /* 256055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 256058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 256063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 256069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256072 */     // MIs[0] tile
     /* 256072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 256075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 256080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256092 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 256092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 256095 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 256097 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 256099 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 256101 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 256103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256107 */     GIR_RootConstrainSelectedInstOperands,
     /* 256108 */     // GIR_Coverage, 3613,
     /* 256108 */     GIR_EraseRootFromParent_Done,
     /* 256109 */   // Label 5112: @256109
     /* 256109 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(256168), // Rule ID 3614 //
     /* 256114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 256117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 256122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 256128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256131 */     // MIs[0] tile
     /* 256131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 256134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 256139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256151 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 256151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 256154 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 256156 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 256158 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 256160 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 256162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256166 */     GIR_RootConstrainSelectedInstOperands,
     /* 256167 */     // GIR_Coverage, 3614,
     /* 256167 */     GIR_EraseRootFromParent_Done,
     /* 256168 */   // Label 5113: @256168
     /* 256168 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(256227), // Rule ID 12544 //
     /* 256173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 256176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 256181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 256187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256190 */     // MIs[0] tile
     /* 256190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 256193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 256198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256210 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 256210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 256213 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 256215 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 256217 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 256219 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 256221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256225 */     GIR_RootConstrainSelectedInstOperands,
     /* 256226 */     // GIR_Coverage, 12544,
     /* 256226 */     GIR_EraseRootFromParent_Done,
     /* 256227 */   // Label 5114: @256227
     /* 256227 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(256286), // Rule ID 12545 //
     /* 256232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 256235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 256240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 256246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256249 */     // MIs[0] tile
     /* 256249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 256252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 256257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256269 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 256269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 256272 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 256274 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 256276 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 256278 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 256280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256284 */     GIR_RootConstrainSelectedInstOperands,
     /* 256285 */     // GIR_Coverage, 12545,
     /* 256285 */     GIR_EraseRootFromParent_Done,
     /* 256286 */   // Label 5115: @256286
     /* 256286 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(256346), // Rule ID 3411 //
     /* 256291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 256299 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256309 */     // MIs[0] Rn
     /* 256309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256321 */     // MIs[0] prfop
     /* 256321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256329 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 256329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 256332 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256344 */     GIR_RootConstrainSelectedInstOperands,
     /* 256345 */     // GIR_Coverage, 3411,
     /* 256345 */     GIR_EraseRootFromParent_Done,
     /* 256346 */   // Label 5116: @256346
     /* 256346 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(256406), // Rule ID 3412 //
     /* 256351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 256359 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256369 */     // MIs[0] Rn
     /* 256369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256381 */     // MIs[0] prfop
     /* 256381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256389 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 256389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 256392 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256404 */     GIR_RootConstrainSelectedInstOperands,
     /* 256405 */     // GIR_Coverage, 3412,
     /* 256405 */     GIR_EraseRootFromParent_Done,
     /* 256406 */   // Label 5117: @256406
     /* 256406 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(256466), // Rule ID 3423 //
     /* 256411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 256419 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256429 */     // MIs[0] Rn
     /* 256429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256441 */     // MIs[0] prfop
     /* 256441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256449 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 256449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 256452 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256464 */     GIR_RootConstrainSelectedInstOperands,
     /* 256465 */     // GIR_Coverage, 3423,
     /* 256465 */     GIR_EraseRootFromParent_Done,
     /* 256466 */   // Label 5118: @256466
     /* 256466 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(256526), // Rule ID 3424 //
     /* 256471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 256479 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256489 */     // MIs[0] Rn
     /* 256489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256501 */     // MIs[0] prfop
     /* 256501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256509 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 256509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 256512 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256524 */     GIR_RootConstrainSelectedInstOperands,
     /* 256525 */     // GIR_Coverage, 3424,
     /* 256525 */     GIR_EraseRootFromParent_Done,
     /* 256526 */   // Label 5119: @256526
     /* 256526 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(256586), // Rule ID 3425 //
     /* 256531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 256539 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256549 */     // MIs[0] Rn
     /* 256549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256561 */     // MIs[0] prfop
     /* 256561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256569 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 256569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 256572 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256584 */     GIR_RootConstrainSelectedInstOperands,
     /* 256585 */     // GIR_Coverage, 3425,
     /* 256585 */     GIR_EraseRootFromParent_Done,
     /* 256586 */   // Label 5120: @256586
     /* 256586 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(256646), // Rule ID 8841 //
     /* 256591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 256599 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256609 */     // MIs[0] Rn
     /* 256609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256621 */     // MIs[0] prfop
     /* 256621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256629 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 256629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 256632 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256644 */     GIR_RootConstrainSelectedInstOperands,
     /* 256645 */     // GIR_Coverage, 8841,
     /* 256645 */     GIR_EraseRootFromParent_Done,
     /* 256646 */   // Label 5121: @256646
     /* 256646 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(256706), // Rule ID 8842 //
     /* 256651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 256659 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256669 */     // MIs[0] Rn
     /* 256669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256681 */     // MIs[0] prfop
     /* 256681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256689 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 256689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 256692 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256704 */     GIR_RootConstrainSelectedInstOperands,
     /* 256705 */     // GIR_Coverage, 8842,
     /* 256705 */     GIR_EraseRootFromParent_Done,
     /* 256706 */   // Label 5122: @256706
     /* 256706 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(256766), // Rule ID 8843 //
     /* 256711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256729 */     // MIs[0] Rn
     /* 256729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256741 */     // MIs[0] prfop
     /* 256741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256749 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 256749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 256752 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256764 */     GIR_RootConstrainSelectedInstOperands,
     /* 256765 */     // GIR_Coverage, 8843,
     /* 256765 */     GIR_EraseRootFromParent_Done,
     /* 256766 */   // Label 5123: @256766
     /* 256766 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256826), // Rule ID 8844 //
     /* 256771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256779 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256789 */     // MIs[0] Rn
     /* 256789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256801 */     // MIs[0] prfop
     /* 256801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256809 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 256809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 256812 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256824 */     GIR_RootConstrainSelectedInstOperands,
     /* 256825 */     // GIR_Coverage, 8844,
     /* 256825 */     GIR_EraseRootFromParent_Done,
     /* 256826 */   // Label 5124: @256826
     /* 256826 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256886), // Rule ID 8845 //
     /* 256831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256839 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256849 */     // MIs[0] Rn
     /* 256849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256861 */     // MIs[0] prfop
     /* 256861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256869 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 256872 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256884 */     GIR_RootConstrainSelectedInstOperands,
     /* 256885 */     // GIR_Coverage, 8845,
     /* 256885 */     GIR_EraseRootFromParent_Done,
     /* 256886 */   // Label 5125: @256886
     /* 256886 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256946), // Rule ID 8846 //
     /* 256891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256899 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256909 */     // MIs[0] Rn
     /* 256909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256921 */     // MIs[0] prfop
     /* 256921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256929 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 256932 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256944 */     GIR_RootConstrainSelectedInstOperands,
     /* 256945 */     // GIR_Coverage, 8846,
     /* 256945 */     GIR_EraseRootFromParent_Done,
     /* 256946 */   // Label 5126: @256946
     /* 256946 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(257006), // Rule ID 8847 //
     /* 256951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 256959 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256969 */     // MIs[0] Rn
     /* 256969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256981 */     // MIs[0] prfop
     /* 256981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256989 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 256992 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257004 */     GIR_RootConstrainSelectedInstOperands,
     /* 257005 */     // GIR_Coverage, 8847,
     /* 257005 */     GIR_EraseRootFromParent_Done,
     /* 257006 */   // Label 5127: @257006
     /* 257006 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(257066), // Rule ID 8848 //
     /* 257011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 257019 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257029 */     // MIs[0] Rn
     /* 257029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257041 */     // MIs[0] prfop
     /* 257041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257049 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 257049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 257052 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257064 */     GIR_RootConstrainSelectedInstOperands,
     /* 257065 */     // GIR_Coverage, 8848,
     /* 257065 */     GIR_EraseRootFromParent_Done,
     /* 257066 */   // Label 5128: @257066
     /* 257066 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(257126), // Rule ID 8849 //
     /* 257071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 257079 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257089 */     // MIs[0] Rn
     /* 257089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257101 */     // MIs[0] prfop
     /* 257101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257109 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 257109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 257112 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257124 */     GIR_RootConstrainSelectedInstOperands,
     /* 257125 */     // GIR_Coverage, 8849,
     /* 257125 */     GIR_EraseRootFromParent_Done,
     /* 257126 */   // Label 5129: @257126
     /* 257126 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(257186), // Rule ID 8850 //
     /* 257131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 257139 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257149 */     // MIs[0] Rn
     /* 257149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257161 */     // MIs[0] prfop
     /* 257161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257169 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 257169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 257172 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257184 */     GIR_RootConstrainSelectedInstOperands,
     /* 257185 */     // GIR_Coverage, 8850,
     /* 257185 */     GIR_EraseRootFromParent_Done,
     /* 257186 */   // Label 5130: @257186
     /* 257186 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(257246), // Rule ID 8851 //
     /* 257191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 257199 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257209 */     // MIs[0] Rn
     /* 257209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257221 */     // MIs[0] prfop
     /* 257221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257229 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 257229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 257232 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257244 */     GIR_RootConstrainSelectedInstOperands,
     /* 257245 */     // GIR_Coverage, 8851,
     /* 257245 */     GIR_EraseRootFromParent_Done,
     /* 257246 */   // Label 5131: @257246
     /* 257246 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(257306), // Rule ID 8852 //
     /* 257251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 257259 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257269 */     // MIs[0] Rn
     /* 257269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257281 */     // MIs[0] prfop
     /* 257281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257289 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 257289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 257292 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257304 */     GIR_RootConstrainSelectedInstOperands,
     /* 257305 */     // GIR_Coverage, 8852,
     /* 257305 */     GIR_EraseRootFromParent_Done,
     /* 257306 */   // Label 5132: @257306
     /* 257306 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(257366), // Rule ID 8853 //
     /* 257311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 257319 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257329 */     // MIs[0] Rn
     /* 257329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257341 */     // MIs[0] prfop
     /* 257341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257349 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 257349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 257352 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257364 */     GIR_RootConstrainSelectedInstOperands,
     /* 257365 */     // GIR_Coverage, 8853,
     /* 257365 */     GIR_EraseRootFromParent_Done,
     /* 257366 */   // Label 5133: @257366
     /* 257366 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(257426), // Rule ID 8854 //
     /* 257371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 257379 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257389 */     // MIs[0] Rn
     /* 257389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257401 */     // MIs[0] prfop
     /* 257401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257409 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 257409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 257412 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257424 */     GIR_RootConstrainSelectedInstOperands,
     /* 257425 */     // GIR_Coverage, 8854,
     /* 257425 */     GIR_EraseRootFromParent_Done,
     /* 257426 */   // Label 5134: @257426
     /* 257426 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(257486), // Rule ID 8855 //
     /* 257431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 257434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 257439 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 257442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257449 */     // MIs[0] Rn
     /* 257449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 257453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 257457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257461 */     // MIs[0] prfop
     /* 257461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 257464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 257469 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 257469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 257472 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 257474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 257476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 257480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257484 */     GIR_RootConstrainSelectedInstOperands,
     /* 257485 */     // GIR_Coverage, 8855,
     /* 257485 */     GIR_EraseRootFromParent_Done,
     /* 257486 */   // Label 5135: @257486
     /* 257486 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(257544), // Rule ID 2374 //
     /* 257491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 257499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257527 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 257530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257542 */     GIR_RootConstrainSelectedInstOperands,
     /* 257543 */     // GIR_Coverage, 2374,
     /* 257543 */     GIR_EraseRootFromParent_Done,
     /* 257544 */   // Label 5136: @257544
     /* 257544 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(257602), // Rule ID 2375 //
     /* 257549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 257557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257585 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 257588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257600 */     GIR_RootConstrainSelectedInstOperands,
     /* 257601 */     // GIR_Coverage, 2375,
     /* 257601 */     GIR_EraseRootFromParent_Done,
     /* 257602 */   // Label 5137: @257602
     /* 257602 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(257660), // Rule ID 2376 //
     /* 257607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 257615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257643 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 257646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257658 */     GIR_RootConstrainSelectedInstOperands,
     /* 257659 */     // GIR_Coverage, 2376,
     /* 257659 */     GIR_EraseRootFromParent_Done,
     /* 257660 */   // Label 5138: @257660
     /* 257660 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(257718), // Rule ID 2377 //
     /* 257665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 257673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257701 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 257704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257716 */     GIR_RootConstrainSelectedInstOperands,
     /* 257717 */     // GIR_Coverage, 2377,
     /* 257717 */     GIR_EraseRootFromParent_Done,
     /* 257718 */   // Label 5139: @257718
     /* 257718 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257776), // Rule ID 2378 //
     /* 257723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 257731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257759 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 257762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257774 */     GIR_RootConstrainSelectedInstOperands,
     /* 257775 */     // GIR_Coverage, 2378,
     /* 257775 */     GIR_EraseRootFromParent_Done,
     /* 257776 */   // Label 5140: @257776
     /* 257776 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257834), // Rule ID 2379 //
     /* 257781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 257789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257817 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 257820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257832 */     GIR_RootConstrainSelectedInstOperands,
     /* 257833 */     // GIR_Coverage, 2379,
     /* 257833 */     GIR_EraseRootFromParent_Done,
     /* 257834 */   // Label 5141: @257834
     /* 257834 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257892), // Rule ID 2380 //
     /* 257839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257875 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 257878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257890 */     GIR_RootConstrainSelectedInstOperands,
     /* 257891 */     // GIR_Coverage, 2380,
     /* 257891 */     GIR_EraseRootFromParent_Done,
     /* 257892 */   // Label 5142: @257892
     /* 257892 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257950), // Rule ID 2381 //
     /* 257897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257933 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 257936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257948 */     GIR_RootConstrainSelectedInstOperands,
     /* 257949 */     // GIR_Coverage, 2381,
     /* 257949 */     GIR_EraseRootFromParent_Done,
     /* 257950 */   // Label 5143: @257950
     /* 257950 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(258008), // Rule ID 2382 //
     /* 257955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 257963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257991 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 257994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258006 */     GIR_RootConstrainSelectedInstOperands,
     /* 258007 */     // GIR_Coverage, 2382,
     /* 258007 */     GIR_EraseRootFromParent_Done,
     /* 258008 */   // Label 5144: @258008
     /* 258008 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(258066), // Rule ID 2383 //
     /* 258013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 258016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 258021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258049 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 258049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 258052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258064 */     GIR_RootConstrainSelectedInstOperands,
     /* 258065 */     // GIR_Coverage, 2383,
     /* 258065 */     GIR_EraseRootFromParent_Done,
     /* 258066 */   // Label 5145: @258066
     /* 258066 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(258124), // Rule ID 2491 //
     /* 258071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 258074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 258079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 258088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 258091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258107 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 258107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 258110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258112 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 258114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258122 */     GIR_RootConstrainSelectedInstOperands,
     /* 258123 */     // GIR_Coverage, 2491,
     /* 258123 */     GIR_EraseRootFromParent_Done,
     /* 258124 */   // Label 5146: @258124
     /* 258124 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(258180), // Rule ID 13103 //
     /* 258129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 258134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258155 */     // MIs[0] addr
     /* 258155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 258159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258163 */     // (intrinsic_w_chain:{ *:[i32] } 1238:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 258163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 258166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 258168 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 258170 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 258172 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 258174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258178 */     GIR_RootConstrainSelectedInstOperands,
     /* 258179 */     // GIR_Coverage, 13103,
     /* 258179 */     GIR_EraseRootFromParent_Done,
     /* 258180 */   // Label 5147: @258180
     /* 258180 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(258236), // Rule ID 13104 //
     /* 258185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 258190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 258203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258211 */     // MIs[0] addr
     /* 258211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 258215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258219 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 258219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 258222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 258224 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 258226 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 258228 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 258230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258234 */     GIR_RootConstrainSelectedInstOperands,
     /* 258235 */     // GIR_Coverage, 13104,
     /* 258235 */     GIR_EraseRootFromParent_Done,
     /* 258236 */   // Label 5148: @258236
     /* 258236 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(258282), // Rule ID 3459 //
     /* 258241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 258244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 258249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258265 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 258268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258280 */     GIR_RootConstrainSelectedInstOperands,
     /* 258281 */     // GIR_Coverage, 3459,
     /* 258281 */     GIR_EraseRootFromParent_Done,
     /* 258282 */   // Label 5149: @258282
     /* 258282 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(258328), // Rule ID 3581 //
     /* 258287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 258295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258311 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 258314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258326 */     GIR_RootConstrainSelectedInstOperands,
     /* 258327 */     // GIR_Coverage, 3581,
     /* 258327 */     GIR_EraseRootFromParent_Done,
     /* 258328 */   // Label 5150: @258328
     /* 258328 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(258374), // Rule ID 12531 //
     /* 258333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 258341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258357 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 258360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258372 */     GIR_RootConstrainSelectedInstOperands,
     /* 258373 */     // GIR_Coverage, 12531,
     /* 258373 */     GIR_EraseRootFromParent_Done,
     /* 258374 */   // Label 5151: @258374
     /* 258374 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(258420), // Rule ID 12535 //
     /* 258379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 258387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258403 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1507:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 258406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258418 */     GIR_RootConstrainSelectedInstOperands,
     /* 258419 */     // GIR_Coverage, 12535,
     /* 258419 */     GIR_EraseRootFromParent_Done,
     /* 258420 */   // Label 5152: @258420
     /* 258420 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(258466), // Rule ID 12536 //
     /* 258425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 258433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258449 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 258452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258464 */     GIR_RootConstrainSelectedInstOperands,
     /* 258465 */     // GIR_Coverage, 12536,
     /* 258465 */     GIR_EraseRootFromParent_Done,
     /* 258466 */   // Label 5153: @258466
     /* 258466 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(258512), // Rule ID 12537 //
     /* 258471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 258479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258495 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 258498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258510 */     GIR_RootConstrainSelectedInstOperands,
     /* 258511 */     // GIR_Coverage, 12537,
     /* 258511 */     GIR_EraseRootFromParent_Done,
     /* 258512 */   // Label 5154: @258512
     /* 258512 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(258558), // Rule ID 12538 //
     /* 258517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 258520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 258525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258541 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 258544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258556 */     GIR_RootConstrainSelectedInstOperands,
     /* 258557 */     // GIR_Coverage, 12538,
     /* 258557 */     GIR_EraseRootFromParent_Done,
     /* 258558 */   // Label 5155: @258558
     /* 258558 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(258604), // Rule ID 12539 //
     /* 258563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 258566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 258571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258587 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 258590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258602 */     GIR_RootConstrainSelectedInstOperands,
     /* 258603 */     // GIR_Coverage, 12539,
     /* 258603 */     GIR_EraseRootFromParent_Done,
     /* 258604 */   // Label 5156: @258604
     /* 258604 */   GIM_Reject,
     /* 258605 */ // Label 5109: @258605
     /* 258605 */ GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(261598),
     /* 258610 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258613 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(258681), // Rule ID 2518 //
     /* 258618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 258626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258654 */     // MIs[0] Idx
     /* 258654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258657 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258662 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 258665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258673 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258679 */     GIR_RootConstrainSelectedInstOperands,
     /* 258680 */     // GIR_Coverage, 2518,
     /* 258680 */     GIR_EraseRootFromParent_Done,
     /* 258681 */   // Label 5158: @258681
     /* 258681 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258749), // Rule ID 2519 //
     /* 258686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 258694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258722 */     // MIs[0] Idx
     /* 258722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258730 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 258733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258741 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258747 */     GIR_RootConstrainSelectedInstOperands,
     /* 258748 */     // GIR_Coverage, 2519,
     /* 258748 */     GIR_EraseRootFromParent_Done,
     /* 258749 */   // Label 5159: @258749
     /* 258749 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(258817), // Rule ID 2520 //
     /* 258754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 258757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 258762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 258765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 258768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258790 */     // MIs[0] Idx
     /* 258790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258798 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 258801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258809 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258815 */     GIR_RootConstrainSelectedInstOperands,
     /* 258816 */     // GIR_Coverage, 2520,
     /* 258816 */     GIR_EraseRootFromParent_Done,
     /* 258817 */   // Label 5160: @258817
     /* 258817 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258885), // Rule ID 2521 //
     /* 258822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 258825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 258830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258858 */     // MIs[0] Idx
     /* 258858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258866 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 258869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258877 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258883 */     GIR_RootConstrainSelectedInstOperands,
     /* 258884 */     // GIR_Coverage, 2521,
     /* 258884 */     GIR_EraseRootFromParent_Done,
     /* 258885 */   // Label 5161: @258885
     /* 258885 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258953), // Rule ID 2522 //
     /* 258890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 258901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258926 */     // MIs[0] Idx
     /* 258926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258934 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 258937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258951 */     GIR_RootConstrainSelectedInstOperands,
     /* 258952 */     // GIR_Coverage, 2522,
     /* 258952 */     GIR_EraseRootFromParent_Done,
     /* 258953 */   // Label 5162: @258953
     /* 258953 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(259021), // Rule ID 2523 //
     /* 258958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258994 */     // MIs[0] Idx
     /* 258994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259002 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 259002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 259005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259013 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 259015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259019 */     GIR_RootConstrainSelectedInstOperands,
     /* 259020 */     // GIR_Coverage, 2523,
     /* 259020 */     GIR_EraseRootFromParent_Done,
     /* 259021 */   // Label 5163: @259021
     /* 259021 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(259089), // Rule ID 6981 //
     /* 259026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 259034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 259062 */     // MIs[0] Idx
     /* 259062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 259070 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 259070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 259073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259081 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 259083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259087 */     GIR_RootConstrainSelectedInstOperands,
     /* 259088 */     // GIR_Coverage, 6981,
     /* 259088 */     GIR_EraseRootFromParent_Done,
     /* 259089 */   // Label 5164: @259089
     /* 259089 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(259157), // Rule ID 6982 //
     /* 259094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 259102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 259130 */     // MIs[0] Idx
     /* 259130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 259138 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 259138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 259141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259149 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 259151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259155 */     GIR_RootConstrainSelectedInstOperands,
     /* 259156 */     // GIR_Coverage, 6982,
     /* 259156 */     GIR_EraseRootFromParent_Done,
     /* 259157 */   // Label 5165: @259157
     /* 259157 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(259225), // Rule ID 6983 //
     /* 259162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 259170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 259198 */     // MIs[0] Idx
     /* 259198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 259206 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 259206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 259209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259217 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 259219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259223 */     GIR_RootConstrainSelectedInstOperands,
     /* 259224 */     // GIR_Coverage, 6983,
     /* 259224 */     GIR_EraseRootFromParent_Done,
     /* 259225 */   // Label 5166: @259225
     /* 259225 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(259293), // Rule ID 6984 //
     /* 259230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 259233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 259238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 259250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 259266 */     // MIs[0] Idx
     /* 259266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 259274 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 259274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 259277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 259281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 259283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 259285 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 259287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259291 */     GIR_RootConstrainSelectedInstOperands,
     /* 259292 */     // GIR_Coverage, 6984,
     /* 259292 */     GIR_EraseRootFromParent_Done,
     /* 259293 */   // Label 5167: @259293
     /* 259293 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(259353), // Rule ID 3593 //
     /* 259298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 259306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259318 */     // MIs[0] tile
     /* 259318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259334 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 259334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 259337 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259345 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259351 */     GIR_RootConstrainSelectedInstOperands,
     /* 259352 */     // GIR_Coverage, 3593,
     /* 259352 */     GIR_EraseRootFromParent_Done,
     /* 259353 */   // Label 5168: @259353
     /* 259353 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(259413), // Rule ID 3594 //
     /* 259358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 259361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 259366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259378 */     // MIs[0] tile
     /* 259378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259394 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 259397 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259405 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259411 */     GIR_RootConstrainSelectedInstOperands,
     /* 259412 */     // GIR_Coverage, 3594,
     /* 259412 */     GIR_EraseRootFromParent_Done,
     /* 259413 */   // Label 5169: @259413
     /* 259413 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(259473), // Rule ID 3595 //
     /* 259418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 259421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 259426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 259432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259438 */     // MIs[0] tile
     /* 259438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259454 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 259454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 259457 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259465 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259471 */     GIR_RootConstrainSelectedInstOperands,
     /* 259472 */     // GIR_Coverage, 3595,
     /* 259472 */     GIR_EraseRootFromParent_Done,
     /* 259473 */   // Label 5170: @259473
     /* 259473 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(259533), // Rule ID 3596 //
     /* 259478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 259481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 259486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259498 */     // MIs[0] tile
     /* 259498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 259506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259514 */     // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 259517 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259525 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259531 */     GIR_RootConstrainSelectedInstOperands,
     /* 259532 */     // GIR_Coverage, 3596,
     /* 259532 */     GIR_EraseRootFromParent_Done,
     /* 259533 */   // Label 5171: @259533
     /* 259533 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(259593), // Rule ID 3597 //
     /* 259538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 259541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 259546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259558 */     // MIs[0] tile
     /* 259558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 259566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259574 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 259577 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259585 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259591 */     GIR_RootConstrainSelectedInstOperands,
     /* 259592 */     // GIR_Coverage, 3597,
     /* 259592 */     GIR_EraseRootFromParent_Done,
     /* 259593 */   // Label 5172: @259593
     /* 259593 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(259653), // Rule ID 3598 //
     /* 259598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 259606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259618 */     // MIs[0] tile
     /* 259618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259634 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 259637 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259645 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259651 */     GIR_RootConstrainSelectedInstOperands,
     /* 259652 */     // GIR_Coverage, 3598,
     /* 259652 */     GIR_EraseRootFromParent_Done,
     /* 259653 */   // Label 5173: @259653
     /* 259653 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(259713), // Rule ID 3599 //
     /* 259658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 259666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259678 */     // MIs[0] tile
     /* 259678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259694 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 259697 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259705 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259711 */     GIR_RootConstrainSelectedInstOperands,
     /* 259712 */     // GIR_Coverage, 3599,
     /* 259712 */     GIR_EraseRootFromParent_Done,
     /* 259713 */   // Label 5174: @259713
     /* 259713 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(259773), // Rule ID 3600 //
     /* 259718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 259726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259738 */     // MIs[0] tile
     /* 259738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259754 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 259757 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259765 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259771 */     GIR_RootConstrainSelectedInstOperands,
     /* 259772 */     // GIR_Coverage, 3600,
     /* 259772 */     GIR_EraseRootFromParent_Done,
     /* 259773 */   // Label 5175: @259773
     /* 259773 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259833), // Rule ID 3694 //
     /* 259778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 259786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259798 */     // MIs[0] tile
     /* 259798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259814 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 259817 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259825 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259831 */     GIR_RootConstrainSelectedInstOperands,
     /* 259832 */     // GIR_Coverage, 3694,
     /* 259832 */     GIR_EraseRootFromParent_Done,
     /* 259833 */   // Label 5176: @259833
     /* 259833 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259893), // Rule ID 3695 //
     /* 259838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 259846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259858 */     // MIs[0] tile
     /* 259858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259874 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 259877 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259885 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259891 */     GIR_RootConstrainSelectedInstOperands,
     /* 259892 */     // GIR_Coverage, 3695,
     /* 259892 */     GIR_EraseRootFromParent_Done,
     /* 259893 */   // Label 5177: @259893
     /* 259893 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259953), // Rule ID 12546 //
     /* 259898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259918 */     // MIs[0] tile
     /* 259918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259934 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 259934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 259937 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259951 */     GIR_RootConstrainSelectedInstOperands,
     /* 259952 */     // GIR_Coverage, 12546,
     /* 259952 */     GIR_EraseRootFromParent_Done,
     /* 259953 */   // Label 5178: @259953
     /* 259953 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(260013), // Rule ID 12547 //
     /* 259958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 259961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 259972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259978 */     // MIs[0] tile
     /* 259978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259994 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 259994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 259997 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260011 */     GIR_RootConstrainSelectedInstOperands,
     /* 260012 */     // GIR_Coverage, 12547,
     /* 260012 */     GIR_EraseRootFromParent_Done,
     /* 260013 */   // Label 5179: @260013
     /* 260013 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(260073), // Rule ID 12548 //
     /* 260018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 260026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260038 */     // MIs[0] tile
     /* 260038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260054 */     // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 260054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 260057 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260065 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260071 */     GIR_RootConstrainSelectedInstOperands,
     /* 260072 */     // GIR_Coverage, 12548,
     /* 260072 */     GIR_EraseRootFromParent_Done,
     /* 260073 */   // Label 5180: @260073
     /* 260073 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(260133), // Rule ID 12549 //
     /* 260078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 260086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260098 */     // MIs[0] tile
     /* 260098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260114 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 260117 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260131 */     GIR_RootConstrainSelectedInstOperands,
     /* 260132 */     // GIR_Coverage, 12549,
     /* 260132 */     GIR_EraseRootFromParent_Done,
     /* 260133 */   // Label 5181: @260133
     /* 260133 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(260193), // Rule ID 12550 //
     /* 260138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 260146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260158 */     // MIs[0] tile
     /* 260158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260174 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 260177 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260185 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260191 */     GIR_RootConstrainSelectedInstOperands,
     /* 260192 */     // GIR_Coverage, 12550,
     /* 260192 */     GIR_EraseRootFromParent_Done,
     /* 260193 */   // Label 5182: @260193
     /* 260193 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(260253), // Rule ID 12551 //
     /* 260198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 260206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260218 */     // MIs[0] tile
     /* 260218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260234 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 260237 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260245 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260251 */     GIR_RootConstrainSelectedInstOperands,
     /* 260252 */     // GIR_Coverage, 12551,
     /* 260252 */     GIR_EraseRootFromParent_Done,
     /* 260253 */   // Label 5183: @260253
     /* 260253 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(260313), // Rule ID 12552 //
     /* 260258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 260266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260278 */     // MIs[0] tile
     /* 260278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260294 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 260297 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260311 */     GIR_RootConstrainSelectedInstOperands,
     /* 260312 */     // GIR_Coverage, 12552,
     /* 260312 */     GIR_EraseRootFromParent_Done,
     /* 260313 */   // Label 5184: @260313
     /* 260313 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(260373), // Rule ID 12553 //
     /* 260318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 260326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260338 */     // MIs[0] tile
     /* 260338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260354 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 260357 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260365 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260371 */     GIR_RootConstrainSelectedInstOperands,
     /* 260372 */     // GIR_Coverage, 12553,
     /* 260372 */     GIR_EraseRootFromParent_Done,
     /* 260373 */   // Label 5185: @260373
     /* 260373 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(260433), // Rule ID 12554 //
     /* 260378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 260386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260398 */     // MIs[0] tile
     /* 260398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260414 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 260417 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260425 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260431 */     GIR_RootConstrainSelectedInstOperands,
     /* 260432 */     // GIR_Coverage, 12554,
     /* 260432 */     GIR_EraseRootFromParent_Done,
     /* 260433 */   // Label 5186: @260433
     /* 260433 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(260493), // Rule ID 12555 //
     /* 260438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 260441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 260446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 260452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260458 */     // MIs[0] tile
     /* 260458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260474 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 260474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 260477 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260485 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260491 */     GIR_RootConstrainSelectedInstOperands,
     /* 260492 */     // GIR_Coverage, 12555,
     /* 260492 */     GIR_EraseRootFromParent_Done,
     /* 260493 */   // Label 5187: @260493
     /* 260493 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(260553), // Rule ID 12556 //
     /* 260498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 260506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260518 */     // MIs[0] tile
     /* 260518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260521 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260534 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 260537 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260545 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260551 */     GIR_RootConstrainSelectedInstOperands,
     /* 260552 */     // GIR_Coverage, 12556,
     /* 260552 */     GIR_EraseRootFromParent_Done,
     /* 260553 */   // Label 5188: @260553
     /* 260553 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(260613), // Rule ID 12557 //
     /* 260558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 260566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260578 */     // MIs[0] tile
     /* 260578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260594 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 260597 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260605 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260611 */     GIR_RootConstrainSelectedInstOperands,
     /* 260612 */     // GIR_Coverage, 12557,
     /* 260612 */     GIR_EraseRootFromParent_Done,
     /* 260613 */   // Label 5189: @260613
     /* 260613 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(260673), // Rule ID 12558 //
     /* 260618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 260626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260638 */     // MIs[0] tile
     /* 260638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260654 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 260657 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260665 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260671 */     GIR_RootConstrainSelectedInstOperands,
     /* 260672 */     // GIR_Coverage, 12558,
     /* 260672 */     GIR_EraseRootFromParent_Done,
     /* 260673 */   // Label 5190: @260673
     /* 260673 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(260733), // Rule ID 12559 //
     /* 260678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 260686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260698 */     // MIs[0] tile
     /* 260698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260714 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 260717 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260725 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260731 */     GIR_RootConstrainSelectedInstOperands,
     /* 260732 */     // GIR_Coverage, 12559,
     /* 260732 */     GIR_EraseRootFromParent_Done,
     /* 260733 */   // Label 5191: @260733
     /* 260733 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260793), // Rule ID 12560 //
     /* 260738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 260746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260758 */     // MIs[0] tile
     /* 260758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260774 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 260777 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260785 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260791 */     GIR_RootConstrainSelectedInstOperands,
     /* 260792 */     // GIR_Coverage, 12560,
     /* 260792 */     GIR_EraseRootFromParent_Done,
     /* 260793 */   // Label 5192: @260793
     /* 260793 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260853), // Rule ID 12561 //
     /* 260798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 260806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260818 */     // MIs[0] tile
     /* 260818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260834 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 260837 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260845 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260851 */     GIR_RootConstrainSelectedInstOperands,
     /* 260852 */     // GIR_Coverage, 12561,
     /* 260852 */     GIR_EraseRootFromParent_Done,
     /* 260853 */   // Label 5193: @260853
     /* 260853 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260913), // Rule ID 12562 //
     /* 260858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 260866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260878 */     // MIs[0] tile
     /* 260878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260894 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 260897 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260905 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260911 */     GIR_RootConstrainSelectedInstOperands,
     /* 260912 */     // GIR_Coverage, 12562,
     /* 260912 */     GIR_EraseRootFromParent_Done,
     /* 260913 */   // Label 5194: @260913
     /* 260913 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260973), // Rule ID 12936 //
     /* 260918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 260926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 260932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260938 */     // MIs[0] tile
     /* 260938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260954 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 260954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 260957 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260965 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260971 */     GIR_RootConstrainSelectedInstOperands,
     /* 260972 */     // GIR_Coverage, 12936,
     /* 260972 */     GIR_EraseRootFromParent_Done,
     /* 260973 */   // Label 5195: @260973
     /* 260973 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(261033), // Rule ID 12937 //
     /* 260978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 260986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260998 */     // MIs[0] tile
     /* 260998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261014 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 261017 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261025 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261031 */     GIR_RootConstrainSelectedInstOperands,
     /* 261032 */     // GIR_Coverage, 12937,
     /* 261032 */     GIR_EraseRootFromParent_Done,
     /* 261033 */   // Label 5196: @261033
     /* 261033 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(261093), // Rule ID 12938 //
     /* 261038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 261046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261058 */     // MIs[0] tile
     /* 261058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261074 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 261077 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261091 */     GIR_RootConstrainSelectedInstOperands,
     /* 261092 */     // GIR_Coverage, 12938,
     /* 261092 */     GIR_EraseRootFromParent_Done,
     /* 261093 */   // Label 5197: @261093
     /* 261093 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(261153), // Rule ID 12939 //
     /* 261098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 261101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 261106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261118 */     // MIs[0] tile
     /* 261118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 261126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261134 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 261134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 261137 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261151 */     GIR_RootConstrainSelectedInstOperands,
     /* 261152 */     // GIR_Coverage, 12939,
     /* 261152 */     GIR_EraseRootFromParent_Done,
     /* 261153 */   // Label 5198: @261153
     /* 261153 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(261213), // Rule ID 13050 //
     /* 261158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 261161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 261166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 261172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261178 */     // MIs[0] tile
     /* 261178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 261181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 261186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 261194 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 261194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 261197 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 261199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 261201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 261203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 261205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 261207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261211 */     GIR_RootConstrainSelectedInstOperands,
     /* 261212 */     // GIR_Coverage, 13050,
     /* 261212 */     GIR_EraseRootFromParent_Done,
     /* 261213 */   // Label 5199: @261213
     /* 261213 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(261261), // Rule ID 3580 //
     /* 261218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 261226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261242 */     // MIs[0] Op4
     /* 261242 */     // No operand predicates
     /* 261242 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 261245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261253 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261259 */     GIR_RootConstrainSelectedInstOperands,
     /* 261260 */     // GIR_Coverage, 3580,
     /* 261260 */     GIR_EraseRootFromParent_Done,
     /* 261261 */   // Label 5200: @261261
     /* 261261 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(261309), // Rule ID 3582 //
     /* 261266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 261274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261290 */     // MIs[0] Op4
     /* 261290 */     // No operand predicates
     /* 261290 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 261293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261307 */     GIR_RootConstrainSelectedInstOperands,
     /* 261308 */     // GIR_Coverage, 3582,
     /* 261308 */     GIR_EraseRootFromParent_Done,
     /* 261309 */   // Label 5201: @261309
     /* 261309 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(261357), // Rule ID 3583 //
     /* 261314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 261317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 261322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261338 */     // MIs[0] Op4
     /* 261338 */     // No operand predicates
     /* 261338 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 261341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261349 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261355 */     GIR_RootConstrainSelectedInstOperands,
     /* 261356 */     // GIR_Coverage, 3583,
     /* 261356 */     GIR_EraseRootFromParent_Done,
     /* 261357 */   // Label 5202: @261357
     /* 261357 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(261405), // Rule ID 3584 //
     /* 261362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 261365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 261370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261386 */     // MIs[0] Op4
     /* 261386 */     // No operand predicates
     /* 261386 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 261389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261397 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261403 */     GIR_RootConstrainSelectedInstOperands,
     /* 261404 */     // GIR_Coverage, 3584,
     /* 261404 */     GIR_EraseRootFromParent_Done,
     /* 261405 */   // Label 5203: @261405
     /* 261405 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(261453), // Rule ID 12530 //
     /* 261410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 261418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261434 */     // MIs[0] Op4
     /* 261434 */     // No operand predicates
     /* 261434 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 261437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261451 */     GIR_RootConstrainSelectedInstOperands,
     /* 261452 */     // GIR_Coverage, 12530,
     /* 261452 */     GIR_EraseRootFromParent_Done,
     /* 261453 */   // Label 5204: @261453
     /* 261453 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(261501), // Rule ID 12532 //
     /* 261458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 261466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261482 */     // MIs[0] Op4
     /* 261482 */     // No operand predicates
     /* 261482 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 261485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261493 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261499 */     GIR_RootConstrainSelectedInstOperands,
     /* 261500 */     // GIR_Coverage, 12532,
     /* 261500 */     GIR_EraseRootFromParent_Done,
     /* 261501 */   // Label 5205: @261501
     /* 261501 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(261549), // Rule ID 12533 //
     /* 261506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 261514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261530 */     // MIs[0] Op4
     /* 261530 */     // No operand predicates
     /* 261530 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 261533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261547 */     GIR_RootConstrainSelectedInstOperands,
     /* 261548 */     // GIR_Coverage, 12533,
     /* 261548 */     GIR_EraseRootFromParent_Done,
     /* 261549 */   // Label 5206: @261549
     /* 261549 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(261597), // Rule ID 12534 //
     /* 261554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 261562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261578 */     // MIs[0] Op4
     /* 261578 */     // No operand predicates
     /* 261578 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 261581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261589 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261595 */     GIR_RootConstrainSelectedInstOperands,
     /* 261596 */     // GIR_Coverage, 12534,
     /* 261596 */     GIR_EraseRootFromParent_Done,
     /* 261597 */   // Label 5207: @261597
     /* 261597 */   GIM_Reject,
     /* 261598 */ // Label 5157: @261598
     /* 261598 */ GIM_Reject,
     /* 261599 */ // Label 37: @261599
     /* 261599 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5212*/ GIMT_Encode4(261888),
     /* 261610 */ /*GILLT_s64*//*Label 5208*/ GIMT_Encode4(261642), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261622 */ /*GILLT_v2s64*//*Label 5209*/ GIMT_Encode4(261702), GIMT_Encode4(0),
     /* 261630 */ /*GILLT_v4s32*//*Label 5210*/ GIMT_Encode4(261764), GIMT_Encode4(0),
     /* 261638 */ /*GILLT_v8s16*//*Label 5211*/ GIMT_Encode4(261826),
     /* 261642 */ // Label 5208: @261642
     /* 261642 */ GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(261701), // Rule ID 6493 //
     /* 261647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 261650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261658 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 261658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 261661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 261685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261700 */   // GIR_Coverage, 6493,
     /* 261700 */   GIR_EraseRootFromParent_Done,
     /* 261701 */ // Label 5213: @261701
     /* 261701 */ GIM_Reject,
     /* 261702 */ // Label 5209: @261702
     /* 261702 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(261763),
     /* 261707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261714 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(261741), // Rule ID 6365 //
     /* 261719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261726 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 261726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 261729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261739 */     GIR_RootConstrainSelectedInstOperands,
     /* 261740 */     // GIR_Coverage, 6365,
     /* 261740 */     GIR_EraseRootFromParent_Done,
     /* 261741 */   // Label 5215: @261741
     /* 261741 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(261762), // Rule ID 6358 //
     /* 261746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261750 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 261750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 261753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261760 */     GIR_RootConstrainSelectedInstOperands,
     /* 261761 */     // GIR_Coverage, 6358,
     /* 261761 */     GIR_EraseRootFromParent_Done,
     /* 261762 */   // Label 5216: @261762
     /* 261762 */   GIM_Reject,
     /* 261763 */ // Label 5214: @261763
     /* 261763 */ GIM_Reject,
     /* 261764 */ // Label 5210: @261764
     /* 261764 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261825),
     /* 261769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261776 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261803), // Rule ID 6362 //
     /* 261781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261788 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 261788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 261791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261801 */     GIR_RootConstrainSelectedInstOperands,
     /* 261802 */     // GIR_Coverage, 6362,
     /* 261802 */     GIR_EraseRootFromParent_Done,
     /* 261803 */   // Label 5218: @261803
     /* 261803 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261824), // Rule ID 6355 //
     /* 261808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261812 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 261812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 261815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261822 */     GIR_RootConstrainSelectedInstOperands,
     /* 261823 */     // GIR_Coverage, 6355,
     /* 261823 */     GIR_EraseRootFromParent_Done,
     /* 261824 */   // Label 5219: @261824
     /* 261824 */   GIM_Reject,
     /* 261825 */ // Label 5217: @261825
     /* 261825 */ GIM_Reject,
     /* 261826 */ // Label 5211: @261826
     /* 261826 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261887),
     /* 261831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 261834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261838 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261865), // Rule ID 6359 //
     /* 261843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261850 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 261850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 261853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261863 */     GIR_RootConstrainSelectedInstOperands,
     /* 261864 */     // GIR_Coverage, 6359,
     /* 261864 */     GIR_EraseRootFromParent_Done,
     /* 261865 */   // Label 5221: @261865
     /* 261865 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261886), // Rule ID 6352 //
     /* 261870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261874 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 261874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261884 */     GIR_RootConstrainSelectedInstOperands,
     /* 261885 */     // GIR_Coverage, 6352,
     /* 261885 */     GIR_EraseRootFromParent_Done,
     /* 261886 */   // Label 5222: @261886
     /* 261886 */   GIM_Reject,
     /* 261887 */ // Label 5220: @261887
     /* 261887 */ GIM_Reject,
     /* 261888 */ // Label 5212: @261888
     /* 261888 */ GIM_Reject,
     /* 261889 */ // Label 38: @261889
     /* 261889 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5227*/ GIMT_Encode4(263325),
     /* 261900 */ /*GILLT_s32*//*Label 5223*/ GIMT_Encode4(261932), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261912 */ /*GILLT_v2s32*//*Label 5224*/ GIMT_Encode4(261971), GIMT_Encode4(0),
     /* 261920 */ /*GILLT_v4s16*//*Label 5225*/ GIMT_Encode4(262327), GIMT_Encode4(0),
     /* 261928 */ /*GILLT_v8s8*//*Label 5226*/ GIMT_Encode4(262826),
     /* 261932 */ // Label 5223: @261932
     /* 261932 */ GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261970), // Rule ID 6514 //
     /* 261937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 261940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261948 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 261948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261953 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 261959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261969 */   // GIR_Coverage, 6514,
     /* 261969 */   GIR_EraseRootFromParent_Done,
     /* 261970 */ // Label 5228: @261970
     /* 261970 */ GIM_Reject,
     /* 261971 */ // Label 5224: @261971
     /* 261971 */ GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(262326),
     /* 261976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261983 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(262061), // Rule ID 5430 //
     /* 261988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 262008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 262025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 262031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 262033 */     // MIs[1] Operand 2
     /* 262033 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 262044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262046 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 262046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 262049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262059 */     GIR_RootConstrainSelectedInstOperands,
     /* 262060 */     // GIR_Coverage, 5430,
     /* 262060 */     GIR_EraseRootFromParent_Done,
     /* 262061 */   // Label 5230: @262061
     /* 262061 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(262132), // Rule ID 5426 //
     /* 262066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 262086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262104 */     // MIs[1] Operand 2
     /* 262104 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 262115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262117 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 262117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 262120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262130 */     GIR_RootConstrainSelectedInstOperands,
     /* 262131 */     // GIR_Coverage, 5426,
     /* 262131 */     GIR_EraseRootFromParent_Done,
     /* 262132 */   // Label 5231: @262132
     /* 262132 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(262203), // Rule ID 5428 //
     /* 262137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 262157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262175 */     // MIs[1] Operand 2
     /* 262175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 262186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262188 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 262188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 262191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262201 */     GIR_RootConstrainSelectedInstOperands,
     /* 262202 */     // GIR_Coverage, 5428,
     /* 262202 */     GIR_EraseRootFromParent_Done,
     /* 262203 */   // Label 5232: @262203
     /* 262203 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(262256), // Rule ID 2162 //
     /* 262208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262228 */     // MIs[1] imm
     /* 262228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 262240 */     // MIs[2] Operand 1
     /* 262240 */     // No operand predicates
     /* 262240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262242 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262254 */     GIR_RootConstrainSelectedInstOperands,
     /* 262255 */     // GIR_Coverage, 2162,
     /* 262255 */     GIR_EraseRootFromParent_Done,
     /* 262256 */   // Label 5233: @262256
     /* 262256 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(262306), // Rule ID 6340 //
     /* 262261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262278 */     // MIs[1] imm
     /* 262278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262286 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 262290 */     // MIs[2] Operand 1
     /* 262290 */     // No operand predicates
     /* 262290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262292 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 262292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 262295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262304 */     GIR_RootConstrainSelectedInstOperands,
     /* 262305 */     // GIR_Coverage, 6340,
     /* 262305 */     GIR_EraseRootFromParent_Done,
     /* 262306 */   // Label 5234: @262306
     /* 262306 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262325), // Rule ID 1099 //
     /* 262311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262318 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 262318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 262323 */     GIR_RootConstrainSelectedInstOperands,
     /* 262324 */     // GIR_Coverage, 1099,
     /* 262324 */     GIR_Done,
     /* 262325 */   // Label 5235: @262325
     /* 262325 */   GIM_Reject,
     /* 262326 */ // Label 5229: @262326
     /* 262326 */ GIM_Reject,
     /* 262327 */ // Label 5225: @262327
     /* 262327 */ GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262825),
     /* 262332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262339 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262417), // Rule ID 5424 //
     /* 262344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 262364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 262381 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 262387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 262389 */     // MIs[1] Operand 2
     /* 262389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 262400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262402 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 262402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 262405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262415 */     GIR_RootConstrainSelectedInstOperands,
     /* 262416 */     // GIR_Coverage, 5424,
     /* 262416 */     GIR_EraseRootFromParent_Done,
     /* 262417 */   // Label 5237: @262417
     /* 262417 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262488), // Rule ID 5420 //
     /* 262422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 262442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262460 */     // MIs[1] Operand 2
     /* 262460 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 262471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262473 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 262473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 262476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262486 */     GIR_RootConstrainSelectedInstOperands,
     /* 262487 */     // GIR_Coverage, 5420,
     /* 262487 */     GIR_EraseRootFromParent_Done,
     /* 262488 */   // Label 5238: @262488
     /* 262488 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262559), // Rule ID 5422 //
     /* 262493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 262513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262531 */     // MIs[1] Operand 2
     /* 262531 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 262542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262544 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 262544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 262547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262557 */     GIR_RootConstrainSelectedInstOperands,
     /* 262558 */     // GIR_Coverage, 5422,
     /* 262558 */     GIR_EraseRootFromParent_Done,
     /* 262559 */   // Label 5239: @262559
     /* 262559 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262651), // Rule ID 5546 //
     /* 262564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262572 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 262583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262619 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 262619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 262626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 262644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262649 */     GIR_RootConstrainSelectedInstOperands,
     /* 262650 */     // GIR_Coverage, 5546,
     /* 262650 */     GIR_EraseRootFromParent_Done,
     /* 262651 */   // Label 5240: @262651
     /* 262651 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262704), // Rule ID 2161 //
     /* 262656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262676 */     // MIs[1] imm
     /* 262676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 262688 */     // MIs[2] Operand 1
     /* 262688 */     // No operand predicates
     /* 262688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262690 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 262693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262702 */     GIR_RootConstrainSelectedInstOperands,
     /* 262703 */     // GIR_Coverage, 2161,
     /* 262703 */     GIR_EraseRootFromParent_Done,
     /* 262704 */   // Label 5241: @262704
     /* 262704 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262754), // Rule ID 6339 //
     /* 262709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262726 */     // MIs[1] imm
     /* 262726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 262738 */     // MIs[2] Operand 1
     /* 262738 */     // No operand predicates
     /* 262738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262740 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 262740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 262743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262752 */     GIR_RootConstrainSelectedInstOperands,
     /* 262753 */     // GIR_Coverage, 6339,
     /* 262753 */     GIR_EraseRootFromParent_Done,
     /* 262754 */   // Label 5242: @262754
     /* 262754 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262805), // Rule ID 5574 //
     /* 262759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262767 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 262778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262790 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 262790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 262793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262803 */     GIR_RootConstrainSelectedInstOperands,
     /* 262804 */     // GIR_Coverage, 5574,
     /* 262804 */     GIR_EraseRootFromParent_Done,
     /* 262805 */   // Label 5243: @262805
     /* 262805 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262824), // Rule ID 1098 //
     /* 262810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262817 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 262817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 262822 */     GIR_RootConstrainSelectedInstOperands,
     /* 262823 */     // GIR_Coverage, 1098,
     /* 262823 */     GIR_Done,
     /* 262824 */   // Label 5244: @262824
     /* 262824 */   GIM_Reject,
     /* 262825 */ // Label 5236: @262825
     /* 262825 */ GIM_Reject,
     /* 262826 */ // Label 5226: @262826
     /* 262826 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(263324),
     /* 262831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262838 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262916), // Rule ID 5418 //
     /* 262843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 262863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 262880 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 262886 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 262888 */     // MIs[1] Operand 2
     /* 262888 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262901 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 262901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262914 */     GIR_RootConstrainSelectedInstOperands,
     /* 262915 */     // GIR_Coverage, 5418,
     /* 262915 */     GIR_EraseRootFromParent_Done,
     /* 262916 */   // Label 5246: @262916
     /* 262916 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262987), // Rule ID 5414 //
     /* 262921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 262941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262959 */     // MIs[1] Operand 2
     /* 262959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262972 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 262972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262985 */     GIR_RootConstrainSelectedInstOperands,
     /* 262986 */     // GIR_Coverage, 5414,
     /* 262986 */     GIR_EraseRootFromParent_Done,
     /* 262987 */   // Label 5247: @262987
     /* 262987 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(263058), // Rule ID 5416 //
     /* 262992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 263004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 263012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 263016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263030 */     // MIs[1] Operand 2
     /* 263030 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263043 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 263043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 263046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 263052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 263056 */     GIR_RootConstrainSelectedInstOperands,
     /* 263057 */     // GIR_Coverage, 5416,
     /* 263057 */     GIR_EraseRootFromParent_Done,
     /* 263058 */   // Label 5248: @263058
     /* 263058 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(263150), // Rule ID 5519 //
     /* 263063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 263071 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 263086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 263090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 263103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 263107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 263118 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 263118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 263121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 263125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 263134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 263138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 263143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263148 */     GIR_RootConstrainSelectedInstOperands,
     /* 263149 */     // GIR_Coverage, 5519,
     /* 263149 */     GIR_EraseRootFromParent_Done,
     /* 263150 */   // Label 5249: @263150
     /* 263150 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(263203), // Rule ID 2160 //
     /* 263155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 263166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 263170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263175 */     // MIs[1] imm
     /* 263175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 263187 */     // MIs[2] Operand 1
     /* 263187 */     // No operand predicates
     /* 263187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263189 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 263189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 263192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263201 */     GIR_RootConstrainSelectedInstOperands,
     /* 263202 */     // GIR_Coverage, 2160,
     /* 263202 */     GIR_EraseRootFromParent_Done,
     /* 263203 */   // Label 5250: @263203
     /* 263203 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(263253), // Rule ID 6338 //
     /* 263208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 263216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 263220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263225 */     // MIs[1] imm
     /* 263225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 263237 */     // MIs[2] Operand 1
     /* 263237 */     // No operand predicates
     /* 263237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263239 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 263239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 263242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263251 */     GIR_RootConstrainSelectedInstOperands,
     /* 263252 */     // GIR_Coverage, 6338,
     /* 263252 */     GIR_EraseRootFromParent_Done,
     /* 263253 */   // Label 5251: @263253
     /* 263253 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(263304), // Rule ID 5573 //
     /* 263258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 263266 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263289 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 263289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 263292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 263298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 263302 */     GIR_RootConstrainSelectedInstOperands,
     /* 263303 */     // GIR_Coverage, 5573,
     /* 263303 */     GIR_EraseRootFromParent_Done,
     /* 263304 */   // Label 5252: @263304
     /* 263304 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(263323), // Rule ID 1097 //
     /* 263309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263316 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 263316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 263321 */     GIR_RootConstrainSelectedInstOperands,
     /* 263322 */     // GIR_Coverage, 1097,
     /* 263322 */     GIR_Done,
     /* 263323 */   // Label 5253: @263323
     /* 263323 */   GIM_Reject,
     /* 263324 */ // Label 5245: @263324
     /* 263324 */ GIM_Reject,
     /* 263325 */ // Label 5227: @263325
     /* 263325 */ GIM_Reject,
     /* 263326 */ // Label 39: @263326
     /* 263326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5256*/ GIMT_Encode4(263445),
     /* 263337 */ /*GILLT_s32*//*Label 5254*/ GIMT_Encode4(263345),
     /* 263341 */ /*GILLT_s64*//*Label 5255*/ GIMT_Encode4(263365),
     /* 263345 */ // Label 5254: @263345
     /* 263345 */ GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(263364), // Rule ID 81 //
     /* 263350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263354 */   // MIs[0] Operand 1
     /* 263354 */   // No operand predicates
     /* 263354 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 263354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 263357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263359 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 263362 */   GIR_RootConstrainSelectedInstOperands,
     /* 263363 */   // GIR_Coverage, 81,
     /* 263363 */   GIR_EraseRootFromParent_Done,
     /* 263364 */ // Label 5257: @263364
     /* 263364 */ GIM_Reject,
     /* 263365 */ // Label 5255: @263365
     /* 263365 */ GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(263425), // Rule ID 3905 //
     /* 263370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 263373 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 263377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263381 */   // MIs[0] Operand 1
     /* 263381 */   // No operand predicates
     /* 263381 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 263381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 263384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 263388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263393 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 263398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 263414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263424 */   // GIR_Coverage, 3905,
     /* 263424 */   GIR_EraseRootFromParent_Done,
     /* 263425 */ // Label 5258: @263425
     /* 263425 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(263444), // Rule ID 82 //
     /* 263430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263434 */   // MIs[0] Operand 1
     /* 263434 */   // No operand predicates
     /* 263434 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 263434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 263437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263439 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 263442 */   GIR_RootConstrainSelectedInstOperands,
     /* 263443 */   // GIR_Coverage, 82,
     /* 263443 */   GIR_EraseRootFromParent_Done,
     /* 263444 */ // Label 5259: @263444
     /* 263444 */ GIM_Reject,
     /* 263445 */ // Label 5256: @263445
     /* 263445 */ GIM_Reject,
     /* 263446 */ // Label 40: @263446
     /* 263446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5263*/ GIMT_Encode4(263686),
     /* 263457 */ /*GILLT_s16*//*Label 5260*/ GIMT_Encode4(263469),
     /* 263461 */ /*GILLT_s32*//*Label 5261*/ GIMT_Encode4(263521),
     /* 263465 */ /*GILLT_s64*//*Label 5262*/ GIMT_Encode4(263634),
     /* 263469 */ // Label 5260: @263469
     /* 263469 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263492), // Rule ID 506 //
     /* 263474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263477 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 263481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263485 */   // MIs[0] Operand 1
     /* 263485 */   // No operand predicates
     /* 263485 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 263485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 263488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263490 */   GIR_RootConstrainSelectedInstOperands,
     /* 263491 */   // GIR_Coverage, 506,
     /* 263491 */   GIR_EraseRootFromParent_Done,
     /* 263492 */ // Label 5264: @263492
     /* 263492 */ GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263520), // Rule ID 688 //
     /* 263497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 263500 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 263504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263508 */   // MIs[0] Operand 1
     /* 263508 */   // No operand predicates
     /* 263508 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 263508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 263511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263513 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 263518 */   GIR_RootConstrainSelectedInstOperands,
     /* 263519 */   // GIR_Coverage, 688,
     /* 263519 */   GIR_EraseRootFromParent_Done,
     /* 263520 */ // Label 5265: @263520
     /* 263520 */ GIM_Reject,
     /* 263521 */ // Label 5261: @263521
     /* 263521 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263544), // Rule ID 507 //
     /* 263526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263529 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 263533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263537 */   // MIs[0] Operand 1
     /* 263537 */   // No operand predicates
     /* 263537 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 263537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 263540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263542 */   GIR_RootConstrainSelectedInstOperands,
     /* 263543 */   // GIR_Coverage, 507,
     /* 263543 */   GIR_EraseRootFromParent_Done,
     /* 263544 */ // Label 5266: @263544
     /* 263544 */ GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263572), // Rule ID 689 //
     /* 263549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263552 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 263556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263560 */   // MIs[0] Operand 1
     /* 263560 */   // No operand predicates
     /* 263560 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 263560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 263563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263565 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 263570 */   GIR_RootConstrainSelectedInstOperands,
     /* 263571 */   // GIR_Coverage, 689,
     /* 263571 */   GIR_EraseRootFromParent_Done,
     /* 263572 */ // Label 5267: @263572
     /* 263572 */ GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263633), // Rule ID 6027 //
     /* 263577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263580 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 263584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263588 */   // MIs[0] Operand 1
     /* 263588 */   // No operand predicates
     /* 263588 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 263588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 263595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263600 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 263605 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 263608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263615 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 263622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263632 */   // GIR_Coverage, 6027,
     /* 263632 */   GIR_EraseRootFromParent_Done,
     /* 263633 */ // Label 5268: @263633
     /* 263633 */ GIM_Reject,
     /* 263634 */ // Label 5262: @263634
     /* 263634 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263657), // Rule ID 508 //
     /* 263639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263642 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 263646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263650 */   // MIs[0] Operand 1
     /* 263650 */   // No operand predicates
     /* 263650 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 263650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 263653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263655 */   GIR_RootConstrainSelectedInstOperands,
     /* 263656 */   // GIR_Coverage, 508,
     /* 263656 */   GIR_EraseRootFromParent_Done,
     /* 263657 */ // Label 5269: @263657
     /* 263657 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263685), // Rule ID 690 //
     /* 263662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263665 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 263669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263673 */   // MIs[0] Operand 1
     /* 263673 */   // No operand predicates
     /* 263673 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 263673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 263676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263678 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 263683 */   GIR_RootConstrainSelectedInstOperands,
     /* 263684 */   // GIR_Coverage, 690,
     /* 263684 */   GIR_EraseRootFromParent_Done,
     /* 263685 */ // Label 5270: @263685
     /* 263685 */ GIM_Reject,
     /* 263686 */ // Label 5263: @263686
     /* 263686 */ GIM_Reject,
     /* 263687 */ // Label 41: @263687
     /* 263687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5276*/ GIMT_Encode4(265584),
     /* 263698 */ /*GILLT_s32*//*Label 5271*/ GIMT_Encode4(263734),
     /* 263702 */ /*GILLT_s64*//*Label 5272*/ GIMT_Encode4(265175), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263714 */ /*GILLT_v2s64*//*Label 5273*/ GIMT_Encode4(265398), GIMT_Encode4(0),
     /* 263722 */ /*GILLT_v4s32*//*Label 5274*/ GIMT_Encode4(265460), GIMT_Encode4(0),
     /* 263730 */ /*GILLT_v8s16*//*Label 5275*/ GIMT_Encode4(265522),
     /* 263734 */ // Label 5271: @263734
     /* 263734 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263854), // Rule ID 13105 //
     /* 263739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263746 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263754 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263757 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263762 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263766 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263773 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263773 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263776 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 263780 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263785 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263817 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263820 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263823 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263826 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263852 */   GIR_RootConstrainSelectedInstOperands,
     /* 263853 */   // GIR_Coverage, 13105,
     /* 263853 */   GIR_EraseRootFromParent_Done,
     /* 263854 */ // Label 5277: @263854
     /* 263854 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263974), // Rule ID 13107 //
     /* 263859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263874 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263877 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263882 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263886 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263893 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263893 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263896 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 263900 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263905 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263911 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263914 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263918 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263937 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263940 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263943 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263972 */   GIR_RootConstrainSelectedInstOperands,
     /* 263973 */   // GIR_Coverage, 13107,
     /* 263973 */   GIR_EraseRootFromParent_Done,
     /* 263974 */ // Label 5278: @263974
     /* 263974 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(264094), // Rule ID 13109 //
     /* 263979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263986 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263994 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263997 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 264002 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264006 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264011 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264013 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264013 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264016 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 264020 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264025 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264031 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264034 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264038 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264060 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264063 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264092 */   GIR_RootConstrainSelectedInstOperands,
     /* 264093 */   // GIR_Coverage, 13109,
     /* 264093 */   GIR_EraseRootFromParent_Done,
     /* 264094 */ // Label 5279: @264094
     /* 264094 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(264214), // Rule ID 13111 //
     /* 264099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264114 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264117 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 264122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264126 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264133 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264133 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264136 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 264140 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264145 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264151 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264154 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264158 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264177 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264180 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264183 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264212 */   GIR_RootConstrainSelectedInstOperands,
     /* 264213 */   // GIR_Coverage, 13111,
     /* 264213 */   GIR_EraseRootFromParent_Done,
     /* 264214 */ // Label 5280: @264214
     /* 264214 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(264334), // Rule ID 13127 //
     /* 264219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264226 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264234 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264237 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 264242 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264246 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264253 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264253 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264256 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 264260 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264265 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264297 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264303 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264332 */   GIR_RootConstrainSelectedInstOperands,
     /* 264333 */   // GIR_Coverage, 13127,
     /* 264333 */   GIR_EraseRootFromParent_Done,
     /* 264334 */ // Label 5281: @264334
     /* 264334 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(264454), // Rule ID 13129 //
     /* 264339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264346 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264354 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264357 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 264362 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 264366 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264373 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264373 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264376 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 264380 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264385 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264423 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264436 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264452 */   GIR_RootConstrainSelectedInstOperands,
     /* 264453 */   // GIR_Coverage, 13129,
     /* 264453 */   GIR_EraseRootFromParent_Done,
     /* 264454 */ // Label 5282: @264454
     /* 264454 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(264574), // Rule ID 13131 //
     /* 264459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264466 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264474 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264477 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 264482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264486 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264493 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264493 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264496 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 264500 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264505 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264540 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264543 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264572 */   GIR_RootConstrainSelectedInstOperands,
     /* 264573 */   // GIR_Coverage, 13131,
     /* 264573 */   GIR_EraseRootFromParent_Done,
     /* 264574 */ // Label 5283: @264574
     /* 264574 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264694), // Rule ID 13133 //
     /* 264579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264586 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264594 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264597 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 264602 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264606 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264613 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264613 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264616 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 264620 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264625 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264631 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264634 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264638 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264660 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264663 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264692 */   GIR_RootConstrainSelectedInstOperands,
     /* 264693 */   // GIR_Coverage, 13133,
     /* 264693 */   GIR_EraseRootFromParent_Done,
     /* 264694 */ // Label 5284: @264694
     /* 264694 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264814), // Rule ID 13137 //
     /* 264699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264714 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264717 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264733 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264733 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264736 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 264740 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264745 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264751 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264754 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264758 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264777 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264783 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264791 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264812 */   GIR_RootConstrainSelectedInstOperands,
     /* 264813 */   // GIR_Coverage, 13137,
     /* 264813 */   GIR_EraseRootFromParent_Done,
     /* 264814 */ // Label 5285: @264814
     /* 264814 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264934), // Rule ID 13139 //
     /* 264819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264826 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264834 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264837 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 264846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264853 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264853 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264856 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 264860 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264865 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264871 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264874 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264878 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264897 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264900 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264903 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264906 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264916 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264932 */   GIR_RootConstrainSelectedInstOperands,
     /* 264933 */   // GIR_Coverage, 13139,
     /* 264933 */   GIR_EraseRootFromParent_Done,
     /* 264934 */ // Label 5286: @264934
     /* 264934 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(265054), // Rule ID 13141 //
     /* 264939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264946 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264954 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264957 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264966 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264973 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264973 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264976 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 264980 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264985 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264991 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264994 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264998 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265017 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265020 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265023 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265052 */   GIR_RootConstrainSelectedInstOperands,
     /* 265053 */   // GIR_Coverage, 13141,
     /* 265053 */   GIR_EraseRootFromParent_Done,
     /* 265054 */ // Label 5287: @265054
     /* 265054 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(265174), // Rule ID 13143 //
     /* 265059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265066 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265074 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265077 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 265082 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 265086 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265093 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 265093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 265096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 265100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265105 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 265143 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 265146 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265172 */   GIR_RootConstrainSelectedInstOperands,
     /* 265173 */   // GIR_Coverage, 13143,
     /* 265173 */   GIR_EraseRootFromParent_Done,
     /* 265174 */ // Label 5288: @265174
     /* 265174 */ GIM_Reject,
     /* 265175 */ // Label 5272: @265175
     /* 265175 */ GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(265397),
     /* 265180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265187 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(265241), // Rule ID 5657 //
     /* 265192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 265204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 265225 */     // MIs[2] Operand 1
     /* 265225 */     // No operand predicates
     /* 265225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265227 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 265227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 265230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265239 */     GIR_RootConstrainSelectedInstOperands,
     /* 265240 */     // GIR_Coverage, 5657,
     /* 265240 */     GIR_EraseRootFromParent_Done,
     /* 265241 */   // Label 5290: @265241
     /* 265241 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(265320), // Rule ID 11210 //
     /* 265246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 265261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 265277 */     // MIs[2] Operand 1
     /* 265277 */     // No operand predicates
     /* 265277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265279 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 265279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 265282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 265310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265318 */     GIR_RootConstrainSelectedInstOperands,
     /* 265319 */     // GIR_Coverage, 11210,
     /* 265319 */     GIR_EraseRootFromParent_Done,
     /* 265320 */   // Label 5291: @265320
     /* 265320 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(265396), // Rule ID 6495 //
     /* 265325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265329 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 265329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 265332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 265346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 265358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 265362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 265365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 265375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265394 */     GIR_RootConstrainSelectedInstOperands,
     /* 265395 */     // GIR_Coverage, 6495,
     /* 265395 */     GIR_EraseRootFromParent_Done,
     /* 265396 */   // Label 5292: @265396
     /* 265396 */   GIM_Reject,
     /* 265397 */ // Label 5289: @265397
     /* 265397 */ GIM_Reject,
     /* 265398 */ // Label 5273: @265398
     /* 265398 */ GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(265459),
     /* 265403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 265406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265410 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(265437), // Rule ID 6367 //
     /* 265415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 265422 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 265422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 265425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 265432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265435 */     GIR_RootConstrainSelectedInstOperands,
     /* 265436 */     // GIR_Coverage, 6367,
     /* 265436 */     GIR_EraseRootFromParent_Done,
     /* 265437 */   // Label 5294: @265437
     /* 265437 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(265458), // Rule ID 6356 //
     /* 265442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265446 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 265446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 265449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265456 */     GIR_RootConstrainSelectedInstOperands,
     /* 265457 */     // GIR_Coverage, 6356,
     /* 265457 */     GIR_EraseRootFromParent_Done,
     /* 265458 */   // Label 5295: @265458
     /* 265458 */   GIM_Reject,
     /* 265459 */ // Label 5293: @265459
     /* 265459 */ GIM_Reject,
     /* 265460 */ // Label 5274: @265460
     /* 265460 */ GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(265521),
     /* 265465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 265468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265472 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(265499), // Rule ID 6364 //
     /* 265477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 265484 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 265484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 265487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 265494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265497 */     GIR_RootConstrainSelectedInstOperands,
     /* 265498 */     // GIR_Coverage, 6364,
     /* 265498 */     GIR_EraseRootFromParent_Done,
     /* 265499 */   // Label 5297: @265499
     /* 265499 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(265520), // Rule ID 6353 //
     /* 265504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265508 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 265508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 265511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265518 */     GIR_RootConstrainSelectedInstOperands,
     /* 265519 */     // GIR_Coverage, 6353,
     /* 265519 */     GIR_EraseRootFromParent_Done,
     /* 265520 */   // Label 5298: @265520
     /* 265520 */   GIM_Reject,
     /* 265521 */ // Label 5296: @265521
     /* 265521 */ GIM_Reject,
     /* 265522 */ // Label 5275: @265522
     /* 265522 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(265583),
     /* 265527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 265530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265534 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(265561), // Rule ID 6361 //
     /* 265539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 265546 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 265546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 265549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 265556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265559 */     GIR_RootConstrainSelectedInstOperands,
     /* 265560 */     // GIR_Coverage, 6361,
     /* 265560 */     GIR_EraseRootFromParent_Done,
     /* 265561 */   // Label 5300: @265561
     /* 265561 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(265582), // Rule ID 6350 //
     /* 265566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265570 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 265570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 265573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265580 */     GIR_RootConstrainSelectedInstOperands,
     /* 265581 */     // GIR_Coverage, 6350,
     /* 265581 */     GIR_EraseRootFromParent_Done,
     /* 265582 */   // Label 5301: @265582
     /* 265582 */   GIM_Reject,
     /* 265583 */ // Label 5299: @265583
     /* 265583 */ GIM_Reject,
     /* 265584 */ // Label 5276: @265584
     /* 265584 */ GIM_Reject,
     /* 265585 */ // Label 42: @265585
     /* 265585 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5307*/ GIMT_Encode4(267238),
     /* 265596 */ /*GILLT_s32*//*Label 5302*/ GIMT_Encode4(265676),
     /* 265600 */ /*GILLT_s64*//*Label 5303*/ GIMT_Encode4(266170), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265652 */ /*GILLT_nxv2s64*//*Label 5304*/ GIMT_Encode4(266812), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265664 */ /*GILLT_nxv4s32*//*Label 5305*/ GIMT_Encode4(267021), GIMT_Encode4(0),
     /* 265672 */ /*GILLT_nxv8s16*//*Label 5306*/ GIMT_Encode4(267165),
     /* 265676 */ // Label 5302: @265676
     /* 265676 */ GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(266169),
     /* 265681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265688 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(265753), // Rule ID 5652 //
     /* 265693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265722 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265726 */     // MIs[2] Operand 1
     /* 265726 */     // No operand predicates
     /* 265726 */     // MIs[0] Operand 2
     /* 265726 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265739 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265751 */     GIR_RootConstrainSelectedInstOperands,
     /* 265752 */     // GIR_Coverage, 5652,
     /* 265752 */     GIR_EraseRootFromParent_Done,
     /* 265753 */   // Label 5309: @265753
     /* 265753 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265818), // Rule ID 5654 //
     /* 265758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265791 */     // MIs[2] Operand 1
     /* 265791 */     // No operand predicates
     /* 265791 */     // MIs[0] Operand 2
     /* 265791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265804 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265816 */     GIR_RootConstrainSelectedInstOperands,
     /* 265817 */     // GIR_Coverage, 5654,
     /* 265817 */     GIR_EraseRootFromParent_Done,
     /* 265818 */   // Label 5310: @265818
     /* 265818 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265883), // Rule ID 5656 //
     /* 265823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265856 */     // MIs[2] Operand 1
     /* 265856 */     // No operand predicates
     /* 265856 */     // MIs[0] Operand 2
     /* 265856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265869 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265881 */     GIR_RootConstrainSelectedInstOperands,
     /* 265882 */     // GIR_Coverage, 5656,
     /* 265882 */     GIR_EraseRootFromParent_Done,
     /* 265883 */   // Label 5311: @265883
     /* 265883 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265973), // Rule ID 11206 //
     /* 265888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265915 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265919 */     // MIs[2] Operand 1
     /* 265919 */     // No operand predicates
     /* 265919 */     // MIs[0] Operand 2
     /* 265919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265932 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265971 */     GIR_RootConstrainSelectedInstOperands,
     /* 265972 */     // GIR_Coverage, 11206,
     /* 265972 */     GIR_EraseRootFromParent_Done,
     /* 265973 */   // Label 5312: @265973
     /* 265973 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(266063), // Rule ID 11208 //
     /* 265978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 266009 */     // MIs[2] Operand 1
     /* 266009 */     // No operand predicates
     /* 266009 */     // MIs[0] Operand 2
     /* 266009 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266022 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 266022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 266025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266034 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 266040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 266053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 266061 */     GIR_RootConstrainSelectedInstOperands,
     /* 266062 */     // GIR_Coverage, 11208,
     /* 266062 */     GIR_EraseRootFromParent_Done,
     /* 266063 */   // Label 5313: @266063
     /* 266063 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(266098), // Rule ID 6500 //
     /* 266068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266072 */     // MIs[0] Operand 2
     /* 266072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266083 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 266083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 266086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266088 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 266096 */     GIR_RootConstrainSelectedInstOperands,
     /* 266097 */     // GIR_Coverage, 6500,
     /* 266097 */     GIR_EraseRootFromParent_Done,
     /* 266098 */   // Label 5314: @266098
     /* 266098 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(266133), // Rule ID 6501 //
     /* 266103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266107 */     // MIs[0] Operand 2
     /* 266107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266118 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 266118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 266121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266123 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 266131 */     GIR_RootConstrainSelectedInstOperands,
     /* 266132 */     // GIR_Coverage, 6501,
     /* 266132 */     GIR_EraseRootFromParent_Done,
     /* 266133 */   // Label 5315: @266133
     /* 266133 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(266168), // Rule ID 6502 //
     /* 266138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266142 */     // MIs[0] Operand 2
     /* 266142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 266153 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 266153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 266156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266166 */     GIR_RootConstrainSelectedInstOperands,
     /* 266167 */     // GIR_Coverage, 6502,
     /* 266167 */     GIR_EraseRootFromParent_Done,
     /* 266168 */   // Label 5316: @266168
     /* 266168 */   GIM_Reject,
     /* 266169 */ // Label 5308: @266169
     /* 266169 */ GIM_Reject,
     /* 266170 */ // Label 5303: @266170
     /* 266170 */ GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(266811),
     /* 266175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266182 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(266259), // Rule ID 5658 //
     /* 266187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 266195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 266211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 266215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 266224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 266232 */     // MIs[3] Operand 1
     /* 266232 */     // No operand predicates
     /* 266232 */     // MIs[0] Operand 2
     /* 266232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 266245 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 266245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 266248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 266254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 266257 */     GIR_RootConstrainSelectedInstOperands,
     /* 266258 */     // GIR_Coverage, 5658,
     /* 266258 */     GIR_EraseRootFromParent_Done,
     /* 266259 */   // Label 5318: @266259
     /* 266259 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(266336), // Rule ID 5659 //
     /* 266264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 266272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 266288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 266292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 266301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 266309 */     // MIs[3] Operand 1
     /* 266309 */     // No operand predicates
     /* 266309 */     // MIs[0] Operand 2
     /* 266309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 266322 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 266322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 266325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 266331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 266334 */     GIR_RootConstrainSelectedInstOperands,
     /* 266335 */     // GIR_Coverage, 5659,
     /* 266335 */     GIR_EraseRootFromParent_Done,
     /* 266336 */   // Label 5319: @266336
     /* 266336 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(266438), // Rule ID 11207 //
     /* 266341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 266344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 266352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 266368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 266372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 266376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 266384 */     // MIs[3] Operand 1
     /* 266384 */     // No operand predicates
     /* 266384 */     // MIs[0] Operand 2
     /* 266384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 266397 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 266397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 266400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 266415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 266428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 266436 */     GIR_RootConstrainSelectedInstOperands,
     /* 266437 */     // GIR_Coverage, 11207,
     /* 266437 */     GIR_EraseRootFromParent_Done,
     /* 266438 */   // Label 5320: @266438
     /* 266438 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(266540), // Rule ID 11209 //
     /* 266443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 266446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 266454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 266458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 266462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 266470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 266474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 266478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266482 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 266486 */     // MIs[3] Operand 1
     /* 266486 */     // No operand predicates
     /* 266486 */     // MIs[0] Operand 2
     /* 266486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 266499 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 266499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 266502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 266517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 266530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 266538 */     GIR_RootConstrainSelectedInstOperands,
     /* 266539 */     // GIR_Coverage, 11209,
     /* 266539 */     GIR_EraseRootFromParent_Done,
     /* 266540 */   // Label 5321: @266540
     /* 266540 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(266605), // Rule ID 5653 //
     /* 266545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 266557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 266578 */     // MIs[2] Operand 1
     /* 266578 */     // No operand predicates
     /* 266578 */     // MIs[0] Operand 2
     /* 266578 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266591 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 266591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 266594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266603 */     GIR_RootConstrainSelectedInstOperands,
     /* 266604 */     // GIR_Coverage, 5653,
     /* 266604 */     GIR_EraseRootFromParent_Done,
     /* 266605 */   // Label 5322: @266605
     /* 266605 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(266670), // Rule ID 5655 //
     /* 266610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 266622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 266643 */     // MIs[2] Operand 1
     /* 266643 */     // No operand predicates
     /* 266643 */     // MIs[0] Operand 2
     /* 266643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266656 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 266656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 266659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266668 */     GIR_RootConstrainSelectedInstOperands,
     /* 266669 */     // GIR_Coverage, 5655,
     /* 266669 */     GIR_EraseRootFromParent_Done,
     /* 266670 */   // Label 5323: @266670
     /* 266670 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(266705), // Rule ID 6496 //
     /* 266675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266679 */     // MIs[0] Operand 2
     /* 266679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 266690 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 266690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 266703 */     GIR_RootConstrainSelectedInstOperands,
     /* 266704 */     // GIR_Coverage, 6496,
     /* 266704 */     GIR_EraseRootFromParent_Done,
     /* 266705 */   // Label 5324: @266705
     /* 266705 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(266740), // Rule ID 6497 //
     /* 266710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266714 */     // MIs[0] Operand 2
     /* 266714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266725 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 266725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 266738 */     GIR_RootConstrainSelectedInstOperands,
     /* 266739 */     // GIR_Coverage, 6497,
     /* 266739 */     GIR_EraseRootFromParent_Done,
     /* 266740 */   // Label 5325: @266740
     /* 266740 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(266775), // Rule ID 6498 //
     /* 266745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266749 */     // MIs[0] Operand 2
     /* 266749 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266760 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 266760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 266773 */     GIR_RootConstrainSelectedInstOperands,
     /* 266774 */     // GIR_Coverage, 6498,
     /* 266774 */     GIR_EraseRootFromParent_Done,
     /* 266775 */   // Label 5326: @266775
     /* 266775 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(266810), // Rule ID 6499 //
     /* 266780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266784 */     // MIs[0] Operand 2
     /* 266784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 266795 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 266795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266808 */     GIR_RootConstrainSelectedInstOperands,
     /* 266809 */     // GIR_Coverage, 6499,
     /* 266809 */     GIR_EraseRootFromParent_Done,
     /* 266810 */   // Label 5327: @266810
     /* 266810 */   GIM_Reject,
     /* 266811 */ // Label 5317: @266811
     /* 266811 */ GIM_Reject,
     /* 266812 */ // Label 5304: @266812
     /* 266812 */ GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(267020),
     /* 266817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 266820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266824 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266889), // Rule ID 10478 //
     /* 266829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266832 */     // MIs[0] Operand 2
     /* 266832 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 266843 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266855 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 266877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266887 */     GIR_RootConstrainSelectedInstOperands,
     /* 266888 */     // GIR_Coverage, 10478,
     /* 266888 */     GIR_EraseRootFromParent_Done,
     /* 266889 */   // Label 5329: @266889
     /* 266889 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266954), // Rule ID 10479 //
     /* 266894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266897 */     // MIs[0] Operand 2
     /* 266897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266908 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 266942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266952 */     GIR_RootConstrainSelectedInstOperands,
     /* 266953 */     // GIR_Coverage, 10479,
     /* 266953 */     GIR_EraseRootFromParent_Done,
     /* 266954 */   // Label 5330: @266954
     /* 266954 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(267019), // Rule ID 10480 //
     /* 266959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266962 */     // MIs[0] Operand 2
     /* 266962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266973 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266985 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 267007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 267015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 267017 */     GIR_RootConstrainSelectedInstOperands,
     /* 267018 */     // GIR_Coverage, 10480,
     /* 267018 */     GIR_EraseRootFromParent_Done,
     /* 267019 */   // Label 5331: @267019
     /* 267019 */   GIM_Reject,
     /* 267020 */ // Label 5328: @267020
     /* 267020 */ GIM_Reject,
     /* 267021 */ // Label 5305: @267021
     /* 267021 */ GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(267164),
     /* 267026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 267029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267033 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(267098), // Rule ID 10481 //
     /* 267038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267041 */     // MIs[0] Operand 2
     /* 267041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 267052 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 267052 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 267055 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 267059 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267064 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 267067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 267069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 267072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 267086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 267094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 267096 */     GIR_RootConstrainSelectedInstOperands,
     /* 267097 */     // GIR_Coverage, 10481,
     /* 267097 */     GIR_EraseRootFromParent_Done,
     /* 267098 */   // Label 5333: @267098
     /* 267098 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(267163), // Rule ID 10482 //
     /* 267103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267106 */     // MIs[0] Operand 2
     /* 267106 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267117 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 267117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 267120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 267124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267129 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 267132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 267134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 267137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 267151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 267159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 267161 */     GIR_RootConstrainSelectedInstOperands,
     /* 267162 */     // GIR_Coverage, 10482,
     /* 267162 */     GIR_EraseRootFromParent_Done,
     /* 267163 */   // Label 5334: @267163
     /* 267163 */   GIM_Reject,
     /* 267164 */ // Label 5332: @267164
     /* 267164 */ GIM_Reject,
     /* 267165 */ // Label 5306: @267165
     /* 267165 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(267237), // Rule ID 10483 //
     /* 267170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 267176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267180 */   // MIs[0] Operand 2
     /* 267180 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 267191 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 267191 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 267194 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 267198 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267203 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 267206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 267208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 267211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 267222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 267225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 267233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 267235 */   GIR_RootConstrainSelectedInstOperands,
     /* 267236 */   // GIR_Coverage, 10483,
     /* 267236 */   GIR_EraseRootFromParent_Done,
     /* 267237 */ // Label 5335: @267237
     /* 267237 */ GIM_Reject,
     /* 267238 */ // Label 5307: @267238
     /* 267238 */ GIM_Reject,
     /* 267239 */ // Label 43: @267239
     /* 267239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5340*/ GIMT_Encode4(270017),
     /* 267250 */ /*GILLT_s32*//*Label 5336*/ GIMT_Encode4(267286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 267266 */ /*GILLT_v2s64*//*Label 5337*/ GIMT_Encode4(269087), GIMT_Encode4(0),
     /* 267274 */ /*GILLT_v4s32*//*Label 5338*/ GIMT_Encode4(269397), GIMT_Encode4(0),
     /* 267282 */ /*GILLT_v8s16*//*Label 5339*/ GIMT_Encode4(269707),
     /* 267286 */ // Label 5336: @267286
     /* 267286 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(267436), // Rule ID 13114 //
     /* 267291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267298 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267306 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267309 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267314 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267318 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267325 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267325 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267328 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 267332 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267337 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267343 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267346 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267350 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267357 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267360 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267364 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267369 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267372 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267375 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267378 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267383 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267388 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267405 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267430 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267435 */   // GIR_Coverage, 13114,
     /* 267435 */   GIR_EraseRootFromParent_Done,
     /* 267436 */ // Label 5341: @267436
     /* 267436 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267586), // Rule ID 13116 //
     /* 267441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267448 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267456 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267459 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267468 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267475 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267475 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267478 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 267482 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267487 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267493 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267496 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267500 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267519 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267522 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267525 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267528 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267533 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267538 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267555 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267562 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267567 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267585 */   // GIR_Coverage, 13116,
     /* 267585 */   GIR_EraseRootFromParent_Done,
     /* 267586 */ // Label 5342: @267586
     /* 267586 */ GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267736), // Rule ID 13118 //
     /* 267591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267598 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267606 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267609 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267614 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267618 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267625 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267625 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267628 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 267632 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267637 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267643 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267646 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267650 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267657 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267660 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267664 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267669 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267672 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267675 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267678 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267683 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267688 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267705 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267735 */   // GIR_Coverage, 13118,
     /* 267735 */   GIR_EraseRootFromParent_Done,
     /* 267736 */ // Label 5343: @267736
     /* 267736 */ GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267886), // Rule ID 13120 //
     /* 267741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267748 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267756 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267759 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267768 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267775 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267775 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267778 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 267782 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267787 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267793 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267796 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267800 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267807 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267810 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267814 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267819 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267822 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267825 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267828 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267833 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267838 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267855 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267885 */   // GIR_Coverage, 13120,
     /* 267885 */   GIR_EraseRootFromParent_Done,
     /* 267886 */ // Label 5344: @267886
     /* 267886 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(268036), // Rule ID 13147 //
     /* 267891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267898 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267906 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267909 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267918 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267925 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267925 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267928 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 267932 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267937 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267943 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267946 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267950 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267957 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267960 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267964 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267969 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267972 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267975 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267978 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267983 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267988 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268005 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268035 */   // GIR_Coverage, 13147,
     /* 268035 */   GIR_EraseRootFromParent_Done,
     /* 268036 */ // Label 5345: @268036
     /* 268036 */ GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(268186), // Rule ID 13149 //
     /* 268041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268048 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268056 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268059 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 268064 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268068 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268075 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268075 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268078 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 268082 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268087 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268093 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268096 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268100 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268107 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268110 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268114 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268119 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268122 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268125 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268128 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268133 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268138 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268155 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268180 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268185 */   // GIR_Coverage, 13149,
     /* 268185 */   GIR_EraseRootFromParent_Done,
     /* 268186 */ // Label 5346: @268186
     /* 268186 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(268336), // Rule ID 13151 //
     /* 268191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268198 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268206 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268209 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 268214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268218 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268223 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268225 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268225 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268228 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 268232 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268237 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268257 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268260 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268264 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268269 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268272 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268275 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268278 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268283 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268288 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268305 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268335 */   // GIR_Coverage, 13151,
     /* 268335 */   GIR_EraseRootFromParent_Done,
     /* 268336 */ // Label 5347: @268336
     /* 268336 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(268486), // Rule ID 13153 //
     /* 268341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268348 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268356 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268359 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 268364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268375 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268375 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268378 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 268382 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268387 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268393 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268396 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268400 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268407 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268410 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268414 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268419 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268422 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268425 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268428 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268433 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268438 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268455 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268480 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268485 */   // GIR_Coverage, 13153,
     /* 268485 */   GIR_EraseRootFromParent_Done,
     /* 268486 */ // Label 5348: @268486
     /* 268486 */ GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(268636), // Rule ID 13157 //
     /* 268491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268498 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268506 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268509 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268525 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268525 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268528 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 268532 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268537 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268543 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268546 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268550 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268557 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268560 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268564 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268569 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268572 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268575 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268578 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268583 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268588 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268605 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268635 */   // GIR_Coverage, 13157,
     /* 268635 */   GIR_EraseRootFromParent_Done,
     /* 268636 */ // Label 5349: @268636
     /* 268636 */ GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(268786), // Rule ID 13159 //
     /* 268641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268648 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268656 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268659 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268675 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268675 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268678 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 268682 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268687 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268693 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268696 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268700 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268707 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268710 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268714 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268719 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268722 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268725 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268728 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268733 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268738 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268755 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268785 */   // GIR_Coverage, 13159,
     /* 268785 */   GIR_EraseRootFromParent_Done,
     /* 268786 */ // Label 5350: @268786
     /* 268786 */ GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(268936), // Rule ID 13161 //
     /* 268791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268798 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268806 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268809 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268814 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268818 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268825 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268825 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268828 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 268832 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268837 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268843 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268846 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268850 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268869 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268872 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268875 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268878 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268883 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268888 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268905 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268935 */   // GIR_Coverage, 13161,
     /* 268935 */   GIR_EraseRootFromParent_Done,
     /* 268936 */ // Label 5351: @268936
     /* 268936 */ GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(269086), // Rule ID 13163 //
     /* 268941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268956 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268959 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268968 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268975 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268975 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268978 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 268982 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268987 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 269007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 269010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269019 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 269022 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 269025 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 269028 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269033 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269038 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 269043 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269046 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269050 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269055 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 269062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 269067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269085 */   // GIR_Coverage, 13163,
     /* 269085 */   GIR_EraseRootFromParent_Done,
     /* 269086 */ // Label 5352: @269086
     /* 269086 */ GIM_Reject,
     /* 269087 */ // Label 5337: @269087
     /* 269087 */ GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(269396),
     /* 269092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269099 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(269164), // Rule ID 702 //
     /* 269104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269115 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269118 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 269127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 269131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 269140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 269147 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 269150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269162 */     GIR_RootConstrainSelectedInstOperands,
     /* 269163 */     // GIR_Coverage, 702,
     /* 269163 */     GIR_EraseRootFromParent_Done,
     /* 269164 */   // Label 5354: @269164
     /* 269164 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(269229), // Rule ID 1711 //
     /* 269169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269180 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269183 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 269192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 269196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 269205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 269212 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 269212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 269215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269227 */     GIR_RootConstrainSelectedInstOperands,
     /* 269228 */     // GIR_Coverage, 1711,
     /* 269228 */     GIR_EraseRootFromParent_Done,
     /* 269229 */   // Label 5355: @269229
     /* 269229 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(269288), // Rule ID 700 //
     /* 269234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269245 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269248 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 269257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 269261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269273 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 269273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 269276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269286 */     GIR_RootConstrainSelectedInstOperands,
     /* 269287 */     // GIR_Coverage, 700,
     /* 269287 */     GIR_EraseRootFromParent_Done,
     /* 269288 */   // Label 5356: @269288
     /* 269288 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(269347), // Rule ID 1709 //
     /* 269293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269304 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269307 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 269316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 269320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269332 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 269332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 269335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269345 */     GIR_RootConstrainSelectedInstOperands,
     /* 269346 */     // GIR_Coverage, 1709,
     /* 269346 */     GIR_EraseRootFromParent_Done,
     /* 269347 */   // Label 5357: @269347
     /* 269347 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(269374), // Rule ID 6366 //
     /* 269352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 269359 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 269359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 269362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269372 */     GIR_RootConstrainSelectedInstOperands,
     /* 269373 */     // GIR_Coverage, 6366,
     /* 269373 */     GIR_EraseRootFromParent_Done,
     /* 269374 */   // Label 5358: @269374
     /* 269374 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(269395), // Rule ID 6357 //
     /* 269379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269383 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 269383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 269386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269393 */     GIR_RootConstrainSelectedInstOperands,
     /* 269394 */     // GIR_Coverage, 6357,
     /* 269394 */     GIR_EraseRootFromParent_Done,
     /* 269395 */   // Label 5359: @269395
     /* 269395 */   GIM_Reject,
     /* 269396 */ // Label 5353: @269396
     /* 269396 */ GIM_Reject,
     /* 269397 */ // Label 5338: @269397
     /* 269397 */ GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(269706),
     /* 269402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269409 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(269474), // Rule ID 698 //
     /* 269414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269457 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 269457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 269460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269472 */     GIR_RootConstrainSelectedInstOperands,
     /* 269473 */     // GIR_Coverage, 698,
     /* 269473 */     GIR_EraseRootFromParent_Done,
     /* 269474 */   // Label 5361: @269474
     /* 269474 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(269539), // Rule ID 1707 //
     /* 269479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269490 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269493 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269502 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269522 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 269522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 269525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269537 */     GIR_RootConstrainSelectedInstOperands,
     /* 269538 */     // GIR_Coverage, 1707,
     /* 269538 */     GIR_EraseRootFromParent_Done,
     /* 269539 */   // Label 5362: @269539
     /* 269539 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(269598), // Rule ID 696 //
     /* 269544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269555 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269558 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269583 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 269583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 269586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269596 */     GIR_RootConstrainSelectedInstOperands,
     /* 269597 */     // GIR_Coverage, 696,
     /* 269597 */     GIR_EraseRootFromParent_Done,
     /* 269598 */   // Label 5363: @269598
     /* 269598 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(269657), // Rule ID 1705 //
     /* 269603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269614 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269617 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269626 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269642 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 269642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 269645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269655 */     GIR_RootConstrainSelectedInstOperands,
     /* 269656 */     // GIR_Coverage, 1705,
     /* 269656 */     GIR_EraseRootFromParent_Done,
     /* 269657 */   // Label 5364: @269657
     /* 269657 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(269684), // Rule ID 6363 //
     /* 269662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269669 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 269669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 269672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269682 */     GIR_RootConstrainSelectedInstOperands,
     /* 269683 */     // GIR_Coverage, 6363,
     /* 269683 */     GIR_EraseRootFromParent_Done,
     /* 269684 */   // Label 5365: @269684
     /* 269684 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(269705), // Rule ID 6354 //
     /* 269689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269693 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 269693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 269696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269703 */     GIR_RootConstrainSelectedInstOperands,
     /* 269704 */     // GIR_Coverage, 6354,
     /* 269704 */     GIR_EraseRootFromParent_Done,
     /* 269705 */   // Label 5366: @269705
     /* 269705 */   GIM_Reject,
     /* 269706 */ // Label 5360: @269706
     /* 269706 */ GIM_Reject,
     /* 269707 */ // Label 5339: @269707
     /* 269707 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(270016),
     /* 269712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269719 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(269784), // Rule ID 694 //
     /* 269724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269735 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269738 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269767 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 269770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269782 */     GIR_RootConstrainSelectedInstOperands,
     /* 269783 */     // GIR_Coverage, 694,
     /* 269783 */     GIR_EraseRootFromParent_Done,
     /* 269784 */   // Label 5368: @269784
     /* 269784 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(269849), // Rule ID 1703 //
     /* 269789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269812 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269832 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 269835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269847 */     GIR_RootConstrainSelectedInstOperands,
     /* 269848 */     // GIR_Coverage, 1703,
     /* 269848 */     GIR_EraseRootFromParent_Done,
     /* 269849 */   // Label 5369: @269849
     /* 269849 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(269908), // Rule ID 692 //
     /* 269854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269865 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269868 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269877 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269893 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 269896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269906 */     GIR_RootConstrainSelectedInstOperands,
     /* 269907 */     // GIR_Coverage, 692,
     /* 269907 */     GIR_EraseRootFromParent_Done,
     /* 269908 */   // Label 5370: @269908
     /* 269908 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(269967), // Rule ID 1701 //
     /* 269913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269924 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269927 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269952 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 269955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269965 */     GIR_RootConstrainSelectedInstOperands,
     /* 269966 */     // GIR_Coverage, 1701,
     /* 269966 */     GIR_EraseRootFromParent_Done,
     /* 269967 */   // Label 5371: @269967
     /* 269967 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(269994), // Rule ID 6360 //
     /* 269972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269979 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 269979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 269982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269992 */     GIR_RootConstrainSelectedInstOperands,
     /* 269993 */     // GIR_Coverage, 6360,
     /* 269993 */     GIR_EraseRootFromParent_Done,
     /* 269994 */   // Label 5372: @269994
     /* 269994 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(270015), // Rule ID 6351 //
     /* 269999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270003 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 270003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 270006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270013 */     GIR_RootConstrainSelectedInstOperands,
     /* 270014 */     // GIR_Coverage, 6351,
     /* 270014 */     GIR_EraseRootFromParent_Done,
     /* 270015 */   // Label 5373: @270015
     /* 270015 */   GIM_Reject,
     /* 270016 */ // Label 5367: @270016
     /* 270016 */ GIM_Reject,
     /* 270017 */ // Label 5340: @270017
     /* 270017 */ GIM_Reject,
     /* 270018 */ // Label 44: @270018
     /* 270018 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5379*/ GIMT_Encode4(270842),
     /* 270029 */ /*GILLT_s32*//*Label 5374*/ GIMT_Encode4(270065),
     /* 270033 */ /*GILLT_s64*//*Label 5375*/ GIMT_Encode4(270242), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270045 */ /*GILLT_v2s64*//*Label 5376*/ GIMT_Encode4(270415), GIMT_Encode4(0),
     /* 270053 */ /*GILLT_v4s32*//*Label 5377*/ GIMT_Encode4(270560), GIMT_Encode4(0),
     /* 270061 */ /*GILLT_v8s16*//*Label 5378*/ GIMT_Encode4(270701),
     /* 270065 */ // Label 5374: @270065
     /* 270065 */ GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(270241),
     /* 270070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270084 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(270121), // Rule ID 3935 //
     /* 270089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270108 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 270111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270119 */     GIR_RootConstrainSelectedInstOperands,
     /* 270120 */     // GIR_Coverage, 3935,
     /* 270120 */     GIR_EraseRootFromParent_Done,
     /* 270121 */   // Label 5381: @270121
     /* 270121 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(270158), // Rule ID 3936 //
     /* 270126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270145 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 270148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270156 */     GIR_RootConstrainSelectedInstOperands,
     /* 270157 */     // GIR_Coverage, 3936,
     /* 270157 */     GIR_EraseRootFromParent_Done,
     /* 270158 */   // Label 5382: @270158
     /* 270158 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(270195), // Rule ID 3934 //
     /* 270163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270182 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 270185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270193 */     GIR_RootConstrainSelectedInstOperands,
     /* 270194 */     // GIR_Coverage, 3934,
     /* 270194 */     GIR_EraseRootFromParent_Done,
     /* 270195 */   // Label 5383: @270195
     /* 270195 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(270240), // Rule ID 3933 //
     /* 270200 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 270200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270212 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 270218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 270231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270238 */     GIR_RootConstrainSelectedInstOperands,
     /* 270239 */     // GIR_Coverage, 3933,
     /* 270239 */     GIR_EraseRootFromParent_Done,
     /* 270240 */   // Label 5384: @270240
     /* 270240 */   GIM_Reject,
     /* 270241 */ // Label 5380: @270241
     /* 270241 */ GIM_Reject,
     /* 270242 */ // Label 5375: @270242
     /* 270242 */ GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(270414),
     /* 270247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270261 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(270329), // Rule ID 3937 //
     /* 270266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270285 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 270320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270327 */     GIR_RootConstrainSelectedInstOperands,
     /* 270328 */     // GIR_Coverage, 3937,
     /* 270328 */     GIR_EraseRootFromParent_Done,
     /* 270329 */   // Label 5386: @270329
     /* 270329 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(270397), // Rule ID 3938 //
     /* 270334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270353 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 270388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270395 */     GIR_RootConstrainSelectedInstOperands,
     /* 270396 */     // GIR_Coverage, 3938,
     /* 270396 */     GIR_EraseRootFromParent_Done,
     /* 270397 */   // Label 5387: @270397
     /* 270397 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(270413), // Rule ID 120 //
     /* 270402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270406 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 270411 */     GIR_RootConstrainSelectedInstOperands,
     /* 270412 */     // GIR_Coverage, 120,
     /* 270412 */     GIR_Done,
     /* 270413 */   // Label 5388: @270413
     /* 270413 */   GIM_Reject,
     /* 270414 */ // Label 5385: @270414
     /* 270414 */ GIM_Reject,
     /* 270415 */ // Label 5376: @270415
     /* 270415 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(270559),
     /* 270420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 270423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 270426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270430 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(270494), // Rule ID 6349 //
     /* 270435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 270464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270472 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270476 */     // MIs[3] Operand 1
     /* 270476 */     // No operand predicates
     /* 270476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270478 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 270478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 270481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270487 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 270492 */     GIR_RootConstrainSelectedInstOperands,
     /* 270493 */     // GIR_Coverage, 6349,
     /* 270493 */     GIR_EraseRootFromParent_Done,
     /* 270494 */   // Label 5390: @270494
     /* 270494 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(270558), // Rule ID 6346 //
     /* 270499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 270528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270536 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270540 */     // MIs[3] Operand 1
     /* 270540 */     // No operand predicates
     /* 270540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270542 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 270542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 270545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270551 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 270556 */     GIR_RootConstrainSelectedInstOperands,
     /* 270557 */     // GIR_Coverage, 6346,
     /* 270557 */     GIR_EraseRootFromParent_Done,
     /* 270558 */   // Label 5391: @270558
     /* 270558 */   GIM_Reject,
     /* 270559 */ // Label 5389: @270559
     /* 270559 */ GIM_Reject,
     /* 270560 */ // Label 5377: @270560
     /* 270560 */ GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(270700),
     /* 270565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270575 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(270637), // Rule ID 6348 //
     /* 270580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 270621 */     // MIs[3] Operand 1
     /* 270621 */     // No operand predicates
     /* 270621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270623 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 270623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 270626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270635 */     GIR_RootConstrainSelectedInstOperands,
     /* 270636 */     // GIR_Coverage, 6348,
     /* 270636 */     GIR_EraseRootFromParent_Done,
     /* 270637 */   // Label 5393: @270637
     /* 270637 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(270699), // Rule ID 6345 //
     /* 270642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 270683 */     // MIs[3] Operand 1
     /* 270683 */     // No operand predicates
     /* 270683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270685 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 270685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 270688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270697 */     GIR_RootConstrainSelectedInstOperands,
     /* 270698 */     // GIR_Coverage, 6345,
     /* 270698 */     GIR_EraseRootFromParent_Done,
     /* 270699 */   // Label 5394: @270699
     /* 270699 */   GIM_Reject,
     /* 270700 */ // Label 5392: @270700
     /* 270700 */ GIM_Reject,
     /* 270701 */ // Label 5378: @270701
     /* 270701 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270841),
     /* 270706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270716 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270778), // Rule ID 6347 //
     /* 270721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270758 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 270762 */     // MIs[3] Operand 1
     /* 270762 */     // No operand predicates
     /* 270762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270764 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 270764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 270767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270776 */     GIR_RootConstrainSelectedInstOperands,
     /* 270777 */     // GIR_Coverage, 6347,
     /* 270777 */     GIR_EraseRootFromParent_Done,
     /* 270778 */   // Label 5396: @270778
     /* 270778 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270840), // Rule ID 6344 //
     /* 270783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270820 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 270824 */     // MIs[3] Operand 1
     /* 270824 */     // No operand predicates
     /* 270824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270826 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 270826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 270829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270838 */     GIR_RootConstrainSelectedInstOperands,
     /* 270839 */     // GIR_Coverage, 6344,
     /* 270839 */     GIR_EraseRootFromParent_Done,
     /* 270840 */   // Label 5397: @270840
     /* 270840 */   GIM_Reject,
     /* 270841 */ // Label 5395: @270841
     /* 270841 */ GIM_Reject,
     /* 270842 */ // Label 5379: @270842
     /* 270842 */ GIM_Reject,
     /* 270843 */ // Label 45: @270843
     /* 270843 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5400*/ GIMT_Encode4(271280),
     /* 270854 */ /*GILLT_s32*//*Label 5398*/ GIMT_Encode4(270862),
     /* 270858 */ /*GILLT_s64*//*Label 5399*/ GIMT_Encode4(271073),
     /* 270862 */ // Label 5398: @270862
     /* 270862 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(271072),
     /* 270867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270881 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270915), // Rule ID 4024 //
     /* 270886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270898 */     // MIs[1] Operand 1
     /* 270898 */     // No operand predicates
     /* 270898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270900 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 270903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270913 */     GIR_RootConstrainSelectedInstOperands,
     /* 270914 */     // GIR_Coverage, 4024,
     /* 270914 */     GIR_EraseRootFromParent_Done,
     /* 270915 */   // Label 5402: @270915
     /* 270915 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270952), // Rule ID 3941 //
     /* 270920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270939 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270950 */     GIR_RootConstrainSelectedInstOperands,
     /* 270951 */     // GIR_Coverage, 3941,
     /* 270951 */     GIR_EraseRootFromParent_Done,
     /* 270952 */   // Label 5403: @270952
     /* 270952 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270989), // Rule ID 3942 //
     /* 270957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270976 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270987 */     GIR_RootConstrainSelectedInstOperands,
     /* 270988 */     // GIR_Coverage, 3942,
     /* 270988 */     GIR_EraseRootFromParent_Done,
     /* 270989 */   // Label 5404: @270989
     /* 270989 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(271026), // Rule ID 3940 //
     /* 270994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271013 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 271016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271024 */     GIR_RootConstrainSelectedInstOperands,
     /* 271025 */     // GIR_Coverage, 3940,
     /* 271025 */     GIR_EraseRootFromParent_Done,
     /* 271026 */   // Label 5405: @271026
     /* 271026 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(271071), // Rule ID 3939 //
     /* 271031 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 271031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271043 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 271049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 271062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271069 */     GIR_RootConstrainSelectedInstOperands,
     /* 271070 */     // GIR_Coverage, 3939,
     /* 271070 */     GIR_EraseRootFromParent_Done,
     /* 271071 */   // Label 5406: @271071
     /* 271071 */   GIM_Reject,
     /* 271072 */ // Label 5401: @271072
     /* 271072 */ GIM_Reject,
     /* 271073 */ // Label 5399: @271073
     /* 271073 */ GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(271279),
     /* 271078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271092 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(271126), // Rule ID 4025 //
     /* 271097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271109 */     // MIs[1] Operand 1
     /* 271109 */     // No operand predicates
     /* 271109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271111 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 271111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 271114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 271124 */     GIR_RootConstrainSelectedInstOperands,
     /* 271125 */     // GIR_Coverage, 4025,
     /* 271125 */     GIR_EraseRootFromParent_Done,
     /* 271126 */   // Label 5408: @271126
     /* 271126 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(271194), // Rule ID 3943 //
     /* 271131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271150 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 271185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271192 */     GIR_RootConstrainSelectedInstOperands,
     /* 271193 */     // GIR_Coverage, 3943,
     /* 271193 */     GIR_EraseRootFromParent_Done,
     /* 271194 */   // Label 5409: @271194
     /* 271194 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(271262), // Rule ID 3944 //
     /* 271199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271218 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 271253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271260 */     GIR_RootConstrainSelectedInstOperands,
     /* 271261 */     // GIR_Coverage, 3944,
     /* 271261 */     GIR_EraseRootFromParent_Done,
     /* 271262 */   // Label 5410: @271262
     /* 271262 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(271278), // Rule ID 121 //
     /* 271267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271271 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 271276 */     GIR_RootConstrainSelectedInstOperands,
     /* 271277 */     // GIR_Coverage, 121,
     /* 271277 */     GIR_Done,
     /* 271278 */   // Label 5411: @271278
     /* 271278 */   GIM_Reject,
     /* 271279 */ // Label 5407: @271279
     /* 271279 */ GIM_Reject,
     /* 271280 */ // Label 5400: @271280
     /* 271280 */ GIM_Reject,
     /* 271281 */ // Label 46: @271281
     /* 271281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5414*/ GIMT_Encode4(272105),
     /* 271292 */ /*GILLT_s32*//*Label 5412*/ GIMT_Encode4(271300),
     /* 271296 */ /*GILLT_s64*//*Label 5413*/ GIMT_Encode4(271655),
     /* 271300 */ // Label 5412: @271300
     /* 271300 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(271654),
     /* 271305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271315 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(271379), // Rule ID 6509 //
     /* 271320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271337 */     // MIs[1] Operand 2
     /* 271337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 271348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 271360 */     // MIs[2] Operand 1
     /* 271360 */     // No operand predicates
     /* 271360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271362 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 271362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 271365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 271377 */     GIR_RootConstrainSelectedInstOperands,
     /* 271378 */     // GIR_Coverage, 6509,
     /* 271378 */     GIR_EraseRootFromParent_Done,
     /* 271379 */   // Label 5416: @271379
     /* 271379 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(271443), // Rule ID 6511 //
     /* 271384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271401 */     // MIs[1] Operand 2
     /* 271401 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 271412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 271424 */     // MIs[2] Operand 1
     /* 271424 */     // No operand predicates
     /* 271424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271426 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 271426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 271429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 271441 */     GIR_RootConstrainSelectedInstOperands,
     /* 271442 */     // GIR_Coverage, 6511,
     /* 271442 */     GIR_EraseRootFromParent_Done,
     /* 271443 */   // Label 5417: @271443
     /* 271443 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(271481), // Rule ID 4022 //
     /* 271448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271464 */     // MIs[1] Operand 1
     /* 271464 */     // No operand predicates
     /* 271464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271466 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 271466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 271469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 271479 */     GIR_RootConstrainSelectedInstOperands,
     /* 271480 */     // GIR_Coverage, 4022,
     /* 271480 */     GIR_EraseRootFromParent_Done,
     /* 271481 */   // Label 5418: @271481
     /* 271481 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(271522), // Rule ID 2435 //
     /* 271486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271509 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 271512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271520 */     GIR_RootConstrainSelectedInstOperands,
     /* 271521 */     // GIR_Coverage, 2435,
     /* 271521 */     GIR_EraseRootFromParent_Done,
     /* 271522 */   // Label 5419: @271522
     /* 271522 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(271563), // Rule ID 2436 //
     /* 271527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271550 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 271553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271561 */     GIR_RootConstrainSelectedInstOperands,
     /* 271562 */     // GIR_Coverage, 2436,
     /* 271562 */     GIR_EraseRootFromParent_Done,
     /* 271563 */   // Label 5420: @271563
     /* 271563 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(271604), // Rule ID 2434 //
     /* 271568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271591 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 271594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271602 */     GIR_RootConstrainSelectedInstOperands,
     /* 271603 */     // GIR_Coverage, 2434,
     /* 271603 */     GIR_EraseRootFromParent_Done,
     /* 271604 */   // Label 5421: @271604
     /* 271604 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(271653), // Rule ID 2433 //
     /* 271609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271613 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 271613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 271616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 271620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 271631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 271644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271651 */     GIR_RootConstrainSelectedInstOperands,
     /* 271652 */     // GIR_Coverage, 2433,
     /* 271652 */     GIR_EraseRootFromParent_Done,
     /* 271653 */   // Label 5422: @271653
     /* 271653 */   GIM_Reject,
     /* 271654 */ // Label 5415: @271654
     /* 271654 */ GIM_Reject,
     /* 271655 */ // Label 5413: @271655
     /* 271655 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(272104),
     /* 271660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271670 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(271734), // Rule ID 6510 //
     /* 271675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271692 */     // MIs[1] Operand 2
     /* 271692 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 271703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271711 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 271715 */     // MIs[2] Operand 1
     /* 271715 */     // No operand predicates
     /* 271715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271717 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 271717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 271732 */     GIR_RootConstrainSelectedInstOperands,
     /* 271733 */     // GIR_Coverage, 6510,
     /* 271733 */     GIR_EraseRootFromParent_Done,
     /* 271734 */   // Label 5424: @271734
     /* 271734 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(271798), // Rule ID 6512 //
     /* 271739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271756 */     // MIs[1] Operand 2
     /* 271756 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 271767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 271779 */     // MIs[2] Operand 1
     /* 271779 */     // No operand predicates
     /* 271779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271781 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 271781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 271796 */     GIR_RootConstrainSelectedInstOperands,
     /* 271797 */     // GIR_Coverage, 6512,
     /* 271797 */     GIR_EraseRootFromParent_Done,
     /* 271798 */   // Label 5425: @271798
     /* 271798 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(271901), // Rule ID 6513 //
     /* 271803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271832 */     // MIs[2] Operand 1
     /* 271832 */     // No operand predicates
     /* 271832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271834 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 271834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 271837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 271841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 271848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 271855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 271863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 271899 */     GIR_RootConstrainSelectedInstOperands,
     /* 271900 */     // GIR_Coverage, 6513,
     /* 271900 */     GIR_EraseRootFromParent_Done,
     /* 271901 */   // Label 5426: @271901
     /* 271901 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271939), // Rule ID 4023 //
     /* 271906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271922 */     // MIs[1] Operand 1
     /* 271922 */     // No operand predicates
     /* 271922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271924 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 271924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 271937 */     GIR_RootConstrainSelectedInstOperands,
     /* 271938 */     // GIR_Coverage, 4023,
     /* 271938 */     GIR_EraseRootFromParent_Done,
     /* 271939 */   // Label 5427: @271939
     /* 271939 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(272011), // Rule ID 2437 //
     /* 271944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271967 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 272002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272009 */     GIR_RootConstrainSelectedInstOperands,
     /* 272010 */     // GIR_Coverage, 2437,
     /* 272010 */     GIR_EraseRootFromParent_Done,
     /* 272011 */   // Label 5428: @272011
     /* 272011 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(272083), // Rule ID 2438 //
     /* 272016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272039 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 272074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272081 */     GIR_RootConstrainSelectedInstOperands,
     /* 272082 */     // GIR_Coverage, 2438,
     /* 272082 */     GIR_EraseRootFromParent_Done,
     /* 272083 */   // Label 5429: @272083
     /* 272083 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(272103), // Rule ID 119 //
     /* 272088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272096 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 272101 */     GIR_RootConstrainSelectedInstOperands,
     /* 272102 */     // GIR_Coverage, 119,
     /* 272102 */     GIR_Done,
     /* 272103 */   // Label 5430: @272103
     /* 272103 */   GIM_Reject,
     /* 272104 */ // Label 5423: @272104
     /* 272104 */ GIM_Reject,
     /* 272105 */ // Label 5414: @272105
     /* 272105 */ GIM_Reject,
     /* 272106 */ // Label 47: @272106
     /* 272106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5433*/ GIMT_Encode4(272235),
     /* 272117 */ /*GILLT_s32*//*Label 5431*/ GIMT_Encode4(272125),
     /* 272121 */ /*GILLT_s64*//*Label 5432*/ GIMT_Encode4(272180),
     /* 272125 */ // Label 5431: @272125
     /* 272125 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(272179), // Rule ID 188 //
     /* 272130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 272136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272159 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272163 */   // MIs[1] Operand 1
     /* 272163 */   // No operand predicates
     /* 272163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272165 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 272165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 272168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272170 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272172 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 272174 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272177 */   GIR_RootConstrainSelectedInstOperands,
     /* 272178 */   // GIR_Coverage, 188,
     /* 272178 */   GIR_EraseRootFromParent_Done,
     /* 272179 */ // Label 5434: @272179
     /* 272179 */ GIM_Reject,
     /* 272180 */ // Label 5432: @272180
     /* 272180 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(272234), // Rule ID 189 //
     /* 272185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272191 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272214 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 272218 */   // MIs[1] Operand 1
     /* 272218 */   // No operand predicates
     /* 272218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272220 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 272220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 272223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272225 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272227 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 272229 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272232 */   GIR_RootConstrainSelectedInstOperands,
     /* 272233 */   // GIR_Coverage, 189,
     /* 272233 */   GIR_EraseRootFromParent_Done,
     /* 272234 */ // Label 5435: @272234
     /* 272234 */ GIM_Reject,
     /* 272235 */ // Label 5433: @272235
     /* 272235 */ GIM_Reject,
     /* 272236 */ // Label 48: @272236
     /* 272236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5438*/ GIMT_Encode4(272777),
     /* 272247 */ /*GILLT_s32*//*Label 5436*/ GIMT_Encode4(272255),
     /* 272251 */ /*GILLT_s64*//*Label 5437*/ GIMT_Encode4(272520),
     /* 272255 */ // Label 5436: @272255
     /* 272255 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(272519),
     /* 272260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272270 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(272309), // Rule ID 184 //
     /* 272275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 272283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 272296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272298 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 272298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 272301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272307 */     GIR_RootConstrainSelectedInstOperands,
     /* 272308 */     // GIR_Coverage, 184,
     /* 272308 */     GIR_EraseRootFromParent_Done,
     /* 272309 */   // Label 5440: @272309
     /* 272309 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(272346), // Rule ID 4018 //
     /* 272314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 272330 */     // MIs[1] Operand 1
     /* 272330 */     // No operand predicates
     /* 272330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272332 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 272332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 272335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272344 */     GIR_RootConstrainSelectedInstOperands,
     /* 272345 */     // GIR_Coverage, 4018,
     /* 272345 */     GIR_EraseRootFromParent_Done,
     /* 272346 */   // Label 5441: @272346
     /* 272346 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(272387), // Rule ID 3947 //
     /* 272351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 272363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272374 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 272377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272385 */     GIR_RootConstrainSelectedInstOperands,
     /* 272386 */     // GIR_Coverage, 3947,
     /* 272386 */     GIR_EraseRootFromParent_Done,
     /* 272387 */   // Label 5442: @272387
     /* 272387 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(272428), // Rule ID 3948 //
     /* 272392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272415 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 272418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272426 */     GIR_RootConstrainSelectedInstOperands,
     /* 272427 */     // GIR_Coverage, 3948,
     /* 272427 */     GIR_EraseRootFromParent_Done,
     /* 272428 */   // Label 5443: @272428
     /* 272428 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(272469), // Rule ID 3946 //
     /* 272433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272456 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 272456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 272459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272467 */     GIR_RootConstrainSelectedInstOperands,
     /* 272468 */     // GIR_Coverage, 3946,
     /* 272468 */     GIR_EraseRootFromParent_Done,
     /* 272469 */   // Label 5444: @272469
     /* 272469 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(272518), // Rule ID 3945 //
     /* 272474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272478 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 272478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 272496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 272509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272516 */     GIR_RootConstrainSelectedInstOperands,
     /* 272517 */     // GIR_Coverage, 3945,
     /* 272517 */     GIR_EraseRootFromParent_Done,
     /* 272518 */   // Label 5445: @272518
     /* 272518 */   GIM_Reject,
     /* 272519 */ // Label 5439: @272519
     /* 272519 */ GIM_Reject,
     /* 272520 */ // Label 5437: @272520
     /* 272520 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(272776),
     /* 272525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 272528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272535 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(272574), // Rule ID 187 //
     /* 272540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 272548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 272552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 272561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272563 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 272563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 272566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272572 */     GIR_RootConstrainSelectedInstOperands,
     /* 272573 */     // GIR_Coverage, 187,
     /* 272573 */     GIR_EraseRootFromParent_Done,
     /* 272574 */   // Label 5447: @272574
     /* 272574 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(272611), // Rule ID 4019 //
     /* 272579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 272595 */     // MIs[1] Operand 1
     /* 272595 */     // No operand predicates
     /* 272595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272597 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 272597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 272600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 272609 */     GIR_RootConstrainSelectedInstOperands,
     /* 272610 */     // GIR_Coverage, 4019,
     /* 272610 */     GIR_EraseRootFromParent_Done,
     /* 272611 */   // Label 5448: @272611
     /* 272611 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272683), // Rule ID 3949 //
     /* 272616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 272628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272639 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272651 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 272674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272681 */     GIR_RootConstrainSelectedInstOperands,
     /* 272682 */     // GIR_Coverage, 3949,
     /* 272682 */     GIR_EraseRootFromParent_Done,
     /* 272683 */   // Label 5449: @272683
     /* 272683 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272755), // Rule ID 3950 //
     /* 272688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 272700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 272704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272711 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 272711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 272718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 272726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 272746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272753 */     GIR_RootConstrainSelectedInstOperands,
     /* 272754 */     // GIR_Coverage, 3950,
     /* 272754 */     GIR_EraseRootFromParent_Done,
     /* 272755 */   // Label 5450: @272755
     /* 272755 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(272775), // Rule ID 122 //
     /* 272760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272768 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 272773 */     GIR_RootConstrainSelectedInstOperands,
     /* 272774 */     // GIR_Coverage, 122,
     /* 272774 */     GIR_Done,
     /* 272775 */   // Label 5451: @272775
     /* 272775 */   GIM_Reject,
     /* 272776 */ // Label 5446: @272776
     /* 272776 */ GIM_Reject,
     /* 272777 */ // Label 5438: @272777
     /* 272777 */ GIM_Reject,
     /* 272778 */ // Label 49: @272778
     /* 272778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5460*/ GIMT_Encode4(280554),
     /* 272789 */ /*GILLT_s64*//*Label 5452*/ GIMT_Encode4(272825), GIMT_Encode4(0),
     /* 272797 */ /*GILLT_v2s32*//*Label 5453*/ GIMT_Encode4(273218),
     /* 272801 */ /*GILLT_v2s64*//*Label 5454*/ GIMT_Encode4(274266),
     /* 272805 */ /*GILLT_v4s16*//*Label 5455*/ GIMT_Encode4(275314),
     /* 272809 */ /*GILLT_v4s32*//*Label 5456*/ GIMT_Encode4(276362),
     /* 272813 */ /*GILLT_v8s8*//*Label 5457*/ GIMT_Encode4(277410),
     /* 272817 */ /*GILLT_v8s16*//*Label 5458*/ GIMT_Encode4(278458),
     /* 272821 */ /*GILLT_v16s8*//*Label 5459*/ GIMT_Encode4(279506),
     /* 272825 */ // Label 5452: @272825
     /* 272825 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(273217),
     /* 272830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272840 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272876), // Rule ID 5242 //
     /* 272845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272848 */     // MIs[0] Operand 1
     /* 272848 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272867 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 272870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272874 */     GIR_RootConstrainSelectedInstOperands,
     /* 272875 */     // GIR_Coverage, 5242,
     /* 272875 */     GIR_EraseRootFromParent_Done,
     /* 272876 */   // Label 5462: @272876
     /* 272876 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(272912), // Rule ID 5243 //
     /* 272881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272884 */     // MIs[0] Operand 1
     /* 272884 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272893 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272899 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272903 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 272906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272910 */     GIR_RootConstrainSelectedInstOperands,
     /* 272911 */     // GIR_Coverage, 5243,
     /* 272911 */     GIR_EraseRootFromParent_Done,
     /* 272912 */   // Label 5463: @272912
     /* 272912 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(272948), // Rule ID 2512 //
     /* 272917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272920 */     // MIs[0] Operand 1
     /* 272920 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272929 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272935 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272939 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 272942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272946 */     GIR_RootConstrainSelectedInstOperands,
     /* 272947 */     // GIR_Coverage, 2512,
     /* 272947 */     GIR_EraseRootFromParent_Done,
     /* 272948 */   // Label 5464: @272948
     /* 272948 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(272984), // Rule ID 5239 //
     /* 272953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272956 */     // MIs[0] Operand 1
     /* 272956 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272965 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272971 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272975 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 272978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272982 */     GIR_RootConstrainSelectedInstOperands,
     /* 272983 */     // GIR_Coverage, 5239,
     /* 272983 */     GIR_EraseRootFromParent_Done,
     /* 272984 */   // Label 5465: @272984
     /* 272984 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(273020), // Rule ID 5240 //
     /* 272989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272992 */     // MIs[0] Operand 1
     /* 272992 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273001 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273011 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 273011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 273014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273018 */     GIR_RootConstrainSelectedInstOperands,
     /* 273019 */     // GIR_Coverage, 5240,
     /* 273019 */     GIR_EraseRootFromParent_Done,
     /* 273020 */   // Label 5466: @273020
     /* 273020 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(273056), // Rule ID 5241 //
     /* 273025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273028 */     // MIs[0] Operand 1
     /* 273028 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273037 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273043 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273047 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 273047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 273050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273054 */     GIR_RootConstrainSelectedInstOperands,
     /* 273055 */     // GIR_Coverage, 5241,
     /* 273055 */     GIR_EraseRootFromParent_Done,
     /* 273056 */   // Label 5467: @273056
     /* 273056 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(273088), // Rule ID 1608 //
     /* 273061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273064 */     // MIs[0] Operand 1
     /* 273064 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273077 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 273077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 273080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273086 */     GIR_RootConstrainSelectedInstOperands,
     /* 273087 */     // GIR_Coverage, 1608,
     /* 273087 */     GIR_EraseRootFromParent_Done,
     /* 273088 */   // Label 5468: @273088
     /* 273088 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(273120), // Rule ID 1609 //
     /* 273093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273096 */     // MIs[0] Operand 1
     /* 273096 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273109 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 273109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 273112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273118 */     GIR_RootConstrainSelectedInstOperands,
     /* 273119 */     // GIR_Coverage, 1609,
     /* 273119 */     GIR_EraseRootFromParent_Done,
     /* 273120 */   // Label 5469: @273120
     /* 273120 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(273152), // Rule ID 1610 //
     /* 273125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273128 */     // MIs[0] Operand 1
     /* 273128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273141 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 273141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 273144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273150 */     GIR_RootConstrainSelectedInstOperands,
     /* 273151 */     // GIR_Coverage, 1610,
     /* 273151 */     GIR_EraseRootFromParent_Done,
     /* 273152 */   // Label 5470: @273152
     /* 273152 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(273184), // Rule ID 1611 //
     /* 273157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273160 */     // MIs[0] Operand 1
     /* 273160 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273173 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 273173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 273176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273182 */     GIR_RootConstrainSelectedInstOperands,
     /* 273183 */     // GIR_Coverage, 1611,
     /* 273183 */     GIR_EraseRootFromParent_Done,
     /* 273184 */   // Label 5471: @273184
     /* 273184 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(273216), // Rule ID 1612 //
     /* 273189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273192 */     // MIs[0] Operand 1
     /* 273192 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273205 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 273205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 273208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273214 */     GIR_RootConstrainSelectedInstOperands,
     /* 273215 */     // GIR_Coverage, 1612,
     /* 273215 */     GIR_EraseRootFromParent_Done,
     /* 273216 */   // Label 5472: @273216
     /* 273216 */   GIM_Reject,
     /* 273217 */ // Label 5461: @273217
     /* 273217 */ GIM_Reject,
     /* 273218 */ // Label 5453: @273218
     /* 273218 */ GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(274265),
     /* 273223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273226 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 273229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273233 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(273273), // Rule ID 754 //
     /* 273238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273241 */     // MIs[0] Operand 1
     /* 273241 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273264 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 273267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273271 */     GIR_RootConstrainSelectedInstOperands,
     /* 273272 */     // GIR_Coverage, 754,
     /* 273272 */     GIR_EraseRootFromParent_Done,
     /* 273273 */   // Label 5474: @273273
     /* 273273 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(273313), // Rule ID 761 //
     /* 273278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273281 */     // MIs[0] Operand 1
     /* 273281 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273290 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273296 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273304 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 273307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273311 */     GIR_RootConstrainSelectedInstOperands,
     /* 273312 */     // GIR_Coverage, 761,
     /* 273312 */     GIR_EraseRootFromParent_Done,
     /* 273313 */   // Label 5475: @273313
     /* 273313 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(273350), // Rule ID 5176 //
     /* 273318 */     // MIs[0] Operand 1
     /* 273318 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273327 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273333 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273341 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 273344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273348 */     GIR_RootConstrainSelectedInstOperands,
     /* 273349 */     // GIR_Coverage, 5176,
     /* 273349 */     GIR_EraseRootFromParent_Done,
     /* 273350 */   // Label 5476: @273350
     /* 273350 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(273387), // Rule ID 5183 //
     /* 273355 */     // MIs[0] Operand 1
     /* 273355 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273364 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273370 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273378 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 273381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273385 */     GIR_RootConstrainSelectedInstOperands,
     /* 273386 */     // GIR_Coverage, 5183,
     /* 273386 */     GIR_EraseRootFromParent_Done,
     /* 273387 */   // Label 5477: @273387
     /* 273387 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(273424), // Rule ID 5190 //
     /* 273392 */     // MIs[0] Operand 1
     /* 273392 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273401 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273407 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273415 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 273418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273422 */     GIR_RootConstrainSelectedInstOperands,
     /* 273423 */     // GIR_Coverage, 5190,
     /* 273423 */     GIR_EraseRootFromParent_Done,
     /* 273424 */   // Label 5478: @273424
     /* 273424 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(273461), // Rule ID 5197 //
     /* 273429 */     // MIs[0] Operand 1
     /* 273429 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273452 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 273455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273459 */     GIR_RootConstrainSelectedInstOperands,
     /* 273460 */     // GIR_Coverage, 5197,
     /* 273460 */     GIR_EraseRootFromParent_Done,
     /* 273461 */   // Label 5479: @273461
     /* 273461 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(273498), // Rule ID 5204 //
     /* 273466 */     // MIs[0] Operand 1
     /* 273466 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273489 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 273492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273496 */     GIR_RootConstrainSelectedInstOperands,
     /* 273497 */     // GIR_Coverage, 5204,
     /* 273497 */     GIR_EraseRootFromParent_Done,
     /* 273498 */   // Label 5480: @273498
     /* 273498 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(273538), // Rule ID 726 //
     /* 273503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273506 */     // MIs[0] Operand 1
     /* 273506 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273519 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273525 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273529 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 273532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273536 */     GIR_RootConstrainSelectedInstOperands,
     /* 273537 */     // GIR_Coverage, 726,
     /* 273537 */     GIR_EraseRootFromParent_Done,
     /* 273538 */   // Label 5481: @273538
     /* 273538 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(273578), // Rule ID 737 //
     /* 273543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273546 */     // MIs[0] Operand 1
     /* 273546 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273569 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 273572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273576 */     GIR_RootConstrainSelectedInstOperands,
     /* 273577 */     // GIR_Coverage, 737,
     /* 273577 */     GIR_EraseRootFromParent_Done,
     /* 273578 */   // Label 5482: @273578
     /* 273578 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(273618), // Rule ID 738 //
     /* 273583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273586 */     // MIs[0] Operand 1
     /* 273586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273605 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273609 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 273612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273616 */     GIR_RootConstrainSelectedInstOperands,
     /* 273617 */     // GIR_Coverage, 738,
     /* 273617 */     GIR_EraseRootFromParent_Done,
     /* 273618 */   // Label 5483: @273618
     /* 273618 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(273658), // Rule ID 747 //
     /* 273623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273626 */     // MIs[0] Operand 1
     /* 273626 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273639 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273645 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273649 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 273652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273656 */     GIR_RootConstrainSelectedInstOperands,
     /* 273657 */     // GIR_Coverage, 747,
     /* 273657 */     GIR_EraseRootFromParent_Done,
     /* 273658 */   // Label 5484: @273658
     /* 273658 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(273695), // Rule ID 5141 //
     /* 273663 */     // MIs[0] Operand 1
     /* 273663 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273676 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273682 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273686 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 273689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273693 */     GIR_RootConstrainSelectedInstOperands,
     /* 273694 */     // GIR_Coverage, 5141,
     /* 273694 */     GIR_EraseRootFromParent_Done,
     /* 273695 */   // Label 5485: @273695
     /* 273695 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273732), // Rule ID 5148 //
     /* 273700 */     // MIs[0] Operand 1
     /* 273700 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273723 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 273726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273730 */     GIR_RootConstrainSelectedInstOperands,
     /* 273731 */     // GIR_Coverage, 5148,
     /* 273731 */     GIR_EraseRootFromParent_Done,
     /* 273732 */   // Label 5486: @273732
     /* 273732 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273769), // Rule ID 5155 //
     /* 273737 */     // MIs[0] Operand 1
     /* 273737 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273750 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273756 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273760 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 273763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273767 */     GIR_RootConstrainSelectedInstOperands,
     /* 273768 */     // GIR_Coverage, 5155,
     /* 273768 */     GIR_EraseRootFromParent_Done,
     /* 273769 */   // Label 5487: @273769
     /* 273769 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273806), // Rule ID 5162 //
     /* 273774 */     // MIs[0] Operand 1
     /* 273774 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273793 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273797 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 273800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273804 */     GIR_RootConstrainSelectedInstOperands,
     /* 273805 */     // GIR_Coverage, 5162,
     /* 273805 */     GIR_EraseRootFromParent_Done,
     /* 273806 */   // Label 5488: @273806
     /* 273806 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273843), // Rule ID 5169 //
     /* 273811 */     // MIs[0] Operand 1
     /* 273811 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273824 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273830 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273834 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 273837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273841 */     GIR_RootConstrainSelectedInstOperands,
     /* 273842 */     // GIR_Coverage, 5169,
     /* 273842 */     GIR_EraseRootFromParent_Done,
     /* 273843 */   // Label 5489: @273843
     /* 273843 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273875), // Rule ID 1125 //
     /* 273848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273851 */     // MIs[0] Operand 1
     /* 273851 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273864 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 273867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273873 */     GIR_RootConstrainSelectedInstOperands,
     /* 273874 */     // GIR_Coverage, 1125,
     /* 273874 */     GIR_EraseRootFromParent_Done,
     /* 273875 */   // Label 5490: @273875
     /* 273875 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(273907), // Rule ID 1132 //
     /* 273880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273883 */     // MIs[0] Operand 1
     /* 273883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273896 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273905 */     GIR_RootConstrainSelectedInstOperands,
     /* 273906 */     // GIR_Coverage, 1132,
     /* 273906 */     GIR_EraseRootFromParent_Done,
     /* 273907 */   // Label 5491: @273907
     /* 273907 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(273939), // Rule ID 1139 //
     /* 273912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273915 */     // MIs[0] Operand 1
     /* 273915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273928 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273937 */     GIR_RootConstrainSelectedInstOperands,
     /* 273938 */     // GIR_Coverage, 1139,
     /* 273938 */     GIR_EraseRootFromParent_Done,
     /* 273939 */   // Label 5492: @273939
     /* 273939 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(273971), // Rule ID 1146 //
     /* 273944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273947 */     // MIs[0] Operand 1
     /* 273947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273960 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273969 */     GIR_RootConstrainSelectedInstOperands,
     /* 273970 */     // GIR_Coverage, 1146,
     /* 273970 */     GIR_EraseRootFromParent_Done,
     /* 273971 */   // Label 5493: @273971
     /* 273971 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(274003), // Rule ID 1153 //
     /* 273976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273979 */     // MIs[0] Operand 1
     /* 273979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273992 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274001 */     GIR_RootConstrainSelectedInstOperands,
     /* 274002 */     // GIR_Coverage, 1153,
     /* 274002 */     GIR_EraseRootFromParent_Done,
     /* 274003 */   // Label 5494: @274003
     /* 274003 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(274032), // Rule ID 5078 //
     /* 274008 */     // MIs[0] Operand 1
     /* 274008 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274021 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 274021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 274024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274030 */     GIR_RootConstrainSelectedInstOperands,
     /* 274031 */     // GIR_Coverage, 5078,
     /* 274031 */     GIR_EraseRootFromParent_Done,
     /* 274032 */   // Label 5495: @274032
     /* 274032 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(274061), // Rule ID 5085 //
     /* 274037 */     // MIs[0] Operand 1
     /* 274037 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274050 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 274050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 274053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274059 */     GIR_RootConstrainSelectedInstOperands,
     /* 274060 */     // GIR_Coverage, 5085,
     /* 274060 */     GIR_EraseRootFromParent_Done,
     /* 274061 */   // Label 5496: @274061
     /* 274061 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(274090), // Rule ID 5092 //
     /* 274066 */     // MIs[0] Operand 1
     /* 274066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274079 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 274079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 274082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274088 */     GIR_RootConstrainSelectedInstOperands,
     /* 274089 */     // GIR_Coverage, 5092,
     /* 274089 */     GIR_EraseRootFromParent_Done,
     /* 274090 */   // Label 5497: @274090
     /* 274090 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(274119), // Rule ID 5099 //
     /* 274095 */     // MIs[0] Operand 1
     /* 274095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274108 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 274108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 274111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274117 */     GIR_RootConstrainSelectedInstOperands,
     /* 274118 */     // GIR_Coverage, 5099,
     /* 274118 */     GIR_EraseRootFromParent_Done,
     /* 274119 */   // Label 5498: @274119
     /* 274119 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(274148), // Rule ID 5106 //
     /* 274124 */     // MIs[0] Operand 1
     /* 274124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274137 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 274137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 274140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274146 */     GIR_RootConstrainSelectedInstOperands,
     /* 274147 */     // GIR_Coverage, 5106,
     /* 274147 */     GIR_EraseRootFromParent_Done,
     /* 274148 */   // Label 5499: @274148
     /* 274148 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(274177), // Rule ID 5113 //
     /* 274153 */     // MIs[0] Operand 1
     /* 274153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274166 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 274166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 274169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274175 */     GIR_RootConstrainSelectedInstOperands,
     /* 274176 */     // GIR_Coverage, 5113,
     /* 274176 */     GIR_EraseRootFromParent_Done,
     /* 274177 */   // Label 5500: @274177
     /* 274177 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(274206), // Rule ID 5120 //
     /* 274182 */     // MIs[0] Operand 1
     /* 274182 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274195 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 274195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 274198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274204 */     GIR_RootConstrainSelectedInstOperands,
     /* 274205 */     // GIR_Coverage, 5120,
     /* 274205 */     GIR_EraseRootFromParent_Done,
     /* 274206 */   // Label 5501: @274206
     /* 274206 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(274235), // Rule ID 5127 //
     /* 274211 */     // MIs[0] Operand 1
     /* 274211 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274224 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 274224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 274227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274233 */     GIR_RootConstrainSelectedInstOperands,
     /* 274234 */     // GIR_Coverage, 5127,
     /* 274234 */     GIR_EraseRootFromParent_Done,
     /* 274235 */   // Label 5502: @274235
     /* 274235 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(274264), // Rule ID 5134 //
     /* 274240 */     // MIs[0] Operand 1
     /* 274240 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274253 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 274253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 274256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274262 */     GIR_RootConstrainSelectedInstOperands,
     /* 274263 */     // GIR_Coverage, 5134,
     /* 274263 */     GIR_EraseRootFromParent_Done,
     /* 274264 */   // Label 5503: @274264
     /* 274264 */   GIM_Reject,
     /* 274265 */ // Label 5473: @274265
     /* 274265 */ GIM_Reject,
     /* 274266 */ // Label 5454: @274266
     /* 274266 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(275313),
     /* 274271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274274 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 274277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274281 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(274321), // Rule ID 756 //
     /* 274286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274289 */     // MIs[0] Operand 1
     /* 274289 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274298 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274304 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274312 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 274315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274319 */     GIR_RootConstrainSelectedInstOperands,
     /* 274320 */     // GIR_Coverage, 756,
     /* 274320 */     GIR_EraseRootFromParent_Done,
     /* 274321 */   // Label 5505: @274321
     /* 274321 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(274361), // Rule ID 763 //
     /* 274326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274329 */     // MIs[0] Operand 1
     /* 274329 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274352 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 274355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274359 */     GIR_RootConstrainSelectedInstOperands,
     /* 274360 */     // GIR_Coverage, 763,
     /* 274360 */     GIR_EraseRootFromParent_Done,
     /* 274361 */   // Label 5506: @274361
     /* 274361 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(274398), // Rule ID 5178 //
     /* 274366 */     // MIs[0] Operand 1
     /* 274366 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274375 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274381 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274389 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 274392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274396 */     GIR_RootConstrainSelectedInstOperands,
     /* 274397 */     // GIR_Coverage, 5178,
     /* 274397 */     GIR_EraseRootFromParent_Done,
     /* 274398 */   // Label 5507: @274398
     /* 274398 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(274435), // Rule ID 5185 //
     /* 274403 */     // MIs[0] Operand 1
     /* 274403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274412 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274418 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274426 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 274429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274433 */     GIR_RootConstrainSelectedInstOperands,
     /* 274434 */     // GIR_Coverage, 5185,
     /* 274434 */     GIR_EraseRootFromParent_Done,
     /* 274435 */   // Label 5508: @274435
     /* 274435 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(274472), // Rule ID 5192 //
     /* 274440 */     // MIs[0] Operand 1
     /* 274440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274449 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274455 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274463 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 274466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274470 */     GIR_RootConstrainSelectedInstOperands,
     /* 274471 */     // GIR_Coverage, 5192,
     /* 274471 */     GIR_EraseRootFromParent_Done,
     /* 274472 */   // Label 5509: @274472
     /* 274472 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(274509), // Rule ID 5199 //
     /* 274477 */     // MIs[0] Operand 1
     /* 274477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274500 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 274503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274507 */     GIR_RootConstrainSelectedInstOperands,
     /* 274508 */     // GIR_Coverage, 5199,
     /* 274508 */     GIR_EraseRootFromParent_Done,
     /* 274509 */   // Label 5510: @274509
     /* 274509 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(274546), // Rule ID 5206 //
     /* 274514 */     // MIs[0] Operand 1
     /* 274514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274537 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 274540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274544 */     GIR_RootConstrainSelectedInstOperands,
     /* 274545 */     // GIR_Coverage, 5206,
     /* 274545 */     GIR_EraseRootFromParent_Done,
     /* 274546 */   // Label 5511: @274546
     /* 274546 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(274586), // Rule ID 728 //
     /* 274551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274554 */     // MIs[0] Operand 1
     /* 274554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274573 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274577 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 274580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274584 */     GIR_RootConstrainSelectedInstOperands,
     /* 274585 */     // GIR_Coverage, 728,
     /* 274585 */     GIR_EraseRootFromParent_Done,
     /* 274586 */   // Label 5512: @274586
     /* 274586 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(274626), // Rule ID 741 //
     /* 274591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274594 */     // MIs[0] Operand 1
     /* 274594 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274607 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274613 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274617 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 274620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274624 */     GIR_RootConstrainSelectedInstOperands,
     /* 274625 */     // GIR_Coverage, 741,
     /* 274625 */     GIR_EraseRootFromParent_Done,
     /* 274626 */   // Label 5513: @274626
     /* 274626 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(274666), // Rule ID 742 //
     /* 274631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274634 */     // MIs[0] Operand 1
     /* 274634 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274657 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 274660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274664 */     GIR_RootConstrainSelectedInstOperands,
     /* 274665 */     // GIR_Coverage, 742,
     /* 274665 */     GIR_EraseRootFromParent_Done,
     /* 274666 */   // Label 5514: @274666
     /* 274666 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274706), // Rule ID 749 //
     /* 274671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274674 */     // MIs[0] Operand 1
     /* 274674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274693 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274697 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 274700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274704 */     GIR_RootConstrainSelectedInstOperands,
     /* 274705 */     // GIR_Coverage, 749,
     /* 274705 */     GIR_EraseRootFromParent_Done,
     /* 274706 */   // Label 5515: @274706
     /* 274706 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274743), // Rule ID 5143 //
     /* 274711 */     // MIs[0] Operand 1
     /* 274711 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274724 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274730 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274734 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 274737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274741 */     GIR_RootConstrainSelectedInstOperands,
     /* 274742 */     // GIR_Coverage, 5143,
     /* 274742 */     GIR_EraseRootFromParent_Done,
     /* 274743 */   // Label 5516: @274743
     /* 274743 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274780), // Rule ID 5150 //
     /* 274748 */     // MIs[0] Operand 1
     /* 274748 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274761 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274767 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274771 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 274774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274778 */     GIR_RootConstrainSelectedInstOperands,
     /* 274779 */     // GIR_Coverage, 5150,
     /* 274779 */     GIR_EraseRootFromParent_Done,
     /* 274780 */   // Label 5517: @274780
     /* 274780 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274817), // Rule ID 5157 //
     /* 274785 */     // MIs[0] Operand 1
     /* 274785 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274798 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274804 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274808 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 274811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274815 */     GIR_RootConstrainSelectedInstOperands,
     /* 274816 */     // GIR_Coverage, 5157,
     /* 274816 */     GIR_EraseRootFromParent_Done,
     /* 274817 */   // Label 5518: @274817
     /* 274817 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(274854), // Rule ID 5164 //
     /* 274822 */     // MIs[0] Operand 1
     /* 274822 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274835 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274841 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274845 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 274848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274852 */     GIR_RootConstrainSelectedInstOperands,
     /* 274853 */     // GIR_Coverage, 5164,
     /* 274853 */     GIR_EraseRootFromParent_Done,
     /* 274854 */   // Label 5519: @274854
     /* 274854 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274891), // Rule ID 5171 //
     /* 274859 */     // MIs[0] Operand 1
     /* 274859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274882 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 274885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274889 */     GIR_RootConstrainSelectedInstOperands,
     /* 274890 */     // GIR_Coverage, 5171,
     /* 274890 */     GIR_EraseRootFromParent_Done,
     /* 274891 */   // Label 5520: @274891
     /* 274891 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274923), // Rule ID 1127 //
     /* 274896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274899 */     // MIs[0] Operand 1
     /* 274899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274912 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 274915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274921 */     GIR_RootConstrainSelectedInstOperands,
     /* 274922 */     // GIR_Coverage, 1127,
     /* 274922 */     GIR_EraseRootFromParent_Done,
     /* 274923 */   // Label 5521: @274923
     /* 274923 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274955), // Rule ID 1134 //
     /* 274928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274931 */     // MIs[0] Operand 1
     /* 274931 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274944 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274953 */     GIR_RootConstrainSelectedInstOperands,
     /* 274954 */     // GIR_Coverage, 1134,
     /* 274954 */     GIR_EraseRootFromParent_Done,
     /* 274955 */   // Label 5522: @274955
     /* 274955 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274987), // Rule ID 1141 //
     /* 274960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274963 */     // MIs[0] Operand 1
     /* 274963 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274976 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274985 */     GIR_RootConstrainSelectedInstOperands,
     /* 274986 */     // GIR_Coverage, 1141,
     /* 274986 */     GIR_EraseRootFromParent_Done,
     /* 274987 */   // Label 5523: @274987
     /* 274987 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(275019), // Rule ID 1148 //
     /* 274992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274995 */     // MIs[0] Operand 1
     /* 274995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275008 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 275011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275017 */     GIR_RootConstrainSelectedInstOperands,
     /* 275018 */     // GIR_Coverage, 1148,
     /* 275018 */     GIR_EraseRootFromParent_Done,
     /* 275019 */   // Label 5524: @275019
     /* 275019 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(275051), // Rule ID 1155 //
     /* 275024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275027 */     // MIs[0] Operand 1
     /* 275027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275040 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 275043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275049 */     GIR_RootConstrainSelectedInstOperands,
     /* 275050 */     // GIR_Coverage, 1155,
     /* 275050 */     GIR_EraseRootFromParent_Done,
     /* 275051 */   // Label 5525: @275051
     /* 275051 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(275080), // Rule ID 5080 //
     /* 275056 */     // MIs[0] Operand 1
     /* 275056 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275069 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 275072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275078 */     GIR_RootConstrainSelectedInstOperands,
     /* 275079 */     // GIR_Coverage, 5080,
     /* 275079 */     GIR_EraseRootFromParent_Done,
     /* 275080 */   // Label 5526: @275080
     /* 275080 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(275109), // Rule ID 5087 //
     /* 275085 */     // MIs[0] Operand 1
     /* 275085 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275098 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 275101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275107 */     GIR_RootConstrainSelectedInstOperands,
     /* 275108 */     // GIR_Coverage, 5087,
     /* 275108 */     GIR_EraseRootFromParent_Done,
     /* 275109 */   // Label 5527: @275109
     /* 275109 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(275138), // Rule ID 5094 //
     /* 275114 */     // MIs[0] Operand 1
     /* 275114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275127 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 275130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275136 */     GIR_RootConstrainSelectedInstOperands,
     /* 275137 */     // GIR_Coverage, 5094,
     /* 275137 */     GIR_EraseRootFromParent_Done,
     /* 275138 */   // Label 5528: @275138
     /* 275138 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(275167), // Rule ID 5101 //
     /* 275143 */     // MIs[0] Operand 1
     /* 275143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275156 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 275159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275165 */     GIR_RootConstrainSelectedInstOperands,
     /* 275166 */     // GIR_Coverage, 5101,
     /* 275166 */     GIR_EraseRootFromParent_Done,
     /* 275167 */   // Label 5529: @275167
     /* 275167 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(275196), // Rule ID 5108 //
     /* 275172 */     // MIs[0] Operand 1
     /* 275172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275185 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 275185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 275188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275194 */     GIR_RootConstrainSelectedInstOperands,
     /* 275195 */     // GIR_Coverage, 5108,
     /* 275195 */     GIR_EraseRootFromParent_Done,
     /* 275196 */   // Label 5530: @275196
     /* 275196 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(275225), // Rule ID 5115 //
     /* 275201 */     // MIs[0] Operand 1
     /* 275201 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275214 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 275214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 275217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275223 */     GIR_RootConstrainSelectedInstOperands,
     /* 275224 */     // GIR_Coverage, 5115,
     /* 275224 */     GIR_EraseRootFromParent_Done,
     /* 275225 */   // Label 5531: @275225
     /* 275225 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(275254), // Rule ID 5122 //
     /* 275230 */     // MIs[0] Operand 1
     /* 275230 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275243 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 275243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 275246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275252 */     GIR_RootConstrainSelectedInstOperands,
     /* 275253 */     // GIR_Coverage, 5122,
     /* 275253 */     GIR_EraseRootFromParent_Done,
     /* 275254 */   // Label 5532: @275254
     /* 275254 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(275283), // Rule ID 5129 //
     /* 275259 */     // MIs[0] Operand 1
     /* 275259 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275272 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 275272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 275275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275281 */     GIR_RootConstrainSelectedInstOperands,
     /* 275282 */     // GIR_Coverage, 5129,
     /* 275282 */     GIR_EraseRootFromParent_Done,
     /* 275283 */   // Label 5533: @275283
     /* 275283 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(275312), // Rule ID 5136 //
     /* 275288 */     // MIs[0] Operand 1
     /* 275288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275301 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 275301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 275304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275310 */     GIR_RootConstrainSelectedInstOperands,
     /* 275311 */     // GIR_Coverage, 5136,
     /* 275311 */     GIR_EraseRootFromParent_Done,
     /* 275312 */   // Label 5534: @275312
     /* 275312 */   GIM_Reject,
     /* 275313 */ // Label 5504: @275313
     /* 275313 */ GIM_Reject,
     /* 275314 */ // Label 5455: @275314
     /* 275314 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(276361),
     /* 275319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 275322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 275325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275329 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(275369), // Rule ID 752 //
     /* 275334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275337 */     // MIs[0] Operand 1
     /* 275337 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275360 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 275363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275367 */     GIR_RootConstrainSelectedInstOperands,
     /* 275368 */     // GIR_Coverage, 752,
     /* 275368 */     GIR_EraseRootFromParent_Done,
     /* 275369 */   // Label 5536: @275369
     /* 275369 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(275409), // Rule ID 759 //
     /* 275374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275377 */     // MIs[0] Operand 1
     /* 275377 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275400 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 275403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275407 */     GIR_RootConstrainSelectedInstOperands,
     /* 275408 */     // GIR_Coverage, 759,
     /* 275408 */     GIR_EraseRootFromParent_Done,
     /* 275409 */   // Label 5537: @275409
     /* 275409 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(275446), // Rule ID 5174 //
     /* 275414 */     // MIs[0] Operand 1
     /* 275414 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275437 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 275440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275444 */     GIR_RootConstrainSelectedInstOperands,
     /* 275445 */     // GIR_Coverage, 5174,
     /* 275445 */     GIR_EraseRootFromParent_Done,
     /* 275446 */   // Label 5538: @275446
     /* 275446 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(275483), // Rule ID 5181 //
     /* 275451 */     // MIs[0] Operand 1
     /* 275451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275460 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275466 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275474 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 275477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275481 */     GIR_RootConstrainSelectedInstOperands,
     /* 275482 */     // GIR_Coverage, 5181,
     /* 275482 */     GIR_EraseRootFromParent_Done,
     /* 275483 */   // Label 5539: @275483
     /* 275483 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(275520), // Rule ID 5188 //
     /* 275488 */     // MIs[0] Operand 1
     /* 275488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275511 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 275514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275518 */     GIR_RootConstrainSelectedInstOperands,
     /* 275519 */     // GIR_Coverage, 5188,
     /* 275519 */     GIR_EraseRootFromParent_Done,
     /* 275520 */   // Label 5540: @275520
     /* 275520 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(275557), // Rule ID 5195 //
     /* 275525 */     // MIs[0] Operand 1
     /* 275525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275548 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 275551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275555 */     GIR_RootConstrainSelectedInstOperands,
     /* 275556 */     // GIR_Coverage, 5195,
     /* 275556 */     GIR_EraseRootFromParent_Done,
     /* 275557 */   // Label 5541: @275557
     /* 275557 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(275594), // Rule ID 5202 //
     /* 275562 */     // MIs[0] Operand 1
     /* 275562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275585 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 275588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275592 */     GIR_RootConstrainSelectedInstOperands,
     /* 275593 */     // GIR_Coverage, 5202,
     /* 275593 */     GIR_EraseRootFromParent_Done,
     /* 275594 */   // Label 5542: @275594
     /* 275594 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(275634), // Rule ID 724 //
     /* 275599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275602 */     // MIs[0] Operand 1
     /* 275602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275625 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 275628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275632 */     GIR_RootConstrainSelectedInstOperands,
     /* 275633 */     // GIR_Coverage, 724,
     /* 275633 */     GIR_EraseRootFromParent_Done,
     /* 275634 */   // Label 5543: @275634
     /* 275634 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(275674), // Rule ID 733 //
     /* 275639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275642 */     // MIs[0] Operand 1
     /* 275642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275665 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 275668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275672 */     GIR_RootConstrainSelectedInstOperands,
     /* 275673 */     // GIR_Coverage, 733,
     /* 275673 */     GIR_EraseRootFromParent_Done,
     /* 275674 */   // Label 5544: @275674
     /* 275674 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275714), // Rule ID 734 //
     /* 275679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275682 */     // MIs[0] Operand 1
     /* 275682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275705 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 275708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275712 */     GIR_RootConstrainSelectedInstOperands,
     /* 275713 */     // GIR_Coverage, 734,
     /* 275713 */     GIR_EraseRootFromParent_Done,
     /* 275714 */   // Label 5545: @275714
     /* 275714 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275754), // Rule ID 745 //
     /* 275719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275722 */     // MIs[0] Operand 1
     /* 275722 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275735 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275741 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275745 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 275748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275752 */     GIR_RootConstrainSelectedInstOperands,
     /* 275753 */     // GIR_Coverage, 745,
     /* 275753 */     GIR_EraseRootFromParent_Done,
     /* 275754 */   // Label 5546: @275754
     /* 275754 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275791), // Rule ID 5139 //
     /* 275759 */     // MIs[0] Operand 1
     /* 275759 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275772 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275778 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275782 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 275785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275789 */     GIR_RootConstrainSelectedInstOperands,
     /* 275790 */     // GIR_Coverage, 5139,
     /* 275790 */     GIR_EraseRootFromParent_Done,
     /* 275791 */   // Label 5547: @275791
     /* 275791 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275828), // Rule ID 5146 //
     /* 275796 */     // MIs[0] Operand 1
     /* 275796 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275809 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275815 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275819 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 275822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275826 */     GIR_RootConstrainSelectedInstOperands,
     /* 275827 */     // GIR_Coverage, 5146,
     /* 275827 */     GIR_EraseRootFromParent_Done,
     /* 275828 */   // Label 5548: @275828
     /* 275828 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275865), // Rule ID 5153 //
     /* 275833 */     // MIs[0] Operand 1
     /* 275833 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275846 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275852 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275856 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 275859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275863 */     GIR_RootConstrainSelectedInstOperands,
     /* 275864 */     // GIR_Coverage, 5153,
     /* 275864 */     GIR_EraseRootFromParent_Done,
     /* 275865 */   // Label 5549: @275865
     /* 275865 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(275902), // Rule ID 5160 //
     /* 275870 */     // MIs[0] Operand 1
     /* 275870 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275889 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275893 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 275896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275900 */     GIR_RootConstrainSelectedInstOperands,
     /* 275901 */     // GIR_Coverage, 5160,
     /* 275901 */     GIR_EraseRootFromParent_Done,
     /* 275902 */   // Label 5550: @275902
     /* 275902 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275939), // Rule ID 5167 //
     /* 275907 */     // MIs[0] Operand 1
     /* 275907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275920 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275926 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275930 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 275933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275937 */     GIR_RootConstrainSelectedInstOperands,
     /* 275938 */     // GIR_Coverage, 5167,
     /* 275938 */     GIR_EraseRootFromParent_Done,
     /* 275939 */   // Label 5551: @275939
     /* 275939 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275971), // Rule ID 1123 //
     /* 275944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275947 */     // MIs[0] Operand 1
     /* 275947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275960 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 275963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275969 */     GIR_RootConstrainSelectedInstOperands,
     /* 275970 */     // GIR_Coverage, 1123,
     /* 275970 */     GIR_EraseRootFromParent_Done,
     /* 275971 */   // Label 5552: @275971
     /* 275971 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(276003), // Rule ID 1130 //
     /* 275976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275979 */     // MIs[0] Operand 1
     /* 275979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275992 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276001 */     GIR_RootConstrainSelectedInstOperands,
     /* 276002 */     // GIR_Coverage, 1130,
     /* 276002 */     GIR_EraseRootFromParent_Done,
     /* 276003 */   // Label 5553: @276003
     /* 276003 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(276035), // Rule ID 1137 //
     /* 276008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276011 */     // MIs[0] Operand 1
     /* 276011 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276024 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 276027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276033 */     GIR_RootConstrainSelectedInstOperands,
     /* 276034 */     // GIR_Coverage, 1137,
     /* 276034 */     GIR_EraseRootFromParent_Done,
     /* 276035 */   // Label 5554: @276035
     /* 276035 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(276067), // Rule ID 1144 //
     /* 276040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276043 */     // MIs[0] Operand 1
     /* 276043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276056 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 276059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276065 */     GIR_RootConstrainSelectedInstOperands,
     /* 276066 */     // GIR_Coverage, 1144,
     /* 276066 */     GIR_EraseRootFromParent_Done,
     /* 276067 */   // Label 5555: @276067
     /* 276067 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(276099), // Rule ID 1151 //
     /* 276072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276075 */     // MIs[0] Operand 1
     /* 276075 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276088 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 276091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276097 */     GIR_RootConstrainSelectedInstOperands,
     /* 276098 */     // GIR_Coverage, 1151,
     /* 276098 */     GIR_EraseRootFromParent_Done,
     /* 276099 */   // Label 5556: @276099
     /* 276099 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(276128), // Rule ID 5076 //
     /* 276104 */     // MIs[0] Operand 1
     /* 276104 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276117 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 276120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276126 */     GIR_RootConstrainSelectedInstOperands,
     /* 276127 */     // GIR_Coverage, 5076,
     /* 276127 */     GIR_EraseRootFromParent_Done,
     /* 276128 */   // Label 5557: @276128
     /* 276128 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(276157), // Rule ID 5083 //
     /* 276133 */     // MIs[0] Operand 1
     /* 276133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276146 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 276149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276155 */     GIR_RootConstrainSelectedInstOperands,
     /* 276156 */     // GIR_Coverage, 5083,
     /* 276156 */     GIR_EraseRootFromParent_Done,
     /* 276157 */   // Label 5558: @276157
     /* 276157 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(276186), // Rule ID 5090 //
     /* 276162 */     // MIs[0] Operand 1
     /* 276162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276175 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 276178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276184 */     GIR_RootConstrainSelectedInstOperands,
     /* 276185 */     // GIR_Coverage, 5090,
     /* 276185 */     GIR_EraseRootFromParent_Done,
     /* 276186 */   // Label 5559: @276186
     /* 276186 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(276215), // Rule ID 5097 //
     /* 276191 */     // MIs[0] Operand 1
     /* 276191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276204 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 276207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276213 */     GIR_RootConstrainSelectedInstOperands,
     /* 276214 */     // GIR_Coverage, 5097,
     /* 276214 */     GIR_EraseRootFromParent_Done,
     /* 276215 */   // Label 5560: @276215
     /* 276215 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(276244), // Rule ID 5104 //
     /* 276220 */     // MIs[0] Operand 1
     /* 276220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276233 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 276233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 276236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276242 */     GIR_RootConstrainSelectedInstOperands,
     /* 276243 */     // GIR_Coverage, 5104,
     /* 276243 */     GIR_EraseRootFromParent_Done,
     /* 276244 */   // Label 5561: @276244
     /* 276244 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(276273), // Rule ID 5111 //
     /* 276249 */     // MIs[0] Operand 1
     /* 276249 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276262 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 276262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 276265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276271 */     GIR_RootConstrainSelectedInstOperands,
     /* 276272 */     // GIR_Coverage, 5111,
     /* 276272 */     GIR_EraseRootFromParent_Done,
     /* 276273 */   // Label 5562: @276273
     /* 276273 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(276302), // Rule ID 5118 //
     /* 276278 */     // MIs[0] Operand 1
     /* 276278 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276291 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 276291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 276294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276300 */     GIR_RootConstrainSelectedInstOperands,
     /* 276301 */     // GIR_Coverage, 5118,
     /* 276301 */     GIR_EraseRootFromParent_Done,
     /* 276302 */   // Label 5563: @276302
     /* 276302 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(276331), // Rule ID 5125 //
     /* 276307 */     // MIs[0] Operand 1
     /* 276307 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276320 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 276320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 276323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276329 */     GIR_RootConstrainSelectedInstOperands,
     /* 276330 */     // GIR_Coverage, 5125,
     /* 276330 */     GIR_EraseRootFromParent_Done,
     /* 276331 */   // Label 5564: @276331
     /* 276331 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(276360), // Rule ID 5132 //
     /* 276336 */     // MIs[0] Operand 1
     /* 276336 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276349 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 276349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 276352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276358 */     GIR_RootConstrainSelectedInstOperands,
     /* 276359 */     // GIR_Coverage, 5132,
     /* 276359 */     GIR_EraseRootFromParent_Done,
     /* 276360 */   // Label 5565: @276360
     /* 276360 */   GIM_Reject,
     /* 276361 */ // Label 5535: @276361
     /* 276361 */ GIM_Reject,
     /* 276362 */ // Label 5456: @276362
     /* 276362 */ GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(277409),
     /* 276367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 276373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276377 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(276417), // Rule ID 755 //
     /* 276382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276385 */     // MIs[0] Operand 1
     /* 276385 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276408 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 276411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276415 */     GIR_RootConstrainSelectedInstOperands,
     /* 276416 */     // GIR_Coverage, 755,
     /* 276416 */     GIR_EraseRootFromParent_Done,
     /* 276417 */   // Label 5567: @276417
     /* 276417 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(276457), // Rule ID 762 //
     /* 276422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276425 */     // MIs[0] Operand 1
     /* 276425 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276434 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276440 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276448 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 276451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276455 */     GIR_RootConstrainSelectedInstOperands,
     /* 276456 */     // GIR_Coverage, 762,
     /* 276456 */     GIR_EraseRootFromParent_Done,
     /* 276457 */   // Label 5568: @276457
     /* 276457 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(276494), // Rule ID 5177 //
     /* 276462 */     // MIs[0] Operand 1
     /* 276462 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276471 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276477 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276485 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 276488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276492 */     GIR_RootConstrainSelectedInstOperands,
     /* 276493 */     // GIR_Coverage, 5177,
     /* 276493 */     GIR_EraseRootFromParent_Done,
     /* 276494 */   // Label 5569: @276494
     /* 276494 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(276531), // Rule ID 5184 //
     /* 276499 */     // MIs[0] Operand 1
     /* 276499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276508 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276522 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 276525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276529 */     GIR_RootConstrainSelectedInstOperands,
     /* 276530 */     // GIR_Coverage, 5184,
     /* 276530 */     GIR_EraseRootFromParent_Done,
     /* 276531 */   // Label 5570: @276531
     /* 276531 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(276568), // Rule ID 5191 //
     /* 276536 */     // MIs[0] Operand 1
     /* 276536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276545 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276551 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276559 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 276562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276566 */     GIR_RootConstrainSelectedInstOperands,
     /* 276567 */     // GIR_Coverage, 5191,
     /* 276567 */     GIR_EraseRootFromParent_Done,
     /* 276568 */   // Label 5571: @276568
     /* 276568 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(276605), // Rule ID 5198 //
     /* 276573 */     // MIs[0] Operand 1
     /* 276573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276582 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276588 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276596 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 276599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276603 */     GIR_RootConstrainSelectedInstOperands,
     /* 276604 */     // GIR_Coverage, 5198,
     /* 276604 */     GIR_EraseRootFromParent_Done,
     /* 276605 */   // Label 5572: @276605
     /* 276605 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(276642), // Rule ID 5205 //
     /* 276610 */     // MIs[0] Operand 1
     /* 276610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276633 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276640 */     GIR_RootConstrainSelectedInstOperands,
     /* 276641 */     // GIR_Coverage, 5205,
     /* 276641 */     GIR_EraseRootFromParent_Done,
     /* 276642 */   // Label 5573: @276642
     /* 276642 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(276682), // Rule ID 727 //
     /* 276647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276650 */     // MIs[0] Operand 1
     /* 276650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276673 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 276676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276680 */     GIR_RootConstrainSelectedInstOperands,
     /* 276681 */     // GIR_Coverage, 727,
     /* 276681 */     GIR_EraseRootFromParent_Done,
     /* 276682 */   // Label 5574: @276682
     /* 276682 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276722), // Rule ID 739 //
     /* 276687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276690 */     // MIs[0] Operand 1
     /* 276690 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276713 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276720 */     GIR_RootConstrainSelectedInstOperands,
     /* 276721 */     // GIR_Coverage, 739,
     /* 276721 */     GIR_EraseRootFromParent_Done,
     /* 276722 */   // Label 5575: @276722
     /* 276722 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276762), // Rule ID 740 //
     /* 276727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276730 */     // MIs[0] Operand 1
     /* 276730 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276753 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276760 */     GIR_RootConstrainSelectedInstOperands,
     /* 276761 */     // GIR_Coverage, 740,
     /* 276761 */     GIR_EraseRootFromParent_Done,
     /* 276762 */   // Label 5576: @276762
     /* 276762 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276802), // Rule ID 748 //
     /* 276767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276770 */     // MIs[0] Operand 1
     /* 276770 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276793 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 276796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276800 */     GIR_RootConstrainSelectedInstOperands,
     /* 276801 */     // GIR_Coverage, 748,
     /* 276801 */     GIR_EraseRootFromParent_Done,
     /* 276802 */   // Label 5577: @276802
     /* 276802 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276839), // Rule ID 5142 //
     /* 276807 */     // MIs[0] Operand 1
     /* 276807 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276820 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276826 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276830 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 276833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276837 */     GIR_RootConstrainSelectedInstOperands,
     /* 276838 */     // GIR_Coverage, 5142,
     /* 276838 */     GIR_EraseRootFromParent_Done,
     /* 276839 */   // Label 5578: @276839
     /* 276839 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276876), // Rule ID 5149 //
     /* 276844 */     // MIs[0] Operand 1
     /* 276844 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276867 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 276870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276874 */     GIR_RootConstrainSelectedInstOperands,
     /* 276875 */     // GIR_Coverage, 5149,
     /* 276875 */     GIR_EraseRootFromParent_Done,
     /* 276876 */   // Label 5579: @276876
     /* 276876 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276913), // Rule ID 5156 //
     /* 276881 */     // MIs[0] Operand 1
     /* 276881 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276894 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276900 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276904 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276911 */     GIR_RootConstrainSelectedInstOperands,
     /* 276912 */     // GIR_Coverage, 5156,
     /* 276912 */     GIR_EraseRootFromParent_Done,
     /* 276913 */   // Label 5580: @276913
     /* 276913 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(276950), // Rule ID 5163 //
     /* 276918 */     // MIs[0] Operand 1
     /* 276918 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276931 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276937 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276941 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 276944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276948 */     GIR_RootConstrainSelectedInstOperands,
     /* 276949 */     // GIR_Coverage, 5163,
     /* 276949 */     GIR_EraseRootFromParent_Done,
     /* 276950 */   // Label 5581: @276950
     /* 276950 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276987), // Rule ID 5170 //
     /* 276955 */     // MIs[0] Operand 1
     /* 276955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276978 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 276981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276985 */     GIR_RootConstrainSelectedInstOperands,
     /* 276986 */     // GIR_Coverage, 5170,
     /* 276986 */     GIR_EraseRootFromParent_Done,
     /* 276987 */   // Label 5582: @276987
     /* 276987 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(277019), // Rule ID 1126 //
     /* 276992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276995 */     // MIs[0] Operand 1
     /* 276995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277008 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 277011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277017 */     GIR_RootConstrainSelectedInstOperands,
     /* 277018 */     // GIR_Coverage, 1126,
     /* 277018 */     GIR_EraseRootFromParent_Done,
     /* 277019 */   // Label 5583: @277019
     /* 277019 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(277051), // Rule ID 1133 //
     /* 277024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277027 */     // MIs[0] Operand 1
     /* 277027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277040 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 277043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277049 */     GIR_RootConstrainSelectedInstOperands,
     /* 277050 */     // GIR_Coverage, 1133,
     /* 277050 */     GIR_EraseRootFromParent_Done,
     /* 277051 */   // Label 5584: @277051
     /* 277051 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(277083), // Rule ID 1140 //
     /* 277056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277059 */     // MIs[0] Operand 1
     /* 277059 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277072 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 277075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277081 */     GIR_RootConstrainSelectedInstOperands,
     /* 277082 */     // GIR_Coverage, 1140,
     /* 277082 */     GIR_EraseRootFromParent_Done,
     /* 277083 */   // Label 5585: @277083
     /* 277083 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(277115), // Rule ID 1147 //
     /* 277088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277091 */     // MIs[0] Operand 1
     /* 277091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277104 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 277107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277113 */     GIR_RootConstrainSelectedInstOperands,
     /* 277114 */     // GIR_Coverage, 1147,
     /* 277114 */     GIR_EraseRootFromParent_Done,
     /* 277115 */   // Label 5586: @277115
     /* 277115 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(277147), // Rule ID 1154 //
     /* 277120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277123 */     // MIs[0] Operand 1
     /* 277123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277136 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 277139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277145 */     GIR_RootConstrainSelectedInstOperands,
     /* 277146 */     // GIR_Coverage, 1154,
     /* 277146 */     GIR_EraseRootFromParent_Done,
     /* 277147 */   // Label 5587: @277147
     /* 277147 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(277176), // Rule ID 5079 //
     /* 277152 */     // MIs[0] Operand 1
     /* 277152 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277165 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 277168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277174 */     GIR_RootConstrainSelectedInstOperands,
     /* 277175 */     // GIR_Coverage, 5079,
     /* 277175 */     GIR_EraseRootFromParent_Done,
     /* 277176 */   // Label 5588: @277176
     /* 277176 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(277205), // Rule ID 5086 //
     /* 277181 */     // MIs[0] Operand 1
     /* 277181 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277194 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 277197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277203 */     GIR_RootConstrainSelectedInstOperands,
     /* 277204 */     // GIR_Coverage, 5086,
     /* 277204 */     GIR_EraseRootFromParent_Done,
     /* 277205 */   // Label 5589: @277205
     /* 277205 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(277234), // Rule ID 5093 //
     /* 277210 */     // MIs[0] Operand 1
     /* 277210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277223 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 277226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277232 */     GIR_RootConstrainSelectedInstOperands,
     /* 277233 */     // GIR_Coverage, 5093,
     /* 277233 */     GIR_EraseRootFromParent_Done,
     /* 277234 */   // Label 5590: @277234
     /* 277234 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(277263), // Rule ID 5100 //
     /* 277239 */     // MIs[0] Operand 1
     /* 277239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277252 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 277255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277261 */     GIR_RootConstrainSelectedInstOperands,
     /* 277262 */     // GIR_Coverage, 5100,
     /* 277262 */     GIR_EraseRootFromParent_Done,
     /* 277263 */   // Label 5591: @277263
     /* 277263 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(277292), // Rule ID 5107 //
     /* 277268 */     // MIs[0] Operand 1
     /* 277268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277281 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 277281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 277284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277290 */     GIR_RootConstrainSelectedInstOperands,
     /* 277291 */     // GIR_Coverage, 5107,
     /* 277291 */     GIR_EraseRootFromParent_Done,
     /* 277292 */   // Label 5592: @277292
     /* 277292 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(277321), // Rule ID 5114 //
     /* 277297 */     // MIs[0] Operand 1
     /* 277297 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277310 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 277310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 277313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277319 */     GIR_RootConstrainSelectedInstOperands,
     /* 277320 */     // GIR_Coverage, 5114,
     /* 277320 */     GIR_EraseRootFromParent_Done,
     /* 277321 */   // Label 5593: @277321
     /* 277321 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(277350), // Rule ID 5121 //
     /* 277326 */     // MIs[0] Operand 1
     /* 277326 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277339 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 277339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 277342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277348 */     GIR_RootConstrainSelectedInstOperands,
     /* 277349 */     // GIR_Coverage, 5121,
     /* 277349 */     GIR_EraseRootFromParent_Done,
     /* 277350 */   // Label 5594: @277350
     /* 277350 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(277379), // Rule ID 5128 //
     /* 277355 */     // MIs[0] Operand 1
     /* 277355 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277368 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 277368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 277371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277377 */     GIR_RootConstrainSelectedInstOperands,
     /* 277378 */     // GIR_Coverage, 5128,
     /* 277378 */     GIR_EraseRootFromParent_Done,
     /* 277379 */   // Label 5595: @277379
     /* 277379 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(277408), // Rule ID 5135 //
     /* 277384 */     // MIs[0] Operand 1
     /* 277384 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277397 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 277397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 277400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277406 */     GIR_RootConstrainSelectedInstOperands,
     /* 277407 */     // GIR_Coverage, 5135,
     /* 277407 */     GIR_EraseRootFromParent_Done,
     /* 277408 */   // Label 5596: @277408
     /* 277408 */   GIM_Reject,
     /* 277409 */ // Label 5566: @277409
     /* 277409 */ GIM_Reject,
     /* 277410 */ // Label 5457: @277410
     /* 277410 */ GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(278457),
     /* 277415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 277418 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 277421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277425 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(277465), // Rule ID 750 //
     /* 277430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277433 */     // MIs[0] Operand 1
     /* 277433 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277442 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277448 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277456 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 277459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277463 */     GIR_RootConstrainSelectedInstOperands,
     /* 277464 */     // GIR_Coverage, 750,
     /* 277464 */     GIR_EraseRootFromParent_Done,
     /* 277465 */   // Label 5598: @277465
     /* 277465 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(277505), // Rule ID 757 //
     /* 277470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277473 */     // MIs[0] Operand 1
     /* 277473 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277482 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277488 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277496 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 277499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277503 */     GIR_RootConstrainSelectedInstOperands,
     /* 277504 */     // GIR_Coverage, 757,
     /* 277504 */     GIR_EraseRootFromParent_Done,
     /* 277505 */   // Label 5599: @277505
     /* 277505 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(277542), // Rule ID 5172 //
     /* 277510 */     // MIs[0] Operand 1
     /* 277510 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277519 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277525 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277533 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 277536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277540 */     GIR_RootConstrainSelectedInstOperands,
     /* 277541 */     // GIR_Coverage, 5172,
     /* 277541 */     GIR_EraseRootFromParent_Done,
     /* 277542 */   // Label 5600: @277542
     /* 277542 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(277579), // Rule ID 5179 //
     /* 277547 */     // MIs[0] Operand 1
     /* 277547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277556 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277562 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277570 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 277573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277577 */     GIR_RootConstrainSelectedInstOperands,
     /* 277578 */     // GIR_Coverage, 5179,
     /* 277578 */     GIR_EraseRootFromParent_Done,
     /* 277579 */   // Label 5601: @277579
     /* 277579 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(277616), // Rule ID 5186 //
     /* 277584 */     // MIs[0] Operand 1
     /* 277584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277593 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277599 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277607 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 277610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277614 */     GIR_RootConstrainSelectedInstOperands,
     /* 277615 */     // GIR_Coverage, 5186,
     /* 277615 */     GIR_EraseRootFromParent_Done,
     /* 277616 */   // Label 5602: @277616
     /* 277616 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(277653), // Rule ID 5193 //
     /* 277621 */     // MIs[0] Operand 1
     /* 277621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277644 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 277647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277651 */     GIR_RootConstrainSelectedInstOperands,
     /* 277652 */     // GIR_Coverage, 5193,
     /* 277652 */     GIR_EraseRootFromParent_Done,
     /* 277653 */   // Label 5603: @277653
     /* 277653 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(277690), // Rule ID 5200 //
     /* 277658 */     // MIs[0] Operand 1
     /* 277658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277681 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277688 */     GIR_RootConstrainSelectedInstOperands,
     /* 277689 */     // GIR_Coverage, 5200,
     /* 277689 */     GIR_EraseRootFromParent_Done,
     /* 277690 */   // Label 5604: @277690
     /* 277690 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277730), // Rule ID 722 //
     /* 277695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277698 */     // MIs[0] Operand 1
     /* 277698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277721 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 277724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277728 */     GIR_RootConstrainSelectedInstOperands,
     /* 277729 */     // GIR_Coverage, 722,
     /* 277729 */     GIR_EraseRootFromParent_Done,
     /* 277730 */   // Label 5605: @277730
     /* 277730 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277770), // Rule ID 729 //
     /* 277735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277738 */     // MIs[0] Operand 1
     /* 277738 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277751 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277757 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277761 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277768 */     GIR_RootConstrainSelectedInstOperands,
     /* 277769 */     // GIR_Coverage, 729,
     /* 277769 */     GIR_EraseRootFromParent_Done,
     /* 277770 */   // Label 5606: @277770
     /* 277770 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277810), // Rule ID 730 //
     /* 277775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277778 */     // MIs[0] Operand 1
     /* 277778 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277801 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277808 */     GIR_RootConstrainSelectedInstOperands,
     /* 277809 */     // GIR_Coverage, 730,
     /* 277809 */     GIR_EraseRootFromParent_Done,
     /* 277810 */   // Label 5607: @277810
     /* 277810 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277850), // Rule ID 743 //
     /* 277815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277818 */     // MIs[0] Operand 1
     /* 277818 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277831 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277837 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277841 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 277844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277848 */     GIR_RootConstrainSelectedInstOperands,
     /* 277849 */     // GIR_Coverage, 743,
     /* 277849 */     GIR_EraseRootFromParent_Done,
     /* 277850 */   // Label 5608: @277850
     /* 277850 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277887), // Rule ID 5137 //
     /* 277855 */     // MIs[0] Operand 1
     /* 277855 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277868 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277874 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277878 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 277881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277885 */     GIR_RootConstrainSelectedInstOperands,
     /* 277886 */     // GIR_Coverage, 5137,
     /* 277886 */     GIR_EraseRootFromParent_Done,
     /* 277887 */   // Label 5609: @277887
     /* 277887 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277924), // Rule ID 5144 //
     /* 277892 */     // MIs[0] Operand 1
     /* 277892 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277911 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277915 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 277918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277922 */     GIR_RootConstrainSelectedInstOperands,
     /* 277923 */     // GIR_Coverage, 5144,
     /* 277923 */     GIR_EraseRootFromParent_Done,
     /* 277924 */   // Label 5610: @277924
     /* 277924 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277961), // Rule ID 5151 //
     /* 277929 */     // MIs[0] Operand 1
     /* 277929 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277952 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277959 */     GIR_RootConstrainSelectedInstOperands,
     /* 277960 */     // GIR_Coverage, 5151,
     /* 277960 */     GIR_EraseRootFromParent_Done,
     /* 277961 */   // Label 5611: @277961
     /* 277961 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(277998), // Rule ID 5158 //
     /* 277966 */     // MIs[0] Operand 1
     /* 277966 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277985 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277989 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 277992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277996 */     GIR_RootConstrainSelectedInstOperands,
     /* 277997 */     // GIR_Coverage, 5158,
     /* 277997 */     GIR_EraseRootFromParent_Done,
     /* 277998 */   // Label 5612: @277998
     /* 277998 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(278035), // Rule ID 5165 //
     /* 278003 */     // MIs[0] Operand 1
     /* 278003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278016 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278022 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278026 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 278026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 278029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278033 */     GIR_RootConstrainSelectedInstOperands,
     /* 278034 */     // GIR_Coverage, 5165,
     /* 278034 */     GIR_EraseRootFromParent_Done,
     /* 278035 */   // Label 5613: @278035
     /* 278035 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(278067), // Rule ID 1121 //
     /* 278040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278043 */     // MIs[0] Operand 1
     /* 278043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278056 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 278059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278065 */     GIR_RootConstrainSelectedInstOperands,
     /* 278066 */     // GIR_Coverage, 1121,
     /* 278066 */     GIR_EraseRootFromParent_Done,
     /* 278067 */   // Label 5614: @278067
     /* 278067 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(278099), // Rule ID 1128 //
     /* 278072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278075 */     // MIs[0] Operand 1
     /* 278075 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278088 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 278091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278097 */     GIR_RootConstrainSelectedInstOperands,
     /* 278098 */     // GIR_Coverage, 1128,
     /* 278098 */     GIR_EraseRootFromParent_Done,
     /* 278099 */   // Label 5615: @278099
     /* 278099 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(278131), // Rule ID 1135 //
     /* 278104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278107 */     // MIs[0] Operand 1
     /* 278107 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278120 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 278123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278129 */     GIR_RootConstrainSelectedInstOperands,
     /* 278130 */     // GIR_Coverage, 1135,
     /* 278130 */     GIR_EraseRootFromParent_Done,
     /* 278131 */   // Label 5616: @278131
     /* 278131 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(278163), // Rule ID 1142 //
     /* 278136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278139 */     // MIs[0] Operand 1
     /* 278139 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278152 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 278155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278161 */     GIR_RootConstrainSelectedInstOperands,
     /* 278162 */     // GIR_Coverage, 1142,
     /* 278162 */     GIR_EraseRootFromParent_Done,
     /* 278163 */   // Label 5617: @278163
     /* 278163 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(278195), // Rule ID 1149 //
     /* 278168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278171 */     // MIs[0] Operand 1
     /* 278171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278184 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 278187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278193 */     GIR_RootConstrainSelectedInstOperands,
     /* 278194 */     // GIR_Coverage, 1149,
     /* 278194 */     GIR_EraseRootFromParent_Done,
     /* 278195 */   // Label 5618: @278195
     /* 278195 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(278224), // Rule ID 5074 //
     /* 278200 */     // MIs[0] Operand 1
     /* 278200 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278213 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 278216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278222 */     GIR_RootConstrainSelectedInstOperands,
     /* 278223 */     // GIR_Coverage, 5074,
     /* 278223 */     GIR_EraseRootFromParent_Done,
     /* 278224 */   // Label 5619: @278224
     /* 278224 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(278253), // Rule ID 5081 //
     /* 278229 */     // MIs[0] Operand 1
     /* 278229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278242 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 278245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278251 */     GIR_RootConstrainSelectedInstOperands,
     /* 278252 */     // GIR_Coverage, 5081,
     /* 278252 */     GIR_EraseRootFromParent_Done,
     /* 278253 */   // Label 5620: @278253
     /* 278253 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(278282), // Rule ID 5088 //
     /* 278258 */     // MIs[0] Operand 1
     /* 278258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278271 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 278274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278280 */     GIR_RootConstrainSelectedInstOperands,
     /* 278281 */     // GIR_Coverage, 5088,
     /* 278281 */     GIR_EraseRootFromParent_Done,
     /* 278282 */   // Label 5621: @278282
     /* 278282 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(278311), // Rule ID 5095 //
     /* 278287 */     // MIs[0] Operand 1
     /* 278287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278300 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 278303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278309 */     GIR_RootConstrainSelectedInstOperands,
     /* 278310 */     // GIR_Coverage, 5095,
     /* 278310 */     GIR_EraseRootFromParent_Done,
     /* 278311 */   // Label 5622: @278311
     /* 278311 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(278340), // Rule ID 5102 //
     /* 278316 */     // MIs[0] Operand 1
     /* 278316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278329 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 278329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 278332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278338 */     GIR_RootConstrainSelectedInstOperands,
     /* 278339 */     // GIR_Coverage, 5102,
     /* 278339 */     GIR_EraseRootFromParent_Done,
     /* 278340 */   // Label 5623: @278340
     /* 278340 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(278369), // Rule ID 5109 //
     /* 278345 */     // MIs[0] Operand 1
     /* 278345 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278358 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 278358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 278361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278367 */     GIR_RootConstrainSelectedInstOperands,
     /* 278368 */     // GIR_Coverage, 5109,
     /* 278368 */     GIR_EraseRootFromParent_Done,
     /* 278369 */   // Label 5624: @278369
     /* 278369 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(278398), // Rule ID 5116 //
     /* 278374 */     // MIs[0] Operand 1
     /* 278374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278387 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 278387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 278390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278396 */     GIR_RootConstrainSelectedInstOperands,
     /* 278397 */     // GIR_Coverage, 5116,
     /* 278397 */     GIR_EraseRootFromParent_Done,
     /* 278398 */   // Label 5625: @278398
     /* 278398 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(278427), // Rule ID 5123 //
     /* 278403 */     // MIs[0] Operand 1
     /* 278403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278416 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 278416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 278419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278425 */     GIR_RootConstrainSelectedInstOperands,
     /* 278426 */     // GIR_Coverage, 5123,
     /* 278426 */     GIR_EraseRootFromParent_Done,
     /* 278427 */   // Label 5626: @278427
     /* 278427 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(278456), // Rule ID 5130 //
     /* 278432 */     // MIs[0] Operand 1
     /* 278432 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278445 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 278445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 278448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278454 */     GIR_RootConstrainSelectedInstOperands,
     /* 278455 */     // GIR_Coverage, 5130,
     /* 278455 */     GIR_EraseRootFromParent_Done,
     /* 278456 */   // Label 5627: @278456
     /* 278456 */   GIM_Reject,
     /* 278457 */ // Label 5597: @278457
     /* 278457 */ GIM_Reject,
     /* 278458 */ // Label 5458: @278458
     /* 278458 */ GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(279505),
     /* 278463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 278469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278473 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(278513), // Rule ID 753 //
     /* 278478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278481 */     // MIs[0] Operand 1
     /* 278481 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278504 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 278507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278511 */     GIR_RootConstrainSelectedInstOperands,
     /* 278512 */     // GIR_Coverage, 753,
     /* 278512 */     GIR_EraseRootFromParent_Done,
     /* 278513 */   // Label 5629: @278513
     /* 278513 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(278553), // Rule ID 760 //
     /* 278518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278521 */     // MIs[0] Operand 1
     /* 278521 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278544 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 278547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278551 */     GIR_RootConstrainSelectedInstOperands,
     /* 278552 */     // GIR_Coverage, 760,
     /* 278552 */     GIR_EraseRootFromParent_Done,
     /* 278553 */   // Label 5630: @278553
     /* 278553 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(278590), // Rule ID 5175 //
     /* 278558 */     // MIs[0] Operand 1
     /* 278558 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278573 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278581 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 278584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278588 */     GIR_RootConstrainSelectedInstOperands,
     /* 278589 */     // GIR_Coverage, 5175,
     /* 278589 */     GIR_EraseRootFromParent_Done,
     /* 278590 */   // Label 5631: @278590
     /* 278590 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(278627), // Rule ID 5182 //
     /* 278595 */     // MIs[0] Operand 1
     /* 278595 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278604 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278610 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278618 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 278621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278625 */     GIR_RootConstrainSelectedInstOperands,
     /* 278626 */     // GIR_Coverage, 5182,
     /* 278626 */     GIR_EraseRootFromParent_Done,
     /* 278627 */   // Label 5632: @278627
     /* 278627 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(278664), // Rule ID 5189 //
     /* 278632 */     // MIs[0] Operand 1
     /* 278632 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278641 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278647 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278655 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 278658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278662 */     GIR_RootConstrainSelectedInstOperands,
     /* 278663 */     // GIR_Coverage, 5189,
     /* 278663 */     GIR_EraseRootFromParent_Done,
     /* 278664 */   // Label 5633: @278664
     /* 278664 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(278701), // Rule ID 5196 //
     /* 278669 */     // MIs[0] Operand 1
     /* 278669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278692 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 278695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278699 */     GIR_RootConstrainSelectedInstOperands,
     /* 278700 */     // GIR_Coverage, 5196,
     /* 278700 */     GIR_EraseRootFromParent_Done,
     /* 278701 */   // Label 5634: @278701
     /* 278701 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(278738), // Rule ID 5203 //
     /* 278706 */     // MIs[0] Operand 1
     /* 278706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278729 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278736 */     GIR_RootConstrainSelectedInstOperands,
     /* 278737 */     // GIR_Coverage, 5203,
     /* 278737 */     GIR_EraseRootFromParent_Done,
     /* 278738 */   // Label 5635: @278738
     /* 278738 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(278778), // Rule ID 725 //
     /* 278743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278746 */     // MIs[0] Operand 1
     /* 278746 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278769 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 278772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278776 */     GIR_RootConstrainSelectedInstOperands,
     /* 278777 */     // GIR_Coverage, 725,
     /* 278777 */     GIR_EraseRootFromParent_Done,
     /* 278778 */   // Label 5636: @278778
     /* 278778 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(278818), // Rule ID 735 //
     /* 278783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278786 */     // MIs[0] Operand 1
     /* 278786 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278809 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278816 */     GIR_RootConstrainSelectedInstOperands,
     /* 278817 */     // GIR_Coverage, 735,
     /* 278817 */     GIR_EraseRootFromParent_Done,
     /* 278818 */   // Label 5637: @278818
     /* 278818 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(278858), // Rule ID 736 //
     /* 278823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278826 */     // MIs[0] Operand 1
     /* 278826 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278839 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278849 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278856 */     GIR_RootConstrainSelectedInstOperands,
     /* 278857 */     // GIR_Coverage, 736,
     /* 278857 */     GIR_EraseRootFromParent_Done,
     /* 278858 */   // Label 5638: @278858
     /* 278858 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(278898), // Rule ID 746 //
     /* 278863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278866 */     // MIs[0] Operand 1
     /* 278866 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278879 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278885 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278889 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 278892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278896 */     GIR_RootConstrainSelectedInstOperands,
     /* 278897 */     // GIR_Coverage, 746,
     /* 278897 */     GIR_EraseRootFromParent_Done,
     /* 278898 */   // Label 5639: @278898
     /* 278898 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278935), // Rule ID 5140 //
     /* 278903 */     // MIs[0] Operand 1
     /* 278903 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278922 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278926 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 278929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278933 */     GIR_RootConstrainSelectedInstOperands,
     /* 278934 */     // GIR_Coverage, 5140,
     /* 278934 */     GIR_EraseRootFromParent_Done,
     /* 278935 */   // Label 5640: @278935
     /* 278935 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278972), // Rule ID 5147 //
     /* 278940 */     // MIs[0] Operand 1
     /* 278940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278953 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278959 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278963 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 278966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278970 */     GIR_RootConstrainSelectedInstOperands,
     /* 278971 */     // GIR_Coverage, 5147,
     /* 278971 */     GIR_EraseRootFromParent_Done,
     /* 278972 */   // Label 5641: @278972
     /* 278972 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(279009), // Rule ID 5154 //
     /* 278977 */     // MIs[0] Operand 1
     /* 278977 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278990 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278996 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279000 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 279000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 279003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279007 */     GIR_RootConstrainSelectedInstOperands,
     /* 279008 */     // GIR_Coverage, 5154,
     /* 279008 */     GIR_EraseRootFromParent_Done,
     /* 279009 */   // Label 5642: @279009
     /* 279009 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(279046), // Rule ID 5161 //
     /* 279014 */     // MIs[0] Operand 1
     /* 279014 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279037 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 279037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 279040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279044 */     GIR_RootConstrainSelectedInstOperands,
     /* 279045 */     // GIR_Coverage, 5161,
     /* 279045 */     GIR_EraseRootFromParent_Done,
     /* 279046 */   // Label 5643: @279046
     /* 279046 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(279083), // Rule ID 5168 //
     /* 279051 */     // MIs[0] Operand 1
     /* 279051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279074 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 279074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 279077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279081 */     GIR_RootConstrainSelectedInstOperands,
     /* 279082 */     // GIR_Coverage, 5168,
     /* 279082 */     GIR_EraseRootFromParent_Done,
     /* 279083 */   // Label 5644: @279083
     /* 279083 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(279115), // Rule ID 1124 //
     /* 279088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279091 */     // MIs[0] Operand 1
     /* 279091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279104 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 279107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279113 */     GIR_RootConstrainSelectedInstOperands,
     /* 279114 */     // GIR_Coverage, 1124,
     /* 279114 */     GIR_EraseRootFromParent_Done,
     /* 279115 */   // Label 5645: @279115
     /* 279115 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(279147), // Rule ID 1131 //
     /* 279120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279123 */     // MIs[0] Operand 1
     /* 279123 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279136 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 279139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279145 */     GIR_RootConstrainSelectedInstOperands,
     /* 279146 */     // GIR_Coverage, 1131,
     /* 279146 */     GIR_EraseRootFromParent_Done,
     /* 279147 */   // Label 5646: @279147
     /* 279147 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(279179), // Rule ID 1138 //
     /* 279152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279155 */     // MIs[0] Operand 1
     /* 279155 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279168 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 279171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279177 */     GIR_RootConstrainSelectedInstOperands,
     /* 279178 */     // GIR_Coverage, 1138,
     /* 279178 */     GIR_EraseRootFromParent_Done,
     /* 279179 */   // Label 5647: @279179
     /* 279179 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(279211), // Rule ID 1145 //
     /* 279184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279187 */     // MIs[0] Operand 1
     /* 279187 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279200 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 279203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279209 */     GIR_RootConstrainSelectedInstOperands,
     /* 279210 */     // GIR_Coverage, 1145,
     /* 279210 */     GIR_EraseRootFromParent_Done,
     /* 279211 */   // Label 5648: @279211
     /* 279211 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(279243), // Rule ID 1152 //
     /* 279216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279219 */     // MIs[0] Operand 1
     /* 279219 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279232 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 279235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279241 */     GIR_RootConstrainSelectedInstOperands,
     /* 279242 */     // GIR_Coverage, 1152,
     /* 279242 */     GIR_EraseRootFromParent_Done,
     /* 279243 */   // Label 5649: @279243
     /* 279243 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(279272), // Rule ID 5077 //
     /* 279248 */     // MIs[0] Operand 1
     /* 279248 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279261 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 279264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279270 */     GIR_RootConstrainSelectedInstOperands,
     /* 279271 */     // GIR_Coverage, 5077,
     /* 279271 */     GIR_EraseRootFromParent_Done,
     /* 279272 */   // Label 5650: @279272
     /* 279272 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(279301), // Rule ID 5084 //
     /* 279277 */     // MIs[0] Operand 1
     /* 279277 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279290 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 279293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279299 */     GIR_RootConstrainSelectedInstOperands,
     /* 279300 */     // GIR_Coverage, 5084,
     /* 279300 */     GIR_EraseRootFromParent_Done,
     /* 279301 */   // Label 5651: @279301
     /* 279301 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(279330), // Rule ID 5091 //
     /* 279306 */     // MIs[0] Operand 1
     /* 279306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279319 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 279322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279328 */     GIR_RootConstrainSelectedInstOperands,
     /* 279329 */     // GIR_Coverage, 5091,
     /* 279329 */     GIR_EraseRootFromParent_Done,
     /* 279330 */   // Label 5652: @279330
     /* 279330 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(279359), // Rule ID 5098 //
     /* 279335 */     // MIs[0] Operand 1
     /* 279335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279348 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 279351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279357 */     GIR_RootConstrainSelectedInstOperands,
     /* 279358 */     // GIR_Coverage, 5098,
     /* 279358 */     GIR_EraseRootFromParent_Done,
     /* 279359 */   // Label 5653: @279359
     /* 279359 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(279388), // Rule ID 5105 //
     /* 279364 */     // MIs[0] Operand 1
     /* 279364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279377 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 279377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 279380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279386 */     GIR_RootConstrainSelectedInstOperands,
     /* 279387 */     // GIR_Coverage, 5105,
     /* 279387 */     GIR_EraseRootFromParent_Done,
     /* 279388 */   // Label 5654: @279388
     /* 279388 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(279417), // Rule ID 5112 //
     /* 279393 */     // MIs[0] Operand 1
     /* 279393 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279406 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 279406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 279409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279415 */     GIR_RootConstrainSelectedInstOperands,
     /* 279416 */     // GIR_Coverage, 5112,
     /* 279416 */     GIR_EraseRootFromParent_Done,
     /* 279417 */   // Label 5655: @279417
     /* 279417 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(279446), // Rule ID 5119 //
     /* 279422 */     // MIs[0] Operand 1
     /* 279422 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279435 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 279435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 279438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279444 */     GIR_RootConstrainSelectedInstOperands,
     /* 279445 */     // GIR_Coverage, 5119,
     /* 279445 */     GIR_EraseRootFromParent_Done,
     /* 279446 */   // Label 5656: @279446
     /* 279446 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(279475), // Rule ID 5126 //
     /* 279451 */     // MIs[0] Operand 1
     /* 279451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279464 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 279464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 279467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279473 */     GIR_RootConstrainSelectedInstOperands,
     /* 279474 */     // GIR_Coverage, 5126,
     /* 279474 */     GIR_EraseRootFromParent_Done,
     /* 279475 */   // Label 5657: @279475
     /* 279475 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(279504), // Rule ID 5133 //
     /* 279480 */     // MIs[0] Operand 1
     /* 279480 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279493 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 279493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 279496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279502 */     GIR_RootConstrainSelectedInstOperands,
     /* 279503 */     // GIR_Coverage, 5133,
     /* 279503 */     GIR_EraseRootFromParent_Done,
     /* 279504 */   // Label 5658: @279504
     /* 279504 */   GIM_Reject,
     /* 279505 */ // Label 5628: @279505
     /* 279505 */ GIM_Reject,
     /* 279506 */ // Label 5459: @279506
     /* 279506 */ GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(280553),
     /* 279511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279514 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 279517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279521 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(279561), // Rule ID 751 //
     /* 279526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279529 */     // MIs[0] Operand 1
     /* 279529 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279552 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 279555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279559 */     GIR_RootConstrainSelectedInstOperands,
     /* 279560 */     // GIR_Coverage, 751,
     /* 279560 */     GIR_EraseRootFromParent_Done,
     /* 279561 */   // Label 5660: @279561
     /* 279561 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(279601), // Rule ID 758 //
     /* 279566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279569 */     // MIs[0] Operand 1
     /* 279569 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279592 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 279595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279599 */     GIR_RootConstrainSelectedInstOperands,
     /* 279600 */     // GIR_Coverage, 758,
     /* 279600 */     GIR_EraseRootFromParent_Done,
     /* 279601 */   // Label 5661: @279601
     /* 279601 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(279638), // Rule ID 5173 //
     /* 279606 */     // MIs[0] Operand 1
     /* 279606 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279629 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 279632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279636 */     GIR_RootConstrainSelectedInstOperands,
     /* 279637 */     // GIR_Coverage, 5173,
     /* 279637 */     GIR_EraseRootFromParent_Done,
     /* 279638 */   // Label 5662: @279638
     /* 279638 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(279675), // Rule ID 5180 //
     /* 279643 */     // MIs[0] Operand 1
     /* 279643 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279666 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 279669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279673 */     GIR_RootConstrainSelectedInstOperands,
     /* 279674 */     // GIR_Coverage, 5180,
     /* 279674 */     GIR_EraseRootFromParent_Done,
     /* 279675 */   // Label 5663: @279675
     /* 279675 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(279712), // Rule ID 5187 //
     /* 279680 */     // MIs[0] Operand 1
     /* 279680 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279689 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279695 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279703 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 279706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279710 */     GIR_RootConstrainSelectedInstOperands,
     /* 279711 */     // GIR_Coverage, 5187,
     /* 279711 */     GIR_EraseRootFromParent_Done,
     /* 279712 */   // Label 5664: @279712
     /* 279712 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(279749), // Rule ID 5194 //
     /* 279717 */     // MIs[0] Operand 1
     /* 279717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279726 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279732 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279740 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 279743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279747 */     GIR_RootConstrainSelectedInstOperands,
     /* 279748 */     // GIR_Coverage, 5194,
     /* 279748 */     GIR_EraseRootFromParent_Done,
     /* 279749 */   // Label 5665: @279749
     /* 279749 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(279786), // Rule ID 5201 //
     /* 279754 */     // MIs[0] Operand 1
     /* 279754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279777 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279784 */     GIR_RootConstrainSelectedInstOperands,
     /* 279785 */     // GIR_Coverage, 5201,
     /* 279785 */     GIR_EraseRootFromParent_Done,
     /* 279786 */   // Label 5666: @279786
     /* 279786 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(279826), // Rule ID 723 //
     /* 279791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279794 */     // MIs[0] Operand 1
     /* 279794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279817 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 279820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279824 */     GIR_RootConstrainSelectedInstOperands,
     /* 279825 */     // GIR_Coverage, 723,
     /* 279825 */     GIR_EraseRootFromParent_Done,
     /* 279826 */   // Label 5667: @279826
     /* 279826 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(279866), // Rule ID 731 //
     /* 279831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279834 */     // MIs[0] Operand 1
     /* 279834 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279847 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279853 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279857 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279864 */     GIR_RootConstrainSelectedInstOperands,
     /* 279865 */     // GIR_Coverage, 731,
     /* 279865 */     GIR_EraseRootFromParent_Done,
     /* 279866 */   // Label 5668: @279866
     /* 279866 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(279906), // Rule ID 732 //
     /* 279871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279874 */     // MIs[0] Operand 1
     /* 279874 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 279895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279897 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279904 */     GIR_RootConstrainSelectedInstOperands,
     /* 279905 */     // GIR_Coverage, 732,
     /* 279905 */     GIR_EraseRootFromParent_Done,
     /* 279906 */   // Label 5669: @279906
     /* 279906 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279946), // Rule ID 744 //
     /* 279911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279914 */     // MIs[0] Operand 1
     /* 279914 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279927 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279933 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279937 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 279940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279944 */     GIR_RootConstrainSelectedInstOperands,
     /* 279945 */     // GIR_Coverage, 744,
     /* 279945 */     GIR_EraseRootFromParent_Done,
     /* 279946 */   // Label 5670: @279946
     /* 279946 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279983), // Rule ID 5138 //
     /* 279951 */     // MIs[0] Operand 1
     /* 279951 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279964 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279970 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279974 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 279977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279981 */     GIR_RootConstrainSelectedInstOperands,
     /* 279982 */     // GIR_Coverage, 5138,
     /* 279982 */     GIR_EraseRootFromParent_Done,
     /* 279983 */   // Label 5671: @279983
     /* 279983 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(280020), // Rule ID 5145 //
     /* 279988 */     // MIs[0] Operand 1
     /* 279988 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280001 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280007 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280011 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 280011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 280014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280018 */     GIR_RootConstrainSelectedInstOperands,
     /* 280019 */     // GIR_Coverage, 5145,
     /* 280019 */     GIR_EraseRootFromParent_Done,
     /* 280020 */   // Label 5672: @280020
     /* 280020 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(280057), // Rule ID 5152 //
     /* 280025 */     // MIs[0] Operand 1
     /* 280025 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280038 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280044 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280048 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 280048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 280051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280055 */     GIR_RootConstrainSelectedInstOperands,
     /* 280056 */     // GIR_Coverage, 5152,
     /* 280056 */     GIR_EraseRootFromParent_Done,
     /* 280057 */   // Label 5673: @280057
     /* 280057 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(280094), // Rule ID 5159 //
     /* 280062 */     // MIs[0] Operand 1
     /* 280062 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280085 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 280085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 280088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280092 */     GIR_RootConstrainSelectedInstOperands,
     /* 280093 */     // GIR_Coverage, 5159,
     /* 280093 */     GIR_EraseRootFromParent_Done,
     /* 280094 */   // Label 5674: @280094
     /* 280094 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(280131), // Rule ID 5166 //
     /* 280099 */     // MIs[0] Operand 1
     /* 280099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 280112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 280120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280122 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 280122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 280125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280129 */     GIR_RootConstrainSelectedInstOperands,
     /* 280130 */     // GIR_Coverage, 5166,
     /* 280130 */     GIR_EraseRootFromParent_Done,
     /* 280131 */   // Label 5675: @280131
     /* 280131 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(280163), // Rule ID 1122 //
     /* 280136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280139 */     // MIs[0] Operand 1
     /* 280139 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280152 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 280155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280161 */     GIR_RootConstrainSelectedInstOperands,
     /* 280162 */     // GIR_Coverage, 1122,
     /* 280162 */     GIR_EraseRootFromParent_Done,
     /* 280163 */   // Label 5676: @280163
     /* 280163 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(280195), // Rule ID 1129 //
     /* 280168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280171 */     // MIs[0] Operand 1
     /* 280171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280184 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 280187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280193 */     GIR_RootConstrainSelectedInstOperands,
     /* 280194 */     // GIR_Coverage, 1129,
     /* 280194 */     GIR_EraseRootFromParent_Done,
     /* 280195 */   // Label 5677: @280195
     /* 280195 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(280227), // Rule ID 1136 //
     /* 280200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280203 */     // MIs[0] Operand 1
     /* 280203 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280216 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 280219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280225 */     GIR_RootConstrainSelectedInstOperands,
     /* 280226 */     // GIR_Coverage, 1136,
     /* 280226 */     GIR_EraseRootFromParent_Done,
     /* 280227 */   // Label 5678: @280227
     /* 280227 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(280259), // Rule ID 1143 //
     /* 280232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280235 */     // MIs[0] Operand 1
     /* 280235 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280248 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 280251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280257 */     GIR_RootConstrainSelectedInstOperands,
     /* 280258 */     // GIR_Coverage, 1143,
     /* 280258 */     GIR_EraseRootFromParent_Done,
     /* 280259 */   // Label 5679: @280259
     /* 280259 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(280291), // Rule ID 1150 //
     /* 280264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280267 */     // MIs[0] Operand 1
     /* 280267 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280280 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 280283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280289 */     GIR_RootConstrainSelectedInstOperands,
     /* 280290 */     // GIR_Coverage, 1150,
     /* 280290 */     GIR_EraseRootFromParent_Done,
     /* 280291 */   // Label 5680: @280291
     /* 280291 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(280320), // Rule ID 5075 //
     /* 280296 */     // MIs[0] Operand 1
     /* 280296 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 280301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280309 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 280312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280318 */     GIR_RootConstrainSelectedInstOperands,
     /* 280319 */     // GIR_Coverage, 5075,
     /* 280319 */     GIR_EraseRootFromParent_Done,
     /* 280320 */   // Label 5681: @280320
     /* 280320 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(280349), // Rule ID 5082 //
     /* 280325 */     // MIs[0] Operand 1
     /* 280325 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 280330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280338 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 280341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280347 */     GIR_RootConstrainSelectedInstOperands,
     /* 280348 */     // GIR_Coverage, 5082,
     /* 280348 */     GIR_EraseRootFromParent_Done,
     /* 280349 */   // Label 5682: @280349
     /* 280349 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(280378), // Rule ID 5089 //
     /* 280354 */     // MIs[0] Operand 1
     /* 280354 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 280359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280367 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 280370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280376 */     GIR_RootConstrainSelectedInstOperands,
     /* 280377 */     // GIR_Coverage, 5089,
     /* 280377 */     GIR_EraseRootFromParent_Done,
     /* 280378 */   // Label 5683: @280378
     /* 280378 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(280407), // Rule ID 5096 //
     /* 280383 */     // MIs[0] Operand 1
     /* 280383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 280388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280396 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 280399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280405 */     GIR_RootConstrainSelectedInstOperands,
     /* 280406 */     // GIR_Coverage, 5096,
     /* 280406 */     GIR_EraseRootFromParent_Done,
     /* 280407 */   // Label 5684: @280407
     /* 280407 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(280436), // Rule ID 5103 //
     /* 280412 */     // MIs[0] Operand 1
     /* 280412 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 280417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280425 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 280425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 280428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280434 */     GIR_RootConstrainSelectedInstOperands,
     /* 280435 */     // GIR_Coverage, 5103,
     /* 280435 */     GIR_EraseRootFromParent_Done,
     /* 280436 */   // Label 5685: @280436
     /* 280436 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(280465), // Rule ID 5110 //
     /* 280441 */     // MIs[0] Operand 1
     /* 280441 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 280446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280454 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 280454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 280457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280463 */     GIR_RootConstrainSelectedInstOperands,
     /* 280464 */     // GIR_Coverage, 5110,
     /* 280464 */     GIR_EraseRootFromParent_Done,
     /* 280465 */   // Label 5686: @280465
     /* 280465 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(280494), // Rule ID 5117 //
     /* 280470 */     // MIs[0] Operand 1
     /* 280470 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 280475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280483 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 280483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 280486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280492 */     GIR_RootConstrainSelectedInstOperands,
     /* 280493 */     // GIR_Coverage, 5117,
     /* 280493 */     GIR_EraseRootFromParent_Done,
     /* 280494 */   // Label 5687: @280494
     /* 280494 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(280523), // Rule ID 5124 //
     /* 280499 */     // MIs[0] Operand 1
     /* 280499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 280504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280512 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 280512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 280515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280521 */     GIR_RootConstrainSelectedInstOperands,
     /* 280522 */     // GIR_Coverage, 5124,
     /* 280522 */     GIR_EraseRootFromParent_Done,
     /* 280523 */   // Label 5688: @280523
     /* 280523 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(280552), // Rule ID 5131 //
     /* 280528 */     // MIs[0] Operand 1
     /* 280528 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 280533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280541 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 280541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 280544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 280548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280550 */     GIR_RootConstrainSelectedInstOperands,
     /* 280551 */     // GIR_Coverage, 5131,
     /* 280551 */     GIR_EraseRootFromParent_Done,
     /* 280552 */   // Label 5689: @280552
     /* 280552 */   GIM_Reject,
     /* 280553 */ // Label 5659: @280553
     /* 280553 */ GIM_Reject,
     /* 280554 */ // Label 5460: @280554
     /* 280554 */ GIM_Reject,
     /* 280555 */ // Label 50: @280555
     /* 280555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5702*/ GIMT_Encode4(281599),
     /* 280566 */ /*GILLT_nxv1s1*//*Label 5690*/ GIMT_Encode4(280614),
     /* 280570 */ /*GILLT_nxv2s1*//*Label 5691*/ GIMT_Encode4(280643),
     /* 280574 */ /*GILLT_nxv2s16*//*Label 5692*/ GIMT_Encode4(280672),
     /* 280578 */ /*GILLT_nxv2s32*//*Label 5693*/ GIMT_Encode4(280757),
     /* 280582 */ /*GILLT_nxv2s64*//*Label 5694*/ GIMT_Encode4(280842),
     /* 280586 */ /*GILLT_nxv4s1*//*Label 5695*/ GIMT_Encode4(281008),
     /* 280590 */ /*GILLT_nxv4s16*//*Label 5696*/ GIMT_Encode4(281037),
     /* 280594 */ /*GILLT_nxv4s32*//*Label 5697*/ GIMT_Encode4(281122),
     /* 280598 */ /*GILLT_nxv8s1*//*Label 5698*/ GIMT_Encode4(281288),
     /* 280602 */ /*GILLT_nxv8s16*//*Label 5699*/ GIMT_Encode4(281317),
     /* 280606 */ /*GILLT_nxv16s1*//*Label 5700*/ GIMT_Encode4(281483),
     /* 280610 */ /*GILLT_nxv16s8*//*Label 5701*/ GIMT_Encode4(281512),
     /* 280614 */ // Label 5690: @280614
     /* 280614 */ GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(280642), // Rule ID 8427 //
     /* 280619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 280625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 280628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 280631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280635 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 280635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280640 */   GIR_RootConstrainSelectedInstOperands,
     /* 280641 */   // GIR_Coverage, 8427,
     /* 280641 */   GIR_Done,
     /* 280642 */ // Label 5703: @280642
     /* 280642 */ GIM_Reject,
     /* 280643 */ // Label 5691: @280643
     /* 280643 */ GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(280671), // Rule ID 8426 //
     /* 280648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 280657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 280660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280664 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 280664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280669 */   GIR_RootConstrainSelectedInstOperands,
     /* 280670 */   // GIR_Coverage, 8426,
     /* 280670 */   GIR_Done,
     /* 280671 */ // Label 5704: @280671
     /* 280671 */ GIM_Reject,
     /* 280672 */ // Label 5692: @280672
     /* 280672 */ GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(280756),
     /* 280677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 280683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 280686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280690 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(280740), // Rule ID 3161 //
     /* 280695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280718 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280722 */     // MIs[2] Operand 1
     /* 280722 */     // No operand predicates
     /* 280722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280724 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280729 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280731 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280733 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280738 */     GIR_RootConstrainSelectedInstOperands,
     /* 280739 */     // GIR_Coverage, 3161,
     /* 280739 */     GIR_EraseRootFromParent_Done,
     /* 280740 */   // Label 5706: @280740
     /* 280740 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(280755), // Rule ID 2741 //
     /* 280745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280748 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 280748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280753 */     GIR_RootConstrainSelectedInstOperands,
     /* 280754 */     // GIR_Coverage, 2741,
     /* 280754 */     GIR_Done,
     /* 280755 */   // Label 5707: @280755
     /* 280755 */   GIM_Reject,
     /* 280756 */ // Label 5705: @280756
     /* 280756 */ GIM_Reject,
     /* 280757 */ // Label 5693: @280757
     /* 280757 */ GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(280841),
     /* 280762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 280768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 280771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280775 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(280825), // Rule ID 3163 //
     /* 280780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280803 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 280807 */     // MIs[2] Operand 1
     /* 280807 */     // No operand predicates
     /* 280807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280809 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 280809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 280812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280814 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280816 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280818 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 280823 */     GIR_RootConstrainSelectedInstOperands,
     /* 280824 */     // GIR_Coverage, 3163,
     /* 280824 */     GIR_EraseRootFromParent_Done,
     /* 280825 */   // Label 5709: @280825
     /* 280825 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(280840), // Rule ID 2742 //
     /* 280830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280833 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 280833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280838 */     GIR_RootConstrainSelectedInstOperands,
     /* 280839 */     // GIR_Coverage, 2742,
     /* 280839 */     GIR_Done,
     /* 280840 */   // Label 5710: @280840
     /* 280840 */   GIM_Reject,
     /* 280841 */ // Label 5708: @280841
     /* 280841 */ GIM_Reject,
     /* 280842 */ // Label 5694: @280842
     /* 280842 */ GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(281007),
     /* 280847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 280853 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(280910), // Rule ID 3164 //
     /* 280858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 280880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280888 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 280892 */     // MIs[2] Operand 1
     /* 280892 */     // No operand predicates
     /* 280892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280894 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 280894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 280897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280899 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280901 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280903 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 280908 */     GIR_RootConstrainSelectedInstOperands,
     /* 280909 */     // GIR_Coverage, 3164,
     /* 280909 */     GIR_EraseRootFromParent_Done,
     /* 280910 */   // Label 5712: @280910
     /* 280910 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(280962), // Rule ID 7473 //
     /* 280915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 280934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 280938 */     // MIs[0] Op2
     /* 280938 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280945 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 280945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 280948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280960 */     GIR_RootConstrainSelectedInstOperands,
     /* 280961 */     // GIR_Coverage, 7473,
     /* 280961 */     GIR_EraseRootFromParent_Done,
     /* 280962 */   // Label 5713: @280962
     /* 280962 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(280984), // Rule ID 2737 //
     /* 280967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280977 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 280977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280982 */     GIR_RootConstrainSelectedInstOperands,
     /* 280983 */     // GIR_Coverage, 2737,
     /* 280983 */     GIR_Done,
     /* 280984 */   // Label 5714: @280984
     /* 280984 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(281006), // Rule ID 2743 //
     /* 280989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280999 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 280999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 281004 */     GIR_RootConstrainSelectedInstOperands,
     /* 281005 */     // GIR_Coverage, 2743,
     /* 281005 */     GIR_Done,
     /* 281006 */   // Label 5715: @281006
     /* 281006 */   GIM_Reject,
     /* 281007 */ // Label 5711: @281007
     /* 281007 */ GIM_Reject,
     /* 281008 */ // Label 5695: @281008
     /* 281008 */ GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(281036), // Rule ID 8425 //
     /* 281013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 281019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 281022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 281025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 281029 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 281029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 281034 */   GIR_RootConstrainSelectedInstOperands,
     /* 281035 */   // GIR_Coverage, 8425,
     /* 281035 */   GIR_Done,
     /* 281036 */ // Label 5716: @281036
     /* 281036 */ GIM_Reject,
     /* 281037 */ // Label 5696: @281037
     /* 281037 */ GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(281121),
     /* 281042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 281045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 281048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 281051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281055 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(281105), // Rule ID 3160 //
     /* 281060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 281071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 281083 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 281087 */     // MIs[2] Operand 1
     /* 281087 */     // No operand predicates
     /* 281087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281089 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 281089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 281092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281094 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 281096 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 281098 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 281103 */     GIR_RootConstrainSelectedInstOperands,
     /* 281104 */     // GIR_Coverage, 3160,
     /* 281104 */     GIR_EraseRootFromParent_Done,
     /* 281105 */   // Label 5718: @281105
     /* 281105 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(281120), // Rule ID 2739 //
     /* 281110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281113 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 281113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 281118 */     GIR_RootConstrainSelectedInstOperands,
     /* 281119 */     // GIR_Coverage, 2739,
     /* 281119 */     GIR_Done,
     /* 281120 */   // Label 5719: @281120
     /* 281120 */   GIM_Reject,
     /* 281121 */ // Label 5717: @281121
     /* 281121 */ GIM_Reject,
     /* 281122 */ // Label 5697: @281122
     /* 281122 */ GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(281287),
     /* 281127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 281130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281133 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(281190), // Rule ID 3162 //
     /* 281138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 281144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 281156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 281168 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 281172 */     // MIs[2] Operand 1
     /* 281172 */     // No operand predicates
     /* 281172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281174 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 281174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 281177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281179 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 281181 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 281183 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 281188 */     GIR_RootConstrainSelectedInstOperands,
     /* 281189 */     // GIR_Coverage, 3162,
     /* 281189 */     GIR_EraseRootFromParent_Done,
     /* 281190 */   // Label 5721: @281190
     /* 281190 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(281242), // Rule ID 7471 //
     /* 281195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 281210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281218 */     // MIs[0] Op2
     /* 281218 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 281223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281225 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 281225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 281228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 281230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 281232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 281236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 281240 */     GIR_RootConstrainSelectedInstOperands,
     /* 281241 */     // GIR_Coverage, 7471,
     /* 281241 */     GIR_EraseRootFromParent_Done,
     /* 281242 */   // Label 5722: @281242
     /* 281242 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(281264), // Rule ID 2736 //
     /* 281247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 281253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281257 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 281257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 281262 */     GIR_RootConstrainSelectedInstOperands,
     /* 281263 */     // GIR_Coverage, 2736,
     /* 281263 */     GIR_Done,
     /* 281264 */   // Label 5723: @281264
     /* 281264 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(281286), // Rule ID 2740 //
     /* 281269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 281275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281279 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 281279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 281284 */     GIR_RootConstrainSelectedInstOperands,
     /* 281285 */     // GIR_Coverage, 2740,
     /* 281285 */     GIR_Done,
     /* 281286 */   // Label 5724: @281286
     /* 281286 */   GIM_Reject,
     /* 281287 */ // Label 5720: @281287
     /* 281287 */ GIM_Reject,
     /* 281288 */ // Label 5698: @281288
     /* 281288 */ GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(281316), // Rule ID 8424 //
     /* 281293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 281299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 281302 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 281305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 281309 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 281309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 281314 */   GIR_RootConstrainSelectedInstOperands,
     /* 281315 */   // GIR_Coverage, 8424,
     /* 281315 */   GIR_Done,
     /* 281316 */ // Label 5725: @281316
     /* 281316 */ GIM_Reject,
     /* 281317 */ // Label 5699: @281317
     /* 281317 */ GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(281482),
     /* 281322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 281325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281328 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(281385), // Rule ID 3159 //
     /* 281333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 281339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 281351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 281363 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 281367 */     // MIs[2] Operand 1
     /* 281367 */     // No operand predicates
     /* 281367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281369 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 281369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 281372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 281374 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 281376 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 281378 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 281383 */     GIR_RootConstrainSelectedInstOperands,
     /* 281384 */     // GIR_Coverage, 3159,
     /* 281384 */     GIR_EraseRootFromParent_Done,
     /* 281385 */   // Label 5727: @281385
     /* 281385 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(281437), // Rule ID 7469 //
     /* 281390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 281405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281413 */     // MIs[0] Op2
     /* 281413 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 281418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281420 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 281420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 281423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 281425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 281427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 281431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 281435 */     GIR_RootConstrainSelectedInstOperands,
     /* 281436 */     // GIR_Coverage, 7469,
     /* 281436 */     GIR_EraseRootFromParent_Done,
     /* 281437 */   // Label 5728: @281437
     /* 281437 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(281459), // Rule ID 2735 //
     /* 281442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 281448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281452 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 281452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 281457 */     GIR_RootConstrainSelectedInstOperands,
     /* 281458 */     // GIR_Coverage, 2735,
     /* 281458 */     GIR_Done,
     /* 281459 */   // Label 5729: @281459
     /* 281459 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(281481), // Rule ID 2738 //
     /* 281464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 281470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281474 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 281474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 281479 */     GIR_RootConstrainSelectedInstOperands,
     /* 281480 */     // GIR_Coverage, 2738,
     /* 281480 */     GIR_Done,
     /* 281481 */   // Label 5730: @281481
     /* 281481 */   GIM_Reject,
     /* 281482 */ // Label 5726: @281482
     /* 281482 */ GIM_Reject,
     /* 281483 */ // Label 5700: @281483
     /* 281483 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(281511), // Rule ID 8423 //
     /* 281488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 281494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 281497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 281500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 281504 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 281504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 281509 */   GIR_RootConstrainSelectedInstOperands,
     /* 281510 */   // GIR_Coverage, 8423,
     /* 281510 */   GIR_Done,
     /* 281511 */ // Label 5731: @281511
     /* 281511 */ GIM_Reject,
     /* 281512 */ // Label 5701: @281512
     /* 281512 */ GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(281598),
     /* 281517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 281520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 281523 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(281575), // Rule ID 7467 //
     /* 281528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 281543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 281551 */     // MIs[0] Op2
     /* 281551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 281556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281558 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 281558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 281561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 281563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 281565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 281569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 281573 */     GIR_RootConstrainSelectedInstOperands,
     /* 281574 */     // GIR_Coverage, 7467,
     /* 281574 */     GIR_EraseRootFromParent_Done,
     /* 281575 */   // Label 5733: @281575
     /* 281575 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(281597), // Rule ID 2734 //
     /* 281580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 281586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281590 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 281590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 281595 */     GIR_RootConstrainSelectedInstOperands,
     /* 281596 */     // GIR_Coverage, 2734,
     /* 281596 */     GIR_Done,
     /* 281597 */   // Label 5734: @281597
     /* 281597 */   GIM_Reject,
     /* 281598 */ // Label 5732: @281598
     /* 281598 */ GIM_Reject,
     /* 281599 */ // Label 5702: @281599
     /* 281599 */ GIM_Reject,
     /* 281600 */ // Label 51: @281600
     /* 281600 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5739*/ GIMT_Encode4(282083),
     /* 281611 */ /*GILLT_s64*//*Label 5735*/ GIMT_Encode4(281647), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281631 */ /*GILLT_v4s32*//*Label 5736*/ GIMT_Encode4(281678), GIMT_Encode4(0),
     /* 281639 */ /*GILLT_v8s16*//*Label 5737*/ GIMT_Encode4(281813),
     /* 281643 */ /*GILLT_v16s8*//*Label 5738*/ GIMT_Encode4(281948),
     /* 281647 */ // Label 5735: @281647
     /* 281647 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(281677), // Rule ID 128 //
     /* 281652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 281658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281670 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 281670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 281675 */   GIR_RootConstrainSelectedInstOperands,
     /* 281676 */   // GIR_Coverage, 128,
     /* 281676 */   GIR_Done,
     /* 281677 */ // Label 5740: @281677
     /* 281677 */ GIM_Reject,
     /* 281678 */ // Label 5736: @281678
     /* 281678 */ GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(281812), // Rule ID 6523 //
     /* 281683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281701 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 281701 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281704 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 281708 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281713 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281717 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281723 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281726 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281730 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281735 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281741 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281746 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281751 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281754 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281758 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281763 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281769 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281774 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 281786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281791 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281794 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281810 */   GIR_RootConstrainSelectedInstOperands,
     /* 281811 */   // GIR_Coverage, 6523,
     /* 281811 */   GIR_EraseRootFromParent_Done,
     /* 281812 */ // Label 5741: @281812
     /* 281812 */ GIM_Reject,
     /* 281813 */ // Label 5737: @281813
     /* 281813 */ GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(281947), // Rule ID 6522 //
     /* 281818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281836 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281836 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281839 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 281843 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281848 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281852 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281856 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281858 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281861 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281865 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281870 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281876 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281881 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281886 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281889 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281893 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281898 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281904 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281909 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 281921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281926 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281929 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281945 */   GIR_RootConstrainSelectedInstOperands,
     /* 281946 */   // GIR_Coverage, 6522,
     /* 281946 */   GIR_EraseRootFromParent_Done,
     /* 281947 */ // Label 5742: @281947
     /* 281947 */ GIM_Reject,
     /* 281948 */ // Label 5738: @281948
     /* 281948 */ GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(282082), // Rule ID 6521 //
     /* 281953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281971 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281971 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281974 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 281978 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281983 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281987 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282005 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 282011 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 282024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282033 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 282039 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282044 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 282052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 282056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282061 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 282072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 282080 */   GIR_RootConstrainSelectedInstOperands,
     /* 282081 */   // GIR_Coverage, 6521,
     /* 282081 */   GIR_EraseRootFromParent_Done,
     /* 282082 */ // Label 5743: @282082
     /* 282082 */ GIM_Reject,
     /* 282083 */ // Label 5739: @282083
     /* 282083 */ GIM_Reject,
     /* 282084 */ // Label 52: @282084
     /* 282084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5748*/ GIMT_Encode4(282567),
     /* 282095 */ /*GILLT_s64*//*Label 5744*/ GIMT_Encode4(282131), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282115 */ /*GILLT_v4s32*//*Label 5745*/ GIMT_Encode4(282162), GIMT_Encode4(0),
     /* 282123 */ /*GILLT_v8s16*//*Label 5746*/ GIMT_Encode4(282297),
     /* 282127 */ /*GILLT_v16s8*//*Label 5747*/ GIMT_Encode4(282432),
     /* 282131 */ // Label 5744: @282131
     /* 282131 */ GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(282161), // Rule ID 127 //
     /* 282136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 282139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 282142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282154 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 282154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 282159 */   GIR_RootConstrainSelectedInstOperands,
     /* 282160 */   // GIR_Coverage, 127,
     /* 282160 */   GIR_Done,
     /* 282161 */ // Label 5749: @282161
     /* 282161 */ GIM_Reject,
     /* 282162 */ // Label 5745: @282162
     /* 282162 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(282296), // Rule ID 6520 //
     /* 282167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282185 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 282185 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 282188 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 282192 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282197 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 282201 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 282205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282207 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 282210 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282214 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282219 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 282225 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282230 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282235 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 282238 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282242 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282247 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 282253 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282258 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 282266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 282270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282275 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 282286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 282294 */   GIR_RootConstrainSelectedInstOperands,
     /* 282295 */   // GIR_Coverage, 6520,
     /* 282295 */   GIR_EraseRootFromParent_Done,
     /* 282296 */ // Label 5750: @282296
     /* 282296 */ GIM_Reject,
     /* 282297 */ // Label 5746: @282297
     /* 282297 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(282431), // Rule ID 6519 //
     /* 282302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282320 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 282320 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 282323 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 282327 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282332 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 282336 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 282340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282342 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 282345 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282349 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282354 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 282360 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282365 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282370 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 282373 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282377 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282382 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 282388 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282393 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 282401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 282405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 282421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 282429 */   GIR_RootConstrainSelectedInstOperands,
     /* 282430 */   // GIR_Coverage, 6519,
     /* 282430 */   GIR_EraseRootFromParent_Done,
     /* 282431 */ // Label 5751: @282431
     /* 282431 */ GIM_Reject,
     /* 282432 */ // Label 5747: @282432
     /* 282432 */ GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(282566), // Rule ID 6518 //
     /* 282437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282455 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 282455 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 282458 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 282462 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282467 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 282471 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 282475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282477 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 282480 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282484 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282489 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 282495 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282500 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 282508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282517 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 282523 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282528 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 282536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 282540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282545 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282548 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 282556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 282564 */   GIR_RootConstrainSelectedInstOperands,
     /* 282565 */   // GIR_Coverage, 6518,
     /* 282565 */   GIR_EraseRootFromParent_Done,
     /* 282566 */ // Label 5752: @282566
     /* 282566 */ GIM_Reject,
     /* 282567 */ // Label 5748: @282567
     /* 282567 */ GIM_Reject,
     /* 282568 */ // Label 53: @282568
     /* 282568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5764*/ GIMT_Encode4(282997),
     /* 282579 */ /*GILLT_v2s32*//*Label 5753*/ GIMT_Encode4(282655),
     /* 282583 */ /*GILLT_v2s64*//*Label 5754*/ GIMT_Encode4(282689),
     /* 282587 */ /*GILLT_v4s16*//*Label 5755*/ GIMT_Encode4(282723),
     /* 282591 */ /*GILLT_v4s32*//*Label 5756*/ GIMT_Encode4(282757),
     /* 282595 */ /*GILLT_v8s8*//*Label 5757*/ GIMT_Encode4(282791),
     /* 282599 */ /*GILLT_v8s16*//*Label 5758*/ GIMT_Encode4(282825),
     /* 282603 */ /*GILLT_v16s8*//*Label 5759*/ GIMT_Encode4(282859), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282623 */ /*GILLT_nxv2s64*//*Label 5760*/ GIMT_Encode4(282893), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282635 */ /*GILLT_nxv4s32*//*Label 5761*/ GIMT_Encode4(282919), GIMT_Encode4(0),
     /* 282643 */ /*GILLT_nxv8s16*//*Label 5762*/ GIMT_Encode4(282945), GIMT_Encode4(0),
     /* 282651 */ /*GILLT_nxv16s8*//*Label 5763*/ GIMT_Encode4(282971),
     /* 282655 */ // Label 5753: @282655
     /* 282655 */ GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(282688), // Rule ID 5023 //
     /* 282660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282681 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 282686 */   GIR_RootConstrainSelectedInstOperands,
     /* 282687 */   // GIR_Coverage, 5023,
     /* 282687 */   GIR_Done,
     /* 282688 */ // Label 5765: @282688
     /* 282688 */ GIM_Reject,
     /* 282689 */ // Label 5754: @282689
     /* 282689 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(282722), // Rule ID 5027 //
     /* 282694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282715 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 282720 */   GIR_RootConstrainSelectedInstOperands,
     /* 282721 */   // GIR_Coverage, 5027,
     /* 282721 */   GIR_Done,
     /* 282722 */ // Label 5766: @282722
     /* 282722 */ GIM_Reject,
     /* 282723 */ // Label 5755: @282723
     /* 282723 */ GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(282756), // Rule ID 5022 //
     /* 282728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282749 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 282754 */   GIR_RootConstrainSelectedInstOperands,
     /* 282755 */   // GIR_Coverage, 5022,
     /* 282755 */   GIR_Done,
     /* 282756 */ // Label 5767: @282756
     /* 282756 */ GIM_Reject,
     /* 282757 */ // Label 5756: @282757
     /* 282757 */ GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(282790), // Rule ID 5026 //
     /* 282762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282783 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 282788 */   GIR_RootConstrainSelectedInstOperands,
     /* 282789 */   // GIR_Coverage, 5026,
     /* 282789 */   GIR_Done,
     /* 282790 */ // Label 5768: @282790
     /* 282790 */ GIM_Reject,
     /* 282791 */ // Label 5757: @282791
     /* 282791 */ GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(282824), // Rule ID 5021 //
     /* 282796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282817 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 282822 */   GIR_RootConstrainSelectedInstOperands,
     /* 282823 */   // GIR_Coverage, 5021,
     /* 282823 */   GIR_Done,
     /* 282824 */ // Label 5769: @282824
     /* 282824 */ GIM_Reject,
     /* 282825 */ // Label 5758: @282825
     /* 282825 */ GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(282858), // Rule ID 5025 //
     /* 282830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282851 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 282856 */   GIR_RootConstrainSelectedInstOperands,
     /* 282857 */   // GIR_Coverage, 5025,
     /* 282857 */   GIR_Done,
     /* 282858 */ // Label 5770: @282858
     /* 282858 */ GIM_Reject,
     /* 282859 */ // Label 5759: @282859
     /* 282859 */ GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(282892), // Rule ID 5024 //
     /* 282864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282885 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 282890 */   GIR_RootConstrainSelectedInstOperands,
     /* 282891 */   // GIR_Coverage, 5024,
     /* 282891 */   GIR_Done,
     /* 282892 */ // Label 5771: @282892
     /* 282892 */ GIM_Reject,
     /* 282893 */ // Label 5760: @282893
     /* 282893 */ GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(282918), // Rule ID 7425 //
     /* 282898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282911 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 282916 */   GIR_RootConstrainSelectedInstOperands,
     /* 282917 */   // GIR_Coverage, 7425,
     /* 282917 */   GIR_Done,
     /* 282918 */ // Label 5772: @282918
     /* 282918 */ GIM_Reject,
     /* 282919 */ // Label 5761: @282919
     /* 282919 */ GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(282944), // Rule ID 7424 //
     /* 282924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282937 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 282942 */   GIR_RootConstrainSelectedInstOperands,
     /* 282943 */   // GIR_Coverage, 7424,
     /* 282943 */   GIR_Done,
     /* 282944 */ // Label 5773: @282944
     /* 282944 */ GIM_Reject,
     /* 282945 */ // Label 5762: @282945
     /* 282945 */ GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(282970), // Rule ID 7423 //
     /* 282950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282963 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 282968 */   GIR_RootConstrainSelectedInstOperands,
     /* 282969 */   // GIR_Coverage, 7423,
     /* 282969 */   GIR_Done,
     /* 282970 */ // Label 5774: @282970
     /* 282970 */ GIM_Reject,
     /* 282971 */ // Label 5763: @282971
     /* 282971 */ GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(282996), // Rule ID 7422 //
     /* 282976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282989 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 282994 */   GIR_RootConstrainSelectedInstOperands,
     /* 282995 */   // GIR_Coverage, 7422,
     /* 282995 */   GIR_Done,
     /* 282996 */ // Label 5775: @282996
     /* 282996 */ GIM_Reject,
     /* 282997 */ // Label 5764: @282997
     /* 282997 */ GIM_Reject,
     /* 282998 */ // Label 54: @282998
     /* 282998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5787*/ GIMT_Encode4(283427),
     /* 283009 */ /*GILLT_v2s32*//*Label 5776*/ GIMT_Encode4(283085),
     /* 283013 */ /*GILLT_v2s64*//*Label 5777*/ GIMT_Encode4(283119),
     /* 283017 */ /*GILLT_v4s16*//*Label 5778*/ GIMT_Encode4(283153),
     /* 283021 */ /*GILLT_v4s32*//*Label 5779*/ GIMT_Encode4(283187),
     /* 283025 */ /*GILLT_v8s8*//*Label 5780*/ GIMT_Encode4(283221),
     /* 283029 */ /*GILLT_v8s16*//*Label 5781*/ GIMT_Encode4(283255),
     /* 283033 */ /*GILLT_v16s8*//*Label 5782*/ GIMT_Encode4(283289), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283053 */ /*GILLT_nxv2s64*//*Label 5783*/ GIMT_Encode4(283323), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283065 */ /*GILLT_nxv4s32*//*Label 5784*/ GIMT_Encode4(283349), GIMT_Encode4(0),
     /* 283073 */ /*GILLT_nxv8s16*//*Label 5785*/ GIMT_Encode4(283375), GIMT_Encode4(0),
     /* 283081 */ /*GILLT_nxv16s8*//*Label 5786*/ GIMT_Encode4(283401),
     /* 283085 */ // Label 5776: @283085
     /* 283085 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283118), // Rule ID 2477 //
     /* 283090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283111 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 283111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 283116 */   GIR_RootConstrainSelectedInstOperands,
     /* 283117 */   // GIR_Coverage, 2477,
     /* 283117 */   GIR_Done,
     /* 283118 */ // Label 5788: @283118
     /* 283118 */ GIM_Reject,
     /* 283119 */ // Label 5777: @283119
     /* 283119 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283152), // Rule ID 2481 //
     /* 283124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283145 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 283145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 283150 */   GIR_RootConstrainSelectedInstOperands,
     /* 283151 */   // GIR_Coverage, 2481,
     /* 283151 */   GIR_Done,
     /* 283152 */ // Label 5789: @283152
     /* 283152 */ GIM_Reject,
     /* 283153 */ // Label 5778: @283153
     /* 283153 */ GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(283186), // Rule ID 2476 //
     /* 283158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283179 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 283179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 283184 */   GIR_RootConstrainSelectedInstOperands,
     /* 283185 */   // GIR_Coverage, 2476,
     /* 283185 */   GIR_Done,
     /* 283186 */ // Label 5790: @283186
     /* 283186 */ GIM_Reject,
     /* 283187 */ // Label 5779: @283187
     /* 283187 */ GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(283220), // Rule ID 2480 //
     /* 283192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283213 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 283213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 283218 */   GIR_RootConstrainSelectedInstOperands,
     /* 283219 */   // GIR_Coverage, 2480,
     /* 283219 */   GIR_Done,
     /* 283220 */ // Label 5791: @283220
     /* 283220 */ GIM_Reject,
     /* 283221 */ // Label 5780: @283221
     /* 283221 */ GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(283254), // Rule ID 2475 //
     /* 283226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283247 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 283247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 283252 */   GIR_RootConstrainSelectedInstOperands,
     /* 283253 */   // GIR_Coverage, 2475,
     /* 283253 */   GIR_Done,
     /* 283254 */ // Label 5792: @283254
     /* 283254 */ GIM_Reject,
     /* 283255 */ // Label 5781: @283255
     /* 283255 */ GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(283288), // Rule ID 2479 //
     /* 283260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283281 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 283281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 283286 */   GIR_RootConstrainSelectedInstOperands,
     /* 283287 */   // GIR_Coverage, 2479,
     /* 283287 */   GIR_Done,
     /* 283288 */ // Label 5793: @283288
     /* 283288 */ GIM_Reject,
     /* 283289 */ // Label 5782: @283289
     /* 283289 */ GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(283322), // Rule ID 2478 //
     /* 283294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283315 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 283315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 283320 */   GIR_RootConstrainSelectedInstOperands,
     /* 283321 */   // GIR_Coverage, 2478,
     /* 283321 */   GIR_Done,
     /* 283322 */ // Label 5794: @283322
     /* 283322 */ GIM_Reject,
     /* 283323 */ // Label 5783: @283323
     /* 283323 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(283348), // Rule ID 7421 //
     /* 283328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 283334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 283337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283341 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 283341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 283346 */   GIR_RootConstrainSelectedInstOperands,
     /* 283347 */   // GIR_Coverage, 7421,
     /* 283347 */   GIR_Done,
     /* 283348 */ // Label 5795: @283348
     /* 283348 */ GIM_Reject,
     /* 283349 */ // Label 5784: @283349
     /* 283349 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283374), // Rule ID 7420 //
     /* 283354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 283363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283367 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 283367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 283372 */   GIR_RootConstrainSelectedInstOperands,
     /* 283373 */   // GIR_Coverage, 7420,
     /* 283373 */   GIR_Done,
     /* 283374 */ // Label 5796: @283374
     /* 283374 */ GIM_Reject,
     /* 283375 */ // Label 5785: @283375
     /* 283375 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(283400), // Rule ID 7419 //
     /* 283380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283393 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 283398 */   GIR_RootConstrainSelectedInstOperands,
     /* 283399 */   // GIR_Coverage, 7419,
     /* 283399 */   GIR_Done,
     /* 283400 */ // Label 5797: @283400
     /* 283400 */ GIM_Reject,
     /* 283401 */ // Label 5786: @283401
     /* 283401 */ GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(283426), // Rule ID 7418 //
     /* 283406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283419 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 283424 */   GIR_RootConstrainSelectedInstOperands,
     /* 283425 */   // GIR_Coverage, 7418,
     /* 283425 */   GIR_Done,
     /* 283426 */ // Label 5798: @283426
     /* 283426 */ GIM_Reject,
     /* 283427 */ // Label 5787: @283427
     /* 283427 */ GIM_Reject,
     /* 283428 */ // Label 55: @283428
     /* 283428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5810*/ GIMT_Encode4(283857),
     /* 283439 */ /*GILLT_v2s32*//*Label 5799*/ GIMT_Encode4(283515),
     /* 283443 */ /*GILLT_v2s64*//*Label 5800*/ GIMT_Encode4(283549),
     /* 283447 */ /*GILLT_v4s16*//*Label 5801*/ GIMT_Encode4(283583),
     /* 283451 */ /*GILLT_v4s32*//*Label 5802*/ GIMT_Encode4(283617),
     /* 283455 */ /*GILLT_v8s8*//*Label 5803*/ GIMT_Encode4(283651),
     /* 283459 */ /*GILLT_v8s16*//*Label 5804*/ GIMT_Encode4(283685),
     /* 283463 */ /*GILLT_v16s8*//*Label 5805*/ GIMT_Encode4(283719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283483 */ /*GILLT_nxv2s64*//*Label 5806*/ GIMT_Encode4(283753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283495 */ /*GILLT_nxv4s32*//*Label 5807*/ GIMT_Encode4(283779), GIMT_Encode4(0),
     /* 283503 */ /*GILLT_nxv8s16*//*Label 5808*/ GIMT_Encode4(283805), GIMT_Encode4(0),
     /* 283511 */ /*GILLT_nxv16s8*//*Label 5809*/ GIMT_Encode4(283831),
     /* 283515 */ // Label 5799: @283515
     /* 283515 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(283548), // Rule ID 5037 //
     /* 283520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283541 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 283541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 283546 */   GIR_RootConstrainSelectedInstOperands,
     /* 283547 */   // GIR_Coverage, 5037,
     /* 283547 */   GIR_Done,
     /* 283548 */ // Label 5811: @283548
     /* 283548 */ GIM_Reject,
     /* 283549 */ // Label 5800: @283549
     /* 283549 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(283582), // Rule ID 5041 //
     /* 283554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283575 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 283575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 283580 */   GIR_RootConstrainSelectedInstOperands,
     /* 283581 */   // GIR_Coverage, 5041,
     /* 283581 */   GIR_Done,
     /* 283582 */ // Label 5812: @283582
     /* 283582 */ GIM_Reject,
     /* 283583 */ // Label 5801: @283583
     /* 283583 */ GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(283616), // Rule ID 5036 //
     /* 283588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283609 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 283609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 283614 */   GIR_RootConstrainSelectedInstOperands,
     /* 283615 */   // GIR_Coverage, 5036,
     /* 283615 */   GIR_Done,
     /* 283616 */ // Label 5813: @283616
     /* 283616 */ GIM_Reject,
     /* 283617 */ // Label 5802: @283617
     /* 283617 */ GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(283650), // Rule ID 5040 //
     /* 283622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283643 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 283643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 283648 */   GIR_RootConstrainSelectedInstOperands,
     /* 283649 */   // GIR_Coverage, 5040,
     /* 283649 */   GIR_Done,
     /* 283650 */ // Label 5814: @283650
     /* 283650 */ GIM_Reject,
     /* 283651 */ // Label 5803: @283651
     /* 283651 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(283684), // Rule ID 5035 //
     /* 283656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283677 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 283677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 283682 */   GIR_RootConstrainSelectedInstOperands,
     /* 283683 */   // GIR_Coverage, 5035,
     /* 283683 */   GIR_Done,
     /* 283684 */ // Label 5815: @283684
     /* 283684 */ GIM_Reject,
     /* 283685 */ // Label 5804: @283685
     /* 283685 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(283718), // Rule ID 5039 //
     /* 283690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283711 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 283711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 283716 */   GIR_RootConstrainSelectedInstOperands,
     /* 283717 */   // GIR_Coverage, 5039,
     /* 283717 */   GIR_Done,
     /* 283718 */ // Label 5816: @283718
     /* 283718 */ GIM_Reject,
     /* 283719 */ // Label 5805: @283719
     /* 283719 */ GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(283752), // Rule ID 5038 //
     /* 283724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283745 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 283745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 283750 */   GIR_RootConstrainSelectedInstOperands,
     /* 283751 */   // GIR_Coverage, 5038,
     /* 283751 */   GIR_Done,
     /* 283752 */ // Label 5817: @283752
     /* 283752 */ GIM_Reject,
     /* 283753 */ // Label 5806: @283753
     /* 283753 */ GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(283778), // Rule ID 7433 //
     /* 283758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 283764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 283767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283771 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 283771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 283776 */   GIR_RootConstrainSelectedInstOperands,
     /* 283777 */   // GIR_Coverage, 7433,
     /* 283777 */   GIR_Done,
     /* 283778 */ // Label 5818: @283778
     /* 283778 */ GIM_Reject,
     /* 283779 */ // Label 5807: @283779
     /* 283779 */ GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(283804), // Rule ID 7432 //
     /* 283784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 283793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283797 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 283797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 283802 */   GIR_RootConstrainSelectedInstOperands,
     /* 283803 */   // GIR_Coverage, 7432,
     /* 283803 */   GIR_Done,
     /* 283804 */ // Label 5819: @283804
     /* 283804 */ GIM_Reject,
     /* 283805 */ // Label 5808: @283805
     /* 283805 */ GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(283830), // Rule ID 7431 //
     /* 283810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283823 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 283828 */   GIR_RootConstrainSelectedInstOperands,
     /* 283829 */   // GIR_Coverage, 7431,
     /* 283829 */   GIR_Done,
     /* 283830 */ // Label 5820: @283830
     /* 283830 */ GIM_Reject,
     /* 283831 */ // Label 5809: @283831
     /* 283831 */ GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(283856), // Rule ID 7430 //
     /* 283836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283849 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 283854 */   GIR_RootConstrainSelectedInstOperands,
     /* 283855 */   // GIR_Coverage, 7430,
     /* 283855 */   GIR_Done,
     /* 283856 */ // Label 5821: @283856
     /* 283856 */ GIM_Reject,
     /* 283857 */ // Label 5810: @283857
     /* 283857 */ GIM_Reject,
     /* 283858 */ // Label 56: @283858
     /* 283858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5833*/ GIMT_Encode4(284287),
     /* 283869 */ /*GILLT_v2s32*//*Label 5822*/ GIMT_Encode4(283945),
     /* 283873 */ /*GILLT_v2s64*//*Label 5823*/ GIMT_Encode4(283979),
     /* 283877 */ /*GILLT_v4s16*//*Label 5824*/ GIMT_Encode4(284013),
     /* 283881 */ /*GILLT_v4s32*//*Label 5825*/ GIMT_Encode4(284047),
     /* 283885 */ /*GILLT_v8s8*//*Label 5826*/ GIMT_Encode4(284081),
     /* 283889 */ /*GILLT_v8s16*//*Label 5827*/ GIMT_Encode4(284115),
     /* 283893 */ /*GILLT_v16s8*//*Label 5828*/ GIMT_Encode4(284149), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283913 */ /*GILLT_nxv2s64*//*Label 5829*/ GIMT_Encode4(284183), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283925 */ /*GILLT_nxv4s32*//*Label 5830*/ GIMT_Encode4(284209), GIMT_Encode4(0),
     /* 283933 */ /*GILLT_nxv8s16*//*Label 5831*/ GIMT_Encode4(284235), GIMT_Encode4(0),
     /* 283941 */ /*GILLT_nxv16s8*//*Label 5832*/ GIMT_Encode4(284261),
     /* 283945 */ // Label 5822: @283945
     /* 283945 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(283978), // Rule ID 5030 //
     /* 283950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283971 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 283971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 283976 */   GIR_RootConstrainSelectedInstOperands,
     /* 283977 */   // GIR_Coverage, 5030,
     /* 283977 */   GIR_Done,
     /* 283978 */ // Label 5834: @283978
     /* 283978 */ GIM_Reject,
     /* 283979 */ // Label 5823: @283979
     /* 283979 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(284012), // Rule ID 5034 //
     /* 283984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284005 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 284005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 284010 */   GIR_RootConstrainSelectedInstOperands,
     /* 284011 */   // GIR_Coverage, 5034,
     /* 284011 */   GIR_Done,
     /* 284012 */ // Label 5835: @284012
     /* 284012 */ GIM_Reject,
     /* 284013 */ // Label 5824: @284013
     /* 284013 */ GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(284046), // Rule ID 5029 //
     /* 284018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284039 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 284039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 284044 */   GIR_RootConstrainSelectedInstOperands,
     /* 284045 */   // GIR_Coverage, 5029,
     /* 284045 */   GIR_Done,
     /* 284046 */ // Label 5836: @284046
     /* 284046 */ GIM_Reject,
     /* 284047 */ // Label 5825: @284047
     /* 284047 */ GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(284080), // Rule ID 5033 //
     /* 284052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284073 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 284073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 284078 */   GIR_RootConstrainSelectedInstOperands,
     /* 284079 */   // GIR_Coverage, 5033,
     /* 284079 */   GIR_Done,
     /* 284080 */ // Label 5837: @284080
     /* 284080 */ GIM_Reject,
     /* 284081 */ // Label 5826: @284081
     /* 284081 */ GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(284114), // Rule ID 5028 //
     /* 284086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 284092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284107 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 284107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 284112 */   GIR_RootConstrainSelectedInstOperands,
     /* 284113 */   // GIR_Coverage, 5028,
     /* 284113 */   GIR_Done,
     /* 284114 */ // Label 5838: @284114
     /* 284114 */ GIM_Reject,
     /* 284115 */ // Label 5827: @284115
     /* 284115 */ GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(284148), // Rule ID 5032 //
     /* 284120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284141 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 284141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 284146 */   GIR_RootConstrainSelectedInstOperands,
     /* 284147 */   // GIR_Coverage, 5032,
     /* 284147 */   GIR_Done,
     /* 284148 */ // Label 5839: @284148
     /* 284148 */ GIM_Reject,
     /* 284149 */ // Label 5828: @284149
     /* 284149 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(284182), // Rule ID 5031 //
     /* 284154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284175 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 284175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 284180 */   GIR_RootConstrainSelectedInstOperands,
     /* 284181 */   // GIR_Coverage, 5031,
     /* 284181 */   GIR_Done,
     /* 284182 */ // Label 5840: @284182
     /* 284182 */ GIM_Reject,
     /* 284183 */ // Label 5829: @284183
     /* 284183 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(284208), // Rule ID 7429 //
     /* 284188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284201 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 284201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 284206 */   GIR_RootConstrainSelectedInstOperands,
     /* 284207 */   // GIR_Coverage, 7429,
     /* 284207 */   GIR_Done,
     /* 284208 */ // Label 5841: @284208
     /* 284208 */ GIM_Reject,
     /* 284209 */ // Label 5830: @284209
     /* 284209 */ GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(284234), // Rule ID 7428 //
     /* 284214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284227 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 284227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 284232 */   GIR_RootConstrainSelectedInstOperands,
     /* 284233 */   // GIR_Coverage, 7428,
     /* 284233 */   GIR_Done,
     /* 284234 */ // Label 5842: @284234
     /* 284234 */ GIM_Reject,
     /* 284235 */ // Label 5831: @284235
     /* 284235 */ GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(284260), // Rule ID 7427 //
     /* 284240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284253 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 284253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 284258 */   GIR_RootConstrainSelectedInstOperands,
     /* 284259 */   // GIR_Coverage, 7427,
     /* 284259 */   GIR_Done,
     /* 284260 */ // Label 5843: @284260
     /* 284260 */ GIM_Reject,
     /* 284261 */ // Label 5832: @284261
     /* 284261 */ GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(284286), // Rule ID 7426 //
     /* 284266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 284275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284279 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 284279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 284284 */   GIR_RootConstrainSelectedInstOperands,
     /* 284285 */   // GIR_Coverage, 7426,
     /* 284285 */   GIR_Done,
     /* 284286 */ // Label 5844: @284286
     /* 284286 */ GIM_Reject,
     /* 284287 */ // Label 5833: @284287
     /* 284287 */ GIM_Reject,
     /* 284288 */ // Label 57: @284288
     /* 284288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5856*/ GIMT_Encode4(286085),
     /* 284299 */ /*GILLT_s16*//*Label 5845*/ GIMT_Encode4(284383),
     /* 284303 */ /*GILLT_s32*//*Label 5846*/ GIMT_Encode4(284609),
     /* 284307 */ /*GILLT_s64*//*Label 5847*/ GIMT_Encode4(284963), GIMT_Encode4(0),
     /* 284315 */ /*GILLT_v2s32*//*Label 5848*/ GIMT_Encode4(285135),
     /* 284319 */ /*GILLT_v2s64*//*Label 5849*/ GIMT_Encode4(285173),
     /* 284323 */ /*GILLT_v4s16*//*Label 5850*/ GIMT_Encode4(285349),
     /* 284327 */ /*GILLT_v4s32*//*Label 5851*/ GIMT_Encode4(285387), GIMT_Encode4(0),
     /* 284335 */ /*GILLT_v8s16*//*Label 5852*/ GIMT_Encode4(285563), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284359 */ /*GILLT_nxv2s64*//*Label 5853*/ GIMT_Encode4(286007), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284371 */ /*GILLT_nxv4s32*//*Label 5854*/ GIMT_Encode4(286033), GIMT_Encode4(0),
     /* 284379 */ /*GILLT_nxv8s16*//*Label 5855*/ GIMT_Encode4(286059),
     /* 284383 */ // Label 5845: @284383
     /* 284383 */ GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(284608),
     /* 284388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 284394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284398 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(284489), // Rule ID 6911 //
     /* 284403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284440 */     // MIs[2] Rn
     /* 284440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284451 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 284451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 284482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284487 */     GIR_RootConstrainSelectedInstOperands,
     /* 284488 */     // GIR_Coverage, 6911,
     /* 284488 */     GIR_EraseRootFromParent_Done,
     /* 284489 */   // Label 5858: @284489
     /* 284489 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(284580), // Rule ID 13916 //
     /* 284494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284531 */     // MIs[2] Rn
     /* 284531 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284536 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284542 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 284542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 284573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284578 */     GIR_RootConstrainSelectedInstOperands,
     /* 284579 */     // GIR_Coverage, 13916,
     /* 284579 */     GIR_EraseRootFromParent_Done,
     /* 284580 */   // Label 5859: @284580
     /* 284580 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(284607), // Rule ID 584 //
     /* 284585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284596 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 284596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 284601 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284605 */     GIR_RootConstrainSelectedInstOperands,
     /* 284606 */     // GIR_Coverage, 584,
     /* 284606 */     GIR_Done,
     /* 284607 */   // Label 5860: @284607
     /* 284607 */   GIM_Reject,
     /* 284608 */ // Label 5857: @284608
     /* 284608 */ GIM_Reject,
     /* 284609 */ // Label 5846: @284609
     /* 284609 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(284962),
     /* 284614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284624 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(284715), // Rule ID 6909 //
     /* 284629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284666 */     // MIs[2] Rn
     /* 284666 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284677 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 284677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284713 */     GIR_RootConstrainSelectedInstOperands,
     /* 284714 */     // GIR_Coverage, 6909,
     /* 284714 */     GIR_EraseRootFromParent_Done,
     /* 284715 */   // Label 5862: @284715
     /* 284715 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284779), // Rule ID 13098 //
     /* 284720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284757 */     // MIs[2] Rn
     /* 284757 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284762 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284768 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 284768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284777 */     GIR_RootConstrainSelectedInstOperands,
     /* 284778 */     // GIR_Coverage, 13098,
     /* 284778 */     GIR_EraseRootFromParent_Done,
     /* 284779 */   // Label 5863: @284779
     /* 284779 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284870), // Rule ID 13914 //
     /* 284784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284821 */     // MIs[2] Rn
     /* 284821 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284832 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 284832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284844 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284868 */     GIR_RootConstrainSelectedInstOperands,
     /* 284869 */     // GIR_Coverage, 13914,
     /* 284869 */     GIR_EraseRootFromParent_Done,
     /* 284870 */   // Label 5864: @284870
     /* 284870 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284934), // Rule ID 15601 //
     /* 284875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284912 */     // MIs[2] Rn
     /* 284912 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284923 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 284923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284932 */     GIR_RootConstrainSelectedInstOperands,
     /* 284933 */     // GIR_Coverage, 15601,
     /* 284933 */     GIR_EraseRootFromParent_Done,
     /* 284934 */   // Label 5865: @284934
     /* 284934 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284961), // Rule ID 586 //
     /* 284939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284950 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 284950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 284955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284959 */     GIR_RootConstrainSelectedInstOperands,
     /* 284960 */     // GIR_Coverage, 586,
     /* 284960 */     GIR_Done,
     /* 284961 */   // Label 5866: @284961
     /* 284961 */   GIM_Reject,
     /* 284962 */ // Label 5861: @284962
     /* 284962 */ GIM_Reject,
     /* 284963 */ // Label 5847: @284963
     /* 284963 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(285134),
     /* 284968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284978 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(285042), // Rule ID 6907 //
     /* 284983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285004 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285020 */     // MIs[2] Rn
     /* 285020 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285025 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 285029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285031 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 285031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 285034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285040 */     GIR_RootConstrainSelectedInstOperands,
     /* 285041 */     // GIR_Coverage, 6907,
     /* 285041 */     GIR_EraseRootFromParent_Done,
     /* 285042 */   // Label 5868: @285042
     /* 285042 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(285106), // Rule ID 13912 //
     /* 285047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 285072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285084 */     // MIs[2] Rn
     /* 285084 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285095 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 285095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 285098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285104 */     GIR_RootConstrainSelectedInstOperands,
     /* 285105 */     // GIR_Coverage, 13912,
     /* 285105 */     GIR_EraseRootFromParent_Done,
     /* 285106 */   // Label 5869: @285106
     /* 285106 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(285133), // Rule ID 588 //
     /* 285111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285122 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 285122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 285127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285131 */     GIR_RootConstrainSelectedInstOperands,
     /* 285132 */     // GIR_Coverage, 588,
     /* 285132 */     GIR_Done,
     /* 285133 */   // Label 5870: @285133
     /* 285133 */   GIM_Reject,
     /* 285134 */ // Label 5867: @285134
     /* 285134 */ GIM_Reject,
     /* 285135 */ // Label 5848: @285135
     /* 285135 */ GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(285172), // Rule ID 1203 //
     /* 285140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285161 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 285161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 285166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285170 */   GIR_RootConstrainSelectedInstOperands,
     /* 285171 */   // GIR_Coverage, 1203,
     /* 285171 */   GIR_Done,
     /* 285172 */ // Label 5871: @285172
     /* 285172 */ GIM_Reject,
     /* 285173 */ // Label 5849: @285173
     /* 285173 */ GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(285348),
     /* 285178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285188 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(285254), // Rule ID 6929 //
     /* 285193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 285201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 285227 */     // MIs[2] Rn
     /* 285227 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285232 */     // MIs[2] Rm
     /* 285232 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285239 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 285239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 285242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285252 */     GIR_RootConstrainSelectedInstOperands,
     /* 285253 */     // GIR_Coverage, 6929,
     /* 285253 */     GIR_EraseRootFromParent_Done,
     /* 285254 */   // Label 5873: @285254
     /* 285254 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(285320), // Rule ID 13924 //
     /* 285259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 285267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 285293 */     // MIs[2] Rn
     /* 285293 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285298 */     // MIs[2] Rm
     /* 285298 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285305 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 285305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 285308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285318 */     GIR_RootConstrainSelectedInstOperands,
     /* 285319 */     // GIR_Coverage, 13924,
     /* 285319 */     GIR_EraseRootFromParent_Done,
     /* 285320 */   // Label 5874: @285320
     /* 285320 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(285347), // Rule ID 1207 //
     /* 285325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285336 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 285336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 285341 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285345 */     GIR_RootConstrainSelectedInstOperands,
     /* 285346 */     // GIR_Coverage, 1207,
     /* 285346 */     GIR_Done,
     /* 285347 */   // Label 5875: @285347
     /* 285347 */   GIM_Reject,
     /* 285348 */ // Label 5872: @285348
     /* 285348 */ GIM_Reject,
     /* 285349 */ // Label 5850: @285349
     /* 285349 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(285386), // Rule ID 1199 //
     /* 285354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285375 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 285375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 285380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285384 */   GIR_RootConstrainSelectedInstOperands,
     /* 285385 */   // GIR_Coverage, 1199,
     /* 285385 */   GIR_Done,
     /* 285386 */ // Label 5876: @285386
     /* 285386 */ GIM_Reject,
     /* 285387 */ // Label 5851: @285387
     /* 285387 */ GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(285562),
     /* 285392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285402 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(285468), // Rule ID 6930 //
     /* 285407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 285415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 285441 */     // MIs[2] Rn
     /* 285441 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285446 */     // MIs[2] Rm
     /* 285446 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285453 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 285453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 285456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285466 */     GIR_RootConstrainSelectedInstOperands,
     /* 285467 */     // GIR_Coverage, 6930,
     /* 285467 */     GIR_EraseRootFromParent_Done,
     /* 285468 */   // Label 5878: @285468
     /* 285468 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(285534), // Rule ID 13925 //
     /* 285473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 285481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 285507 */     // MIs[2] Rn
     /* 285507 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285512 */     // MIs[2] Rm
     /* 285512 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285519 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 285519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 285522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285532 */     GIR_RootConstrainSelectedInstOperands,
     /* 285533 */     // GIR_Coverage, 13925,
     /* 285533 */     GIR_EraseRootFromParent_Done,
     /* 285534 */   // Label 5879: @285534
     /* 285534 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285561), // Rule ID 1205 //
     /* 285539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285550 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 285555 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285559 */     GIR_RootConstrainSelectedInstOperands,
     /* 285560 */     // GIR_Coverage, 1205,
     /* 285560 */     GIR_Done,
     /* 285561 */   // Label 5880: @285561
     /* 285561 */   GIM_Reject,
     /* 285562 */ // Label 5877: @285562
     /* 285562 */ GIM_Reject,
     /* 285563 */ // Label 5852: @285563
     /* 285563 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(286006),
     /* 285568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285578 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(285647), // Rule ID 6931 //
     /* 285583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 285594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 285620 */     // MIs[2] Rn
     /* 285620 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285625 */     // MIs[2] Rm
     /* 285625 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285632 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 285632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 285635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285645 */     GIR_RootConstrainSelectedInstOperands,
     /* 285646 */     // GIR_Coverage, 6931,
     /* 285646 */     GIR_EraseRootFromParent_Done,
     /* 285647 */   // Label 5882: @285647
     /* 285647 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(285716), // Rule ID 13926 //
     /* 285652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 285663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 285689 */     // MIs[2] Rn
     /* 285689 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 285694 */     // MIs[2] Rm
     /* 285694 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 285699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285701 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 285701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 285704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 285714 */     GIR_RootConstrainSelectedInstOperands,
     /* 285715 */     // GIR_Coverage, 13926,
     /* 285715 */     GIR_EraseRootFromParent_Done,
     /* 285716 */   // Label 5883: @285716
     /* 285716 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(285743), // Rule ID 1201 //
     /* 285721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285732 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 285737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285741 */     GIR_RootConstrainSelectedInstOperands,
     /* 285742 */     // GIR_Coverage, 1201,
     /* 285742 */     GIR_Done,
     /* 285743 */   // Label 5884: @285743
     /* 285743 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(286005), // Rule ID 7000 //
     /* 285748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285759 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285759 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285762 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285766 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285771 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285777 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285780 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285784 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285789 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285795 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285798 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 285802 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285807 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285810 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285815 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285818 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285822 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285827 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285833 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285838 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285843 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285846 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285850 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285855 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285860 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285863 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285867 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285872 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285878 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285883 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285888 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285891 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285895 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285900 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285905 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285908 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 285912 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285917 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285920 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285937 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285974 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 286003 */     GIR_RootConstrainSelectedInstOperands,
     /* 286004 */     // GIR_Coverage, 7000,
     /* 286004 */     GIR_EraseRootFromParent_Done,
     /* 286005 */   // Label 5885: @286005
     /* 286005 */   GIM_Reject,
     /* 286006 */ // Label 5881: @286006
     /* 286006 */ GIM_Reject,
     /* 286007 */ // Label 5853: @286007
     /* 286007 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(286032), // Rule ID 2824 //
     /* 286012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 286018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 286021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286025 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 286025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 286030 */   GIR_RootConstrainSelectedInstOperands,
     /* 286031 */   // GIR_Coverage, 2824,
     /* 286031 */   GIR_Done,
     /* 286032 */ // Label 5886: @286032
     /* 286032 */ GIM_Reject,
     /* 286033 */ // Label 5854: @286033
     /* 286033 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(286058), // Rule ID 2822 //
     /* 286038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 286044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 286047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286051 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 286051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 286056 */   GIR_RootConstrainSelectedInstOperands,
     /* 286057 */   // GIR_Coverage, 2822,
     /* 286057 */   GIR_Done,
     /* 286058 */ // Label 5887: @286058
     /* 286058 */ GIM_Reject,
     /* 286059 */ // Label 5855: @286059
     /* 286059 */ GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(286084), // Rule ID 2820 //
     /* 286064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 286070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 286073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286077 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 286077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 286082 */   GIR_RootConstrainSelectedInstOperands,
     /* 286083 */   // GIR_Coverage, 2820,
     /* 286083 */   GIR_Done,
     /* 286084 */ // Label 5888: @286084
     /* 286084 */ GIM_Reject,
     /* 286085 */ // Label 5856: @286085
     /* 286085 */ GIM_Reject,
     /* 286086 */ // Label 58: @286086
     /* 286086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5900*/ GIMT_Encode4(286823),
     /* 286097 */ /*GILLT_s16*//*Label 5889*/ GIMT_Encode4(286181),
     /* 286101 */ /*GILLT_s32*//*Label 5890*/ GIMT_Encode4(286219),
     /* 286105 */ /*GILLT_s64*//*Label 5891*/ GIMT_Encode4(286257), GIMT_Encode4(0),
     /* 286113 */ /*GILLT_v2s32*//*Label 5892*/ GIMT_Encode4(286295),
     /* 286117 */ /*GILLT_v2s64*//*Label 5893*/ GIMT_Encode4(286333),
     /* 286121 */ /*GILLT_v4s16*//*Label 5894*/ GIMT_Encode4(286371),
     /* 286125 */ /*GILLT_v4s32*//*Label 5895*/ GIMT_Encode4(286409), GIMT_Encode4(0),
     /* 286133 */ /*GILLT_v8s16*//*Label 5896*/ GIMT_Encode4(286447), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286157 */ /*GILLT_nxv2s64*//*Label 5897*/ GIMT_Encode4(286745), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286169 */ /*GILLT_nxv4s32*//*Label 5898*/ GIMT_Encode4(286771), GIMT_Encode4(0),
     /* 286177 */ /*GILLT_nxv8s16*//*Label 5899*/ GIMT_Encode4(286797),
     /* 286181 */ // Label 5889: @286181
     /* 286181 */ GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(286218), // Rule ID 632 //
     /* 286186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 286195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286207 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 286212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286216 */   GIR_RootConstrainSelectedInstOperands,
     /* 286217 */   // GIR_Coverage, 632,
     /* 286217 */   GIR_Done,
     /* 286218 */ // Label 5901: @286218
     /* 286218 */ GIM_Reject,
     /* 286219 */ // Label 5890: @286219
     /* 286219 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(286256), // Rule ID 634 //
     /* 286224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286245 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 286245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 286250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286254 */   GIR_RootConstrainSelectedInstOperands,
     /* 286255 */   // GIR_Coverage, 634,
     /* 286255 */   GIR_Done,
     /* 286256 */ // Label 5902: @286256
     /* 286256 */ GIM_Reject,
     /* 286257 */ // Label 5891: @286257
     /* 286257 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(286294), // Rule ID 636 //
     /* 286262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286283 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 286283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 286288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286292 */   GIR_RootConstrainSelectedInstOperands,
     /* 286293 */   // GIR_Coverage, 636,
     /* 286293 */   GIR_Done,
     /* 286294 */ // Label 5903: @286294
     /* 286294 */ GIM_Reject,
     /* 286295 */ // Label 5892: @286295
     /* 286295 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(286332), // Rule ID 1343 //
     /* 286300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 286309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286321 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 286321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 286326 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286330 */   GIR_RootConstrainSelectedInstOperands,
     /* 286331 */   // GIR_Coverage, 1343,
     /* 286331 */   GIR_Done,
     /* 286332 */ // Label 5904: @286332
     /* 286332 */ GIM_Reject,
     /* 286333 */ // Label 5893: @286333
     /* 286333 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(286370), // Rule ID 1347 //
     /* 286338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 286347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286359 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 286359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 286364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286368 */   GIR_RootConstrainSelectedInstOperands,
     /* 286369 */   // GIR_Coverage, 1347,
     /* 286369 */   GIR_Done,
     /* 286370 */ // Label 5905: @286370
     /* 286370 */ GIM_Reject,
     /* 286371 */ // Label 5894: @286371
     /* 286371 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(286408), // Rule ID 1339 //
     /* 286376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286397 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 286397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 286402 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286406 */   GIR_RootConstrainSelectedInstOperands,
     /* 286407 */   // GIR_Coverage, 1339,
     /* 286407 */   GIR_Done,
     /* 286408 */ // Label 5906: @286408
     /* 286408 */ GIM_Reject,
     /* 286409 */ // Label 5895: @286409
     /* 286409 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(286446), // Rule ID 1345 //
     /* 286414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286435 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 286435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 286440 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286444 */   GIR_RootConstrainSelectedInstOperands,
     /* 286445 */   // GIR_Coverage, 1345,
     /* 286445 */   GIR_Done,
     /* 286446 */ // Label 5907: @286446
     /* 286446 */ GIM_Reject,
     /* 286447 */ // Label 5896: @286447
     /* 286447 */ GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(286744),
     /* 286452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286470 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(286489), // Rule ID 1341 //
     /* 286475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286478 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 286478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 286483 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286487 */     GIR_RootConstrainSelectedInstOperands,
     /* 286488 */     // GIR_Coverage, 1341,
     /* 286488 */     GIR_Done,
     /* 286489 */   // Label 5909: @286489
     /* 286489 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(286743), // Rule ID 7006 //
     /* 286494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 286497 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 286497 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 286500 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 286504 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286509 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 286513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 286515 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 286518 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 286522 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286527 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 286531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 286533 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 286536 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 286540 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286545 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 286548 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 286551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 286553 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 286556 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286560 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286565 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286571 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286576 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286581 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 286584 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 286588 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286593 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 286596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 286598 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 286601 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286605 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286610 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286616 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286621 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286626 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 286629 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 286633 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286638 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 286641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 286643 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 286646 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 286650 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286655 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 286658 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 286661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 286666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 286670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286675 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 286678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286680 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 286683 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286687 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 286694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 286697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 286709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 286712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 286715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 286733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 286741 */     GIR_RootConstrainSelectedInstOperands,
     /* 286742 */     // GIR_Coverage, 7006,
     /* 286742 */     GIR_EraseRootFromParent_Done,
     /* 286743 */   // Label 5910: @286743
     /* 286743 */   GIM_Reject,
     /* 286744 */ // Label 5908: @286744
     /* 286744 */ GIM_Reject,
     /* 286745 */ // Label 5897: @286745
     /* 286745 */ GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(286770), // Rule ID 8176 //
     /* 286750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 286756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 286759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286763 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 286763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 286768 */   GIR_RootConstrainSelectedInstOperands,
     /* 286769 */   // GIR_Coverage, 8176,
     /* 286769 */   GIR_Done,
     /* 286770 */ // Label 5911: @286770
     /* 286770 */ GIM_Reject,
     /* 286771 */ // Label 5898: @286771
     /* 286771 */ GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(286796), // Rule ID 8174 //
     /* 286776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 286782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 286785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286789 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 286789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 286794 */   GIR_RootConstrainSelectedInstOperands,
     /* 286795 */   // GIR_Coverage, 8174,
     /* 286795 */   GIR_Done,
     /* 286796 */ // Label 5912: @286796
     /* 286796 */ GIM_Reject,
     /* 286797 */ // Label 5899: @286797
     /* 286797 */ GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(286822), // Rule ID 8172 //
     /* 286802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 286808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 286811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286815 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 286815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 286820 */   GIR_RootConstrainSelectedInstOperands,
     /* 286821 */   // GIR_Coverage, 8172,
     /* 286821 */   GIR_Done,
     /* 286822 */ // Label 5913: @286822
     /* 286822 */ GIM_Reject,
     /* 286823 */ // Label 5900: @286823
     /* 286823 */ GIM_Reject,
     /* 286824 */ // Label 59: @286824
     /* 286824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5925*/ GIMT_Encode4(290919),
     /* 286835 */ /*GILLT_s16*//*Label 5914*/ GIMT_Encode4(286919),
     /* 286839 */ /*GILLT_s32*//*Label 5915*/ GIMT_Encode4(287561),
     /* 286843 */ /*GILLT_s64*//*Label 5916*/ GIMT_Encode4(288191), GIMT_Encode4(0),
     /* 286851 */ /*GILLT_v2s32*//*Label 5917*/ GIMT_Encode4(288821),
     /* 286855 */ /*GILLT_v2s64*//*Label 5918*/ GIMT_Encode4(289351),
     /* 286859 */ /*GILLT_v4s16*//*Label 5919*/ GIMT_Encode4(289709),
     /* 286863 */ /*GILLT_v4s32*//*Label 5920*/ GIMT_Encode4(290051), GIMT_Encode4(0),
     /* 286871 */ /*GILLT_v8s16*//*Label 5921*/ GIMT_Encode4(290409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286895 */ /*GILLT_nxv2s64*//*Label 5922*/ GIMT_Encode4(290841), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286907 */ /*GILLT_nxv4s32*//*Label 5923*/ GIMT_Encode4(290867), GIMT_Encode4(0),
     /* 286915 */ /*GILLT_nxv8s16*//*Label 5924*/ GIMT_Encode4(290893),
     /* 286919 */ // Label 5914: @286919
     /* 286919 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(287560),
     /* 286924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 286930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286934 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(287047), // Rule ID 6241 //
     /* 286939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286963 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286996 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287000 */     // MIs[3] Operand 1
     /* 287000 */     // No operand predicates
     /* 287000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287002 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287014 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 287033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287045 */     GIR_RootConstrainSelectedInstOperands,
     /* 287046 */     // GIR_Coverage, 6241,
     /* 287046 */     GIR_EraseRootFromParent_Done,
     /* 287047 */   // Label 5927: @287047
     /* 287047 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(287160), // Rule ID 13893 //
     /* 287052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287088 */     // MIs[2] Operand 1
     /* 287088 */     // No operand predicates
     /* 287088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287100 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287109 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287115 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287127 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 287146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287158 */     GIR_RootConstrainSelectedInstOperands,
     /* 287159 */     // GIR_Coverage, 13893,
     /* 287159 */     GIR_EraseRootFromParent_Done,
     /* 287160 */   // Label 5928: @287160
     /* 287160 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(287239), // Rule ID 13827 //
     /* 287165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287189 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287199 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 287199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287211 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 287217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 287230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287237 */     GIR_RootConstrainSelectedInstOperands,
     /* 287238 */     // GIR_Coverage, 13827,
     /* 287238 */     GIR_EraseRootFromParent_Done,
     /* 287239 */   // Label 5929: @287239
     /* 287239 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(287318), // Rule ID 4803 //
     /* 287244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287278 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 287278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287290 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 287296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 287309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287316 */     GIR_RootConstrainSelectedInstOperands,
     /* 287317 */     // GIR_Coverage, 4803,
     /* 287317 */     GIR_EraseRootFromParent_Done,
     /* 287318 */   // Label 5930: @287318
     /* 287318 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(287381), // Rule ID 13442 //
     /* 287323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287355 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287359 */     // MIs[2] Operand 1
     /* 287359 */     // No operand predicates
     /* 287359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287365 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 287368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287379 */     GIR_RootConstrainSelectedInstOperands,
     /* 287380 */     // GIR_Coverage, 13442,
     /* 287380 */     GIR_EraseRootFromParent_Done,
     /* 287381 */   // Label 5931: @287381
     /* 287381 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(287444), // Rule ID 2012 //
     /* 287386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287426 */     // MIs[2] Operand 1
     /* 287426 */     // No operand predicates
     /* 287426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287428 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 287431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287442 */     GIR_RootConstrainSelectedInstOperands,
     /* 287443 */     // GIR_Coverage, 2012,
     /* 287443 */     GIR_EraseRootFromParent_Done,
     /* 287444 */   // Label 5932: @287444
     /* 287444 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(287488), // Rule ID 4808 //
     /* 287449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287475 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 287475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 287478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287484 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287486 */     GIR_RootConstrainSelectedInstOperands,
     /* 287487 */     // GIR_Coverage, 4808,
     /* 287487 */     GIR_EraseRootFromParent_Done,
     /* 287488 */   // Label 5933: @287488
     /* 287488 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(287532), // Rule ID 13832 //
     /* 287493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287519 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 287519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 287522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287528 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287530 */     GIR_RootConstrainSelectedInstOperands,
     /* 287531 */     // GIR_Coverage, 13832,
     /* 287531 */     GIR_EraseRootFromParent_Done,
     /* 287532 */   // Label 5934: @287532
     /* 287532 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(287559), // Rule ID 620 //
     /* 287537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287548 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 287548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 287553 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287557 */     GIR_RootConstrainSelectedInstOperands,
     /* 287558 */     // GIR_Coverage, 620,
     /* 287558 */     GIR_Done,
     /* 287559 */   // Label 5935: @287559
     /* 287559 */   GIM_Reject,
     /* 287560 */ // Label 5926: @287560
     /* 287560 */ GIM_Reject,
     /* 287561 */ // Label 5915: @287561
     /* 287561 */ GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(288190),
     /* 287566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287576 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(287689), // Rule ID 6243 //
     /* 287581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287642 */     // MIs[3] Operand 1
     /* 287642 */     // No operand predicates
     /* 287642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287644 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 287662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287687 */     GIR_RootConstrainSelectedInstOperands,
     /* 287688 */     // GIR_Coverage, 6243,
     /* 287688 */     GIR_EraseRootFromParent_Done,
     /* 287689 */   // Label 5937: @287689
     /* 287689 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(287802), // Rule ID 13895 //
     /* 287694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287730 */     // MIs[2] Operand 1
     /* 287730 */     // No operand predicates
     /* 287730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287742 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287746 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287751 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287757 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 287775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287800 */     GIR_RootConstrainSelectedInstOperands,
     /* 287801 */     // GIR_Coverage, 13895,
     /* 287801 */     GIR_EraseRootFromParent_Done,
     /* 287802 */   // Label 5938: @287802
     /* 287802 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(287878), // Rule ID 13829 //
     /* 287807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287838 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 287838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287850 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 287856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287876 */     GIR_RootConstrainSelectedInstOperands,
     /* 287877 */     // GIR_Coverage, 13829,
     /* 287877 */     GIR_EraseRootFromParent_Done,
     /* 287878 */   // Label 5939: @287878
     /* 287878 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(287954), // Rule ID 4805 //
     /* 287883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287908 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287914 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 287914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287926 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 287932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287952 */     GIR_RootConstrainSelectedInstOperands,
     /* 287953 */     // GIR_Coverage, 4805,
     /* 287953 */     GIR_EraseRootFromParent_Done,
     /* 287954 */   // Label 5940: @287954
     /* 287954 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(288017), // Rule ID 13444 //
     /* 287959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287995 */     // MIs[2] Operand 1
     /* 287995 */     // No operand predicates
     /* 287995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288001 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 288004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288015 */     GIR_RootConstrainSelectedInstOperands,
     /* 288016 */     // GIR_Coverage, 13444,
     /* 288016 */     GIR_EraseRootFromParent_Done,
     /* 288017 */   // Label 5941: @288017
     /* 288017 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(288080), // Rule ID 2014 //
     /* 288022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288062 */     // MIs[2] Operand 1
     /* 288062 */     // No operand predicates
     /* 288062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288064 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 288067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288078 */     GIR_RootConstrainSelectedInstOperands,
     /* 288079 */     // GIR_Coverage, 2014,
     /* 288079 */     GIR_EraseRootFromParent_Done,
     /* 288080 */   // Label 5942: @288080
     /* 288080 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(288121), // Rule ID 4809 //
     /* 288085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288108 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 288108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 288111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288117 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 288119 */     GIR_RootConstrainSelectedInstOperands,
     /* 288120 */     // GIR_Coverage, 4809,
     /* 288120 */     GIR_EraseRootFromParent_Done,
     /* 288121 */   // Label 5943: @288121
     /* 288121 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(288162), // Rule ID 13833 //
     /* 288126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288149 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 288149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 288152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288158 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 288160 */     GIR_RootConstrainSelectedInstOperands,
     /* 288161 */     // GIR_Coverage, 13833,
     /* 288161 */     GIR_EraseRootFromParent_Done,
     /* 288162 */   // Label 5944: @288162
     /* 288162 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(288189), // Rule ID 622 //
     /* 288167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288178 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 288178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 288183 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288187 */     GIR_RootConstrainSelectedInstOperands,
     /* 288188 */     // GIR_Coverage, 622,
     /* 288188 */     GIR_Done,
     /* 288189 */   // Label 5945: @288189
     /* 288189 */   GIM_Reject,
     /* 288190 */ // Label 5936: @288190
     /* 288190 */ GIM_Reject,
     /* 288191 */ // Label 5916: @288191
     /* 288191 */ GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(288820),
     /* 288196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288206 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(288319), // Rule ID 6245 //
     /* 288211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288268 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288272 */     // MIs[3] Operand 1
     /* 288272 */     // No operand predicates
     /* 288272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288274 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 288305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288317 */     GIR_RootConstrainSelectedInstOperands,
     /* 288318 */     // GIR_Coverage, 6245,
     /* 288318 */     GIR_EraseRootFromParent_Done,
     /* 288319 */   // Label 5947: @288319
     /* 288319 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(288432), // Rule ID 13897 //
     /* 288324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288360 */     // MIs[2] Operand 1
     /* 288360 */     // No operand predicates
     /* 288360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 288376 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288381 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 288385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288387 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 288387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 288405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 288418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288430 */     GIR_RootConstrainSelectedInstOperands,
     /* 288431 */     // GIR_Coverage, 13897,
     /* 288431 */     GIR_EraseRootFromParent_Done,
     /* 288432 */   // Label 5948: @288432
     /* 288432 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(288508), // Rule ID 13831 //
     /* 288437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288458 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288468 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 288468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288480 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 288499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288506 */     GIR_RootConstrainSelectedInstOperands,
     /* 288507 */     // GIR_Coverage, 13831,
     /* 288507 */     GIR_EraseRootFromParent_Done,
     /* 288508 */   // Label 5949: @288508
     /* 288508 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(288584), // Rule ID 4807 //
     /* 288513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288544 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 288544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 288562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 288575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288582 */     GIR_RootConstrainSelectedInstOperands,
     /* 288583 */     // GIR_Coverage, 4807,
     /* 288583 */     GIR_EraseRootFromParent_Done,
     /* 288584 */   // Label 5950: @288584
     /* 288584 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(288647), // Rule ID 13446 //
     /* 288589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288625 */     // MIs[2] Operand 1
     /* 288625 */     // No operand predicates
     /* 288625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288631 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 288634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288645 */     GIR_RootConstrainSelectedInstOperands,
     /* 288646 */     // GIR_Coverage, 13446,
     /* 288646 */     GIR_EraseRootFromParent_Done,
     /* 288647 */   // Label 5951: @288647
     /* 288647 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(288710), // Rule ID 2016 //
     /* 288652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288688 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288692 */     // MIs[2] Operand 1
     /* 288692 */     // No operand predicates
     /* 288692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288694 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 288697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288708 */     GIR_RootConstrainSelectedInstOperands,
     /* 288709 */     // GIR_Coverage, 2016,
     /* 288709 */     GIR_EraseRootFromParent_Done,
     /* 288710 */   // Label 5952: @288710
     /* 288710 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(288751), // Rule ID 4810 //
     /* 288715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288738 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 288738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 288741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288747 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 288749 */     GIR_RootConstrainSelectedInstOperands,
     /* 288750 */     // GIR_Coverage, 4810,
     /* 288750 */     GIR_EraseRootFromParent_Done,
     /* 288751 */   // Label 5953: @288751
     /* 288751 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288792), // Rule ID 13834 //
     /* 288756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288779 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 288779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 288782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288788 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 288790 */     GIR_RootConstrainSelectedInstOperands,
     /* 288791 */     // GIR_Coverage, 13834,
     /* 288791 */     GIR_EraseRootFromParent_Done,
     /* 288792 */   // Label 5954: @288792
     /* 288792 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288819), // Rule ID 624 //
     /* 288797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288808 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 288808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 288813 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288817 */     GIR_RootConstrainSelectedInstOperands,
     /* 288818 */     // GIR_Coverage, 624,
     /* 288818 */     GIR_Done,
     /* 288819 */   // Label 5955: @288819
     /* 288819 */   GIM_Reject,
     /* 288820 */ // Label 5946: @288820
     /* 288820 */ GIM_Reject,
     /* 288821 */ // Label 5917: @288821
     /* 288821 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(289350),
     /* 288826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288836 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288922), // Rule ID 13435 //
     /* 288841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288889 */     // MIs[3] Operand 1
     /* 288889 */     // No operand predicates
     /* 288889 */     // MIs[1] Operand 2
     /* 288889 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288906 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288920 */     GIR_RootConstrainSelectedInstOperands,
     /* 288921 */     // GIR_Coverage, 13435,
     /* 288921 */     GIR_EraseRootFromParent_Done,
     /* 288922 */   // Label 5957: @288922
     /* 288922 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(289008), // Rule ID 2005 //
     /* 288927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288979 */     // MIs[3] Operand 1
     /* 288979 */     // No operand predicates
     /* 288979 */     // MIs[1] Operand 2
     /* 288979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288992 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289006 */     GIR_RootConstrainSelectedInstOperands,
     /* 289007 */     // GIR_Coverage, 2005,
     /* 289007 */     GIR_EraseRootFromParent_Done,
     /* 289008 */   // Label 5958: @289008
     /* 289008 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(289071), // Rule ID 13436 //
     /* 289013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289049 */     // MIs[2] Operand 1
     /* 289049 */     // No operand predicates
     /* 289049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289055 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 289058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289069 */     GIR_RootConstrainSelectedInstOperands,
     /* 289070 */     // GIR_Coverage, 13436,
     /* 289070 */     GIR_EraseRootFromParent_Done,
     /* 289071 */   // Label 5959: @289071
     /* 289071 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(289134), // Rule ID 2006 //
     /* 289076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289116 */     // MIs[2] Operand 1
     /* 289116 */     // No operand predicates
     /* 289116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289118 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289132 */     GIR_RootConstrainSelectedInstOperands,
     /* 289133 */     // GIR_Coverage, 2006,
     /* 289133 */     GIR_EraseRootFromParent_Done,
     /* 289134 */   // Label 5960: @289134
     /* 289134 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(289228), // Rule ID 13899 //
     /* 289139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289162 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 289216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289226 */     GIR_RootConstrainSelectedInstOperands,
     /* 289227 */     // GIR_Coverage, 13899,
     /* 289227 */     GIR_EraseRootFromParent_Done,
     /* 289228 */   // Label 5961: @289228
     /* 289228 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(289322), // Rule ID 6247 //
     /* 289233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289256 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289282 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 289310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289320 */     GIR_RootConstrainSelectedInstOperands,
     /* 289321 */     // GIR_Coverage, 6247,
     /* 289321 */     GIR_EraseRootFromParent_Done,
     /* 289322 */   // Label 5962: @289322
     /* 289322 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(289349), // Rule ID 1323 //
     /* 289327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289338 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 289343 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289347 */     GIR_RootConstrainSelectedInstOperands,
     /* 289348 */     // GIR_Coverage, 1323,
     /* 289348 */     GIR_Done,
     /* 289349 */   // Label 5963: @289349
     /* 289349 */   GIM_Reject,
     /* 289350 */ // Label 5956: @289350
     /* 289350 */ GIM_Reject,
     /* 289351 */ // Label 5918: @289351
     /* 289351 */ GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(289708),
     /* 289356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 289362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289366 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(289429), // Rule ID 13440 //
     /* 289371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289407 */     // MIs[2] Operand 1
     /* 289407 */     // No operand predicates
     /* 289407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289413 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 289416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289427 */     GIR_RootConstrainSelectedInstOperands,
     /* 289428 */     // GIR_Coverage, 13440,
     /* 289428 */     GIR_EraseRootFromParent_Done,
     /* 289429 */   // Label 5965: @289429
     /* 289429 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(289492), // Rule ID 2010 //
     /* 289434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289474 */     // MIs[2] Operand 1
     /* 289474 */     // No operand predicates
     /* 289474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289476 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 289479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289490 */     GIR_RootConstrainSelectedInstOperands,
     /* 289491 */     // GIR_Coverage, 2010,
     /* 289491 */     GIR_EraseRootFromParent_Done,
     /* 289492 */   // Label 5966: @289492
     /* 289492 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(289586), // Rule ID 13903 //
     /* 289497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289520 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 289556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 289574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289584 */     GIR_RootConstrainSelectedInstOperands,
     /* 289585 */     // GIR_Coverage, 13903,
     /* 289585 */     GIR_EraseRootFromParent_Done,
     /* 289586 */   // Label 5967: @289586
     /* 289586 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(289680), // Rule ID 6251 //
     /* 289591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289614 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 289650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 289668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289678 */     GIR_RootConstrainSelectedInstOperands,
     /* 289679 */     // GIR_Coverage, 6251,
     /* 289679 */     GIR_EraseRootFromParent_Done,
     /* 289680 */   // Label 5968: @289680
     /* 289680 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(289707), // Rule ID 1327 //
     /* 289685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289696 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 289696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 289701 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289705 */     GIR_RootConstrainSelectedInstOperands,
     /* 289706 */     // GIR_Coverage, 1327,
     /* 289706 */     GIR_Done,
     /* 289707 */   // Label 5969: @289707
     /* 289707 */   GIM_Reject,
     /* 289708 */ // Label 5964: @289708
     /* 289708 */ GIM_Reject,
     /* 289709 */ // Label 5919: @289709
     /* 289709 */ GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(290050),
     /* 289714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 289717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 289720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289724 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(289810), // Rule ID 13429 //
     /* 289729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 289740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289777 */     // MIs[3] Operand 1
     /* 289777 */     // No operand predicates
     /* 289777 */     // MIs[1] Operand 2
     /* 289777 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 289788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289794 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289808 */     GIR_RootConstrainSelectedInstOperands,
     /* 289809 */     // GIR_Coverage, 13429,
     /* 289809 */     GIR_EraseRootFromParent_Done,
     /* 289810 */   // Label 5971: @289810
     /* 289810 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289896), // Rule ID 1999 //
     /* 289815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 289830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289867 */     // MIs[3] Operand 1
     /* 289867 */     // No operand predicates
     /* 289867 */     // MIs[1] Operand 2
     /* 289867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 289878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289880 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289894 */     GIR_RootConstrainSelectedInstOperands,
     /* 289895 */     // GIR_Coverage, 1999,
     /* 289895 */     GIR_EraseRootFromParent_Done,
     /* 289896 */   // Label 5972: @289896
     /* 289896 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(289959), // Rule ID 13430 //
     /* 289901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289937 */     // MIs[2] Operand 1
     /* 289937 */     // No operand predicates
     /* 289937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289943 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289957 */     GIR_RootConstrainSelectedInstOperands,
     /* 289958 */     // GIR_Coverage, 13430,
     /* 289958 */     GIR_EraseRootFromParent_Done,
     /* 289959 */   // Label 5973: @289959
     /* 289959 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(290022), // Rule ID 2000 //
     /* 289964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290004 */     // MIs[2] Operand 1
     /* 290004 */     // No operand predicates
     /* 290004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290006 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 290009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290020 */     GIR_RootConstrainSelectedInstOperands,
     /* 290021 */     // GIR_Coverage, 2000,
     /* 290021 */     GIR_EraseRootFromParent_Done,
     /* 290022 */   // Label 5974: @290022
     /* 290022 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(290049), // Rule ID 1319 //
     /* 290027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290038 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 290038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 290043 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290047 */     GIR_RootConstrainSelectedInstOperands,
     /* 290048 */     // GIR_Coverage, 1319,
     /* 290048 */     GIR_Done,
     /* 290049 */   // Label 5975: @290049
     /* 290049 */   GIM_Reject,
     /* 290050 */ // Label 5970: @290050
     /* 290050 */ GIM_Reject,
     /* 290051 */ // Label 5920: @290051
     /* 290051 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(290408),
     /* 290056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 290062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290066 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(290129), // Rule ID 13438 //
     /* 290071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290103 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290107 */     // MIs[2] Operand 1
     /* 290107 */     // No operand predicates
     /* 290107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290113 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 290116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290127 */     GIR_RootConstrainSelectedInstOperands,
     /* 290128 */     // GIR_Coverage, 13438,
     /* 290128 */     GIR_EraseRootFromParent_Done,
     /* 290129 */   // Label 5977: @290129
     /* 290129 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(290192), // Rule ID 2008 //
     /* 290134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 290149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290174 */     // MIs[2] Operand 1
     /* 290174 */     // No operand predicates
     /* 290174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290176 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 290179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290190 */     GIR_RootConstrainSelectedInstOperands,
     /* 290191 */     // GIR_Coverage, 2008,
     /* 290191 */     GIR_EraseRootFromParent_Done,
     /* 290192 */   // Label 5978: @290192
     /* 290192 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(290286), // Rule ID 13901 //
     /* 290197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290220 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290253 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 290274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290284 */     GIR_RootConstrainSelectedInstOperands,
     /* 290285 */     // GIR_Coverage, 13901,
     /* 290285 */     GIR_EraseRootFromParent_Done,
     /* 290286 */   // Label 5979: @290286
     /* 290286 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(290380), // Rule ID 6249 //
     /* 290291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290314 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 290317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 290331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 290350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 290368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290378 */     GIR_RootConstrainSelectedInstOperands,
     /* 290379 */     // GIR_Coverage, 6249,
     /* 290379 */     GIR_EraseRootFromParent_Done,
     /* 290380 */   // Label 5980: @290380
     /* 290380 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(290407), // Rule ID 1325 //
     /* 290385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290396 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 290396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 290401 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290405 */     GIR_RootConstrainSelectedInstOperands,
     /* 290406 */     // GIR_Coverage, 1325,
     /* 290406 */     GIR_Done,
     /* 290407 */   // Label 5981: @290407
     /* 290407 */   GIM_Reject,
     /* 290408 */ // Label 5976: @290408
     /* 290408 */ GIM_Reject,
     /* 290409 */ // Label 5921: @290409
     /* 290409 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(290840),
     /* 290414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 290420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290424 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(290487), // Rule ID 13432 //
     /* 290429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 290440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290465 */     // MIs[2] Operand 1
     /* 290465 */     // No operand predicates
     /* 290465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290471 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 290474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290485 */     GIR_RootConstrainSelectedInstOperands,
     /* 290486 */     // GIR_Coverage, 13432,
     /* 290486 */     GIR_EraseRootFromParent_Done,
     /* 290487 */   // Label 5983: @290487
     /* 290487 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(290550), // Rule ID 2002 //
     /* 290492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 290507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290532 */     // MIs[2] Operand 1
     /* 290532 */     // No operand predicates
     /* 290532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290534 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 290534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 290537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290548 */     GIR_RootConstrainSelectedInstOperands,
     /* 290549 */     // GIR_Coverage, 2002,
     /* 290549 */     GIR_EraseRootFromParent_Done,
     /* 290550 */   // Label 5984: @290550
     /* 290550 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(290577), // Rule ID 1321 //
     /* 290555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290566 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 290566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 290571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 290575 */     GIR_RootConstrainSelectedInstOperands,
     /* 290576 */     // GIR_Coverage, 1321,
     /* 290576 */     GIR_Done,
     /* 290577 */   // Label 5985: @290577
     /* 290577 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(290839), // Rule ID 7004 //
     /* 290582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 290585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290593 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 290593 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 290596 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 290600 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290605 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 290609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 290611 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 290614 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 290618 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290623 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 290627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 290629 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 290632 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 290636 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290641 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 290644 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 290647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 290649 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 290652 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290656 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290661 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 290667 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290672 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290677 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 290680 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 290684 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290689 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 290692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 290694 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 290697 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290701 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290706 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 290712 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290717 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290722 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 290725 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 290729 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290734 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 290737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 290739 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 290742 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 290746 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290751 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 290754 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 290757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 290759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 290762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 290766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290771 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 290774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 290776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 290779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 290808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 290829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 290837 */     GIR_RootConstrainSelectedInstOperands,
     /* 290838 */     // GIR_Coverage, 7004,
     /* 290838 */     GIR_EraseRootFromParent_Done,
     /* 290839 */   // Label 5986: @290839
     /* 290839 */   GIM_Reject,
     /* 290840 */ // Label 5982: @290840
     /* 290840 */ GIM_Reject,
     /* 290841 */ // Label 5922: @290841
     /* 290841 */ GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(290866), // Rule ID 8182 //
     /* 290846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 290852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 290855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290859 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 290859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 290864 */   GIR_RootConstrainSelectedInstOperands,
     /* 290865 */   // GIR_Coverage, 8182,
     /* 290865 */   GIR_Done,
     /* 290866 */ // Label 5987: @290866
     /* 290866 */ GIM_Reject,
     /* 290867 */ // Label 5923: @290867
     /* 290867 */ GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(290892), // Rule ID 8180 //
     /* 290872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 290878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 290881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290885 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 290885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 290890 */   GIR_RootConstrainSelectedInstOperands,
     /* 290891 */   // GIR_Coverage, 8180,
     /* 290891 */   GIR_Done,
     /* 290892 */ // Label 5988: @290892
     /* 290892 */ GIM_Reject,
     /* 290893 */ // Label 5924: @290893
     /* 290893 */ GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(290918), // Rule ID 8178 //
     /* 290898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 290904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 290907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290911 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 290911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 290916 */   GIR_RootConstrainSelectedInstOperands,
     /* 290917 */   // GIR_Coverage, 8178,
     /* 290917 */   GIR_Done,
     /* 290918 */ // Label 5989: @290918
     /* 290918 */ GIM_Reject,
     /* 290919 */ // Label 5925: @290919
     /* 290919 */ GIM_Reject,
     /* 290920 */ // Label 60: @290920
     /* 290920 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5998*/ GIMT_Encode4(307192),
     /* 290931 */ /*GILLT_s16*//*Label 5990*/ GIMT_Encode4(290971),
     /* 290935 */ /*GILLT_s32*//*Label 5991*/ GIMT_Encode4(293975),
     /* 290939 */ /*GILLT_s64*//*Label 5992*/ GIMT_Encode4(297123), GIMT_Encode4(0),
     /* 290947 */ /*GILLT_v2s32*//*Label 5993*/ GIMT_Encode4(300271),
     /* 290951 */ /*GILLT_v2s64*//*Label 5994*/ GIMT_Encode4(301792),
     /* 290955 */ /*GILLT_v4s16*//*Label 5995*/ GIMT_Encode4(303313),
     /* 290959 */ /*GILLT_v4s32*//*Label 5996*/ GIMT_Encode4(304492), GIMT_Encode4(0),
     /* 290967 */ /*GILLT_v8s16*//*Label 5997*/ GIMT_Encode4(306013),
     /* 290971 */ // Label 5990: @290971
     /* 290971 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(293974),
     /* 290976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 290979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 290982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 290985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290989 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(291139), // Rule ID 4865 //
     /* 290994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291018 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291043 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 291051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291055 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 291059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291066 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 291069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291078 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291106 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 291133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 291137 */     GIR_RootConstrainSelectedInstOperands,
     /* 291138 */     // GIR_Coverage, 4865,
     /* 291138 */     GIR_EraseRootFromParent_Done,
     /* 291139 */   // Label 6000: @291139
     /* 291139 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(291286), // Rule ID 4829 //
     /* 291144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 291188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291205 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291215 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 291218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291227 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 291282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291284 */     GIR_RootConstrainSelectedInstOperands,
     /* 291285 */     // GIR_Coverage, 4829,
     /* 291285 */     GIR_EraseRootFromParent_Done,
     /* 291286 */   // Label 6001: @291286
     /* 291286 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(291433), // Rule ID 13840 //
     /* 291291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291327 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291339 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291343 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291352 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291362 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 291365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291374 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 291429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291431 */     GIR_RootConstrainSelectedInstOperands,
     /* 291432 */     // GIR_Coverage, 13840,
     /* 291432 */     GIR_EraseRootFromParent_Done,
     /* 291433 */   // Label 6002: @291433
     /* 291433 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(291564), // Rule ID 6079 //
     /* 291438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 291482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291494 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 291503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291507 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291511 */     // MIs[4] Operand 1
     /* 291511 */     // No operand predicates
     /* 291511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291515 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291517 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 291559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 291562 */     GIR_RootConstrainSelectedInstOperands,
     /* 291563 */     // GIR_Coverage, 6079,
     /* 291563 */     GIR_EraseRootFromParent_Done,
     /* 291564 */   // Label 6003: @291564
     /* 291564 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(291695), // Rule ID 6111 //
     /* 291569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291605 */     // MIs[2] Operand 1
     /* 291605 */     // No operand predicates
     /* 291605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 291617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 291621 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291625 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291629 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 291633 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291638 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 291642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291646 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291648 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291660 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291693 */     GIR_RootConstrainSelectedInstOperands,
     /* 291694 */     // GIR_Coverage, 6111,
     /* 291694 */     GIR_EraseRootFromParent_Done,
     /* 291695 */   // Label 6004: @291695
     /* 291695 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(291826), // Rule ID 6175 //
     /* 291700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291736 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 291765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291769 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291773 */     // MIs[4] Operand 1
     /* 291773 */     // No operand predicates
     /* 291773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291777 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291779 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291791 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 291821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 291824 */     GIR_RootConstrainSelectedInstOperands,
     /* 291825 */     // GIR_Coverage, 6175,
     /* 291825 */     GIR_EraseRootFromParent_Done,
     /* 291826 */   // Label 6005: @291826
     /* 291826 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(291957), // Rule ID 6143 //
     /* 291831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291875 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291879 */     // MIs[3] Operand 1
     /* 291879 */     // No operand predicates
     /* 291879 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 291883 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291887 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291891 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 291895 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291900 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 291904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291908 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291910 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291922 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291955 */     GIR_RootConstrainSelectedInstOperands,
     /* 291956 */     // GIR_Coverage, 6143,
     /* 291956 */     GIR_EraseRootFromParent_Done,
     /* 291957 */   // Label 6006: @291957
     /* 291957 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(292092), // Rule ID 2456 //
     /* 291962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291986 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292011 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292021 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 292024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292033 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292061 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292090 */     GIR_RootConstrainSelectedInstOperands,
     /* 292091 */     // GIR_Coverage, 2456,
     /* 292091 */     GIR_EraseRootFromParent_Done,
     /* 292092 */   // Label 6007: @292092
     /* 292092 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(292211), // Rule ID 6047 //
     /* 292097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292121 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292158 */     // MIs[3] Operand 1
     /* 292158 */     // No operand predicates
     /* 292158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292164 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292176 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292209 */     GIR_RootConstrainSelectedInstOperands,
     /* 292210 */     // GIR_Coverage, 6047,
     /* 292210 */     GIR_EraseRootFromParent_Done,
     /* 292211 */   // Label 6008: @292211
     /* 292211 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(292330), // Rule ID 2538 //
     /* 292216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292252 */     // MIs[2] Operand 1
     /* 292252 */     // No operand predicates
     /* 292252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292268 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292273 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292283 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292295 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292328 */     GIR_RootConstrainSelectedInstOperands,
     /* 292329 */     // GIR_Coverage, 2538,
     /* 292329 */     GIR_EraseRootFromParent_Done,
     /* 292330 */   // Label 6009: @292330
     /* 292330 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(292430), // Rule ID 4827 //
     /* 292335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292359 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292386 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292428 */     GIR_RootConstrainSelectedInstOperands,
     /* 292429 */     // GIR_Coverage, 4827,
     /* 292429 */     GIR_EraseRootFromParent_Done,
     /* 292430 */   // Label 6010: @292430
     /* 292430 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(292530), // Rule ID 4863 //
     /* 292435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292459 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292486 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292498 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292528 */     GIR_RootConstrainSelectedInstOperands,
     /* 292529 */     // GIR_Coverage, 4863,
     /* 292529 */     GIR_EraseRootFromParent_Done,
     /* 292530 */   // Label 6011: @292530
     /* 292530 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(292627), // Rule ID 13836 //
     /* 292535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292571 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292585 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292597 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292625 */     GIR_RootConstrainSelectedInstOperands,
     /* 292626 */     // GIR_Coverage, 13836,
     /* 292626 */     GIR_EraseRootFromParent_Done,
     /* 292627 */   // Label 6012: @292627
     /* 292627 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(292727), // Rule ID 13838 //
     /* 292632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292673 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292683 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292695 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292725 */     GIR_RootConstrainSelectedInstOperands,
     /* 292726 */     // GIR_Coverage, 13838,
     /* 292726 */     GIR_EraseRootFromParent_Done,
     /* 292727 */   // Label 6013: @292727
     /* 292727 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(292827), // Rule ID 4861 //
     /* 292732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292760 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292783 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292795 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292825 */     GIR_RootConstrainSelectedInstOperands,
     /* 292826 */     // GIR_Coverage, 4861,
     /* 292826 */     GIR_EraseRootFromParent_Done,
     /* 292827 */   // Label 6014: @292827
     /* 292827 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(292924), // Rule ID 4825 //
     /* 292832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292872 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292882 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292894 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292922 */     GIR_RootConstrainSelectedInstOperands,
     /* 292923 */     // GIR_Coverage, 4825,
     /* 292923 */     GIR_EraseRootFromParent_Done,
     /* 292924 */   // Label 6015: @292924
     /* 292924 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(293008), // Rule ID 6109 //
     /* 292929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292965 */     // MIs[2] Operand 1
     /* 292965 */     // No operand predicates
     /* 292965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 292977 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292988 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 292999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293006 */     GIR_RootConstrainSelectedInstOperands,
     /* 293007 */     // GIR_Coverage, 6109,
     /* 293007 */     GIR_EraseRootFromParent_Done,
     /* 293008 */   // Label 6016: @293008
     /* 293008 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(293089), // Rule ID 6141 //
     /* 293013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293057 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293061 */     // MIs[3] Operand 1
     /* 293061 */     // No operand predicates
     /* 293061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293071 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293087 */     GIR_RootConstrainSelectedInstOperands,
     /* 293088 */     // GIR_Coverage, 6141,
     /* 293088 */     GIR_EraseRootFromParent_Done,
     /* 293089 */   // Label 6017: @293089
     /* 293089 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(293173), // Rule ID 6173 //
     /* 293094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293147 */     // MIs[3] Operand 1
     /* 293147 */     // No operand predicates
     /* 293147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293153 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293171 */     GIR_RootConstrainSelectedInstOperands,
     /* 293172 */     // GIR_Coverage, 6173,
     /* 293172 */     GIR_EraseRootFromParent_Done,
     /* 293173 */   // Label 6018: @293173
     /* 293173 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(293254), // Rule ID 6077 //
     /* 293178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293230 */     // MIs[3] Operand 1
     /* 293230 */     // No operand predicates
     /* 293230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293236 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 293239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293252 */     GIR_RootConstrainSelectedInstOperands,
     /* 293253 */     // GIR_Coverage, 6077,
     /* 293253 */     GIR_EraseRootFromParent_Done,
     /* 293254 */   // Label 6019: @293254
     /* 293254 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(293339), // Rule ID 2454 //
     /* 293259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293297 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293309 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 293315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293337 */     GIR_RootConstrainSelectedInstOperands,
     /* 293338 */     // GIR_Coverage, 2454,
     /* 293338 */     GIR_EraseRootFromParent_Done,
     /* 293339 */   // Label 6020: @293339
     /* 293339 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(293424), // Rule ID 2452 //
     /* 293344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293382 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 293382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 293385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293394 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 293400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293422 */     GIR_RootConstrainSelectedInstOperands,
     /* 293423 */     // GIR_Coverage, 2452,
     /* 293423 */     GIR_EraseRootFromParent_Done,
     /* 293424 */   // Label 6021: @293424
     /* 293424 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(293493), // Rule ID 2536 //
     /* 293429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293465 */     // MIs[2] Operand 1
     /* 293465 */     // No operand predicates
     /* 293465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293475 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293491 */     GIR_RootConstrainSelectedInstOperands,
     /* 293492 */     // GIR_Coverage, 2536,
     /* 293492 */     GIR_EraseRootFromParent_Done,
     /* 293493 */   // Label 6022: @293493
     /* 293493 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(293562), // Rule ID 6045 //
     /* 293498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 293517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 293526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293534 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 293538 */     // MIs[2] Operand 1
     /* 293538 */     // No operand predicates
     /* 293538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293544 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 293544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 293547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293560 */     GIR_RootConstrainSelectedInstOperands,
     /* 293561 */     // GIR_Coverage, 6045,
     /* 293561 */     GIR_EraseRootFromParent_Done,
     /* 293562 */   // Label 6023: @293562
     /* 293562 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(293627), // Rule ID 4881 //
     /* 293567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293610 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 293613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 293625 */     GIR_RootConstrainSelectedInstOperands,
     /* 293626 */     // GIR_Coverage, 4881,
     /* 293626 */     GIR_EraseRootFromParent_Done,
     /* 293627 */   // Label 6024: @293627
     /* 293627 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(293692), // Rule ID 13856 //
     /* 293632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 293668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293675 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 293678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 293686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 293690 */     GIR_RootConstrainSelectedInstOperands,
     /* 293691 */     // GIR_Coverage, 13856,
     /* 293691 */     GIR_EraseRootFromParent_Done,
     /* 293692 */   // Label 6025: @293692
     /* 293692 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(293742), // Rule ID 4878 //
     /* 293697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293727 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293740 */     GIR_RootConstrainSelectedInstOperands,
     /* 293741 */     // GIR_Coverage, 4878,
     /* 293741 */     GIR_EraseRootFromParent_Done,
     /* 293742 */   // Label 6026: @293742
     /* 293742 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(293792), // Rule ID 13282 //
     /* 293747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293777 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293790 */     GIR_RootConstrainSelectedInstOperands,
     /* 293791 */     // GIR_Coverage, 13282,
     /* 293791 */     GIR_EraseRootFromParent_Done,
     /* 293792 */   // Label 6027: @293792
     /* 293792 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(293842), // Rule ID 644 //
     /* 293797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293827 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293840 */     GIR_RootConstrainSelectedInstOperands,
     /* 293841 */     // GIR_Coverage, 644,
     /* 293841 */     GIR_EraseRootFromParent_Done,
     /* 293842 */   // Label 6028: @293842
     /* 293842 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(293892), // Rule ID 13853 //
     /* 293847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293877 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 293888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293890 */     GIR_RootConstrainSelectedInstOperands,
     /* 293891 */     // GIR_Coverage, 13853,
     /* 293891 */     GIR_EraseRootFromParent_Done,
     /* 293892 */   // Label 6029: @293892
     /* 293892 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(293942), // Rule ID 656 //
     /* 293897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293927 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 293930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 293940 */     GIR_RootConstrainSelectedInstOperands,
     /* 293941 */     // GIR_Coverage, 656,
     /* 293941 */     GIR_EraseRootFromParent_Done,
     /* 293942 */   // Label 6030: @293942
     /* 293942 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(293973), // Rule ID 638 //
     /* 293947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293962 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293967 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 293971 */     GIR_RootConstrainSelectedInstOperands,
     /* 293972 */     // GIR_Coverage, 638,
     /* 293972 */     GIR_Done,
     /* 293973 */   // Label 6031: @293973
     /* 293973 */   GIM_Reject,
     /* 293974 */ // Label 5999: @293974
     /* 293974 */ GIM_Reject,
     /* 293975 */ // Label 5991: @293975
     /* 293975 */ GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(297122),
     /* 293980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 293983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 293986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 293989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293993 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(294143), // Rule ID 4871 //
     /* 293998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294022 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294047 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 294055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 294063 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294070 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 294073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294082 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294110 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 294137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 294141 */     GIR_RootConstrainSelectedInstOperands,
     /* 294142 */     // GIR_Coverage, 4871,
     /* 294142 */     GIR_EraseRootFromParent_Done,
     /* 294143 */   // Label 6033: @294143
     /* 294143 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(294290), // Rule ID 4835 //
     /* 294148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294172 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 294192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294200 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294204 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294209 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294219 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 294222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294231 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294259 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 294286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294288 */     GIR_RootConstrainSelectedInstOperands,
     /* 294289 */     // GIR_Coverage, 4835,
     /* 294289 */     GIR_EraseRootFromParent_Done,
     /* 294290 */   // Label 6034: @294290
     /* 294290 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(294437), // Rule ID 13846 //
     /* 294295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294331 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294347 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294351 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294356 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294366 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 294369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294378 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294406 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 294433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294435 */     GIR_RootConstrainSelectedInstOperands,
     /* 294436 */     // GIR_Coverage, 13846,
     /* 294436 */     GIR_EraseRootFromParent_Done,
     /* 294437 */   // Label 6035: @294437
     /* 294437 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(294568), // Rule ID 6095 //
     /* 294442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294466 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 294486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294490 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294494 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294498 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294503 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 294507 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294511 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294515 */     // MIs[4] Operand 1
     /* 294515 */     // No operand predicates
     /* 294515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294519 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294521 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294533 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 294563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 294566 */     GIR_RootConstrainSelectedInstOperands,
     /* 294567 */     // GIR_Coverage, 6095,
     /* 294567 */     GIR_EraseRootFromParent_Done,
     /* 294568 */   // Label 6036: @294568
     /* 294568 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(294699), // Rule ID 6127 //
     /* 294573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294609 */     // MIs[2] Operand 1
     /* 294609 */     // No operand predicates
     /* 294609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294617 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 294621 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 294625 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294629 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294633 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 294637 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294642 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 294646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294652 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294664 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294697 */     GIR_RootConstrainSelectedInstOperands,
     /* 294698 */     // GIR_Coverage, 6127,
     /* 294698 */     GIR_EraseRootFromParent_Done,
     /* 294699 */   // Label 6037: @294699
     /* 294699 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(294830), // Rule ID 6191 //
     /* 294704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294740 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294765 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 294769 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294773 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294777 */     // MIs[4] Operand 1
     /* 294777 */     // No operand predicates
     /* 294777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294781 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294783 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294795 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 294825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 294828 */     GIR_RootConstrainSelectedInstOperands,
     /* 294829 */     // GIR_Coverage, 6191,
     /* 294829 */     GIR_EraseRootFromParent_Done,
     /* 294830 */   // Label 6038: @294830
     /* 294830 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(294961), // Rule ID 6159 //
     /* 294835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294879 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294883 */     // MIs[3] Operand 1
     /* 294883 */     // No operand predicates
     /* 294883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 294887 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294891 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294895 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 294899 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294904 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 294908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294912 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294914 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294926 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294959 */     GIR_RootConstrainSelectedInstOperands,
     /* 294960 */     // GIR_Coverage, 6159,
     /* 294960 */     GIR_EraseRootFromParent_Done,
     /* 294961 */   // Label 6039: @294961
     /* 294961 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(295096), // Rule ID 2462 //
     /* 294966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294990 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295015 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295025 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295025 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 295028 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295032 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295037 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 295092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295094 */     GIR_RootConstrainSelectedInstOperands,
     /* 295095 */     // GIR_Coverage, 2462,
     /* 295095 */     GIR_EraseRootFromParent_Done,
     /* 295096 */   // Label 6040: @295096
     /* 295096 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(295215), // Rule ID 6063 //
     /* 295101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295125 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295158 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295162 */     // MIs[3] Operand 1
     /* 295162 */     // No operand predicates
     /* 295162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295168 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295180 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295213 */     GIR_RootConstrainSelectedInstOperands,
     /* 295214 */     // GIR_Coverage, 6063,
     /* 295214 */     GIR_EraseRootFromParent_Done,
     /* 295215 */   // Label 6041: @295215
     /* 295215 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(295334), // Rule ID 2554 //
     /* 295220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295252 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295256 */     // MIs[2] Operand 1
     /* 295256 */     // No operand predicates
     /* 295256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295268 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295272 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295277 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295287 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295332 */     GIR_RootConstrainSelectedInstOperands,
     /* 295333 */     // GIR_Coverage, 2554,
     /* 295333 */     GIR_EraseRootFromParent_Done,
     /* 295334 */   // Label 6042: @295334
     /* 295334 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(295434), // Rule ID 4833 //
     /* 295339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295363 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295390 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295432 */     GIR_RootConstrainSelectedInstOperands,
     /* 295433 */     // GIR_Coverage, 4833,
     /* 295433 */     GIR_EraseRootFromParent_Done,
     /* 295434 */   // Label 6043: @295434
     /* 295434 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(295534), // Rule ID 4869 //
     /* 295439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295490 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295502 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295532 */     GIR_RootConstrainSelectedInstOperands,
     /* 295533 */     // GIR_Coverage, 4869,
     /* 295533 */     GIR_EraseRootFromParent_Done,
     /* 295534 */   // Label 6044: @295534
     /* 295534 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295631), // Rule ID 13842 //
     /* 295539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295575 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295589 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295601 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295629 */     GIR_RootConstrainSelectedInstOperands,
     /* 295630 */     // GIR_Coverage, 13842,
     /* 295630 */     GIR_EraseRootFromParent_Done,
     /* 295631 */   // Label 6045: @295631
     /* 295631 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(295731), // Rule ID 13844 //
     /* 295636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295677 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295687 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295699 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295729 */     GIR_RootConstrainSelectedInstOperands,
     /* 295730 */     // GIR_Coverage, 13844,
     /* 295730 */     GIR_EraseRootFromParent_Done,
     /* 295731 */   // Label 6046: @295731
     /* 295731 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(295831), // Rule ID 4867 //
     /* 295736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295787 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295799 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295829 */     GIR_RootConstrainSelectedInstOperands,
     /* 295830 */     // GIR_Coverage, 4867,
     /* 295830 */     GIR_EraseRootFromParent_Done,
     /* 295831 */   // Label 6047: @295831
     /* 295831 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(295928), // Rule ID 4831 //
     /* 295836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295876 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295886 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295898 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295926 */     GIR_RootConstrainSelectedInstOperands,
     /* 295927 */     // GIR_Coverage, 4831,
     /* 295927 */     GIR_EraseRootFromParent_Done,
     /* 295928 */   // Label 6048: @295928
     /* 295928 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(296006), // Rule ID 6213 //
     /* 295933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295978 */     // MIs[3] Operand 1
     /* 295978 */     // No operand predicates
     /* 295978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295988 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296004 */     GIR_RootConstrainSelectedInstOperands,
     /* 296005 */     // GIR_Coverage, 6213,
     /* 296005 */     GIR_EraseRootFromParent_Done,
     /* 296006 */   // Label 6049: @296006
     /* 296006 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(296090), // Rule ID 6125 //
     /* 296011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296047 */     // MIs[2] Operand 1
     /* 296047 */     // No operand predicates
     /* 296047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296055 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 296059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296070 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 296081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296088 */     GIR_RootConstrainSelectedInstOperands,
     /* 296089 */     // GIR_Coverage, 6125,
     /* 296089 */     GIR_EraseRootFromParent_Done,
     /* 296090 */   // Label 6050: @296090
     /* 296090 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(296171), // Rule ID 6157 //
     /* 296095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296139 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296143 */     // MIs[3] Operand 1
     /* 296143 */     // No operand predicates
     /* 296143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296153 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296169 */     GIR_RootConstrainSelectedInstOperands,
     /* 296170 */     // GIR_Coverage, 6157,
     /* 296170 */     GIR_EraseRootFromParent_Done,
     /* 296171 */   // Label 6051: @296171
     /* 296171 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(296255), // Rule ID 6189 //
     /* 296176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296225 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296229 */     // MIs[3] Operand 1
     /* 296229 */     // No operand predicates
     /* 296229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296235 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296253 */     GIR_RootConstrainSelectedInstOperands,
     /* 296254 */     // GIR_Coverage, 6189,
     /* 296254 */     GIR_EraseRootFromParent_Done,
     /* 296255 */   // Label 6052: @296255
     /* 296255 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(296333), // Rule ID 6235 //
     /* 296260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296309 */     // MIs[3] Operand 1
     /* 296309 */     // No operand predicates
     /* 296309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296315 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296331 */     GIR_RootConstrainSelectedInstOperands,
     /* 296332 */     // GIR_Coverage, 6235,
     /* 296332 */     GIR_EraseRootFromParent_Done,
     /* 296333 */   // Label 6053: @296333
     /* 296333 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(296414), // Rule ID 6093 //
     /* 296338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296386 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296390 */     // MIs[3] Operand 1
     /* 296390 */     // No operand predicates
     /* 296390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296396 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 296399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296412 */     GIR_RootConstrainSelectedInstOperands,
     /* 296413 */     // GIR_Coverage, 6093,
     /* 296413 */     GIR_EraseRootFromParent_Done,
     /* 296414 */   // Label 6054: @296414
     /* 296414 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(296499), // Rule ID 2460 //
     /* 296419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296443 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296457 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 296475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296497 */     GIR_RootConstrainSelectedInstOperands,
     /* 296498 */     // GIR_Coverage, 2460,
     /* 296498 */     GIR_EraseRootFromParent_Done,
     /* 296499 */   // Label 6055: @296499
     /* 296499 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(296584), // Rule ID 2458 //
     /* 296504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296542 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 296542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 296545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 296560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296582 */     GIR_RootConstrainSelectedInstOperands,
     /* 296583 */     // GIR_Coverage, 2458,
     /* 296583 */     GIR_EraseRootFromParent_Done,
     /* 296584 */   // Label 6056: @296584
     /* 296584 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(296653), // Rule ID 2552 //
     /* 296589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296625 */     // MIs[2] Operand 1
     /* 296625 */     // No operand predicates
     /* 296625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296635 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296651 */     GIR_RootConstrainSelectedInstOperands,
     /* 296652 */     // GIR_Coverage, 2552,
     /* 296652 */     GIR_EraseRootFromParent_Done,
     /* 296653 */   // Label 6057: @296653
     /* 296653 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(296722), // Rule ID 6061 //
     /* 296658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 296677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 296698 */     // MIs[2] Operand 1
     /* 296698 */     // No operand predicates
     /* 296698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296704 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 296707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296720 */     GIR_RootConstrainSelectedInstOperands,
     /* 296721 */     // GIR_Coverage, 6061,
     /* 296721 */     GIR_EraseRootFromParent_Done,
     /* 296722 */   // Label 6058: @296722
     /* 296722 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(296784), // Rule ID 4882 //
     /* 296727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296767 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 296770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 296782 */     GIR_RootConstrainSelectedInstOperands,
     /* 296783 */     // GIR_Coverage, 4882,
     /* 296783 */     GIR_EraseRootFromParent_Done,
     /* 296784 */   // Label 6059: @296784
     /* 296784 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(296846), // Rule ID 13857 //
     /* 296789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296829 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 296832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 296844 */     GIR_RootConstrainSelectedInstOperands,
     /* 296845 */     // GIR_Coverage, 13857,
     /* 296845 */     GIR_EraseRootFromParent_Done,
     /* 296846 */   // Label 6060: @296846
     /* 296846 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(296893), // Rule ID 4879 //
     /* 296851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296878 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296891 */     GIR_RootConstrainSelectedInstOperands,
     /* 296892 */     // GIR_Coverage, 4879,
     /* 296892 */     GIR_EraseRootFromParent_Done,
     /* 296893 */   // Label 6061: @296893
     /* 296893 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(296943), // Rule ID 13284 //
     /* 296898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296928 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296941 */     GIR_RootConstrainSelectedInstOperands,
     /* 296942 */     // GIR_Coverage, 13284,
     /* 296942 */     GIR_EraseRootFromParent_Done,
     /* 296943 */   // Label 6062: @296943
     /* 296943 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(296993), // Rule ID 646 //
     /* 296948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296978 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296991 */     GIR_RootConstrainSelectedInstOperands,
     /* 296992 */     // GIR_Coverage, 646,
     /* 296992 */     GIR_EraseRootFromParent_Done,
     /* 296993 */   // Label 6063: @296993
     /* 296993 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(297040), // Rule ID 13854 //
     /* 296998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297025 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 297028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 297036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297038 */     GIR_RootConstrainSelectedInstOperands,
     /* 297039 */     // GIR_Coverage, 13854,
     /* 297039 */     GIR_EraseRootFromParent_Done,
     /* 297040 */   // Label 6064: @297040
     /* 297040 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(297090), // Rule ID 658 //
     /* 297045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297075 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 297078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 297088 */     GIR_RootConstrainSelectedInstOperands,
     /* 297089 */     // GIR_Coverage, 658,
     /* 297089 */     GIR_EraseRootFromParent_Done,
     /* 297090 */   // Label 6065: @297090
     /* 297090 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(297121), // Rule ID 640 //
     /* 297095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297110 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 297115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 297119 */     GIR_RootConstrainSelectedInstOperands,
     /* 297120 */     // GIR_Coverage, 640,
     /* 297120 */     GIR_Done,
     /* 297121 */   // Label 6066: @297121
     /* 297121 */   GIM_Reject,
     /* 297122 */ // Label 6032: @297122
     /* 297122 */ GIM_Reject,
     /* 297123 */ // Label 5992: @297123
     /* 297123 */ GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(300270),
     /* 297128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297134 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 297137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297141 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(297291), // Rule ID 4877 //
     /* 297146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297170 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297195 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 297203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 297211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297218 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297230 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 297289 */     GIR_RootConstrainSelectedInstOperands,
     /* 297290 */     // GIR_Coverage, 4877,
     /* 297290 */     GIR_EraseRootFromParent_Done,
     /* 297291 */   // Label 6068: @297291
     /* 297291 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(297438), // Rule ID 4841 //
     /* 297296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297320 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297352 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297357 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297367 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297379 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297407 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297436 */     GIR_RootConstrainSelectedInstOperands,
     /* 297437 */     // GIR_Coverage, 4841,
     /* 297437 */     GIR_EraseRootFromParent_Done,
     /* 297438 */   // Label 6069: @297438
     /* 297438 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(297585), // Rule ID 13852 //
     /* 297443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297479 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297504 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297514 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297526 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297583 */     GIR_RootConstrainSelectedInstOperands,
     /* 297584 */     // GIR_Coverage, 13852,
     /* 297584 */     GIR_EraseRootFromParent_Done,
     /* 297585 */   // Label 6070: @297585
     /* 297585 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(297716), // Rule ID 6099 //
     /* 297590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297614 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 297634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297642 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297659 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297663 */     // MIs[4] Operand 1
     /* 297663 */     // No operand predicates
     /* 297663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297669 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297714 */     GIR_RootConstrainSelectedInstOperands,
     /* 297715 */     // GIR_Coverage, 6099,
     /* 297715 */     GIR_EraseRootFromParent_Done,
     /* 297716 */   // Label 6071: @297716
     /* 297716 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(297847), // Rule ID 6131 //
     /* 297721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297757 */     // MIs[2] Operand 1
     /* 297757 */     // No operand predicates
     /* 297757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 297769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 297773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297777 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 297785 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297790 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 297794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297798 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297800 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297845 */     GIR_RootConstrainSelectedInstOperands,
     /* 297846 */     // GIR_Coverage, 6131,
     /* 297846 */     GIR_EraseRootFromParent_Done,
     /* 297847 */   // Label 6072: @297847
     /* 297847 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(297978), // Rule ID 6195 //
     /* 297852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297888 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297908 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297913 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297917 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297921 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297925 */     // MIs[4] Operand 1
     /* 297925 */     // No operand predicates
     /* 297925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297929 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297931 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297943 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297976 */     GIR_RootConstrainSelectedInstOperands,
     /* 297977 */     // GIR_Coverage, 6195,
     /* 297977 */     GIR_EraseRootFromParent_Done,
     /* 297978 */   // Label 6073: @297978
     /* 297978 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(298109), // Rule ID 6163 //
     /* 297983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298027 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298031 */     // MIs[3] Operand 1
     /* 298031 */     // No operand predicates
     /* 298031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 298035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298043 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 298047 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298052 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 298056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298060 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298062 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298074 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298107 */     GIR_RootConstrainSelectedInstOperands,
     /* 298108 */     // GIR_Coverage, 6163,
     /* 298108 */     GIR_EraseRootFromParent_Done,
     /* 298109 */   // Label 6074: @298109
     /* 298109 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(298244), // Rule ID 2468 //
     /* 298114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298138 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298163 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298173 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298185 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298242 */     GIR_RootConstrainSelectedInstOperands,
     /* 298243 */     // GIR_Coverage, 2468,
     /* 298243 */     GIR_EraseRootFromParent_Done,
     /* 298244 */   // Label 6075: @298244
     /* 298244 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(298363), // Rule ID 6067 //
     /* 298249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298273 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298306 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298310 */     // MIs[3] Operand 1
     /* 298310 */     // No operand predicates
     /* 298310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298316 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298328 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298361 */     GIR_RootConstrainSelectedInstOperands,
     /* 298362 */     // GIR_Coverage, 6067,
     /* 298362 */     GIR_EraseRootFromParent_Done,
     /* 298363 */   // Label 6076: @298363
     /* 298363 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(298482), // Rule ID 2558 //
     /* 298368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298404 */     // MIs[2] Operand 1
     /* 298404 */     // No operand predicates
     /* 298404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 298408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298420 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298425 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298435 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298447 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298480 */     GIR_RootConstrainSelectedInstOperands,
     /* 298481 */     // GIR_Coverage, 2558,
     /* 298481 */     GIR_EraseRootFromParent_Done,
     /* 298482 */   // Label 6077: @298482
     /* 298482 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298582), // Rule ID 4839 //
     /* 298487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298538 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298580 */     GIR_RootConstrainSelectedInstOperands,
     /* 298581 */     // GIR_Coverage, 4839,
     /* 298581 */     GIR_EraseRootFromParent_Done,
     /* 298582 */   // Label 6078: @298582
     /* 298582 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(298682), // Rule ID 4875 //
     /* 298587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298638 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298650 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298680 */     GIR_RootConstrainSelectedInstOperands,
     /* 298681 */     // GIR_Coverage, 4875,
     /* 298681 */     GIR_EraseRootFromParent_Done,
     /* 298682 */   // Label 6079: @298682
     /* 298682 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(298779), // Rule ID 13848 //
     /* 298687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298737 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298749 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298777 */     GIR_RootConstrainSelectedInstOperands,
     /* 298778 */     // GIR_Coverage, 13848,
     /* 298778 */     GIR_EraseRootFromParent_Done,
     /* 298779 */   // Label 6080: @298779
     /* 298779 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(298879), // Rule ID 13850 //
     /* 298784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298825 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298835 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298877 */     GIR_RootConstrainSelectedInstOperands,
     /* 298878 */     // GIR_Coverage, 13850,
     /* 298878 */     GIR_EraseRootFromParent_Done,
     /* 298879 */   // Label 6081: @298879
     /* 298879 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(298979), // Rule ID 4873 //
     /* 298884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298912 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298935 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298977 */     GIR_RootConstrainSelectedInstOperands,
     /* 298978 */     // GIR_Coverage, 4873,
     /* 298978 */     GIR_EraseRootFromParent_Done,
     /* 298979 */   // Label 6082: @298979
     /* 298979 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(299076), // Rule ID 4837 //
     /* 298984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299024 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 299028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299034 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299046 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299074 */     GIR_RootConstrainSelectedInstOperands,
     /* 299075 */     // GIR_Coverage, 4837,
     /* 299075 */     GIR_EraseRootFromParent_Done,
     /* 299076 */   // Label 6083: @299076
     /* 299076 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(299154), // Rule ID 6217 //
     /* 299081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299126 */     // MIs[3] Operand 1
     /* 299126 */     // No operand predicates
     /* 299126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299136 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299152 */     GIR_RootConstrainSelectedInstOperands,
     /* 299153 */     // GIR_Coverage, 6217,
     /* 299153 */     GIR_EraseRootFromParent_Done,
     /* 299154 */   // Label 6084: @299154
     /* 299154 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(299238), // Rule ID 6129 //
     /* 299159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299191 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299195 */     // MIs[2] Operand 1
     /* 299195 */     // No operand predicates
     /* 299195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 299207 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299218 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299236 */     GIR_RootConstrainSelectedInstOperands,
     /* 299237 */     // GIR_Coverage, 6129,
     /* 299237 */     GIR_EraseRootFromParent_Done,
     /* 299238 */   // Label 6085: @299238
     /* 299238 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(299319), // Rule ID 6161 //
     /* 299243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299291 */     // MIs[3] Operand 1
     /* 299291 */     // No operand predicates
     /* 299291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299301 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299317 */     GIR_RootConstrainSelectedInstOperands,
     /* 299318 */     // GIR_Coverage, 6161,
     /* 299318 */     GIR_EraseRootFromParent_Done,
     /* 299319 */   // Label 6086: @299319
     /* 299319 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(299403), // Rule ID 6193 //
     /* 299324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299373 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299377 */     // MIs[3] Operand 1
     /* 299377 */     // No operand predicates
     /* 299377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299383 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299401 */     GIR_RootConstrainSelectedInstOperands,
     /* 299402 */     // GIR_Coverage, 6193,
     /* 299402 */     GIR_EraseRootFromParent_Done,
     /* 299403 */   // Label 6087: @299403
     /* 299403 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(299481), // Rule ID 6239 //
     /* 299408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299457 */     // MIs[3] Operand 1
     /* 299457 */     // No operand predicates
     /* 299457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299463 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299479 */     GIR_RootConstrainSelectedInstOperands,
     /* 299480 */     // GIR_Coverage, 6239,
     /* 299480 */     GIR_EraseRootFromParent_Done,
     /* 299481 */   // Label 6088: @299481
     /* 299481 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(299562), // Rule ID 6097 //
     /* 299486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299534 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299538 */     // MIs[3] Operand 1
     /* 299538 */     // No operand predicates
     /* 299538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299544 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 299547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299560 */     GIR_RootConstrainSelectedInstOperands,
     /* 299561 */     // GIR_Coverage, 6097,
     /* 299561 */     GIR_EraseRootFromParent_Done,
     /* 299562 */   // Label 6089: @299562
     /* 299562 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(299647), // Rule ID 2466 //
     /* 299567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299591 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299605 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299645 */     GIR_RootConstrainSelectedInstOperands,
     /* 299646 */     // GIR_Coverage, 2466,
     /* 299646 */     GIR_EraseRootFromParent_Done,
     /* 299647 */   // Label 6090: @299647
     /* 299647 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(299732), // Rule ID 2464 //
     /* 299652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 299684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299690 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 299690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299730 */     GIR_RootConstrainSelectedInstOperands,
     /* 299731 */     // GIR_Coverage, 2464,
     /* 299731 */     GIR_EraseRootFromParent_Done,
     /* 299732 */   // Label 6091: @299732
     /* 299732 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(299801), // Rule ID 2556 //
     /* 299737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299773 */     // MIs[2] Operand 1
     /* 299773 */     // No operand predicates
     /* 299773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299783 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299799 */     GIR_RootConstrainSelectedInstOperands,
     /* 299800 */     // GIR_Coverage, 2556,
     /* 299800 */     GIR_EraseRootFromParent_Done,
     /* 299801 */   // Label 6092: @299801
     /* 299801 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(299870), // Rule ID 6065 //
     /* 299806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299842 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299846 */     // MIs[2] Operand 1
     /* 299846 */     // No operand predicates
     /* 299846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299852 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299868 */     GIR_RootConstrainSelectedInstOperands,
     /* 299869 */     // GIR_Coverage, 6065,
     /* 299869 */     GIR_EraseRootFromParent_Done,
     /* 299870 */   // Label 6093: @299870
     /* 299870 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(299932), // Rule ID 4883 //
     /* 299875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 299900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299915 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 299930 */     GIR_RootConstrainSelectedInstOperands,
     /* 299931 */     // GIR_Coverage, 4883,
     /* 299931 */     GIR_EraseRootFromParent_Done,
     /* 299932 */   // Label 6094: @299932
     /* 299932 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(299994), // Rule ID 13858 //
     /* 299937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 299962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299977 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 299988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 299992 */     GIR_RootConstrainSelectedInstOperands,
     /* 299993 */     // GIR_Coverage, 13858,
     /* 299993 */     GIR_EraseRootFromParent_Done,
     /* 299994 */   // Label 6095: @299994
     /* 299994 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(300041), // Rule ID 4880 //
     /* 299999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300026 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 300037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300039 */     GIR_RootConstrainSelectedInstOperands,
     /* 300040 */     // GIR_Coverage, 4880,
     /* 300040 */     GIR_EraseRootFromParent_Done,
     /* 300041 */   // Label 6096: @300041
     /* 300041 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(300091), // Rule ID 13286 //
     /* 300046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300076 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300089 */     GIR_RootConstrainSelectedInstOperands,
     /* 300090 */     // GIR_Coverage, 13286,
     /* 300090 */     GIR_EraseRootFromParent_Done,
     /* 300091 */   // Label 6097: @300091
     /* 300091 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(300141), // Rule ID 648 //
     /* 300096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300126 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300139 */     GIR_RootConstrainSelectedInstOperands,
     /* 300140 */     // GIR_Coverage, 648,
     /* 300140 */     GIR_EraseRootFromParent_Done,
     /* 300141 */   // Label 6098: @300141
     /* 300141 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(300188), // Rule ID 13855 //
     /* 300146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300173 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 300176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 300184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 300186 */     GIR_RootConstrainSelectedInstOperands,
     /* 300187 */     // GIR_Coverage, 13855,
     /* 300187 */     GIR_EraseRootFromParent_Done,
     /* 300188 */   // Label 6099: @300188
     /* 300188 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(300238), // Rule ID 660 //
     /* 300193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 300208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300223 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 300226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 300232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 300236 */     GIR_RootConstrainSelectedInstOperands,
     /* 300237 */     // GIR_Coverage, 660,
     /* 300237 */     GIR_EraseRootFromParent_Done,
     /* 300238 */   // Label 6100: @300238
     /* 300238 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(300269), // Rule ID 642 //
     /* 300243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300258 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 300258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 300263 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300267 */     GIR_RootConstrainSelectedInstOperands,
     /* 300268 */     // GIR_Coverage, 642,
     /* 300268 */     GIR_Done,
     /* 300269 */   // Label 6101: @300269
     /* 300269 */   GIM_Reject,
     /* 300270 */ // Label 6067: @300270
     /* 300270 */ GIM_Reject,
     /* 300271 */ // Label 5993: @300271
     /* 300271 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(301791),
     /* 300276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 300285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300289 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(300367), // Rule ID 6197 //
     /* 300294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300335 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300339 */     // MIs[3] Operand 1
     /* 300339 */     // No operand predicates
     /* 300339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300349 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300365 */     GIR_RootConstrainSelectedInstOperands,
     /* 300366 */     // GIR_Coverage, 6197,
     /* 300366 */     GIR_EraseRootFromParent_Done,
     /* 300367 */   // Label 6103: @300367
     /* 300367 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(300451), // Rule ID 6113 //
     /* 300372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300408 */     // MIs[2] Operand 1
     /* 300408 */     // No operand predicates
     /* 300408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300420 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300431 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300449 */     GIR_RootConstrainSelectedInstOperands,
     /* 300450 */     // GIR_Coverage, 6113,
     /* 300450 */     GIR_EraseRootFromParent_Done,
     /* 300451 */   // Label 6104: @300451
     /* 300451 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(300532), // Rule ID 6145 //
     /* 300456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300504 */     // MIs[3] Operand 1
     /* 300504 */     // No operand predicates
     /* 300504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300514 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300530 */     GIR_RootConstrainSelectedInstOperands,
     /* 300531 */     // GIR_Coverage, 6145,
     /* 300531 */     GIR_EraseRootFromParent_Done,
     /* 300532 */   // Label 6105: @300532
     /* 300532 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(300616), // Rule ID 6177 //
     /* 300537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300586 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300590 */     // MIs[3] Operand 1
     /* 300590 */     // No operand predicates
     /* 300590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300596 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300614 */     GIR_RootConstrainSelectedInstOperands,
     /* 300615 */     // GIR_Coverage, 6177,
     /* 300615 */     GIR_EraseRootFromParent_Done,
     /* 300616 */   // Label 6106: @300616
     /* 300616 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(300694), // Rule ID 6219 //
     /* 300621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300666 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300670 */     // MIs[3] Operand 1
     /* 300670 */     // No operand predicates
     /* 300670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300676 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300692 */     GIR_RootConstrainSelectedInstOperands,
     /* 300693 */     // GIR_Coverage, 6219,
     /* 300693 */     GIR_EraseRootFromParent_Done,
     /* 300694 */   // Label 6107: @300694
     /* 300694 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(300775), // Rule ID 6081 //
     /* 300699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300747 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300751 */     // MIs[3] Operand 1
     /* 300751 */     // No operand predicates
     /* 300751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300757 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300773 */     GIR_RootConstrainSelectedInstOperands,
     /* 300774 */     // GIR_Coverage, 6081,
     /* 300774 */     GIR_EraseRootFromParent_Done,
     /* 300775 */   // Label 6108: @300775
     /* 300775 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(300844), // Rule ID 2540 //
     /* 300780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300816 */     // MIs[2] Operand 1
     /* 300816 */     // No operand predicates
     /* 300816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300826 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300842 */     GIR_RootConstrainSelectedInstOperands,
     /* 300843 */     // GIR_Coverage, 2540,
     /* 300843 */     GIR_EraseRootFromParent_Done,
     /* 300844 */   // Label 6109: @300844
     /* 300844 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(300913), // Rule ID 6049 //
     /* 300849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300885 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300889 */     // MIs[2] Operand 1
     /* 300889 */     // No operand predicates
     /* 300889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300895 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300911 */     GIR_RootConstrainSelectedInstOperands,
     /* 300912 */     // GIR_Coverage, 6049,
     /* 300912 */     GIR_EraseRootFromParent_Done,
     /* 300913 */   // Label 6110: @300913
     /* 300913 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(301006), // Rule ID 6201 //
     /* 300918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300957 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301004 */     GIR_RootConstrainSelectedInstOperands,
     /* 301005 */     // GIR_Coverage, 6201,
     /* 301005 */     GIR_EraseRootFromParent_Done,
     /* 301006 */   // Label 6111: @301006
     /* 301006 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(301105), // Rule ID 6115 //
     /* 301011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301054 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301103 */     GIR_RootConstrainSelectedInstOperands,
     /* 301104 */     // GIR_Coverage, 6115,
     /* 301104 */     GIR_EraseRootFromParent_Done,
     /* 301105 */   // Label 6112: @301105
     /* 301105 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301201), // Rule ID 6147 //
     /* 301110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 301137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301152 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301199 */     GIR_RootConstrainSelectedInstOperands,
     /* 301200 */     // GIR_Coverage, 6147,
     /* 301200 */     GIR_EraseRootFromParent_Done,
     /* 301201 */   // Label 6113: @301201
     /* 301201 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(301300), // Rule ID 6179 //
     /* 301206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 301238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301249 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301261 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301298 */     GIR_RootConstrainSelectedInstOperands,
     /* 301299 */     // GIR_Coverage, 6179,
     /* 301299 */     GIR_EraseRootFromParent_Done,
     /* 301300 */   // Label 6114: @301300
     /* 301300 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(301393), // Rule ID 6223 //
     /* 301305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 301333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301344 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301391 */     GIR_RootConstrainSelectedInstOperands,
     /* 301392 */     // GIR_Coverage, 6223,
     /* 301392 */     GIR_EraseRootFromParent_Done,
     /* 301393 */   // Label 6115: @301393
     /* 301393 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(301489), // Rule ID 6083 //
     /* 301398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 301429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301440 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 301475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301487 */     GIR_RootConstrainSelectedInstOperands,
     /* 301488 */     // GIR_Coverage, 6083,
     /* 301488 */     GIR_EraseRootFromParent_Done,
     /* 301489 */   // Label 6116: @301489
     /* 301489 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(301573), // Rule ID 2542 //
     /* 301494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301524 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 301559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301571 */     GIR_RootConstrainSelectedInstOperands,
     /* 301572 */     // GIR_Coverage, 2542,
     /* 301572 */     GIR_EraseRootFromParent_Done,
     /* 301573 */   // Label 6117: @301573
     /* 301573 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(301623), // Rule ID 13316 //
     /* 301578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301608 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 301608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 301611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301621 */     GIR_RootConstrainSelectedInstOperands,
     /* 301622 */     // GIR_Coverage, 13316,
     /* 301622 */     GIR_EraseRootFromParent_Done,
     /* 301623 */   // Label 6118: @301623
     /* 301623 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(301707), // Rule ID 6051 //
     /* 301628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301658 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 301680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 301693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301705 */     GIR_RootConstrainSelectedInstOperands,
     /* 301706 */     // GIR_Coverage, 6051,
     /* 301706 */     GIR_EraseRootFromParent_Done,
     /* 301707 */   // Label 6119: @301707
     /* 301707 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(301757), // Rule ID 1308 //
     /* 301712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301742 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 301742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 301745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301755 */     GIR_RootConstrainSelectedInstOperands,
     /* 301756 */     // GIR_Coverage, 1308,
     /* 301756 */     GIR_EraseRootFromParent_Done,
     /* 301757 */   // Label 6120: @301757
     /* 301757 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(301790), // Rule ID 1298 //
     /* 301762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301777 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 301777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 301780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301788 */     GIR_RootConstrainSelectedInstOperands,
     /* 301789 */     // GIR_Coverage, 1298,
     /* 301789 */     GIR_EraseRootFromParent_Done,
     /* 301790 */   // Label 6121: @301790
     /* 301790 */   GIM_Reject,
     /* 301791 */ // Label 6102: @301791
     /* 301791 */ GIM_Reject,
     /* 301792 */ // Label 5994: @301792
     /* 301792 */ GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(303312),
     /* 301797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 301806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301810 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(301888), // Rule ID 6209 //
     /* 301815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301860 */     // MIs[3] Operand 1
     /* 301860 */     // No operand predicates
     /* 301860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301870 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301886 */     GIR_RootConstrainSelectedInstOperands,
     /* 301887 */     // GIR_Coverage, 6209,
     /* 301887 */     GIR_EraseRootFromParent_Done,
     /* 301888 */   // Label 6123: @301888
     /* 301888 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(301972), // Rule ID 6121 //
     /* 301893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301929 */     // MIs[2] Operand 1
     /* 301929 */     // No operand predicates
     /* 301929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 301933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301952 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 301963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301970 */     GIR_RootConstrainSelectedInstOperands,
     /* 301971 */     // GIR_Coverage, 6121,
     /* 301971 */     GIR_EraseRootFromParent_Done,
     /* 301972 */   // Label 6124: @301972
     /* 301972 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(302053), // Rule ID 6153 //
     /* 301977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302021 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302025 */     // MIs[3] Operand 1
     /* 302025 */     // No operand predicates
     /* 302025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302035 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302051 */     GIR_RootConstrainSelectedInstOperands,
     /* 302052 */     // GIR_Coverage, 6153,
     /* 302052 */     GIR_EraseRootFromParent_Done,
     /* 302053 */   // Label 6125: @302053
     /* 302053 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(302137), // Rule ID 6185 //
     /* 302058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302111 */     // MIs[3] Operand 1
     /* 302111 */     // No operand predicates
     /* 302111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302117 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302135 */     GIR_RootConstrainSelectedInstOperands,
     /* 302136 */     // GIR_Coverage, 6185,
     /* 302136 */     GIR_EraseRootFromParent_Done,
     /* 302137 */   // Label 6126: @302137
     /* 302137 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(302215), // Rule ID 6231 //
     /* 302142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 302183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302191 */     // MIs[3] Operand 1
     /* 302191 */     // No operand predicates
     /* 302191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302197 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302213 */     GIR_RootConstrainSelectedInstOperands,
     /* 302214 */     // GIR_Coverage, 6231,
     /* 302214 */     GIR_EraseRootFromParent_Done,
     /* 302215 */   // Label 6127: @302215
     /* 302215 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(302296), // Rule ID 6089 //
     /* 302220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302268 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302272 */     // MIs[3] Operand 1
     /* 302272 */     // No operand predicates
     /* 302272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302278 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302294 */     GIR_RootConstrainSelectedInstOperands,
     /* 302295 */     // GIR_Coverage, 6089,
     /* 302295 */     GIR_EraseRootFromParent_Done,
     /* 302296 */   // Label 6128: @302296
     /* 302296 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302365), // Rule ID 2548 //
     /* 302301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302337 */     // MIs[2] Operand 1
     /* 302337 */     // No operand predicates
     /* 302337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302347 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302363 */     GIR_RootConstrainSelectedInstOperands,
     /* 302364 */     // GIR_Coverage, 2548,
     /* 302364 */     GIR_EraseRootFromParent_Done,
     /* 302365 */   // Label 6129: @302365
     /* 302365 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(302434), // Rule ID 6057 //
     /* 302370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 302385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302406 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 302410 */     // MIs[2] Operand 1
     /* 302410 */     // No operand predicates
     /* 302410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302416 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 302416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302432 */     GIR_RootConstrainSelectedInstOperands,
     /* 302433 */     // GIR_Coverage, 6057,
     /* 302433 */     GIR_EraseRootFromParent_Done,
     /* 302434 */   // Label 6130: @302434
     /* 302434 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302527), // Rule ID 6211 //
     /* 302439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302478 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302490 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302525 */     GIR_RootConstrainSelectedInstOperands,
     /* 302526 */     // GIR_Coverage, 6211,
     /* 302526 */     GIR_EraseRootFromParent_Done,
     /* 302527 */   // Label 6131: @302527
     /* 302527 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(302626), // Rule ID 6123 //
     /* 302532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302575 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302624 */     GIR_RootConstrainSelectedInstOperands,
     /* 302625 */     // GIR_Coverage, 6123,
     /* 302625 */     GIR_EraseRootFromParent_Done,
     /* 302626 */   // Label 6132: @302626
     /* 302626 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(302722), // Rule ID 6155 //
     /* 302631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302673 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302720 */     GIR_RootConstrainSelectedInstOperands,
     /* 302721 */     // GIR_Coverage, 6155,
     /* 302721 */     GIR_EraseRootFromParent_Done,
     /* 302722 */   // Label 6133: @302722
     /* 302722 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(302821), // Rule ID 6187 //
     /* 302727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302770 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302789 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302819 */     GIR_RootConstrainSelectedInstOperands,
     /* 302820 */     // GIR_Coverage, 6187,
     /* 302820 */     GIR_EraseRootFromParent_Done,
     /* 302821 */   // Label 6134: @302821
     /* 302821 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(302914), // Rule ID 6233 //
     /* 302826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302865 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302912 */     GIR_RootConstrainSelectedInstOperands,
     /* 302913 */     // GIR_Coverage, 6233,
     /* 302913 */     GIR_EraseRootFromParent_Done,
     /* 302914 */   // Label 6135: @302914
     /* 302914 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(303010), // Rule ID 6091 //
     /* 302919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302961 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303008 */     GIR_RootConstrainSelectedInstOperands,
     /* 303009 */     // GIR_Coverage, 6091,
     /* 303009 */     GIR_EraseRootFromParent_Done,
     /* 303010 */   // Label 6136: @303010
     /* 303010 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(303094), // Rule ID 2550 //
     /* 303015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303045 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303057 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303092 */     GIR_RootConstrainSelectedInstOperands,
     /* 303093 */     // GIR_Coverage, 2550,
     /* 303093 */     GIR_EraseRootFromParent_Done,
     /* 303094 */   // Label 6137: @303094
     /* 303094 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(303144), // Rule ID 13320 //
     /* 303099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303129 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 303132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303142 */     GIR_RootConstrainSelectedInstOperands,
     /* 303143 */     // GIR_Coverage, 13320,
     /* 303143 */     GIR_EraseRootFromParent_Done,
     /* 303144 */   // Label 6138: @303144
     /* 303144 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(303228), // Rule ID 6059 //
     /* 303149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 303168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303179 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303191 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 303214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303226 */     GIR_RootConstrainSelectedInstOperands,
     /* 303227 */     // GIR_Coverage, 6059,
     /* 303227 */     GIR_EraseRootFromParent_Done,
     /* 303228 */   // Label 6139: @303228
     /* 303228 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(303278), // Rule ID 1312 //
     /* 303233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303263 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 303266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303276 */     GIR_RootConstrainSelectedInstOperands,
     /* 303277 */     // GIR_Coverage, 1312,
     /* 303277 */     GIR_EraseRootFromParent_Done,
     /* 303278 */   // Label 6140: @303278
     /* 303278 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(303311), // Rule ID 1302 //
     /* 303283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303298 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 303301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303309 */     GIR_RootConstrainSelectedInstOperands,
     /* 303310 */     // GIR_Coverage, 1302,
     /* 303310 */     GIR_EraseRootFromParent_Done,
     /* 303311 */   // Label 6141: @303311
     /* 303311 */   GIM_Reject,
     /* 303312 */ // Label 6122: @303312
     /* 303312 */ GIM_Reject,
     /* 303313 */ // Label 5995: @303313
     /* 303313 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(304491),
     /* 303318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 303327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303331 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(303415), // Rule ID 6105 //
     /* 303336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303372 */     // MIs[2] Operand 1
     /* 303372 */     // No operand predicates
     /* 303372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303395 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303413 */     GIR_RootConstrainSelectedInstOperands,
     /* 303414 */     // GIR_Coverage, 6105,
     /* 303414 */     GIR_EraseRootFromParent_Done,
     /* 303415 */   // Label 6143: @303415
     /* 303415 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(303496), // Rule ID 6137 //
     /* 303420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303464 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303468 */     // MIs[3] Operand 1
     /* 303468 */     // No operand predicates
     /* 303468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303478 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303494 */     GIR_RootConstrainSelectedInstOperands,
     /* 303495 */     // GIR_Coverage, 6137,
     /* 303495 */     GIR_EraseRootFromParent_Done,
     /* 303496 */   // Label 6144: @303496
     /* 303496 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(303580), // Rule ID 6169 //
     /* 303501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303554 */     // MIs[3] Operand 1
     /* 303554 */     // No operand predicates
     /* 303554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303560 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303578 */     GIR_RootConstrainSelectedInstOperands,
     /* 303579 */     // GIR_Coverage, 6169,
     /* 303579 */     GIR_EraseRootFromParent_Done,
     /* 303580 */   // Label 6145: @303580
     /* 303580 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(303661), // Rule ID 6073 //
     /* 303585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303633 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303637 */     // MIs[3] Operand 1
     /* 303637 */     // No operand predicates
     /* 303637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303643 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303659 */     GIR_RootConstrainSelectedInstOperands,
     /* 303660 */     // GIR_Coverage, 6073,
     /* 303660 */     GIR_EraseRootFromParent_Done,
     /* 303661 */   // Label 6146: @303661
     /* 303661 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303730), // Rule ID 2532 //
     /* 303666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303702 */     // MIs[2] Operand 1
     /* 303702 */     // No operand predicates
     /* 303702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303712 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303728 */     GIR_RootConstrainSelectedInstOperands,
     /* 303729 */     // GIR_Coverage, 2532,
     /* 303729 */     GIR_EraseRootFromParent_Done,
     /* 303730 */   // Label 6147: @303730
     /* 303730 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303799), // Rule ID 6041 //
     /* 303735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303771 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303775 */     // MIs[2] Operand 1
     /* 303775 */     // No operand predicates
     /* 303775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303781 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303797 */     GIR_RootConstrainSelectedInstOperands,
     /* 303798 */     // GIR_Coverage, 6041,
     /* 303798 */     GIR_EraseRootFromParent_Done,
     /* 303799 */   // Label 6148: @303799
     /* 303799 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(303898), // Rule ID 6107 //
     /* 303804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303847 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 303890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303896 */     GIR_RootConstrainSelectedInstOperands,
     /* 303897 */     // GIR_Coverage, 6107,
     /* 303897 */     GIR_EraseRootFromParent_Done,
     /* 303898 */   // Label 6149: @303898
     /* 303898 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303994), // Rule ID 6139 //
     /* 303903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303945 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303992 */     GIR_RootConstrainSelectedInstOperands,
     /* 303993 */     // GIR_Coverage, 6139,
     /* 303993 */     GIR_EraseRootFromParent_Done,
     /* 303994 */   // Label 6150: @303994
     /* 303994 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(304093), // Rule ID 6171 //
     /* 303999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 304031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304042 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 304045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 304064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 304077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304091 */     GIR_RootConstrainSelectedInstOperands,
     /* 304092 */     // GIR_Coverage, 6171,
     /* 304092 */     GIR_EraseRootFromParent_Done,
     /* 304093 */   // Label 6151: @304093
     /* 304093 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(304189), // Rule ID 6075 //
     /* 304098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 304129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304140 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 304143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 304162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 304175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304187 */     GIR_RootConstrainSelectedInstOperands,
     /* 304188 */     // GIR_Coverage, 6075,
     /* 304188 */     GIR_EraseRootFromParent_Done,
     /* 304189 */   // Label 6152: @304189
     /* 304189 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(304273), // Rule ID 2534 //
     /* 304194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304224 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 304227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 304246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 304259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304271 */     GIR_RootConstrainSelectedInstOperands,
     /* 304272 */     // GIR_Coverage, 2534,
     /* 304272 */     GIR_EraseRootFromParent_Done,
     /* 304273 */   // Label 6153: @304273
     /* 304273 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(304323), // Rule ID 13312 //
     /* 304278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304308 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 304311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304321 */     GIR_RootConstrainSelectedInstOperands,
     /* 304322 */     // GIR_Coverage, 13312,
     /* 304322 */     GIR_EraseRootFromParent_Done,
     /* 304323 */   // Label 6154: @304323
     /* 304323 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(304407), // Rule ID 6043 //
     /* 304328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304358 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 304361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304377 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 304380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 304390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 304393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304405 */     GIR_RootConstrainSelectedInstOperands,
     /* 304406 */     // GIR_Coverage, 6043,
     /* 304406 */     GIR_EraseRootFromParent_Done,
     /* 304407 */   // Label 6155: @304407
     /* 304407 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(304457), // Rule ID 1304 //
     /* 304412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304442 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 304445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304455 */     GIR_RootConstrainSelectedInstOperands,
     /* 304456 */     // GIR_Coverage, 1304,
     /* 304456 */     GIR_EraseRootFromParent_Done,
     /* 304457 */   // Label 6156: @304457
     /* 304457 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(304490), // Rule ID 1294 //
     /* 304462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304477 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 304480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304488 */     GIR_RootConstrainSelectedInstOperands,
     /* 304489 */     // GIR_Coverage, 1294,
     /* 304489 */     GIR_EraseRootFromParent_Done,
     /* 304490 */   // Label 6157: @304490
     /* 304490 */   GIM_Reject,
     /* 304491 */ // Label 6142: @304491
     /* 304491 */ GIM_Reject,
     /* 304492 */ // Label 5996: @304492
     /* 304492 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(306012),
     /* 304497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 304506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304510 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(304588), // Rule ID 6203 //
     /* 304515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 304552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304556 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304560 */     // MIs[3] Operand 1
     /* 304560 */     // No operand predicates
     /* 304560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304570 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304586 */     GIR_RootConstrainSelectedInstOperands,
     /* 304587 */     // GIR_Coverage, 6203,
     /* 304587 */     GIR_EraseRootFromParent_Done,
     /* 304588 */   // Label 6159: @304588
     /* 304588 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(304672), // Rule ID 6117 //
     /* 304593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304629 */     // MIs[2] Operand 1
     /* 304629 */     // No operand predicates
     /* 304629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304641 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304652 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 304663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304670 */     GIR_RootConstrainSelectedInstOperands,
     /* 304671 */     // GIR_Coverage, 6117,
     /* 304671 */     GIR_EraseRootFromParent_Done,
     /* 304672 */   // Label 6160: @304672
     /* 304672 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(304753), // Rule ID 6149 //
     /* 304677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304721 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304725 */     // MIs[3] Operand 1
     /* 304725 */     // No operand predicates
     /* 304725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304735 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304751 */     GIR_RootConstrainSelectedInstOperands,
     /* 304752 */     // GIR_Coverage, 6149,
     /* 304752 */     GIR_EraseRootFromParent_Done,
     /* 304753 */   // Label 6161: @304753
     /* 304753 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(304837), // Rule ID 6181 //
     /* 304758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304807 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304811 */     // MIs[3] Operand 1
     /* 304811 */     // No operand predicates
     /* 304811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304817 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304835 */     GIR_RootConstrainSelectedInstOperands,
     /* 304836 */     // GIR_Coverage, 6181,
     /* 304836 */     GIR_EraseRootFromParent_Done,
     /* 304837 */   // Label 6162: @304837
     /* 304837 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(304915), // Rule ID 6225 //
     /* 304842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 304883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304891 */     // MIs[3] Operand 1
     /* 304891 */     // No operand predicates
     /* 304891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304897 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304913 */     GIR_RootConstrainSelectedInstOperands,
     /* 304914 */     // GIR_Coverage, 6225,
     /* 304914 */     GIR_EraseRootFromParent_Done,
     /* 304915 */   // Label 6163: @304915
     /* 304915 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(304996), // Rule ID 6085 //
     /* 304920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304968 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304972 */     // MIs[3] Operand 1
     /* 304972 */     // No operand predicates
     /* 304972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304978 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304994 */     GIR_RootConstrainSelectedInstOperands,
     /* 304995 */     // GIR_Coverage, 6085,
     /* 304995 */     GIR_EraseRootFromParent_Done,
     /* 304996 */   // Label 6164: @304996
     /* 304996 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(305065), // Rule ID 2544 //
     /* 305001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 305012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305037 */     // MIs[2] Operand 1
     /* 305037 */     // No operand predicates
     /* 305037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305047 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305063 */     GIR_RootConstrainSelectedInstOperands,
     /* 305064 */     // GIR_Coverage, 2544,
     /* 305064 */     GIR_EraseRootFromParent_Done,
     /* 305065 */   // Label 6165: @305065
     /* 305065 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(305134), // Rule ID 6053 //
     /* 305070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 305085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305110 */     // MIs[2] Operand 1
     /* 305110 */     // No operand predicates
     /* 305110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305116 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305132 */     GIR_RootConstrainSelectedInstOperands,
     /* 305133 */     // GIR_Coverage, 6053,
     /* 305133 */     GIR_EraseRootFromParent_Done,
     /* 305134 */   // Label 6166: @305134
     /* 305134 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(305227), // Rule ID 6207 //
     /* 305139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305178 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305225 */     GIR_RootConstrainSelectedInstOperands,
     /* 305226 */     // GIR_Coverage, 6207,
     /* 305226 */     GIR_EraseRootFromParent_Done,
     /* 305227 */   // Label 6167: @305227
     /* 305227 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(305326), // Rule ID 6119 //
     /* 305232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305275 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305324 */     GIR_RootConstrainSelectedInstOperands,
     /* 305325 */     // GIR_Coverage, 6119,
     /* 305325 */     GIR_EraseRootFromParent_Done,
     /* 305326 */   // Label 6168: @305326
     /* 305326 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(305422), // Rule ID 6151 //
     /* 305331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305373 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305420 */     GIR_RootConstrainSelectedInstOperands,
     /* 305421 */     // GIR_Coverage, 6151,
     /* 305421 */     GIR_EraseRootFromParent_Done,
     /* 305422 */   // Label 6169: @305422
     /* 305422 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(305521), // Rule ID 6183 //
     /* 305427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305470 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305519 */     GIR_RootConstrainSelectedInstOperands,
     /* 305520 */     // GIR_Coverage, 6183,
     /* 305520 */     GIR_EraseRootFromParent_Done,
     /* 305521 */   // Label 6170: @305521
     /* 305521 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(305614), // Rule ID 6229 //
     /* 305526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305565 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305612 */     GIR_RootConstrainSelectedInstOperands,
     /* 305613 */     // GIR_Coverage, 6229,
     /* 305613 */     GIR_EraseRootFromParent_Done,
     /* 305614 */   // Label 6171: @305614
     /* 305614 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(305710), // Rule ID 6087 //
     /* 305619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305661 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 305696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305708 */     GIR_RootConstrainSelectedInstOperands,
     /* 305709 */     // GIR_Coverage, 6087,
     /* 305709 */     GIR_EraseRootFromParent_Done,
     /* 305710 */   // Label 6172: @305710
     /* 305710 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(305794), // Rule ID 2546 //
     /* 305715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305745 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305764 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305792 */     GIR_RootConstrainSelectedInstOperands,
     /* 305793 */     // GIR_Coverage, 2546,
     /* 305793 */     GIR_EraseRootFromParent_Done,
     /* 305794 */   // Label 6173: @305794
     /* 305794 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(305844), // Rule ID 13318 //
     /* 305799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305829 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 305832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305842 */     GIR_RootConstrainSelectedInstOperands,
     /* 305843 */     // GIR_Coverage, 13318,
     /* 305843 */     GIR_EraseRootFromParent_Done,
     /* 305844 */   // Label 6174: @305844
     /* 305844 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(305928), // Rule ID 6055 //
     /* 305849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305879 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305926 */     GIR_RootConstrainSelectedInstOperands,
     /* 305927 */     // GIR_Coverage, 6055,
     /* 305927 */     GIR_EraseRootFromParent_Done,
     /* 305928 */   // Label 6175: @305928
     /* 305928 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(305978), // Rule ID 1310 //
     /* 305933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305963 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 305966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305976 */     GIR_RootConstrainSelectedInstOperands,
     /* 305977 */     // GIR_Coverage, 1310,
     /* 305977 */     GIR_EraseRootFromParent_Done,
     /* 305978 */   // Label 6176: @305978
     /* 305978 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(306011), // Rule ID 1300 //
     /* 305983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305998 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 306001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 306009 */     GIR_RootConstrainSelectedInstOperands,
     /* 306010 */     // GIR_Coverage, 1300,
     /* 306010 */     GIR_EraseRootFromParent_Done,
     /* 306011 */   // Label 6177: @306011
     /* 306011 */   GIM_Reject,
     /* 306012 */ // Label 6158: @306012
     /* 306012 */ GIM_Reject,
     /* 306013 */ // Label 5997: @306013
     /* 306013 */ GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(307191),
     /* 306018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 306024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 306027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306031 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(306115), // Rule ID 6101 //
     /* 306036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306072 */     // MIs[2] Operand 1
     /* 306072 */     // No operand predicates
     /* 306072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306095 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 306106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306113 */     GIR_RootConstrainSelectedInstOperands,
     /* 306114 */     // GIR_Coverage, 6101,
     /* 306114 */     GIR_EraseRootFromParent_Done,
     /* 306115 */   // Label 6179: @306115
     /* 306115 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(306196), // Rule ID 6133 //
     /* 306120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306164 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306168 */     // MIs[3] Operand 1
     /* 306168 */     // No operand predicates
     /* 306168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306178 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306194 */     GIR_RootConstrainSelectedInstOperands,
     /* 306195 */     // GIR_Coverage, 6133,
     /* 306195 */     GIR_EraseRootFromParent_Done,
     /* 306196 */   // Label 6180: @306196
     /* 306196 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(306280), // Rule ID 6165 //
     /* 306201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306250 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306254 */     // MIs[3] Operand 1
     /* 306254 */     // No operand predicates
     /* 306254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306260 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306278 */     GIR_RootConstrainSelectedInstOperands,
     /* 306279 */     // GIR_Coverage, 6165,
     /* 306279 */     GIR_EraseRootFromParent_Done,
     /* 306280 */   // Label 6181: @306280
     /* 306280 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(306361), // Rule ID 6069 //
     /* 306285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306333 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306337 */     // MIs[3] Operand 1
     /* 306337 */     // No operand predicates
     /* 306337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306343 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306359 */     GIR_RootConstrainSelectedInstOperands,
     /* 306360 */     // GIR_Coverage, 6069,
     /* 306360 */     GIR_EraseRootFromParent_Done,
     /* 306361 */   // Label 6182: @306361
     /* 306361 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(306430), // Rule ID 2528 //
     /* 306366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306402 */     // MIs[2] Operand 1
     /* 306402 */     // No operand predicates
     /* 306402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306412 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306428 */     GIR_RootConstrainSelectedInstOperands,
     /* 306429 */     // GIR_Coverage, 2528,
     /* 306429 */     GIR_EraseRootFromParent_Done,
     /* 306430 */   // Label 6183: @306430
     /* 306430 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(306499), // Rule ID 6037 //
     /* 306435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 306450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306475 */     // MIs[2] Operand 1
     /* 306475 */     // No operand predicates
     /* 306475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306481 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 306481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306497 */     GIR_RootConstrainSelectedInstOperands,
     /* 306498 */     // GIR_Coverage, 6037,
     /* 306498 */     GIR_EraseRootFromParent_Done,
     /* 306499 */   // Label 6184: @306499
     /* 306499 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(306598), // Rule ID 6103 //
     /* 306504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306547 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 306590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306596 */     GIR_RootConstrainSelectedInstOperands,
     /* 306597 */     // GIR_Coverage, 6103,
     /* 306597 */     GIR_EraseRootFromParent_Done,
     /* 306598 */   // Label 6185: @306598
     /* 306598 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(306694), // Rule ID 6135 //
     /* 306603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 306630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306645 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306692 */     GIR_RootConstrainSelectedInstOperands,
     /* 306693 */     // GIR_Coverage, 6135,
     /* 306693 */     GIR_EraseRootFromParent_Done,
     /* 306694 */   // Label 6186: @306694
     /* 306694 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(306793), // Rule ID 6167 //
     /* 306699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 306731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306742 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306791 */     GIR_RootConstrainSelectedInstOperands,
     /* 306792 */     // GIR_Coverage, 6167,
     /* 306792 */     GIR_EraseRootFromParent_Done,
     /* 306793 */   // Label 6187: @306793
     /* 306793 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(306889), // Rule ID 6071 //
     /* 306798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 306829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306840 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306887 */     GIR_RootConstrainSelectedInstOperands,
     /* 306888 */     // GIR_Coverage, 6071,
     /* 306888 */     GIR_EraseRootFromParent_Done,
     /* 306889 */   // Label 6188: @306889
     /* 306889 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(306973), // Rule ID 2530 //
     /* 306894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306924 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306971 */     GIR_RootConstrainSelectedInstOperands,
     /* 306972 */     // GIR_Coverage, 2530,
     /* 306972 */     GIR_EraseRootFromParent_Done,
     /* 306973 */   // Label 6189: @306973
     /* 306973 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(307023), // Rule ID 13314 //
     /* 306978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307008 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 307011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307021 */     GIR_RootConstrainSelectedInstOperands,
     /* 307022 */     // GIR_Coverage, 13314,
     /* 307022 */     GIR_EraseRootFromParent_Done,
     /* 307023 */   // Label 6190: @307023
     /* 307023 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(307107), // Rule ID 6039 //
     /* 307028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 307052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307058 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 307061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 307065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 307090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 307093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307105 */     GIR_RootConstrainSelectedInstOperands,
     /* 307106 */     // GIR_Coverage, 6039,
     /* 307106 */     GIR_EraseRootFromParent_Done,
     /* 307107 */   // Label 6191: @307107
     /* 307107 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(307157), // Rule ID 1306 //
     /* 307112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307142 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 307145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307155 */     GIR_RootConstrainSelectedInstOperands,
     /* 307156 */     // GIR_Coverage, 1306,
     /* 307156 */     GIR_EraseRootFromParent_Done,
     /* 307157 */   // Label 6192: @307157
     /* 307157 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(307190), // Rule ID 1296 //
     /* 307162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307177 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 307180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 307184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 307188 */     GIR_RootConstrainSelectedInstOperands,
     /* 307189 */     // GIR_Coverage, 1296,
     /* 307189 */     GIR_EraseRootFromParent_Done,
     /* 307190 */   // Label 6193: @307190
     /* 307190 */   GIM_Reject,
     /* 307191 */ // Label 6178: @307191
     /* 307191 */ GIM_Reject,
     /* 307192 */ // Label 5998: @307192
     /* 307192 */ GIM_Reject,
     /* 307193 */ // Label 61: @307193
     /* 307193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6202*/ GIMT_Encode4(307808),
     /* 307204 */ /*GILLT_s16*//*Label 6194*/ GIMT_Encode4(307244),
     /* 307208 */ /*GILLT_s32*//*Label 6195*/ GIMT_Encode4(307282),
     /* 307212 */ /*GILLT_s64*//*Label 6196*/ GIMT_Encode4(307320), GIMT_Encode4(0),
     /* 307220 */ /*GILLT_v2s32*//*Label 6197*/ GIMT_Encode4(307358),
     /* 307224 */ /*GILLT_v2s64*//*Label 6198*/ GIMT_Encode4(307396),
     /* 307228 */ /*GILLT_v4s16*//*Label 6199*/ GIMT_Encode4(307434),
     /* 307232 */ /*GILLT_v4s32*//*Label 6200*/ GIMT_Encode4(307472), GIMT_Encode4(0),
     /* 307240 */ /*GILLT_v8s16*//*Label 6201*/ GIMT_Encode4(307510),
     /* 307244 */ // Label 6194: @307244
     /* 307244 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(307281), // Rule ID 590 //
     /* 307249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 307258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307270 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 307275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307279 */   GIR_RootConstrainSelectedInstOperands,
     /* 307280 */   // GIR_Coverage, 590,
     /* 307280 */   GIR_Done,
     /* 307281 */ // Label 6203: @307281
     /* 307281 */ GIM_Reject,
     /* 307282 */ // Label 6195: @307282
     /* 307282 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(307319), // Rule ID 592 //
     /* 307287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 307296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307308 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 307308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 307313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307317 */   GIR_RootConstrainSelectedInstOperands,
     /* 307318 */   // GIR_Coverage, 592,
     /* 307318 */   GIR_Done,
     /* 307319 */ // Label 6204: @307319
     /* 307319 */ GIM_Reject,
     /* 307320 */ // Label 6196: @307320
     /* 307320 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(307357), // Rule ID 594 //
     /* 307325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 307334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307346 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 307346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 307351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307355 */   GIR_RootConstrainSelectedInstOperands,
     /* 307356 */   // GIR_Coverage, 594,
     /* 307356 */   GIR_Done,
     /* 307357 */ // Label 6205: @307357
     /* 307357 */ GIM_Reject,
     /* 307358 */ // Label 6197: @307358
     /* 307358 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(307395), // Rule ID 1228 //
     /* 307363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 307372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307384 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 307384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 307389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307393 */   GIR_RootConstrainSelectedInstOperands,
     /* 307394 */   // GIR_Coverage, 1228,
     /* 307394 */   GIR_Done,
     /* 307395 */ // Label 6206: @307395
     /* 307395 */ GIM_Reject,
     /* 307396 */ // Label 6198: @307396
     /* 307396 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(307433), // Rule ID 1232 //
     /* 307401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 307410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307422 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 307422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 307427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307431 */   GIR_RootConstrainSelectedInstOperands,
     /* 307432 */   // GIR_Coverage, 1232,
     /* 307432 */   GIR_Done,
     /* 307433 */ // Label 6207: @307433
     /* 307433 */ GIM_Reject,
     /* 307434 */ // Label 6199: @307434
     /* 307434 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(307471), // Rule ID 1224 //
     /* 307439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 307445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 307448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307460 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 307460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 307465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307469 */   GIR_RootConstrainSelectedInstOperands,
     /* 307470 */   // GIR_Coverage, 1224,
     /* 307470 */   GIR_Done,
     /* 307471 */ // Label 6208: @307471
     /* 307471 */ GIM_Reject,
     /* 307472 */ // Label 6200: @307472
     /* 307472 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(307509), // Rule ID 1230 //
     /* 307477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 307486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307498 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 307498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 307503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307507 */   GIR_RootConstrainSelectedInstOperands,
     /* 307508 */   // GIR_Coverage, 1230,
     /* 307508 */   GIR_Done,
     /* 307509 */ // Label 6209: @307509
     /* 307509 */ GIM_Reject,
     /* 307510 */ // Label 6201: @307510
     /* 307510 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(307807),
     /* 307515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 307521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307533 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(307552), // Rule ID 1226 //
     /* 307538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307541 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 307541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 307546 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307550 */     GIR_RootConstrainSelectedInstOperands,
     /* 307551 */     // GIR_Coverage, 1226,
     /* 307551 */     GIR_Done,
     /* 307552 */   // Label 6211: @307552
     /* 307552 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(307806), // Rule ID 7002 //
     /* 307557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 307560 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 307560 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 307563 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307567 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307572 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 307576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 307578 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 307581 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 307585 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307590 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 307596 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 307599 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 307603 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307608 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 307611 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 307614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 307616 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 307619 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307623 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307628 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307634 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307639 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307644 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 307647 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307651 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307656 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 307659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 307661 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 307664 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307668 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307673 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307679 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307684 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307689 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 307692 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 307696 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307701 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 307704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307706 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 307709 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 307713 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307718 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307721 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 307724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 307726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 307729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 307733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307738 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307772 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 307796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 307804 */     GIR_RootConstrainSelectedInstOperands,
     /* 307805 */     // GIR_Coverage, 7002,
     /* 307805 */     GIR_EraseRootFromParent_Done,
     /* 307806 */   // Label 6212: @307806
     /* 307806 */   GIM_Reject,
     /* 307807 */ // Label 6210: @307807
     /* 307807 */ GIM_Reject,
     /* 307808 */ // Label 6202: @307808
     /* 307808 */ GIM_Reject,
     /* 307809 */ // Label 62: @307809
     /* 307809 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6221*/ GIMT_Encode4(311315),
     /* 307820 */ /*GILLT_s16*//*Label 6213*/ GIMT_Encode4(307860),
     /* 307824 */ /*GILLT_s32*//*Label 6214*/ GIMT_Encode4(309028),
     /* 307828 */ /*GILLT_s64*//*Label 6215*/ GIMT_Encode4(310051), GIMT_Encode4(0),
     /* 307836 */ /*GILLT_v2s32*//*Label 6216*/ GIMT_Encode4(311074),
     /* 307840 */ /*GILLT_v2s64*//*Label 6217*/ GIMT_Encode4(311101),
     /* 307844 */ /*GILLT_v4s16*//*Label 6218*/ GIMT_Encode4(311128),
     /* 307848 */ /*GILLT_v4s32*//*Label 6219*/ GIMT_Encode4(311208), GIMT_Encode4(0),
     /* 307856 */ /*GILLT_v8s16*//*Label 6220*/ GIMT_Encode4(311235),
     /* 307860 */ // Label 6213: @307860
     /* 307860 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(309027),
     /* 307865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307872 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(308030), // Rule ID 4847 //
     /* 307877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307937 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307946 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307957 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 307960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307969 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307997 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308028 */     GIR_RootConstrainSelectedInstOperands,
     /* 308029 */     // GIR_Coverage, 4847,
     /* 308029 */     GIR_EraseRootFromParent_Done,
     /* 308030 */   // Label 6223: @308030
     /* 308030 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(308188), // Rule ID 4846 //
     /* 308035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308054 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308079 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308091 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308099 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308104 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308115 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 308118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308127 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308155 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308186 */     GIR_RootConstrainSelectedInstOperands,
     /* 308187 */     // GIR_Coverage, 4846,
     /* 308187 */     GIR_EraseRootFromParent_Done,
     /* 308188 */   // Label 6224: @308188
     /* 308188 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(308299), // Rule ID 4845 //
     /* 308193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308212 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308237 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308253 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 308253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308265 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308297 */     GIR_RootConstrainSelectedInstOperands,
     /* 308298 */     // GIR_Coverage, 4845,
     /* 308298 */     GIR_EraseRootFromParent_Done,
     /* 308299 */   // Label 6225: @308299
     /* 308299 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(308410), // Rule ID 4843 //
     /* 308304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308353 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308364 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308376 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308408 */     GIR_RootConstrainSelectedInstOperands,
     /* 308409 */     // GIR_Coverage, 4843,
     /* 308409 */     GIR_EraseRootFromParent_Done,
     /* 308410 */   // Label 6226: @308410
     /* 308410 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(308521), // Rule ID 4844 //
     /* 308415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308434 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308459 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308475 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 308475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308487 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308519 */     GIR_RootConstrainSelectedInstOperands,
     /* 308520 */     // GIR_Coverage, 4844,
     /* 308520 */     GIR_EraseRootFromParent_Done,
     /* 308521 */   // Label 6227: @308521
     /* 308521 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(308632), // Rule ID 4842 //
     /* 308526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308545 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308575 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308586 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 308586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 308604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308630 */     GIR_RootConstrainSelectedInstOperands,
     /* 308631 */     // GIR_Coverage, 4842,
     /* 308631 */     GIR_EraseRootFromParent_Done,
     /* 308632 */   // Label 6228: @308632
     /* 308632 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(308696), // Rule ID 650 //
     /* 308637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308677 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 308677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308694 */     GIR_RootConstrainSelectedInstOperands,
     /* 308695 */     // GIR_Coverage, 650,
     /* 308695 */     GIR_EraseRootFromParent_Done,
     /* 308696 */   // Label 6229: @308696
     /* 308696 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308760), // Rule ID 649 //
     /* 308701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 308724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308741 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 308741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308758 */     GIR_RootConstrainSelectedInstOperands,
     /* 308759 */     // GIR_Coverage, 649,
     /* 308759 */     GIR_EraseRootFromParent_Done,
     /* 308760 */   // Label 6230: @308760
     /* 308760 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308811), // Rule ID 626 //
     /* 308765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 308776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308796 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 308799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308809 */     GIR_RootConstrainSelectedInstOperands,
     /* 308810 */     // GIR_Coverage, 626,
     /* 308810 */     GIR_EraseRootFromParent_Done,
     /* 308811 */   // Label 6231: @308811
     /* 308811 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308862), // Rule ID 625 //
     /* 308816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 308827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308847 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 308850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308860 */     GIR_RootConstrainSelectedInstOperands,
     /* 308861 */     // GIR_Coverage, 625,
     /* 308861 */     GIR_EraseRootFromParent_Done,
     /* 308862 */   // Label 6232: @308862
     /* 308862 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308881), // Rule ID 524 //
     /* 308867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308874 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 308874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 308879 */     GIR_RootConstrainSelectedInstOperands,
     /* 308880 */     // GIR_Coverage, 524,
     /* 308880 */     GIR_Done,
     /* 308881 */   // Label 6233: @308881
     /* 308881 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(309026), // Rule ID 6369 //
     /* 308886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308890 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 308890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 308893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 308904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 308907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308916 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308919 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 308923 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 308926 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308931 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308941 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308944 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308948 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308953 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 308956 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 308968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308973 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308976 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 308981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 309015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309025 */     // GIR_Coverage, 6369,
     /* 309025 */     GIR_EraseRootFromParent_Done,
     /* 309026 */   // Label 6234: @309026
     /* 309026 */   GIM_Reject,
     /* 309027 */ // Label 6222: @309027
     /* 309027 */ GIM_Reject,
     /* 309028 */ // Label 6214: @309028
     /* 309028 */ GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(310050),
     /* 309033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309040 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(309198), // Rule ID 4853 //
     /* 309045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309105 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309114 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309125 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 309125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 309128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309137 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 309143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 309171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309196 */     GIR_RootConstrainSelectedInstOperands,
     /* 309197 */     // GIR_Coverage, 4853,
     /* 309197 */     GIR_EraseRootFromParent_Done,
     /* 309198 */   // Label 6236: @309198
     /* 309198 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(309356), // Rule ID 4852 //
     /* 309203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309222 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309247 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309272 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309283 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 309283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 309286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309295 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 309301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 309329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309354 */     GIR_RootConstrainSelectedInstOperands,
     /* 309355 */     // GIR_Coverage, 4852,
     /* 309355 */     GIR_EraseRootFromParent_Done,
     /* 309356 */   // Label 6237: @309356
     /* 309356 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(309467), // Rule ID 4851 //
     /* 309361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309380 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309405 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309421 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309433 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 309439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309465 */     GIR_RootConstrainSelectedInstOperands,
     /* 309466 */     // GIR_Coverage, 4851,
     /* 309466 */     GIR_EraseRootFromParent_Done,
     /* 309467 */   // Label 6238: @309467
     /* 309467 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(309578), // Rule ID 4849 //
     /* 309472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309491 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309532 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 309532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309544 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 309550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309576 */     GIR_RootConstrainSelectedInstOperands,
     /* 309577 */     // GIR_Coverage, 4849,
     /* 309577 */     GIR_EraseRootFromParent_Done,
     /* 309578 */   // Label 6239: @309578
     /* 309578 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(309689), // Rule ID 4850 //
     /* 309583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309627 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309643 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309655 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 309661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309687 */     GIR_RootConstrainSelectedInstOperands,
     /* 309688 */     // GIR_Coverage, 4850,
     /* 309688 */     GIR_EraseRootFromParent_Done,
     /* 309689 */   // Label 6240: @309689
     /* 309689 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(309800), // Rule ID 4848 //
     /* 309694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309713 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309743 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309754 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 309754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 309772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309798 */     GIR_RootConstrainSelectedInstOperands,
     /* 309799 */     // GIR_Coverage, 4848,
     /* 309799 */     GIR_EraseRootFromParent_Done,
     /* 309800 */   // Label 6241: @309800
     /* 309800 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(309864), // Rule ID 652 //
     /* 309805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309824 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309845 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309862 */     GIR_RootConstrainSelectedInstOperands,
     /* 309863 */     // GIR_Coverage, 652,
     /* 309863 */     GIR_EraseRootFromParent_Done,
     /* 309864 */   // Label 6242: @309864
     /* 309864 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(309928), // Rule ID 651 //
     /* 309869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309888 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309909 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309926 */     GIR_RootConstrainSelectedInstOperands,
     /* 309927 */     // GIR_Coverage, 651,
     /* 309927 */     GIR_EraseRootFromParent_Done,
     /* 309928 */   // Label 6243: @309928
     /* 309928 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(309979), // Rule ID 628 //
     /* 309933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 309944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309964 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 309964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 309967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309977 */     GIR_RootConstrainSelectedInstOperands,
     /* 309978 */     // GIR_Coverage, 628,
     /* 309978 */     GIR_EraseRootFromParent_Done,
     /* 309979 */   // Label 6244: @309979
     /* 309979 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(310030), // Rule ID 627 //
     /* 309984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 309995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 310003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310015 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 310015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 310018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310028 */     GIR_RootConstrainSelectedInstOperands,
     /* 310029 */     // GIR_Coverage, 627,
     /* 310029 */     GIR_EraseRootFromParent_Done,
     /* 310030 */   // Label 6245: @310030
     /* 310030 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310049), // Rule ID 525 //
     /* 310035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310042 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 310042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 310047 */     GIR_RootConstrainSelectedInstOperands,
     /* 310048 */     // GIR_Coverage, 525,
     /* 310048 */     GIR_Done,
     /* 310049 */   // Label 6246: @310049
     /* 310049 */   GIM_Reject,
     /* 310050 */ // Label 6235: @310050
     /* 310050 */ GIM_Reject,
     /* 310051 */ // Label 6215: @310051
     /* 310051 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(311073),
     /* 310056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310063 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(310221), // Rule ID 4859 //
     /* 310068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310112 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310132 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310137 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310148 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 310148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 310151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310160 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 310166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310188 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 310194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310219 */     GIR_RootConstrainSelectedInstOperands,
     /* 310220 */     // GIR_Coverage, 4859,
     /* 310220 */     GIR_EraseRootFromParent_Done,
     /* 310221 */   // Label 6248: @310221
     /* 310221 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(310379), // Rule ID 4858 //
     /* 310226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310245 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310270 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 310278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310295 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310306 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 310306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 310309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310318 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 310324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310329 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 310352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310377 */     GIR_RootConstrainSelectedInstOperands,
     /* 310378 */     // GIR_Coverage, 4858,
     /* 310378 */     GIR_EraseRootFromParent_Done,
     /* 310379 */   // Label 6249: @310379
     /* 310379 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(310490), // Rule ID 4857 //
     /* 310384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310403 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310428 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310444 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 310462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310488 */     GIR_RootConstrainSelectedInstOperands,
     /* 310489 */     // GIR_Coverage, 4857,
     /* 310489 */     GIR_EraseRootFromParent_Done,
     /* 310490 */   // Label 6250: @310490
     /* 310490 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(310601), // Rule ID 4855 //
     /* 310495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310544 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310555 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 310555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310567 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 310573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310599 */     GIR_RootConstrainSelectedInstOperands,
     /* 310600 */     // GIR_Coverage, 4855,
     /* 310600 */     GIR_EraseRootFromParent_Done,
     /* 310601 */   // Label 6251: @310601
     /* 310601 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(310712), // Rule ID 4856 //
     /* 310606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310625 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310650 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310666 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 310684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310710 */     GIR_RootConstrainSelectedInstOperands,
     /* 310711 */     // GIR_Coverage, 4856,
     /* 310711 */     GIR_EraseRootFromParent_Done,
     /* 310712 */   // Label 6252: @310712
     /* 310712 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(310823), // Rule ID 4854 //
     /* 310717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310766 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310777 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 310777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310789 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 310795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310821 */     GIR_RootConstrainSelectedInstOperands,
     /* 310822 */     // GIR_Coverage, 4854,
     /* 310822 */     GIR_EraseRootFromParent_Done,
     /* 310823 */   // Label 6253: @310823
     /* 310823 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(310887), // Rule ID 654 //
     /* 310828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310847 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310868 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310885 */     GIR_RootConstrainSelectedInstOperands,
     /* 310886 */     // GIR_Coverage, 654,
     /* 310886 */     GIR_EraseRootFromParent_Done,
     /* 310887 */   // Label 6254: @310887
     /* 310887 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(310951), // Rule ID 653 //
     /* 310892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310932 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310949 */     GIR_RootConstrainSelectedInstOperands,
     /* 310950 */     // GIR_Coverage, 653,
     /* 310950 */     GIR_EraseRootFromParent_Done,
     /* 310951 */   // Label 6255: @310951
     /* 310951 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(311002), // Rule ID 630 //
     /* 310956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 310967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310987 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 310987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 310990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311000 */     GIR_RootConstrainSelectedInstOperands,
     /* 311001 */     // GIR_Coverage, 630,
     /* 311001 */     GIR_EraseRootFromParent_Done,
     /* 311002 */   // Label 6256: @311002
     /* 311002 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(311053), // Rule ID 629 //
     /* 311007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 311018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311038 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 311038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 311041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311051 */     GIR_RootConstrainSelectedInstOperands,
     /* 311052 */     // GIR_Coverage, 629,
     /* 311052 */     GIR_EraseRootFromParent_Done,
     /* 311053 */   // Label 6257: @311053
     /* 311053 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(311072), // Rule ID 526 //
     /* 311058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311065 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 311065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 311070 */     GIR_RootConstrainSelectedInstOperands,
     /* 311071 */     // GIR_Coverage, 526,
     /* 311071 */     GIR_Done,
     /* 311072 */   // Label 6258: @311072
     /* 311072 */   GIM_Reject,
     /* 311073 */ // Label 6247: @311073
     /* 311073 */ GIM_Reject,
     /* 311074 */ // Label 6216: @311074
     /* 311074 */ GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(311100), // Rule ID 860 //
     /* 311079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311093 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 311093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 311098 */   GIR_RootConstrainSelectedInstOperands,
     /* 311099 */   // GIR_Coverage, 860,
     /* 311099 */   GIR_Done,
     /* 311100 */ // Label 6259: @311100
     /* 311100 */ GIM_Reject,
     /* 311101 */ // Label 6217: @311101
     /* 311101 */ GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(311127), // Rule ID 862 //
     /* 311106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311120 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 311120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 311125 */   GIR_RootConstrainSelectedInstOperands,
     /* 311126 */   // GIR_Coverage, 862,
     /* 311126 */   GIR_Done,
     /* 311127 */ // Label 6260: @311127
     /* 311127 */ GIM_Reject,
     /* 311128 */ // Label 6218: @311128
     /* 311128 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(311207),
     /* 311133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311144 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(311159), // Rule ID 858 //
     /* 311149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311152 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 311152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 311157 */     GIR_RootConstrainSelectedInstOperands,
     /* 311158 */     // GIR_Coverage, 858,
     /* 311158 */     GIR_Done,
     /* 311159 */   // Label 6262: @311159
     /* 311159 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(311206), // Rule ID 6372 //
     /* 311164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311167 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 311167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 311174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311179 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 311189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 311192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 311197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311204 */     GIR_RootConstrainSelectedInstOperands,
     /* 311205 */     // GIR_Coverage, 6372,
     /* 311205 */     GIR_EraseRootFromParent_Done,
     /* 311206 */   // Label 6263: @311206
     /* 311206 */   GIM_Reject,
     /* 311207 */ // Label 6261: @311207
     /* 311207 */ GIM_Reject,
     /* 311208 */ // Label 6219: @311208
     /* 311208 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(311234), // Rule ID 861 //
     /* 311213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311227 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 311227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 311232 */   GIR_RootConstrainSelectedInstOperands,
     /* 311233 */   // GIR_Coverage, 861,
     /* 311233 */   GIR_Done,
     /* 311234 */ // Label 6264: @311234
     /* 311234 */ GIM_Reject,
     /* 311235 */ // Label 6220: @311235
     /* 311235 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(311314),
     /* 311240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311251 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(311266), // Rule ID 859 //
     /* 311256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311259 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 311259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 311264 */     GIR_RootConstrainSelectedInstOperands,
     /* 311265 */     // GIR_Coverage, 859,
     /* 311265 */     GIR_Done,
     /* 311266 */   // Label 6266: @311266
     /* 311266 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(311313), // Rule ID 6373 //
     /* 311271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311274 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 311274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 311277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 311281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311286 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 311296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 311299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 311304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311311 */     GIR_RootConstrainSelectedInstOperands,
     /* 311312 */     // GIR_Coverage, 6373,
     /* 311312 */     GIR_EraseRootFromParent_Done,
     /* 311313 */   // Label 6267: @311313
     /* 311313 */   GIM_Reject,
     /* 311314 */ // Label 6265: @311314
     /* 311314 */ GIM_Reject,
     /* 311315 */ // Label 6221: @311315
     /* 311315 */ GIM_Reject,
     /* 311316 */ // Label 63: @311316
     /* 311316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6272*/ GIMT_Encode4(311563),
     /* 311327 */ /*GILLT_s32*//*Label 6268*/ GIMT_Encode4(311355),
     /* 311331 */ /*GILLT_s64*//*Label 6269*/ GIMT_Encode4(311386), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 311343 */ /*GILLT_v2s64*//*Label 6270*/ GIMT_Encode4(311447), GIMT_Encode4(0),
     /* 311351 */ /*GILLT_v4s32*//*Label 6271*/ GIMT_Encode4(311505),
     /* 311355 */ // Label 6268: @311355
     /* 311355 */ GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(311385), // Rule ID 516 //
     /* 311360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311374 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 311374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 311379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311383 */   GIR_RootConstrainSelectedInstOperands,
     /* 311384 */   // GIR_Coverage, 516,
     /* 311384 */   GIR_Done,
     /* 311385 */ // Label 6273: @311385
     /* 311385 */ GIM_Reject,
     /* 311386 */ // Label 6269: @311386
     /* 311386 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(311416), // Rule ID 514 //
     /* 311391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311405 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 311405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 311410 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311414 */   GIR_RootConstrainSelectedInstOperands,
     /* 311415 */   // GIR_Coverage, 514,
     /* 311415 */   GIR_Done,
     /* 311416 */ // Label 6274: @311416
     /* 311416 */ GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(311446), // Rule ID 518 //
     /* 311421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311435 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 311435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 311440 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311444 */   GIR_RootConstrainSelectedInstOperands,
     /* 311445 */   // GIR_Coverage, 518,
     /* 311445 */   GIR_Done,
     /* 311446 */ // Label 6275: @311446
     /* 311446 */ GIM_Reject,
     /* 311447 */ // Label 6270: @311447
     /* 311447 */ GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(311504),
     /* 311452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311459 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(311483), // Rule ID 4902 //
     /* 311464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 311471 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 311471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 311474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311481 */     GIR_RootConstrainSelectedInstOperands,
     /* 311482 */     // GIR_Coverage, 4902,
     /* 311482 */     GIR_EraseRootFromParent_Done,
     /* 311483 */   // Label 6277: @311483
     /* 311483 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(311503), // Rule ID 4900 //
     /* 311488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311492 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 311492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 311497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311501 */     GIR_RootConstrainSelectedInstOperands,
     /* 311502 */     // GIR_Coverage, 4900,
     /* 311502 */     GIR_Done,
     /* 311503 */   // Label 6278: @311503
     /* 311503 */   GIM_Reject,
     /* 311504 */ // Label 6276: @311504
     /* 311504 */ GIM_Reject,
     /* 311505 */ // Label 6271: @311505
     /* 311505 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(311562),
     /* 311510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311517 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(311541), // Rule ID 4906 //
     /* 311522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 311529 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 311529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 311532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311539 */     GIR_RootConstrainSelectedInstOperands,
     /* 311540 */     // GIR_Coverage, 4906,
     /* 311540 */     GIR_EraseRootFromParent_Done,
     /* 311541 */   // Label 6280: @311541
     /* 311541 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311561), // Rule ID 4904 //
     /* 311546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311550 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 311550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 311555 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311559 */     GIR_RootConstrainSelectedInstOperands,
     /* 311560 */     // GIR_Coverage, 4904,
     /* 311560 */     GIR_Done,
     /* 311561 */   // Label 6281: @311561
     /* 311561 */   GIM_Reject,
     /* 311562 */ // Label 6279: @311562
     /* 311562 */ GIM_Reject,
     /* 311563 */ // Label 6272: @311563
     /* 311563 */ GIM_Reject,
     /* 311564 */ // Label 64: @311564
     /* 311564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6286*/ GIMT_Encode4(311751),
     /* 311575 */ /*GILLT_s16*//*Label 6282*/ GIMT_Encode4(311603),
     /* 311579 */ /*GILLT_s32*//*Label 6283*/ GIMT_Encode4(311664), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 311591 */ /*GILLT_v2s32*//*Label 6284*/ GIMT_Encode4(311695), GIMT_Encode4(0),
     /* 311599 */ /*GILLT_v4s16*//*Label 6285*/ GIMT_Encode4(311723),
     /* 311603 */ // Label 6282: @311603
     /* 311603 */ GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311633), // Rule ID 510 //
     /* 311608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311622 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 311622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 311627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311631 */   GIR_RootConstrainSelectedInstOperands,
     /* 311632 */   // GIR_Coverage, 510,
     /* 311632 */   GIR_Done,
     /* 311633 */ // Label 6287: @311633
     /* 311633 */ GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311663), // Rule ID 520 //
     /* 311638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311652 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 311652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 311657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311661 */   GIR_RootConstrainSelectedInstOperands,
     /* 311662 */   // GIR_Coverage, 520,
     /* 311662 */   GIR_Done,
     /* 311663 */ // Label 6288: @311663
     /* 311663 */ GIM_Reject,
     /* 311664 */ // Label 6283: @311664
     /* 311664 */ GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311694), // Rule ID 512 //
     /* 311669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311683 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 311683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 311688 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311692 */   GIR_RootConstrainSelectedInstOperands,
     /* 311693 */   // GIR_Coverage, 512,
     /* 311693 */   GIR_Done,
     /* 311694 */ // Label 6289: @311694
     /* 311694 */ GIM_Reject,
     /* 311695 */ // Label 6284: @311695
     /* 311695 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311722), // Rule ID 4910 //
     /* 311700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311711 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 311711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 311716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311720 */   GIR_RootConstrainSelectedInstOperands,
     /* 311721 */   // GIR_Coverage, 4910,
     /* 311721 */   GIR_Done,
     /* 311722 */ // Label 6290: @311722
     /* 311722 */ GIM_Reject,
     /* 311723 */ // Label 6285: @311723
     /* 311723 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311750), // Rule ID 4912 //
     /* 311728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311739 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 311739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 311744 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311748 */   GIR_RootConstrainSelectedInstOperands,
     /* 311749 */   // GIR_Coverage, 4912,
     /* 311749 */   GIR_Done,
     /* 311750 */ // Label 6291: @311750
     /* 311750 */ GIM_Reject,
     /* 311751 */ // Label 6286: @311751
     /* 311751 */ GIM_Reject,
     /* 311752 */ // Label 65: @311752
     /* 311752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6299*/ GIMT_Encode4(312728),
     /* 311763 */ /*GILLT_s32*//*Label 6292*/ GIMT_Encode4(311799),
     /* 311767 */ /*GILLT_s64*//*Label 6293*/ GIMT_Encode4(312186), GIMT_Encode4(0),
     /* 311775 */ /*GILLT_v2s32*//*Label 6294*/ GIMT_Encode4(312573),
     /* 311779 */ /*GILLT_v2s64*//*Label 6295*/ GIMT_Encode4(312604),
     /* 311783 */ /*GILLT_v4s16*//*Label 6296*/ GIMT_Encode4(312635),
     /* 311787 */ /*GILLT_v4s32*//*Label 6297*/ GIMT_Encode4(312666), GIMT_Encode4(0),
     /* 311795 */ /*GILLT_v8s16*//*Label 6298*/ GIMT_Encode4(312697),
     /* 311799 */ // Label 6292: @311799
     /* 311799 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(311836), // Rule ID 4649 //
     /* 311804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311811 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311819 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311825 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 311828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311830 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311834 */   GIR_RootConstrainSelectedInstOperands,
     /* 311835 */   // GIR_Coverage, 4649,
     /* 311835 */   GIR_EraseRootFromParent_Done,
     /* 311836 */ // Label 6300: @311836
     /* 311836 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311873), // Rule ID 4651 //
     /* 311841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311862 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 311865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311867 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311871 */   GIR_RootConstrainSelectedInstOperands,
     /* 311872 */   // GIR_Coverage, 4651,
     /* 311872 */   GIR_EraseRootFromParent_Done,
     /* 311873 */ // Label 6301: @311873
     /* 311873 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311910), // Rule ID 4669 //
     /* 311878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311885 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311889 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311893 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311899 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 311902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311904 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311908 */   GIR_RootConstrainSelectedInstOperands,
     /* 311909 */   // GIR_Coverage, 4669,
     /* 311909 */   GIR_EraseRootFromParent_Done,
     /* 311910 */ // Label 6302: @311910
     /* 311910 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311947), // Rule ID 4671 //
     /* 311915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311930 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311936 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 311939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311941 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311945 */   GIR_RootConstrainSelectedInstOperands,
     /* 311946 */   // GIR_Coverage, 4671,
     /* 311946 */   GIR_EraseRootFromParent_Done,
     /* 311947 */ // Label 6303: @311947
     /* 311947 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311984), // Rule ID 4709 //
     /* 311952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311967 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311971 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311973 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 311976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311978 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311982 */   GIR_RootConstrainSelectedInstOperands,
     /* 311983 */   // GIR_Coverage, 4709,
     /* 311983 */   GIR_EraseRootFromParent_Done,
     /* 311984 */ // Label 6304: @311984
     /* 311984 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(312021), // Rule ID 4711 //
     /* 311989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312004 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312010 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 312013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312019 */   GIR_RootConstrainSelectedInstOperands,
     /* 312020 */   // GIR_Coverage, 4711,
     /* 312020 */   GIR_EraseRootFromParent_Done,
     /* 312021 */ // Label 6305: @312021
     /* 312021 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(312058), // Rule ID 4689 //
     /* 312026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312041 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312045 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312047 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 312050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312052 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312056 */   GIR_RootConstrainSelectedInstOperands,
     /* 312057 */   // GIR_Coverage, 4689,
     /* 312057 */   GIR_EraseRootFromParent_Done,
     /* 312058 */ // Label 6306: @312058
     /* 312058 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(312095), // Rule ID 4691 //
     /* 312063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312078 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312084 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 312087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312089 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312093 */   GIR_RootConstrainSelectedInstOperands,
     /* 312094 */   // GIR_Coverage, 4691,
     /* 312094 */   GIR_EraseRootFromParent_Done,
     /* 312095 */ // Label 6307: @312095
     /* 312095 */ GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(312125), // Rule ID 395 //
     /* 312100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312114 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 312114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 312119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312123 */   GIR_RootConstrainSelectedInstOperands,
     /* 312124 */   // GIR_Coverage, 395,
     /* 312124 */   GIR_Done,
     /* 312125 */ // Label 6308: @312125
     /* 312125 */ GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(312155), // Rule ID 399 //
     /* 312130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312144 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 312144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 312149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312153 */   GIR_RootConstrainSelectedInstOperands,
     /* 312154 */   // GIR_Coverage, 399,
     /* 312154 */   GIR_Done,
     /* 312155 */ // Label 6309: @312155
     /* 312155 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(312185), // Rule ID 403 //
     /* 312160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312174 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 312174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 312179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312183 */   GIR_RootConstrainSelectedInstOperands,
     /* 312184 */   // GIR_Coverage, 403,
     /* 312184 */   GIR_Done,
     /* 312185 */ // Label 6310: @312185
     /* 312185 */ GIM_Reject,
     /* 312186 */ // Label 6293: @312186
     /* 312186 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(312223), // Rule ID 4650 //
     /* 312191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312198 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312202 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312206 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312210 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312212 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 312215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312217 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312221 */   GIR_RootConstrainSelectedInstOperands,
     /* 312222 */   // GIR_Coverage, 4650,
     /* 312222 */   GIR_EraseRootFromParent_Done,
     /* 312223 */ // Label 6311: @312223
     /* 312223 */ GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(312260), // Rule ID 4652 //
     /* 312228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312243 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312249 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 312252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312254 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312258 */   GIR_RootConstrainSelectedInstOperands,
     /* 312259 */   // GIR_Coverage, 4652,
     /* 312259 */   GIR_EraseRootFromParent_Done,
     /* 312260 */ // Label 6312: @312260
     /* 312260 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(312297), // Rule ID 4670 //
     /* 312265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312272 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312276 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312280 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312286 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 312289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312291 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312295 */   GIR_RootConstrainSelectedInstOperands,
     /* 312296 */   // GIR_Coverage, 4670,
     /* 312296 */   GIR_EraseRootFromParent_Done,
     /* 312297 */ // Label 6313: @312297
     /* 312297 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(312334), // Rule ID 4672 //
     /* 312302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312317 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312321 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312323 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 312326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312328 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312332 */   GIR_RootConstrainSelectedInstOperands,
     /* 312333 */   // GIR_Coverage, 4672,
     /* 312333 */   GIR_EraseRootFromParent_Done,
     /* 312334 */ // Label 6314: @312334
     /* 312334 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(312371), // Rule ID 4710 //
     /* 312339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312360 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 312363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312369 */   GIR_RootConstrainSelectedInstOperands,
     /* 312370 */   // GIR_Coverage, 4710,
     /* 312370 */   GIR_EraseRootFromParent_Done,
     /* 312371 */ // Label 6315: @312371
     /* 312371 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(312408), // Rule ID 4712 //
     /* 312376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312391 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312397 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 312400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312402 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312406 */   GIR_RootConstrainSelectedInstOperands,
     /* 312407 */   // GIR_Coverage, 4712,
     /* 312407 */   GIR_EraseRootFromParent_Done,
     /* 312408 */ // Label 6316: @312408
     /* 312408 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(312445), // Rule ID 4690 //
     /* 312413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312420 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312424 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312428 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312434 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 312437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312439 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312443 */   GIR_RootConstrainSelectedInstOperands,
     /* 312444 */   // GIR_Coverage, 4690,
     /* 312444 */   GIR_EraseRootFromParent_Done,
     /* 312445 */ // Label 6317: @312445
     /* 312445 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(312482), // Rule ID 4692 //
     /* 312450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312465 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312471 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 312474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312476 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312480 */   GIR_RootConstrainSelectedInstOperands,
     /* 312481 */   // GIR_Coverage, 4692,
     /* 312481 */   GIR_EraseRootFromParent_Done,
     /* 312482 */ // Label 6318: @312482
     /* 312482 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312512), // Rule ID 397 //
     /* 312487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312501 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 312501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 312506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312510 */   GIR_RootConstrainSelectedInstOperands,
     /* 312511 */   // GIR_Coverage, 397,
     /* 312511 */   GIR_Done,
     /* 312512 */ // Label 6319: @312512
     /* 312512 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312542), // Rule ID 401 //
     /* 312517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312531 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 312531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 312536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312540 */   GIR_RootConstrainSelectedInstOperands,
     /* 312541 */   // GIR_Coverage, 401,
     /* 312541 */   GIR_Done,
     /* 312542 */ // Label 6320: @312542
     /* 312542 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(312572), // Rule ID 405 //
     /* 312547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312561 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 312561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 312566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312570 */   GIR_RootConstrainSelectedInstOperands,
     /* 312571 */   // GIR_Coverage, 405,
     /* 312571 */   GIR_Done,
     /* 312572 */ // Label 6321: @312572
     /* 312572 */ GIM_Reject,
     /* 312573 */ // Label 6294: @312573
     /* 312573 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(312603), // Rule ID 843 //
     /* 312578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312592 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 312592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 312597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312601 */   GIR_RootConstrainSelectedInstOperands,
     /* 312602 */   // GIR_Coverage, 843,
     /* 312602 */   GIR_Done,
     /* 312603 */ // Label 6322: @312603
     /* 312603 */ GIM_Reject,
     /* 312604 */ // Label 6295: @312604
     /* 312604 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(312634), // Rule ID 847 //
     /* 312609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312623 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 312623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 312628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312632 */   GIR_RootConstrainSelectedInstOperands,
     /* 312633 */   // GIR_Coverage, 847,
     /* 312633 */   GIR_Done,
     /* 312634 */ // Label 6323: @312634
     /* 312634 */ GIM_Reject,
     /* 312635 */ // Label 6296: @312635
     /* 312635 */ GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(312665), // Rule ID 839 //
     /* 312640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312654 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 312654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 312659 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312663 */   GIR_RootConstrainSelectedInstOperands,
     /* 312664 */   // GIR_Coverage, 839,
     /* 312664 */   GIR_Done,
     /* 312665 */ // Label 6324: @312665
     /* 312665 */ GIM_Reject,
     /* 312666 */ // Label 6297: @312666
     /* 312666 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(312696), // Rule ID 845 //
     /* 312671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312685 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 312685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 312690 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312694 */   GIR_RootConstrainSelectedInstOperands,
     /* 312695 */   // GIR_Coverage, 845,
     /* 312695 */   GIR_Done,
     /* 312696 */ // Label 6325: @312696
     /* 312696 */ GIM_Reject,
     /* 312697 */ // Label 6298: @312697
     /* 312697 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(312727), // Rule ID 841 //
     /* 312702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312716 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 312716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 312721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312725 */   GIR_RootConstrainSelectedInstOperands,
     /* 312726 */   // GIR_Coverage, 841,
     /* 312726 */   GIR_Done,
     /* 312727 */ // Label 6326: @312727
     /* 312727 */ GIM_Reject,
     /* 312728 */ // Label 6299: @312728
     /* 312728 */ GIM_Reject,
     /* 312729 */ // Label 66: @312729
     /* 312729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6334*/ GIMT_Encode4(313705),
     /* 312740 */ /*GILLT_s32*//*Label 6327*/ GIMT_Encode4(312776),
     /* 312744 */ /*GILLT_s64*//*Label 6328*/ GIMT_Encode4(313163), GIMT_Encode4(0),
     /* 312752 */ /*GILLT_v2s32*//*Label 6329*/ GIMT_Encode4(313550),
     /* 312756 */ /*GILLT_v2s64*//*Label 6330*/ GIMT_Encode4(313581),
     /* 312760 */ /*GILLT_v4s16*//*Label 6331*/ GIMT_Encode4(313612),
     /* 312764 */ /*GILLT_v4s32*//*Label 6332*/ GIMT_Encode4(313643), GIMT_Encode4(0),
     /* 312772 */ /*GILLT_v8s16*//*Label 6333*/ GIMT_Encode4(313674),
     /* 312776 */ // Label 6327: @312776
     /* 312776 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(312813), // Rule ID 4659 //
     /* 312781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312796 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312802 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 312805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312807 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312811 */   GIR_RootConstrainSelectedInstOperands,
     /* 312812 */   // GIR_Coverage, 4659,
     /* 312812 */   GIR_EraseRootFromParent_Done,
     /* 312813 */ // Label 6335: @312813
     /* 312813 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312850), // Rule ID 4661 //
     /* 312818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312833 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312839 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 312842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312844 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312848 */   GIR_RootConstrainSelectedInstOperands,
     /* 312849 */   // GIR_Coverage, 4661,
     /* 312849 */   GIR_EraseRootFromParent_Done,
     /* 312850 */ // Label 6336: @312850
     /* 312850 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312887), // Rule ID 4679 //
     /* 312855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312876 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 312879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312885 */   GIR_RootConstrainSelectedInstOperands,
     /* 312886 */   // GIR_Coverage, 4679,
     /* 312886 */   GIR_EraseRootFromParent_Done,
     /* 312887 */ // Label 6337: @312887
     /* 312887 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312924), // Rule ID 4681 //
     /* 312892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312907 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312913 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 312916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312918 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312922 */   GIR_RootConstrainSelectedInstOperands,
     /* 312923 */   // GIR_Coverage, 4681,
     /* 312923 */   GIR_EraseRootFromParent_Done,
     /* 312924 */ // Label 6338: @312924
     /* 312924 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312961), // Rule ID 4719 //
     /* 312929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312936 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312940 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312944 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312950 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 312953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312955 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312959 */   GIR_RootConstrainSelectedInstOperands,
     /* 312960 */   // GIR_Coverage, 4719,
     /* 312960 */   GIR_EraseRootFromParent_Done,
     /* 312961 */ // Label 6339: @312961
     /* 312961 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312998), // Rule ID 4721 //
     /* 312966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312981 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312987 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 312990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312996 */   GIR_RootConstrainSelectedInstOperands,
     /* 312997 */   // GIR_Coverage, 4721,
     /* 312997 */   GIR_EraseRootFromParent_Done,
     /* 312998 */ // Label 6340: @312998
     /* 312998 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(313035), // Rule ID 4699 //
     /* 313003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313024 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 313024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 313027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313029 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313033 */   GIR_RootConstrainSelectedInstOperands,
     /* 313034 */   // GIR_Coverage, 4699,
     /* 313034 */   GIR_EraseRootFromParent_Done,
     /* 313035 */ // Label 6341: @313035
     /* 313035 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(313072), // Rule ID 4701 //
     /* 313040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313055 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313061 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 313061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 313064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313070 */   GIR_RootConstrainSelectedInstOperands,
     /* 313071 */   // GIR_Coverage, 4701,
     /* 313071 */   GIR_EraseRootFromParent_Done,
     /* 313072 */ // Label 6342: @313072
     /* 313072 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(313102), // Rule ID 407 //
     /* 313077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313091 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 313091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 313096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313100 */   GIR_RootConstrainSelectedInstOperands,
     /* 313101 */   // GIR_Coverage, 407,
     /* 313101 */   GIR_Done,
     /* 313102 */ // Label 6343: @313102
     /* 313102 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(313132), // Rule ID 411 //
     /* 313107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313121 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 313121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 313126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313130 */   GIR_RootConstrainSelectedInstOperands,
     /* 313131 */   // GIR_Coverage, 411,
     /* 313131 */   GIR_Done,
     /* 313132 */ // Label 6344: @313132
     /* 313132 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(313162), // Rule ID 415 //
     /* 313137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313151 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 313151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 313156 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313160 */   GIR_RootConstrainSelectedInstOperands,
     /* 313161 */   // GIR_Coverage, 415,
     /* 313161 */   GIR_Done,
     /* 313162 */ // Label 6345: @313162
     /* 313162 */ GIM_Reject,
     /* 313163 */ // Label 6328: @313163
     /* 313163 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(313200), // Rule ID 4660 //
     /* 313168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313175 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313179 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313183 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313189 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 313192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313194 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313198 */   GIR_RootConstrainSelectedInstOperands,
     /* 313199 */   // GIR_Coverage, 4660,
     /* 313199 */   GIR_EraseRootFromParent_Done,
     /* 313200 */ // Label 6346: @313200
     /* 313200 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(313237), // Rule ID 4662 //
     /* 313205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 313220 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313224 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313226 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 313229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313231 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313235 */   GIR_RootConstrainSelectedInstOperands,
     /* 313236 */   // GIR_Coverage, 4662,
     /* 313236 */   GIR_EraseRootFromParent_Done,
     /* 313237 */ // Label 6347: @313237
     /* 313237 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(313274), // Rule ID 4680 //
     /* 313242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313257 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313263 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 313266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313268 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313272 */   GIR_RootConstrainSelectedInstOperands,
     /* 313273 */   // GIR_Coverage, 4680,
     /* 313273 */   GIR_EraseRootFromParent_Done,
     /* 313274 */ // Label 6348: @313274
     /* 313274 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(313311), // Rule ID 4682 //
     /* 313279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 313294 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313300 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 313303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313305 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313309 */   GIR_RootConstrainSelectedInstOperands,
     /* 313310 */   // GIR_Coverage, 4682,
     /* 313310 */   GIR_EraseRootFromParent_Done,
     /* 313311 */ // Label 6349: @313311
     /* 313311 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(313348), // Rule ID 4720 //
     /* 313316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313337 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 313340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313346 */   GIR_RootConstrainSelectedInstOperands,
     /* 313347 */   // GIR_Coverage, 4720,
     /* 313347 */   GIR_EraseRootFromParent_Done,
     /* 313348 */ // Label 6350: @313348
     /* 313348 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(313385), // Rule ID 4722 //
     /* 313353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 313368 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313374 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 313377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313379 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313383 */   GIR_RootConstrainSelectedInstOperands,
     /* 313384 */   // GIR_Coverage, 4722,
     /* 313384 */   GIR_EraseRootFromParent_Done,
     /* 313385 */ // Label 6351: @313385
     /* 313385 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(313422), // Rule ID 4700 //
     /* 313390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313409 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313411 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 313411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 313414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313416 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313420 */   GIR_RootConstrainSelectedInstOperands,
     /* 313421 */   // GIR_Coverage, 4700,
     /* 313421 */   GIR_EraseRootFromParent_Done,
     /* 313422 */ // Label 6352: @313422
     /* 313422 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(313459), // Rule ID 4702 //
     /* 313427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 313442 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 313446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313448 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 313448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 313451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313457 */   GIR_RootConstrainSelectedInstOperands,
     /* 313458 */   // GIR_Coverage, 4702,
     /* 313458 */   GIR_EraseRootFromParent_Done,
     /* 313459 */ // Label 6353: @313459
     /* 313459 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(313489), // Rule ID 409 //
     /* 313464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313478 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 313478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 313483 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313487 */   GIR_RootConstrainSelectedInstOperands,
     /* 313488 */   // GIR_Coverage, 409,
     /* 313488 */   GIR_Done,
     /* 313489 */ // Label 6354: @313489
     /* 313489 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(313519), // Rule ID 413 //
     /* 313494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313508 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 313508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 313513 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313517 */   GIR_RootConstrainSelectedInstOperands,
     /* 313518 */   // GIR_Coverage, 413,
     /* 313518 */   GIR_Done,
     /* 313519 */ // Label 6355: @313519
     /* 313519 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(313549), // Rule ID 417 //
     /* 313524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313538 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 313538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 313543 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313547 */   GIR_RootConstrainSelectedInstOperands,
     /* 313548 */   // GIR_Coverage, 417,
     /* 313548 */   GIR_Done,
     /* 313549 */ // Label 6356: @313549
     /* 313549 */ GIM_Reject,
     /* 313550 */ // Label 6329: @313550
     /* 313550 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(313580), // Rule ID 853 //
     /* 313555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313569 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 313569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 313574 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313578 */   GIR_RootConstrainSelectedInstOperands,
     /* 313579 */   // GIR_Coverage, 853,
     /* 313579 */   GIR_Done,
     /* 313580 */ // Label 6357: @313580
     /* 313580 */ GIM_Reject,
     /* 313581 */ // Label 6330: @313581
     /* 313581 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(313611), // Rule ID 857 //
     /* 313586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313600 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 313600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 313605 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313609 */   GIR_RootConstrainSelectedInstOperands,
     /* 313610 */   // GIR_Coverage, 857,
     /* 313610 */   GIR_Done,
     /* 313611 */ // Label 6358: @313611
     /* 313611 */ GIM_Reject,
     /* 313612 */ // Label 6331: @313612
     /* 313612 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(313642), // Rule ID 849 //
     /* 313617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313631 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 313631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 313636 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313640 */   GIR_RootConstrainSelectedInstOperands,
     /* 313641 */   // GIR_Coverage, 849,
     /* 313641 */   GIR_Done,
     /* 313642 */ // Label 6359: @313642
     /* 313642 */ GIM_Reject,
     /* 313643 */ // Label 6332: @313643
     /* 313643 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(313673), // Rule ID 855 //
     /* 313648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313662 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 313662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 313667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313671 */   GIR_RootConstrainSelectedInstOperands,
     /* 313672 */   // GIR_Coverage, 855,
     /* 313672 */   GIR_Done,
     /* 313673 */ // Label 6360: @313673
     /* 313673 */ GIM_Reject,
     /* 313674 */ // Label 6333: @313674
     /* 313674 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(313704), // Rule ID 851 //
     /* 313679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313693 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 313693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 313698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313702 */   GIR_RootConstrainSelectedInstOperands,
     /* 313703 */   // GIR_Coverage, 851,
     /* 313703 */   GIR_Done,
     /* 313704 */ // Label 6361: @313704
     /* 313704 */ GIM_Reject,
     /* 313705 */ // Label 6334: @313705
     /* 313705 */ GIM_Reject,
     /* 313706 */ // Label 67: @313706
     /* 313706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6370*/ GIMT_Encode4(318333),
     /* 313717 */ /*GILLT_s16*//*Label 6362*/ GIMT_Encode4(313757),
     /* 313721 */ /*GILLT_s32*//*Label 6363*/ GIMT_Encode4(314198),
     /* 313725 */ /*GILLT_s64*//*Label 6364*/ GIMT_Encode4(316194), GIMT_Encode4(0),
     /* 313733 */ /*GILLT_v2s32*//*Label 6365*/ GIMT_Encode4(318178),
     /* 313737 */ /*GILLT_v2s64*//*Label 6366*/ GIMT_Encode4(318209),
     /* 313741 */ /*GILLT_v4s16*//*Label 6367*/ GIMT_Encode4(318240),
     /* 313745 */ /*GILLT_v4s32*//*Label 6368*/ GIMT_Encode4(318271), GIMT_Encode4(0),
     /* 313753 */ /*GILLT_v8s16*//*Label 6369*/ GIMT_Encode4(318302),
     /* 313757 */ // Label 6362: @313757
     /* 313757 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(313860), // Rule ID 5323 //
     /* 313762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 313765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 313780 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313784 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313788 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313792 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313796 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313800 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313805 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313809 */   // MIs[1] Operand 2
     /* 313809 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 313820 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313822 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 313822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313834 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 313840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 313853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313858 */   GIR_RootConstrainSelectedInstOperands,
     /* 313859 */   // GIR_Coverage, 5323,
     /* 313859 */   GIR_EraseRootFromParent_Done,
     /* 313860 */ // Label 6371: @313860
     /* 313860 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313940), // Rule ID 2444 //
     /* 313865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313883 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313887 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313896 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313902 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 313902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313914 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 313933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313938 */   GIR_RootConstrainSelectedInstOperands,
     /* 313939 */   // GIR_Coverage, 2444,
     /* 313939 */   GIR_EraseRootFromParent_Done,
     /* 313940 */ // Label 6372: @313940
     /* 313940 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(314020), // Rule ID 2448 //
     /* 313945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313963 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313967 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313971 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313976 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313982 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 313982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 313985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313994 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 314000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 314013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314018 */   GIR_RootConstrainSelectedInstOperands,
     /* 314019 */   // GIR_Coverage, 2448,
     /* 314019 */   GIR_EraseRootFromParent_Done,
     /* 314020 */ // Label 6373: @314020
     /* 314020 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(314077), // Rule ID 5314 //
     /* 314025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 314028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 314043 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314049 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 314049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 314052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 314056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314061 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 314067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 314070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314075 */   GIR_RootConstrainSelectedInstOperands,
     /* 314076 */   // GIR_Coverage, 5314,
     /* 314076 */   GIR_EraseRootFromParent_Done,
     /* 314077 */ // Label 6374: @314077
     /* 314077 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(314107), // Rule ID 443 //
     /* 314082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314096 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 314096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 314101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314105 */   GIR_RootConstrainSelectedInstOperands,
     /* 314106 */   // GIR_Coverage, 443,
     /* 314106 */   GIR_Done,
     /* 314107 */ // Label 6375: @314107
     /* 314107 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(314137), // Rule ID 449 //
     /* 314112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314126 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 314126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 314131 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314135 */   GIR_RootConstrainSelectedInstOperands,
     /* 314136 */   // GIR_Coverage, 449,
     /* 314136 */   GIR_Done,
     /* 314137 */ // Label 6376: @314137
     /* 314137 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(314167), // Rule ID 491 //
     /* 314142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314156 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 314156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 314161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314165 */   GIR_RootConstrainSelectedInstOperands,
     /* 314166 */   // GIR_Coverage, 491,
     /* 314166 */   GIR_Done,
     /* 314167 */ // Label 6377: @314167
     /* 314167 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(314197), // Rule ID 495 //
     /* 314172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314186 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 314186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 314191 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314195 */   GIR_RootConstrainSelectedInstOperands,
     /* 314196 */   // GIR_Coverage, 495,
     /* 314196 */   GIR_Done,
     /* 314197 */ // Label 6378: @314197
     /* 314197 */ GIM_Reject,
     /* 314198 */ // Label 6363: @314198
     /* 314198 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(314436), // Rule ID 6374 //
     /* 314203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314221 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314224 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314231 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314235 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314237 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 314244 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314244 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314247 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 314251 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314271 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314278 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314281 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314285 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314292 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314295 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314299 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314304 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314307 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314310 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314313 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314318 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314323 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314328 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314331 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314335 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314340 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314343 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314348 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314351 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314355 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314360 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314367 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314372 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314377 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314380 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314384 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314389 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314392 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314409 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314416 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314434 */   GIR_RootConstrainSelectedInstOperands,
     /* 314435 */   // GIR_Coverage, 6374,
     /* 314435 */   GIR_EraseRootFromParent_Done,
     /* 314436 */ // Label 6379: @314436
     /* 314436 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(314674), // Rule ID 6375 //
     /* 314441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314459 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314462 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314469 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314475 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 314482 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314482 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314485 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 314489 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314509 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314516 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314519 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314523 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314530 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314533 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314537 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314542 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314545 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314548 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314551 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314556 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314561 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314566 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314569 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314573 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314578 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314581 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314586 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314589 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314593 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314598 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314605 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314610 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314627 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314630 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314647 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314672 */   GIR_RootConstrainSelectedInstOperands,
     /* 314673 */   // GIR_Coverage, 6375,
     /* 314673 */   GIR_EraseRootFromParent_Done,
     /* 314674 */ // Label 6380: @314674
     /* 314674 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314863), // Rule ID 6378 //
     /* 314679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314697 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314700 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 314720 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314720 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314723 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 314727 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314747 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314754 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314757 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314761 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314768 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314771 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314775 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314780 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314783 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314786 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314789 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314794 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314799 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314816 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314819 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314836 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314861 */   GIR_RootConstrainSelectedInstOperands,
     /* 314862 */   // GIR_Coverage, 6378,
     /* 314862 */   GIR_EraseRootFromParent_Done,
     /* 314863 */ // Label 6381: @314863
     /* 314863 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(315052), // Rule ID 6379 //
     /* 314868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314886 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314889 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314896 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314902 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 314909 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314909 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314912 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 314916 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314936 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314943 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314946 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314950 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314957 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314960 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314964 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314969 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314972 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314975 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314978 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314983 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314988 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315005 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315008 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315025 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315050 */   GIR_RootConstrainSelectedInstOperands,
     /* 315051 */   // GIR_Coverage, 6379,
     /* 315051 */   GIR_EraseRootFromParent_Done,
     /* 315052 */ // Label 6382: @315052
     /* 315052 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(315285), // Rule ID 6376 //
     /* 315057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315078 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315085 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315091 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 315098 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315098 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 315101 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 315105 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315120 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315127 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315130 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315134 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315141 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315144 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315148 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315153 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315156 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315159 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 315162 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315167 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315172 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315177 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315180 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 315184 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315189 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315192 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315197 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315200 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315204 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315209 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315216 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315221 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315226 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315229 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315233 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315238 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315241 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315258 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315283 */   GIR_RootConstrainSelectedInstOperands,
     /* 315284 */   // GIR_Coverage, 6376,
     /* 315284 */   GIR_EraseRootFromParent_Done,
     /* 315285 */ // Label 6383: @315285
     /* 315285 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(315518), // Rule ID 6377 //
     /* 315290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315308 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315311 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315318 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315324 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 315331 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315331 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 315334 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 315338 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315353 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315360 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315363 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315367 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315374 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315377 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315381 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315386 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315389 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315392 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 315395 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315400 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315405 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315410 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315413 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 315417 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315422 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315425 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315430 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315433 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315437 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315442 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315449 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315454 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315459 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315462 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315466 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315471 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315474 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315491 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315498 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315516 */   GIR_RootConstrainSelectedInstOperands,
     /* 315517 */   // GIR_Coverage, 6377,
     /* 315517 */   GIR_EraseRootFromParent_Done,
     /* 315518 */ // Label 6384: @315518
     /* 315518 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(315702), // Rule ID 6380 //
     /* 315523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315541 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315544 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315551 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315557 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 315564 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315564 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 315567 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 315571 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315586 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315593 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315596 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315600 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315607 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315610 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315614 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315619 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315622 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315625 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 315628 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315633 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315638 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315655 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315658 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315675 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315700 */   GIR_RootConstrainSelectedInstOperands,
     /* 315701 */   // GIR_Coverage, 6380,
     /* 315701 */   GIR_EraseRootFromParent_Done,
     /* 315702 */ // Label 6385: @315702
     /* 315702 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(315886), // Rule ID 6381 //
     /* 315707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315725 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315728 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315735 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315741 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 315748 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315748 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 315751 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 315755 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315770 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315777 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315780 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315784 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315791 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315794 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315798 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315803 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315806 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315809 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 315812 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315817 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315822 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315839 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315842 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315859 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315884 */   GIR_RootConstrainSelectedInstOperands,
     /* 315885 */   // GIR_Coverage, 6381,
     /* 315885 */   GIR_EraseRootFromParent_Done,
     /* 315886 */ // Label 6386: @315886
     /* 315886 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(315966), // Rule ID 2450 //
     /* 315891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315909 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315913 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315917 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315922 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315926 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315928 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 315928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315940 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 315959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315964 */   GIR_RootConstrainSelectedInstOperands,
     /* 315965 */   // GIR_Coverage, 2450,
     /* 315965 */   GIR_EraseRootFromParent_Done,
     /* 315966 */ // Label 6387: @315966
     /* 315966 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(316046), // Rule ID 5319 //
     /* 315971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315981 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315985 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315989 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315993 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315997 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316002 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316006 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316008 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 316008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316020 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 316026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316044 */   GIR_RootConstrainSelectedInstOperands,
     /* 316045 */   // GIR_Coverage, 5319,
     /* 316045 */   GIR_EraseRootFromParent_Done,
     /* 316046 */ // Label 6388: @316046
     /* 316046 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(316103), // Rule ID 5302 //
     /* 316051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 316069 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 316073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316075 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 316075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 316078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 316082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316087 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 316096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316101 */   GIR_RootConstrainSelectedInstOperands,
     /* 316102 */   // GIR_Coverage, 5302,
     /* 316102 */   GIR_EraseRootFromParent_Done,
     /* 316103 */ // Label 6389: @316103
     /* 316103 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(316133), // Rule ID 445 //
     /* 316108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316122 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 316122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 316127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316131 */   GIR_RootConstrainSelectedInstOperands,
     /* 316132 */   // GIR_Coverage, 445,
     /* 316132 */   GIR_Done,
     /* 316133 */ // Label 6390: @316133
     /* 316133 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(316163), // Rule ID 451 //
     /* 316138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316152 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 316152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 316157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316161 */   GIR_RootConstrainSelectedInstOperands,
     /* 316162 */   // GIR_Coverage, 451,
     /* 316162 */   GIR_Done,
     /* 316163 */ // Label 6391: @316163
     /* 316163 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(316193), // Rule ID 497 //
     /* 316168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 316171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316182 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 316182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 316187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316191 */   GIR_RootConstrainSelectedInstOperands,
     /* 316192 */   // GIR_Coverage, 497,
     /* 316192 */   GIR_Done,
     /* 316193 */ // Label 6392: @316193
     /* 316193 */ GIM_Reject,
     /* 316194 */ // Label 6364: @316194
     /* 316194 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(316380), // Rule ID 6386 //
     /* 316199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 316217 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 316224 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316230 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 316237 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316237 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 316240 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 316244 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316264 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316271 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316274 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316278 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316285 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316288 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316292 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316297 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316300 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316303 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 316306 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316311 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316316 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316321 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316324 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316328 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316333 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316336 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316353 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316378 */   GIR_RootConstrainSelectedInstOperands,
     /* 316379 */   // GIR_Coverage, 6386,
     /* 316379 */   GIR_EraseRootFromParent_Done,
     /* 316380 */ // Label 6393: @316380
     /* 316380 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(316566), // Rule ID 6387 //
     /* 316385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 316403 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 316410 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316416 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 316423 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316423 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 316426 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 316430 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316450 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316457 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316460 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316464 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316471 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316474 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316478 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316483 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316486 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316489 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 316492 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316497 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316502 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316519 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316522 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316539 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316564 */   GIR_RootConstrainSelectedInstOperands,
     /* 316565 */   // GIR_Coverage, 6387,
     /* 316565 */   GIR_EraseRootFromParent_Done,
     /* 316566 */ // Label 6394: @316566
     /* 316566 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316804), // Rule ID 6382 //
     /* 316571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316589 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316592 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316599 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316605 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 316612 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316612 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316615 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 316619 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316639 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316646 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316649 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316653 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316660 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316663 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316667 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316672 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316675 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316678 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316681 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316686 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316691 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316696 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316699 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316703 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316708 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316711 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316716 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316719 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316723 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316728 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316735 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316740 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316745 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316748 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316752 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316757 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316760 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316777 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316802 */   GIR_RootConstrainSelectedInstOperands,
     /* 316803 */   // GIR_Coverage, 6382,
     /* 316803 */   GIR_EraseRootFromParent_Done,
     /* 316804 */ // Label 6395: @316804
     /* 316804 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(317042), // Rule ID 6383 //
     /* 316809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316827 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316830 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316837 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316841 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316843 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 316850 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316850 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316853 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 316857 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316877 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316884 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316887 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316891 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316898 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316901 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316905 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316910 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316913 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316916 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316919 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316924 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316929 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316934 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316937 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316941 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316946 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316949 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316966 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316973 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316978 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316995 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316998 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317015 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317040 */   GIR_RootConstrainSelectedInstOperands,
     /* 317041 */   // GIR_Coverage, 6383,
     /* 317041 */   GIR_EraseRootFromParent_Done,
     /* 317042 */ // Label 6396: @317042
     /* 317042 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(317223), // Rule ID 6388 //
     /* 317047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317065 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317072 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317078 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 317085 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317085 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317088 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 317092 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317107 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317114 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317117 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317121 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317128 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317131 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317135 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317140 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317143 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317146 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 317149 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317154 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317159 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317164 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317167 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317171 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317176 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317179 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317196 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317203 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317221 */   GIR_RootConstrainSelectedInstOperands,
     /* 317222 */   // GIR_Coverage, 6388,
     /* 317222 */   GIR_EraseRootFromParent_Done,
     /* 317223 */ // Label 6397: @317223
     /* 317223 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(317404), // Rule ID 6389 //
     /* 317228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 317246 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 317253 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317259 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 317266 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317266 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317269 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 317273 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317288 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317295 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 317298 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317302 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317309 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317312 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317316 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317321 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317324 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 317327 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 317330 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317335 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317340 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317345 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317348 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317352 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317357 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317360 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317377 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317389 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317402 */   GIR_RootConstrainSelectedInstOperands,
     /* 317403 */   // GIR_Coverage, 6389,
     /* 317403 */   GIR_EraseRootFromParent_Done,
     /* 317404 */ // Label 6398: @317404
     /* 317404 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(317637), // Rule ID 6384 //
     /* 317409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317427 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317430 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317437 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317443 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 317450 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317450 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 317453 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 317457 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317472 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 317479 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 317482 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317486 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 317493 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 317496 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317500 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317505 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 317508 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 317511 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 317514 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317519 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317524 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317529 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 317532 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317536 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317541 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 317544 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 317547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317549 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317552 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317556 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317561 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317568 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317573 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317590 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317593 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317635 */   GIR_RootConstrainSelectedInstOperands,
     /* 317636 */   // GIR_Coverage, 6384,
     /* 317636 */   GIR_EraseRootFromParent_Done,
     /* 317637 */ // Label 6399: @317637
     /* 317637 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(317870), // Rule ID 6385 //
     /* 317642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 317645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 317660 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317663 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317670 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317674 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317676 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 317683 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 317683 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 317686 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 317690 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317705 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 317712 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 317715 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317719 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 317726 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 317729 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317733 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317738 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 317741 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 317744 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 317747 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317752 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317757 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317762 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 317765 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 317769 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317774 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 317777 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 317780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 317782 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 317785 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317789 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317794 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317801 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317806 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317811 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317814 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317818 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317823 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317826 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317843 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317868 */   GIR_RootConstrainSelectedInstOperands,
     /* 317869 */   // GIR_Coverage, 6385,
     /* 317869 */   GIR_EraseRootFromParent_Done,
     /* 317870 */ // Label 6400: @317870
     /* 317870 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(317950), // Rule ID 2446 //
     /* 317875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317885 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317889 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317893 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317897 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317901 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317906 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317912 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 317912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317924 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 317930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 317943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317948 */   GIR_RootConstrainSelectedInstOperands,
     /* 317949 */   // GIR_Coverage, 2446,
     /* 317949 */   GIR_EraseRootFromParent_Done,
     /* 317950 */ // Label 6401: @317950
     /* 317950 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(318030), // Rule ID 5321 //
     /* 317955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317977 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317990 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317992 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 317992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318004 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318028 */   GIR_RootConstrainSelectedInstOperands,
     /* 318029 */   // GIR_Coverage, 5321,
     /* 318029 */   GIR_EraseRootFromParent_Done,
     /* 318030 */ // Label 6402: @318030
     /* 318030 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(318087), // Rule ID 5298 //
     /* 318035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 318053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318059 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 318059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 318066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 318080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318085 */   GIR_RootConstrainSelectedInstOperands,
     /* 318086 */   // GIR_Coverage, 5298,
     /* 318086 */   GIR_EraseRootFromParent_Done,
     /* 318087 */ // Label 6403: @318087
     /* 318087 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(318117), // Rule ID 447 //
     /* 318092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318106 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 318106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 318111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318115 */   GIR_RootConstrainSelectedInstOperands,
     /* 318116 */   // GIR_Coverage, 447,
     /* 318116 */   GIR_Done,
     /* 318117 */ // Label 6404: @318117
     /* 318117 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(318147), // Rule ID 453 //
     /* 318122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318136 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 318136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 318141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318145 */   GIR_RootConstrainSelectedInstOperands,
     /* 318146 */   // GIR_Coverage, 453,
     /* 318146 */   GIR_Done,
     /* 318147 */ // Label 6405: @318147
     /* 318147 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(318177), // Rule ID 493 //
     /* 318152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318166 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 318166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 318171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318175 */   GIR_RootConstrainSelectedInstOperands,
     /* 318176 */   // GIR_Coverage, 493,
     /* 318176 */   GIR_Done,
     /* 318177 */ // Label 6406: @318177
     /* 318177 */ GIM_Reject,
     /* 318178 */ // Label 6365: @318178
     /* 318178 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(318208), // Rule ID 1017 //
     /* 318183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318197 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 318197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 318202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318206 */   GIR_RootConstrainSelectedInstOperands,
     /* 318207 */   // GIR_Coverage, 1017,
     /* 318207 */   GIR_Done,
     /* 318208 */ // Label 6407: @318208
     /* 318208 */ GIM_Reject,
     /* 318209 */ // Label 6366: @318209
     /* 318209 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(318239), // Rule ID 1021 //
     /* 318214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318228 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 318228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 318233 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318237 */   GIR_RootConstrainSelectedInstOperands,
     /* 318238 */   // GIR_Coverage, 1021,
     /* 318238 */   GIR_Done,
     /* 318239 */ // Label 6408: @318239
     /* 318239 */ GIM_Reject,
     /* 318240 */ // Label 6367: @318240
     /* 318240 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(318270), // Rule ID 1013 //
     /* 318245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318259 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 318259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 318264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318268 */   GIR_RootConstrainSelectedInstOperands,
     /* 318269 */   // GIR_Coverage, 1013,
     /* 318269 */   GIR_Done,
     /* 318270 */ // Label 6409: @318270
     /* 318270 */ GIM_Reject,
     /* 318271 */ // Label 6368: @318271
     /* 318271 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(318301), // Rule ID 1019 //
     /* 318276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318290 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 318290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 318295 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318299 */   GIR_RootConstrainSelectedInstOperands,
     /* 318300 */   // GIR_Coverage, 1019,
     /* 318300 */   GIR_Done,
     /* 318301 */ // Label 6410: @318301
     /* 318301 */ GIM_Reject,
     /* 318302 */ // Label 6369: @318302
     /* 318302 */ GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(318332), // Rule ID 1015 //
     /* 318307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318321 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 318321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 318326 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318330 */   GIR_RootConstrainSelectedInstOperands,
     /* 318331 */   // GIR_Coverage, 1015,
     /* 318331 */   GIR_Done,
     /* 318332 */ // Label 6411: @318332
     /* 318332 */ GIM_Reject,
     /* 318333 */ // Label 6370: @318333
     /* 318333 */ GIM_Reject,
     /* 318334 */ // Label 68: @318334
     /* 318334 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6420*/ GIMT_Encode4(322339),
     /* 318345 */ /*GILLT_s16*//*Label 6412*/ GIMT_Encode4(318385),
     /* 318349 */ /*GILLT_s32*//*Label 6413*/ GIMT_Encode4(318830),
     /* 318353 */ /*GILLT_s64*//*Label 6414*/ GIMT_Encode4(320238), GIMT_Encode4(0),
     /* 318361 */ /*GILLT_v2s32*//*Label 6415*/ GIMT_Encode4(322184),
     /* 318365 */ /*GILLT_v2s64*//*Label 6416*/ GIMT_Encode4(322215),
     /* 318369 */ /*GILLT_v4s16*//*Label 6417*/ GIMT_Encode4(322246),
     /* 318373 */ /*GILLT_v4s32*//*Label 6418*/ GIMT_Encode4(322277), GIMT_Encode4(0),
     /* 318381 */ /*GILLT_v8s16*//*Label 6419*/ GIMT_Encode4(322308),
     /* 318385 */ // Label 6412: @318385
     /* 318385 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(318492), // Rule ID 5324 //
     /* 318390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 318393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318400 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318404 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 318408 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318412 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 318416 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318420 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318424 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318428 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318432 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318437 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 318441 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 318452 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318454 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 318454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 318457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318466 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 318472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 318485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318490 */   GIR_RootConstrainSelectedInstOperands,
     /* 318491 */   // GIR_Coverage, 5324,
     /* 318491 */   GIR_EraseRootFromParent_Done,
     /* 318492 */ // Label 6421: @318492
     /* 318492 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(318572), // Rule ID 4748 //
     /* 318497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318515 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318519 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318528 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318534 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 318534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318546 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 318552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 318565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318570 */   GIR_RootConstrainSelectedInstOperands,
     /* 318571 */   // GIR_Coverage, 4748,
     /* 318571 */   GIR_EraseRootFromParent_Done,
     /* 318572 */ // Label 6422: @318572
     /* 318572 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(318652), // Rule ID 4752 //
     /* 318577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318595 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318599 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318603 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318608 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318614 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 318614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318626 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 318645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318650 */   GIR_RootConstrainSelectedInstOperands,
     /* 318651 */   // GIR_Coverage, 4752,
     /* 318651 */   GIR_EraseRootFromParent_Done,
     /* 318652 */ // Label 6423: @318652
     /* 318652 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(318709), // Rule ID 5318 //
     /* 318657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 318660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 318675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318681 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 318681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 318684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 318688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318693 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 318702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318707 */   GIR_RootConstrainSelectedInstOperands,
     /* 318708 */   // GIR_Coverage, 5318,
     /* 318708 */   GIR_EraseRootFromParent_Done,
     /* 318709 */ // Label 6424: @318709
     /* 318709 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(318739), // Rule ID 467 //
     /* 318714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 318717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318728 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 318728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 318733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318737 */   GIR_RootConstrainSelectedInstOperands,
     /* 318738 */   // GIR_Coverage, 467,
     /* 318738 */   GIR_Done,
     /* 318739 */ // Label 6425: @318739
     /* 318739 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(318769), // Rule ID 473 //
     /* 318744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 318747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318758 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 318758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 318763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318767 */   GIR_RootConstrainSelectedInstOperands,
     /* 318768 */   // GIR_Coverage, 473,
     /* 318768 */   GIR_Done,
     /* 318769 */ // Label 6426: @318769
     /* 318769 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(318799), // Rule ID 499 //
     /* 318774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318788 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 318788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 318793 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318797 */   GIR_RootConstrainSelectedInstOperands,
     /* 318798 */   // GIR_Coverage, 499,
     /* 318798 */   GIR_Done,
     /* 318799 */ // Label 6427: @318799
     /* 318799 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(318829), // Rule ID 503 //
     /* 318804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318818 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 318818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 318823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318827 */   GIR_RootConstrainSelectedInstOperands,
     /* 318828 */   // GIR_Coverage, 503,
     /* 318828 */   GIR_Done,
     /* 318829 */ // Label 6428: @318829
     /* 318829 */ GIM_Reject,
     /* 318830 */ // Label 6413: @318830
     /* 318830 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(318970), // Rule ID 5325 //
     /* 318835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318845 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318853 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318856 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318863 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318869 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 318876 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318876 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318879 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 318883 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318903 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318910 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318913 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318917 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318936 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318939 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318942 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318955 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318965 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318968 */   GIR_RootConstrainSelectedInstOperands,
     /* 318969 */   // GIR_Coverage, 5325,
     /* 318969 */   GIR_EraseRootFromParent_Done,
     /* 318970 */ // Label 6429: @318970
     /* 318970 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(319110), // Rule ID 5326 //
     /* 318975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318993 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318996 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319003 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319009 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 319016 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 319016 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319019 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 319023 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319043 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319050 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319053 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319057 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319076 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319079 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319082 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319085 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319108 */   GIR_RootConstrainSelectedInstOperands,
     /* 319109 */   // GIR_Coverage, 5326,
     /* 319109 */   GIR_EraseRootFromParent_Done,
     /* 319110 */ // Label 6430: @319110
     /* 319110 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(319250), // Rule ID 5329 //
     /* 319115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319133 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319136 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319143 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319149 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 319156 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319156 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319159 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 319163 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319183 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319190 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319193 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319197 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319216 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319219 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319222 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319248 */   GIR_RootConstrainSelectedInstOperands,
     /* 319249 */   // GIR_Coverage, 5329,
     /* 319249 */   GIR_EraseRootFromParent_Done,
     /* 319250 */ // Label 6431: @319250
     /* 319250 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(319390), // Rule ID 5330 //
     /* 319255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319273 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319276 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319283 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319289 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 319296 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319296 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319299 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 319303 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319323 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319330 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319333 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319337 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319356 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319359 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319362 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319388 */   GIR_RootConstrainSelectedInstOperands,
     /* 319389 */   // GIR_Coverage, 5330,
     /* 319389 */   GIR_EraseRootFromParent_Done,
     /* 319390 */ // Label 6432: @319390
     /* 319390 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(319525), // Rule ID 5327 //
     /* 319395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319413 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319416 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319423 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319429 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 319436 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 319436 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319439 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 319443 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319458 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319465 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319468 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319472 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319497 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319523 */   GIR_RootConstrainSelectedInstOperands,
     /* 319524 */   // GIR_Coverage, 5327,
     /* 319524 */   GIR_EraseRootFromParent_Done,
     /* 319525 */ // Label 6433: @319525
     /* 319525 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(319660), // Rule ID 5328 //
     /* 319530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319548 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319551 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319558 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319564 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 319571 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 319571 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319574 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 319578 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319593 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319600 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319603 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319607 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319626 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319629 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319632 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319635 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319645 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319658 */   GIR_RootConstrainSelectedInstOperands,
     /* 319659 */   // GIR_Coverage, 5328,
     /* 319659 */   GIR_EraseRootFromParent_Done,
     /* 319660 */ // Label 6434: @319660
     /* 319660 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(319795), // Rule ID 5331 //
     /* 319665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319675 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319683 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319686 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319693 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319699 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 319706 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 319706 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319709 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 319713 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319728 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319735 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319738 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319742 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319764 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319767 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319775 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319780 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319793 */   GIR_RootConstrainSelectedInstOperands,
     /* 319794 */   // GIR_Coverage, 5331,
     /* 319794 */   GIR_EraseRootFromParent_Done,
     /* 319795 */ // Label 6435: @319795
     /* 319795 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(319930), // Rule ID 5332 //
     /* 319800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319818 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319821 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319828 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319834 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 319841 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 319841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 319848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319863 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319870 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 319873 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319877 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319896 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319899 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319902 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319905 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319928 */   GIR_RootConstrainSelectedInstOperands,
     /* 319929 */   // GIR_Coverage, 5332,
     /* 319929 */   GIR_EraseRootFromParent_Done,
     /* 319930 */ // Label 6436: @319930
     /* 319930 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(320010), // Rule ID 4754 //
     /* 319935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319966 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319972 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 319972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319984 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 319990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 320003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320008 */   GIR_RootConstrainSelectedInstOperands,
     /* 320009 */   // GIR_Coverage, 4754,
     /* 320009 */   GIR_EraseRootFromParent_Done,
     /* 320010 */ // Label 6437: @320010
     /* 320010 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(320090), // Rule ID 5320 //
     /* 320015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320033 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320037 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320046 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320052 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 320052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320064 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 320070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320088 */   GIR_RootConstrainSelectedInstOperands,
     /* 320089 */   // GIR_Coverage, 5320,
     /* 320089 */   GIR_EraseRootFromParent_Done,
     /* 320090 */ // Label 6438: @320090
     /* 320090 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(320147), // Rule ID 5310 //
     /* 320095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320113 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320119 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 320119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 320122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 320126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320131 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 320140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320142 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320145 */   GIR_RootConstrainSelectedInstOperands,
     /* 320146 */   // GIR_Coverage, 5310,
     /* 320146 */   GIR_EraseRootFromParent_Done,
     /* 320147 */ // Label 6439: @320147
     /* 320147 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(320177), // Rule ID 469 //
     /* 320152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320166 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 320166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 320171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320175 */   GIR_RootConstrainSelectedInstOperands,
     /* 320176 */   // GIR_Coverage, 469,
     /* 320176 */   GIR_Done,
     /* 320177 */ // Label 6440: @320177
     /* 320177 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(320207), // Rule ID 475 //
     /* 320182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320196 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 320196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 320201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320205 */   GIR_RootConstrainSelectedInstOperands,
     /* 320206 */   // GIR_Coverage, 475,
     /* 320206 */   GIR_Done,
     /* 320207 */ // Label 6441: @320207
     /* 320207 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(320237), // Rule ID 505 //
     /* 320212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320226 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 320226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 320231 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320235 */   GIR_RootConstrainSelectedInstOperands,
     /* 320236 */   // GIR_Coverage, 505,
     /* 320236 */   GIR_Done,
     /* 320237 */ // Label 6442: @320237
     /* 320237 */ GIM_Reject,
     /* 320238 */ // Label 6414: @320238
     /* 320238 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(320375), // Rule ID 5341 //
     /* 320243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 320261 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 320268 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320274 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 320281 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 320281 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 320284 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 320288 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320308 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320315 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320318 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320322 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320341 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320344 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320347 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320355 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320373 */   GIR_RootConstrainSelectedInstOperands,
     /* 320374 */   // GIR_Coverage, 5341,
     /* 320374 */   GIR_EraseRootFromParent_Done,
     /* 320375 */ // Label 6443: @320375
     /* 320375 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(320512), // Rule ID 5342 //
     /* 320380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 320398 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320401 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 320405 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320409 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320411 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 320418 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 320418 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 320421 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 320425 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320445 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320478 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320481 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320484 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320510 */   GIR_RootConstrainSelectedInstOperands,
     /* 320511 */   // GIR_Coverage, 5342,
     /* 320511 */   GIR_EraseRootFromParent_Done,
     /* 320512 */ // Label 6444: @320512
     /* 320512 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(320652), // Rule ID 5333 //
     /* 320517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320535 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320538 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320545 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320551 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 320558 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320558 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320561 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 320565 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320585 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320592 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320595 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320599 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320618 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320621 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320624 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320650 */   GIR_RootConstrainSelectedInstOperands,
     /* 320651 */   // GIR_Coverage, 5333,
     /* 320651 */   GIR_EraseRootFromParent_Done,
     /* 320652 */ // Label 6445: @320652
     /* 320652 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(320792), // Rule ID 5334 //
     /* 320657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320675 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320678 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320685 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320689 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320691 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 320698 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 320698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 320705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320725 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320758 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320790 */   GIR_RootConstrainSelectedInstOperands,
     /* 320791 */   // GIR_Coverage, 5334,
     /* 320791 */   GIR_EraseRootFromParent_Done,
     /* 320792 */ // Label 6446: @320792
     /* 320792 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(320932), // Rule ID 5337 //
     /* 320797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320815 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320818 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320825 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320831 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 320838 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320838 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320841 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 320845 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 320860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 320865 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320872 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320875 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320879 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320898 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320901 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320904 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320930 */   GIR_RootConstrainSelectedInstOperands,
     /* 320931 */   // GIR_Coverage, 5337,
     /* 320931 */   GIR_EraseRootFromParent_Done,
     /* 320932 */ // Label 6447: @320932
     /* 320932 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(321072), // Rule ID 5338 //
     /* 320937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320955 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320958 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320965 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320971 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 320978 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 320978 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320981 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 320985 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 321000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 321005 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321044 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321070 */   GIR_RootConstrainSelectedInstOperands,
     /* 321071 */   // GIR_Coverage, 5338,
     /* 321071 */   GIR_EraseRootFromParent_Done,
     /* 321072 */ // Label 6448: @321072
     /* 321072 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(321204), // Rule ID 5343 //
     /* 321077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321095 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321102 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321108 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 321115 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 321115 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321118 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 321122 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321137 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321170 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321173 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321176 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321179 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321184 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321189 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321202 */   GIR_RootConstrainSelectedInstOperands,
     /* 321203 */   // GIR_Coverage, 5343,
     /* 321203 */   GIR_EraseRootFromParent_Done,
     /* 321204 */ // Label 6449: @321204
     /* 321204 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(321336), // Rule ID 5344 //
     /* 321209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 321227 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 321234 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321238 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321240 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 321247 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 321247 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321250 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 321254 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321269 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321302 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321308 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 321311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321321 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321334 */   GIR_RootConstrainSelectedInstOperands,
     /* 321335 */   // GIR_Coverage, 5344,
     /* 321335 */   GIR_EraseRootFromParent_Done,
     /* 321336 */ // Label 6450: @321336
     /* 321336 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(321471), // Rule ID 5335 //
     /* 321341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321359 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321362 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 321369 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321375 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 321382 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 321382 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 321385 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 321389 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321404 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321411 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321414 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321418 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321437 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321440 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321443 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321456 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321469 */   GIR_RootConstrainSelectedInstOperands,
     /* 321470 */   // GIR_Coverage, 5335,
     /* 321470 */   GIR_EraseRootFromParent_Done,
     /* 321471 */ // Label 6451: @321471
     /* 321471 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(321606), // Rule ID 5336 //
     /* 321476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321494 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321497 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 321504 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321510 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 321517 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 321517 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 321520 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 321524 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321539 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321572 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321578 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 321581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 321596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321604 */   GIR_RootConstrainSelectedInstOperands,
     /* 321605 */   // GIR_Coverage, 5336,
     /* 321605 */   GIR_EraseRootFromParent_Done,
     /* 321606 */ // Label 6452: @321606
     /* 321606 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(321741), // Rule ID 5339 //
     /* 321611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321629 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321632 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321639 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321645 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 321652 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 321652 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321655 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 321659 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321674 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321681 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321684 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321688 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321707 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321710 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321713 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321739 */   GIR_RootConstrainSelectedInstOperands,
     /* 321740 */   // GIR_Coverage, 5339,
     /* 321740 */   GIR_EraseRootFromParent_Done,
     /* 321741 */ // Label 6453: @321741
     /* 321741 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(321876), // Rule ID 5340 //
     /* 321746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 321764 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 321767 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 321774 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 321778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321780 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 321787 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 321787 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 321790 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 321794 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 321804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 321809 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 321814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 321816 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 321819 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321823 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 321833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321842 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321845 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 321848 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321851 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321856 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 321869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321874 */   GIR_RootConstrainSelectedInstOperands,
     /* 321875 */   // GIR_Coverage, 5340,
     /* 321875 */   GIR_EraseRootFromParent_Done,
     /* 321876 */ // Label 6454: @321876
     /* 321876 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(321956), // Rule ID 4750 //
     /* 321881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321912 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321918 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 321918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321930 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 321936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321941 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 321949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321951 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321954 */   GIR_RootConstrainSelectedInstOperands,
     /* 321955 */   // GIR_Coverage, 4750,
     /* 321955 */   GIR_EraseRootFromParent_Done,
     /* 321956 */ // Label 6455: @321956
     /* 321956 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(322036), // Rule ID 5322 //
     /* 321961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 321964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 321979 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321992 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 321996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321998 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 321998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322010 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 322016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322034 */   GIR_RootConstrainSelectedInstOperands,
     /* 322035 */   // GIR_Coverage, 5322,
     /* 322035 */   GIR_EraseRootFromParent_Done,
     /* 322036 */ // Label 6456: @322036
     /* 322036 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(322093), // Rule ID 5306 //
     /* 322041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 322044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 322059 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322065 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 322065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 322068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 322072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 322086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322091 */   GIR_RootConstrainSelectedInstOperands,
     /* 322092 */   // GIR_Coverage, 5306,
     /* 322092 */   GIR_EraseRootFromParent_Done,
     /* 322093 */ // Label 6457: @322093
     /* 322093 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(322123), // Rule ID 471 //
     /* 322098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322112 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 322112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 322117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322121 */   GIR_RootConstrainSelectedInstOperands,
     /* 322122 */   // GIR_Coverage, 471,
     /* 322122 */   GIR_Done,
     /* 322123 */ // Label 6458: @322123
     /* 322123 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(322153), // Rule ID 477 //
     /* 322128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322142 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 322142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 322147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322151 */   GIR_RootConstrainSelectedInstOperands,
     /* 322152 */   // GIR_Coverage, 477,
     /* 322152 */   GIR_Done,
     /* 322153 */ // Label 6459: @322153
     /* 322153 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(322183), // Rule ID 501 //
     /* 322158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 322161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322172 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 322172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 322177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322181 */   GIR_RootConstrainSelectedInstOperands,
     /* 322182 */   // GIR_Coverage, 501,
     /* 322182 */   GIR_Done,
     /* 322183 */ // Label 6460: @322183
     /* 322183 */ GIM_Reject,
     /* 322184 */ // Label 6415: @322184
     /* 322184 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(322214), // Rule ID 1078 //
     /* 322189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322203 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 322203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 322208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322212 */   GIR_RootConstrainSelectedInstOperands,
     /* 322213 */   // GIR_Coverage, 1078,
     /* 322213 */   GIR_Done,
     /* 322214 */ // Label 6461: @322214
     /* 322214 */ GIM_Reject,
     /* 322215 */ // Label 6416: @322215
     /* 322215 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(322245), // Rule ID 1082 //
     /* 322220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322234 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 322234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 322239 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322243 */   GIR_RootConstrainSelectedInstOperands,
     /* 322244 */   // GIR_Coverage, 1082,
     /* 322244 */   GIR_Done,
     /* 322245 */ // Label 6462: @322245
     /* 322245 */ GIM_Reject,
     /* 322246 */ // Label 6417: @322246
     /* 322246 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(322276), // Rule ID 1074 //
     /* 322251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322265 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 322265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 322270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322274 */   GIR_RootConstrainSelectedInstOperands,
     /* 322275 */   // GIR_Coverage, 1074,
     /* 322275 */   GIR_Done,
     /* 322276 */ // Label 6463: @322276
     /* 322276 */ GIM_Reject,
     /* 322277 */ // Label 6418: @322277
     /* 322277 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(322307), // Rule ID 1080 //
     /* 322282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322296 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 322296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 322301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322305 */   GIR_RootConstrainSelectedInstOperands,
     /* 322306 */   // GIR_Coverage, 1080,
     /* 322306 */   GIR_Done,
     /* 322307 */ // Label 6464: @322307
     /* 322307 */ GIM_Reject,
     /* 322308 */ // Label 6419: @322308
     /* 322308 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(322338), // Rule ID 1076 //
     /* 322313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322327 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 322327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 322332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322336 */   GIR_RootConstrainSelectedInstOperands,
     /* 322337 */   // GIR_Coverage, 1076,
     /* 322337 */   GIR_Done,
     /* 322338 */ // Label 6465: @322338
     /* 322338 */ GIM_Reject,
     /* 322339 */ // Label 6420: @322339
     /* 322339 */ GIM_Reject,
     /* 322340 */ // Label 69: @322340
     /* 322340 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6473*/ GIMT_Encode4(322659),
     /* 322351 */ /*GILLT_s32*//*Label 6466*/ GIMT_Encode4(322387),
     /* 322355 */ /*GILLT_s64*//*Label 6467*/ GIMT_Encode4(322460), GIMT_Encode4(0),
     /* 322363 */ /*GILLT_v2s32*//*Label 6468*/ GIMT_Encode4(322533),
     /* 322367 */ /*GILLT_v2s64*//*Label 6469*/ GIMT_Encode4(322557),
     /* 322371 */ /*GILLT_v4s16*//*Label 6470*/ GIMT_Encode4(322581),
     /* 322375 */ /*GILLT_v4s32*//*Label 6471*/ GIMT_Encode4(322608), GIMT_Encode4(0),
     /* 322383 */ /*GILLT_v8s16*//*Label 6472*/ GIMT_Encode4(322632),
     /* 322387 */ // Label 6466: @322387
     /* 322387 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(322413), // Rule ID 4583 //
     /* 322392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322402 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 322402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 322407 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322411 */   GIR_RootConstrainSelectedInstOperands,
     /* 322412 */   // GIR_Coverage, 4583,
     /* 322412 */   GIR_Done,
     /* 322413 */ // Label 6474: @322413
     /* 322413 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(322436), // Rule ID 4585 //
     /* 322418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322425 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 322425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 322430 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322434 */   GIR_RootConstrainSelectedInstOperands,
     /* 322435 */   // GIR_Coverage, 4585,
     /* 322435 */   GIR_Done,
     /* 322436 */ // Label 6475: @322436
     /* 322436 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(322459), // Rule ID 4587 //
     /* 322441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322448 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 322448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 322453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322457 */   GIR_RootConstrainSelectedInstOperands,
     /* 322458 */   // GIR_Coverage, 4587,
     /* 322458 */   GIR_Done,
     /* 322459 */ // Label 6476: @322459
     /* 322459 */ GIM_Reject,
     /* 322460 */ // Label 6467: @322460
     /* 322460 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(322486), // Rule ID 4584 //
     /* 322465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322475 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 322475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 322480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322484 */   GIR_RootConstrainSelectedInstOperands,
     /* 322485 */   // GIR_Coverage, 4584,
     /* 322485 */   GIR_Done,
     /* 322486 */ // Label 6477: @322486
     /* 322486 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(322509), // Rule ID 4586 //
     /* 322491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322498 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 322498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 322503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322507 */   GIR_RootConstrainSelectedInstOperands,
     /* 322508 */   // GIR_Coverage, 4586,
     /* 322508 */   GIR_Done,
     /* 322509 */ // Label 6478: @322509
     /* 322509 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(322532), // Rule ID 4588 //
     /* 322514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322521 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 322521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 322526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322530 */   GIR_RootConstrainSelectedInstOperands,
     /* 322531 */   // GIR_Coverage, 4588,
     /* 322531 */   GIR_Done,
     /* 322532 */ // Label 6479: @322532
     /* 322532 */ GIM_Reject,
     /* 322533 */ // Label 6468: @322533
     /* 322533 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(322556), // Rule ID 4924 //
     /* 322538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322545 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 322545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 322550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322554 */   GIR_RootConstrainSelectedInstOperands,
     /* 322555 */   // GIR_Coverage, 4924,
     /* 322555 */   GIR_Done,
     /* 322556 */ // Label 6480: @322556
     /* 322556 */ GIM_Reject,
     /* 322557 */ // Label 6469: @322557
     /* 322557 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(322580), // Rule ID 4926 //
     /* 322562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322569 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 322569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 322574 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322578 */   GIR_RootConstrainSelectedInstOperands,
     /* 322579 */   // GIR_Coverage, 4926,
     /* 322579 */   GIR_Done,
     /* 322580 */ // Label 6481: @322580
     /* 322580 */ GIM_Reject,
     /* 322581 */ // Label 6470: @322581
     /* 322581 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(322607), // Rule ID 4919 //
     /* 322586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322596 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 322596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 322601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322605 */   GIR_RootConstrainSelectedInstOperands,
     /* 322606 */   // GIR_Coverage, 4919,
     /* 322606 */   GIR_Done,
     /* 322607 */ // Label 6482: @322607
     /* 322607 */ GIM_Reject,
     /* 322608 */ // Label 6471: @322608
     /* 322608 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(322631), // Rule ID 4925 //
     /* 322613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322620 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 322620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 322625 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322629 */   GIR_RootConstrainSelectedInstOperands,
     /* 322630 */   // GIR_Coverage, 4925,
     /* 322630 */   GIR_Done,
     /* 322631 */ // Label 6483: @322631
     /* 322631 */ GIM_Reject,
     /* 322632 */ // Label 6472: @322632
     /* 322632 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(322658), // Rule ID 4920 //
     /* 322637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322647 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 322647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 322652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322656 */   GIR_RootConstrainSelectedInstOperands,
     /* 322657 */   // GIR_Coverage, 4920,
     /* 322657 */   GIR_Done,
     /* 322658 */ // Label 6484: @322658
     /* 322658 */ GIM_Reject,
     /* 322659 */ // Label 6473: @322659
     /* 322659 */ GIM_Reject,
     /* 322660 */ // Label 70: @322660
     /* 322660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6492*/ GIMT_Encode4(322979),
     /* 322671 */ /*GILLT_s32*//*Label 6485*/ GIMT_Encode4(322707),
     /* 322675 */ /*GILLT_s64*//*Label 6486*/ GIMT_Encode4(322780), GIMT_Encode4(0),
     /* 322683 */ /*GILLT_v2s32*//*Label 6487*/ GIMT_Encode4(322853),
     /* 322687 */ /*GILLT_v2s64*//*Label 6488*/ GIMT_Encode4(322877),
     /* 322691 */ /*GILLT_v4s16*//*Label 6489*/ GIMT_Encode4(322901),
     /* 322695 */ /*GILLT_v4s32*//*Label 6490*/ GIMT_Encode4(322928), GIMT_Encode4(0),
     /* 322703 */ /*GILLT_v8s16*//*Label 6491*/ GIMT_Encode4(322952),
     /* 322707 */ // Label 6485: @322707
     /* 322707 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(322733), // Rule ID 4607 //
     /* 322712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322722 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 322722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 322727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322731 */   GIR_RootConstrainSelectedInstOperands,
     /* 322732 */   // GIR_Coverage, 4607,
     /* 322732 */   GIR_Done,
     /* 322733 */ // Label 6493: @322733
     /* 322733 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(322756), // Rule ID 4609 //
     /* 322738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322745 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 322745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 322750 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322754 */   GIR_RootConstrainSelectedInstOperands,
     /* 322755 */   // GIR_Coverage, 4609,
     /* 322755 */   GIR_Done,
     /* 322756 */ // Label 6494: @322756
     /* 322756 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(322779), // Rule ID 4611 //
     /* 322761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322768 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 322768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 322773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322777 */   GIR_RootConstrainSelectedInstOperands,
     /* 322778 */   // GIR_Coverage, 4611,
     /* 322778 */   GIR_Done,
     /* 322779 */ // Label 6495: @322779
     /* 322779 */ GIM_Reject,
     /* 322780 */ // Label 6486: @322780
     /* 322780 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(322806), // Rule ID 4608 //
     /* 322785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322795 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 322795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 322800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322804 */   GIR_RootConstrainSelectedInstOperands,
     /* 322805 */   // GIR_Coverage, 4608,
     /* 322805 */   GIR_Done,
     /* 322806 */ // Label 6496: @322806
     /* 322806 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(322829), // Rule ID 4610 //
     /* 322811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322818 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 322818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 322823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322827 */   GIR_RootConstrainSelectedInstOperands,
     /* 322828 */   // GIR_Coverage, 4610,
     /* 322828 */   GIR_Done,
     /* 322829 */ // Label 6497: @322829
     /* 322829 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(322852), // Rule ID 4612 //
     /* 322834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322841 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 322841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 322846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322850 */   GIR_RootConstrainSelectedInstOperands,
     /* 322851 */   // GIR_Coverage, 4612,
     /* 322851 */   GIR_Done,
     /* 322852 */ // Label 6498: @322852
     /* 322852 */ GIM_Reject,
     /* 322853 */ // Label 6487: @322853
     /* 322853 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(322876), // Rule ID 4934 //
     /* 322858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322865 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 322865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 322870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322874 */   GIR_RootConstrainSelectedInstOperands,
     /* 322875 */   // GIR_Coverage, 4934,
     /* 322875 */   GIR_Done,
     /* 322876 */ // Label 6499: @322876
     /* 322876 */ GIM_Reject,
     /* 322877 */ // Label 6488: @322877
     /* 322877 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(322900), // Rule ID 4936 //
     /* 322882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322889 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 322889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 322894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322898 */   GIR_RootConstrainSelectedInstOperands,
     /* 322899 */   // GIR_Coverage, 4936,
     /* 322899 */   GIR_Done,
     /* 322900 */ // Label 6500: @322900
     /* 322900 */ GIM_Reject,
     /* 322901 */ // Label 6489: @322901
     /* 322901 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(322927), // Rule ID 4929 //
     /* 322906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322916 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 322916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 322921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322925 */   GIR_RootConstrainSelectedInstOperands,
     /* 322926 */   // GIR_Coverage, 4929,
     /* 322926 */   GIR_Done,
     /* 322927 */ // Label 6501: @322927
     /* 322927 */ GIM_Reject,
     /* 322928 */ // Label 6490: @322928
     /* 322928 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(322951), // Rule ID 4935 //
     /* 322933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322940 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 322940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 322945 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322949 */   GIR_RootConstrainSelectedInstOperands,
     /* 322950 */   // GIR_Coverage, 4935,
     /* 322950 */   GIR_Done,
     /* 322951 */ // Label 6502: @322951
     /* 322951 */ GIM_Reject,
     /* 322952 */ // Label 6491: @322952
     /* 322952 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(322978), // Rule ID 4930 //
     /* 322957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322967 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 322967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 322972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322976 */   GIR_RootConstrainSelectedInstOperands,
     /* 322977 */   // GIR_Coverage, 4930,
     /* 322977 */   GIR_Done,
     /* 322978 */ // Label 6503: @322978
     /* 322978 */ GIM_Reject,
     /* 322979 */ // Label 6492: @322979
     /* 322979 */ GIM_Reject,
     /* 322980 */ // Label 71: @322980
     /* 322980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6512*/ GIMT_Encode4(323836),
     /* 322991 */ /*GILLT_s16*//*Label 6504*/ GIMT_Encode4(323031),
     /* 322995 */ /*GILLT_s32*//*Label 6505*/ GIMT_Encode4(323250),
     /* 322999 */ /*GILLT_s64*//*Label 6506*/ GIMT_Encode4(323324), GIMT_Encode4(0),
     /* 323007 */ /*GILLT_v2s32*//*Label 6507*/ GIMT_Encode4(323398),
     /* 323011 */ /*GILLT_v2s64*//*Label 6508*/ GIMT_Encode4(323472),
     /* 323015 */ /*GILLT_v4s16*//*Label 6509*/ GIMT_Encode4(323546),
     /* 323019 */ /*GILLT_v4s32*//*Label 6510*/ GIMT_Encode4(323654), GIMT_Encode4(0),
     /* 323027 */ /*GILLT_v8s16*//*Label 6511*/ GIMT_Encode4(323728),
     /* 323031 */ // Label 6504: @323031
     /* 323031 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(323249),
     /* 323036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323043 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(323084), // Rule ID 5208 //
     /* 323048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323069 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 323069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 323072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323082 */     GIR_RootConstrainSelectedInstOperands,
     /* 323083 */     // GIR_Coverage, 5208,
     /* 323083 */     GIR_EraseRootFromParent_Done,
     /* 323084 */   // Label 6514: @323084
     /* 323084 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(323103), // Rule ID 521 //
     /* 323089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323096 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 323096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 323101 */     GIR_RootConstrainSelectedInstOperands,
     /* 323102 */     // GIR_Coverage, 521,
     /* 323102 */     GIR_Done,
     /* 323103 */   // Label 6515: @323103
     /* 323103 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(323248), // Rule ID 6368 //
     /* 323108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323112 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 323112 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 323115 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 323119 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 323126 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 323129 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 323133 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323138 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 323141 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 323145 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 323148 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323153 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323158 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 323166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323175 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 323178 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 323186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 323190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323195 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 323198 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 323203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 323205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323230 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 323237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323247 */     // GIR_Coverage, 6368,
     /* 323247 */     GIR_EraseRootFromParent_Done,
     /* 323248 */   // Label 6516: @323248
     /* 323248 */   GIM_Reject,
     /* 323249 */ // Label 6513: @323249
     /* 323249 */ GIM_Reject,
     /* 323250 */ // Label 6505: @323250
     /* 323250 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(323323),
     /* 323255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323262 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(323303), // Rule ID 5209 //
     /* 323267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 323286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323288 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 323288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 323291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323301 */     GIR_RootConstrainSelectedInstOperands,
     /* 323302 */     // GIR_Coverage, 5209,
     /* 323302 */     GIR_EraseRootFromParent_Done,
     /* 323303 */   // Label 6518: @323303
     /* 323303 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(323322), // Rule ID 522 //
     /* 323308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323315 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 323315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 323320 */     GIR_RootConstrainSelectedInstOperands,
     /* 323321 */     // GIR_Coverage, 522,
     /* 323321 */     GIR_Done,
     /* 323322 */   // Label 6519: @323322
     /* 323322 */   GIM_Reject,
     /* 323323 */ // Label 6517: @323323
     /* 323323 */ GIM_Reject,
     /* 323324 */ // Label 6506: @323324
     /* 323324 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(323397),
     /* 323329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323336 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(323377), // Rule ID 5210 //
     /* 323341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323362 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 323362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 323365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323375 */     GIR_RootConstrainSelectedInstOperands,
     /* 323376 */     // GIR_Coverage, 5210,
     /* 323376 */     GIR_EraseRootFromParent_Done,
     /* 323377 */   // Label 6521: @323377
     /* 323377 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(323396), // Rule ID 523 //
     /* 323382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323389 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 323389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 323394 */     GIR_RootConstrainSelectedInstOperands,
     /* 323395 */     // GIR_Coverage, 523,
     /* 323395 */     GIR_Done,
     /* 323396 */   // Label 6522: @323396
     /* 323396 */   GIM_Reject,
     /* 323397 */ // Label 6520: @323397
     /* 323397 */ GIM_Reject,
     /* 323398 */ // Label 6507: @323398
     /* 323398 */ GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(323471),
     /* 323403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323410 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(323451), // Rule ID 5001 //
     /* 323415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323436 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 323436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 323439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323449 */     GIR_RootConstrainSelectedInstOperands,
     /* 323450 */     // GIR_Coverage, 5001,
     /* 323450 */     GIR_EraseRootFromParent_Done,
     /* 323451 */   // Label 6524: @323451
     /* 323451 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(323470), // Rule ID 768 //
     /* 323456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323463 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 323463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 323468 */     GIR_RootConstrainSelectedInstOperands,
     /* 323469 */     // GIR_Coverage, 768,
     /* 323469 */     GIR_Done,
     /* 323470 */   // Label 6525: @323470
     /* 323470 */   GIM_Reject,
     /* 323471 */ // Label 6523: @323471
     /* 323471 */ GIM_Reject,
     /* 323472 */ // Label 6508: @323472
     /* 323472 */ GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(323545),
     /* 323477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323484 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(323525), // Rule ID 5003 //
     /* 323489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323510 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 323510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 323513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323523 */     GIR_RootConstrainSelectedInstOperands,
     /* 323524 */     // GIR_Coverage, 5003,
     /* 323524 */     GIR_EraseRootFromParent_Done,
     /* 323525 */   // Label 6527: @323525
     /* 323525 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(323544), // Rule ID 770 //
     /* 323530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323537 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 323537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 323542 */     GIR_RootConstrainSelectedInstOperands,
     /* 323543 */     // GIR_Coverage, 770,
     /* 323543 */     GIR_Done,
     /* 323544 */   // Label 6528: @323544
     /* 323544 */   GIM_Reject,
     /* 323545 */ // Label 6526: @323545
     /* 323545 */ GIM_Reject,
     /* 323546 */ // Label 6509: @323546
     /* 323546 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(323653),
     /* 323551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323558 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(323599), // Rule ID 5004 //
     /* 323563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323584 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 323584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 323587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323597 */     GIR_RootConstrainSelectedInstOperands,
     /* 323598 */     // GIR_Coverage, 5004,
     /* 323598 */     GIR_EraseRootFromParent_Done,
     /* 323599 */   // Label 6530: @323599
     /* 323599 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(323618), // Rule ID 766 //
     /* 323604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323611 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 323611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 323616 */     GIR_RootConstrainSelectedInstOperands,
     /* 323617 */     // GIR_Coverage, 766,
     /* 323617 */     GIR_Done,
     /* 323618 */   // Label 6531: @323618
     /* 323618 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(323652), // Rule ID 6370 //
     /* 323623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323630 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 323630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 323633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323637 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 323647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 323650 */     GIR_RootConstrainSelectedInstOperands,
     /* 323651 */     // GIR_Coverage, 6370,
     /* 323651 */     GIR_EraseRootFromParent_Done,
     /* 323652 */   // Label 6532: @323652
     /* 323652 */   GIM_Reject,
     /* 323653 */ // Label 6529: @323653
     /* 323653 */ GIM_Reject,
     /* 323654 */ // Label 6510: @323654
     /* 323654 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(323727),
     /* 323659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323666 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(323707), // Rule ID 5002 //
     /* 323671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323692 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 323692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 323695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323705 */     GIR_RootConstrainSelectedInstOperands,
     /* 323706 */     // GIR_Coverage, 5002,
     /* 323706 */     GIR_EraseRootFromParent_Done,
     /* 323707 */   // Label 6534: @323707
     /* 323707 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(323726), // Rule ID 769 //
     /* 323712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323719 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 323719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 323724 */     GIR_RootConstrainSelectedInstOperands,
     /* 323725 */     // GIR_Coverage, 769,
     /* 323725 */     GIR_Done,
     /* 323726 */   // Label 6535: @323726
     /* 323726 */   GIM_Reject,
     /* 323727 */ // Label 6533: @323727
     /* 323727 */ GIM_Reject,
     /* 323728 */ // Label 6511: @323728
     /* 323728 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(323835),
     /* 323733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323740 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(323781), // Rule ID 5005 //
     /* 323745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 323756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323766 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 323766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 323769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 323779 */     GIR_RootConstrainSelectedInstOperands,
     /* 323780 */     // GIR_Coverage, 5005,
     /* 323780 */     GIR_EraseRootFromParent_Done,
     /* 323781 */   // Label 6537: @323781
     /* 323781 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(323800), // Rule ID 767 //
     /* 323786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323793 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 323793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 323798 */     GIR_RootConstrainSelectedInstOperands,
     /* 323799 */     // GIR_Coverage, 767,
     /* 323799 */     GIR_Done,
     /* 323800 */   // Label 6538: @323800
     /* 323800 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(323834), // Rule ID 6371 //
     /* 323805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323812 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 323812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 323815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323819 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 323829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 323832 */     GIR_RootConstrainSelectedInstOperands,
     /* 323833 */     // GIR_Coverage, 6371,
     /* 323833 */     GIR_EraseRootFromParent_Done,
     /* 323834 */   // Label 6539: @323834
     /* 323834 */   GIM_Reject,
     /* 323835 */ // Label 6536: @323835
     /* 323835 */ GIM_Reject,
     /* 323836 */ // Label 6512: @323836
     /* 323836 */ GIM_Reject,
     /* 323837 */ // Label 72: @323837
     /* 323837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6548*/ GIMT_Encode4(324118),
     /* 323848 */ /*GILLT_s16*//*Label 6540*/ GIMT_Encode4(323888),
     /* 323852 */ /*GILLT_s32*//*Label 6541*/ GIMT_Encode4(323915),
     /* 323856 */ /*GILLT_s64*//*Label 6542*/ GIMT_Encode4(323939), GIMT_Encode4(0),
     /* 323864 */ /*GILLT_v2s32*//*Label 6543*/ GIMT_Encode4(323963),
     /* 323868 */ /*GILLT_v2s64*//*Label 6544*/ GIMT_Encode4(323994),
     /* 323872 */ /*GILLT_v4s16*//*Label 6545*/ GIMT_Encode4(324025),
     /* 323876 */ /*GILLT_v4s32*//*Label 6546*/ GIMT_Encode4(324056), GIMT_Encode4(0),
     /* 323884 */ /*GILLT_v8s16*//*Label 6547*/ GIMT_Encode4(324087),
     /* 323888 */ // Label 6540: @323888
     /* 323888 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(323914), // Rule ID 4823 //
     /* 323893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323903 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 323903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323908 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323910 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323912 */   GIR_RootConstrainSelectedInstOperands,
     /* 323913 */   // GIR_Coverage, 4823,
     /* 323913 */   GIR_EraseRootFromParent_Done,
     /* 323914 */ // Label 6549: @323914
     /* 323914 */ GIM_Reject,
     /* 323915 */ // Label 6541: @323915
     /* 323915 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(323938), // Rule ID 4820 //
     /* 323920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323927 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 323927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323932 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323934 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323936 */   GIR_RootConstrainSelectedInstOperands,
     /* 323937 */   // GIR_Coverage, 4820,
     /* 323937 */   GIR_EraseRootFromParent_Done,
     /* 323938 */ // Label 6550: @323938
     /* 323938 */ GIM_Reject,
     /* 323939 */ // Label 6542: @323939
     /* 323939 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(323962), // Rule ID 4817 //
     /* 323944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323951 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 323951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323956 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323958 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 323960 */   GIR_RootConstrainSelectedInstOperands,
     /* 323961 */   // GIR_Coverage, 4817,
     /* 323961 */   GIR_EraseRootFromParent_Done,
     /* 323962 */ // Label 6551: @323962
     /* 323962 */ GIM_Reject,
     /* 323963 */ // Label 6543: @323963
     /* 323963 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(323993), // Rule ID 5014 //
     /* 323968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323982 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 323982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 323985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323989 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323991 */   GIR_RootConstrainSelectedInstOperands,
     /* 323992 */   // GIR_Coverage, 5014,
     /* 323992 */   GIR_EraseRootFromParent_Done,
     /* 323993 */ // Label 6552: @323993
     /* 323993 */ GIM_Reject,
     /* 323994 */ // Label 6544: @323994
     /* 323994 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(324024), // Rule ID 5008 //
     /* 323999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324013 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 324013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 324016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324018 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324020 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324022 */   GIR_RootConstrainSelectedInstOperands,
     /* 324023 */   // GIR_Coverage, 5008,
     /* 324023 */   GIR_EraseRootFromParent_Done,
     /* 324024 */ // Label 6553: @324024
     /* 324024 */ GIM_Reject,
     /* 324025 */ // Label 6545: @324025
     /* 324025 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(324055), // Rule ID 5020 //
     /* 324030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324044 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 324044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 324047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324049 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324051 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324053 */   GIR_RootConstrainSelectedInstOperands,
     /* 324054 */   // GIR_Coverage, 5020,
     /* 324054 */   GIR_EraseRootFromParent_Done,
     /* 324055 */ // Label 6554: @324055
     /* 324055 */ GIM_Reject,
     /* 324056 */ // Label 6546: @324056
     /* 324056 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(324086), // Rule ID 5011 //
     /* 324061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324075 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 324075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 324078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324080 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324082 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324084 */   GIR_RootConstrainSelectedInstOperands,
     /* 324085 */   // GIR_Coverage, 5011,
     /* 324085 */   GIR_EraseRootFromParent_Done,
     /* 324086 */ // Label 6555: @324086
     /* 324086 */ GIM_Reject,
     /* 324087 */ // Label 6547: @324087
     /* 324087 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(324117), // Rule ID 5017 //
     /* 324092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324106 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 324106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 324109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324111 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324115 */   GIR_RootConstrainSelectedInstOperands,
     /* 324116 */   // GIR_Coverage, 5017,
     /* 324116 */   GIR_EraseRootFromParent_Done,
     /* 324117 */ // Label 6556: @324117
     /* 324117 */ GIM_Reject,
     /* 324118 */ // Label 6548: @324118
     /* 324118 */ GIM_Reject,
     /* 324119 */ // Label 73: @324119
     /* 324119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6565*/ GIMT_Encode4(324496),
     /* 324130 */ /*GILLT_s16*//*Label 6557*/ GIMT_Encode4(324170),
     /* 324134 */ /*GILLT_s32*//*Label 6558*/ GIMT_Encode4(324208),
     /* 324138 */ /*GILLT_s64*//*Label 6559*/ GIMT_Encode4(324246), GIMT_Encode4(0),
     /* 324146 */ /*GILLT_v2s32*//*Label 6560*/ GIMT_Encode4(324306),
     /* 324150 */ /*GILLT_v2s64*//*Label 6561*/ GIMT_Encode4(324344),
     /* 324154 */ /*GILLT_v4s16*//*Label 6562*/ GIMT_Encode4(324382),
     /* 324158 */ /*GILLT_v4s32*//*Label 6563*/ GIMT_Encode4(324420), GIMT_Encode4(0),
     /* 324166 */ /*GILLT_v8s16*//*Label 6564*/ GIMT_Encode4(324458),
     /* 324170 */ // Label 6557: @324170
     /* 324170 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(324207), // Rule ID 608 //
     /* 324175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324196 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 324201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324205 */   GIR_RootConstrainSelectedInstOperands,
     /* 324206 */   // GIR_Coverage, 608,
     /* 324206 */   GIR_Done,
     /* 324207 */ // Label 6566: @324207
     /* 324207 */ GIM_Reject,
     /* 324208 */ // Label 6558: @324208
     /* 324208 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(324245), // Rule ID 610 //
     /* 324213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324234 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 324239 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324243 */   GIR_RootConstrainSelectedInstOperands,
     /* 324244 */   // GIR_Coverage, 610,
     /* 324244 */   GIR_Done,
     /* 324245 */ // Label 6567: @324245
     /* 324245 */ GIM_Reject,
     /* 324246 */ // Label 6559: @324246
     /* 324246 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(324305),
     /* 324251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324269 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(324288), // Rule ID 612 //
     /* 324274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324277 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 324282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324286 */     GIR_RootConstrainSelectedInstOperands,
     /* 324287 */     // GIR_Coverage, 612,
     /* 324287 */     GIR_Done,
     /* 324288 */   // Label 6569: @324288
     /* 324288 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(324304), // Rule ID 4814 //
     /* 324293 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 324298 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324302 */     GIR_RootConstrainSelectedInstOperands,
     /* 324303 */     // GIR_Coverage, 4814,
     /* 324303 */     GIR_Done,
     /* 324304 */   // Label 6570: @324304
     /* 324304 */   GIM_Reject,
     /* 324305 */ // Label 6568: @324305
     /* 324305 */ GIM_Reject,
     /* 324306 */ // Label 6560: @324306
     /* 324306 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(324343), // Rule ID 1273 //
     /* 324311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324332 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 324337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324341 */   GIR_RootConstrainSelectedInstOperands,
     /* 324342 */   // GIR_Coverage, 1273,
     /* 324342 */   GIR_Done,
     /* 324343 */ // Label 6571: @324343
     /* 324343 */ GIM_Reject,
     /* 324344 */ // Label 6561: @324344
     /* 324344 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(324381), // Rule ID 1277 //
     /* 324349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324370 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 324375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324379 */   GIR_RootConstrainSelectedInstOperands,
     /* 324380 */   // GIR_Coverage, 1277,
     /* 324380 */   GIR_Done,
     /* 324381 */ // Label 6572: @324381
     /* 324381 */ GIM_Reject,
     /* 324382 */ // Label 6562: @324382
     /* 324382 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(324419), // Rule ID 1269 //
     /* 324387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324408 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 324413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324417 */   GIR_RootConstrainSelectedInstOperands,
     /* 324418 */   // GIR_Coverage, 1269,
     /* 324418 */   GIR_Done,
     /* 324419 */ // Label 6573: @324419
     /* 324419 */ GIM_Reject,
     /* 324420 */ // Label 6563: @324420
     /* 324420 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(324457), // Rule ID 1275 //
     /* 324425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324446 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 324451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324455 */   GIR_RootConstrainSelectedInstOperands,
     /* 324456 */   // GIR_Coverage, 1275,
     /* 324456 */   GIR_Done,
     /* 324457 */ // Label 6574: @324457
     /* 324457 */ GIM_Reject,
     /* 324458 */ // Label 6564: @324458
     /* 324458 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(324495), // Rule ID 1271 //
     /* 324463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324484 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 324489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324493 */   GIR_RootConstrainSelectedInstOperands,
     /* 324494 */   // GIR_Coverage, 1271,
     /* 324494 */   GIR_Done,
     /* 324495 */ // Label 6575: @324495
     /* 324495 */ GIM_Reject,
     /* 324496 */ // Label 6565: @324496
     /* 324496 */ GIM_Reject,
     /* 324497 */ // Label 74: @324497
     /* 324497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6584*/ GIMT_Encode4(324874),
     /* 324508 */ /*GILLT_s16*//*Label 6576*/ GIMT_Encode4(324548),
     /* 324512 */ /*GILLT_s32*//*Label 6577*/ GIMT_Encode4(324586),
     /* 324516 */ /*GILLT_s64*//*Label 6578*/ GIMT_Encode4(324624), GIMT_Encode4(0),
     /* 324524 */ /*GILLT_v2s32*//*Label 6579*/ GIMT_Encode4(324684),
     /* 324528 */ /*GILLT_v2s64*//*Label 6580*/ GIMT_Encode4(324722),
     /* 324532 */ /*GILLT_v4s16*//*Label 6581*/ GIMT_Encode4(324760),
     /* 324536 */ /*GILLT_v4s32*//*Label 6582*/ GIMT_Encode4(324798), GIMT_Encode4(0),
     /* 324544 */ /*GILLT_v8s16*//*Label 6583*/ GIMT_Encode4(324836),
     /* 324548 */ // Label 6576: @324548
     /* 324548 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(324585), // Rule ID 596 //
     /* 324553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324574 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 324579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324583 */   GIR_RootConstrainSelectedInstOperands,
     /* 324584 */   // GIR_Coverage, 596,
     /* 324584 */   GIR_Done,
     /* 324585 */ // Label 6585: @324585
     /* 324585 */ GIM_Reject,
     /* 324586 */ // Label 6577: @324586
     /* 324586 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(324623), // Rule ID 598 //
     /* 324591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324612 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 324617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324621 */   GIR_RootConstrainSelectedInstOperands,
     /* 324622 */   // GIR_Coverage, 598,
     /* 324622 */   GIR_Done,
     /* 324623 */ // Label 6586: @324623
     /* 324623 */ GIM_Reject,
     /* 324624 */ // Label 6578: @324624
     /* 324624 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(324683),
     /* 324629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324643 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324647 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(324666), // Rule ID 600 //
     /* 324652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324655 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 324660 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324664 */     GIR_RootConstrainSelectedInstOperands,
     /* 324665 */     // GIR_Coverage, 600,
     /* 324665 */     GIR_Done,
     /* 324666 */   // Label 6588: @324666
     /* 324666 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(324682), // Rule ID 4813 //
     /* 324671 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 324676 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324680 */     GIR_RootConstrainSelectedInstOperands,
     /* 324681 */     // GIR_Coverage, 4813,
     /* 324681 */     GIR_Done,
     /* 324682 */   // Label 6589: @324682
     /* 324682 */   GIM_Reject,
     /* 324683 */ // Label 6587: @324683
     /* 324683 */ GIM_Reject,
     /* 324684 */ // Label 6579: @324684
     /* 324684 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(324721), // Rule ID 1243 //
     /* 324689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324710 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 324715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324719 */   GIR_RootConstrainSelectedInstOperands,
     /* 324720 */   // GIR_Coverage, 1243,
     /* 324720 */   GIR_Done,
     /* 324721 */ // Label 6590: @324721
     /* 324721 */ GIM_Reject,
     /* 324722 */ // Label 6580: @324722
     /* 324722 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(324759), // Rule ID 1247 //
     /* 324727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324748 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 324753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324757 */   GIR_RootConstrainSelectedInstOperands,
     /* 324758 */   // GIR_Coverage, 1247,
     /* 324758 */   GIR_Done,
     /* 324759 */ // Label 6591: @324759
     /* 324759 */ GIM_Reject,
     /* 324760 */ // Label 6581: @324760
     /* 324760 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(324797), // Rule ID 1239 //
     /* 324765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324786 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 324791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324795 */   GIR_RootConstrainSelectedInstOperands,
     /* 324796 */   // GIR_Coverage, 1239,
     /* 324796 */   GIR_Done,
     /* 324797 */ // Label 6592: @324797
     /* 324797 */ GIM_Reject,
     /* 324798 */ // Label 6582: @324798
     /* 324798 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(324835), // Rule ID 1245 //
     /* 324803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324824 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 324829 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324833 */   GIR_RootConstrainSelectedInstOperands,
     /* 324834 */   // GIR_Coverage, 1245,
     /* 324834 */   GIR_Done,
     /* 324835 */ // Label 6593: @324835
     /* 324835 */ GIM_Reject,
     /* 324836 */ // Label 6583: @324836
     /* 324836 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(324873), // Rule ID 1241 //
     /* 324841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324862 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 324867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324871 */   GIR_RootConstrainSelectedInstOperands,
     /* 324872 */   // GIR_Coverage, 1241,
     /* 324872 */   GIR_Done,
     /* 324873 */ // Label 6594: @324873
     /* 324873 */ GIM_Reject,
     /* 324874 */ // Label 6584: @324874
     /* 324874 */ GIM_Reject,
     /* 324875 */ // Label 75: @324875
     /* 324875 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6603*/ GIMT_Encode4(325224),
     /* 324886 */ /*GILLT_s16*//*Label 6595*/ GIMT_Encode4(324926),
     /* 324890 */ /*GILLT_s32*//*Label 6596*/ GIMT_Encode4(324964),
     /* 324894 */ /*GILLT_s64*//*Label 6597*/ GIMT_Encode4(324999), GIMT_Encode4(0),
     /* 324902 */ /*GILLT_v2s32*//*Label 6598*/ GIMT_Encode4(325034),
     /* 324906 */ /*GILLT_v2s64*//*Label 6599*/ GIMT_Encode4(325072),
     /* 324910 */ /*GILLT_v4s16*//*Label 6600*/ GIMT_Encode4(325110),
     /* 324914 */ /*GILLT_v4s32*//*Label 6601*/ GIMT_Encode4(325148), GIMT_Encode4(0),
     /* 324922 */ /*GILLT_v8s16*//*Label 6602*/ GIMT_Encode4(325186),
     /* 324926 */ // Label 6595: @324926
     /* 324926 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(324963), // Rule ID 4821 //
     /* 324931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324952 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 324952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 324957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324961 */   GIR_RootConstrainSelectedInstOperands,
     /* 324962 */   // GIR_Coverage, 4821,
     /* 324962 */   GIR_Done,
     /* 324963 */ // Label 6604: @324963
     /* 324963 */ GIM_Reject,
     /* 324964 */ // Label 6596: @324964
     /* 324964 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(324998), // Rule ID 4818 //
     /* 324969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324987 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 324987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 324992 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324996 */   GIR_RootConstrainSelectedInstOperands,
     /* 324997 */   // GIR_Coverage, 4818,
     /* 324997 */   GIR_Done,
     /* 324998 */ // Label 6605: @324998
     /* 324998 */ GIM_Reject,
     /* 324999 */ // Label 6597: @324999
     /* 324999 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(325033), // Rule ID 4815 //
     /* 325004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325022 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 325022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 325027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325031 */   GIR_RootConstrainSelectedInstOperands,
     /* 325032 */   // GIR_Coverage, 4815,
     /* 325032 */   GIR_Done,
     /* 325033 */ // Label 6606: @325033
     /* 325033 */ GIM_Reject,
     /* 325034 */ // Label 6598: @325034
     /* 325034 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(325071), // Rule ID 5012 //
     /* 325039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325060 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 325065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325069 */   GIR_RootConstrainSelectedInstOperands,
     /* 325070 */   // GIR_Coverage, 5012,
     /* 325070 */   GIR_Done,
     /* 325071 */ // Label 6607: @325071
     /* 325071 */ GIM_Reject,
     /* 325072 */ // Label 6599: @325072
     /* 325072 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(325109), // Rule ID 5006 //
     /* 325077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325098 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 325103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325107 */   GIR_RootConstrainSelectedInstOperands,
     /* 325108 */   // GIR_Coverage, 5006,
     /* 325108 */   GIR_Done,
     /* 325109 */ // Label 6608: @325109
     /* 325109 */ GIM_Reject,
     /* 325110 */ // Label 6600: @325110
     /* 325110 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(325147), // Rule ID 5018 //
     /* 325115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325136 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 325141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325145 */   GIR_RootConstrainSelectedInstOperands,
     /* 325146 */   // GIR_Coverage, 5018,
     /* 325146 */   GIR_Done,
     /* 325147 */ // Label 6609: @325147
     /* 325147 */ GIM_Reject,
     /* 325148 */ // Label 6601: @325148
     /* 325148 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(325185), // Rule ID 5009 //
     /* 325153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325174 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 325179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325183 */   GIR_RootConstrainSelectedInstOperands,
     /* 325184 */   // GIR_Coverage, 5009,
     /* 325184 */   GIR_Done,
     /* 325185 */ // Label 6610: @325185
     /* 325185 */ GIM_Reject,
     /* 325186 */ // Label 6602: @325186
     /* 325186 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(325223), // Rule ID 5015 //
     /* 325191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325212 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 325217 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325221 */   GIR_RootConstrainSelectedInstOperands,
     /* 325222 */   // GIR_Coverage, 5015,
     /* 325222 */   GIR_Done,
     /* 325223 */ // Label 6611: @325223
     /* 325223 */ GIM_Reject,
     /* 325224 */ // Label 6603: @325224
     /* 325224 */ GIM_Reject,
     /* 325225 */ // Label 76: @325225
     /* 325225 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6620*/ GIMT_Encode4(325574),
     /* 325236 */ /*GILLT_s16*//*Label 6612*/ GIMT_Encode4(325276),
     /* 325240 */ /*GILLT_s32*//*Label 6613*/ GIMT_Encode4(325314),
     /* 325244 */ /*GILLT_s64*//*Label 6614*/ GIMT_Encode4(325349), GIMT_Encode4(0),
     /* 325252 */ /*GILLT_v2s32*//*Label 6615*/ GIMT_Encode4(325384),
     /* 325256 */ /*GILLT_v2s64*//*Label 6616*/ GIMT_Encode4(325422),
     /* 325260 */ /*GILLT_v4s16*//*Label 6617*/ GIMT_Encode4(325460),
     /* 325264 */ /*GILLT_v4s32*//*Label 6618*/ GIMT_Encode4(325498), GIMT_Encode4(0),
     /* 325272 */ /*GILLT_v8s16*//*Label 6619*/ GIMT_Encode4(325536),
     /* 325276 */ // Label 6612: @325276
     /* 325276 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(325313), // Rule ID 4822 //
     /* 325281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325302 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 325302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 325307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325311 */   GIR_RootConstrainSelectedInstOperands,
     /* 325312 */   // GIR_Coverage, 4822,
     /* 325312 */   GIR_Done,
     /* 325313 */ // Label 6621: @325313
     /* 325313 */ GIM_Reject,
     /* 325314 */ // Label 6613: @325314
     /* 325314 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(325348), // Rule ID 4819 //
     /* 325319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325337 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 325337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 325342 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325346 */   GIR_RootConstrainSelectedInstOperands,
     /* 325347 */   // GIR_Coverage, 4819,
     /* 325347 */   GIR_Done,
     /* 325348 */ // Label 6622: @325348
     /* 325348 */ GIM_Reject,
     /* 325349 */ // Label 6614: @325349
     /* 325349 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(325383), // Rule ID 4816 //
     /* 325354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325372 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 325372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 325377 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325381 */   GIR_RootConstrainSelectedInstOperands,
     /* 325382 */   // GIR_Coverage, 4816,
     /* 325382 */   GIR_Done,
     /* 325383 */ // Label 6623: @325383
     /* 325383 */ GIM_Reject,
     /* 325384 */ // Label 6615: @325384
     /* 325384 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(325421), // Rule ID 5013 //
     /* 325389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325410 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 325415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325419 */   GIR_RootConstrainSelectedInstOperands,
     /* 325420 */   // GIR_Coverage, 5013,
     /* 325420 */   GIR_Done,
     /* 325421 */ // Label 6624: @325421
     /* 325421 */ GIM_Reject,
     /* 325422 */ // Label 6616: @325422
     /* 325422 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(325459), // Rule ID 5007 //
     /* 325427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325448 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 325453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325457 */   GIR_RootConstrainSelectedInstOperands,
     /* 325458 */   // GIR_Coverage, 5007,
     /* 325458 */   GIR_Done,
     /* 325459 */ // Label 6625: @325459
     /* 325459 */ GIM_Reject,
     /* 325460 */ // Label 6617: @325460
     /* 325460 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(325497), // Rule ID 5019 //
     /* 325465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325486 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 325491 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325495 */   GIR_RootConstrainSelectedInstOperands,
     /* 325496 */   // GIR_Coverage, 5019,
     /* 325496 */   GIR_Done,
     /* 325497 */ // Label 6626: @325497
     /* 325497 */ GIM_Reject,
     /* 325498 */ // Label 6618: @325498
     /* 325498 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(325535), // Rule ID 5010 //
     /* 325503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325524 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 325529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325533 */   GIR_RootConstrainSelectedInstOperands,
     /* 325534 */   // GIR_Coverage, 5010,
     /* 325534 */   GIR_Done,
     /* 325535 */ // Label 6627: @325535
     /* 325535 */ GIM_Reject,
     /* 325536 */ // Label 6619: @325536
     /* 325536 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(325573), // Rule ID 5016 //
     /* 325541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325562 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 325567 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325571 */   GIR_RootConstrainSelectedInstOperands,
     /* 325572 */   // GIR_Coverage, 5016,
     /* 325572 */   GIR_Done,
     /* 325573 */ // Label 6628: @325573
     /* 325573 */ GIM_Reject,
     /* 325574 */ // Label 6620: @325574
     /* 325574 */ GIM_Reject,
     /* 325575 */ // Label 77: @325575
     /* 325575 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6637*/ GIMT_Encode4(326277),
     /* 325586 */ /*GILLT_s16*//*Label 6629*/ GIMT_Encode4(325626),
     /* 325590 */ /*GILLT_s32*//*Label 6630*/ GIMT_Encode4(325664),
     /* 325594 */ /*GILLT_s64*//*Label 6631*/ GIMT_Encode4(325702), GIMT_Encode4(0),
     /* 325602 */ /*GILLT_v2s32*//*Label 6632*/ GIMT_Encode4(325762),
     /* 325606 */ /*GILLT_v2s64*//*Label 6633*/ GIMT_Encode4(325865),
     /* 325610 */ /*GILLT_v4s16*//*Label 6634*/ GIMT_Encode4(325968),
     /* 325614 */ /*GILLT_v4s32*//*Label 6635*/ GIMT_Encode4(326071), GIMT_Encode4(0),
     /* 325622 */ /*GILLT_v8s16*//*Label 6636*/ GIMT_Encode4(326174),
     /* 325626 */ // Label 6629: @325626
     /* 325626 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(325663), // Rule ID 614 //
     /* 325631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325652 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 325657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325661 */   GIR_RootConstrainSelectedInstOperands,
     /* 325662 */   // GIR_Coverage, 614,
     /* 325662 */   GIR_Done,
     /* 325663 */ // Label 6638: @325663
     /* 325663 */ GIM_Reject,
     /* 325664 */ // Label 6630: @325664
     /* 325664 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(325701), // Rule ID 616 //
     /* 325669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325690 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 325695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325699 */   GIR_RootConstrainSelectedInstOperands,
     /* 325700 */   // GIR_Coverage, 616,
     /* 325700 */   GIR_Done,
     /* 325701 */ // Label 6639: @325701
     /* 325701 */ GIM_Reject,
     /* 325702 */ // Label 6631: @325702
     /* 325702 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(325761),
     /* 325707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325725 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(325744), // Rule ID 618 //
     /* 325730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325733 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 325738 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325742 */     GIR_RootConstrainSelectedInstOperands,
     /* 325743 */     // GIR_Coverage, 618,
     /* 325743 */     GIR_Done,
     /* 325744 */   // Label 6641: @325744
     /* 325744 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(325760), // Rule ID 4812 //
     /* 325749 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 325749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 325754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325758 */     GIR_RootConstrainSelectedInstOperands,
     /* 325759 */     // GIR_Coverage, 4812,
     /* 325759 */     GIR_Done,
     /* 325760 */   // Label 6642: @325760
     /* 325760 */   GIM_Reject,
     /* 325761 */ // Label 6640: @325761
     /* 325761 */ GIM_Reject,
     /* 325762 */ // Label 6632: @325762
     /* 325762 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(325864),
     /* 325767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325777 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(325836), // Rule ID 2366 //
     /* 325782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325821 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 325824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325834 */     GIR_RootConstrainSelectedInstOperands,
     /* 325835 */     // GIR_Coverage, 2366,
     /* 325835 */     GIR_EraseRootFromParent_Done,
     /* 325836 */   // Label 6644: @325836
     /* 325836 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(325863), // Rule ID 1288 //
     /* 325841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325852 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 325857 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325861 */     GIR_RootConstrainSelectedInstOperands,
     /* 325862 */     // GIR_Coverage, 1288,
     /* 325862 */     GIR_Done,
     /* 325863 */   // Label 6645: @325863
     /* 325863 */   GIM_Reject,
     /* 325864 */ // Label 6643: @325864
     /* 325864 */ GIM_Reject,
     /* 325865 */ // Label 6633: @325865
     /* 325865 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(325967),
     /* 325870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325880 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(325939), // Rule ID 2372 //
     /* 325885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325924 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 325927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325937 */     GIR_RootConstrainSelectedInstOperands,
     /* 325938 */     // GIR_Coverage, 2372,
     /* 325938 */     GIR_EraseRootFromParent_Done,
     /* 325939 */   // Label 6647: @325939
     /* 325939 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(325966), // Rule ID 1292 //
     /* 325944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325955 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 325960 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325964 */     GIR_RootConstrainSelectedInstOperands,
     /* 325965 */     // GIR_Coverage, 1292,
     /* 325965 */     GIR_Done,
     /* 325966 */   // Label 6648: @325966
     /* 325966 */   GIM_Reject,
     /* 325967 */ // Label 6646: @325967
     /* 325967 */ GIM_Reject,
     /* 325968 */ // Label 6634: @325968
     /* 325968 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(326070),
     /* 325973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325983 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(326042), // Rule ID 2360 //
     /* 325988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326027 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 326030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326040 */     GIR_RootConstrainSelectedInstOperands,
     /* 326041 */     // GIR_Coverage, 2360,
     /* 326041 */     GIR_EraseRootFromParent_Done,
     /* 326042 */   // Label 6650: @326042
     /* 326042 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(326069), // Rule ID 1284 //
     /* 326047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326058 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 326063 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326067 */     GIR_RootConstrainSelectedInstOperands,
     /* 326068 */     // GIR_Coverage, 1284,
     /* 326068 */     GIR_Done,
     /* 326069 */   // Label 6651: @326069
     /* 326069 */   GIM_Reject,
     /* 326070 */ // Label 6649: @326070
     /* 326070 */ GIM_Reject,
     /* 326071 */ // Label 6635: @326071
     /* 326071 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(326173),
     /* 326076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326086 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(326145), // Rule ID 2369 //
     /* 326091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326130 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 326133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326143 */     GIR_RootConstrainSelectedInstOperands,
     /* 326144 */     // GIR_Coverage, 2369,
     /* 326144 */     GIR_EraseRootFromParent_Done,
     /* 326145 */   // Label 6653: @326145
     /* 326145 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(326172), // Rule ID 1290 //
     /* 326150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326161 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 326166 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326170 */     GIR_RootConstrainSelectedInstOperands,
     /* 326171 */     // GIR_Coverage, 1290,
     /* 326171 */     GIR_Done,
     /* 326172 */   // Label 6654: @326172
     /* 326172 */   GIM_Reject,
     /* 326173 */ // Label 6652: @326173
     /* 326173 */ GIM_Reject,
     /* 326174 */ // Label 6636: @326174
     /* 326174 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(326276),
     /* 326179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326189 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(326248), // Rule ID 2363 //
     /* 326194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326233 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 326236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326246 */     GIR_RootConstrainSelectedInstOperands,
     /* 326247 */     // GIR_Coverage, 2363,
     /* 326247 */     GIR_EraseRootFromParent_Done,
     /* 326248 */   // Label 6656: @326248
     /* 326248 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(326275), // Rule ID 1286 //
     /* 326253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326264 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 326269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326273 */     GIR_RootConstrainSelectedInstOperands,
     /* 326274 */     // GIR_Coverage, 1286,
     /* 326274 */     GIR_Done,
     /* 326275 */   // Label 6657: @326275
     /* 326275 */   GIM_Reject,
     /* 326276 */ // Label 6655: @326276
     /* 326276 */ GIM_Reject,
     /* 326277 */ // Label 6637: @326277
     /* 326277 */ GIM_Reject,
     /* 326278 */ // Label 78: @326278
     /* 326278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6666*/ GIMT_Encode4(326980),
     /* 326289 */ /*GILLT_s16*//*Label 6658*/ GIMT_Encode4(326329),
     /* 326293 */ /*GILLT_s32*//*Label 6659*/ GIMT_Encode4(326367),
     /* 326297 */ /*GILLT_s64*//*Label 6660*/ GIMT_Encode4(326405), GIMT_Encode4(0),
     /* 326305 */ /*GILLT_v2s32*//*Label 6661*/ GIMT_Encode4(326465),
     /* 326309 */ /*GILLT_v2s64*//*Label 6662*/ GIMT_Encode4(326568),
     /* 326313 */ /*GILLT_v4s16*//*Label 6663*/ GIMT_Encode4(326671),
     /* 326317 */ /*GILLT_v4s32*//*Label 6664*/ GIMT_Encode4(326774), GIMT_Encode4(0),
     /* 326325 */ /*GILLT_v8s16*//*Label 6665*/ GIMT_Encode4(326877),
     /* 326329 */ // Label 6658: @326329
     /* 326329 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(326366), // Rule ID 602 //
     /* 326334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 326343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326355 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 326360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326364 */   GIR_RootConstrainSelectedInstOperands,
     /* 326365 */   // GIR_Coverage, 602,
     /* 326365 */   GIR_Done,
     /* 326366 */ // Label 6667: @326366
     /* 326366 */ GIM_Reject,
     /* 326367 */ // Label 6659: @326367
     /* 326367 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(326404), // Rule ID 604 //
     /* 326372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326393 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 326393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 326398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326402 */   GIR_RootConstrainSelectedInstOperands,
     /* 326403 */   // GIR_Coverage, 604,
     /* 326403 */   GIR_Done,
     /* 326404 */ // Label 6668: @326404
     /* 326404 */ GIM_Reject,
     /* 326405 */ // Label 6660: @326405
     /* 326405 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(326464),
     /* 326410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326428 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(326447), // Rule ID 606 //
     /* 326433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 326436 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 326441 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326445 */     GIR_RootConstrainSelectedInstOperands,
     /* 326446 */     // GIR_Coverage, 606,
     /* 326446 */     GIR_Done,
     /* 326447 */   // Label 6670: @326447
     /* 326447 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(326463), // Rule ID 4811 //
     /* 326452 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 326452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 326457 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326461 */     GIR_RootConstrainSelectedInstOperands,
     /* 326462 */     // GIR_Coverage, 4811,
     /* 326462 */     GIR_Done,
     /* 326463 */   // Label 6671: @326463
     /* 326463 */   GIM_Reject,
     /* 326464 */ // Label 6669: @326464
     /* 326464 */ GIM_Reject,
     /* 326465 */ // Label 6661: @326465
     /* 326465 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(326567),
     /* 326470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326480 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(326539), // Rule ID 2351 //
     /* 326485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326524 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 326527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326537 */     GIR_RootConstrainSelectedInstOperands,
     /* 326538 */     // GIR_Coverage, 2351,
     /* 326538 */     GIR_EraseRootFromParent_Done,
     /* 326539 */   // Label 6673: @326539
     /* 326539 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(326566), // Rule ID 1258 //
     /* 326544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326555 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 326560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326564 */     GIR_RootConstrainSelectedInstOperands,
     /* 326565 */     // GIR_Coverage, 1258,
     /* 326565 */     GIR_Done,
     /* 326566 */   // Label 6674: @326566
     /* 326566 */   GIM_Reject,
     /* 326567 */ // Label 6672: @326567
     /* 326567 */ GIM_Reject,
     /* 326568 */ // Label 6662: @326568
     /* 326568 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(326670),
     /* 326573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326583 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(326642), // Rule ID 2357 //
     /* 326588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326627 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 326630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326640 */     GIR_RootConstrainSelectedInstOperands,
     /* 326641 */     // GIR_Coverage, 2357,
     /* 326641 */     GIR_EraseRootFromParent_Done,
     /* 326642 */   // Label 6676: @326642
     /* 326642 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(326669), // Rule ID 1262 //
     /* 326647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326658 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 326663 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326667 */     GIR_RootConstrainSelectedInstOperands,
     /* 326668 */     // GIR_Coverage, 1262,
     /* 326668 */     GIR_Done,
     /* 326669 */   // Label 6677: @326669
     /* 326669 */   GIM_Reject,
     /* 326670 */ // Label 6675: @326670
     /* 326670 */ GIM_Reject,
     /* 326671 */ // Label 6663: @326671
     /* 326671 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(326773),
     /* 326676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326686 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(326745), // Rule ID 2345 //
     /* 326691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326730 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 326733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326743 */     GIR_RootConstrainSelectedInstOperands,
     /* 326744 */     // GIR_Coverage, 2345,
     /* 326744 */     GIR_EraseRootFromParent_Done,
     /* 326745 */   // Label 6679: @326745
     /* 326745 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(326772), // Rule ID 1254 //
     /* 326750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326761 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 326766 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326770 */     GIR_RootConstrainSelectedInstOperands,
     /* 326771 */     // GIR_Coverage, 1254,
     /* 326771 */     GIR_Done,
     /* 326772 */   // Label 6680: @326772
     /* 326772 */   GIM_Reject,
     /* 326773 */ // Label 6678: @326773
     /* 326773 */ GIM_Reject,
     /* 326774 */ // Label 6664: @326774
     /* 326774 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(326876),
     /* 326779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326789 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(326848), // Rule ID 2354 //
     /* 326794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326833 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 326836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326846 */     GIR_RootConstrainSelectedInstOperands,
     /* 326847 */     // GIR_Coverage, 2354,
     /* 326847 */     GIR_EraseRootFromParent_Done,
     /* 326848 */   // Label 6682: @326848
     /* 326848 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(326875), // Rule ID 1260 //
     /* 326853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326864 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 326869 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326873 */     GIR_RootConstrainSelectedInstOperands,
     /* 326874 */     // GIR_Coverage, 1260,
     /* 326874 */     GIR_Done,
     /* 326875 */   // Label 6683: @326875
     /* 326875 */   GIM_Reject,
     /* 326876 */ // Label 6681: @326876
     /* 326876 */ GIM_Reject,
     /* 326877 */ // Label 6665: @326877
     /* 326877 */ GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(326979),
     /* 326882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326892 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(326951), // Rule ID 2348 //
     /* 326897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 326900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 326925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326936 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 326939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 326949 */     GIR_RootConstrainSelectedInstOperands,
     /* 326950 */     // GIR_Coverage, 2348,
     /* 326950 */     GIR_EraseRootFromParent_Done,
     /* 326951 */   // Label 6685: @326951
     /* 326951 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(326978), // Rule ID 1256 //
     /* 326956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326967 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 326972 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326976 */     GIR_RootConstrainSelectedInstOperands,
     /* 326977 */     // GIR_Coverage, 1256,
     /* 326977 */     GIR_Done,
     /* 326978 */   // Label 6686: @326978
     /* 326978 */   GIM_Reject,
     /* 326979 */ // Label 6684: @326979
     /* 326979 */ GIM_Reject,
     /* 326980 */ // Label 6666: @326980
     /* 326980 */ GIM_Reject,
     /* 326981 */ // Label 79: @326981
     /* 326981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6695*/ GIMT_Encode4(327384),
     /* 326992 */ /*GILLT_s32*//*Label 6687*/ GIMT_Encode4(327032),
     /* 326996 */ /*GILLT_s64*//*Label 6688*/ GIMT_Encode4(327106), GIMT_Encode4(0),
     /* 327004 */ /*GILLT_v2s32*//*Label 6689*/ GIMT_Encode4(327180), GIMT_Encode4(0),
     /* 327012 */ /*GILLT_v4s16*//*Label 6690*/ GIMT_Encode4(327214),
     /* 327016 */ /*GILLT_v4s32*//*Label 6691*/ GIMT_Encode4(327248),
     /* 327020 */ /*GILLT_v8s8*//*Label 6692*/ GIMT_Encode4(327282),
     /* 327024 */ /*GILLT_v8s16*//*Label 6693*/ GIMT_Encode4(327316),
     /* 327028 */ /*GILLT_v16s8*//*Label 6694*/ GIMT_Encode4(327350),
     /* 327032 */ // Label 6687: @327032
     /* 327032 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(327105),
     /* 327037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327051 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(327085), // Rule ID 2328 //
     /* 327056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 327071 */     // MIs[1] Operand 1
     /* 327071 */     // No operand predicates
     /* 327071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327073 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 327073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 327076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327083 */     GIR_RootConstrainSelectedInstOperands,
     /* 327084 */     // GIR_Coverage, 2328,
     /* 327084 */     GIR_EraseRootFromParent_Done,
     /* 327085 */   // Label 6697: @327085
     /* 327085 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(327104), // Rule ID 2327 //
     /* 327090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327097 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 327097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 327102 */     GIR_RootConstrainSelectedInstOperands,
     /* 327103 */     // GIR_Coverage, 2327,
     /* 327103 */     GIR_Done,
     /* 327104 */   // Label 6698: @327104
     /* 327104 */   GIM_Reject,
     /* 327105 */ // Label 6696: @327105
     /* 327105 */ GIM_Reject,
     /* 327106 */ // Label 6688: @327106
     /* 327106 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(327179),
     /* 327111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327125 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(327159), // Rule ID 2330 //
     /* 327130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 327145 */     // MIs[1] Operand 1
     /* 327145 */     // No operand predicates
     /* 327145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327147 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 327147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 327150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327157 */     GIR_RootConstrainSelectedInstOperands,
     /* 327158 */     // GIR_Coverage, 2330,
     /* 327158 */     GIR_EraseRootFromParent_Done,
     /* 327159 */   // Label 6700: @327159
     /* 327159 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(327178), // Rule ID 2329 //
     /* 327164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327171 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 327171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 327176 */     GIR_RootConstrainSelectedInstOperands,
     /* 327177 */     // GIR_Coverage, 2329,
     /* 327177 */     GIR_Done,
     /* 327178 */   // Label 6701: @327178
     /* 327178 */   GIM_Reject,
     /* 327179 */ // Label 6699: @327179
     /* 327179 */ GIM_Reject,
     /* 327180 */ // Label 6689: @327180
     /* 327180 */ GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(327213), // Rule ID 1414 //
     /* 327185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327206 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 327206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 327211 */   GIR_RootConstrainSelectedInstOperands,
     /* 327212 */   // GIR_Coverage, 1414,
     /* 327212 */   GIR_Done,
     /* 327213 */ // Label 6702: @327213
     /* 327213 */ GIM_Reject,
     /* 327214 */ // Label 6690: @327214
     /* 327214 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(327247), // Rule ID 1412 //
     /* 327219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327240 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 327240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 327245 */   GIR_RootConstrainSelectedInstOperands,
     /* 327246 */   // GIR_Coverage, 1412,
     /* 327246 */   GIR_Done,
     /* 327247 */ // Label 6703: @327247
     /* 327247 */ GIM_Reject,
     /* 327248 */ // Label 6691: @327248
     /* 327248 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(327281), // Rule ID 1415 //
     /* 327253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327274 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 327274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 327279 */   GIR_RootConstrainSelectedInstOperands,
     /* 327280 */   // GIR_Coverage, 1415,
     /* 327280 */   GIR_Done,
     /* 327281 */ // Label 6704: @327281
     /* 327281 */ GIM_Reject,
     /* 327282 */ // Label 6692: @327282
     /* 327282 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(327315), // Rule ID 1410 //
     /* 327287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 327296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327308 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 327308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 327313 */   GIR_RootConstrainSelectedInstOperands,
     /* 327314 */   // GIR_Coverage, 1410,
     /* 327314 */   GIR_Done,
     /* 327315 */ // Label 6705: @327315
     /* 327315 */ GIM_Reject,
     /* 327316 */ // Label 6693: @327316
     /* 327316 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(327349), // Rule ID 1413 //
     /* 327321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327342 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 327342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 327347 */   GIR_RootConstrainSelectedInstOperands,
     /* 327348 */   // GIR_Coverage, 1413,
     /* 327348 */   GIR_Done,
     /* 327349 */ // Label 6706: @327349
     /* 327349 */ GIM_Reject,
     /* 327350 */ // Label 6694: @327350
     /* 327350 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(327383), // Rule ID 1411 //
     /* 327355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 327364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327376 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 327376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 327381 */   GIR_RootConstrainSelectedInstOperands,
     /* 327382 */   // GIR_Coverage, 1411,
     /* 327382 */   GIR_Done,
     /* 327383 */ // Label 6707: @327383
     /* 327383 */ GIM_Reject,
     /* 327384 */ // Label 6695: @327384
     /* 327384 */ GIM_Reject,
     /* 327385 */ // Label 80: @327385
     /* 327385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6716*/ GIMT_Encode4(327788),
     /* 327396 */ /*GILLT_s32*//*Label 6708*/ GIMT_Encode4(327436),
     /* 327400 */ /*GILLT_s64*//*Label 6709*/ GIMT_Encode4(327510), GIMT_Encode4(0),
     /* 327408 */ /*GILLT_v2s32*//*Label 6710*/ GIMT_Encode4(327584), GIMT_Encode4(0),
     /* 327416 */ /*GILLT_v4s16*//*Label 6711*/ GIMT_Encode4(327618),
     /* 327420 */ /*GILLT_v4s32*//*Label 6712*/ GIMT_Encode4(327652),
     /* 327424 */ /*GILLT_v8s8*//*Label 6713*/ GIMT_Encode4(327686),
     /* 327428 */ /*GILLT_v8s16*//*Label 6714*/ GIMT_Encode4(327720),
     /* 327432 */ /*GILLT_v16s8*//*Label 6715*/ GIMT_Encode4(327754),
     /* 327436 */ // Label 6708: @327436
     /* 327436 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(327509),
     /* 327441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327455 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(327489), // Rule ID 2324 //
     /* 327460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 327475 */     // MIs[1] Operand 1
     /* 327475 */     // No operand predicates
     /* 327475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327477 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 327477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 327480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327487 */     GIR_RootConstrainSelectedInstOperands,
     /* 327488 */     // GIR_Coverage, 2324,
     /* 327488 */     GIR_EraseRootFromParent_Done,
     /* 327489 */   // Label 6718: @327489
     /* 327489 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(327508), // Rule ID 2323 //
     /* 327494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327501 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 327501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 327506 */     GIR_RootConstrainSelectedInstOperands,
     /* 327507 */     // GIR_Coverage, 2323,
     /* 327507 */     GIR_Done,
     /* 327508 */   // Label 6719: @327508
     /* 327508 */   GIM_Reject,
     /* 327509 */ // Label 6717: @327509
     /* 327509 */ GIM_Reject,
     /* 327510 */ // Label 6709: @327510
     /* 327510 */ GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(327583),
     /* 327515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327529 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(327563), // Rule ID 2326 //
     /* 327534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 327549 */     // MIs[1] Operand 1
     /* 327549 */     // No operand predicates
     /* 327549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327551 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 327551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 327554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327561 */     GIR_RootConstrainSelectedInstOperands,
     /* 327562 */     // GIR_Coverage, 2326,
     /* 327562 */     GIR_EraseRootFromParent_Done,
     /* 327563 */   // Label 6721: @327563
     /* 327563 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(327582), // Rule ID 2325 //
     /* 327568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327575 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 327575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 327580 */     GIR_RootConstrainSelectedInstOperands,
     /* 327581 */     // GIR_Coverage, 2325,
     /* 327581 */     GIR_Done,
     /* 327582 */   // Label 6722: @327582
     /* 327582 */   GIM_Reject,
     /* 327583 */ // Label 6720: @327583
     /* 327583 */ GIM_Reject,
     /* 327584 */ // Label 6710: @327584
     /* 327584 */ GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(327617), // Rule ID 1402 //
     /* 327589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327610 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 327610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 327615 */   GIR_RootConstrainSelectedInstOperands,
     /* 327616 */   // GIR_Coverage, 1402,
     /* 327616 */   GIR_Done,
     /* 327617 */ // Label 6723: @327617
     /* 327617 */ GIM_Reject,
     /* 327618 */ // Label 6711: @327618
     /* 327618 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(327651), // Rule ID 1400 //
     /* 327623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327644 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 327644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 327649 */   GIR_RootConstrainSelectedInstOperands,
     /* 327650 */   // GIR_Coverage, 1400,
     /* 327650 */   GIR_Done,
     /* 327651 */ // Label 6724: @327651
     /* 327651 */ GIM_Reject,
     /* 327652 */ // Label 6712: @327652
     /* 327652 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(327685), // Rule ID 1403 //
     /* 327657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327678 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 327678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 327683 */   GIR_RootConstrainSelectedInstOperands,
     /* 327684 */   // GIR_Coverage, 1403,
     /* 327684 */   GIR_Done,
     /* 327685 */ // Label 6725: @327685
     /* 327685 */ GIM_Reject,
     /* 327686 */ // Label 6713: @327686
     /* 327686 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(327719), // Rule ID 1398 //
     /* 327691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 327700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327712 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 327712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 327717 */   GIR_RootConstrainSelectedInstOperands,
     /* 327718 */   // GIR_Coverage, 1398,
     /* 327718 */   GIR_Done,
     /* 327719 */ // Label 6726: @327719
     /* 327719 */ GIM_Reject,
     /* 327720 */ // Label 6714: @327720
     /* 327720 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(327753), // Rule ID 1401 //
     /* 327725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327746 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 327746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 327751 */   GIR_RootConstrainSelectedInstOperands,
     /* 327752 */   // GIR_Coverage, 1401,
     /* 327752 */   GIR_Done,
     /* 327753 */ // Label 6727: @327753
     /* 327753 */ GIM_Reject,
     /* 327754 */ // Label 6715: @327754
     /* 327754 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(327787), // Rule ID 1399 //
     /* 327759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 327768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327780 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 327780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 327785 */   GIR_RootConstrainSelectedInstOperands,
     /* 327786 */   // GIR_Coverage, 1399,
     /* 327786 */   GIR_Done,
     /* 327787 */ // Label 6728: @327787
     /* 327787 */ GIM_Reject,
     /* 327788 */ // Label 6716: @327788
     /* 327788 */ GIM_Reject,
     /* 327789 */ // Label 81: @327789
     /* 327789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6737*/ GIMT_Encode4(328192),
     /* 327800 */ /*GILLT_s32*//*Label 6729*/ GIMT_Encode4(327840),
     /* 327804 */ /*GILLT_s64*//*Label 6730*/ GIMT_Encode4(327914), GIMT_Encode4(0),
     /* 327812 */ /*GILLT_v2s32*//*Label 6731*/ GIMT_Encode4(327988), GIMT_Encode4(0),
     /* 327820 */ /*GILLT_v4s16*//*Label 6732*/ GIMT_Encode4(328022),
     /* 327824 */ /*GILLT_v4s32*//*Label 6733*/ GIMT_Encode4(328056),
     /* 327828 */ /*GILLT_v8s8*//*Label 6734*/ GIMT_Encode4(328090),
     /* 327832 */ /*GILLT_v8s16*//*Label 6735*/ GIMT_Encode4(328124),
     /* 327836 */ /*GILLT_v16s8*//*Label 6736*/ GIMT_Encode4(328158),
     /* 327840 */ // Label 6729: @327840
     /* 327840 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(327913),
     /* 327845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327859 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(327893), // Rule ID 2336 //
     /* 327864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 327879 */     // MIs[1] Operand 1
     /* 327879 */     // No operand predicates
     /* 327879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327881 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 327881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 327884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327891 */     GIR_RootConstrainSelectedInstOperands,
     /* 327892 */     // GIR_Coverage, 2336,
     /* 327892 */     GIR_EraseRootFromParent_Done,
     /* 327893 */   // Label 6739: @327893
     /* 327893 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(327912), // Rule ID 2335 //
     /* 327898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327905 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 327905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 327910 */     GIR_RootConstrainSelectedInstOperands,
     /* 327911 */     // GIR_Coverage, 2335,
     /* 327911 */     GIR_Done,
     /* 327912 */   // Label 6740: @327912
     /* 327912 */   GIM_Reject,
     /* 327913 */ // Label 6738: @327913
     /* 327913 */ GIM_Reject,
     /* 327914 */ // Label 6730: @327914
     /* 327914 */ GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(327987),
     /* 327919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327933 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(327967), // Rule ID 2338 //
     /* 327938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 327953 */     // MIs[1] Operand 1
     /* 327953 */     // No operand predicates
     /* 327953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327955 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 327955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 327958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327965 */     GIR_RootConstrainSelectedInstOperands,
     /* 327966 */     // GIR_Coverage, 2338,
     /* 327966 */     GIR_EraseRootFromParent_Done,
     /* 327967 */   // Label 6742: @327967
     /* 327967 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(327986), // Rule ID 2337 //
     /* 327972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327979 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 327979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 327984 */     GIR_RootConstrainSelectedInstOperands,
     /* 327985 */     // GIR_Coverage, 2337,
     /* 327985 */     GIR_Done,
     /* 327986 */   // Label 6743: @327986
     /* 327986 */   GIM_Reject,
     /* 327987 */ // Label 6741: @327987
     /* 327987 */ GIM_Reject,
     /* 327988 */ // Label 6731: @327988
     /* 327988 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328021), // Rule ID 1537 //
     /* 327993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 328002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328014 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 328014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 328019 */   GIR_RootConstrainSelectedInstOperands,
     /* 328020 */   // GIR_Coverage, 1537,
     /* 328020 */   GIR_Done,
     /* 328021 */ // Label 6744: @328021
     /* 328021 */ GIM_Reject,
     /* 328022 */ // Label 6732: @328022
     /* 328022 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(328055), // Rule ID 1535 //
     /* 328027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328048 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 328048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 328053 */   GIR_RootConstrainSelectedInstOperands,
     /* 328054 */   // GIR_Coverage, 1535,
     /* 328054 */   GIR_Done,
     /* 328055 */ // Label 6745: @328055
     /* 328055 */ GIM_Reject,
     /* 328056 */ // Label 6733: @328056
     /* 328056 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(328089), // Rule ID 1538 //
     /* 328061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328082 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 328082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 328087 */   GIR_RootConstrainSelectedInstOperands,
     /* 328088 */   // GIR_Coverage, 1538,
     /* 328088 */   GIR_Done,
     /* 328089 */ // Label 6746: @328089
     /* 328089 */ GIM_Reject,
     /* 328090 */ // Label 6734: @328090
     /* 328090 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(328123), // Rule ID 1533 //
     /* 328095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 328104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328116 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 328116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 328121 */   GIR_RootConstrainSelectedInstOperands,
     /* 328122 */   // GIR_Coverage, 1533,
     /* 328122 */   GIR_Done,
     /* 328123 */ // Label 6747: @328123
     /* 328123 */ GIM_Reject,
     /* 328124 */ // Label 6735: @328124
     /* 328124 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(328157), // Rule ID 1536 //
     /* 328129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328146 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328150 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 328150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 328155 */   GIR_RootConstrainSelectedInstOperands,
     /* 328156 */   // GIR_Coverage, 1536,
     /* 328156 */   GIR_Done,
     /* 328157 */ // Label 6748: @328157
     /* 328157 */ GIM_Reject,
     /* 328158 */ // Label 6736: @328158
     /* 328158 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(328191), // Rule ID 1534 //
     /* 328163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 328169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 328172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328184 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 328184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 328189 */   GIR_RootConstrainSelectedInstOperands,
     /* 328190 */   // GIR_Coverage, 1534,
     /* 328190 */   GIR_Done,
     /* 328191 */ // Label 6749: @328191
     /* 328191 */ GIM_Reject,
     /* 328192 */ // Label 6737: @328192
     /* 328192 */ GIM_Reject,
     /* 328193 */ // Label 82: @328193
     /* 328193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6758*/ GIMT_Encode4(328596),
     /* 328204 */ /*GILLT_s32*//*Label 6750*/ GIMT_Encode4(328244),
     /* 328208 */ /*GILLT_s64*//*Label 6751*/ GIMT_Encode4(328318), GIMT_Encode4(0),
     /* 328216 */ /*GILLT_v2s32*//*Label 6752*/ GIMT_Encode4(328392), GIMT_Encode4(0),
     /* 328224 */ /*GILLT_v4s16*//*Label 6753*/ GIMT_Encode4(328426),
     /* 328228 */ /*GILLT_v4s32*//*Label 6754*/ GIMT_Encode4(328460),
     /* 328232 */ /*GILLT_v8s8*//*Label 6755*/ GIMT_Encode4(328494),
     /* 328236 */ /*GILLT_v8s16*//*Label 6756*/ GIMT_Encode4(328528),
     /* 328240 */ /*GILLT_v16s8*//*Label 6757*/ GIMT_Encode4(328562),
     /* 328244 */ // Label 6750: @328244
     /* 328244 */ GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(328317),
     /* 328249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 328255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328263 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(328297), // Rule ID 2332 //
     /* 328268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 328283 */     // MIs[1] Operand 1
     /* 328283 */     // No operand predicates
     /* 328283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328285 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 328285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 328288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328295 */     GIR_RootConstrainSelectedInstOperands,
     /* 328296 */     // GIR_Coverage, 2332,
     /* 328296 */     GIR_EraseRootFromParent_Done,
     /* 328297 */   // Label 6760: @328297
     /* 328297 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(328316), // Rule ID 2331 //
     /* 328302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328309 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 328309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 328314 */     GIR_RootConstrainSelectedInstOperands,
     /* 328315 */     // GIR_Coverage, 2331,
     /* 328315 */     GIR_Done,
     /* 328316 */   // Label 6761: @328316
     /* 328316 */   GIM_Reject,
     /* 328317 */ // Label 6759: @328317
     /* 328317 */ GIM_Reject,
     /* 328318 */ // Label 6751: @328318
     /* 328318 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(328391),
     /* 328323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 328329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328337 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(328371), // Rule ID 2334 //
     /* 328342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 328357 */     // MIs[1] Operand 1
     /* 328357 */     // No operand predicates
     /* 328357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328359 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 328359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 328362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 328366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 328369 */     GIR_RootConstrainSelectedInstOperands,
     /* 328370 */     // GIR_Coverage, 2334,
     /* 328370 */     GIR_EraseRootFromParent_Done,
     /* 328371 */   // Label 6763: @328371
     /* 328371 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(328390), // Rule ID 2333 //
     /* 328376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328383 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 328383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 328388 */     GIR_RootConstrainSelectedInstOperands,
     /* 328389 */     // GIR_Coverage, 2333,
     /* 328389 */     GIR_Done,
     /* 328390 */   // Label 6764: @328390
     /* 328390 */   GIM_Reject,
     /* 328391 */ // Label 6762: @328391
     /* 328391 */ GIM_Reject,
     /* 328392 */ // Label 6752: @328392
     /* 328392 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(328425), // Rule ID 1525 //
     /* 328397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 328406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328418 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 328418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 328423 */   GIR_RootConstrainSelectedInstOperands,
     /* 328424 */   // GIR_Coverage, 1525,
     /* 328424 */   GIR_Done,
     /* 328425 */ // Label 6765: @328425
     /* 328425 */ GIM_Reject,
     /* 328426 */ // Label 6753: @328426
     /* 328426 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(328459), // Rule ID 1523 //
     /* 328431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 328440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328452 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 328452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 328457 */   GIR_RootConstrainSelectedInstOperands,
     /* 328458 */   // GIR_Coverage, 1523,
     /* 328458 */   GIR_Done,
     /* 328459 */ // Label 6766: @328459
     /* 328459 */ GIM_Reject,
     /* 328460 */ // Label 6754: @328460
     /* 328460 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(328493), // Rule ID 1526 //
     /* 328465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328486 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 328486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 328491 */   GIR_RootConstrainSelectedInstOperands,
     /* 328492 */   // GIR_Coverage, 1526,
     /* 328492 */   GIR_Done,
     /* 328493 */ // Label 6767: @328493
     /* 328493 */ GIM_Reject,
     /* 328494 */ // Label 6755: @328494
     /* 328494 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(328527), // Rule ID 1521 //
     /* 328499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 328508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328520 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 328520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 328525 */   GIR_RootConstrainSelectedInstOperands,
     /* 328526 */   // GIR_Coverage, 1521,
     /* 328526 */   GIR_Done,
     /* 328527 */ // Label 6768: @328527
     /* 328527 */ GIM_Reject,
     /* 328528 */ // Label 6756: @328528
     /* 328528 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(328561), // Rule ID 1524 //
     /* 328533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328554 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 328554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 328559 */   GIR_RootConstrainSelectedInstOperands,
     /* 328560 */   // GIR_Coverage, 1524,
     /* 328560 */   GIR_Done,
     /* 328561 */ // Label 6769: @328561
     /* 328561 */ GIM_Reject,
     /* 328562 */ // Label 6757: @328562
     /* 328562 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(328595), // Rule ID 1522 //
     /* 328567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 328573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 328576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328588 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 328588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 328593 */   GIR_RootConstrainSelectedInstOperands,
     /* 328594 */   // GIR_Coverage, 1522,
     /* 328594 */   GIR_Done,
     /* 328595 */ // Label 6770: @328595
     /* 328595 */ GIM_Reject,
     /* 328596 */ // Label 6758: @328596
     /* 328596 */ GIM_Reject,
     /* 328597 */ // Label 83: @328597
     /* 328597 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6780*/ GIMT_Encode4(329411),
     /* 328608 */ /*GILLT_s32*//*Label 6771*/ GIMT_Encode4(328648),
     /* 328612 */ /*GILLT_s64*//*Label 6772*/ GIMT_Encode4(328675), GIMT_Encode4(0),
     /* 328620 */ /*GILLT_v2s32*//*Label 6773*/ GIMT_Encode4(328754),
     /* 328624 */ /*GILLT_v2s64*//*Label 6774*/ GIMT_Encode4(328781),
     /* 328628 */ /*GILLT_v4s16*//*Label 6775*/ GIMT_Encode4(328964),
     /* 328632 */ /*GILLT_v4s32*//*Label 6776*/ GIMT_Encode4(328991),
     /* 328636 */ /*GILLT_v8s8*//*Label 6777*/ GIMT_Encode4(329174),
     /* 328640 */ /*GILLT_v8s16*//*Label 6778*/ GIMT_Encode4(329201),
     /* 328644 */ /*GILLT_v16s8*//*Label 6779*/ GIMT_Encode4(329384),
     /* 328648 */ // Label 6771: @328648
     /* 328648 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(328674), // Rule ID 2317 //
     /* 328653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328667 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 328667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 328672 */   GIR_RootConstrainSelectedInstOperands,
     /* 328673 */   // GIR_Coverage, 2317,
     /* 328673 */   GIR_Done,
     /* 328674 */ // Label 6781: @328674
     /* 328674 */ GIM_Reject,
     /* 328675 */ // Label 6772: @328675
     /* 328675 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(328753),
     /* 328680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328683 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(328706), // Rule ID 1652 //
     /* 328688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328699 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 328699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 328704 */     GIR_RootConstrainSelectedInstOperands,
     /* 328705 */     // GIR_Coverage, 1652,
     /* 328705 */     GIR_Done,
     /* 328706 */   // Label 6783: @328706
     /* 328706 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(328729), // Rule ID 2318 //
     /* 328711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 328714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328722 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 328722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 328727 */     GIR_RootConstrainSelectedInstOperands,
     /* 328728 */     // GIR_Coverage, 2318,
     /* 328728 */     GIR_Done,
     /* 328729 */   // Label 6784: @328729
     /* 328729 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(328752), // Rule ID 2514 //
     /* 328734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 328737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328745 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 328745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 328750 */     GIR_RootConstrainSelectedInstOperands,
     /* 328751 */     // GIR_Coverage, 2514,
     /* 328751 */     GIR_Done,
     /* 328752 */   // Label 6785: @328752
     /* 328752 */   GIM_Reject,
     /* 328753 */ // Label 6782: @328753
     /* 328753 */ GIM_Reject,
     /* 328754 */ // Label 6773: @328754
     /* 328754 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(328780), // Rule ID 707 //
     /* 328759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328773 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 328773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 328778 */   GIR_RootConstrainSelectedInstOperands,
     /* 328779 */   // GIR_Coverage, 707,
     /* 328779 */   GIR_Done,
     /* 328780 */ // Label 6786: @328780
     /* 328780 */ GIM_Reject,
     /* 328781 */ // Label 6774: @328781
     /* 328781 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(328963),
     /* 328786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328793 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(328871), // Rule ID 4889 //
     /* 328798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 328806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 328814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328834 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 328847 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 328854 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 328854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 328857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 328864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 328869 */     GIR_RootConstrainSelectedInstOperands,
     /* 328870 */     // GIR_Coverage, 4889,
     /* 328870 */     GIR_EraseRootFromParent_Done,
     /* 328871 */   // Label 6788: @328871
     /* 328871 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(328943), // Rule ID 4888 //
     /* 328876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 328884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 328892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328917 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328928 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 328928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 328931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 328937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 328941 */     GIR_RootConstrainSelectedInstOperands,
     /* 328942 */     // GIR_Coverage, 4888,
     /* 328942 */     GIR_EraseRootFromParent_Done,
     /* 328943 */   // Label 6789: @328943
     /* 328943 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(328962), // Rule ID 709 //
     /* 328948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328955 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 328955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 328960 */     GIR_RootConstrainSelectedInstOperands,
     /* 328961 */     // GIR_Coverage, 709,
     /* 328961 */     GIR_Done,
     /* 328962 */   // Label 6790: @328962
     /* 328962 */   GIM_Reject,
     /* 328963 */ // Label 6787: @328963
     /* 328963 */ GIM_Reject,
     /* 328964 */ // Label 6775: @328964
     /* 328964 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(328990), // Rule ID 705 //
     /* 328969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328983 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 328983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 328988 */   GIR_RootConstrainSelectedInstOperands,
     /* 328989 */   // GIR_Coverage, 705,
     /* 328989 */   GIR_Done,
     /* 328990 */ // Label 6791: @328990
     /* 328990 */ GIM_Reject,
     /* 328991 */ // Label 6776: @328991
     /* 328991 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(329173),
     /* 328996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329003 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(329081), // Rule ID 4887 //
     /* 329008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 329016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 329057 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 329064 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 329064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 329067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 329074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 329079 */     GIR_RootConstrainSelectedInstOperands,
     /* 329080 */     // GIR_Coverage, 4887,
     /* 329080 */     GIR_EraseRootFromParent_Done,
     /* 329081 */   // Label 6793: @329081
     /* 329081 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(329153), // Rule ID 4886 //
     /* 329086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 329094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 329102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329138 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 329138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 329141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 329147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 329151 */     GIR_RootConstrainSelectedInstOperands,
     /* 329152 */     // GIR_Coverage, 4886,
     /* 329152 */     GIR_EraseRootFromParent_Done,
     /* 329153 */   // Label 6794: @329153
     /* 329153 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(329172), // Rule ID 708 //
     /* 329158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329165 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 329165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 329170 */     GIR_RootConstrainSelectedInstOperands,
     /* 329171 */     // GIR_Coverage, 708,
     /* 329171 */     GIR_Done,
     /* 329172 */   // Label 6795: @329172
     /* 329172 */   GIM_Reject,
     /* 329173 */ // Label 6792: @329173
     /* 329173 */ GIM_Reject,
     /* 329174 */ // Label 6777: @329174
     /* 329174 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(329200), // Rule ID 703 //
     /* 329179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329193 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 329193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 329198 */   GIR_RootConstrainSelectedInstOperands,
     /* 329199 */   // GIR_Coverage, 703,
     /* 329199 */   GIR_Done,
     /* 329200 */ // Label 6796: @329200
     /* 329200 */ GIM_Reject,
     /* 329201 */ // Label 6778: @329201
     /* 329201 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(329383),
     /* 329206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329213 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(329291), // Rule ID 4885 //
     /* 329218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 329226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 329267 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 329274 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 329274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 329277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 329284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 329289 */     GIR_RootConstrainSelectedInstOperands,
     /* 329290 */     // GIR_Coverage, 4885,
     /* 329290 */     GIR_EraseRootFromParent_Done,
     /* 329291 */   // Label 6798: @329291
     /* 329291 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(329363), // Rule ID 4884 //
     /* 329296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 329304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 329312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 329333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 329337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329348 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 329348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 329351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 329357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 329361 */     GIR_RootConstrainSelectedInstOperands,
     /* 329362 */     // GIR_Coverage, 4884,
     /* 329362 */     GIR_EraseRootFromParent_Done,
     /* 329363 */   // Label 6799: @329363
     /* 329363 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(329382), // Rule ID 706 //
     /* 329368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329375 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 329375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 329380 */     GIR_RootConstrainSelectedInstOperands,
     /* 329381 */     // GIR_Coverage, 706,
     /* 329381 */     GIR_Done,
     /* 329382 */   // Label 6800: @329382
     /* 329382 */   GIM_Reject,
     /* 329383 */ // Label 6797: @329383
     /* 329383 */ GIM_Reject,
     /* 329384 */ // Label 6779: @329384
     /* 329384 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(329410), // Rule ID 704 //
     /* 329389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329403 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 329403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 329408 */   GIR_RootConstrainSelectedInstOperands,
     /* 329409 */   // GIR_Coverage, 704,
     /* 329409 */   GIR_Done,
     /* 329410 */ // Label 6801: @329410
     /* 329410 */ GIM_Reject,
     /* 329411 */ // Label 6780: @329411
     /* 329411 */ GIM_Reject,
     /* 329412 */ // Label 84: @329412
     /* 329412 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6804*/ GIMT_Encode4(329577),
     /* 329423 */ /*GILLT_s32*//*Label 6802*/ GIMT_Encode4(329431),
     /* 329427 */ /*GILLT_s64*//*Label 6803*/ GIMT_Encode4(329504),
     /* 329431 */ // Label 6802: @329431
     /* 329431 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(329457), // Rule ID 4730 //
     /* 329436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329446 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 329446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 329451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329455 */   GIR_RootConstrainSelectedInstOperands,
     /* 329456 */   // GIR_Coverage, 4730,
     /* 329456 */   GIR_Done,
     /* 329457 */ // Label 6805: @329457
     /* 329457 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(329480), // Rule ID 4736 //
     /* 329462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329469 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 329474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329478 */   GIR_RootConstrainSelectedInstOperands,
     /* 329479 */   // GIR_Coverage, 4736,
     /* 329479 */   GIR_Done,
     /* 329480 */ // Label 6806: @329480
     /* 329480 */ GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(329503), // Rule ID 4738 //
     /* 329485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329492 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 329497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329501 */   GIR_RootConstrainSelectedInstOperands,
     /* 329502 */   // GIR_Coverage, 4738,
     /* 329502 */   GIR_Done,
     /* 329503 */ // Label 6807: @329503
     /* 329503 */ GIM_Reject,
     /* 329504 */ // Label 6803: @329504
     /* 329504 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(329530), // Rule ID 4732 //
     /* 329509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329519 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 329519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 329524 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329528 */   GIR_RootConstrainSelectedInstOperands,
     /* 329529 */   // GIR_Coverage, 4732,
     /* 329529 */   GIR_Done,
     /* 329530 */ // Label 6808: @329530
     /* 329530 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(329553), // Rule ID 4740 //
     /* 329535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329542 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 329547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329551 */   GIR_RootConstrainSelectedInstOperands,
     /* 329552 */   // GIR_Coverage, 4740,
     /* 329552 */   GIR_Done,
     /* 329553 */ // Label 6809: @329553
     /* 329553 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(329576), // Rule ID 4742 //
     /* 329558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329565 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 329570 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329574 */   GIR_RootConstrainSelectedInstOperands,
     /* 329575 */   // GIR_Coverage, 4742,
     /* 329575 */   GIR_Done,
     /* 329576 */ // Label 6810: @329576
     /* 329576 */ GIM_Reject,
     /* 329577 */ // Label 6804: @329577
     /* 329577 */ GIM_Reject,
     /* 329578 */ // Label 85: @329578
     /* 329578 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(329676),
     /* 329583 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 329586 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6815*/ GIMT_Encode4(329675),
     /* 329597 */   /*GILLT_s16*//*Label 6812*/ GIMT_Encode4(329609),
     /* 329601 */   /*GILLT_s32*//*Label 6813*/ GIMT_Encode4(329633),
     /* 329605 */   /*GILLT_s64*//*Label 6814*/ GIMT_Encode4(329654),
     /* 329609 */   // Label 6812: @329609
     /* 329609 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(329632), // Rule ID 4734 //
     /* 329614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 329617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329621 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 329621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 329626 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329630 */     GIR_RootConstrainSelectedInstOperands,
     /* 329631 */     // GIR_Coverage, 4734,
     /* 329631 */     GIR_Done,
     /* 329632 */   // Label 6816: @329632
     /* 329632 */   GIM_Reject,
     /* 329633 */   // Label 6813: @329633
     /* 329633 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(329653), // Rule ID 4744 //
     /* 329638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329642 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 329642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 329647 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329651 */     GIR_RootConstrainSelectedInstOperands,
     /* 329652 */     // GIR_Coverage, 4744,
     /* 329652 */     GIR_Done,
     /* 329653 */   // Label 6817: @329653
     /* 329653 */   GIM_Reject,
     /* 329654 */   // Label 6814: @329654
     /* 329654 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(329674), // Rule ID 4746 //
     /* 329659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329663 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 329663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 329668 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329672 */     GIR_RootConstrainSelectedInstOperands,
     /* 329673 */     // GIR_Coverage, 4746,
     /* 329673 */     GIR_Done,
     /* 329674 */   // Label 6818: @329674
     /* 329674 */   GIM_Reject,
     /* 329675 */   // Label 6815: @329675
     /* 329675 */   GIM_Reject,
     /* 329676 */ // Label 6811: @329676
     /* 329676 */ GIM_Reject,
     /* 329677 */ // Label 86: @329677
     /* 329677 */ GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(329692), // Rule ID 225 //
     /* 329682 */   // MIs[0] addr
     /* 329682 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 329685 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 329685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 329690 */   GIR_RootConstrainSelectedInstOperands,
     /* 329691 */   // GIR_Coverage, 225,
     /* 329691 */   GIR_Done,
     /* 329692 */ // Label 6819: @329692
     /* 329692 */ GIM_Reject,
     /* 329693 */ // Label 87: @329693
     /* 329693 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6831*/ GIMT_Encode4(335064),
     /* 329704 */ /*GILLT_s64*//*Label 6820*/ GIMT_Encode4(329776), GIMT_Encode4(0),
     /* 329712 */ /*GILLT_v2s32*//*Label 6821*/ GIMT_Encode4(330178), GIMT_Encode4(0),
     /* 329720 */ /*GILLT_v4s16*//*Label 6822*/ GIMT_Encode4(330580), GIMT_Encode4(0),
     /* 329728 */ /*GILLT_v8s8*//*Label 6823*/ GIMT_Encode4(330982), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329740 */ /*GILLT_nxv1s1*//*Label 6824*/ GIMT_Encode4(331162),
     /* 329744 */ /*GILLT_nxv2s1*//*Label 6825*/ GIMT_Encode4(333425),
     /* 329748 */ /*GILLT_nxv2s16*//*Label 6826*/ GIMT_Encode4(334280),
     /* 329752 */ /*GILLT_nxv2s32*//*Label 6827*/ GIMT_Encode4(334567), GIMT_Encode4(0),
     /* 329760 */ /*GILLT_nxv4s1*//*Label 6828*/ GIMT_Encode4(334637),
     /* 329764 */ /*GILLT_nxv4s16*//*Label 6829*/ GIMT_Encode4(334924), GIMT_Encode4(0),
     /* 329772 */ /*GILLT_nxv8s1*//*Label 6830*/ GIMT_Encode4(334994),
     /* 329776 */ // Label 6820: @329776
     /* 329776 */ GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(330177),
     /* 329781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329788 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(329840), // Rule ID 5580 //
     /* 329793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329805 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329812 */     // MIs[0] Operand 2
     /* 329812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329825 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 329825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 329828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329838 */     GIR_RootConstrainSelectedInstOperands,
     /* 329839 */     // GIR_Coverage, 5580,
     /* 329839 */     GIR_EraseRootFromParent_Done,
     /* 329840 */   // Label 6833: @329840
     /* 329840 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(329892), // Rule ID 5583 //
     /* 329845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329857 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329864 */     // MIs[0] Operand 2
     /* 329864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329877 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 329877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 329880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329890 */     GIR_RootConstrainSelectedInstOperands,
     /* 329891 */     // GIR_Coverage, 5583,
     /* 329891 */     GIR_EraseRootFromParent_Done,
     /* 329892 */   // Label 6834: @329892
     /* 329892 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(329960), // Rule ID 5459 //
     /* 329897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329901 */     // MIs[0] Operand 2
     /* 329901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329912 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329942 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329959 */     // GIR_Coverage, 5459,
     /* 329959 */     GIR_EraseRootFromParent_Done,
     /* 329960 */   // Label 6835: @329960
     /* 329960 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(330028), // Rule ID 5464 //
     /* 329965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329969 */     // MIs[0] Operand 2
     /* 329969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329980 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330000 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330010 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330027 */     // GIR_Coverage, 5464,
     /* 330027 */     GIR_EraseRootFromParent_Done,
     /* 330028 */   // Label 6836: @330028
     /* 330028 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(330070), // Rule ID 6885 //
     /* 330033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330037 */     // MIs[0] Operand 2
     /* 330037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330048 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 330048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330053 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330069 */     // GIR_Coverage, 6885,
     /* 330069 */     GIR_EraseRootFromParent_Done,
     /* 330070 */   // Label 6837: @330070
     /* 330070 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(330112), // Rule ID 6886 //
     /* 330075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330079 */     // MIs[0] Operand 2
     /* 330079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330090 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 330090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330095 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330111 */     // GIR_Coverage, 6886,
     /* 330111 */     GIR_EraseRootFromParent_Done,
     /* 330112 */   // Label 6838: @330112
     /* 330112 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(330176), // Rule ID 6890 //
     /* 330117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330121 */     // MIs[0] Operand 2
     /* 330121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330132 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 330132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 330139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 330151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330158 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330175 */     // GIR_Coverage, 6890,
     /* 330175 */     GIR_EraseRootFromParent_Done,
     /* 330176 */   // Label 6839: @330176
     /* 330176 */   GIM_Reject,
     /* 330177 */ // Label 6832: @330177
     /* 330177 */ GIM_Reject,
     /* 330178 */ // Label 6821: @330178
     /* 330178 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(330579),
     /* 330183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330190 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(330242), // Rule ID 5579 //
     /* 330195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 330203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330207 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 330209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330214 */     // MIs[0] Operand 2
     /* 330214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330227 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 330227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 330230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330240 */     GIR_RootConstrainSelectedInstOperands,
     /* 330241 */     // GIR_Coverage, 5579,
     /* 330241 */     GIR_EraseRootFromParent_Done,
     /* 330242 */   // Label 6841: @330242
     /* 330242 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(330294), // Rule ID 5582 //
     /* 330247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 330255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330259 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 330261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330266 */     // MIs[0] Operand 2
     /* 330266 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330279 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 330279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 330282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330292 */     GIR_RootConstrainSelectedInstOperands,
     /* 330293 */     // GIR_Coverage, 5582,
     /* 330293 */     GIR_EraseRootFromParent_Done,
     /* 330294 */   // Label 6842: @330294
     /* 330294 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(330362), // Rule ID 5449 //
     /* 330299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330303 */     // MIs[0] Operand 2
     /* 330303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330314 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 330314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 330321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330344 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330361 */     // GIR_Coverage, 5449,
     /* 330361 */     GIR_EraseRootFromParent_Done,
     /* 330362 */   // Label 6843: @330362
     /* 330362 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(330430), // Rule ID 5454 //
     /* 330367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330371 */     // MIs[0] Operand 2
     /* 330371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330382 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 330382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 330389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330429 */     // GIR_Coverage, 5454,
     /* 330429 */     GIR_EraseRootFromParent_Done,
     /* 330430 */   // Label 6844: @330430
     /* 330430 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(330472), // Rule ID 6882 //
     /* 330435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330439 */     // MIs[0] Operand 2
     /* 330439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330450 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 330450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330455 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330471 */     // GIR_Coverage, 6882,
     /* 330471 */     GIR_EraseRootFromParent_Done,
     /* 330472 */   // Label 6845: @330472
     /* 330472 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(330514), // Rule ID 6884 //
     /* 330477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330481 */     // MIs[0] Operand 2
     /* 330481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330492 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 330492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330497 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330513 */     // GIR_Coverage, 6884,
     /* 330513 */     GIR_EraseRootFromParent_Done,
     /* 330514 */   // Label 6846: @330514
     /* 330514 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(330578), // Rule ID 6889 //
     /* 330519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330523 */     // MIs[0] Operand 2
     /* 330523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330534 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 330534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 330541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 330553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330577 */     // GIR_Coverage, 6889,
     /* 330577 */     GIR_EraseRootFromParent_Done,
     /* 330578 */   // Label 6847: @330578
     /* 330578 */   GIM_Reject,
     /* 330579 */ // Label 6840: @330579
     /* 330579 */ GIM_Reject,
     /* 330580 */ // Label 6822: @330580
     /* 330580 */ GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(330981),
     /* 330585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330592 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(330644), // Rule ID 5578 //
     /* 330597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 330605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330609 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 330611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330616 */     // MIs[0] Operand 2
     /* 330616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330629 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 330629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 330632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330642 */     GIR_RootConstrainSelectedInstOperands,
     /* 330643 */     // GIR_Coverage, 5578,
     /* 330643 */     GIR_EraseRootFromParent_Done,
     /* 330644 */   // Label 6849: @330644
     /* 330644 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(330696), // Rule ID 5581 //
     /* 330649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 330657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 330661 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 330663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330668 */     // MIs[0] Operand 2
     /* 330668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330681 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 330681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 330684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 330694 */     GIR_RootConstrainSelectedInstOperands,
     /* 330695 */     // GIR_Coverage, 5581,
     /* 330695 */     GIR_EraseRootFromParent_Done,
     /* 330696 */   // Label 6850: @330696
     /* 330696 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(330764), // Rule ID 5439 //
     /* 330701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330705 */     // MIs[0] Operand 2
     /* 330705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330716 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 330716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 330723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330736 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330746 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330763 */     // GIR_Coverage, 5439,
     /* 330763 */     GIR_EraseRootFromParent_Done,
     /* 330764 */   // Label 6851: @330764
     /* 330764 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(330832), // Rule ID 5444 //
     /* 330769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330773 */     // MIs[0] Operand 2
     /* 330773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330784 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 330784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 330791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330814 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330831 */     // GIR_Coverage, 5444,
     /* 330831 */     GIR_EraseRootFromParent_Done,
     /* 330832 */   // Label 6852: @330832
     /* 330832 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(330874), // Rule ID 6880 //
     /* 330837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330841 */     // MIs[0] Operand 2
     /* 330841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330852 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 330852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330857 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330873 */     // GIR_Coverage, 6880,
     /* 330873 */     GIR_EraseRootFromParent_Done,
     /* 330874 */   // Label 6853: @330874
     /* 330874 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(330916), // Rule ID 6883 //
     /* 330879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330883 */     // MIs[0] Operand 2
     /* 330883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330894 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 330894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330899 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330915 */     // GIR_Coverage, 6883,
     /* 330915 */     GIR_EraseRootFromParent_Done,
     /* 330916 */   // Label 6854: @330916
     /* 330916 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(330980), // Rule ID 6888 //
     /* 330921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330925 */     // MIs[0] Operand 2
     /* 330925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330936 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 330936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 330943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 330955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330962 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330979 */     // GIR_Coverage, 6888,
     /* 330979 */     GIR_EraseRootFromParent_Done,
     /* 330980 */   // Label 6855: @330980
     /* 330980 */   GIM_Reject,
     /* 330981 */ // Label 6848: @330981
     /* 330981 */ GIM_Reject,
     /* 330982 */ // Label 6823: @330982
     /* 330982 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(331161),
     /* 330987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 330990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330998 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(331062), // Rule ID 5434 //
     /* 331003 */     // MIs[0] Operand 2
     /* 331003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 331014 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 331014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 331021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 331037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331044 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331061 */     // GIR_Coverage, 5434,
     /* 331061 */     GIR_EraseRootFromParent_Done,
     /* 331062 */   // Label 6857: @331062
     /* 331062 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(331100), // Rule ID 6881 //
     /* 331067 */     // MIs[0] Operand 2
     /* 331067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331078 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 331078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331083 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331099 */     // GIR_Coverage, 6881,
     /* 331099 */     GIR_EraseRootFromParent_Done,
     /* 331100 */   // Label 6858: @331100
     /* 331100 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(331160), // Rule ID 6887 //
     /* 331105 */     // MIs[0] Operand 2
     /* 331105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331116 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 331116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 331123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 331132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 331135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331142 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331159 */     // GIR_Coverage, 6887,
     /* 331159 */     GIR_EraseRootFromParent_Done,
     /* 331160 */   // Label 6859: @331160
     /* 331160 */   GIM_Reject,
     /* 331161 */ // Label 6856: @331161
     /* 331161 */ GIM_Reject,
     /* 331162 */ // Label 6824: @331162
     /* 331162 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(331197), // Rule ID 8949 //
     /* 331167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 331173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331177 */   // MIs[0] Operand 2
     /* 331177 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331188 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 331188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331193 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331195 */   GIR_RootConstrainSelectedInstOperands,
     /* 331196 */   // GIR_Coverage, 8949,
     /* 331196 */   GIR_EraseRootFromParent_Done,
     /* 331197 */ // Label 6860: @331197
     /* 331197 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(331232), // Rule ID 8950 //
     /* 331202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 331208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331212 */   // MIs[0] Operand 2
     /* 331212 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331223 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 331223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331230 */   GIR_RootConstrainSelectedInstOperands,
     /* 331231 */   // GIR_Coverage, 8950,
     /* 331231 */   GIR_EraseRootFromParent_Done,
     /* 331232 */ // Label 6861: @331232
     /* 331232 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(331286), // Rule ID 8957 //
     /* 331237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331247 */   // MIs[0] Operand 2
     /* 331247 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331258 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 331258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331284 */   GIR_RootConstrainSelectedInstOperands,
     /* 331285 */   // GIR_Coverage, 8957,
     /* 331285 */   GIR_EraseRootFromParent_Done,
     /* 331286 */ // Label 6862: @331286
     /* 331286 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(331340), // Rule ID 8958 //
     /* 331291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331301 */   // MIs[0] Operand 2
     /* 331301 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331312 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 331312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331324 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331338 */   GIR_RootConstrainSelectedInstOperands,
     /* 331339 */   // GIR_Coverage, 8958,
     /* 331339 */   GIR_EraseRootFromParent_Done,
     /* 331340 */ // Label 6863: @331340
     /* 331340 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(331394), // Rule ID 8959 //
     /* 331345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331355 */   // MIs[0] Operand 2
     /* 331355 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331366 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 331366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331378 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331392 */   GIR_RootConstrainSelectedInstOperands,
     /* 331393 */   // GIR_Coverage, 8959,
     /* 331393 */   GIR_EraseRootFromParent_Done,
     /* 331394 */ // Label 6864: @331394
     /* 331394 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(331448), // Rule ID 8960 //
     /* 331399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331409 */   // MIs[0] Operand 2
     /* 331409 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 331420 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 331420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331432 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331446 */   GIR_RootConstrainSelectedInstOperands,
     /* 331447 */   // GIR_Coverage, 8960,
     /* 331447 */   GIR_EraseRootFromParent_Done,
     /* 331448 */ // Label 6865: @331448
     /* 331448 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(331519), // Rule ID 8969 //
     /* 331453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331463 */   // MIs[0] Operand 2
     /* 331463 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331474 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331486 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331517 */   GIR_RootConstrainSelectedInstOperands,
     /* 331518 */   // GIR_Coverage, 8969,
     /* 331518 */   GIR_EraseRootFromParent_Done,
     /* 331519 */ // Label 6866: @331519
     /* 331519 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(331590), // Rule ID 8970 //
     /* 331524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331534 */   // MIs[0] Operand 2
     /* 331534 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331545 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331557 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331588 */   GIR_RootConstrainSelectedInstOperands,
     /* 331589 */   // GIR_Coverage, 8970,
     /* 331589 */   GIR_EraseRootFromParent_Done,
     /* 331590 */ // Label 6867: @331590
     /* 331590 */ GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(331661), // Rule ID 8971 //
     /* 331595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331605 */   // MIs[0] Operand 2
     /* 331605 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331616 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331616 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331619 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331623 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331628 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331646 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331659 */   GIR_RootConstrainSelectedInstOperands,
     /* 331660 */   // GIR_Coverage, 8971,
     /* 331660 */   GIR_EraseRootFromParent_Done,
     /* 331661 */ // Label 6868: @331661
     /* 331661 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(331732), // Rule ID 8972 //
     /* 331666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331676 */   // MIs[0] Operand 2
     /* 331676 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 331687 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331699 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331717 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331730 */   GIR_RootConstrainSelectedInstOperands,
     /* 331731 */   // GIR_Coverage, 8972,
     /* 331731 */   GIR_EraseRootFromParent_Done,
     /* 331732 */ // Label 6869: @331732
     /* 331732 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(331803), // Rule ID 8973 //
     /* 331737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331747 */   // MIs[0] Operand 2
     /* 331747 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 331758 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331770 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331801 */   GIR_RootConstrainSelectedInstOperands,
     /* 331802 */   // GIR_Coverage, 8973,
     /* 331802 */   GIR_EraseRootFromParent_Done,
     /* 331803 */ // Label 6870: @331803
     /* 331803 */ GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(331874), // Rule ID 8974 //
     /* 331808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331818 */   // MIs[0] Operand 2
     /* 331818 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 331829 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331829 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331832 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331836 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331841 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331859 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331872 */   GIR_RootConstrainSelectedInstOperands,
     /* 331873 */   // GIR_Coverage, 8974,
     /* 331873 */   GIR_EraseRootFromParent_Done,
     /* 331874 */ // Label 6871: @331874
     /* 331874 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(331945), // Rule ID 8975 //
     /* 331879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331889 */   // MIs[0] Operand 2
     /* 331889 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 331900 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331912 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331930 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331943 */   GIR_RootConstrainSelectedInstOperands,
     /* 331944 */   // GIR_Coverage, 8975,
     /* 331944 */   GIR_EraseRootFromParent_Done,
     /* 331945 */ // Label 6872: @331945
     /* 331945 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(332016), // Rule ID 8976 //
     /* 331950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331960 */   // MIs[0] Operand 2
     /* 331960 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 331971 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 331971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331983 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332001 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332014 */   GIR_RootConstrainSelectedInstOperands,
     /* 332015 */   // GIR_Coverage, 8976,
     /* 332015 */   GIR_EraseRootFromParent_Done,
     /* 332016 */ // Label 6873: @332016
     /* 332016 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(332104), // Rule ID 8985 //
     /* 332021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332031 */   // MIs[0] Operand 2
     /* 332031 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332042 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332042 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332045 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332049 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332054 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332060 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332063 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332067 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332072 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332102 */   GIR_RootConstrainSelectedInstOperands,
     /* 332103 */   // GIR_Coverage, 8985,
     /* 332103 */   GIR_EraseRootFromParent_Done,
     /* 332104 */ // Label 6874: @332104
     /* 332104 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(332192), // Rule ID 8986 //
     /* 332109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332119 */   // MIs[0] Operand 2
     /* 332119 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 332130 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332130 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332133 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332137 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332142 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332148 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332151 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332155 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332160 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332177 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332190 */   GIR_RootConstrainSelectedInstOperands,
     /* 332191 */   // GIR_Coverage, 8986,
     /* 332191 */   GIR_EraseRootFromParent_Done,
     /* 332192 */ // Label 6875: @332192
     /* 332192 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(332280), // Rule ID 8987 //
     /* 332197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332207 */   // MIs[0] Operand 2
     /* 332207 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332218 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332218 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332221 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332225 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332230 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332236 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332239 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332243 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332248 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332265 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332278 */   GIR_RootConstrainSelectedInstOperands,
     /* 332279 */   // GIR_Coverage, 8987,
     /* 332279 */   GIR_EraseRootFromParent_Done,
     /* 332280 */ // Label 6876: @332280
     /* 332280 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(332368), // Rule ID 8988 //
     /* 332285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332295 */   // MIs[0] Operand 2
     /* 332295 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 332306 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332306 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332309 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332313 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332318 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332336 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332353 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332366 */   GIR_RootConstrainSelectedInstOperands,
     /* 332367 */   // GIR_Coverage, 8988,
     /* 332367 */   GIR_EraseRootFromParent_Done,
     /* 332368 */ // Label 6877: @332368
     /* 332368 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(332456), // Rule ID 8989 //
     /* 332373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332383 */   // MIs[0] Operand 2
     /* 332383 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332394 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332394 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332397 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332401 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332406 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332424 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332441 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332454 */   GIR_RootConstrainSelectedInstOperands,
     /* 332455 */   // GIR_Coverage, 8989,
     /* 332455 */   GIR_EraseRootFromParent_Done,
     /* 332456 */ // Label 6878: @332456
     /* 332456 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(332544), // Rule ID 8990 //
     /* 332461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332471 */   // MIs[0] Operand 2
     /* 332471 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 332482 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332482 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332485 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332489 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332494 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332500 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332503 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332507 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332512 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332529 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332542 */   GIR_RootConstrainSelectedInstOperands,
     /* 332543 */   // GIR_Coverage, 8990,
     /* 332543 */   GIR_EraseRootFromParent_Done,
     /* 332544 */ // Label 6879: @332544
     /* 332544 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(332632), // Rule ID 8991 //
     /* 332549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332559 */   // MIs[0] Operand 2
     /* 332559 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332570 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332570 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332573 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332577 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332582 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332588 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332591 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332595 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332600 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332617 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332630 */   GIR_RootConstrainSelectedInstOperands,
     /* 332631 */   // GIR_Coverage, 8991,
     /* 332631 */   GIR_EraseRootFromParent_Done,
     /* 332632 */ // Label 6880: @332632
     /* 332632 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(332720), // Rule ID 8992 //
     /* 332637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332647 */   // MIs[0] Operand 2
     /* 332647 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 332658 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332658 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332661 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332665 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332670 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332676 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332679 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332683 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332688 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332705 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332718 */   GIR_RootConstrainSelectedInstOperands,
     /* 332719 */   // GIR_Coverage, 8992,
     /* 332719 */   GIR_EraseRootFromParent_Done,
     /* 332720 */ // Label 6881: @332720
     /* 332720 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(332808), // Rule ID 8993 //
     /* 332725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332735 */   // MIs[0] Operand 2
     /* 332735 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332746 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332746 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332749 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332753 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332758 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332764 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332767 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332771 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332776 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332793 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332806 */   GIR_RootConstrainSelectedInstOperands,
     /* 332807 */   // GIR_Coverage, 8993,
     /* 332807 */   GIR_EraseRootFromParent_Done,
     /* 332808 */ // Label 6882: @332808
     /* 332808 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(332896), // Rule ID 8994 //
     /* 332813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332823 */   // MIs[0] Operand 2
     /* 332823 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 332834 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332846 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332864 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332881 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332894 */   GIR_RootConstrainSelectedInstOperands,
     /* 332895 */   // GIR_Coverage, 8994,
     /* 332895 */   GIR_EraseRootFromParent_Done,
     /* 332896 */ // Label 6883: @332896
     /* 332896 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(332984), // Rule ID 8995 //
     /* 332901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332911 */   // MIs[0] Operand 2
     /* 332911 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 332922 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332922 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332925 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332929 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332934 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332940 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332943 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332947 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332952 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332982 */   GIR_RootConstrainSelectedInstOperands,
     /* 332983 */   // GIR_Coverage, 8995,
     /* 332983 */   GIR_EraseRootFromParent_Done,
     /* 332984 */ // Label 6884: @332984
     /* 332984 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(333072), // Rule ID 8996 //
     /* 332989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332999 */   // MIs[0] Operand 2
     /* 332999 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 333010 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333010 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333013 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333017 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333022 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333040 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333070 */   GIR_RootConstrainSelectedInstOperands,
     /* 333071 */   // GIR_Coverage, 8996,
     /* 333071 */   GIR_EraseRootFromParent_Done,
     /* 333072 */ // Label 6885: @333072
     /* 333072 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(333160), // Rule ID 8997 //
     /* 333077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333087 */   // MIs[0] Operand 2
     /* 333087 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333098 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333098 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333101 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333105 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333110 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333116 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333119 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333123 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333128 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333145 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333158 */   GIR_RootConstrainSelectedInstOperands,
     /* 333159 */   // GIR_Coverage, 8997,
     /* 333159 */   GIR_EraseRootFromParent_Done,
     /* 333160 */ // Label 6886: @333160
     /* 333160 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(333248), // Rule ID 8998 //
     /* 333165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333175 */   // MIs[0] Operand 2
     /* 333175 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 333186 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333186 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333189 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333193 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333198 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333216 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333233 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333246 */   GIR_RootConstrainSelectedInstOperands,
     /* 333247 */   // GIR_Coverage, 8998,
     /* 333247 */   GIR_EraseRootFromParent_Done,
     /* 333248 */ // Label 6887: @333248
     /* 333248 */ GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(333336), // Rule ID 8999 //
     /* 333253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333263 */   // MIs[0] Operand 2
     /* 333263 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 333274 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333274 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333277 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333281 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333286 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333292 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333295 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333299 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333304 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333321 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333334 */   GIR_RootConstrainSelectedInstOperands,
     /* 333335 */   // GIR_Coverage, 8999,
     /* 333335 */   GIR_EraseRootFromParent_Done,
     /* 333336 */ // Label 6888: @333336
     /* 333336 */ GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(333424), // Rule ID 9000 //
     /* 333341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333351 */   // MIs[0] Operand 2
     /* 333351 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 333362 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 333362 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 333365 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333369 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333374 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333380 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333383 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333387 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333392 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333409 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333422 */   GIR_RootConstrainSelectedInstOperands,
     /* 333423 */   // GIR_Coverage, 9000,
     /* 333423 */   GIR_EraseRootFromParent_Done,
     /* 333424 */ // Label 6889: @333424
     /* 333424 */ GIM_Reject,
     /* 333425 */ // Label 6825: @333425
     /* 333425 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(333460), // Rule ID 8951 //
     /* 333430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 333436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333440 */   // MIs[0] Operand 2
     /* 333440 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333451 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 333451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333456 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333458 */   GIR_RootConstrainSelectedInstOperands,
     /* 333459 */   // GIR_Coverage, 8951,
     /* 333459 */   GIR_EraseRootFromParent_Done,
     /* 333460 */ // Label 6890: @333460
     /* 333460 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(333495), // Rule ID 8952 //
     /* 333465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 333471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333475 */   // MIs[0] Operand 2
     /* 333475 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333486 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 333486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333491 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333493 */   GIR_RootConstrainSelectedInstOperands,
     /* 333494 */   // GIR_Coverage, 8952,
     /* 333494 */   GIR_EraseRootFromParent_Done,
     /* 333495 */ // Label 6891: @333495
     /* 333495 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(333549), // Rule ID 8961 //
     /* 333500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333510 */   // MIs[0] Operand 2
     /* 333510 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333521 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 333521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333547 */   GIR_RootConstrainSelectedInstOperands,
     /* 333548 */   // GIR_Coverage, 8961,
     /* 333548 */   GIR_EraseRootFromParent_Done,
     /* 333549 */ // Label 6892: @333549
     /* 333549 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(333603), // Rule ID 8962 //
     /* 333554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333564 */   // MIs[0] Operand 2
     /* 333564 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333575 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 333575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333587 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333601 */   GIR_RootConstrainSelectedInstOperands,
     /* 333602 */   // GIR_Coverage, 8962,
     /* 333602 */   GIR_EraseRootFromParent_Done,
     /* 333603 */ // Label 6893: @333603
     /* 333603 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(333657), // Rule ID 8963 //
     /* 333608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333618 */   // MIs[0] Operand 2
     /* 333618 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333629 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 333629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333655 */   GIR_RootConstrainSelectedInstOperands,
     /* 333656 */   // GIR_Coverage, 8963,
     /* 333656 */   GIR_EraseRootFromParent_Done,
     /* 333657 */ // Label 6894: @333657
     /* 333657 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(333711), // Rule ID 8964 //
     /* 333662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333672 */   // MIs[0] Operand 2
     /* 333672 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 333683 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 333683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333695 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333709 */   GIR_RootConstrainSelectedInstOperands,
     /* 333710 */   // GIR_Coverage, 8964,
     /* 333710 */   GIR_EraseRootFromParent_Done,
     /* 333711 */ // Label 6895: @333711
     /* 333711 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(333782), // Rule ID 8977 //
     /* 333716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333726 */   // MIs[0] Operand 2
     /* 333726 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333737 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333737 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333740 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333744 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333749 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333780 */   GIR_RootConstrainSelectedInstOperands,
     /* 333781 */   // GIR_Coverage, 8977,
     /* 333781 */   GIR_EraseRootFromParent_Done,
     /* 333782 */ // Label 6896: @333782
     /* 333782 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(333853), // Rule ID 8978 //
     /* 333787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333797 */   // MIs[0] Operand 2
     /* 333797 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333808 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333808 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333811 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333815 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333820 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333838 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333851 */   GIR_RootConstrainSelectedInstOperands,
     /* 333852 */   // GIR_Coverage, 8978,
     /* 333852 */   GIR_EraseRootFromParent_Done,
     /* 333853 */ // Label 6897: @333853
     /* 333853 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(333924), // Rule ID 8979 //
     /* 333858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333868 */   // MIs[0] Operand 2
     /* 333868 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333879 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333879 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333882 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333886 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333891 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333909 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333922 */   GIR_RootConstrainSelectedInstOperands,
     /* 333923 */   // GIR_Coverage, 8979,
     /* 333923 */   GIR_EraseRootFromParent_Done,
     /* 333924 */ // Label 6898: @333924
     /* 333924 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(333995), // Rule ID 8980 //
     /* 333929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333939 */   // MIs[0] Operand 2
     /* 333939 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 333950 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333950 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333953 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333957 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333962 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333980 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333993 */   GIR_RootConstrainSelectedInstOperands,
     /* 333994 */   // GIR_Coverage, 8980,
     /* 333994 */   GIR_EraseRootFromParent_Done,
     /* 333995 */ // Label 6899: @333995
     /* 333995 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(334066), // Rule ID 8981 //
     /* 334000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334010 */   // MIs[0] Operand 2
     /* 334010 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 334021 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 334021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334064 */   GIR_RootConstrainSelectedInstOperands,
     /* 334065 */   // GIR_Coverage, 8981,
     /* 334065 */   GIR_EraseRootFromParent_Done,
     /* 334066 */ // Label 6900: @334066
     /* 334066 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(334137), // Rule ID 8982 //
     /* 334071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334081 */   // MIs[0] Operand 2
     /* 334081 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 334092 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 334092 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334095 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334099 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334104 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334122 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334135 */   GIR_RootConstrainSelectedInstOperands,
     /* 334136 */   // GIR_Coverage, 8982,
     /* 334136 */   GIR_EraseRootFromParent_Done,
     /* 334137 */ // Label 6901: @334137
     /* 334137 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(334208), // Rule ID 8983 //
     /* 334142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334152 */   // MIs[0] Operand 2
     /* 334152 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 334163 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 334163 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334166 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334170 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334175 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334193 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334206 */   GIR_RootConstrainSelectedInstOperands,
     /* 334207 */   // GIR_Coverage, 8983,
     /* 334207 */   GIR_EraseRootFromParent_Done,
     /* 334208 */ // Label 6902: @334208
     /* 334208 */ GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(334279), // Rule ID 8984 //
     /* 334213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334223 */   // MIs[0] Operand 2
     /* 334223 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 334234 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 334234 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 334237 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334241 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334246 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334264 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334277 */   GIR_RootConstrainSelectedInstOperands,
     /* 334278 */   // GIR_Coverage, 8984,
     /* 334278 */   GIR_EraseRootFromParent_Done,
     /* 334279 */ // Label 6903: @334279
     /* 334279 */ GIM_Reject,
     /* 334280 */ // Label 6826: @334280
     /* 334280 */ GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(334315), // Rule ID 9001 //
     /* 334285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 334291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334295 */   // MIs[0] Operand 2
     /* 334295 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334306 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 334306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 334309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334313 */   GIR_RootConstrainSelectedInstOperands,
     /* 334314 */   // GIR_Coverage, 9001,
     /* 334314 */   GIR_EraseRootFromParent_Done,
     /* 334315 */ // Label 6904: @334315
     /* 334315 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(334350), // Rule ID 9002 //
     /* 334320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 334326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334330 */   // MIs[0] Operand 2
     /* 334330 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 334341 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 334341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 334344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334346 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334348 */   GIR_RootConstrainSelectedInstOperands,
     /* 334349 */   // GIR_Coverage, 9002,
     /* 334349 */   GIR_EraseRootFromParent_Done,
     /* 334350 */ // Label 6905: @334350
     /* 334350 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(334404), // Rule ID 9007 //
     /* 334355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 334361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334365 */   // MIs[0] Operand 2
     /* 334365 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334376 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 334376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 334379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 334383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334388 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 334392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 334397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334402 */   GIR_RootConstrainSelectedInstOperands,
     /* 334403 */   // GIR_Coverage, 9007,
     /* 334403 */   GIR_EraseRootFromParent_Done,
     /* 334404 */ // Label 6906: @334404
     /* 334404 */ GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(334458), // Rule ID 9008 //
     /* 334409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 334415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334419 */   // MIs[0] Operand 2
     /* 334419 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 334430 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 334430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 334433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 334437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 334446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 334451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334456 */   GIR_RootConstrainSelectedInstOperands,
     /* 334457 */   // GIR_Coverage, 9008,
     /* 334457 */   GIR_EraseRootFromParent_Done,
     /* 334458 */ // Label 6907: @334458
     /* 334458 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(334512), // Rule ID 9009 //
     /* 334463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 334469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334473 */   // MIs[0] Operand 2
     /* 334473 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 334484 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 334484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 334487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 334491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334496 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 334500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 334505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334510 */   GIR_RootConstrainSelectedInstOperands,
     /* 334511 */   // GIR_Coverage, 9009,
     /* 334511 */   GIR_EraseRootFromParent_Done,
     /* 334512 */ // Label 6908: @334512
     /* 334512 */ GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(334566), // Rule ID 9010 //
     /* 334517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 334523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334527 */   // MIs[0] Operand 2
     /* 334527 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 334538 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 334538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 334541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 334545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 334554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 334559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334564 */   GIR_RootConstrainSelectedInstOperands,
     /* 334565 */   // GIR_Coverage, 9010,
     /* 334565 */   GIR_EraseRootFromParent_Done,
     /* 334566 */ // Label 6909: @334566
     /* 334566 */ GIM_Reject,
     /* 334567 */ // Label 6827: @334567
     /* 334567 */ GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(334636),
     /* 334572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 334575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334579 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(334607), // Rule ID 9005 //
     /* 334584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334587 */     // MIs[0] Operand 2
     /* 334587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334598 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 334598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 334601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334605 */     GIR_RootConstrainSelectedInstOperands,
     /* 334606 */     // GIR_Coverage, 9005,
     /* 334606 */     GIR_EraseRootFromParent_Done,
     /* 334607 */   // Label 6911: @334607
     /* 334607 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(334635), // Rule ID 9006 //
     /* 334612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334615 */     // MIs[0] Operand 2
     /* 334615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 334626 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 334626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 334629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334633 */     GIR_RootConstrainSelectedInstOperands,
     /* 334634 */     // GIR_Coverage, 9006,
     /* 334634 */     GIR_EraseRootFromParent_Done,
     /* 334635 */   // Label 6912: @334635
     /* 334635 */   GIM_Reject,
     /* 334636 */ // Label 6910: @334636
     /* 334636 */ GIM_Reject,
     /* 334637 */ // Label 6828: @334637
     /* 334637 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(334672), // Rule ID 8953 //
     /* 334642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 334648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334652 */   // MIs[0] Operand 2
     /* 334652 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334663 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 334663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334668 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334670 */   GIR_RootConstrainSelectedInstOperands,
     /* 334671 */   // GIR_Coverage, 8953,
     /* 334671 */   GIR_EraseRootFromParent_Done,
     /* 334672 */ // Label 6913: @334672
     /* 334672 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(334707), // Rule ID 8954 //
     /* 334677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 334683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334687 */   // MIs[0] Operand 2
     /* 334687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 334698 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 334698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334703 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334705 */   GIR_RootConstrainSelectedInstOperands,
     /* 334706 */   // GIR_Coverage, 8954,
     /* 334706 */   GIR_EraseRootFromParent_Done,
     /* 334707 */ // Label 6914: @334707
     /* 334707 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(334761), // Rule ID 8965 //
     /* 334712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334722 */   // MIs[0] Operand 2
     /* 334722 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334733 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 334733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334759 */   GIR_RootConstrainSelectedInstOperands,
     /* 334760 */   // GIR_Coverage, 8965,
     /* 334760 */   GIR_EraseRootFromParent_Done,
     /* 334761 */ // Label 6915: @334761
     /* 334761 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(334815), // Rule ID 8966 //
     /* 334766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334776 */   // MIs[0] Operand 2
     /* 334776 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 334787 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 334787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334813 */   GIR_RootConstrainSelectedInstOperands,
     /* 334814 */   // GIR_Coverage, 8966,
     /* 334814 */   GIR_EraseRootFromParent_Done,
     /* 334815 */ // Label 6916: @334815
     /* 334815 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(334869), // Rule ID 8967 //
     /* 334820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334830 */   // MIs[0] Operand 2
     /* 334830 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 334841 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 334841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334853 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334867 */   GIR_RootConstrainSelectedInstOperands,
     /* 334868 */   // GIR_Coverage, 8967,
     /* 334868 */   GIR_EraseRootFromParent_Done,
     /* 334869 */ // Label 6917: @334869
     /* 334869 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(334923), // Rule ID 8968 //
     /* 334874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 334880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 334884 */   // MIs[0] Operand 2
     /* 334884 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 334895 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 334895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 334898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 334911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334921 */   GIR_RootConstrainSelectedInstOperands,
     /* 334922 */   // GIR_Coverage, 8968,
     /* 334922 */   GIR_EraseRootFromParent_Done,
     /* 334923 */ // Label 6918: @334923
     /* 334923 */ GIM_Reject,
     /* 334924 */ // Label 6829: @334924
     /* 334924 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(334993),
     /* 334929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 334932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 334936 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(334964), // Rule ID 9003 //
     /* 334941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334944 */     // MIs[0] Operand 2
     /* 334944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334955 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 334955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 334958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334962 */     GIR_RootConstrainSelectedInstOperands,
     /* 334963 */     // GIR_Coverage, 9003,
     /* 334963 */     GIR_EraseRootFromParent_Done,
     /* 334964 */   // Label 6920: @334964
     /* 334964 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(334992), // Rule ID 9004 //
     /* 334969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334972 */     // MIs[0] Operand 2
     /* 334972 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 334983 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 334983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 334986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 334988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 334990 */     GIR_RootConstrainSelectedInstOperands,
     /* 334991 */     // GIR_Coverage, 9004,
     /* 334991 */     GIR_EraseRootFromParent_Done,
     /* 334992 */   // Label 6921: @334992
     /* 334992 */   GIM_Reject,
     /* 334993 */ // Label 6919: @334993
     /* 334993 */ GIM_Reject,
     /* 334994 */ // Label 6830: @334994
     /* 334994 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(335063),
     /* 334999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 335002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 335006 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(335034), // Rule ID 8955 //
     /* 335011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335014 */     // MIs[0] Operand 2
     /* 335014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 335025 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 335025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 335028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 335032 */     GIR_RootConstrainSelectedInstOperands,
     /* 335033 */     // GIR_Coverage, 8955,
     /* 335033 */     GIR_EraseRootFromParent_Done,
     /* 335034 */   // Label 6923: @335034
     /* 335034 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(335062), // Rule ID 8956 //
     /* 335039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 335042 */     // MIs[0] Operand 2
     /* 335042 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 335053 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 335053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 335056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 335058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 335060 */     GIR_RootConstrainSelectedInstOperands,
     /* 335061 */     // GIR_Coverage, 8956,
     /* 335061 */     GIR_EraseRootFromParent_Done,
     /* 335062 */   // Label 6924: @335062
     /* 335062 */   GIM_Reject,
     /* 335063 */ // Label 6922: @335063
     /* 335063 */ GIM_Reject,
     /* 335064 */ // Label 6831: @335064
     /* 335064 */ GIM_Reject,
     /* 335065 */ // Label 88: @335065
     /* 335065 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6940*/ GIMT_Encode4(364201),
     /* 335076 */ /*GILLT_s64*//*Label 6925*/ GIMT_Encode4(335160), GIMT_Encode4(0),
     /* 335084 */ /*GILLT_v2s32*//*Label 6926*/ GIMT_Encode4(335870),
     /* 335088 */ /*GILLT_v2s64*//*Label 6927*/ GIMT_Encode4(339401),
     /* 335092 */ /*GILLT_v4s16*//*Label 6928*/ GIMT_Encode4(342634),
     /* 335096 */ /*GILLT_v4s32*//*Label 6929*/ GIMT_Encode4(346274),
     /* 335100 */ /*GILLT_v8s8*//*Label 6930*/ GIMT_Encode4(349342),
     /* 335104 */ /*GILLT_v8s16*//*Label 6931*/ GIMT_Encode4(351186),
     /* 335108 */ /*GILLT_v16s8*//*Label 6932*/ GIMT_Encode4(354605), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 335120 */ /*GILLT_nxv2s16*//*Label 6933*/ GIMT_Encode4(356407),
     /* 335124 */ /*GILLT_nxv2s32*//*Label 6934*/ GIMT_Encode4(356532),
     /* 335128 */ /*GILLT_nxv2s64*//*Label 6935*/ GIMT_Encode4(356657), GIMT_Encode4(0),
     /* 335136 */ /*GILLT_nxv4s16*//*Label 6936*/ GIMT_Encode4(358635),
     /* 335140 */ /*GILLT_nxv4s32*//*Label 6937*/ GIMT_Encode4(358787), GIMT_Encode4(0),
     /* 335148 */ /*GILLT_nxv8s16*//*Label 6938*/ GIMT_Encode4(360819), GIMT_Encode4(0),
     /* 335156 */ /*GILLT_nxv16s8*//*Label 6939*/ GIMT_Encode4(363087),
     /* 335160 */ // Label 6925: @335160
     /* 335160 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(335869),
     /* 335165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 335171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335178 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(335308), // Rule ID 5734 //
     /* 335183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335216 */     // MIs[2] Operand 1
     /* 335216 */     // No operand predicates
     /* 335216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335224 */     // MIs[3] Operand 1
     /* 335224 */     // No operand predicates
     /* 335224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335226 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335238 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335241 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335245 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 335276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 335283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335307 */     // GIR_Coverage, 5734,
     /* 335307 */     GIR_EraseRootFromParent_Done,
     /* 335308 */   // Label 6942: @335308
     /* 335308 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(335469), // Rule ID 5735 //
     /* 335313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335346 */     // MIs[2] Operand 1
     /* 335346 */     // No operand predicates
     /* 335346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335354 */     // MIs[3] Operand 1
     /* 335354 */     // No operand predicates
     /* 335354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335356 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335356 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 335359 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335363 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335368 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 335371 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335375 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 335378 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335383 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335400 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335432 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 335438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 335441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 335444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335451 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335468 */     // GIR_Coverage, 5735,
     /* 335468 */     GIR_EraseRootFromParent_Done,
     /* 335469 */   // Label 6943: @335469
     /* 335469 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(335599), // Rule ID 5766 //
     /* 335474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335507 */     // MIs[2] Operand 1
     /* 335507 */     // No operand predicates
     /* 335507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335515 */     // MIs[3] Operand 1
     /* 335515 */     // No operand predicates
     /* 335515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335517 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335536 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 335567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 335574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335581 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335598 */     // GIR_Coverage, 5766,
     /* 335598 */     GIR_EraseRootFromParent_Done,
     /* 335599 */   // Label 6944: @335599
     /* 335599 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(335760), // Rule ID 5767 //
     /* 335604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335637 */     // MIs[2] Operand 1
     /* 335637 */     // No operand predicates
     /* 335637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335645 */     // MIs[3] Operand 1
     /* 335645 */     // No operand predicates
     /* 335645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335647 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 335647 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 335650 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335654 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335659 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 335662 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335666 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 335669 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335674 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335691 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 335698 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 335701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 335729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 335732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 335735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335759 */     // GIR_Coverage, 5767,
     /* 335759 */     GIR_EraseRootFromParent_Done,
     /* 335760 */   // Label 6945: @335760
     /* 335760 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(335796), // Rule ID 6661 //
     /* 335765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335783 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 335783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 335790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335795 */     // GIR_Coverage, 6661,
     /* 335795 */     GIR_EraseRootFromParent_Done,
     /* 335796 */   // Label 6946: @335796
     /* 335796 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(335832), // Rule ID 6663 //
     /* 335801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 335813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335819 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 335819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 335826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335831 */     // GIR_Coverage, 6663,
     /* 335831 */     GIR_EraseRootFromParent_Done,
     /* 335832 */   // Label 6947: @335832
     /* 335832 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(335868), // Rule ID 6665 //
     /* 335837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335855 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 335855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335858 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 335860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 335862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335867 */     // GIR_Coverage, 6665,
     /* 335867 */     GIR_EraseRootFromParent_Done,
     /* 335868 */   // Label 6948: @335868
     /* 335868 */   GIM_Reject,
     /* 335869 */ // Label 6941: @335869
     /* 335869 */ GIM_Reject,
     /* 335870 */ // Label 6926: @335870
     /* 335870 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(339400),
     /* 335875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 335881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335888 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335997), // Rule ID 4272 //
     /* 335893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335913 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335920 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335937 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335964 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335996 */     // GIR_Coverage, 4272,
     /* 335996 */     GIR_EraseRootFromParent_Done,
     /* 335997 */   // Label 6950: @335997
     /* 335997 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(336106), // Rule ID 4273 //
     /* 336002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336022 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336029 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336046 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336073 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336105 */     // GIR_Coverage, 4273,
     /* 336105 */     GIR_EraseRootFromParent_Done,
     /* 336106 */   // Label 6951: @336106
     /* 336106 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(336215), // Rule ID 4380 //
     /* 336111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336131 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336138 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336155 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336182 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336214 */     // GIR_Coverage, 4380,
     /* 336214 */     GIR_EraseRootFromParent_Done,
     /* 336215 */   // Label 6952: @336215
     /* 336215 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(336324), // Rule ID 4381 //
     /* 336220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336224 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336230 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336240 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336247 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336264 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336291 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336323 */     // GIR_Coverage, 4381,
     /* 336323 */     GIR_EraseRootFromParent_Done,
     /* 336324 */   // Label 6953: @336324
     /* 336324 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(336429), // Rule ID 4278 //
     /* 336329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336345 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336352 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336369 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336396 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336428 */     // GIR_Coverage, 4278,
     /* 336428 */     GIR_EraseRootFromParent_Done,
     /* 336429 */   // Label 6954: @336429
     /* 336429 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(336534), // Rule ID 4280 //
     /* 336434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336450 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336474 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336533 */     // GIR_Coverage, 4280,
     /* 336533 */     GIR_EraseRootFromParent_Done,
     /* 336534 */   // Label 6955: @336534
     /* 336534 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(336639), // Rule ID 4386 //
     /* 336539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336555 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336562 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 336579 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 336586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336606 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336638 */     // GIR_Coverage, 4386,
     /* 336638 */     GIR_EraseRootFromParent_Done,
     /* 336639 */   // Label 6956: @336639
     /* 336639 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(336744), // Rule ID 4388 //
     /* 336644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 336684 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 336684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 336691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336743 */     // GIR_Coverage, 4388,
     /* 336743 */     GIR_EraseRootFromParent_Done,
     /* 336744 */   // Label 6957: @336744
     /* 336744 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(336848), // Rule ID 4270 //
     /* 336749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336769 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 336793 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 336793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 336800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336847 */     // GIR_Coverage, 4270,
     /* 336847 */     GIR_EraseRootFromParent_Done,
     /* 336848 */   // Label 6958: @336848
     /* 336848 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(336952), // Rule ID 4271 //
     /* 336853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336880 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336897 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 336897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336919 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336951 */     // GIR_Coverage, 4271,
     /* 336951 */     GIR_EraseRootFromParent_Done,
     /* 336952 */   // Label 6959: @336952
     /* 336952 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(337056), // Rule ID 4378 //
     /* 336957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336961 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336977 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336984 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337001 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337055 */     // GIR_Coverage, 4378,
     /* 337055 */     GIR_EraseRootFromParent_Done,
     /* 337056 */   // Label 6960: @337056
     /* 337056 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(337160), // Rule ID 4379 //
     /* 337061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337065 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337071 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337081 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337084 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337088 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337105 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337127 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337159 */     // GIR_Coverage, 4379,
     /* 337159 */     GIR_EraseRootFromParent_Done,
     /* 337160 */   // Label 6961: @337160
     /* 337160 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(337260), // Rule ID 4274 //
     /* 337165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337181 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337188 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337205 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337227 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337259 */     // GIR_Coverage, 4274,
     /* 337259 */     GIR_EraseRootFromParent_Done,
     /* 337260 */   // Label 6962: @337260
     /* 337260 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(337360), // Rule ID 4276 //
     /* 337265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337281 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337288 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337305 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337327 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337359 */     // GIR_Coverage, 4276,
     /* 337359 */     GIR_EraseRootFromParent_Done,
     /* 337360 */   // Label 6963: @337360
     /* 337360 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(337460), // Rule ID 4382 //
     /* 337365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337381 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337388 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 337405 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 337405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 337412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337459 */     // GIR_Coverage, 4382,
     /* 337459 */     GIR_EraseRootFromParent_Done,
     /* 337460 */   // Label 6964: @337460
     /* 337460 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(337560), // Rule ID 4384 //
     /* 337465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 337505 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 337505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 337512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337559 */     // GIR_Coverage, 4384,
     /* 337559 */     GIR_EraseRootFromParent_Done,
     /* 337560 */   // Label 6965: @337560
     /* 337560 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(337680), // Rule ID 6440 //
     /* 337565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337584 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337587 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337591 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337598 */     // MIs[2] Rn
     /* 337598 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 337602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337613 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 337616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 337634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 337649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337662 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337679 */     // GIR_Coverage, 6440,
     /* 337679 */     GIR_EraseRootFromParent_Done,
     /* 337680 */   // Label 6966: @337680
     /* 337680 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(337800), // Rule ID 6442 //
     /* 337685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 337688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337704 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337707 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337711 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337718 */     // MIs[2] Rn
     /* 337718 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 337722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337733 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 337754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 337769 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337782 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337799 */     // GIR_Coverage, 6442,
     /* 337799 */     GIR_EraseRootFromParent_Done,
     /* 337800 */   // Label 6967: @337800
     /* 337800 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(337930), // Rule ID 5726 //
     /* 337805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337838 */     // MIs[2] Operand 1
     /* 337838 */     // No operand predicates
     /* 337838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337846 */     // MIs[3] Operand 1
     /* 337846 */     // No operand predicates
     /* 337846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337848 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337860 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337867 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337929 */     // GIR_Coverage, 5726,
     /* 337929 */     GIR_EraseRootFromParent_Done,
     /* 337930 */   // Label 6968: @337930
     /* 337930 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(338091), // Rule ID 5727 //
     /* 337935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337968 */     // MIs[2] Operand 1
     /* 337968 */     // No operand predicates
     /* 337968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337976 */     // MIs[3] Operand 1
     /* 337976 */     // No operand predicates
     /* 337976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337978 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337993 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337997 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 338000 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338005 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338022 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338025 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 338029 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 338060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 338066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338073 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338090 */     // GIR_Coverage, 5727,
     /* 338090 */     GIR_EraseRootFromParent_Done,
     /* 338091 */   // Label 6969: @338091
     /* 338091 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(338221), // Rule ID 5758 //
     /* 338096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338129 */     // MIs[2] Operand 1
     /* 338129 */     // No operand predicates
     /* 338129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338137 */     // MIs[3] Operand 1
     /* 338137 */     // No operand predicates
     /* 338137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338139 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 338139 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338142 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338146 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338151 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 338158 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338161 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338166 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 338189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 338196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338203 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338220 */     // GIR_Coverage, 5758,
     /* 338220 */     GIR_EraseRootFromParent_Done,
     /* 338221 */   // Label 6970: @338221
     /* 338221 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(338382), // Rule ID 5759 //
     /* 338226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 338242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338259 */     // MIs[2] Operand 1
     /* 338259 */     // No operand predicates
     /* 338259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338267 */     // MIs[3] Operand 1
     /* 338267 */     // No operand predicates
     /* 338267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338269 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 338269 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 338272 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338276 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338281 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 338284 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338288 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 338291 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338296 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338313 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 338320 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 338351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 338357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338364 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338381 */     // GIR_Coverage, 5759,
     /* 338381 */     GIR_EraseRootFromParent_Done,
     /* 338382 */   // Label 6971: @338382
     /* 338382 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(338448), // Rule ID 5677 //
     /* 338387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338405 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 338405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 338408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 338429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338447 */     // GIR_Coverage, 5677,
     /* 338447 */     GIR_EraseRootFromParent_Done,
     /* 338448 */   // Label 6972: @338448
     /* 338448 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(338514), // Rule ID 5689 //
     /* 338453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338471 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 338471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 338474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 338495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 338498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338513 */     // GIR_Coverage, 5689,
     /* 338513 */     GIR_EraseRootFromParent_Done,
     /* 338514 */   // Label 6973: @338514
     /* 338514 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(338649), // Rule ID 5697 //
     /* 338519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 338531 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 338535 */     // MIs[1] Operand 1
     /* 338535 */     // No operand predicates
     /* 338535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338547 */     // MIs[2] Operand 1
     /* 338547 */     // No operand predicates
     /* 338547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338549 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 338549 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 338552 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338556 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 338566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338575 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 338578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 338582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338595 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 338607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 338618 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 338624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338648 */     // GIR_Coverage, 5697,
     /* 338648 */     GIR_EraseRootFromParent_Done,
     /* 338649 */   // Label 6974: @338649
     /* 338649 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(338781), // Rule ID 6448 //
     /* 338654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338673 */     // MIs[1] Rn
     /* 338673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 338677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 338682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338694 */     // MIs[2] Operand 1
     /* 338694 */     // No operand predicates
     /* 338694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338696 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 338696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338708 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 338715 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 338735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 338746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338750 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338763 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338780 */     // GIR_Coverage, 6448,
     /* 338780 */     GIR_EraseRootFromParent_Done,
     /* 338781 */   // Label 6975: @338781
     /* 338781 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(338913), // Rule ID 6449 //
     /* 338786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338798 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338805 */     // MIs[1] Rn
     /* 338805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 338809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 338814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338826 */     // MIs[2] Operand 1
     /* 338826 */     // No operand predicates
     /* 338826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338828 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 338828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338840 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 338847 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338850 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338855 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 338867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 338878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338882 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338912 */     // GIR_Coverage, 6449,
     /* 338912 */     GIR_EraseRootFromParent_Done,
     /* 338913 */   // Label 6976: @338913
     /* 338913 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(339096), // Rule ID 5769 //
     /* 338918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 338926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 338939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338943 */     // MIs[2] Operand 1
     /* 338943 */     // No operand predicates
     /* 338943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338945 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 338945 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 338948 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338952 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 338959 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 338962 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338966 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338971 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 338974 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 338978 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 338981 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338986 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338991 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338996 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 338999 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339003 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 339013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339022 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 339025 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339029 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 339065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 339068 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339095 */     // GIR_Coverage, 5769,
     /* 339095 */     GIR_EraseRootFromParent_Done,
     /* 339096 */   // Label 6977: @339096
     /* 339096 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(339274), // Rule ID 5700 //
     /* 339101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 339113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 339121 */     // MIs[1] Operand 1
     /* 339121 */     // No operand predicates
     /* 339121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339123 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 339123 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 339126 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339130 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 339137 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 339140 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339144 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339149 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 339152 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 339156 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 339159 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339164 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339169 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339174 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 339177 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339181 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 339191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339200 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 339203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 339207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 339232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 339243 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 339246 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339273 */     // GIR_Coverage, 5700,
     /* 339273 */     GIR_EraseRootFromParent_Done,
     /* 339274 */   // Label 6978: @339274
     /* 339274 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(339399), // Rule ID 5703 //
     /* 339279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 339291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 339299 */     // MIs[1] Operand 1
     /* 339299 */     // No operand predicates
     /* 339299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339301 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 339301 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 339304 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339308 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 339318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339327 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 339330 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 339334 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 339359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 339370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 339374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339398 */     // GIR_Coverage, 5703,
     /* 339398 */     GIR_EraseRootFromParent_Done,
     /* 339399 */   // Label 6979: @339399
     /* 339399 */   GIM_Reject,
     /* 339400 */ // Label 6949: @339400
     /* 339400 */ GIM_Reject,
     /* 339401 */ // Label 6927: @339401
     /* 339401 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(342633),
     /* 339406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 339412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339419 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(339528), // Rule ID 4296 //
     /* 339424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339428 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339434 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339444 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339451 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 339468 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 339475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339495 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339527 */     // GIR_Coverage, 4296,
     /* 339527 */     GIR_EraseRootFromParent_Done,
     /* 339528 */   // Label 6981: @339528
     /* 339528 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(339637), // Rule ID 4297 //
     /* 339533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339537 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339543 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339553 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339560 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 339577 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 339584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339604 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339636 */     // GIR_Coverage, 4297,
     /* 339636 */     GIR_EraseRootFromParent_Done,
     /* 339637 */   // Label 6982: @339637
     /* 339637 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(339746), // Rule ID 4404 //
     /* 339642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339646 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339652 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339662 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339669 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 339686 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 339693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339713 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339745 */     // GIR_Coverage, 4404,
     /* 339745 */     GIR_EraseRootFromParent_Done,
     /* 339746 */   // Label 6983: @339746
     /* 339746 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(339855), // Rule ID 4405 //
     /* 339751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339771 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339778 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 339795 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 339802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339822 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339854 */     // GIR_Coverage, 4405,
     /* 339854 */     GIR_EraseRootFromParent_Done,
     /* 339855 */   // Label 6984: @339855
     /* 339855 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(339960), // Rule ID 4302 //
     /* 339860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339876 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339883 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 339900 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 339907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339927 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339959 */     // GIR_Coverage, 4302,
     /* 339959 */     GIR_EraseRootFromParent_Done,
     /* 339960 */   // Label 6985: @339960
     /* 339960 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(340065), // Rule ID 4304 //
     /* 339965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339981 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339988 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 340005 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 340005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 340012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340032 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340064 */     // GIR_Coverage, 4304,
     /* 340064 */     GIR_EraseRootFromParent_Done,
     /* 340065 */   // Label 6986: @340065
     /* 340065 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(340170), // Rule ID 4410 //
     /* 340070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340086 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340093 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 340110 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 340110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 340117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340137 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340169 */     // GIR_Coverage, 4410,
     /* 340169 */     GIR_EraseRootFromParent_Done,
     /* 340170 */   // Label 6987: @340170
     /* 340170 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(340275), // Rule ID 4412 //
     /* 340175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340191 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340198 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 340215 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 340215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 340222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340242 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340274 */     // GIR_Coverage, 4412,
     /* 340274 */     GIR_EraseRootFromParent_Done,
     /* 340275 */   // Label 6988: @340275
     /* 340275 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(340379), // Rule ID 4294 //
     /* 340280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340300 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340307 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 340324 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 340324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 340331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340378 */     // GIR_Coverage, 4294,
     /* 340378 */     GIR_EraseRootFromParent_Done,
     /* 340379 */   // Label 6989: @340379
     /* 340379 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(340483), // Rule ID 4295 //
     /* 340384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 340428 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 340428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 340435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340482 */     // GIR_Coverage, 4295,
     /* 340482 */     GIR_EraseRootFromParent_Done,
     /* 340483 */   // Label 6990: @340483
     /* 340483 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(340587), // Rule ID 4402 //
     /* 340488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340508 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340515 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 340532 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 340532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 340539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340554 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340586 */     // GIR_Coverage, 4402,
     /* 340586 */     GIR_EraseRootFromParent_Done,
     /* 340587 */   // Label 6991: @340587
     /* 340587 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(340691), // Rule ID 4403 //
     /* 340592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340596 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340602 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340612 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340619 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 340636 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 340636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 340643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340658 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340690 */     // GIR_Coverage, 4403,
     /* 340690 */     GIR_EraseRootFromParent_Done,
     /* 340691 */   // Label 6992: @340691
     /* 340691 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(340791), // Rule ID 4298 //
     /* 340696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340712 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340719 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 340736 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 340736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 340743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340790 */     // GIR_Coverage, 4298,
     /* 340790 */     GIR_EraseRootFromParent_Done,
     /* 340791 */   // Label 6993: @340791
     /* 340791 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(340891), // Rule ID 4300 //
     /* 340796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340812 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340819 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 340836 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 340836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 340843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340858 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340890 */     // GIR_Coverage, 4300,
     /* 340890 */     GIR_EraseRootFromParent_Done,
     /* 340891 */   // Label 6994: @340891
     /* 340891 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340991), // Rule ID 4406 //
     /* 340896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340912 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340919 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 340936 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 340936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 340943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340958 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340990 */     // GIR_Coverage, 4406,
     /* 340990 */     GIR_EraseRootFromParent_Done,
     /* 340991 */   // Label 6995: @340991
     /* 340991 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(341091), // Rule ID 4408 //
     /* 340996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341012 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341019 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 341036 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 341036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 341039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 341043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341058 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341090 */     // GIR_Coverage, 4408,
     /* 341090 */     GIR_EraseRootFromParent_Done,
     /* 341091 */   // Label 6996: @341091
     /* 341091 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(341204), // Rule ID 5732 //
     /* 341096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 341120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341133 */     // MIs[3] Operand 1
     /* 341133 */     // No operand predicates
     /* 341133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341139 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 341139 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341142 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 341146 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 341155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 341158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 341163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 341185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341203 */     // GIR_Coverage, 5732,
     /* 341203 */     GIR_EraseRootFromParent_Done,
     /* 341204 */   // Label 6997: @341204
     /* 341204 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(341317), // Rule ID 5764 //
     /* 341209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 341233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341246 */     // MIs[3] Operand 1
     /* 341246 */     // No operand predicates
     /* 341246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341252 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 341252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 341255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 341259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 341268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 341271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 341276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 341298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 341301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341316 */     // GIR_Coverage, 5764,
     /* 341316 */     GIR_EraseRootFromParent_Done,
     /* 341317 */   // Label 6998: @341317
     /* 341317 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(341395), // Rule ID 1941 //
     /* 341322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341362 */     // MIs[2] Operand 1
     /* 341362 */     // No operand predicates
     /* 341362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341374 */     // MIs[3] Operand 1
     /* 341374 */     // No operand predicates
     /* 341374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341376 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 341376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 341386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 341393 */     GIR_RootConstrainSelectedInstOperands,
     /* 341394 */     // GIR_Coverage, 1941,
     /* 341394 */     GIR_EraseRootFromParent_Done,
     /* 341395 */   // Label 6999: @341395
     /* 341395 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(341486), // Rule ID 7398 //
     /* 341400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 341403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 341415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 341423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341427 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 341430 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 341437 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 341440 */     // MIs[2] Rn
     /* 341440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 341444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 341449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341461 */     // MIs[3] Operand 1
     /* 341461 */     // No operand predicates
     /* 341461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341463 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15839>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 341463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 341466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 341473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 341477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 341484 */     GIR_RootConstrainSelectedInstOperands,
     /* 341485 */     // GIR_Coverage, 7398,
     /* 341485 */     GIR_EraseRootFromParent_Done,
     /* 341486 */   // Label 7000: @341486
     /* 341486 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(341575), // Rule ID 5729 //
     /* 341491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 341503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341519 */     // MIs[2] Operand 1
     /* 341519 */     // No operand predicates
     /* 341519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341527 */     // MIs[3] Operand 1
     /* 341527 */     // No operand predicates
     /* 341527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341529 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 341529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 341532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341541 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 341547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 341557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341573 */     GIR_RootConstrainSelectedInstOperands,
     /* 341574 */     // GIR_Coverage, 5729,
     /* 341574 */     GIR_EraseRootFromParent_Done,
     /* 341575 */   // Label 7001: @341575
     /* 341575 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(341664), // Rule ID 5761 //
     /* 341580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 341592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341604 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341608 */     // MIs[2] Operand 1
     /* 341608 */     // No operand predicates
     /* 341608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341616 */     // MIs[3] Operand 1
     /* 341616 */     // No operand predicates
     /* 341616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341618 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 341618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 341621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341630 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 341636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 341646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341662 */     GIR_RootConstrainSelectedInstOperands,
     /* 341663 */     // GIR_Coverage, 5761,
     /* 341663 */     GIR_EraseRootFromParent_Done,
     /* 341664 */   // Label 7002: @341664
     /* 341664 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(341731), // Rule ID 5731 //
     /* 341669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341702 */     // MIs[2] Operand 1
     /* 341702 */     // No operand predicates
     /* 341702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341710 */     // MIs[3] Operand 1
     /* 341710 */     // No operand predicates
     /* 341710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341712 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 341712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341729 */     GIR_RootConstrainSelectedInstOperands,
     /* 341730 */     // GIR_Coverage, 5731,
     /* 341730 */     GIR_EraseRootFromParent_Done,
     /* 341731 */   // Label 7003: @341731
     /* 341731 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(341829), // Rule ID 5733 //
     /* 341736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341769 */     // MIs[2] Operand 1
     /* 341769 */     // No operand predicates
     /* 341769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341777 */     // MIs[3] Operand 1
     /* 341777 */     // No operand predicates
     /* 341777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341779 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 341779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 341782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 341794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341827 */     GIR_RootConstrainSelectedInstOperands,
     /* 341828 */     // GIR_Coverage, 5733,
     /* 341828 */     GIR_EraseRootFromParent_Done,
     /* 341829 */   // Label 7004: @341829
     /* 341829 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(341896), // Rule ID 5763 //
     /* 341834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341867 */     // MIs[2] Operand 1
     /* 341867 */     // No operand predicates
     /* 341867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341875 */     // MIs[3] Operand 1
     /* 341875 */     // No operand predicates
     /* 341875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341877 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 341877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341894 */     GIR_RootConstrainSelectedInstOperands,
     /* 341895 */     // GIR_Coverage, 5763,
     /* 341895 */     GIR_EraseRootFromParent_Done,
     /* 341896 */   // Label 7005: @341896
     /* 341896 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(341994), // Rule ID 5765 //
     /* 341901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341934 */     // MIs[2] Operand 1
     /* 341934 */     // No operand predicates
     /* 341934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341942 */     // MIs[3] Operand 1
     /* 341942 */     // No operand predicates
     /* 341942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341944 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 341944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 341947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 341959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341992 */     GIR_RootConstrainSelectedInstOperands,
     /* 341993 */     // GIR_Coverage, 5765,
     /* 341993 */     GIR_EraseRootFromParent_Done,
     /* 341994 */   // Label 7006: @341994
     /* 341994 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(342060), // Rule ID 5681 //
     /* 341999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342017 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 342017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342059 */     // GIR_Coverage, 5681,
     /* 342059 */     GIR_EraseRootFromParent_Done,
     /* 342060 */   // Label 7007: @342060
     /* 342060 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(342126), // Rule ID 5691 //
     /* 342065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342083 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 342083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342125 */     // GIR_Coverage, 5691,
     /* 342125 */     GIR_EraseRootFromParent_Done,
     /* 342126 */   // Label 7008: @342126
     /* 342126 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(342204), // Rule ID 7397 //
     /* 342131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 342134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342146 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 342149 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 342156 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 342159 */     // MIs[1] Rn
     /* 342159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342176 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342180 */     // MIs[2] Operand 1
     /* 342180 */     // No operand predicates
     /* 342180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342182 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15839>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 342185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342202 */     GIR_RootConstrainSelectedInstOperands,
     /* 342203 */     // GIR_Coverage, 7397,
     /* 342203 */     GIR_EraseRootFromParent_Done,
     /* 342204 */   // Label 7009: @342204
     /* 342204 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(342273), // Rule ID 6431 //
     /* 342209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342221 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342228 */     // MIs[1] Rn
     /* 342228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342249 */     // MIs[2] Operand 1
     /* 342249 */     // No operand predicates
     /* 342249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342251 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 342254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342271 */     GIR_RootConstrainSelectedInstOperands,
     /* 342272 */     // GIR_Coverage, 6431,
     /* 342272 */     GIR_EraseRootFromParent_Done,
     /* 342273 */   // Label 7010: @342273
     /* 342273 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(342342), // Rule ID 6432 //
     /* 342278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342297 */     // MIs[1] Rn
     /* 342297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342314 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342318 */     // MIs[2] Operand 1
     /* 342318 */     // No operand predicates
     /* 342318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342320 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 342323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342340 */     GIR_RootConstrainSelectedInstOperands,
     /* 342341 */     // GIR_Coverage, 6432,
     /* 342341 */     GIR_EraseRootFromParent_Done,
     /* 342342 */   // Label 7011: @342342
     /* 342342 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(342391), // Rule ID 5698 //
     /* 342347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 342355 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 342359 */     // MIs[1] Operand 1
     /* 342359 */     // No operand predicates
     /* 342359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342371 */     // MIs[2] Operand 1
     /* 342371 */     // No operand predicates
     /* 342371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342373 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 342373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 342376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 342383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 342389 */     GIR_RootConstrainSelectedInstOperands,
     /* 342390 */     // GIR_Coverage, 5698,
     /* 342390 */     GIR_EraseRootFromParent_Done,
     /* 342391 */   // Label 7012: @342391
     /* 342391 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(342492), // Rule ID 5770 //
     /* 342396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 342404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342421 */     // MIs[2] Operand 1
     /* 342421 */     // No operand predicates
     /* 342421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342423 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342449 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 342456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 342477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342479 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 342484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342490 */     GIR_RootConstrainSelectedInstOperands,
     /* 342491 */     // GIR_Coverage, 5770,
     /* 342491 */     GIR_EraseRootFromParent_Done,
     /* 342492 */   // Label 7013: @342492
     /* 342492 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(342536), // Rule ID 1937 //
     /* 342497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342520 */     // MIs[1] Operand 1
     /* 342520 */     // No operand predicates
     /* 342520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342522 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 342522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 342525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 342532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342534 */     GIR_RootConstrainSelectedInstOperands,
     /* 342535 */     // GIR_Coverage, 1937,
     /* 342535 */     GIR_EraseRootFromParent_Done,
     /* 342536 */   // Label 7014: @342536
     /* 342536 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(342632), // Rule ID 5702 //
     /* 342541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 342561 */     // MIs[1] Operand 1
     /* 342561 */     // No operand predicates
     /* 342561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342563 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 342566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 342580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 342596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 342617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 342624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342630 */     GIR_RootConstrainSelectedInstOperands,
     /* 342631 */     // GIR_Coverage, 5702,
     /* 342631 */     GIR_EraseRootFromParent_Done,
     /* 342632 */   // Label 7015: @342632
     /* 342632 */   GIM_Reject,
     /* 342633 */ // Label 6980: @342633
     /* 342633 */ GIM_Reject,
     /* 342634 */ // Label 6928: @342634
     /* 342634 */ GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(346273),
     /* 342639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342642 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(342768), // Rule ID 4236 //
     /* 342647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342677 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342680 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342684 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342691 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 342708 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 342708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 342715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342767 */     // GIR_Coverage, 4236,
     /* 342767 */     GIR_EraseRootFromParent_Done,
     /* 342768 */   // Label 7017: @342768
     /* 342768 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(342894), // Rule ID 4237 //
     /* 342773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342793 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 342834 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 342834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 342841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342861 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342893 */     // GIR_Coverage, 4237,
     /* 342893 */     GIR_EraseRootFromParent_Done,
     /* 342894 */   // Label 7018: @342894
     /* 342894 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(343013), // Rule ID 4344 //
     /* 342899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 342953 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 342953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 342960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343012 */     // GIR_Coverage, 4344,
     /* 343012 */     GIR_EraseRootFromParent_Done,
     /* 343013 */   // Label 7019: @343013
     /* 343013 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(343132), // Rule ID 4345 //
     /* 343018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343032 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343038 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 343072 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 343072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 343079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343131 */     // GIR_Coverage, 4345,
     /* 343131 */     GIR_EraseRootFromParent_Done,
     /* 343132 */   // Label 7020: @343132
     /* 343132 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(343254), // Rule ID 4242 //
     /* 343137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343163 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343166 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343170 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343177 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 343194 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 343194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 343201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343221 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343253 */     // GIR_Coverage, 4242,
     /* 343253 */     GIR_EraseRootFromParent_Done,
     /* 343254 */   // Label 7021: @343254
     /* 343254 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(343376), // Rule ID 4244 //
     /* 343259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343285 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343288 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343292 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343299 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 343316 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 343316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 343323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343375 */     // GIR_Coverage, 4244,
     /* 343375 */     GIR_EraseRootFromParent_Done,
     /* 343376 */   // Label 7022: @343376
     /* 343376 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(343491), // Rule ID 4350 //
     /* 343381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343407 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343414 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 343431 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 343431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 343438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343458 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343490 */     // GIR_Coverage, 4350,
     /* 343490 */     GIR_EraseRootFromParent_Done,
     /* 343491 */   // Label 7023: @343491
     /* 343491 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(343606), // Rule ID 4352 //
     /* 343496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343529 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 343546 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 343546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 343553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343605 */     // GIR_Coverage, 4352,
     /* 343605 */     GIR_EraseRootFromParent_Done,
     /* 343606 */   // Label 7024: @343606
     /* 343606 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(343727), // Rule ID 4234 //
     /* 343611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343644 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343648 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343655 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 343672 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 343672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 343679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343726 */     // GIR_Coverage, 4234,
     /* 343726 */     GIR_EraseRootFromParent_Done,
     /* 343727 */   // Label 7025: @343727
     /* 343727 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(343848), // Rule ID 4235 //
     /* 343732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343746 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343752 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343762 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343765 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343769 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 343793 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 343793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 343800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343815 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343847 */     // GIR_Coverage, 4235,
     /* 343847 */     GIR_EraseRootFromParent_Done,
     /* 343848 */   // Label 7026: @343848
     /* 343848 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(343962), // Rule ID 4342 //
     /* 343853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343883 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343890 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 343907 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 343907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 343914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343929 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343961 */     // GIR_Coverage, 4342,
     /* 343961 */     GIR_EraseRootFromParent_Done,
     /* 343962 */   // Label 7027: @343962
     /* 343962 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(344076), // Rule ID 4343 //
     /* 343967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343981 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343987 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343997 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344004 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 344021 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 344021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 344028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344043 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344075 */     // GIR_Coverage, 4343,
     /* 344075 */     GIR_EraseRootFromParent_Done,
     /* 344076 */   // Label 7028: @344076
     /* 344076 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(344193), // Rule ID 4238 //
     /* 344081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344110 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344114 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 344138 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 344138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 344145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344192 */     // GIR_Coverage, 4238,
     /* 344192 */     GIR_EraseRootFromParent_Done,
     /* 344193 */   // Label 7029: @344193
     /* 344193 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(344310), // Rule ID 4240 //
     /* 344198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344224 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344227 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344231 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344238 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 344255 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 344255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 344262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344277 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344309 */     // GIR_Coverage, 4240,
     /* 344309 */     GIR_EraseRootFromParent_Done,
     /* 344310 */   // Label 7030: @344310
     /* 344310 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(344420), // Rule ID 4346 //
     /* 344315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344348 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 344365 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 344365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 344372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344387 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344419 */     // GIR_Coverage, 4346,
     /* 344419 */     GIR_EraseRootFromParent_Done,
     /* 344420 */   // Label 7031: @344420
     /* 344420 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(344530), // Rule ID 4348 //
     /* 344425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344451 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344458 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 344475 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 344475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 344482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344497 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344529 */     // GIR_Coverage, 4348,
     /* 344529 */     GIR_EraseRootFromParent_Done,
     /* 344530 */   // Label 7032: @344530
     /* 344530 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(344660), // Rule ID 6444 //
     /* 344535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344564 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344567 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344571 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344578 */     // MIs[2] Rn
     /* 344578 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 344582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 344587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344593 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 344593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 344596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 344614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 344629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344642 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344659 */     // GIR_Coverage, 6444,
     /* 344659 */     GIR_EraseRootFromParent_Done,
     /* 344660 */   // Label 7033: @344660
     /* 344660 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(344800), // Rule ID 5718 //
     /* 344665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344708 */     // MIs[2] Operand 1
     /* 344708 */     // No operand predicates
     /* 344708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344716 */     // MIs[3] Operand 1
     /* 344716 */     // No operand predicates
     /* 344716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344718 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 344718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344730 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 344737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 344757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 344768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 344775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344782 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344799 */     // GIR_Coverage, 5718,
     /* 344799 */     GIR_EraseRootFromParent_Done,
     /* 344800 */   // Label 7034: @344800
     /* 344800 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(344971), // Rule ID 5719 //
     /* 344805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344848 */     // MIs[2] Operand 1
     /* 344848 */     // No operand predicates
     /* 344848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344856 */     // MIs[3] Operand 1
     /* 344856 */     // No operand predicates
     /* 344856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344858 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 344858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 344861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344870 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344873 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344877 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 344880 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344885 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344890 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344893 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344897 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344902 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344905 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 344909 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344912 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344917 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 344929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344934 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 344940 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 344946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344970 */     // GIR_Coverage, 5719,
     /* 344970 */     GIR_EraseRootFromParent_Done,
     /* 344971 */   // Label 7035: @344971
     /* 344971 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(345111), // Rule ID 5750 //
     /* 344976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345019 */     // MIs[2] Operand 1
     /* 345019 */     // No operand predicates
     /* 345019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345027 */     // MIs[3] Operand 1
     /* 345027 */     // No operand predicates
     /* 345027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345029 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 345029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 345032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 345044 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 345048 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 345051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 345068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 345079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 345086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 345100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345110 */     // GIR_Coverage, 5750,
     /* 345110 */     GIR_EraseRootFromParent_Done,
     /* 345111 */   // Label 7036: @345111
     /* 345111 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(345282), // Rule ID 5751 //
     /* 345116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 345138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 345146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 345155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345159 */     // MIs[2] Operand 1
     /* 345159 */     // No operand predicates
     /* 345159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 345163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345167 */     // MIs[3] Operand 1
     /* 345167 */     // No operand predicates
     /* 345167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345169 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 345169 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 345172 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345176 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345181 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 345184 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345188 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 345191 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 345204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345213 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 345216 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 345220 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 345223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 345240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 345251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 345254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 345257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 345271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345281 */     // GIR_Coverage, 5751,
     /* 345281 */     GIR_EraseRootFromParent_Done,
     /* 345282 */   // Label 7037: @345282
     /* 345282 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(345361), // Rule ID 5671 //
     /* 345287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345315 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 345315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 345331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345360 */     // GIR_Coverage, 5671,
     /* 345360 */     GIR_EraseRootFromParent_Done,
     /* 345361 */   // Label 7038: @345361
     /* 345361 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(345437), // Rule ID 5673 //
     /* 345366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345394 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 345394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 345397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 345401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 345411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 345418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345436 */     // GIR_Coverage, 5673,
     /* 345436 */     GIR_EraseRootFromParent_Done,
     /* 345437 */   // Label 7039: @345437
     /* 345437 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(345513), // Rule ID 5683 //
     /* 345442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345470 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 345470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 345473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 345477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 345487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 345494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345512 */     // GIR_Coverage, 5683,
     /* 345512 */     GIR_EraseRootFromParent_Done,
     /* 345513 */   // Label 7040: @345513
     /* 345513 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(345658), // Rule ID 5695 //
     /* 345518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 345540 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 345544 */     // MIs[1] Operand 1
     /* 345544 */     // No operand predicates
     /* 345544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 345548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 345556 */     // MIs[2] Operand 1
     /* 345556 */     // No operand predicates
     /* 345556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345558 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 345558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 345561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 345565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 345572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 345575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 345579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 345587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 345591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 345594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 345616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 345627 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 345633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345640 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 345647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345657 */     // GIR_Coverage, 5695,
     /* 345657 */     GIR_EraseRootFromParent_Done,
     /* 345658 */   // Label 7041: @345658
     /* 345658 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(345807), // Rule ID 6447 //
     /* 345663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345688 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 345692 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345699 */     // MIs[1] Rn
     /* 345699 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 345703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 345708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 345712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345716 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 345720 */     // MIs[2] Operand 1
     /* 345720 */     // No operand predicates
     /* 345720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345722 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 345722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 345725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345734 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 345737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 345741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 345744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 345761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 345772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345776 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 345796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345806 */     // GIR_Coverage, 6447,
     /* 345806 */     GIR_EraseRootFromParent_Done,
     /* 345807 */   // Label 7042: @345807
     /* 345807 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(345949), // Rule ID 6450 //
     /* 345812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 345841 */     // MIs[1] Rn
     /* 345841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 345845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 345850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 345854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345858 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 345862 */     // MIs[2] Operand 1
     /* 345862 */     // No operand predicates
     /* 345862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345864 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 345864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 345867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345876 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 345879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 345883 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 345886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 345899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 345903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 345911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 345914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345918 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 345929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345931 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 345938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345948 */     // GIR_Coverage, 6450,
     /* 345948 */     GIR_EraseRootFromParent_Done,
     /* 345949 */   // Label 7043: @345949
     /* 345949 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(346137), // Rule ID 5693 //
     /* 345954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 345976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 345984 */     // MIs[1] Operand 1
     /* 345984 */     // No operand predicates
     /* 345984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345986 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 345986 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 345989 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 345993 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 346000 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 346003 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346007 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346012 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346015 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 346019 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 346022 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346027 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346032 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346037 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 346040 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346044 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 346054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346063 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 346066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346070 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 346106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346119 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346136 */     // GIR_Coverage, 5693,
     /* 346136 */     GIR_EraseRootFromParent_Done,
     /* 346137 */   // Label 7044: @346137
     /* 346137 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(346272), // Rule ID 5704 //
     /* 346142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 346164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 346172 */     // MIs[1] Operand 1
     /* 346172 */     // No operand predicates
     /* 346172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346174 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 346174 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 346177 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346181 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 346191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346200 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 346203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 346207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 346210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 346232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 346243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 346247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346254 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 346261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346271 */     // GIR_Coverage, 5704,
     /* 346271 */     GIR_EraseRootFromParent_Done,
     /* 346272 */   // Label 7045: @346272
     /* 346272 */   GIM_Reject,
     /* 346273 */ // Label 7016: @346273
     /* 346273 */ GIM_Reject,
     /* 346274 */ // Label 6929: @346274
     /* 346274 */ GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(349341),
     /* 346279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346292 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(346401), // Rule ID 4260 //
     /* 346297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346301 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346324 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 346341 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 346348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346368 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346400 */     // GIR_Coverage, 4260,
     /* 346400 */     GIR_EraseRootFromParent_Done,
     /* 346401 */   // Label 7047: @346401
     /* 346401 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(346510), // Rule ID 4261 //
     /* 346406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346410 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346416 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346426 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346433 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 346450 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 346457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346477 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346509 */     // GIR_Coverage, 4261,
     /* 346509 */     GIR_EraseRootFromParent_Done,
     /* 346510 */   // Label 7048: @346510
     /* 346510 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(346619), // Rule ID 4368 //
     /* 346515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346519 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346525 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346535 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346542 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 346559 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 346566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346586 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346618 */     // GIR_Coverage, 4368,
     /* 346618 */     GIR_EraseRootFromParent_Done,
     /* 346619 */   // Label 7049: @346619
     /* 346619 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(346728), // Rule ID 4369 //
     /* 346624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346628 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346634 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346644 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346651 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 346668 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 346675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346695 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346727 */     // GIR_Coverage, 4369,
     /* 346727 */     GIR_EraseRootFromParent_Done,
     /* 346728 */   // Label 7050: @346728
     /* 346728 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(346833), // Rule ID 4266 //
     /* 346733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346749 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346752 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346756 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 346773 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 346780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346800 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346832 */     // GIR_Coverage, 4266,
     /* 346832 */     GIR_EraseRootFromParent_Done,
     /* 346833 */   // Label 7051: @346833
     /* 346833 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(346938), // Rule ID 4268 //
     /* 346838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346854 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346861 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 346878 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 346885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346905 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346937 */     // GIR_Coverage, 4268,
     /* 346937 */     GIR_EraseRootFromParent_Done,
     /* 346938 */   // Label 7052: @346938
     /* 346938 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(347043), // Rule ID 4374 //
     /* 346943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346959 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 346983 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 346983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 346990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347042 */     // GIR_Coverage, 4374,
     /* 347042 */     GIR_EraseRootFromParent_Done,
     /* 347043 */   // Label 7053: @347043
     /* 347043 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(347148), // Rule ID 4376 //
     /* 347048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 347088 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 347088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 347095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347147 */     // GIR_Coverage, 4376,
     /* 347147 */     GIR_EraseRootFromParent_Done,
     /* 347148 */   // Label 7054: @347148
     /* 347148 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(347252), // Rule ID 4258 //
     /* 347153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347157 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347163 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347180 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 347197 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 347197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 347204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347219 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347251 */     // GIR_Coverage, 4258,
     /* 347251 */     GIR_EraseRootFromParent_Done,
     /* 347252 */   // Label 7055: @347252
     /* 347252 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(347356), // Rule ID 4259 //
     /* 347257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347261 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347267 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347277 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347284 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 347301 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 347301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 347308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347323 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347355 */     // GIR_Coverage, 4259,
     /* 347355 */     GIR_EraseRootFromParent_Done,
     /* 347356 */   // Label 7056: @347356
     /* 347356 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(347460), // Rule ID 4366 //
     /* 347361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347365 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347371 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347381 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347388 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 347405 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 347405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 347412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347459 */     // GIR_Coverage, 4366,
     /* 347459 */     GIR_EraseRootFromParent_Done,
     /* 347460 */   // Label 7057: @347460
     /* 347460 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(347564), // Rule ID 4367 //
     /* 347465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347469 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347475 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347485 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347492 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 347509 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 347509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 347516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347531 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347563 */     // GIR_Coverage, 4367,
     /* 347563 */     GIR_EraseRootFromParent_Done,
     /* 347564 */   // Label 7058: @347564
     /* 347564 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(347664), // Rule ID 4262 //
     /* 347569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347585 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347592 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 347609 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 347609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 347616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347631 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347663 */     // GIR_Coverage, 4262,
     /* 347663 */     GIR_EraseRootFromParent_Done,
     /* 347664 */   // Label 7059: @347664
     /* 347664 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(347764), // Rule ID 4264 //
     /* 347669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347685 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347692 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 347709 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 347709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 347716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347763 */     // GIR_Coverage, 4264,
     /* 347763 */     GIR_EraseRootFromParent_Done,
     /* 347764 */   // Label 7060: @347764
     /* 347764 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(347864), // Rule ID 4370 //
     /* 347769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347785 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347792 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 347809 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 347809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 347816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347863 */     // GIR_Coverage, 4370,
     /* 347863 */     GIR_EraseRootFromParent_Done,
     /* 347864 */   // Label 7061: @347864
     /* 347864 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(347964), // Rule ID 4372 //
     /* 347869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 347909 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 347909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 347916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347931 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347963 */     // GIR_Coverage, 4372,
     /* 347963 */     GIR_EraseRootFromParent_Done,
     /* 347964 */   // Label 7062: @347964
     /* 347964 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(348077), // Rule ID 5724 //
     /* 347969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 347993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348006 */     // MIs[3] Operand 1
     /* 348006 */     // No operand predicates
     /* 348006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348012 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 348012 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 348015 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 348019 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348024 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 348028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 348031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 348058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348076 */     // GIR_Coverage, 5724,
     /* 348076 */     GIR_EraseRootFromParent_Done,
     /* 348077 */   // Label 7063: @348077
     /* 348077 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(348190), // Rule ID 5756 //
     /* 348082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 348106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348119 */     // MIs[3] Operand 1
     /* 348119 */     // No operand predicates
     /* 348119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348125 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 348125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 348128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 348132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348137 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 348141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 348144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 348171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348189 */     // GIR_Coverage, 5756,
     /* 348189 */     GIR_EraseRootFromParent_Done,
     /* 348190 */   // Label 7064: @348190
     /* 348190 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(348268), // Rule ID 1940 //
     /* 348195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348231 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 348235 */     // MIs[2] Operand 1
     /* 348235 */     // No operand predicates
     /* 348235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 348247 */     // MIs[3] Operand 1
     /* 348247 */     // No operand predicates
     /* 348247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348249 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 348249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 348256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 348259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 348266 */     GIR_RootConstrainSelectedInstOperands,
     /* 348267 */     // GIR_Coverage, 1940,
     /* 348267 */     GIR_EraseRootFromParent_Done,
     /* 348268 */   // Label 7065: @348268
     /* 348268 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(348357), // Rule ID 5721 //
     /* 348273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 348285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 348301 */     // MIs[2] Operand 1
     /* 348301 */     // No operand predicates
     /* 348301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348309 */     // MIs[3] Operand 1
     /* 348309 */     // No operand predicates
     /* 348309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348311 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 348311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 348329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348355 */     GIR_RootConstrainSelectedInstOperands,
     /* 348356 */     // GIR_Coverage, 5721,
     /* 348356 */     GIR_EraseRootFromParent_Done,
     /* 348357 */   // Label 7066: @348357
     /* 348357 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(348446), // Rule ID 5753 //
     /* 348362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 348374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348386 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 348390 */     // MIs[2] Operand 1
     /* 348390 */     // No operand predicates
     /* 348390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348398 */     // MIs[3] Operand 1
     /* 348398 */     // No operand predicates
     /* 348398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348400 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 348400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348412 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 348418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348444 */     GIR_RootConstrainSelectedInstOperands,
     /* 348445 */     // GIR_Coverage, 5753,
     /* 348445 */     GIR_EraseRootFromParent_Done,
     /* 348446 */   // Label 7067: @348446
     /* 348446 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(348513), // Rule ID 5723 //
     /* 348451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348484 */     // MIs[2] Operand 1
     /* 348484 */     // No operand predicates
     /* 348484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348492 */     // MIs[3] Operand 1
     /* 348492 */     // No operand predicates
     /* 348492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348494 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 348494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 348501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348511 */     GIR_RootConstrainSelectedInstOperands,
     /* 348512 */     // GIR_Coverage, 5723,
     /* 348512 */     GIR_EraseRootFromParent_Done,
     /* 348513 */   // Label 7068: @348513
     /* 348513 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(348611), // Rule ID 5725 //
     /* 348518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348551 */     // MIs[2] Operand 1
     /* 348551 */     // No operand predicates
     /* 348551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348559 */     // MIs[3] Operand 1
     /* 348559 */     // No operand predicates
     /* 348559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348561 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 348561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 348576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 348583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 348600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348609 */     GIR_RootConstrainSelectedInstOperands,
     /* 348610 */     // GIR_Coverage, 5725,
     /* 348610 */     GIR_EraseRootFromParent_Done,
     /* 348611 */   // Label 7069: @348611
     /* 348611 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(348678), // Rule ID 5755 //
     /* 348616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348649 */     // MIs[2] Operand 1
     /* 348649 */     // No operand predicates
     /* 348649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348657 */     // MIs[3] Operand 1
     /* 348657 */     // No operand predicates
     /* 348657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348659 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 348659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 348666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348676 */     GIR_RootConstrainSelectedInstOperands,
     /* 348677 */     // GIR_Coverage, 5755,
     /* 348677 */     GIR_EraseRootFromParent_Done,
     /* 348678 */   // Label 7070: @348678
     /* 348678 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(348776), // Rule ID 5757 //
     /* 348683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348716 */     // MIs[2] Operand 1
     /* 348716 */     // No operand predicates
     /* 348716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348724 */     // MIs[3] Operand 1
     /* 348724 */     // No operand predicates
     /* 348724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348726 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 348726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 348741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348745 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 348748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 348761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 348765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 348768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 348774 */     GIR_RootConstrainSelectedInstOperands,
     /* 348775 */     // GIR_Coverage, 5757,
     /* 348775 */     GIR_EraseRootFromParent_Done,
     /* 348776 */   // Label 7071: @348776
     /* 348776 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(348842), // Rule ID 5679 //
     /* 348781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348799 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 348799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 348823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348841 */     // GIR_Coverage, 5679,
     /* 348841 */     GIR_EraseRootFromParent_Done,
     /* 348842 */   // Label 7072: @348842
     /* 348842 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(348908), // Rule ID 5687 //
     /* 348847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348865 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 348865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 348868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 348889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348907 */     // GIR_Coverage, 5687,
     /* 348907 */     GIR_EraseRootFromParent_Done,
     /* 348908 */   // Label 7073: @348908
     /* 348908 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(348961), // Rule ID 5696 //
     /* 348913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 348925 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 348929 */     // MIs[1] Operand 1
     /* 348929 */     // No operand predicates
     /* 348929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 348941 */     // MIs[2] Operand 1
     /* 348941 */     // No operand predicates
     /* 348941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348943 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 348943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 348946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 348950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 348953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 348959 */     GIR_RootConstrainSelectedInstOperands,
     /* 348960 */     // GIR_Coverage, 5696,
     /* 348960 */     GIR_EraseRootFromParent_Done,
     /* 348961 */   // Label 7074: @348961
     /* 348961 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(349030), // Rule ID 6429 //
     /* 348966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 348985 */     // MIs[1] Rn
     /* 348985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 348989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 348994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349006 */     // MIs[2] Operand 1
     /* 349006 */     // No operand predicates
     /* 349006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349008 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 349008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 349011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 349018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349028 */     GIR_RootConstrainSelectedInstOperands,
     /* 349029 */     // GIR_Coverage, 6429,
     /* 349029 */     GIR_EraseRootFromParent_Done,
     /* 349030 */   // Label 7075: @349030
     /* 349030 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(349099), // Rule ID 6430 //
     /* 349035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 349054 */     // MIs[1] Rn
     /* 349054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 349058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 349063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 349067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349075 */     // MIs[2] Operand 1
     /* 349075 */     // No operand predicates
     /* 349075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349077 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 349077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 349080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 349087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349097 */     GIR_RootConstrainSelectedInstOperands,
     /* 349098 */     // GIR_Coverage, 6430,
     /* 349098 */     GIR_EraseRootFromParent_Done,
     /* 349099 */   // Label 7076: @349099
     /* 349099 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(349200), // Rule ID 5768 //
     /* 349104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 349112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 349116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 349125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349129 */     // MIs[2] Operand 1
     /* 349129 */     // No operand predicates
     /* 349129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349131 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 349131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 349134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 349164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 349167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 349189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 349192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349198 */     GIR_RootConstrainSelectedInstOperands,
     /* 349199 */     // GIR_Coverage, 5768,
     /* 349199 */     GIR_EraseRootFromParent_Done,
     /* 349200 */   // Label 7077: @349200
     /* 349200 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(349244), // Rule ID 1936 //
     /* 349205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349228 */     // MIs[1] Operand 1
     /* 349228 */     // No operand predicates
     /* 349228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349230 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 349230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 349233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 349240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 349242 */     GIR_RootConstrainSelectedInstOperands,
     /* 349243 */     // GIR_Coverage, 1936,
     /* 349243 */     GIR_EraseRootFromParent_Done,
     /* 349244 */   // Label 7078: @349244
     /* 349244 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(349340), // Rule ID 5701 //
     /* 349249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 349269 */     // MIs[1] Operand 1
     /* 349269 */     // No operand predicates
     /* 349269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349271 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 349271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 349274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 349288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 349304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 349307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 349325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 349332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349338 */     GIR_RootConstrainSelectedInstOperands,
     /* 349339 */     // GIR_Coverage, 5701,
     /* 349339 */     GIR_EraseRootFromParent_Done,
     /* 349340 */   // Label 7079: @349340
     /* 349340 */   GIM_Reject,
     /* 349341 */ // Label 7046: @349341
     /* 349341 */ GIM_Reject,
     /* 349342 */ // Label 6930: @349342
     /* 349342 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351185),
     /* 349347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349350 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(349476), // Rule ID 4200 //
     /* 349355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349385 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349388 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349392 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349399 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349416 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349443 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349475 */     // GIR_Coverage, 4200,
     /* 349475 */     GIR_EraseRootFromParent_Done,
     /* 349476 */   // Label 7081: @349476
     /* 349476 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(349602), // Rule ID 4201 //
     /* 349481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349501 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349511 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349514 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349518 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349525 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349542 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349601 */     // GIR_Coverage, 4201,
     /* 349601 */     GIR_EraseRootFromParent_Done,
     /* 349602 */   // Label 7082: @349602
     /* 349602 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(349724), // Rule ID 4206 //
     /* 349607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349633 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349636 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349640 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349647 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349664 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349691 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349723 */     // GIR_Coverage, 4206,
     /* 349723 */     GIR_EraseRootFromParent_Done,
     /* 349724 */   // Label 7083: @349724
     /* 349724 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(349846), // Rule ID 4208 //
     /* 349729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349758 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349762 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349769 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349786 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349813 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349845 */     // GIR_Coverage, 4208,
     /* 349845 */     GIR_EraseRootFromParent_Done,
     /* 349846 */   // Label 7084: @349846
     /* 349846 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(349967), // Rule ID 4198 //
     /* 349851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349865 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349871 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349881 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349884 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349888 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349912 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349966 */     // GIR_Coverage, 4198,
     /* 349966 */     GIR_EraseRootFromParent_Done,
     /* 349967 */   // Label 7085: @349967
     /* 349967 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(350088), // Rule ID 4199 //
     /* 349972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350002 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350005 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350009 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350016 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 350033 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 350033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 350040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350055 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350087 */     // GIR_Coverage, 4199,
     /* 350087 */     GIR_EraseRootFromParent_Done,
     /* 350088 */   // Label 7086: @350088
     /* 350088 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(350205), // Rule ID 4202 //
     /* 350093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350119 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350122 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350126 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350133 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 350150 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 350150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 350157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350172 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350204 */     // GIR_Coverage, 4202,
     /* 350204 */     GIR_EraseRootFromParent_Done,
     /* 350205 */   // Label 7087: @350205
     /* 350205 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(350322), // Rule ID 4204 //
     /* 350210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350236 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350239 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350243 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350250 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 350267 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 350267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 350270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 350274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350289 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 350311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 350321 */     // GIR_Coverage, 4204,
     /* 350321 */     GIR_EraseRootFromParent_Done,
     /* 350322 */   // Label 7088: @350322
     /* 350322 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(350462), // Rule ID 5742 //
     /* 350327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 350353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350370 */     // MIs[2] Operand 1
     /* 350370 */     // No operand predicates
     /* 350370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350378 */     // MIs[3] Operand 1
     /* 350378 */     // No operand predicates
     /* 350378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350380 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 350380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 350383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 350395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 350399 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 350402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 350419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350424 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 350430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 350437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350444 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350461 */     // GIR_Coverage, 5742,
     /* 350461 */     GIR_EraseRootFromParent_Done,
     /* 350462 */   // Label 7089: @350462
     /* 350462 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(350633), // Rule ID 5743 //
     /* 350467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 350493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350510 */     // MIs[2] Operand 1
     /* 350510 */     // No operand predicates
     /* 350510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350518 */     // MIs[3] Operand 1
     /* 350518 */     // No operand predicates
     /* 350518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350520 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 350520 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 350523 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350527 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350532 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 350535 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350539 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 350542 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350547 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 350555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350564 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 350567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 350571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 350574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 350591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 350602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 350605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 350608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350615 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350632 */     // GIR_Coverage, 5743,
     /* 350632 */     GIR_EraseRootFromParent_Done,
     /* 350633 */   // Label 7090: @350633
     /* 350633 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(350712), // Rule ID 5666 //
     /* 350638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350666 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 350666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 350669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 350682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 350701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350711 */     // GIR_Coverage, 5666,
     /* 350711 */     GIR_EraseRootFromParent_Done,
     /* 350712 */   // Label 7091: @350712
     /* 350712 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350861), // Rule ID 6446 //
     /* 350717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350739 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350742 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 350746 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 350753 */     // MIs[1] Rn
     /* 350753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 350757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 350762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 350766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 350774 */     // MIs[2] Operand 1
     /* 350774 */     // No operand predicates
     /* 350774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350776 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 350776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 350779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350788 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 350791 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 350795 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 350798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 350815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350820 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 350826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350830 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350860 */     // GIR_Coverage, 6446,
     /* 350860 */     GIR_EraseRootFromParent_Done,
     /* 350861 */   // Label 7092: @350861
     /* 350861 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(350996), // Rule ID 5705 //
     /* 350866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 350888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 350896 */     // MIs[1] Operand 1
     /* 350896 */     // No operand predicates
     /* 350896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350898 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 350898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 350901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 350905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 350915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 350919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 350931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 350934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 350956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 350967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 350971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350978 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 350985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350995 */     // GIR_Coverage, 5705,
     /* 350995 */     GIR_EraseRootFromParent_Done,
     /* 350996 */   // Label 7093: @350996
     /* 350996 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351184), // Rule ID 5706 //
     /* 351001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 351004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 351023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 351031 */     // MIs[1] Operand 1
     /* 351031 */     // No operand predicates
     /* 351031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351033 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 351033 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 351036 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351040 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 351047 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 351050 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351054 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351059 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 351062 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 351066 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 351069 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351074 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351079 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 351087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 351101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351110 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 351117 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 351120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 351142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 351153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351166 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 351173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351183 */     // GIR_Coverage, 5706,
     /* 351183 */     GIR_EraseRootFromParent_Done,
     /* 351184 */   // Label 7094: @351184
     /* 351184 */   GIM_Reject,
     /* 351185 */ // Label 7080: @351185
     /* 351185 */ GIM_Reject,
     /* 351186 */ // Label 6931: @351186
     /* 351186 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(354604),
     /* 351191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351194 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351320), // Rule ID 4224 //
     /* 351199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351213 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351219 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351229 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351232 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351236 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351243 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 351260 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 351267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351319 */     // GIR_Coverage, 4224,
     /* 351319 */     GIR_EraseRootFromParent_Done,
     /* 351320 */   // Label 7096: @351320
     /* 351320 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(351446), // Rule ID 4225 //
     /* 351325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351355 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351358 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351362 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351369 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 351386 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 351393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351445 */     // GIR_Coverage, 4225,
     /* 351445 */     GIR_EraseRootFromParent_Done,
     /* 351446 */   // Label 7097: @351446
     /* 351446 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(351565), // Rule ID 4332 //
     /* 351451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351465 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351471 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 351505 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 351512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351564 */     // GIR_Coverage, 4332,
     /* 351564 */     GIR_EraseRootFromParent_Done,
     /* 351565 */   // Label 7098: @351565
     /* 351565 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(351684), // Rule ID 4333 //
     /* 351570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351584 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351590 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351600 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351607 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 351624 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 351631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351651 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351683 */     // GIR_Coverage, 4333,
     /* 351683 */     GIR_EraseRootFromParent_Done,
     /* 351684 */   // Label 7099: @351684
     /* 351684 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(351806), // Rule ID 4230 //
     /* 351689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351715 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351718 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351722 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351729 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 351746 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 351753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351773 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351805 */     // GIR_Coverage, 4230,
     /* 351805 */     GIR_EraseRootFromParent_Done,
     /* 351806 */   // Label 7100: @351806
     /* 351806 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(351928), // Rule ID 4232 //
     /* 351811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351837 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351840 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351844 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351851 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 351868 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 351875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351895 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351927 */     // GIR_Coverage, 4232,
     /* 351927 */     GIR_EraseRootFromParent_Done,
     /* 351928 */   // Label 7101: @351928
     /* 351928 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352043), // Rule ID 4338 //
     /* 351933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351959 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 351983 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 351983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 351990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352042 */     // GIR_Coverage, 4338,
     /* 352042 */     GIR_EraseRootFromParent_Done,
     /* 352043 */   // Label 7102: @352043
     /* 352043 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(352158), // Rule ID 4340 //
     /* 352048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352074 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352081 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 352098 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 352098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 352105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352157 */     // GIR_Coverage, 4340,
     /* 352157 */     GIR_EraseRootFromParent_Done,
     /* 352158 */   // Label 7103: @352158
     /* 352158 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352279), // Rule ID 4222 //
     /* 352163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352177 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352193 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352196 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352200 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 352224 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 352224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 352231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352246 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352278 */     // GIR_Coverage, 4222,
     /* 352278 */     GIR_EraseRootFromParent_Done,
     /* 352279 */   // Label 7104: @352279
     /* 352279 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352400), // Rule ID 4223 //
     /* 352284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352298 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352304 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352314 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352317 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352321 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352328 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 352345 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 352345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 352352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352367 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352399 */     // GIR_Coverage, 4223,
     /* 352399 */     GIR_EraseRootFromParent_Done,
     /* 352400 */   // Label 7105: @352400
     /* 352400 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352514), // Rule ID 4330 //
     /* 352405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352435 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 352459 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 352459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 352466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352481 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352513 */     // GIR_Coverage, 4330,
     /* 352513 */     GIR_EraseRootFromParent_Done,
     /* 352514 */   // Label 7106: @352514
     /* 352514 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352628), // Rule ID 4331 //
     /* 352519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352533 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352539 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352549 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352556 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 352573 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 352573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 352580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352627 */     // GIR_Coverage, 4331,
     /* 352627 */     GIR_EraseRootFromParent_Done,
     /* 352628 */   // Label 7107: @352628
     /* 352628 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352745), // Rule ID 4226 //
     /* 352633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352659 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352662 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352666 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352673 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 352690 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 352690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 352697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352712 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352744 */     // GIR_Coverage, 4226,
     /* 352744 */     GIR_EraseRootFromParent_Done,
     /* 352745 */   // Label 7108: @352745
     /* 352745 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(352862), // Rule ID 4228 //
     /* 352750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352779 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352783 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 352807 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 352807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 352814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352861 */     // GIR_Coverage, 4228,
     /* 352861 */     GIR_EraseRootFromParent_Done,
     /* 352862 */   // Label 7109: @352862
     /* 352862 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352972), // Rule ID 4334 //
     /* 352867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352893 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352900 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 352917 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 352917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 352920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 352924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352939 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 352961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352971 */     // GIR_Coverage, 4334,
     /* 352971 */     GIR_EraseRootFromParent_Done,
     /* 352972 */   // Label 7110: @352972
     /* 352972 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353082), // Rule ID 4336 //
     /* 352977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353003 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 353027 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 353027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 353034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353081 */     // GIR_Coverage, 4336,
     /* 353081 */     GIR_EraseRootFromParent_Done,
     /* 353082 */   // Label 7111: @353082
     /* 353082 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353205), // Rule ID 5716 //
     /* 353087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 353117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 353121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 353130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353134 */     // MIs[3] Operand 1
     /* 353134 */     // No operand predicates
     /* 353134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353140 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 353140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 353143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 353147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353152 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 353156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 353159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 353164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 353186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353204 */     // GIR_Coverage, 5716,
     /* 353204 */     GIR_EraseRootFromParent_Done,
     /* 353205 */   // Label 7112: @353205
     /* 353205 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353328), // Rule ID 5748 //
     /* 353210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 353240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 353244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 353253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353257 */     // MIs[3] Operand 1
     /* 353257 */     // No operand predicates
     /* 353257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353263 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 353263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 353266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 353270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 353279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 353282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 353287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 353309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353327 */     // GIR_Coverage, 5748,
     /* 353327 */     GIR_EraseRootFromParent_Done,
     /* 353328 */   // Label 7113: @353328
     /* 353328 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353416), // Rule ID 1939 //
     /* 353333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 353362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 353383 */     // MIs[2] Operand 1
     /* 353383 */     // No operand predicates
     /* 353383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353391 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 353395 */     // MIs[3] Operand 1
     /* 353395 */     // No operand predicates
     /* 353395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353397 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 353397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 353407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 353414 */     GIR_RootConstrainSelectedInstOperands,
     /* 353415 */     // GIR_Coverage, 1939,
     /* 353415 */     GIR_EraseRootFromParent_Done,
     /* 353416 */   // Label 7114: @353416
     /* 353416 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353515), // Rule ID 5713 //
     /* 353421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 353459 */     // MIs[2] Operand 1
     /* 353459 */     // No operand predicates
     /* 353459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353467 */     // MIs[3] Operand 1
     /* 353467 */     // No operand predicates
     /* 353467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353469 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 353469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 353472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353481 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 353487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 353504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353513 */     GIR_RootConstrainSelectedInstOperands,
     /* 353514 */     // GIR_Coverage, 5713,
     /* 353514 */     GIR_EraseRootFromParent_Done,
     /* 353515 */   // Label 7115: @353515
     /* 353515 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353614), // Rule ID 5745 //
     /* 353520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 353558 */     // MIs[2] Operand 1
     /* 353558 */     // No operand predicates
     /* 353558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353566 */     // MIs[3] Operand 1
     /* 353566 */     // No operand predicates
     /* 353566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353568 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 353568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 353571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353580 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 353586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 353603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353612 */     GIR_RootConstrainSelectedInstOperands,
     /* 353613 */     // GIR_Coverage, 5745,
     /* 353613 */     GIR_EraseRootFromParent_Done,
     /* 353614 */   // Label 7116: @353614
     /* 353614 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353691), // Rule ID 5715 //
     /* 353619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 353645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353662 */     // MIs[2] Operand 1
     /* 353662 */     // No operand predicates
     /* 353662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353670 */     // MIs[3] Operand 1
     /* 353670 */     // No operand predicates
     /* 353670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353672 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 353672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353689 */     GIR_RootConstrainSelectedInstOperands,
     /* 353690 */     // GIR_Coverage, 5715,
     /* 353690 */     GIR_EraseRootFromParent_Done,
     /* 353691 */   // Label 7117: @353691
     /* 353691 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353799), // Rule ID 5717 //
     /* 353696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 353722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353739 */     // MIs[2] Operand 1
     /* 353739 */     // No operand predicates
     /* 353739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353747 */     // MIs[3] Operand 1
     /* 353747 */     // No operand predicates
     /* 353747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353749 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 353749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 353764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353797 */     GIR_RootConstrainSelectedInstOperands,
     /* 353798 */     // GIR_Coverage, 5717,
     /* 353798 */     GIR_EraseRootFromParent_Done,
     /* 353799 */   // Label 7118: @353799
     /* 353799 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353876), // Rule ID 5747 //
     /* 353804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 353830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353847 */     // MIs[2] Operand 1
     /* 353847 */     // No operand predicates
     /* 353847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353855 */     // MIs[3] Operand 1
     /* 353855 */     // No operand predicates
     /* 353855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353857 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 353857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353874 */     GIR_RootConstrainSelectedInstOperands,
     /* 353875 */     // GIR_Coverage, 5747,
     /* 353875 */     GIR_EraseRootFromParent_Done,
     /* 353876 */   // Label 7119: @353876
     /* 353876 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353984), // Rule ID 5749 //
     /* 353881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 353907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353924 */     // MIs[2] Operand 1
     /* 353924 */     // No operand predicates
     /* 353924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353932 */     // MIs[3] Operand 1
     /* 353932 */     // No operand predicates
     /* 353932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353934 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 353934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 353949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353953 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 353969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353982 */     GIR_RootConstrainSelectedInstOperands,
     /* 353983 */     // GIR_Coverage, 5749,
     /* 353983 */     GIR_EraseRootFromParent_Done,
     /* 353984 */   // Label 7120: @353984
     /* 353984 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(354063), // Rule ID 5669 //
     /* 353989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354017 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 354017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 354033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354062 */     // GIR_Coverage, 5669,
     /* 354062 */     GIR_EraseRootFromParent_Done,
     /* 354063 */   // Label 7121: @354063
     /* 354063 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(354139), // Rule ID 5675 //
     /* 354068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354096 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 354096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 354120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354138 */     // GIR_Coverage, 5675,
     /* 354138 */     GIR_EraseRootFromParent_Done,
     /* 354139 */   // Label 7122: @354139
     /* 354139 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(354215), // Rule ID 5685 //
     /* 354144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354172 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 354172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 354196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354214 */     // GIR_Coverage, 5685,
     /* 354214 */     GIR_EraseRootFromParent_Done,
     /* 354215 */   // Label 7123: @354215
     /* 354215 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(354278), // Rule ID 5694 //
     /* 354220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354242 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 354246 */     // MIs[1] Operand 1
     /* 354246 */     // No operand predicates
     /* 354246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 354250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354258 */     // MIs[2] Operand 1
     /* 354258 */     // No operand predicates
     /* 354258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354260 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 354260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 354263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 354270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 354276 */     GIR_RootConstrainSelectedInstOperands,
     /* 354277 */     // GIR_Coverage, 5694,
     /* 354277 */     GIR_EraseRootFromParent_Done,
     /* 354278 */   // Label 7124: @354278
     /* 354278 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(354364), // Rule ID 6428 //
     /* 354283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354308 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 354312 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354319 */     // MIs[1] Rn
     /* 354319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 354323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 354332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354336 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354340 */     // MIs[2] Operand 1
     /* 354340 */     // No operand predicates
     /* 354340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354342 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 354342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 354345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 354349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 354352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354362 */     GIR_RootConstrainSelectedInstOperands,
     /* 354363 */     // GIR_Coverage, 6428,
     /* 354363 */     GIR_EraseRootFromParent_Done,
     /* 354364 */   // Label 7125: @354364
     /* 354364 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(354443), // Rule ID 6433 //
     /* 354369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 354398 */     // MIs[1] Rn
     /* 354398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 354402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 354407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 354411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354419 */     // MIs[2] Operand 1
     /* 354419 */     // No operand predicates
     /* 354419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354421 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 354421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 354424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 354428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 354431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354441 */     GIR_RootConstrainSelectedInstOperands,
     /* 354442 */     // GIR_Coverage, 6433,
     /* 354442 */     GIR_EraseRootFromParent_Done,
     /* 354443 */   // Label 7126: @354443
     /* 354443 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(354497), // Rule ID 1935 //
     /* 354448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 354451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 354473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354481 */     // MIs[1] Operand 1
     /* 354481 */     // No operand predicates
     /* 354481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354483 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 354483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 354486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 354490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 354493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 354495 */     GIR_RootConstrainSelectedInstOperands,
     /* 354496 */     // GIR_Coverage, 1935,
     /* 354496 */     GIR_EraseRootFromParent_Done,
     /* 354497 */   // Label 7127: @354497
     /* 354497 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(354603), // Rule ID 5699 //
     /* 354502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 354524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 354532 */     // MIs[1] Operand 1
     /* 354532 */     // No operand predicates
     /* 354532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354534 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354534 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 354537 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354541 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 354551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354560 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 354567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 354570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 354588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 354595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354601 */     GIR_RootConstrainSelectedInstOperands,
     /* 354602 */     // GIR_Coverage, 5699,
     /* 354602 */     GIR_EraseRootFromParent_Done,
     /* 354603 */   // Label 7128: @354603
     /* 354603 */   GIM_Reject,
     /* 354604 */ // Label 7095: @354604
     /* 354604 */ GIM_Reject,
     /* 354605 */ // Label 6932: @354605
     /* 354605 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(356406),
     /* 354610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 354613 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(354739), // Rule ID 4188 //
     /* 354618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354632 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354638 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354648 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354651 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354655 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 354662 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 354679 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 354679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 354682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 354686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 354728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 354738 */     // GIR_Coverage, 4188,
     /* 354738 */     GIR_EraseRootFromParent_Done,
     /* 354739 */   // Label 7130: @354739
     /* 354739 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(354865), // Rule ID 4189 //
     /* 354744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354774 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354777 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354781 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 354788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 354805 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 354805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 354808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 354812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 354854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 354864 */     // GIR_Coverage, 4189,
     /* 354864 */     GIR_EraseRootFromParent_Done,
     /* 354865 */   // Label 7131: @354865
     /* 354865 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354987), // Rule ID 4194 //
     /* 354870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354896 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354899 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354903 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 354910 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 354927 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 354927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 354930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 354934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354954 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 354976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 354986 */     // GIR_Coverage, 4194,
     /* 354986 */     GIR_EraseRootFromParent_Done,
     /* 354987 */   // Label 7132: @354987
     /* 354987 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(355109), // Rule ID 4196 //
     /* 354992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355021 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355025 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355032 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 355049 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 355049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 355052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 355056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355108 */     // GIR_Coverage, 4196,
     /* 355108 */     GIR_EraseRootFromParent_Done,
     /* 355109 */   // Label 7133: @355109
     /* 355109 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(355230), // Rule ID 4186 //
     /* 355114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355128 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355134 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355144 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355147 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355151 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355158 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 355175 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 355175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 355178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 355182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355197 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355229 */     // GIR_Coverage, 4186,
     /* 355229 */     GIR_EraseRootFromParent_Done,
     /* 355230 */   // Label 7134: @355230
     /* 355230 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(355351), // Rule ID 4187 //
     /* 355235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355255 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355265 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355268 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355272 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355279 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 355296 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 355296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 355299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 355303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355318 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355350 */     // GIR_Coverage, 4187,
     /* 355350 */     GIR_EraseRootFromParent_Done,
     /* 355351 */   // Label 7135: @355351
     /* 355351 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(355468), // Rule ID 4190 //
     /* 355356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355382 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355385 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355389 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355396 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 355413 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 355413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 355416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 355420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355467 */     // GIR_Coverage, 4190,
     /* 355467 */     GIR_EraseRootFromParent_Done,
     /* 355468 */   // Label 7136: @355468
     /* 355468 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(355585), // Rule ID 4192 //
     /* 355473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355502 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355506 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 355530 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 355530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 355533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 355537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355552 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355584 */     // GIR_Coverage, 4192,
     /* 355584 */     GIR_EraseRootFromParent_Done,
     /* 355585 */   // Label 7137: @355585
     /* 355585 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(355708), // Rule ID 5740 //
     /* 355590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 355633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355637 */     // MIs[3] Operand 1
     /* 355637 */     // No operand predicates
     /* 355637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355643 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 355643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 355646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 355650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 355659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 355662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 355667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 355681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 355689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 355692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 355707 */     // GIR_Coverage, 5740,
     /* 355707 */     GIR_EraseRootFromParent_Done,
     /* 355708 */   // Label 7138: @355708
     /* 355708 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(355796), // Rule ID 1938 //
     /* 355713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 355763 */     // MIs[2] Operand 1
     /* 355763 */     // No operand predicates
     /* 355763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355771 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 355775 */     // MIs[3] Operand 1
     /* 355775 */     // No operand predicates
     /* 355775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355777 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 355777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 355780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 355784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 355787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 355794 */     GIR_RootConstrainSelectedInstOperands,
     /* 355795 */     // GIR_Coverage, 1938,
     /* 355795 */     GIR_EraseRootFromParent_Done,
     /* 355796 */   // Label 7139: @355796
     /* 355796 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(355895), // Rule ID 5737 //
     /* 355801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 355823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 355839 */     // MIs[2] Operand 1
     /* 355839 */     // No operand predicates
     /* 355839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355847 */     // MIs[3] Operand 1
     /* 355847 */     // No operand predicates
     /* 355847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355849 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 355849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 355852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 355867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 355880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 355884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355893 */     GIR_RootConstrainSelectedInstOperands,
     /* 355894 */     // GIR_Coverage, 5737,
     /* 355894 */     GIR_EraseRootFromParent_Done,
     /* 355895 */   // Label 7140: @355895
     /* 355895 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(355972), // Rule ID 5739 //
     /* 355900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355943 */     // MIs[2] Operand 1
     /* 355943 */     // No operand predicates
     /* 355943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355951 */     // MIs[3] Operand 1
     /* 355951 */     // No operand predicates
     /* 355951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355953 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 355953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 355956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 355960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 355963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 355970 */     GIR_RootConstrainSelectedInstOperands,
     /* 355971 */     // GIR_Coverage, 5739,
     /* 355971 */     GIR_EraseRootFromParent_Done,
     /* 355972 */   // Label 7141: @355972
     /* 355972 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(356080), // Rule ID 5741 //
     /* 355977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 356003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356020 */     // MIs[2] Operand 1
     /* 356020 */     // No operand predicates
     /* 356020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356028 */     // MIs[3] Operand 1
     /* 356028 */     // No operand predicates
     /* 356028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356030 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 356030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 356052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 356065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 356069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 356072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 356078 */     GIR_RootConstrainSelectedInstOperands,
     /* 356079 */     // GIR_Coverage, 5741,
     /* 356079 */     GIR_EraseRootFromParent_Done,
     /* 356080 */   // Label 7142: @356080
     /* 356080 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(356159), // Rule ID 5664 //
     /* 356085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356113 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 356113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 356129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356158 */     // GIR_Coverage, 5664,
     /* 356158 */     GIR_EraseRootFromParent_Done,
     /* 356159 */   // Label 7143: @356159
     /* 356159 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356245), // Rule ID 6427 //
     /* 356164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356189 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 356193 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356200 */     // MIs[1] Rn
     /* 356200 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 356204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356217 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 356221 */     // MIs[2] Operand 1
     /* 356221 */     // No operand predicates
     /* 356221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356223 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 356223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 356226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 356230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 356233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356243 */     GIR_RootConstrainSelectedInstOperands,
     /* 356244 */     // GIR_Coverage, 6427,
     /* 356244 */     GIR_EraseRootFromParent_Done,
     /* 356245 */   // Label 7144: @356245
     /* 356245 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356299), // Rule ID 1934 //
     /* 356250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 356283 */     // MIs[1] Operand 1
     /* 356283 */     // No operand predicates
     /* 356283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356285 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 356285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 356288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 356292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 356295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356297 */     GIR_RootConstrainSelectedInstOperands,
     /* 356298 */     // GIR_Coverage, 1934,
     /* 356298 */     GIR_EraseRootFromParent_Done,
     /* 356299 */   // Label 7145: @356299
     /* 356299 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356405), // Rule ID 5707 //
     /* 356304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 356307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 356326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 356334 */     // MIs[1] Operand 1
     /* 356334 */     // No operand predicates
     /* 356334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356336 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 356336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 356339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 356353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 356369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 356372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 356390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 356394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 356397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356403 */     GIR_RootConstrainSelectedInstOperands,
     /* 356404 */     // GIR_Coverage, 5707,
     /* 356404 */     GIR_EraseRootFromParent_Done,
     /* 356405 */   // Label 7146: @356405
     /* 356405 */   GIM_Reject,
     /* 356406 */ // Label 7129: @356406
     /* 356406 */ GIM_Reject,
     /* 356407 */ // Label 6933: @356407
     /* 356407 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356531), // Rule ID 11170 //
     /* 356412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 356418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 356421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356436 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 356436 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356439 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 356443 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356448 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 356452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356454 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356457 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 356461 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356466 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356469 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 356481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356486 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 356498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356503 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356506 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356512 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 356520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356522 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356527 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356529 */   GIR_RootConstrainSelectedInstOperands,
     /* 356530 */   // GIR_Coverage, 11170,
     /* 356530 */   GIR_EraseRootFromParent_Done,
     /* 356531 */ // Label 7147: @356531
     /* 356531 */ GIM_Reject,
     /* 356532 */ // Label 6934: @356532
     /* 356532 */ GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(356656), // Rule ID 11173 //
     /* 356537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 356543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356557 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356561 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 356561 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356564 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 356568 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356573 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 356577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356579 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356582 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 356586 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356591 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356594 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356599 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356602 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 356606 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356611 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 356623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356628 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356631 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356634 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356637 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 356645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356647 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356652 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356654 */   GIR_RootConstrainSelectedInstOperands,
     /* 356655 */   // GIR_Coverage, 11173,
     /* 356655 */   GIR_EraseRootFromParent_Done,
     /* 356656 */ // Label 7148: @356656
     /* 356656 */ GIM_Reject,
     /* 356657 */ // Label 6935: @356657
     /* 356657 */ GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(358634),
     /* 356662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 356665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 356668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356675 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(356784), // Rule ID 4320 //
     /* 356680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356684 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356700 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356707 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356724 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356751 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356783 */     // GIR_Coverage, 4320,
     /* 356783 */     GIR_EraseRootFromParent_Done,
     /* 356784 */   // Label 7150: @356784
     /* 356784 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(356893), // Rule ID 4321 //
     /* 356789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 356833 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 356840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356892 */     // GIR_Coverage, 4321,
     /* 356892 */     GIR_EraseRootFromParent_Done,
     /* 356893 */   // Label 7151: @356893
     /* 356893 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(357002), // Rule ID 4428 //
     /* 356898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356908 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356918 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 356942 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 356942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 356945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 356949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357001 */     // GIR_Coverage, 4428,
     /* 357001 */     GIR_EraseRootFromParent_Done,
     /* 357002 */   // Label 7152: @357002
     /* 357002 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(357111), // Rule ID 4429 //
     /* 357007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357011 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357017 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357027 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357051 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357078 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357110 */     // GIR_Coverage, 4429,
     /* 357110 */     GIR_EraseRootFromParent_Done,
     /* 357111 */   // Label 7153: @357111
     /* 357111 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(357216), // Rule ID 4326 //
     /* 357116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357132 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357156 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357215 */     // GIR_Coverage, 4326,
     /* 357215 */     GIR_EraseRootFromParent_Done,
     /* 357216 */   // Label 7154: @357216
     /* 357216 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(357321), // Rule ID 4328 //
     /* 357221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357237 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357244 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357261 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357288 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357320 */     // GIR_Coverage, 4328,
     /* 357320 */     GIR_EraseRootFromParent_Done,
     /* 357321 */   // Label 7155: @357321
     /* 357321 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(357426), // Rule ID 4434 //
     /* 357326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357342 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357349 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357366 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357393 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357425 */     // GIR_Coverage, 4434,
     /* 357425 */     GIR_EraseRootFromParent_Done,
     /* 357426 */   // Label 7156: @357426
     /* 357426 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(357531), // Rule ID 4436 //
     /* 357431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357447 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357454 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357471 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357498 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357530 */     // GIR_Coverage, 4436,
     /* 357530 */     GIR_EraseRootFromParent_Done,
     /* 357531 */   // Label 7157: @357531
     /* 357531 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(357635), // Rule ID 4318 //
     /* 357536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357563 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357580 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357634 */     // GIR_Coverage, 4318,
     /* 357634 */     GIR_EraseRootFromParent_Done,
     /* 357635 */   // Label 7158: @357635
     /* 357635 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(357739), // Rule ID 4319 //
     /* 357640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357684 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357738 */     // GIR_Coverage, 4319,
     /* 357738 */     GIR_EraseRootFromParent_Done,
     /* 357739 */   // Label 7159: @357739
     /* 357739 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(357843), // Rule ID 4426 //
     /* 357744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357788 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357842 */     // GIR_Coverage, 4426,
     /* 357842 */     GIR_EraseRootFromParent_Done,
     /* 357843 */   // Label 7160: @357843
     /* 357843 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357947), // Rule ID 4427 //
     /* 357848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357868 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357875 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 357892 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 357892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 357899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357914 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357946 */     // GIR_Coverage, 4427,
     /* 357946 */     GIR_EraseRootFromParent_Done,
     /* 357947 */   // Label 7161: @357947
     /* 357947 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(358047), // Rule ID 4322 //
     /* 357952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357968 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 357992 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 357992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 357999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358014 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358046 */     // GIR_Coverage, 4322,
     /* 358046 */     GIR_EraseRootFromParent_Done,
     /* 358047 */   // Label 7162: @358047
     /* 358047 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(358147), // Rule ID 4324 //
     /* 358052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358068 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358075 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358092 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358114 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358146 */     // GIR_Coverage, 4324,
     /* 358146 */     GIR_EraseRootFromParent_Done,
     /* 358147 */   // Label 7163: @358147
     /* 358147 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(358247), // Rule ID 4430 //
     /* 358152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358168 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358175 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358192 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358214 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358246 */     // GIR_Coverage, 4430,
     /* 358246 */     GIR_EraseRootFromParent_Done,
     /* 358247 */   // Label 7164: @358247
     /* 358247 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(358347), // Rule ID 4432 //
     /* 358252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358268 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358275 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358292 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358346 */     // GIR_Coverage, 4432,
     /* 358346 */     GIR_EraseRootFromParent_Done,
     /* 358347 */   // Label 7165: @358347
     /* 358347 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(358411), // Rule ID 11228 //
     /* 358352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 358375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358387 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 358391 */     // MIs[3] Operand 1
     /* 358391 */     // No operand predicates
     /* 358391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358397 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 358397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 358400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 358406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 358409 */     GIR_RootConstrainSelectedInstOperands,
     /* 358410 */     // GIR_Coverage, 11228,
     /* 358410 */     GIR_EraseRootFromParent_Done,
     /* 358411 */   // Label 7166: @358411
     /* 358411 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(358522), // Rule ID 11169 //
     /* 358416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358427 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 358427 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358430 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 358434 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358439 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 358443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358445 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358448 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 358452 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358457 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358460 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358477 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358503 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 358511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358513 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358520 */     GIR_RootConstrainSelectedInstOperands,
     /* 358521 */     // GIR_Coverage, 11169,
     /* 358521 */     GIR_EraseRootFromParent_Done,
     /* 358522 */   // Label 7167: @358522
     /* 358522 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(358633), // Rule ID 11175 //
     /* 358527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358538 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 358538 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358541 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 358545 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358550 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 358554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358556 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358559 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 358563 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358568 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358571 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 358583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 358600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358614 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 358622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358624 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358631 */     GIR_RootConstrainSelectedInstOperands,
     /* 358632 */     // GIR_Coverage, 11175,
     /* 358632 */     GIR_EraseRootFromParent_Done,
     /* 358633 */   // Label 7168: @358633
     /* 358633 */   GIM_Reject,
     /* 358634 */ // Label 7149: @358634
     /* 358634 */ GIM_Reject,
     /* 358635 */ // Label 6936: @358635
     /* 358635 */ GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(358786), // Rule ID 11171 //
     /* 358640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 358646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358664 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 358664 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 358667 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358671 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358676 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 358682 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358687 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358692 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358695 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 358699 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358704 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358709 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358712 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 358716 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358721 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358724 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358727 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358729 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358732 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 358736 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358741 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 358753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358758 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358764 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358767 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 358775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358777 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358782 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358784 */   GIR_RootConstrainSelectedInstOperands,
     /* 358785 */   // GIR_Coverage, 11171,
     /* 358785 */   GIR_EraseRootFromParent_Done,
     /* 358786 */ // Label 7169: @358786
     /* 358786 */ GIM_Reject,
     /* 358787 */ // Label 6937: @358787
     /* 358787 */ GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(360818),
     /* 358792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 358795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358805 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(358914), // Rule ID 4284 //
     /* 358810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358814 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358820 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358830 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358833 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358837 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 358854 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 358854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 358857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 358861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358913 */     // GIR_Coverage, 4284,
     /* 358913 */     GIR_EraseRootFromParent_Done,
     /* 358914 */   // Label 7171: @358914
     /* 358914 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(359023), // Rule ID 4285 //
     /* 358919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 358963 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 358963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 358966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 358970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359022 */     // GIR_Coverage, 4285,
     /* 359022 */     GIR_EraseRootFromParent_Done,
     /* 359023 */   // Label 7172: @359023
     /* 359023 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(359132), // Rule ID 4392 //
     /* 359028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359032 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359038 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 359072 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 359079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359131 */     // GIR_Coverage, 4392,
     /* 359131 */     GIR_EraseRootFromParent_Done,
     /* 359132 */   // Label 7173: @359132
     /* 359132 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(359241), // Rule ID 4393 //
     /* 359137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359157 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 359181 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 359188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359240 */     // GIR_Coverage, 4393,
     /* 359240 */     GIR_EraseRootFromParent_Done,
     /* 359241 */   // Label 7174: @359241
     /* 359241 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(359346), // Rule ID 4290 //
     /* 359246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359262 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359269 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 359286 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 359293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359313 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359345 */     // GIR_Coverage, 4290,
     /* 359345 */     GIR_EraseRootFromParent_Done,
     /* 359346 */   // Label 7175: @359346
     /* 359346 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(359451), // Rule ID 4292 //
     /* 359351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359367 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359374 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 359391 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 359398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359418 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359450 */     // GIR_Coverage, 4292,
     /* 359450 */     GIR_EraseRootFromParent_Done,
     /* 359451 */   // Label 7176: @359451
     /* 359451 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(359556), // Rule ID 4398 //
     /* 359456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359472 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359479 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 359496 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 359503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359523 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359555 */     // GIR_Coverage, 4398,
     /* 359555 */     GIR_EraseRootFromParent_Done,
     /* 359556 */   // Label 7177: @359556
     /* 359556 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(359661), // Rule ID 4400 //
     /* 359561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359577 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359584 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 359601 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 359601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 359608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359628 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359660 */     // GIR_Coverage, 4400,
     /* 359660 */     GIR_EraseRootFromParent_Done,
     /* 359661 */   // Label 7178: @359661
     /* 359661 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(359765), // Rule ID 4282 //
     /* 359666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359686 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359693 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 359710 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 359710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 359717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359764 */     // GIR_Coverage, 4282,
     /* 359764 */     GIR_EraseRootFromParent_Done,
     /* 359765 */   // Label 7179: @359765
     /* 359765 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(359869), // Rule ID 4283 //
     /* 359770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359797 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 359814 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 359814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 359821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359836 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359868 */     // GIR_Coverage, 4283,
     /* 359868 */     GIR_EraseRootFromParent_Done,
     /* 359869 */   // Label 7180: @359869
     /* 359869 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(359973), // Rule ID 4390 //
     /* 359874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359878 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359884 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359894 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359901 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 359918 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 359918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 359921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 359925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 359962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359972 */     // GIR_Coverage, 4390,
     /* 359972 */     GIR_EraseRootFromParent_Done,
     /* 359973 */   // Label 7181: @359973
     /* 359973 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(360077), // Rule ID 4391 //
     /* 359978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359998 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360005 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 360022 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 360022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 360029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360044 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360076 */     // GIR_Coverage, 4391,
     /* 360076 */     GIR_EraseRootFromParent_Done,
     /* 360077 */   // Label 7182: @360077
     /* 360077 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(360177), // Rule ID 4286 //
     /* 360082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360098 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360105 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 360122 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 360122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 360129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360176 */     // GIR_Coverage, 4286,
     /* 360176 */     GIR_EraseRootFromParent_Done,
     /* 360177 */   // Label 7183: @360177
     /* 360177 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(360277), // Rule ID 4288 //
     /* 360182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360198 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360205 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 360222 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 360222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 360229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360244 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360276 */     // GIR_Coverage, 4288,
     /* 360276 */     GIR_EraseRootFromParent_Done,
     /* 360277 */   // Label 7184: @360277
     /* 360277 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(360377), // Rule ID 4394 //
     /* 360282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 360322 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 360322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 360329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360376 */     // GIR_Coverage, 4394,
     /* 360376 */     GIR_EraseRootFromParent_Done,
     /* 360377 */   // Label 7185: @360377
     /* 360377 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(360477), // Rule ID 4396 //
     /* 360382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360398 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360405 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 360422 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 360422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 360429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360444 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 360466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360476 */     // GIR_Coverage, 4396,
     /* 360476 */     GIR_EraseRootFromParent_Done,
     /* 360477 */   // Label 7186: @360477
     /* 360477 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(360541), // Rule ID 11226 //
     /* 360482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 360505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360517 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 360521 */     // MIs[3] Operand 1
     /* 360521 */     // No operand predicates
     /* 360521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360527 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 360527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 360536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 360539 */     GIR_RootConstrainSelectedInstOperands,
     /* 360540 */     // GIR_Coverage, 11226,
     /* 360540 */     GIR_EraseRootFromParent_Done,
     /* 360541 */   // Label 7187: @360541
     /* 360541 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(360679), // Rule ID 11168 //
     /* 360546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360557 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 360557 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360560 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360564 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360569 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360575 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360580 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360585 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360588 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 360592 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360597 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 360609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360614 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360617 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 360629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 360646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360660 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 360668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360670 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360677 */     GIR_RootConstrainSelectedInstOperands,
     /* 360678 */     // GIR_Coverage, 11168,
     /* 360678 */     GIR_EraseRootFromParent_Done,
     /* 360679 */   // Label 7188: @360679
     /* 360679 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(360817), // Rule ID 11174 //
     /* 360684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360695 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 360695 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360698 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360702 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360707 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360713 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360718 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360723 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360726 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 360730 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360735 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360740 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360743 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 360747 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360752 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360755 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360760 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360763 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 360767 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360772 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 360784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360789 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360798 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 360806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360808 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360815 */     GIR_RootConstrainSelectedInstOperands,
     /* 360816 */     // GIR_Coverage, 11174,
     /* 360816 */     GIR_EraseRootFromParent_Done,
     /* 360817 */   // Label 7189: @360817
     /* 360817 */   GIM_Reject,
     /* 360818 */ // Label 7170: @360818
     /* 360818 */ GIM_Reject,
     /* 360819 */ // Label 6938: @360819
     /* 360819 */ GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(363086),
     /* 360824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360827 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(360953), // Rule ID 4248 //
     /* 360832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360846 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360852 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360862 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360865 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360869 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360876 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360893 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360952 */     // GIR_Coverage, 4248,
     /* 360952 */     GIR_EraseRootFromParent_Done,
     /* 360953 */   // Label 7191: @360953
     /* 360953 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(361079), // Rule ID 4249 //
     /* 360958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360972 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360978 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360988 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360991 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360995 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361019 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361078 */     // GIR_Coverage, 4249,
     /* 361078 */     GIR_EraseRootFromParent_Done,
     /* 361079 */   // Label 7192: @361079
     /* 361079 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(361198), // Rule ID 4356 //
     /* 361084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361098 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361104 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361114 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361138 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361197 */     // GIR_Coverage, 4356,
     /* 361197 */     GIR_EraseRootFromParent_Done,
     /* 361198 */   // Label 7193: @361198
     /* 361198 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(361317), // Rule ID 4357 //
     /* 361203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361223 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361233 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361240 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361257 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361284 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361316 */     // GIR_Coverage, 4357,
     /* 361316 */     GIR_EraseRootFromParent_Done,
     /* 361317 */   // Label 7194: @361317
     /* 361317 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(361439), // Rule ID 4254 //
     /* 361322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361348 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361351 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361355 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361379 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361438 */     // GIR_Coverage, 4254,
     /* 361438 */     GIR_EraseRootFromParent_Done,
     /* 361439 */   // Label 7195: @361439
     /* 361439 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(361561), // Rule ID 4256 //
     /* 361444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361470 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361473 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361477 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361484 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361501 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361528 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361560 */     // GIR_Coverage, 4256,
     /* 361560 */     GIR_EraseRootFromParent_Done,
     /* 361561 */   // Label 7196: @361561
     /* 361561 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(361676), // Rule ID 4362 //
     /* 361566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361592 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361599 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361616 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361643 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361675 */     // GIR_Coverage, 4362,
     /* 361675 */     GIR_EraseRootFromParent_Done,
     /* 361676 */   // Label 7197: @361676
     /* 361676 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(361791), // Rule ID 4364 //
     /* 361681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361707 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361714 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361731 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361790 */     // GIR_Coverage, 4364,
     /* 361790 */     GIR_EraseRootFromParent_Done,
     /* 361791 */   // Label 7198: @361791
     /* 361791 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361912), // Rule ID 4246 //
     /* 361796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361810 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361826 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361829 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361833 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361840 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361857 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361911 */     // GIR_Coverage, 4246,
     /* 361911 */     GIR_EraseRootFromParent_Done,
     /* 361912 */   // Label 7199: @361912
     /* 361912 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(362033), // Rule ID 4247 //
     /* 361917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361931 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361937 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361947 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361950 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361954 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361961 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361978 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362032 */     // GIR_Coverage, 4247,
     /* 362032 */     GIR_EraseRootFromParent_Done,
     /* 362033 */   // Label 7200: @362033
     /* 362033 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(362147), // Rule ID 4354 //
     /* 362038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362068 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362075 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362092 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362114 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362146 */     // GIR_Coverage, 4354,
     /* 362146 */     GIR_EraseRootFromParent_Done,
     /* 362147 */   // Label 7201: @362147
     /* 362147 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(362261), // Rule ID 4355 //
     /* 362152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362182 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362189 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362206 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362228 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362260 */     // GIR_Coverage, 4355,
     /* 362260 */     GIR_EraseRootFromParent_Done,
     /* 362261 */   // Label 7202: @362261
     /* 362261 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(362378), // Rule ID 4250 //
     /* 362266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362292 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362295 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362299 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362306 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362323 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362345 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362377 */     // GIR_Coverage, 4250,
     /* 362377 */     GIR_EraseRootFromParent_Done,
     /* 362378 */   // Label 7203: @362378
     /* 362378 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(362495), // Rule ID 4252 //
     /* 362383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362409 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362412 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362416 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362423 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362440 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362494 */     // GIR_Coverage, 4252,
     /* 362494 */     GIR_EraseRootFromParent_Done,
     /* 362495 */   // Label 7204: @362495
     /* 362495 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(362605), // Rule ID 4358 //
     /* 362500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362526 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362550 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362604 */     // GIR_Coverage, 4358,
     /* 362604 */     GIR_EraseRootFromParent_Done,
     /* 362605 */   // Label 7205: @362605
     /* 362605 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(362715), // Rule ID 4360 //
     /* 362610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362636 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362660 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362714 */     // GIR_Coverage, 4360,
     /* 362714 */     GIR_EraseRootFromParent_Done,
     /* 362715 */   // Label 7206: @362715
     /* 362715 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(362789), // Rule ID 11224 //
     /* 362720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 362769 */     // MIs[3] Operand 1
     /* 362769 */     // No operand predicates
     /* 362769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362775 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 362775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 362778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 362784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 362787 */     GIR_RootConstrainSelectedInstOperands,
     /* 362788 */     // GIR_Coverage, 11224,
     /* 362788 */     GIR_EraseRootFromParent_Done,
     /* 362789 */   // Label 7207: @362789
     /* 362789 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(362937), // Rule ID 11167 //
     /* 362794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362815 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 362815 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362818 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362822 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362827 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362833 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362838 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362843 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362846 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 362850 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362855 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 362858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 362860 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 362863 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 362867 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362872 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362875 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 362878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 362880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 362883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 362887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 362895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 362904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 362918 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 362926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 362928 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362933 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 362935 */     GIR_RootConstrainSelectedInstOperands,
     /* 362936 */     // GIR_Coverage, 11167,
     /* 362936 */     GIR_EraseRootFromParent_Done,
     /* 362937 */   // Label 7208: @362937
     /* 362937 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(363085), // Rule ID 11172 //
     /* 362942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362963 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 362963 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 362966 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362970 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362975 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 362981 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362986 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362991 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 362994 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 362998 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363003 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 363008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 363011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 363015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363020 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363023 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 363026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 363031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 363035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 363043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 363052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 363066 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 363074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 363076 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 363083 */     GIR_RootConstrainSelectedInstOperands,
     /* 363084 */     // GIR_Coverage, 11172,
     /* 363084 */     GIR_EraseRootFromParent_Done,
     /* 363085 */   // Label 7209: @363085
     /* 363085 */   GIM_Reject,
     /* 363086 */ // Label 7190: @363086
     /* 363086 */ GIM_Reject,
     /* 363087 */ // Label 6939: @363087
     /* 363087 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(364200),
     /* 363092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 363095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363105 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(363221), // Rule ID 4212 //
     /* 363110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363114 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363120 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363130 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363133 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363137 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363144 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 363161 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 363161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 363168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363188 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363220 */     // GIR_Coverage, 4212,
     /* 363220 */     GIR_EraseRootFromParent_Done,
     /* 363221 */   // Label 7211: @363221
     /* 363221 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(363337), // Rule ID 4213 //
     /* 363226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363230 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363236 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363246 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363249 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363253 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363260 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 363277 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 363277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 363284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363336 */     // GIR_Coverage, 4213,
     /* 363336 */     GIR_EraseRootFromParent_Done,
     /* 363337 */   // Label 7212: @363337
     /* 363337 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(363449), // Rule ID 4218 //
     /* 363342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363358 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363361 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363365 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363372 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 363389 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 363389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 363396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363416 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363448 */     // GIR_Coverage, 4218,
     /* 363448 */     GIR_EraseRootFromParent_Done,
     /* 363449 */   // Label 7213: @363449
     /* 363449 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(363561), // Rule ID 4220 //
     /* 363454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363470 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363473 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363477 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363484 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 363501 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 363501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 363508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 363523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 363528 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363560 */     // GIR_Coverage, 4220,
     /* 363560 */     GIR_EraseRootFromParent_Done,
     /* 363561 */   // Label 7214: @363561
     /* 363561 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(363672), // Rule ID 4210 //
     /* 363566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363570 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363576 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363589 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363593 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363600 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 363617 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 363617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 363624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363639 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363671 */     // GIR_Coverage, 4210,
     /* 363671 */     GIR_EraseRootFromParent_Done,
     /* 363672 */   // Label 7215: @363672
     /* 363672 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(363783), // Rule ID 4211 //
     /* 363677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363681 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 363687 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 363689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363697 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363700 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363704 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363711 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 363728 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 363728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 363735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363750 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363782 */     // GIR_Coverage, 4211,
     /* 363782 */     GIR_EraseRootFromParent_Done,
     /* 363783 */   // Label 7216: @363783
     /* 363783 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(363890), // Rule ID 4214 //
     /* 363788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363804 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363807 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363811 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363818 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 363835 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 363835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 363842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363857 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363889 */     // GIR_Coverage, 4214,
     /* 363889 */     GIR_EraseRootFromParent_Done,
     /* 363890 */   // Label 7217: @363890
     /* 363890 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(363997), // Rule ID 4216 //
     /* 363895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363911 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363914 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363918 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 363942 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 363942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 363945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 363949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363964 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 363986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 363996 */     // GIR_Coverage, 4216,
     /* 363996 */     GIR_EraseRootFromParent_Done,
     /* 363997 */   // Label 7218: @363997
     /* 363997 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(364061), // Rule ID 11222 //
     /* 364002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 364025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364037 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 364041 */     // MIs[3] Operand 1
     /* 364041 */     // No operand predicates
     /* 364041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364047 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 364047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 364050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 364056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 364059 */     GIR_RootConstrainSelectedInstOperands,
     /* 364060 */     // GIR_Coverage, 11222,
     /* 364060 */     GIR_EraseRootFromParent_Done,
     /* 364061 */   // Label 7219: @364061
     /* 364061 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(364199), // Rule ID 11166 //
     /* 364066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364077 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 364077 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 364080 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364084 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364089 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 364095 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364100 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364105 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 364108 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 364112 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364117 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 364125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 364129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 364137 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 364140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 364145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 364149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364154 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 364157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 364166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364180 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 364188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364190 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 364197 */     GIR_RootConstrainSelectedInstOperands,
     /* 364198 */     // GIR_Coverage, 11166,
     /* 364198 */     GIR_EraseRootFromParent_Done,
     /* 364199 */   // Label 7220: @364199
     /* 364199 */   GIM_Reject,
     /* 364200 */ // Label 7210: @364200
     /* 364200 */ GIM_Reject,
     /* 364201 */ // Label 6940: @364201
     /* 364201 */ GIM_Reject,
     /* 364202 */ // Label 89: @364202
     /* 364202 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7224*/ GIMT_Encode4(367119),
     /* 364213 */ /*GILLT_s16*//*Label 7221*/ GIMT_Encode4(364225),
     /* 364217 */ /*GILLT_s32*//*Label 7222*/ GIMT_Encode4(364859),
     /* 364221 */ /*GILLT_s64*//*Label 7223*/ GIMT_Encode4(366452),
     /* 364225 */ // Label 7221: @364225
     /* 364225 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(364269), // Rule ID 11215 //
     /* 364230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364243 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364247 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 364247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364252 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 364258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364268 */   // GIR_Coverage, 11215,
     /* 364268 */   GIR_EraseRootFromParent_Done,
     /* 364269 */ // Label 7225: @364269
     /* 364269 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(364313), // Rule ID 11216 //
     /* 364274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364287 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364291 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 364291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364296 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 364302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364312 */   // GIR_Coverage, 11216,
     /* 364312 */   GIR_EraseRootFromParent_Done,
     /* 364313 */ // Label 7226: @364313
     /* 364313 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(364357), // Rule ID 11217 //
     /* 364318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 364324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364331 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364335 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 364335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364340 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 364346 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364356 */   // GIR_Coverage, 11217,
     /* 364356 */   GIR_EraseRootFromParent_Done,
     /* 364357 */ // Label 7227: @364357
     /* 364357 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(364402), // Rule ID 5777 //
     /* 364362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364376 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364380 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 364380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364385 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364401 */   // GIR_Coverage, 5777,
     /* 364401 */   GIR_EraseRootFromParent_Done,
     /* 364402 */ // Label 7228: @364402
     /* 364402 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(364447), // Rule ID 5780 //
     /* 364407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364429 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364433 */   // MIs[1] Operand 1
     /* 364433 */   // No operand predicates
     /* 364433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364435 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 364435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 364438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364440 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364442 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364445 */   GIR_RootConstrainSelectedInstOperands,
     /* 364446 */   // GIR_Coverage, 5780,
     /* 364446 */   GIR_EraseRootFromParent_Done,
     /* 364447 */ // Label 7229: @364447
     /* 364447 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(364523), // Rule ID 11190 //
     /* 364452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364473 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364477 */   // MIs[1] Operand 1
     /* 364477 */   // No operand predicates
     /* 364477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364479 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 364479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364495 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364505 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 364512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364522 */   // GIR_Coverage, 11190,
     /* 364522 */   GIR_EraseRootFromParent_Done,
     /* 364523 */ // Label 7230: @364523
     /* 364523 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(364599), // Rule ID 11191 //
     /* 364528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364549 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364553 */   // MIs[1] Operand 1
     /* 364553 */   // No operand predicates
     /* 364553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364555 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 364555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364567 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364571 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364581 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 364588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364598 */   // GIR_Coverage, 11191,
     /* 364598 */   GIR_EraseRootFromParent_Done,
     /* 364599 */ // Label 7231: @364599
     /* 364599 */ GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(364675), // Rule ID 11192 //
     /* 364604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 364610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364625 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364629 */   // MIs[1] Operand 1
     /* 364629 */   // No operand predicates
     /* 364629 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364631 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 364631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364643 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364647 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364657 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 364664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364674 */   // GIR_Coverage, 11192,
     /* 364674 */   GIR_EraseRootFromParent_Done,
     /* 364675 */ // Label 7232: @364675
     /* 364675 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(364736), // Rule ID 11180 //
     /* 364680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364697 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 364697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 364704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364709 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364719 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 364727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364732 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364734 */   GIR_RootConstrainSelectedInstOperands,
     /* 364735 */   // GIR_Coverage, 11180,
     /* 364735 */   GIR_EraseRootFromParent_Done,
     /* 364736 */ // Label 7233: @364736
     /* 364736 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(364797), // Rule ID 11181 //
     /* 364741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364758 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 364758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 364765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364770 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364776 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364780 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 364788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364793 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364795 */   GIR_RootConstrainSelectedInstOperands,
     /* 364796 */   // GIR_Coverage, 11181,
     /* 364796 */   GIR_EraseRootFromParent_Done,
     /* 364797 */ // Label 7234: @364797
     /* 364797 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364858), // Rule ID 11182 //
     /* 364802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 364808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364819 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 364819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364831 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364837 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364841 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 364849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364854 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364856 */   GIR_RootConstrainSelectedInstOperands,
     /* 364857 */   // GIR_Coverage, 11182,
     /* 364857 */   GIR_EraseRootFromParent_Done,
     /* 364858 */ // Label 7235: @364858
     /* 364858 */ GIM_Reject,
     /* 364859 */ // Label 7222: @364859
     /* 364859 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364904), // Rule ID 6954 //
     /* 364864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364878 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364882 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 364882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364887 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 364893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364903 */   // GIR_Coverage, 6954,
     /* 364903 */   GIR_EraseRootFromParent_Done,
     /* 364904 */ // Label 7236: @364904
     /* 364904 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364949), // Rule ID 6955 //
     /* 364909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364923 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364927 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 364927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364932 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 364938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364948 */   // GIR_Coverage, 6955,
     /* 364948 */   GIR_EraseRootFromParent_Done,
     /* 364949 */ // Label 7237: @364949
     /* 364949 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364993), // Rule ID 11211 //
     /* 364954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 364960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364967 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364971 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 364971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364976 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 364982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364992 */   // GIR_Coverage, 11211,
     /* 364992 */   GIR_EraseRootFromParent_Done,
     /* 364993 */ // Label 7238: @364993
     /* 364993 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(365037), // Rule ID 11212 //
     /* 364998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365011 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365015 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 365015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365020 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 365026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365036 */   // GIR_Coverage, 11212,
     /* 365036 */   GIR_EraseRootFromParent_Done,
     /* 365037 */ // Label 7239: @365037
     /* 365037 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(365081), // Rule ID 11213 //
     /* 365042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365055 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365059 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 365059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365064 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 365070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365080 */   // GIR_Coverage, 11213,
     /* 365080 */   GIR_EraseRootFromParent_Done,
     /* 365081 */ // Label 7240: @365081
     /* 365081 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(365125), // Rule ID 11218 //
     /* 365086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365099 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365103 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 365103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365108 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 365114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365124 */   // GIR_Coverage, 11218,
     /* 365124 */   GIR_EraseRootFromParent_Done,
     /* 365125 */ // Label 7241: @365125
     /* 365125 */ GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(365169), // Rule ID 11219 //
     /* 365130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 365136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365143 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365147 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 365147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365152 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 365158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365168 */   // GIR_Coverage, 11219,
     /* 365168 */   GIR_EraseRootFromParent_Done,
     /* 365169 */ // Label 7242: @365169
     /* 365169 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365214), // Rule ID 5776 //
     /* 365174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365188 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 365192 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 365192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365197 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 365203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365213 */   // GIR_Coverage, 5776,
     /* 365213 */   GIR_EraseRootFromParent_Done,
     /* 365214 */ // Label 7243: @365214
     /* 365214 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(365287), // Rule ID 11196 //
     /* 365219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 365225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365240 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 365244 */   // MIs[1] Operand 1
     /* 365244 */   // No operand predicates
     /* 365244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365246 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 365246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 365249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365258 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 365264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 365277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365282 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 365285 */   GIR_RootConstrainSelectedInstOperands,
     /* 365286 */   // GIR_Coverage, 11196,
     /* 365286 */   GIR_EraseRootFromParent_Done,
     /* 365287 */ // Label 7244: @365287
     /* 365287 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365360), // Rule ID 11197 //
     /* 365292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365305 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365313 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365317 */   // MIs[1] Operand 1
     /* 365317 */   // No operand predicates
     /* 365317 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365319 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 365319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 365322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365331 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 365337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 365350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365355 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 365358 */   GIR_RootConstrainSelectedInstOperands,
     /* 365359 */   // GIR_Coverage, 11197,
     /* 365359 */   GIR_EraseRootFromParent_Done,
     /* 365360 */ // Label 7245: @365360
     /* 365360 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365433), // Rule ID 11198 //
     /* 365365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365386 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365390 */   // MIs[1] Operand 1
     /* 365390 */   // No operand predicates
     /* 365390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365392 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 365392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 365395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365404 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 365410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 365423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365428 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 365431 */   GIR_RootConstrainSelectedInstOperands,
     /* 365432 */   // GIR_Coverage, 11198,
     /* 365432 */   GIR_EraseRootFromParent_Done,
     /* 365433 */ // Label 7246: @365433
     /* 365433 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365481), // Rule ID 1926 //
     /* 365438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 365441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 365444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365463 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 365467 */   // MIs[1] Operand 1
     /* 365467 */   // No operand predicates
     /* 365467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365469 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 365472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365474 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365476 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365479 */   GIR_RootConstrainSelectedInstOperands,
     /* 365480 */   // GIR_Coverage, 1926,
     /* 365480 */   GIR_EraseRootFromParent_Done,
     /* 365481 */ // Label 7247: @365481
     /* 365481 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365529), // Rule ID 1927 //
     /* 365486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 365489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365511 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 365515 */   // MIs[1] Operand 1
     /* 365515 */   // No operand predicates
     /* 365515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365517 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 365520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365522 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365524 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365527 */   GIR_RootConstrainSelectedInstOperands,
     /* 365528 */   // GIR_Coverage, 1927,
     /* 365528 */   GIR_EraseRootFromParent_Done,
     /* 365529 */ // Label 7248: @365529
     /* 365529 */ GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365577), // Rule ID 1928 //
     /* 365534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 365537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365559 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 365563 */   // MIs[1] Operand 1
     /* 365563 */   // No operand predicates
     /* 365563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365565 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 365568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365570 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365572 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365575 */   GIR_RootConstrainSelectedInstOperands,
     /* 365576 */   // GIR_Coverage, 1928,
     /* 365576 */   GIR_EraseRootFromParent_Done,
     /* 365577 */ // Label 7249: @365577
     /* 365577 */ GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365625), // Rule ID 1930 //
     /* 365582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 365588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365607 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 365611 */   // MIs[1] Operand 1
     /* 365611 */   // No operand predicates
     /* 365611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365613 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 365616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365618 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365620 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365623 */   GIR_RootConstrainSelectedInstOperands,
     /* 365624 */   // GIR_Coverage, 1930,
     /* 365624 */   GIR_EraseRootFromParent_Done,
     /* 365625 */ // Label 7250: @365625
     /* 365625 */ GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(365673), // Rule ID 1931 //
     /* 365630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365655 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365659 */   // MIs[1] Operand 1
     /* 365659 */   // No operand predicates
     /* 365659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365661 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 365664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365666 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365668 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365671 */   GIR_RootConstrainSelectedInstOperands,
     /* 365672 */   // GIR_Coverage, 1931,
     /* 365672 */   GIR_EraseRootFromParent_Done,
     /* 365673 */ // Label 7251: @365673
     /* 365673 */ GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(365721), // Rule ID 1932 //
     /* 365678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 365691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365703 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365707 */   // MIs[1] Operand 1
     /* 365707 */   // No operand predicates
     /* 365707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365709 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 365709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 365712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365714 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365716 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365719 */   GIR_RootConstrainSelectedInstOperands,
     /* 365720 */   // GIR_Coverage, 1932,
     /* 365720 */   GIR_EraseRootFromParent_Done,
     /* 365721 */ // Label 7252: @365721
     /* 365721 */ GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(365766), // Rule ID 5779 //
     /* 365726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365748 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 365752 */   // MIs[1] Operand 1
     /* 365752 */   // No operand predicates
     /* 365752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365754 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 365754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365759 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 365761 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 365764 */   GIR_RootConstrainSelectedInstOperands,
     /* 365765 */   // GIR_Coverage, 5779,
     /* 365765 */   GIR_EraseRootFromParent_Done,
     /* 365766 */ // Label 7253: @365766
     /* 365766 */ GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(365842), // Rule ID 11186 //
     /* 365771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 365777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365784 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365792 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 365796 */   // MIs[1] Operand 1
     /* 365796 */   // No operand predicates
     /* 365796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365798 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 365798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 365805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 365814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 365817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365824 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 365831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365841 */   // GIR_Coverage, 11186,
     /* 365841 */   GIR_EraseRootFromParent_Done,
     /* 365842 */ // Label 7254: @365842
     /* 365842 */ GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(365918), // Rule ID 11187 //
     /* 365847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365868 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365872 */   // MIs[1] Operand 1
     /* 365872 */   // No operand predicates
     /* 365872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365874 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 365874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 365890 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 365893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365900 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 365907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365917 */   // GIR_Coverage, 11187,
     /* 365917 */   GIR_EraseRootFromParent_Done,
     /* 365918 */ // Label 7255: @365918
     /* 365918 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(365994), // Rule ID 11188 //
     /* 365923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365936 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365940 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365944 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365948 */   // MIs[1] Operand 1
     /* 365948 */   // No operand predicates
     /* 365948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365950 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 365950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365962 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 365966 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 365969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365976 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 365983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365993 */   // GIR_Coverage, 11188,
     /* 365993 */   GIR_EraseRootFromParent_Done,
     /* 365994 */ // Label 7256: @365994
     /* 365994 */ GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366070), // Rule ID 11193 //
     /* 365999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366012 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366020 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366024 */   // MIs[1] Operand 1
     /* 366024 */   // No operand predicates
     /* 366024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366026 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 366026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366042 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366052 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 366059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366069 */   // GIR_Coverage, 11193,
     /* 366069 */   GIR_EraseRootFromParent_Done,
     /* 366070 */ // Label 7257: @366070
     /* 366070 */ GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366146), // Rule ID 11194 //
     /* 366075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 366081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366096 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 366100 */   // MIs[1] Operand 1
     /* 366100 */   // No operand predicates
     /* 366100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366102 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 366102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 366109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366114 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366118 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366128 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 366135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366145 */   // GIR_Coverage, 11194,
     /* 366145 */   GIR_EraseRootFromParent_Done,
     /* 366146 */ // Label 7258: @366146
     /* 366146 */ GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366207), // Rule ID 11176 //
     /* 366151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366168 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 366168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 366175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366180 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366186 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366190 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 366198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366203 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366205 */   GIR_RootConstrainSelectedInstOperands,
     /* 366206 */   // GIR_Coverage, 11176,
     /* 366206 */   GIR_EraseRootFromParent_Done,
     /* 366207 */ // Label 7259: @366207
     /* 366207 */ GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366268), // Rule ID 11177 //
     /* 366212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366229 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 366229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 366236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366241 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366251 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 366259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366264 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366266 */   GIR_RootConstrainSelectedInstOperands,
     /* 366267 */   // GIR_Coverage, 11177,
     /* 366267 */   GIR_EraseRootFromParent_Done,
     /* 366268 */ // Label 7260: @366268
     /* 366268 */ GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(366329), // Rule ID 11178 //
     /* 366273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366286 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366290 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 366290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 366297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366302 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366308 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366312 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 366320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366325 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366327 */   GIR_RootConstrainSelectedInstOperands,
     /* 366328 */   // GIR_Coverage, 11178,
     /* 366328 */   GIR_EraseRootFromParent_Done,
     /* 366329 */ // Label 7261: @366329
     /* 366329 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(366390), // Rule ID 11183 //
     /* 366334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366351 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 366351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 366358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366363 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366369 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366373 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 366381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366386 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366388 */   GIR_RootConstrainSelectedInstOperands,
     /* 366389 */   // GIR_Coverage, 11183,
     /* 366389 */   GIR_EraseRootFromParent_Done,
     /* 366390 */ // Label 7262: @366390
     /* 366390 */ GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(366451), // Rule ID 11184 //
     /* 366395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 366401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366412 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 366412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 366415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 366419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366424 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366430 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 366434 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 366437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 366442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 366444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366447 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 366449 */   GIR_RootConstrainSelectedInstOperands,
     /* 366450 */   // GIR_Coverage, 11184,
     /* 366450 */   GIR_EraseRootFromParent_Done,
     /* 366451 */ // Label 7263: @366451
     /* 366451 */ GIM_Reject,
     /* 366452 */ // Label 7223: @366452
     /* 366452 */ GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(366497), // Rule ID 6953 //
     /* 366457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366471 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366475 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 366475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366480 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 366486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366496 */   // GIR_Coverage, 6953,
     /* 366496 */   GIR_EraseRootFromParent_Done,
     /* 366497 */ // Label 7264: @366497
     /* 366497 */ GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(366541), // Rule ID 11214 //
     /* 366502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 366508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366515 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366519 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 366519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366524 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 366530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366540 */   // GIR_Coverage, 11214,
     /* 366540 */   GIR_EraseRootFromParent_Done,
     /* 366541 */ // Label 7265: @366541
     /* 366541 */ GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(366585), // Rule ID 11220 //
     /* 366546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 366552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366559 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366563 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 366563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366568 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 366574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366584 */   // GIR_Coverage, 11220,
     /* 366584 */   GIR_EraseRootFromParent_Done,
     /* 366585 */ // Label 7266: @366585
     /* 366585 */ GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(366630), // Rule ID 5775 //
     /* 366590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366604 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 366608 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 366608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366613 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 366619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366629 */   // GIR_Coverage, 5775,
     /* 366629 */   GIR_EraseRootFromParent_Done,
     /* 366630 */ // Label 7267: @366630
     /* 366630 */ GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(366703), // Rule ID 11199 //
     /* 366635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 366641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366656 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 366660 */   // MIs[1] Operand 1
     /* 366660 */   // No operand predicates
     /* 366660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366662 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 366662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 366665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366674 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 366680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366685 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 366693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366698 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 366701 */   GIR_RootConstrainSelectedInstOperands,
     /* 366702 */   // GIR_Coverage, 11199,
     /* 366702 */   GIR_EraseRootFromParent_Done,
     /* 366703 */ // Label 7268: @366703
     /* 366703 */ GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(366751), // Rule ID 1929 //
     /* 366708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 366711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366733 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 366737 */   // MIs[1] Operand 1
     /* 366737 */   // No operand predicates
     /* 366737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366739 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 366739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 366742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366744 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366746 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366749 */   GIR_RootConstrainSelectedInstOperands,
     /* 366750 */   // GIR_Coverage, 1929,
     /* 366750 */   GIR_EraseRootFromParent_Done,
     /* 366751 */ // Label 7269: @366751
     /* 366751 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(366799), // Rule ID 1933 //
     /* 366756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366781 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 366785 */   // MIs[1] Operand 1
     /* 366785 */   // No operand predicates
     /* 366785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366787 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 366787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 366790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366792 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366794 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366797 */   GIR_RootConstrainSelectedInstOperands,
     /* 366798 */   // GIR_Coverage, 1933,
     /* 366798 */   GIR_EraseRootFromParent_Done,
     /* 366799 */ // Label 7270: @366799
     /* 366799 */ GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(366844), // Rule ID 5778 //
     /* 366804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366826 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 366830 */   // MIs[1] Operand 1
     /* 366830 */   // No operand predicates
     /* 366830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366832 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 366832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 366835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366837 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366839 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 366842 */   GIR_RootConstrainSelectedInstOperands,
     /* 366843 */   // GIR_Coverage, 5778,
     /* 366843 */   GIR_EraseRootFromParent_Done,
     /* 366844 */ // Label 7271: @366844
     /* 366844 */ GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(366920), // Rule ID 11189 //
     /* 366849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 366855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366870 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 366874 */   // MIs[1] Operand 1
     /* 366874 */   // No operand predicates
     /* 366874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366876 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 366876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 366883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366888 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366892 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366902 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366919 */   // GIR_Coverage, 11189,
     /* 366919 */   GIR_EraseRootFromParent_Done,
     /* 366920 */ // Label 7272: @366920
     /* 366920 */ GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(366996), // Rule ID 11195 //
     /* 366925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 366931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366946 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 366950 */   // MIs[1] Operand 1
     /* 366950 */   // No operand predicates
     /* 366950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366952 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 366952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 366959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 366968 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 366971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366978 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 366985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366995 */   // GIR_Coverage, 11195,
     /* 366995 */   GIR_EraseRootFromParent_Done,
     /* 366996 */ // Label 7273: @366996
     /* 366996 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(367057), // Rule ID 11179 //
     /* 367001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 367007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367018 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 367018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 367025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367030 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367036 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367040 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 367048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367053 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367055 */   GIR_RootConstrainSelectedInstOperands,
     /* 367056 */   // GIR_Coverage, 11179,
     /* 367056 */   GIR_EraseRootFromParent_Done,
     /* 367057 */ // Label 7274: @367057
     /* 367057 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(367118), // Rule ID 11185 //
     /* 367062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 367068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 367071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367079 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 367079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 367082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 367086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367091 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 367101 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 367104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 367109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 367111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367114 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 367116 */   GIR_RootConstrainSelectedInstOperands,
     /* 367117 */   // GIR_Coverage, 11185,
     /* 367117 */   GIR_EraseRootFromParent_Done,
     /* 367118 */ // Label 7275: @367118
     /* 367118 */ GIM_Reject,
     /* 367119 */ // Label 7224: @367119
     /* 367119 */ GIM_Reject,
     /* 367120 */ // Label 90: @367120
     /* 367120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7283*/ GIMT_Encode4(369439),
     /* 367131 */ /*GILLT_nxv2s16*//*Label 7276*/ GIMT_Encode4(367171),
     /* 367135 */ /*GILLT_nxv2s32*//*Label 7277*/ GIMT_Encode4(367530),
     /* 367139 */ /*GILLT_nxv2s64*//*Label 7278*/ GIMT_Encode4(367832), GIMT_Encode4(0),
     /* 367147 */ /*GILLT_nxv4s16*//*Label 7279*/ GIMT_Encode4(368207),
     /* 367151 */ /*GILLT_nxv4s32*//*Label 7280*/ GIMT_Encode4(368509), GIMT_Encode4(0),
     /* 367159 */ /*GILLT_nxv8s16*//*Label 7281*/ GIMT_Encode4(368884), GIMT_Encode4(0),
     /* 367167 */ /*GILLT_nxv16s8*//*Label 7282*/ GIMT_Encode4(369295),
     /* 367171 */ // Label 7276: @367171
     /* 367171 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(367529),
     /* 367176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367183 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(367247), // Rule ID 6009 //
     /* 367188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367199 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 367203 */     // MIs[1] Operand 1
     /* 367203 */     // No operand predicates
     /* 367203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367205 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 367205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 367212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367217 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 367236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367246 */     // GIR_Coverage, 6009,
     /* 367246 */     GIR_EraseRootFromParent_Done,
     /* 367247 */   // Label 7285: @367247
     /* 367247 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(367304), // Rule ID 2675 //
     /* 367252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 367267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367288 */     // MIs[2] Operand 1
     /* 367288 */     // No operand predicates
     /* 367288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367290 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 367290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367302 */     GIR_RootConstrainSelectedInstOperands,
     /* 367303 */     // GIR_Coverage, 2675,
     /* 367303 */     GIR_EraseRootFromParent_Done,
     /* 367304 */   // Label 7286: @367304
     /* 367304 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(367361), // Rule ID 2677 //
     /* 367309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 367324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 367345 */     // MIs[2] Operand 1
     /* 367345 */     // No operand predicates
     /* 367345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367347 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 367347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 367350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367359 */     GIR_RootConstrainSelectedInstOperands,
     /* 367360 */     // GIR_Coverage, 2677,
     /* 367360 */     GIR_EraseRootFromParent_Done,
     /* 367361 */   // Label 7287: @367361
     /* 367361 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(367418), // Rule ID 8319 //
     /* 367366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 367381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 367402 */     // MIs[2] Operand 1
     /* 367402 */     // No operand predicates
     /* 367402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367404 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 367404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 367407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367416 */     GIR_RootConstrainSelectedInstOperands,
     /* 367417 */     // GIR_Coverage, 8319,
     /* 367417 */     GIR_EraseRootFromParent_Done,
     /* 367418 */   // Label 7288: @367418
     /* 367418 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(367452), // Rule ID 8362 //
     /* 367423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367434 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 367438 */     // MIs[1] Operand 1
     /* 367438 */     // No operand predicates
     /* 367438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367440 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 367440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 367443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 367450 */     GIR_RootConstrainSelectedInstOperands,
     /* 367451 */     // GIR_Coverage, 8362,
     /* 367451 */     GIR_EraseRootFromParent_Done,
     /* 367452 */   // Label 7289: @367452
     /* 367452 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(367528), // Rule ID 8340 //
     /* 367457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367464 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 367467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 367497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 367500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 367518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367526 */     GIR_RootConstrainSelectedInstOperands,
     /* 367527 */     // GIR_Coverage, 8340,
     /* 367527 */     GIR_EraseRootFromParent_Done,
     /* 367528 */   // Label 7290: @367528
     /* 367528 */   GIM_Reject,
     /* 367529 */ // Label 7284: @367529
     /* 367529 */ GIM_Reject,
     /* 367530 */ // Label 7277: @367530
     /* 367530 */ GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(367831),
     /* 367535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367542 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(367606), // Rule ID 6007 //
     /* 367547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367558 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 367562 */     // MIs[1] Operand 1
     /* 367562 */     // No operand predicates
     /* 367562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367564 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 367564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 367571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 367595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367605 */     // GIR_Coverage, 6007,
     /* 367605 */     GIR_EraseRootFromParent_Done,
     /* 367606 */   // Label 7292: @367606
     /* 367606 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(367663), // Rule ID 8328 //
     /* 367611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 367647 */     // MIs[2] Operand 1
     /* 367647 */     // No operand predicates
     /* 367647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367649 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 367649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367661 */     GIR_RootConstrainSelectedInstOperands,
     /* 367662 */     // GIR_Coverage, 8328,
     /* 367662 */     GIR_EraseRootFromParent_Done,
     /* 367663 */   // Label 7293: @367663
     /* 367663 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(367720), // Rule ID 8337 //
     /* 367668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 367683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 367704 */     // MIs[2] Operand 1
     /* 367704 */     // No operand predicates
     /* 367704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367706 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 367706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 367709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367718 */     GIR_RootConstrainSelectedInstOperands,
     /* 367719 */     // GIR_Coverage, 8337,
     /* 367719 */     GIR_EraseRootFromParent_Done,
     /* 367720 */   // Label 7294: @367720
     /* 367720 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(367754), // Rule ID 8364 //
     /* 367725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367736 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 367740 */     // MIs[1] Operand 1
     /* 367740 */     // No operand predicates
     /* 367740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367742 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 367742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 367745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367747 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 367752 */     GIR_RootConstrainSelectedInstOperands,
     /* 367753 */     // GIR_Coverage, 8364,
     /* 367753 */     GIR_EraseRootFromParent_Done,
     /* 367754 */   // Label 7295: @367754
     /* 367754 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(367830), // Rule ID 8342 //
     /* 367759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367766 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 367769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 367783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 367799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 367820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367828 */     GIR_RootConstrainSelectedInstOperands,
     /* 367829 */     // GIR_Coverage, 8342,
     /* 367829 */     GIR_EraseRootFromParent_Done,
     /* 367830 */   // Label 7296: @367830
     /* 367830 */   GIM_Reject,
     /* 367831 */ // Label 7291: @367831
     /* 367831 */ GIM_Reject,
     /* 367832 */ // Label 7278: @367832
     /* 367832 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(368206),
     /* 367837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367844 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(367898), // Rule ID 6002 //
     /* 367849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 367856 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 367856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 367863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 367887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367897 */     // GIR_Coverage, 6002,
     /* 367897 */     GIR_EraseRootFromParent_Done,
     /* 367898 */   // Label 7298: @367898
     /* 367898 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(367962), // Rule ID 6006 //
     /* 367903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367914 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 367918 */     // MIs[1] Operand 1
     /* 367918 */     // No operand predicates
     /* 367918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367920 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 367920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 367927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 367951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367961 */     // GIR_Coverage, 6006,
     /* 367961 */     GIR_EraseRootFromParent_Done,
     /* 367962 */   // Label 7299: @367962
     /* 367962 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(368019), // Rule ID 2672 //
     /* 367967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 367982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368003 */     // MIs[2] Operand 1
     /* 368003 */     // No operand predicates
     /* 368003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368005 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 368005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368017 */     GIR_RootConstrainSelectedInstOperands,
     /* 368018 */     // GIR_Coverage, 2672,
     /* 368018 */     GIR_EraseRootFromParent_Done,
     /* 368019 */   // Label 7300: @368019
     /* 368019 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(368076), // Rule ID 8334 //
     /* 368024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 368039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 368060 */     // MIs[2] Operand 1
     /* 368060 */     // No operand predicates
     /* 368060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368062 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 368062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368074 */     GIR_RootConstrainSelectedInstOperands,
     /* 368075 */     // GIR_Coverage, 8334,
     /* 368075 */     GIR_EraseRootFromParent_Done,
     /* 368076 */   // Label 7301: @368076
     /* 368076 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(368110), // Rule ID 8365 //
     /* 368081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368092 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 368096 */     // MIs[1] Operand 1
     /* 368096 */     // No operand predicates
     /* 368096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368098 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 368098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 368101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368103 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 368108 */     GIR_RootConstrainSelectedInstOperands,
     /* 368109 */     // GIR_Coverage, 8365,
     /* 368109 */     GIR_EraseRootFromParent_Done,
     /* 368110 */   // Label 7302: @368110
     /* 368110 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(368129), // Rule ID 2391 //
     /* 368115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 368122 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 368122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 368127 */     GIR_RootConstrainSelectedInstOperands,
     /* 368128 */     // GIR_Coverage, 2391,
     /* 368128 */     GIR_Done,
     /* 368129 */   // Label 7303: @368129
     /* 368129 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(368205), // Rule ID 8343 //
     /* 368134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368141 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 368144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 368195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368203 */     GIR_RootConstrainSelectedInstOperands,
     /* 368204 */     // GIR_Coverage, 8343,
     /* 368204 */     GIR_EraseRootFromParent_Done,
     /* 368205 */   // Label 7304: @368205
     /* 368205 */   GIM_Reject,
     /* 368206 */ // Label 7297: @368206
     /* 368206 */ GIM_Reject,
     /* 368207 */ // Label 7279: @368207
     /* 368207 */ GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(368508),
     /* 368212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368219 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(368283), // Rule ID 6010 //
     /* 368224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368235 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368239 */     // MIs[1] Operand 1
     /* 368239 */     // No operand predicates
     /* 368239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368241 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368253 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368282 */     // GIR_Coverage, 6010,
     /* 368282 */     GIR_EraseRootFromParent_Done,
     /* 368283 */   // Label 7306: @368283
     /* 368283 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(368340), // Rule ID 2676 //
     /* 368288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 368303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 368324 */     // MIs[2] Operand 1
     /* 368324 */     // No operand predicates
     /* 368324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368326 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 368326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368338 */     GIR_RootConstrainSelectedInstOperands,
     /* 368339 */     // GIR_Coverage, 2676,
     /* 368339 */     GIR_EraseRootFromParent_Done,
     /* 368340 */   // Label 7307: @368340
     /* 368340 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(368397), // Rule ID 8322 //
     /* 368345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 368360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 368381 */     // MIs[2] Operand 1
     /* 368381 */     // No operand predicates
     /* 368381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368383 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 368383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 368386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368395 */     GIR_RootConstrainSelectedInstOperands,
     /* 368396 */     // GIR_Coverage, 8322,
     /* 368396 */     GIR_EraseRootFromParent_Done,
     /* 368397 */   // Label 7308: @368397
     /* 368397 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(368431), // Rule ID 8361 //
     /* 368402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368413 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 368417 */     // MIs[1] Operand 1
     /* 368417 */     // No operand predicates
     /* 368417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368419 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 368419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 368422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368424 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 368429 */     GIR_RootConstrainSelectedInstOperands,
     /* 368430 */     // GIR_Coverage, 8361,
     /* 368430 */     GIR_EraseRootFromParent_Done,
     /* 368431 */   // Label 7309: @368431
     /* 368431 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(368507), // Rule ID 8339 //
     /* 368436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368443 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 368446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 368479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 368497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368505 */     GIR_RootConstrainSelectedInstOperands,
     /* 368506 */     // GIR_Coverage, 8339,
     /* 368506 */     GIR_EraseRootFromParent_Done,
     /* 368507 */   // Label 7310: @368507
     /* 368507 */   GIM_Reject,
     /* 368508 */ // Label 7305: @368508
     /* 368508 */ GIM_Reject,
     /* 368509 */ // Label 7280: @368509
     /* 368509 */ GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(368883),
     /* 368514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368521 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(368575), // Rule ID 6003 //
     /* 368526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 368533 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368545 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368574 */     // GIR_Coverage, 6003,
     /* 368574 */     GIR_EraseRootFromParent_Done,
     /* 368575 */   // Label 7312: @368575
     /* 368575 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(368639), // Rule ID 6008 //
     /* 368580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368591 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368595 */     // MIs[1] Operand 1
     /* 368595 */     // No operand predicates
     /* 368595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368597 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368638 */     // GIR_Coverage, 6008,
     /* 368638 */     GIR_EraseRootFromParent_Done,
     /* 368639 */   // Label 7313: @368639
     /* 368639 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(368696), // Rule ID 2669 //
     /* 368644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 368680 */     // MIs[2] Operand 1
     /* 368680 */     // No operand predicates
     /* 368680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368682 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 368682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368694 */     GIR_RootConstrainSelectedInstOperands,
     /* 368695 */     // GIR_Coverage, 2669,
     /* 368695 */     GIR_EraseRootFromParent_Done,
     /* 368696 */   // Label 7314: @368696
     /* 368696 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(368753), // Rule ID 8331 //
     /* 368701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 368716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368733 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 368737 */     // MIs[2] Operand 1
     /* 368737 */     // No operand predicates
     /* 368737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368739 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 368739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 368748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 368751 */     GIR_RootConstrainSelectedInstOperands,
     /* 368752 */     // GIR_Coverage, 8331,
     /* 368752 */     GIR_EraseRootFromParent_Done,
     /* 368753 */   // Label 7315: @368753
     /* 368753 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(368787), // Rule ID 8363 //
     /* 368758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368769 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 368773 */     // MIs[1] Operand 1
     /* 368773 */     // No operand predicates
     /* 368773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368775 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 368775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 368778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368780 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 368785 */     GIR_RootConstrainSelectedInstOperands,
     /* 368786 */     // GIR_Coverage, 8363,
     /* 368786 */     GIR_EraseRootFromParent_Done,
     /* 368787 */   // Label 7316: @368787
     /* 368787 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(368806), // Rule ID 2390 //
     /* 368792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 368799 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 368799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 368804 */     GIR_RootConstrainSelectedInstOperands,
     /* 368805 */     // GIR_Coverage, 2390,
     /* 368805 */     GIR_Done,
     /* 368806 */   // Label 7317: @368806
     /* 368806 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(368882), // Rule ID 8341 //
     /* 368811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 368814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368818 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 368818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 368821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 368835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 368851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 368854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 368872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 368874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368880 */     GIR_RootConstrainSelectedInstOperands,
     /* 368881 */     // GIR_Coverage, 8341,
     /* 368881 */     GIR_EraseRootFromParent_Done,
     /* 368882 */   // Label 7318: @368882
     /* 368882 */   GIM_Reject,
     /* 368883 */ // Label 7311: @368883
     /* 368883 */ GIM_Reject,
     /* 368884 */ // Label 7281: @368884
     /* 368884 */ GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(368945), // Rule ID 6004 //
     /* 368889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368899 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 368903 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368915 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 368934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368944 */   // GIR_Coverage, 6004,
     /* 368944 */   GIR_EraseRootFromParent_Done,
     /* 368945 */ // Label 7319: @368945
     /* 368945 */ GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(369016), // Rule ID 6011 //
     /* 368950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 368960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 368968 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 368972 */   // MIs[1] Operand 1
     /* 368972 */   // No operand predicates
     /* 368972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368974 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 368974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 368981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368986 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 368989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369015 */   // GIR_Coverage, 6011,
     /* 369015 */   GIR_EraseRootFromParent_Done,
     /* 369016 */ // Label 7320: @369016
     /* 369016 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(369080), // Rule ID 2666 //
     /* 369021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369031 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369039 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 369043 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369047 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369052 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369056 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369060 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 369064 */   // MIs[2] Operand 1
     /* 369064 */   // No operand predicates
     /* 369064 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369066 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 369066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369071 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369075 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369078 */   GIR_RootConstrainSelectedInstOperands,
     /* 369079 */   // GIR_Coverage, 2666,
     /* 369079 */   GIR_EraseRootFromParent_Done,
     /* 369080 */ // Label 7321: @369080
     /* 369080 */ GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(369144), // Rule ID 8325 //
     /* 369085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 369107 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369116 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369120 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369124 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 369128 */   // MIs[2] Operand 1
     /* 369128 */   // No operand predicates
     /* 369128 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369130 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 369130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369139 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369142 */   GIR_RootConstrainSelectedInstOperands,
     /* 369143 */   // GIR_Coverage, 8325,
     /* 369143 */   GIR_EraseRootFromParent_Done,
     /* 369144 */ // Label 7322: @369144
     /* 369144 */ GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(369185), // Rule ID 8360 //
     /* 369149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 369167 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 369171 */   // MIs[1] Operand 1
     /* 369171 */   // No operand predicates
     /* 369171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369173 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 369173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 369176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369178 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 369183 */   GIR_RootConstrainSelectedInstOperands,
     /* 369184 */   // GIR_Coverage, 8360,
     /* 369184 */   GIR_EraseRootFromParent_Done,
     /* 369185 */ // Label 7323: @369185
     /* 369185 */ GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(369211), // Rule ID 2389 //
     /* 369190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 369204 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 369204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 369209 */   GIR_RootConstrainSelectedInstOperands,
     /* 369210 */   // GIR_Coverage, 2389,
     /* 369210 */   GIR_Done,
     /* 369211 */ // Label 7324: @369211
     /* 369211 */ GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(369294), // Rule ID 8338 //
     /* 369216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369230 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369230 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 369233 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369237 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 369247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369256 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369263 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 369266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 369284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369292 */   GIR_RootConstrainSelectedInstOperands,
     /* 369293 */   // GIR_Coverage, 8338,
     /* 369293 */   GIR_EraseRootFromParent_Done,
     /* 369294 */ // Label 7325: @369294
     /* 369294 */ GIM_Reject,
     /* 369295 */ // Label 7282: @369295
     /* 369295 */ GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(369438),
     /* 369300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369307 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(369361), // Rule ID 6005 //
     /* 369312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 369319 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 369319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 369326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 369334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 369350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369360 */     // GIR_Coverage, 6005,
     /* 369360 */     GIR_EraseRootFromParent_Done,
     /* 369361 */   // Label 7327: @369361
     /* 369361 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(369418), // Rule ID 2663 //
     /* 369366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 369381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 369390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 369402 */     // MIs[2] Operand 1
     /* 369402 */     // No operand predicates
     /* 369402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369404 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 369404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 369407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 369409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 369413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 369416 */     GIR_RootConstrainSelectedInstOperands,
     /* 369417 */     // GIR_Coverage, 2663,
     /* 369417 */     GIR_EraseRootFromParent_Done,
     /* 369418 */   // Label 7328: @369418
     /* 369418 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(369437), // Rule ID 2388 //
     /* 369423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 369426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 369430 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 369430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 369435 */     GIR_RootConstrainSelectedInstOperands,
     /* 369436 */     // GIR_Coverage, 2388,
     /* 369436 */     GIR_Done,
     /* 369437 */   // Label 7329: @369437
     /* 369437 */   GIM_Reject,
     /* 369438 */ // Label 7326: @369438
     /* 369438 */ GIM_Reject,
     /* 369439 */ // Label 7283: @369439
     /* 369439 */ GIM_Reject,
     /* 369440 */ // Label 91: @369440
     /* 369440 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7332*/ GIMT_Encode4(369591),
     /* 369451 */ /*GILLT_s32*//*Label 7330*/ GIMT_Encode4(369459),
     /* 369455 */ /*GILLT_s64*//*Label 7331*/ GIMT_Encode4(369525),
     /* 369459 */ // Label 7330: @369459
     /* 369459 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(369524),
     /* 369464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369475 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(369490), // Rule ID 2321 //
     /* 369480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 369483 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 369483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 369488 */     GIR_RootConstrainSelectedInstOperands,
     /* 369489 */     // GIR_Coverage, 2321,
     /* 369489 */     GIR_Done,
     /* 369490 */   // Label 7334: @369490
     /* 369490 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(369523), // Rule ID 4005 //
     /* 369495 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 369495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 369502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 369516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369521 */     GIR_RootConstrainSelectedInstOperands,
     /* 369522 */     // GIR_Coverage, 4005,
     /* 369522 */     GIR_EraseRootFromParent_Done,
     /* 369523 */   // Label 7335: @369523
     /* 369523 */   GIM_Reject,
     /* 369524 */ // Label 7333: @369524
     /* 369524 */ GIM_Reject,
     /* 369525 */ // Label 7331: @369525
     /* 369525 */ GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(369590),
     /* 369530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 369537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 369541 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(369556), // Rule ID 2322 //
     /* 369546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 369549 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 369549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 369554 */     GIR_RootConstrainSelectedInstOperands,
     /* 369555 */     // GIR_Coverage, 2322,
     /* 369555 */     GIR_Done,
     /* 369556 */   // Label 7337: @369556
     /* 369556 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(369589), // Rule ID 4006 //
     /* 369561 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 369561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 369568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 369582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369587 */     GIR_RootConstrainSelectedInstOperands,
     /* 369588 */     // GIR_Coverage, 4006,
     /* 369588 */     GIR_EraseRootFromParent_Done,
     /* 369589 */   // Label 7338: @369589
     /* 369589 */   GIM_Reject,
     /* 369590 */ // Label 7336: @369590
     /* 369590 */ GIM_Reject,
     /* 369591 */ // Label 7332: @369591
     /* 369591 */ GIM_Reject,
     /* 369592 */ // Label 92: @369592
     /* 369592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7347*/ GIMT_Encode4(370265),
     /* 369603 */ /*GILLT_s32*//*Label 7339*/ GIMT_Encode4(369643),
     /* 369607 */ /*GILLT_s64*//*Label 7340*/ GIMT_Encode4(369873), GIMT_Encode4(0),
     /* 369615 */ /*GILLT_v2s32*//*Label 7341*/ GIMT_Encode4(370103), GIMT_Encode4(0),
     /* 369623 */ /*GILLT_v4s16*//*Label 7342*/ GIMT_Encode4(370130),
     /* 369627 */ /*GILLT_v4s32*//*Label 7343*/ GIMT_Encode4(370157),
     /* 369631 */ /*GILLT_v8s8*//*Label 7344*/ GIMT_Encode4(370184),
     /* 369635 */ /*GILLT_v8s16*//*Label 7345*/ GIMT_Encode4(370211),
     /* 369639 */ /*GILLT_v16s8*//*Label 7346*/ GIMT_Encode4(370238),
     /* 369643 */ // Label 7339: @369643
     /* 369643 */ GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(369872),
     /* 369648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369655 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(369755), // Rule ID 4007 //
     /* 369660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 369668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 369684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 369696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 369700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 369704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 369708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 369712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 369716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 369720 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369725 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 369729 */     // MIs[3] Rn
     /* 369729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 369734 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 369742 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 369744 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 369744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 369747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 369753 */     GIR_RootConstrainSelectedInstOperands,
     /* 369754 */     // GIR_Coverage, 4007,
     /* 369754 */     GIR_EraseRootFromParent_Done,
     /* 369755 */   // Label 7349: @369755
     /* 369755 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(369855), // Rule ID 13777 //
     /* 369760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 369768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 369784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 369796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 369800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 369804 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 369808 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 369817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 369821 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 369825 */     // MIs[4] Rn
     /* 369825 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 369830 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 369834 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369838 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 369842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 369844 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 369844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 369847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 369853 */     GIR_RootConstrainSelectedInstOperands,
     /* 369854 */     // GIR_Coverage, 13777,
     /* 369854 */     GIR_EraseRootFromParent_Done,
     /* 369855 */   // Label 7350: @369855
     /* 369855 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(369871), // Rule ID 180 //
     /* 369860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369864 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 369864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 369869 */     GIR_RootConstrainSelectedInstOperands,
     /* 369870 */     // GIR_Coverage, 180,
     /* 369870 */     GIR_Done,
     /* 369871 */   // Label 7351: @369871
     /* 369871 */   GIM_Reject,
     /* 369872 */ // Label 7348: @369872
     /* 369872 */ GIM_Reject,
     /* 369873 */ // Label 7340: @369873
     /* 369873 */ GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(370102),
     /* 369878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 369885 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(369985), // Rule ID 4008 //
     /* 369890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 369898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 369902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 369914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 369918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 369926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 369930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 369934 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 369938 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 369942 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 369946 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 369950 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 369955 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 369959 */     // MIs[3] Rn
     /* 369959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 369964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 369972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 369974 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 369974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 369977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 369983 */     GIR_RootConstrainSelectedInstOperands,
     /* 369984 */     // GIR_Coverage, 4008,
     /* 369984 */     GIR_EraseRootFromParent_Done,
     /* 369985 */   // Label 7353: @369985
     /* 369985 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(370085), // Rule ID 13778 //
     /* 369990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 369998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 370014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 370030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370038 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 370051 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370055 */     // MIs[4] Rn
     /* 370055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 370060 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 370064 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370074 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 370077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 370083 */     GIR_RootConstrainSelectedInstOperands,
     /* 370084 */     // GIR_Coverage, 13778,
     /* 370084 */     GIR_EraseRootFromParent_Done,
     /* 370085 */   // Label 7354: @370085
     /* 370085 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(370101), // Rule ID 181 //
     /* 370090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370094 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 370099 */     GIR_RootConstrainSelectedInstOperands,
     /* 370100 */     // GIR_Coverage, 181,
     /* 370100 */     GIR_Done,
     /* 370101 */   // Label 7355: @370101
     /* 370101 */   GIM_Reject,
     /* 370102 */ // Label 7352: @370102
     /* 370102 */ GIM_Reject,
     /* 370103 */ // Label 7341: @370103
     /* 370103 */ GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(370129), // Rule ID 720 //
     /* 370108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370122 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 370122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 370127 */   GIR_RootConstrainSelectedInstOperands,
     /* 370128 */   // GIR_Coverage, 720,
     /* 370128 */   GIR_Done,
     /* 370129 */ // Label 7356: @370129
     /* 370129 */ GIM_Reject,
     /* 370130 */ // Label 7342: @370130
     /* 370130 */ GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(370156), // Rule ID 718 //
     /* 370135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370149 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 370149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 370154 */   GIR_RootConstrainSelectedInstOperands,
     /* 370155 */   // GIR_Coverage, 718,
     /* 370155 */   GIR_Done,
     /* 370156 */ // Label 7357: @370156
     /* 370156 */ GIM_Reject,
     /* 370157 */ // Label 7343: @370157
     /* 370157 */ GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(370183), // Rule ID 721 //
     /* 370162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370176 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 370176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 370181 */   GIR_RootConstrainSelectedInstOperands,
     /* 370182 */   // GIR_Coverage, 721,
     /* 370182 */   GIR_Done,
     /* 370183 */ // Label 7358: @370183
     /* 370183 */ GIM_Reject,
     /* 370184 */ // Label 7344: @370184
     /* 370184 */ GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(370210), // Rule ID 716 //
     /* 370189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370203 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 370203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 370208 */   GIR_RootConstrainSelectedInstOperands,
     /* 370209 */   // GIR_Coverage, 716,
     /* 370209 */   GIR_Done,
     /* 370210 */ // Label 7359: @370210
     /* 370210 */ GIM_Reject,
     /* 370211 */ // Label 7345: @370211
     /* 370211 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(370237), // Rule ID 719 //
     /* 370216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370230 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 370230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 370235 */   GIR_RootConstrainSelectedInstOperands,
     /* 370236 */   // GIR_Coverage, 719,
     /* 370236 */   GIR_Done,
     /* 370237 */ // Label 7360: @370237
     /* 370237 */ GIM_Reject,
     /* 370238 */ // Label 7346: @370238
     /* 370238 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(370264), // Rule ID 717 //
     /* 370243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370257 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 370257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 370262 */   GIR_RootConstrainSelectedInstOperands,
     /* 370263 */   // GIR_Coverage, 717,
     /* 370263 */   GIR_Done,
     /* 370264 */ // Label 7361: @370264
     /* 370264 */ GIM_Reject,
     /* 370265 */ // Label 7347: @370265
     /* 370265 */ GIM_Reject,
     /* 370266 */ // Label 93: @370266
     /* 370266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7366*/ GIMT_Encode4(370425),
     /* 370277 */ /*GILLT_s32*//*Label 7362*/ GIMT_Encode4(370317),
     /* 370281 */ /*GILLT_s64*//*Label 7363*/ GIMT_Encode4(370344), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 370305 */ /*GILLT_v8s8*//*Label 7364*/ GIMT_Encode4(370371), GIMT_Encode4(0),
     /* 370313 */ /*GILLT_v16s8*//*Label 7365*/ GIMT_Encode4(370398),
     /* 370317 */ // Label 7362: @370317
     /* 370317 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(370343), // Rule ID 2319 //
     /* 370322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 370325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370336 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 370336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 370341 */   GIR_RootConstrainSelectedInstOperands,
     /* 370342 */   // GIR_Coverage, 2319,
     /* 370342 */   GIR_Done,
     /* 370343 */ // Label 7367: @370343
     /* 370343 */ GIM_Reject,
     /* 370344 */ // Label 7363: @370344
     /* 370344 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(370370), // Rule ID 2320 //
     /* 370349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 370352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370363 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 370368 */   GIR_RootConstrainSelectedInstOperands,
     /* 370369 */   // GIR_Coverage, 2320,
     /* 370369 */   GIR_Done,
     /* 370370 */ // Label 7368: @370370
     /* 370370 */ GIM_Reject,
     /* 370371 */ // Label 7364: @370371
     /* 370371 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(370397), // Rule ID 764 //
     /* 370376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370390 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 370390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 370395 */   GIR_RootConstrainSelectedInstOperands,
     /* 370396 */   // GIR_Coverage, 764,
     /* 370396 */   GIR_Done,
     /* 370397 */ // Label 7369: @370397
     /* 370397 */ GIM_Reject,
     /* 370398 */ // Label 7365: @370398
     /* 370398 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(370424), // Rule ID 765 //
     /* 370403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370417 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 370417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 370422 */   GIR_RootConstrainSelectedInstOperands,
     /* 370423 */   // GIR_Coverage, 765,
     /* 370423 */   GIR_Done,
     /* 370424 */ // Label 7370: @370424
     /* 370424 */ GIM_Reject,
     /* 370425 */ // Label 7366: @370425
     /* 370425 */ GIM_Reject,
     /* 370426 */ // Label 94: @370426
     /* 370426 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7378*/ GIMT_Encode4(370739),
     /* 370437 */ /*GILLT_s32*//*Label 7371*/ GIMT_Encode4(370473),
     /* 370441 */ /*GILLT_s64*//*Label 7372*/ GIMT_Encode4(370546), GIMT_Encode4(0),
     /* 370449 */ /*GILLT_v2s32*//*Label 7373*/ GIMT_Encode4(370619),
     /* 370453 */ /*GILLT_v2s64*//*Label 7374*/ GIMT_Encode4(370643),
     /* 370457 */ /*GILLT_v4s16*//*Label 7375*/ GIMT_Encode4(370667),
     /* 370461 */ /*GILLT_v4s32*//*Label 7376*/ GIMT_Encode4(370691), GIMT_Encode4(0),
     /* 370469 */ /*GILLT_v8s16*//*Label 7377*/ GIMT_Encode4(370715),
     /* 370473 */ // Label 7371: @370473
     /* 370473 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(370545),
     /* 370478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370485 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(370528), // Rule ID 4011 //
     /* 370490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 370498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 370515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370517 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 370517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 370520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370526 */     GIR_RootConstrainSelectedInstOperands,
     /* 370527 */     // GIR_Coverage, 4011,
     /* 370527 */     GIR_EraseRootFromParent_Done,
     /* 370528 */   // Label 7380: @370528
     /* 370528 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(370544), // Rule ID 185 //
     /* 370533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370537 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 370537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 370542 */     GIR_RootConstrainSelectedInstOperands,
     /* 370543 */     // GIR_Coverage, 185,
     /* 370543 */     GIR_Done,
     /* 370544 */   // Label 7381: @370544
     /* 370544 */   GIM_Reject,
     /* 370545 */ // Label 7379: @370545
     /* 370545 */ GIM_Reject,
     /* 370546 */ // Label 7372: @370546
     /* 370546 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(370618),
     /* 370551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370558 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(370601), // Rule ID 4012 //
     /* 370563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 370571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 370588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370590 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 370593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370599 */     GIR_RootConstrainSelectedInstOperands,
     /* 370600 */     // GIR_Coverage, 4012,
     /* 370600 */     GIR_EraseRootFromParent_Done,
     /* 370601 */   // Label 7383: @370601
     /* 370601 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(370617), // Rule ID 186 //
     /* 370606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370610 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 370615 */     GIR_RootConstrainSelectedInstOperands,
     /* 370616 */     // GIR_Coverage, 186,
     /* 370616 */     GIR_Done,
     /* 370617 */   // Label 7384: @370617
     /* 370617 */   GIM_Reject,
     /* 370618 */ // Label 7382: @370618
     /* 370618 */ GIM_Reject,
     /* 370619 */ // Label 7373: @370619
     /* 370619 */ GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(370642), // Rule ID 4988 //
     /* 370624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370635 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 370635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 370640 */   GIR_RootConstrainSelectedInstOperands,
     /* 370641 */   // GIR_Coverage, 4988,
     /* 370641 */   GIR_Done,
     /* 370642 */ // Label 7385: @370642
     /* 370642 */ GIM_Reject,
     /* 370643 */ // Label 7374: @370643
     /* 370643 */ GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(370666), // Rule ID 4990 //
     /* 370648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370659 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 370659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 370664 */   GIR_RootConstrainSelectedInstOperands,
     /* 370665 */   // GIR_Coverage, 4990,
     /* 370665 */   GIR_Done,
     /* 370666 */ // Label 7386: @370666
     /* 370666 */ GIM_Reject,
     /* 370667 */ // Label 7375: @370667
     /* 370667 */ GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(370690), // Rule ID 4986 //
     /* 370672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370683 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 370683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 370688 */   GIR_RootConstrainSelectedInstOperands,
     /* 370689 */   // GIR_Coverage, 4986,
     /* 370689 */   GIR_Done,
     /* 370690 */ // Label 7387: @370690
     /* 370690 */ GIM_Reject,
     /* 370691 */ // Label 7376: @370691
     /* 370691 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(370714), // Rule ID 4989 //
     /* 370696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370707 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 370707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 370712 */   GIR_RootConstrainSelectedInstOperands,
     /* 370713 */   // GIR_Coverage, 4989,
     /* 370713 */   GIR_Done,
     /* 370714 */ // Label 7388: @370714
     /* 370714 */ GIM_Reject,
     /* 370715 */ // Label 7377: @370715
     /* 370715 */ GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(370738), // Rule ID 4987 //
     /* 370720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370731 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 370731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 370736 */   GIR_RootConstrainSelectedInstOperands,
     /* 370737 */   // GIR_Coverage, 4987,
     /* 370737 */   GIR_Done,
     /* 370738 */ // Label 7389: @370738
     /* 370738 */ GIM_Reject,
     /* 370739 */ // Label 7378: @370739
     /* 370739 */ GIM_Reject,
     /* 370740 */ // Label 95: @370740
     /* 370740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7394*/ GIMT_Encode4(370893),
     /* 370751 */ /*GILLT_s32*//*Label 7390*/ GIMT_Encode4(370791),
     /* 370755 */ /*GILLT_s64*//*Label 7391*/ GIMT_Encode4(370815), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 370779 */ /*GILLT_v8s8*//*Label 7392*/ GIMT_Encode4(370839), GIMT_Encode4(0),
     /* 370787 */ /*GILLT_v16s8*//*Label 7393*/ GIMT_Encode4(370866),
     /* 370791 */ // Label 7390: @370791
     /* 370791 */ GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(370814), // Rule ID 182 //
     /* 370796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370807 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 370807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 370812 */   GIR_RootConstrainSelectedInstOperands,
     /* 370813 */   // GIR_Coverage, 182,
     /* 370813 */   GIR_Done,
     /* 370814 */ // Label 7395: @370814
     /* 370814 */ GIM_Reject,
     /* 370815 */ // Label 7391: @370815
     /* 370815 */ GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(370838), // Rule ID 183 //
     /* 370820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 370831 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 370831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 370836 */   GIR_RootConstrainSelectedInstOperands,
     /* 370837 */   // GIR_Coverage, 183,
     /* 370837 */   GIR_Done,
     /* 370838 */ // Label 7396: @370838
     /* 370838 */ GIM_Reject,
     /* 370839 */ // Label 7392: @370839
     /* 370839 */ GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(370865), // Rule ID 974 //
     /* 370844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370858 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 370858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 370863 */   GIR_RootConstrainSelectedInstOperands,
     /* 370864 */   // GIR_Coverage, 974,
     /* 370864 */   GIR_Done,
     /* 370865 */ // Label 7397: @370865
     /* 370865 */ GIM_Reject,
     /* 370866 */ // Label 7393: @370866
     /* 370866 */ GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(370892), // Rule ID 975 //
     /* 370871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370885 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 370885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 370890 */   GIR_RootConstrainSelectedInstOperands,
     /* 370891 */   // GIR_Coverage, 975,
     /* 370891 */   GIR_Done,
     /* 370892 */ // Label 7398: @370892
     /* 370892 */ GIM_Reject,
     /* 370893 */ // Label 7394: @370893
     /* 370893 */ GIM_Reject,
     /* 370894 */ // Label 96: @370894
     /* 370894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7407*/ GIMT_Encode4(371384),
     /* 370905 */ /*GILLT_s16*//*Label 7399*/ GIMT_Encode4(370945),
     /* 370909 */ /*GILLT_s32*//*Label 7400*/ GIMT_Encode4(370976),
     /* 370913 */ /*GILLT_s64*//*Label 7401*/ GIMT_Encode4(371007), GIMT_Encode4(0),
     /* 370921 */ /*GILLT_v2s32*//*Label 7402*/ GIMT_Encode4(371038),
     /* 370925 */ /*GILLT_v2s64*//*Label 7403*/ GIMT_Encode4(371069),
     /* 370929 */ /*GILLT_v4s16*//*Label 7404*/ GIMT_Encode4(371100),
     /* 370933 */ /*GILLT_v4s32*//*Label 7405*/ GIMT_Encode4(371131), GIMT_Encode4(0),
     /* 370941 */ /*GILLT_v8s16*//*Label 7406*/ GIMT_Encode4(371162),
     /* 370945 */ // Label 7399: @370945
     /* 370945 */ GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(370975), // Rule ID 552 //
     /* 370950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370964 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 370964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 370969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370973 */   GIR_RootConstrainSelectedInstOperands,
     /* 370974 */   // GIR_Coverage, 552,
     /* 370974 */   GIR_Done,
     /* 370975 */ // Label 7408: @370975
     /* 370975 */ GIM_Reject,
     /* 370976 */ // Label 7400: @370976
     /* 370976 */ GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(371006), // Rule ID 554 //
     /* 370981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370995 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 370995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 371000 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371004 */   GIR_RootConstrainSelectedInstOperands,
     /* 371005 */   // GIR_Coverage, 554,
     /* 371005 */   GIR_Done,
     /* 371006 */ // Label 7409: @371006
     /* 371006 */ GIM_Reject,
     /* 371007 */ // Label 7401: @371007
     /* 371007 */ GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(371037), // Rule ID 556 //
     /* 371012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371026 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 371026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 371031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371035 */   GIR_RootConstrainSelectedInstOperands,
     /* 371036 */   // GIR_Coverage, 556,
     /* 371036 */   GIR_Done,
     /* 371037 */ // Label 7410: @371037
     /* 371037 */ GIM_Reject,
     /* 371038 */ // Label 7402: @371038
     /* 371038 */ GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(371068), // Rule ID 913 //
     /* 371043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371057 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 371057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 371062 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371066 */   GIR_RootConstrainSelectedInstOperands,
     /* 371067 */   // GIR_Coverage, 913,
     /* 371067 */   GIR_Done,
     /* 371068 */ // Label 7411: @371068
     /* 371068 */ GIM_Reject,
     /* 371069 */ // Label 7403: @371069
     /* 371069 */ GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(371099), // Rule ID 917 //
     /* 371074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371088 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 371088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 371093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371097 */   GIR_RootConstrainSelectedInstOperands,
     /* 371098 */   // GIR_Coverage, 917,
     /* 371098 */   GIR_Done,
     /* 371099 */ // Label 7412: @371099
     /* 371099 */ GIM_Reject,
     /* 371100 */ // Label 7404: @371100
     /* 371100 */ GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(371130), // Rule ID 909 //
     /* 371105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371119 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 371119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 371124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371128 */   GIR_RootConstrainSelectedInstOperands,
     /* 371129 */   // GIR_Coverage, 909,
     /* 371129 */   GIR_Done,
     /* 371130 */ // Label 7413: @371130
     /* 371130 */ GIM_Reject,
     /* 371131 */ // Label 7405: @371131
     /* 371131 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(371161), // Rule ID 915 //
     /* 371136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371150 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 371150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 371155 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371159 */   GIR_RootConstrainSelectedInstOperands,
     /* 371160 */   // GIR_Coverage, 915,
     /* 371160 */   GIR_Done,
     /* 371161 */ // Label 7414: @371161
     /* 371161 */ GIM_Reject,
     /* 371162 */ // Label 7406: @371162
     /* 371162 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(371383),
     /* 371167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371178 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(371197), // Rule ID 911 //
     /* 371183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371186 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 371186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 371191 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371195 */     GIR_RootConstrainSelectedInstOperands,
     /* 371196 */     // GIR_Coverage, 911,
     /* 371196 */     GIR_Done,
     /* 371197 */   // Label 7416: @371197
     /* 371197 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(371382), // Rule ID 6986 //
     /* 371202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371205 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 371205 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 371208 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371212 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371217 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 371223 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371226 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 371230 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371235 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371240 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371243 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371247 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371252 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371258 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371263 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371268 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371271 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371275 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371280 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371285 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371288 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 371292 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371297 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371314 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371351 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 371380 */     GIR_RootConstrainSelectedInstOperands,
     /* 371381 */     // GIR_Coverage, 6986,
     /* 371381 */     GIR_EraseRootFromParent_Done,
     /* 371382 */   // Label 7417: @371382
     /* 371382 */   GIM_Reject,
     /* 371383 */ // Label 7415: @371383
     /* 371383 */ GIM_Reject,
     /* 371384 */ // Label 7407: @371384
     /* 371384 */ GIM_Reject,
     /* 371385 */ // Label 97: @371385
     /* 371385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7426*/ GIMT_Encode4(371684),
     /* 371396 */ /*GILLT_s16*//*Label 7418*/ GIMT_Encode4(371436),
     /* 371400 */ /*GILLT_s32*//*Label 7419*/ GIMT_Encode4(371467),
     /* 371404 */ /*GILLT_s64*//*Label 7420*/ GIMT_Encode4(371498), GIMT_Encode4(0),
     /* 371412 */ /*GILLT_v2s32*//*Label 7421*/ GIMT_Encode4(371529),
     /* 371416 */ /*GILLT_v2s64*//*Label 7422*/ GIMT_Encode4(371560),
     /* 371420 */ /*GILLT_v4s16*//*Label 7423*/ GIMT_Encode4(371591),
     /* 371424 */ /*GILLT_v4s32*//*Label 7424*/ GIMT_Encode4(371622), GIMT_Encode4(0),
     /* 371432 */ /*GILLT_v8s16*//*Label 7425*/ GIMT_Encode4(371653),
     /* 371436 */ // Label 7418: @371436
     /* 371436 */ GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(371466), // Rule ID 570 //
     /* 371441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371455 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 371455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 371460 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371464 */   GIR_RootConstrainSelectedInstOperands,
     /* 371465 */   // GIR_Coverage, 570,
     /* 371465 */   GIR_Done,
     /* 371466 */ // Label 7427: @371466
     /* 371466 */ GIM_Reject,
     /* 371467 */ // Label 7419: @371467
     /* 371467 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(371497), // Rule ID 572 //
     /* 371472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371486 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 371486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 371491 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371495 */   GIR_RootConstrainSelectedInstOperands,
     /* 371496 */   // GIR_Coverage, 572,
     /* 371496 */   GIR_Done,
     /* 371497 */ // Label 7428: @371497
     /* 371497 */ GIM_Reject,
     /* 371498 */ // Label 7420: @371498
     /* 371498 */ GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(371528), // Rule ID 574 //
     /* 371503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371517 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 371517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 371522 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371526 */   GIR_RootConstrainSelectedInstOperands,
     /* 371527 */   // GIR_Coverage, 574,
     /* 371527 */   GIR_Done,
     /* 371528 */ // Label 7429: @371528
     /* 371528 */ GIM_Reject,
     /* 371529 */ // Label 7421: @371529
     /* 371529 */ GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(371559), // Rule ID 960 //
     /* 371534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371548 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 371548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 371553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371557 */   GIR_RootConstrainSelectedInstOperands,
     /* 371558 */   // GIR_Coverage, 960,
     /* 371558 */   GIR_Done,
     /* 371559 */ // Label 7430: @371559
     /* 371559 */ GIM_Reject,
     /* 371560 */ // Label 7422: @371560
     /* 371560 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(371590), // Rule ID 964 //
     /* 371565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371579 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 371579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 371584 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371588 */   GIR_RootConstrainSelectedInstOperands,
     /* 371589 */   // GIR_Coverage, 964,
     /* 371589 */   GIR_Done,
     /* 371590 */ // Label 7431: @371590
     /* 371590 */ GIM_Reject,
     /* 371591 */ // Label 7423: @371591
     /* 371591 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(371621), // Rule ID 956 //
     /* 371596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371610 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 371610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 371615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371619 */   GIR_RootConstrainSelectedInstOperands,
     /* 371620 */   // GIR_Coverage, 956,
     /* 371620 */   GIR_Done,
     /* 371621 */ // Label 7432: @371621
     /* 371621 */ GIM_Reject,
     /* 371622 */ // Label 7424: @371622
     /* 371622 */ GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(371652), // Rule ID 962 //
     /* 371627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371641 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 371641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 371646 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371650 */   GIR_RootConstrainSelectedInstOperands,
     /* 371651 */   // GIR_Coverage, 962,
     /* 371651 */   GIR_Done,
     /* 371652 */ // Label 7433: @371652
     /* 371652 */ GIM_Reject,
     /* 371653 */ // Label 7425: @371653
     /* 371653 */ GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(371683), // Rule ID 958 //
     /* 371658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371672 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 371672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 371677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371681 */   GIR_RootConstrainSelectedInstOperands,
     /* 371682 */   // GIR_Coverage, 958,
     /* 371682 */   GIR_Done,
     /* 371683 */ // Label 7434: @371683
     /* 371683 */ GIM_Reject,
     /* 371684 */ // Label 7426: @371684
     /* 371684 */ GIM_Reject,
     /* 371685 */ // Label 98: @371685
     /* 371685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7443*/ GIMT_Encode4(372175),
     /* 371696 */ /*GILLT_s16*//*Label 7435*/ GIMT_Encode4(371736),
     /* 371700 */ /*GILLT_s32*//*Label 7436*/ GIMT_Encode4(371767),
     /* 371704 */ /*GILLT_s64*//*Label 7437*/ GIMT_Encode4(371798), GIMT_Encode4(0),
     /* 371712 */ /*GILLT_v2s32*//*Label 7438*/ GIMT_Encode4(371829),
     /* 371716 */ /*GILLT_v2s64*//*Label 7439*/ GIMT_Encode4(371860),
     /* 371720 */ /*GILLT_v4s16*//*Label 7440*/ GIMT_Encode4(371891),
     /* 371724 */ /*GILLT_v4s32*//*Label 7441*/ GIMT_Encode4(371922), GIMT_Encode4(0),
     /* 371732 */ /*GILLT_v8s16*//*Label 7442*/ GIMT_Encode4(371953),
     /* 371736 */ // Label 7435: @371736
     /* 371736 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(371766), // Rule ID 540 //
     /* 371741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371755 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 371755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 371760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371764 */   GIR_RootConstrainSelectedInstOperands,
     /* 371765 */   // GIR_Coverage, 540,
     /* 371765 */   GIR_Done,
     /* 371766 */ // Label 7444: @371766
     /* 371766 */ GIM_Reject,
     /* 371767 */ // Label 7436: @371767
     /* 371767 */ GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(371797), // Rule ID 542 //
     /* 371772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371786 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 371786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 371791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371795 */   GIR_RootConstrainSelectedInstOperands,
     /* 371796 */   // GIR_Coverage, 542,
     /* 371796 */   GIR_Done,
     /* 371797 */ // Label 7445: @371797
     /* 371797 */ GIM_Reject,
     /* 371798 */ // Label 7437: @371798
     /* 371798 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(371828), // Rule ID 544 //
     /* 371803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371817 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 371817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 371822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371826 */   GIR_RootConstrainSelectedInstOperands,
     /* 371827 */   // GIR_Coverage, 544,
     /* 371827 */   GIR_Done,
     /* 371828 */ // Label 7446: @371828
     /* 371828 */ GIM_Reject,
     /* 371829 */ // Label 7438: @371829
     /* 371829 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(371859), // Rule ID 893 //
     /* 371834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371848 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 371848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 371853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371857 */   GIR_RootConstrainSelectedInstOperands,
     /* 371858 */   // GIR_Coverage, 893,
     /* 371858 */   GIR_Done,
     /* 371859 */ // Label 7447: @371859
     /* 371859 */ GIM_Reject,
     /* 371860 */ // Label 7439: @371860
     /* 371860 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(371890), // Rule ID 897 //
     /* 371865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371879 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 371879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 371884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371888 */   GIR_RootConstrainSelectedInstOperands,
     /* 371889 */   // GIR_Coverage, 897,
     /* 371889 */   GIR_Done,
     /* 371890 */ // Label 7448: @371890
     /* 371890 */ GIM_Reject,
     /* 371891 */ // Label 7440: @371891
     /* 371891 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(371921), // Rule ID 889 //
     /* 371896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371910 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 371910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 371915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371919 */   GIR_RootConstrainSelectedInstOperands,
     /* 371920 */   // GIR_Coverage, 889,
     /* 371920 */   GIR_Done,
     /* 371921 */ // Label 7449: @371921
     /* 371921 */ GIM_Reject,
     /* 371922 */ // Label 7441: @371922
     /* 371922 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(371952), // Rule ID 895 //
     /* 371927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371941 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 371941 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 371946 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371950 */   GIR_RootConstrainSelectedInstOperands,
     /* 371951 */   // GIR_Coverage, 895,
     /* 371951 */   GIR_Done,
     /* 371952 */ // Label 7450: @371952
     /* 371952 */ GIM_Reject,
     /* 371953 */ // Label 7442: @371953
     /* 371953 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(372174),
     /* 371958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371969 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(371988), // Rule ID 891 //
     /* 371974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371977 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 371977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 371982 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371986 */     GIR_RootConstrainSelectedInstOperands,
     /* 371987 */     // GIR_Coverage, 891,
     /* 371987 */     GIR_Done,
     /* 371988 */   // Label 7452: @371988
     /* 371988 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(372173), // Rule ID 6988 //
     /* 371993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371996 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 371996 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 371999 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372003 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372008 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 372014 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372017 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 372021 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372026 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 372029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 372031 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 372034 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372038 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372043 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372049 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372054 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372059 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372062 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372066 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372071 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372076 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372079 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 372083 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372088 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372093 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372096 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372100 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372105 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 372171 */     GIR_RootConstrainSelectedInstOperands,
     /* 372172 */     // GIR_Coverage, 6988,
     /* 372172 */     GIR_EraseRootFromParent_Done,
     /* 372173 */   // Label 7453: @372173
     /* 372173 */   GIM_Reject,
     /* 372174 */ // Label 7451: @372174
     /* 372174 */ GIM_Reject,
     /* 372175 */ // Label 7443: @372175
     /* 372175 */ GIM_Reject,
     /* 372176 */ // Label 99: @372176
     /* 372176 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7462*/ GIMT_Encode4(372666),
     /* 372187 */ /*GILLT_s16*//*Label 7454*/ GIMT_Encode4(372227),
     /* 372191 */ /*GILLT_s32*//*Label 7455*/ GIMT_Encode4(372258),
     /* 372195 */ /*GILLT_s64*//*Label 7456*/ GIMT_Encode4(372289), GIMT_Encode4(0),
     /* 372203 */ /*GILLT_v2s32*//*Label 7457*/ GIMT_Encode4(372320),
     /* 372207 */ /*GILLT_v2s64*//*Label 7458*/ GIMT_Encode4(372351),
     /* 372211 */ /*GILLT_v4s16*//*Label 7459*/ GIMT_Encode4(372382),
     /* 372215 */ /*GILLT_v4s32*//*Label 7460*/ GIMT_Encode4(372413), GIMT_Encode4(0),
     /* 372223 */ /*GILLT_v8s16*//*Label 7461*/ GIMT_Encode4(372444),
     /* 372227 */ // Label 7454: @372227
     /* 372227 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(372257), // Rule ID 558 //
     /* 372232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372246 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 372251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372255 */   GIR_RootConstrainSelectedInstOperands,
     /* 372256 */   // GIR_Coverage, 558,
     /* 372256 */   GIR_Done,
     /* 372257 */ // Label 7463: @372257
     /* 372257 */ GIM_Reject,
     /* 372258 */ // Label 7455: @372258
     /* 372258 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(372288), // Rule ID 560 //
     /* 372263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372277 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 372277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 372282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372286 */   GIR_RootConstrainSelectedInstOperands,
     /* 372287 */   // GIR_Coverage, 560,
     /* 372287 */   GIR_Done,
     /* 372288 */ // Label 7464: @372288
     /* 372288 */ GIM_Reject,
     /* 372289 */ // Label 7456: @372289
     /* 372289 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(372319), // Rule ID 562 //
     /* 372294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372308 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 372308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 372313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372317 */   GIR_RootConstrainSelectedInstOperands,
     /* 372318 */   // GIR_Coverage, 562,
     /* 372318 */   GIR_Done,
     /* 372319 */ // Label 7465: @372319
     /* 372319 */ GIM_Reject,
     /* 372320 */ // Label 7457: @372320
     /* 372320 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(372350), // Rule ID 923 //
     /* 372325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372339 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 372339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 372344 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372348 */   GIR_RootConstrainSelectedInstOperands,
     /* 372349 */   // GIR_Coverage, 923,
     /* 372349 */   GIR_Done,
     /* 372350 */ // Label 7466: @372350
     /* 372350 */ GIM_Reject,
     /* 372351 */ // Label 7458: @372351
     /* 372351 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(372381), // Rule ID 927 //
     /* 372356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372370 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 372370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 372375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372379 */   GIR_RootConstrainSelectedInstOperands,
     /* 372380 */   // GIR_Coverage, 927,
     /* 372380 */   GIR_Done,
     /* 372381 */ // Label 7467: @372381
     /* 372381 */ GIM_Reject,
     /* 372382 */ // Label 7459: @372382
     /* 372382 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(372412), // Rule ID 919 //
     /* 372387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372401 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 372401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 372406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372410 */   GIR_RootConstrainSelectedInstOperands,
     /* 372411 */   // GIR_Coverage, 919,
     /* 372411 */   GIR_Done,
     /* 372412 */ // Label 7468: @372412
     /* 372412 */ GIM_Reject,
     /* 372413 */ // Label 7460: @372413
     /* 372413 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(372443), // Rule ID 925 //
     /* 372418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372432 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 372432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 372437 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372441 */   GIR_RootConstrainSelectedInstOperands,
     /* 372442 */   // GIR_Coverage, 925,
     /* 372442 */   GIR_Done,
     /* 372443 */ // Label 7469: @372443
     /* 372443 */ GIM_Reject,
     /* 372444 */ // Label 7461: @372444
     /* 372444 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(372665),
     /* 372449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372460 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(372479), // Rule ID 921 //
     /* 372465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372468 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 372468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 372473 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372477 */     GIR_RootConstrainSelectedInstOperands,
     /* 372478 */     // GIR_Coverage, 921,
     /* 372478 */     GIR_Done,
     /* 372479 */   // Label 7471: @372479
     /* 372479 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(372664), // Rule ID 6996 //
     /* 372484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 372487 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 372487 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 372490 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372494 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372499 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 372505 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372508 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 372512 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372517 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 372520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 372522 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 372525 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372529 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372534 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372540 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372545 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372550 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372553 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372557 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372562 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372567 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372570 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 372574 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372579 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372584 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372587 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372591 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372596 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 372662 */     GIR_RootConstrainSelectedInstOperands,
     /* 372663 */     // GIR_Coverage, 6996,
     /* 372663 */     GIR_EraseRootFromParent_Done,
     /* 372664 */   // Label 7472: @372664
     /* 372664 */   GIM_Reject,
     /* 372665 */ // Label 7470: @372665
     /* 372665 */ GIM_Reject,
     /* 372666 */ // Label 7462: @372666
     /* 372666 */ GIM_Reject,
     /* 372667 */ // Label 100: @372667
     /* 372667 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7481*/ GIMT_Encode4(373157),
     /* 372678 */ /*GILLT_s16*//*Label 7473*/ GIMT_Encode4(372718),
     /* 372682 */ /*GILLT_s32*//*Label 7474*/ GIMT_Encode4(372749),
     /* 372686 */ /*GILLT_s64*//*Label 7475*/ GIMT_Encode4(372780), GIMT_Encode4(0),
     /* 372694 */ /*GILLT_v2s32*//*Label 7476*/ GIMT_Encode4(372811),
     /* 372698 */ /*GILLT_v2s64*//*Label 7477*/ GIMT_Encode4(372842),
     /* 372702 */ /*GILLT_v4s16*//*Label 7478*/ GIMT_Encode4(372873),
     /* 372706 */ /*GILLT_v4s32*//*Label 7479*/ GIMT_Encode4(372904), GIMT_Encode4(0),
     /* 372714 */ /*GILLT_v8s16*//*Label 7480*/ GIMT_Encode4(372935),
     /* 372718 */ // Label 7473: @372718
     /* 372718 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(372748), // Rule ID 534 //
     /* 372723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372737 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 372737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 372742 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372746 */   GIR_RootConstrainSelectedInstOperands,
     /* 372747 */   // GIR_Coverage, 534,
     /* 372747 */   GIR_Done,
     /* 372748 */ // Label 7482: @372748
     /* 372748 */ GIM_Reject,
     /* 372749 */ // Label 7474: @372749
     /* 372749 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(372779), // Rule ID 536 //
     /* 372754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372768 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 372768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 372773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372777 */   GIR_RootConstrainSelectedInstOperands,
     /* 372778 */   // GIR_Coverage, 536,
     /* 372778 */   GIR_Done,
     /* 372779 */ // Label 7483: @372779
     /* 372779 */ GIM_Reject,
     /* 372780 */ // Label 7475: @372780
     /* 372780 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(372810), // Rule ID 538 //
     /* 372785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372799 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 372799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 372804 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372808 */   GIR_RootConstrainSelectedInstOperands,
     /* 372809 */   // GIR_Coverage, 538,
     /* 372809 */   GIR_Done,
     /* 372810 */ // Label 7484: @372810
     /* 372810 */ GIM_Reject,
     /* 372811 */ // Label 7476: @372811
     /* 372811 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(372841), // Rule ID 883 //
     /* 372816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372830 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 372830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 372835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372839 */   GIR_RootConstrainSelectedInstOperands,
     /* 372840 */   // GIR_Coverage, 883,
     /* 372840 */   GIR_Done,
     /* 372841 */ // Label 7485: @372841
     /* 372841 */ GIM_Reject,
     /* 372842 */ // Label 7477: @372842
     /* 372842 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(372872), // Rule ID 887 //
     /* 372847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372861 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 372861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 372866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372870 */   GIR_RootConstrainSelectedInstOperands,
     /* 372871 */   // GIR_Coverage, 887,
     /* 372871 */   GIR_Done,
     /* 372872 */ // Label 7486: @372872
     /* 372872 */ GIM_Reject,
     /* 372873 */ // Label 7478: @372873
     /* 372873 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(372903), // Rule ID 879 //
     /* 372878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372892 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 372892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 372897 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372901 */   GIR_RootConstrainSelectedInstOperands,
     /* 372902 */   // GIR_Coverage, 879,
     /* 372902 */   GIR_Done,
     /* 372903 */ // Label 7487: @372903
     /* 372903 */ GIM_Reject,
     /* 372904 */ // Label 7479: @372904
     /* 372904 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(372934), // Rule ID 885 //
     /* 372909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372923 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 372923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 372928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372932 */   GIR_RootConstrainSelectedInstOperands,
     /* 372933 */   // GIR_Coverage, 885,
     /* 372933 */   GIR_Done,
     /* 372934 */ // Label 7488: @372934
     /* 372934 */ GIM_Reject,
     /* 372935 */ // Label 7480: @372935
     /* 372935 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(373156),
     /* 372940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372951 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(372970), // Rule ID 881 //
     /* 372956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372959 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 372959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 372964 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372968 */     GIR_RootConstrainSelectedInstOperands,
     /* 372969 */     // GIR_Coverage, 881,
     /* 372969 */     GIR_Done,
     /* 372970 */   // Label 7490: @372970
     /* 372970 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(373155), // Rule ID 6990 //
     /* 372975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 372978 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 372978 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 372981 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372985 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372990 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 372996 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372999 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 373003 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373008 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 373011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 373013 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 373016 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373020 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373025 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373031 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373036 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373041 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 373044 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 373048 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373053 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 373056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 373058 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 373061 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 373065 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373070 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 373073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 373075 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 373078 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 373082 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373087 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 373090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 373092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 373095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 373124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 373145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 373153 */     GIR_RootConstrainSelectedInstOperands,
     /* 373154 */     // GIR_Coverage, 6990,
     /* 373154 */     GIR_EraseRootFromParent_Done,
     /* 373155 */   // Label 7491: @373155
     /* 373155 */   GIM_Reject,
     /* 373156 */ // Label 7489: @373156
     /* 373156 */ GIM_Reject,
     /* 373157 */ // Label 7481: @373157
     /* 373157 */ GIM_Reject,
     /* 373158 */ // Label 101: @373158
     /* 373158 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7500*/ GIMT_Encode4(374283),
     /* 373169 */ /*GILLT_s16*//*Label 7492*/ GIMT_Encode4(373209),
     /* 373173 */ /*GILLT_s32*//*Label 7493*/ GIMT_Encode4(373435),
     /* 373177 */ /*GILLT_s64*//*Label 7494*/ GIMT_Encode4(373661), GIMT_Encode4(0),
     /* 373185 */ /*GILLT_v2s32*//*Label 7495*/ GIMT_Encode4(373833),
     /* 373189 */ /*GILLT_v2s64*//*Label 7496*/ GIMT_Encode4(373871),
     /* 373193 */ /*GILLT_v4s16*//*Label 7497*/ GIMT_Encode4(373909),
     /* 373197 */ /*GILLT_v4s32*//*Label 7498*/ GIMT_Encode4(373947), GIMT_Encode4(0),
     /* 373205 */ /*GILLT_v8s16*//*Label 7499*/ GIMT_Encode4(373985),
     /* 373209 */ // Label 7492: @373209
     /* 373209 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(373434),
     /* 373214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 373217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373224 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(373315), // Rule ID 6910 //
     /* 373229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373266 */     // MIs[2] Rn
     /* 373266 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373271 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 373275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373277 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 373277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 373308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373313 */     GIR_RootConstrainSelectedInstOperands,
     /* 373314 */     // GIR_Coverage, 6910,
     /* 373314 */     GIR_EraseRootFromParent_Done,
     /* 373315 */   // Label 7502: @373315
     /* 373315 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(373406), // Rule ID 13915 //
     /* 373320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 373345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373357 */     // MIs[2] Rn
     /* 373357 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373362 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373368 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 373368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373380 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 373399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373404 */     GIR_RootConstrainSelectedInstOperands,
     /* 373405 */     // GIR_Coverage, 13915,
     /* 373405 */     GIR_EraseRootFromParent_Done,
     /* 373406 */   // Label 7503: @373406
     /* 373406 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(373433), // Rule ID 583 //
     /* 373411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373422 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 373422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 373427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373431 */     GIR_RootConstrainSelectedInstOperands,
     /* 373432 */     // GIR_Coverage, 583,
     /* 373432 */     GIR_Done,
     /* 373433 */   // Label 7504: @373433
     /* 373433 */   GIM_Reject,
     /* 373434 */ // Label 7501: @373434
     /* 373434 */ GIM_Reject,
     /* 373435 */ // Label 7493: @373435
     /* 373435 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(373660),
     /* 373440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373450 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(373541), // Rule ID 6908 //
     /* 373455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373476 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373492 */     // MIs[2] Rn
     /* 373492 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 373501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373503 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 373503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 373534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373539 */     GIR_RootConstrainSelectedInstOperands,
     /* 373540 */     // GIR_Coverage, 6908,
     /* 373540 */     GIR_EraseRootFromParent_Done,
     /* 373541 */   // Label 7506: @373541
     /* 373541 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(373632), // Rule ID 13913 //
     /* 373546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 373571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373583 */     // MIs[2] Rn
     /* 373583 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373588 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373594 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 373594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 373625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373630 */     GIR_RootConstrainSelectedInstOperands,
     /* 373631 */     // GIR_Coverage, 13913,
     /* 373631 */     GIR_EraseRootFromParent_Done,
     /* 373632 */   // Label 7507: @373632
     /* 373632 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(373659), // Rule ID 585 //
     /* 373637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373648 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 373648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 373653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373657 */     GIR_RootConstrainSelectedInstOperands,
     /* 373658 */     // GIR_Coverage, 585,
     /* 373658 */     GIR_Done,
     /* 373659 */   // Label 7508: @373659
     /* 373659 */   GIM_Reject,
     /* 373660 */ // Label 7505: @373660
     /* 373660 */ GIM_Reject,
     /* 373661 */ // Label 7494: @373661
     /* 373661 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(373832),
     /* 373666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 373672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373676 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(373740), // Rule ID 6906 //
     /* 373681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373718 */     // MIs[2] Rn
     /* 373718 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373723 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 373727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373729 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 373729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 373732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373738 */     GIR_RootConstrainSelectedInstOperands,
     /* 373739 */     // GIR_Coverage, 6906,
     /* 373739 */     GIR_EraseRootFromParent_Done,
     /* 373740 */   // Label 7510: @373740
     /* 373740 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(373804), // Rule ID 13911 //
     /* 373745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373766 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 373770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373782 */     // MIs[2] Rn
     /* 373782 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373787 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373793 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 373793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 373796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373802 */     GIR_RootConstrainSelectedInstOperands,
     /* 373803 */     // GIR_Coverage, 13911,
     /* 373803 */     GIR_EraseRootFromParent_Done,
     /* 373804 */   // Label 7511: @373804
     /* 373804 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(373831), // Rule ID 587 //
     /* 373809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373820 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 373820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 373825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373829 */     GIR_RootConstrainSelectedInstOperands,
     /* 373830 */     // GIR_Coverage, 587,
     /* 373830 */     GIR_Done,
     /* 373831 */   // Label 7512: @373831
     /* 373831 */   GIM_Reject,
     /* 373832 */ // Label 7509: @373832
     /* 373832 */ GIM_Reject,
     /* 373833 */ // Label 7495: @373833
     /* 373833 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(373870), // Rule ID 1202 //
     /* 373838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 373847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373859 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 373859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 373864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373868 */   GIR_RootConstrainSelectedInstOperands,
     /* 373869 */   // GIR_Coverage, 1202,
     /* 373869 */   GIR_Done,
     /* 373870 */ // Label 7513: @373870
     /* 373870 */ GIM_Reject,
     /* 373871 */ // Label 7496: @373871
     /* 373871 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(373908), // Rule ID 1206 //
     /* 373876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 373885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373897 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 373897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 373902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373906 */   GIR_RootConstrainSelectedInstOperands,
     /* 373907 */   // GIR_Coverage, 1206,
     /* 373907 */   GIR_Done,
     /* 373908 */ // Label 7514: @373908
     /* 373908 */ GIM_Reject,
     /* 373909 */ // Label 7497: @373909
     /* 373909 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(373946), // Rule ID 1198 //
     /* 373914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 373923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373935 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 373935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 373940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373944 */   GIR_RootConstrainSelectedInstOperands,
     /* 373945 */   // GIR_Coverage, 1198,
     /* 373945 */   GIR_Done,
     /* 373946 */ // Label 7515: @373946
     /* 373946 */ GIM_Reject,
     /* 373947 */ // Label 7498: @373947
     /* 373947 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(373984), // Rule ID 1204 //
     /* 373952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 373961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373973 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 373973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 373978 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373982 */   GIR_RootConstrainSelectedInstOperands,
     /* 373983 */   // GIR_Coverage, 1204,
     /* 373983 */   GIR_Done,
     /* 373984 */ // Label 7516: @373984
     /* 373984 */ GIM_Reject,
     /* 373985 */ // Label 7499: @373985
     /* 373985 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(374282),
     /* 373990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 373996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374008 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(374027), // Rule ID 1200 //
     /* 374013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374016 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 374016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 374021 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374025 */     GIR_RootConstrainSelectedInstOperands,
     /* 374026 */     // GIR_Coverage, 1200,
     /* 374026 */     GIR_Done,
     /* 374027 */   // Label 7518: @374027
     /* 374027 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(374281), // Rule ID 6999 //
     /* 374032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374035 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 374035 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 374038 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374042 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374047 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 374051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 374053 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 374056 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374060 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374065 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 374071 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 374074 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 374078 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374083 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 374086 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 374089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 374091 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 374094 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374098 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374103 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374109 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374114 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374119 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374122 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374126 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374131 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374136 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374139 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374143 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374148 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374154 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374159 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374164 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374167 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374171 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374176 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374181 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374184 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 374188 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374193 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374196 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 374199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374201 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374204 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374208 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374213 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 374279 */     GIR_RootConstrainSelectedInstOperands,
     /* 374280 */     // GIR_Coverage, 6999,
     /* 374280 */     GIR_EraseRootFromParent_Done,
     /* 374281 */   // Label 7519: @374281
     /* 374281 */   GIM_Reject,
     /* 374282 */ // Label 7517: @374282
     /* 374282 */ GIM_Reject,
     /* 374283 */ // Label 7500: @374283
     /* 374283 */ GIM_Reject,
     /* 374284 */ // Label 102: @374284
     /* 374284 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7528*/ GIMT_Encode4(374899),
     /* 374295 */ /*GILLT_s16*//*Label 7520*/ GIMT_Encode4(374335),
     /* 374299 */ /*GILLT_s32*//*Label 7521*/ GIMT_Encode4(374373),
     /* 374303 */ /*GILLT_s64*//*Label 7522*/ GIMT_Encode4(374411), GIMT_Encode4(0),
     /* 374311 */ /*GILLT_v2s32*//*Label 7523*/ GIMT_Encode4(374449),
     /* 374315 */ /*GILLT_v2s64*//*Label 7524*/ GIMT_Encode4(374487),
     /* 374319 */ /*GILLT_v4s16*//*Label 7525*/ GIMT_Encode4(374525),
     /* 374323 */ /*GILLT_v4s32*//*Label 7526*/ GIMT_Encode4(374563), GIMT_Encode4(0),
     /* 374331 */ /*GILLT_v8s16*//*Label 7527*/ GIMT_Encode4(374601),
     /* 374335 */ // Label 7520: @374335
     /* 374335 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(374372), // Rule ID 631 //
     /* 374340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374361 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 374361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 374366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374370 */   GIR_RootConstrainSelectedInstOperands,
     /* 374371 */   // GIR_Coverage, 631,
     /* 374371 */   GIR_Done,
     /* 374372 */ // Label 7529: @374372
     /* 374372 */ GIM_Reject,
     /* 374373 */ // Label 7521: @374373
     /* 374373 */ GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(374410), // Rule ID 633 //
     /* 374378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374399 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 374399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 374404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374408 */   GIR_RootConstrainSelectedInstOperands,
     /* 374409 */   // GIR_Coverage, 633,
     /* 374409 */   GIR_Done,
     /* 374410 */ // Label 7530: @374410
     /* 374410 */ GIM_Reject,
     /* 374411 */ // Label 7522: @374411
     /* 374411 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(374448), // Rule ID 635 //
     /* 374416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 374422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 374425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374437 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 374437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 374442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374446 */   GIR_RootConstrainSelectedInstOperands,
     /* 374447 */   // GIR_Coverage, 635,
     /* 374447 */   GIR_Done,
     /* 374448 */ // Label 7531: @374448
     /* 374448 */ GIM_Reject,
     /* 374449 */ // Label 7523: @374449
     /* 374449 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(374486), // Rule ID 1342 //
     /* 374454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 374463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374475 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 374480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374484 */   GIR_RootConstrainSelectedInstOperands,
     /* 374485 */   // GIR_Coverage, 1342,
     /* 374485 */   GIR_Done,
     /* 374486 */ // Label 7532: @374486
     /* 374486 */ GIM_Reject,
     /* 374487 */ // Label 7524: @374487
     /* 374487 */ GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(374524), // Rule ID 1346 //
     /* 374492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374513 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 374513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 374518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374522 */   GIR_RootConstrainSelectedInstOperands,
     /* 374523 */   // GIR_Coverage, 1346,
     /* 374523 */   GIR_Done,
     /* 374524 */ // Label 7533: @374524
     /* 374524 */ GIM_Reject,
     /* 374525 */ // Label 7525: @374525
     /* 374525 */ GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(374562), // Rule ID 1338 //
     /* 374530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 374539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374551 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 374551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 374556 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374560 */   GIR_RootConstrainSelectedInstOperands,
     /* 374561 */   // GIR_Coverage, 1338,
     /* 374561 */   GIR_Done,
     /* 374562 */ // Label 7534: @374562
     /* 374562 */ GIM_Reject,
     /* 374563 */ // Label 7526: @374563
     /* 374563 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(374600), // Rule ID 1344 //
     /* 374568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 374577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374589 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 374589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 374594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374598 */   GIR_RootConstrainSelectedInstOperands,
     /* 374599 */   // GIR_Coverage, 1344,
     /* 374599 */   GIR_Done,
     /* 374600 */ // Label 7535: @374600
     /* 374600 */ GIM_Reject,
     /* 374601 */ // Label 7527: @374601
     /* 374601 */ GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(374898),
     /* 374606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 374612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374624 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(374643), // Rule ID 1340 //
     /* 374629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374632 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 374632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 374637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374641 */     GIR_RootConstrainSelectedInstOperands,
     /* 374642 */     // GIR_Coverage, 1340,
     /* 374642 */     GIR_Done,
     /* 374643 */   // Label 7537: @374643
     /* 374643 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(374897), // Rule ID 7005 //
     /* 374648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 374651 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 374651 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 374654 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374658 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374663 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 374667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 374669 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 374672 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 374676 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374681 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 374685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 374687 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 374690 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 374694 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374699 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 374702 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 374705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 374707 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 374710 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374714 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374719 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374725 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374730 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374735 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 374738 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374742 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374747 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 374750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 374752 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 374755 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374759 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374764 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 374770 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374775 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374780 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 374783 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 374787 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374792 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 374795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 374797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 374800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 374804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374809 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 374812 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 374815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 374817 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 374820 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 374824 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374829 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 374832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 374834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 374837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 374866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 374887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 374895 */     GIR_RootConstrainSelectedInstOperands,
     /* 374896 */     // GIR_Coverage, 7005,
     /* 374896 */     GIR_EraseRootFromParent_Done,
     /* 374897 */   // Label 7538: @374897
     /* 374897 */   GIM_Reject,
     /* 374898 */ // Label 7536: @374898
     /* 374898 */ GIM_Reject,
     /* 374899 */ // Label 7528: @374899
     /* 374899 */ GIM_Reject,
     /* 374900 */ // Label 103: @374900
     /* 374900 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7547*/ GIMT_Encode4(378621),
     /* 374911 */ /*GILLT_s16*//*Label 7539*/ GIMT_Encode4(374951),
     /* 374915 */ /*GILLT_s32*//*Label 7540*/ GIMT_Encode4(375505),
     /* 374919 */ /*GILLT_s64*//*Label 7541*/ GIMT_Encode4(376053), GIMT_Encode4(0),
     /* 374927 */ /*GILLT_v2s32*//*Label 7542*/ GIMT_Encode4(376601),
     /* 374931 */ /*GILLT_v2s64*//*Label 7543*/ GIMT_Encode4(377131),
     /* 374935 */ /*GILLT_v4s16*//*Label 7544*/ GIMT_Encode4(377489),
     /* 374939 */ /*GILLT_v4s32*//*Label 7545*/ GIMT_Encode4(377831), GIMT_Encode4(0),
     /* 374947 */ /*GILLT_v8s16*//*Label 7546*/ GIMT_Encode4(378189),
     /* 374951 */ // Label 7539: @374951
     /* 374951 */ GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(375504),
     /* 374956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 374959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374966 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(375079), // Rule ID 6240 //
     /* 374971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375028 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375032 */     // MIs[3] Operand 1
     /* 375032 */     // No operand predicates
     /* 375032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375034 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 375034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375046 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 375052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 375065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375077 */     GIR_RootConstrainSelectedInstOperands,
     /* 375078 */     // GIR_Coverage, 6240,
     /* 375078 */     GIR_EraseRootFromParent_Done,
     /* 375079 */   // Label 7549: @375079
     /* 375079 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(375192), // Rule ID 13892 //
     /* 375084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375120 */     // MIs[2] Operand 1
     /* 375120 */     // No operand predicates
     /* 375120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 375136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375141 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 375145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375147 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 375147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375159 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 375165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 375178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375190 */     GIR_RootConstrainSelectedInstOperands,
     /* 375191 */     // GIR_Coverage, 13892,
     /* 375191 */     GIR_EraseRootFromParent_Done,
     /* 375192 */   // Label 7550: @375192
     /* 375192 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(375271), // Rule ID 13826 //
     /* 375197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375221 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375231 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 375231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375243 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 375249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 375262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375269 */     GIR_RootConstrainSelectedInstOperands,
     /* 375270 */     // GIR_Coverage, 13826,
     /* 375270 */     GIR_EraseRootFromParent_Done,
     /* 375271 */   // Label 7551: @375271
     /* 375271 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(375350), // Rule ID 4802 //
     /* 375276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375310 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 375310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 375313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 375328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 375341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375348 */     GIR_RootConstrainSelectedInstOperands,
     /* 375349 */     // GIR_Coverage, 4802,
     /* 375349 */     GIR_EraseRootFromParent_Done,
     /* 375350 */   // Label 7552: @375350
     /* 375350 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(375413), // Rule ID 13441 //
     /* 375355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375391 */     // MIs[2] Operand 1
     /* 375391 */     // No operand predicates
     /* 375391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375397 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 375400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375411 */     GIR_RootConstrainSelectedInstOperands,
     /* 375412 */     // GIR_Coverage, 13441,
     /* 375412 */     GIR_EraseRootFromParent_Done,
     /* 375413 */   // Label 7553: @375413
     /* 375413 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(375476), // Rule ID 2011 //
     /* 375418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375458 */     // MIs[2] Operand 1
     /* 375458 */     // No operand predicates
     /* 375458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375460 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 375463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375474 */     GIR_RootConstrainSelectedInstOperands,
     /* 375475 */     // GIR_Coverage, 2011,
     /* 375475 */     GIR_EraseRootFromParent_Done,
     /* 375476 */   // Label 7554: @375476
     /* 375476 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(375503), // Rule ID 619 //
     /* 375481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375492 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 375497 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375501 */     GIR_RootConstrainSelectedInstOperands,
     /* 375502 */     // GIR_Coverage, 619,
     /* 375502 */     GIR_Done,
     /* 375503 */   // Label 7555: @375503
     /* 375503 */   GIM_Reject,
     /* 375504 */ // Label 7548: @375504
     /* 375504 */ GIM_Reject,
     /* 375505 */ // Label 7540: @375505
     /* 375505 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(376052),
     /* 375510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375520 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(375633), // Rule ID 6242 //
     /* 375525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375549 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375582 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375586 */     // MIs[3] Operand 1
     /* 375586 */     // No operand predicates
     /* 375586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375588 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 375619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375631 */     GIR_RootConstrainSelectedInstOperands,
     /* 375632 */     // GIR_Coverage, 6242,
     /* 375632 */     GIR_EraseRootFromParent_Done,
     /* 375633 */   // Label 7557: @375633
     /* 375633 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(375746), // Rule ID 13894 //
     /* 375638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375674 */     // MIs[2] Operand 1
     /* 375674 */     // No operand predicates
     /* 375674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375686 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 375690 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375695 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 375699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375701 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 375732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375744 */     GIR_RootConstrainSelectedInstOperands,
     /* 375745 */     // GIR_Coverage, 13894,
     /* 375745 */     GIR_EraseRootFromParent_Done,
     /* 375746 */   // Label 7558: @375746
     /* 375746 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(375822), // Rule ID 13828 //
     /* 375751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375782 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 375782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 375800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 375813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375820 */     GIR_RootConstrainSelectedInstOperands,
     /* 375821 */     // GIR_Coverage, 13828,
     /* 375821 */     GIR_EraseRootFromParent_Done,
     /* 375822 */   // Label 7559: @375822
     /* 375822 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(375898), // Rule ID 4804 //
     /* 375827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375858 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 375858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 375876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 375889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375896 */     GIR_RootConstrainSelectedInstOperands,
     /* 375897 */     // GIR_Coverage, 4804,
     /* 375897 */     GIR_EraseRootFromParent_Done,
     /* 375898 */   // Label 7560: @375898
     /* 375898 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(375961), // Rule ID 13443 //
     /* 375903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375935 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375939 */     // MIs[2] Operand 1
     /* 375939 */     // No operand predicates
     /* 375939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375945 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 375948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375959 */     GIR_RootConstrainSelectedInstOperands,
     /* 375960 */     // GIR_Coverage, 13443,
     /* 375960 */     GIR_EraseRootFromParent_Done,
     /* 375961 */   // Label 7561: @375961
     /* 375961 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(376024), // Rule ID 2013 //
     /* 375966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376006 */     // MIs[2] Operand 1
     /* 376006 */     // No operand predicates
     /* 376006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376008 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 376011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376022 */     GIR_RootConstrainSelectedInstOperands,
     /* 376023 */     // GIR_Coverage, 2013,
     /* 376023 */     GIR_EraseRootFromParent_Done,
     /* 376024 */   // Label 7562: @376024
     /* 376024 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(376051), // Rule ID 621 //
     /* 376029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376040 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 376040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 376045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376049 */     GIR_RootConstrainSelectedInstOperands,
     /* 376050 */     // GIR_Coverage, 621,
     /* 376050 */     GIR_Done,
     /* 376051 */   // Label 7563: @376051
     /* 376051 */   GIM_Reject,
     /* 376052 */ // Label 7556: @376052
     /* 376052 */ GIM_Reject,
     /* 376053 */ // Label 7541: @376053
     /* 376053 */ GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(376600),
     /* 376058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 376061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 376064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376068 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(376181), // Rule ID 6244 //
     /* 376073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376097 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376130 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 376134 */     // MIs[3] Operand 1
     /* 376134 */     // No operand predicates
     /* 376134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376136 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 376136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376148 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 376167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376179 */     GIR_RootConstrainSelectedInstOperands,
     /* 376180 */     // GIR_Coverage, 6244,
     /* 376180 */     GIR_EraseRootFromParent_Done,
     /* 376181 */   // Label 7565: @376181
     /* 376181 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(376294), // Rule ID 13896 //
     /* 376186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376218 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 376222 */     // MIs[2] Operand 1
     /* 376222 */     // No operand predicates
     /* 376222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376234 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376238 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376243 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376249 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 376249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 376280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376292 */     GIR_RootConstrainSelectedInstOperands,
     /* 376293 */     // GIR_Coverage, 13896,
     /* 376293 */     GIR_EraseRootFromParent_Done,
     /* 376294 */   // Label 7566: @376294
     /* 376294 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(376370), // Rule ID 13830 //
     /* 376299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376320 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376330 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 376330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376342 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 376361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376368 */     GIR_RootConstrainSelectedInstOperands,
     /* 376369 */     // GIR_Coverage, 13830,
     /* 376369 */     GIR_EraseRootFromParent_Done,
     /* 376370 */   // Label 7567: @376370
     /* 376370 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(376446), // Rule ID 4806 //
     /* 376375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376400 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376406 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 376406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 376409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 376437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376444 */     GIR_RootConstrainSelectedInstOperands,
     /* 376445 */     // GIR_Coverage, 4806,
     /* 376445 */     GIR_EraseRootFromParent_Done,
     /* 376446 */   // Label 7568: @376446
     /* 376446 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(376509), // Rule ID 13445 //
     /* 376451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 376487 */     // MIs[2] Operand 1
     /* 376487 */     // No operand predicates
     /* 376487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376493 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 376496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376507 */     GIR_RootConstrainSelectedInstOperands,
     /* 376508 */     // GIR_Coverage, 13445,
     /* 376508 */     GIR_EraseRootFromParent_Done,
     /* 376509 */   // Label 7569: @376509
     /* 376509 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(376572), // Rule ID 2015 //
     /* 376514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 376554 */     // MIs[2] Operand 1
     /* 376554 */     // No operand predicates
     /* 376554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376556 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 376559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376570 */     GIR_RootConstrainSelectedInstOperands,
     /* 376571 */     // GIR_Coverage, 2015,
     /* 376571 */     GIR_EraseRootFromParent_Done,
     /* 376572 */   // Label 7570: @376572
     /* 376572 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(376599), // Rule ID 623 //
     /* 376577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376588 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 376588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 376593 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376597 */     GIR_RootConstrainSelectedInstOperands,
     /* 376598 */     // GIR_Coverage, 623,
     /* 376598 */     GIR_Done,
     /* 376599 */   // Label 7571: @376599
     /* 376599 */   GIM_Reject,
     /* 376600 */ // Label 7564: @376600
     /* 376600 */ GIM_Reject,
     /* 376601 */ // Label 7542: @376601
     /* 376601 */ GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(377130),
     /* 376606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 376612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376616 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(376702), // Rule ID 13433 //
     /* 376621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 376632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376665 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376669 */     // MIs[3] Operand 1
     /* 376669 */     // No operand predicates
     /* 376669 */     // MIs[1] Operand 2
     /* 376669 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 376680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376686 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 376689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376700 */     GIR_RootConstrainSelectedInstOperands,
     /* 376701 */     // GIR_Coverage, 13433,
     /* 376701 */     GIR_EraseRootFromParent_Done,
     /* 376702 */   // Label 7573: @376702
     /* 376702 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(376788), // Rule ID 2003 //
     /* 376707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 376722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376755 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376759 */     // MIs[3] Operand 1
     /* 376759 */     // No operand predicates
     /* 376759 */     // MIs[1] Operand 2
     /* 376759 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 376770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376772 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 376775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376786 */     GIR_RootConstrainSelectedInstOperands,
     /* 376787 */     // GIR_Coverage, 2003,
     /* 376787 */     GIR_EraseRootFromParent_Done,
     /* 376788 */   // Label 7574: @376788
     /* 376788 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(376851), // Rule ID 13434 //
     /* 376793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376829 */     // MIs[2] Operand 1
     /* 376829 */     // No operand predicates
     /* 376829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376835 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 376838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376849 */     GIR_RootConstrainSelectedInstOperands,
     /* 376850 */     // GIR_Coverage, 13434,
     /* 376850 */     GIR_EraseRootFromParent_Done,
     /* 376851 */   // Label 7575: @376851
     /* 376851 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(376914), // Rule ID 2004 //
     /* 376856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 376871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376896 */     // MIs[2] Operand 1
     /* 376896 */     // No operand predicates
     /* 376896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376898 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 376898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 376901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376912 */     GIR_RootConstrainSelectedInstOperands,
     /* 376913 */     // GIR_Coverage, 2004,
     /* 376913 */     GIR_EraseRootFromParent_Done,
     /* 376914 */   // Label 7576: @376914
     /* 376914 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(377008), // Rule ID 13898 //
     /* 376919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376942 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 376945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 376959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376975 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 376978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 376996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377006 */     GIR_RootConstrainSelectedInstOperands,
     /* 377007 */     // GIR_Coverage, 13898,
     /* 377007 */     GIR_EraseRootFromParent_Done,
     /* 377008 */   // Label 7577: @377008
     /* 377008 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(377102), // Rule ID 6246 //
     /* 377013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377036 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377036 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 377039 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377043 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 377053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377062 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 377090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377100 */     GIR_RootConstrainSelectedInstOperands,
     /* 377101 */     // GIR_Coverage, 6246,
     /* 377101 */     GIR_EraseRootFromParent_Done,
     /* 377102 */   // Label 7578: @377102
     /* 377102 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(377129), // Rule ID 1322 //
     /* 377107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377118 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 377118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 377123 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377127 */     GIR_RootConstrainSelectedInstOperands,
     /* 377128 */     // GIR_Coverage, 1322,
     /* 377128 */     GIR_Done,
     /* 377129 */   // Label 7579: @377129
     /* 377129 */   GIM_Reject,
     /* 377130 */ // Label 7572: @377130
     /* 377130 */ GIM_Reject,
     /* 377131 */ // Label 7543: @377131
     /* 377131 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(377488),
     /* 377136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 377142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377146 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(377209), // Rule ID 13439 //
     /* 377151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377187 */     // MIs[2] Operand 1
     /* 377187 */     // No operand predicates
     /* 377187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377193 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 377196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377207 */     GIR_RootConstrainSelectedInstOperands,
     /* 377208 */     // GIR_Coverage, 13439,
     /* 377208 */     GIR_EraseRootFromParent_Done,
     /* 377209 */   // Label 7581: @377209
     /* 377209 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(377272), // Rule ID 2009 //
     /* 377214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 377229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377254 */     // MIs[2] Operand 1
     /* 377254 */     // No operand predicates
     /* 377254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377256 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 377259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377270 */     GIR_RootConstrainSelectedInstOperands,
     /* 377271 */     // GIR_Coverage, 2009,
     /* 377271 */     GIR_EraseRootFromParent_Done,
     /* 377272 */   // Label 7582: @377272
     /* 377272 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(377366), // Rule ID 13902 //
     /* 377277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 377289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377300 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 377303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 377317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 377354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377364 */     GIR_RootConstrainSelectedInstOperands,
     /* 377365 */     // GIR_Coverage, 13902,
     /* 377365 */     GIR_EraseRootFromParent_Done,
     /* 377366 */   // Label 7583: @377366
     /* 377366 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(377460), // Rule ID 6250 //
     /* 377371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 377387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377394 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 377397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 377411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 377448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377458 */     GIR_RootConstrainSelectedInstOperands,
     /* 377459 */     // GIR_Coverage, 6250,
     /* 377459 */     GIR_EraseRootFromParent_Done,
     /* 377460 */   // Label 7584: @377460
     /* 377460 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(377487), // Rule ID 1326 //
     /* 377465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377476 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 377476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 377481 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377485 */     GIR_RootConstrainSelectedInstOperands,
     /* 377486 */     // GIR_Coverage, 1326,
     /* 377486 */     GIR_Done,
     /* 377487 */   // Label 7585: @377487
     /* 377487 */   GIM_Reject,
     /* 377488 */ // Label 7580: @377488
     /* 377488 */ GIM_Reject,
     /* 377489 */ // Label 7544: @377489
     /* 377489 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(377830),
     /* 377494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 377500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377504 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(377590), // Rule ID 13427 //
     /* 377509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 377520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 377532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377553 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377557 */     // MIs[3] Operand 1
     /* 377557 */     // No operand predicates
     /* 377557 */     // MIs[1] Operand 2
     /* 377557 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 377568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377574 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 377577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377588 */     GIR_RootConstrainSelectedInstOperands,
     /* 377589 */     // GIR_Coverage, 13427,
     /* 377589 */     GIR_EraseRootFromParent_Done,
     /* 377590 */   // Label 7587: @377590
     /* 377590 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(377676), // Rule ID 1997 //
     /* 377595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 377610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 377622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377643 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377647 */     // MIs[3] Operand 1
     /* 377647 */     // No operand predicates
     /* 377647 */     // MIs[1] Operand 2
     /* 377647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 377658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377660 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 377663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377674 */     GIR_RootConstrainSelectedInstOperands,
     /* 377675 */     // GIR_Coverage, 1997,
     /* 377675 */     GIR_EraseRootFromParent_Done,
     /* 377676 */   // Label 7588: @377676
     /* 377676 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(377739), // Rule ID 13428 //
     /* 377681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 377692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377717 */     // MIs[2] Operand 1
     /* 377717 */     // No operand predicates
     /* 377717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377723 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 377726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377737 */     GIR_RootConstrainSelectedInstOperands,
     /* 377738 */     // GIR_Coverage, 13428,
     /* 377738 */     GIR_EraseRootFromParent_Done,
     /* 377739 */   // Label 7589: @377739
     /* 377739 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(377802), // Rule ID 1998 //
     /* 377744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 377759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377784 */     // MIs[2] Operand 1
     /* 377784 */     // No operand predicates
     /* 377784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377786 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 377789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377800 */     GIR_RootConstrainSelectedInstOperands,
     /* 377801 */     // GIR_Coverage, 1998,
     /* 377801 */     GIR_EraseRootFromParent_Done,
     /* 377802 */   // Label 7590: @377802
     /* 377802 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(377829), // Rule ID 1318 //
     /* 377807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377818 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 377823 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377827 */     GIR_RootConstrainSelectedInstOperands,
     /* 377828 */     // GIR_Coverage, 1318,
     /* 377828 */     GIR_Done,
     /* 377829 */   // Label 7591: @377829
     /* 377829 */   GIM_Reject,
     /* 377830 */ // Label 7586: @377830
     /* 377830 */ GIM_Reject,
     /* 377831 */ // Label 7545: @377831
     /* 377831 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(378188),
     /* 377836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 377842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377846 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(377909), // Rule ID 13437 //
     /* 377851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377887 */     // MIs[2] Operand 1
     /* 377887 */     // No operand predicates
     /* 377887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377893 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 377896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377907 */     GIR_RootConstrainSelectedInstOperands,
     /* 377908 */     // GIR_Coverage, 13437,
     /* 377908 */     GIR_EraseRootFromParent_Done,
     /* 377909 */   // Label 7593: @377909
     /* 377909 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(377972), // Rule ID 2007 //
     /* 377914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377954 */     // MIs[2] Operand 1
     /* 377954 */     // No operand predicates
     /* 377954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377956 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 377956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 377959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377970 */     GIR_RootConstrainSelectedInstOperands,
     /* 377971 */     // GIR_Coverage, 2007,
     /* 377971 */     GIR_EraseRootFromParent_Done,
     /* 377972 */   // Label 7594: @377972
     /* 377972 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(378066), // Rule ID 13900 //
     /* 377977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378000 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 378054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378064 */     GIR_RootConstrainSelectedInstOperands,
     /* 378065 */     // GIR_Coverage, 13900,
     /* 378065 */     GIR_EraseRootFromParent_Done,
     /* 378066 */   // Label 7595: @378066
     /* 378066 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(378160), // Rule ID 6248 //
     /* 378071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378094 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 378097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 378111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378127 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 378148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378158 */     GIR_RootConstrainSelectedInstOperands,
     /* 378159 */     // GIR_Coverage, 6248,
     /* 378159 */     GIR_EraseRootFromParent_Done,
     /* 378160 */   // Label 7596: @378160
     /* 378160 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(378187), // Rule ID 1324 //
     /* 378165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378176 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 378181 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378185 */     GIR_RootConstrainSelectedInstOperands,
     /* 378186 */     // GIR_Coverage, 1324,
     /* 378186 */     GIR_Done,
     /* 378187 */   // Label 7597: @378187
     /* 378187 */   GIM_Reject,
     /* 378188 */ // Label 7592: @378188
     /* 378188 */ GIM_Reject,
     /* 378189 */ // Label 7546: @378189
     /* 378189 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(378620),
     /* 378194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 378200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378204 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(378267), // Rule ID 13431 //
     /* 378209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378245 */     // MIs[2] Operand 1
     /* 378245 */     // No operand predicates
     /* 378245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378251 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 378254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378265 */     GIR_RootConstrainSelectedInstOperands,
     /* 378266 */     // GIR_Coverage, 13431,
     /* 378266 */     GIR_EraseRootFromParent_Done,
     /* 378267 */   // Label 7599: @378267
     /* 378267 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(378330), // Rule ID 2001 //
     /* 378272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378312 */     // MIs[2] Operand 1
     /* 378312 */     // No operand predicates
     /* 378312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378314 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 378314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 378317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378328 */     GIR_RootConstrainSelectedInstOperands,
     /* 378329 */     // GIR_Coverage, 2001,
     /* 378329 */     GIR_EraseRootFromParent_Done,
     /* 378330 */   // Label 7600: @378330
     /* 378330 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(378357), // Rule ID 1320 //
     /* 378335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378346 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 378346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 378351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378355 */     GIR_RootConstrainSelectedInstOperands,
     /* 378356 */     // GIR_Coverage, 1320,
     /* 378356 */     GIR_Done,
     /* 378357 */   // Label 7601: @378357
     /* 378357 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(378619), // Rule ID 7003 //
     /* 378362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 378365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378373 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 378373 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 378376 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 378380 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378385 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 378389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 378391 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 378394 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 378398 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378403 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 378407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 378409 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 378412 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 378416 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378421 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 378424 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 378427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 378429 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 378432 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378436 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378441 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 378447 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378452 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378457 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 378460 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 378464 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378469 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 378472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 378474 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 378477 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378481 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378486 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378492 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378497 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378502 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 378505 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 378509 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378514 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 378517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 378519 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 378522 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 378526 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378531 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 378534 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 378537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378539 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 378542 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 378546 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378551 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 378554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 378559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 378563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 378577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 378591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 378609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 378617 */     GIR_RootConstrainSelectedInstOperands,
     /* 378618 */     // GIR_Coverage, 7003,
     /* 378618 */     GIR_EraseRootFromParent_Done,
     /* 378619 */   // Label 7602: @378619
     /* 378619 */   GIM_Reject,
     /* 378620 */ // Label 7598: @378620
     /* 378620 */ GIM_Reject,
     /* 378621 */ // Label 7547: @378621
     /* 378621 */ GIM_Reject,
     /* 378622 */ // Label 104: @378622
     /* 378622 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7611*/ GIMT_Encode4(379237),
     /* 378633 */ /*GILLT_s16*//*Label 7603*/ GIMT_Encode4(378673),
     /* 378637 */ /*GILLT_s32*//*Label 7604*/ GIMT_Encode4(378711),
     /* 378641 */ /*GILLT_s64*//*Label 7605*/ GIMT_Encode4(378749), GIMT_Encode4(0),
     /* 378649 */ /*GILLT_v2s32*//*Label 7606*/ GIMT_Encode4(378787),
     /* 378653 */ /*GILLT_v2s64*//*Label 7607*/ GIMT_Encode4(378825),
     /* 378657 */ /*GILLT_v4s16*//*Label 7608*/ GIMT_Encode4(378863),
     /* 378661 */ /*GILLT_v4s32*//*Label 7609*/ GIMT_Encode4(378901), GIMT_Encode4(0),
     /* 378669 */ /*GILLT_v8s16*//*Label 7610*/ GIMT_Encode4(378939),
     /* 378673 */ // Label 7603: @378673
     /* 378673 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(378710), // Rule ID 589 //
     /* 378678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 378684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 378687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378699 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 378699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 378704 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378708 */   GIR_RootConstrainSelectedInstOperands,
     /* 378709 */   // GIR_Coverage, 589,
     /* 378709 */   GIR_Done,
     /* 378710 */ // Label 7612: @378710
     /* 378710 */ GIM_Reject,
     /* 378711 */ // Label 7604: @378711
     /* 378711 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(378748), // Rule ID 591 //
     /* 378716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 378722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378737 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 378737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 378742 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378746 */   GIR_RootConstrainSelectedInstOperands,
     /* 378747 */   // GIR_Coverage, 591,
     /* 378747 */   GIR_Done,
     /* 378748 */ // Label 7613: @378748
     /* 378748 */ GIM_Reject,
     /* 378749 */ // Label 7605: @378749
     /* 378749 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(378786), // Rule ID 593 //
     /* 378754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 378760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 378763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378775 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 378775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 378780 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378784 */   GIR_RootConstrainSelectedInstOperands,
     /* 378785 */   // GIR_Coverage, 593,
     /* 378785 */   GIR_Done,
     /* 378786 */ // Label 7614: @378786
     /* 378786 */ GIM_Reject,
     /* 378787 */ // Label 7606: @378787
     /* 378787 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(378824), // Rule ID 1227 //
     /* 378792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 378798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 378801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378813 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 378813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 378818 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378822 */   GIR_RootConstrainSelectedInstOperands,
     /* 378823 */   // GIR_Coverage, 1227,
     /* 378823 */   GIR_Done,
     /* 378824 */ // Label 7615: @378824
     /* 378824 */ GIM_Reject,
     /* 378825 */ // Label 7607: @378825
     /* 378825 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(378862), // Rule ID 1231 //
     /* 378830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 378839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378851 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 378851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 378856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378860 */   GIR_RootConstrainSelectedInstOperands,
     /* 378861 */   // GIR_Coverage, 1231,
     /* 378861 */   GIR_Done,
     /* 378862 */ // Label 7616: @378862
     /* 378862 */ GIM_Reject,
     /* 378863 */ // Label 7608: @378863
     /* 378863 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(378900), // Rule ID 1223 //
     /* 378868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 378874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 378877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378889 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 378889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 378894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378898 */   GIR_RootConstrainSelectedInstOperands,
     /* 378899 */   // GIR_Coverage, 1223,
     /* 378899 */   GIR_Done,
     /* 378900 */ // Label 7617: @378900
     /* 378900 */ GIM_Reject,
     /* 378901 */ // Label 7609: @378901
     /* 378901 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(378938), // Rule ID 1229 //
     /* 378906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 378915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378927 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 378932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378936 */   GIR_RootConstrainSelectedInstOperands,
     /* 378937 */   // GIR_Coverage, 1229,
     /* 378937 */   GIR_Done,
     /* 378938 */ // Label 7618: @378938
     /* 378938 */ GIM_Reject,
     /* 378939 */ // Label 7610: @378939
     /* 378939 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(379236),
     /* 378944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 378950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378962 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(378981), // Rule ID 1225 //
     /* 378967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378970 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 378970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 378975 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378979 */     GIR_RootConstrainSelectedInstOperands,
     /* 378980 */     // GIR_Coverage, 1225,
     /* 378980 */     GIR_Done,
     /* 378981 */   // Label 7620: @378981
     /* 378981 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(379235), // Rule ID 7001 //
     /* 378986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 378989 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 378989 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 378992 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 378996 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379001 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 379005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 379007 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 379010 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 379014 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379019 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 379023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 379025 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 379028 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 379032 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379037 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 379040 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 379043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 379045 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 379048 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379052 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379057 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 379063 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379068 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379073 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 379076 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 379080 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379085 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 379088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 379090 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 379093 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379097 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379102 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 379108 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379113 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379118 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 379121 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 379125 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379130 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 379133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 379135 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 379138 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 379142 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379147 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 379150 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 379153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379155 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 379158 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 379162 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379167 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 379170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 379175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 379179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 379189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 379193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 379207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 379225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 379233 */     GIR_RootConstrainSelectedInstOperands,
     /* 379234 */     // GIR_Coverage, 7001,
     /* 379234 */     GIR_EraseRootFromParent_Done,
     /* 379235 */   // Label 7621: @379235
     /* 379235 */   GIM_Reject,
     /* 379236 */ // Label 7619: @379236
     /* 379236 */ GIM_Reject,
     /* 379237 */ // Label 7611: @379237
     /* 379237 */ GIM_Reject,
     /* 379238 */ // Label 105: @379238
     /* 379238 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7630*/ GIMT_Encode4(394844),
     /* 379249 */ /*GILLT_s16*//*Label 7622*/ GIMT_Encode4(379289),
     /* 379253 */ /*GILLT_s32*//*Label 7623*/ GIMT_Encode4(382063),
     /* 379257 */ /*GILLT_s64*//*Label 7624*/ GIMT_Encode4(384993), GIMT_Encode4(0),
     /* 379265 */ /*GILLT_v2s32*//*Label 7625*/ GIMT_Encode4(387923),
     /* 379269 */ /*GILLT_v2s64*//*Label 7626*/ GIMT_Encode4(389444),
     /* 379273 */ /*GILLT_v4s16*//*Label 7627*/ GIMT_Encode4(390965),
     /* 379277 */ /*GILLT_v4s32*//*Label 7628*/ GIMT_Encode4(392144), GIMT_Encode4(0),
     /* 379285 */ /*GILLT_v8s16*//*Label 7629*/ GIMT_Encode4(393665),
     /* 379289 */ // Label 7622: @379289
     /* 379289 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(382062),
     /* 379294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 379297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 379300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 379303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379307 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(379457), // Rule ID 4864 //
     /* 379312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379336 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379361 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 379369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 379377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379384 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 379384 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 379387 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379391 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379396 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 379402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 379443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 379455 */     GIR_RootConstrainSelectedInstOperands,
     /* 379456 */     // GIR_Coverage, 4864,
     /* 379456 */     GIR_EraseRootFromParent_Done,
     /* 379457 */   // Label 7632: @379457
     /* 379457 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(379604), // Rule ID 4828 //
     /* 379462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379486 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379518 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379523 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379533 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 379533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 379536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379545 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 379551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379602 */     GIR_RootConstrainSelectedInstOperands,
     /* 379603 */     // GIR_Coverage, 4828,
     /* 379603 */     GIR_EraseRootFromParent_Done,
     /* 379604 */   // Label 7633: @379604
     /* 379604 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(379751), // Rule ID 13839 //
     /* 379609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379645 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379657 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379661 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379665 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379670 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379680 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 379680 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 379683 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379687 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379692 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 379698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379749 */     GIR_RootConstrainSelectedInstOperands,
     /* 379750 */     // GIR_Coverage, 13839,
     /* 379750 */     GIR_EraseRootFromParent_Done,
     /* 379751 */   // Label 7634: @379751
     /* 379751 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379882), // Rule ID 6078 //
     /* 379756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379804 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379808 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379812 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379817 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 379821 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379825 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379829 */     // MIs[4] Operand 1
     /* 379829 */     // No operand predicates
     /* 379829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379833 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379835 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 379866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379880 */     GIR_RootConstrainSelectedInstOperands,
     /* 379881 */     // GIR_Coverage, 6078,
     /* 379881 */     GIR_EraseRootFromParent_Done,
     /* 379882 */   // Label 7635: @379882
     /* 379882 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(380013), // Rule ID 6110 //
     /* 379887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379923 */     // MIs[2] Operand 1
     /* 379923 */     // No operand predicates
     /* 379923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 379935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 379939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379951 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379956 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379966 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379978 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 379997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380011 */     GIR_RootConstrainSelectedInstOperands,
     /* 380012 */     // GIR_Coverage, 6110,
     /* 380012 */     GIR_EraseRootFromParent_Done,
     /* 380013 */   // Label 7636: @380013
     /* 380013 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(380144), // Rule ID 6174 //
     /* 380018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380054 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380074 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 380079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 380083 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380087 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 380091 */     // MIs[4] Operand 1
     /* 380091 */     // No operand predicates
     /* 380091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380095 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380097 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 380097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380109 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 380128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 380139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 380142 */     GIR_RootConstrainSelectedInstOperands,
     /* 380143 */     // GIR_Coverage, 6174,
     /* 380143 */     GIR_EraseRootFromParent_Done,
     /* 380144 */   // Label 7637: @380144
     /* 380144 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(380275), // Rule ID 6142 //
     /* 380149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 380185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 380197 */     // MIs[3] Operand 1
     /* 380197 */     // No operand predicates
     /* 380197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 380201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380205 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 380213 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380218 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 380222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380228 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 380228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380240 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 380259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380273 */     GIR_RootConstrainSelectedInstOperands,
     /* 380274 */     // GIR_Coverage, 6142,
     /* 380274 */     GIR_EraseRootFromParent_Done,
     /* 380275 */   // Label 7638: @380275
     /* 380275 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(380410), // Rule ID 2455 //
     /* 380280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380339 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 380339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 380342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380351 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 380357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380379 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 380398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380408 */     GIR_RootConstrainSelectedInstOperands,
     /* 380409 */     // GIR_Coverage, 2455,
     /* 380409 */     GIR_EraseRootFromParent_Done,
     /* 380410 */   // Label 7639: @380410
     /* 380410 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(380529), // Rule ID 6046 //
     /* 380415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380439 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 380464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380472 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 380476 */     // MIs[3] Operand 1
     /* 380476 */     // No operand predicates
     /* 380476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380482 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 380482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380494 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 380513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380527 */     GIR_RootConstrainSelectedInstOperands,
     /* 380528 */     // GIR_Coverage, 6046,
     /* 380528 */     GIR_EraseRootFromParent_Done,
     /* 380529 */   // Label 7640: @380529
     /* 380529 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(380648), // Rule ID 2537 //
     /* 380534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 380558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 380570 */     // MIs[2] Operand 1
     /* 380570 */     // No operand predicates
     /* 380570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380591 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 380595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380601 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 380601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 380632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380646 */     GIR_RootConstrainSelectedInstOperands,
     /* 380647 */     // GIR_Coverage, 2537,
     /* 380647 */     GIR_EraseRootFromParent_Done,
     /* 380648 */   // Label 7641: @380648
     /* 380648 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(380748), // Rule ID 4826 //
     /* 380653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380677 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380704 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 380704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380716 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 380735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380746 */     GIR_RootConstrainSelectedInstOperands,
     /* 380747 */     // GIR_Coverage, 4826,
     /* 380747 */     GIR_EraseRootFromParent_Done,
     /* 380748 */   // Label 7642: @380748
     /* 380748 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(380848), // Rule ID 4862 //
     /* 380753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380777 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 380789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380804 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 380804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 380822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 380835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380846 */     GIR_RootConstrainSelectedInstOperands,
     /* 380847 */     // GIR_Coverage, 4862,
     /* 380847 */     GIR_EraseRootFromParent_Done,
     /* 380848 */   // Label 7643: @380848
     /* 380848 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(380945), // Rule ID 13835 //
     /* 380853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380889 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380903 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 380903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 380906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380915 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 380921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 380934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380943 */     GIR_RootConstrainSelectedInstOperands,
     /* 380944 */     // GIR_Coverage, 13835,
     /* 380944 */     GIR_EraseRootFromParent_Done,
     /* 380945 */   // Label 7644: @380945
     /* 380945 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(381045), // Rule ID 13837 //
     /* 380950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381001 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 381001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381013 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381043 */     GIR_RootConstrainSelectedInstOperands,
     /* 381044 */     // GIR_Coverage, 13837,
     /* 381044 */     GIR_EraseRootFromParent_Done,
     /* 381045 */   // Label 7645: @381045
     /* 381045 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(381145), // Rule ID 4860 //
     /* 381050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 381086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381101 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381113 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 381132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 381143 */     GIR_RootConstrainSelectedInstOperands,
     /* 381144 */     // GIR_Coverage, 4860,
     /* 381144 */     GIR_EraseRootFromParent_Done,
     /* 381145 */   // Label 7646: @381145
     /* 381145 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(381242), // Rule ID 4824 //
     /* 381150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381190 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381200 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381212 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381240 */     GIR_RootConstrainSelectedInstOperands,
     /* 381241 */     // GIR_Coverage, 4824,
     /* 381241 */     GIR_EraseRootFromParent_Done,
     /* 381242 */   // Label 7647: @381242
     /* 381242 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(381326), // Rule ID 6108 //
     /* 381247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381283 */     // MIs[2] Operand 1
     /* 381283 */     // No operand predicates
     /* 381283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 381295 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381306 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 381317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381324 */     GIR_RootConstrainSelectedInstOperands,
     /* 381325 */     // GIR_Coverage, 6108,
     /* 381325 */     GIR_EraseRootFromParent_Done,
     /* 381326 */   // Label 7648: @381326
     /* 381326 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(381407), // Rule ID 6140 //
     /* 381331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381379 */     // MIs[3] Operand 1
     /* 381379 */     // No operand predicates
     /* 381379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381389 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381405 */     GIR_RootConstrainSelectedInstOperands,
     /* 381406 */     // GIR_Coverage, 6140,
     /* 381406 */     GIR_EraseRootFromParent_Done,
     /* 381407 */   // Label 7649: @381407
     /* 381407 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(381491), // Rule ID 6172 //
     /* 381412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381461 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381465 */     // MIs[3] Operand 1
     /* 381465 */     // No operand predicates
     /* 381465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381471 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381489 */     GIR_RootConstrainSelectedInstOperands,
     /* 381490 */     // GIR_Coverage, 6172,
     /* 381490 */     GIR_EraseRootFromParent_Done,
     /* 381491 */   // Label 7650: @381491
     /* 381491 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(381572), // Rule ID 6076 //
     /* 381496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381548 */     // MIs[3] Operand 1
     /* 381548 */     // No operand predicates
     /* 381548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381554 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 381557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381570 */     GIR_RootConstrainSelectedInstOperands,
     /* 381571 */     // GIR_Coverage, 6076,
     /* 381571 */     GIR_EraseRootFromParent_Done,
     /* 381572 */   // Label 7651: @381572
     /* 381572 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(381657), // Rule ID 2453 //
     /* 381577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381601 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381615 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 381615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381627 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 381633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 381646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381655 */     GIR_RootConstrainSelectedInstOperands,
     /* 381656 */     // GIR_Coverage, 2453,
     /* 381656 */     GIR_EraseRootFromParent_Done,
     /* 381657 */   // Label 7652: @381657
     /* 381657 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(381742), // Rule ID 2451 //
     /* 381662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381690 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381700 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 381700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381712 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 381718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 381731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381740 */     GIR_RootConstrainSelectedInstOperands,
     /* 381741 */     // GIR_Coverage, 2451,
     /* 381741 */     GIR_EraseRootFromParent_Done,
     /* 381742 */   // Label 7653: @381742
     /* 381742 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(381811), // Rule ID 2535 //
     /* 381747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381783 */     // MIs[2] Operand 1
     /* 381783 */     // No operand predicates
     /* 381783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381793 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 381796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381809 */     GIR_RootConstrainSelectedInstOperands,
     /* 381810 */     // GIR_Coverage, 2535,
     /* 381810 */     GIR_EraseRootFromParent_Done,
     /* 381811 */   // Label 7654: @381811
     /* 381811 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(381880), // Rule ID 6044 //
     /* 381816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 381844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 381856 */     // MIs[2] Operand 1
     /* 381856 */     // No operand predicates
     /* 381856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381862 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 381862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 381865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381878 */     GIR_RootConstrainSelectedInstOperands,
     /* 381879 */     // GIR_Coverage, 6044,
     /* 381879 */     GIR_EraseRootFromParent_Done,
     /* 381880 */   // Label 7655: @381880
     /* 381880 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(381930), // Rule ID 13281 //
     /* 381885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381915 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 381915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381928 */     GIR_RootConstrainSelectedInstOperands,
     /* 381929 */     // GIR_Coverage, 13281,
     /* 381929 */     GIR_EraseRootFromParent_Done,
     /* 381930 */   // Label 7656: @381930
     /* 381930 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(381980), // Rule ID 643 //
     /* 381935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381965 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 381965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 381968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381978 */     GIR_RootConstrainSelectedInstOperands,
     /* 381979 */     // GIR_Coverage, 643,
     /* 381979 */     GIR_EraseRootFromParent_Done,
     /* 381980 */   // Label 7657: @381980
     /* 381980 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(382030), // Rule ID 655 //
     /* 381985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 381988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 382000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382015 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 382018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 382028 */     GIR_RootConstrainSelectedInstOperands,
     /* 382029 */     // GIR_Coverage, 655,
     /* 382029 */     GIR_EraseRootFromParent_Done,
     /* 382030 */   // Label 7658: @382030
     /* 382030 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(382061), // Rule ID 637 //
     /* 382035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 382038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382050 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 382050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 382055 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382059 */     GIR_RootConstrainSelectedInstOperands,
     /* 382060 */     // GIR_Coverage, 637,
     /* 382060 */     GIR_Done,
     /* 382061 */   // Label 7659: @382061
     /* 382061 */   GIM_Reject,
     /* 382062 */ // Label 7631: @382062
     /* 382062 */ GIM_Reject,
     /* 382063 */ // Label 7623: @382063
     /* 382063 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(384992),
     /* 382068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 382071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 382077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382081 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(382231), // Rule ID 4870 //
     /* 382086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382135 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 382143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 382151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382158 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 382158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 382161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382170 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 382176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 382217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 382229 */     GIR_RootConstrainSelectedInstOperands,
     /* 382230 */     // GIR_Coverage, 4870,
     /* 382230 */     GIR_EraseRootFromParent_Done,
     /* 382231 */   // Label 7661: @382231
     /* 382231 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(382378), // Rule ID 4834 //
     /* 382236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382260 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382292 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382297 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382307 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 382307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 382310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382319 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 382325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382376 */     GIR_RootConstrainSelectedInstOperands,
     /* 382377 */     // GIR_Coverage, 4834,
     /* 382377 */     GIR_EraseRootFromParent_Done,
     /* 382378 */   // Label 7662: @382378
     /* 382378 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(382525), // Rule ID 13845 //
     /* 382383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382419 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382439 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382444 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382454 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 382454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 382457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382466 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 382472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382494 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382523 */     GIR_RootConstrainSelectedInstOperands,
     /* 382524 */     // GIR_Coverage, 13845,
     /* 382524 */     GIR_EraseRootFromParent_Done,
     /* 382525 */   // Label 7663: @382525
     /* 382525 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(382656), // Rule ID 6094 //
     /* 382530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382554 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382591 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382595 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382599 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382603 */     // MIs[4] Operand 1
     /* 382603 */     // No operand predicates
     /* 382603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382607 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382609 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382621 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382654 */     GIR_RootConstrainSelectedInstOperands,
     /* 382655 */     // GIR_Coverage, 6094,
     /* 382655 */     GIR_EraseRootFromParent_Done,
     /* 382656 */   // Label 7664: @382656
     /* 382656 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(382787), // Rule ID 6126 //
     /* 382661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382697 */     // MIs[2] Operand 1
     /* 382697 */     // No operand predicates
     /* 382697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 382709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 382713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382725 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382730 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382738 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382740 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382752 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382785 */     GIR_RootConstrainSelectedInstOperands,
     /* 382786 */     // GIR_Coverage, 6126,
     /* 382786 */     GIR_EraseRootFromParent_Done,
     /* 382787 */   // Label 7665: @382787
     /* 382787 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(382918), // Rule ID 6190 //
     /* 382792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382828 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382848 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382861 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382865 */     // MIs[4] Operand 1
     /* 382865 */     // No operand predicates
     /* 382865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382869 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382871 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382916 */     GIR_RootConstrainSelectedInstOperands,
     /* 382917 */     // GIR_Coverage, 6190,
     /* 382917 */     GIR_EraseRootFromParent_Done,
     /* 382918 */   // Label 7666: @382918
     /* 382918 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383049), // Rule ID 6158 //
     /* 382923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382971 */     // MIs[3] Operand 1
     /* 382971 */     // No operand predicates
     /* 382971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 382975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382979 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382983 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382987 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382992 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383000 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383002 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383014 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 383033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383047 */     GIR_RootConstrainSelectedInstOperands,
     /* 383048 */     // GIR_Coverage, 6158,
     /* 383048 */     GIR_EraseRootFromParent_Done,
     /* 383049 */   // Label 7667: @383049
     /* 383049 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383184), // Rule ID 2461 //
     /* 383054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383103 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383113 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 383116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383125 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383153 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 383172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383182 */     GIR_RootConstrainSelectedInstOperands,
     /* 383183 */     // GIR_Coverage, 2461,
     /* 383183 */     GIR_EraseRootFromParent_Done,
     /* 383184 */   // Label 7668: @383184
     /* 383184 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383303), // Rule ID 6062 //
     /* 383189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383246 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 383250 */     // MIs[3] Operand 1
     /* 383250 */     // No operand predicates
     /* 383250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383256 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383268 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 383287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383301 */     GIR_RootConstrainSelectedInstOperands,
     /* 383302 */     // GIR_Coverage, 6062,
     /* 383302 */     GIR_EraseRootFromParent_Done,
     /* 383303 */   // Label 7669: @383303
     /* 383303 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383422), // Rule ID 2553 //
     /* 383308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383340 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 383344 */     // MIs[2] Operand 1
     /* 383344 */     // No operand predicates
     /* 383344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383356 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383360 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383365 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383375 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383387 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 383406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383420 */     GIR_RootConstrainSelectedInstOperands,
     /* 383421 */     // GIR_Coverage, 2553,
     /* 383421 */     GIR_EraseRootFromParent_Done,
     /* 383422 */   // Label 7670: @383422
     /* 383422 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(383522), // Rule ID 4832 //
     /* 383427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383478 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 383478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 383509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383520 */     GIR_RootConstrainSelectedInstOperands,
     /* 383521 */     // GIR_Coverage, 4832,
     /* 383521 */     GIR_EraseRootFromParent_Done,
     /* 383522 */   // Label 7671: @383522
     /* 383522 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(383622), // Rule ID 4868 //
     /* 383527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383578 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 383578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 383609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383620 */     GIR_RootConstrainSelectedInstOperands,
     /* 383621 */     // GIR_Coverage, 4868,
     /* 383621 */     GIR_EraseRootFromParent_Done,
     /* 383622 */   // Label 7672: @383622
     /* 383622 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(383719), // Rule ID 13841 //
     /* 383627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383663 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383677 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383689 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 383708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383717 */     GIR_RootConstrainSelectedInstOperands,
     /* 383718 */     // GIR_Coverage, 13841,
     /* 383718 */     GIR_EraseRootFromParent_Done,
     /* 383719 */   // Label 7673: @383719
     /* 383719 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(383819), // Rule ID 13843 //
     /* 383724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383765 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383775 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 383775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383787 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 383793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 383806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383817 */     GIR_RootConstrainSelectedInstOperands,
     /* 383818 */     // GIR_Coverage, 13843,
     /* 383818 */     GIR_EraseRootFromParent_Done,
     /* 383819 */   // Label 7674: @383819
     /* 383819 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(383919), // Rule ID 4866 //
     /* 383824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383875 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383887 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 383906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383917 */     GIR_RootConstrainSelectedInstOperands,
     /* 383918 */     // GIR_Coverage, 4866,
     /* 383918 */     GIR_EraseRootFromParent_Done,
     /* 383919 */   // Label 7675: @383919
     /* 383919 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(384016), // Rule ID 4830 //
     /* 383924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383974 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 383974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 383977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383986 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 383992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 384005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384014 */     GIR_RootConstrainSelectedInstOperands,
     /* 384015 */     // GIR_Coverage, 4830,
     /* 384015 */     GIR_EraseRootFromParent_Done,
     /* 384016 */   // Label 7676: @384016
     /* 384016 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(384094), // Rule ID 6212 //
     /* 384021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384062 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384066 */     // MIs[3] Operand 1
     /* 384066 */     // No operand predicates
     /* 384066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384076 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384092 */     GIR_RootConstrainSelectedInstOperands,
     /* 384093 */     // GIR_Coverage, 6212,
     /* 384093 */     GIR_EraseRootFromParent_Done,
     /* 384094 */   // Label 7677: @384094
     /* 384094 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(384178), // Rule ID 6124 //
     /* 384099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384135 */     // MIs[2] Operand 1
     /* 384135 */     // No operand predicates
     /* 384135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 384147 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384158 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384176 */     GIR_RootConstrainSelectedInstOperands,
     /* 384177 */     // GIR_Coverage, 6124,
     /* 384177 */     GIR_EraseRootFromParent_Done,
     /* 384178 */   // Label 7678: @384178
     /* 384178 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(384259), // Rule ID 6156 //
     /* 384183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384231 */     // MIs[3] Operand 1
     /* 384231 */     // No operand predicates
     /* 384231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384241 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384257 */     GIR_RootConstrainSelectedInstOperands,
     /* 384258 */     // GIR_Coverage, 6156,
     /* 384258 */     GIR_EraseRootFromParent_Done,
     /* 384259 */   // Label 7679: @384259
     /* 384259 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(384343), // Rule ID 6188 //
     /* 384264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384313 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384317 */     // MIs[3] Operand 1
     /* 384317 */     // No operand predicates
     /* 384317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384323 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384341 */     GIR_RootConstrainSelectedInstOperands,
     /* 384342 */     // GIR_Coverage, 6188,
     /* 384342 */     GIR_EraseRootFromParent_Done,
     /* 384343 */   // Label 7680: @384343
     /* 384343 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(384421), // Rule ID 6234 //
     /* 384348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384397 */     // MIs[3] Operand 1
     /* 384397 */     // No operand predicates
     /* 384397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384403 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384419 */     GIR_RootConstrainSelectedInstOperands,
     /* 384420 */     // GIR_Coverage, 6234,
     /* 384420 */     GIR_EraseRootFromParent_Done,
     /* 384421 */   // Label 7681: @384421
     /* 384421 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(384502), // Rule ID 6092 //
     /* 384426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384478 */     // MIs[3] Operand 1
     /* 384478 */     // No operand predicates
     /* 384478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384484 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 384487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384500 */     GIR_RootConstrainSelectedInstOperands,
     /* 384501 */     // GIR_Coverage, 6092,
     /* 384501 */     GIR_EraseRootFromParent_Done,
     /* 384502 */   // Label 7682: @384502
     /* 384502 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(384587), // Rule ID 2459 //
     /* 384507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384545 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 384545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 384563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 384576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384585 */     GIR_RootConstrainSelectedInstOperands,
     /* 384586 */     // GIR_Coverage, 2459,
     /* 384586 */     GIR_EraseRootFromParent_Done,
     /* 384587 */   // Label 7683: @384587
     /* 384587 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(384672), // Rule ID 2457 //
     /* 384592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384630 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 384630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 384633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 384648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 384661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384670 */     GIR_RootConstrainSelectedInstOperands,
     /* 384671 */     // GIR_Coverage, 2457,
     /* 384671 */     GIR_EraseRootFromParent_Done,
     /* 384672 */   // Label 7684: @384672
     /* 384672 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(384741), // Rule ID 2551 //
     /* 384677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384713 */     // MIs[2] Operand 1
     /* 384713 */     // No operand predicates
     /* 384713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384723 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384739 */     GIR_RootConstrainSelectedInstOperands,
     /* 384740 */     // GIR_Coverage, 2551,
     /* 384740 */     GIR_EraseRootFromParent_Done,
     /* 384741 */   // Label 7685: @384741
     /* 384741 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(384810), // Rule ID 6060 //
     /* 384746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384786 */     // MIs[2] Operand 1
     /* 384786 */     // No operand predicates
     /* 384786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384792 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 384795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384808 */     GIR_RootConstrainSelectedInstOperands,
     /* 384809 */     // GIR_Coverage, 6060,
     /* 384809 */     GIR_EraseRootFromParent_Done,
     /* 384810 */   // Label 7686: @384810
     /* 384810 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(384860), // Rule ID 13283 //
     /* 384815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384845 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 384845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 384848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384858 */     GIR_RootConstrainSelectedInstOperands,
     /* 384859 */     // GIR_Coverage, 13283,
     /* 384859 */     GIR_EraseRootFromParent_Done,
     /* 384860 */   // Label 7687: @384860
     /* 384860 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(384910), // Rule ID 645 //
     /* 384865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384895 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 384895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 384898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384908 */     GIR_RootConstrainSelectedInstOperands,
     /* 384909 */     // GIR_Coverage, 645,
     /* 384909 */     GIR_EraseRootFromParent_Done,
     /* 384910 */   // Label 7688: @384910
     /* 384910 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(384960), // Rule ID 657 //
     /* 384915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 384930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384945 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 384945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 384948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 384958 */     GIR_RootConstrainSelectedInstOperands,
     /* 384959 */     // GIR_Coverage, 657,
     /* 384959 */     GIR_EraseRootFromParent_Done,
     /* 384960 */   // Label 7689: @384960
     /* 384960 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(384991), // Rule ID 639 //
     /* 384965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384980 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 384980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 384985 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384989 */     GIR_RootConstrainSelectedInstOperands,
     /* 384990 */     // GIR_Coverage, 639,
     /* 384990 */     GIR_Done,
     /* 384991 */   // Label 7690: @384991
     /* 384991 */   GIM_Reject,
     /* 384992 */ // Label 7660: @384992
     /* 384992 */ GIM_Reject,
     /* 384993 */ // Label 7624: @384993
     /* 384993 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(387922),
     /* 384998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 385001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385011 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(385161), // Rule ID 4876 //
     /* 385016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385040 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385065 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 385073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 385081 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385088 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 385088 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 385091 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385095 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385100 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 385106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385111 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385128 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 385147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 385155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 385159 */     GIR_RootConstrainSelectedInstOperands,
     /* 385160 */     // GIR_Coverage, 4876,
     /* 385160 */     GIR_EraseRootFromParent_Done,
     /* 385161 */   // Label 7692: @385161
     /* 385161 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(385308), // Rule ID 4840 //
     /* 385166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385190 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 385206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385218 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 385222 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385227 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 385231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385237 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 385237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 385240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385249 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 385255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385277 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 385304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385306 */     GIR_RootConstrainSelectedInstOperands,
     /* 385307 */     // GIR_Coverage, 4840,
     /* 385307 */     GIR_EraseRootFromParent_Done,
     /* 385308 */   // Label 7693: @385308
     /* 385308 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(385455), // Rule ID 13851 //
     /* 385313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385349 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385361 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385365 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 385369 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385374 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 385378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385384 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 385384 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 385387 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385391 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385396 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 385402 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 385451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385453 */     GIR_RootConstrainSelectedInstOperands,
     /* 385454 */     // GIR_Coverage, 13851,
     /* 385454 */     GIR_EraseRootFromParent_Done,
     /* 385455 */   // Label 7694: @385455
     /* 385455 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(385586), // Rule ID 6098 //
     /* 385460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 385500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385512 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 385516 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385521 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 385525 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385529 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385533 */     // MIs[4] Operand 1
     /* 385533 */     // No operand predicates
     /* 385533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385537 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 385539 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385551 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 385581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 385584 */     GIR_RootConstrainSelectedInstOperands,
     /* 385585 */     // GIR_Coverage, 6098,
     /* 385585 */     GIR_EraseRootFromParent_Done,
     /* 385586 */   // Label 7695: @385586
     /* 385586 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(385717), // Rule ID 6130 //
     /* 385591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385623 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385627 */     // MIs[2] Operand 1
     /* 385627 */     // No operand predicates
     /* 385627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385635 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 385639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 385643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385647 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385651 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 385655 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385660 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 385664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 385670 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385682 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385715 */     GIR_RootConstrainSelectedInstOperands,
     /* 385716 */     // GIR_Coverage, 6130,
     /* 385716 */     GIR_EraseRootFromParent_Done,
     /* 385717 */   // Label 7696: @385717
     /* 385717 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(385848), // Rule ID 6194 //
     /* 385722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385758 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 385762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385774 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 385778 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385783 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 385787 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385791 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385795 */     // MIs[4] Operand 1
     /* 385795 */     // No operand predicates
     /* 385795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385799 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 385801 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385813 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 385843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 385846 */     GIR_RootConstrainSelectedInstOperands,
     /* 385847 */     // GIR_Coverage, 6194,
     /* 385847 */     GIR_EraseRootFromParent_Done,
     /* 385848 */   // Label 7697: @385848
     /* 385848 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(385979), // Rule ID 6162 //
     /* 385853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385901 */     // MIs[3] Operand 1
     /* 385901 */     // No operand predicates
     /* 385901 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 385905 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385909 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 385917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 385926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385930 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 385932 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385977 */     GIR_RootConstrainSelectedInstOperands,
     /* 385978 */     // GIR_Coverage, 6162,
     /* 385978 */     GIR_EraseRootFromParent_Done,
     /* 385979 */   // Label 7698: @385979
     /* 385979 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(386114), // Rule ID 2467 //
     /* 385984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386033 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386043 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 386046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386055 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 386102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 386110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386112 */     GIR_RootConstrainSelectedInstOperands,
     /* 386113 */     // GIR_Coverage, 2467,
     /* 386113 */     GIR_EraseRootFromParent_Done,
     /* 386114 */   // Label 7699: @386114
     /* 386114 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(386233), // Rule ID 6066 //
     /* 386119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386143 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386176 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386180 */     // MIs[3] Operand 1
     /* 386180 */     // No operand predicates
     /* 386180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386186 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 386186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 386217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386231 */     GIR_RootConstrainSelectedInstOperands,
     /* 386232 */     // GIR_Coverage, 6066,
     /* 386232 */     GIR_EraseRootFromParent_Done,
     /* 386233 */   // Label 7700: @386233
     /* 386233 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(386352), // Rule ID 2557 //
     /* 386238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386274 */     // MIs[2] Operand 1
     /* 386274 */     // No operand predicates
     /* 386274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 386278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 386290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386295 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 386299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386305 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 386305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 386336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386350 */     GIR_RootConstrainSelectedInstOperands,
     /* 386351 */     // GIR_Coverage, 2557,
     /* 386351 */     GIR_EraseRootFromParent_Done,
     /* 386352 */   // Label 7701: @386352
     /* 386352 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(386452), // Rule ID 4838 //
     /* 386357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386381 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386408 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 386408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386450 */     GIR_RootConstrainSelectedInstOperands,
     /* 386451 */     // GIR_Coverage, 4838,
     /* 386451 */     GIR_EraseRootFromParent_Done,
     /* 386452 */   // Label 7702: @386452
     /* 386452 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(386552), // Rule ID 4874 //
     /* 386457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386481 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 386493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386508 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 386508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 386539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 386550 */     GIR_RootConstrainSelectedInstOperands,
     /* 386551 */     // GIR_Coverage, 4874,
     /* 386551 */     GIR_EraseRootFromParent_Done,
     /* 386552 */   // Label 7703: @386552
     /* 386552 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(386649), // Rule ID 13847 //
     /* 386557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386607 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386619 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386647 */     GIR_RootConstrainSelectedInstOperands,
     /* 386648 */     // GIR_Coverage, 13847,
     /* 386648 */     GIR_EraseRootFromParent_Done,
     /* 386649 */   // Label 7704: @386649
     /* 386649 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(386749), // Rule ID 13849 //
     /* 386654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386705 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 386705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386717 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 386723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386747 */     GIR_RootConstrainSelectedInstOperands,
     /* 386748 */     // GIR_Coverage, 13849,
     /* 386748 */     GIR_EraseRootFromParent_Done,
     /* 386749 */   // Label 7705: @386749
     /* 386749 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(386849), // Rule ID 4872 //
     /* 386754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 386786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 386790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386805 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 386836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 386847 */     GIR_RootConstrainSelectedInstOperands,
     /* 386848 */     // GIR_Coverage, 4872,
     /* 386848 */     GIR_EraseRootFromParent_Done,
     /* 386849 */   // Label 7706: @386849
     /* 386849 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(386946), // Rule ID 4836 //
     /* 386854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 386857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386894 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 386898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386904 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 386904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 386907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 386922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 386935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 386944 */     GIR_RootConstrainSelectedInstOperands,
     /* 386945 */     // GIR_Coverage, 4836,
     /* 386945 */     GIR_EraseRootFromParent_Done,
     /* 386946 */   // Label 7707: @386946
     /* 386946 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(387024), // Rule ID 6216 //
     /* 386951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 386988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386992 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386996 */     // MIs[3] Operand 1
     /* 386996 */     // No operand predicates
     /* 386996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387006 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387022 */     GIR_RootConstrainSelectedInstOperands,
     /* 387023 */     // GIR_Coverage, 6216,
     /* 387023 */     GIR_EraseRootFromParent_Done,
     /* 387024 */   // Label 7708: @387024
     /* 387024 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(387108), // Rule ID 6128 //
     /* 387029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387061 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387065 */     // MIs[2] Operand 1
     /* 387065 */     // No operand predicates
     /* 387065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387073 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 387077 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387088 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 387099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387106 */     GIR_RootConstrainSelectedInstOperands,
     /* 387107 */     // GIR_Coverage, 6128,
     /* 387107 */     GIR_EraseRootFromParent_Done,
     /* 387108 */   // Label 7709: @387108
     /* 387108 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(387189), // Rule ID 6160 //
     /* 387113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387161 */     // MIs[3] Operand 1
     /* 387161 */     // No operand predicates
     /* 387161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387171 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387187 */     GIR_RootConstrainSelectedInstOperands,
     /* 387188 */     // GIR_Coverage, 6160,
     /* 387188 */     GIR_EraseRootFromParent_Done,
     /* 387189 */   // Label 7710: @387189
     /* 387189 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(387273), // Rule ID 6192 //
     /* 387194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387243 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387247 */     // MIs[3] Operand 1
     /* 387247 */     // No operand predicates
     /* 387247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387253 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387271 */     GIR_RootConstrainSelectedInstOperands,
     /* 387272 */     // GIR_Coverage, 6192,
     /* 387272 */     GIR_EraseRootFromParent_Done,
     /* 387273 */   // Label 7711: @387273
     /* 387273 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(387351), // Rule ID 6238 //
     /* 387278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 387319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387323 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387327 */     // MIs[3] Operand 1
     /* 387327 */     // No operand predicates
     /* 387327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387333 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387349 */     GIR_RootConstrainSelectedInstOperands,
     /* 387350 */     // GIR_Coverage, 6238,
     /* 387350 */     GIR_EraseRootFromParent_Done,
     /* 387351 */   // Label 7712: @387351
     /* 387351 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(387432), // Rule ID 6096 //
     /* 387356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387404 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387408 */     // MIs[3] Operand 1
     /* 387408 */     // No operand predicates
     /* 387408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387414 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 387417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387430 */     GIR_RootConstrainSelectedInstOperands,
     /* 387431 */     // GIR_Coverage, 6096,
     /* 387431 */     GIR_EraseRootFromParent_Done,
     /* 387432 */   // Label 7713: @387432
     /* 387432 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(387517), // Rule ID 2465 //
     /* 387437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387461 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387475 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387487 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 387493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 387506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387515 */     GIR_RootConstrainSelectedInstOperands,
     /* 387516 */     // GIR_Coverage, 2465,
     /* 387516 */     GIR_EraseRootFromParent_Done,
     /* 387517 */   // Label 7714: @387517
     /* 387517 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(387602), // Rule ID 2463 //
     /* 387522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 387554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387560 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 387560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387572 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 387578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 387591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387600 */     GIR_RootConstrainSelectedInstOperands,
     /* 387601 */     // GIR_Coverage, 2463,
     /* 387601 */     GIR_EraseRootFromParent_Done,
     /* 387602 */   // Label 7715: @387602
     /* 387602 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(387671), // Rule ID 2555 //
     /* 387607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387643 */     // MIs[2] Operand 1
     /* 387643 */     // No operand predicates
     /* 387643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387653 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387669 */     GIR_RootConstrainSelectedInstOperands,
     /* 387670 */     // GIR_Coverage, 2555,
     /* 387670 */     GIR_EraseRootFromParent_Done,
     /* 387671 */   // Label 7716: @387671
     /* 387671 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(387740), // Rule ID 6064 //
     /* 387676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 387691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387716 */     // MIs[2] Operand 1
     /* 387716 */     // No operand predicates
     /* 387716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387722 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 387722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 387725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387738 */     GIR_RootConstrainSelectedInstOperands,
     /* 387739 */     // GIR_Coverage, 6064,
     /* 387739 */     GIR_EraseRootFromParent_Done,
     /* 387740 */   // Label 7717: @387740
     /* 387740 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(387790), // Rule ID 13285 //
     /* 387745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387775 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 387778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387788 */     GIR_RootConstrainSelectedInstOperands,
     /* 387789 */     // GIR_Coverage, 13285,
     /* 387789 */     GIR_EraseRootFromParent_Done,
     /* 387790 */   // Label 7718: @387790
     /* 387790 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(387840), // Rule ID 647 //
     /* 387795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387825 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 387828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 387838 */     GIR_RootConstrainSelectedInstOperands,
     /* 387839 */     // GIR_Coverage, 647,
     /* 387839 */     GIR_EraseRootFromParent_Done,
     /* 387840 */   // Label 7719: @387840
     /* 387840 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(387890), // Rule ID 659 //
     /* 387845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387875 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 387878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 387888 */     GIR_RootConstrainSelectedInstOperands,
     /* 387889 */     // GIR_Coverage, 659,
     /* 387889 */     GIR_EraseRootFromParent_Done,
     /* 387890 */   // Label 7720: @387890
     /* 387890 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(387921), // Rule ID 641 //
     /* 387895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387910 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 387910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 387915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387919 */     GIR_RootConstrainSelectedInstOperands,
     /* 387920 */     // GIR_Coverage, 641,
     /* 387920 */     GIR_Done,
     /* 387921 */   // Label 7721: @387921
     /* 387921 */   GIM_Reject,
     /* 387922 */ // Label 7691: @387922
     /* 387922 */ GIM_Reject,
     /* 387923 */ // Label 7625: @387923
     /* 387923 */ GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(389443),
     /* 387928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 387934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 387937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387941 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(388019), // Rule ID 6196 //
     /* 387946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 387954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 387983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387987 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387991 */     // MIs[3] Operand 1
     /* 387991 */     // No operand predicates
     /* 387991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388001 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388017 */     GIR_RootConstrainSelectedInstOperands,
     /* 388018 */     // GIR_Coverage, 6196,
     /* 388018 */     GIR_EraseRootFromParent_Done,
     /* 388019 */   // Label 7723: @388019
     /* 388019 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(388103), // Rule ID 6112 //
     /* 388024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388060 */     // MIs[2] Operand 1
     /* 388060 */     // No operand predicates
     /* 388060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388072 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388083 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388101 */     GIR_RootConstrainSelectedInstOperands,
     /* 388102 */     // GIR_Coverage, 6112,
     /* 388102 */     GIR_EraseRootFromParent_Done,
     /* 388103 */   // Label 7724: @388103
     /* 388103 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(388184), // Rule ID 6144 //
     /* 388108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388152 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388156 */     // MIs[3] Operand 1
     /* 388156 */     // No operand predicates
     /* 388156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388166 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388182 */     GIR_RootConstrainSelectedInstOperands,
     /* 388183 */     // GIR_Coverage, 6144,
     /* 388183 */     GIR_EraseRootFromParent_Done,
     /* 388184 */   // Label 7725: @388184
     /* 388184 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(388268), // Rule ID 6176 //
     /* 388189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388238 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388242 */     // MIs[3] Operand 1
     /* 388242 */     // No operand predicates
     /* 388242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388248 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388266 */     GIR_RootConstrainSelectedInstOperands,
     /* 388267 */     // GIR_Coverage, 6176,
     /* 388267 */     GIR_EraseRootFromParent_Done,
     /* 388268 */   // Label 7726: @388268
     /* 388268 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(388346), // Rule ID 6218 //
     /* 388273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388322 */     // MIs[3] Operand 1
     /* 388322 */     // No operand predicates
     /* 388322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388328 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388344 */     GIR_RootConstrainSelectedInstOperands,
     /* 388345 */     // GIR_Coverage, 6218,
     /* 388345 */     GIR_EraseRootFromParent_Done,
     /* 388346 */   // Label 7727: @388346
     /* 388346 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(388427), // Rule ID 6080 //
     /* 388351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388399 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388403 */     // MIs[3] Operand 1
     /* 388403 */     // No operand predicates
     /* 388403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388409 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388425 */     GIR_RootConstrainSelectedInstOperands,
     /* 388426 */     // GIR_Coverage, 6080,
     /* 388426 */     GIR_EraseRootFromParent_Done,
     /* 388427 */   // Label 7728: @388427
     /* 388427 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(388496), // Rule ID 2539 //
     /* 388432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388468 */     // MIs[2] Operand 1
     /* 388468 */     // No operand predicates
     /* 388468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388478 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 388481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388494 */     GIR_RootConstrainSelectedInstOperands,
     /* 388495 */     // GIR_Coverage, 2539,
     /* 388495 */     GIR_EraseRootFromParent_Done,
     /* 388496 */   // Label 7729: @388496
     /* 388496 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(388565), // Rule ID 6048 //
     /* 388501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388537 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388541 */     // MIs[2] Operand 1
     /* 388541 */     // No operand predicates
     /* 388541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388547 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 388550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388563 */     GIR_RootConstrainSelectedInstOperands,
     /* 388564 */     // GIR_Coverage, 6048,
     /* 388564 */     GIR_EraseRootFromParent_Done,
     /* 388565 */   // Label 7730: @388565
     /* 388565 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(388658), // Rule ID 6200 //
     /* 388570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 388582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 388594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388609 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388656 */     GIR_RootConstrainSelectedInstOperands,
     /* 388657 */     // GIR_Coverage, 6200,
     /* 388657 */     GIR_EraseRootFromParent_Done,
     /* 388658 */   // Label 7731: @388658
     /* 388658 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(388757), // Rule ID 6114 //
     /* 388663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 388678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388706 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 388749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388755 */     GIR_RootConstrainSelectedInstOperands,
     /* 388756 */     // GIR_Coverage, 6114,
     /* 388756 */     GIR_EraseRootFromParent_Done,
     /* 388757 */   // Label 7732: @388757
     /* 388757 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(388853), // Rule ID 6146 //
     /* 388762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 388789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388804 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388851 */     GIR_RootConstrainSelectedInstOperands,
     /* 388852 */     // GIR_Coverage, 6146,
     /* 388852 */     GIR_EraseRootFromParent_Done,
     /* 388853 */   // Label 7733: @388853
     /* 388853 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(388952), // Rule ID 6178 //
     /* 388858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 388890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388901 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 388923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 388936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388950 */     GIR_RootConstrainSelectedInstOperands,
     /* 388951 */     // GIR_Coverage, 6178,
     /* 388951 */     GIR_EraseRootFromParent_Done,
     /* 388952 */   // Label 7734: @388952
     /* 388952 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(389045), // Rule ID 6222 //
     /* 388957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 388973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 388985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388996 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389043 */     GIR_RootConstrainSelectedInstOperands,
     /* 389044 */     // GIR_Coverage, 6222,
     /* 389044 */     GIR_EraseRootFromParent_Done,
     /* 389045 */   // Label 7735: @389045
     /* 389045 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(389141), // Rule ID 6082 //
     /* 389050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389092 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 389127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389139 */     GIR_RootConstrainSelectedInstOperands,
     /* 389140 */     // GIR_Coverage, 6082,
     /* 389140 */     GIR_EraseRootFromParent_Done,
     /* 389141 */   // Label 7736: @389141
     /* 389141 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(389225), // Rule ID 2541 //
     /* 389146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389176 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389188 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 389211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389223 */     GIR_RootConstrainSelectedInstOperands,
     /* 389224 */     // GIR_Coverage, 2541,
     /* 389224 */     GIR_EraseRootFromParent_Done,
     /* 389225 */   // Label 7737: @389225
     /* 389225 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(389275), // Rule ID 13315 //
     /* 389230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389260 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 389263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389273 */     GIR_RootConstrainSelectedInstOperands,
     /* 389274 */     // GIR_Coverage, 13315,
     /* 389274 */     GIR_EraseRootFromParent_Done,
     /* 389275 */   // Label 7738: @389275
     /* 389275 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(389359), // Rule ID 6050 //
     /* 389280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389310 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 389345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389357 */     GIR_RootConstrainSelectedInstOperands,
     /* 389358 */     // GIR_Coverage, 6050,
     /* 389358 */     GIR_EraseRootFromParent_Done,
     /* 389359 */   // Label 7739: @389359
     /* 389359 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(389409), // Rule ID 1307 //
     /* 389364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389394 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 389397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389407 */     GIR_RootConstrainSelectedInstOperands,
     /* 389408 */     // GIR_Coverage, 1307,
     /* 389408 */     GIR_EraseRootFromParent_Done,
     /* 389409 */   // Label 7740: @389409
     /* 389409 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(389442), // Rule ID 1297 //
     /* 389414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389429 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 389432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 389440 */     GIR_RootConstrainSelectedInstOperands,
     /* 389441 */     // GIR_Coverage, 1297,
     /* 389441 */     GIR_EraseRootFromParent_Done,
     /* 389442 */   // Label 7741: @389442
     /* 389442 */   GIM_Reject,
     /* 389443 */ // Label 7722: @389443
     /* 389443 */ GIM_Reject,
     /* 389444 */ // Label 7626: @389444
     /* 389444 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(390964),
     /* 389449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 389455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 389458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389462 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(389540), // Rule ID 6208 //
     /* 389467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389508 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389512 */     // MIs[3] Operand 1
     /* 389512 */     // No operand predicates
     /* 389512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389522 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389538 */     GIR_RootConstrainSelectedInstOperands,
     /* 389539 */     // GIR_Coverage, 6208,
     /* 389539 */     GIR_EraseRootFromParent_Done,
     /* 389540 */   // Label 7743: @389540
     /* 389540 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(389624), // Rule ID 6120 //
     /* 389545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389577 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389581 */     // MIs[2] Operand 1
     /* 389581 */     // No operand predicates
     /* 389581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 389585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389604 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389622 */     GIR_RootConstrainSelectedInstOperands,
     /* 389623 */     // GIR_Coverage, 6120,
     /* 389623 */     GIR_EraseRootFromParent_Done,
     /* 389624 */   // Label 7744: @389624
     /* 389624 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(389705), // Rule ID 6152 //
     /* 389629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389677 */     // MIs[3] Operand 1
     /* 389677 */     // No operand predicates
     /* 389677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389687 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389703 */     GIR_RootConstrainSelectedInstOperands,
     /* 389704 */     // GIR_Coverage, 6152,
     /* 389704 */     GIR_EraseRootFromParent_Done,
     /* 389705 */   // Label 7745: @389705
     /* 389705 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(389789), // Rule ID 6184 //
     /* 389710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389759 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389763 */     // MIs[3] Operand 1
     /* 389763 */     // No operand predicates
     /* 389763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389769 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389787 */     GIR_RootConstrainSelectedInstOperands,
     /* 389788 */     // GIR_Coverage, 6184,
     /* 389788 */     GIR_EraseRootFromParent_Done,
     /* 389789 */   // Label 7746: @389789
     /* 389789 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(389867), // Rule ID 6230 //
     /* 389794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389839 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389843 */     // MIs[3] Operand 1
     /* 389843 */     // No operand predicates
     /* 389843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389849 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389865 */     GIR_RootConstrainSelectedInstOperands,
     /* 389866 */     // GIR_Coverage, 6230,
     /* 389866 */     GIR_EraseRootFromParent_Done,
     /* 389867 */   // Label 7747: @389867
     /* 389867 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(389948), // Rule ID 6088 //
     /* 389872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389920 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389924 */     // MIs[3] Operand 1
     /* 389924 */     // No operand predicates
     /* 389924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389930 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 389933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389946 */     GIR_RootConstrainSelectedInstOperands,
     /* 389947 */     // GIR_Coverage, 6088,
     /* 389947 */     GIR_EraseRootFromParent_Done,
     /* 389948 */   // Label 7748: @389948
     /* 389948 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(390017), // Rule ID 2547 //
     /* 389953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 389964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389989 */     // MIs[2] Operand 1
     /* 389989 */     // No operand predicates
     /* 389989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389999 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 390002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390015 */     GIR_RootConstrainSelectedInstOperands,
     /* 390016 */     // GIR_Coverage, 2547,
     /* 390016 */     GIR_EraseRootFromParent_Done,
     /* 390017 */   // Label 7749: @390017
     /* 390017 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(390086), // Rule ID 6056 //
     /* 390022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 390037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 390062 */     // MIs[2] Operand 1
     /* 390062 */     // No operand predicates
     /* 390062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390068 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 390071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390084 */     GIR_RootConstrainSelectedInstOperands,
     /* 390085 */     // GIR_Coverage, 6056,
     /* 390085 */     GIR_EraseRootFromParent_Done,
     /* 390086 */   // Label 7750: @390086
     /* 390086 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(390179), // Rule ID 6210 //
     /* 390091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390130 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390142 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390149 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390177 */     GIR_RootConstrainSelectedInstOperands,
     /* 390178 */     // GIR_Coverage, 6210,
     /* 390178 */     GIR_EraseRootFromParent_Done,
     /* 390179 */   // Label 7751: @390179
     /* 390179 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(390278), // Rule ID 6122 //
     /* 390184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390227 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390246 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390276 */     GIR_RootConstrainSelectedInstOperands,
     /* 390277 */     // GIR_Coverage, 6122,
     /* 390277 */     GIR_EraseRootFromParent_Done,
     /* 390278 */   // Label 7752: @390278
     /* 390278 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(390374), // Rule ID 6154 //
     /* 390283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390325 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390372 */     GIR_RootConstrainSelectedInstOperands,
     /* 390373 */     // GIR_Coverage, 6154,
     /* 390373 */     GIR_EraseRootFromParent_Done,
     /* 390374 */   // Label 7753: @390374
     /* 390374 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(390473), // Rule ID 6186 //
     /* 390379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390422 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390471 */     GIR_RootConstrainSelectedInstOperands,
     /* 390472 */     // GIR_Coverage, 6186,
     /* 390472 */     GIR_EraseRootFromParent_Done,
     /* 390473 */   // Label 7754: @390473
     /* 390473 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(390566), // Rule ID 6232 //
     /* 390478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390517 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390564 */     GIR_RootConstrainSelectedInstOperands,
     /* 390565 */     // GIR_Coverage, 6232,
     /* 390565 */     GIR_EraseRootFromParent_Done,
     /* 390566 */   // Label 7755: @390566
     /* 390566 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(390662), // Rule ID 6090 //
     /* 390571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 390602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390613 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 390648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390660 */     GIR_RootConstrainSelectedInstOperands,
     /* 390661 */     // GIR_Coverage, 6090,
     /* 390661 */     GIR_EraseRootFromParent_Done,
     /* 390662 */   // Label 7756: @390662
     /* 390662 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(390746), // Rule ID 2549 //
     /* 390667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390697 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390709 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 390732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390744 */     GIR_RootConstrainSelectedInstOperands,
     /* 390745 */     // GIR_Coverage, 2549,
     /* 390745 */     GIR_EraseRootFromParent_Done,
     /* 390746 */   // Label 7757: @390746
     /* 390746 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(390796), // Rule ID 13319 //
     /* 390751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390781 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 390781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 390784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390794 */     GIR_RootConstrainSelectedInstOperands,
     /* 390795 */     // GIR_Coverage, 13319,
     /* 390795 */     GIR_EraseRootFromParent_Done,
     /* 390796 */   // Label 7758: @390796
     /* 390796 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(390880), // Rule ID 6058 //
     /* 390801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 390820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390831 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390843 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390850 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 390866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390878 */     GIR_RootConstrainSelectedInstOperands,
     /* 390879 */     // GIR_Coverage, 6058,
     /* 390879 */     GIR_EraseRootFromParent_Done,
     /* 390880 */   // Label 7759: @390880
     /* 390880 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(390930), // Rule ID 1311 //
     /* 390885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390915 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 390915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 390918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390928 */     GIR_RootConstrainSelectedInstOperands,
     /* 390929 */     // GIR_Coverage, 1311,
     /* 390929 */     GIR_EraseRootFromParent_Done,
     /* 390930 */   // Label 7760: @390930
     /* 390930 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(390963), // Rule ID 1301 //
     /* 390935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390950 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 390950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 390953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390961 */     GIR_RootConstrainSelectedInstOperands,
     /* 390962 */     // GIR_Coverage, 1301,
     /* 390962 */     GIR_EraseRootFromParent_Done,
     /* 390963 */   // Label 7761: @390963
     /* 390963 */   GIM_Reject,
     /* 390964 */ // Label 7742: @390964
     /* 390964 */ GIM_Reject,
     /* 390965 */ // Label 7627: @390965
     /* 390965 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(392143),
     /* 390970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 390976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 390979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390983 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(391067), // Rule ID 6104 //
     /* 390988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391024 */     // MIs[2] Operand 1
     /* 391024 */     // No operand predicates
     /* 391024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 391028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391047 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391065 */     GIR_RootConstrainSelectedInstOperands,
     /* 391066 */     // GIR_Coverage, 6104,
     /* 391066 */     GIR_EraseRootFromParent_Done,
     /* 391067 */   // Label 7763: @391067
     /* 391067 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(391148), // Rule ID 6136 //
     /* 391072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391120 */     // MIs[3] Operand 1
     /* 391120 */     // No operand predicates
     /* 391120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391130 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391146 */     GIR_RootConstrainSelectedInstOperands,
     /* 391147 */     // GIR_Coverage, 6136,
     /* 391147 */     GIR_EraseRootFromParent_Done,
     /* 391148 */   // Label 7764: @391148
     /* 391148 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(391232), // Rule ID 6168 //
     /* 391153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391202 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391206 */     // MIs[3] Operand 1
     /* 391206 */     // No operand predicates
     /* 391206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391212 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391230 */     GIR_RootConstrainSelectedInstOperands,
     /* 391231 */     // GIR_Coverage, 6168,
     /* 391231 */     GIR_EraseRootFromParent_Done,
     /* 391232 */   // Label 7765: @391232
     /* 391232 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(391313), // Rule ID 6072 //
     /* 391237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391289 */     // MIs[3] Operand 1
     /* 391289 */     // No operand predicates
     /* 391289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391295 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391311 */     GIR_RootConstrainSelectedInstOperands,
     /* 391312 */     // GIR_Coverage, 6072,
     /* 391312 */     GIR_EraseRootFromParent_Done,
     /* 391313 */   // Label 7766: @391313
     /* 391313 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(391382), // Rule ID 2531 //
     /* 391318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391350 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391354 */     // MIs[2] Operand 1
     /* 391354 */     // No operand predicates
     /* 391354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391364 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 391367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391380 */     GIR_RootConstrainSelectedInstOperands,
     /* 391381 */     // GIR_Coverage, 2531,
     /* 391381 */     GIR_EraseRootFromParent_Done,
     /* 391382 */   // Label 7767: @391382
     /* 391382 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(391451), // Rule ID 6040 //
     /* 391387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391427 */     // MIs[2] Operand 1
     /* 391427 */     // No operand predicates
     /* 391427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391433 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 391436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391449 */     GIR_RootConstrainSelectedInstOperands,
     /* 391450 */     // GIR_Coverage, 6040,
     /* 391450 */     GIR_EraseRootFromParent_Done,
     /* 391451 */   // Label 7768: @391451
     /* 391451 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(391550), // Rule ID 6106 //
     /* 391456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391499 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 391542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391548 */     GIR_RootConstrainSelectedInstOperands,
     /* 391549 */     // GIR_Coverage, 6106,
     /* 391549 */     GIR_EraseRootFromParent_Done,
     /* 391550 */   // Label 7769: @391550
     /* 391550 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(391646), // Rule ID 6138 //
     /* 391555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391597 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391644 */     GIR_RootConstrainSelectedInstOperands,
     /* 391645 */     // GIR_Coverage, 6138,
     /* 391645 */     GIR_EraseRootFromParent_Done,
     /* 391646 */   // Label 7770: @391646
     /* 391646 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(391745), // Rule ID 6170 //
     /* 391651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391694 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391743 */     GIR_RootConstrainSelectedInstOperands,
     /* 391744 */     // GIR_Coverage, 6170,
     /* 391744 */     GIR_EraseRootFromParent_Done,
     /* 391745 */   // Label 7771: @391745
     /* 391745 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(391841), // Rule ID 6074 //
     /* 391750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391792 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 391827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391839 */     GIR_RootConstrainSelectedInstOperands,
     /* 391840 */     // GIR_Coverage, 6074,
     /* 391840 */     GIR_EraseRootFromParent_Done,
     /* 391841 */   // Label 7772: @391841
     /* 391841 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(391925), // Rule ID 2533 //
     /* 391846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391876 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391888 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 391911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391923 */     GIR_RootConstrainSelectedInstOperands,
     /* 391924 */     // GIR_Coverage, 2533,
     /* 391924 */     GIR_EraseRootFromParent_Done,
     /* 391925 */   // Label 7773: @391925
     /* 391925 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(391975), // Rule ID 13311 //
     /* 391930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391960 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 391960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 391963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391973 */     GIR_RootConstrainSelectedInstOperands,
     /* 391974 */     // GIR_Coverage, 13311,
     /* 391974 */     GIR_EraseRootFromParent_Done,
     /* 391975 */   // Label 7774: @391975
     /* 391975 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(392059), // Rule ID 6042 //
     /* 391980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392010 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 392013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 392045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392057 */     GIR_RootConstrainSelectedInstOperands,
     /* 392058 */     // GIR_Coverage, 6042,
     /* 392058 */     GIR_EraseRootFromParent_Done,
     /* 392059 */   // Label 7775: @392059
     /* 392059 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(392109), // Rule ID 1303 //
     /* 392064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392094 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 392097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392107 */     GIR_RootConstrainSelectedInstOperands,
     /* 392108 */     // GIR_Coverage, 1303,
     /* 392108 */     GIR_EraseRootFromParent_Done,
     /* 392109 */   // Label 7776: @392109
     /* 392109 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(392142), // Rule ID 1293 //
     /* 392114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392129 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 392129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 392132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 392140 */     GIR_RootConstrainSelectedInstOperands,
     /* 392141 */     // GIR_Coverage, 1293,
     /* 392141 */     GIR_EraseRootFromParent_Done,
     /* 392142 */   // Label 7777: @392142
     /* 392142 */   GIM_Reject,
     /* 392143 */ // Label 7762: @392143
     /* 392143 */ GIM_Reject,
     /* 392144 */ // Label 7628: @392144
     /* 392144 */ GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(393664),
     /* 392149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 392155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 392158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392162 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(392240), // Rule ID 6202 //
     /* 392167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 392204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392208 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392212 */     // MIs[3] Operand 1
     /* 392212 */     // No operand predicates
     /* 392212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392222 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392238 */     GIR_RootConstrainSelectedInstOperands,
     /* 392239 */     // GIR_Coverage, 6202,
     /* 392239 */     GIR_EraseRootFromParent_Done,
     /* 392240 */   // Label 7779: @392240
     /* 392240 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(392324), // Rule ID 6116 //
     /* 392245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392281 */     // MIs[2] Operand 1
     /* 392281 */     // No operand predicates
     /* 392281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 392285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392304 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392322 */     GIR_RootConstrainSelectedInstOperands,
     /* 392323 */     // GIR_Coverage, 6116,
     /* 392323 */     GIR_EraseRootFromParent_Done,
     /* 392324 */   // Label 7780: @392324
     /* 392324 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(392405), // Rule ID 6148 //
     /* 392329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392373 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392377 */     // MIs[3] Operand 1
     /* 392377 */     // No operand predicates
     /* 392377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392387 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392403 */     GIR_RootConstrainSelectedInstOperands,
     /* 392404 */     // GIR_Coverage, 6148,
     /* 392404 */     GIR_EraseRootFromParent_Done,
     /* 392405 */   // Label 7781: @392405
     /* 392405 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(392489), // Rule ID 6180 //
     /* 392410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392459 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392463 */     // MIs[3] Operand 1
     /* 392463 */     // No operand predicates
     /* 392463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392469 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392487 */     GIR_RootConstrainSelectedInstOperands,
     /* 392488 */     // GIR_Coverage, 6180,
     /* 392488 */     GIR_EraseRootFromParent_Done,
     /* 392489 */   // Label 7782: @392489
     /* 392489 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(392567), // Rule ID 6224 //
     /* 392494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 392535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392539 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392543 */     // MIs[3] Operand 1
     /* 392543 */     // No operand predicates
     /* 392543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392549 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392565 */     GIR_RootConstrainSelectedInstOperands,
     /* 392566 */     // GIR_Coverage, 6224,
     /* 392566 */     GIR_EraseRootFromParent_Done,
     /* 392567 */   // Label 7783: @392567
     /* 392567 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(392648), // Rule ID 6084 //
     /* 392572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392620 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392624 */     // MIs[3] Operand 1
     /* 392624 */     // No operand predicates
     /* 392624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392630 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392646 */     GIR_RootConstrainSelectedInstOperands,
     /* 392647 */     // GIR_Coverage, 6084,
     /* 392647 */     GIR_EraseRootFromParent_Done,
     /* 392648 */   // Label 7784: @392648
     /* 392648 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(392717), // Rule ID 2543 //
     /* 392653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392689 */     // MIs[2] Operand 1
     /* 392689 */     // No operand predicates
     /* 392689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392699 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 392702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392715 */     GIR_RootConstrainSelectedInstOperands,
     /* 392716 */     // GIR_Coverage, 2543,
     /* 392716 */     GIR_EraseRootFromParent_Done,
     /* 392717 */   // Label 7785: @392717
     /* 392717 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(392786), // Rule ID 6052 //
     /* 392722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 392754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392758 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392762 */     // MIs[2] Operand 1
     /* 392762 */     // No operand predicates
     /* 392762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392768 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 392768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 392771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 392784 */     GIR_RootConstrainSelectedInstOperands,
     /* 392785 */     // GIR_Coverage, 6052,
     /* 392785 */     GIR_EraseRootFromParent_Done,
     /* 392786 */   // Label 7786: @392786
     /* 392786 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(392879), // Rule ID 6206 //
     /* 392791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 392815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392830 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 392852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392877 */     GIR_RootConstrainSelectedInstOperands,
     /* 392878 */     // GIR_Coverage, 6206,
     /* 392878 */     GIR_EraseRootFromParent_Done,
     /* 392879 */   // Label 7787: @392879
     /* 392879 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(392978), // Rule ID 6118 //
     /* 392884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392927 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 392930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 392949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 392962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 392970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392976 */     GIR_RootConstrainSelectedInstOperands,
     /* 392977 */     // GIR_Coverage, 6118,
     /* 392977 */     GIR_EraseRootFromParent_Done,
     /* 392978 */   // Label 7788: @392978
     /* 392978 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(393074), // Rule ID 6150 //
     /* 392983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393025 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393072 */     GIR_RootConstrainSelectedInstOperands,
     /* 393073 */     // GIR_Coverage, 6150,
     /* 393073 */     GIR_EraseRootFromParent_Done,
     /* 393074 */   // Label 7789: @393074
     /* 393074 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(393173), // Rule ID 6182 //
     /* 393079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393122 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393134 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393171 */     GIR_RootConstrainSelectedInstOperands,
     /* 393172 */     // GIR_Coverage, 6182,
     /* 393172 */     GIR_EraseRootFromParent_Done,
     /* 393173 */   // Label 7790: @393173
     /* 393173 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(393266), // Rule ID 6228 //
     /* 393178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393217 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393264 */     GIR_RootConstrainSelectedInstOperands,
     /* 393265 */     // GIR_Coverage, 6228,
     /* 393265 */     GIR_EraseRootFromParent_Done,
     /* 393266 */   // Label 7791: @393266
     /* 393266 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(393362), // Rule ID 6086 //
     /* 393271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 393298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 393302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393313 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 393348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393360 */     GIR_RootConstrainSelectedInstOperands,
     /* 393361 */     // GIR_Coverage, 6086,
     /* 393361 */     GIR_EraseRootFromParent_Done,
     /* 393362 */   // Label 7792: @393362
     /* 393362 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(393446), // Rule ID 2545 //
     /* 393367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393397 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 393432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393444 */     GIR_RootConstrainSelectedInstOperands,
     /* 393445 */     // GIR_Coverage, 2545,
     /* 393445 */     GIR_EraseRootFromParent_Done,
     /* 393446 */   // Label 7793: @393446
     /* 393446 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(393496), // Rule ID 13317 //
     /* 393451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393481 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 393481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 393484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393494 */     GIR_RootConstrainSelectedInstOperands,
     /* 393495 */     // GIR_Coverage, 13317,
     /* 393495 */     GIR_EraseRootFromParent_Done,
     /* 393496 */   // Label 7794: @393496
     /* 393496 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(393580), // Rule ID 6054 //
     /* 393501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 393516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 393520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393531 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 393531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 393538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 393546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 393553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 393566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393578 */     GIR_RootConstrainSelectedInstOperands,
     /* 393579 */     // GIR_Coverage, 6054,
     /* 393579 */     GIR_EraseRootFromParent_Done,
     /* 393580 */   // Label 7795: @393580
     /* 393580 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(393630), // Rule ID 1309 //
     /* 393585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393615 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 393615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 393618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393628 */     GIR_RootConstrainSelectedInstOperands,
     /* 393629 */     // GIR_Coverage, 1309,
     /* 393629 */     GIR_EraseRootFromParent_Done,
     /* 393630 */   // Label 7796: @393630
     /* 393630 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(393663), // Rule ID 1299 //
     /* 393635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393650 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 393650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 393653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 393661 */     GIR_RootConstrainSelectedInstOperands,
     /* 393662 */     // GIR_Coverage, 1299,
     /* 393662 */     GIR_EraseRootFromParent_Done,
     /* 393663 */   // Label 7797: @393663
     /* 393663 */   GIM_Reject,
     /* 393664 */ // Label 7778: @393664
     /* 393664 */ GIM_Reject,
     /* 393665 */ // Label 7629: @393665
     /* 393665 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(394843),
     /* 393670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 393679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393683 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(393767), // Rule ID 6100 //
     /* 393688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393724 */     // MIs[2] Operand 1
     /* 393724 */     // No operand predicates
     /* 393724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393747 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 393747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 393750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 393758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393765 */     GIR_RootConstrainSelectedInstOperands,
     /* 393766 */     // GIR_Coverage, 6100,
     /* 393766 */     GIR_EraseRootFromParent_Done,
     /* 393767 */   // Label 7799: @393767
     /* 393767 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(393848), // Rule ID 6132 //
     /* 393772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393816 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393820 */     // MIs[3] Operand 1
     /* 393820 */     // No operand predicates
     /* 393820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393830 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 393830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 393833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393846 */     GIR_RootConstrainSelectedInstOperands,
     /* 393847 */     // GIR_Coverage, 6132,
     /* 393847 */     GIR_EraseRootFromParent_Done,
     /* 393848 */   // Label 7800: @393848
     /* 393848 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(393932), // Rule ID 6164 //
     /* 393853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393906 */     // MIs[3] Operand 1
     /* 393906 */     // No operand predicates
     /* 393906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393912 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 393912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 393915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 393919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393930 */     GIR_RootConstrainSelectedInstOperands,
     /* 393931 */     // GIR_Coverage, 6164,
     /* 393931 */     GIR_EraseRootFromParent_Done,
     /* 393932 */   // Label 7801: @393932
     /* 393932 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(394013), // Rule ID 6068 //
     /* 393937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 393952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393989 */     // MIs[3] Operand 1
     /* 393989 */     // No operand predicates
     /* 393989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393995 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 393995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 393998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 394011 */     GIR_RootConstrainSelectedInstOperands,
     /* 394012 */     // GIR_Coverage, 6068,
     /* 394012 */     GIR_EraseRootFromParent_Done,
     /* 394013 */   // Label 7802: @394013
     /* 394013 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(394082), // Rule ID 2527 //
     /* 394018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 394029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 394042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 394054 */     // MIs[2] Operand 1
     /* 394054 */     // No operand predicates
     /* 394054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394064 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 394064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 394067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394080 */     GIR_RootConstrainSelectedInstOperands,
     /* 394081 */     // GIR_Coverage, 2527,
     /* 394081 */     GIR_EraseRootFromParent_Done,
     /* 394082 */   // Label 7803: @394082
     /* 394082 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(394151), // Rule ID 6036 //
     /* 394087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 394102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 394115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 394127 */     // MIs[2] Operand 1
     /* 394127 */     // No operand predicates
     /* 394127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394133 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 394133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 394136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 394149 */     GIR_RootConstrainSelectedInstOperands,
     /* 394150 */     // GIR_Coverage, 6036,
     /* 394150 */     GIR_EraseRootFromParent_Done,
     /* 394151 */   // Label 7804: @394151
     /* 394151 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(394250), // Rule ID 6102 //
     /* 394156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394199 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 394234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 394242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394248 */     GIR_RootConstrainSelectedInstOperands,
     /* 394249 */     // GIR_Coverage, 6102,
     /* 394249 */     GIR_EraseRootFromParent_Done,
     /* 394250 */   // Label 7805: @394250
     /* 394250 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(394346), // Rule ID 6134 //
     /* 394255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394297 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 394332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394344 */     GIR_RootConstrainSelectedInstOperands,
     /* 394345 */     // GIR_Coverage, 6134,
     /* 394345 */     GIR_EraseRootFromParent_Done,
     /* 394346 */   // Label 7806: @394346
     /* 394346 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(394445), // Rule ID 6166 //
     /* 394351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394394 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 394429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394443 */     GIR_RootConstrainSelectedInstOperands,
     /* 394444 */     // GIR_Coverage, 6166,
     /* 394444 */     GIR_EraseRootFromParent_Done,
     /* 394445 */   // Label 7807: @394445
     /* 394445 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(394541), // Rule ID 6070 //
     /* 394450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 394473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 394477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 394492 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 394511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 394527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394539 */     GIR_RootConstrainSelectedInstOperands,
     /* 394540 */     // GIR_Coverage, 6070,
     /* 394540 */     GIR_EraseRootFromParent_Done,
     /* 394541 */   // Label 7808: @394541
     /* 394541 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(394625), // Rule ID 2529 //
     /* 394546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394576 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 394611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394623 */     GIR_RootConstrainSelectedInstOperands,
     /* 394624 */     // GIR_Coverage, 2529,
     /* 394624 */     GIR_EraseRootFromParent_Done,
     /* 394625 */   // Label 7809: @394625
     /* 394625 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(394675), // Rule ID 13313 //
     /* 394630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394660 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 394663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394673 */     GIR_RootConstrainSelectedInstOperands,
     /* 394674 */     // GIR_Coverage, 13313,
     /* 394674 */     GIR_EraseRootFromParent_Done,
     /* 394675 */   // Label 7810: @394675
     /* 394675 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(394759), // Rule ID 6038 //
     /* 394680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 394695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394710 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 394710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 394713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 394717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 394725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 394732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 394742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 394745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394757 */     GIR_RootConstrainSelectedInstOperands,
     /* 394758 */     // GIR_Coverage, 6038,
     /* 394758 */     GIR_EraseRootFromParent_Done,
     /* 394759 */   // Label 7811: @394759
     /* 394759 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(394809), // Rule ID 1305 //
     /* 394764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 394775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 394779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394794 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 394797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 394807 */     GIR_RootConstrainSelectedInstOperands,
     /* 394808 */     // GIR_Coverage, 1305,
     /* 394808 */     GIR_EraseRootFromParent_Done,
     /* 394809 */   // Label 7812: @394809
     /* 394809 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(394842), // Rule ID 1295 //
     /* 394814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394829 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 394832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 394836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 394838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 394840 */     GIR_RootConstrainSelectedInstOperands,
     /* 394841 */     // GIR_Coverage, 1295,
     /* 394841 */     GIR_EraseRootFromParent_Done,
     /* 394842 */   // Label 7813: @394842
     /* 394842 */   GIM_Reject,
     /* 394843 */ // Label 7798: @394843
     /* 394843 */ GIM_Reject,
     /* 394844 */ // Label 7630: @394844
     /* 394844 */ GIM_Reject,
     /* 394845 */ // Label 106: @394845
     /* 394845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7822*/ GIMT_Encode4(395144),
     /* 394856 */ /*GILLT_s16*//*Label 7814*/ GIMT_Encode4(394896),
     /* 394860 */ /*GILLT_s32*//*Label 7815*/ GIMT_Encode4(394927),
     /* 394864 */ /*GILLT_s64*//*Label 7816*/ GIMT_Encode4(394958), GIMT_Encode4(0),
     /* 394872 */ /*GILLT_v2s32*//*Label 7817*/ GIMT_Encode4(394989),
     /* 394876 */ /*GILLT_v2s64*//*Label 7818*/ GIMT_Encode4(395020),
     /* 394880 */ /*GILLT_v4s16*//*Label 7819*/ GIMT_Encode4(395051),
     /* 394884 */ /*GILLT_v4s32*//*Label 7820*/ GIMT_Encode4(395082), GIMT_Encode4(0),
     /* 394892 */ /*GILLT_v8s16*//*Label 7821*/ GIMT_Encode4(395113),
     /* 394896 */ // Label 7814: @394896
     /* 394896 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(394926), // Rule ID 569 //
     /* 394901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394915 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 394920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394924 */   GIR_RootConstrainSelectedInstOperands,
     /* 394925 */   // GIR_Coverage, 569,
     /* 394925 */   GIR_Done,
     /* 394926 */ // Label 7823: @394926
     /* 394926 */ GIM_Reject,
     /* 394927 */ // Label 7815: @394927
     /* 394927 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(394957), // Rule ID 571 //
     /* 394932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394946 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 394951 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394955 */   GIR_RootConstrainSelectedInstOperands,
     /* 394956 */   // GIR_Coverage, 571,
     /* 394956 */   GIR_Done,
     /* 394957 */ // Label 7824: @394957
     /* 394957 */ GIM_Reject,
     /* 394958 */ // Label 7816: @394958
     /* 394958 */ GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(394988), // Rule ID 573 //
     /* 394963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394977 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 394982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394986 */   GIR_RootConstrainSelectedInstOperands,
     /* 394987 */   // GIR_Coverage, 573,
     /* 394987 */   GIR_Done,
     /* 394988 */ // Label 7825: @394988
     /* 394988 */ GIM_Reject,
     /* 394989 */ // Label 7817: @394989
     /* 394989 */ GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(395019), // Rule ID 959 //
     /* 394994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395008 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 395013 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395017 */   GIR_RootConstrainSelectedInstOperands,
     /* 395018 */   // GIR_Coverage, 959,
     /* 395018 */   GIR_Done,
     /* 395019 */ // Label 7826: @395019
     /* 395019 */ GIM_Reject,
     /* 395020 */ // Label 7818: @395020
     /* 395020 */ GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(395050), // Rule ID 963 //
     /* 395025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395039 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 395044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395048 */   GIR_RootConstrainSelectedInstOperands,
     /* 395049 */   // GIR_Coverage, 963,
     /* 395049 */   GIR_Done,
     /* 395050 */ // Label 7827: @395050
     /* 395050 */ GIM_Reject,
     /* 395051 */ // Label 7819: @395051
     /* 395051 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(395081), // Rule ID 955 //
     /* 395056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395070 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 395075 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395079 */   GIR_RootConstrainSelectedInstOperands,
     /* 395080 */   // GIR_Coverage, 955,
     /* 395080 */   GIR_Done,
     /* 395081 */ // Label 7828: @395081
     /* 395081 */ GIM_Reject,
     /* 395082 */ // Label 7820: @395082
     /* 395082 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(395112), // Rule ID 961 //
     /* 395087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395101 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 395106 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395110 */   GIR_RootConstrainSelectedInstOperands,
     /* 395111 */   // GIR_Coverage, 961,
     /* 395111 */   GIR_Done,
     /* 395112 */ // Label 7829: @395112
     /* 395112 */ GIM_Reject,
     /* 395113 */ // Label 7821: @395113
     /* 395113 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(395143), // Rule ID 957 //
     /* 395118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395132 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 395137 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395141 */   GIR_RootConstrainSelectedInstOperands,
     /* 395142 */   // GIR_Coverage, 957,
     /* 395142 */   GIR_Done,
     /* 395143 */ // Label 7830: @395143
     /* 395143 */ GIM_Reject,
     /* 395144 */ // Label 7822: @395144
     /* 395144 */ GIM_Reject,
     /* 395145 */ // Label 107: @395145
     /* 395145 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(395158), // Rule ID 6515 //
     /* 395150 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 395150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 395153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 395156 */   GIR_RootConstrainSelectedInstOperands,
     /* 395157 */   // GIR_Coverage, 6515,
     /* 395157 */   GIR_EraseRootFromParent_Done,
     /* 395158 */ // Label 7831: @395158
     /* 395158 */ GIM_Reject,
     /* 395159 */ // Label 108: @395159
     /* 395159 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(395179), // Rule ID 6516 //
     /* 395164 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 395164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 395167 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 395177 */   GIR_RootConstrainSelectedInstOperands,
     /* 395178 */   // GIR_Coverage, 6516,
     /* 395178 */   GIR_EraseRootFromParent_Done,
     /* 395179 */ // Label 7832: @395179
     /* 395179 */ GIM_Reject,
     /* 395180 */ // Label 109: @395180
     /* 395180 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(395204), // Rule ID 6517 //
     /* 395185 */   // MIs[0] kind
     /* 395185 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 395188 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 395193 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 395193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 395196 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 395202 */   GIR_RootConstrainSelectedInstOperands,
     /* 395203 */   // GIR_Coverage, 6517,
     /* 395203 */   GIR_EraseRootFromParent_Done,
     /* 395204 */ // Label 7833: @395204
     /* 395204 */ GIM_Reject,
     /* 395205 */ // Label 110: @395205
     /* 395205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7837*/ GIMT_Encode4(395514),
     /* 395216 */ /*GILLT_s16*//*Label 7834*/ GIMT_Encode4(395228),
     /* 395220 */ /*GILLT_s32*//*Label 7835*/ GIMT_Encode4(395381),
     /* 395224 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(395486),
     /* 395228 */ // Label 7834: @395228
     /* 395228 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(395329), // Rule ID 5606 //
     /* 395233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395247 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 395247 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 395250 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 395254 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395259 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395263 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395269 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395272 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 395276 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395281 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 395284 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395302 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 395309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395327 */   GIR_RootConstrainSelectedInstOperands,
     /* 395328 */   // GIR_Coverage, 5606,
     /* 395328 */   GIR_EraseRootFromParent_Done,
     /* 395329 */ // Label 7838: @395329
     /* 395329 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(395380), // Rule ID 5607 //
     /* 395334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395348 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 395348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 395355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395378 */   GIR_RootConstrainSelectedInstOperands,
     /* 395379 */   // GIR_Coverage, 5607,
     /* 395379 */   GIR_EraseRootFromParent_Done,
     /* 395380 */ // Label 7839: @395380
     /* 395380 */ GIM_Reject,
     /* 395381 */ // Label 7835: @395381
     /* 395381 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(395458), // Rule ID 5608 //
     /* 395386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395397 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 395397 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395400 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 395404 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395409 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395413 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395431 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 395438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395456 */   GIR_RootConstrainSelectedInstOperands,
     /* 395457 */   // GIR_Coverage, 5608,
     /* 395457 */   GIR_EraseRootFromParent_Done,
     /* 395458 */ // Label 7840: @395458
     /* 395458 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(395485), // Rule ID 5609 //
     /* 395463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395474 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395483 */   GIR_RootConstrainSelectedInstOperands,
     /* 395484 */   // GIR_Coverage, 5609,
     /* 395484 */   GIR_Done,
     /* 395485 */ // Label 7841: @395485
     /* 395485 */ GIM_Reject,
     /* 395486 */ // Label 7836: @395486
     /* 395486 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(395513), // Rule ID 5610 //
     /* 395491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395502 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 395507 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395511 */   GIR_RootConstrainSelectedInstOperands,
     /* 395512 */   // GIR_Coverage, 5610,
     /* 395512 */   GIR_Done,
     /* 395513 */ // Label 7842: @395513
     /* 395513 */ GIM_Reject,
     /* 395514 */ // Label 7837: @395514
     /* 395514 */ GIM_Reject,
     /* 395515 */ // Label 111: @395515
     /* 395515 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7846*/ GIMT_Encode4(395685),
     /* 395526 */ /*GILLT_s16*//*Label 7843*/ GIMT_Encode4(395538),
     /* 395530 */ /*GILLT_s32*//*Label 7844*/ GIMT_Encode4(395599),
     /* 395534 */ /*GILLT_s64*//*Label 7845*/ GIMT_Encode4(395657),
     /* 395538 */ // Label 7843: @395538
     /* 395538 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(395568), // Rule ID 1942 //
     /* 395543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395557 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 395562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395566 */   GIR_RootConstrainSelectedInstOperands,
     /* 395567 */   // GIR_Coverage, 1942,
     /* 395567 */   GIR_Done,
     /* 395568 */ // Label 7847: @395568
     /* 395568 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(395598), // Rule ID 1944 //
     /* 395573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395587 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 395592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395596 */   GIR_RootConstrainSelectedInstOperands,
     /* 395597 */   // GIR_Coverage, 1944,
     /* 395597 */   GIR_Done,
     /* 395598 */ // Label 7848: @395598
     /* 395598 */ GIM_Reject,
     /* 395599 */ // Label 7844: @395599
     /* 395599 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(395629), // Rule ID 1946 //
     /* 395604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395618 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 395623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395627 */   GIR_RootConstrainSelectedInstOperands,
     /* 395628 */   // GIR_Coverage, 1946,
     /* 395628 */   GIR_Done,
     /* 395629 */ // Label 7849: @395629
     /* 395629 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(395656), // Rule ID 5616 //
     /* 395634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395645 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 395650 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395654 */   GIR_RootConstrainSelectedInstOperands,
     /* 395655 */   // GIR_Coverage, 5616,
     /* 395655 */   GIR_Done,
     /* 395656 */ // Label 7850: @395656
     /* 395656 */ GIM_Reject,
     /* 395657 */ // Label 7845: @395657
     /* 395657 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(395684), // Rule ID 5618 //
     /* 395662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395673 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 395678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395682 */   GIR_RootConstrainSelectedInstOperands,
     /* 395683 */   // GIR_Coverage, 5618,
     /* 395683 */   GIR_Done,
     /* 395684 */ // Label 7851: @395684
     /* 395684 */ GIM_Reject,
     /* 395685 */ // Label 7846: @395685
     /* 395685 */ GIM_Reject,
     /* 395686 */ // Label 112: @395686
     /* 395686 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7855*/ GIMT_Encode4(395856),
     /* 395697 */ /*GILLT_s16*//*Label 7852*/ GIMT_Encode4(395709),
     /* 395701 */ /*GILLT_s32*//*Label 7853*/ GIMT_Encode4(395770),
     /* 395705 */ /*GILLT_s64*//*Label 7854*/ GIMT_Encode4(395828),
     /* 395709 */ // Label 7852: @395709
     /* 395709 */ GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(395739), // Rule ID 1954 //
     /* 395714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395728 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 395733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395737 */   GIR_RootConstrainSelectedInstOperands,
     /* 395738 */   // GIR_Coverage, 1954,
     /* 395738 */   GIR_Done,
     /* 395739 */ // Label 7856: @395739
     /* 395739 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(395769), // Rule ID 1956 //
     /* 395744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395758 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 395763 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395767 */   GIR_RootConstrainSelectedInstOperands,
     /* 395768 */   // GIR_Coverage, 1956,
     /* 395768 */   GIR_Done,
     /* 395769 */ // Label 7857: @395769
     /* 395769 */ GIM_Reject,
     /* 395770 */ // Label 7853: @395770
     /* 395770 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(395800), // Rule ID 1958 //
     /* 395775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395789 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 395794 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395798 */   GIR_RootConstrainSelectedInstOperands,
     /* 395799 */   // GIR_Coverage, 1958,
     /* 395799 */   GIR_Done,
     /* 395800 */ // Label 7858: @395800
     /* 395800 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(395827), // Rule ID 5624 //
     /* 395805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395816 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 395821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395825 */   GIR_RootConstrainSelectedInstOperands,
     /* 395826 */   // GIR_Coverage, 5624,
     /* 395826 */   GIR_Done,
     /* 395827 */ // Label 7859: @395827
     /* 395827 */ GIM_Reject,
     /* 395828 */ // Label 7854: @395828
     /* 395828 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(395855), // Rule ID 5626 //
     /* 395833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395844 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 395849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395853 */   GIR_RootConstrainSelectedInstOperands,
     /* 395854 */   // GIR_Coverage, 5626,
     /* 395854 */   GIR_Done,
     /* 395855 */ // Label 7860: @395855
     /* 395855 */ GIM_Reject,
     /* 395856 */ // Label 7855: @395856
     /* 395856 */ GIM_Reject,
     /* 395857 */ // Label 113: @395857
     /* 395857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7864*/ GIMT_Encode4(396027),
     /* 395868 */ /*GILLT_s16*//*Label 7861*/ GIMT_Encode4(395880),
     /* 395872 */ /*GILLT_s32*//*Label 7862*/ GIMT_Encode4(395941),
     /* 395876 */ /*GILLT_s64*//*Label 7863*/ GIMT_Encode4(395999),
     /* 395880 */ // Label 7861: @395880
     /* 395880 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(395910), // Rule ID 1948 //
     /* 395885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395899 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 395904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395908 */   GIR_RootConstrainSelectedInstOperands,
     /* 395909 */   // GIR_Coverage, 1948,
     /* 395909 */   GIR_Done,
     /* 395910 */ // Label 7865: @395910
     /* 395910 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(395940), // Rule ID 1950 //
     /* 395915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395929 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 395934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395938 */   GIR_RootConstrainSelectedInstOperands,
     /* 395939 */   // GIR_Coverage, 1950,
     /* 395939 */   GIR_Done,
     /* 395940 */ // Label 7866: @395940
     /* 395940 */ GIM_Reject,
     /* 395941 */ // Label 7862: @395941
     /* 395941 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(395971), // Rule ID 1952 //
     /* 395946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395960 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 395965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395969 */   GIR_RootConstrainSelectedInstOperands,
     /* 395970 */   // GIR_Coverage, 1952,
     /* 395970 */   GIR_Done,
     /* 395971 */ // Label 7867: @395971
     /* 395971 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(395998), // Rule ID 5620 //
     /* 395976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395987 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 395992 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395996 */   GIR_RootConstrainSelectedInstOperands,
     /* 395997 */   // GIR_Coverage, 5620,
     /* 395997 */   GIR_Done,
     /* 395998 */ // Label 7868: @395998
     /* 395998 */ GIM_Reject,
     /* 395999 */ // Label 7863: @395999
     /* 395999 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(396026), // Rule ID 5622 //
     /* 396004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396015 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 396020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396024 */   GIR_RootConstrainSelectedInstOperands,
     /* 396025 */   // GIR_Coverage, 5622,
     /* 396025 */   GIR_Done,
     /* 396026 */ // Label 7869: @396026
     /* 396026 */ GIM_Reject,
     /* 396027 */ // Label 7864: @396027
     /* 396027 */ GIM_Reject,
     /* 396028 */ // Label 114: @396028
     /* 396028 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7873*/ GIMT_Encode4(396198),
     /* 396039 */ /*GILLT_s16*//*Label 7870*/ GIMT_Encode4(396051),
     /* 396043 */ /*GILLT_s32*//*Label 7871*/ GIMT_Encode4(396112),
     /* 396047 */ /*GILLT_s64*//*Label 7872*/ GIMT_Encode4(396170),
     /* 396051 */ // Label 7870: @396051
     /* 396051 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(396081), // Rule ID 1960 //
     /* 396056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396070 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 396070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 396075 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396079 */   GIR_RootConstrainSelectedInstOperands,
     /* 396080 */   // GIR_Coverage, 1960,
     /* 396080 */   GIR_Done,
     /* 396081 */ // Label 7874: @396081
     /* 396081 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(396111), // Rule ID 1962 //
     /* 396086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396100 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 396100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 396105 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396109 */   GIR_RootConstrainSelectedInstOperands,
     /* 396110 */   // GIR_Coverage, 1962,
     /* 396110 */   GIR_Done,
     /* 396111 */ // Label 7875: @396111
     /* 396111 */ GIM_Reject,
     /* 396112 */ // Label 7871: @396112
     /* 396112 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(396142), // Rule ID 1964 //
     /* 396117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396131 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 396131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 396136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396140 */   GIR_RootConstrainSelectedInstOperands,
     /* 396141 */   // GIR_Coverage, 1964,
     /* 396141 */   GIR_Done,
     /* 396142 */ // Label 7876: @396142
     /* 396142 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(396169), // Rule ID 5628 //
     /* 396147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396158 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 396158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 396163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396167 */   GIR_RootConstrainSelectedInstOperands,
     /* 396168 */   // GIR_Coverage, 5628,
     /* 396168 */   GIR_Done,
     /* 396169 */ // Label 7877: @396169
     /* 396169 */ GIM_Reject,
     /* 396170 */ // Label 7872: @396170
     /* 396170 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(396197), // Rule ID 5630 //
     /* 396175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396186 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 396186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 396191 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396195 */   GIR_RootConstrainSelectedInstOperands,
     /* 396196 */   // GIR_Coverage, 5630,
     /* 396196 */   GIR_Done,
     /* 396197 */ // Label 7878: @396197
     /* 396197 */ GIM_Reject,
     /* 396198 */ // Label 7873: @396198
     /* 396198 */ GIM_Reject,
     /* 396199 */ // Label 115: @396199
     /* 396199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7883*/ GIMT_Encode4(397327),
     /* 396210 */ /*GILLT_s8*//*Label 7879*/ GIMT_Encode4(396226),
     /* 396214 */ /*GILLT_s16*//*Label 7880*/ GIMT_Encode4(396273),
     /* 396218 */ /*GILLT_s32*//*Label 7881*/ GIMT_Encode4(396688),
     /* 396222 */ /*GILLT_s64*//*Label 7882*/ GIMT_Encode4(397141),
     /* 396226 */ // Label 7879: @396226
     /* 396226 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(396249), // Rule ID 5889 //
     /* 396231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 396238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396242 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 396242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 396247 */   GIR_RootConstrainSelectedInstOperands,
     /* 396248 */   // GIR_Coverage, 5889,
     /* 396248 */   GIR_Done,
     /* 396249 */ // Label 7884: @396249
     /* 396249 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(396272), // Rule ID 5890 //
     /* 396254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 396261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396265 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 396265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 396270 */   GIR_RootConstrainSelectedInstOperands,
     /* 396271 */   // GIR_Coverage, 5890,
     /* 396271 */   GIR_Done,
     /* 396272 */ // Label 7885: @396272
     /* 396272 */ GIM_Reject,
     /* 396273 */ // Label 7880: @396273
     /* 396273 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(396323), // Rule ID 5836 //
     /* 396278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396293 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396296 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396301 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396312 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 396312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396317 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396321 */   GIR_RootConstrainSelectedInstOperands,
     /* 396322 */   // GIR_Coverage, 5836,
     /* 396322 */   GIR_EraseRootFromParent_Done,
     /* 396323 */ // Label 7886: @396323
     /* 396323 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(396373), // Rule ID 5838 //
     /* 396328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396343 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396346 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396362 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 396362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396367 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396371 */   GIR_RootConstrainSelectedInstOperands,
     /* 396372 */   // GIR_Coverage, 5838,
     /* 396372 */   GIR_EraseRootFromParent_Done,
     /* 396373 */ // Label 7887: @396373
     /* 396373 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(396423), // Rule ID 5846 //
     /* 396378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396393 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396396 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 396401 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396405 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396410 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396412 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 396412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 396415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396417 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396421 */   GIR_RootConstrainSelectedInstOperands,
     /* 396422 */   // GIR_Coverage, 5846,
     /* 396422 */   GIR_EraseRootFromParent_Done,
     /* 396423 */ // Label 7888: @396423
     /* 396423 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(396473), // Rule ID 5848 //
     /* 396428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396443 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396446 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 396451 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396455 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396462 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 396462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 396465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396467 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396471 */   GIR_RootConstrainSelectedInstOperands,
     /* 396472 */   // GIR_Coverage, 5848,
     /* 396472 */   GIR_EraseRootFromParent_Done,
     /* 396473 */ // Label 7889: @396473
     /* 396473 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(396515), // Rule ID 5845 //
     /* 396478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396485 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396489 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 396493 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396497 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396504 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 396504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 396507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396509 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396513 */   GIR_RootConstrainSelectedInstOperands,
     /* 396514 */   // GIR_Coverage, 5845,
     /* 396514 */   GIR_EraseRootFromParent_Done,
     /* 396515 */ // Label 7890: @396515
     /* 396515 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(396557), // Rule ID 5847 //
     /* 396520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 396535 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396539 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396546 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 396546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 396549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396551 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396555 */   GIR_RootConstrainSelectedInstOperands,
     /* 396556 */   // GIR_Coverage, 5847,
     /* 396556 */   GIR_EraseRootFromParent_Done,
     /* 396557 */ // Label 7891: @396557
     /* 396557 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(396599), // Rule ID 5835 //
     /* 396562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396577 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396588 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 396588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396597 */   GIR_RootConstrainSelectedInstOperands,
     /* 396598 */   // GIR_Coverage, 5835,
     /* 396598 */   GIR_EraseRootFromParent_Done,
     /* 396599 */ // Label 7892: @396599
     /* 396599 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(396641), // Rule ID 5837 //
     /* 396604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396623 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396630 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 396630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396635 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396639 */   GIR_RootConstrainSelectedInstOperands,
     /* 396640 */   // GIR_Coverage, 5837,
     /* 396640 */   GIR_EraseRootFromParent_Done,
     /* 396641 */ // Label 7893: @396641
     /* 396641 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(396664), // Rule ID 5891 //
     /* 396646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396657 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 396657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 396662 */   GIR_RootConstrainSelectedInstOperands,
     /* 396663 */   // GIR_Coverage, 5891,
     /* 396663 */   GIR_Done,
     /* 396664 */ // Label 7894: @396664
     /* 396664 */ GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(396687), // Rule ID 5892 //
     /* 396669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396680 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 396680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 396685 */   GIR_RootConstrainSelectedInstOperands,
     /* 396686 */   // GIR_Coverage, 5892,
     /* 396686 */   GIR_Done,
     /* 396687 */ // Label 7895: @396687
     /* 396687 */ GIM_Reject,
     /* 396688 */ // Label 7881: @396688
     /* 396688 */ GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(396738), // Rule ID 5840 //
     /* 396693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396708 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396711 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396727 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 396727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396732 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396736 */   GIR_RootConstrainSelectedInstOperands,
     /* 396737 */   // GIR_Coverage, 5840,
     /* 396737 */   GIR_EraseRootFromParent_Done,
     /* 396738 */ // Label 7896: @396738
     /* 396738 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(396788), // Rule ID 5842 //
     /* 396743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396758 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396761 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396770 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396777 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 396777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 396780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396782 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396786 */   GIR_RootConstrainSelectedInstOperands,
     /* 396787 */   // GIR_Coverage, 5842,
     /* 396787 */   GIR_EraseRootFromParent_Done,
     /* 396788 */ // Label 7897: @396788
     /* 396788 */ GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(396838), // Rule ID 5850 //
     /* 396793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396808 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396811 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 396816 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396820 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396827 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 396827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 396830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396832 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396836 */   GIR_RootConstrainSelectedInstOperands,
     /* 396837 */   // GIR_Coverage, 5850,
     /* 396837 */   GIR_EraseRootFromParent_Done,
     /* 396838 */ // Label 7898: @396838
     /* 396838 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(396888), // Rule ID 5852 //
     /* 396843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396858 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396861 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 396866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396870 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396877 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 396877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 396880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 396886 */   GIR_RootConstrainSelectedInstOperands,
     /* 396887 */   // GIR_Coverage, 5852,
     /* 396887 */   GIR_EraseRootFromParent_Done,
     /* 396888 */ // Label 7899: @396888
     /* 396888 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(396930), // Rule ID 5849 //
     /* 396893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 396908 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396912 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396919 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 396919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 396922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396924 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396928 */   GIR_RootConstrainSelectedInstOperands,
     /* 396929 */   // GIR_Coverage, 5849,
     /* 396929 */   GIR_EraseRootFromParent_Done,
     /* 396930 */ // Label 7900: @396930
     /* 396930 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(396972), // Rule ID 5851 //
     /* 396935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 396950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396954 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396961 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 396961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 396964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396966 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396970 */   GIR_RootConstrainSelectedInstOperands,
     /* 396971 */   // GIR_Coverage, 5851,
     /* 396971 */   GIR_EraseRootFromParent_Done,
     /* 396972 */ // Label 7901: @396972
     /* 396972 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(397014), // Rule ID 5839 //
     /* 396977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396984 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396992 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396996 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397003 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 397003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 397006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397008 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397012 */   GIR_RootConstrainSelectedInstOperands,
     /* 397013 */   // GIR_Coverage, 5839,
     /* 397013 */   GIR_EraseRootFromParent_Done,
     /* 397014 */ // Label 7902: @397014
     /* 397014 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(397056), // Rule ID 5841 //
     /* 397019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 397034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397045 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 397045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 397048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397054 */   GIR_RootConstrainSelectedInstOperands,
     /* 397055 */   // GIR_Coverage, 5841,
     /* 397055 */   GIR_EraseRootFromParent_Done,
     /* 397056 */ // Label 7903: @397056
     /* 397056 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(397117), // Rule ID 5893 //
     /* 397061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397072 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 397072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 397079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397084 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 397094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397099 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 397106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397116 */   // GIR_Coverage, 5893,
     /* 397116 */   GIR_EraseRootFromParent_Done,
     /* 397117 */ // Label 7904: @397117
     /* 397117 */ GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(397140), // Rule ID 5894 //
     /* 397122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397133 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 397133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 397138 */   GIR_RootConstrainSelectedInstOperands,
     /* 397139 */   // GIR_Coverage, 5894,
     /* 397139 */   GIR_Done,
     /* 397140 */ // Label 7905: @397140
     /* 397140 */ GIM_Reject,
     /* 397141 */ // Label 7882: @397141
     /* 397141 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(397326),
     /* 397146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397153 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(397196), // Rule ID 5844 //
     /* 397158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397166 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397169 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 397174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397185 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 397185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 397188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397194 */     GIR_RootConstrainSelectedInstOperands,
     /* 397195 */     // GIR_Coverage, 5844,
     /* 397195 */     GIR_EraseRootFromParent_Done,
     /* 397196 */   // Label 7907: @397196
     /* 397196 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(397239), // Rule ID 5854 //
     /* 397201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 397209 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 397212 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 397217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397228 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 397228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 397231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 397237 */     GIR_RootConstrainSelectedInstOperands,
     /* 397238 */     // GIR_Coverage, 5854,
     /* 397238 */     GIR_EraseRootFromParent_Done,
     /* 397239 */   // Label 7908: @397239
     /* 397239 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(397274), // Rule ID 5853 //
     /* 397244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 397252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397263 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 397263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 397266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397272 */     GIR_RootConstrainSelectedInstOperands,
     /* 397273 */     // GIR_Coverage, 5853,
     /* 397273 */     GIR_EraseRootFromParent_Done,
     /* 397274 */   // Label 7909: @397274
     /* 397274 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(397309), // Rule ID 5843 //
     /* 397279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 397287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397298 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 397298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 397301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397307 */     GIR_RootConstrainSelectedInstOperands,
     /* 397308 */     // GIR_Coverage, 5843,
     /* 397308 */     GIR_EraseRootFromParent_Done,
     /* 397309 */   // Label 7910: @397309
     /* 397309 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(397325), // Rule ID 5895 //
     /* 397314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397318 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 397318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 397323 */     GIR_RootConstrainSelectedInstOperands,
     /* 397324 */     // GIR_Coverage, 5895,
     /* 397324 */     GIR_Done,
     /* 397325 */   // Label 7911: @397325
     /* 397325 */   GIM_Reject,
     /* 397326 */ // Label 7906: @397326
     /* 397326 */ GIM_Reject,
     /* 397327 */ // Label 7883: @397327
     /* 397327 */ GIM_Reject,
     /* 397328 */ // Label 116: @397328
     /* 397328 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7915*/ GIMT_Encode4(397530),
     /* 397339 */ /*GILLT_s8*//*Label 7912*/ GIMT_Encode4(397351),
     /* 397343 */ /*GILLT_s16*//*Label 7913*/ GIMT_Encode4(397398),
     /* 397347 */ /*GILLT_s32*//*Label 7914*/ GIMT_Encode4(397445),
     /* 397351 */ // Label 7912: @397351
     /* 397351 */ GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(397374), // Rule ID 5986 //
     /* 397356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397367 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 397367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 397372 */   GIR_RootConstrainSelectedInstOperands,
     /* 397373 */   // GIR_Coverage, 5986,
     /* 397373 */   GIR_Done,
     /* 397374 */ // Label 7916: @397374
     /* 397374 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(397397), // Rule ID 5987 //
     /* 397379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397390 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 397390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 397395 */   GIR_RootConstrainSelectedInstOperands,
     /* 397396 */   // GIR_Coverage, 5987,
     /* 397396 */   GIR_Done,
     /* 397397 */ // Label 7917: @397397
     /* 397397 */ GIM_Reject,
     /* 397398 */ // Label 7913: @397398
     /* 397398 */ GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(397421), // Rule ID 5988 //
     /* 397403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397414 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 397414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 397419 */   GIR_RootConstrainSelectedInstOperands,
     /* 397420 */   // GIR_Coverage, 5988,
     /* 397420 */   GIR_Done,
     /* 397421 */ // Label 7918: @397421
     /* 397421 */ GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(397444), // Rule ID 5989 //
     /* 397426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397437 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 397437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 397442 */   GIR_RootConstrainSelectedInstOperands,
     /* 397443 */   // GIR_Coverage, 5989,
     /* 397443 */   GIR_Done,
     /* 397444 */ // Label 7919: @397444
     /* 397444 */ GIM_Reject,
     /* 397445 */ // Label 7914: @397445
     /* 397445 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(397468), // Rule ID 5990 //
     /* 397450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397461 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 397461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 397466 */   GIR_RootConstrainSelectedInstOperands,
     /* 397467 */   // GIR_Coverage, 5990,
     /* 397467 */   GIR_Done,
     /* 397468 */ // Label 7920: @397468
     /* 397468 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(397529), // Rule ID 5991 //
     /* 397473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397484 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 397484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 397491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397496 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397500 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 397506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397511 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 397518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397528 */   // GIR_Coverage, 5991,
     /* 397528 */   GIR_EraseRootFromParent_Done,
     /* 397529 */ // Label 7921: @397529
     /* 397529 */ GIM_Reject,
     /* 397530 */ // Label 7915: @397530
     /* 397530 */ GIM_Reject,
     /* 397531 */ // Label 117: @397531
     /* 397531 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7925*/ GIMT_Encode4(397733),
     /* 397542 */ /*GILLT_s8*//*Label 7922*/ GIMT_Encode4(397554),
     /* 397546 */ /*GILLT_s16*//*Label 7923*/ GIMT_Encode4(397601),
     /* 397550 */ /*GILLT_s32*//*Label 7924*/ GIMT_Encode4(397648),
     /* 397554 */ // Label 7922: @397554
     /* 397554 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(397577), // Rule ID 5980 //
     /* 397559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397570 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 397570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 397575 */   GIR_RootConstrainSelectedInstOperands,
     /* 397576 */   // GIR_Coverage, 5980,
     /* 397576 */   GIR_Done,
     /* 397577 */ // Label 7926: @397577
     /* 397577 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(397600), // Rule ID 5981 //
     /* 397582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397593 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 397593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 397598 */   GIR_RootConstrainSelectedInstOperands,
     /* 397599 */   // GIR_Coverage, 5981,
     /* 397599 */   GIR_Done,
     /* 397600 */ // Label 7927: @397600
     /* 397600 */ GIM_Reject,
     /* 397601 */ // Label 7923: @397601
     /* 397601 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(397624), // Rule ID 5982 //
     /* 397606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397617 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 397617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 397622 */   GIR_RootConstrainSelectedInstOperands,
     /* 397623 */   // GIR_Coverage, 5982,
     /* 397623 */   GIR_Done,
     /* 397624 */ // Label 7928: @397624
     /* 397624 */ GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(397647), // Rule ID 5983 //
     /* 397629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397640 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 397640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 397645 */   GIR_RootConstrainSelectedInstOperands,
     /* 397646 */   // GIR_Coverage, 5983,
     /* 397646 */   GIR_Done,
     /* 397647 */ // Label 7929: @397647
     /* 397647 */ GIM_Reject,
     /* 397648 */ // Label 7924: @397648
     /* 397648 */ GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(397671), // Rule ID 5984 //
     /* 397653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397664 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 397664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 397669 */   GIR_RootConstrainSelectedInstOperands,
     /* 397670 */   // GIR_Coverage, 5984,
     /* 397670 */   GIR_Done,
     /* 397671 */ // Label 7930: @397671
     /* 397671 */ GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(397732), // Rule ID 5985 //
     /* 397676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397687 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 397687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 397694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397699 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397703 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 397709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397714 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 397721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397731 */   // GIR_Coverage, 5985,
     /* 397731 */   GIR_EraseRootFromParent_Done,
     /* 397732 */ // Label 7931: @397732
     /* 397732 */ GIM_Reject,
     /* 397733 */ // Label 7925: @397733
     /* 397733 */ GIM_Reject,
     /* 397734 */ // Label 118: @397734
     /* 397734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7935*/ GIMT_Encode4(397936),
     /* 397745 */ /*GILLT_s8*//*Label 7932*/ GIMT_Encode4(397757),
     /* 397749 */ /*GILLT_s16*//*Label 7933*/ GIMT_Encode4(397804),
     /* 397753 */ /*GILLT_s32*//*Label 7934*/ GIMT_Encode4(397851),
     /* 397757 */ // Label 7932: @397757
     /* 397757 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(397780), // Rule ID 5974 //
     /* 397762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397773 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 397773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 397778 */   GIR_RootConstrainSelectedInstOperands,
     /* 397779 */   // GIR_Coverage, 5974,
     /* 397779 */   GIR_Done,
     /* 397780 */ // Label 7936: @397780
     /* 397780 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(397803), // Rule ID 5975 //
     /* 397785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397796 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 397796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 397801 */   GIR_RootConstrainSelectedInstOperands,
     /* 397802 */   // GIR_Coverage, 5975,
     /* 397802 */   GIR_Done,
     /* 397803 */ // Label 7937: @397803
     /* 397803 */ GIM_Reject,
     /* 397804 */ // Label 7933: @397804
     /* 397804 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(397827), // Rule ID 5976 //
     /* 397809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397820 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 397820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 397825 */   GIR_RootConstrainSelectedInstOperands,
     /* 397826 */   // GIR_Coverage, 5976,
     /* 397826 */   GIR_Done,
     /* 397827 */ // Label 7938: @397827
     /* 397827 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(397850), // Rule ID 5977 //
     /* 397832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397843 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 397843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 397848 */   GIR_RootConstrainSelectedInstOperands,
     /* 397849 */   // GIR_Coverage, 5977,
     /* 397849 */   GIR_Done,
     /* 397850 */ // Label 7939: @397850
     /* 397850 */ GIM_Reject,
     /* 397851 */ // Label 7934: @397851
     /* 397851 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(397874), // Rule ID 5978 //
     /* 397856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397867 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 397867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 397872 */   GIR_RootConstrainSelectedInstOperands,
     /* 397873 */   // GIR_Coverage, 5978,
     /* 397873 */   GIR_Done,
     /* 397874 */ // Label 7940: @397874
     /* 397874 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(397935), // Rule ID 5979 //
     /* 397879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397890 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 397890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 397897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 397912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397917 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 397924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397934 */   // GIR_Coverage, 5979,
     /* 397934 */   GIR_EraseRootFromParent_Done,
     /* 397935 */ // Label 7941: @397935
     /* 397935 */ GIM_Reject,
     /* 397936 */ // Label 7935: @397936
     /* 397936 */ GIM_Reject,
     /* 397937 */ // Label 119: @397937
     /* 397937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7945*/ GIMT_Encode4(398139),
     /* 397948 */ /*GILLT_s8*//*Label 7942*/ GIMT_Encode4(397960),
     /* 397952 */ /*GILLT_s16*//*Label 7943*/ GIMT_Encode4(398007),
     /* 397956 */ /*GILLT_s32*//*Label 7944*/ GIMT_Encode4(398054),
     /* 397960 */ // Label 7942: @397960
     /* 397960 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(397983), // Rule ID 5968 //
     /* 397965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 397968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397976 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 397976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 397981 */   GIR_RootConstrainSelectedInstOperands,
     /* 397982 */   // GIR_Coverage, 5968,
     /* 397982 */   GIR_Done,
     /* 397983 */ // Label 7946: @397983
     /* 397983 */ GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(398006), // Rule ID 5969 //
     /* 397988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 397991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 397995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397999 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 397999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 398004 */   GIR_RootConstrainSelectedInstOperands,
     /* 398005 */   // GIR_Coverage, 5969,
     /* 398005 */   GIR_Done,
     /* 398006 */ // Label 7947: @398006
     /* 398006 */ GIM_Reject,
     /* 398007 */ // Label 7943: @398007
     /* 398007 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(398030), // Rule ID 5970 //
     /* 398012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398023 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 398023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 398028 */   GIR_RootConstrainSelectedInstOperands,
     /* 398029 */   // GIR_Coverage, 5970,
     /* 398029 */   GIR_Done,
     /* 398030 */ // Label 7948: @398030
     /* 398030 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(398053), // Rule ID 5971 //
     /* 398035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398046 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 398046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 398051 */   GIR_RootConstrainSelectedInstOperands,
     /* 398052 */   // GIR_Coverage, 5971,
     /* 398052 */   GIR_Done,
     /* 398053 */ // Label 7949: @398053
     /* 398053 */ GIM_Reject,
     /* 398054 */ // Label 7944: @398054
     /* 398054 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(398077), // Rule ID 5972 //
     /* 398059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398070 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 398075 */   GIR_RootConstrainSelectedInstOperands,
     /* 398076 */   // GIR_Coverage, 5972,
     /* 398076 */   GIR_Done,
     /* 398077 */ // Label 7950: @398077
     /* 398077 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(398138), // Rule ID 5973 //
     /* 398082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398093 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 398093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 398100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398109 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398120 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 398127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398137 */   // GIR_Coverage, 5973,
     /* 398137 */   GIR_EraseRootFromParent_Done,
     /* 398138 */ // Label 7951: @398138
     /* 398138 */ GIM_Reject,
     /* 398139 */ // Label 7945: @398139
     /* 398139 */ GIM_Reject,
     /* 398140 */ // Label 120: @398140
     /* 398140 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(398279),
     /* 398145 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 398148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 398152 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(398186), // Rule ID 257 //
     /* 398157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 398164 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 398164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 398167 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 398169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 398179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 398184 */     GIR_RootConstrainSelectedInstOperands,
     /* 398185 */     // GIR_Coverage, 257,
     /* 398185 */     GIR_EraseRootFromParent_Done,
     /* 398186 */   // Label 7953: @398186
     /* 398186 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(398220), // Rule ID 258 //
     /* 398191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 398198 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 398198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 398201 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 398203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 398213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 398218 */     GIR_RootConstrainSelectedInstOperands,
     /* 398219 */     // GIR_Coverage, 258,
     /* 398219 */     GIR_EraseRootFromParent_Done,
     /* 398220 */   // Label 7954: @398220
     /* 398220 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(398249), // Rule ID 273 //
     /* 398225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 398232 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 398232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 398235 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 398237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 398247 */     GIR_RootConstrainSelectedInstOperands,
     /* 398248 */     // GIR_Coverage, 273,
     /* 398248 */     GIR_EraseRootFromParent_Done,
     /* 398249 */   // Label 7955: @398249
     /* 398249 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(398278), // Rule ID 294 //
     /* 398254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 398261 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 398261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 398264 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 398266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 398276 */     GIR_RootConstrainSelectedInstOperands,
     /* 398277 */     // GIR_Coverage, 294,
     /* 398277 */     GIR_EraseRootFromParent_Done,
     /* 398278 */   // Label 7956: @398278
     /* 398278 */   GIM_Reject,
     /* 398279 */ // Label 7952: @398279
     /* 398279 */ GIM_Reject,
     /* 398280 */ // Label 121: @398280
     /* 398280 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7969*/ GIMT_Encode4(398819),
     /* 398291 */ /*GILLT_s64*//*Label 7957*/ GIMT_Encode4(398375), GIMT_Encode4(0),
     /* 398299 */ /*GILLT_v2s32*//*Label 7958*/ GIMT_Encode4(398413),
     /* 398303 */ /*GILLT_v2s64*//*Label 7959*/ GIMT_Encode4(398451),
     /* 398307 */ /*GILLT_v4s16*//*Label 7960*/ GIMT_Encode4(398489),
     /* 398311 */ /*GILLT_v4s32*//*Label 7961*/ GIMT_Encode4(398527),
     /* 398315 */ /*GILLT_v8s8*//*Label 7962*/ GIMT_Encode4(398565),
     /* 398319 */ /*GILLT_v8s16*//*Label 7963*/ GIMT_Encode4(398603),
     /* 398323 */ /*GILLT_v16s8*//*Label 7964*/ GIMT_Encode4(398641), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398343 */ /*GILLT_nxv2s64*//*Label 7965*/ GIMT_Encode4(398679), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398355 */ /*GILLT_nxv4s32*//*Label 7966*/ GIMT_Encode4(398714), GIMT_Encode4(0),
     /* 398363 */ /*GILLT_nxv8s16*//*Label 7967*/ GIMT_Encode4(398749), GIMT_Encode4(0),
     /* 398371 */ /*GILLT_nxv16s8*//*Label 7968*/ GIMT_Encode4(398784),
     /* 398375 */ // Label 7957: @398375
     /* 398375 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(398412), // Rule ID 5069 //
     /* 398380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 398389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398405 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 398405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 398410 */   GIR_RootConstrainSelectedInstOperands,
     /* 398411 */   // GIR_Coverage, 5069,
     /* 398411 */   GIR_Done,
     /* 398412 */ // Label 7970: @398412
     /* 398412 */ GIM_Reject,
     /* 398413 */ // Label 7958: @398413
     /* 398413 */ GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(398450), // Rule ID 5068 //
     /* 398418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 398427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398439 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398443 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 398443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 398448 */   GIR_RootConstrainSelectedInstOperands,
     /* 398449 */   // GIR_Coverage, 5068,
     /* 398449 */   GIR_Done,
     /* 398450 */ // Label 7971: @398450
     /* 398450 */ GIM_Reject,
     /* 398451 */ // Label 7959: @398451
     /* 398451 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(398488), // Rule ID 5073 //
     /* 398456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398462 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 398465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398481 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 398481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 398486 */   GIR_RootConstrainSelectedInstOperands,
     /* 398487 */   // GIR_Coverage, 5073,
     /* 398487 */   GIR_Done,
     /* 398488 */ // Label 7972: @398488
     /* 398488 */ GIM_Reject,
     /* 398489 */ // Label 7960: @398489
     /* 398489 */ GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(398526), // Rule ID 5067 //
     /* 398494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 398503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398515 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398519 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 398524 */   GIR_RootConstrainSelectedInstOperands,
     /* 398525 */   // GIR_Coverage, 5067,
     /* 398525 */   GIR_Done,
     /* 398526 */ // Label 7973: @398526
     /* 398526 */ GIM_Reject,
     /* 398527 */ // Label 7961: @398527
     /* 398527 */ GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(398564), // Rule ID 5072 //
     /* 398532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 398541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398557 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 398557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 398562 */   GIR_RootConstrainSelectedInstOperands,
     /* 398563 */   // GIR_Coverage, 5072,
     /* 398563 */   GIR_Done,
     /* 398564 */ // Label 7974: @398564
     /* 398564 */ GIM_Reject,
     /* 398565 */ // Label 7962: @398565
     /* 398565 */ GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(398602), // Rule ID 5066 //
     /* 398570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 398579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398591 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398595 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 398600 */   GIR_RootConstrainSelectedInstOperands,
     /* 398601 */   // GIR_Coverage, 5066,
     /* 398601 */   GIR_Done,
     /* 398602 */ // Label 7975: @398602
     /* 398602 */ GIM_Reject,
     /* 398603 */ // Label 7963: @398603
     /* 398603 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(398640), // Rule ID 5071 //
     /* 398608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 398617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398633 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 398638 */   GIR_RootConstrainSelectedInstOperands,
     /* 398639 */   // GIR_Coverage, 5071,
     /* 398639 */   GIR_Done,
     /* 398640 */ // Label 7976: @398640
     /* 398640 */ GIM_Reject,
     /* 398641 */ // Label 7964: @398641
     /* 398641 */ GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(398678), // Rule ID 5070 //
     /* 398646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 398652 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 398655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398671 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 398676 */   GIR_RootConstrainSelectedInstOperands,
     /* 398677 */   // GIR_Coverage, 5070,
     /* 398677 */   GIR_Done,
     /* 398678 */ // Label 7977: @398678
     /* 398678 */ GIM_Reject,
     /* 398679 */ // Label 7965: @398679
     /* 398679 */ GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(398713), // Rule ID 11860 //
     /* 398684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 398687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 398690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 398693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 398696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398700 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 398700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 398703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 398705 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 398707 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 398709 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 398711 */   GIR_RootConstrainSelectedInstOperands,
     /* 398712 */   // GIR_Coverage, 11860,
     /* 398712 */   GIR_EraseRootFromParent_Done,
     /* 398713 */ // Label 7978: @398713
     /* 398713 */ GIM_Reject,
     /* 398714 */ // Label 7966: @398714
     /* 398714 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(398748), // Rule ID 11858 //
     /* 398719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 398722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 398725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 398728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 398731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398735 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 398735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 398738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 398740 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 398742 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 398744 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 398746 */   GIR_RootConstrainSelectedInstOperands,
     /* 398747 */   // GIR_Coverage, 11858,
     /* 398747 */   GIR_EraseRootFromParent_Done,
     /* 398748 */ // Label 7979: @398748
     /* 398748 */ GIM_Reject,
     /* 398749 */ // Label 7967: @398749
     /* 398749 */ GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(398783), // Rule ID 11856 //
     /* 398754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 398757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 398760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 398763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 398766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398770 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 398770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 398773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 398775 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 398777 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 398779 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 398781 */   GIR_RootConstrainSelectedInstOperands,
     /* 398782 */   // GIR_Coverage, 11856,
     /* 398782 */   GIR_EraseRootFromParent_Done,
     /* 398783 */ // Label 7980: @398783
     /* 398783 */ GIM_Reject,
     /* 398784 */ // Label 7968: @398784
     /* 398784 */ GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(398818), // Rule ID 11854 //
     /* 398789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 398792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 398795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 398798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 398801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398805 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 398805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 398808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 398810 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 398812 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 398814 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 398816 */   GIR_RootConstrainSelectedInstOperands,
     /* 398817 */   // GIR_Coverage, 11854,
     /* 398817 */   GIR_EraseRootFromParent_Done,
     /* 398818 */ // Label 7981: @398818
     /* 398818 */ GIM_Reject,
     /* 398819 */ // Label 7969: @398819
     /* 398819 */ GIM_Reject,
     /* 398820 */ // Label 122: @398820
     /* 398820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7990*/ GIMT_Encode4(400642),
     /* 398831 */ /*GILLT_s64*//*Label 7982*/ GIMT_Encode4(398867), GIMT_Encode4(0),
     /* 398839 */ /*GILLT_v2s32*//*Label 7983*/ GIMT_Encode4(399062),
     /* 398843 */ /*GILLT_v2s64*//*Label 7984*/ GIMT_Encode4(399309),
     /* 398847 */ /*GILLT_v4s16*//*Label 7985*/ GIMT_Encode4(399556),
     /* 398851 */ /*GILLT_v4s32*//*Label 7986*/ GIMT_Encode4(399832),
     /* 398855 */ /*GILLT_v8s8*//*Label 7987*/ GIMT_Encode4(400079),
     /* 398859 */ /*GILLT_v8s16*//*Label 7988*/ GIMT_Encode4(400224),
     /* 398863 */ /*GILLT_v16s8*//*Label 7989*/ GIMT_Encode4(400500),
     /* 398867 */ // Label 7982: @398867
     /* 398867 */ GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(399061),
     /* 398872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398879 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(398926), // Rule ID 6413 //
     /* 398884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398899 */     // MIs[1] Rn
     /* 398899 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398910 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 398913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398924 */     GIR_RootConstrainSelectedInstOperands,
     /* 398925 */     // GIR_Coverage, 6413,
     /* 398925 */     GIR_EraseRootFromParent_Done,
     /* 398926 */   // Label 7992: @398926
     /* 398926 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(398973), // Rule ID 6424 //
     /* 398931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398946 */     // MIs[1] Rn
     /* 398946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398957 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 398960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398971 */     GIR_RootConstrainSelectedInstOperands,
     /* 398972 */     // GIR_Coverage, 6424,
     /* 398972 */     GIR_EraseRootFromParent_Done,
     /* 398973 */   // Label 7993: @398973
     /* 398973 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(399020), // Rule ID 13184 //
     /* 398978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398993 */     // MIs[1] Rn
     /* 398993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399004 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 399007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399018 */     GIR_RootConstrainSelectedInstOperands,
     /* 399019 */     // GIR_Coverage, 13184,
     /* 399019 */     GIR_EraseRootFromParent_Done,
     /* 399020 */   // Label 7994: @399020
     /* 399020 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(399040), // Rule ID 5632 //
     /* 399025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 399029 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 399029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399039 */     // GIR_Coverage, 5632,
     /* 399039 */     GIR_Done,
     /* 399040 */   // Label 7995: @399040
     /* 399040 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(399060), // Rule ID 5633 //
     /* 399045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399049 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 399049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399059 */     // GIR_Coverage, 5633,
     /* 399059 */     GIR_Done,
     /* 399060 */   // Label 7996: @399060
     /* 399060 */   GIM_Reject,
     /* 399061 */ // Label 7991: @399061
     /* 399061 */ GIM_Reject,
     /* 399062 */ // Label 7983: @399062
     /* 399062 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(399308),
     /* 399067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399074 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(399121), // Rule ID 6410 //
     /* 399079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399094 */     // MIs[1] Rn
     /* 399094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399105 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 399108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399119 */     GIR_RootConstrainSelectedInstOperands,
     /* 399120 */     // GIR_Coverage, 6410,
     /* 399120 */     GIR_EraseRootFromParent_Done,
     /* 399121 */   // Label 7998: @399121
     /* 399121 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(399168), // Rule ID 6421 //
     /* 399126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399141 */     // MIs[1] Rn
     /* 399141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399152 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 399155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399166 */     GIR_RootConstrainSelectedInstOperands,
     /* 399167 */     // GIR_Coverage, 6421,
     /* 399167 */     GIR_EraseRootFromParent_Done,
     /* 399168 */   // Label 7999: @399168
     /* 399168 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(399215), // Rule ID 13181 //
     /* 399173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399188 */     // MIs[1] Rn
     /* 399188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399199 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 399202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399213 */     GIR_RootConstrainSelectedInstOperands,
     /* 399214 */     // GIR_Coverage, 13181,
     /* 399214 */     GIR_EraseRootFromParent_Done,
     /* 399215 */   // Label 8000: @399215
     /* 399215 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(399234), // Rule ID 1916 //
     /* 399220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 399227 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 399227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 399232 */     GIR_RootConstrainSelectedInstOperands,
     /* 399233 */     // GIR_Coverage, 1916,
     /* 399233 */     GIR_Done,
     /* 399234 */   // Label 8001: @399234
     /* 399234 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(399307), // Rule ID 5634 //
     /* 399239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399243 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 399297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399305 */     GIR_RootConstrainSelectedInstOperands,
     /* 399306 */     // GIR_Coverage, 5634,
     /* 399306 */     GIR_EraseRootFromParent_Done,
     /* 399307 */   // Label 8002: @399307
     /* 399307 */   GIM_Reject,
     /* 399308 */ // Label 7997: @399308
     /* 399308 */ GIM_Reject,
     /* 399309 */ // Label 7984: @399309
     /* 399309 */ GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(399555),
     /* 399314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399321 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(399368), // Rule ID 6412 //
     /* 399326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399341 */     // MIs[1] Rn
     /* 399341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399352 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 399355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399366 */     GIR_RootConstrainSelectedInstOperands,
     /* 399367 */     // GIR_Coverage, 6412,
     /* 399367 */     GIR_EraseRootFromParent_Done,
     /* 399368 */   // Label 8004: @399368
     /* 399368 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(399415), // Rule ID 6423 //
     /* 399373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399388 */     // MIs[1] Rn
     /* 399388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399399 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 399402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399413 */     GIR_RootConstrainSelectedInstOperands,
     /* 399414 */     // GIR_Coverage, 6423,
     /* 399414 */     GIR_EraseRootFromParent_Done,
     /* 399415 */   // Label 8005: @399415
     /* 399415 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(399462), // Rule ID 13183 //
     /* 399420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399435 */     // MIs[1] Rn
     /* 399435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399446 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 399449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399460 */     GIR_RootConstrainSelectedInstOperands,
     /* 399461 */     // GIR_Coverage, 13183,
     /* 399461 */     GIR_EraseRootFromParent_Done,
     /* 399462 */   // Label 8006: @399462
     /* 399462 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(399481), // Rule ID 1918 //
     /* 399467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 399474 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 399474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 399479 */     GIR_RootConstrainSelectedInstOperands,
     /* 399480 */     // GIR_Coverage, 1918,
     /* 399480 */     GIR_Done,
     /* 399481 */   // Label 8007: @399481
     /* 399481 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(399554), // Rule ID 5636 //
     /* 399486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399490 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399516 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 399544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399552 */     GIR_RootConstrainSelectedInstOperands,
     /* 399553 */     // GIR_Coverage, 5636,
     /* 399553 */     GIR_EraseRootFromParent_Done,
     /* 399554 */   // Label 8008: @399554
     /* 399554 */   GIM_Reject,
     /* 399555 */ // Label 8003: @399555
     /* 399555 */ GIM_Reject,
     /* 399556 */ // Label 7985: @399556
     /* 399556 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(399617), // Rule ID 6408 //
     /* 399561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399576 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399579 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399583 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 399590 */   // MIs[1] Rn
     /* 399590 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399601 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 399604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399615 */   GIR_RootConstrainSelectedInstOperands,
     /* 399616 */   // GIR_Coverage, 6408,
     /* 399616 */   GIR_EraseRootFromParent_Done,
     /* 399617 */ // Label 8009: @399617
     /* 399617 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(399671), // Rule ID 6425 //
     /* 399622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399637 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399644 */   // MIs[1] Rn
     /* 399644 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399655 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 399658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399660 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399669 */   GIR_RootConstrainSelectedInstOperands,
     /* 399670 */   // GIR_Coverage, 6425,
     /* 399670 */   GIR_EraseRootFromParent_Done,
     /* 399671 */ // Label 8010: @399671
     /* 399671 */ GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(399725), // Rule ID 13179 //
     /* 399676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399691 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399698 */   // MIs[1] Rn
     /* 399698 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399702 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399709 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 399712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399714 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399723 */   GIR_RootConstrainSelectedInstOperands,
     /* 399724 */   // GIR_Coverage, 13179,
     /* 399724 */   GIR_EraseRootFromParent_Done,
     /* 399725 */ // Label 8011: @399725
     /* 399725 */ GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(399751), // Rule ID 1914 //
     /* 399730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 399744 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 399744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 399749 */   GIR_RootConstrainSelectedInstOperands,
     /* 399750 */   // GIR_Coverage, 1914,
     /* 399750 */   GIR_Done,
     /* 399751 */ // Label 8012: @399751
     /* 399751 */ GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(399831), // Rule ID 5637 //
     /* 399756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399767 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399767 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 399770 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399774 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 399784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399793 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399800 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 399803 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 399821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399829 */   GIR_RootConstrainSelectedInstOperands,
     /* 399830 */   // GIR_Coverage, 5637,
     /* 399830 */   GIR_EraseRootFromParent_Done,
     /* 399831 */ // Label 8013: @399831
     /* 399831 */ GIM_Reject,
     /* 399832 */ // Label 7986: @399832
     /* 399832 */ GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(400078),
     /* 399837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399844 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(399891), // Rule ID 6411 //
     /* 399849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399864 */     // MIs[1] Rn
     /* 399864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399875 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 399878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399889 */     GIR_RootConstrainSelectedInstOperands,
     /* 399890 */     // GIR_Coverage, 6411,
     /* 399890 */     GIR_EraseRootFromParent_Done,
     /* 399891 */   // Label 8015: @399891
     /* 399891 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(399938), // Rule ID 6422 //
     /* 399896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399911 */     // MIs[1] Rn
     /* 399911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399922 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 399925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399936 */     GIR_RootConstrainSelectedInstOperands,
     /* 399937 */     // GIR_Coverage, 6422,
     /* 399937 */     GIR_EraseRootFromParent_Done,
     /* 399938 */   // Label 8016: @399938
     /* 399938 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(399985), // Rule ID 13182 //
     /* 399943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399958 */     // MIs[1] Rn
     /* 399958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399969 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 399972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399983 */     GIR_RootConstrainSelectedInstOperands,
     /* 399984 */     // GIR_Coverage, 13182,
     /* 399984 */     GIR_EraseRootFromParent_Done,
     /* 399985 */   // Label 8017: @399985
     /* 399985 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(400004), // Rule ID 1917 //
     /* 399990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 399997 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 399997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 400002 */     GIR_RootConstrainSelectedInstOperands,
     /* 400003 */     // GIR_Coverage, 1917,
     /* 400003 */     GIR_Done,
     /* 400004 */   // Label 8018: @400004
     /* 400004 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(400077), // Rule ID 5635 //
     /* 400009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400013 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400013 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400016 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400020 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 400067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400075 */     GIR_RootConstrainSelectedInstOperands,
     /* 400076 */     // GIR_Coverage, 5635,
     /* 400076 */     GIR_EraseRootFromParent_Done,
     /* 400077 */   // Label 8019: @400077
     /* 400077 */   GIM_Reject,
     /* 400078 */ // Label 8014: @400078
     /* 400078 */ GIM_Reject,
     /* 400079 */ // Label 7987: @400079
     /* 400079 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(400136), // Rule ID 13177 //
     /* 400084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 400087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400099 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 400110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 400119 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 400122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400134 */   GIR_RootConstrainSelectedInstOperands,
     /* 400135 */   // GIR_Coverage, 13177,
     /* 400135 */   GIR_EraseRootFromParent_Done,
     /* 400136 */ // Label 8020: @400136
     /* 400136 */ GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(400197), // Rule ID 6406 //
     /* 400141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400156 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400159 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400163 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 400170 */   // MIs[1] Rn
     /* 400170 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400174 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400181 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 400184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400186 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400195 */   GIR_RootConstrainSelectedInstOperands,
     /* 400196 */   // GIR_Coverage, 6406,
     /* 400196 */   GIR_EraseRootFromParent_Done,
     /* 400197 */ // Label 8021: @400197
     /* 400197 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(400223), // Rule ID 1912 //
     /* 400202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 400216 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 400216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 400221 */   GIR_RootConstrainSelectedInstOperands,
     /* 400222 */   // GIR_Coverage, 1912,
     /* 400222 */   GIR_Done,
     /* 400223 */ // Label 8022: @400223
     /* 400223 */ GIM_Reject,
     /* 400224 */ // Label 7988: @400224
     /* 400224 */ GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(400285), // Rule ID 6409 //
     /* 400229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400236 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400244 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400247 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400251 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 400258 */   // MIs[1] Rn
     /* 400258 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400262 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400269 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 400272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400274 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400283 */   GIR_RootConstrainSelectedInstOperands,
     /* 400284 */   // GIR_Coverage, 6409,
     /* 400284 */   GIR_EraseRootFromParent_Done,
     /* 400285 */ // Label 8023: @400285
     /* 400285 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(400339), // Rule ID 6426 //
     /* 400290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400305 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400312 */   // MIs[1] Rn
     /* 400312 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400321 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400323 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 400326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400328 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400337 */   GIR_RootConstrainSelectedInstOperands,
     /* 400338 */   // GIR_Coverage, 6426,
     /* 400338 */   GIR_EraseRootFromParent_Done,
     /* 400339 */ // Label 8024: @400339
     /* 400339 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(400393), // Rule ID 13180 //
     /* 400344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400359 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400362 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400366 */   // MIs[1] Rn
     /* 400366 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400377 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 400380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400382 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400391 */   GIR_RootConstrainSelectedInstOperands,
     /* 400392 */   // GIR_Coverage, 13180,
     /* 400392 */   GIR_EraseRootFromParent_Done,
     /* 400393 */ // Label 8025: @400393
     /* 400393 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(400419), // Rule ID 1915 //
     /* 400398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 400412 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 400412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 400417 */   GIR_RootConstrainSelectedInstOperands,
     /* 400418 */   // GIR_Coverage, 1915,
     /* 400418 */   GIR_Done,
     /* 400419 */ // Label 8026: @400419
     /* 400419 */ GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(400499), // Rule ID 5638 //
     /* 400424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400435 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 400438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 400452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400461 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400468 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 400471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 400489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400497 */   GIR_RootConstrainSelectedInstOperands,
     /* 400498 */   // GIR_Coverage, 5638,
     /* 400498 */   GIR_EraseRootFromParent_Done,
     /* 400499 */ // Label 8027: @400499
     /* 400499 */ GIM_Reject,
     /* 400500 */ // Label 7989: @400500
     /* 400500 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(400561), // Rule ID 6407 //
     /* 400505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400520 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400523 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400527 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 400534 */   // MIs[1] Rn
     /* 400534 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400538 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400545 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 400548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400550 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400559 */   GIR_RootConstrainSelectedInstOperands,
     /* 400560 */   // GIR_Coverage, 6407,
     /* 400560 */   GIR_EraseRootFromParent_Done,
     /* 400561 */ // Label 8028: @400561
     /* 400561 */ GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(400615), // Rule ID 13178 //
     /* 400566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 400569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400581 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400588 */   // MIs[1] Rn
     /* 400588 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400592 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400597 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400599 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 400602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400613 */   GIR_RootConstrainSelectedInstOperands,
     /* 400614 */   // GIR_Coverage, 13178,
     /* 400614 */   GIR_EraseRootFromParent_Done,
     /* 400615 */ // Label 8029: @400615
     /* 400615 */ GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(400641), // Rule ID 1913 //
     /* 400620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 400634 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 400634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 400639 */   GIR_RootConstrainSelectedInstOperands,
     /* 400640 */   // GIR_Coverage, 1913,
     /* 400640 */   GIR_Done,
     /* 400641 */ // Label 8030: @400641
     /* 400641 */ GIM_Reject,
     /* 400642 */ // Label 7990: @400642
     /* 400642 */ GIM_Reject,
     /* 400643 */ // Label 123: @400643
     /* 400643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8033*/ GIMT_Encode4(400897),
     /* 400654 */ /*GILLT_v4s16*//*Label 8031*/ GIMT_Encode4(400670), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 400666 */ /*GILLT_v8s16*//*Label 8032*/ GIMT_Encode4(400756),
     /* 400670 */ // Label 8031: @400670
     /* 400670 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(400755),
     /* 400675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400689 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(400723), // Rule ID 1922 //
     /* 400694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400709 */     // MIs[1] Operand 1
     /* 400709 */     // No operand predicates
     /* 400709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400711 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 400711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 400714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 400721 */     GIR_RootConstrainSelectedInstOperands,
     /* 400722 */     // GIR_Coverage, 1922,
     /* 400722 */     GIR_EraseRootFromParent_Done,
     /* 400723 */   // Label 8035: @400723
     /* 400723 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(400754), // Rule ID 5639 //
     /* 400728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400740 */     // MIs[1] Operand 1
     /* 400740 */     // No operand predicates
     /* 400740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400742 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 400742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 400745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400752 */     GIR_RootConstrainSelectedInstOperands,
     /* 400753 */     // GIR_Coverage, 5639,
     /* 400753 */     GIR_EraseRootFromParent_Done,
     /* 400754 */   // Label 8036: @400754
     /* 400754 */   GIM_Reject,
     /* 400755 */ // Label 8034: @400755
     /* 400755 */ GIM_Reject,
     /* 400756 */ // Label 8032: @400756
     /* 400756 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(400896),
     /* 400761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400771 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(400822), // Rule ID 6417 //
     /* 400776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 400784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 400787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 400791 */     // MIs[1] Rn
     /* 400791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 400795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 400800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 400804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400806 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 400806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 400809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 400811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 400820 */     GIR_RootConstrainSelectedInstOperands,
     /* 400821 */     // GIR_Coverage, 6417,
     /* 400821 */     GIR_EraseRootFromParent_Done,
     /* 400822 */   // Label 8038: @400822
     /* 400822 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(400860), // Rule ID 1923 //
     /* 400827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400846 */     // MIs[1] Operand 1
     /* 400846 */     // No operand predicates
     /* 400846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400848 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 400848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 400851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 400858 */     GIR_RootConstrainSelectedInstOperands,
     /* 400859 */     // GIR_Coverage, 1923,
     /* 400859 */     GIR_EraseRootFromParent_Done,
     /* 400860 */   // Label 8039: @400860
     /* 400860 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(400895), // Rule ID 5640 //
     /* 400865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400881 */     // MIs[1] Operand 1
     /* 400881 */     // No operand predicates
     /* 400881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400883 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 400883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 400886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400893 */     GIR_RootConstrainSelectedInstOperands,
     /* 400894 */     // GIR_Coverage, 5640,
     /* 400894 */     GIR_EraseRootFromParent_Done,
     /* 400895 */   // Label 8040: @400895
     /* 400895 */   GIM_Reject,
     /* 400896 */ // Label 8037: @400896
     /* 400896 */ GIM_Reject,
     /* 400897 */ // Label 8033: @400897
     /* 400897 */ GIM_Reject,
     /* 400898 */ // Label 124: @400898
     /* 400898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8043*/ GIMT_Encode4(401152),
     /* 400909 */ /*GILLT_v2s32*//*Label 8041*/ GIMT_Encode4(400925), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 400921 */ /*GILLT_v4s32*//*Label 8042*/ GIMT_Encode4(401011),
     /* 400925 */ // Label 8041: @400925
     /* 400925 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(401010),
     /* 400930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400944 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(400978), // Rule ID 1920 //
     /* 400949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400964 */     // MIs[1] Operand 1
     /* 400964 */     // No operand predicates
     /* 400964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400966 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 400966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 400969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 400976 */     GIR_RootConstrainSelectedInstOperands,
     /* 400977 */     // GIR_Coverage, 1920,
     /* 400977 */     GIR_EraseRootFromParent_Done,
     /* 400978 */   // Label 8045: @400978
     /* 400978 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(401009), // Rule ID 5641 //
     /* 400983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400995 */     // MIs[1] Operand 1
     /* 400995 */     // No operand predicates
     /* 400995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400997 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 400997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 401000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401007 */     GIR_RootConstrainSelectedInstOperands,
     /* 401008 */     // GIR_Coverage, 5641,
     /* 401008 */     GIR_EraseRootFromParent_Done,
     /* 401009 */   // Label 8046: @401009
     /* 401009 */   GIM_Reject,
     /* 401010 */ // Label 8044: @401010
     /* 401010 */ GIM_Reject,
     /* 401011 */ // Label 8042: @401011
     /* 401011 */ GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(401151),
     /* 401016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401026 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(401077), // Rule ID 6419 //
     /* 401031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401046 */     // MIs[1] Rn
     /* 401046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 401059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401061 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 401064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401075 */     GIR_RootConstrainSelectedInstOperands,
     /* 401076 */     // GIR_Coverage, 6419,
     /* 401076 */     GIR_EraseRootFromParent_Done,
     /* 401077 */   // Label 8048: @401077
     /* 401077 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(401115), // Rule ID 1921 //
     /* 401082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401101 */     // MIs[1] Operand 1
     /* 401101 */     // No operand predicates
     /* 401101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401103 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 401103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 401106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 401113 */     GIR_RootConstrainSelectedInstOperands,
     /* 401114 */     // GIR_Coverage, 1921,
     /* 401114 */     GIR_EraseRootFromParent_Done,
     /* 401115 */   // Label 8049: @401115
     /* 401115 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(401150), // Rule ID 5642 //
     /* 401120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 401136 */     // MIs[1] Operand 1
     /* 401136 */     // No operand predicates
     /* 401136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401138 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 401138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 401141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401148 */     GIR_RootConstrainSelectedInstOperands,
     /* 401149 */     // GIR_Coverage, 5642,
     /* 401149 */     GIR_EraseRootFromParent_Done,
     /* 401150 */   // Label 8050: @401150
     /* 401150 */   GIM_Reject,
     /* 401151 */ // Label 8047: @401151
     /* 401151 */ GIM_Reject,
     /* 401152 */ // Label 8043: @401152
     /* 401152 */ GIM_Reject,
     /* 401153 */ // Label 125: @401153
     /* 401153 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(401298),
     /* 401158 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 401161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401171 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(401222), // Rule ID 6420 //
     /* 401176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401191 */     // MIs[1] Rn
     /* 401191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 401204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401206 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 401209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401220 */     GIR_RootConstrainSelectedInstOperands,
     /* 401221 */     // GIR_Coverage, 6420,
     /* 401221 */     GIR_EraseRootFromParent_Done,
     /* 401222 */   // Label 8052: @401222
     /* 401222 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(401297),
     /* 401227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401231 */     GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(401265), // Rule ID 1919 //
     /* 401236 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401239 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401243 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401247 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 401251 */       // MIs[1] Operand 1
     /* 401251 */       // No operand predicates
     /* 401251 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401253 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 401253 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 401256 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401258 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401260 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 401263 */       GIR_RootConstrainSelectedInstOperands,
     /* 401264 */       // GIR_Coverage, 1919,
     /* 401264 */       GIR_EraseRootFromParent_Done,
     /* 401265 */     // Label 8054: @401265
     /* 401265 */     GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(401296), // Rule ID 5643 //
     /* 401270 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401274 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401278 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 401282 */       // MIs[1] Operand 1
     /* 401282 */       // No operand predicates
     /* 401282 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401284 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 401284 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 401287 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401289 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401291 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401294 */       GIR_RootConstrainSelectedInstOperands,
     /* 401295 */       // GIR_Coverage, 5643,
     /* 401295 */       GIR_EraseRootFromParent_Done,
     /* 401296 */     // Label 8055: @401296
     /* 401296 */     GIM_Reject,
     /* 401297 */   // Label 8053: @401297
     /* 401297 */   GIM_Reject,
     /* 401298 */ // Label 8051: @401298
     /* 401298 */ GIM_Reject,
     /* 401299 */ // Label 126: @401299
     /* 401299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8058*/ GIMT_Encode4(401477),
     /* 401310 */ /*GILLT_v8s8*//*Label 8056*/ GIMT_Encode4(401322), GIMT_Encode4(0),
     /* 401318 */ /*GILLT_v16s8*//*Label 8057*/ GIMT_Encode4(401371),
     /* 401322 */ // Label 8056: @401322
     /* 401322 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(401370), // Rule ID 1924 //
     /* 401327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401352 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 401356 */   // MIs[1] Operand 1
     /* 401356 */   // No operand predicates
     /* 401356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401358 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 401358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 401361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401365 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 401368 */   GIR_RootConstrainSelectedInstOperands,
     /* 401369 */   // GIR_Coverage, 1924,
     /* 401369 */   GIR_EraseRootFromParent_Done,
     /* 401370 */ // Label 8059: @401370
     /* 401370 */ GIM_Reject,
     /* 401371 */ // Label 8057: @401371
     /* 401371 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(401476),
     /* 401376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401386 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(401437), // Rule ID 6415 //
     /* 401391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 401399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 401402 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 401406 */     // MIs[1] Rn
     /* 401406 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 401410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 401415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 401419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401421 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 401421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 401424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 401426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 401435 */     GIR_RootConstrainSelectedInstOperands,
     /* 401436 */     // GIR_Coverage, 6415,
     /* 401436 */     GIR_EraseRootFromParent_Done,
     /* 401437 */   // Label 8061: @401437
     /* 401437 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(401475), // Rule ID 1925 //
     /* 401442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 401461 */     // MIs[1] Operand 1
     /* 401461 */     // No operand predicates
     /* 401461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401463 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 401463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 401466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 401473 */     GIR_RootConstrainSelectedInstOperands,
     /* 401474 */     // GIR_Coverage, 1925,
     /* 401474 */     GIR_EraseRootFromParent_Done,
     /* 401475 */   // Label 8062: @401475
     /* 401475 */   GIM_Reject,
     /* 401476 */ // Label 8060: @401476
     /* 401476 */ GIM_Reject,
     /* 401477 */ // Label 8058: @401477
     /* 401477 */ GIM_Reject,
     /* 401478 */ // Label 127: @401478
     /* 401478 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8072*/ GIMT_Encode4(403127),
     /* 401489 */ /*GILLT_s64*//*Label 8063*/ GIMT_Encode4(401573), GIMT_Encode4(0),
     /* 401497 */ /*GILLT_v2s32*//*Label 8064*/ GIMT_Encode4(401894),
     /* 401501 */ /*GILLT_v2s64*//*Label 8065*/ GIMT_Encode4(402215),
     /* 401505 */ /*GILLT_v4s16*//*Label 8066*/ GIMT_Encode4(402298),
     /* 401509 */ /*GILLT_v4s32*//*Label 8067*/ GIMT_Encode4(402619),
     /* 401513 */ /*GILLT_v8s8*//*Label 8068*/ GIMT_Encode4(402702),
     /* 401517 */ /*GILLT_v8s16*//*Label 8069*/ GIMT_Encode4(402911),
     /* 401521 */ /*GILLT_v16s8*//*Label 8070*/ GIMT_Encode4(402994), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 401569 */ /*GILLT_nxv16s8*//*Label 8071*/ GIMT_Encode4(403080),
     /* 401573 */ // Label 8063: @401573
     /* 401573 */ GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(401893),
     /* 401578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401588 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(401703), // Rule ID 5460 //
     /* 401593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401610 */     // MIs[1] Operand 2
     /* 401610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401629 */     // MIs[2] Rn
     /* 401629 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 401634 */     // MIs[2] Operand 2
     /* 401634 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 401645 */     // MIs[0] imm
     /* 401645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401653 */     // MIs[3] Operand 1
     /* 401653 */     // No operand predicates
     /* 401653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401655 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 401655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 401662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 401678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 401680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 401692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401702 */     // GIR_Coverage, 5460,
     /* 401702 */     GIR_EraseRootFromParent_Done,
     /* 401703 */   // Label 8074: @401703
     /* 401703 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(401818), // Rule ID 5465 //
     /* 401708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401725 */     // MIs[1] Operand 2
     /* 401725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401744 */     // MIs[2] Rn
     /* 401744 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 401749 */     // MIs[2] Operand 2
     /* 401749 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 401760 */     // MIs[0] imm
     /* 401760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401768 */     // MIs[3] Operand 1
     /* 401768 */     // No operand predicates
     /* 401768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401770 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 401770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 401777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 401793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 401795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 401807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401817 */     // GIR_Coverage, 5465,
     /* 401817 */     GIR_EraseRootFromParent_Done,
     /* 401818 */   // Label 8075: @401818
     /* 401818 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(401855), // Rule ID 5457 //
     /* 401823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401831 */     // MIs[0] imm
     /* 401831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 401835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401839 */     // MIs[1] Operand 1
     /* 401839 */     // No operand predicates
     /* 401839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401841 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 401841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 401844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 401850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401853 */     GIR_RootConstrainSelectedInstOperands,
     /* 401854 */     // GIR_Coverage, 5457,
     /* 401854 */     GIR_EraseRootFromParent_Done,
     /* 401855 */   // Label 8076: @401855
     /* 401855 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(401892), // Rule ID 5462 //
     /* 401860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401868 */     // MIs[0] imm
     /* 401868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 401872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401876 */     // MIs[1] Operand 1
     /* 401876 */     // No operand predicates
     /* 401876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401878 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 401878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 401881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 401887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 401890 */     GIR_RootConstrainSelectedInstOperands,
     /* 401891 */     // GIR_Coverage, 5462,
     /* 401891 */     GIR_EraseRootFromParent_Done,
     /* 401892 */   // Label 8077: @401892
     /* 401892 */   GIM_Reject,
     /* 401893 */ // Label 8073: @401893
     /* 401893 */ GIM_Reject,
     /* 401894 */ // Label 8064: @401894
     /* 401894 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(402214),
     /* 401899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401909 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(402024), // Rule ID 5450 //
     /* 401914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401931 */     // MIs[1] Operand 2
     /* 401931 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 401942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 401950 */     // MIs[2] Rn
     /* 401950 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 401955 */     // MIs[2] Operand 2
     /* 401955 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 401966 */     // MIs[0] imm
     /* 401966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401974 */     // MIs[3] Operand 1
     /* 401974 */     // No operand predicates
     /* 401974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401976 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 401976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 401983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 401999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402006 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 402013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402023 */     // GIR_Coverage, 5450,
     /* 402023 */     GIR_EraseRootFromParent_Done,
     /* 402024 */   // Label 8079: @402024
     /* 402024 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(402139), // Rule ID 5455 //
     /* 402029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402046 */     // MIs[1] Operand 2
     /* 402046 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 402057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402065 */     // MIs[2] Rn
     /* 402065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 402070 */     // MIs[2] Operand 2
     /* 402070 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 402081 */     // MIs[0] imm
     /* 402081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402089 */     // MIs[3] Operand 1
     /* 402089 */     // No operand predicates
     /* 402089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402091 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 402091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 402114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 402128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402138 */     // GIR_Coverage, 5455,
     /* 402138 */     GIR_EraseRootFromParent_Done,
     /* 402139 */   // Label 8080: @402139
     /* 402139 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(402176), // Rule ID 5447 //
     /* 402144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402152 */     // MIs[0] imm
     /* 402152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402160 */     // MIs[1] Operand 1
     /* 402160 */     // No operand predicates
     /* 402160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402162 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402174 */     GIR_RootConstrainSelectedInstOperands,
     /* 402175 */     // GIR_Coverage, 5447,
     /* 402175 */     GIR_EraseRootFromParent_Done,
     /* 402176 */   // Label 8081: @402176
     /* 402176 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(402213), // Rule ID 5452 //
     /* 402181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402189 */     // MIs[0] imm
     /* 402189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402197 */     // MIs[1] Operand 1
     /* 402197 */     // No operand predicates
     /* 402197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402199 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402211 */     GIR_RootConstrainSelectedInstOperands,
     /* 402212 */     // GIR_Coverage, 5452,
     /* 402212 */     GIR_EraseRootFromParent_Done,
     /* 402213 */   // Label 8082: @402213
     /* 402213 */   GIM_Reject,
     /* 402214 */ // Label 8078: @402214
     /* 402214 */ GIM_Reject,
     /* 402215 */ // Label 8065: @402215
     /* 402215 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(402297),
     /* 402220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402238 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(402267), // Rule ID 5458 //
     /* 402243 */     // MIs[0] imm
     /* 402243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402251 */     // MIs[1] Operand 1
     /* 402251 */     // No operand predicates
     /* 402251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402253 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402265 */     GIR_RootConstrainSelectedInstOperands,
     /* 402266 */     // GIR_Coverage, 5458,
     /* 402266 */     GIR_EraseRootFromParent_Done,
     /* 402267 */   // Label 8084: @402267
     /* 402267 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(402296), // Rule ID 5463 //
     /* 402272 */     // MIs[0] imm
     /* 402272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402280 */     // MIs[1] Operand 1
     /* 402280 */     // No operand predicates
     /* 402280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402282 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402294 */     GIR_RootConstrainSelectedInstOperands,
     /* 402295 */     // GIR_Coverage, 5463,
     /* 402295 */     GIR_EraseRootFromParent_Done,
     /* 402296 */   // Label 8085: @402296
     /* 402296 */   GIM_Reject,
     /* 402297 */ // Label 8083: @402297
     /* 402297 */ GIM_Reject,
     /* 402298 */ // Label 8066: @402298
     /* 402298 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(402618),
     /* 402303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402313 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(402428), // Rule ID 5440 //
     /* 402318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402335 */     // MIs[1] Operand 2
     /* 402335 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 402346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402354 */     // MIs[2] Rn
     /* 402354 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 402359 */     // MIs[2] Operand 2
     /* 402359 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 402370 */     // MIs[0] imm
     /* 402370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402378 */     // MIs[3] Operand 1
     /* 402378 */     // No operand predicates
     /* 402378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402380 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 402380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 402403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402410 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 402417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402427 */     // GIR_Coverage, 5440,
     /* 402427 */     GIR_EraseRootFromParent_Done,
     /* 402428 */   // Label 8087: @402428
     /* 402428 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(402543), // Rule ID 5445 //
     /* 402433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402450 */     // MIs[1] Operand 2
     /* 402450 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 402461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402469 */     // MIs[2] Rn
     /* 402469 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 402474 */     // MIs[2] Operand 2
     /* 402474 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 402485 */     // MIs[0] imm
     /* 402485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402493 */     // MIs[3] Operand 1
     /* 402493 */     // No operand predicates
     /* 402493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402495 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 402495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 402518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 402532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402542 */     // GIR_Coverage, 5445,
     /* 402542 */     GIR_EraseRootFromParent_Done,
     /* 402543 */   // Label 8088: @402543
     /* 402543 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(402580), // Rule ID 5437 //
     /* 402548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402556 */     // MIs[0] imm
     /* 402556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402564 */     // MIs[1] Operand 1
     /* 402564 */     // No operand predicates
     /* 402564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402566 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402578 */     GIR_RootConstrainSelectedInstOperands,
     /* 402579 */     // GIR_Coverage, 5437,
     /* 402579 */     GIR_EraseRootFromParent_Done,
     /* 402580 */   // Label 8089: @402580
     /* 402580 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(402617), // Rule ID 5442 //
     /* 402585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402593 */     // MIs[0] imm
     /* 402593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402601 */     // MIs[1] Operand 1
     /* 402601 */     // No operand predicates
     /* 402601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402603 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402615 */     GIR_RootConstrainSelectedInstOperands,
     /* 402616 */     // GIR_Coverage, 5442,
     /* 402616 */     GIR_EraseRootFromParent_Done,
     /* 402617 */   // Label 8090: @402617
     /* 402617 */   GIM_Reject,
     /* 402618 */ // Label 8086: @402618
     /* 402618 */ GIM_Reject,
     /* 402619 */ // Label 8067: @402619
     /* 402619 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(402701),
     /* 402624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402642 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(402671), // Rule ID 5448 //
     /* 402647 */     // MIs[0] imm
     /* 402647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402655 */     // MIs[1] Operand 1
     /* 402655 */     // No operand predicates
     /* 402655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402657 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402669 */     GIR_RootConstrainSelectedInstOperands,
     /* 402670 */     // GIR_Coverage, 5448,
     /* 402670 */     GIR_EraseRootFromParent_Done,
     /* 402671 */   // Label 8092: @402671
     /* 402671 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(402700), // Rule ID 5453 //
     /* 402676 */     // MIs[0] imm
     /* 402676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402684 */     // MIs[1] Operand 1
     /* 402684 */     // No operand predicates
     /* 402684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402686 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402698 */     GIR_RootConstrainSelectedInstOperands,
     /* 402699 */     // GIR_Coverage, 5453,
     /* 402699 */     GIR_EraseRootFromParent_Done,
     /* 402700 */   // Label 8093: @402700
     /* 402700 */   GIM_Reject,
     /* 402701 */ // Label 8091: @402701
     /* 402701 */ GIM_Reject,
     /* 402702 */ // Label 8068: @402702
     /* 402702 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(402910),
     /* 402707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402717 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(402832), // Rule ID 5435 //
     /* 402722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402739 */     // MIs[1] Operand 2
     /* 402739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 402750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 402758 */     // MIs[2] Rn
     /* 402758 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 402763 */     // MIs[2] Operand 2
     /* 402763 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 402774 */     // MIs[0] imm
     /* 402774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 402778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402782 */     // MIs[3] Operand 1
     /* 402782 */     // No operand predicates
     /* 402782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402784 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 402784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 402787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 402807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402814 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 402821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402831 */     // GIR_Coverage, 5435,
     /* 402831 */     GIR_EraseRootFromParent_Done,
     /* 402832 */   // Label 8095: @402832
     /* 402832 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(402872), // Rule ID 1868 //
     /* 402837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402848 */     // MIs[0] imm
     /* 402848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402856 */     // MIs[1] Operand 1
     /* 402856 */     // No operand predicates
     /* 402856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402858 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402870 */     GIR_RootConstrainSelectedInstOperands,
     /* 402871 */     // GIR_Coverage, 1868,
     /* 402871 */     GIR_EraseRootFromParent_Done,
     /* 402872 */   // Label 8096: @402872
     /* 402872 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(402909), // Rule ID 5432 //
     /* 402877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402885 */     // MIs[0] imm
     /* 402885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402893 */     // MIs[1] Operand 1
     /* 402893 */     // No operand predicates
     /* 402893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402895 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 402898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402907 */     GIR_RootConstrainSelectedInstOperands,
     /* 402908 */     // GIR_Coverage, 5432,
     /* 402908 */     GIR_EraseRootFromParent_Done,
     /* 402909 */   // Label 8097: @402909
     /* 402909 */   GIM_Reject,
     /* 402910 */ // Label 8094: @402910
     /* 402910 */ GIM_Reject,
     /* 402911 */ // Label 8069: @402911
     /* 402911 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(402993),
     /* 402916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402934 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(402963), // Rule ID 5438 //
     /* 402939 */     // MIs[0] imm
     /* 402939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402947 */     // MIs[1] Operand 1
     /* 402947 */     // No operand predicates
     /* 402947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402949 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402961 */     GIR_RootConstrainSelectedInstOperands,
     /* 402962 */     // GIR_Coverage, 5438,
     /* 402962 */     GIR_EraseRootFromParent_Done,
     /* 402963 */   // Label 8099: @402963
     /* 402963 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(402992), // Rule ID 5443 //
     /* 402968 */     // MIs[0] imm
     /* 402968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 402972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402976 */     // MIs[1] Operand 1
     /* 402976 */     // No operand predicates
     /* 402976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402978 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 402978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 402981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 402990 */     GIR_RootConstrainSelectedInstOperands,
     /* 402991 */     // GIR_Coverage, 5443,
     /* 402991 */     GIR_EraseRootFromParent_Done,
     /* 402992 */   // Label 8100: @402992
     /* 402992 */   GIM_Reject,
     /* 402993 */ // Label 8098: @402993
     /* 402993 */ GIM_Reject,
     /* 402994 */ // Label 8070: @402994
     /* 402994 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(403079),
     /* 402999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 403005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403017 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(403049), // Rule ID 1869 //
     /* 403022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403025 */     // MIs[0] imm
     /* 403025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403033 */     // MIs[1] Operand 1
     /* 403033 */     // No operand predicates
     /* 403033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403035 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403047 */     GIR_RootConstrainSelectedInstOperands,
     /* 403048 */     // GIR_Coverage, 1869,
     /* 403048 */     GIR_EraseRootFromParent_Done,
     /* 403049 */   // Label 8102: @403049
     /* 403049 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(403078), // Rule ID 5433 //
     /* 403054 */     // MIs[0] imm
     /* 403054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403062 */     // MIs[1] Operand 1
     /* 403062 */     // No operand predicates
     /* 403062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403064 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 403064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 403067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 403076 */     GIR_RootConstrainSelectedInstOperands,
     /* 403077 */     // GIR_Coverage, 5433,
     /* 403077 */     GIR_EraseRootFromParent_Done,
     /* 403078 */   // Label 8103: @403078
     /* 403078 */   GIM_Reject,
     /* 403079 */ // Label 8101: @403079
     /* 403079 */ GIM_Reject,
     /* 403080 */ // Label 8071: @403080
     /* 403080 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(403126), // Rule ID 2733 //
     /* 403085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 403088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 403091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 403094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 403098 */   // MIs[0] Op3
     /* 403098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403106 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 403110 */   // MIs[1] Operand 1
     /* 403110 */   // No operand predicates
     /* 403110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403112 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 403112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 403115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 403117 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 403119 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 403121 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 403124 */   GIR_RootConstrainSelectedInstOperands,
     /* 403125 */   // GIR_Coverage, 2733,
     /* 403125 */   GIR_EraseRootFromParent_Done,
     /* 403126 */ // Label 8104: @403126
     /* 403126 */ GIM_Reject,
     /* 403127 */ // Label 8072: @403127
     /* 403127 */ GIM_Reject,
     /* 403128 */ // Label 128: @403128
     /* 403128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8112*/ GIMT_Encode4(403686),
     /* 403139 */ /*GILLT_s32*//*Label 8105*/ GIMT_Encode4(403175),
     /* 403143 */ /*GILLT_s64*//*Label 8106*/ GIMT_Encode4(403213), GIMT_Encode4(0),
     /* 403151 */ /*GILLT_v2s32*//*Label 8107*/ GIMT_Encode4(403311),
     /* 403155 */ /*GILLT_v2s64*//*Label 8108*/ GIMT_Encode4(403386),
     /* 403159 */ /*GILLT_v4s16*//*Label 8109*/ GIMT_Encode4(403461),
     /* 403163 */ /*GILLT_v4s32*//*Label 8110*/ GIMT_Encode4(403536), GIMT_Encode4(0),
     /* 403171 */ /*GILLT_v8s16*//*Label 8111*/ GIMT_Encode4(403611),
     /* 403175 */ // Label 8105: @403175
     /* 403175 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(403212), // Rule ID 1622 //
     /* 403180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 403189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403201 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 403201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 403206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403210 */   GIR_RootConstrainSelectedInstOperands,
     /* 403211 */   // GIR_Coverage, 1622,
     /* 403211 */   GIR_Done,
     /* 403212 */ // Label 8113: @403212
     /* 403212 */ GIM_Reject,
     /* 403213 */ // Label 8106: @403213
     /* 403213 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(403310),
     /* 403218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 403224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403232 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(403263), // Rule ID 2513 //
     /* 403237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403244 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403250 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403254 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 403254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 403257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403261 */     GIR_RootConstrainSelectedInstOperands,
     /* 403262 */     // GIR_Coverage, 2513,
     /* 403262 */     GIR_EraseRootFromParent_Done,
     /* 403263 */   // Label 8115: @403263
     /* 403263 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(403286), // Rule ID 1621 //
     /* 403268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403275 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 403275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 403280 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403284 */     GIR_RootConstrainSelectedInstOperands,
     /* 403285 */     // GIR_Coverage, 1621,
     /* 403285 */     GIR_Done,
     /* 403286 */   // Label 8116: @403286
     /* 403286 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(403309), // Rule ID 5212 //
     /* 403291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403298 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 403298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 403303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403307 */     GIR_RootConstrainSelectedInstOperands,
     /* 403308 */     // GIR_Coverage, 5212,
     /* 403308 */     GIR_Done,
     /* 403309 */   // Label 8117: @403309
     /* 403309 */   GIM_Reject,
     /* 403310 */ // Label 8114: @403310
     /* 403310 */ GIM_Reject,
     /* 403311 */ // Label 8107: @403311
     /* 403311 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(403385),
     /* 403316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 403322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403330 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(403361), // Rule ID 773 //
     /* 403335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403352 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 403352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 403355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403359 */     GIR_RootConstrainSelectedInstOperands,
     /* 403360 */     // GIR_Coverage, 773,
     /* 403360 */     GIR_EraseRootFromParent_Done,
     /* 403361 */   // Label 8119: @403361
     /* 403361 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(403384), // Rule ID 1210 //
     /* 403366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403373 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 403373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 403378 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403382 */     GIR_RootConstrainSelectedInstOperands,
     /* 403383 */     // GIR_Coverage, 1210,
     /* 403383 */     GIR_Done,
     /* 403384 */   // Label 8120: @403384
     /* 403384 */   GIM_Reject,
     /* 403385 */ // Label 8118: @403385
     /* 403385 */ GIM_Reject,
     /* 403386 */ // Label 8108: @403386
     /* 403386 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(403460),
     /* 403391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 403397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403405 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(403436), // Rule ID 775 //
     /* 403410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403427 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 403427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 403430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403434 */     GIR_RootConstrainSelectedInstOperands,
     /* 403435 */     // GIR_Coverage, 775,
     /* 403435 */     GIR_EraseRootFromParent_Done,
     /* 403436 */   // Label 8122: @403436
     /* 403436 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(403459), // Rule ID 1212 //
     /* 403441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403448 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 403448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 403453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403457 */     GIR_RootConstrainSelectedInstOperands,
     /* 403458 */     // GIR_Coverage, 1212,
     /* 403458 */     GIR_Done,
     /* 403459 */   // Label 8123: @403459
     /* 403459 */   GIM_Reject,
     /* 403460 */ // Label 8121: @403460
     /* 403460 */ GIM_Reject,
     /* 403461 */ // Label 8109: @403461
     /* 403461 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(403535),
     /* 403466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 403472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403480 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(403511), // Rule ID 771 //
     /* 403485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403502 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 403502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 403505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403509 */     GIR_RootConstrainSelectedInstOperands,
     /* 403510 */     // GIR_Coverage, 771,
     /* 403510 */     GIR_EraseRootFromParent_Done,
     /* 403511 */   // Label 8125: @403511
     /* 403511 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(403534), // Rule ID 1208 //
     /* 403516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403523 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 403523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 403528 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403532 */     GIR_RootConstrainSelectedInstOperands,
     /* 403533 */     // GIR_Coverage, 1208,
     /* 403533 */     GIR_Done,
     /* 403534 */   // Label 8126: @403534
     /* 403534 */   GIM_Reject,
     /* 403535 */ // Label 8124: @403535
     /* 403535 */ GIM_Reject,
     /* 403536 */ // Label 8110: @403536
     /* 403536 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(403610),
     /* 403541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 403547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403555 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(403586), // Rule ID 774 //
     /* 403560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403573 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403577 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 403577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 403580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403584 */     GIR_RootConstrainSelectedInstOperands,
     /* 403585 */     // GIR_Coverage, 774,
     /* 403585 */     GIR_EraseRootFromParent_Done,
     /* 403586 */   // Label 8128: @403586
     /* 403586 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(403609), // Rule ID 1211 //
     /* 403591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403598 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 403598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 403603 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403607 */     GIR_RootConstrainSelectedInstOperands,
     /* 403608 */     // GIR_Coverage, 1211,
     /* 403608 */     GIR_Done,
     /* 403609 */   // Label 8129: @403609
     /* 403609 */   GIM_Reject,
     /* 403610 */ // Label 8127: @403610
     /* 403610 */ GIM_Reject,
     /* 403611 */ // Label 8111: @403611
     /* 403611 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(403685),
     /* 403616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 403622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403630 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(403661), // Rule ID 772 //
     /* 403635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403652 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 403652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 403655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403659 */     GIR_RootConstrainSelectedInstOperands,
     /* 403660 */     // GIR_Coverage, 772,
     /* 403660 */     GIR_EraseRootFromParent_Done,
     /* 403661 */   // Label 8131: @403661
     /* 403661 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(403684), // Rule ID 1209 //
     /* 403666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403673 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 403673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 403678 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403682 */     GIR_RootConstrainSelectedInstOperands,
     /* 403683 */     // GIR_Coverage, 1209,
     /* 403683 */     GIR_Done,
     /* 403684 */   // Label 8132: @403684
     /* 403684 */   GIM_Reject,
     /* 403685 */ // Label 8130: @403685
     /* 403685 */ GIM_Reject,
     /* 403686 */ // Label 8112: @403686
     /* 403686 */ GIM_Reject,
     /* 403687 */ // Label 129: @403687
     /* 403687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8140*/ GIMT_Encode4(404778),
     /* 403698 */ /*GILLT_s32*//*Label 8133*/ GIMT_Encode4(403734),
     /* 403702 */ /*GILLT_s64*//*Label 8134*/ GIMT_Encode4(403772), GIMT_Encode4(0),
     /* 403710 */ /*GILLT_v2s32*//*Label 8135*/ GIMT_Encode4(403913),
     /* 403714 */ /*GILLT_v2s64*//*Label 8136*/ GIMT_Encode4(404086),
     /* 403718 */ /*GILLT_v4s16*//*Label 8137*/ GIMT_Encode4(404259),
     /* 403722 */ /*GILLT_v4s32*//*Label 8138*/ GIMT_Encode4(404432), GIMT_Encode4(0),
     /* 403730 */ /*GILLT_v8s16*//*Label 8139*/ GIMT_Encode4(404605),
     /* 403734 */ // Label 8133: @403734
     /* 403734 */ GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(403771), // Rule ID 1624 //
     /* 403739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 403748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403760 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 403760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 403765 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403769 */   GIR_RootConstrainSelectedInstOperands,
     /* 403770 */   // GIR_Coverage, 1624,
     /* 403770 */   GIR_Done,
     /* 403771 */ // Label 8141: @403771
     /* 403771 */ GIM_Reject,
     /* 403772 */ // Label 8134: @403772
     /* 403772 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(403912),
     /* 403777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 403783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403787 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(403822), // Rule ID 5246 //
     /* 403792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403813 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 403813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 403816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403820 */     GIR_RootConstrainSelectedInstOperands,
     /* 403821 */     // GIR_Coverage, 5246,
     /* 403821 */     GIR_EraseRootFromParent_Done,
     /* 403822 */   // Label 8143: @403822
     /* 403822 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(403857), // Rule ID 5244 //
     /* 403827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403838 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403844 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403848 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 403848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 403851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403855 */     GIR_RootConstrainSelectedInstOperands,
     /* 403856 */     // GIR_Coverage, 5244,
     /* 403856 */     GIR_EraseRootFromParent_Done,
     /* 403857 */   // Label 8144: @403857
     /* 403857 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(403884), // Rule ID 1623 //
     /* 403862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403873 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 403873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 403878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403882 */     GIR_RootConstrainSelectedInstOperands,
     /* 403883 */     // GIR_Coverage, 1623,
     /* 403883 */     GIR_Done,
     /* 403884 */   // Label 8145: @403884
     /* 403884 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(403911), // Rule ID 5213 //
     /* 403889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403900 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 403900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 403905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403909 */     GIR_RootConstrainSelectedInstOperands,
     /* 403910 */     // GIR_Coverage, 5213,
     /* 403910 */     GIR_Done,
     /* 403911 */   // Label 8146: @403911
     /* 403911 */   GIM_Reject,
     /* 403912 */ // Label 8142: @403912
     /* 403912 */ GIM_Reject,
     /* 403913 */ // Label 8135: @403913
     /* 403913 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(404085),
     /* 403918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 403924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403928 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(403987), // Rule ID 1172 //
     /* 403933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403972 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 403972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 403975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403985 */     GIR_RootConstrainSelectedInstOperands,
     /* 403986 */     // GIR_Coverage, 1172,
     /* 403986 */     GIR_EraseRootFromParent_Done,
     /* 403987 */   // Label 8148: @403987
     /* 403987 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(404022), // Rule ID 788 //
     /* 403992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404013 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 404013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 404016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404020 */     GIR_RootConstrainSelectedInstOperands,
     /* 404021 */     // GIR_Coverage, 788,
     /* 404021 */     GIR_EraseRootFromParent_Done,
     /* 404022 */   // Label 8149: @404022
     /* 404022 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(404057), // Rule ID 778 //
     /* 404027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404038 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404044 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404048 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 404048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 404051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404055 */     GIR_RootConstrainSelectedInstOperands,
     /* 404056 */     // GIR_Coverage, 778,
     /* 404056 */     GIR_EraseRootFromParent_Done,
     /* 404057 */   // Label 8150: @404057
     /* 404057 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(404084), // Rule ID 1215 //
     /* 404062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404073 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 404073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 404078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404082 */     GIR_RootConstrainSelectedInstOperands,
     /* 404083 */     // GIR_Coverage, 1215,
     /* 404083 */     GIR_Done,
     /* 404084 */   // Label 8151: @404084
     /* 404084 */   GIM_Reject,
     /* 404085 */ // Label 8147: @404085
     /* 404085 */ GIM_Reject,
     /* 404086 */ // Label 8136: @404086
     /* 404086 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(404258),
     /* 404091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 404097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404101 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(404160), // Rule ID 1176 //
     /* 404106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 404138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404145 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 404148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404158 */     GIR_RootConstrainSelectedInstOperands,
     /* 404159 */     // GIR_Coverage, 1176,
     /* 404159 */     GIR_EraseRootFromParent_Done,
     /* 404160 */   // Label 8153: @404160
     /* 404160 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(404195), // Rule ID 790 //
     /* 404165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404172 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404178 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404186 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 404186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 404189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404193 */     GIR_RootConstrainSelectedInstOperands,
     /* 404194 */     // GIR_Coverage, 790,
     /* 404194 */     GIR_EraseRootFromParent_Done,
     /* 404195 */   // Label 8154: @404195
     /* 404195 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(404230), // Rule ID 780 //
     /* 404200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404221 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 404221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 404224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404228 */     GIR_RootConstrainSelectedInstOperands,
     /* 404229 */     // GIR_Coverage, 780,
     /* 404229 */     GIR_EraseRootFromParent_Done,
     /* 404230 */   // Label 8155: @404230
     /* 404230 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(404257), // Rule ID 1217 //
     /* 404235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404246 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 404246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 404251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404255 */     GIR_RootConstrainSelectedInstOperands,
     /* 404256 */     // GIR_Coverage, 1217,
     /* 404256 */     GIR_Done,
     /* 404257 */   // Label 8156: @404257
     /* 404257 */   GIM_Reject,
     /* 404258 */ // Label 8152: @404258
     /* 404258 */ GIM_Reject,
     /* 404259 */ // Label 8137: @404259
     /* 404259 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(404431),
     /* 404264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404274 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(404333), // Rule ID 1168 //
     /* 404279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404318 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 404318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 404321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404331 */     GIR_RootConstrainSelectedInstOperands,
     /* 404332 */     // GIR_Coverage, 1168,
     /* 404332 */     GIR_EraseRootFromParent_Done,
     /* 404333 */   // Label 8158: @404333
     /* 404333 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(404368), // Rule ID 786 //
     /* 404338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404345 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404351 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404359 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 404359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 404362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404366 */     GIR_RootConstrainSelectedInstOperands,
     /* 404367 */     // GIR_Coverage, 786,
     /* 404367 */     GIR_EraseRootFromParent_Done,
     /* 404368 */   // Label 8159: @404368
     /* 404368 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(404403), // Rule ID 776 //
     /* 404373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404384 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404390 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404394 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 404394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 404397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404401 */     GIR_RootConstrainSelectedInstOperands,
     /* 404402 */     // GIR_Coverage, 776,
     /* 404402 */     GIR_EraseRootFromParent_Done,
     /* 404403 */   // Label 8160: @404403
     /* 404403 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(404430), // Rule ID 1213 //
     /* 404408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404419 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 404419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 404424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404428 */     GIR_RootConstrainSelectedInstOperands,
     /* 404429 */     // GIR_Coverage, 1213,
     /* 404429 */     GIR_Done,
     /* 404430 */   // Label 8161: @404430
     /* 404430 */   GIM_Reject,
     /* 404431 */ // Label 8157: @404431
     /* 404431 */ GIM_Reject,
     /* 404432 */ // Label 8138: @404432
     /* 404432 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(404604),
     /* 404437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 404443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404447 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(404506), // Rule ID 1174 //
     /* 404452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404491 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 404491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 404494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404504 */     GIR_RootConstrainSelectedInstOperands,
     /* 404505 */     // GIR_Coverage, 1174,
     /* 404505 */     GIR_EraseRootFromParent_Done,
     /* 404506 */   // Label 8163: @404506
     /* 404506 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(404541), // Rule ID 789 //
     /* 404511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404518 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404524 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404532 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 404532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 404535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404539 */     GIR_RootConstrainSelectedInstOperands,
     /* 404540 */     // GIR_Coverage, 789,
     /* 404540 */     GIR_EraseRootFromParent_Done,
     /* 404541 */   // Label 8164: @404541
     /* 404541 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(404576), // Rule ID 779 //
     /* 404546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404557 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404567 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 404567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 404570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404574 */     GIR_RootConstrainSelectedInstOperands,
     /* 404575 */     // GIR_Coverage, 779,
     /* 404575 */     GIR_EraseRootFromParent_Done,
     /* 404576 */   // Label 8165: @404576
     /* 404576 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(404603), // Rule ID 1216 //
     /* 404581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404592 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 404592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 404597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404601 */     GIR_RootConstrainSelectedInstOperands,
     /* 404602 */     // GIR_Coverage, 1216,
     /* 404602 */     GIR_Done,
     /* 404603 */   // Label 8166: @404603
     /* 404603 */   GIM_Reject,
     /* 404604 */ // Label 8162: @404604
     /* 404604 */ GIM_Reject,
     /* 404605 */ // Label 8139: @404605
     /* 404605 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(404777),
     /* 404610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 404616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404620 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(404679), // Rule ID 1170 //
     /* 404625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 404653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404664 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 404664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 404667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 404673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404677 */     GIR_RootConstrainSelectedInstOperands,
     /* 404678 */     // GIR_Coverage, 1170,
     /* 404678 */     GIR_EraseRootFromParent_Done,
     /* 404679 */   // Label 8168: @404679
     /* 404679 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(404714), // Rule ID 787 //
     /* 404684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404705 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 404705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 404708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404712 */     GIR_RootConstrainSelectedInstOperands,
     /* 404713 */     // GIR_Coverage, 787,
     /* 404713 */     GIR_EraseRootFromParent_Done,
     /* 404714 */   // Label 8169: @404714
     /* 404714 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(404749), // Rule ID 777 //
     /* 404719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404730 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404736 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404740 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 404740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 404743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404747 */     GIR_RootConstrainSelectedInstOperands,
     /* 404748 */     // GIR_Coverage, 777,
     /* 404748 */     GIR_EraseRootFromParent_Done,
     /* 404749 */   // Label 8170: @404749
     /* 404749 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(404776), // Rule ID 1214 //
     /* 404754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404765 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 404765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 404770 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404774 */     GIR_RootConstrainSelectedInstOperands,
     /* 404775 */     // GIR_Coverage, 1214,
     /* 404775 */     GIR_Done,
     /* 404776 */   // Label 8171: @404776
     /* 404776 */   GIM_Reject,
     /* 404777 */ // Label 8167: @404777
     /* 404777 */ GIM_Reject,
     /* 404778 */ // Label 8140: @404778
     /* 404778 */ GIM_Reject,
     /* 404779 */ // Label 130: @404779
     /* 404779 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8179*/ GIMT_Encode4(405870),
     /* 404790 */ /*GILLT_s32*//*Label 8172*/ GIMT_Encode4(404826),
     /* 404794 */ /*GILLT_s64*//*Label 8173*/ GIMT_Encode4(404864), GIMT_Encode4(0),
     /* 404802 */ /*GILLT_v2s32*//*Label 8174*/ GIMT_Encode4(405005),
     /* 404806 */ /*GILLT_v2s64*//*Label 8175*/ GIMT_Encode4(405178),
     /* 404810 */ /*GILLT_v4s16*//*Label 8176*/ GIMT_Encode4(405351),
     /* 404814 */ /*GILLT_v4s32*//*Label 8177*/ GIMT_Encode4(405524), GIMT_Encode4(0),
     /* 404822 */ /*GILLT_v8s16*//*Label 8178*/ GIMT_Encode4(405697),
     /* 404826 */ // Label 8172: @404826
     /* 404826 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(404863), // Rule ID 1626 //
     /* 404831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 404840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404852 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 404852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 404857 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404861 */   GIR_RootConstrainSelectedInstOperands,
     /* 404862 */   // GIR_Coverage, 1626,
     /* 404862 */   GIR_Done,
     /* 404863 */ // Label 8180: @404863
     /* 404863 */ GIM_Reject,
     /* 404864 */ // Label 8173: @404864
     /* 404864 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(405004),
     /* 404869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 404875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404879 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(404914), // Rule ID 5247 //
     /* 404884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404905 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 404905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 404908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404912 */     GIR_RootConstrainSelectedInstOperands,
     /* 404913 */     // GIR_Coverage, 5247,
     /* 404913 */     GIR_EraseRootFromParent_Done,
     /* 404914 */   // Label 8182: @404914
     /* 404914 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(404949), // Rule ID 5245 //
     /* 404919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404930 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 404936 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 404938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404940 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 404940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 404943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404947 */     GIR_RootConstrainSelectedInstOperands,
     /* 404948 */     // GIR_Coverage, 5245,
     /* 404948 */     GIR_EraseRootFromParent_Done,
     /* 404949 */   // Label 8183: @404949
     /* 404949 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(404976), // Rule ID 1625 //
     /* 404954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404965 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 404965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 404970 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404974 */     GIR_RootConstrainSelectedInstOperands,
     /* 404975 */     // GIR_Coverage, 1625,
     /* 404975 */     GIR_Done,
     /* 404976 */   // Label 8184: @404976
     /* 404976 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(405003), // Rule ID 5214 //
     /* 404981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404992 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 404992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 404997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405001 */     GIR_RootConstrainSelectedInstOperands,
     /* 405002 */     // GIR_Coverage, 5214,
     /* 405002 */     GIR_Done,
     /* 405003 */   // Label 8185: @405003
     /* 405003 */   GIM_Reject,
     /* 405004 */ // Label 8181: @405004
     /* 405004 */ GIM_Reject,
     /* 405005 */ // Label 8174: @405005
     /* 405005 */ GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(405177),
     /* 405010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405020 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(405079), // Rule ID 1182 //
     /* 405025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405064 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 405067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405077 */     GIR_RootConstrainSelectedInstOperands,
     /* 405078 */     // GIR_Coverage, 1182,
     /* 405078 */     GIR_EraseRootFromParent_Done,
     /* 405079 */   // Label 8187: @405079
     /* 405079 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(405114), // Rule ID 793 //
     /* 405084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405105 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 405108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405112 */     GIR_RootConstrainSelectedInstOperands,
     /* 405113 */     // GIR_Coverage, 793,
     /* 405113 */     GIR_EraseRootFromParent_Done,
     /* 405114 */   // Label 8188: @405114
     /* 405114 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(405149), // Rule ID 783 //
     /* 405119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405140 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 405140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 405143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405147 */     GIR_RootConstrainSelectedInstOperands,
     /* 405148 */     // GIR_Coverage, 783,
     /* 405148 */     GIR_EraseRootFromParent_Done,
     /* 405149 */   // Label 8189: @405149
     /* 405149 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(405176), // Rule ID 1220 //
     /* 405154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405165 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 405170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405174 */     GIR_RootConstrainSelectedInstOperands,
     /* 405175 */     // GIR_Coverage, 1220,
     /* 405175 */     GIR_Done,
     /* 405176 */   // Label 8190: @405176
     /* 405176 */   GIM_Reject,
     /* 405177 */ // Label 8186: @405177
     /* 405177 */ GIM_Reject,
     /* 405178 */ // Label 8175: @405178
     /* 405178 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(405350),
     /* 405183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405193 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(405252), // Rule ID 1186 //
     /* 405198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405237 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 405240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405250 */     GIR_RootConstrainSelectedInstOperands,
     /* 405251 */     // GIR_Coverage, 1186,
     /* 405251 */     GIR_EraseRootFromParent_Done,
     /* 405252 */   // Label 8192: @405252
     /* 405252 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(405287), // Rule ID 795 //
     /* 405257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405264 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405270 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405278 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 405281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405285 */     GIR_RootConstrainSelectedInstOperands,
     /* 405286 */     // GIR_Coverage, 795,
     /* 405286 */     GIR_EraseRootFromParent_Done,
     /* 405287 */   // Label 8193: @405287
     /* 405287 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(405322), // Rule ID 785 //
     /* 405292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405313 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 405313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 405316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405320 */     GIR_RootConstrainSelectedInstOperands,
     /* 405321 */     // GIR_Coverage, 785,
     /* 405321 */     GIR_EraseRootFromParent_Done,
     /* 405322 */   // Label 8194: @405322
     /* 405322 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(405349), // Rule ID 1222 //
     /* 405327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405338 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 405343 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405347 */     GIR_RootConstrainSelectedInstOperands,
     /* 405348 */     // GIR_Coverage, 1222,
     /* 405348 */     GIR_Done,
     /* 405349 */   // Label 8195: @405349
     /* 405349 */   GIM_Reject,
     /* 405350 */ // Label 8191: @405350
     /* 405350 */ GIM_Reject,
     /* 405351 */ // Label 8176: @405351
     /* 405351 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(405523),
     /* 405356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405366 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(405425), // Rule ID 1178 //
     /* 405371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405410 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 405413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405423 */     GIR_RootConstrainSelectedInstOperands,
     /* 405424 */     // GIR_Coverage, 1178,
     /* 405424 */     GIR_EraseRootFromParent_Done,
     /* 405425 */   // Label 8197: @405425
     /* 405425 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(405460), // Rule ID 791 //
     /* 405430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405451 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 405454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405458 */     GIR_RootConstrainSelectedInstOperands,
     /* 405459 */     // GIR_Coverage, 791,
     /* 405459 */     GIR_EraseRootFromParent_Done,
     /* 405460 */   // Label 8198: @405460
     /* 405460 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(405495), // Rule ID 781 //
     /* 405465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405476 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405482 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405486 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 405486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 405489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405493 */     GIR_RootConstrainSelectedInstOperands,
     /* 405494 */     // GIR_Coverage, 781,
     /* 405494 */     GIR_EraseRootFromParent_Done,
     /* 405495 */   // Label 8199: @405495
     /* 405495 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(405522), // Rule ID 1218 //
     /* 405500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405511 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 405516 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405520 */     GIR_RootConstrainSelectedInstOperands,
     /* 405521 */     // GIR_Coverage, 1218,
     /* 405521 */     GIR_Done,
     /* 405522 */   // Label 8200: @405522
     /* 405522 */   GIM_Reject,
     /* 405523 */ // Label 8196: @405523
     /* 405523 */ GIM_Reject,
     /* 405524 */ // Label 8177: @405524
     /* 405524 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(405696),
     /* 405529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405539 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(405598), // Rule ID 1184 //
     /* 405544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405583 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 405586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405596 */     GIR_RootConstrainSelectedInstOperands,
     /* 405597 */     // GIR_Coverage, 1184,
     /* 405597 */     GIR_EraseRootFromParent_Done,
     /* 405598 */   // Label 8202: @405598
     /* 405598 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(405633), // Rule ID 794 //
     /* 405603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405610 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405616 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405624 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 405624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 405627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405631 */     GIR_RootConstrainSelectedInstOperands,
     /* 405632 */     // GIR_Coverage, 794,
     /* 405632 */     GIR_EraseRootFromParent_Done,
     /* 405633 */   // Label 8203: @405633
     /* 405633 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(405668), // Rule ID 784 //
     /* 405638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405659 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 405659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 405662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405666 */     GIR_RootConstrainSelectedInstOperands,
     /* 405667 */     // GIR_Coverage, 784,
     /* 405667 */     GIR_EraseRootFromParent_Done,
     /* 405668 */   // Label 8204: @405668
     /* 405668 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(405695), // Rule ID 1221 //
     /* 405673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405684 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 405689 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405693 */     GIR_RootConstrainSelectedInstOperands,
     /* 405694 */     // GIR_Coverage, 1221,
     /* 405694 */     GIR_Done,
     /* 405695 */   // Label 8205: @405695
     /* 405695 */   GIM_Reject,
     /* 405696 */ // Label 8201: @405696
     /* 405696 */ GIM_Reject,
     /* 405697 */ // Label 8178: @405697
     /* 405697 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(405869),
     /* 405702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405712 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(405771), // Rule ID 1180 //
     /* 405717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 405745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405756 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 405759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 405765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405769 */     GIR_RootConstrainSelectedInstOperands,
     /* 405770 */     // GIR_Coverage, 1180,
     /* 405770 */     GIR_EraseRootFromParent_Done,
     /* 405771 */   // Label 8207: @405771
     /* 405771 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(405806), // Rule ID 792 //
     /* 405776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405797 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 405797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 405800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405804 */     GIR_RootConstrainSelectedInstOperands,
     /* 405805 */     // GIR_Coverage, 792,
     /* 405805 */     GIR_EraseRootFromParent_Done,
     /* 405806 */   // Label 8208: @405806
     /* 405806 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(405841), // Rule ID 782 //
     /* 405811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405822 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 405828 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 405830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 405832 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 405832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 405835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405839 */     GIR_RootConstrainSelectedInstOperands,
     /* 405840 */     // GIR_Coverage, 782,
     /* 405840 */     GIR_EraseRootFromParent_Done,
     /* 405841 */   // Label 8209: @405841
     /* 405841 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(405868), // Rule ID 1219 //
     /* 405846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 405849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405857 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 405862 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405866 */     GIR_RootConstrainSelectedInstOperands,
     /* 405867 */     // GIR_Coverage, 1219,
     /* 405867 */     GIR_Done,
     /* 405868 */   // Label 8210: @405868
     /* 405868 */   GIM_Reject,
     /* 405869 */ // Label 8206: @405869
     /* 405869 */ GIM_Reject,
     /* 405870 */ // Label 8179: @405870
     /* 405870 */ GIM_Reject,
     /* 405871 */ // Label 131: @405871
     /* 405871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8215*/ GIMT_Encode4(406024),
     /* 405882 */ /*GILLT_s32*//*Label 8211*/ GIMT_Encode4(405922),
     /* 405886 */ /*GILLT_s64*//*Label 8212*/ GIMT_Encode4(405946), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 405910 */ /*GILLT_v8s8*//*Label 8213*/ GIMT_Encode4(405970), GIMT_Encode4(0),
     /* 405918 */ /*GILLT_v16s8*//*Label 8214*/ GIMT_Encode4(405997),
     /* 405922 */ // Label 8211: @405922
     /* 405922 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(405945), // Rule ID 4015 //
     /* 405927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 405930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 405934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 405938 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 405938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 405943 */   GIR_RootConstrainSelectedInstOperands,
     /* 405944 */   // GIR_Coverage, 4015,
     /* 405944 */   GIR_Done,
     /* 405945 */ // Label 8216: @405945
     /* 405945 */ GIM_Reject,
     /* 405946 */ // Label 8212: @405946
     /* 405946 */ GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(405969), // Rule ID 4016 //
     /* 405951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 405958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 405962 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 405962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 405967 */   GIR_RootConstrainSelectedInstOperands,
     /* 405968 */   // GIR_Coverage, 4016,
     /* 405968 */   GIR_Done,
     /* 405969 */ // Label 8217: @405969
     /* 405969 */ GIM_Reject,
     /* 405970 */ // Label 8213: @405970
     /* 405970 */ GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(405996), // Rule ID 976 //
     /* 405975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405989 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 405989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 405994 */   GIR_RootConstrainSelectedInstOperands,
     /* 405995 */   // GIR_Coverage, 976,
     /* 405995 */   GIR_Done,
     /* 405996 */ // Label 8218: @405996
     /* 405996 */ GIM_Reject,
     /* 405997 */ // Label 8214: @405997
     /* 405997 */ GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(406023), // Rule ID 977 //
     /* 406002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406016 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 406016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 406021 */   GIR_RootConstrainSelectedInstOperands,
     /* 406022 */   // GIR_Coverage, 977,
     /* 406022 */   GIR_Done,
     /* 406023 */ // Label 8219: @406023
     /* 406023 */ GIM_Reject,
     /* 406024 */ // Label 8215: @406024
     /* 406024 */ GIM_Reject,
     /* 406025 */ // Label 132: @406025
     /* 406025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8224*/ GIMT_Encode4(406200),
     /* 406036 */ /*GILLT_v4s16*//*Label 8220*/ GIMT_Encode4(406056), GIMT_Encode4(0),
     /* 406044 */ /*GILLT_v8s8*//*Label 8221*/ GIMT_Encode4(406101),
     /* 406048 */ /*GILLT_v8s16*//*Label 8222*/ GIMT_Encode4(406128),
     /* 406052 */ /*GILLT_v16s8*//*Label 8223*/ GIMT_Encode4(406173),
     /* 406056 */ // Label 8220: @406056
     /* 406056 */ GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(406100),
     /* 406061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406072 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(406087), // Rule ID 980 //
     /* 406077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406080 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 406080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 406085 */     GIR_RootConstrainSelectedInstOperands,
     /* 406086 */     // GIR_Coverage, 980,
     /* 406086 */     GIR_Done,
     /* 406087 */   // Label 8226: @406087
     /* 406087 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(406099), // Rule ID 4962 //
     /* 406092 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 406092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 406097 */     GIR_RootConstrainSelectedInstOperands,
     /* 406098 */     // GIR_Coverage, 4962,
     /* 406098 */     GIR_Done,
     /* 406099 */   // Label 8227: @406099
     /* 406099 */   GIM_Reject,
     /* 406100 */ // Label 8225: @406100
     /* 406100 */ GIM_Reject,
     /* 406101 */ // Label 8221: @406101
     /* 406101 */ GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(406127), // Rule ID 978 //
     /* 406106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406120 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 406120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 406125 */   GIR_RootConstrainSelectedInstOperands,
     /* 406126 */   // GIR_Coverage, 978,
     /* 406126 */   GIR_Done,
     /* 406127 */ // Label 8228: @406127
     /* 406127 */ GIM_Reject,
     /* 406128 */ // Label 8222: @406128
     /* 406128 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(406172),
     /* 406133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406144 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(406159), // Rule ID 981 //
     /* 406149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406152 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 406152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 406157 */     GIR_RootConstrainSelectedInstOperands,
     /* 406158 */     // GIR_Coverage, 981,
     /* 406158 */     GIR_Done,
     /* 406159 */   // Label 8230: @406159
     /* 406159 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(406171), // Rule ID 4964 //
     /* 406164 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 406164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 406169 */     GIR_RootConstrainSelectedInstOperands,
     /* 406170 */     // GIR_Coverage, 4964,
     /* 406170 */     GIR_Done,
     /* 406171 */   // Label 8231: @406171
     /* 406171 */   GIM_Reject,
     /* 406172 */ // Label 8229: @406172
     /* 406172 */ GIM_Reject,
     /* 406173 */ // Label 8223: @406173
     /* 406173 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(406199), // Rule ID 979 //
     /* 406178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406192 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 406192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 406197 */   GIR_RootConstrainSelectedInstOperands,
     /* 406198 */   // GIR_Coverage, 979,
     /* 406198 */   GIR_Done,
     /* 406199 */ // Label 8232: @406199
     /* 406199 */ GIM_Reject,
     /* 406200 */ // Label 8224: @406200
     /* 406200 */ GIM_Reject,
     /* 406201 */ // Label 133: @406201
     /* 406201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8239*/ GIMT_Encode4(406474),
     /* 406212 */ /*GILLT_v2s32*//*Label 8233*/ GIMT_Encode4(406240), GIMT_Encode4(0),
     /* 406220 */ /*GILLT_v4s16*//*Label 8234*/ GIMT_Encode4(406285),
     /* 406224 */ /*GILLT_v4s32*//*Label 8235*/ GIMT_Encode4(406330),
     /* 406228 */ /*GILLT_v8s8*//*Label 8236*/ GIMT_Encode4(406375),
     /* 406232 */ /*GILLT_v8s16*//*Label 8237*/ GIMT_Encode4(406402),
     /* 406236 */ /*GILLT_v16s8*//*Label 8238*/ GIMT_Encode4(406447),
     /* 406240 */ // Label 8233: @406240
     /* 406240 */ GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(406284),
     /* 406245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406256 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(406271), // Rule ID 986 //
     /* 406261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406264 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 406264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 406269 */     GIR_RootConstrainSelectedInstOperands,
     /* 406270 */     // GIR_Coverage, 986,
     /* 406270 */     GIR_Done,
     /* 406271 */   // Label 8241: @406271
     /* 406271 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(406283), // Rule ID 4966 //
     /* 406276 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 406276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 406281 */     GIR_RootConstrainSelectedInstOperands,
     /* 406282 */     // GIR_Coverage, 4966,
     /* 406282 */     GIR_Done,
     /* 406283 */   // Label 8242: @406283
     /* 406283 */   GIM_Reject,
     /* 406284 */ // Label 8240: @406284
     /* 406284 */ GIM_Reject,
     /* 406285 */ // Label 8234: @406285
     /* 406285 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(406329),
     /* 406290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406301 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(406316), // Rule ID 984 //
     /* 406306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406309 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 406309 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 406314 */     GIR_RootConstrainSelectedInstOperands,
     /* 406315 */     // GIR_Coverage, 984,
     /* 406315 */     GIR_Done,
     /* 406316 */   // Label 8244: @406316
     /* 406316 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(406328), // Rule ID 4963 //
     /* 406321 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 406321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 406326 */     GIR_RootConstrainSelectedInstOperands,
     /* 406327 */     // GIR_Coverage, 4963,
     /* 406327 */     GIR_Done,
     /* 406328 */   // Label 8245: @406328
     /* 406328 */   GIM_Reject,
     /* 406329 */ // Label 8243: @406329
     /* 406329 */ GIM_Reject,
     /* 406330 */ // Label 8235: @406330
     /* 406330 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(406374),
     /* 406335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406346 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(406361), // Rule ID 987 //
     /* 406351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406354 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 406354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 406359 */     GIR_RootConstrainSelectedInstOperands,
     /* 406360 */     // GIR_Coverage, 987,
     /* 406360 */     GIR_Done,
     /* 406361 */   // Label 8247: @406361
     /* 406361 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(406373), // Rule ID 4967 //
     /* 406366 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 406366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 406371 */     GIR_RootConstrainSelectedInstOperands,
     /* 406372 */     // GIR_Coverage, 4967,
     /* 406372 */     GIR_Done,
     /* 406373 */   // Label 8248: @406373
     /* 406373 */   GIM_Reject,
     /* 406374 */ // Label 8246: @406374
     /* 406374 */ GIM_Reject,
     /* 406375 */ // Label 8236: @406375
     /* 406375 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(406401), // Rule ID 982 //
     /* 406380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406394 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 406394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 406399 */   GIR_RootConstrainSelectedInstOperands,
     /* 406400 */   // GIR_Coverage, 982,
     /* 406400 */   GIR_Done,
     /* 406401 */ // Label 8249: @406401
     /* 406401 */ GIM_Reject,
     /* 406402 */ // Label 8237: @406402
     /* 406402 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(406446),
     /* 406407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406418 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(406433), // Rule ID 985 //
     /* 406423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406426 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 406426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 406431 */     GIR_RootConstrainSelectedInstOperands,
     /* 406432 */     // GIR_Coverage, 985,
     /* 406432 */     GIR_Done,
     /* 406433 */   // Label 8251: @406433
     /* 406433 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(406445), // Rule ID 4965 //
     /* 406438 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 406438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 406443 */     GIR_RootConstrainSelectedInstOperands,
     /* 406444 */     // GIR_Coverage, 4965,
     /* 406444 */     GIR_Done,
     /* 406445 */   // Label 8252: @406445
     /* 406445 */   GIM_Reject,
     /* 406446 */ // Label 8250: @406446
     /* 406446 */ GIM_Reject,
     /* 406447 */ // Label 8238: @406447
     /* 406447 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(406473), // Rule ID 983 //
     /* 406452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406466 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 406466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 406471 */   GIR_RootConstrainSelectedInstOperands,
     /* 406472 */   // GIR_Coverage, 983,
     /* 406472 */   GIR_Done,
     /* 406473 */ // Label 8253: @406473
     /* 406473 */ GIM_Reject,
     /* 406474 */ // Label 8239: @406474
     /* 406474 */ GIM_Reject,
     /* 406475 */ // Label 134: @406475
     /* 406475 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8260*/ GIMT_Encode4(406680),
     /* 406486 */ /*GILLT_s64*//*Label 8254*/ GIMT_Encode4(406518), GIMT_Encode4(0),
     /* 406494 */ /*GILLT_v2s32*//*Label 8255*/ GIMT_Encode4(406545),
     /* 406498 */ /*GILLT_v2s64*//*Label 8256*/ GIMT_Encode4(406572),
     /* 406502 */ /*GILLT_v4s16*//*Label 8257*/ GIMT_Encode4(406599),
     /* 406506 */ /*GILLT_v4s32*//*Label 8258*/ GIMT_Encode4(406626), GIMT_Encode4(0),
     /* 406514 */ /*GILLT_v8s16*//*Label 8259*/ GIMT_Encode4(406653),
     /* 406518 */ // Label 8254: @406518
     /* 406518 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(406544), // Rule ID 1008 //
     /* 406523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406537 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 406537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 406542 */   GIR_RootConstrainSelectedInstOperands,
     /* 406543 */   // GIR_Coverage, 1008,
     /* 406543 */   GIR_Done,
     /* 406544 */ // Label 8261: @406544
     /* 406544 */ GIM_Reject,
     /* 406545 */ // Label 8255: @406545
     /* 406545 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(406571), // Rule ID 1004 //
     /* 406550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406564 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 406564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 406569 */   GIR_RootConstrainSelectedInstOperands,
     /* 406570 */   // GIR_Coverage, 1004,
     /* 406570 */   GIR_Done,
     /* 406571 */ // Label 8262: @406571
     /* 406571 */ GIM_Reject,
     /* 406572 */ // Label 8256: @406572
     /* 406572 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(406598), // Rule ID 1010 //
     /* 406577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406591 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 406591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 406596 */   GIR_RootConstrainSelectedInstOperands,
     /* 406597 */   // GIR_Coverage, 1010,
     /* 406597 */   GIR_Done,
     /* 406598 */ // Label 8263: @406598
     /* 406598 */ GIM_Reject,
     /* 406599 */ // Label 8257: @406599
     /* 406599 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(406625), // Rule ID 1000 //
     /* 406604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406618 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 406618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 406623 */   GIR_RootConstrainSelectedInstOperands,
     /* 406624 */   // GIR_Coverage, 1000,
     /* 406624 */   GIR_Done,
     /* 406625 */ // Label 8264: @406625
     /* 406625 */ GIM_Reject,
     /* 406626 */ // Label 8258: @406626
     /* 406626 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(406652), // Rule ID 1006 //
     /* 406631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406645 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 406645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 406650 */   GIR_RootConstrainSelectedInstOperands,
     /* 406651 */   // GIR_Coverage, 1006,
     /* 406651 */   GIR_Done,
     /* 406652 */ // Label 8265: @406652
     /* 406652 */ GIM_Reject,
     /* 406653 */ // Label 8259: @406653
     /* 406653 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(406679), // Rule ID 1002 //
     /* 406658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406672 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 406672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 406677 */   GIR_RootConstrainSelectedInstOperands,
     /* 406678 */   // GIR_Coverage, 1002,
     /* 406678 */   GIR_Done,
     /* 406679 */ // Label 8266: @406679
     /* 406679 */ GIM_Reject,
     /* 406680 */ // Label 8260: @406680
     /* 406680 */ GIM_Reject,
     /* 406681 */ // Label 135: @406681
     /* 406681 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8269*/ GIMT_Encode4(407079),
     /* 406692 */ /*GILLT_v2s64*//*Label 8267*/ GIMT_Encode4(406704), GIMT_Encode4(0),
     /* 406700 */ /*GILLT_v4s32*//*Label 8268*/ GIMT_Encode4(406842),
     /* 406704 */ // Label 8267: @406704
     /* 406704 */ GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(406763), // Rule ID 5870 //
     /* 406709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406720 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 406720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 406727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 406736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 406738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 406741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 406752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406762 */   // GIR_Coverage, 5870,
     /* 406762 */   GIR_EraseRootFromParent_Done,
     /* 406763 */ // Label 8270: @406763
     /* 406763 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(406841), // Rule ID 5992 //
     /* 406768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406779 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 406779 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406782 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 406786 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406791 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 406795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 406797 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 406800 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 406804 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 406811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 406814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 406825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406830 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406840 */   // GIR_Coverage, 5992,
     /* 406840 */   GIR_EraseRootFromParent_Done,
     /* 406841 */ // Label 8271: @406841
     /* 406841 */ GIM_Reject,
     /* 406842 */ // Label 8268: @406842
     /* 406842 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(406901), // Rule ID 5866 //
     /* 406847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406858 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 406858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 406861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 406865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 406874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 406876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 406879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 406890 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 406900 */   // GIR_Coverage, 5866,
     /* 406900 */   GIR_EraseRootFromParent_Done,
     /* 406901 */ // Label 8272: @406901
     /* 406901 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(406960), // Rule ID 5867 //
     /* 406906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406917 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 406917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 406924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 406933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 406935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 406938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406943 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 406949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406959 */   // GIR_Coverage, 5867,
     /* 406959 */   GIR_EraseRootFromParent_Done,
     /* 406960 */ // Label 8273: @406960
     /* 406960 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(407019), // Rule ID 5868 //
     /* 406965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406976 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 406976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 406979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 406983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 406992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 406994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 406997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407018 */   // GIR_Coverage, 5868,
     /* 407018 */   GIR_EraseRootFromParent_Done,
     /* 407019 */ // Label 8274: @407019
     /* 407019 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(407078), // Rule ID 5869 //
     /* 407024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407035 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 407035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 407042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407072 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407077 */   // GIR_Coverage, 5869,
     /* 407077 */   GIR_EraseRootFromParent_Done,
     /* 407078 */ // Label 8275: @407078
     /* 407078 */ GIM_Reject,
     /* 407079 */ // Label 8269: @407079
     /* 407079 */ GIM_Reject,
     /* 407080 */ // Label 136: @407080
     /* 407080 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8280*/ GIMT_Encode4(407449),
     /* 407091 */ /*GILLT_v2s32*//*Label 8276*/ GIMT_Encode4(407151), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407103 */ /*GILLT_v4s32*//*Label 8277*/ GIMT_Encode4(407271), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407135 */ /*GILLT_nxv2s64*//*Label 8278*/ GIMT_Encode4(407391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 407147 */ /*GILLT_nxv4s32*//*Label 8279*/ GIMT_Encode4(407420),
     /* 407151 */ // Label 8276: @407151
     /* 407151 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(407270),
     /* 407156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 407165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407177 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(407250), // Rule ID 26 //
     /* 407182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 407185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 407189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 407193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407230 */     // MIs[3] Operand 1
     /* 407230 */     // No operand predicates
     /* 407230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407232 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 407235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 407239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407248 */     GIR_RootConstrainSelectedInstOperands,
     /* 407249 */     // GIR_Coverage, 26,
     /* 407249 */     GIR_EraseRootFromParent_Done,
     /* 407250 */   // Label 8282: @407250
     /* 407250 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(407269), // Rule ID 22 //
     /* 407255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 407258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407262 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 407262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 407267 */     GIR_RootConstrainSelectedInstOperands,
     /* 407268 */     // GIR_Coverage, 22,
     /* 407268 */     GIR_Done,
     /* 407269 */   // Label 8283: @407269
     /* 407269 */   GIM_Reject,
     /* 407270 */ // Label 8281: @407270
     /* 407270 */ GIM_Reject,
     /* 407271 */ // Label 8277: @407271
     /* 407271 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(407390),
     /* 407276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 407282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 407285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407297 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(407370), // Rule ID 27 //
     /* 407302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 407305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 407309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 407313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407346 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407350 */     // MIs[3] Operand 1
     /* 407350 */     // No operand predicates
     /* 407350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407352 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 407355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 407359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407368 */     GIR_RootConstrainSelectedInstOperands,
     /* 407369 */     // GIR_Coverage, 27,
     /* 407369 */     GIR_EraseRootFromParent_Done,
     /* 407370 */   // Label 8285: @407370
     /* 407370 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(407389), // Rule ID 23 //
     /* 407375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 407378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407382 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 407382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 407387 */     GIR_RootConstrainSelectedInstOperands,
     /* 407388 */     // GIR_Coverage, 23,
     /* 407388 */     GIR_Done,
     /* 407389 */   // Label 8286: @407389
     /* 407389 */   GIM_Reject,
     /* 407390 */ // Label 8284: @407390
     /* 407390 */ GIM_Reject,
     /* 407391 */ // Label 8278: @407391
     /* 407391 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(407419), // Rule ID 2986 //
     /* 407396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 407402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 407405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 407408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407412 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 407412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 407417 */   GIR_RootConstrainSelectedInstOperands,
     /* 407418 */   // GIR_Coverage, 2986,
     /* 407418 */   GIR_Done,
     /* 407419 */ // Label 8287: @407419
     /* 407419 */ GIM_Reject,
     /* 407420 */ // Label 8279: @407420
     /* 407420 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(407448), // Rule ID 2985 //
     /* 407425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 407431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 407434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 407437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407441 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 407441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 407446 */   GIR_RootConstrainSelectedInstOperands,
     /* 407447 */   // GIR_Coverage, 2985,
     /* 407447 */   GIR_Done,
     /* 407448 */ // Label 8288: @407448
     /* 407448 */ GIM_Reject,
     /* 407449 */ // Label 8280: @407449
     /* 407449 */ GIM_Reject,
     /* 407450 */ // Label 137: @407450
     /* 407450 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8292*/ GIMT_Encode4(407566),
     /* 407461 */ /*GILLT_s16*//*Label 8289*/ GIMT_Encode4(407473),
     /* 407465 */ /*GILLT_s32*//*Label 8290*/ GIMT_Encode4(407504),
     /* 407469 */ /*GILLT_s64*//*Label 8291*/ GIMT_Encode4(407535),
     /* 407473 */ // Label 8289: @407473
     /* 407473 */ GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(407503), // Rule ID 1658 //
     /* 407478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 407481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 407484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407492 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 407492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 407497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407501 */   GIR_RootConstrainSelectedInstOperands,
     /* 407502 */   // GIR_Coverage, 1658,
     /* 407502 */   GIR_Done,
     /* 407503 */ // Label 8293: @407503
     /* 407503 */ GIM_Reject,
     /* 407504 */ // Label 8290: @407504
     /* 407504 */ GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(407534), // Rule ID 1657 //
     /* 407509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 407512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 407515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407523 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 407523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 407528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407532 */   GIR_RootConstrainSelectedInstOperands,
     /* 407533 */   // GIR_Coverage, 1657,
     /* 407533 */   GIR_Done,
     /* 407534 */ // Label 8294: @407534
     /* 407534 */ GIM_Reject,
     /* 407535 */ // Label 8291: @407535
     /* 407535 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(407565), // Rule ID 1656 //
     /* 407540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 407543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407554 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 407554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 407559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407563 */   GIR_RootConstrainSelectedInstOperands,
     /* 407564 */   // GIR_Coverage, 1656,
     /* 407564 */   GIR_Done,
     /* 407565 */ // Label 8295: @407565
     /* 407565 */ GIM_Reject,
     /* 407566 */ // Label 8292: @407566
     /* 407566 */ GIM_Reject,
     /* 407567 */ // Label 138: @407567
     /* 407567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8299*/ GIMT_Encode4(408799),
     /* 407578 */ /*GILLT_v2s64*//*Label 8296*/ GIMT_Encode4(407598), GIMT_Encode4(0),
     /* 407586 */ /*GILLT_v4s32*//*Label 8297*/ GIMT_Encode4(408159), GIMT_Encode4(0),
     /* 407594 */ /*GILLT_v8s16*//*Label 8298*/ GIMT_Encode4(408720),
     /* 407598 */ // Label 8296: @407598
     /* 407598 */ GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(408158),
     /* 407603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 407609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407613 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(407705), // Rule ID 2054 //
     /* 407618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 407629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407662 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407666 */     // MIs[3] Operand 1
     /* 407666 */     // No operand predicates
     /* 407666 */     // MIs[1] Operand 2
     /* 407666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 407677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 407686 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 407689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 407696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407703 */     GIR_RootConstrainSelectedInstOperands,
     /* 407704 */     // GIR_Coverage, 2054,
     /* 407704 */     GIR_EraseRootFromParent_Done,
     /* 407705 */   // Label 8301: @407705
     /* 407705 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(407797), // Rule ID 13482 //
     /* 407710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 407721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407758 */     // MIs[3] Operand 1
     /* 407758 */     // No operand predicates
     /* 407758 */     // MIs[1] Operand 2
     /* 407758 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 407769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 407778 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 407781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 407788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407795 */     GIR_RootConstrainSelectedInstOperands,
     /* 407796 */     // GIR_Coverage, 13482,
     /* 407796 */     GIR_EraseRootFromParent_Done,
     /* 407797 */   // Label 8302: @407797
     /* 407797 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(407883), // Rule ID 13480 //
     /* 407802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 407813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407846 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407850 */     // MIs[3] Operand 1
     /* 407850 */     // No operand predicates
     /* 407850 */     // MIs[1] Operand 2
     /* 407850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 407861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407867 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 407870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407881 */     GIR_RootConstrainSelectedInstOperands,
     /* 407882 */     // GIR_Coverage, 13480,
     /* 407882 */     GIR_EraseRootFromParent_Done,
     /* 407883 */   // Label 8303: @407883
     /* 407883 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(407969), // Rule ID 2052 //
     /* 407888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 407903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 407915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407936 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407940 */     // MIs[3] Operand 1
     /* 407940 */     // No operand predicates
     /* 407940 */     // MIs[1] Operand 2
     /* 407940 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 407951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407953 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 407953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 407956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407967 */     GIR_RootConstrainSelectedInstOperands,
     /* 407968 */     // GIR_Coverage, 2052,
     /* 407968 */     GIR_EraseRootFromParent_Done,
     /* 407969 */   // Label 8304: @407969
     /* 407969 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(408008), // Rule ID 1741 //
     /* 407974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 407984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 407991 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 407991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 407994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 408006 */     GIR_RootConstrainSelectedInstOperands,
     /* 408007 */     // GIR_Coverage, 1741,
     /* 408007 */     GIR_EraseRootFromParent_Done,
     /* 408008 */   // Label 8305: @408008
     /* 408008 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(408071), // Rule ID 13481 //
     /* 408013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408049 */     // MIs[2] Operand 1
     /* 408049 */     // No operand predicates
     /* 408049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408055 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 408058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408069 */     GIR_RootConstrainSelectedInstOperands,
     /* 408070 */     // GIR_Coverage, 13481,
     /* 408070 */     GIR_EraseRootFromParent_Done,
     /* 408071 */   // Label 8306: @408071
     /* 408071 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(408134), // Rule ID 2053 //
     /* 408076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408116 */     // MIs[2] Operand 1
     /* 408116 */     // No operand predicates
     /* 408116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408118 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 408121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408132 */     GIR_RootConstrainSelectedInstOperands,
     /* 408133 */     // GIR_Coverage, 2053,
     /* 408133 */     GIR_EraseRootFromParent_Done,
     /* 408134 */   // Label 8307: @408134
     /* 408134 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(408157), // Rule ID 1740 //
     /* 408139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408150 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 408150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 408155 */     GIR_RootConstrainSelectedInstOperands,
     /* 408156 */     // GIR_Coverage, 1740,
     /* 408156 */     GIR_Done,
     /* 408157 */   // Label 8308: @408157
     /* 408157 */   GIM_Reject,
     /* 408158 */ // Label 8300: @408158
     /* 408158 */ GIM_Reject,
     /* 408159 */ // Label 8297: @408159
     /* 408159 */ GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(408719),
     /* 408164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 408170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408174 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(408266), // Rule ID 2051 //
     /* 408179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408223 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408227 */     // MIs[3] Operand 1
     /* 408227 */     // No operand predicates
     /* 408227 */     // MIs[1] Operand 2
     /* 408227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 408238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 408247 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 408250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408264 */     GIR_RootConstrainSelectedInstOperands,
     /* 408265 */     // GIR_Coverage, 2051,
     /* 408265 */     GIR_EraseRootFromParent_Done,
     /* 408266 */   // Label 8310: @408266
     /* 408266 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(408358), // Rule ID 13479 //
     /* 408271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408319 */     // MIs[3] Operand 1
     /* 408319 */     // No operand predicates
     /* 408319 */     // MIs[1] Operand 2
     /* 408319 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 408330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 408339 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 408342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408356 */     GIR_RootConstrainSelectedInstOperands,
     /* 408357 */     // GIR_Coverage, 13479,
     /* 408357 */     GIR_EraseRootFromParent_Done,
     /* 408358 */   // Label 8311: @408358
     /* 408358 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(408444), // Rule ID 13477 //
     /* 408363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408411 */     // MIs[3] Operand 1
     /* 408411 */     // No operand predicates
     /* 408411 */     // MIs[1] Operand 2
     /* 408411 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 408422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408428 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 408431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408442 */     GIR_RootConstrainSelectedInstOperands,
     /* 408443 */     // GIR_Coverage, 13477,
     /* 408443 */     GIR_EraseRootFromParent_Done,
     /* 408444 */   // Label 8312: @408444
     /* 408444 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(408530), // Rule ID 2049 //
     /* 408449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408497 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408501 */     // MIs[3] Operand 1
     /* 408501 */     // No operand predicates
     /* 408501 */     // MIs[1] Operand 2
     /* 408501 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 408512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408514 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 408517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408528 */     GIR_RootConstrainSelectedInstOperands,
     /* 408529 */     // GIR_Coverage, 2049,
     /* 408529 */     GIR_EraseRootFromParent_Done,
     /* 408530 */   // Label 8313: @408530
     /* 408530 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(408569), // Rule ID 1739 //
     /* 408535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 408545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 408552 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 408552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 408555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 408567 */     GIR_RootConstrainSelectedInstOperands,
     /* 408568 */     // GIR_Coverage, 1739,
     /* 408568 */     GIR_EraseRootFromParent_Done,
     /* 408569 */   // Label 8314: @408569
     /* 408569 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(408632), // Rule ID 13478 //
     /* 408574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408610 */     // MIs[2] Operand 1
     /* 408610 */     // No operand predicates
     /* 408610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408616 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 408619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408630 */     GIR_RootConstrainSelectedInstOperands,
     /* 408631 */     // GIR_Coverage, 13478,
     /* 408631 */     GIR_EraseRootFromParent_Done,
     /* 408632 */   // Label 8315: @408632
     /* 408632 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(408695), // Rule ID 2050 //
     /* 408637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 408652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 408665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 408677 */     // MIs[2] Operand 1
     /* 408677 */     // No operand predicates
     /* 408677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408679 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 408682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408693 */     GIR_RootConstrainSelectedInstOperands,
     /* 408694 */     // GIR_Coverage, 2050,
     /* 408694 */     GIR_EraseRootFromParent_Done,
     /* 408695 */   // Label 8316: @408695
     /* 408695 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(408718), // Rule ID 1738 //
     /* 408700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408711 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 408711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 408716 */     GIR_RootConstrainSelectedInstOperands,
     /* 408717 */     // GIR_Coverage, 1738,
     /* 408717 */     GIR_Done,
     /* 408718 */   // Label 8317: @408718
     /* 408718 */   GIM_Reject,
     /* 408719 */ // Label 8309: @408719
     /* 408719 */ GIM_Reject,
     /* 408720 */ // Label 8298: @408720
     /* 408720 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(408798),
     /* 408725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408735 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(408774), // Rule ID 1737 //
     /* 408740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 408750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 408757 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 408760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 408772 */     GIR_RootConstrainSelectedInstOperands,
     /* 408773 */     // GIR_Coverage, 1737,
     /* 408773 */     GIR_EraseRootFromParent_Done,
     /* 408774 */   // Label 8319: @408774
     /* 408774 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(408797), // Rule ID 1736 //
     /* 408779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408790 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 408795 */     GIR_RootConstrainSelectedInstOperands,
     /* 408796 */     // GIR_Coverage, 1736,
     /* 408796 */     GIR_Done,
     /* 408797 */   // Label 8320: @408797
     /* 408797 */   GIM_Reject,
     /* 408798 */ // Label 8318: @408798
     /* 408798 */ GIM_Reject,
     /* 408799 */ // Label 8299: @408799
     /* 408799 */ GIM_Reject,
     /* 408800 */ // Label 139: @408800
     /* 408800 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8339*/ GIMT_Encode4(409579),
     /* 408811 */ /*GILLT_v2s32*//*Label 8321*/ GIMT_Encode4(408887),
     /* 408815 */ /*GILLT_v2s64*//*Label 8322*/ GIMT_Encode4(408942),
     /* 408819 */ /*GILLT_v4s16*//*Label 8323*/ GIMT_Encode4(408997),
     /* 408823 */ /*GILLT_v4s32*//*Label 8324*/ GIMT_Encode4(409052),
     /* 408827 */ /*GILLT_v8s8*//*Label 8325*/ GIMT_Encode4(409107),
     /* 408831 */ /*GILLT_v8s16*//*Label 8326*/ GIMT_Encode4(409141),
     /* 408835 */ /*GILLT_v16s8*//*Label 8327*/ GIMT_Encode4(409196), GIMT_Encode4(0),
     /* 408843 */ /*GILLT_nxv2s1*//*Label 8328*/ GIMT_Encode4(409230),
     /* 408847 */ /*GILLT_nxv2s16*//*Label 8329*/ GIMT_Encode4(409256),
     /* 408851 */ /*GILLT_nxv2s32*//*Label 8330*/ GIMT_Encode4(409282),
     /* 408855 */ /*GILLT_nxv2s64*//*Label 8331*/ GIMT_Encode4(409308),
     /* 408859 */ /*GILLT_nxv4s1*//*Label 8332*/ GIMT_Encode4(409355),
     /* 408863 */ /*GILLT_nxv4s16*//*Label 8333*/ GIMT_Encode4(409381),
     /* 408867 */ /*GILLT_nxv4s32*//*Label 8334*/ GIMT_Encode4(409407),
     /* 408871 */ /*GILLT_nxv8s1*//*Label 8335*/ GIMT_Encode4(409454),
     /* 408875 */ /*GILLT_nxv8s16*//*Label 8336*/ GIMT_Encode4(409480),
     /* 408879 */ /*GILLT_nxv16s1*//*Label 8337*/ GIMT_Encode4(409527),
     /* 408883 */ /*GILLT_nxv16s8*//*Label 8338*/ GIMT_Encode4(409553),
     /* 408887 */ // Label 8321: @408887
     /* 408887 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(408941),
     /* 408892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408910 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(408925), // Rule ID 1874 //
     /* 408915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408918 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 408918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 408923 */     GIR_RootConstrainSelectedInstOperands,
     /* 408924 */     // GIR_Coverage, 1874,
     /* 408924 */     GIR_Done,
     /* 408925 */   // Label 8341: @408925
     /* 408925 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(408940), // Rule ID 2505 //
     /* 408930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408933 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 408933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 408938 */     GIR_RootConstrainSelectedInstOperands,
     /* 408939 */     // GIR_Coverage, 2505,
     /* 408939 */     GIR_Done,
     /* 408940 */   // Label 8342: @408940
     /* 408940 */   GIM_Reject,
     /* 408941 */ // Label 8340: @408941
     /* 408941 */ GIM_Reject,
     /* 408942 */ // Label 8322: @408942
     /* 408942 */ GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(408996),
     /* 408947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 408953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408965 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(408980), // Rule ID 1876 //
     /* 408970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408973 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 408973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 408978 */     GIR_RootConstrainSelectedInstOperands,
     /* 408979 */     // GIR_Coverage, 1876,
     /* 408979 */     GIR_Done,
     /* 408980 */   // Label 8344: @408980
     /* 408980 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(408995), // Rule ID 2507 //
     /* 408985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408988 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 408988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 408993 */     GIR_RootConstrainSelectedInstOperands,
     /* 408994 */     // GIR_Coverage, 2507,
     /* 408994 */     GIR_Done,
     /* 408995 */   // Label 8345: @408995
     /* 408995 */   GIM_Reject,
     /* 408996 */ // Label 8343: @408996
     /* 408996 */ GIM_Reject,
     /* 408997 */ // Label 8323: @408997
     /* 408997 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(409051),
     /* 409002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409020 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(409035), // Rule ID 1872 //
     /* 409025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409028 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 409033 */     GIR_RootConstrainSelectedInstOperands,
     /* 409034 */     // GIR_Coverage, 1872,
     /* 409034 */     GIR_Done,
     /* 409035 */   // Label 8347: @409035
     /* 409035 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(409050), // Rule ID 2503 //
     /* 409040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409043 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 409043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 409048 */     GIR_RootConstrainSelectedInstOperands,
     /* 409049 */     // GIR_Coverage, 2503,
     /* 409049 */     GIR_Done,
     /* 409050 */   // Label 8348: @409050
     /* 409050 */   GIM_Reject,
     /* 409051 */ // Label 8346: @409051
     /* 409051 */ GIM_Reject,
     /* 409052 */ // Label 8324: @409052
     /* 409052 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(409106),
     /* 409057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 409063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409075 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(409090), // Rule ID 1875 //
     /* 409080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409083 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 409088 */     GIR_RootConstrainSelectedInstOperands,
     /* 409089 */     // GIR_Coverage, 1875,
     /* 409089 */     GIR_Done,
     /* 409090 */   // Label 8350: @409090
     /* 409090 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(409105), // Rule ID 2506 //
     /* 409095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409098 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 409098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 409103 */     GIR_RootConstrainSelectedInstOperands,
     /* 409104 */     // GIR_Coverage, 2506,
     /* 409104 */     GIR_Done,
     /* 409105 */   // Label 8351: @409105
     /* 409105 */   GIM_Reject,
     /* 409106 */ // Label 8349: @409106
     /* 409106 */ GIM_Reject,
     /* 409107 */ // Label 8325: @409107
     /* 409107 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(409140), // Rule ID 1870 //
     /* 409112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409133 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 409138 */   GIR_RootConstrainSelectedInstOperands,
     /* 409139 */   // GIR_Coverage, 1870,
     /* 409139 */   GIR_Done,
     /* 409140 */ // Label 8352: @409140
     /* 409140 */ GIM_Reject,
     /* 409141 */ // Label 8326: @409141
     /* 409141 */ GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(409195),
     /* 409146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 409152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409164 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(409179), // Rule ID 1873 //
     /* 409169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409172 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 409177 */     GIR_RootConstrainSelectedInstOperands,
     /* 409178 */     // GIR_Coverage, 1873,
     /* 409178 */     GIR_Done,
     /* 409179 */   // Label 8354: @409179
     /* 409179 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(409194), // Rule ID 2504 //
     /* 409184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409187 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 409187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 409192 */     GIR_RootConstrainSelectedInstOperands,
     /* 409193 */     // GIR_Coverage, 2504,
     /* 409193 */     GIR_Done,
     /* 409194 */   // Label 8355: @409194
     /* 409194 */   GIM_Reject,
     /* 409195 */ // Label 8353: @409195
     /* 409195 */ GIM_Reject,
     /* 409196 */ // Label 8327: @409196
     /* 409196 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(409229), // Rule ID 1871 //
     /* 409201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 409207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 409210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409222 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 409227 */   GIR_RootConstrainSelectedInstOperands,
     /* 409228 */   // GIR_Coverage, 1871,
     /* 409228 */   GIR_Done,
     /* 409229 */ // Label 8356: @409229
     /* 409229 */ GIM_Reject,
     /* 409230 */ // Label 8328: @409230
     /* 409230 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(409255), // Rule ID 8945 //
     /* 409235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 409241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 409244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409248 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 409248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 409253 */   GIR_RootConstrainSelectedInstOperands,
     /* 409254 */   // GIR_Coverage, 8945,
     /* 409254 */   GIR_Done,
     /* 409255 */ // Label 8357: @409255
     /* 409255 */ GIM_Reject,
     /* 409256 */ // Label 8329: @409256
     /* 409256 */ GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(409281), // Rule ID 8921 //
     /* 409261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 409267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 409270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409274 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 409274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 409279 */   GIR_RootConstrainSelectedInstOperands,
     /* 409280 */   // GIR_Coverage, 8921,
     /* 409280 */   GIR_Done,
     /* 409281 */ // Label 8358: @409281
     /* 409281 */ GIM_Reject,
     /* 409282 */ // Label 8330: @409282
     /* 409282 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(409307), // Rule ID 8922 //
     /* 409287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 409293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 409296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409300 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 409300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 409305 */   GIR_RootConstrainSelectedInstOperands,
     /* 409306 */   // GIR_Coverage, 8922,
     /* 409306 */   GIR_Done,
     /* 409307 */ // Label 8359: @409307
     /* 409307 */ GIM_Reject,
     /* 409308 */ // Label 8331: @409308
     /* 409308 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(409354),
     /* 409313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 409316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 409319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409323 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(409338), // Rule ID 8917 //
     /* 409328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409331 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 409331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 409336 */     GIR_RootConstrainSelectedInstOperands,
     /* 409337 */     // GIR_Coverage, 8917,
     /* 409337 */     GIR_Done,
     /* 409338 */   // Label 8361: @409338
     /* 409338 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(409353), // Rule ID 8923 //
     /* 409343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409346 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 409346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 409351 */     GIR_RootConstrainSelectedInstOperands,
     /* 409352 */     // GIR_Coverage, 8923,
     /* 409352 */     GIR_Done,
     /* 409353 */   // Label 8362: @409353
     /* 409353 */   GIM_Reject,
     /* 409354 */ // Label 8360: @409354
     /* 409354 */ GIM_Reject,
     /* 409355 */ // Label 8332: @409355
     /* 409355 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(409380), // Rule ID 8944 //
     /* 409360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 409366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 409369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409373 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 409373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 409378 */   GIR_RootConstrainSelectedInstOperands,
     /* 409379 */   // GIR_Coverage, 8944,
     /* 409379 */   GIR_Done,
     /* 409380 */ // Label 8363: @409380
     /* 409380 */ GIM_Reject,
     /* 409381 */ // Label 8333: @409381
     /* 409381 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(409406), // Rule ID 8919 //
     /* 409386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 409392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 409395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409399 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 409399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 409404 */   GIR_RootConstrainSelectedInstOperands,
     /* 409405 */   // GIR_Coverage, 8919,
     /* 409405 */   GIR_Done,
     /* 409406 */ // Label 8364: @409406
     /* 409406 */ GIM_Reject,
     /* 409407 */ // Label 8334: @409407
     /* 409407 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(409453),
     /* 409412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 409415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 409418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409422 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(409437), // Rule ID 8916 //
     /* 409427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409430 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 409430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 409435 */     GIR_RootConstrainSelectedInstOperands,
     /* 409436 */     // GIR_Coverage, 8916,
     /* 409436 */     GIR_Done,
     /* 409437 */   // Label 8366: @409437
     /* 409437 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(409452), // Rule ID 8920 //
     /* 409442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409445 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 409445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 409450 */     GIR_RootConstrainSelectedInstOperands,
     /* 409451 */     // GIR_Coverage, 8920,
     /* 409451 */     GIR_Done,
     /* 409452 */   // Label 8367: @409452
     /* 409452 */   GIM_Reject,
     /* 409453 */ // Label 8365: @409453
     /* 409453 */ GIM_Reject,
     /* 409454 */ // Label 8335: @409454
     /* 409454 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(409479), // Rule ID 8943 //
     /* 409459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 409465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 409468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409472 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 409472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 409477 */   GIR_RootConstrainSelectedInstOperands,
     /* 409478 */   // GIR_Coverage, 8943,
     /* 409478 */   GIR_Done,
     /* 409479 */ // Label 8368: @409479
     /* 409479 */ GIM_Reject,
     /* 409480 */ // Label 8336: @409480
     /* 409480 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(409526),
     /* 409485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 409488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 409491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409495 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(409510), // Rule ID 8915 //
     /* 409500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409503 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 409503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 409508 */     GIR_RootConstrainSelectedInstOperands,
     /* 409509 */     // GIR_Coverage, 8915,
     /* 409509 */     GIR_Done,
     /* 409510 */   // Label 8370: @409510
     /* 409510 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(409525), // Rule ID 8918 //
     /* 409515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409518 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 409518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 409523 */     GIR_RootConstrainSelectedInstOperands,
     /* 409524 */     // GIR_Coverage, 8918,
     /* 409524 */     GIR_Done,
     /* 409525 */   // Label 8371: @409525
     /* 409525 */   GIM_Reject,
     /* 409526 */ // Label 8369: @409526
     /* 409526 */ GIM_Reject,
     /* 409527 */ // Label 8337: @409527
     /* 409527 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(409552), // Rule ID 2414 //
     /* 409532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 409538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 409541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409545 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 409545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 409550 */   GIR_RootConstrainSelectedInstOperands,
     /* 409551 */   // GIR_Coverage, 2414,
     /* 409551 */   GIR_Done,
     /* 409552 */ // Label 8372: @409552
     /* 409552 */ GIM_Reject,
     /* 409553 */ // Label 8338: @409553
     /* 409553 */ GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(409578), // Rule ID 8914 //
     /* 409558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 409564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 409567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409571 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 409571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 409576 */   GIR_RootConstrainSelectedInstOperands,
     /* 409577 */   // GIR_Coverage, 8914,
     /* 409577 */   GIR_Done,
     /* 409578 */ // Label 8373: @409578
     /* 409578 */ GIM_Reject,
     /* 409579 */ // Label 8339: @409579
     /* 409579 */ GIM_Reject,
     /* 409580 */ // Label 140: @409580
     /* 409580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8392*/ GIMT_Encode4(410359),
     /* 409591 */ /*GILLT_v2s32*//*Label 8374*/ GIMT_Encode4(409667),
     /* 409595 */ /*GILLT_v2s64*//*Label 8375*/ GIMT_Encode4(409722),
     /* 409599 */ /*GILLT_v4s16*//*Label 8376*/ GIMT_Encode4(409777),
     /* 409603 */ /*GILLT_v4s32*//*Label 8377*/ GIMT_Encode4(409832),
     /* 409607 */ /*GILLT_v8s8*//*Label 8378*/ GIMT_Encode4(409887),
     /* 409611 */ /*GILLT_v8s16*//*Label 8379*/ GIMT_Encode4(409921),
     /* 409615 */ /*GILLT_v16s8*//*Label 8380*/ GIMT_Encode4(409976), GIMT_Encode4(0),
     /* 409623 */ /*GILLT_nxv2s1*//*Label 8381*/ GIMT_Encode4(410010),
     /* 409627 */ /*GILLT_nxv2s16*//*Label 8382*/ GIMT_Encode4(410036),
     /* 409631 */ /*GILLT_nxv2s32*//*Label 8383*/ GIMT_Encode4(410062),
     /* 409635 */ /*GILLT_nxv2s64*//*Label 8384*/ GIMT_Encode4(410088),
     /* 409639 */ /*GILLT_nxv4s1*//*Label 8385*/ GIMT_Encode4(410135),
     /* 409643 */ /*GILLT_nxv4s16*//*Label 8386*/ GIMT_Encode4(410161),
     /* 409647 */ /*GILLT_nxv4s32*//*Label 8387*/ GIMT_Encode4(410187),
     /* 409651 */ /*GILLT_nxv8s1*//*Label 8388*/ GIMT_Encode4(410234),
     /* 409655 */ /*GILLT_nxv8s16*//*Label 8389*/ GIMT_Encode4(410260),
     /* 409659 */ /*GILLT_nxv16s1*//*Label 8390*/ GIMT_Encode4(410307),
     /* 409663 */ /*GILLT_nxv16s8*//*Label 8391*/ GIMT_Encode4(410333),
     /* 409667 */ // Label 8374: @409667
     /* 409667 */ GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(409721),
     /* 409672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409690 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(409705), // Rule ID 1881 //
     /* 409695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409698 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 409703 */     GIR_RootConstrainSelectedInstOperands,
     /* 409704 */     // GIR_Coverage, 1881,
     /* 409704 */     GIR_Done,
     /* 409705 */   // Label 8394: @409705
     /* 409705 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(409720), // Rule ID 5469 //
     /* 409710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409713 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 409713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 409718 */     GIR_RootConstrainSelectedInstOperands,
     /* 409719 */     // GIR_Coverage, 5469,
     /* 409719 */     GIR_Done,
     /* 409720 */   // Label 8395: @409720
     /* 409720 */   GIM_Reject,
     /* 409721 */ // Label 8393: @409721
     /* 409721 */ GIM_Reject,
     /* 409722 */ // Label 8375: @409722
     /* 409722 */ GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(409776),
     /* 409727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 409733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409745 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(409760), // Rule ID 1883 //
     /* 409750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409753 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 409753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 409758 */     GIR_RootConstrainSelectedInstOperands,
     /* 409759 */     // GIR_Coverage, 1883,
     /* 409759 */     GIR_Done,
     /* 409760 */   // Label 8397: @409760
     /* 409760 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(409775), // Rule ID 5471 //
     /* 409765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409768 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 409768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 409773 */     GIR_RootConstrainSelectedInstOperands,
     /* 409774 */     // GIR_Coverage, 5471,
     /* 409774 */     GIR_Done,
     /* 409775 */   // Label 8398: @409775
     /* 409775 */   GIM_Reject,
     /* 409776 */ // Label 8396: @409776
     /* 409776 */ GIM_Reject,
     /* 409777 */ // Label 8376: @409777
     /* 409777 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(409831),
     /* 409782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409800 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(409815), // Rule ID 1879 //
     /* 409805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409808 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 409813 */     GIR_RootConstrainSelectedInstOperands,
     /* 409814 */     // GIR_Coverage, 1879,
     /* 409814 */     GIR_Done,
     /* 409815 */   // Label 8400: @409815
     /* 409815 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(409830), // Rule ID 5467 //
     /* 409820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409823 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 409823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 409828 */     GIR_RootConstrainSelectedInstOperands,
     /* 409829 */     // GIR_Coverage, 5467,
     /* 409829 */     GIR_Done,
     /* 409830 */   // Label 8401: @409830
     /* 409830 */   GIM_Reject,
     /* 409831 */ // Label 8399: @409831
     /* 409831 */ GIM_Reject,
     /* 409832 */ // Label 8377: @409832
     /* 409832 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(409886),
     /* 409837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 409843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409855 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(409870), // Rule ID 1882 //
     /* 409860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409863 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 409868 */     GIR_RootConstrainSelectedInstOperands,
     /* 409869 */     // GIR_Coverage, 1882,
     /* 409869 */     GIR_Done,
     /* 409870 */   // Label 8403: @409870
     /* 409870 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(409885), // Rule ID 5470 //
     /* 409875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409878 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 409878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 409883 */     GIR_RootConstrainSelectedInstOperands,
     /* 409884 */     // GIR_Coverage, 5470,
     /* 409884 */     GIR_Done,
     /* 409885 */   // Label 8404: @409885
     /* 409885 */   GIM_Reject,
     /* 409886 */ // Label 8402: @409886
     /* 409886 */ GIM_Reject,
     /* 409887 */ // Label 8378: @409887
     /* 409887 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(409920), // Rule ID 1877 //
     /* 409892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409913 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 409918 */   GIR_RootConstrainSelectedInstOperands,
     /* 409919 */   // GIR_Coverage, 1877,
     /* 409919 */   GIR_Done,
     /* 409920 */ // Label 8405: @409920
     /* 409920 */ GIM_Reject,
     /* 409921 */ // Label 8379: @409921
     /* 409921 */ GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(409975),
     /* 409926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 409932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409944 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(409959), // Rule ID 1880 //
     /* 409949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409952 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 409957 */     GIR_RootConstrainSelectedInstOperands,
     /* 409958 */     // GIR_Coverage, 1880,
     /* 409958 */     GIR_Done,
     /* 409959 */   // Label 8407: @409959
     /* 409959 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(409974), // Rule ID 5468 //
     /* 409964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409967 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 409967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 409972 */     GIR_RootConstrainSelectedInstOperands,
     /* 409973 */     // GIR_Coverage, 5468,
     /* 409973 */     GIR_Done,
     /* 409974 */   // Label 8408: @409974
     /* 409974 */   GIM_Reject,
     /* 409975 */ // Label 8406: @409975
     /* 409975 */ GIM_Reject,
     /* 409976 */ // Label 8380: @409976
     /* 409976 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(410009), // Rule ID 1878 //
     /* 409981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 409987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 409990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410002 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 410007 */   GIR_RootConstrainSelectedInstOperands,
     /* 410008 */   // GIR_Coverage, 1878,
     /* 410008 */   GIR_Done,
     /* 410009 */ // Label 8409: @410009
     /* 410009 */ GIM_Reject,
     /* 410010 */ // Label 8381: @410010
     /* 410010 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(410035), // Rule ID 8948 //
     /* 410015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410028 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 410033 */   GIR_RootConstrainSelectedInstOperands,
     /* 410034 */   // GIR_Coverage, 8948,
     /* 410034 */   GIR_Done,
     /* 410035 */ // Label 8410: @410035
     /* 410035 */ GIM_Reject,
     /* 410036 */ // Label 8382: @410036
     /* 410036 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(410061), // Rule ID 8931 //
     /* 410041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410054 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 410059 */   GIR_RootConstrainSelectedInstOperands,
     /* 410060 */   // GIR_Coverage, 8931,
     /* 410060 */   GIR_Done,
     /* 410061 */ // Label 8411: @410061
     /* 410061 */ GIM_Reject,
     /* 410062 */ // Label 8383: @410062
     /* 410062 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(410087), // Rule ID 8932 //
     /* 410067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410080 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 410085 */   GIR_RootConstrainSelectedInstOperands,
     /* 410086 */   // GIR_Coverage, 8932,
     /* 410086 */   GIR_Done,
     /* 410087 */ // Label 8412: @410087
     /* 410087 */ GIM_Reject,
     /* 410088 */ // Label 8384: @410088
     /* 410088 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(410134),
     /* 410093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410103 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(410118), // Rule ID 8927 //
     /* 410108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410111 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 410116 */     GIR_RootConstrainSelectedInstOperands,
     /* 410117 */     // GIR_Coverage, 8927,
     /* 410117 */     GIR_Done,
     /* 410118 */   // Label 8414: @410118
     /* 410118 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(410133), // Rule ID 8933 //
     /* 410123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410126 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 410131 */     GIR_RootConstrainSelectedInstOperands,
     /* 410132 */     // GIR_Coverage, 8933,
     /* 410132 */     GIR_Done,
     /* 410133 */   // Label 8415: @410133
     /* 410133 */   GIM_Reject,
     /* 410134 */ // Label 8413: @410134
     /* 410134 */ GIM_Reject,
     /* 410135 */ // Label 8385: @410135
     /* 410135 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(410160), // Rule ID 8947 //
     /* 410140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410153 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 410158 */   GIR_RootConstrainSelectedInstOperands,
     /* 410159 */   // GIR_Coverage, 8947,
     /* 410159 */   GIR_Done,
     /* 410160 */ // Label 8416: @410160
     /* 410160 */ GIM_Reject,
     /* 410161 */ // Label 8386: @410161
     /* 410161 */ GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(410186), // Rule ID 8929 //
     /* 410166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410179 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 410184 */   GIR_RootConstrainSelectedInstOperands,
     /* 410185 */   // GIR_Coverage, 8929,
     /* 410185 */   GIR_Done,
     /* 410186 */ // Label 8417: @410186
     /* 410186 */ GIM_Reject,
     /* 410187 */ // Label 8387: @410187
     /* 410187 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(410233),
     /* 410192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 410195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 410198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410202 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(410217), // Rule ID 8926 //
     /* 410207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410210 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 410210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 410215 */     GIR_RootConstrainSelectedInstOperands,
     /* 410216 */     // GIR_Coverage, 8926,
     /* 410216 */     GIR_Done,
     /* 410217 */   // Label 8419: @410217
     /* 410217 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(410232), // Rule ID 8930 //
     /* 410222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410225 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 410225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 410230 */     GIR_RootConstrainSelectedInstOperands,
     /* 410231 */     // GIR_Coverage, 8930,
     /* 410231 */     GIR_Done,
     /* 410232 */   // Label 8420: @410232
     /* 410232 */   GIM_Reject,
     /* 410233 */ // Label 8418: @410233
     /* 410233 */ GIM_Reject,
     /* 410234 */ // Label 8388: @410234
     /* 410234 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(410259), // Rule ID 8946 //
     /* 410239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 410245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 410248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410252 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 410252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 410257 */   GIR_RootConstrainSelectedInstOperands,
     /* 410258 */   // GIR_Coverage, 8946,
     /* 410258 */   GIR_Done,
     /* 410259 */ // Label 8421: @410259
     /* 410259 */ GIM_Reject,
     /* 410260 */ // Label 8389: @410260
     /* 410260 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(410306),
     /* 410265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 410268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 410271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410275 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(410290), // Rule ID 8925 //
     /* 410280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410283 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 410283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 410288 */     GIR_RootConstrainSelectedInstOperands,
     /* 410289 */     // GIR_Coverage, 8925,
     /* 410289 */     GIR_Done,
     /* 410290 */   // Label 8423: @410290
     /* 410290 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(410305), // Rule ID 8928 //
     /* 410295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410298 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 410298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 410303 */     GIR_RootConstrainSelectedInstOperands,
     /* 410304 */     // GIR_Coverage, 8928,
     /* 410304 */     GIR_Done,
     /* 410305 */   // Label 8424: @410305
     /* 410305 */   GIM_Reject,
     /* 410306 */ // Label 8422: @410306
     /* 410306 */ GIM_Reject,
     /* 410307 */ // Label 8390: @410307
     /* 410307 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(410332), // Rule ID 2418 //
     /* 410312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 410318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 410321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410325 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 410325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 410330 */   GIR_RootConstrainSelectedInstOperands,
     /* 410331 */   // GIR_Coverage, 2418,
     /* 410331 */   GIR_Done,
     /* 410332 */ // Label 8425: @410332
     /* 410332 */ GIM_Reject,
     /* 410333 */ // Label 8391: @410333
     /* 410333 */ GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(410358), // Rule ID 8924 //
     /* 410338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 410344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 410347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410351 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 410351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 410356 */   GIR_RootConstrainSelectedInstOperands,
     /* 410357 */   // GIR_Coverage, 8924,
     /* 410357 */   GIR_Done,
     /* 410358 */ // Label 8426: @410358
     /* 410358 */ GIM_Reject,
     /* 410359 */ // Label 8392: @410359
     /* 410359 */ GIM_Reject,
     /* 410360 */ // Label 141: @410360
     /* 410360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8433*/ GIMT_Encode4(410565),
     /* 410371 */ /*GILLT_s64*//*Label 8427*/ GIMT_Encode4(410403), GIMT_Encode4(0),
     /* 410379 */ /*GILLT_v2s32*//*Label 8428*/ GIMT_Encode4(410430),
     /* 410383 */ /*GILLT_v2s64*//*Label 8429*/ GIMT_Encode4(410457),
     /* 410387 */ /*GILLT_v4s16*//*Label 8430*/ GIMT_Encode4(410484),
     /* 410391 */ /*GILLT_v4s32*//*Label 8431*/ GIMT_Encode4(410511), GIMT_Encode4(0),
     /* 410399 */ /*GILLT_v8s16*//*Label 8432*/ GIMT_Encode4(410538),
     /* 410403 */ // Label 8427: @410403
     /* 410403 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(410429), // Rule ID 1069 //
     /* 410408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410422 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 410422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 410427 */   GIR_RootConstrainSelectedInstOperands,
     /* 410428 */   // GIR_Coverage, 1069,
     /* 410428 */   GIR_Done,
     /* 410429 */ // Label 8434: @410429
     /* 410429 */ GIM_Reject,
     /* 410430 */ // Label 8428: @410430
     /* 410430 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(410456), // Rule ID 1065 //
     /* 410435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410449 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 410449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 410454 */   GIR_RootConstrainSelectedInstOperands,
     /* 410455 */   // GIR_Coverage, 1065,
     /* 410455 */   GIR_Done,
     /* 410456 */ // Label 8435: @410456
     /* 410456 */ GIM_Reject,
     /* 410457 */ // Label 8429: @410457
     /* 410457 */ GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(410483), // Rule ID 1071 //
     /* 410462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410476 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 410476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 410481 */   GIR_RootConstrainSelectedInstOperands,
     /* 410482 */   // GIR_Coverage, 1071,
     /* 410482 */   GIR_Done,
     /* 410483 */ // Label 8436: @410483
     /* 410483 */ GIM_Reject,
     /* 410484 */ // Label 8430: @410484
     /* 410484 */ GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(410510), // Rule ID 1061 //
     /* 410489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410503 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 410503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 410508 */   GIR_RootConstrainSelectedInstOperands,
     /* 410509 */   // GIR_Coverage, 1061,
     /* 410509 */   GIR_Done,
     /* 410510 */ // Label 8437: @410510
     /* 410510 */ GIM_Reject,
     /* 410511 */ // Label 8431: @410511
     /* 410511 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(410537), // Rule ID 1067 //
     /* 410516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410530 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 410530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 410535 */   GIR_RootConstrainSelectedInstOperands,
     /* 410536 */   // GIR_Coverage, 1067,
     /* 410536 */   GIR_Done,
     /* 410537 */ // Label 8438: @410537
     /* 410537 */ GIM_Reject,
     /* 410538 */ // Label 8432: @410538
     /* 410538 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(410564), // Rule ID 1063 //
     /* 410543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410557 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 410557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 410562 */   GIR_RootConstrainSelectedInstOperands,
     /* 410563 */   // GIR_Coverage, 1063,
     /* 410563 */   GIR_Done,
     /* 410564 */ // Label 8439: @410564
     /* 410564 */ GIM_Reject,
     /* 410565 */ // Label 8433: @410565
     /* 410565 */ GIM_Reject,
     /* 410566 */ // Label 142: @410566
     /* 410566 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8442*/ GIMT_Encode4(411432),
     /* 410577 */ /*GILLT_v2s64*//*Label 8440*/ GIMT_Encode4(410589), GIMT_Encode4(0),
     /* 410585 */ /*GILLT_v4s32*//*Label 8441*/ GIMT_Encode4(410883),
     /* 410589 */ // Label 8440: @410589
     /* 410589 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(410671), // Rule ID 5856 //
     /* 410594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 410609 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 410612 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 410617 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410621 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410628 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 410628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 410631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 410635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410640 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 410644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 410646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 410660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410670 */   // GIR_Coverage, 5856,
     /* 410670 */   GIR_EraseRootFromParent_Done,
     /* 410671 */ // Label 8443: @410671
     /* 410671 */ GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(410745), // Rule ID 5855 //
     /* 410676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 410691 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410695 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410702 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 410702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 410705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 410709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410714 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 410718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 410720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 410734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410744 */   // GIR_Coverage, 5855,
     /* 410744 */   GIR_EraseRootFromParent_Done,
     /* 410745 */ // Label 8444: @410745
     /* 410745 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(410804), // Rule ID 5865 //
     /* 410750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410761 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 410761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 410768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410773 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 410777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 410779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 410793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410803 */   // GIR_Coverage, 5865,
     /* 410803 */   GIR_EraseRootFromParent_Done,
     /* 410804 */ // Label 8445: @410804
     /* 410804 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(410882), // Rule ID 5993 //
     /* 410809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410820 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 410820 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 410823 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 410827 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410832 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 410836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 410838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 410841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 410845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 410852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 410855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 410863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 410866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410881 */   // GIR_Coverage, 5993,
     /* 410881 */   GIR_EraseRootFromParent_Done,
     /* 410882 */ // Label 8446: @410882
     /* 410882 */ GIM_Reject,
     /* 410883 */ // Label 8441: @410883
     /* 410883 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(410965), // Rule ID 5858 //
     /* 410888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410895 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 410903 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 410906 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 410911 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410915 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410922 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 410922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 410925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 410929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410934 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 410938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 410940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 410954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 410964 */   // GIR_Coverage, 5858,
     /* 410964 */   GIR_EraseRootFromParent_Done,
     /* 410965 */ // Label 8447: @410965
     /* 410965 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(411047), // Rule ID 5860 //
     /* 410970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410977 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 410985 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 410988 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 410993 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410997 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411002 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411004 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 411004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 411007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 411011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411016 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 411020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 411036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411046 */   // GIR_Coverage, 5860,
     /* 411046 */   GIR_EraseRootFromParent_Done,
     /* 411047 */ // Label 8448: @411047
     /* 411047 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(411121), // Rule ID 5857 //
     /* 411052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 411067 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411071 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411078 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 411078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 411081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 411085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411090 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 411094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 411110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411120 */   // GIR_Coverage, 5857,
     /* 411120 */   GIR_EraseRootFromParent_Done,
     /* 411121 */ // Label 8449: @411121
     /* 411121 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(411195), // Rule ID 5859 //
     /* 411126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 411141 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411145 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411152 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 411152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 411155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 411159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411164 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 411168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 411184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411194 */   // GIR_Coverage, 5859,
     /* 411194 */   GIR_EraseRootFromParent_Done,
     /* 411195 */ // Label 8450: @411195
     /* 411195 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(411254), // Rule ID 5861 //
     /* 411200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411211 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 411211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 411214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 411218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 411227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 411243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411253 */   // GIR_Coverage, 5861,
     /* 411253 */   GIR_EraseRootFromParent_Done,
     /* 411254 */ // Label 8451: @411254
     /* 411254 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(411313), // Rule ID 5862 //
     /* 411259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411270 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 411270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 411273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 411277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 411286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 411302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411312 */   // GIR_Coverage, 5862,
     /* 411312 */   GIR_EraseRootFromParent_Done,
     /* 411313 */ // Label 8452: @411313
     /* 411313 */ GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(411372), // Rule ID 5863 //
     /* 411318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411329 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 411329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 411332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 411336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 411345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 411361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411371 */   // GIR_Coverage, 5863,
     /* 411371 */   GIR_EraseRootFromParent_Done,
     /* 411372 */ // Label 8453: @411372
     /* 411372 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(411431), // Rule ID 5864 //
     /* 411377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411388 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 411388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 411391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 411395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411400 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 411404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 411406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 411420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411430 */   // GIR_Coverage, 5864,
     /* 411430 */   GIR_EraseRootFromParent_Done,
     /* 411431 */ // Label 8454: @411431
     /* 411431 */ GIM_Reject,
     /* 411432 */ // Label 8442: @411432
     /* 411432 */ GIM_Reject,
     /* 411433 */ // Label 143: @411433
     /* 411433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8459*/ GIMT_Encode4(411802),
     /* 411444 */ /*GILLT_v2s32*//*Label 8455*/ GIMT_Encode4(411504), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 411456 */ /*GILLT_v4s32*//*Label 8456*/ GIMT_Encode4(411624), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 411488 */ /*GILLT_nxv2s64*//*Label 8457*/ GIMT_Encode4(411744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 411500 */ /*GILLT_nxv4s32*//*Label 8458*/ GIMT_Encode4(411773),
     /* 411504 */ // Label 8455: @411504
     /* 411504 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(411623),
     /* 411509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 411518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411530 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(411603), // Rule ID 28 //
     /* 411535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 411538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 411542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 411546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411583 */     // MIs[3] Operand 1
     /* 411583 */     // No operand predicates
     /* 411583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411585 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 411585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 411588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 411592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411601 */     GIR_RootConstrainSelectedInstOperands,
     /* 411602 */     // GIR_Coverage, 28,
     /* 411602 */     GIR_EraseRootFromParent_Done,
     /* 411603 */   // Label 8461: @411603
     /* 411603 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(411622), // Rule ID 24 //
     /* 411608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 411611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411615 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 411620 */     GIR_RootConstrainSelectedInstOperands,
     /* 411621 */     // GIR_Coverage, 24,
     /* 411621 */     GIR_Done,
     /* 411622 */   // Label 8462: @411622
     /* 411622 */   GIM_Reject,
     /* 411623 */ // Label 8460: @411623
     /* 411623 */ GIM_Reject,
     /* 411624 */ // Label 8456: @411624
     /* 411624 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(411743),
     /* 411629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 411638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411650 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(411723), // Rule ID 29 //
     /* 411655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 411658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 411662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 411666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 411703 */     // MIs[3] Operand 1
     /* 411703 */     // No operand predicates
     /* 411703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411705 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 411705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 411708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 411712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411721 */     GIR_RootConstrainSelectedInstOperands,
     /* 411722 */     // GIR_Coverage, 29,
     /* 411722 */     GIR_EraseRootFromParent_Done,
     /* 411723 */   // Label 8464: @411723
     /* 411723 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(411742), // Rule ID 25 //
     /* 411728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 411731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411735 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 411740 */     GIR_RootConstrainSelectedInstOperands,
     /* 411741 */     // GIR_Coverage, 25,
     /* 411741 */     GIR_Done,
     /* 411742 */   // Label 8465: @411742
     /* 411742 */   GIM_Reject,
     /* 411743 */ // Label 8463: @411743
     /* 411743 */ GIM_Reject,
     /* 411744 */ // Label 8457: @411744
     /* 411744 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(411772), // Rule ID 7631 //
     /* 411749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411758 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 411761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411765 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 411765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 411770 */   GIR_RootConstrainSelectedInstOperands,
     /* 411771 */   // GIR_Coverage, 7631,
     /* 411771 */   GIR_Done,
     /* 411772 */ // Label 8466: @411772
     /* 411772 */ GIM_Reject,
     /* 411773 */ // Label 8458: @411773
     /* 411773 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(411801), // Rule ID 7630 //
     /* 411778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 411790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411794 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 411794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 411799 */   GIR_RootConstrainSelectedInstOperands,
     /* 411800 */   // GIR_Coverage, 7630,
     /* 411800 */   GIR_Done,
     /* 411801 */ // Label 8467: @411801
     /* 411801 */ GIM_Reject,
     /* 411802 */ // Label 8459: @411802
     /* 411802 */ GIM_Reject,
     /* 411803 */ // Label 144: @411803
     /* 411803 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8471*/ GIMT_Encode4(411919),
     /* 411814 */ /*GILLT_s16*//*Label 8468*/ GIMT_Encode4(411826),
     /* 411818 */ /*GILLT_s32*//*Label 8469*/ GIMT_Encode4(411857),
     /* 411822 */ /*GILLT_s64*//*Label 8470*/ GIMT_Encode4(411888),
     /* 411826 */ // Label 8468: @411826
     /* 411826 */ GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(411856), // Rule ID 1669 //
     /* 411831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 411834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 411837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 411845 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 411845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 411850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 411854 */   GIR_RootConstrainSelectedInstOperands,
     /* 411855 */   // GIR_Coverage, 1669,
     /* 411855 */   GIR_Done,
     /* 411856 */ // Label 8472: @411856
     /* 411856 */ GIM_Reject,
     /* 411857 */ // Label 8469: @411857
     /* 411857 */ GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(411887), // Rule ID 1668 //
     /* 411862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 411865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 411868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411876 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 411876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 411881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 411885 */   GIR_RootConstrainSelectedInstOperands,
     /* 411886 */   // GIR_Coverage, 1668,
     /* 411886 */   GIR_Done,
     /* 411887 */ // Label 8473: @411887
     /* 411887 */ GIM_Reject,
     /* 411888 */ // Label 8470: @411888
     /* 411888 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(411918), // Rule ID 1667 //
     /* 411893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 411896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 411899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411907 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 411907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 411912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 411916 */   GIR_RootConstrainSelectedInstOperands,
     /* 411917 */   // GIR_Coverage, 1667,
     /* 411917 */   GIR_Done,
     /* 411918 */ // Label 8474: @411918
     /* 411918 */ GIM_Reject,
     /* 411919 */ // Label 8471: @411919
     /* 411919 */ GIM_Reject,
     /* 411920 */ // Label 145: @411920
     /* 411920 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8478*/ GIMT_Encode4(413152),
     /* 411931 */ /*GILLT_v2s64*//*Label 8475*/ GIMT_Encode4(411951), GIMT_Encode4(0),
     /* 411939 */ /*GILLT_v4s32*//*Label 8476*/ GIMT_Encode4(412512), GIMT_Encode4(0),
     /* 411947 */ /*GILLT_v8s16*//*Label 8477*/ GIMT_Encode4(413073),
     /* 411951 */ // Label 8475: @411951
     /* 411951 */ GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(412511),
     /* 411956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411966 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(412058), // Rule ID 2106 //
     /* 411971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 411982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 411994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412015 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412019 */     // MIs[3] Operand 1
     /* 412019 */     // No operand predicates
     /* 412019 */     // MIs[1] Operand 2
     /* 412019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 412030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 412039 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 412042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412056 */     GIR_RootConstrainSelectedInstOperands,
     /* 412057 */     // GIR_Coverage, 2106,
     /* 412057 */     GIR_EraseRootFromParent_Done,
     /* 412058 */   // Label 8480: @412058
     /* 412058 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(412150), // Rule ID 13512 //
     /* 412063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412107 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412111 */     // MIs[3] Operand 1
     /* 412111 */     // No operand predicates
     /* 412111 */     // MIs[1] Operand 2
     /* 412111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 412122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 412131 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 412134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412148 */     GIR_RootConstrainSelectedInstOperands,
     /* 412149 */     // GIR_Coverage, 13512,
     /* 412149 */     GIR_EraseRootFromParent_Done,
     /* 412150 */   // Label 8481: @412150
     /* 412150 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(412236), // Rule ID 13510 //
     /* 412155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412203 */     // MIs[3] Operand 1
     /* 412203 */     // No operand predicates
     /* 412203 */     // MIs[1] Operand 2
     /* 412203 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 412214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412220 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 412223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412234 */     GIR_RootConstrainSelectedInstOperands,
     /* 412235 */     // GIR_Coverage, 13510,
     /* 412235 */     GIR_EraseRootFromParent_Done,
     /* 412236 */   // Label 8482: @412236
     /* 412236 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(412322), // Rule ID 2104 //
     /* 412241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412293 */     // MIs[3] Operand 1
     /* 412293 */     // No operand predicates
     /* 412293 */     // MIs[1] Operand 2
     /* 412293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 412304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412306 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 412309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412320 */     GIR_RootConstrainSelectedInstOperands,
     /* 412321 */     // GIR_Coverage, 2104,
     /* 412321 */     GIR_EraseRootFromParent_Done,
     /* 412322 */   // Label 8483: @412322
     /* 412322 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(412361), // Rule ID 1831 //
     /* 412327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 412337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 412344 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 412344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 412347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 412359 */     GIR_RootConstrainSelectedInstOperands,
     /* 412360 */     // GIR_Coverage, 1831,
     /* 412360 */     GIR_EraseRootFromParent_Done,
     /* 412361 */   // Label 8484: @412361
     /* 412361 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(412424), // Rule ID 13511 //
     /* 412366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412402 */     // MIs[2] Operand 1
     /* 412402 */     // No operand predicates
     /* 412402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412408 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 412411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412422 */     GIR_RootConstrainSelectedInstOperands,
     /* 412423 */     // GIR_Coverage, 13511,
     /* 412423 */     GIR_EraseRootFromParent_Done,
     /* 412424 */   // Label 8485: @412424
     /* 412424 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(412487), // Rule ID 2105 //
     /* 412429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 412444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 412469 */     // MIs[2] Operand 1
     /* 412469 */     // No operand predicates
     /* 412469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412471 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 412474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412485 */     GIR_RootConstrainSelectedInstOperands,
     /* 412486 */     // GIR_Coverage, 2105,
     /* 412486 */     GIR_EraseRootFromParent_Done,
     /* 412487 */   // Label 8486: @412487
     /* 412487 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(412510), // Rule ID 1830 //
     /* 412492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412503 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 412503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 412508 */     GIR_RootConstrainSelectedInstOperands,
     /* 412509 */     // GIR_Coverage, 1830,
     /* 412509 */     GIR_Done,
     /* 412510 */   // Label 8487: @412510
     /* 412510 */   GIM_Reject,
     /* 412511 */ // Label 8479: @412511
     /* 412511 */ GIM_Reject,
     /* 412512 */ // Label 8476: @412512
     /* 412512 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(413072),
     /* 412517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 412523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412527 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(412619), // Rule ID 2103 //
     /* 412532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412576 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412580 */     // MIs[3] Operand 1
     /* 412580 */     // No operand predicates
     /* 412580 */     // MIs[1] Operand 2
     /* 412580 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 412591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 412600 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 412603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412617 */     GIR_RootConstrainSelectedInstOperands,
     /* 412618 */     // GIR_Coverage, 2103,
     /* 412618 */     GIR_EraseRootFromParent_Done,
     /* 412619 */   // Label 8489: @412619
     /* 412619 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(412711), // Rule ID 13509 //
     /* 412624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412672 */     // MIs[3] Operand 1
     /* 412672 */     // No operand predicates
     /* 412672 */     // MIs[1] Operand 2
     /* 412672 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 412683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 412692 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 412695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412709 */     GIR_RootConstrainSelectedInstOperands,
     /* 412710 */     // GIR_Coverage, 13509,
     /* 412710 */     GIR_EraseRootFromParent_Done,
     /* 412711 */   // Label 8490: @412711
     /* 412711 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(412797), // Rule ID 13507 //
     /* 412716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412764 */     // MIs[3] Operand 1
     /* 412764 */     // No operand predicates
     /* 412764 */     // MIs[1] Operand 2
     /* 412764 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 412775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412781 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 412784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412795 */     GIR_RootConstrainSelectedInstOperands,
     /* 412796 */     // GIR_Coverage, 13507,
     /* 412796 */     GIR_EraseRootFromParent_Done,
     /* 412797 */   // Label 8491: @412797
     /* 412797 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(412883), // Rule ID 2101 //
     /* 412802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 412817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412850 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412854 */     // MIs[3] Operand 1
     /* 412854 */     // No operand predicates
     /* 412854 */     // MIs[1] Operand 2
     /* 412854 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 412865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412867 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 412870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412881 */     GIR_RootConstrainSelectedInstOperands,
     /* 412882 */     // GIR_Coverage, 2101,
     /* 412882 */     GIR_EraseRootFromParent_Done,
     /* 412883 */   // Label 8492: @412883
     /* 412883 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(412922), // Rule ID 1829 //
     /* 412888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 412898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 412905 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 412905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 412908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 412915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 412920 */     GIR_RootConstrainSelectedInstOperands,
     /* 412921 */     // GIR_Coverage, 1829,
     /* 412921 */     GIR_EraseRootFromParent_Done,
     /* 412922 */   // Label 8493: @412922
     /* 412922 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(412985), // Rule ID 13508 //
     /* 412927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412959 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412963 */     // MIs[2] Operand 1
     /* 412963 */     // No operand predicates
     /* 412963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412969 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 412969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 412972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412983 */     GIR_RootConstrainSelectedInstOperands,
     /* 412984 */     // GIR_Coverage, 13508,
     /* 412984 */     GIR_EraseRootFromParent_Done,
     /* 412985 */   // Label 8494: @412985
     /* 412985 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(413048), // Rule ID 2102 //
     /* 412990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413030 */     // MIs[2] Operand 1
     /* 413030 */     // No operand predicates
     /* 413030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413032 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 413032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 413035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413046 */     GIR_RootConstrainSelectedInstOperands,
     /* 413047 */     // GIR_Coverage, 2102,
     /* 413047 */     GIR_EraseRootFromParent_Done,
     /* 413048 */   // Label 8495: @413048
     /* 413048 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(413071), // Rule ID 1828 //
     /* 413053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413064 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 413069 */     GIR_RootConstrainSelectedInstOperands,
     /* 413070 */     // GIR_Coverage, 1828,
     /* 413070 */     GIR_Done,
     /* 413071 */   // Label 8496: @413071
     /* 413071 */   GIM_Reject,
     /* 413072 */ // Label 8488: @413072
     /* 413072 */ GIM_Reject,
     /* 413073 */ // Label 8477: @413073
     /* 413073 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(413151),
     /* 413078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413088 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(413127), // Rule ID 1827 //
     /* 413093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 413103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 413110 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 413113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 413120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 413125 */     GIR_RootConstrainSelectedInstOperands,
     /* 413126 */     // GIR_Coverage, 1827,
     /* 413126 */     GIR_EraseRootFromParent_Done,
     /* 413127 */   // Label 8498: @413127
     /* 413127 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(413150), // Rule ID 1826 //
     /* 413132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413143 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 413148 */     GIR_RootConstrainSelectedInstOperands,
     /* 413149 */     // GIR_Coverage, 1826,
     /* 413149 */     GIR_Done,
     /* 413150 */   // Label 8499: @413150
     /* 413150 */   GIM_Reject,
     /* 413151 */ // Label 8497: @413151
     /* 413151 */ GIM_Reject,
     /* 413152 */ // Label 8478: @413152
     /* 413152 */ GIM_Reject,
     /* 413153 */ // Label 146: @413153
     /* 413153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8518*/ GIMT_Encode4(413932),
     /* 413164 */ /*GILLT_v2s32*//*Label 8500*/ GIMT_Encode4(413240),
     /* 413168 */ /*GILLT_v2s64*//*Label 8501*/ GIMT_Encode4(413295),
     /* 413172 */ /*GILLT_v4s16*//*Label 8502*/ GIMT_Encode4(413350),
     /* 413176 */ /*GILLT_v4s32*//*Label 8503*/ GIMT_Encode4(413405),
     /* 413180 */ /*GILLT_v8s8*//*Label 8504*/ GIMT_Encode4(413460),
     /* 413184 */ /*GILLT_v8s16*//*Label 8505*/ GIMT_Encode4(413494),
     /* 413188 */ /*GILLT_v16s8*//*Label 8506*/ GIMT_Encode4(413549), GIMT_Encode4(0),
     /* 413196 */ /*GILLT_nxv2s1*//*Label 8507*/ GIMT_Encode4(413583),
     /* 413200 */ /*GILLT_nxv2s16*//*Label 8508*/ GIMT_Encode4(413609),
     /* 413204 */ /*GILLT_nxv2s32*//*Label 8509*/ GIMT_Encode4(413635),
     /* 413208 */ /*GILLT_nxv2s64*//*Label 8510*/ GIMT_Encode4(413661),
     /* 413212 */ /*GILLT_nxv4s1*//*Label 8511*/ GIMT_Encode4(413708),
     /* 413216 */ /*GILLT_nxv4s16*//*Label 8512*/ GIMT_Encode4(413734),
     /* 413220 */ /*GILLT_nxv4s32*//*Label 8513*/ GIMT_Encode4(413760),
     /* 413224 */ /*GILLT_nxv8s1*//*Label 8514*/ GIMT_Encode4(413807),
     /* 413228 */ /*GILLT_nxv8s16*//*Label 8515*/ GIMT_Encode4(413833),
     /* 413232 */ /*GILLT_nxv16s1*//*Label 8516*/ GIMT_Encode4(413880),
     /* 413236 */ /*GILLT_nxv16s8*//*Label 8517*/ GIMT_Encode4(413906),
     /* 413240 */ // Label 8500: @413240
     /* 413240 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(413294),
     /* 413245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413263 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(413278), // Rule ID 1888 //
     /* 413268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413271 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 413271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 413276 */     GIR_RootConstrainSelectedInstOperands,
     /* 413277 */     // GIR_Coverage, 1888,
     /* 413277 */     GIR_Done,
     /* 413278 */   // Label 8520: @413278
     /* 413278 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(413293), // Rule ID 5474 //
     /* 413283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413286 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 413291 */     GIR_RootConstrainSelectedInstOperands,
     /* 413292 */     // GIR_Coverage, 5474,
     /* 413292 */     GIR_Done,
     /* 413293 */   // Label 8521: @413293
     /* 413293 */   GIM_Reject,
     /* 413294 */ // Label 8519: @413294
     /* 413294 */ GIM_Reject,
     /* 413295 */ // Label 8501: @413295
     /* 413295 */ GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(413349),
     /* 413300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413318 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(413333), // Rule ID 1890 //
     /* 413323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413326 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 413326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 413331 */     GIR_RootConstrainSelectedInstOperands,
     /* 413332 */     // GIR_Coverage, 1890,
     /* 413332 */     GIR_Done,
     /* 413333 */   // Label 8523: @413333
     /* 413333 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(413348), // Rule ID 5476 //
     /* 413338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413341 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 413346 */     GIR_RootConstrainSelectedInstOperands,
     /* 413347 */     // GIR_Coverage, 5476,
     /* 413347 */     GIR_Done,
     /* 413348 */   // Label 8524: @413348
     /* 413348 */   GIM_Reject,
     /* 413349 */ // Label 8522: @413349
     /* 413349 */ GIM_Reject,
     /* 413350 */ // Label 8502: @413350
     /* 413350 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(413404),
     /* 413355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413373 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(413388), // Rule ID 1886 //
     /* 413378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413381 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 413386 */     GIR_RootConstrainSelectedInstOperands,
     /* 413387 */     // GIR_Coverage, 1886,
     /* 413387 */     GIR_Done,
     /* 413388 */   // Label 8526: @413388
     /* 413388 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(413403), // Rule ID 5472 //
     /* 413393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413396 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 413401 */     GIR_RootConstrainSelectedInstOperands,
     /* 413402 */     // GIR_Coverage, 5472,
     /* 413402 */     GIR_Done,
     /* 413403 */   // Label 8527: @413403
     /* 413403 */   GIM_Reject,
     /* 413404 */ // Label 8525: @413404
     /* 413404 */ GIM_Reject,
     /* 413405 */ // Label 8503: @413405
     /* 413405 */ GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(413459),
     /* 413410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413428 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(413443), // Rule ID 1889 //
     /* 413433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413436 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 413441 */     GIR_RootConstrainSelectedInstOperands,
     /* 413442 */     // GIR_Coverage, 1889,
     /* 413442 */     GIR_Done,
     /* 413443 */   // Label 8529: @413443
     /* 413443 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(413458), // Rule ID 5475 //
     /* 413448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413451 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 413451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 413456 */     GIR_RootConstrainSelectedInstOperands,
     /* 413457 */     // GIR_Coverage, 5475,
     /* 413457 */     GIR_Done,
     /* 413458 */   // Label 8530: @413458
     /* 413458 */   GIM_Reject,
     /* 413459 */ // Label 8528: @413459
     /* 413459 */ GIM_Reject,
     /* 413460 */ // Label 8504: @413460
     /* 413460 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(413493), // Rule ID 1884 //
     /* 413465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413486 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 413491 */   GIR_RootConstrainSelectedInstOperands,
     /* 413492 */   // GIR_Coverage, 1884,
     /* 413492 */   GIR_Done,
     /* 413493 */ // Label 8531: @413493
     /* 413493 */ GIM_Reject,
     /* 413494 */ // Label 8505: @413494
     /* 413494 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(413548),
     /* 413499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413517 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(413532), // Rule ID 1887 //
     /* 413522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413525 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 413530 */     GIR_RootConstrainSelectedInstOperands,
     /* 413531 */     // GIR_Coverage, 1887,
     /* 413531 */     GIR_Done,
     /* 413532 */   // Label 8533: @413532
     /* 413532 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(413547), // Rule ID 5473 //
     /* 413537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413540 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 413545 */     GIR_RootConstrainSelectedInstOperands,
     /* 413546 */     // GIR_Coverage, 5473,
     /* 413546 */     GIR_Done,
     /* 413547 */   // Label 8534: @413547
     /* 413547 */   GIM_Reject,
     /* 413548 */ // Label 8532: @413548
     /* 413548 */ GIM_Reject,
     /* 413549 */ // Label 8506: @413549
     /* 413549 */ GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(413582), // Rule ID 1885 //
     /* 413554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413575 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 413580 */   GIR_RootConstrainSelectedInstOperands,
     /* 413581 */   // GIR_Coverage, 1885,
     /* 413581 */   GIR_Done,
     /* 413582 */ // Label 8535: @413582
     /* 413582 */ GIM_Reject,
     /* 413583 */ // Label 8507: @413583
     /* 413583 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(413608), // Rule ID 8939 //
     /* 413588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413601 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 413606 */   GIR_RootConstrainSelectedInstOperands,
     /* 413607 */   // GIR_Coverage, 8939,
     /* 413607 */   GIR_Done,
     /* 413608 */ // Label 8536: @413608
     /* 413608 */ GIM_Reject,
     /* 413609 */ // Label 8508: @413609
     /* 413609 */ GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(413634), // Rule ID 8901 //
     /* 413614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 413620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 413623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413627 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 413627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 413632 */   GIR_RootConstrainSelectedInstOperands,
     /* 413633 */   // GIR_Coverage, 8901,
     /* 413633 */   GIR_Done,
     /* 413634 */ // Label 8537: @413634
     /* 413634 */ GIM_Reject,
     /* 413635 */ // Label 8509: @413635
     /* 413635 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(413660), // Rule ID 8902 //
     /* 413640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 413646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 413649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413653 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 413653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 413658 */   GIR_RootConstrainSelectedInstOperands,
     /* 413659 */   // GIR_Coverage, 8902,
     /* 413659 */   GIR_Done,
     /* 413660 */ // Label 8538: @413660
     /* 413660 */ GIM_Reject,
     /* 413661 */ // Label 8510: @413661
     /* 413661 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(413707),
     /* 413666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 413672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413676 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(413691), // Rule ID 8897 //
     /* 413681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413684 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 413684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 413689 */     GIR_RootConstrainSelectedInstOperands,
     /* 413690 */     // GIR_Coverage, 8897,
     /* 413690 */     GIR_Done,
     /* 413691 */   // Label 8540: @413691
     /* 413691 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(413706), // Rule ID 8903 //
     /* 413696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413699 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 413699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 413704 */     GIR_RootConstrainSelectedInstOperands,
     /* 413705 */     // GIR_Coverage, 8903,
     /* 413705 */     GIR_Done,
     /* 413706 */   // Label 8541: @413706
     /* 413706 */   GIM_Reject,
     /* 413707 */ // Label 8539: @413707
     /* 413707 */ GIM_Reject,
     /* 413708 */ // Label 8511: @413708
     /* 413708 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(413733), // Rule ID 8938 //
     /* 413713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 413719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 413722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413726 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 413726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 413731 */   GIR_RootConstrainSelectedInstOperands,
     /* 413732 */   // GIR_Coverage, 8938,
     /* 413732 */   GIR_Done,
     /* 413733 */ // Label 8542: @413733
     /* 413733 */ GIM_Reject,
     /* 413734 */ // Label 8512: @413734
     /* 413734 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(413759), // Rule ID 8899 //
     /* 413739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 413745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 413748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413752 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 413752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 413757 */   GIR_RootConstrainSelectedInstOperands,
     /* 413758 */   // GIR_Coverage, 8899,
     /* 413758 */   GIR_Done,
     /* 413759 */ // Label 8543: @413759
     /* 413759 */ GIM_Reject,
     /* 413760 */ // Label 8513: @413760
     /* 413760 */ GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(413806),
     /* 413765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 413771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413775 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(413790), // Rule ID 8896 //
     /* 413780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413783 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 413783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 413788 */     GIR_RootConstrainSelectedInstOperands,
     /* 413789 */     // GIR_Coverage, 8896,
     /* 413789 */     GIR_Done,
     /* 413790 */   // Label 8545: @413790
     /* 413790 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(413805), // Rule ID 8900 //
     /* 413795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413798 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 413798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 413803 */     GIR_RootConstrainSelectedInstOperands,
     /* 413804 */     // GIR_Coverage, 8900,
     /* 413804 */     GIR_Done,
     /* 413805 */   // Label 8546: @413805
     /* 413805 */   GIM_Reject,
     /* 413806 */ // Label 8544: @413806
     /* 413806 */ GIM_Reject,
     /* 413807 */ // Label 8514: @413807
     /* 413807 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(413832), // Rule ID 8937 //
     /* 413812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 413818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 413821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413825 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 413825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 413830 */   GIR_RootConstrainSelectedInstOperands,
     /* 413831 */   // GIR_Coverage, 8937,
     /* 413831 */   GIR_Done,
     /* 413832 */ // Label 8547: @413832
     /* 413832 */ GIM_Reject,
     /* 413833 */ // Label 8515: @413833
     /* 413833 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(413879),
     /* 413838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 413841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413848 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(413863), // Rule ID 8895 //
     /* 413853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413856 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 413856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 413861 */     GIR_RootConstrainSelectedInstOperands,
     /* 413862 */     // GIR_Coverage, 8895,
     /* 413862 */     GIR_Done,
     /* 413863 */   // Label 8549: @413863
     /* 413863 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(413878), // Rule ID 8898 //
     /* 413868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413871 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 413871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 413876 */     GIR_RootConstrainSelectedInstOperands,
     /* 413877 */     // GIR_Coverage, 8898,
     /* 413877 */     GIR_Done,
     /* 413878 */   // Label 8550: @413878
     /* 413878 */   GIM_Reject,
     /* 413879 */ // Label 8548: @413879
     /* 413879 */ GIM_Reject,
     /* 413880 */ // Label 8516: @413880
     /* 413880 */ GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(413905), // Rule ID 2406 //
     /* 413885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 413891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 413894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413898 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 413898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 413903 */   GIR_RootConstrainSelectedInstOperands,
     /* 413904 */   // GIR_Coverage, 2406,
     /* 413904 */   GIR_Done,
     /* 413905 */ // Label 8551: @413905
     /* 413905 */ GIM_Reject,
     /* 413906 */ // Label 8517: @413906
     /* 413906 */ GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(413931), // Rule ID 8894 //
     /* 413911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 413917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413924 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 413924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 413929 */   GIR_RootConstrainSelectedInstOperands,
     /* 413930 */   // GIR_Coverage, 8894,
     /* 413930 */   GIR_Done,
     /* 413931 */ // Label 8552: @413931
     /* 413931 */ GIM_Reject,
     /* 413932 */ // Label 8518: @413932
     /* 413932 */ GIM_Reject,
     /* 413933 */ // Label 147: @413933
     /* 413933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8571*/ GIMT_Encode4(414712),
     /* 413944 */ /*GILLT_v2s32*//*Label 8553*/ GIMT_Encode4(414020),
     /* 413948 */ /*GILLT_v2s64*//*Label 8554*/ GIMT_Encode4(414075),
     /* 413952 */ /*GILLT_v4s16*//*Label 8555*/ GIMT_Encode4(414130),
     /* 413956 */ /*GILLT_v4s32*//*Label 8556*/ GIMT_Encode4(414185),
     /* 413960 */ /*GILLT_v8s8*//*Label 8557*/ GIMT_Encode4(414240),
     /* 413964 */ /*GILLT_v8s16*//*Label 8558*/ GIMT_Encode4(414274),
     /* 413968 */ /*GILLT_v16s8*//*Label 8559*/ GIMT_Encode4(414329), GIMT_Encode4(0),
     /* 413976 */ /*GILLT_nxv2s1*//*Label 8560*/ GIMT_Encode4(414363),
     /* 413980 */ /*GILLT_nxv2s16*//*Label 8561*/ GIMT_Encode4(414389),
     /* 413984 */ /*GILLT_nxv2s32*//*Label 8562*/ GIMT_Encode4(414415),
     /* 413988 */ /*GILLT_nxv2s64*//*Label 8563*/ GIMT_Encode4(414441),
     /* 413992 */ /*GILLT_nxv4s1*//*Label 8564*/ GIMT_Encode4(414488),
     /* 413996 */ /*GILLT_nxv4s16*//*Label 8565*/ GIMT_Encode4(414514),
     /* 414000 */ /*GILLT_nxv4s32*//*Label 8566*/ GIMT_Encode4(414540),
     /* 414004 */ /*GILLT_nxv8s1*//*Label 8567*/ GIMT_Encode4(414587),
     /* 414008 */ /*GILLT_nxv8s16*//*Label 8568*/ GIMT_Encode4(414613),
     /* 414012 */ /*GILLT_nxv16s1*//*Label 8569*/ GIMT_Encode4(414660),
     /* 414016 */ /*GILLT_nxv16s8*//*Label 8570*/ GIMT_Encode4(414686),
     /* 414020 */ // Label 8553: @414020
     /* 414020 */ GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(414074),
     /* 414025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 414031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414043 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(414058), // Rule ID 1895 //
     /* 414048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414051 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 414056 */     GIR_RootConstrainSelectedInstOperands,
     /* 414057 */     // GIR_Coverage, 1895,
     /* 414057 */     GIR_Done,
     /* 414058 */   // Label 8573: @414058
     /* 414058 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(414073), // Rule ID 5479 //
     /* 414063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414066 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 414066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 414071 */     GIR_RootConstrainSelectedInstOperands,
     /* 414072 */     // GIR_Coverage, 5479,
     /* 414072 */     GIR_Done,
     /* 414073 */   // Label 8574: @414073
     /* 414073 */   GIM_Reject,
     /* 414074 */ // Label 8572: @414074
     /* 414074 */ GIM_Reject,
     /* 414075 */ // Label 8554: @414075
     /* 414075 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(414129),
     /* 414080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 414086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414098 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(414113), // Rule ID 1897 //
     /* 414103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414106 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 414106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 414111 */     GIR_RootConstrainSelectedInstOperands,
     /* 414112 */     // GIR_Coverage, 1897,
     /* 414112 */     GIR_Done,
     /* 414113 */   // Label 8576: @414113
     /* 414113 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(414128), // Rule ID 5481 //
     /* 414118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414121 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 414126 */     GIR_RootConstrainSelectedInstOperands,
     /* 414127 */     // GIR_Coverage, 5481,
     /* 414127 */     GIR_Done,
     /* 414128 */   // Label 8577: @414128
     /* 414128 */   GIM_Reject,
     /* 414129 */ // Label 8575: @414129
     /* 414129 */ GIM_Reject,
     /* 414130 */ // Label 8555: @414130
     /* 414130 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(414184),
     /* 414135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414153 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(414168), // Rule ID 1893 //
     /* 414158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414161 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 414166 */     GIR_RootConstrainSelectedInstOperands,
     /* 414167 */     // GIR_Coverage, 1893,
     /* 414167 */     GIR_Done,
     /* 414168 */   // Label 8579: @414168
     /* 414168 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(414183), // Rule ID 5477 //
     /* 414173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414176 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 414181 */     GIR_RootConstrainSelectedInstOperands,
     /* 414182 */     // GIR_Coverage, 5477,
     /* 414182 */     GIR_Done,
     /* 414183 */   // Label 8580: @414183
     /* 414183 */   GIM_Reject,
     /* 414184 */ // Label 8578: @414184
     /* 414184 */ GIM_Reject,
     /* 414185 */ // Label 8556: @414185
     /* 414185 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(414239),
     /* 414190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414208 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(414223), // Rule ID 1896 //
     /* 414213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414216 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 414216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 414221 */     GIR_RootConstrainSelectedInstOperands,
     /* 414222 */     // GIR_Coverage, 1896,
     /* 414222 */     GIR_Done,
     /* 414223 */   // Label 8582: @414223
     /* 414223 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(414238), // Rule ID 5480 //
     /* 414228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414231 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 414236 */     GIR_RootConstrainSelectedInstOperands,
     /* 414237 */     // GIR_Coverage, 5480,
     /* 414237 */     GIR_Done,
     /* 414238 */   // Label 8583: @414238
     /* 414238 */   GIM_Reject,
     /* 414239 */ // Label 8581: @414239
     /* 414239 */ GIM_Reject,
     /* 414240 */ // Label 8557: @414240
     /* 414240 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(414273), // Rule ID 1891 //
     /* 414245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414266 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 414266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 414271 */   GIR_RootConstrainSelectedInstOperands,
     /* 414272 */   // GIR_Coverage, 1891,
     /* 414272 */   GIR_Done,
     /* 414273 */ // Label 8584: @414273
     /* 414273 */ GIM_Reject,
     /* 414274 */ // Label 8558: @414274
     /* 414274 */ GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(414328),
     /* 414279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 414285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414297 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(414312), // Rule ID 1894 //
     /* 414302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414305 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 414305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 414310 */     GIR_RootConstrainSelectedInstOperands,
     /* 414311 */     // GIR_Coverage, 1894,
     /* 414311 */     GIR_Done,
     /* 414312 */   // Label 8586: @414312
     /* 414312 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(414327), // Rule ID 5478 //
     /* 414317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414320 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 414320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 414325 */     GIR_RootConstrainSelectedInstOperands,
     /* 414326 */     // GIR_Coverage, 5478,
     /* 414326 */     GIR_Done,
     /* 414327 */   // Label 8587: @414327
     /* 414327 */   GIM_Reject,
     /* 414328 */ // Label 8585: @414328
     /* 414328 */ GIM_Reject,
     /* 414329 */ // Label 8559: @414329
     /* 414329 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(414362), // Rule ID 1892 //
     /* 414334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 414340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 414343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414355 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 414355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 414360 */   GIR_RootConstrainSelectedInstOperands,
     /* 414361 */   // GIR_Coverage, 1892,
     /* 414361 */   GIR_Done,
     /* 414362 */ // Label 8588: @414362
     /* 414362 */ GIM_Reject,
     /* 414363 */ // Label 8560: @414363
     /* 414363 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(414388), // Rule ID 8942 //
     /* 414368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 414374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 414377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414381 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 414381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 414386 */   GIR_RootConstrainSelectedInstOperands,
     /* 414387 */   // GIR_Coverage, 8942,
     /* 414387 */   GIR_Done,
     /* 414388 */ // Label 8589: @414388
     /* 414388 */ GIM_Reject,
     /* 414389 */ // Label 8561: @414389
     /* 414389 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(414414), // Rule ID 8911 //
     /* 414394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 414400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 414403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414407 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 414407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 414412 */   GIR_RootConstrainSelectedInstOperands,
     /* 414413 */   // GIR_Coverage, 8911,
     /* 414413 */   GIR_Done,
     /* 414414 */ // Label 8590: @414414
     /* 414414 */ GIM_Reject,
     /* 414415 */ // Label 8562: @414415
     /* 414415 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(414440), // Rule ID 8912 //
     /* 414420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 414426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 414429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414433 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 414433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 414438 */   GIR_RootConstrainSelectedInstOperands,
     /* 414439 */   // GIR_Coverage, 8912,
     /* 414439 */   GIR_Done,
     /* 414440 */ // Label 8591: @414440
     /* 414440 */ GIM_Reject,
     /* 414441 */ // Label 8563: @414441
     /* 414441 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(414487),
     /* 414446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 414449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 414452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414456 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(414471), // Rule ID 8907 //
     /* 414461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414464 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 414464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 414469 */     GIR_RootConstrainSelectedInstOperands,
     /* 414470 */     // GIR_Coverage, 8907,
     /* 414470 */     GIR_Done,
     /* 414471 */   // Label 8593: @414471
     /* 414471 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(414486), // Rule ID 8913 //
     /* 414476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414479 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 414479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 414484 */     GIR_RootConstrainSelectedInstOperands,
     /* 414485 */     // GIR_Coverage, 8913,
     /* 414485 */     GIR_Done,
     /* 414486 */   // Label 8594: @414486
     /* 414486 */   GIM_Reject,
     /* 414487 */ // Label 8592: @414487
     /* 414487 */ GIM_Reject,
     /* 414488 */ // Label 8564: @414488
     /* 414488 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(414513), // Rule ID 8941 //
     /* 414493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 414499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 414502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414506 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 414506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 414511 */   GIR_RootConstrainSelectedInstOperands,
     /* 414512 */   // GIR_Coverage, 8941,
     /* 414512 */   GIR_Done,
     /* 414513 */ // Label 8595: @414513
     /* 414513 */ GIM_Reject,
     /* 414514 */ // Label 8565: @414514
     /* 414514 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(414539), // Rule ID 8909 //
     /* 414519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 414525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 414528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414532 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 414532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 414537 */   GIR_RootConstrainSelectedInstOperands,
     /* 414538 */   // GIR_Coverage, 8909,
     /* 414538 */   GIR_Done,
     /* 414539 */ // Label 8596: @414539
     /* 414539 */ GIM_Reject,
     /* 414540 */ // Label 8566: @414540
     /* 414540 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(414586),
     /* 414545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 414548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 414551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414555 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(414570), // Rule ID 8906 //
     /* 414560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414563 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 414563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 414568 */     GIR_RootConstrainSelectedInstOperands,
     /* 414569 */     // GIR_Coverage, 8906,
     /* 414569 */     GIR_Done,
     /* 414570 */   // Label 8598: @414570
     /* 414570 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(414585), // Rule ID 8910 //
     /* 414575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414578 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 414578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 414583 */     GIR_RootConstrainSelectedInstOperands,
     /* 414584 */     // GIR_Coverage, 8910,
     /* 414584 */     GIR_Done,
     /* 414585 */   // Label 8599: @414585
     /* 414585 */   GIM_Reject,
     /* 414586 */ // Label 8597: @414586
     /* 414586 */ GIM_Reject,
     /* 414587 */ // Label 8567: @414587
     /* 414587 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(414612), // Rule ID 8940 //
     /* 414592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 414598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 414601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414605 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 414605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 414610 */   GIR_RootConstrainSelectedInstOperands,
     /* 414611 */   // GIR_Coverage, 8940,
     /* 414611 */   GIR_Done,
     /* 414612 */ // Label 8600: @414612
     /* 414612 */ GIM_Reject,
     /* 414613 */ // Label 8568: @414613
     /* 414613 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(414659),
     /* 414618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 414621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 414624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414628 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(414643), // Rule ID 8905 //
     /* 414633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414636 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 414636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 414641 */     GIR_RootConstrainSelectedInstOperands,
     /* 414642 */     // GIR_Coverage, 8905,
     /* 414642 */     GIR_Done,
     /* 414643 */   // Label 8602: @414643
     /* 414643 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(414658), // Rule ID 8908 //
     /* 414648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414651 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 414651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 414656 */     GIR_RootConstrainSelectedInstOperands,
     /* 414657 */     // GIR_Coverage, 8908,
     /* 414657 */     GIR_Done,
     /* 414658 */   // Label 8603: @414658
     /* 414658 */   GIM_Reject,
     /* 414659 */ // Label 8601: @414659
     /* 414659 */ GIM_Reject,
     /* 414660 */ // Label 8569: @414660
     /* 414660 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(414685), // Rule ID 2410 //
     /* 414665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 414671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 414674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414678 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 414678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 414683 */   GIR_RootConstrainSelectedInstOperands,
     /* 414684 */   // GIR_Coverage, 2410,
     /* 414684 */   GIR_Done,
     /* 414685 */ // Label 8604: @414685
     /* 414685 */ GIM_Reject,
     /* 414686 */ // Label 8570: @414686
     /* 414686 */ GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(414711), // Rule ID 8904 //
     /* 414691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 414697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 414700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414704 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 414704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 414709 */   GIR_RootConstrainSelectedInstOperands,
     /* 414710 */   // GIR_Coverage, 8904,
     /* 414710 */   GIR_Done,
     /* 414711 */ // Label 8605: @414711
     /* 414711 */ GIM_Reject,
     /* 414712 */ // Label 8571: @414712
     /* 414712 */ GIM_Reject,
     /* 414713 */ // Label 148: @414713
     /* 414713 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8614*/ GIMT_Encode4(415410),
     /* 414724 */ /*GILLT_s64*//*Label 8606*/ GIMT_Encode4(414760), GIMT_Encode4(0),
     /* 414732 */ /*GILLT_v2s32*//*Label 8607*/ GIMT_Encode4(414871),
     /* 414736 */ /*GILLT_v2s64*//*Label 8608*/ GIMT_Encode4(414948),
     /* 414740 */ /*GILLT_v4s16*//*Label 8609*/ GIMT_Encode4(415025),
     /* 414744 */ /*GILLT_v4s32*//*Label 8610*/ GIMT_Encode4(415102),
     /* 414748 */ /*GILLT_v8s8*//*Label 8611*/ GIMT_Encode4(415179),
     /* 414752 */ /*GILLT_v8s16*//*Label 8612*/ GIMT_Encode4(415256),
     /* 414756 */ /*GILLT_v16s8*//*Label 8613*/ GIMT_Encode4(415333),
     /* 414760 */ // Label 8606: @414760
     /* 414760 */ GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(414870),
     /* 414765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 414768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414776 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(414801), // Rule ID 5251 //
     /* 414781 */     // MIs[0] Operand 2
     /* 414781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 414792 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 414792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 414795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414799 */     GIR_RootConstrainSelectedInstOperands,
     /* 414800 */     // GIR_Coverage, 5251,
     /* 414800 */     GIR_EraseRootFromParent_Done,
     /* 414801 */   // Label 8616: @414801
     /* 414801 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(414835), // Rule ID 2120 //
     /* 414806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414809 */     // MIs[0] imm
     /* 414809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 414821 */     // MIs[1] Operand 1
     /* 414821 */     // No operand predicates
     /* 414821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414823 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 414823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 414826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 414833 */     GIR_RootConstrainSelectedInstOperands,
     /* 414834 */     // GIR_Coverage, 2120,
     /* 414834 */     GIR_EraseRootFromParent_Done,
     /* 414835 */   // Label 8617: @414835
     /* 414835 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(414869), // Rule ID 6289 //
     /* 414840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414843 */     // MIs[0] imm
     /* 414843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 414855 */     // MIs[1] Operand 1
     /* 414855 */     // No operand predicates
     /* 414855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414857 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 414857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 414860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 414867 */     GIR_RootConstrainSelectedInstOperands,
     /* 414868 */     // GIR_Coverage, 6289,
     /* 414868 */     GIR_EraseRootFromParent_Done,
     /* 414869 */   // Label 8618: @414869
     /* 414869 */   GIM_Reject,
     /* 414870 */ // Label 8615: @414870
     /* 414870 */ GIM_Reject,
     /* 414871 */ // Label 8607: @414871
     /* 414871 */ GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(414947),
     /* 414876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414887 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(414912), // Rule ID 4892 //
     /* 414892 */     // MIs[0] Operand 2
     /* 414892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 414903 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 414903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 414906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414910 */     GIR_RootConstrainSelectedInstOperands,
     /* 414911 */     // GIR_Coverage, 4892,
     /* 414911 */     GIR_EraseRootFromParent_Done,
     /* 414912 */   // Label 8620: @414912
     /* 414912 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(414946), // Rule ID 2227 //
     /* 414917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414920 */     // MIs[0] imm
     /* 414920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 414932 */     // MIs[1] Operand 1
     /* 414932 */     // No operand predicates
     /* 414932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414934 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 414934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 414937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 414944 */     GIR_RootConstrainSelectedInstOperands,
     /* 414945 */     // GIR_Coverage, 2227,
     /* 414945 */     GIR_EraseRootFromParent_Done,
     /* 414946 */   // Label 8621: @414946
     /* 414946 */   GIM_Reject,
     /* 414947 */ // Label 8619: @414947
     /* 414947 */ GIM_Reject,
     /* 414948 */ // Label 8608: @414948
     /* 414948 */ GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(415024),
     /* 414953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414964 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(414989), // Rule ID 4896 //
     /* 414969 */     // MIs[0] Operand 2
     /* 414969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 414980 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 414980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 414983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 414985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414987 */     GIR_RootConstrainSelectedInstOperands,
     /* 414988 */     // GIR_Coverage, 4896,
     /* 414988 */     GIR_EraseRootFromParent_Done,
     /* 414989 */   // Label 8623: @414989
     /* 414989 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(415023), // Rule ID 2229 //
     /* 414994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414997 */     // MIs[0] imm
     /* 414997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 415009 */     // MIs[1] Operand 1
     /* 415009 */     // No operand predicates
     /* 415009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415011 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 415014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415021 */     GIR_RootConstrainSelectedInstOperands,
     /* 415022 */     // GIR_Coverage, 2229,
     /* 415022 */     GIR_EraseRootFromParent_Done,
     /* 415023 */   // Label 8624: @415023
     /* 415023 */   GIM_Reject,
     /* 415024 */ // Label 8622: @415024
     /* 415024 */ GIM_Reject,
     /* 415025 */ // Label 8609: @415025
     /* 415025 */ GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(415101),
     /* 415030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415041 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(415066), // Rule ID 4891 //
     /* 415046 */     // MIs[0] Operand 2
     /* 415046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 415057 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 415057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 415060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415064 */     GIR_RootConstrainSelectedInstOperands,
     /* 415065 */     // GIR_Coverage, 4891,
     /* 415065 */     GIR_EraseRootFromParent_Done,
     /* 415066 */   // Label 8626: @415066
     /* 415066 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(415100), // Rule ID 2225 //
     /* 415071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415074 */     // MIs[0] imm
     /* 415074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 415086 */     // MIs[1] Operand 1
     /* 415086 */     // No operand predicates
     /* 415086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415088 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 415091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415098 */     GIR_RootConstrainSelectedInstOperands,
     /* 415099 */     // GIR_Coverage, 2225,
     /* 415099 */     GIR_EraseRootFromParent_Done,
     /* 415100 */   // Label 8627: @415100
     /* 415100 */   GIM_Reject,
     /* 415101 */ // Label 8625: @415101
     /* 415101 */ GIM_Reject,
     /* 415102 */ // Label 8610: @415102
     /* 415102 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(415178),
     /* 415107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415118 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(415143), // Rule ID 4895 //
     /* 415123 */     // MIs[0] Operand 2
     /* 415123 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 415134 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 415134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 415137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415141 */     GIR_RootConstrainSelectedInstOperands,
     /* 415142 */     // GIR_Coverage, 4895,
     /* 415142 */     GIR_EraseRootFromParent_Done,
     /* 415143 */   // Label 8629: @415143
     /* 415143 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(415177), // Rule ID 2228 //
     /* 415148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415151 */     // MIs[0] imm
     /* 415151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 415163 */     // MIs[1] Operand 1
     /* 415163 */     // No operand predicates
     /* 415163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415165 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 415168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415175 */     GIR_RootConstrainSelectedInstOperands,
     /* 415176 */     // GIR_Coverage, 2228,
     /* 415176 */     GIR_EraseRootFromParent_Done,
     /* 415177 */   // Label 8630: @415177
     /* 415177 */   GIM_Reject,
     /* 415178 */ // Label 8628: @415178
     /* 415178 */ GIM_Reject,
     /* 415179 */ // Label 8611: @415179
     /* 415179 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(415255),
     /* 415184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 415187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415195 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(415220), // Rule ID 4890 //
     /* 415200 */     // MIs[0] Operand 2
     /* 415200 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 415211 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 415211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 415214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415218 */     GIR_RootConstrainSelectedInstOperands,
     /* 415219 */     // GIR_Coverage, 4890,
     /* 415219 */     GIR_EraseRootFromParent_Done,
     /* 415220 */   // Label 8632: @415220
     /* 415220 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(415254), // Rule ID 2223 //
     /* 415225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415228 */     // MIs[0] imm
     /* 415228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 415240 */     // MIs[1] Operand 1
     /* 415240 */     // No operand predicates
     /* 415240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415242 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 415245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415252 */     GIR_RootConstrainSelectedInstOperands,
     /* 415253 */     // GIR_Coverage, 2223,
     /* 415253 */     GIR_EraseRootFromParent_Done,
     /* 415254 */   // Label 8633: @415254
     /* 415254 */   GIM_Reject,
     /* 415255 */ // Label 8631: @415255
     /* 415255 */ GIM_Reject,
     /* 415256 */ // Label 8612: @415256
     /* 415256 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(415332),
     /* 415261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415272 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(415297), // Rule ID 4894 //
     /* 415277 */     // MIs[0] Operand 2
     /* 415277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 415288 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 415288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 415291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415295 */     GIR_RootConstrainSelectedInstOperands,
     /* 415296 */     // GIR_Coverage, 4894,
     /* 415296 */     GIR_EraseRootFromParent_Done,
     /* 415297 */   // Label 8635: @415297
     /* 415297 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(415331), // Rule ID 2226 //
     /* 415302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415305 */     // MIs[0] imm
     /* 415305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 415317 */     // MIs[1] Operand 1
     /* 415317 */     // No operand predicates
     /* 415317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415319 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 415322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415329 */     GIR_RootConstrainSelectedInstOperands,
     /* 415330 */     // GIR_Coverage, 2226,
     /* 415330 */     GIR_EraseRootFromParent_Done,
     /* 415331 */   // Label 8636: @415331
     /* 415331 */   GIM_Reject,
     /* 415332 */ // Label 8634: @415332
     /* 415332 */ GIM_Reject,
     /* 415333 */ // Label 8613: @415333
     /* 415333 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(415409),
     /* 415338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415349 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(415374), // Rule ID 4893 //
     /* 415354 */     // MIs[0] Operand 2
     /* 415354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 415365 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 415365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 415368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415372 */     GIR_RootConstrainSelectedInstOperands,
     /* 415373 */     // GIR_Coverage, 4893,
     /* 415373 */     GIR_EraseRootFromParent_Done,
     /* 415374 */   // Label 8638: @415374
     /* 415374 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(415408), // Rule ID 2224 //
     /* 415379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415382 */     // MIs[0] imm
     /* 415382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 415394 */     // MIs[1] Operand 1
     /* 415394 */     // No operand predicates
     /* 415394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415396 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 415399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415406 */     GIR_RootConstrainSelectedInstOperands,
     /* 415407 */     // GIR_Coverage, 2224,
     /* 415407 */     GIR_EraseRootFromParent_Done,
     /* 415408 */   // Label 8639: @415408
     /* 415408 */   GIM_Reject,
     /* 415409 */ // Label 8637: @415409
     /* 415409 */ GIM_Reject,
     /* 415410 */ // Label 8614: @415410
     /* 415410 */ GIM_Reject,
     /* 415411 */ // Label 149: @415411
     /* 415411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8648*/ GIMT_Encode4(415866),
     /* 415422 */ /*GILLT_s64*//*Label 8640*/ GIMT_Encode4(415458), GIMT_Encode4(0),
     /* 415430 */ /*GILLT_v2s32*//*Label 8641*/ GIMT_Encode4(415544),
     /* 415434 */ /*GILLT_v2s64*//*Label 8642*/ GIMT_Encode4(415590),
     /* 415438 */ /*GILLT_v4s16*//*Label 8643*/ GIMT_Encode4(415636),
     /* 415442 */ /*GILLT_v4s32*//*Label 8644*/ GIMT_Encode4(415682),
     /* 415446 */ /*GILLT_v8s8*//*Label 8645*/ GIMT_Encode4(415728),
     /* 415450 */ /*GILLT_v8s16*//*Label 8646*/ GIMT_Encode4(415774),
     /* 415454 */ /*GILLT_v16s8*//*Label 8647*/ GIMT_Encode4(415820),
     /* 415458 */ // Label 8640: @415458
     /* 415458 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(415543),
     /* 415463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 415466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415474 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(415508), // Rule ID 2129 //
     /* 415479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415482 */     // MIs[0] imm
     /* 415482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 415494 */     // MIs[1] Operand 1
     /* 415494 */     // No operand predicates
     /* 415494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415496 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 415499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415506 */     GIR_RootConstrainSelectedInstOperands,
     /* 415507 */     // GIR_Coverage, 2129,
     /* 415507 */     GIR_EraseRootFromParent_Done,
     /* 415508 */   // Label 8650: @415508
     /* 415508 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(415542), // Rule ID 6292 //
     /* 415513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415516 */     // MIs[0] imm
     /* 415516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 415528 */     // MIs[1] Operand 1
     /* 415528 */     // No operand predicates
     /* 415528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415530 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 415530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 415533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415540 */     GIR_RootConstrainSelectedInstOperands,
     /* 415541 */     // GIR_Coverage, 6292,
     /* 415541 */     GIR_EraseRootFromParent_Done,
     /* 415542 */   // Label 8651: @415542
     /* 415542 */   GIM_Reject,
     /* 415543 */ // Label 8649: @415543
     /* 415543 */ GIM_Reject,
     /* 415544 */ // Label 8641: @415544
     /* 415544 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(415589), // Rule ID 2286 //
     /* 415549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415563 */   // MIs[0] imm
     /* 415563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415571 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 415575 */   // MIs[1] Operand 1
     /* 415575 */   // No operand predicates
     /* 415575 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415577 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 415580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415582 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415584 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415587 */   GIR_RootConstrainSelectedInstOperands,
     /* 415588 */   // GIR_Coverage, 2286,
     /* 415588 */   GIR_EraseRootFromParent_Done,
     /* 415589 */ // Label 8652: @415589
     /* 415589 */ GIM_Reject,
     /* 415590 */ // Label 8642: @415590
     /* 415590 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(415635), // Rule ID 2288 //
     /* 415595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 415601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415609 */   // MIs[0] imm
     /* 415609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415617 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 415621 */   // MIs[1] Operand 1
     /* 415621 */   // No operand predicates
     /* 415621 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415623 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 415626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415628 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415630 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415633 */   GIR_RootConstrainSelectedInstOperands,
     /* 415634 */   // GIR_Coverage, 2288,
     /* 415634 */   GIR_EraseRootFromParent_Done,
     /* 415635 */ // Label 8653: @415635
     /* 415635 */ GIM_Reject,
     /* 415636 */ // Label 8643: @415636
     /* 415636 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(415681), // Rule ID 2284 //
     /* 415641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 415647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415655 */   // MIs[0] imm
     /* 415655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415663 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 415667 */   // MIs[1] Operand 1
     /* 415667 */   // No operand predicates
     /* 415667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415669 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 415672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415674 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415676 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415679 */   GIR_RootConstrainSelectedInstOperands,
     /* 415680 */   // GIR_Coverage, 2284,
     /* 415680 */   GIR_EraseRootFromParent_Done,
     /* 415681 */ // Label 8654: @415681
     /* 415681 */ GIM_Reject,
     /* 415682 */ // Label 8644: @415682
     /* 415682 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(415727), // Rule ID 2287 //
     /* 415687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415701 */   // MIs[0] imm
     /* 415701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415709 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 415713 */   // MIs[1] Operand 1
     /* 415713 */   // No operand predicates
     /* 415713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415715 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 415718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415722 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415725 */   GIR_RootConstrainSelectedInstOperands,
     /* 415726 */   // GIR_Coverage, 2287,
     /* 415726 */   GIR_EraseRootFromParent_Done,
     /* 415727 */ // Label 8655: @415727
     /* 415727 */ GIM_Reject,
     /* 415728 */ // Label 8645: @415728
     /* 415728 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(415773), // Rule ID 2282 //
     /* 415733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 415739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415747 */   // MIs[0] imm
     /* 415747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415755 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 415759 */   // MIs[1] Operand 1
     /* 415759 */   // No operand predicates
     /* 415759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415761 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 415764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415766 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415768 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415771 */   GIR_RootConstrainSelectedInstOperands,
     /* 415772 */   // GIR_Coverage, 2282,
     /* 415772 */   GIR_EraseRootFromParent_Done,
     /* 415773 */ // Label 8656: @415773
     /* 415773 */ GIM_Reject,
     /* 415774 */ // Label 8646: @415774
     /* 415774 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(415819), // Rule ID 2285 //
     /* 415779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415793 */   // MIs[0] imm
     /* 415793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415801 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 415805 */   // MIs[1] Operand 1
     /* 415805 */   // No operand predicates
     /* 415805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415807 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 415810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415812 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415817 */   GIR_RootConstrainSelectedInstOperands,
     /* 415818 */   // GIR_Coverage, 2285,
     /* 415818 */   GIR_EraseRootFromParent_Done,
     /* 415819 */ // Label 8657: @415819
     /* 415819 */ GIM_Reject,
     /* 415820 */ // Label 8647: @415820
     /* 415820 */ GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(415865), // Rule ID 2283 //
     /* 415825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 415831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415839 */   // MIs[0] imm
     /* 415839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415847 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 415851 */   // MIs[1] Operand 1
     /* 415851 */   // No operand predicates
     /* 415851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415853 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 415853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 415856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 415858 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415860 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 415863 */   GIR_RootConstrainSelectedInstOperands,
     /* 415864 */   // GIR_Coverage, 2283,
     /* 415864 */   GIR_EraseRootFromParent_Done,
     /* 415865 */ // Label 8658: @415865
     /* 415865 */ GIM_Reject,
     /* 415866 */ // Label 8648: @415866
     /* 415866 */ GIM_Reject,
     /* 415867 */ // Label 150: @415867
     /* 415867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8677*/ GIMT_Encode4(416646),
     /* 415878 */ /*GILLT_v2s32*//*Label 8659*/ GIMT_Encode4(415954),
     /* 415882 */ /*GILLT_v2s64*//*Label 8660*/ GIMT_Encode4(416009),
     /* 415886 */ /*GILLT_v4s16*//*Label 8661*/ GIMT_Encode4(416064),
     /* 415890 */ /*GILLT_v4s32*//*Label 8662*/ GIMT_Encode4(416119),
     /* 415894 */ /*GILLT_v8s8*//*Label 8663*/ GIMT_Encode4(416174),
     /* 415898 */ /*GILLT_v8s16*//*Label 8664*/ GIMT_Encode4(416208),
     /* 415902 */ /*GILLT_v16s8*//*Label 8665*/ GIMT_Encode4(416263), GIMT_Encode4(0),
     /* 415910 */ /*GILLT_nxv2s1*//*Label 8666*/ GIMT_Encode4(416297),
     /* 415914 */ /*GILLT_nxv2s16*//*Label 8667*/ GIMT_Encode4(416323),
     /* 415918 */ /*GILLT_nxv2s32*//*Label 8668*/ GIMT_Encode4(416349),
     /* 415922 */ /*GILLT_nxv2s64*//*Label 8669*/ GIMT_Encode4(416375),
     /* 415926 */ /*GILLT_nxv4s1*//*Label 8670*/ GIMT_Encode4(416422),
     /* 415930 */ /*GILLT_nxv4s16*//*Label 8671*/ GIMT_Encode4(416448),
     /* 415934 */ /*GILLT_nxv4s32*//*Label 8672*/ GIMT_Encode4(416474),
     /* 415938 */ /*GILLT_nxv8s1*//*Label 8673*/ GIMT_Encode4(416521),
     /* 415942 */ /*GILLT_nxv8s16*//*Label 8674*/ GIMT_Encode4(416547),
     /* 415946 */ /*GILLT_nxv16s1*//*Label 8675*/ GIMT_Encode4(416594),
     /* 415950 */ /*GILLT_nxv16s8*//*Label 8676*/ GIMT_Encode4(416620),
     /* 415954 */ // Label 8659: @415954
     /* 415954 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(416008),
     /* 415959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 415962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 415965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 415977 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(415992), // Rule ID 1902 //
     /* 415982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415985 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 415985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 415990 */     GIR_RootConstrainSelectedInstOperands,
     /* 415991 */     // GIR_Coverage, 1902,
     /* 415991 */     GIR_Done,
     /* 415992 */   // Label 8679: @415992
     /* 415992 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(416007), // Rule ID 5484 //
     /* 415997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416000 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 416000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 416005 */     GIR_RootConstrainSelectedInstOperands,
     /* 416006 */     // GIR_Coverage, 5484,
     /* 416006 */     GIR_Done,
     /* 416007 */   // Label 8680: @416007
     /* 416007 */   GIM_Reject,
     /* 416008 */ // Label 8678: @416008
     /* 416008 */ GIM_Reject,
     /* 416009 */ // Label 8660: @416009
     /* 416009 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(416063),
     /* 416014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 416020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416032 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(416047), // Rule ID 1904 //
     /* 416037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416040 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 416040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 416045 */     GIR_RootConstrainSelectedInstOperands,
     /* 416046 */     // GIR_Coverage, 1904,
     /* 416046 */     GIR_Done,
     /* 416047 */   // Label 8682: @416047
     /* 416047 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(416062), // Rule ID 5486 //
     /* 416052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416055 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 416055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 416060 */     GIR_RootConstrainSelectedInstOperands,
     /* 416061 */     // GIR_Coverage, 5486,
     /* 416061 */     GIR_Done,
     /* 416062 */   // Label 8683: @416062
     /* 416062 */   GIM_Reject,
     /* 416063 */ // Label 8681: @416063
     /* 416063 */ GIM_Reject,
     /* 416064 */ // Label 8661: @416064
     /* 416064 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(416118),
     /* 416069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 416075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416087 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(416102), // Rule ID 1900 //
     /* 416092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416095 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 416095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 416100 */     GIR_RootConstrainSelectedInstOperands,
     /* 416101 */     // GIR_Coverage, 1900,
     /* 416101 */     GIR_Done,
     /* 416102 */   // Label 8685: @416102
     /* 416102 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(416117), // Rule ID 5482 //
     /* 416107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416110 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 416110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 416115 */     GIR_RootConstrainSelectedInstOperands,
     /* 416116 */     // GIR_Coverage, 5482,
     /* 416116 */     GIR_Done,
     /* 416117 */   // Label 8686: @416117
     /* 416117 */   GIM_Reject,
     /* 416118 */ // Label 8684: @416118
     /* 416118 */ GIM_Reject,
     /* 416119 */ // Label 8662: @416119
     /* 416119 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(416173),
     /* 416124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 416130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416142 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(416157), // Rule ID 1903 //
     /* 416147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416150 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 416150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 416155 */     GIR_RootConstrainSelectedInstOperands,
     /* 416156 */     // GIR_Coverage, 1903,
     /* 416156 */     GIR_Done,
     /* 416157 */   // Label 8688: @416157
     /* 416157 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(416172), // Rule ID 5485 //
     /* 416162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416165 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 416170 */     GIR_RootConstrainSelectedInstOperands,
     /* 416171 */     // GIR_Coverage, 5485,
     /* 416171 */     GIR_Done,
     /* 416172 */   // Label 8689: @416172
     /* 416172 */   GIM_Reject,
     /* 416173 */ // Label 8687: @416173
     /* 416173 */ GIM_Reject,
     /* 416174 */ // Label 8663: @416174
     /* 416174 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(416207), // Rule ID 1898 //
     /* 416179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 416185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 416188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416200 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 416200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 416205 */   GIR_RootConstrainSelectedInstOperands,
     /* 416206 */   // GIR_Coverage, 1898,
     /* 416206 */   GIR_Done,
     /* 416207 */ // Label 8690: @416207
     /* 416207 */ GIM_Reject,
     /* 416208 */ // Label 8664: @416208
     /* 416208 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(416262),
     /* 416213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 416219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416231 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(416246), // Rule ID 1901 //
     /* 416236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416239 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 416239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 416244 */     GIR_RootConstrainSelectedInstOperands,
     /* 416245 */     // GIR_Coverage, 1901,
     /* 416245 */     GIR_Done,
     /* 416246 */   // Label 8692: @416246
     /* 416246 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(416261), // Rule ID 5483 //
     /* 416251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416254 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 416259 */     GIR_RootConstrainSelectedInstOperands,
     /* 416260 */     // GIR_Coverage, 5483,
     /* 416260 */     GIR_Done,
     /* 416261 */   // Label 8693: @416261
     /* 416261 */   GIM_Reject,
     /* 416262 */ // Label 8691: @416262
     /* 416262 */ GIM_Reject,
     /* 416263 */ // Label 8665: @416263
     /* 416263 */ GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(416296), // Rule ID 1899 //
     /* 416268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 416274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 416277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416289 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 416289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 416294 */   GIR_RootConstrainSelectedInstOperands,
     /* 416295 */   // GIR_Coverage, 1899,
     /* 416295 */   GIR_Done,
     /* 416296 */ // Label 8694: @416296
     /* 416296 */ GIM_Reject,
     /* 416297 */ // Label 8666: @416297
     /* 416297 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(416322), // Rule ID 3348 //
     /* 416302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 416308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 416311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416315 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 416315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 416320 */   GIR_RootConstrainSelectedInstOperands,
     /* 416321 */   // GIR_Coverage, 3348,
     /* 416321 */   GIR_Done,
     /* 416322 */ // Label 8695: @416322
     /* 416322 */ GIM_Reject,
     /* 416323 */ // Label 8667: @416323
     /* 416323 */ GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(416348), // Rule ID 2879 //
     /* 416328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 416334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 416337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416341 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 416341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 416346 */   GIR_RootConstrainSelectedInstOperands,
     /* 416347 */   // GIR_Coverage, 2879,
     /* 416347 */   GIR_Done,
     /* 416348 */ // Label 8696: @416348
     /* 416348 */ GIM_Reject,
     /* 416349 */ // Label 8668: @416349
     /* 416349 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(416374), // Rule ID 2880 //
     /* 416354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 416360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 416363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416367 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 416367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 416372 */   GIR_RootConstrainSelectedInstOperands,
     /* 416373 */   // GIR_Coverage, 2880,
     /* 416373 */   GIR_Done,
     /* 416374 */ // Label 8697: @416374
     /* 416374 */ GIM_Reject,
     /* 416375 */ // Label 8669: @416375
     /* 416375 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(416421),
     /* 416380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 416383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 416386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416390 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(416405), // Rule ID 2875 //
     /* 416395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416398 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 416398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 416403 */     GIR_RootConstrainSelectedInstOperands,
     /* 416404 */     // GIR_Coverage, 2875,
     /* 416404 */     GIR_Done,
     /* 416405 */   // Label 8699: @416405
     /* 416405 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(416420), // Rule ID 2881 //
     /* 416410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416413 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 416413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 416418 */     GIR_RootConstrainSelectedInstOperands,
     /* 416419 */     // GIR_Coverage, 2881,
     /* 416419 */     GIR_Done,
     /* 416420 */   // Label 8700: @416420
     /* 416420 */   GIM_Reject,
     /* 416421 */ // Label 8698: @416421
     /* 416421 */ GIM_Reject,
     /* 416422 */ // Label 8670: @416422
     /* 416422 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(416447), // Rule ID 3347 //
     /* 416427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 416433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 416436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416440 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 416440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 416445 */   GIR_RootConstrainSelectedInstOperands,
     /* 416446 */   // GIR_Coverage, 3347,
     /* 416446 */   GIR_Done,
     /* 416447 */ // Label 8701: @416447
     /* 416447 */ GIM_Reject,
     /* 416448 */ // Label 8671: @416448
     /* 416448 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(416473), // Rule ID 2877 //
     /* 416453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 416459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 416462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416466 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 416466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 416471 */   GIR_RootConstrainSelectedInstOperands,
     /* 416472 */   // GIR_Coverage, 2877,
     /* 416472 */   GIR_Done,
     /* 416473 */ // Label 8702: @416473
     /* 416473 */ GIM_Reject,
     /* 416474 */ // Label 8672: @416474
     /* 416474 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(416520),
     /* 416479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 416482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 416485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416489 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(416504), // Rule ID 2874 //
     /* 416494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416497 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 416497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 416502 */     GIR_RootConstrainSelectedInstOperands,
     /* 416503 */     // GIR_Coverage, 2874,
     /* 416503 */     GIR_Done,
     /* 416504 */   // Label 8704: @416504
     /* 416504 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(416519), // Rule ID 2878 //
     /* 416509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416512 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 416512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 416517 */     GIR_RootConstrainSelectedInstOperands,
     /* 416518 */     // GIR_Coverage, 2878,
     /* 416518 */     GIR_Done,
     /* 416519 */   // Label 8705: @416519
     /* 416519 */   GIM_Reject,
     /* 416520 */ // Label 8703: @416520
     /* 416520 */ GIM_Reject,
     /* 416521 */ // Label 8673: @416521
     /* 416521 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(416546), // Rule ID 3346 //
     /* 416526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 416532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 416535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416539 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 416539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 416544 */   GIR_RootConstrainSelectedInstOperands,
     /* 416545 */   // GIR_Coverage, 3346,
     /* 416545 */   GIR_Done,
     /* 416546 */ // Label 8706: @416546
     /* 416546 */ GIM_Reject,
     /* 416547 */ // Label 8674: @416547
     /* 416547 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(416593),
     /* 416552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 416555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 416558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416562 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(416577), // Rule ID 2873 //
     /* 416567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416570 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 416570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 416575 */     GIR_RootConstrainSelectedInstOperands,
     /* 416576 */     // GIR_Coverage, 2873,
     /* 416576 */     GIR_Done,
     /* 416577 */   // Label 8708: @416577
     /* 416577 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(416592), // Rule ID 2876 //
     /* 416582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416585 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 416585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 416590 */     GIR_RootConstrainSelectedInstOperands,
     /* 416591 */     // GIR_Coverage, 2876,
     /* 416591 */     GIR_Done,
     /* 416592 */   // Label 8709: @416592
     /* 416592 */   GIM_Reject,
     /* 416593 */ // Label 8707: @416593
     /* 416593 */ GIM_Reject,
     /* 416594 */ // Label 8675: @416594
     /* 416594 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(416619), // Rule ID 2398 //
     /* 416599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 416605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 416608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 416612 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 416612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 416617 */   GIR_RootConstrainSelectedInstOperands,
     /* 416618 */   // GIR_Coverage, 2398,
     /* 416618 */   GIR_Done,
     /* 416619 */ // Label 8710: @416619
     /* 416619 */ GIM_Reject,
     /* 416620 */ // Label 8676: @416620
     /* 416620 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(416645), // Rule ID 2872 //
     /* 416625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 416628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 416631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 416634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 416638 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 416638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 416643 */   GIR_RootConstrainSelectedInstOperands,
     /* 416644 */   // GIR_Coverage, 2872,
     /* 416644 */   GIR_Done,
     /* 416645 */ // Label 8711: @416645
     /* 416645 */ GIM_Reject,
     /* 416646 */ // Label 8677: @416646
     /* 416646 */ GIM_Reject,
     /* 416647 */ // Label 151: @416647
     /* 416647 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8730*/ GIMT_Encode4(417426),
     /* 416658 */ /*GILLT_v2s32*//*Label 8712*/ GIMT_Encode4(416734),
     /* 416662 */ /*GILLT_v2s64*//*Label 8713*/ GIMT_Encode4(416789),
     /* 416666 */ /*GILLT_v4s16*//*Label 8714*/ GIMT_Encode4(416844),
     /* 416670 */ /*GILLT_v4s32*//*Label 8715*/ GIMT_Encode4(416899),
     /* 416674 */ /*GILLT_v8s8*//*Label 8716*/ GIMT_Encode4(416954),
     /* 416678 */ /*GILLT_v8s16*//*Label 8717*/ GIMT_Encode4(416988),
     /* 416682 */ /*GILLT_v16s8*//*Label 8718*/ GIMT_Encode4(417043), GIMT_Encode4(0),
     /* 416690 */ /*GILLT_nxv2s1*//*Label 8719*/ GIMT_Encode4(417077),
     /* 416694 */ /*GILLT_nxv2s16*//*Label 8720*/ GIMT_Encode4(417103),
     /* 416698 */ /*GILLT_nxv2s32*//*Label 8721*/ GIMT_Encode4(417129),
     /* 416702 */ /*GILLT_nxv2s64*//*Label 8722*/ GIMT_Encode4(417155),
     /* 416706 */ /*GILLT_nxv4s1*//*Label 8723*/ GIMT_Encode4(417202),
     /* 416710 */ /*GILLT_nxv4s16*//*Label 8724*/ GIMT_Encode4(417228),
     /* 416714 */ /*GILLT_nxv4s32*//*Label 8725*/ GIMT_Encode4(417254),
     /* 416718 */ /*GILLT_nxv8s1*//*Label 8726*/ GIMT_Encode4(417301),
     /* 416722 */ /*GILLT_nxv8s16*//*Label 8727*/ GIMT_Encode4(417327),
     /* 416726 */ /*GILLT_nxv16s1*//*Label 8728*/ GIMT_Encode4(417374),
     /* 416730 */ /*GILLT_nxv16s8*//*Label 8729*/ GIMT_Encode4(417400),
     /* 416734 */ // Label 8712: @416734
     /* 416734 */ GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(416788),
     /* 416739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 416745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416757 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(416772), // Rule ID 1909 //
     /* 416762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416765 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 416765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 416770 */     GIR_RootConstrainSelectedInstOperands,
     /* 416771 */     // GIR_Coverage, 1909,
     /* 416771 */     GIR_Done,
     /* 416772 */   // Label 8732: @416772
     /* 416772 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(416787), // Rule ID 5489 //
     /* 416777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416780 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 416780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 416785 */     GIR_RootConstrainSelectedInstOperands,
     /* 416786 */     // GIR_Coverage, 5489,
     /* 416786 */     GIR_Done,
     /* 416787 */   // Label 8733: @416787
     /* 416787 */   GIM_Reject,
     /* 416788 */ // Label 8731: @416788
     /* 416788 */ GIM_Reject,
     /* 416789 */ // Label 8713: @416789
     /* 416789 */ GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(416843),
     /* 416794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 416800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416812 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(416827), // Rule ID 1911 //
     /* 416817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416820 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 416820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 416825 */     GIR_RootConstrainSelectedInstOperands,
     /* 416826 */     // GIR_Coverage, 1911,
     /* 416826 */     GIR_Done,
     /* 416827 */   // Label 8735: @416827
     /* 416827 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(416842), // Rule ID 5491 //
     /* 416832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416835 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 416835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 416840 */     GIR_RootConstrainSelectedInstOperands,
     /* 416841 */     // GIR_Coverage, 5491,
     /* 416841 */     GIR_Done,
     /* 416842 */   // Label 8736: @416842
     /* 416842 */   GIM_Reject,
     /* 416843 */ // Label 8734: @416843
     /* 416843 */ GIM_Reject,
     /* 416844 */ // Label 8714: @416844
     /* 416844 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(416898),
     /* 416849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 416855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416867 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(416882), // Rule ID 1907 //
     /* 416872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416875 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 416875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 416880 */     GIR_RootConstrainSelectedInstOperands,
     /* 416881 */     // GIR_Coverage, 1907,
     /* 416881 */     GIR_Done,
     /* 416882 */   // Label 8738: @416882
     /* 416882 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(416897), // Rule ID 5487 //
     /* 416887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416890 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 416890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 416895 */     GIR_RootConstrainSelectedInstOperands,
     /* 416896 */     // GIR_Coverage, 5487,
     /* 416896 */     GIR_Done,
     /* 416897 */   // Label 8739: @416897
     /* 416897 */   GIM_Reject,
     /* 416898 */ // Label 8737: @416898
     /* 416898 */ GIM_Reject,
     /* 416899 */ // Label 8715: @416899
     /* 416899 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(416953),
     /* 416904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 416910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416922 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(416937), // Rule ID 1910 //
     /* 416927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416930 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 416930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 416935 */     GIR_RootConstrainSelectedInstOperands,
     /* 416936 */     // GIR_Coverage, 1910,
     /* 416936 */     GIR_Done,
     /* 416937 */   // Label 8741: @416937
     /* 416937 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(416952), // Rule ID 5490 //
     /* 416942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416945 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 416950 */     GIR_RootConstrainSelectedInstOperands,
     /* 416951 */     // GIR_Coverage, 5490,
     /* 416951 */     GIR_Done,
     /* 416952 */   // Label 8742: @416952
     /* 416952 */   GIM_Reject,
     /* 416953 */ // Label 8740: @416953
     /* 416953 */ GIM_Reject,
     /* 416954 */ // Label 8716: @416954
     /* 416954 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(416987), // Rule ID 1905 //
     /* 416959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 416965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 416968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416980 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 416980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 416985 */   GIR_RootConstrainSelectedInstOperands,
     /* 416986 */   // GIR_Coverage, 1905,
     /* 416986 */   GIR_Done,
     /* 416987 */ // Label 8743: @416987
     /* 416987 */ GIM_Reject,
     /* 416988 */ // Label 8717: @416988
     /* 416988 */ GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(417042),
     /* 416993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 416999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417011 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(417026), // Rule ID 1908 //
     /* 417016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417019 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 417019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 417024 */     GIR_RootConstrainSelectedInstOperands,
     /* 417025 */     // GIR_Coverage, 1908,
     /* 417025 */     GIR_Done,
     /* 417026 */   // Label 8745: @417026
     /* 417026 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(417041), // Rule ID 5488 //
     /* 417031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417034 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 417039 */     GIR_RootConstrainSelectedInstOperands,
     /* 417040 */     // GIR_Coverage, 5488,
     /* 417040 */     GIR_Done,
     /* 417041 */   // Label 8746: @417041
     /* 417041 */   GIM_Reject,
     /* 417042 */ // Label 8744: @417042
     /* 417042 */ GIM_Reject,
     /* 417043 */ // Label 8718: @417043
     /* 417043 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(417076), // Rule ID 1906 //
     /* 417048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 417054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 417057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417069 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 417069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 417074 */   GIR_RootConstrainSelectedInstOperands,
     /* 417075 */   // GIR_Coverage, 1906,
     /* 417075 */   GIR_Done,
     /* 417076 */ // Label 8747: @417076
     /* 417076 */ GIM_Reject,
     /* 417077 */ // Label 8719: @417077
     /* 417077 */ GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(417102), // Rule ID 8936 //
     /* 417082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 417088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 417091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417095 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 417095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 417100 */   GIR_RootConstrainSelectedInstOperands,
     /* 417101 */   // GIR_Coverage, 8936,
     /* 417101 */   GIR_Done,
     /* 417102 */ // Label 8748: @417102
     /* 417102 */ GIM_Reject,
     /* 417103 */ // Label 8720: @417103
     /* 417103 */ GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(417128), // Rule ID 8891 //
     /* 417108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 417114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 417117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417121 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 417121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 417126 */   GIR_RootConstrainSelectedInstOperands,
     /* 417127 */   // GIR_Coverage, 8891,
     /* 417127 */   GIR_Done,
     /* 417128 */ // Label 8749: @417128
     /* 417128 */ GIM_Reject,
     /* 417129 */ // Label 8721: @417129
     /* 417129 */ GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(417154), // Rule ID 8892 //
     /* 417134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 417140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 417143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417147 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 417147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 417152 */   GIR_RootConstrainSelectedInstOperands,
     /* 417153 */   // GIR_Coverage, 8892,
     /* 417153 */   GIR_Done,
     /* 417154 */ // Label 8750: @417154
     /* 417154 */ GIM_Reject,
     /* 417155 */ // Label 8722: @417155
     /* 417155 */ GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(417201),
     /* 417160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 417163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 417166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417170 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(417185), // Rule ID 8887 //
     /* 417175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417178 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 417178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 417183 */     GIR_RootConstrainSelectedInstOperands,
     /* 417184 */     // GIR_Coverage, 8887,
     /* 417184 */     GIR_Done,
     /* 417185 */   // Label 8752: @417185
     /* 417185 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(417200), // Rule ID 8893 //
     /* 417190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417193 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 417193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 417198 */     GIR_RootConstrainSelectedInstOperands,
     /* 417199 */     // GIR_Coverage, 8893,
     /* 417199 */     GIR_Done,
     /* 417200 */   // Label 8753: @417200
     /* 417200 */   GIM_Reject,
     /* 417201 */ // Label 8751: @417201
     /* 417201 */ GIM_Reject,
     /* 417202 */ // Label 8723: @417202
     /* 417202 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(417227), // Rule ID 8935 //
     /* 417207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 417213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 417216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417220 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 417220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 417225 */   GIR_RootConstrainSelectedInstOperands,
     /* 417226 */   // GIR_Coverage, 8935,
     /* 417226 */   GIR_Done,
     /* 417227 */ // Label 8754: @417227
     /* 417227 */ GIM_Reject,
     /* 417228 */ // Label 8724: @417228
     /* 417228 */ GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(417253), // Rule ID 8889 //
     /* 417233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 417239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 417242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417246 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 417246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 417251 */   GIR_RootConstrainSelectedInstOperands,
     /* 417252 */   // GIR_Coverage, 8889,
     /* 417252 */   GIR_Done,
     /* 417253 */ // Label 8755: @417253
     /* 417253 */ GIM_Reject,
     /* 417254 */ // Label 8725: @417254
     /* 417254 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(417300),
     /* 417259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 417262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 417265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417269 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(417284), // Rule ID 8886 //
     /* 417274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417277 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 417277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 417282 */     GIR_RootConstrainSelectedInstOperands,
     /* 417283 */     // GIR_Coverage, 8886,
     /* 417283 */     GIR_Done,
     /* 417284 */   // Label 8757: @417284
     /* 417284 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(417299), // Rule ID 8890 //
     /* 417289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417292 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 417292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 417297 */     GIR_RootConstrainSelectedInstOperands,
     /* 417298 */     // GIR_Coverage, 8890,
     /* 417298 */     GIR_Done,
     /* 417299 */   // Label 8758: @417299
     /* 417299 */   GIM_Reject,
     /* 417300 */ // Label 8756: @417300
     /* 417300 */ GIM_Reject,
     /* 417301 */ // Label 8726: @417301
     /* 417301 */ GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(417326), // Rule ID 8934 //
     /* 417306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 417312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 417315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417319 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 417319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 417324 */   GIR_RootConstrainSelectedInstOperands,
     /* 417325 */   // GIR_Coverage, 8934,
     /* 417325 */   GIR_Done,
     /* 417326 */ // Label 8759: @417326
     /* 417326 */ GIM_Reject,
     /* 417327 */ // Label 8727: @417327
     /* 417327 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(417373),
     /* 417332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 417335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 417338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417342 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(417357), // Rule ID 8885 //
     /* 417347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417350 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 417350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 417355 */     GIR_RootConstrainSelectedInstOperands,
     /* 417356 */     // GIR_Coverage, 8885,
     /* 417356 */     GIR_Done,
     /* 417357 */   // Label 8761: @417357
     /* 417357 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(417372), // Rule ID 8888 //
     /* 417362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417365 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 417365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 417370 */     GIR_RootConstrainSelectedInstOperands,
     /* 417371 */     // GIR_Coverage, 8888,
     /* 417371 */     GIR_Done,
     /* 417372 */   // Label 8762: @417372
     /* 417372 */   GIM_Reject,
     /* 417373 */ // Label 8760: @417373
     /* 417373 */ GIM_Reject,
     /* 417374 */ // Label 8728: @417374
     /* 417374 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(417399), // Rule ID 2402 //
     /* 417379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 417385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 417388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 417392 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 417392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 417397 */   GIR_RootConstrainSelectedInstOperands,
     /* 417398 */   // GIR_Coverage, 2402,
     /* 417398 */   GIR_Done,
     /* 417399 */ // Label 8763: @417399
     /* 417399 */ GIM_Reject,
     /* 417400 */ // Label 8729: @417400
     /* 417400 */ GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(417425), // Rule ID 8884 //
     /* 417405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 417408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 417411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 417414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 417418 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 417418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 417423 */   GIR_RootConstrainSelectedInstOperands,
     /* 417424 */   // GIR_Coverage, 8884,
     /* 417424 */   GIR_Done,
     /* 417425 */ // Label 8764: @417425
     /* 417425 */ GIM_Reject,
     /* 417426 */ // Label 8730: @417426
     /* 417426 */ GIM_Reject,
     /* 417427 */ // Label 152: @417427
     /* 417427 */ GIM_Reject,
     /* 417428 */ }; // Size: 417428 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
